-- name=int_button_hint_impl
function public.Init ()

  public.DIRECTION = -1;
  public.POSITION = 70;

  private.RELOAD_ANIM_FRAME_COUNT     = 18;
  private.RELOAD_BEGIN_ANIM_TIME      = 0; -- время "ухода" жабы, зависит от тита лягушки
  private.RELOAD_ANIM_TIME            = 0; -- время "прихода" жабы, зависит от тита лягушки
  private.RELOAD_VID_FRAME_COUNT      = 1080;
  private.BUTTON_MOUSE_OVER_ANIM_TIME = 0.3;
  private.SHOW_ANIM_TIME              = 0.3;
  private.POS_X                       = 931;

  ObjSet( "spr_int_button_hint_button_back",
  {
    event_mdown = int_button_hint.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  } );

  ObjSet( "obj_int_button_hint_button",
  {
    event_mdown = int_button_hint.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  } );

end;
--******************************************************************************************
function public.WideScreenUpdate ()

  if ( not GetWideScreen() ) then

    ObjSet( "spr_int_button_hint_back_add", { visible = false } );

  else

    ObjSet( "spr_int_button_hint_back_add", { visible = true } );

  end;

end;
--******************************************************************************************
function public.ShowAnim ( event_id )

  local trg = function () int_button_hint.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "int_button_hint", "alp", 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

end;
--******************************************************************************************
function public.HideAnim ( event_id )

  local trg = function () int_button_hint.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "int_button_hint", "alp", 0, 0, trg,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

end;
--******************************************************************************************
function public.ChangeToStatic ()
  
  ObjSet( "obj_int_button_hint_reload", { active = false, visible = false } );
  ObjSet( "obj_int_button_hint_static", { active = true,  visible = true  } );
  ObjSet( "vid_int_button_hint_static", { active = true,  visible = true  } );

  ObjSet( "vid_int_button_hint_loader", { active = false, visible = false } );
  ObjSet( "vid_int_button_hint_close",  { active = false, visible = false } );
  
  ObjSet( "vid_int_button_hint_static", { active = true,  visible = true  } );

  public.StartAnimStatic();

  VidPlay( "vid_int_button_hint_static", function () end );

end;
--******************************************************************************************
function public.ChangeToReload ( is_begin )

  VidStop( "vid_int_button_hint_static" );
  ObjSet( "obj_int_button_hint_static", { active = false, visible = false } );
  ObjSet( "vid_int_button_hint_loader", { active = true,  visible = true  } ); 

  ObjSet( "vid_int_button_hint_static", { active = false, visible = false } );
  ObjSet( "obj_int_button_hint_reload", { active = true,  visible = true  } );

  if ( is_begin ) then

    public.ReloadAnim( true );    

  else

    public.ReloadAnim( true );

  end;

end;
--******************************************************************************************
function public.ReloadAnim ( is_first )

  if ( is_first ) then

  end;
 
  local time_min    = int_button_hint.GetTimeMin();
  local time_remain = int_button_hint.GetTimeRemain();
  local time_full   = int_button_hint.GetTimeFull();

  local frame_count     = private.RELOAD_ANIM_FRAME_COUNT;
  local vid_frame_count = private.RELOAD_VID_FRAME_COUNT;

  --  время на один фрейм
  local time_frame     = time_full / frame_count;
  local vid_time_frame = time_full / vid_frame_count;  

  local time_current      = time_full - time_remain;
  local frame_current     = math.floor( time_current / time_frame );
  local vid_frame_current = math.floor( time_current / vid_time_frame );

  ObjSet( "vid_int_button_hint_loader", { frame = vid_frame_current } );

  ObjSet( "tmr_int_button_hint_reload", { endtrig = "" });

  if ( frame_current < ( frame_count ) ) then

    local trg = "int_button_hint_impl.ReloadAnim();";    
    ObjSet( "tmr_int_button_hint_reload_anim", { endtrig = trg, time = time_min, playing = true } );

  else
    
    private.EndAnimReload();
    ObjSet( "vid_int_button_hint_loader", { active = false, visible = false } );

  end;

end;
--******************************************************************************************
-- конец анимации зарядки хинта
function private.EndAnimReload ()

  int_button_hint.EventAnimEnd( 'reload' );
  VidStop( "vid_int_button_hint_loader" );
  ObjSet( 'vid_int_button_hint_loader', { frame = 0 } );
  ObjSet( 'obj_int_button_hint', { alp = 1 } );

end;
--******************************************************************************************
function public.SetHardcore ( is_hardcore )

  if ( is_hardcore ) then

    --ObjSet( "obj_int_button_hint_active",   { visible = false } );
    ObjSet( "obj_int_button_hint_hardcore", { active = true, visible = true } );
    --ObjSet( "obj_int_button_hint_button",   { input = false, visible = false } );

  else

    ObjSet( "obj_int_button_hint_hardcore", { active = false, visible = false } );
    --ObjSet( "obj_int_button_hint_active",   { visible = true } );
    --ObjSet( "obj_int_button_hint_button",   { input = true, visible = true } );

  end;

end;
--******************************************************************************************
-- старт анимации зарядки хинта
function public.StartAnimReload ()

  PlaySfx( "assets/audio/aud_hinton_sfx", 0, "", 0 );

  if ( ng_global.widget.hint_type_frog == 1 ) then

    PlaySfx( "assets/audio/oth/aud_hinton_sfx", 0, "", 0 );

  elseif ( ng_global.widget.hint_type_frog == 2 ) then

    ObjSet( 'obj_int_button_hint', { pos_x = -15, pos_y = 32 } );
    ObjSet( "obj_vid_int_button_hint_reload", { pos_x = 58, pos_y = -77, ang = -4.25 } );
    ObjStopAnimate( "obj_vid_int_button_hint_reload", 7 );
    ObjStopAnimate( "obj_vid_int_button_hint_reload", 3 );

    ObjAnimate( "obj_vid_int_button_hint_reload", 7, 0, 0, "",
    {
      0.0, 3, -4.25,
      0.5, 3,  0.00
    } );
    ObjAnimate( "obj_vid_int_button_hint_reload", 3, 0, 0, "",
    {
      0.00, 1,  58, -77,
      0.15, 0, -7,  -96,
      0.30, 1, -67, -71,
      0.50, 0,  58, -77
    } );
 
    PlaySfx( "assets/audio/oth/aud_hinton_sfx", 0, "", 0 );

  elseif ( ng_global.widget.hint_type_frog == 3 ) then

    PlaySfx( "assets/audio/oth/aud_hinton_sfx", 0, "", 0 );

  elseif ( ng_global.widget.hint_type_frog == 4 ) then

    PlaySfx( "assets/audio/oth/aud_hinton_sfx", 0, "", 0 );
    ObjStopAnimate( "obj_int_button_hint", 1 );
    ObjSet( "obj_int_button_hint", { pos_x = 2, pos_y = 32 } );
    local posy = ObjGet( "obj_int_button_hint" ).pos_y;
    ObjAnimate( "obj_int_button_hint", 1, 1, 0, "",
    {
      0.0, 3, posy,
      0.5, 3, posy - 2,
      1.5, 3, posy + 2,
      2.0, 3, posy
    } );

  end; 

end;
--******************************************************************************************
-- конец анимации зарядки хинта
function private.EndAnimReload ()

  int_button_hint.EventAnimEnd( 'reload' );
  VidStop( "vid_int_button_hint_loader");
  ObjSet( 'vid_int_button_hint_loader', { frame = 0 } );
  ObjSet( 'obj_int_button_hint', { alp = 1 } );

end;
--******************************************************************************************
-- старт анимации "разрядки" хинта
function public.StartAnimReloadBegin ()

  local func_end = 
function () 
ObjSet( 'vid_int_button_hint_close', { active = false, visible = false } ); 
ObjSet( 'vid_int_button_hint_loader', { active = true, visible = true } ); 
ObjSet( "vid_int_button_hint_loader", { alp = 1 } );  
end;

  ObjSet( "vid_int_button_hint_loader", { active = false, visible = false } );  
  ObjSet( "vid_int_button_hint_close", { active = true, visible = true } );
  ObjSet( "vid_int_button_hint_static", { active = false, visible = false } );    
  ObjSet( "vid_int_button_hint_close", { alp = 1 } );
  ObjSet( "vid_int_button_hint_loader", { alp = 0 } );
  VidStop( "vid_int_button_hint_close" );
  VidPlay( "vid_int_button_hint_close", func_end );

end;
--******************************************************************************************
-- конец анимации "разрядки" хинта
function private.EndAnimReloadBegin ()

  ObjStopAnimate( "obj_int_button_hint", 1 );
  ObjStopAnimate( "obj_int_button_hint", 3 );
  ObjStopAnimate( "obj_int_button_hint", 8 );
  ObjStopAnimate( "obj_vid_int_button_hint_reload", 3 );
  ObjStopAnimate( "obj_vid_int_button_hint_reload", 7 );

  ObjSet( 'vid_int_button_hint_reload_begin', { active  = false, visible = false, trg = "" } );
  ObjSet( 'obj_int_button_hint', { alp = 1 } );
  --ObjSet( "vid_int_button_hint_loader", { alp = 1 } );
  --ObjSet( "vid_int_button_hint_loader", { active = true, visible = true } );  

end;
--******************************************************************************************
function private.MouseEnterAnim ()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_hint_button_focus";
  if ( GetPerformanceMode() == 0 ) then
    obj = "pfx_int_button_hint_button_focus";
  end;
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.BUTTON_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.MouseLeaveAnim ()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_button_hint_button_focus";
  if ( GetPerformanceMode() == 0 ) then
    obj = "pfx_int_button_hint_button_focus";
  end;
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.BUTTON_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );


end;
--******************************************************************************************
-- старт анимации "статики" хинта
function public.StartAnimStatic ()

  ObjSet( "tmr_int_button_hint_reload", { playing = false } );

end;
--******************************************************************************************