-- name=int_button_map_impl
--******************************************************************************************
function public.Init ()

  public.DIRECTION = 1;
  public.POSITION  = 932;

  private.MOUSE_OVER_ANIM_TIME = 0.3;

  ObjSet( "obj_int_button_map_button",
  {
    event_mdown  = int_button_map.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  } );

end;
--******************************************************************************************
function private.MouseEnterAnim ()

  SetCursor( CURSOR_HAND );

  --local prg  = ng_global.currentprogress; 

  --if not ng_global.progress[ prg ].common.diary.show then

    local obj = "pfx_int_button_map_button_focus";
    local alp = ObjGet( obj ).alp;
    local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 2, alp,
      tme, 2, 1
    } );

    local obj_diary_open  = "spr_int_button_map_diary_opened";
    local obj_diary_close = "spr_int_button_map_diary_closed";
    local obj_diary_pfx   = "pfx_int_button_map_diary_focus";

    ObjAnimate( obj_diary_open, "alp", 0, 0, "",
    {
      0.0, 3, 0,
      private.MOUSE_OVER_ANIM_TIME, 3, 1
    } );  

    ObjAnimate( obj_diary_pfx,  "alp", 0, 0, "",
    {
      0.0, 3, 0,
      private.MOUSE_OVER_ANIM_TIME, 3, 1
    } ); 

    ObjAnimate( obj_diary_close, "alp", 0, 0, "",
    {
      0.0, 3, 1,
      private.MOUSE_OVER_ANIM_TIME, 3, 0
    } );

    cmn.PlayAudio( "sfx", "audio/aud_buttonmap_enter" );

  --end;

end;
--******************************************************************************************
function private.MouseLeaveAnim ()

  SetCursor( CURSOR_DEFAULT );

  --local prg  = ng_global.currentprogress; 

  --if not ng_global.progress[ prg ].common.diary.show then

    local obj = "pfx_int_button_map_button_focus";
    local alp = ObjGet( obj ).alp;
    local tme = alp * private.MOUSE_OVER_ANIM_TIME;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 1, alp,
      tme, 1, 0
    } );

    local obj_diary_open  = "spr_int_button_map_diary_opened";
    local obj_diary_close = "spr_int_button_map_diary_closed"; 
    local obj_diary_pfx   = "pfx_int_button_map_diary_focus";
    
    ObjAnimate( obj_diary_open, "alp", 0, 0, "",
    {
      0.0, 1, 1,
      private.MOUSE_OVER_ANIM_TIME, 1, 0
    } );

    ObjAnimate( obj_diary_pfx,  "alp", 0, 0, "",
    {
      0.0, 1, 1,
      private.MOUSE_OVER_ANIM_TIME, 1, 0
    } );

    ObjAnimate( obj_diary_close, "alp", 0, 0, "",
    {
      0.0, 1, 0,
      private.MOUSE_OVER_ANIM_TIME, 1, 1
    } );  

    cmn.PlayAudio( "sfx", "audio/aud_buttonmap_leave" );

  --end;

end;
--******************************************************************************************
function public.WideScreenUpdate ()

  if ( not GetWideScreen() ) then

  
  else


  end;

end;
--******************************************************************************************