-- name=int_button_menu_impl
--******************************************************************************************
function public.Init ()

  public.DIRECTION = 1;
  public.POSITION  = 932;
  private.MOUSE_OVER_ANIM_TIME = 0.3;
  ObjSet( "obj_int_button_menu",
  {
    event_mdown  = private.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  } );

end;
--******************************************************************************************
function public.Destroy ()

end;
--******************************************************************************************
function public.WideScreenUpdate ()

  if ( not GetWideScreen() ) then

    ObjSet( "spr_int_button_menu_back_add", { active = false, visible = false } );

  else

    ObjSet( "spr_int_button_menu_back_add", { active = false, visible = true } );

  end;

end;
--******************************************************************************************
function private.MouseDown ()
  
  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );
  int_button_menu.MouseDown();
  
end;
--******************************************************************************************
function private.MouseEnterAnim ()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_menu_focus";
  if ( GetPerformanceMode() == 0 ) then
    obj = "pfx_int_button_menu_focus";
  end;
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.MouseLeaveAnim ()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_button_menu_focus";
  if ( GetPerformanceMode() == 0 ) then
    obj = "pfx_int_button_menu_focus";
  end;
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************