-- name=int_button_reset_impl
--******************************************************************************************
function public.Init ()

  public.DIRECTION = -1;
  public.POSITION  = 64;

  private.MOUSE_OVER_ANIM_TIME = 0.3;

  private.MOVE_ANIM_POS_X_BEG = - 64;
  private.MOVE_ANIM_POS_X_END =   64;
  private.MOVE_ANIM_TIME      =  0.6;

  ObjSet( "obj_int_button_reset",
  {
    event_mdown  = int_button_reset.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  } );

end;
--******************************************************************************************
function public.WideScreenUpdate ()

  if ( not GetWideScreen() ) then

    --
  
  else

    --

  end;

end;
--******************************************************************************************
function public.ShowAnim ( event_id )

  local obj = "int_button_reset_impl";
  local trg = function () int_button_reset.EventAnimEnd( event_id ); end;
  local tme = private.MOVE_ANIM_TIME;
  local offset = 0.5 * ( GetAppWidth() - 1024 );

  ObjAnimate( obj, "pos_x", 0, 0, trg,
  {
    0.0, 2, public.DIRECTION*offset + private.MOVE_ANIM_POS_X_BEG,
    tme, 2, public.DIRECTION*offset + private.MOVE_ANIM_POS_X_END
  } );

end;
--******************************************************************************************
function public.HideAnim ( event_id )

  local obj = "int_button_reset_impl";
  local trg = function () int_button_reset.EventAnimEnd( event_id ); end;
  local tme = private.MOVE_ANIM_TIME;
  local offset = 0.5 * ( GetAppWidth() - 1024 );

  ObjAnimate( obj, "pos_x", 0, 0, trg,
  {
    0.0, 1, public.DIRECTION*offset + private.MOVE_ANIM_POS_X_END,
    tme, 1, public.DIRECTION*offset + private.MOVE_ANIM_POS_X_BEG
  } );

end;
--******************************************************************************************
function private.MouseEnterAnim ()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_reset_focus";
  if ( GetPerformanceMode() == 0 ) then
    obj = "pfx_int_button_reset_focus";
  end;
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.MouseLeaveAnim ()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_button_reset_focus";
  if ( GetPerformanceMode() == 0 ) then
    obj = "pfx_int_button_reset_focus";
  end;
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************