-- name=int_button_task
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_button_task", "obj_int_inventory_task" );
  ObjSet( "int_button_task", { pos_z = pos_z } );

  private.MOUSE_OVER_ANIM_TIME = 0.3;
  private.MOVE_ANIM_TIME      =  0.6;

  ObjSet( "obj_int_button_task", 
  {
    event_mdown = private.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  } );
  
end;
--******************************************************************************************
function public.Destroy ()

  --

end;
--******************************************************************************************
function public.WideScreenUpdate ()

  if ( not GetWideScreen() ) then

    --

  else

    --

  end;

end;
--******************************************************************************************
function private.MouseDown ()

  if ( int_dialog_task.show ) then

    interface.DialogTaskHide();

  else

    interface.DialogTaskShow( private.task_current, "current_task" );

  end;

end;
--******************************************************************************************
function private.MouseEnterAnim ()

  interface.InventoryOpen();
  --common_impl.DialogButtonMouseEnter( "int_button_task" );
  SetCursor( CURSOR_HAND );

  focus_name = "spr_int_button_task_focus";

  if ( ObjGet( focus_name ) ) then

    ObjSet( focus_name, { visible = true, active = true} ); 

    local focus_alp = ObjGet( focus_name ).alp;

    ObjAnimate( focus_name, "alp", 0, 0, "", 
    { 

      0, 0, focus_alp, 
      ( private.MOUSE_OVER_ANIM_TIME * ( 1 - focus_alp ) ), 0, 1 
    
    });

  end;

end;
--******************************************************************************************
function private.MouseLeaveAnim ()

  interface.InventoryClose();
  --common_impl.DialogButtonMouseLeave( "int_button_task" );

  SetCursor( CURSOR_DEFAULT );

  focus_name = "spr_int_button_task_focus";

  if ( ObjGet( focus_name ) ) then

    ObjSet( focus_name, { visible = true, active = true} ); 

    local focus_alp = ObjGet( focus_name ).alp;

    ObjAnimate( focus_name, "alp", 0, 0, "", 
    { 

      0, 0, focus_alp, 
      ( private.MOUSE_OVER_ANIM_TIME * ( 1 - focus_alp ) ), 0, 0 
    
    });

  end;

end;
--******************************************************************************************
function public.Update ( state, task )

  private.task_current = task;
  ObjSet( "int_button_task", { active = state, visible = state, input = state } );
  AnimPlay( "anm_int_button_task_appear", "DoAnim", function () ObjDelete( "anm_int_button_task_appear" );  end );

end;
--******************************************************************************************
function public.SwitchBtnToExt ()
  
  ObjSet( "spr_int_button_task", { res = "assets/interface/int_task/anims/task_hourglass", pos_x = -5, pos_y = -26 } );
  ObjSet( "spr_int_button_task_focus", { res = "assets/interface/int_task/task_buttonadd2", pos_x = -5, pos_y = -26 } );
  ObjSet( "anm_int_button_task_appear", { res = "assets/interface/int_task/anims/anm_task_appear_clock", pos_x = -5, pos_y = -26 } );
  
end;