-- name=int_collectibles
--******************************************************************************************
function public.Init ( pos_z )

  --int.collectibles = {};
  ObjAttach( "int_collectibles", interface.originhub );
  private.event_anim_end = {};
  private.DIRECTION      = -1;

  private.MOUSE_OVER_ANIM_TIME = 0.3;
  private.SHOW_ANIM_TIME       = 0.4;

  private.MOVE_ANIM_POS_X_BEG = -164;
  private.MOVE_ANIM_POS_X_END =  146;

  private.MOVE_ANIM_TIME = 0.6;
  private.timer          = 3; --время таймера
  public.previous_room   = 0;

  public.show_collectibles  = 0; --на экране или нет
  public.previous_room      = 0; --на экране или нет

  private.IMG_X = -114;
  private.IMG_Y = -1;
  private.IMG_SC_X = 0.685;
  private.IMG_SC_Y = 0.685;

  private.TEXT_NAME_X = 50;
  private.TEXT_NAME_Y = 0;

  private.CURRENT_COLLECT = "";
  private.CLICK_TO_SCREEN = false;

  if ng_global[ "collect" ] == nil then

     ng_global[ "collect" ] = {};

  end;

  ObjSet( "int_collectibles", { alp = 0 } );
--
--  ObjSet( "obj_int_collectibles_close", 
--  {
--    event_mdown  = function () private.HideAnim() end,
--    event_menter = function () SetCursor( CURSOR_DOWN ) end,
--    event_mleave = function () SetCursor( CURSOR_DEFAULT ) end
--  } );
--
--  ObjSet( "spr_int_collectibles_button_goto", 
--  {
--    event_mdown  = function () private.GoCollectibles() end,
--    event_menter = function () private.MouseEnterAnim( "spr_int_collectibles_button_goto" ) end,
--    event_mleave = function () private.MouseLeaveAnim( "spr_int_collectibles_button_goto" ) end
--  } );
--
--  ObjSet( "spr_int_collectibles_button_close", 
--  {
--    event_mdown  = function () private.HideAnim() end,
--    event_menter = function () private.MouseEnterAnim( "spr_int_collectibles_button_close" ) end,
--    event_mleave = function () private.MouseLeaveAnim( "spr_int_collectibles_button_close" ) end
--  } );

  ObjSet( "spr_int_collectibles_button", { alp = 0, input = false } );
  ObjSet( "int_collectibles", { alp = 0 } );

  ObjAttach( "tmr_int_collectibles_hide", "cmn_timers" );

  ObjSet( "obj_int_collectibles_button", 
  {
    event_mdown  = function () private.GoCollectibles() end,
    event_menter = function () private.MouseEnterAnim( "int_collectibles_button" ) end,
    event_mleave = function () private.MouseLeaveAnim( "int_collectibles_button" ) end
  } );

  private.WideScreenUpdate();

  int.AddCollectibles = private.AddCollectibles;

end;
--******************************************************************************************
function private.WideScreenUpdate ()

  local direction = private.DIRECTION or 0;

  if ( direction ~= 0 ) then

      local offset   = 0.5 * ( GetAppWidth() - 1024 );
      local position =  0;
      local posx     = position + ( direction * offset );

      ObjSet( "int_collectibles", { pos_x = posx } );

  end;

end;
--******************************************************************************************
function private.GoCollectibles ()

  if ( int.GetMorphingShow() ) then

     int.HideAnimMorphing();

  end;

  ng_global.achievements.previous_room = GetCurrentRoom();

  private.CLICK_TO_SCREEN = true; 

  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );

  local func_end = function () private.HideAnim(); end;

  ObjSet( "tmr_int_collectibles_hide", { endtrig = func_end, time = 0.01, playing = true } );
  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );
  public.previous_room = common.GetCurrentRoom();

  cmn.GotoRoom( "rm_collectibles", 0, true ); 

end;

--******************************************************************************************
function private.EventAnimEnd ( event_id )
--DbgTrace("EventAnimEnd - "..event_id);
  if ( event_id == "show" ) then
    --local func_end = function () private.EventAnimEnd( event_id ) end;

    ObjSet( "obj_int_collectibles", { input = true } );
    ObjSet( "tmr_int_collectibles_hide", { endtrig = private.HideAnim, time = private.timer, playing = true } );

  elseif ( event_id == "hide" ) then

    ObjSet( "int_collectibles", { active = false, visible = false, input = false } );

  end;
  
end;

--******************************************************************************************
function private.MouseEnterAnim ( name )

  --SetCursor( CURSOR_HAND );

--  local prefix = "spr_";
--
--  if ( GetPerformanceMode() == 0 ) then
--
--    prefix = "pfx_";
--
--    if ( not ObjGet( prefix..( common.GetObjectName( name ) ).."_focus" ).name ) then
--
--      prefix = "spr_";
--
--    end;
--
--  end;

--  local obj = prefix..( common.GetObjectName( name ) ).."_focus";
--  local alp = ObjGet( obj ).alp;
--  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;
--
--  ObjAnimate( obj, "alp", 0, 0, "",
--  {
--    0.0, 3, alp,
--    tme, 3, 1
--  } );
--
--  cmn.PlayAudio( "sfx", "audio/aud_menter" );

  local prefix = "spr_";

  if GetPerformanceMode() == 0 then

    prefix = "pfx_";

    if ( not ObjGet( prefix..name.."_focus" ) )  then

      prefix = "spr_";

    end;

  end;

  if not ( ObjGet( prefix..name.."_focus" ) ) then

    prefix = "";

  end;  

  SetCursor( CURSOR_HAND );

  local obj = prefix..name.."_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.MouseLeaveAnim ( name )

--  SetCursor( CURSOR_DEFAULT );
--
--  local prefix = "spr_";
--
--  if ( GetPerformanceMode() == 0 ) then
--
--    prefix = "pfx_";
--
--    if ( not ObjGet( prefix..( common.GetObjectName( name ) ).."_focus" ).name ) then
--
--      prefix = "spr_";
--
--    end;
--
--  end;
--
--  local obj = prefix..( common.GetObjectName( name ) ).."_focus";
--  local alp = ObjGet( obj ).alp;
--  local tme = alp * private.MOUSE_OVER_ANIM_TIME;
--
--  ObjAnimate( obj, "alp", 0, 0, "",
--  {
--    0.0, 1, alp,
--    tme, 1, 0
--  } );

    local prefix = "spr_";

    if ( GetPerformanceMode() == 0 ) then

      prefix = "pfx_";

      if not ObjGet( prefix..name.."_focus" ) then

        prefix = "spr_";

      end;

    end;

    if not ( ObjGet( prefix..name.."_focus" ) ) then

      prefix = "";

    end;  

    SetCursor( CURSOR_DEFAULT );

    local obj = prefix..name.."_focus";
    local alp = ObjGet( obj ).alp;
    local tme = alp * private.MOUSE_OVER_ANIM_TIME;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 1, alp,
      tme, 1, 0
    } );


end;
--******************************************************************************************
function private.AddCollectiblesEnd ( prg_event, collect_name, close )
--DbgTrace("AddCollectiblesEnd - "..collect_name);
  ObjSet( "int_collectibles", { active = true, visible = true, input = true } );

  local event_id = "show";
  private.event_anim_end[ event_id ] = {};
  private.ShowAnim( collect_name );

  close = tonumber( close );

  int.Lock( false );

  cmn.SetEventDone( prg_event );
  cmn.CallEventHandler( prg_event );

  if ( ng_global[ "collect" ][ collect_name ] == nil ) then

     ng_global[ "collect" ][ collect_name ] = {};
     ng_global[ "collect" ][ collect_name ].done = 1;

  end;

  if ( close == 1 ) then

    CloseSubRoom();

  end;

end;
--******************************************************************************************
function private.AddCollectibles ( name_obj )

--  local c_Num     = string.find( name_obj, "collect" );
--  local name      = string.sub( name_obj, c_Num ); --выделяем из имени объекта форму collect_<num>_<num>
--  local prg_event = "get_"..name;
-- 
--  int.Lock( true );
--
--  ObjSet( name_obj, { input = false } );
--
--  local collect_pos       = GetObjPosByObj( name_obj, InterfaceWidget_Top_Name );
--  local collect_drawoff_x = ObjGet( name_obj ).drawoff_x;
--  local collect_drawoff_y = ObjGet( name_obj ).drawoff_y;
--  
--  local collect_name  = "pfx_collect_"..name_obj;
--
--  ObjAttach( name_obj, InterfaceWidget_Top_Name );
--  ObjSet( name_obj, { pos_x = collect_pos[ 1 ], pos_y = collect_pos[ 2 ], pos_z = 0 });
--
--  ObjCreate( collect_name, "partsys" );
--  
--  ObjSet( collect_name,
--  {
--    res = "assets/interface/resources/effects_ho_hint",
--    pos_x = collect_drawoff_x, pos_y = collect_drawoff_y,
--    pos_z = 1,
--    active = true,
--    visible = true,
--    input = false
--  } );
--
--  ObjAttach( collect_name, InterfaceWidget_Top_Name );
--  ObjSet( collect_name, { blendmode = 2 } );
--  
--  PartSysSetMaskObj( collect_name, name_obj );  
--  
--  local func_end = function () private.AddCollectiblesEnd( prg_event, name, param_close ); ObjDelete( collect_name ); end;
--
--  ObjAnimate( name_obj, "alp", 0, 0, func_end,
--  { 
--    0.0, 0, 1.0,
--    1.0, 0, 0.0
--  } );
--
--  cmn.PlayAudio( "sfx", "audio/aud_morphing" );

  local c_Num     = string.find( name_obj, "collect" );
  local name      = string.sub( name_obj, c_Num ); --выделяем из имени объекта форму collect_<num>_<num>
  local prg_event = "get_"..name;
  local amount    = 10;
  local folder    = string.sub( name, 1, amount );

  local collect_name = name or private.CURRENT_COLLECT;

  int.Lock( true );

  ObjSet( name_obj, { input = false } );

  local collect_pos       = GetObjPosByObj( name_obj, interface.originhub );
  local collect_drawoff_x = ObjGet( name_obj ).drawoff_x;
  local collect_drawoff_y = ObjGet( name_obj ).drawoff_y;
  local collect_name      = "pfx_collect_"..name_obj;

  ObjAttach( name_obj, InterfaceWidget_Top_Name );
  ObjSet   ( name_obj, { pos_x = collect_pos[ 1 ], pos_y = collect_pos[ 2 ] });
  ObjCreate( collect_name, "partsys" );

  cmn.SetEventDone( prg_event );

  ObjSet( collect_name,
  {
    res = "assets/interface/resources/effects_ho_hint",
    pos_x = collect_drawoff_x, pos_y = collect_drawoff_y,
    active = true,
    visible = true,
    input = false
  } );

  ObjAttach( collect_name, InterfaceWidget_Top_Name );
  ObjSet( collect_name, { blendmode = 2 } );

  PartSysSetMaskObj( collect_name, name_obj );  
  
  local func_end = function () private.AddCollectiblesEnd( prg_event, name, param_close ); ObjDelete( collect_name ); end;

  ObjAnimate( name_obj, "alp", 0, 0, func_end,
  { 
    0.0, 0, 1.0,
    1.0, 0, 0.0
  } );

  cmn.PlayAudio( "sfx", "audio/aud_morphing" );

end;
----******************************************************************************************
function private.ShowAnim ( name )
--DbgTrace( "ShowAnim - "..name );
--  local obj      = "obj_int_collectibles";
--  local event_id = "show";
--  local func_end = function () private.EventAnimEnd( event_id ) end;
--  local tme      = private.SHOW_ANIM_TIME;
--
--  public.show_collectibles = 1;
--  private.CURRENT_COLLECT = name;
  --private.CreatObjCollect( name );
--
--  ObjSet( "int_collectibles",     { input = true, visible = true, pos_x = 512, pos_y = 384 } );
--  ObjSet( "obj_int_collectibles", { input = false } );
--
--  ObjAnimate( "int_collectibles", "alp", 0, 0, "", 
--  { 
--    0.0, 2, 0, 
--    tme, 2, 1 
--  } );
--
--  ObjAnimate( obj, "scale_xy", 0, 0, func_end, 
--  { 
--    0.0, 2, 0, 0, 
--    tme, 2, 1, 1
--  } );

  local obj      = "obj_int_collectibles";
  local event_id = "show";
  local tme      = private.MOVE_ANIM_TIME;
  local func_end = function () private.EventAnimEnd( event_id ) end;

  public.show_collectibles = 1;
  private.CURRENT_COLLECT = name;
  private.CreatObjCollect( name );

  ObjSet( "int_collectibles", { active = true, visible = true, input = true, alp = 1 } );
  ObjStopAnimate( obj, "pos_x" ); 
  --ObjSet( "tmr_int_collectibles_hide", { endtrig = func_end, time = private.timer, playing = true } );

  local current_posx = private.MOVE_ANIM_POS_X_BEG;
  ObjAttach( obj, "int_collectibles" );

  ObjAnimate( obj, "pos_x", 0, 0, func_end,
  {
    0.0, 2, private.MOVE_ANIM_POS_X_BEG,
    tme, 2, private.MOVE_ANIM_POS_X_END
  } );

  private.CURRENT_collectibles2 = name;

  cmn.PlayAudio( "sfx", "audio/aud_plate" );

end;
--******************************************************************************************
function private.HideAnim ()

--  local obj      = "obj_int_collectibles";
--  local func_end = function () private.EventAnimEnd("hide") end;
--  local tme      = private.SHOW_ANIM_TIME;
--
--  public.show_collectibles = 0;
--  ObjSet( obj, { input = false } );
--
--  ObjAnimate( "int_collectibles", "alp", 0, 0, "", 
--  { 
--    0.0, 2, 1, 
--    tme, 2, 0 
--  } );
--
--  ObjAnimate( obj, "scale_xy", 0, 0, func_end, 
--  { 
--    0.0, 2, 1, 1, 
--    tme, 2, 0, 0
--  } );

  local obj      = "obj_int_collectibles";
  local event_id = "hide";
  local func_end = function () private.EventAnimEnd( event_id ) end;
  local tme      = private.MOVE_ANIM_TIME;
  local cur_posx = private.MOVE_ANIM_POS_X_END;

  ObjStopAnimate( obj, "pos_x" );

  cur_posx = ObjGet( obj ).pos_x;

  ObjSet( "int_collectibles", { input = false } );

  ObjAnimate( obj, "pos_x", 0, 0, func_end,
  {
    0.0, 1, cur_posx,
    tme, 1, private.MOVE_ANIM_POS_X_BEG
  } );

  ObjSet( "tmr_int_collectibles_hide", { playing = false } );

  cmn.PlayAudio( "sfx", "audio/aud_plate1" );

end;
--******************************************************************************************
function private.CreatObjCollect ( name )

  local amount       = 9;
  local folder       = string.sub( name, 1, amount );
  local collect_name = name or private.CURRENT_COLLECT;
  local count = 1;
  local prg   = ng_global.currentprogress;
  local level = ng_global.progress[ prg ].common.chapter;
  local lvl   = string.sub(level,6);

  if ( lvl == "ext" ) then

    lvl = 4

  end;

  for j = 1, 4 do

      local name_collect = "collect_"..lvl.."_"..j;

          if ( ng_global[ "collect" ][ name_collect ] ~= nil ) then

              if ( ng_global[ "collect" ][ name_collect ].done == 1 ) then

                  count = count + 1;

              end;

          end;

  end;

  ObjSet( "spr_int_collectibles_img", { res = "assets/levels/menu/rm_collectibles/layers/icon/"..collect_name } );
  ObjSet( "txt_int_collectibles_name_2",    { text = count.." of 4" } );
  --ObjSet( "txt_int_collectibles_info",    { text = "str_collectibles_"..collect_name.."_info" } );

  ObjSet( "spr_int_collectibles_button_goto", { input = true, alp = 1 } );
    
end;
