-- name=int_collectibles2
--******************************************************************************************
function public.Init ( posz )

  ObjAttach( "int_collectibles2", interface.originhub );

--  private.DIRECTION = -1;
--

--
--  private.MOVE_ANIM_POS_X_BEG = -164;
--  private.MOVE_ANIM_POS_X_END =  146;
--
--  private.MOVE_ANIM_TIME = 0.6;
--  private.timer          = 3; --время таймера
  --public.previous_room   = 0;

  --private.IMG_X = -114;
  --private.IMG_Y = -1;
  --private.IMG_SC_X = 0.685;
  --private.IMG_SC_Y = 0.685;

  --private.TEXT_NAME_X = 50;
  --private.TEXT_NAME_Y = 0;

  private.CURRENT_collectibles2 = "";
  private.CLICK_TO_SCREEN       = false;

  private.collectibles2 = {};
  private.collectibles2.animtime = 0.4;
  private.collectibles2.SHOW_ANIM_TIME       =  0.4;
  private.collectibles2.MOUSE_OVER_ANIM_TIME               = 0.3;

  --ObjSet( "spr_int_collectibles2_button", { alp = 0, input = false } );
  ObjSet( "int_collectibles2", { alp = 0, pos_z = posz } );

  ObjAttach( "tmr_int_collectibles2_hide", "cmn_timers" );

  ObjSet( "obj_int_collectibles2_button", 
  {
    event_mdown  = function () private.GoCollectibles2() end,
    event_menter = function () private.MouseEnterAnim() end,
    event_mleave = function () private.MouseLeaveAnim() end
  } );

  ObjSet( "obj_int_collectibles2_btn_exit", 
  {
    event_mdown  = private.BtnCloseMouseDown,
    event_menter = function() private.BtnMouseEnter( CURSOR_HAND, "int_collectibles2_btn_exit" ) end, 
    event_mleave = function() private.BtnMouseLeave( "int_collectibles2_btn_exit" ) end;
  } );

  ObjSet( "obj_int_collectibles2_back", 
  {
    event_mdown  = private.CloseMouseDown,
    event_menter = function() cmn.SetCursor( CURSOR_DOWN ); end, 
    event_mleave = function() cmn.SetCursor( CURSOR_DEFAULT ); end;
  } );

  private.WideScreenUpdate();

  int.AddCollectibles2 = private.AddCollectibles2;

end;
--******************************************************************************************
function private.WideScreenUpdate ()

  local direction = private.DIRECTION or 0;

  if ( direction ~= 0 ) then

      local offset = 0.5 * ( GetAppWidth() - 1024 );
      local position =  0;
      local posx = position + ( direction * offset );

      ObjSet( "int_collectibles2", { pos_x = posx } );

  end;

end;
--******************************************************************************************
function private.GoCollectibles2 ()

--  if int.counter.show == 1 then
--
--    int.counter.Hide();
--
--  end;

  private.CLICK_TO_SCREEN = true;

  local func_end = function () private.HideAnimCollectibles2(); end;

  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );
  ObjSet( "tmr_int_collectibles2_hide", { endtrig = func_end, time = 0.01, playing = true } );
  ng_global.achievements.previous_room = common.GetCurrentRoom();
  cmn.CloseSubRoom();
  cmn.GotoRoom( "rm_collectibles", 0, true);

end;
--******************************************************************************************
function private.MouseEnterAnim ()

  cmn.PlayAudio( "sfx", "audio/aud_menter" );
  SetCursor( CURSOR_HAND );

  local obj = "pfx_int_collectibles2_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.collectibles2.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.MouseLeaveAnim ()

  SetCursor( CURSOR_DEFAULT );

  local obj = "pfx_int_collectibles2_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.collectibles2.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
function private.BtnMouseEnter( type_cursor, name )

  if type_cursor then
    SetCursor( type_cursor );
  else
    SetCursor( CURSOR_DEFAULT );
  end;
  
  if GetPerformanceMode() == 0 then

    name = "pfx_"..name.."_focus";

  else

    name = "spr_"..name.."_focus";

  end;

  local alp = ObjGet( name ).alp;

  ObjAnimate( name, "alp", 0, 0, "", { 0, 0, alp, ( private.collectibles2.animtime * ( 1 - alp ) ), 0, 1 } );
  cmn.PlayAudio( "sfx", "audio/aud_menter" );

end;
--******************************************************************************************
function private.BtnMouseLeave( name )

  SetCursor( CURSOR_DEFAULT );

  if GetPerformanceMode() == 0 then

    name = "pfx_"..name.."_focus";

  else

    name = "spr_"..name.."_focus";

  end;

  local alp = ObjGet( name ).alp;

  ObjAnimate( name, "alp", 0, 0, "", { 0, 1, alp, ( private.collectibles2.animtime * alp ), 1, 0 } );
  cmn.PlayAudio( "sfx", "audio/aud_menter" );

end;
--******************************************************************************************
function private.BtnCloseMouseDown ()

  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );
  private.HideAnimCollectibles2();

end;
--******************************************************************************************
function private.CloseMouseDown ()

  private.HideAnimCollectibles2();

end;
--******************************************************************************************
function private.EventAnimEnd ( event_id )

  if ( event_id == "show" ) then

    ObjSet( "obj_int_collectibles2", { input = true } );

  elseif ( event_id == "hide" ) then

    ObjSet( "int_collectibles2",     { active = false, visible = false } );
    ObjSet( "obj_int_collectibles2", { input = false } );

    private.CURRENT_collectibles2 = "";

  end;
  
end;
--******************************************************************************************
function private.AddCollectibles2 ( name_obj )

  local c_Num     = string.find( name_obj, "collect" );
  local name      = string.sub( name_obj, c_Num ); --выделяем из имени объекта форму collect_<num>_<num>
  local prg_event = "get_"..name;
  local amount    = 10;

  local collect_name = name or private.CURRENT_COLLECT;

  local prg   = ng_global.currentprogress;
  local level = ng_global.progress[ prg ].common.chapter;
  local lvl   = string.sub(level,6);

  if ( lvl == "ext" or lvl == "scr" ) then

    lvl = 4

  end;

  ObjSet( "spr_int_collectibles2_img", { res = "assets/levels/menu/rm_collectibles/layers/collect_"..lvl.."/"..name } );
  ObjSet( "txt_int_collectibles2_name",{ text = "str_collectibles_"..name } );
  ObjSet( "txt_int_collectibles2_info",{ text = "str_collectibles_"..name.."_info" } );

  int.Lock( true );

  ObjSet( name_obj, { input = false } );

  local collect_pos       = GetObjPosByObj( name_obj, interface.originhub );
  local collect_drawoff_x = ObjGet( name_obj ).drawoff_x;
  local collect_drawoff_y = ObjGet( name_obj ).drawoff_y;
  local collect_name      = "pfx_collect2_"..name_obj;

  ObjAttach( name_obj, InterfaceWidget_Top_Name );
  ObjSet   ( name_obj, { pos_x = collect_pos[ 1 ], pos_y = collect_pos[ 2 ] });
  ObjCreate( collect_name, "partsys" );

  ObjSet( collect_name,
  {
    res = "assets/interface/resources/effects_ho_hint",
    pos_x = collect_drawoff_x, pos_y = collect_drawoff_y,
    active = true,
    visible = true,
    input = false
  } );

  ObjAttach( collect_name, InterfaceWidget_Top_Name );
  ObjSet( collect_name, { blendmode = 2 } );

  PartSysSetMaskObj( collect_name, name_obj );  
  
  local func_end = function ()

    private.AddCollectibles2End( prg_event, name  );

    ObjDelete( collect_name );

    int.Lock( false );

  end;

  ObjAnimate( name_obj, "alp", 0, 0, func_end,
  { 
    0.0, 0, 1.0,
    1.0, 0, 0.0
  } );

  cmn.PlayAudio( "sfx", "audio/aud_morphing" );

end;
--******************************************************************************************
function private.AddCollectibles2End ( prg_event, collect_name )
--DbgTrace("AddCollectiblesEnd - "..collect_name);
  ObjSet( "int_collectibles", { active = true, visible = true, input = true } );

  --local event_id = "show";
  --private.event_anim_end[ event_id ] = {};
  private.ShowAnimCollectibles2( );

  int.Lock( false );

  cmn.SetEventDone( prg_event );
  cmn.CallEventHandler( prg_event );

  if ( not ng_global[ "collect" ][ collect_name ] ) then

     ng_global[ "collect" ][ collect_name ] = {};
     ng_global[ "collect" ][ collect_name ].done = 1;
     private.CURRENT_collectibles2 = prg_event;

  end;
  
end;
--******************************************************************************************
function private.ShowAnimCollectibles2 ()

  local obj = "obj_int_collectibles2";
  local event_id = "show";
  local func_end = function () private.EventAnimEnd( event_id ) end;
  local tme = private.collectibles2.SHOW_ANIM_TIME;

  --int.collectibles.CreatObjCollect( name, is_game );

  ObjSet( "int_collectibles2",     { input = 1, visible = 1 } );
  ObjSet( "obj_int_collectibles2", { input = 0 } );

  ObjAnimate( "int_collectibles2", "alp", 0, 0, "", 
  { 
    0.0, 2, 0, 
    tme, 2, 1 
  } );

  ObjAnimate( obj, "scale_xy", 0, 0, func_end, 
  { 
    0.0, 2, 0, 0, 
    tme, 2, 1, 1
  } );

  int.show_collectibles2 = true;

  --private.CURRENT_collectibles2 = name;

  --cmn.PlayAudio( "sfx", "audio/aud_plate" );

end;
--******************************************************************************************
function private.HideAnimCollectibles2 ()

  local obj      = "obj_int_collectibles2";
  local event_id = "hide";
  local func_end = function () private.EventAnimEnd( event_id ) end;
  local tme      = private.collectibles2.SHOW_ANIM_TIME;

  ObjSet( "int_collectibles2", { input = false } );

  ObjAnimate( "int_collectibles", "alp", 0, 0, "", 
  { 
    0.0, 2, 1, 
    tme, 2, 0 
  } );

  ObjAnimate( obj, "scale_xy", 0, 0, trg, 
  { 
    0.0, 2, 1, 1, 
    tme, 2, 0, 0
  } );

  cmn.PlayAudio( "sfx", "audio/aud_plate1" );

end;
--******************************************************************************************