-- name=int_datetime
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_datetime", interface.originhub );
  ObjSet( "int_datetime", { pos_z = pos_z } );

  ObjSet( "obj_int_datetime", { event_mdown = private.Hide } );

end;
--******************************************************************************************
function public.Show( date, time, func_end )

  private.FuncEnd = func_end;

  int.Lock( true );

  local room = common.GetCurrentRoom();

  ObjSet( room, { color_r = 0, color_g = 0, color_b = 0 } );

  --ObjAnimate( room, "color_rgb", 0, 0, "", 
  --{
  --  0.0, 0, 1, 1, 1,
  --  0.3, 0, 0, 0, 0
  --} );

  ObjSet( "txt_int_datetime_date", { text = "str_datetime_"..date } );
  ObjSet( "txt_int_datetime_time", { text = "str_datetime_"..time } );

  ObjAnimate( "obj_int_datetime", "alp", 0, 0,
  function ()

    int.Lock( false );

    ObjSet( "obj_int_datetime", { input = 1 } );

  end, 
  {
    0.0, 0, 0,
    0.3, 0, 1,
  } );

end;
--******************************************************************************************
function private.Hide()

  int.Lock( true );

  ObjSet( "obj_int_datetime", { input = 0 } );

  local room = common.GetCurrentRoom();

  ObjAnimate( room, "color_rgb", 0, 0, "", 
  {
    0.0, 0, 0, 0, 0,
    0.3, 0, 1, 1, 1
  } );

  ObjAnimate( "obj_int_datetime", "alp", 0, 0,
  function ()

    int.Lock( false );

    if ( private.FuncEnd ) then

      private.FuncEnd();

    end;

  end, 
  {
    0.0, 0, 1,
    0.3, 0, 0,
  } );

end;
--******************************************************************************************