-- name=int_deploy_inv
--******************************************************************************************
function public.Init( pos_z )

  ObjAttach( "int_deploy_inv", interface.originhub );
  ObjSet( "int_deploy_inv", { pos_z = pos_z } );

  private.SHOW_ANIM_TIME = 0.5;
  private.SKIP_MOUSE_OVER_ANIM_TIME = 0.5;

  private.show = 0;
  private.show_obj = nil;

  ObjSet("spr_int_deploy_inv_close", {
  event_mdown = function () cmn.PlayAudio( "sfx", "audio/aud_click_menu" ); private.HideAnim("hide"); end,
    event_menter = function () private.CloseMouseEnterAnim(); end,
    event_mleave = function () private.CloseMouseLeaveAnim(); end
  });

  ObjSet("int_deploy_inv_exit", {
    event_mdown = function () private.HideAnim("hide"); end,
    event_menter = function () private.ExitMouseEnterAnim();SetCursor( CURSOR_DOWN ); end,
    event_mleave = function () private.ExitMouseLeaveAnim();SetCursor( CURSOR_DEFAULT ); end
  });

  ObjSet("spr_int_deploy_inv_back", {
    event_mdown = function () private.HideAnim("hide") end
  });

  int.CreateDeployPlus = private.CreateDeployPlus;

end;
--******************************************************************************************
function public.Define ( deploy_inv )

  _G[ deploy_inv ] = {};

end;
--******************************************************************************************
function public.Destroy()

end;
--******************************************************************************************
function private.EventAnimEnd( event_id )

  int.Lock( false );

  if ( event_id == "show" ) then

    private.show = 1;

    ObjSet( "int_deploy_inv", { input = true } );

    ObjSet( private.show_obj, { input = true, active = true } );

    if ng_global.progress[ ng_global.currentprogress ].common.buttonlock ~= 1 then

      --interface.InventoryAutoHideSet( 1 );

    end;

  elseif ( event_id == "hide" ) then

    private.show = 0;

    local prg   = ng_global.currentprogress;
    local level = ng_global.progress[ prg ].common.chapter;
    local lvl = string.sub( level, 6 );

--    if ( lvl == "ext" ) then
--
--      lvl = 4;
--
--    end;
--
--    lvl = tonumber( lvl );

    ObjSet( "int_deploy_inv", { visible = false, input = false } );
    ObjAttach( private.show_obj,"level"..lvl.."_inv_deploy");

    ObjSet( private.show_obj, { input = false, active = false } );

    if ( ObjGet( "spr_"..private.show_obj.."_note" ) ) then

      cmn.NoteScaleEnd( { "spr_"..private.show_obj.."_note" }, true );

    end;

  end;

end;
--******************************************************************************************
function private.ShowAnim( event_id )

  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  int.Lock( true );

  cmn.CloseSubRoom();

  ObjAnimate( "int_deploy_inv", "alp", 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

end;
--******************************************************************************************
function private.HideAnim( event_id )

  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  int.Lock( true );

  ObjAnimate( "int_deploy_inv", "alp", 0, 0, trg,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

  local name_obj_dep = string.sub( private.show_obj, 12, string.len( private.show_obj ) );

  if ( ng_global.progress[ng_global.currentprogress][ "win_"..name_obj_dep ] ) then

    if ( ng_global.progress[ ng_global.currentprogress ][ "win_"..name_obj_dep ].start == 1 ) and 
       ( ng_global.progress[ ng_global.currentprogress ][ "win_"..name_obj_dep ].done == 0 ) then

      cmn.MiniGameHide( name_obj_dep );
      common_impl.PassingMgStop( name_obj_dep );

    end;

  end;

end;
--******************************************************************************************
function private.ExitMouseEnterAnim()

  SetCursor( CURSOR_DOWN );

  local obj = "int_deploy_inv_exit_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.ExitMouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  local obj = "int_deploy_inv_exit_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
function private.CloseMouseEnterAnim()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_deploy_inv_close_focus";

  if (GetPerformanceMode() == 0)then

    obj = "pfx_int_deploy_inv_close_focus"; 
 
  end;

  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.CloseMouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_deploy_inv_close_focus";

  if (GetPerformanceMode() == 0)then

    obj = "pfx_int_deploy_inv_close_focus"; 
 
  end;

  local alp = ObjGet( obj ).alp;
  local tme = alp * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
function private.CreateDeployPlus( number )

  local parent = "level"..number.."_inv_deploy";

  if ( not ObjGet( parent ) ) then

    return;

  end;

  local relations = ObjGetRelations( parent );
  local table_multiset = {};

  for i = 1, #relations.childs do

    --obj
    local obj = common.GetObjectName( relations.childs[ i ] ).."_plus_focus";   

    ObjCreate( obj, "obj");
    ObjAttach( obj, common.GetObjectName( relations.childs[ i ] ) );
    ObjSet( obj,
      {
        alp = 1,
        input = false,
        pos_x = 28,
        pos_y = 28,
        pos_z = 100
      } );

    -- plus
    local obj1 = common.GetObjectName( relations.childs[ i ] ).."_plus_focus1";   

    ObjCreate( obj1, "spr");
    ObjAttach( obj1, obj );
    ObjSet( obj1,
      {
        alp = 1,
        input = false,
        pos_x = 0,
        pos_y = 0,
        color_r = 0.5,
        color_g = 0.5,
        color_b = 0.5, 
        res = "assets/interface/resources/int_deploy_inv/plus"
      } );

    -- plus_light
    local obj2 = obj.."2";   

    ObjCreate( obj2, "spr");
    ObjAttach( obj2, obj );
    ObjSet( obj2,
      {
        alp = 1,
        input = false,
        blendmode = 2,
        pos_x = 1,
        pos_y = 2,
        res = "assets/interface/resources/int_deploy_inv/light"
      } );

  end;


end;
--******************************************************************************************
function public.GetCurrentName()

  return private.show_obj;

end;
--******************************************************************************************
function public.IsOnScreen()

  return private.show == 1;

end;
--******************************************************************************************
function public.Show( inv_obj )

  local inv_obj = inv_obj;
  local event_id = "show";

  private.show_obj = "deploy_"..inv_obj;

  ObjSet( "int_deploy_inv", { active = true, visible = true, alp = 0 } );
  ObjAttach( private.show_obj, "int_deploy_inv" );
  ObjSet( private.show_obj, { pos_x = 0, pos_y = 0 } );

  private.ShowAnim( event_id );

end;
--******************************************************************************************
function public.Hide()

  local event_id = "hide";

  if ( private.show_obj ) and
     ( ObjGet( "int_deploy_inv" ) ) then 

    private.HideAnim( event_id );

  end;

end;
--******************************************************************************************