-- name=int_dialog_scr
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_dialog_scr", interface.originhub );
  ObjSet( "int_dialog_scr", { pos_z = pos_z } );
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  private.MOUSE_OVER_ANIM_TIME = 0.3;
  private.SHOW_ANIM_TIME       = 0.6;
  ObjSet("obj_int_dialog_scr_button", {
    event_mdown = int_dialog_scr.HideAnim,
    event_menter = function () common_impl.DialogButtonMouseEnter( "int_dialog_scr_button" ) end,
    event_mleave = function () common_impl.DialogButtonMouseLeave( "int_dialog_scr_button" ) end
  });

  private.task = "";

  --ObjAttach( "obj_int_dialog_scr_exit", "obj_int_dialog_scr_root" );

  ObjSet("obj_int_dialog_scr_impl_root", { pos_z = -1,
    event_mdown = int_dialog_scr.HideAnim,
    event_menter = function () SetCursor( CURSOR_DOWN ); end,
    event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
  });
  ObjSet("obj_int_dialog_scr_focus", {
    event_mdown = int_dialog_scr.HideAnim,
    event_menter = function () SetCursor( CURSOR_LOUPE ); end,
    event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
  });

end;
--******************************************************************************************
function public.Destroy ()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
function private.WideScreenUpdate()

end;
--******************************************************************************************
function public.ShowAnim ( task )

  int.Lock( true );
  ObjMultiSet( {
    { "txt_int_dialog_scr_1",          { param0 = StringGet( "str_task_scr_"..task ) } },
    { "obj_int_dialog_scr_impl_root",  { active = true, visible = true, input = false } },
    { "spr_int_dialog_scr_dialog",     { res = "assets/interface/resources/morphing_secret/"..task } },
  } );

  int_timer_scr.PauseTimer(); -- ставим на паузу таймер

  local trg = function ()  private.task = task; int.Lock( false ); ObjSet( "obj_int_dialog_scr_impl_root", { input = true } ); end;
  local tme = private.SHOW_ANIM_TIME;

  cmn.PlayAudio( "sfx","aud_new_task" );

  int_morph_scr.Hide();
  ObjAnimate( "obj_int_dialog_scr_root", "scale_xy", 0, 0, trg, {
    ( 0.0 * tme ), 2, 0, 0,
    ( 1.0 * tme ), 2, 1, 1
  } );

  ObjAnimate( "int_dialog_scr", "alp", 0, 0, "", {
    ( 0.0 * tme ), 2, 0,
    ( 0.5 * tme ), 2, 0,
    ( 1.0 * tme ), 2, 1 
  });

end;
--******************************************************************************************
function private.HideAnimEnd ()  

  ng_global.progress.scr[ "get_"..private.task.."_scr" ].start = 1;
  private.task = "";

  ng_global.secret.game = false;
  cmn.StartMorhpTask();

end;
--******************************************************************************************
function public.HideAnim ()

  ObjSet( "obj_int_dialog_scr_impl_root", { input = false } );
  --local trg = function ()  end;
  local tme = private.SHOW_ANIM_TIME;

  local func_end = function ()

    int.Lock( false );
    private.HideAnimEnd( task );   

  end;

  int.Lock( true );
  ObjAnimate( "obj_int_dialog_scr_root", "scale_xy", 0, 0, func_end, {
    ( 0.0 * tme ), 1, 1, 1,
    ( 1.0 * tme ), 1, 0, 0
  } );

  ObjAnimate( "int_dialog_scr", "alp", 0, 0, "", {
    ( 0.0 * tme ), 1, 1,
    ( 0.5 * tme ), 1, 0,
    ( 1.0 * tme ), 1, 0
  } );

end;
--******************************************************************************************