-- name=int_dialog_task
--******************************************************************************************
function public.Init ( pos_z )

  public.GRID_CORNER_W =  360;
  public.GRID_CORNER_H =  100;
  public.GRID_MID_W    =    8;
  public.GRID_MID_H    =  100;

  public.GRID_BORDER_W = 150;
  public.GRID_BORDER_H = 200;

  public.MIN_W = 1000;
  public.MAX_W = 2000;
  public.MIN_H = 64;
  public.MAX_H = 64;

  public.shadow_GRID_CORNER_W =  200;
  public.shadow_GRID_CORNER_H =  44;
  public.shadow_GRID_MID_W    =   92;
  public.shadow_GRID_MID_H    =   44;

  public.shadow_GRID_BORDER_W = 300;
  public.shadow_GRID_BORDER_H = 200;

  public.shadow_MIN_W = 800;
  public.shadow_MAX_W = 5000;
  public.shadow_MIN_H = 134;
  public.shadow_MAX_H = 134;

  --public.GRID_FIXED_W = 500;
  public.GRID_FIXED_H = 64;


  ObjAttach( "int_dialog_task", interface.originhub );
  ObjSet( "int_dialog_task", { pos_z = pos_z } );

  public.show = false;
  private.SHOW_ANIM_TIME = 0.5;
  private.MOUSE_OVER_ANIM_TIME = 0.3;
  
  private.FuncEnd = nil;
  private.task = "";

  ObjSet( "obj_int_dialog_task",
  {
    event_mdown = function () public.StopTypeAnim (); end,
  } );

  private.task_array = { 
                       { 0, 0, 0 }, 
                       { 0, 0, 0 }, 
                       { 0, 0, 0 }, 
                       { 0, 0, 0 }
                       };

  int.TaskDone     = public.TaskDone;
  int.ShowTaskNote = public.ShowTaskNote;
  int.UpdateTask   = private.UpdateTask;

end;
--******************************************************************************************
function public.Destroy()
  --
end;
--******************************************************************************************
function private.AnimEnd( event_id )  

  int.Lock( false );

  if ( event_id == "show" ) then

    ObjSet( "obj_int_dialog_task", { input = true } );
  
    public.show = true;

    ObjSet( "obj_int_dialog_task",
    {
      event_mdown = function ()  

          local func_end = function () private.AnimEnd( "hide" ); end;
          local tme = private.SHOW_ANIM_TIME;

          int.Lock( true );
          ObjAnimate( "obj_int_dialog_task_handnote", "pos_xy", 0, 0, func_end,
          {
            0.0, 3, ObjGet( "obj_int_dialog_task_handnote" ).pos_x, ObjGet( "obj_int_dialog_task_handnote" ).pos_y,
            tme, 3, -146, 766
          } );    

                    end
    } );

  elseif ( event_id == "hide" ) then
  
    public.show = false;
    
    --ObjSet( "obj_int_dialog_task", { input = false, event_mdown = function () public.StopTypeAnim (); end } );
    ObjSet( "obj_int_dialog_task", { input = false, event_mdown = function ()   ObjSet( "obj_int_dialog_task",{ event_mdown = function () public.Hide(); end } ); end } );

    if ( private.FuncEnd ) then

      private.FuncEnd();
      private.FuncEnd = nil;

    end;

  end;

end;
--******************************************************************************************
function private.ShowAnim ( event_id, data )
  
  local func_end = function () private.TypeAnim( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;   
  
  --int.Lock( true );
  
  if ( ng_global.currentprogress == "ext" ) then
    
      ObjAnimate( "obj_int_dialog_task_hourglass", "pos_xy", 0, 0, func_end,
      {
        0.0, 3, ObjGet( "obj_int_dialog_task_hourglass" ).pos_x, ObjGet( "obj_int_dialog_task_hourglass" ).pos_y,
        tme, 3, -146, 99
      } );     
    
  else
      
    cmn.PlayAudio( "sfx", "audio/aud_up_blocknote" );

    --private.task = data.task;

    ObjAnimate( "obj_int_dialog_task_handnote", "pos_xy", 0, 0, func_end,
    {
      0.0, 3, ObjGet( "obj_int_dialog_task_handnote" ).pos_x, ObjGet( "obj_int_dialog_task_handnote" ).pos_y,
      tme, 3, -146, 99
    } );      
    

    -- вывод таска полностью
    --ObjSet( "txt_int_dialog_task_description", { text = "str_dialog_task_"..private.task } );
    
  end;

end;
--******************************************************************************************
function private.TypeAnim ( event_id )  

  --int.Lock( false );

  ObjSet( "obj_int_dialog_task", { input = true } );

  local func_end = function () 

    private.AnimEnd( event_id ); 

    ObjSet( "obj_int_dialog_task",
    {
      event_mdown = function () public.Hide(); end,
    } );

  end;

  -- вывод таска по одной букве
  --common_impl.PrintText(
  --  "txt_int_dialog_task_description", 
  --  "str_dialog_task_"..private.task, 
  --  private.SHOW_ANIM_TIME*3, 
  --  func_end
  --);

  func_end();

  int.Lock( false );

end;
--******************************************************************************************
function public.StopTypeAnim ()

  common_impl.ShowText("txt_int_dialog_task_description");
  ObjSet( "obj_int_dialog_task",
  {
    event_mdown = function () public.Hide(); end,
  } );

end;
--******************************************************************************************
function private.HideAnim ( event_id )

  local func_end = function () private.AnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  int.Lock( true );
  
  if ( ng_global.currentprogress == "ext" ) then
    
    ObjAnimate( "obj_int_dialog_task_hourglass", "pos_xy", 0, 0, func_end,
    {
      0.0, 3, ObjGet( "obj_int_dialog_task_hourglass" ).pos_x, ObjGet( "obj_int_dialog_task_hourglass" ).pos_y,
      tme, 3, -146, 766
    } ); 
    
  else
    
    cmn.PlayAudio( "sfx", "audio/aud_down_blocknote" );

    ObjAnimate( "obj_int_dialog_task_handnote", "pos_xy", 0, 0, func_end,
    {
      0.0, 3, ObjGet( "obj_int_dialog_task_handnote" ).pos_x, ObjGet( "obj_int_dialog_task_handnote" ).pos_y,
      tme, 3, -146, 766
    } );    
    
  end;

end;
--*****************************************************************************************
function public.Show ( data )
  
  int.Lock( true );
  local event_id = "show";  

  int.DeployInvHide();

  private.Update( data );

  ObjSet( "txt_int_dialog_task_description2", { text = "str_dialog_task_"..data.task } );

  local off_x = public.GRID_BORDER_W;
  local off_y = public.GRID_BORDER_H;

  local dialog_w = ObjGet( "txt_int_dialog_task_description2" ).draw_width + off_x;

  if ( dialog_w < public.MIN_W ) then

    dialog_w = public.MIN_W;

  end;

  if ( dialog_w > public.MAX_W ) then

    dialog_w = public.MAX_W;

  end;

  local dialog_h = ObjGet( "txt_int_dialog_task_description2" ).draw_height + off_y;
  dialog_h = public.MAX_H;

  local grid_corner_w = public.GRID_CORNER_W;
  local grid_corner_h = public.GRID_CORNER_H;
  local grid_mid_w = public.GRID_MID_W;
  local grid_mid_h = public.GRID_MID_H;

  interface.FrameGridSet( "int_task",
  {
    grid_w   = dialog_w,
    grid_h   = dialog_h,
    corner_w = grid_corner_w,
    corner_h = grid_corner_h,
    mid_w    = grid_mid_w,
    mid_h    = grid_mid_h
  } );

  local shadow_off_x = public.shadow_GRID_BORDER_W;
  local shadow_off_y = public.shadow_GRID_BORDER_H;

  local dialog_w = ObjGet( "txt_int_dialog_task_description2" ).draw_width + shadow_off_x;

  if ( dialog_w < public.shadow_MIN_W ) then

    dialog_w = public.shadow_MIN_W;

  end;

  if ( dialog_w > public.shadow_MAX_W ) then

    dialog_w = public.shadow_MAX_W;

  end;

  local dialog_h = ObjGet( "txt_int_dialog_task_description2" ).draw_height + shadow_off_y;
  dialog_h = public.shadow_MAX_H;

  local grid_corner_w = public.shadow_GRID_CORNER_W;
  local grid_corner_h = public.shadow_GRID_CORNER_H;
  local grid_mid_w = public.shadow_GRID_MID_W;
  local grid_mid_h = public.shadow_GRID_MID_H;

  interface.FrameGridSet( "int_task_shadow",
  {
    grid_w   = dialog_w,
    grid_h   = dialog_h,
    corner_w = grid_corner_w,
    corner_h = grid_corner_h,
    mid_w    = grid_mid_w,
    mid_h    = grid_mid_h
  } );

  private.FuncEnd = data.func_end;
  private.ShowAnim( event_id, data );

end;
--******************************************************************************************
function public.Hide ()

  local event_id = "hide";
  private.HideAnim( event_id );

  --if private.task == "examine_square" then
  --  common_impl.TutorialShow( "tutorial_page_9" );
  --  private.task = "";
  --end;

end;
--******************************************************************************************
function private.Update ( data )

  ObjSet( "txt_int_dialog_task_header", { text = "str_dialog_task_header_"..data.state } );
  ObjSet( "txt_int_dialog_task_description", { text = "" } );

end;


--- task nootebook
--******************************************************************************************
function public.ShowTaskNote ( num, end_function )
  
  local lvl = string.sub( ng_global.progress[ ng_global.currentprogress ].common.chapter , 6 );

  if ( lvl == "ext" ) then

    lvl = 4;

  end;  

  if end_function then
  
    private.FuncEnd = end_function;

  end;

  if num then

    local func_end = function () 

      local func_end_1 = function () 

        private.AnimEnd( "show" );
        cmn.ShowBbt( "bbt_dialog_task_"..lvl.."_"..num );
        ObjSet( "spr_int_dialog_task_check"..num, { alp = 1 } );
        ObjSet( "anm_int_dialog_task_check"..num, { alp = 0 } );

      end;   

      cmn.PlayAudio( "sfx", "audio/aud_pen_write" );
      ObjSet( "anm_int_dialog_task_check"..num, { alp = 1 } );
      AnimPlay( "anm_int_dialog_task_check"..num, "DoAnim", "func_end_1" );
      ObjAnimate( "spr_int_dialog_task_check"..num, "alp", 0, 0, func_end_1, 
      {
        0.0, 0, 0,
        0.3, 0, 1
      } );

    end; 

    int.Lock( true );

    local tme = private.SHOW_ANIM_TIME;

    --ObjAnimate( "obj_int_dialog_task", "alp", 0, 0, func_end,
    --{
    --  0.0, 3, 0,
    --  tme, 3, 1
    --} );  
    
    cmn.PlayAudio( "sfx", "audio/aud_up_blocknote" );
    ObjAnimate( "obj_int_dialog_task_handnote", "pos_xy", 0, 0, func_end,
    {
      0.0, 3, ObjGet( "obj_int_dialog_task_handnote" ).pos_x, ObjGet( "obj_int_dialog_task_handnote" ).pos_y,
      tme, 3, -146, 99
    } );      

  else

    local func_end = function () 

      private.AnimEnd( "show" );

    end;
    
    int.Lock( true );

    local tme = private.SHOW_ANIM_TIME;

    --ObjAnimate( "obj_int_dialog_task", "alp", 0, 0, func_end,
    --{
    --  0.0, 3, 0,
    --  tme, 3, 1
    --} );  
    cmn.PlayAudio( "sfx", "audio/aud_up_blocknote" );
    ObjAnimate( "obj_int_dialog_task_handnote", "pos_xy", 0, 0, func_end,
    {
      0.0, 3, ObjGet( "obj_int_dialog_task_handnote" ).pos_x, ObjGet( "obj_int_dialog_task_handnote" ).pos_y,
      tme, 3, -146, 99
    } );      

  end;

end;
--******************************************************************************************
function public.TaskDone ( num )

  local lvl = string.sub( ng_global.progress[ ng_global.currentprogress ].common.chapter , 6 );

  if ( lvl == "ext" ) then

    lvl = 4;

  end;

  private.task_array[ tonumber(lvl) ][ num ] = 1;
  ng_global.task_current = "task_1";
  interface.KeyUpdate(); 

end;
--******************************************************************************************
function private.UpdateTask ( lvl )
  
  if lvl == 4 then
    
    ObjSet( "obj_int_dialog_task_handnote", { alp = 0 } );
    ObjSet( "obj_int_dialog_task_hourglass", { alp = 1 } );    
   
  else

    ObjSet( "txt_int_dialog_tack_header", { text = "str_dialog_task_"..lvl.."_header" } );

    for num = 1, #private.task_array[ lvl ] do

      ObjSet( "txt_int_dialog_tack_"..num, { text = "str_dialog_task_"..lvl.."_"..num } );
      ObjSet( "spr_int_dialog_task_pic"..num, { res = "assets/interface/int_task/"..lvl.."lvl/pic"..num } );

      if ( private.task_array[ lvl ][ num ] == 1 ) then

        ObjSet( "spr_int_dialog_task_check"..num, { alp = 1 } );

      end;

    end;
  
  end;

end;
--******************************************************************************************
function public.InitHourglassStage ()
  
  ng_global.task_hour_current = 0;
  
end;
--******************************************************************************************
function public.UpdateHourglassStage ( show )
  
  if ( ng_global.task_hour_current < 4 ) then
    ng_global.task_hour_current = ng_global.task_hour_current + 1;
  else
    ng_global.task_hour_current = 1;
  end;
  
  ObjSet( "vid_int_dialog_task_hourlass", { res = "assets/interface/int_task/anims/vid_hourglass_"..ng_global.task_hour_current } );
  ng_global.task_current = "task_4"; 
  
  if ( show ) then
    int.Lock( true );
    private.ShowAnim ( "show" );
  end;
  
end;
--******************************************************************************************
function public.IsOnScreen()

  return ObjGet( "obj_int_dialog_task" ).input;

end;