-- name=int_effects_impl
--******************************************************************************************
function public.Init()
  private.ho_hint = {};
end;
--******************************************************************************************
function public.Destroy()
end;
--******************************************************************************************
function public.HoHintShowAnim( target_name, hint_pos_x, hint_pos_y, event_id )

  local hint_name  = "pfx_int_effects_ho_hint_"..target_name;
  local timer_name = "tmr_int_effects_ho_hint_"..target_name;

  if ( not private.ho_hint[ target_name ] ) then

    private.ho_hint[ target_name ] = 1;

    ObjCreate( hint_name, "partsys" );

    ObjSet( hint_name,
    {
      res = "assets/interface/resources/effects_ho_hint",
      pos_x = hint_pos_x, pos_y = hint_pos_y,
      active = 1, visible = 1, input = 0
    } );

    ObjAttach( hint_name, "int_effects_impl" );

    ObjCreate( timer_name, "timer" );
    ObjAttach( timer_name, hint_name );

  else

    ObjSet( timer_name, { playing = 0 } );
    PartSysStop( hint_name, 0 );
    PartSysStart( hint_name );

  end;

  ObjSet( timer_name, 
  {
    endtrig = function () private.HoHintShowAnimEnd( target_name, event_id ); end,
    time    = 3.0,
    playing = true
  } );

end;
--******************************************************************************************
function private.HoHintShowAnimEnd( target_name, event_id )

  local hint_name  = "pfx_int_effects_ho_hint_"..target_name;
  local timer_name = "tmr_int_effects_ho_hint_"..target_name;

  ObjDelete( hint_name );
  ObjDelete( timer_name );
  private.ho_hint[ target_name ] = nil;
  int_effects.EventAnimEnd( event_id );

end;
--******************************************************************************************