-- name=int_morphing
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_morphing", interface.originhub );
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );
  --private.event_anim_end = {};
  private.DIRECTION =  -1;

  private.MOUSE_OVER_ANIM_TIME = 0.3;

  private.MOVE_ANIM_POS_X_BEG  =  -164;
  private.MOVE_ANIM_POS_X_END  =   160;

  private.MOVE_ANIM_TIME       =  0.6;

  private.timer = 3; --время таймера

  private.IMG_X = -114;
  private.IMG_Y = -1;
  private.IMG_SC_X = 0.685;
  private.IMG_SC_Y = 0.685;

  private.TEXT_NAME_X = 50;
  private.TEXT_NAME_Y = 0;

  private.LEFT_NUMBERS  = 0;
  private.RIGHT_NUMBERS = 0;

  private.morphing = {};
  private.morphing.show = false;

  private.morphing.map_room = 
  {
      { "bypolicestation", "policestation", "bygrayscar", "abandonedfarm", "townoutskirts", "carrepairshop" },
      { "livingroom", "yard", "kitchen", "office", "basement", "switchroom" },
      { "waitinghall", "window", "aircompaniesstand", "secondfloorcorridor", "technicalroom", "controltower" },
      { "nearcar", "farm", "cemetery", "livingroomext", "kitchenext", "basementext", "plane", "stewardessroom", "flightdeck" }
  }

  ObjSet( "int_morphing", { alp = 0 } );
  ObjAttach( "tmr_int_morphing_hide", "cmn_timers" );
  ObjSet( "spr_int_morphing_back", { event_mdown = function () private.HideAnimMorphing(); end } );
  private.WideScreenUpdate();

  int.GetMorphObject       = private.GetMorphObject;
  int.MorphRandomState     = private.MorphRandomState;
  int.InitMorphRandomState = private.InitMorphRandomState;
  int.HideAnimMorphing     = private.HideAnimMorphing;
  int.GetMorphingShow      = private.GetMorphingShow;

end;

--******************************************************************************************
function private.InitMorphRandomState( lvl )

 for i = 1,#private.morphing.map_room[ lvl ] do
 
     local room = private.morphing.map_room[ lvl ][ i ];
     local obj  = "obj_"..room.."_morphobject";
     local rel  = ObjGetRelations( obj );

     if ( ObjGet( obj ) ) then

        local child  = rel.childs[ 1 ];
        local index  = string.len( child ) - 4;
        local number = string.sub( child, -5, index );
        int.MorphRandomState( "rm_"..room, "morphobject_"..lvl.."_"..number );

        local name  = "spr_"..room.."_morphobject_"..lvl.."_"..number;

        ObjSet( name.."_beg", { event_mdown = function () int.GetMorphObject( name.."_beg" ) end; } );
        ObjSet( name.."_end", { event_mdown = function () int.GetMorphObject( name.."_end" ) end; } );

     end;

 end;

end;
--******************************************************************************************
function private.WideScreenUpdate()

  local direction = private.DIRECTION or 0;

  if ( direction ~= 0 ) and ObjGet( "int_morphing" ) then

    local offset = 0.5 * ( GetAppWidth() - 1024 );
    local position =  0;

    local posx = position + ( direction * offset );
    ObjSet( "int_morphing", { pos_x = posx } );

  end;

end;
--******************************************************************************************
function private.MorphRandomState ( room, name )
  
  local state = { "beg", "end" };
  local value = math.random( 1, 2 );

  if ( string.find( room, "rm" ) ) then

    room = common.GetObjectName( room );

  end;

  local name_obj = "spr_"..room.."_"..name.."_"..state[ value ];
  local invert_value = 1;
  
  if ( value == 1 ) then
    
      invert_value = 2;

  end;

  local name_invert = "spr_"..room.."_"..name.."_"..state[ invert_value ];

  if ( ObjGet( name_obj ) ) then --глобальная проверка на существование морфинг-объекта

      ObjSet( name_obj,    { alp = 1, input = true } );
      ObjSet( name_invert, { alp = 0, input = false } );

      local name_timer = "tmr_"..room.."_morphobject";

      if not ( ObjGet( name_timer ) ) then

          ObjCreate( name_timer, "timer" );
          ObjAttach( name_timer, "rm_"..room );
          
          local tme = math.random( 3, 15 );
          
          ObjSet( name_timer, 
          { 
            time = tme, 
            playing = 1,
            endtrig = function () private.MorphStateAnim( name_obj, name_invert, room ) end
          } );

      end;

  end;

end;
--******************************************************************************************
function private.MorphStateAnim ( name_obj, name_invert, room )

  ObjSet( name_obj, { input = false } );
  ObjSet( name_invert, { input = false } );

  ObjAnimate( name_obj, "alp", 0, 0, "", 
  { 
    0.0, 0, 1.0,
    0.6, 0, 0.0
  } );

  ObjAnimate( name_invert, "alp", 0, 0, function () private.MorphStateAnimEnd( name_obj, name_invert, room ) end, 
  { 
    0.0, 0, 0.0,
    0.6, 0, 1.0
  } );

end;
--******************************************************************************************
function private.MorphStateAnimEnd ( name_obj, name_invert, room )

  ObjSet( name_invert, { input = true } );

  local name_timer = "tmr_"..room.."_morphobject";

  local tme = math.random( 3, 15 );
  
  ObjSet( name_timer, 
  { 
    time = tme, 
    playing = 1,
    endtrig = function () private.MorphStateAnim( name_invert, name_obj, room ) end
  } );

end;

--******************************************************************************************
function private.GetMorphObjectEnd( prg_event )

  private.ShowAnimMorphing ();

  int.Lock( false );

  cmn.CallEventHandler( prg_event );

  private.CheckMorphings( prg_event );

end;
--******************************************************************************************
function private.CheckMorphings ( name )

  local prg = ng_global.currentprogress; 
--DbgTrace( "1private.CheckMorphings = "..tostring( name ) );
  if ( IsCollectorsEdition() or IsSurveyEdition() ) and prg ~= "scr" then
--DbgTrace( "2private.CheckMorphings = "..tostring( name ) );
      --ng_global.morphings.count = ng_global.morphings.count + 1;
    common_impl.CountGetMorphCollect();


  end;

end;
--******************************************************************************************
function private.GetMorphObject ( name_obj )

  local c_Num     = string.find( name_obj, "morphobject" );
  local name      = string.sub( name_obj, c_Num, ( c_Num + 14 ) ); --выделяем из имени объекта форму morphobject_<num>_<num>
  local prg_event = "get_"..name;
 
  local pfx_frame_name = "pfx_frame_"..name;
  local pfx_hide_name  = "pfx_hide_"..name_obj;

  int.Lock( true );

  local name_timer = "tmr_"..tostring( common.GetObjectName( GetCurrentRoom() ) ).."_morphobject";

  if ( ObjGet( name_timer ) ) then

    ObjDelete( name_timer );

  end;

  if not ( ng_global.morphings ) then

      ng_global.morphings = {};

  end;

  if not ( ng_global.morphings.count ) then

      ng_global.morphings.count = 0;

  end;

  ng_global.morphings.count = ng_global.morphings.count + 1;
  cmn.SetEventDone( prg_event );

  ObjSet( name_obj, { input = false } );

  local func_end     = function () private.GetMorphObjectEnd( prg_event ); ObjDelete( "pfx_hide_name" ) end;
  local name_obj_end = "obj_"..( common.GetObjectName( GetCurrentRoom() ) ).."_morphobject";
  local pfx_hide_pos       = GetObjPosByObj( name_obj, InterfaceWidget_Top_Name );
  local pfx_hide_drawoff_x = ObjGet( name_obj ).drawoff_x;
  local pfx_hide_drawoff_y = ObjGet( name_obj ).drawoff_y;

  ObjCreate( pfx_frame_name, "partsys" );

  ObjAttach( pfx_frame_name, InterfaceWidget_Top_Name );
  ObjSet( pfx_frame_name, 
  { 
    input = false, 
    pos_x = pfx_hide_pos[ 1 ] - 50, pos_y = pfx_hide_pos[ 2 ] + 10,
    res = "assets/levels/common/fx/pfx_morphing" 
  } );
 
  ObjCreate( pfx_hide_name, "partsys" );

  ObjSet( pfx_hide_name,
  {
    res = "assets/interface/resources/effects_ho_hint",
    pos_x = pfx_hide_pos[ 1 ], pos_y = pfx_hide_pos[ 2 ],
    active =true, visible = true, input = false
  } );

  ObjAttach( pfx_hide_name, InterfaceWidget_Top_Name );
  ObjSet( pfx_hide_name, { blendmode = 2 } );
  
  PartSysSetMaskObj( pfx_hide_name, name_obj );  

  ObjAnimate( name_obj, "alp", 0, 0, func_end,
  { 
    0.0, 0, 1.0,
    1.4, 0, 0.0
  } );

  local func_end_1 = function () ObjDelete( "pfx_hide_name" ); ObjDelete( "name_obj" ) end;

  ObjAnimate( pfx_frame_name, "alp", 0, 0, func_end_1,
  { 
    0.0, 0, 1.0,
    1.2, 0, 1.0,
    1.4, 0, 0.0
  } );

  cmn.PlayAudio( "sfx", "audio/aud_morphing" );

end;
--******************************************************************************************
function private.ChangeValue ( event_id )

  local func_end         = function () private.ChangeValueEnd();  end;
  local left_name_first  = "spr_int_morphing_numbers_left_first_"..private.LEFT_NUMBERS;
  local right_name_first = "spr_int_morphing_numbers_right_first_"..private.RIGHT_NUMBERS;

  local left_name_second  = "spr_int_morphing_numbers_left_second_"..private.LEFT_NUMBERS;
  local right_name_second = "spr_int_morphing_numbers_right_second_"..private.RIGHT_NUMBERS;
  
  if ( private.RIGHT_NUMBERS == 0 ) then

      ObjCreate( left_name_second, "spr" );    

      ObjSet( left_name_second, 
      {
        pos_x = -125,
        pos_y = 44,
        pos_z =  0,
        res   = "assets/interface/resources/morphing/numbers/"..private.LEFT_NUMBERS,
        input =  false,
      } );

      ObjAttach( left_name_second, "obj_int_morphing_numbers" );    

      ObjAnimate( left_name_first, "pos_y", 0, 0, "", 
      { 
        0.0, 3,  12,
        0.5, 3, -66 
      } );

      ObjAnimate( left_name_second, "pos_y", 0, 0, "", 
      { 
        0.0, 3, 46, 
        0.5, 3, 12 
      } );

  end;

  ObjCreate( right_name_second, "spr" );

  ObjSet( right_name_second, 
  {
    pos_x = -70,
    pos_y = 44,
    pos_z =  0,
    res   = "assets/interface/resources/morphing/numbers/"..private.RIGHT_NUMBERS,
    input = false,
  } );

  ObjAttach( right_name_second, "obj_int_morphing_numbers" );

  ObjAnimate( right_name_first, "pos_y", 0, 0, func_end, 
  { 
    0.0, 3,  12,
    0.5, 3, -66 
  } );

  ObjAnimate( right_name_second, "pos_y", 0, 0, "", 
  { 
    0.0, 3, 46, 
    0.5, 3, 12 
  } );

  --cmn.PlayAudio( "sfx", "audio/aud_counter" );

end;
--******************************************************************************************
function private.ChangeValueEnd ()

  ObjSet( "obj_int_morphing", { input = true } );

  if ( int.GetMorphingShow() ) then

     ObjSet( "tmr_int_morphing_hide", { playing = false });
     local func_end   = function () private.HideAnimMorphing(); end;
     local func_end_1 = function () ObjSet( "tmr_int_morphing_hide", { endtrig = func_end, time = private.timer, playing = true } );  end;
     func_end_1();

  else 

  end;


  ObjSet( "int_morphing", { alp = 1, input = true } );
  ObjSet( "obj_int_morphing", { input = true } );

end;
--******************************************************************************************
function private.EventAnimEnd ( event_id )

  if ( event_id == "show" ) then

    ObjSet( "obj_int_morphing", { input = true } );

    private.ChangeValue( event_id );

  elseif ( event_id == "hide" ) then

    ObjSet( "obj_int_morphing", { input = false } );
    private.DeleteNumbers();

  end;
  
end;

--******************************************************************************************
function private.MouseEnterAnim ()

  ld.PlayAudio( "sfx", "audio/aud_menter" );
  SetCursor( CURSOR_HAND );

  local obj = "pfx_int_morphing_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
--******************************************************************************************
function private.MouseLeaveAnim ()

  SetCursor( CURSOR_DEFAULT );

  local obj = "pfx_int_morphing_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
--******************************************************************************************
function private.ShowAnimMorphing ()

  local obj      = "obj_int_morphing";
  local event_id = "show";
  local tme      = private.MOVE_ANIM_TIME;
  local func_end = function () private.EventAnimEnd( event_id ) end;

  private.NumbersInit();
  private.morphing.show = true;

  ObjStopAnimate( obj, "pos_x" ); 
  ObjSet( "int_morphing", { alp = 1 } );
  ObjSet( "tmr_int_morphing_hide", { endtrig = func_end, time = private.timer, playing = 0 } );

  local current_posx = private.MOVE_ANIM_POS_X_BEG;

  ObjAnimate( obj, "pos_x", 0, 0, func_end,
  {
    0.0, 2, private.MOVE_ANIM_POS_X_BEG,
    tme, 2, private.MOVE_ANIM_POS_X_END
  } );

  cmn.PlayAudio( "sfx", "audio/aud_clue_show" );
  cmn.PlayAudio( "sfx", "audio/aud_counter" );

end;
--******************************************************************************************
--******************************************************************************************
function private.HideAnimMorphing ()

  local obj      = "obj_int_morphing";
  local event_id = "hide";
  local func_end = function () private.EventAnimEnd( event_id ) end;
  local tme      = private.MOVE_ANIM_TIME;
  local cur_posx = private.MOVE_ANIM_POS_X_END;

  private.morphing.show = false;

  ObjStopAnimate( obj, "pos_x" ); 
  current_posx = ObjGet( obj ).pos_x; 
  
  ObjSet( "int_morphing", { input = false } );

  ObjAnimate( obj, "pos_x", 0, 0, func_end,
  {
    0.0, 1, cur_posx,
    tme, 1, private.MOVE_ANIM_POS_X_BEG
  } );

  ObjSet( "tmr_int_morphing_hide", { playing = 0 } );

  cmn.PlayAudio( "sfx", "audio/aud_clue_hide" );

end;
--******************************************************************************************
--******************************************************************************************
function private.NumbersInit ()

  local value     = 0;
  local tmp_value = value;

  if ( ng_global.morphings.count > 0 ) then

    value     = ng_global.morphings.count;
    tmp_value = ng_global.morphings.count - 1;

  end;

  private.LEFT_NUMBERS  = 0;
  private.RIGHT_NUMBERS = 0;
  
  local tmp_value_left  = 0;
  local tmp_value_right = 0;

  if ( value >= 9 ) then
  
      private.RIGHT_NUMBERS = math.fmod( value, 10 );
      tmp_value_right = math.fmod( tmp_value, 10 );

      private.LEFT_NUMBERS  = math.floor( value / 10 );
      tmp_value_left = math.floor( value / 10 );
    
      if ( tmp_value_right == 9 ) then

          tmp_value_left = tmp_value_left - 1;

      end;

  else

      private.RIGHT_NUMBERS = value;
      tmp_value_right       = tmp_value;

  end;

  local left_name  = "spr_int_morphing_numbers_left_first_"..private.LEFT_NUMBERS;
  local right_name = "spr_int_morphing_numbers_right_first_"..private.RIGHT_NUMBERS;
  
  ObjCreate( left_name, "spr" );
  ObjCreate( right_name, "spr" );

  ObjSet( left_name, 
  {
    pos_x = -125,
    pos_y = 12,
    pos_z =  2,
    res   = "assets/interface/resources/morphing/numbers/"..tmp_value_left,
    input =  false,
  } );

  ObjSet( right_name, 
  {
    pos_x = -70,
    pos_y =  12,
    pos_z =  2,
    res   = "assets/interface/resources/morphing/numbers/"..tmp_value_right,
    input = false,
  } );

  ObjAttach( left_name,  "obj_int_morphing_numbers" );
  ObjAttach( right_name, "obj_int_morphing_numbers" );

end;
--******************************************************************************************
--******************************************************************************************
function private.DeleteNumbers ()

  local left_name_first  = "spr_int_morphing_numbers_left_first_"..private.LEFT_NUMBERS;
  local right_name_first = "spr_int_morphing_numbers_right_first_"..private.RIGHT_NUMBERS;

  local left_name_second  = "spr_int_morphing_numbers_left_second_"..private.LEFT_NUMBERS;
  local right_name_second = "spr_int_morphing_numbers_right_second_"..private.RIGHT_NUMBERS;

  ObjDelete( left_name_first   );
  ObjDelete( left_name_second  );
  ObjDelete( right_name_first  );
  ObjDelete( right_name_second );

end;
--******************************************************************************************
function private.GetMorphingShow()

  return private.morphing.show;

end;
--******************************************************************************************

