-- name=int_strategy_guide_impl
--******************************************************************************************
function public.Init()

  
  public.GRID_CORNER_W = 110;
  public.GRID_CORNER_H = 110;
  public.GRID_MID_W    =  8;
  public.GRID_MID_H    =  8;

  public.GRID_FIXED_W  = 640;
  public.GRID_FIXED_H  = 360;
  public.GRID_BORDER_H = 47;
  public.GRID_MIN_H    = 140;  
  
  local grid_w = public.GRID_FIXED_W + public.GRID_BORDER_H;
  local grid_h = public.GRID_FIXED_H + public.GRID_BORDER_H;

  local grid_corner_w = public.GRID_CORNER_W;
  local grid_corner_h = public.GRID_CORNER_H;

  local grid_mid_w = public.GRID_MID_W;
  local grid_mid_h = public.GRID_MID_H;

  interface.FrameGridSet( "int_strategy_guide_image",
  {
    grid_w   = grid_w,
    grid_h   = grid_h,
    corner_w = grid_corner_w,
    corner_h = grid_corner_h,
    mid_w    = grid_mid_w,
    mid_h    = grid_mid_h
  } );  
  
  local TEXT_WIDTH_1 = 400;
  local TEXT_WIDTH_2 = 400;

  local IMAGE_COLUMN_1 = 134;
  local IMAGE_COLUMN_2 = 328;

  local IMAGE_ROW_1 = - 188;
  local IMAGE_ROW_2 = -  26;
  local IMAGE_ROW_3 =   148;

  public.PAGE_CONTENT_DATA_0 = {

    {
      text   =  { maxwidth = TEXT_WIDTH_2 },
      images =  {
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_1 }
                },
    }
  };

  public.PAGE_CONTENT_DATA = {

    {
      text   =  { maxwidth = TEXT_WIDTH_2 },
      images =  {
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_1 }
                },
    },

    {
      text   =  { maxwidth = TEXT_WIDTH_2 },
      images =  {
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_1 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_2 }
                }
    },

    {
      text   =  { maxwidth = TEXT_WIDTH_2 },
      images =  {
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_1 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_2 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_3 }
                }
    },

    {
      text   =  { maxwidth = TEXT_WIDTH_1 },
      images =  {
                  { pos_x = IMAGE_COLUMN_1, pos_y = IMAGE_ROW_1 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_1 },
                  { pos_x = IMAGE_COLUMN_1, pos_y = IMAGE_ROW_2 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_2 }
                }
    },

    {
      text   =  { maxwidth = TEXT_WIDTH_1 },
      images =  {
                  { pos_x = IMAGE_COLUMN_1, pos_y = IMAGE_ROW_1 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_1 },
                  { pos_x = IMAGE_COLUMN_1, pos_y = IMAGE_ROW_2 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_2 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_3 }
                }
    },

    {
      text   =  { maxwidth = TEXT_WIDTH_1 },
      images =  {
                  { pos_x = IMAGE_COLUMN_1, pos_y = IMAGE_ROW_1 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_1 },
                  { pos_x = IMAGE_COLUMN_1, pos_y = IMAGE_ROW_2 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_2 },
                  { pos_x = IMAGE_COLUMN_1, pos_y = IMAGE_ROW_3 },
                  { pos_x = IMAGE_COLUMN_2, pos_y = IMAGE_ROW_3 }
                }
    }

  };


  public.PAGE_CONTENT_DATA[ 0 ] = { text = { maxwidth = 400 } };

  private.MOUSE_OVER_ANIM_TIME = 0.3;
  private.MOUSE_ENTER_FIRST = false;
  private.OFFSET_CHECKBOX = 12;

  ObjSet( "btn_int_strategy_guide_button_close", {
    event_mdown  = function () cmn.PlayAudio( "sfx", "audio/aud_click_menu" ); int_strategy_guide.ButtonCloseMouseDown(); end,
    event_menter = function () private.CloseButtonMouseEnterAnim("btn_int_strategy_guide_button_close"); end,
    event_mleave = function () private.CloseButtonMouseLeaveAnim("btn_int_strategy_guide_button_close"); end,
  } );
  ObjSet( "btn_int_strategy_guide_button_toc", {
    event_mdown  = function () int_strategy_guide.ButtonTOCMouseDown(); end,
    event_menter = function () private.ButtonMouseEnterAnim( "btn_int_strategy_guide_button_toc" ); end,
    event_mleave = function () private.ButtonMouseLeaveAnim( "btn_int_strategy_guide_button_toc" ); end,
  } );
  ObjSet( "btn_int_strategy_guide_button_next", {
    event_mdown  = function () cmn.PlayAudio( "sfx", "audio/aud_strategy_guide_list" ); int_strategy_guide.ButtonNextMouseDown(); end,
    event_menter = function () private.ButtonMouseEnterAnim( "btn_int_strategy_guide_button_next" ); end,
    event_mleave = function () private.ButtonMouseLeaveAnim( "btn_int_strategy_guide_button_next" ); end,
  } );
  ObjSet( "btn_int_strategy_guide_button_prev", {
    event_mdown  = function () cmn.PlayAudio( "sfx", "audio/aud_strategy_guide_list" ); int_strategy_guide.ButtonPrevMouseDown(); end,
    event_menter = function () private.ButtonMouseEnterAnim( "btn_int_strategy_guide_button_prev" ); end,
    event_mleave = function () private.ButtonMouseLeaveAnim( "btn_int_strategy_guide_button_prev" ); end,
  } );
  ObjSet( "wnd_int_strategy_guide_image", {
    event_mdown  = function () int_strategy_guide.ImageHide(); end,
    event_menter = function () SetCursor( CURSOR_DOWN ); end,
    event_mleave = function () SetCursor( CURSOR_DEFAULT ); end,
  } );
  for i = 1, 6 do
    ObjSet( "obj_int_strategy_guide_page_image_"..i, {
      event_mdown  = function () cmn.PlayAudio( "sfx", "audio/aud_click_menu" ); int_strategy_guide.ImageShow( i ); end,
      event_menter = function () private.ButtonMouseEnterAnim( "obj_int_strategy_guide_page_image_"..i, "grd" ); end,
      event_mleave = function () private.ButtonMouseLeaveAnim( "obj_int_strategy_guide_page_image_"..i, "grd" ); end,
    } );
  end;
  for i = 1, 9 do
    ObjSet( "obj_int_strategy_guide_toc_chapter_"..i, {
      event_mdown  = function ()  end,
      event_menter = function () private.TocButtonMouseEnterAnim("obj_int_strategy_guide_toc_chapter_"..i); end,
      event_mleave = function () private.TocButtonMouseLeaveAnim("obj_int_strategy_guide_toc_chapter_"..i); end,
    } );
  end;

end;
--******************************************************************************************
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then

    --
  
  else

    --

  end;

end;
--******************************************************************************************
--******************************************************************************************
function public.ShowAnim( event_id )

  local obj = "int_strategy_guide_impl";
  local trg = int_strategy_guide.EventAnimEnd( event_id );

  ObjAnimate( obj, "alp", 0, 0, trg,
  {
    0.0, 0, 0,
    0.4, 0, 1
  } );

end;
--******************************************************************************************
--******************************************************************************************
function public.HideAnim( event_id )

  local obj = "int_strategy_guide_impl";
  local trg = int_strategy_guide.EventAnimEnd( event_id );

  ObjAnimate( obj, "alp", 0, 0, trg,
  {
    0.0, 0, 1,
    0.4, 0, 0
  } );

end;
--******************************************************************************************
--******************************************************************************************
function public.PageShowAnim( obj_name, event_id )

  local trg = function () int_strategy_guide.EventAnimEnd( event_id ); end;

  local pic     = "obj_strategy_guide_pic";

  if obj_name == "obj_int_strategy_guide_page" then
    
    ObjSet( "txt_int_strategy_guide_title", { pos_x = -216, pos_y = -243 } );

    --ObjAnimate( pic, "alp", 0, 0, "", 
    --{ 
    --  0.0, 0, ObjGet( pic ).alp, 
    --  0.3, 0, 0 
    --} );

  elseif obj_name == "obj_int_strategy_guide_toc" then

    ObjSet( "txt_int_strategy_guide_title", { pos_x = -216, pos_y = -243 } );

    --ObjAnimate( pic, "alp", 0, 0, "", 
    --{ 
    --  0.0, 0, ObjGet( pic ).alp, 
    --  0.3, 0, 1 
    --} );

  end;

  int_strategy_guide.StdPageShowAnimation( obj_name, trg );

end;
--******************************************************************************************
function public.PageHideAnim( obj_name, event_id )

  local trg = function () int_strategy_guide.EventAnimEnd( event_id ); end;

  int_strategy_guide.StdPageHideAnimation( obj_name, trg );

end;
--******************************************************************************************
function private.ButtonMouseEnterAnim( sender, focus_type )

  SetCursor( CURSOR_HAND );

  focus_type = focus_type or "spr";

  local focus = string.format( "%s_%s_focus", focus_type, interface.GetObjectName( sender ) );

  if ( sender == "btn_int_strategy_guide_button_toc") then

    ObjSet( "txt_int_strategy_guide_button_toc", { fontcolor_r = 0.3529, fontcolor_g = 0.2039, fontcolor_b = 0.1412 } );
    local alp = ObjGet( "spr_int_strategy_guide_button_toc_focus" ).alp;
    ObjAnimate( "spr_int_strategy_guide_button_toc_focus", "alp", 0, 0, "", { 0, 0, alp, ( private.MOUSE_OVER_ANIM_TIME * ( 1 - alp ) ), 0, 1 } );

  else

    local name = interface.GetObjectName( sender );

    name = "spr_"..name.."_focus";

    local alp = ObjGet( name ).alp;
    ObjAnimate( name, "alp", 0, 0, "", { 0, 0, alp, ( private.MOUSE_OVER_ANIM_TIME * ( 1 - alp ) ), 0, 1 } );

  end;

  cmn.PlayAudio( "sfx", "audio/aud_menter" );

  --interface.ButtonMouseEnterAnim( sender, "alp", focus );

end;
--******************************************************************************************
function private.ButtonMouseLeaveAnim( sender, focus_type )

  SetCursor( CURSOR_DEFAULT );

  focus_type = focus_type or "spr";

  local focus = string.format( "%s_%s_focus", focus_type, interface.GetObjectName( sender ) );

  if ( sender == "btn_int_strategy_guide_button_toc") then

    ObjSet( "txt_int_strategy_guide_button_toc", { fontcolor_r = 0,fontcolor_g = 0,fontcolor_b = 0 } );
    local alp = ObjGet( "spr_int_strategy_guide_button_toc_focus" ).alp;
    ObjAnimate( "spr_int_strategy_guide_button_toc_focus", "alp", 0, 0, "", { 0, 0, alp, ( private.MOUSE_OVER_ANIM_TIME * ( 1 - alp ) ), 0, 0 } );

  else

    local name = interface.GetObjectName( sender );

    name = "spr_"..name.."_focus";

    local alp = ObjGet( name ).alp;
    ObjAnimate( name, "alp", 0, 0, "", { 0, 0, alp, ( private.MOUSE_OVER_ANIM_TIME * ( 1 - alp ) ), 0, 0 } );

  end;

  cmn.PlayAudio( "sfx", "audio/aud_menter" );

  --interface.ButtonMouseLeaveAnim( sender, "alp", focus );

end;
--******************************************************************************************
--******************************************************************************************
function private.TocButtonMouseEnterAnim( sender )

  SetCursor( CURSOR_HAND );

  local focus = string.format( "%s_%s_focus", "obj", interface.GetObjectName( sender ) );
  local alp = ObjGet( focus ).alp;

  private.SetCheckboxPos()

  ObjSet( focus, { alp = 1 } );

end;

function private.TocButtonMouseLeaveAnim( sender )

  SetCursor( CURSOR_DEFAULT );

  local focus = string.format( "%s_%s_focus", "obj", interface.GetObjectName( sender ) );
  local alp = ObjGet( focus ).alp;
  
  ObjSet( focus, { alp = 0 } );

end;
--******************************************************************************************
--******************************************************************************************
function private.SetCheckboxPos()

  if not private.MOUSE_ENTER_FIRST then

    private.MOUSE_ENTER_FIRST = true;

    for i = 1, 9, 1 do

      local spr_name = "spr_int_strategy_guide_toc_chapter_"..i.."_focus_checkbox";
      
      local txt_width = ObjGet( "txt_int_strategy_guide_toc_chapter_"..i ).draw_width;
      local offset_x  = ( ( txt_width / 2 ) + private.OFFSET_CHECKBOX ) * ( -1 );
      
      ObjSet( spr_name, { pos_x = offset_x } );

    end;

  end;

end;
--******************************************************************************************
function private.CloseButtonMouseEnterAnim( sender )

  SetCursor( CURSOR_HAND );
  local name = interface.GetObjectName( sender );
  
  if GetPerformanceMode() == 0 then

    name = "pfx_"..name.."_focus";

  else

    name = "spr_"..name.."_focus";

  end;
  local alp = ObjGet( name ).alp;
  ObjAnimate( name, "alp", 0, 0, "", { 0, 0, alp, ( private.MOUSE_OVER_ANIM_TIME * ( 1 - alp ) ), 0, 1 } );
  cmn.PlayAudio( "sfx", "audio/aud_menter" );

end;
--******************************************************************************************
function private.CloseButtonMouseLeaveAnim( sender )

  SetCursor( CURSOR_HAND );
  local name = interface.GetObjectName( sender );
  
  if GetPerformanceMode() == 0 then

    name = "pfx_"..name.."_focus";

  else

    name = "spr_"..name.."_focus";

  end;

  local alp = ObjGet( name ).alp;
  ObjAnimate( name, "alp", 0, 0, "", { 0, 0, alp, ( private.MOUSE_OVER_ANIM_TIME * alp  ), 0, 0 } );
  cmn.PlayAudio( "sfx", "audio/aud_menter" );

end;
