-- name=int_taskpanel_scr
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_taskpanel_scr", interface.originhub );
  ObjSet( "int_taskpanel_scr", { pos_z = pos_z } );
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  private.MOVE_ANIM_TIME      = 0.6;
  private.MOVE_ANIM_POS_Y_TOP = 714;
  private.MOVE_ANIM_POS_Y_BOT = 888;

  local pos_offset = - 15;
  --private.TASKHEADER_MOVE_ANIM_TIME_BEG  = int_taskheader_impl.MOVE_ANIM_TIME_BEG;
  --private.TASKHEADER_MOVE_ANIM_TIME_END  = int_taskheader_impl.MOVE_ANIM_TIME_END;
  --private.TASKHEADER_MOVE_ANIM_POS_Y_TOP = int_taskheader_impl.MOVE_ANIM_POS_Y_TOP + pos_offset;
  --private.TASKHEADER_MOVE_ANIM_POS_Y_BOT = int_taskheader_impl.MOVE_ANIM_POS_Y_BOT + pos_offset;

  local tb = {};

  table.insert( tb, { "obj_int_taskpanel_scr_clk_win_scr", {
    event_mdown =  function () private.ClkAchievButton( "win_scr" ); end,
    event_menter = function () SetCursor( CURSOR_LOUPE ); end,
    event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
  } } );

  table.insert( tb, { "obj_int_taskpanel_scr_clk_less_12minutes", {
    event_mdown =  function () private.ClkAchievButton( "less_12minutes" ); end,
    event_menter = function () SetCursor( CURSOR_LOUPE ); end,
    event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
  } } );

  table.insert( tb, { "obj_int_taskpanel_scr_clk_less_6minutes", {
    event_mdown =  function () private.ClkAchievButton( "less_6minutes" ); end,
    event_menter = function () SetCursor( CURSOR_LOUPE ); end,
    event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
  } } );

  table.insert( tb, { "obj_int_taskpanel_scr_clk_no_hint", {
    event_mdown =  function () private.ClkAchievButton( "no_hint" ); end,
    event_menter = function () SetCursor( CURSOR_LOUPE ); end,
    event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
  } } );

  ObjMultiSet( tb );
  private.InitAnim ();
  
end;
--******************************************************************************************
function public.Destroy()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
function private.WideScreenUpdate ()
end;
--******************************************************************************************
function public.UpdateProgressPanel ()

  local prg = { "get_roses_scr", "get_knives_scr", "get_fire_scr", "get_planes_scr", "get_cursed_tickets_scr", "get_cards_of_destiny_scr" };

  for i = 1, #prg do

    if ( cmn.IsEventDone( prg[ i ] ) ) then

      ObjSet( "spr_int_taskpanel_scr_progress_bar_"..i, { alp = 1 } );

    end;

  end;

end;
--******************************************************************************************
function public.ShowAnim( event_id )

  local obj = "int_taskpanel_scr";

  local trg = function () int_taskpanel.EventAnimEnd( event_id ); end;

  local tme = private.MOVE_ANIM_TIME;

  local beg_y = ObjGet( obj ).pos_y;

  ObjAnimate( obj, "pos_y", 0, 0, trg,
  {
    0.0, 2, beg_y,--private.MOVE_ANIM_POS_Y_BOT,
    tme, 2, private.MOVE_ANIM_POS_Y_TOP
  } );

end;
--******************************************************************************************
function public.HideAnim( event_id )

  local obj = "int_taskpanel_scr";

  local trg = function () int_taskpanel.EventAnimEnd( event_id ); end;

  local tme = private.MOVE_ANIM_TIME;

  local beg_y = ObjGet( obj ).pos_y; 

  ObjAnimate( obj, "pos_y", 0, 0, trg,
  {
    0.0, 1, beg_y,--private.MOVE_ANIM_POS_Y_TOP,
    tme, 1, private.MOVE_ANIM_POS_Y_BOT
  } );

end;
--******************************************************************************************
function private.ClkAchievButton ( id )

  cmn.ShowBbt( "bbt_secretroom_achiev_info_"..id );

end;
--******************************************************************************************
function public.UpdateAchievpanel ()

  for key, value in pairs( ng_global.secret.achiev ) do 

    if ( value ) then

      ObjMultiSet( {
        { "spr_int_taskpanel_scr_"..key,           { alp = 1 } },
        { "spr_int_taskpanel_scr_"..key.."_done",  { alp = 1 } },
        { "spr_int_taskpanel_scr_"..key.."_off",   { alp = 0 } },
      } );

    elseif ( ng_global.secret.achiev_temp[ key ] ) then

      ObjMultiSet( {
        { "spr_int_taskpanel_scr_"..key,           { alp = 1 } },
        { "spr_int_taskpanel_scr_"..key.."_done",  { alp = 0 } },
        { "spr_int_taskpanel_scr_"..key.."_off",   { alp = 0 } },
      } );

    elseif ( not ng_global.secret.achiev_temp[ key ] ) then

      ObjMultiSet( {
        { "spr_int_taskpanel_scr_"..key,           { alp = 0 } },
        { "spr_int_taskpanel_scr_"..key.."_done",  { alp = 0 } },
        { "spr_int_taskpanel_scr_"..key.."_off",   { alp = 1 } },
      } );

    end;

  end;

end;
--******************************************************************************************
function private.InitAnim ( )
  
  local prg = { "win_scr", "less_12minutes" ,"less_6minutes" ,"no_hint" }
  for i = 1,4 do 
    
    ObjAnimate( "spr_int_taskpanel_scr_"..prg[i].."_done", "scale_xy", 1, 0, "",
    {
      0.0, 3, 1.2,1.2,
      1.0, 3, 1.0,1.0,
      2.0, 3, 1.2,1.2,
    } );
    
  end;
  
end;
--******************************************************************************************




