-- name=int_timer_scr
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_timer_scr", interface.originhub );
  ObjSet( "int_timer_scr", { pos_z = pos_z } );
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  public.DIRECTION = -1;
  public.POSITION = 57;

  private.WideScreenUpdate();

  --private.pos_y_time_10 = {
  --  62, 38, 14, -10, -34, -95, -82, -106, 
  --};
  private.pos_y_time_10 = {
    49, 25, 1, -23, -47, -71, -95, 
  };

  private.pos_y_time_1 = {
    98, 74, 50, 26, 2, -22, -46, -70, -94, -118, -142, 
  };

end;
--******************************************************************************************
function public.Destroy ()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
function private.WideScreenUpdate()

  if ( not GetWideScreen() ) then

    ObjSet( "int_timer_scr", { pos_x = 0 } );
  
  else

    ObjSet( "int_timer_scr", { pos_x = 180 } );

  end;

end;
--******************************************************************************************
function public.SetTimer ()

  ObjSet( "tmr_int_timer_scr", {
    time = ng_global.secret.curr_time,      
  } );

  local time = math.floor ( ObjGet( "tmr_int_timer_scr" ).time );

  local hours = math.floor(time / 3600);
  local minuts = math.floor(((time - hours * 3600)/60));
  local seconds = math.ceil(time - hours*3600 - minuts*60 );

  local pos_y_curr_hours = private.GetCoordTime( hours );
  local pos_y_curr_minuts = private.GetCoordTime( minuts );
  local pos_y_curr_second = private.GetCoordTime( seconds );

  ObjMultiSet( {
    { "spr_int_timer_scr_digit_1", { pos_y = private.pos_y_time_1[ pos_y_curr_hours[ 2 ] ] } },
    { "spr_int_timer_scr_digit_2", { pos_y = private.pos_y_time_10[ pos_y_curr_minuts[ 1 ] ] } },
    { "spr_int_timer_scr_digit_3", { pos_y = private.pos_y_time_1[ pos_y_curr_minuts[ 2 ] ] } },
    { "spr_int_timer_scr_digit_4", { pos_y = private.pos_y_time_10[ pos_y_curr_second[ 1 ] ] } },
    { "spr_int_timer_scr_digit_5", { pos_y = private.pos_y_time_1[ pos_y_curr_second[ 2 ] ] } },
  } );

end;
--******************************************************************************************
function public.StartTimer ()

  if ( not ObjGet( "tmr_int_timer_scr" ).playing ) then

    cmn.PlayAudio( "sfx", "secretroom/sfx/aud_bell_timer", 0, "", 0 );
    ObjSet( "tmr_int_timer_scr", {
      playing = true,      
    } );
    private.Time();

  end;

end;
--******************************************************************************************
function public.PauseTimer ()

  ObjSet( "tmr_int_timer_scr", {
    playing = false,    
  } );

end;
--******************************************************************************************
function public.StopTimer ()
end;
--******************************************************************************************
function private.Time ()

  local time;
  local tme;

  time = math.floor ( ObjGet( "tmr_int_timer_scr" ).time );
  tme = 1;

  local hours = math.floor(time / 3600);
  local minuts = math.floor(((time - hours * 3600)/60));
  local seconds = math.ceil(time - hours*3600 - minuts*60 );

  local pos_y_curr_hours = private.GetCoordTime( hours );
  local pos_y_curr_minuts = private.GetCoordTime( minuts );
  local pos_y_curr_second = private.GetCoordTime( seconds );

  local func_end = function ()
    
    ng_global.secret.curr_time = ObjGet( "tmr_int_timer_scr" ).time;

    if ( ng_global.secret.curr_time >= 360 and ng_global.secret.achiev_temp[ "less_6minutes" ] ) then 
 
      ng_global.secret.achiev_temp[ "less_6minutes" ] = false;
      int_taskpanel_scr.UpdateAchievpanel();

    end;

    if ( ng_global.secret.curr_time >= 720 and ng_global.secret.achiev_temp[ "less_12minutes" ] ) then 
 
      ng_global.secret.achiev_temp[ "less_12minutes" ] = false;
      int_taskpanel_scr.UpdateAchievpanel();

    end;

    if ( ObjGet( "tmr_int_timer_scr" ).playing ) then    

      private.Time();

    end;

  end; 

  local atm = 0.3;

  --hours
  if ( pos_y_curr_hours[ 2 ] == 2 and 
    ObjGet( "spr_int_timer_scr_digit_1" ).pos_y == private.pos_y_time_1[ #private.pos_y_time_1 ] ) then

    ObjSet( "spr_int_timer_scr_digit_1", { pos_y = private.pos_y_time_1[ 1 ] } );

  end;
  ObjAnimate( "spr_int_timer_scr_digit_1", "pos_y", 0, 0, "", {
    0.0, 0, ObjGet( "spr_int_timer_scr_digit_1" ).pos_y,
    atm, 0, private.pos_y_time_1[ pos_y_curr_hours[ 2 ] ],
  } );
  -----------

  --minutes
  if ( pos_y_curr_minuts[ 1 ] == 2 and 
    ObjGet( "spr_int_timer_scr_digit_2" ).pos_y == private.pos_y_time_10[ #private.pos_y_time_10 ] ) then

    ObjSet( "spr_int_timer_scr_digit_2", { pos_y = private.pos_y_time_10[ 1 ] } );

  end;
  if ( pos_y_curr_minuts[ 2 ] == 2 and 
    ObjGet( "spr_int_timer_scr_digit_3" ).pos_y == private.pos_y_time_1[ #private.pos_y_time_1 ] ) then

    ObjSet( "spr_int_timer_scr_digit_3", { pos_y = private.pos_y_time_1[ 1 ] } );

  end;
  ObjAnimate( "spr_int_timer_scr_digit_2", "pos_y", 0, 0, "", {
    0.0, 0, ObjGet( "spr_int_timer_scr_digit_2" ).pos_y,
    atm, 0, private.pos_y_time_10[ pos_y_curr_minuts[ 1 ] ],
  } );
  ObjAnimate( "spr_int_timer_scr_digit_3", "pos_y", 0, 0, "", {
    0.0, 0, ObjGet( "spr_int_timer_scr_digit_3" ).pos_y,
    atm, 0, private.pos_y_time_1[ pos_y_curr_minuts[ 2 ] ],
  } );  
  -----------

  --seconds
  if ( pos_y_curr_second[ 1 ] == 2 and 
    ObjGet( "spr_int_timer_scr_digit_4" ).pos_y == private.pos_y_time_10[ #private.pos_y_time_10 ] ) then

    ObjSet( "spr_int_timer_scr_digit_4", { pos_y = private.pos_y_time_10[ 1 ] } );

  end;
  if ( pos_y_curr_second[ 2 ] == 2 and
    ObjGet( "spr_int_timer_scr_digit_5" ).pos_y == private.pos_y_time_1[ #private.pos_y_time_1 ] ) then

    ObjSet( "spr_int_timer_scr_digit_5", { pos_y = private.pos_y_time_1[ 1 ] } );

  end;
    
  if ( ObjGet( "spr_int_timer_scr_digit_4" ).pos_y ~= private.pos_y_time_10[ pos_y_curr_second[ 1 ] ] ) then

    cmn.PlayAudio( "sfx", "secretroom/sfx/aud_timer1", 0, "", 0 );

  end;

  ObjAnimate( "spr_int_timer_scr_digit_4", "pos_y", 0, 0, "", {
    0.0, 0, ObjGet( "spr_int_timer_scr_digit_4" ).pos_y,
    atm, 0, private.pos_y_time_10[ pos_y_curr_second[ 1 ] ],
  } );
  ObjAnimate( "spr_int_timer_scr_digit_5", "pos_y", 0, 0, func_end, {
    0.0, 0, ObjGet( "spr_int_timer_scr_digit_5" ).pos_y,
    atm, 0, private.pos_y_time_1[ pos_y_curr_second[ 2 ] ],
    tme, 0, private.pos_y_time_1[ pos_y_curr_second[ 2 ] ],
  } );
  -----------

end;
--******************************************************************************************
function private.GetCoordTime ( time )

  local pos_y_10 = math.floor( time/10 ) + 1;
  local pos_y_1 = time%10 + 1;
  
  if ( pos_y_10 == 1 ) then

    pos_y_10 = #private.pos_y_time_10;

  end;

  if ( pos_y_1 == 1 ) then

    pos_y_1 = #private.pos_y_time_1;

  end;

  return { pos_y_10, pos_y_1 };

end;
--******************************************************************************************