-- name=interface_impl
function public.Init ()

  int = {};

  int.WidgetAdd               = interface.WidgetAdd;
  int.PanelNotificationAdd    = interface.PanelNotificationAdd;
  int.InventoryItemAdd        = interface.InventoryItemAdd;
  int.InventoryItemRemove     = interface.InventoryItemRemove;
  int.ItemPanelShow           = interface.ItemPanelShow;
  int.ItemPanelHide           = interface.ItemPanelHide;
  int.ItemPanelTryToComplete  = interface.ItemPanelTryToComplete;
  int.TaskPanelShow           = interface.TaskPanelShow;
  int.TaskPanelHide           = interface.TaskPanelHide;
  int.ButtonLockAdd           = interface.ButtonLockAdd;
  int.BlockSubRoomClose       = interface.BlockSubroomClose;
  int.PopupShow               = interface.PopupShow;
  int.PopupHide               = interface.PopupHide;
  int.Lock                    = private.Lock;

  int.DeployInvAdd            = private.DeployInvAdd;
  int.DeployInvShow           = private.DeployInvShow;
  int.DeployInvHide           = private.DeployInvHide;
  int.GetCurrentInv           = private.GetCurrentInv;
  int.ObjIntersectCheck       = private.ObjIntersectCheck;

  int.DialogHintAdd           = private.DialogHintAdd;
  int.DialogHintShow          = private.DialogHintShow;
  int.DialogHintHide          = private.DialogHintHide;

  int.MorphingAdd             = private.MorphingAdd;
  int.CollectiblesAdd         = private.CollectiblesAdd;
  int.Collectibles2Add        = private.Collectibles2Add;

  int.DialogVideoShow         = interface.DialogVideoShow;
  int.DialogVideoHide         = interface.DialogVideoHide;

  int.InterfaceSetInput       = interface.InterfaceSetInput;
  int.InterfaceSetVisible     = interface.InterfaceSetVisible;

  int.ShowDatetime            = private.DatetimeShow;

  int.InitMiniho              = private.InitMiniho;
  
  private.Init_IntTaskpanelScr();
  private.Init_IntMorphScr();
  private.Init_IntTimerScr();
  private.Init_IntDialogScr();
    
  private.InitLock();
  private.Init_Task();
  private.Init_Achievements();
  private.InitDatetime();

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function Deploy () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.DeployInvAdd ( pos_z )

    InterfaceWidget_Deploy_Inv = "InterfaceWidget_Deploy_Inv";
    interface.CustomWidgetAdd( InterfaceWidget_Deploy_Inv, "assets/interface/int_deploy_inv", "int_deploy_inv",pos_z );

  end;
  -------------------------------------------------------------------------------------
  function private.GetCurrentInv ()

    if ( _G[ "int_deploy_inv" ] ) then

      if ( int_deploy_inv.IsOnScreen() ) then  

        return int_deploy_inv.GetCurrentName();

      end;      

    end;

    return "";

  end;
  -------------------------------------------------------------------------------------
  function private.DeployInvShow ( inv_obj )
    
    if ( _G[ "int_deploy_inv" ] ) then

      int_deploy_inv.Show( inv_obj );

    end;

  end;
  -------------------------------------------------------------------------------------
  function private.DeployInvHide ()

    --common_impl.DeleteHintFx()
  
    if ( _G[ "int_deploy_inv" ] ) then

      int_deploy_inv.Hide();

    end;
    
  end;
  -------------------------------------------------------------------------------------
  function private.StringDivide ( string )  

    local table = {};
    local id = 1;
    local il = 1;

    for i = 1, string.len( string ) do

      if ( string.sub( string, i, i ) == "_" ) then

        table[ id ] = string.sub( string, il, i-1 );
        il = i + 1;
        id = id + 1;

      end;

      if ( i == string.len( string ) ) then

        table[ id ] = string.sub( string, il, i );
        il = i + 1;
        id = id + 1;

      end;

    end;

    return table;

  end;
  -------------------------------------------------------------------------------------
  function private.ObjIntersectCheck ( obj_to_apply, obj_to_check, obj_complex_inv )

    local obj_complex_inv = obj_complex_inv or "deploy_inv_"..private.StringDivide( obj_to_check )[ 4 ];
    return int.GetCurrentInv() == obj_complex_inv and ObjIntersect( obj_to_apply, obj_to_check );

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function Dialog Hint () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.DialogHintAdd ()

    InterfaceWidget_Dialog_Hint = "InterfaceWidget_Dialog_Hint";
    interface.CustomWidgetAdd( InterfaceWidget_Dialog_Hint, "assets/interface/int_dialog_hint", "int_dialog_hint", 10 );

  end;
  -------------------------------------------------------------------------------------
  function private.DialogHintShow ( dlg_room )

    dlg_room = dlg_room;  
    int_dialog_hint.Show( dlg_room );

  end;
  -------------------------------------------------------------------------------------
  function private.DialogHintHide ()

    int_dialog_hint.Hide();

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function Lock () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.InitLock ()

    InterfaceWidget_Lock = "InterfaceWidget_Lock";
    interface.CustomWidgetAdd( InterfaceWidget_Lock, "assets/interface/int_lock", "int_lock",1490 );

  end;
  -------------------------------------------------------------------------------------
  function private.LockShow ()

    if ( _G[ "int_lock" ] ) then

      int_lock.Show();

    end;

  end;
  -------------------------------------------------------------------------------------
  function private.LockHide ()

    if ( _G[ "int_lock" ] ) then

        int_lock.Hide();

    end;

  end;
  -------------------------------------------------------------------------------------
  function private.Lock ( state )

    if ( state ) then

      private.LockShow();

    else

      private.LockHide();

    end;

  end;
-- end
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function Datetime () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.InitDatetime ()

    InterfaceWidget_Datetime = "InterfaceWidget_Datetime";
    interface.CustomWidgetAdd( InterfaceWidget_Datetime, "assets/interface/int_datetime", "int_datetime", 1480 );

  end;
  -------------------------------------------------------------------------------------
  function private.DatetimeShow ( date, time, func_end )

    if ( _G[ "int_datetime" ] ) then

      int_datetime.Show( date, time, func_end );

    end;

  end;
  -------------------------------------------------------------------------------------
-- end
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function Miniho () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.InitMiniho ( pos_z )

    InterfaceWidget_Miniho = "InterfaceWidget_Miniho";
    interface.CustomWidgetAdd( InterfaceWidget_Miniho, "assets/interface/int_button_mini_ho", "int_button_mini_ho", pos_z );

  end;
  -------------------------------------------------------------------------------------
-- end
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function Secretroom () end;
--*********************************************************************************************************************
--*********************************************************************************************************************

  function private.Init_IntTaskpanelScr ()

    function interface.IntTaskpanelScrAdd ( pos_z )

      InterfaceWidget_TaskpanelScr = "InterfaceWidget_TaskpanelScr";
      interface.CustomWidgetAdd( InterfaceWidget_TaskpanelScr, "assets/interface/int_taskpanel_scr", "int_taskpanel_scr", pos_z );

    end;


  end;
  ------------------------------------------------------------------------------------
  function private.Init_IntMorphScr ()

    function interface.IntMorphScrAdd ( pos_z )

      InterfaceWidget_MorphScr = "InterfaceWidget_MorphScr";
      interface.CustomWidgetAdd( InterfaceWidget_MorphScr, "assets/interface/int_morph_scr", "int_morph_scr", pos_z );

    end;

  end;
  ------------------------------------------------------------------------------------
  function private.Init_IntTimerScr ()

    function interface.IntTimerScrAdd ( pos_z )

      InterfaceWidget_TimerScr = "InterfaceWidget_TimerScr";
      interface.CustomWidgetAdd( InterfaceWidget_TimerScr, "assets/interface/int_timer_scr", "int_timer_scr", pos_z );

    end;

  end;
  ------------------------------------------------------------------------------------
  function private.Init_IntDialogScr ()

    function interface.IntDialogScrAdd ( pos_z )

      InterfaceWidget_DialogScr = "InterfaceWidget_DialogScr";
      interface.CustomWidgetAdd( InterfaceWidget_DialogScr, "assets/interface/int_dialog_scr", "int_dialog_scr", pos_z );

    end;

  end;
  ------------------------------------------------------------------------------------
  -- end
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.Init_Task ()

  function interface.ButtonTaskAdd ( pos_z )

    InterfaceWidget_Button_Task = "InterfaceWidget_Button_Task";
    interface.CustomWidgetAdd( InterfaceWidget_Button_Task, "assets/interface/int_button_task", "int_button_task", pos_z );

  end;
  ------------------------------------------------------------------------------------
  function interface.DialogTaskAdd ( pos_z )

    InterfaceWidget_Dialog_Task = "InterfaceWidget_Dialog_Task";
    interface.CustomWidgetAdd( InterfaceWidget_Dialog_Task, "assets/interface/int_dialog_task", "int_dialog_task", pos_z );

  end;
  ------------------------------------------------------------------------------------
  function interface.DialogTaskShow ( task, state, func_end )
    
    local data = { task = task, state = state, func_end = func_end };

    if ( not int_dialog_task.show ) then 
     
      if ( _G[ "int_dialog_task" ] ) then

         int_dialog_task.Show( data );

      end;

    else

      interface.DialogTaskHide();

    end;

  end;
  ------------------------------------------------------------------------------------
  function interface.DialogTaskHide ()

    if ( int_dialog_task.show ) then

      if ( _G[ "int_dialog_task" ] ) then

         int_dialog_task.Hide();

      end;

    end;
    
  end;
  ------------------------------------------------------------------------------------
  function interface.KeyTaskAdd ( task_name, runtime, func_end )

    ng_global.task_current = task_name;
    int_button_task.Update( true, task_name );
    cmn.PlayAudio( "sfx", "audio/aud_global_task", 0, "", 0 );

    interface.DialogTaskShow( task_name, "new_task", func_end );

  end;
  ------------------------------------------------------------------------------------
  function interface.KeyTaskDone ( runtime, func_end )

    if ( runtime ) then

      interface.DialogTaskShow( ng_global.task_current, "done_task", func_end );  

    end;
    int_button_task.Update( false, "none" );
    ng_global.task_current = "none";
  
  end;
  ------------------------------------------------------------------------------------
  function interface.KeyUpdate ()

    local active = false;
    if ( ng_global.task_current ) and ( ng_global.task_current ~= "none" ) then
      active = true;
    end;
    
    if ( ng_global.currentprogress == "ext" ) then
      int_button_task.SwitchBtnToExt();
    end;

    int_button_task.Update( active, ng_global.task_current );
  
  end;
  ------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.MorphingAdd ( pos_z )

  InterfaceWidget_Morphing = "InterfaceWidget_Morphing";
  interface.CustomWidgetAdd( InterfaceWidget_Morphing, "assets/interface/int_morphing", "int_morphing", pos_z );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.CollectiblesAdd ( pos_z )

  InterfaceWidget_Collectibles = "InterfaceWidget_Collectibles";
  interface.CustomWidgetAdd( InterfaceWidget_Collectibles, "assets/interface/int_collectibles", "int_collectibles", pos_z );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.Collectibles2Add ( pos_z )

  InterfaceWidget_Collectibles2 = "InterfaceWidget_Collectibles2";
  interface.CustomWidgetAdd( InterfaceWidget_Collectibles2, "assets/interface/int_collectibles2", "int_collectibles2", pos_z );

end;
--******************************************************************************************
function private.Init_Achievements ()

  function interface.AchievementsAdd ( pos_z )

    InterfaceWidget_achievements = "InterfaceWidget_achievements";
    interface.CustomWidgetAdd( InterfaceWidget_achievements, "assets/interface/int_achievements", "int_achievements", pos_z );

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
