-- name=ho_investigatorsdesk
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------

  room.Define( "ho_investigatorsdesk" );

  private.room_objname = "ho_investigatorsdesk";
  game.relations[ private.room_objname ].exitroom = "rm_policestation";

  private.win_investigatorsdesk = {};

  private.InitAnim();
  private.win_investigatorsdesk.time = { 9, 8.5, 3.5, 7, 9, 6, 7, 5.3, 7.0, 8, 9.5, 9 };
  --------------------------------------------------------------------------------------------
  -- function opn_investigatorsdesk () end;
  --------------------------------------------------------------------------------------------
  local opn_investigatorsdesk = function ()

  end;

  cmn.AddSubscriber( "opn_investigatorsdesk", opn_investigatorsdesk, private.room_objname );
  --------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_investigatorsdesk" ] =
  {
    type    = "get",
    get_obj = "spr_investigatorsdesk_win",
    room    = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_investigatorsdesk_func = function ()

    if ( cmn.IsEventDone( "win_investigatorsdesk" ) ) then

        int.InventoryItemAdd( "inv_killersphoto", "spr_investigatorsdesk_win" );
        ObjDelete( "gho_policestation_investigatorsdesk" );
        ObjDelete( "obj_investigatorsdesk_taskpanel" );
        ObjSet( "obj_policestation_clk_policeman_dialog_2", { input = 1 } );
        ObjDelete( "anm_policestation_policeman1" );
        ObjDelete( "anm_policestation_head_static" );
        ObjSet( "anm_policestation_policeman2", { alp = 1 } );
        --ng_global.task_current = "task_1";
        --int.DeleteTaskMap( "rm_policestation", "win_investigatorsdesk" );

    end;
 
  end;
  cmn.AddSubscriber( "win_investigatorsdesk", win_investigatorsdesk_func );
  --------------------------------------------------------------------------------------------------
  local start_investigatorsdesk_func = function ()

    if ( cmn.IsEventStart( "win_investigatorsdesk" ) ) then

        common_impl.ProcessHoStart( "investigatorsdesk" );

        local ho_found = ng_global.progress[ "std" ][ "win_investigatorsdesk" ].found;

        for i = 1, #ho_found, 1 do

            ObjDelete( ho_found[ i ][ "object" ] );

        end;

        for i = 1,3 do

          local idx = ng_global.progress["std"]["win_investigatorsdesk"].note[ i ][ 1 ];

          if ( ng_global.progress["std"]["win_investigatorsdesk"].note[ i ][ 2 ] ) then

            ObjSet( "spr_investigatorsdesk_"..i.."check", { alp = 1 } );

          end;

        end;

    end;

  end;
  cmn.AddSubscriber( "win_investigatorsdesk", start_investigatorsdesk_func, "ho_investigatorsdesk" );
  --------------------------------------------------------------------------------------------------

  private.win_investigatorsdesk.task = { "twentythree", "car", "spikes", "cartracks", "gun", "camera", "family", "cassette", "house", "knife", "deer", "manphoto" };

  for i = 1, #private.win_investigatorsdesk.task do

    ObjSet( "spr_investigatorsdesk_"..private.win_investigatorsdesk.task[ i ], { input = false, event_mdown = function () private.CompleteTask( private.win_investigatorsdesk.task[ i ] ); end } );

  end;
  --------------------------------------------------------------------------------------------------  
end;
--*********************************************************************************************************************
function public.Load ()


end;
--*********************************************************************************************************************
function public.PreOpen ()


  cmn.InterfaceSetVisible( true );
  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventDone( "opn_investigatorsdesk" ) ) then

    cmn.SetEventDone( "opn_investigatorsdesk" );
    cmn.CallEventHandler( "opn_investigatorsdesk" );

    ng_global.progress["std"]["win_investigatorsdesk"].number = 1;
    ng_global.progress["std"]["win_investigatorsdesk"].note = { { 6, false }, { 9, false }, { 12, false } };

    cmn.TutorialShow( "tutorial_page_10" );
    cmn.TutorialSetShown( "tutorial_page_10" );

  end;

  private.TaskStart();

  local ho_tasks = {};

  interface.TaskPanelTaskAdd( ho_tasks, "twentythree",    1, 0, { { "spr_investigatorsdesk_twentythree"        } } );
  interface.TaskPanelTaskAdd( ho_tasks, "car",            1, 0, { { "spr_investigatorsdesk_car"  } } );
  interface.TaskPanelTaskAdd( ho_tasks, "spikes",         1, 0, { { "spr_investigatorsdesk_spikes"  } } );
  interface.TaskPanelTaskAdd( ho_tasks, "cartracks",      1, 0, { { "spr_investigatorsdesk_cartracks" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "gun",            1, 0, { { "spr_investigatorsdesk_gun"     } } );
  interface.TaskPanelTaskAdd( ho_tasks, "camera",         1, 0, { { "spr_investigatorsdesk_camera"       } } );
  interface.TaskPanelTaskAdd( ho_tasks, "family",         1, 0, { { "spr_investigatorsdesk_family"      } } );
  interface.TaskPanelTaskAdd( ho_tasks, "cassette",       1, 0, { { "spr_investigatorsdesk_cassette"      } } );
  interface.TaskPanelTaskAdd( ho_tasks, "house",          1, 0, { { "spr_investigatorsdesk_house"  } } );
  interface.TaskPanelTaskAdd( ho_tasks, "knife",          1, 0, { { "spr_investigatorsdesk_knife"       } } );
  interface.TaskPanelTaskAdd( ho_tasks, "deer",           1, 0, { { "spr_investigatorsdesk_deer" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "manphoto",       1, 0, { { "spr_investigatorsdesk_manphoto"     } } );


  if ( not cmn.IsEventStart( "win_investigatorsdesk" ) ) then

      cmn.InitHo( "investigatorsdesk" );

  end;

  int.TaskPanelShow( ho_tasks );
  private.Panel();

  common_impl.StopMusEnv( false );

  cmn.StopAllEnv( "audio/level1/env/aud_policestation_env" );

  cmn.PlayAudio( "env", "audio/level1/env/aud_investigatorsdesk_env", 1 );

  --cmn.PlayAudio( "env", "audio/level1/env/aud_ho_theme_mus_env", 1 );

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();
  private.TimerStart();

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();
  --cmn.StopAudio( "env", "audio/level1/env/aud_ho_theme_mus_env", 0.3 );
  cmn.StopAllVoc();

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();
  ObjSet( "int_inventory_impl", { input = true } );

end;
--*********************************************************************************************************************
function public.HoComplete ()

  --common_impl.PassingHoWin();

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )

  local postfix = "";

  if ( number ) then

     postfix = "_1"

  end;

  cmn.HoTaskFind( "spr_investigatorsdesk_"..name..postfix, name..postfix );
  common_impl.PassingHoCheck();
  private.CheckDone();
  if ( ng_global.progress["std"]["win_investigatorsdesk"].number ~= 12) then

    ng_global.progress["std"]["win_investigatorsdesk"].number = ng_global.progress["std"]["win_investigatorsdesk"].number + 1;
    private.Task();

  end;

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );
  ObjAttach( "obj_investigatorsdesk_taskpanel" , "int_taskpanel_impl" );

end;
--*********************************************************************************************************************
function private.TaskStart()

  local number = ng_global.progress["std"]["win_investigatorsdesk"].number;
  ObjSet( "txt_investigatorsdesk_taskpanel", { alp = 1, text = "tsk_investigatorsdesk_"..private.win_investigatorsdesk.task[ number ] } );
  ObjSet( "spr_investigatorsdesk_"..private.win_investigatorsdesk.task[ number ], { input = true } );

end;
--*********************************************************************************************************************
function private.Task ()
  
  local func_end = function ()

    local number = ng_global.progress["std"]["win_investigatorsdesk"].number;
    ObjSet( "txt_investigatorsdesk_taskpanel", { text = "tsk_investigatorsdesk_"..private.win_investigatorsdesk.task[ number ] } );
    ObjSet( "spr_investigatorsdesk_"..private.win_investigatorsdesk.task[ number ], { input = true } );

  end;

  local func_end2 = function ()

    int.Lock( false );

  end;

  int.Lock( true );

  ObjAnimate( "txt_investigatorsdesk_taskpanel", "alp", 0, 0, func_end2,
  { 
    0.0, 0, 1, 
    0.3, 0, 0,
    0.4, 0, 0,
    0.7, 0, 1

  } );

  ObjAnimate( "ho_investigatorsdesk", "alp", 0, 0, func_end,
  { 
    0.0, 0, 1, 
    0.3, 0, 1
  } );

  private.TimerDone();
  private.TimerStart();

end;
--*********************************************************************************************************************
function private.TimerStart ()

  local number = ng_global.progress["std"]["win_investigatorsdesk"].number;

  ObjSet( "tmr_investigatorsdesk_voice", 
    { 
    playing = true, 
    time = private.win_investigatorsdesk.time[ number ],
    endtrig = private.TimerDone
    } );

  cmn.StopAllVoc();
  cmn.PlayAudio( "voc", "audio/level1/voc/aud_youngpolice"..number.."_voc", 0 ); 

  ObjSet( "obj_investigatorsdesk_button", { input = false } );
  ObjSet( "anm_investigatorsdesk_recorder", { active = true } );
  ObjAnimate( "spr_investigatorsdesk_play2", "alp", 0, 0, "",
  { 
    0.0, 0, ObjGet( "spr_investigatorsdesk_play2" ).alp, 
    0.3, 0, 1
  } );

end;
--*********************************************************************************************************************
function private.TimerDone ()

  local func_end = function ()

    private.TimerStart();
    cmn.PlayAudio( "env", "audio/level1/env/aud_investigatorsdesk_in", 0 );

  end;

  local number = ng_global.progress["std"]["win_investigatorsdesk"].number;

  cmn.StopAllVoc();
  cmn.PlayAudio( "env", "audio/level1/env/aud_investigatorsdesk_in", 0 );
  ObjSet( "obj_investigatorsdesk_button", { input = true, event_mdown = func_end } );
  ObjSet( "anm_investigatorsdesk_recorder", { active = false } );
  ObjAnimate( "spr_investigatorsdesk_play2", "alp", 0, 0, "",
  { 
    0.0, 0, ObjGet( "spr_investigatorsdesk_play2" ).alp, 
    0.3, 0, 0
  } );

end;
--*********************************************************************************************************************
function private.CheckDone ()

  local number = ng_global.progress["std"]["win_investigatorsdesk"].number;

  for i = 1,3 do

    local idx = ng_global.progress["std"]["win_investigatorsdesk"].note[ i ][ 1 ];

    if ( number == idx ) and not ( ng_global.progress["std"]["win_investigatorsdesk"].note[ i ][ 2 ] ) then

      ng_global.progress["std"]["win_investigatorsdesk"].note[ i ][ 2 ] = true;
      ObjAnimate( "spr_investigatorsdesk_"..i.."check", "alp", 0, 0, "",
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      } );

      AnimPlay( "anm_investigatorsdesk_sighnfx_"..i, "DoAnim", "" );

    end;


  end;

end;
--*********************************************************************************************************************
function private.InitAnim ()

  ObjAnimate( "spr_investigatorsdesk_lamp_light_add", "alp", 1, 0, "",
  { 
    0.0, 0, 1, 
    0.5, 0, 0.9,
    1, 0, 1 
  } );

end;
--*********************************************************************************************************************