-- name=ho_roundthecorner
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_roundthecorner" );
  game.relations[ "ho_roundthecorner" ].exitroom = "rm_townoutskirts";
  private.room_objname = "ho_roundthecorner";

  --ObjSet( "spr_roundthecorner_", { event_mdown = function () MsgSend( Event_DialogHo_Show, {} ); end } );

  ObjSet( "spr_roundthecorner_antirustsolution", { event_mdown = private.get_antirustsolution } );

  private.win_roundthecorner = {};

  private.win_roundthecorner.pos_inv = 
  {-240, -120, 0, 120, 240, 360, 480, 600, 720, 840, 960, 1080};

  --------------------------------------------------------------------------------------------
  -- function opn_roundthecorner () end;
  --------------------------------------------------------------------------------------------
  local opn_roundthecorner = function ()

  end;

  cmn.AddSubscriber( "opn_roundthecorner", opn_roundthecorner, private.room_objname );
  --------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_roundthecorner" ] =
  {
    type = "get",
    get_obj = "spr_roundthecorner_win",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_roundthecorner_func = function ()

    if ( cmn.IsEventDone( "win_roundthecorner" ) ) then

      int.InventoryItemAdd( "inv_antirustsolution", "spr_roundthecorner_win" );
      ObjDelete( "gho_townoutskirts_roundthecorner" );
      ObjDelete( "obj_antirustsolution_ho2" );
      --int.DeleteTaskMap( "rm_townoutskirts", "win_roundthecorner" );
      ObjSet( "inv_rustyjack_plus_focus2", { alp = 1 } );

    end;

  end;
  cmn.AddSubscriber( "win_roundthecorner", win_roundthecorner_func );
  --------------------------------------------------------------------------------------------------
  local start_roundthecorner_func = function ()

    if ( cmn.IsEventStart( "win_roundthecorner" ) ) then

      common_impl.ProcessHoStart( "roundthecorner" );
      local ho_found = ng_global.progress[ "std" ][ "win_roundthecorner" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
      end;

    end;

  end;
  cmn.AddSubscriber( "win_roundthecorner", start_roundthecorner_func, "ho_roundthecorner" );
  --------------------------------------------------------------------------------------------------
  private.win_roundthecorner.task = { "antenna", "antirustsolution", "bags", "ball", "banks", "fireextinguisher", "hose", "mask", "peel", "purse", "sign", "tools" };

  for i = 1, #private.win_roundthecorner.task do

    ObjSet( "spr_roundthecorner_"..private.win_roundthecorner.task[ i ], { event_mdown = function () private.CompleteTask( private.win_roundthecorner.task[ i ] ); end, input = false } );

  end;

end;

--*********************************************************************************************************************
function public.Load ()

--  local unmark_jar = function () 
--    ObjSet( "spr_roundthecorner_jar", { event_mdown = function () private.CompleteTask( "jar" ); end, color_g = 0  } ); 
--  end
--
--  if not cmn.IsEventStart( "win_roundthecorner" ) or not cmn.IsUnmarkedTask( "roundthecorner", "jar" ) then
--
--    local find_jar = function () 
--      cmn.UnmarkTask( "roundthecorner", "jar" ); 
--      unmark_jar();
--    end
--    ObjSet( "spr_roundthecorner_jar", { event_mdown = find_jar } );
--
--  else
--
--    unmark_jar();
--
--  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  local ho_tasks = {};
  cmn.InterfaceSetVisible( true );
  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventDone( "opn_roundthecorner" ) ) then

      cmn.SetEventDone( "opn_roundthecorner" );
      cmn.CallEventHandler( "opn_roundthecorner" );

  end;

--  int.TaskPanelTaskAdd( ho_tasks, "apple",  2, 0, { { "spr_roundthecorner_apple_1"} , { "spr_roundthecorner_apple_2" } } );

  if ( not cmn.IsEventStart( "win_roundthecorner" ) ) then

    cmn.InitHo( "roundthecorner" );
    --cmn.SetMarkedTask( "roundthecorner", "jar" );

  end;

  for i = 1, #private.win_roundthecorner.task do

    interface.TaskPanelTaskAdd( ho_tasks, private.win_roundthecorner.task[ i ], 1, 0, { { "spr_roundthecorner_"..private.win_roundthecorner.task[ i ] } } );

  end;

  int.TaskPanelShow( ho_tasks );
  private.Panel();

  common_impl.StopMusEnv( false );

  cmn.StopAllEnv( "audio/level1/env/aud_townoutskirts_env" );

  cmn.PlayAudio( "env", "audio/level1/env/aud_roundthecorner_env", 1 );
  cmn.PlayAudio( "env", "audio/level1/env/aud_ho_theme_mus_env", 1 );

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();
  cmn.StopAudio( "env", "audio/level1/env/aud_ho_theme_mus_env", 0.3 );

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();
  ObjSet( "int_inventory_impl", { input = true, alp = 1 } );

end;
--*********************************************************************************************************************
function public.HoComplete ()

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )

  int.Lock( true );

  local postfix = "";

  if ( number ) then

     postfix = "_"..number;

  end;

  cmn.HoTaskFind( "spr_roundthecorner_"..name..postfix, name );
  common_impl.PassingHoCheck();
  for i = 1,#private.win_roundthecorner.task do

      if ( private.win_roundthecorner.task[i] == name ) then 

          local object_name = "obj_"..i; 
          local collect_name  = "pfx_roundthecorner_collect_"..object_name.."_effect";
          ng_global.progress[ "std" ][ "win_roundthecorner" ].task_check[ i ] = 1;
          ObjCreate( collect_name, "partsys" );

          if  ( cmn.IsEventDone( "win_roundthecorner" ) ) then

              --int.Lock( false );

          end;

          ObjSet( collect_name,
          {
            res    = "assets/interface/resources/effects_ho_hint",
            pos_x  = ObjGet( object_name ).pos_x, pos_y = ObjGet( object_name ).pos_y,
            active = 1, visible = 1, input = 0
          } );

          ObjAttach( collect_name, "obj_roundthecorner_ho2" );
          ObjSet( collect_name, { blendmode = 2, scale_x = 0.8, scale_y = 0.8 } );
          --PartSysSetMaskObj( collect_name, object_name );  
          local func_end = function () private.AnimInv( i ); end;
          ObjAnimate( object_name, 8,0,0, func_end,
          { 
              0.0, 0, 1.0,
              0.5, 0, 0.0
          } );
--
      end;

  end;

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );

  if ( not ng_global.progress[ "std" ]["win_roundthecorner"].task_check ) then

     ng_global.progress["std"]["win_roundthecorner"].task_check = {0,0,0,0,0,0,0,0,0,0,0,0};

  end;

  local posx = -240;
  local tmp = 0;
--
  ObjSet( "obj_roundthecorner_ho2", { croprect_init = true, croprect_x = -308, croprect_y = -200, croprect_w = 617, croprect_h = 400 } );

  --ObjSet( "txt_auntlibrary_task", { text = } );
--
  for i = 1,#private.win_roundthecorner.task do 

     local obj = "obj_"..i;

     if ( ng_global.progress["std"]["win_roundthecorner"].task_check[i] == 0 ) and
        ( not ObjGet( obj ) ) then

        ObjCreate( obj, "obj" );
        ObjAttach( obj, "obj_roundthecorner_ho2" );
        ObjAttach( "obj_roundthecorner_ho2" , "spr_int_taskpanel" );
        ObjSet( obj, { pos_x = posx, pos_y = 17, inputrect_init = true, inputrect_x = -45, inputrect_y = -45, inputrect_w = 90, inputrect_h = 90, alp = 1, input = 0  } );
        local spr = "spr_roundthecorner_"..private.win_roundthecorner.task[i].."_inv";
        ObjCreate( spr, "spr" );
        ObjSet( spr, { res = "assets/levels/level1/ho_roundthecorner/layers/inv/"..private.win_roundthecorner.task[i].."_inv", scale_x = 0.95, scale_y = 0.95 } );
        ObjAttach( spr, obj );
        tmp = tmp + 1;
        if ( tmp < 6 ) then

           private.CheckPanel( i, tmp );
          
        end;

        posx = posx + 120;

        if ( tmp == 12 ) then

            ng_global.progress["std"]["win_roundthecorner"].set = 1;

        end;

     else

     end;

  end;
   
end;
--********************************************************************************************************************* 
function private.CheckPanel ( i, tmp ) 

   local obj = "obj_"..i;

   if ( tmp < 6 ) then

      ObjSet( obj, { input = 1 } );

      ObjAnimate( obj, "alp", 0, 0, "", 
      { 
        0,0,0, 
        0.3,0,1 
      });

      ObjSet( "spr_roundthecorner_"..private.win_roundthecorner.task[i], { alp = 1, input = 1 } );

   end;
   
end;
--*********************************************************************************************************************
function private.AnimInv ( num )

  local item = "obj_"..num;
  local tmp = num + 1;

      for i = tmp,#private.win_roundthecorner.task do
          local obj_tmp = "obj_"..i;

          if obj_tmp ~= nil and ng_global.progress["std"]["win_roundthecorner"].task_check[i] ~= 1 then

              ObjAnimate( "obj_"..i, "pos_x", 0, 0, "", 
              { 
                0,3,ObjGet( "obj_"..i ).pos_x, 
                0.6,3,ObjGet( "obj_"..i ).pos_x-120
              });

               if ObjGet( "obj_"..i ).pos_x-120 == 240 then

                  ObjAnimate( "obj_"..i, "scale_xy", 0, 0, "", 
                  { 
                    0.0,0,0.2,0.2, 
                    0.7,0,1,1
                  });

               end;

          end;

      end;

  private.Check( num );

end;
--*********************************************************************************************************************
function private.Check ( num )  

   local tmp = 0;

   for i = 1,#private.win_roundthecorner.task do

       local item = "obj_"..i;

       if ( item and ng_global.progress[ "std" ][ "win_roundthecorner" ].task_check[ i ] ~= 1 ) then

          tmp = tmp + 1;

          if ( tmp < 6 ) then

             ObjSet( "spr_roundthecorner_"..private.win_roundthecorner.task[ i ], { alp = 1, input = 1 } );

          end;

          num = num + 1;

       end;

   end;
   
   local func_end = function () int.Lock( false ) end;

   ObjAnimate( "ho_roundthecorner", "alp", 0, 0, func_end, 
   { 
    0,3,1, 
    0.6,3,1
   });

end;
--*********************************************************************************************************************