-- name=mg_mgremovecollapse
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_mgremovecollapse";
  game.relations[ "mg_mgremovecollapse" ].exitroom = "rm_carrepairshop";
  private.PairsInit();
  private.ShelfInit();
  private.CupboardInit();

  private.Anims();

  --------------------------------------------------------------------------------------------
  -- function win_mgremovecollapse () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_mgremovecollapse" ] =
  {
    type = "click",
    get_obj = "spr_mgremovecollapse_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_mgremovecollapse = function ()

    if ( cmn.IsEventStart( "win_mgremovecollapse" ) ) then

      private.Load();

    end;

  end;
  -----------------------------------------------
  local win_mgremovecollapse_loc = function ()

    if ( cmn.IsEventDone( "win_mgremovecollapse" ) ) then

      ObjSet( "grm_carrepairshop_townoutskirts", { input = true, visible = true, active = true } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_carrepairshop_townoutskirts_focus");
      end;     
      ObjDelete( "gmg_carrepairshop_mgremovecollapse" );

    end;

  end;
  -----------------------------------------------
  local win_mgremovecollapse_end = function ()

    if ( cmn.IsEventDone( "win_mgremovecollapse" ) ) then

      int.LockRoomMap( "bygrayscar", 0 );
      int.LockRoomMap( "abandonedfarm", 0 );
      int.LockRoomMap( "track", 0 );
      int.LockRoomMap( "townoutskirts", 0 );

    end;

  end;

  cmn.AddSubscriber( "win_mgremovecollapse", win_mgremovecollapse_loc, "rm_carrepairshop" );
  cmn.AddSubscriber( "win_mgremovecollapse", win_mgremovecollapse, private.room_objname );
  cmn.AddSubscriber( "win_mgremovecollapse", win_mgremovecollapse_end );
  -----------------------------------------------

end;
--*********************************************************************************************************************
function private.Load ()

  for p = 1, private.pairs_count do

    local is_found = ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_found[ p ];

    if ( is_found ) then

      ObjSet( "spr_mgremovecollapse_pair_"..p,            { alp = 0, input = false } );
      ObjSet( "spr_mgremovecollapse_pair_"..p.."_shadow", { alp = 0 } );

    end;

  end;

  if ( ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current ) then

    ObjSet( "spr_mgremovecollapse_pair_"..ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current.."_light", { alp = 1 } );

  end;

  private.PairsSetInput();

  if ( private.PairsIsWin() ) then

    private.PairsWin();

  end;

  if ( private.CupboardIsWin() ) then

    private.CupboardWin();

  end;
  
  private.ShelfSetInput();

end;
--*********************************************************************************************************************
function public.PreOpen () 

  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  interface.WidgetSetVisible( InterfaceWidget_Inventory, false );
  interface.WidgetSetInput( InterfaceWidget_Inventory, false );   

  ObjStopAnimate( "int_inventory", "alp" );
  ObjSet( "int_inventory", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );  
 
  if ( not cmn.IsEventStart( "win_mgremovecollapse" ) ) then

    ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_found   = { false, false, false, false, false, false, false, false, false, false, false, false, false, false };
    ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current = nil;
    ng_global.progress[ "std" ][ "win_mgremovecollapse" ].cupboard      = false;

    private.PairsSetInput();

    ng_global.progress[ "std" ][ "win_mgremovecollapse" ].items = { false, false, false, false, false, false, false, false, false, false, false, false, false, false, false };
    ng_global.progress[ "std" ][ "win_mgremovecollapse" ].items_dub = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
    
    private.ShelfSetInput();

  end;

  cmn.StopAllEnv( "audio/level1/env/aud_carrepairshop_env" );
  cmn.PlayAudio( "env", "audio/level1/env/aud_carrepairshop_env", 1 );

  if ( private.ShelfIsWin() ) then
    
    private.PreWin();

  end;
  --common_impl.PlayMusEnv();

end;
--*********************************************************************************************************************
function public.Open () 

  ObjSet( "rm_carrepairshop", { color_r = 1, color_g = 1, color_b = 1 } );
  if ( not cmn.IsEventDone( "win_mgremovecollapse" ) ) then

    cmn.MiniGameShow( "mgremovecollapse" );
    common_impl.PassingMgStart( "mgremovecollapse" );

  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  cmn.MiniGameHide();
  interface.WidgetSetVisible( InterfaceWidget_Inventory, true );
  interface.WidgetSetInput( InterfaceWidget_Inventory, true );   

  ObjSet( "int_inventory", { alp = 1 } );
  ObjSet( "int_inventory_impl", { input = true } );  
  common_impl.PassingMgStop( "mgremovecollapse" );

end;
--*********************************************************************************************************************
function public.Reset ()

  ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_found   = { false, false, false, false, false, false, false, false, false, false, false, false, false, false };
  ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current = nil;
  ng_global.progress[ "std" ][ "win_mgremovecollapse" ].cupboard      = false;
  ng_global.progress[ "std" ][ "win_mgremovecollapse" ].items         = { false, false, false, false, false, false, false, false, false, false, false, false, false, false, false };
  ng_global.progress[ "std" ][ "win_mgremovecollapse" ].items_dub = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
    
  for p = 1, private.pairs_count do

    ObjSet( "spr_mgremovecollapse_pair_"..p,            { alp = 1 } );
    ObjSet( "spr_mgremovecollapse_pair_"..p.."_shadow", { alp = 1 } );
    ObjSet( "spr_mgremovecollapse_pair_"..p.."_light",  { alp = 0 } );

  end;

  private.PairsSetInput();

  ObjSet( "obj_mgremovecollapse_pairs",     { input = true  } );
  ObjSet( "obj_mgremovecollapse_shelf",     { alp = 0, input = false } );
  ObjSet( "obj_mgremovecollapse_cupboard",  { input = false } );
  ObjSet( "spr_mgremovecollapse_cupboard",  { alp = 1 } );
  ObjSet( "spr_mgremovecollapse_cupboard2", { alp = 0 } );

  for p = 1, private.items_count do

    ObjSet( "spr_mgremovecollapse_drop_"..p,            { alp = 0, input = false } );
    ObjSet( "spr_mgremovecollapse_item_"..p,            { alp = 1, input = false } );
    ObjSet( "spr_mgremovecollapse_item_"..p.."_shadow", { alp = 1 } );
    ObjSet( "obj_mgremovecollapse_field_"..p,           { alp = 1, input = true, active = true } );
    
    ObjAttach( "spr_mgremovecollapse_item_"..p, "obj_mgremovecollapse_drag" );
    
  end;

  private.ShelfSetInput();

end;
--*********************************************************************************************************************
function public.Skip ()
port.skip_mg = true;
  int.Lock( true );

  local func_end = function ()

    ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_found   = { true, true, true, true, true, true, true, true, true, true, true, true, true, true };
    ng_global.progress[ "std" ][ "win_mgremovecollapse" ].cupboard      = true;
    ng_global.progress[ "std" ][ "win_mgremovecollapse" ].items         = { true, true, true, true, true, true, true, true, true, true, true, true, true, true, true };
    ng_global.progress[ "std" ][ "win_mgremovecollapse" ].items_dub = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
    
    private.PreWin();

  end;

  ObjAnimate( "obj_mgremovecollapse_pairs", "alp", 0, 0, "", 
  {
    0.0, 3, 1.0,
    0.3, 3, 0.0,
  } );

  ObjAnimate( "obj_mgremovecollapse_drag", "alp", 0, 0, "", 
  {
    0.0, 3, 1.0,
    0.3, 3, 0.0,
  } );

  ObjAnimate( "obj_mgremovecollapse_shelf", "alp", 0, 0, "", 
  {
    0.0, 3, ObjGet( "obj_mgremovecollapse_shelf" ).alp,
    0.3, 3, 1.0,
  } );

  ObjAnimate( "obj_mgremovecollapse_drop", "alp", 0, 0, "", 
  {
    0.0, 3, ObjGet( "obj_mgremovecollapse_drop" ).alp,
    0.3, 3, 1.0,
  } );

  for p = 1, private.items_count do

    local alp = ObjGet( "spr_mgremovecollapse_drop_"..p ).alp;

    ObjAnimate( "spr_mgremovecollapse_drop_"..p, "alp", 0, 0, "", 
    {
      0.0, 3, alp,
      0.3, 3, 1.0,
    } );

  end;

  ObjAnimate( "spr_mgremovecollapse_cupboard", "alp", 0, 0, "", 
  {
    0.0, 0, ObjGet( "spr_mgremovecollapse_cupboard" ).alp,
    0.3, 0, 0.0,
  } );

  ObjAnimate( "spr_mgremovecollapse_cupboard2", "alp", 0, 0, func_end, 
  {
    0.0, 0, ObjGet( "spr_mgremovecollapse_cupboard2" ).alp,
    0.3, 0, 1.0,
  } );

end;
--*********************************************************************************************************************
function private.PreWin ()

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_garage_doors" );
  AnimPlay( "anm_mgremovecollapse_door", "DoAnim", private.Win );  

  ObjAnimate( "spr_mgremovecollapse_nail_15", "alp", 0, 0, "", 
  {
    0.0, 3, 1,
    0.3, 3, 0
  } );

  ObjAnimate( "spr_mgremovecollapse_nail_13", "alp", 0, 0, "", 
  {
    0.0, 3, 1,
    0.3, 3, 0
  } );

end;
--*********************************************************************************************************************
function private.Win ()

  int.Lock( false );
  cmn.MiniGameHide();
  cmn.SetEventDone( "win_mgremovecollapse" );
  cmn.CallEventHandler( "win_mgremovecollapse" );
  common_impl.PassingMgWin( "mgremovecollapse" );

  cmn.GotoRoom( "rm_townoutskirts" );

end;
--*********************************************************************************************************************
-- function *** PAIRS *** () end; *************************************************************************************
--*********************************************************************************************************************
  function private.PairsInit ()

    private.pairs_dependence = { {}, {}, { 10, 11, 15 }, { 9, 1, 13, 11 }, { 3 }, { 3 }, {}, { 4 }, {}, {}, { 14 }, {}, {}, {}, {}, {} };
    private.pairs            = { 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8 };
    private.pairs_count      = 16;

    for p = 1, private.pairs_count do

      ObjSet( "spr_mgremovecollapse_pair_"..p,
      {
        input = true,
        event_menter = function ()

          cmn.SetCursor( CURSOR_HAND );

        end,
        event_mleave = function ()

          cmn.SetCursor( CURSOR_DEFAULT );

        end,
        event_mdown = function ()

          private.PairsClick( p );

        end,
      } );

    end;

    -- поправить, если таких объектов будет много
    ObjSet( "obj_mgremovecollapse_pair_8",
    {
      input = true,
      event_menter = function ()

        cmn.SetCursor( CURSOR_HAND );

      end,
      event_mleave = function ()

        cmn.SetCursor( CURSOR_DEFAULT );

      end,
      event_mdown = function ()

        private.PairsClick( 8 );

      end,
    } );

    ObjSet( "spr_mgremovecollapse_pair_8",
    {
      event_menter = function ()
      end,
      event_mleave = function ()
      end,
      event_mdown = function ()
      end,
    } );
    
  end;
--*********************************************************************************************************************
  function private.PairsClick ( idx )

    int.Lock( true );

    if ( ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current ) and
       ( ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current == idx ) then

      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mgremovecollabse_unclick" );

      ObjAnimate( "spr_mgremovecollapse_pair_"..idx.."_light", "alp", 0, 0,
      function ()

        ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current = nil;

        int.Lock( false );

      end, 
      {
        0.0, 0, 1.0,
        0.3, 0, 0.0,
      } );

      return;

    end;

    ObjAnimate( "spr_mgremovecollapse_pair_"..idx.."_light", "alp", 0, 0,
    function ()

      private.PairsClickEnd ( idx );

    end, 
    {
      0.0, 0, 0.0,
      0.3, 0, 1.0,
    } );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mgremovecollabse_click" );

  end;
--*********************************************************************************************************************
  function private.PairsClickEnd ( idx )

    int.Lock( false );

    -- выбрали первый элемент
    if ( not ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current ) then

      ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current = idx;

    -- выбрали второй элемент
    else

      local item_1 = private.pairs[ ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current ];
      local item_2 = private.pairs[ idx ];

      -- элементы совпадают
      if ( item_1 == item_2 ) then

        int.Lock( true );

        local pfx_hide_name_1 = "pfx_hide_"..ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current;
        local pfx_hide_name_2 = "pfx_hide_"..idx;
        local pfx_hide_pos_1  = GetObjPosByObj( "spr_mgremovecollapse_pair_"..ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current, "obj_mgremovecollapse_hub" );
        local pfx_hide_pos_2  = GetObjPosByObj( "spr_mgremovecollapse_pair_"..idx, "obj_mgremovecollapse_hub" );

        local func_end = function ()

          int.Lock( false );

          ObjSet( "spr_mgremovecollapse_pair_"..idx.."_light", { alp = 0 } );
          ObjSet( "spr_mgremovecollapse_pair_"..ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current.."_light", { alp = 0 } );

          ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_found[ ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current ] = true;
          ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_found[ idx ] = true;
          ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current = nil;

          if ( private.PairsIsWin() ) then

            private.PairsWin();

          end;

          private.PairsSetInput();

          ObjDelete( pfx_hide_name_1 );
          ObjDelete( pfx_hide_name_2 );

        end;

        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mgremovecollabse_similar" );

        ObjAnimate( "spr_mgremovecollapse_pair_"..idx, "alp", 0, 0, func_end, 
        {
          0.0, 0, 1,
          0.3, 0, 0,
          1.0, 0, 0,
        } );

        ObjAnimate( "spr_mgremovecollapse_pair_"..ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current, "alp", 0, 0, "", 
        {
          0.0, 0, 1,
          0.3, 0, 0,
        } );

        ObjAnimate( "spr_mgremovecollapse_pair_"..idx.."_shadow", "alp", 0, 0, "", 
        {
          0.0, 0, 1,
          0.3, 0, 0,
        } );

        ObjAnimate( "spr_mgremovecollapse_pair_"..ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current.."_shadow", "alp", 0, 0, "", 
        {
          0.0, 0, 1,
          0.3, 0, 0,
        } );

        ObjSet( "spr_mgremovecollapse_pair_"..idx, { input = false } );

        -----------------------------------------------------------------------------------------------------------------------------------------------------
        local collect_pos_1 = GetObjPosByObj( "spr_mgremovecollapse_pair_"..ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current, "obj_mgremovecollapse_hub" );

        local collect_drawoff_x_1 = ObjGet( "spr_mgremovecollapse_pair_"..ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current ).drawoff_x;
        local collect_drawoff_y_1 = ObjGet( "spr_mgremovecollapse_pair_"..ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current ).drawoff_y;

        ObjSet( "spr_mgremovecollapse_pair_"..ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current ,{ pos_x = collect_pos_1[ 1 ], pos_y = collect_pos_1[ 2 ] } );

        ObjCreate( pfx_hide_name_1, "partsys" );

        ObjSet( pfx_hide_name_1,
        {
          res = "assets/levels/level1/mg_mgremovecollapse/anims/pfx_effects",
          pos_x = collect_drawoff_x_1, pos_y = collect_drawoff_y_1,
          input = false
        } );

        ObjAttach( pfx_hide_name_1, "obj_mgremovecollapse_hub" );

        ObjSet( pfx_hide_name_1, { blendmode = 2 } );
        
        PartSysSetMaskObj( pfx_hide_name_1, "spr_mgremovecollapse_pair_"..ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current );  
        -----------------------------------------------------------------------------------------------------------------------------------------------------
        local collect_pos_2 = GetObjPosByObj( "spr_mgremovecollapse_pair_"..idx, "obj_mgremovecollapse_hub" );

        local collect_drawoff_x_2 = ObjGet( "spr_mgremovecollapse_pair_"..idx ).drawoff_x;
        local collect_drawoff_y_2 = ObjGet( "spr_mgremovecollapse_pair_"..idx ).drawoff_y;

        ObjSet( "spr_mgremovecollapse_pair_"..idx ,{ pos_x = collect_pos_2[ 1 ], pos_y = collect_pos_2[ 2 ] } );

        ObjCreate( pfx_hide_name_2, "partsys" );

        ObjSet( pfx_hide_name_2,
        {
          res = "assets/levels/level1/mg_mgremovecollapse/anims/pfx_effects",
          pos_x = collect_drawoff_x_2, pos_y = collect_drawoff_y_2,
          input = false
        } );

        ObjAttach( pfx_hide_name_2, "obj_mgremovecollapse_hub" );

        ObjSet( pfx_hide_name_2, { blendmode = 2 } );
        
        PartSysSetMaskObj( pfx_hide_name_2, "spr_mgremovecollapse_pair_"..idx );  

      -- элементы не совпадают
      else

        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mgremovecollabse_unclick" );

        private.PairsRevert( ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current, idx );

      end;

    end;

  end;
--*********************************************************************************************************************
  function private.PairsRevert ( idx_1, idx_2 )

    int.Lock( true );

    local func_end = function ()

      int.Lock( false );

      ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_current = nil;

      private.PairsSetInput();

    end;

    ObjAnimate( "spr_mgremovecollapse_pair_"..idx_1.."_light", "alp", 0, 0, "", 
    {
      0.0, 0, 1.0,
      0.3, 0, 0.0,
    } );

    ObjAnimate( "spr_mgremovecollapse_pair_"..idx_2.."_light", "alp", 0, 0, func_end, 
    {
      0.0, 0, 1.0,
      0.3, 0, 0.0,
    } );

    --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mgremovecollapse_item_revert" );

  end;
--*********************************************************************************************************************
  function private.PairsSetInput ()

    private.pairs_dependence = { {}, {}, { 10, 11, 15 }, { 9, 1, 13, 11 }, { 3 }, { 3 }, {}, { 4 }, {}, {}, { 14 }, {}, {}, {}, {}, {} };

    for p = 1, private.pairs_count do

      ObjSet( "spr_mgremovecollapse_pair_"..p, { input = true } );

    end;

    for p = 1, private.pairs_count do

      if ( ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_found[ p ] ) then

        ObjSet( "spr_mgremovecollapse_pair_"..p, { input = false } );

      end;

      if ( private.PairsIsDependence( p ) ) then

        ObjSet( "spr_mgremovecollapse_pair_"..p, { input = false } );

      end;

    end;

  end;
--*********************************************************************************************************************
  function private.PairsIsDependence ( idx )

    for d = 1, #private.pairs_dependence[ idx ] do

      local item = private.pairs_dependence[ idx ][ d ];

      if ( not ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_found[ item ] ) then

        return true;

      end;

    end;    

    return false;

  end;
--*********************************************************************************************************************
  function private.PairsIsWin ()

    for p = 1, private.pairs_count do

      if ( not ng_global.progress[ "std" ][ "win_mgremovecollapse" ].pairs_found[ p ] ) then

        return false;

      end;

    end;

    return true;

  end;
--*********************************************************************************************************************
  function private.PairsWin ()

    ObjSet( "obj_mgremovecollapse_pairs", { input = false } );
    ObjSet( "obj_mgremovecollapse_cupboard", { input = true } );

  end;
--*********************************************************************************************************************
-- function *** CUPBOARD *** () end; **********************************************************************************
--*********************************************************************************************************************
  function private.CupboardInit ()

    ObjSet( "spr_mgremovecollapse_cupboard",
    {
      input = true,
      event_menter = function ()

        cmn.SetCursor( CURSOR_HAND );

      end,
      event_mleave = function ()

        cmn.SetCursor( CURSOR_DEFAULT );

      end,
      event_mdown = private.CupboardClick,
    } );

  end;
--*********************************************************************************************************************
  function private.CupboardClick ()

    int.Lock( true );
    
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_cupboard_click" );

    ObjAnimate( "spr_mgremovecollapse_cupboard", "alp", 0, 0, "", 
    {
      0.0, 0, 1.0,
      0.3, 0, 0.0,
    } );

    ObjAnimate( "spr_mgremovecollapse_cupboard2", "alp", 0, 0,   
    function ()

        ng_global.progress[ "std" ][ "win_mgremovecollapse" ].cupboard = true;

        int.Lock( false );

        if ( private.CupboardIsWin() ) then

          ObjAnimate( "obj_mgremovecollapse_shelf", "alp", 0, 0, private.CupboardWin, 
          {
            0.0, 0, 0.0,
            0.3, 0, 1.0,
          } );

        end;

      end, 
    {
      0.0, 0, 0.0,
      0.3, 0, 1.0,
    } );

  end;
--*********************************************************************************************************************
  function private.CupboardIsWin ()

    if ( not ng_global.progress[ "std" ][ "win_mgremovecollapse" ].cupboard ) then

      return false;

    end;

    return true;

  end;
--*********************************************************************************************************************
  function private.CupboardWin ()

    ObjSet( "obj_mgremovecollapse_cupboard",  { input = false } );
    ObjSet( "spr_mgremovecollapse_cupboard",  { alp = 0 } );
    ObjSet( "spr_mgremovecollapse_cupboard2", { alp = 1 } );
    ObjSet( "obj_mgremovecollapse_shelf",     { alp = 1, input = true } );

  end;
--*********************************************************************************************************************
-- function *** SHELF *** () end; *************************************************************************************
--*********************************************************************************************************************
  function private.ShelfInit ()

    private.items_count = 15;

    for p = 1, private.items_count do

      ObjSet( "spr_mgremovecollapse_item_"..p,
      {
        input = true,
        event_menter = function ()

          cmn.SetCursor( CURSOR_HAND );

        end,
        event_mleave = function ()

          cmn.SetCursor( CURSOR_DEFAULT );

        end,
        event_mdown = function ()

          private.ShelfItemClick( p );

        end,
        event_startdrag = function ()

          private.ShelfItemStartDrag( p );

        end,
        event_dragdrop = function ()

          private.ShelfItemDrop( p );

        end,
      } );

    end;

    for p = 1, private.items_count do

      ObjSet( "obj_mgremovecollapse_field_"..p,
      {
        input = true,
        event_menter = function ()

          private.MouseEnter( p );

        end,
        event_mleave = function ()

          private.MouseLeave( p );

        end,
      } );

    end;

  end;
--*********************************************************************************************************************
  function private.MouseEnter ( idx )

    local light = "spr_mgremovecollapse_shelf_item_"..idx.."_lightadd";

    cmn.SetCursor( CURSOR_USE );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mgremovecollabse_paste" );

    ObjAnimate( light, "alp", 0, 0, "", 
    {
      0.0, 0, ObjGet( light ).alp,
      0.3, 0, 1.0,
    } );

  end;
--*********************************************************************************************************************
  function private.MouseLeave ( idx )

    local light = "spr_mgremovecollapse_shelf_item_"..idx.."_lightadd";

    cmn.SetCursor( CURSOR_DEFAULT );

    ObjAnimate( light, "alp", 0, 0, "", 
    {
      0.0, 0, ObjGet( light ).alp,
      0.3, 0, 0.0,
    } );

  end;
--*********************************************************************************************************************
  function private.ShelfItemClick ( idx )

    local item = "spr_mgremovecollapse_item_"..idx;

    private.first_drag = true;

    ObjSet( "spr_mgremovecollapse_item_"..idx.."_shadow", { alp = 0 } );
    ObjAttach( item, "obj_mgremovecollapse_hub" );
    ObjStartDrag( item );

    if ( idx == 13 or idx == 15 or idx == 5 ) then

      --ObjStopAnimate( item, "alp" );
      ObjSet( item, { active = false, ang = 0 } );
      private.NextAnims( idx );

    end;

  end;
--*********************************************************************************************************************
  function private.ShelfItemStartDrag ( idx )

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mgremovecollabse_take" );

    local item = "spr_mgremovecollapse_item_"..idx;

    private.item_parent = ObjGetRelations( item ).parent;

    ObjSet( item, { alp = 1, input = true } );
    ObjAttach( item, "obj_mgremovecollapse_hub" );

  end;
--*********************************************************************************************************************
  function private.ShelfItemDrop ( idx )

    local item = "spr_mgremovecollapse_item_"..idx;

    if ( ( ApplyObj( item, "obj_mgremovecollapse_field_"..idx ) or
        ApplyObj( item, "obj_mgremovecollapse_drop_"..idx ) ) and 
        ObjGet( "obj_mgremovecollapse_field_"..idx ).input ) then  
        
      private.CheckShelfSetInput( idx );
        
    elseif ( idx == 13 or idx == 15 or idx == 2 or idx == 3 ) then

      if ( ( idx == 13 or idx == 15 ) ) then

        if ( (ApplyObj( item, "obj_mgremovecollapse_field_13" ) or
          ApplyObj( item, "obj_mgremovecollapse_drop_13" ) ) and 
          ObjGet( "obj_mgremovecollapse_field_13" ).input ) then  
          
          private.CheckShelfSetInput( idx, 13 );         
          
        elseif ( (ApplyObj( item, "obj_mgremovecollapse_field_15" ) or
          ApplyObj( item, "obj_mgremovecollapse_drop_15" ) ) and 
          ObjGet( "obj_mgremovecollapse_field_15" ).input ) then       
          
          private.CheckShelfSetInput( idx, 15 ); 
          
        else 
          
          private.Else( idx );
          
        end;   
        
      else 
        
        if ( (ApplyObj( item, "obj_mgremovecollapse_field_2" ) or
          ApplyObj( item, "obj_mgremovecollapse_drop_2" ) ) and 
          ObjGet( "obj_mgremovecollapse_field_2" ).input ) then  
      
          private.CheckShelfSetInput( idx, 2 );         
          
        elseif ( (ApplyObj( item, "obj_mgremovecollapse_field_3" ) or
          ApplyObj( item, "obj_mgremovecollapse_drop_3" ) ) and 
          ObjGet( "obj_mgremovecollapse_field_3" ).input ) then          

          private.CheckShelfSetInput( idx, 3 ); 
          
        else 
          
          private.Else( idx );
          
        end;  
        
      end;   
    
    else 

      private.Else( idx );
      
    end;

    private.first_drag = false;

    if ( private.ShelfIsWin() ) then

      private.PreWin();

    end;

  end;
--*********************************************************************************************************************
  function private.CheckShelfSetInput( idx, num )
    
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mgremovecollabse_put_on_floor" );

    ng_global.progress[ "std" ][ "win_mgremovecollapse" ].items[ idx ] = true;
    
    if ( num ) then  

      ng_global.progress[ "std" ][ "win_mgremovecollapse" ].items_dub[ idx ] = num;
      
    end;
    
    private.ShelfSetInput(); 
    
  end;
--*********************************************************************************************************************
  function private.Else( idx )
    
    local item = "spr_mgremovecollapse_item_"..idx;
    ObjAttach( item, "obj_mgremovecollapse_drag" );
    ObjSet( "spr_mgremovecollapse_item_"..idx.."_shadow", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/aud_wrongapply"..math.random( 1, 3 ) );  
 
    if ( idx == 13 or idx == 15 or idx == 5 ) then

      ObjSet( item, { active = true, ang = 0 } );

    end;

  end;
--*********************************************************************************************************************
  function private.ShelfIsWin ()

    for p = 1, private.items_count do

      if ( not ng_global.progress[ "std" ][ "win_mgremovecollapse" ].items[ p ] ) then

        return false;

      end;

    end;

    return true;

  end;
--*********************************************************************************************************************
  function private.ShelfSetInput ()

    for p = 1, private.items_count do

      ObjSet( "spr_mgremovecollapse_item_"..p, { input = true } );

    end;

    for p = 1, private.items_count do

      if ( ng_global.progress[ "std" ][ "win_mgremovecollapse" ].items[ p ] ) then
        
        if ( ng_global.progress[ "std" ][ "win_mgremovecollapse" ].items_dub[ p ] == 0 ) then

          ObjSet( "spr_mgremovecollapse_item_"..p,  { alp = 0, input = false } );
          ObjSet( "spr_mgremovecollapse_item_"..p.."_shadow",  { alp = 0 } );
          ObjSet( "spr_mgremovecollapse_drop_"..p,  { alp = 1 } );
          ObjSet( "obj_mgremovecollapse_field_"..p, { alp = 0, input = false, active = false } );
          
        else   
          
          local p_dub = ng_global.progress[ "std" ][ "win_mgremovecollapse" ].items_dub[ p ];
        
          ObjSet( "spr_mgremovecollapse_item_"..p,  { alp = 0, input = false } );
          ObjSet( "spr_mgremovecollapse_item_"..p.."_shadow",  { alp = 0 } );
          ObjSet( "spr_mgremovecollapse_drop_"..p_dub,  { alp = 1 } );
          ObjSet( "obj_mgremovecollapse_field_"..p_dub, { alp = 0, input = false, active = false } );  

        end;

      end;

    end;

  end;
--*********************************************************************************************************************
function private.NextAnims ( idx )
  
  if ( idx == 15 ) then

    ObjAnimate( "spr_mgremovecollapse_item_15", "ang", 1, 0, "", 
    {
      0.0, 3,  -0.1,
      1.8, 3,  0.00,
      3.6, 3,  -0.1,
    } );

    ObjAnimate( "spr_mgremovecollapse_item_15_shadow", "ang", 1, 0, "", 
    {
      0.0, 3,  -0.1,
      1.8, 3,  0.00,
      3.6, 3,  -0.1,
    } );

  elseif ( idx == 13 ) then

    ObjAnimate( "spr_mgremovecollapse_item_13", "ang", 1, 0, "", 
    {
      0.0, 3,  0.00,
      1.8, 3,  -0.1,
      3.6, 3,  0.00,
    } );

    ObjAnimate( "spr_mgremovecollapse_item_13_shadow", "ang", 1, 0, "", 
    {
      0.0, 3,  0.00,
      1.8, 3,  -0.1,
      3.6, 3,  0.00,
    } );

  elseif ( idx == 5 ) then

    ObjAnimate( "spr_mgremovecollapse_item_5", "ang", 1, 0, "", 
    {
      0.0, 3,  0.08,
      2.0, 3,  0.00,
      4.0, 3,  0.08,
    } );

  end;



end;
--*********************************************************************************************************************
function private.Anims ()

  ObjAnimate( "spr_mgremovecollapse_chain_1", "ang", 1, 0, "", 
  {
    0.0, 3, -0.02,
    1.3, 3,  0.02,
    2.6, 3, -0.02,
  } );

  ObjAnimate( "spr_mgremovecollapse_chain_2", "ang", 1, 0, "", 
  {
    0.0, 3,  0.01,
    2.3, 3, -0.01,
    4.6, 3,  0.01,
  } );

  ObjAnimate( "spr_mgremovecollapse_chain_3", "ang", 1, 0, "", 
  {
    0.0, 3,  0.04,
    1.8, 3, -0.04,
    3.6, 3,  0.04,
  } );

  ObjAnimate( "spr_mgremovecollapse_item_15", "ang", 1, 0, "", 
  {
    0.0, 3,  -0.1,
    1.8, 3,  0.00,
    3.6, 3,  -0.1,
  } );

  ObjAnimate( "spr_mgremovecollapse_item_15_shadow", "ang", 1, 0, "", 
  {
    0.0, 3,  -0.1,
    1.8, 3,  0.00,
    3.6, 3,  -0.1,
  } );

  ObjAnimate( "spr_mgremovecollapse_item_13", "ang", 1, 0, "", 
  {
    0.0, 3,  0.00,
    1.8, 3,  -0.1,
    3.6, 3,  0.00,
  } );

  ObjAnimate( "spr_mgremovecollapse_item_5", "ang", 1, 0, "", 
  {
    0.0, 3,  0.08,
    2.0, 3,  0.00,
    4.0, 3,  0.08,
  } );

  ObjAnimate( "spr_mgremovecollapse_item_13_shadow", "ang", 1, 0, "", 
  {
    0.0, 3,  0.00,
    1.8, 3,  -0.1,
    3.6, 3,  0.00,
  } );

end;
--********************************************************************************************************************