-- name=level1_inv
--*********************************************************************************************************************
function public.Init ()

  if port.isPortable() == 1 then
    port.InventoryPopupInit("level1_inv_hub");
    port.VideoResizeInRoom("level1_inv");
  end;
  
  private.purse_init();
  private.folder_init();
  private.stolenbag_init();
  private.ironpiece_init();
  private.bow_init();
  private.rustyjack_init();
  private.brokenworkshopfob_init();

  private.IronpieceInit();

  int.CreateDeployPlus( 1 );

  MsgSubscribe( Command_Interface_UpdateGameMode, private.UpdateGameMode );

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_level1_inv_deploy = function ()

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    common_impl.TurnChildGfx( { "level1_inv_deploy" } , "level1_inv_deploy", visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_level1_inv_deploy", update_game_mode_level1_inv_deploy, nil );

end;
--*********************************************************************************************************************
function private.UpdateGameMode ( msg, params )

--  if ( params.mode == 3 ) then
--    
--    if ( not ObjGet( "level1_inv_deploy" ) ) then
--
--      return;
--
--    end;
--
--    local relations = ObjGetRelations( "level1_inv_deploy" );
--    local table_multiset = {};
--
--    for i = 1, #relations.childs do
--
--      local obj = "spr_"..common.GetObjectName( common.GetObjectName( relations.childs[ i ] ) ).."_plus";      
--      table.insert( table_multiset, { obj, { visible = ng_global.gamemode_custom[ "plus_inv" ] } } );
--      table.insert( table_multiset, { obj.."_light", { visible = ng_global.gamemode_custom[ "plus_inv" ] } } );
--
--    end;
--
--    ObjMultiSet( table_multiset );
--  
--  end;

end;
--*********************************************************************************************************************
-- function *** folder *** ()
--*********************************************************************************************************************
  function private.folder_init ()

    ObjSet( "spr_deploy_inv_folder_closed",  { event_mdown = private.clk_folder } );
    ObjSet( "spr_deploy_inv_folder_page_1",  { event_mdown = private.clk_folder_page_1 } );
    ObjSet( "spr_deploy_inv_folder_page_2",  { event_mdown = private.clk_folder_page_2 } );
    ObjSet( "spr_deploy_inv_folder_page_3",  { event_mdown = private.clk_folder_page_3 } );
    ObjSet( "spr_deploy_inv_gloveboxslider", { event_mdown = private.get_gloveboxslider } );
    ObjSet( "spr_deploy_inv_medalliondove",  { event_mdown = private.get_medalliondove } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_gloveboxslider" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_gloveboxslider",
      room = "int_deploy_inv",
      zz = "deploy_inv_folder",
      zz_gate = "inv_folder"
    };
    -------------------------------------------------------------------------------------------
    function get_gloveboxslider_inv ()

      if ( cmn.IsEventDone( "get_medalliondove" ) ) then

        interface.InventoryItemRemove( "inv_folder" );

      end;

      interface.InventoryItemAdd( "inv_gloveboxslider", "spr_deploy_inv_gloveboxslider" );

      ObjDelete( "spr_deploy_inv_gloveboxslider_shadow" );
      ObjDelete( "gfx_deploy_inv_gloveboxslider" );
      ObjDelete( "spr_folder_gloveboxslider" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_gloveboxslider", get_gloveboxslider_inv );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_medalliondove" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_medalliondove",
      room = "int_deploy_inv",
      zz = "deploy_inv_folder",
      zz_gate = "inv_folder"
    };
    -------------------------------------------------------------------------------------------
    function get_medalliondove_inv ()

      if ( cmn.IsEventDone( "get_gloveboxslider" ) ) then

        interface.InventoryItemRemove( "inv_folder" );

      end;

      interface.InventoryItemAdd( "inv_medalliondove", "spr_deploy_inv_medalliondove" );

      ObjSet( "inv_stolenbag_plus_focus2", { alp = 1 } );
      ObjDelete( "gfx_deploy_inv_medalliondove" );
      ObjDelete( "spr_folder_medalliondove" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_medalliondove", get_medalliondove_inv );
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_folder" ] =
    {
      type = "click",
      clk_obj = "spr_deploy_inv_folder_closed",
      room = "int_deploy_inv",
      zz = "deploy_inv_folder",
      zz_gate = "inv_folder"
    };
    -------------------------------------------------------------------------------------------
    function clk_folder_inv ()

      ObjSet( "inv_folder",       { res = "assets/levels/level1/common_inventory1/inv_folder/inv/inv_folder_open" } );
      ObjSet( "obj_folder_pages", { alp = 1 } );

    end;
    function clk_folder_beg ()

      ObjSet( "spr_deploy_inv_folder_open", { alp = 1 } );

    end;
    function clk_folder_end ()

      ObjDelete( "spr_deploy_inv_folder_closed" );
      ObjSet( "spr_deploy_inv_folder_page_1", { input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_folder", clk_folder_inv );
    cmn.AddSubscriber( "clk_folder", clk_folder_beg, "inv_folder" );
    cmn.AddSubscriber( "clk_folder", clk_folder_end, "inv_folder" );
    cmn.AddSubscriber( "clk_folder_inv", clk_folder_inv );
    cmn.AddSubscriber( "clk_folder_beg", clk_folder_beg, "inv_folder" );
    cmn.AddSubscriber( "clk_folder_end", clk_folder_end, "inv_folder" );
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_folder_page_1" ] =
    {
      type = "click",
      clk_obj = "spr_deploy_inv_folder_page_1",
      room = "int_deploy_inv",
      zz = "deploy_inv_folder",
      zz_gate = "inv_folder"
    };
    -------------------------------------------------------------------------------------------
    function clk_folder_page_1_inv ()

      ObjDelete( "spr_folder_page_1" );

    end;
    function clk_folder_page_1_beg ()

    end;
    function clk_folder_page_1_end ()

      ObjSet( "spr_deploy_inv_folder_page_1", { input = false, pos_x = -137, pos_y = -78, pos_z = 1 } );
      ObjSet( "spr_deploy_inv_folder_page_2", { input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_folder_page_1", clk_folder_page_1_inv );
    cmn.AddSubscriber( "clk_folder_page_1", clk_folder_page_1_beg, "inv_folder" );
    cmn.AddSubscriber( "clk_folder_page_1", clk_folder_page_1_end, "inv_folder" );
    cmn.AddSubscriber( "clk_folder_page_1_inv", clk_folder_page_1_inv );
    cmn.AddSubscriber( "clk_folder_page_1_beg", clk_folder_page_1_beg, "inv_folder" );
    cmn.AddSubscriber( "clk_folder_page_1_end", clk_folder_page_1_end, "inv_folder" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_folder_page_2" ] =
    {
      type = "click",
      clk_obj = "spr_deploy_inv_folder_page_2",
      room = "int_deploy_inv",
      zz = "deploy_inv_folder",
      zz_gate = "inv_folder"
    };
    -------------------------------------------------------------------------------------------
    function clk_folder_page_2_inv ()

      ObjDelete( "spr_folder_page_2" );

    end;
    function clk_folder_page_2_beg ()

    end;
    function clk_folder_page_2_end ()

      ObjSet( "spr_deploy_inv_folder_page_2", { input = false, pos_x = -172, pos_y = -40, pos_z = 2 } );
      ObjSet( "spr_deploy_inv_folder_page_3", { input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_folder_page_2", clk_folder_page_2_inv );
    cmn.AddSubscriber( "clk_folder_page_2", clk_folder_page_2_beg, "inv_folder" );
    cmn.AddSubscriber( "clk_folder_page_2", clk_folder_page_2_end, "inv_folder" );
    cmn.AddSubscriber( "clk_folder_page_2_inv", clk_folder_page_2_inv );
    cmn.AddSubscriber( "clk_folder_page_2_beg", clk_folder_page_2_beg, "inv_folder" );
    cmn.AddSubscriber( "clk_folder_page_2_end", clk_folder_page_2_end, "inv_folder" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_folder_page_3" ] =
    {
      type = "click",
      clk_obj = "spr_deploy_inv_folder_page_3",
      room = "int_deploy_inv",
      zz = "deploy_inv_folder",
      zz_gate = "inv_folder"
    };
    -------------------------------------------------------------------------------------------
    function clk_folder_page_3_inv ()

      ObjDelete( "spr_folder_page_3" );

    end;
    function clk_folder_page_3_beg ()

    end;
    function clk_folder_page_3_end ()

      ObjSet( "spr_deploy_inv_folder_page_3",  { input = false, pos_x = -135, pos_y = -68, pos_z = 3 } );
      ObjSet( "spr_deploy_inv_gloveboxslider", { input = true } );
      ObjSet( "spr_deploy_inv_medalliondove",  { input = true } );
      ObjSet( "gfx_deploy_inv_gloveboxslider", { active = true } );
      ObjSet( "gfx_deploy_inv_medalliondove",  { active = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_folder_page_3", clk_folder_page_3_inv );
    cmn.AddSubscriber( "clk_folder_page_3", clk_folder_page_3_beg, "inv_folder" );
    cmn.AddSubscriber( "clk_folder_page_3", clk_folder_page_3_end, "inv_folder" );
    cmn.AddSubscriber( "clk_folder_page_3_inv", clk_folder_page_3_inv );
    cmn.AddSubscriber( "clk_folder_page_3_beg", clk_folder_page_3_beg, "inv_folder" );
    cmn.AddSubscriber( "clk_folder_page_3_end", clk_folder_page_3_end, "inv_folder" );
    --------------------------------------------------------------------------------------------

  end;
  --*********************************************************************************************************************
  function private.clk_folder ()

    cmn.CallEventHandler( "clk_folder_inv", "inv_folder" );
    cmn.CallEventHandler( "clk_folder_beg", "inv_folder" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_folder" );
      cmn.CallEventHandler( "clk_folder_end", "inv_folder" );
    
    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_open_book" );

    ObjAnimate( "spr_deploy_inv_folder_open", "alp", 0, 0, "", 
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    ObjAnimate( "spr_deploy_inv_folder_closed", "alp", 0, 0, func_end, 
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );

    return true;

  end;
  --*********************************************************************************************************************
  function private.clk_folder_page_1 ()

    cmn.CallEventHandler( "clk_folder_page_1_inv", "inv_folder" );
    cmn.CallEventHandler( "clk_folder_page_1_beg", "inv_folder" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_folder_page_1" );
      cmn.CallEventHandler( "clk_folder_page_1_end", "inv_folder" );
    
    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_paper_away" );

    ObjAnimate( "spr_deploy_inv_folder_page_1", "pos_xy", 0, 0, func_end, 
    {
      0.0, 3,  193, -58,
      0.5, 3, -137, -78,
    } );

    return true;

  end;
  --*********************************************************************************************************************
  function private.clk_folder_page_2 ()

    cmn.CallEventHandler( "clk_folder_page_2_inv", "inv_folder" );
    cmn.CallEventHandler( "clk_folder_page_2_beg", "inv_folder" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_folder_page_2" );
      cmn.CallEventHandler( "clk_folder_page_2_end", "inv_folder" );
    
    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_paper_away" );

    ObjAnimate( "spr_deploy_inv_folder_page_2", "pos_xy", 0, 0, func_end, 
    {
      0.0, 3,  175, -27,
      0.5, 3, -172, -40,
    } );

    return true;

  end;
  --*********************************************************************************************************************
  function private.clk_folder_page_3 ()

    cmn.CallEventHandler( "clk_folder_page_3_inv", "inv_folder" );
    cmn.CallEventHandler( "clk_folder_page_3_beg", "inv_folder" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_folder_page_3" );
      cmn.CallEventHandler( "clk_folder_page_3_end", "inv_folder" );

      cmn.TutorialShow( "tutorial_page_6" );
      cmn.TutorialSetShown( "tutorial_page_6" );
      
    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_paper_away" );

    ObjAnimate( "spr_deploy_inv_folder_page_3", "pos_xy", 0, 0, func_end, 
    {
      0.0, 3,  170, -27,
      0.5, 3, -135, -68,
    } );

    return true;

  end;
  --*********************************************************************************************************************
  function private.get_gloveboxslider ()

    cmn.GetObjectSfx();

    cmn.SetEventDone( "get_gloveboxslider" );
    cmn.CallEventHandler( "get_gloveboxslider", "inv_gloveboxslider" );

    if ( cmn.IsEventDone( "get_medalliondove" ) ) then

      int.DeployInvHide();

    end;

  end;
  --*********************************************************************************************************************
  function private.get_medalliondove ()

    cmn.GetObjectSfx();

    cmn.SetEventDone( "get_medalliondove" );
    cmn.CallEventHandler( "get_medalliondove", "inv_medalliondove" );

    if ( cmn.IsEventDone( "get_gloveboxslider" ) ) then

      int.DeployInvHide();

    end;

  end;
--*********************************************************************************************************************
-- function *** purse *** ()
--*********************************************************************************************************************
  function private.purse_init ()

    ObjSet( "spr_deploy_inv_notebooksheet",  { event_mdown = private.get_notebooksheet } );
    ObjSet( "spr_deploy_inv_thread",         { event_mdown = private.get_thread } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_notebooksheet" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_notebooksheet",
      room = "int_deploy_inv",
      zz = "deploy_inv_purse",
      zz_gate = "inv_purse"
    };
    -------------------------------------------------------------------------------------------
    function get_notebooksheet_inv ()

      if ( cmn.IsEventDone( "get_thread" ) ) then

        interface.InventoryItemRemove( "inv_purse" );

      end;

      interface.InventoryItemAdd( "inv_notebooksheet", "spr_deploy_inv_notebooksheet" );

      ObjDelete( "spr_deploy_inv_notebooksheet_shadow" );
      ObjDelete( "gfx_deploy_inv_notebooksheet" );
      ObjDelete( "spr_purse_notebooksheet" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_notebooksheet", get_notebooksheet_inv );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_thread" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_thread",
      room = "int_deploy_inv",
      zz = "deploy_inv_purse",
      zz_gate = "inv_purse"
    };
    -------------------------------------------------------------------------------------------
    function get_thread_inv ()

      if ( cmn.IsEventDone( "get_notebooksheet" ) ) then

        interface.InventoryItemRemove( "inv_purse" );

      end;

      if ( cmn.IsEventDone( "use_playdough" ) ) then

        ObjSet( "inv_bow_plus_focus2", { alp = 1 } );

      end;

      interface.InventoryItemAdd( "inv_thread", "spr_deploy_inv_thread" );

      ObjDelete( "spr_deploy_inv_thread_shadow" );
      ObjDelete( "gfx_deploy_inv_thread" );
      ObjDelete( "spr_purse_thread" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_thread", get_thread_inv );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_goldennut" ] =
    {
      type = "use",
      use_obj = "inv_goldennut",
      use_place = "obj_deploy_inv_use_goldennut",
      room = "int_deploy_inv",
      zz = "deploy_inv_purse",
      zz_gate = "inv_purse"
    };
    -------------------------------------------------------------------------------------------
    function use_goldennut_inv ()
  
      interface.InventoryItemRemove( "inv_goldennut" );

      ObjSet( "inv_purse", { res = "assets/levels/level1/common_inventory1/inv_purse/inv/inv_purse_open" } );
      ObjSet( "obj_purse_open", { alp = 1 } );

    end;
    function use_goldennut_beg ()

      ObjDelete( "obj_deploy_inv_use_goldennut" );

    end;
    function use_goldennut_end ()

      ObjDelete( "obj_deploy_inv_purse_closed" );
      ObjSet( "obj_deploy_inv_purse_open",    { alp = 1, input = true } );
      ObjSet( "spr_deploy_inv_purse_brochure", { pos_z = 4 } );
      ObjSet( "spr_deploy_inv_notebooksheet", { input = true } );
      ObjSet( "spr_deploy_inv_thread",        { input = true } );
      ObjSet( "gfx_deploy_inv_notebooksheet", { active = true } );
      ObjSet( "gfx_deploy_inv_thread",        { active = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_goldennut", use_goldennut_beg, "inv_purse" );
    cmn.AddSubscriber( "use_goldennut", use_goldennut_inv );
    cmn.AddSubscriber( "use_goldennut", use_goldennut_end, "inv_purse" );
    cmn.AddSubscriber( "use_goldennut_inv", use_goldennut_inv );
    cmn.AddSubscriber( "use_goldennut_beg", use_goldennut_beg, "inv_purse" );
    cmn.AddSubscriber( "use_goldennut_end", use_goldennut_end, "inv_purse" );
  end;
  --*********************************************************************************************************************
  function private.get_notebooksheet ()

    cmn.GetObjectSfx();

    cmn.SetEventDone( "get_notebooksheet" );
    cmn.CallEventHandler( "get_notebooksheet", "inv_notebooksheet" );

    if ( cmn.IsEventDone( "get_thread" ) ) then

      int.DeployInvHide();

    end;

  end;
  --*********************************************************************************************************************
  function private.get_thread ()

    cmn.GetObjectSfx();

    cmn.SetEventDone( "get_thread" );
    cmn.CallEventHandler( "get_thread", "inv_thread" );

    if ( cmn.IsEventDone( "get_notebooksheet" ) ) then

      int.DeployInvHide();

    end;

  end;
  --*********************************************************************************************************************
  function public.use_goldennut ()

    local item = "inv_goldennut";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_use_goldennut", "deploy_inv_purse" ) ) then

      cmn.CallEventHandler( "use_goldennut_inv" );
      cmn.CallEventHandler( "use_goldennut_beg", "inv_purse" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_goldennut" );
        cmn.CallEventHandler( "use_goldennut_end", "inv_purse" );
      
      end;

      int.Lock( true );

      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_nuts_amulet" );
      ObjAnimate( "spr_deploy_inv_purse_goldennut", "alp", 0, 0, "", 
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

      ObjAnimate( "obj_deploy_inv_purse_open", "alp", 0, 0, "", 
      {
        0.0, 3, 0.0,
        0.5, 3, 0.0,
        0.8, 3, 1.0,
      } );

      ObjAnimate( "obj_deploy_inv_purse_closed", "alp", 0, 0, func_end, 
      {
        0.0, 3, 1.0,
        0.5, 3, 1.0,
        0.8, 3, 0.0,
      } );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** stolenbag *** ()
--*********************************************************************************************************************
  function private.stolenbag_init ()

    ObjSet( "spr_deploy_inv_suitcasebutton", { event_mdown = private.get_suitcasebutton } );
    ObjSet( "spr_deploy_inv_gloves",         { event_mdown = private.get_gloves } );
    ObjSet( "obj_deploy_inv_clk_stolenbag",  { event_mdown = private.clk_stolenbag } );
    ObjSet( "spr_deploy_inv_stolenbag_note", { event_mdown = private.clk_stolenbag_note } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_suitcasebutton" ] =
    {
      type = "get",
      get_obj = "obj_deploy_inv_stolenbag_hint",
      room = "int_deploy_inv",
      zz = "deploy_inv_stolenbag",
      zz_gate = "inv_stolenbag"
    };
    -------------------------------------------------------------------------------------------
    function get_suitcasebutton_inv ()

      interface.InventoryItemAdd( "inv_suitcasebutton", "spr_deploy_inv_suitcasebutton" );

      if ( cmn.IsEventDone( "get_gloves" ) ) then

        interface.InventoryItemRemove( "inv_stolenbag" );

      end;

      ObjDelete( "gfx_deploy_inv_suitcasebutton" );
      ObjDelete( "spr_deploy_inv_suitcasebutton_shadow" );
      ObjDelete( "spr_stolenbag_suitcasebutton" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_suitcasebutton", get_suitcasebutton_inv );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_gloves" ] =
    {
      type = "get",
      get_obj = "obj_deploy_inv_stolenbag_hint",
      room = "int_deploy_inv",
      zz = "deploy_inv_stolenbag",
      zz_gate = "inv_stolenbag"
    };
    -------------------------------------------------------------------------------------------
    function get_gloves_inv ()

      interface.InventoryItemAdd( "inv_gloves", "spr_deploy_inv_gloves" );

      if ( cmn.IsEventDone( "get_suitcasebutton" ) ) then

        interface.InventoryItemRemove( "inv_stolenbag" );

      end;

      ObjDelete( "gfx_deploy_inv_gloves" );
      ObjDelete( "spr_deploy_inv_stolenbag_gloves_shadow" );
      ObjDelete( "spr_deploy_inv_stolenbag_gloves_over_shadow" );
      ObjDelete( "spr_stolenbag_gloves" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_gloves", get_gloves_inv );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_medalliondove" ] =
    {
      type = "use",
      use_obj = "inv_medalliondove",
      use_place = "obj_deploy_inv_use_medalliondove",
      room = "int_deploy_inv",
      zz = "deploy_inv_stolenbag",
      zz_gate = "inv_stolenbag"
    };
    -------------------------------------------------------------------------------------------
    function use_medalliondove_inv ()
  
      interface.InventoryItemRemove( "inv_medalliondove" );
      ObjSet( "spr_stolenbag_medalliondove", { alp = 1 } );

    end;
    function use_medalliondove_beg ()

      ObjDelete( "obj_deploy_inv_use_medalliondove" );

    end;
    function use_medalliondove_end ()

      ObjSet( "spr_deploy_inv_stolenbag_medalliondove", { alp = 1 } );
      ObjSet( "obj_deploy_inv_clk_stolenbag",           { input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_medalliondove", use_medalliondove_beg, "inv_stolenbag" );
    cmn.AddSubscriber( "use_medalliondove", use_medalliondove_inv );
    cmn.AddSubscriber( "use_medalliondove", use_medalliondove_end, "inv_stolenbag" );
    cmn.AddSubscriber( "use_medalliondove_inv", use_medalliondove_inv );
    cmn.AddSubscriber( "use_medalliondove_beg", use_medalliondove_beg, "inv_stolenbag" );
    cmn.AddSubscriber( "use_medalliondove_end", use_medalliondove_end, "inv_stolenbag" );
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_stolenbag" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_clk_stolenbag",
      room = "int_deploy_inv",
      zz = "deploy_inv_stolenbag",
      zz_gate = "inv_stolenbag"
    };
    -------------------------------------------------------------------------------------------
    function clk_stolenbag_inv ()

      ObjSet( "inv_stolenbag",      { res = "assets/levels/level1/common_inventory1/inv_stolenbag/inv/inv_stolenbag_open" } );
      ObjSet( "obj_stolenbag_open", { alp = 1 } );
      ObjDelete( "spr_stolenbag_medalliondove" );

    end;
    function clk_stolenbag_beg ()

      ObjDelete( "obj_deploy_inv_clk_stolenbag" );

    end;
    function clk_stolenbag_end ()

      ObjDelete( "spr_deploy_inv_stolenbag_closed" );
      ObjSet( "spr_deploy_inv_stolenbag_open", { alp = 1 } );
      ObjSet( "spr_deploy_inv_stolenbag_note", { input = true } );
      ObjSet( "spr_deploy_inv_gloves_over",    { input = true } );
      ObjSet( "spr_deploy_inv_gloves",         { input = true } );
      ObjSet( "spr_deploy_inv_suitcasebutton", { input = true } );
      ObjSet( "gfx_deploy_inv_gloves",         { active = true } );
      ObjSet( "gfx_deploy_inv_suitcasebutton", { active = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_stolenbag", clk_stolenbag_inv );
    cmn.AddSubscriber( "clk_stolenbag", clk_stolenbag_beg, "inv_stolenbag" );
    cmn.AddSubscriber( "clk_stolenbag", clk_stolenbag_end, "inv_stolenbag" );
    cmn.AddSubscriber( "clk_stolenbag_inv", clk_stolenbag_inv );
    cmn.AddSubscriber( "clk_stolenbag_beg", clk_stolenbag_beg, "inv_stolenbag" );
    cmn.AddSubscriber( "clk_stolenbag_end", clk_stolenbag_end, "inv_stolenbag" );
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_stolenbag_note" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_stolenbag_hint",
      room = "int_deploy_inv",
      zz = "deploy_inv_stolenbag",
      zz_gate = "inv_stolenbag"
    };
    -------------------------------------------------------------------------------------------
    function clk_stolenbag_note_inv ()

      ObjSet( "spr_stolenbag_note", { pos_z = 2 } );

    end;
    function clk_stolenbag_note_beg ()

    end;
    function clk_stolenbag_note_end ()

      ObjSet( "spr_deploy_inv_stolenbag_note", { pos_z = 4, inputrect_init = false } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_stolenbag_note", clk_stolenbag_note_inv );
    cmn.AddSubscriber( "clk_stolenbag_note", clk_stolenbag_note_beg, "inv_stolenbag" );
    cmn.AddSubscriber( "clk_stolenbag_note", clk_stolenbag_note_end, "inv_stolenbag" );
    cmn.AddSubscriber( "clk_stolenbag_note_inv", clk_stolenbag_note_inv );
    cmn.AddSubscriber( "clk_stolenbag_note_beg", clk_stolenbag_note_beg, "inv_stolenbag" );
    cmn.AddSubscriber( "clk_stolenbag_note_end", clk_stolenbag_note_end, "inv_stolenbag" );
    -------------------------------------------------------------------------------------------  

  end;
  --*********************************************************************************************************************
  function private.get_suitcasebutton ()

    cmn.GetObjectSfx();

    cmn.SetEventDone( "get_suitcasebutton" );
    cmn.CallEventHandler( "get_suitcasebutton", "inv_suitcasebutton" );

    if ( cmn.IsEventDone( "get_gloves" ) ) then

      int.DeployInvHide();

    end;

  end;
  --*********************************************************************************************************************
  function private.get_gloves ()

    cmn.GetObjectSfx();

    cmn.SetEventDone( "get_gloves" );
    cmn.CallEventHandler( "get_gloves", "inv_gloves" );

    if ( not cmn.IsEventDone( "get_suitcasebutton" ) ) then

      private.get_suitcasebutton();

    end;

    int.DeployInvHide();

  end;
  --*********************************************************************************************************************
  function public.use_medalliondove ()

    local item = "inv_medalliondove";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_use_medalliondove", "deploy_inv_stolenbag" ) ) then

      cmn.CallEventHandler( "use_medalliondove_inv" );
      cmn.CallEventHandler( "use_medalliondove_beg", "inv_stolenbag" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_medalliondove" );
        cmn.CallEventHandler( "use_medalliondove_end", "inv_stolenbag" );
      
      end;

      int.Lock( true );

      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_apply_fly_amulet" );
      ObjAnimate( "spr_deploy_inv_stolenbag_medalliondove", "alp", 0, 0, func_end, 
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

      return true;

    end;

    return false;

  end;
  --*********************************************************************************************************************
  function private.clk_stolenbag ()

    cmn.CallEventHandler( "clk_stolenbag_inv", "inv_stolenbag" );
    cmn.CallEventHandler( "clk_stolenbag_beg", "inv_stolenbag" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_stolenbag" );
      cmn.CallEventHandler( "clk_stolenbag_end", "inv_stolenbag" );
    
    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_open_fly_bag" );

    ObjAnimate( "spr_deploy_inv_stolenbag_open", "alp", 0, 0, "", 
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    ObjAnimate( "spr_deploy_inv_stolenbag_closed", "alp", 0, 0, func_end, 
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );

    return true;

  end;
  --*********************************************************************************************************************
  function private.clk_stolenbag_note ()

    cmn.CallEventHandler( "clk_stolenbag_note_inv", "inv_stolenbag" );
    cmn.CallEventHandler( "clk_stolenbag_note_beg", "inv_stolenbag" );

    local func_end = function ()

      cmn.SetEventDone( "clk_stolenbag_note" );
      cmn.CallEventHandler( "clk_stolenbag_note_end", "inv_stolenbag" );
    
    end;

    cmn.NoteScale( { "spr_deploy_inv_stolenbag_note" } );
    cmn.ShowBbt("bbt_deploy_inv_stolenbag_note");

    local pos_z = ObjGet( "spr_deploy_inv_stolenbag_note" ).pos_z;

    ObjAnimate( "spr_deploy_inv_stolenbag_note", "pos_z", 0, 0, func_end, 
    {
      0.0, 3, pos_z,
      0.3, 3, pos_z,
      0.3, 3, 4,
    } );

  end;
--*********************************************************************************************************************
-- function *** ironpiece *** ()
--*********************************************************************************************************************
  function private.ironpiece_init ()

    ObjSet( "spr_deploy_inv_amuletowl",       { event_mdown = private.get_amuletowl } );
    ObjSet( "spr_deploy_inv_ironpiece_chalk",
    {
      event_startdrag = function ()

        ObjSet( "spr_deploy_inv_ironpiece_chalk_shadow", { alp = 0 } );

      end,
      event_dragdrop = function ()

        private.clk_ironpiece_chalk();

      end,
    } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_amuletowl" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_amuletowl",
      room = "int_deploy_inv",
      zz = "deploy_inv_ironpiece",
      zz_gate = "inv_ironpiece"
    };
    -------------------------------------------------------------------------------------------
    function get_amuletowl_inv ()

      interface.InventoryItemRemove( "inv_ironpiece" );
      interface.InventoryItemAdd( "inv_amuletowl", "spr_deploy_inv_amuletowl" );

      ObjDelete( "gfx_deploy_inv_amuletowl" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_amuletowl", get_amuletowl_inv );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_amuletpicture" ] =
    {
      type = "use",
      use_obj = "inv_amuletpicture",
      use_place = "obj_deploy_inv_ironpiece_use_amuletpicture",
      room = "int_deploy_inv",
      zz = "deploy_inv_ironpiece",
      zz_gate = "inv_ironpiece"
    };
    -------------------------------------------------------------------------------------------
    function use_amuletpicture_inv ()
  
      interface.InventoryItemRemove( "inv_amuletpicture" );

    end;
    function use_amuletpicture_beg ()

      ObjDelete( "obj_deploy_inv_ironpiece_use_amuletpicture" );

    end;
    function use_amuletpicture_end ()

      ObjSet( "spr_deploy_inv_ironpiece_amuletpicture", { alp = 1 } );
      ObjSet( "spr_deploy_inv_ironpiece_chalk",         { input = true } );
      ObjSet( "obj_deploy_inv_ironpiece_use_chalk",     { input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_amuletpicture", use_amuletpicture_beg, "inv_ironpiece" );
    cmn.AddSubscriber( "use_amuletpicture", use_amuletpicture_inv );
    cmn.AddSubscriber( "use_amuletpicture", use_amuletpicture_end, "inv_ironpiece" );
    cmn.AddSubscriber( "use_amuletpicture_inv", use_amuletpicture_inv );
    cmn.AddSubscriber( "use_amuletpicture_beg", use_amuletpicture_beg, "inv_ironpiece" );
    cmn.AddSubscriber( "use_amuletpicture_end", use_amuletpicture_end, "inv_ironpiece" );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_awl_3" ] =
    {
      type = "use",
      use_obj = "inv_awl",
      use_place = "obj_deploy_inv_ironpiece_use_awl_3",
      room = "int_deploy_inv",
      zz = "deploy_inv_ironpiece",
      zz_gate = "inv_ironpiece"
    };
    -------------------------------------------------------------------------------------------
    function use_awl_3_inv ()
  
      if ( cmn.IsEventDone( "use_awl_1" ) ) and
         ( cmn.IsEventDone( "use_awl_2" ) ) then

        interface.InventoryItemRemove( "inv_awl" );

      end;

    end;
    function use_awl_3_beg ()

      ObjDelete( "obj_deploy_inv_ironpiece_use_awl_3" );

    end;
    function use_awl_3_end ()

      ObjDelete( "spr_deploy_inv_ironpiece_ironpiece" );
      ObjDelete( "anm_deploy_inv_ironpiece_awl_3" );
      ObjSet( "spr_deploy_inv_amuletowl", { alp = 1, input = true } );
      ObjSet( "gfx_deploy_inv_amuletowl", { active = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_awl_3", use_awl_3_beg, "inv_ironpiece" );
    cmn.AddSubscriber( "use_awl_3", use_awl_3_inv );
    cmn.AddSubscriber( "use_awl_3", use_awl_3_end, "inv_ironpiece" );
    cmn.AddSubscriber( "use_awl_3_inv", use_awl_3_inv );
    cmn.AddSubscriber( "use_awl_3_beg", use_awl_3_beg, "inv_ironpiece" );
    cmn.AddSubscriber( "use_awl_3_end", use_awl_3_end, "inv_ironpiece" );
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_ironpiece_chalk" ] =
    {
      type = "click",
      clk_obj = "spr_deploy_inv_ironpiece_chalk",
      room = "int_deploy_inv",
      zz = "deploy_inv_ironpiece",
      zz_gate = "inv_ironpiece"
    };
    -------------------------------------------------------------------------------------------
    function clk_ironpiece_chalk_inv ()

      ObjSet( "inv_ironpiece_owl_1", { alp = 1 } );

    end;
    function clk_ironpiece_chalk_beg ()

      ObjDelete( "obj_deploy_inv_ironpiece_use_chalk" );

    end;
    function clk_ironpiece_chalk_end ()

      ObjSet( "spr_deploy_inv_ironpiece_chalk",   { input = false, drag = false } );
      ObjSet( "spr_deploy_inv_ironpiece_owl",     { alp = 1 } );
      ObjSet( "obj_deploy_inv_ironpiece_buttons", { input = true } );

      ObjDelete( "anm_deploy_inv_ironpiece_chalk" );

      if ( not cmn.IsEventStart( "win_ironpiece" ) ) then

        ObjSet( "spr_deploy_inv_ironpiece_head_2",  { alp = 1 } );
        ObjSet( "spr_deploy_inv_ironpiece_body_3",  { alp = 1 } );
        ObjSet( "spr_deploy_inv_ironpiece_tail_2",  { alp = 1 } );

      end;

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_ironpiece_chalk", clk_ironpiece_chalk_inv );
    cmn.AddSubscriber( "clk_ironpiece_chalk", clk_ironpiece_chalk_beg, "inv_ironpiece" );
    cmn.AddSubscriber( "clk_ironpiece_chalk", clk_ironpiece_chalk_end, "inv_ironpiece" );
    cmn.AddSubscriber( "clk_ironpiece_chalk_inv", clk_ironpiece_chalk_inv );
    cmn.AddSubscriber( "clk_ironpiece_chalk_beg", clk_ironpiece_chalk_beg, "inv_ironpiece" );
    cmn.AddSubscriber( "clk_ironpiece_chalk_end", clk_ironpiece_chalk_end, "inv_ironpiece" );
    --------------------------------------------------------------------------------------------
    -- function win_ironpiece () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "win_ironpiece" ] =
    {
      type = "click",
      clk_obj = "spr_deploy_inv_ironpiece_ironpiece",
      room = "int_deploy_inv",
      zz = "deploy_inv_ironpiece",
      zz_gate = "inv_ironpiece"
    };
    -----------------------------------------------
    local win_ironpiece = function ()

      if ( cmn.IsEventStart( "win_ironpiece" ) ) then

        private.IronpieceLoad();

      end;

      if ( cmn.IsEventDone( "win_ironpiece" ) ) then

        ObjDelete( "obj_deploy_inv_ironpiece_buttons" );
        ObjDelete( "inv_ironpiece_owl_1" );
        ObjSet( "obj_deploy_inv_ironpiece_use_awl_3", { input = true } );
        ObjSet( "inv_ironpiece_owl_2",                { alp = 1 } );

      end;

      if ( not cmn.IsEventDone( "get_awl" ) ) then

        ObjSet( "inv_ironpiece_plus_focus2", { alp = 0 } );

      end;

    end;

    cmn.AddSubscriber( "win_ironpiece", win_ironpiece );
    --------------------------------------------------------------------------------------------

  end;
  --*********************************************************************************************************************
  function private.get_amuletowl ()

    cmn.GetObjectSfx();

    cmn.SetEventDone( "get_amuletowl" );
    cmn.CallEventHandler( "get_amuletowl", "inv_amuletowl" );

    int.DeployInvHide();

  end;
  --*********************************************************************************************************************
  function public.use_amuletpicture ()

    local item = "inv_amuletpicture";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_ironpiece_use_amuletpicture", "deploy_inv_ironpiece" ) ) then

      cmn.CallEventHandler( "use_amuletpicture_inv" );
      cmn.CallEventHandler( "use_amuletpicture_beg", "inv_ironpiece" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_amuletpicture" );
        cmn.CallEventHandler( "use_amuletpicture_end", "inv_ironpiece" );
      
        ng_global.progress[ "std" ][ "win_ironpiece" ].parts = { 2, 3, 2 };

      end;

      int.Lock( true );

      ObjAnimate( "spr_deploy_inv_ironpiece_amuletpicture", "alp", 0, 0, func_end, 
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

      ObjAnimate( "spr_deploy_inv_ironpiece_chalk", "alp", 0, 0, "", 
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

      return true;

    end;

    return false;

  end;
  --*********************************************************************************************************************
  function public.use_awl_3 ()

    local item = "inv_awl";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_ironpiece_use_awl_3", "deploy_inv_ironpiece" ) ) and
       ( cmn.IsEventDone( "win_ironpiece" ) ) then

      cmn.CallEventHandler( "use_awl_3_inv" );
      cmn.CallEventHandler( "use_awl_3_beg", "inv_ironpiece" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_awl_3" );
        cmn.CallEventHandler( "use_awl_3_end", "inv_ironpiece" );
      
      end;

      int.Lock( true );

      ObjSet( "spr_deploy_inv_ironpiece_ironpiece",  { alp = 0 } );
      ObjSet( "anm_deploy_inv_ironpiece_awl_3",      { alp = 1 } );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_file_app" );
      AnimPlay( "anm_deploy_inv_ironpiece_awl_3", "DoAnim", func_end );

      return true;

    end;

    return false;

  end;
  --*********************************************************************************************************************
  function private.clk_ironpiece_chalk ()

    if ( not int.ObjIntersectCheck( "spr_deploy_inv_ironpiece_chalk", "obj_deploy_inv_ironpiece_use_chalk", "deploy_inv_ironpiece" ) ) then

      ObjSet( "spr_deploy_inv_ironpiece_chalk_shadow", { alp = 1 } );
      return false;

    end;

    cmn.CallEventHandler( "clk_ironpiece_chalk_inv", "inv_ironpiece" );
    cmn.CallEventHandler( "clk_ironpiece_chalk_beg", "inv_ironpiece" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_ironpiece_chalk" );
      cmn.CallEventHandler( "clk_ironpiece_chalk_end", "inv_ironpiece" );

      cmn.MiniGameShow( "ironpiece" );
      common_impl.PassingMgStart( "ironpiece" );

      ObjSet( "spr_deploy_inv_ironpiece_chalk",        { alp = 1 } );
      ObjSet( "spr_deploy_inv_ironpiece_chalk_shadow", { alp = 1 } );

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_chalk_to_stone" );

    ObjSet( "anm_deploy_inv_ironpiece_chalk",        { alp = 1 } );
    ObjSet( "spr_deploy_inv_ironpiece_chalk",        { alp = 0 } );
    ObjSet( "spr_deploy_inv_ironpiece_chalk_shadow", { alp = 0 } );

    AnimPlay( "anm_deploy_inv_ironpiece_chalk", "DoAnim", func_end );

    ObjAnimate( "spr_deploy_inv_ironpiece_head_2", "alp", 0, 0, "", 
    {
      0.0, 3, 0.0,
      2.0, 3, 0.0,
      2.3, 3, 1.0,
    } );

    ObjAnimate( "spr_deploy_inv_ironpiece_body_3", "alp", 0, 0, "", 
    {
      0.0, 3, 0.0,
      2.0, 3, 0.0,
      2.3, 3, 1.0,
    } );

    ObjAnimate( "spr_deploy_inv_ironpiece_tail_2", "alp", 0, 0, "", 
    {
      0.0, 3, 0.0,
      2.0, 3, 0.0,
      2.3, 3, 1.0,
    } );

    ObjAnimate( "spr_deploy_inv_ironpiece_owl", "alp", 0, 0, "", 
    {
      0.0, 3, 0.0,
      2.0, 3, 0.0,
      2.3, 3, 1.0,
    } );

    return true;

  end;
--*********************************************************************************************************************
-- function *** bow *** ()
--*********************************************************************************************************************
  function private.bow_init ()

    ObjSet( "spr_deploy_inv_bowwitharrow", { event_mdown = private.get_bowwitharrow } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_bowwitharrow" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_bowwitharrow",
      room = "int_deploy_inv",
      zz = "deploy_inv_bow",
      zz_gate = "inv_bow"
    };
    -------------------------------------------------------------------------------------------
    function get_bowwitharrow_inv ()

      interface.InventoryItemRemove( "inv_bow" );
      interface.InventoryItemAdd( "inv_bowwitharrow", "spr_deploy_inv_bowwitharrow" );

      ObjDelete( "gfx_deploy_inv_bowwitharrow" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_bowwitharrow", get_bowwitharrow_inv );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_arrow" ] =
    {
      type = "use",
      use_obj = "inv_arrow",
      use_place = "obj_deploy_inv_use_arrow",
      room = "int_deploy_inv",
      zz = "deploy_inv_bow",
      zz_gate = "inv_bow"
    };
    -------------------------------------------------------------------------------------------
    function use_arrow_inv ()
  
      interface.InventoryItemRemove( "inv_arrow" );

      ObjSet( "inv_bow_plus_focus2", { alp = 0 } );

      if ( cmn.IsEventDone( "get_playdough" ) ) or
         ( cmn.IsEventDone( "get_feathers" ) ) then

        ObjSet( "inv_bow_plus_focus2", { alp = 1 } );

      end;

      ObjSet( "spr_bow_arrow", { alp = 1 } );

    end;
    function use_arrow_beg ()

      ObjDelete( "obj_deploy_inv_use_arrow" );

    end;
    function use_arrow_end ()

      if cmn.IsEventDone( "use_arrow" ) and
         cmn.IsEventDone( "use_playdough" ) and
         cmn.IsEventDone( "use_feathers" ) and
         cmn.IsEventDone( "use_thread" ) then

        ObjSet( "spr_deploy_inv_bowwitharrow", { input = true } );
        ObjSet( "gfx_deploy_inv_bowwitharrow", { active = true } );

      end;

      ObjSet( "spr_deploy_inv_bowwitharrow_arrow", { alp = 1 } );
      ObjSet( "obj_deploy_inv_use_playdough",      { input = true } );
      ObjSet( "obj_deploy_inv_use_feathers",       { input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_arrow", use_arrow_beg, "inv_bow" );
    cmn.AddSubscriber( "use_arrow", use_arrow_inv );
    cmn.AddSubscriber( "use_arrow", use_arrow_end, "inv_bow" );
    cmn.AddSubscriber( "use_arrow_inv", use_arrow_inv );
    cmn.AddSubscriber( "use_arrow_beg", use_arrow_beg, "inv_bow" );
    cmn.AddSubscriber( "use_arrow_end", use_arrow_end, "inv_bow" );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_playdough" ] =
    {
      type = "use",
      use_obj = "inv_playdough",
      use_place = "obj_deploy_inv_use_playdough",
      room = "int_deploy_inv",
      zz = "deploy_inv_bow",
      zz_gate = "inv_bow"
    };
    -------------------------------------------------------------------------------------------
    function use_playdough_inv ()
  
      interface.InventoryItemRemove( "inv_playdough" );

      ObjSet( "inv_bow_plus_focus2", { alp = 0 } );

      if ( cmn.IsEventDone( "get_feathers" ) ) and
         ( not cmn.IsEventDone( "use_feathers" ) ) then

        ObjSet( "inv_bow_plus_focus2", { alp = 1 } );

      end;

      if ( cmn.IsEventDone( "get_thread" ) ) then

        ObjSet( "inv_bow_plus_focus2", { alp = 1 } );

      end;

      ObjSet( "spr_bow_playdough", { alp = 1 } );

    end;
    function use_playdough_beg ()

      ObjDelete( "obj_deploy_inv_use_playdough" );

    end;
    function use_playdough_end ()

      if cmn.IsEventDone( "use_arrow" ) and
         cmn.IsEventDone( "use_playdough" ) and
         cmn.IsEventDone( "use_feathers" ) and
         cmn.IsEventDone( "use_thread" ) then

        ObjSet( "spr_deploy_inv_bowwitharrow", { input = true } );
        ObjSet( "gfx_deploy_inv_bowwitharrow", { active = true } );

      end;

      ObjSet( "spr_deploy_inv_bowwitharrow_playdough", { alp = 1 } );
      ObjSet( "obj_deploy_inv_use_thread",             { input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_playdough", use_playdough_beg, "inv_bow" );
    cmn.AddSubscriber( "use_playdough", use_playdough_inv );
    cmn.AddSubscriber( "use_playdough", use_playdough_end, "inv_bow" );
    cmn.AddSubscriber( "use_playdough_inv", use_playdough_inv );
    cmn.AddSubscriber( "use_playdough_beg", use_playdough_beg, "inv_bow" );
    cmn.AddSubscriber( "use_playdough_end", use_playdough_end, "inv_bow" );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_feathers" ] =
    {
      type = "use",
      use_obj = "inv_feathers",
      use_place = "obj_deploy_inv_use_feathers",
      room = "int_deploy_inv",
      zz = "deploy_inv_bow",
      zz_gate = "inv_bow"
    };
    -------------------------------------------------------------------------------------------
    function use_feathers_inv ()
  
      interface.InventoryItemRemove( "inv_feathers" );

      ObjSet( "inv_bow_plus_focus2", { alp = 0 } );

      if ( cmn.IsEventDone( "get_playdough" ) ) and
         ( not cmn.IsEventDone( "use_playdough" ) ) then

        ObjSet( "inv_bow_plus_focus2", { alp = 1 } );

      end;

      if ( cmn.IsEventDone( "get_thread" ) ) and
         ( cmn.IsEventDone( "use_playdough" ) ) and
         ( not cmn.IsEventDone( "use_thread" ) ) then

        ObjSet( "inv_bow_plus_focus2", { alp = 1 } );

      end;

      if ( cmn.IsEventDone( "use_thread" ) ) then

        ObjSet( "inv_bow_plus_focus2", { alp = 1 } );

      end;

      ObjSet( "spr_bow_feathers", { alp = 1 } );

    end;
    function use_feathers_beg ()

      ObjDelete( "obj_deploy_inv_use_feathers" );

    end;
    function use_feathers_end ()

      if cmn.IsEventDone( "use_arrow" ) and
         cmn.IsEventDone( "use_playdough" ) and
         cmn.IsEventDone( "use_feathers" ) and
         cmn.IsEventDone( "use_thread" ) then

        ObjSet( "spr_deploy_inv_bowwitharrow", { input = true } );
        ObjSet( "gfx_deploy_inv_bowwitharrow", { active = true } );

      end;

      ObjSet( "spr_deploy_inv_bowwitharrow_feathers", { alp = 1 } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_feathers", use_feathers_beg, "inv_bow" );
    cmn.AddSubscriber( "use_feathers", use_feathers_inv );
    cmn.AddSubscriber( "use_feathers", use_feathers_end, "inv_bow" );
    cmn.AddSubscriber( "use_feathers_inv", use_feathers_inv );
    cmn.AddSubscriber( "use_feathers_beg", use_feathers_beg, "inv_bow" );
    cmn.AddSubscriber( "use_feathers_end", use_feathers_end, "inv_bow" );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_thread" ] =
    {
      type = "use",
      use_obj = "inv_thread",
      use_place = "obj_deploy_inv_use_thread",
      room = "int_deploy_inv",
      zz = "deploy_inv_bow",
      zz_gate = "inv_bow"
    };
    -------------------------------------------------------------------------------------------
    function use_thread_inv ()
  
      interface.InventoryItemRemove( "inv_thread" );

      ObjSet( "inv_bow_plus_focus2", { alp = 0 } );

      if ( cmn.IsEventDone( "get_feathers" ) ) and
         ( not cmn.IsEventDone( "use_feathers" ) ) then

        ObjSet( "inv_bow_plus_focus2", { alp = 1 } );

      end;

      if ( cmn.IsEventDone( "use_feathers" ) ) then

        ObjSet( "inv_bow_plus_focus2", { alp = 1 } );

      end;

      ObjSet( "spr_bow_thread", { alp = 1 } );

    end;
    function use_thread_beg ()

      ObjDelete( "obj_deploy_inv_use_thread" );

    end;
    function use_thread_end ()

      if cmn.IsEventDone( "use_arrow" ) and
         cmn.IsEventDone( "use_playdough" ) and
         cmn.IsEventDone( "use_feathers" ) and
         cmn.IsEventDone( "use_thread" ) then

        ObjSet( "spr_deploy_inv_bowwitharrow", { input = true } );
        ObjSet( "gfx_deploy_inv_bowwitharrow", { active = true } );

      end;

      ObjSet( "spr_deploy_inv_bowwitharrow_thread", { alp = 1 } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_thread", use_thread_beg, "inv_bow" );
    cmn.AddSubscriber( "use_thread", use_thread_inv );
    cmn.AddSubscriber( "use_thread", use_thread_end, "inv_bow" );
    cmn.AddSubscriber( "use_thread_inv", use_thread_inv );
    cmn.AddSubscriber( "use_thread_beg", use_thread_beg, "inv_bow" );
    cmn.AddSubscriber( "use_thread_end", use_thread_end, "inv_bow" );
    --------------------------------------------------------------------------------------------

  end;
  --*********************************************************************************************************************
  function private.get_bowwitharrow ()

    cmn.GetObjectSfx();

    cmn.SetEventDone( "get_bowwitharrow" );
    cmn.CallEventHandler( "get_bowwitharrow", "inv_bowwitharrow" );

    int.DeployInvHide();

  end;
  --*********************************************************************************************************************
  function public.use_arrow ()

    local item = "inv_arrow";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_use_arrow", "deploy_inv_bow" ) ) then

      cmn.CallEventHandler( "use_arrow_inv" );
      cmn.CallEventHandler( "use_arrow_beg", "inv_bow" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_arrow" );
        cmn.CallEventHandler( "use_arrow_end", "inv_bow" );
      
      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_arrow_app" );
      ObjAnimate( "spr_deploy_inv_bowwitharrow_arrow", "alp", 0, 0, func_end, 
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

      return true;

    end;

    return false;

  end;
  --*********************************************************************************************************************
  function public.use_playdough ()

    local item = "inv_playdough";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_use_playdough", "deploy_inv_bow" ) ) and
       ( cmn.IsEventDone( "use_arrow" ) ) then

      cmn.CallEventHandler( "use_playdough_inv" );
      cmn.CallEventHandler( "use_playdough_beg", "inv_bow" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_playdough" );
        cmn.CallEventHandler( "use_playdough_end", "inv_bow" );
      
      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_stone_app" );
      ObjAnimate( "spr_deploy_inv_bowwitharrow_playdough", "alp", 0, 0, func_end, 
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

      return true;

    end;

    return false;

  end;
  --*********************************************************************************************************************
  function public.use_feathers ()

    local item = "inv_feathers";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_use_feathers", "deploy_inv_bow" ) ) and
       ( cmn.IsEventDone( "use_arrow" ) ) then

      cmn.CallEventHandler( "use_feathers_inv" );
      cmn.CallEventHandler( "use_feathers_beg", "inv_bow" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_feathers" );
        cmn.CallEventHandler( "use_feathers_end", "inv_bow" );
      
      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_feather_app" );
      ObjAnimate( "spr_deploy_inv_bowwitharrow_feathers", "alp", 0, 0, func_end, 
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

      return true;

    end;

    return false;

  end;
  --*********************************************************************************************************************
  function public.use_thread ()

    local item = "inv_thread";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_use_thread", "deploy_inv_bow" ) ) and
       ( cmn.IsEventDone( "use_playdough" ) ) then

      cmn.CallEventHandler( "use_thread_inv" );
      cmn.CallEventHandler( "use_thread_beg", "inv_bow" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_thread" );
        cmn.CallEventHandler( "use_thread_end", "inv_bow" );
      
      end;

      int.Lock( true );

      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_rope_app" );
      ObjAnimate( "spr_deploy_inv_bowwitharrow_thread", "alp", 0, 0, func_end, 
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
-- function *** rustyjack *** ()
--*********************************************************************************************************************
  function private.rustyjack_init ()

    ObjSet( "spr_deploy_inv_crossed_bones",   { event_mdown = private.get_crossed_bones } );
    ObjSet( "anm_deploy_inv_jack",                 { event_mdown = private.get_jack } );
    ObjSet( "obj_deploy_inv_use_antirustsolution", { event_mdown = private.RustyjackClick } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_crossed_bones" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_crossed_bones",
      room = "int_deploy_inv",
      zz = "deploy_inv_rustyjack",
      zz_gate = "inv_rustyjack"
    };
    -------------------------------------------------------------------------------------------
    function get_crossed_bones_inv ()

      if ( cmn.IsEventDone( "get_jack" ) ) then

        interface.InventoryItemRemove( "inv_rustyjack" );

      end;

      interface.InventoryItemAdd( "inv_crossed_bones", "spr_deploy_inv_crossed_bones" );

      ObjDelete( "gfx_deploy_inv_crossed_bones" );
      ObjDelete( "inv_rustyjack_crossed_bones" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_crossed_bones", get_crossed_bones_inv );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_jack" ] =
    {
      type = "get",
      get_obj = "anm_deploy_inv_jack",
      room = "int_deploy_inv",
      zz = "deploy_inv_rustyjack",
      zz_gate = "inv_rustyjack"
    };
    -------------------------------------------------------------------------------------------
    function get_jack_inv ()

      if ( cmn.IsEventDone( "get_crossed_bones" ) ) then

        interface.InventoryItemRemove( "inv_rustyjack" );

      end;

      interface.InventoryItemAdd( "inv_jack", "anm_deploy_inv_jack" );

      ObjDelete( "gfx_deploy_inv_jack" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_jack", get_jack_inv );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_antirustsolution_1" ] =
    {
      type = "use",
      use_obj = "inv_antirustsolution",
      use_place = "obj_deploy_inv_use_antirustsolution",
      room = "int_deploy_inv",
      zz = "deploy_inv_rustyjack",
      zz_gate = "inv_rustyjack"
    };
    -------------------------------------------------------------------------------------------
    function use_antirustsolution_1_inv ()
  
      ObjDelete( "inv_rustyjack_rust" );

      if cmn.IsEventDone( "use_antirustsolution_2" ) then

        int.InventoryItemRemove( "inv_antirustsolution" );

      end;

    end;
    function use_antirustsolution_1_beg ()

      ObjDelete( "obj_deploy_inv_use_antirustsolution" );

    end;
    function use_antirustsolution_1_end ()

      ObjSet( "spr_deploy_inv_crossed_bones", { input = true } );
      ObjSet( "anm_deploy_inv_jack",               { input = true, alp = 1 } );
      ObjSet( "gfx_deploy_inv_crossed_bones", { active = true } );
      ObjSet( "gfx_deploy_inv_jack",               { active = true } );
      ObjDelete( "anm_deploy_inv_rustyjack_antirustsolution" );
      ObjDelete( "anm_deploy_inv_rustyjack_click" );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_antirustsolution_1", use_antirustsolution_1_beg, "inv_rustyjack" );
    cmn.AddSubscriber( "use_antirustsolution_1", use_antirustsolution_1_inv );
    cmn.AddSubscriber( "use_antirustsolution_1", use_antirustsolution_1_end, "inv_rustyjack" );
    cmn.AddSubscriber( "use_antirustsolution_1_inv", use_antirustsolution_1_inv );
    cmn.AddSubscriber( "use_antirustsolution_1_beg", use_antirustsolution_1_beg, "inv_rustyjack" );
    cmn.AddSubscriber( "use_antirustsolution_1_end", use_antirustsolution_1_end, "inv_rustyjack" );
    --------------------------------------------------------------------------------------------

  end;
  --*********************************************************************************************************************
  function private.get_crossed_bones ()

    cmn.GetObjectSfx();

    cmn.SetEventDone( "get_crossed_bones" );
    cmn.CallEventHandler( "get_crossed_bones", "inv_crossed_bones" );

    if ( cmn.IsEventDone( "get_jack" ) ) then

      int.DeployInvHide();

    end;

  end;
  --*********************************************************************************************************************
  function private.get_jack ()

    cmn.GetObjectSfx();

    cmn.SetEventDone( "get_jack" );
    cmn.CallEventHandler( "get_jack", "inv_jack" );

    int.DeployInvHide();

    if ( not cmn.IsEventDone( "get_crossed_bones" ) ) then

      private.get_crossed_bones();

    end;

  end;
  --*********************************************************************************************************************
  function public.use_antirustsolution_1 ()

    local item = "inv_antirustsolution";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_use_antirustsolution", "deploy_inv_rustyjack" ) ) then

      cmn.CallEventHandler( "use_antirustsolution_1_inv" );
      cmn.CallEventHandler( "use_antirustsolution_1_beg", "inv_rustyjack" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_antirustsolution_1" );
        cmn.CallEventHandler( "use_antirustsolution_1_end", "inv_rustyjack" );
      
      end;

      int.Lock( true );

      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_solvent_to_jack" );

      ObjSet( "anm_deploy_inv_rustyjack_click", { alp = 0 } );
      ObjSet( "anm_deploy_inv_rustyjack_antirustsolution", { alp = 1 } );

      AnimPlay( "anm_deploy_inv_rustyjack_antirustsolution", "DoAnim", func_end );

      return true;

    end;

    return false;

  end;
  --*********************************************************************************************************************
  function private.RustyjackClick ()

    int.Lock( true );

    local func_end = function ()

      int.Lock( false );

      cmn.ShowBbt( "bbt_level1_inv_antirustsolution_use");

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_bone_in_jack_clk" );
    AnimPlay( "anm_deploy_inv_rustyjack_click", "DoAnim", func_end );

  end
--*********************************************************************************************************************
-- function *** brokenworkshopfob *** ()
--*********************************************************************************************************************
  function private.brokenworkshopfob_init ()

    ObjSet( "spr_deploy_inv_workshopfob_up",                  { event_mdown = private.get_workshopfob } );
    ObjSet( "obj_deploy_inv_brokenworkshopfob_clk_up",        { event_mdown = private.clk_brokenworkshopfob_up } );
    ObjSet( "obj_deploy_inv_brokenworkshopfob_clk_cup_close", { event_mdown = private.clk_brokenworkshopfob_cup_close } );
    ObjSet( "obj_deploy_inv_brokenworkshopfob_clk_cup_open",  { event_mdown = private.clk_brokenworkshopfob_cup_open } );
    ObjSet( "obj_deploy_inv_brokenworkshopfob_clk_bottom",    { event_mdown = private.clk_brokenworkshopfob_bottom } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_workshopfob" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_workshopfob_up",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenworkshopfob",
      zz_gate = "inv_brokenworkshopfob"
    };
    -------------------------------------------------------------------------------------------
    function get_workshopfob_inv ()

      interface.InventoryItemRemove( "inv_brokenworkshopfob" );
      interface.InventoryItemAdd( "inv_workshopfob", "spr_deploy_inv_workshopfob_up" );

      ObjDelete( "gfx_deploy_inv_workshopfob" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_workshopfob", get_workshopfob_inv );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_smallbattery_2" ] =
    {
      type = "use",
      use_obj = "inv_smallbattery_1",
      use_place = "obj_deploy_inv_brokenworkshopfob_use_smallbattery",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenworkshopfob",
      zz_gate = "inv_brokenworkshopfob"
    };
    -------------------------------------------------------------------------------------------
    function use_smallbattery_2_inv ()
  
      interface.InventoryItemRemove( "inv_smallbattery_1" );
      ObjSet( "spr_brokenworkshopfob_smallbattery", { alp = 1 } );

    end;
    function use_smallbattery_2_beg ()

      ObjDelete( "obj_deploy_inv_brokenworkshopfob_use_smallbattery" );

    end;
    function use_smallbattery_2_end ()

      ObjSet( "spr_deploy_inv_workshopfob_smallbattery",        { alp = 1 } );
      ObjSet( "obj_deploy_inv_brokenworkshopfob_clk_cup_close", { input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_smallbattery_2", use_smallbattery_2_beg, "inv_brokenworkshopfob" );
    cmn.AddSubscriber( "use_smallbattery_2", use_smallbattery_2_inv );
    cmn.AddSubscriber( "use_smallbattery_2", use_smallbattery_2_end, "inv_brokenworkshopfob" );
    cmn.AddSubscriber( "use_smallbattery_2_inv", use_smallbattery_2_inv );
    cmn.AddSubscriber( "use_smallbattery_2_beg", use_smallbattery_2_beg, "inv_brokenworkshopfob" );
    cmn.AddSubscriber( "use_smallbattery_2_end", use_smallbattery_2_end, "inv_brokenworkshopfob" );
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_adhesivetape" ] =
    {
      type = "use",
      use_obj = "inv_adhesivetape",
      use_place = "obj_deploy_inv_brokenworkshopfob_use_adhesivetape",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenworkshopfob",
      zz_gate = "inv_brokenworkshopfob"
    };
    -------------------------------------------------------------------------------------------
    function use_adhesivetape_inv ()
  
      interface.InventoryItemRemove( "inv_adhesivetape" );
      ObjSet( "spr_brokenworkshopfob_adhesivetape", { alp = 1 } );

    end;
    function use_adhesivetape_beg ()

      ObjDelete( "obj_deploy_inv_brokenworkshopfob_use_adhesivetape" );

    end;
    function use_adhesivetape_end ()

      ObjSet( "spr_deploy_inv_workshopfob_adhesivetape", { alp = 1 } );
      ObjSet( "obj_deploy_inv_brokenworkshopfob_clk_up", { input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_adhesivetape", use_adhesivetape_beg, "inv_brokenworkshopfob" );
    cmn.AddSubscriber( "use_adhesivetape", use_adhesivetape_inv );
    cmn.AddSubscriber( "use_adhesivetape", use_adhesivetape_end, "inv_brokenworkshopfob" );
    cmn.AddSubscriber( "use_adhesivetape_inv", use_adhesivetape_inv );
    cmn.AddSubscriber( "use_adhesivetape_beg", use_adhesivetape_beg, "inv_brokenworkshopfob" );
    cmn.AddSubscriber( "use_adhesivetape_end", use_adhesivetape_end, "inv_brokenworkshopfob" );
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_brokenworkshopfob_bottom" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_brokenworkshopfob_clk_bottom",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenworkshopfob",
      zz_gate = "inv_brokenworkshopfob"
    };
    -------------------------------------------------------------------------------------------
    function clk_brokenworkshopfob_bottom_inv ()

      ObjSet( "inv_brokenworkshopfob", { res = "assets/levels/level1/common_inventory1/inv_brokenworkshopfob/inv/inv_brokenworkshopfob_bottom" } );
      ObjSet( "inv_brokenworkshopfob_bottom", { alp = 1 } );

    end;
    function clk_brokenworkshopfob_bottom_beg ()

      ObjDelete( "obj_deploy_inv_brokenworkshopfob_clk_bottom" );

    end;
    function clk_brokenworkshopfob_bottom_end ()

      ObjSet( "spr_deploy_inv_workshopfob_up",                 { alp = 0 } );
      ObjSet( "obj_deploy_inv_workshopfob_bottom",             { alp = 1 } );
      ObjSet( "obj_deploy_inv_brokenworkshopfob_clk_cup_open", { input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_brokenworkshopfob_bottom", clk_brokenworkshopfob_bottom_inv );
    cmn.AddSubscriber( "clk_brokenworkshopfob_bottom", clk_brokenworkshopfob_bottom_beg, "inv_brokenworkshopfob" );
    cmn.AddSubscriber( "clk_brokenworkshopfob_bottom", clk_brokenworkshopfob_bottom_end, "inv_brokenworkshopfob" );
    cmn.AddSubscriber( "clk_brokenworkshopfob_bottom_inv", clk_brokenworkshopfob_bottom_inv );
    cmn.AddSubscriber( "clk_brokenworkshopfob_bottom_beg", clk_brokenworkshopfob_bottom_beg, "inv_brokenworkshopfob" );
    cmn.AddSubscriber( "clk_brokenworkshopfob_bottom_end", clk_brokenworkshopfob_bottom_end, "inv_brokenworkshopfob" );
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_brokenworkshopfob_cup_open" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_brokenworkshopfob_clk_cup_open",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenworkshopfob",
      zz_gate = "inv_brokenworkshopfob"
    };
    -------------------------------------------------------------------------------------------
    function clk_brokenworkshopfob_cup_open_inv ()

      if ( not cmn.IsEventDone( "get_smallbattery_1" ) ) or
         ( not cmn.IsEventDone( "get_smallbattery_2" ) ) then

        ObjSet( "inv_brokenworkshopfob_plus_focus2", { alp = 0 } );

      end;

      ObjSet( "spr_brokenworkshopfob_cover", { pos_x = 30, pos_y = 4 } );

    end;
    function clk_brokenworkshopfob_cup_open_beg ()

      ObjDelete( "obj_deploy_inv_brokenworkshopfob_clk_cup_open" );

    end;
    function clk_brokenworkshopfob_cup_open_end ()

      ObjSet( "spr_deploy_inv_workshopfob_cup",                    { pos_x = 245, pos_y = 25 } );
      ObjSet( "obj_deploy_inv_brokenworkshopfob_use_smallbattery", { input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_brokenworkshopfob_cup_open", clk_brokenworkshopfob_cup_open_inv );
    cmn.AddSubscriber( "clk_brokenworkshopfob_cup_open", clk_brokenworkshopfob_cup_open_beg, "inv_brokenworkshopfob" );
    cmn.AddSubscriber( "clk_brokenworkshopfob_cup_open", clk_brokenworkshopfob_cup_open_end, "inv_brokenworkshopfob" );
    cmn.AddSubscriber( "clk_brokenworkshopfob_cup_open_inv", clk_brokenworkshopfob_cup_open_inv );
    cmn.AddSubscriber( "clk_brokenworkshopfob_cup_open_beg", clk_brokenworkshopfob_cup_open_beg, "inv_brokenworkshopfob" );
    cmn.AddSubscriber( "clk_brokenworkshopfob_cup_open_end", clk_brokenworkshopfob_cup_open_end, "inv_brokenworkshopfob" );
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_brokenworkshopfob_cup_close" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_brokenworkshopfob_clk_cup_close",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenworkshopfob",
      zz_gate = "inv_brokenworkshopfob"
    };
    -------------------------------------------------------------------------------------------
    function clk_brokenworkshopfob_cup_close_inv ()

      if ( not cmn.IsEventDone( "get_adhesivetape" ) ) then

        ObjSet( "inv_brokenworkshopfob_plus_focus2", { alp = 0 } );

      end;

      ObjSet( "spr_brokenworkshopfob_cover", { pos_x = 2, pos_y = -22 } );

    end;
    function clk_brokenworkshopfob_cup_close_beg ()

      ObjDelete( "obj_deploy_inv_brokenworkshopfob_clk_cup_close" );

    end;
    function clk_brokenworkshopfob_cup_close_end ()

      ObjSet( "spr_deploy_inv_workshopfob_cup",                    { pos_x = 42, pos_y = -108 } );
      ObjSet( "obj_deploy_inv_brokenworkshopfob_use_adhesivetape", { input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_brokenworkshopfob_cup_close", clk_brokenworkshopfob_cup_close_inv );
    cmn.AddSubscriber( "clk_brokenworkshopfob_cup_close", clk_brokenworkshopfob_cup_close_beg, "inv_brokenworkshopfob" );
    cmn.AddSubscriber( "clk_brokenworkshopfob_cup_close", clk_brokenworkshopfob_cup_close_end, "inv_brokenworkshopfob" );
    cmn.AddSubscriber( "clk_brokenworkshopfob_cup_close_inv", clk_brokenworkshopfob_cup_close_inv );
    cmn.AddSubscriber( "clk_brokenworkshopfob_cup_close_beg", clk_brokenworkshopfob_cup_close_beg, "inv_brokenworkshopfob" );
    cmn.AddSubscriber( "clk_brokenworkshopfob_cup_close_end", clk_brokenworkshopfob_cup_close_end, "inv_brokenworkshopfob" );
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_brokenworkshopfob_up" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_brokenworkshopfob_clk_up",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenworkshopfob",
      zz_gate = "inv_brokenworkshopfob"
    };
    -------------------------------------------------------------------------------------------
    function clk_brokenworkshopfob_up_inv ()

      ObjDelete( "obj_deploy_inv_brokenworkshopfob_clk_up" );
      ObjDelete( "inv_brokenworkshopfob_bottom" );
      ObjSet( "inv_brokenworkshopfob", { res = "assets/levels/level1/rm_townoutskirts/zz_policewindow/inv/inv_brokenworkshopfob" } );

    end;
    function clk_brokenworkshopfob_up_beg ()

      ObjDelete( "obj_deploy_inv_brokenworkshopfob_clk_bottom" );

    end;
    function clk_brokenworkshopfob_up_end ()

      ObjSet( "obj_deploy_inv_workshopfob_bottom", { alp = 0 } );
      ObjSet( "spr_deploy_inv_workshopfob_up",     { alp = 1, input = true } );
      ObjSet( "gfx_deploy_inv_workshopfob",        { active = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_brokenworkshopfob_up", clk_brokenworkshopfob_up_inv );
    cmn.AddSubscriber( "clk_brokenworkshopfob_up", clk_brokenworkshopfob_up_beg, "inv_brokenworkshopfob" );
    cmn.AddSubscriber( "clk_brokenworkshopfob_up", clk_brokenworkshopfob_up_end, "inv_brokenworkshopfob" );
    cmn.AddSubscriber( "clk_brokenworkshopfob_up_inv", clk_brokenworkshopfob_up_inv );
    cmn.AddSubscriber( "clk_brokenworkshopfob_up_beg", clk_brokenworkshopfob_up_beg, "inv_brokenworkshopfob" );
    cmn.AddSubscriber( "clk_brokenworkshopfob_up_end", clk_brokenworkshopfob_up_end, "inv_brokenworkshopfob" );
    -------------------------------------------------------------------------------------------  

  end;
  --*********************************************************************************************************************
  function private.get_workshopfob ()

    cmn.GetObjectSfx();

    cmn.SetEventDone( "get_workshopfob" );
    cmn.CallEventHandler( "get_workshopfob", "inv_workshopfob" );

    int.DeployInvHide();

  end;
  --*********************************************************************************************************************
  function public.use_smallbattery_2 ()

    local item = "inv_smallbattery_1";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_brokenworkshopfob_use_smallbattery", "deploy_inv_brokenworkshopfob" ) ) and
       ( cmn.IsEventDone( "get_smallbattery_1" ) ) and
       ( cmn.IsEventDone( "get_smallbattery_2" ) ) and
       ( cmn.IsEventDone( "clk_brokenworkshopfob_cup_open" ) ) then

      cmn.CallEventHandler( "use_smallbattery_2_inv" );
      cmn.CallEventHandler( "use_smallbattery_2_beg", "inv_brokenworkshopfob" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_smallbattery_2" );
        cmn.CallEventHandler( "use_smallbattery_2_end", "inv_brokenworkshopfob" );
      
      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_trinket_batterys_app" );
      ObjAnimate( "spr_deploy_inv_workshopfob_smallbattery", "alp", 0, 0, func_end, 
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

      return true;

    end;

    return false;

  end;
  --*********************************************************************************************************************
  function public.use_adhesivetape ()

    local item = "inv_adhesivetape";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_brokenworkshopfob_use_adhesivetape", "deploy_inv_brokenworkshopfob" ) ) and
       ( cmn.IsEventDone( "clk_brokenworkshopfob_cup_close" ) ) then

      cmn.CallEventHandler( "use_adhesivetape_inv" );
      cmn.CallEventHandler( "use_adhesivetape_beg", "inv_brokenworkshopfob" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_adhesivetape" );
        cmn.CallEventHandler( "use_adhesivetape_end", "inv_brokenworkshopfob" );
      
      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_trinket_tape_app" );
      ObjAnimate( "spr_deploy_inv_workshopfob_adhesivetape", "alp", 0, 0, func_end, 
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

      return true;

    elseif ( cmn.ApplyObj( item, "obj_track_use_rope", true ) ) then

      cmn.ShowBbt( "bbt_adhesivetape_wrong_use" );

      return true;

    end;

    return false;

  end;
  --*********************************************************************************************************************
  function private.clk_brokenworkshopfob_bottom ()

    cmn.CallEventHandler( "clk_brokenworkshopfob_bottom_inv", "inv_brokenworkshopfob" );
    cmn.CallEventHandler( "clk_brokenworkshopfob_bottom_beg", "inv_brokenworkshopfob" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_brokenworkshopfob_bottom" );
      cmn.CallEventHandler( "clk_brokenworkshopfob_bottom_end", "inv_brokenworkshopfob" );
    
    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_trinket_click" );

    ObjAnimate( "obj_deploy_inv_workshopfob_bottom", "alp", 0, 0, "", 
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    ObjAnimate( "spr_deploy_inv_workshopfob_up", "alp", 0, 0, func_end, 
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );

    return true;

  end;
  --*********************************************************************************************************************
  function private.clk_brokenworkshopfob_cup_open ()

    cmn.CallEventHandler( "clk_brokenworkshopfob_cup_open_inv", "inv_brokenworkshopfob" );
    cmn.CallEventHandler( "clk_brokenworkshopfob_cup_open_beg", "inv_brokenworkshopfob" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_brokenworkshopfob_cup_open" );
      cmn.CallEventHandler( "clk_brokenworkshopfob_cup_open_end", "inv_brokenworkshopfob" );
    
    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_trinket_take_cover" );

    ObjAnimate( "spr_deploy_inv_workshopfob_cup", "pos_xy", 0, 0, func_end, 
    {
      0.0, 3,  42, -108,
      0.7, 3, 245,   25,
    } );

    return true;

  end;
  --*********************************************************************************************************************
  function private.clk_brokenworkshopfob_cup_close ()

    cmn.CallEventHandler( "clk_brokenworkshopfob_cup_close_inv", "inv_brokenworkshopfob" );
    cmn.CallEventHandler( "clk_brokenworkshopfob_cup_close_beg", "inv_brokenworkshopfob" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_brokenworkshopfob_cup_close" );
      cmn.CallEventHandler( "clk_brokenworkshopfob_cup_close_end", "inv_brokenworkshopfob" );
    
    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_trinket_close_cover" );

    ObjAnimate( "spr_deploy_inv_workshopfob_cup", "pos_xy", 0, 0, func_end, 
    {
      0.0, 3, 245,   25,
      0.7, 3,  42, -108,
    } );

    return true;

  end;
  --*********************************************************************************************************************
  function private.clk_brokenworkshopfob_up ()

    cmn.CallEventHandler( "clk_brokenworkshopfob_up_inv", "inv_brokenworkshopfob" );
    cmn.CallEventHandler( "clk_brokenworkshopfob_up_beg", "inv_brokenworkshopfob" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_brokenworkshopfob_up" );
      cmn.CallEventHandler( "clk_brokenworkshopfob_up_end", "inv_brokenworkshopfob" );
    
    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_trinket_finish_him" );

    ObjAnimate( "spr_deploy_inv_workshopfob_up", "alp", 0, 0, "", 
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    ObjAnimate( "obj_deploy_inv_workshopfob_bottom", "alp", 0, 0, func_end, 
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );

    return true;

  end;
--*********************************************************************************************************************
--*** function *** CHECK FUNCTIONS *** () end;
--********************************************************************************************************************
  function public.CheckPlanks ()

    local path = "inv_planks_2";

    if ( cmn.IsEventDone( "get_planks_2" ) and cmn.IsEventDone( "get_planks_4" ) ) then

      path = "inv_planks_4";

    end;

    ObjSet( "inv_planks_2", { res = "assets/levels/level1/rm_abandonedfarm/zz_doorstothehouse/inv/"..path } );

  end;
--*********************************************************************************************************************
  function public.CheckNails ()

    local path = "inv_nails_4";

    if ( cmn.IsEventDone( "get_nails_4" ) and cmn.IsEventDone( "get_nails_8" ) ) then

      path = "inv_nails_8";

    end;

    ObjSet( "inv_nails_4", { res = "assets/levels/level1/rm_abandonedfarm/zz_doorstothehouse/inv/"..path } );

  end;
--*********************************************************************************************************************
  function public.CheckTriangularpart ()

    local path = "inv_triangularpart_1";

    if ( cmn.IsEventDone( "get_triangularpart_1" ) and cmn.IsEventDone( "get_triangularpart_2" ) ) then

      path = "inv_triangularpart_2";

    end;

    ObjSet( "inv_triangularpart_1", { res = "assets/levels/level1/rm_abandonedfarm/zz_bicyclezone/inv/"..path } );

  end;
--*********************************************************************************************************************
  function public.CheckSmallbattery ()

    local path = "inv_smallbattery_1";

    if ( cmn.IsEventDone( "get_smallbattery_1" ) and cmn.IsEventDone( "get_smallbattery_2" ) ) then

      path = "inv_smallbattery_2";

      if ( cmn.IsEventDone( "clk_brokenworkshopfob_cup_open" ) ) then

        ObjSet( "inv_brokenworkshopfob_plus_focus2", { alp = 1 } );

      end;

    end;

    ObjSet( "inv_smallbattery_1", { res = "assets/levels/level1/rm_bygrayscar/zz_trunk/inv/"..path } );

  end;
--*********************************************************************************************************************
  function public.CheckCoin ()

    local path = "inv_coin_1";

    if ( cmn.IsEventDone( "get_coin_1" ) and cmn.IsEventDone( "get_coin_2" ) ) then

      path = "inv_coin_2";

    end;

    ObjSet( "inv_coin_1", { res = "assets/levels/level1/rm_abandonedfarm/zz_treehole/inv/"..path } );

  end;
--*********************************************************************************************************************
--*** function *** MMG IRONPIECE *** () end;
--*********************************************************************************************************************
  function private.IronpieceInit ()

    int_deploy_inv.Define( "ironpiece" );

    ObjSet( "obj_deploy_inv_ironpiece_btn_head", { event_mdown = function () private.IronpieceClick( "head" ); end; } );
    ObjSet( "obj_deploy_inv_ironpiece_btn_body", { event_mdown = function () private.IronpieceClick( "body" ); end; } );
    ObjSet( "obj_deploy_inv_ironpiece_btn_tail", { event_mdown = function () private.IronpieceClick( "tail" ); end; } );

    --*********************************************************************************************************************
    function ironpiece.Reset ()

      local parts = { "head", "body", "tail" };

      for p = 1, 3 do

        local part = ng_global.progress[ "std" ][ "win_ironpiece" ].parts[ p ];

        ObjSet( "spr_deploy_inv_ironpiece_"..parts[ p ].."_"..part, { alp = 0 } );

      end;

      ObjSet( "spr_deploy_inv_ironpiece_head_2", { alp = 1 } );
      ObjSet( "spr_deploy_inv_ironpiece_body_3", { alp = 1 } );
      ObjSet( "spr_deploy_inv_ironpiece_tail_2", { alp = 1 } );

      ng_global.progress[ "std" ][ "win_ironpiece" ].parts = { 2, 3, 2 };

    end;
    --*********************************************************************************************************************
    function ironpiece.Skip ()

      local parts = { "head", "body", "tail" };

      int.Lock( true );

      for p = 1, 3 do

        local part = ng_global.progress[ "std" ][ "win_ironpiece" ].parts[ p ];

        ObjAnimate( "spr_deploy_inv_ironpiece_"..parts[ p ].."_"..part, "alp", 0, 0, "", 
        {
          0.0, 3, 1.0,
          0.3, 3, 0.0,
        } );

        local alp = ObjGet( "spr_deploy_inv_ironpiece_"..parts[ p ].."_1" ).alp;

        ObjAnimate( "spr_deploy_inv_ironpiece_"..parts[ p ].."_1", "alp", 0, 0, "", 
        {
          0.0, 3, alp,
          0.3, 3, 1.0,
        } );

      end;

      ng_global.progress[ "std" ][ "win_ironpiece" ].parts = { 1, 1, 1 };

      ObjSet( "tmr_deploy_inv_ironpiece_skip",
      {
        time = 0.3,
        playing = true,
        endtrig = function ()

          int.Lock( false );

          private.IronpieceWin();

        end,
      } );

    end;

  end;
--*********************************************************************************************************************
  function private.IronpieceClick ( part )

    local parts = { [ "head" ] = 1, [ "body" ] = 2, [ "tail" ] = 3 };

    local idx_curr = ng_global.progress[ "std" ][ "win_ironpiece" ].parts[ parts[ part ] ];
    local idx_next = idx_curr + 1;

    if ( idx_next > 3 ) then

      idx_next = 1;

    end;

    int.Lock( true );

    local func_end = function ()

      int.Lock( false );

      ng_global.progress[ "std" ][ "win_ironpiece" ].parts[ parts[ part ] ] = idx_next;

      if ( private.IronpieceIsWin() ) then

        private.IronpieceWin();

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_differences_owl_click" );
    ObjAnimate( "spr_deploy_inv_ironpiece_"..part.."_"..idx_curr, "alp", 0, 0, "", 
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );

    ObjAnimate( "spr_deploy_inv_ironpiece_"..part.."_"..idx_next, "alp", 0, 0, func_end, 
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

  end;
--*********************************************************************************************************************
  function private.IronpieceIsWin ()

    for p = 1, 3 do

      local part = ng_global.progress[ "std" ][ "win_ironpiece" ].parts[ p ];

      if ( part ~= 1 ) then

        return false;

      end;

    end;

    return true;

  end;
--*********************************************************************************************************************
  function private.IronpieceLoad ()

    ObjSet( "spr_deploy_inv_ironpiece_head_2", { alp = 0 } );
    ObjSet( "spr_deploy_inv_ironpiece_body_3", { alp = 0 } );
    ObjSet( "spr_deploy_inv_ironpiece_tail_2", { alp = 0 } );

    local parts = { "head", "body", "tail" };

    for p = 1, 3 do

      local part = ng_global.progress[ "std" ][ "win_ironpiece" ].parts[ p ];

      ObjSet( "spr_deploy_inv_ironpiece_"..parts[ p ].."_"..part, { alp = 1 } );

    end;

  end;
--*********************************************************************************************************************
  function private.IronpieceWin ()

    cmn.MiniGameHide( "ironpiece" );
    common_impl.PassingMgWin( "ironpiece" );

    cmn.SetEventDone( "win_ironpiece" );
    cmn.CallEventHandler( "win_ironpiece", "win_ironpiece" );

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************