-- name=rm_abandonedfarm
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_abandonedfarm";

  ObjAttach( "zz_bicyclezone", "room_hub" );
  ObjAttach( "zz_tent", "room_hub" );
  ObjAttach( "zz_savingbox", "room_hub" );
  ObjAttach( "zz_doorstothehouse", "room_hub" );
  ObjAttach( "zz_treehole", "room_hub" );

  private.treehole_nut_number = 0;
  private.coin_delay = 0;
  
  ObjMultiSet( {
    { "spr_bicyclezone_bicycle",            { event_mdown = private.get_bicycle } },
    { "spr_bicyclezone_triangularpart_1",   { event_mdown = private.get_triangularpart_1 } },
    { "spr_tent_ironpiece",                 { event_mdown = private.get_ironpiece } },
    { "spr_tent_smallbattery_2",            { event_mdown = private.get_smallbattery_2 } },
    { "spr_tent_triangularpart_2",          { event_mdown = private.get_triangularpart_2 } },
    { "spr_tent_coaltongs",                 { event_mdown = private.get_coaltongs } },
    { "spr_tent_toggle",                    { event_mdown = private.get_toggle } },
    { "spr_tent_pump",                      { event_mdown = private.get_pump } },
    { "spr_doorstothehouse_planks_2",       { event_mdown = private.get_planks_2 } },
    { "spr_doorstothehouse_nails_4",        { event_mdown = private.get_nails_4 } },
    { "spr_treehole_feathers",              { event_mdown = private.get_feathers } },
    { "spr_treehole_bicyclekey",            { event_mdown = private.get_bicyclekey } },
    { "spr_treehole_handfulofnuts",         { event_mdown = private.get_handfulofnuts } },
    { "spr_treehole_coin_1",                { event_mdown = private.get_coin_1 } },
    { "obj_savingbox_clk_vid_bat",          { event_mdown = private.clk_vid_bat } },
    { "obj_bicyclezone_clk_bicyclekey",     { event_mdown = private.clk_bicyclekey } },
    { "obj_savingbox_use_triangularpart_2", { event_mdown = private.SavingboxCupClick } },
    { "obj_bicyclezone_use_bicyclekey",     { event_mdown = private.BicyclezoneClick } },
    { "obj_tent_clk_bag",                   { event_mdown = private.clk_bag_lvl1 } },
    { "obj_doorstothehouse_use_hammer",     { event_mdown = private.DoorstothehouseClick } },
    { "obj_doorstothehouse_use_lockpick",   { event_mdown = private.DoorstothehouseLockClick } },
    { "obj_tent_use_shard",                 { event_mdown = private.TentClick } },
    { "obj_tent_use_insectspray",           { event_mdown = private.ScorpioClick } },
    { "obj_treehole_use_awl",               { event_mdown = private.TreeholeClick } },
    { "obj_tent_use_awl",                   { event_mdown = private.FridgeClick } },
    { "obj_bicyclezone_bag",                { event_mdown = private.BicyclezoneBagClick } },
    { "spr_tent_collect2_1_2",              { event_mdown = private.get_collect2_1_2 } }
  } );

  private.anim_obj = 
  {
    {"obj_treehole_lantern",      0, -30, 20, 0}
  };
  private.x = -0.5;
  private.y =  0.5;

  private.InitSubroom();
  private.Anims();    

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_abandonedfarm = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gho_abandonedfarm_farmhouse",
        "gmg_abandonedfarm_onthelid",
        "gzz_abandonedfarm_bicyclezone",
        "gzz_abandonedfarm_tent",
        "gzz_abandonedfarm_savingbox",
        "gzz_abandonedfarm_doorstothehouse",
        "gzz_abandonedfarm_treehole"
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_bicyclezone", 
        "zz_tent", 
        "zz_savingbox", 
        "zz_doorstothehouse",
        "zz_treehole",
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_abandonedfarm", update_game_mode_abandonedfarm, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_bicycle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bicycle" ] =
  {
    type = "get",
    get_obj = "spr_bicyclezone_bicycle",
    room = private.room_objname,
    zz = "zz_bicyclezone",
    zz_gate = "gzz_abandonedfarm_bicyclezone"
  };
  -----------------------------------------------
  local get_bicycle_inv = function ()

    int.InventoryItemAdd( "inv_bicycle", "spr_bicyclezone_bicycle" );

  end;

  local get_bicycle_closezz = function ()

    ObjDelete( "gfx_bicyclezone_bicycle" );
    ObjDelete( "spr_bicyclezone_bicycle_shadow" );
    ObjDelete( "gzz_abandonedfarm_bicyclezone" );
    ObjDelete( "spr_abandonedfarm_bicycle" );

  end;

  cmn.AddSubscriber( "get_bicycle", get_bicycle_inv );
  cmn.AddSubscriber( "get_bicycle", get_bicycle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_triangularpart_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_triangularpart_1" ] =
  {
    type = "get",
    get_obj = "spr_bicyclezone_triangularpart_1",
    room = private.room_objname,
    zz = "zz_bicyclezone",
    zz_gate = "gzz_abandonedfarm_bicyclezone"
  };
  -----------------------------------------------
  local get_triangularpart_1_inv = function ()

    int.InventoryItemAdd( "inv_triangularpart_1", "spr_bicyclezone_triangularpart_1", "assets/levels/level1/rm_abandonedfarm/zz_bicyclezone/inv/inv_triangularpart_morph" );
    level1_inv.CheckTriangularpart ();

  end;

  local get_triangularpart_1_closezz = function ()

    ObjDelete( "gfx_bicyclezone_triangularpart_1" );
    ObjDelete( "spr_bicyclezone_triangularpart_1_shadow" );
    ObjDelete( "spr_abandonedfarm_glass_2" );

  end;

  cmn.AddSubscriber( "get_triangularpart_1", get_triangularpart_1_inv );
  cmn.AddSubscriber( "get_triangularpart_1", get_triangularpart_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ironpiece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ironpiece" ] =
  {
    type = "get",
    get_obj = "spr_tent_ironpiece",
    room = private.room_objname,
    zz = "zz_tent",
    zz_gate = "gzz_abandonedfarm_tent"
  };
  -----------------------------------------------
  local get_ironpiece_inv = function ()

    int.InventoryItemAdd( "inv_ironpiece", "spr_tent_ironpiece" );
    ObjSet( "inv_ironpiece", { drag = false } );

    if ( not cmn.IsEventDone( "get_amuletpicture" ) ) then

      ObjSet( "inv_ironpiece_plus_focus2", { alp = 0 } );

    end;

  end;

  local get_ironpiece_closezz = function ()

    ObjDelete( "gfx_tent_ironpiece" );
    ObjDelete( "spr_abandonedfarm_metall_piece" );

    if ( cmn.IsEventDone( "get_ironpiece" ) and
         cmn.IsEventDone( "get_smallbattery_2" ) and
         cmn.IsEventDone( "get_triangularpart_2" ) and
         cmn.IsEventDone( "get_coaltongs" ) and
         cmn.IsEventDone( "get_toggle" ) and
         cmn.IsEventDone( "get_collect2_1_2" ) and
         cmn.IsEventDone( "get_pump" ) ) then

      ObjDelete( "gzz_abandonedfarm_tent" );

    end;

  end;

  cmn.AddSubscriber( "get_ironpiece", get_ironpiece_inv );
  cmn.AddSubscriber( "get_ironpiece", get_ironpiece_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_smallbattery_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_smallbattery_2" ] =
  {
    type = "get",
    get_obj = "spr_tent_smallbattery_2",
    room = private.room_objname,
    zz = "zz_tent",
    zz_gate = "gzz_abandonedfarm_tent"
  };
  -----------------------------------------------
  local get_smallbattery_2_inv = function ()

    int.InventoryItemAdd( "inv_smallbattery_1", "spr_tent_smallbattery_2", "assets/levels/level1/rm_bygrayscar/zz_trunk/inv/inv_smallbattery_morph" );
    level1_inv.CheckSmallbattery();

  end;

  local get_smallbattery_2_closezz = function ()

    ObjDelete( "gfx_tent_smallbattery_2" );
    ObjDelete( "spr_tent_smallbattery_2_shadow" );
    ObjDelete( "spr_abandonedfarm_button" );

    if ( cmn.IsEventDone( "get_ironpiece" ) and
         cmn.IsEventDone( "get_smallbattery_2" ) and
         cmn.IsEventDone( "get_triangularpart_2" ) and
         cmn.IsEventDone( "get_coaltongs" ) and
         cmn.IsEventDone( "get_toggle" ) and
         cmn.IsEventDone( "get_collect2_1_2" ) and
         cmn.IsEventDone( "get_pump" ) ) then

      ObjDelete( "gzz_abandonedfarm_tent" );

    end;

  end;

  cmn.AddSubscriber( "get_smallbattery_2", get_smallbattery_2_inv );
  cmn.AddSubscriber( "get_smallbattery_2", get_smallbattery_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_triangularpart_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_triangularpart_2" ] =
  {
    type = "get",
    get_obj = "spr_tent_triangularpart_2",
    room = private.room_objname,
    zz = "zz_tent",
    zz_gate = "gzz_abandonedfarm_tent"
  };
  -----------------------------------------------
  local get_triangularpart_2_inv = function ()

    int.InventoryItemAdd( "inv_triangularpart_1", "spr_tent_triangularpart_2", "assets/levels/level1/rm_abandonedfarm/zz_bicyclezone/inv/inv_triangularpart_morph" );
    level1_inv.CheckTriangularpart ();

  end;

  local get_triangularpart_2_closezz = function ()

    ObjDelete( "gfx_tent_triangularpart_2" );
    ObjDelete( "spr_tent_triangularpart_2_shadow" );
    ObjDelete( "spr_abandonedfarm_glass" );

    if ( cmn.IsEventDone( "get_ironpiece" ) and
         cmn.IsEventDone( "get_smallbattery_2" ) and
         cmn.IsEventDone( "get_triangularpart_2" ) and
         cmn.IsEventDone( "get_coaltongs" ) and
         cmn.IsEventDone( "get_toggle" ) and
         cmn.IsEventDone( "get_collect2_1_2" ) and
         cmn.IsEventDone( "get_pump" ) ) then

      ObjDelete( "gzz_abandonedfarm_tent" );

    end;

  end;

  cmn.AddSubscriber( "get_triangularpart_2", get_triangularpart_2_inv );
  cmn.AddSubscriber( "get_triangularpart_2", get_triangularpart_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coaltongs () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_coaltongs" ] =
  {
    type = "get",
    get_obj = "spr_tent_coaltongs",
    room = private.room_objname,
    zz = "zz_tent",
    zz_gate = "gzz_abandonedfarm_tent"
  };
  -----------------------------------------------
  local get_coaltongs_inv = function ()

    int.InventoryItemAdd( "inv_coaltongs", "spr_tent_coaltongs" );

  end;

  local get_coaltongs_closezz = function ()

    ObjDelete( "gfx_tent_coaltongs" );
    ObjDelete( "spr_tent_coaltongs_shadow" );
    ObjDelete( "spr_abandonedfarm_tongs" );
    
    if ( cmn.IsEventDone( "get_ironpiece" ) and
         cmn.IsEventDone( "get_smallbattery_2" ) and
         cmn.IsEventDone( "get_triangularpart_2" ) and
         cmn.IsEventDone( "get_coaltongs" ) and
         cmn.IsEventDone( "get_toggle" ) and
         cmn.IsEventDone( "get_collect2_1_2" ) and
         cmn.IsEventDone( "get_pump" ) ) then

      ObjDelete( "gzz_abandonedfarm_tent" );

    end;

  end;

  cmn.AddSubscriber( "get_coaltongs", get_coaltongs_inv );
  cmn.AddSubscriber( "get_coaltongs", get_coaltongs_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_toggle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_toggle" ] =
  {
    type = "get",
    get_obj = "spr_tent_toggle",
    room = private.room_objname,
    zz = "zz_tent",
    zz_gate = "gzz_abandonedfarm_tent"
  };
  -----------------------------------------------
  local get_toggle_inv = function ()

    int.InventoryItemAdd( "inv_toggle", "spr_tent_toggle" );

  end;

  local get_toggle_closezz = function ()

    ObjDelete( "gfx_tent_toggle" );
    ObjDelete( "spr_tent_toggle_shadow" );
    ObjDelete( "spr_abandonedfarm_tumbler" );

    if ( cmn.IsEventDone( "get_ironpiece" ) and
         cmn.IsEventDone( "get_smallbattery_2" ) and
         cmn.IsEventDone( "get_triangularpart_2" ) and
         cmn.IsEventDone( "get_coaltongs" ) and
         cmn.IsEventDone( "get_toggle" ) and
         cmn.IsEventDone( "get_collect2_1_2" ) and
         cmn.IsEventDone( "get_pump" ) ) then

      ObjDelete( "gzz_abandonedfarm_tent" );

    end;

  end;

  cmn.AddSubscriber( "get_toggle", get_toggle_inv );
  cmn.AddSubscriber( "get_toggle", get_toggle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pump () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pump" ] =
  {
    type = "get",
    get_obj = "spr_tent_pump",
    room = private.room_objname,
    zz = "zz_tent",
    zz_gate = "gzz_abandonedfarm_tent"
  };
  -----------------------------------------------
  local get_pump_inv = function ()

    int.InventoryItemAdd( "inv_pump", "spr_tent_pump" );

  end;

  local get_pump_closezz = function ()

    ObjDelete( "gfx_tent_pump" );
    ObjDelete( "spr_tent_pump_shadow" );
    ObjDelete( "spr_abandonedfarm_pump" );
    ObjDelete( "spr_tent_pump_shadow_over" );

    if ( cmn.IsEventDone( "get_ironpiece" ) and
         cmn.IsEventDone( "get_smallbattery_2" ) and
         cmn.IsEventDone( "get_triangularpart_2" ) and
         cmn.IsEventDone( "get_coaltongs" ) and
         cmn.IsEventDone( "get_toggle" ) and
         cmn.IsEventDone( "get_collect2_1_2" ) and
         cmn.IsEventDone( "get_pump" ) ) then

      ObjDelete( "gzz_abandonedfarm_tent" );

    end;

  end;

  cmn.AddSubscriber( "get_pump", get_pump_inv );
  cmn.AddSubscriber( "get_pump", get_pump_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_planks_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_planks_2" ] =
  {
    type = "get",
    get_obj = "spr_doorstothehouse_planks_2",
    room = private.room_objname,
    zz = "zz_doorstothehouse",
    zz_gate = "gzz_abandonedfarm_doorstothehouse"
  };
  -----------------------------------------------
  local get_planks_2_inv = function ()

    int.InventoryItemAdd( "inv_planks_2", "spr_doorstothehouse_planks_2", "assets/levels/level1/rm_abandonedfarm/zz_doorstothehouse/inv/inv_planks_morph" );
    level1_inv.CheckPlanks();

  end;

  local get_planks_2_closezz = function ()

    --ObjSet( "obj_doorstothehouse_use_lockpick", { input = true } );
    ObjDelete( "spr_abandonedfarm_planks" );

  end;

  cmn.AddSubscriber( "get_planks_2", get_planks_2_inv );
  cmn.AddSubscriber( "get_planks_2", get_planks_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_nails_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_nails_4" ] =
  {
    type = "get",
    get_obj = "spr_doorstothehouse_nails_4",
    room = private.room_objname,
    zz = "zz_doorstothehouse",
    zz_gate = "gzz_abandonedfarm_doorstothehouse"
  };
  -----------------------------------------------
  local get_nails_4_inv = function ()

  int.InventoryItemAdd( "inv_nails_4", "spr_doorstothehouse_nails_4", "assets/levels/level1/rm_abandonedfarm/zz_doorstothehouse/inv/inv_nails_morph" );
    level1_inv.CheckNails();

  end;

  local get_nails_4_closezz = function ()

  end;

  cmn.AddSubscriber( "get_nails_4", get_nails_4_inv );
  cmn.AddSubscriber( "get_nails_4", get_nails_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_feathers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_feathers" ] =
  {
    type = "get",
    get_obj = "spr_treehole_feathers",
    room = private.room_objname,
    zz = "zz_treehole",
    zz_gate = "gzz_abandonedfarm_treehole"
  };
  -----------------------------------------------
  local get_feathers_inv = function ()

    int.InventoryItemAdd( "inv_feathers", "spr_treehole_feathers" );

    if ( cmn.IsEventDone( "use_arrow" ) ) then

      ObjSet( "inv_bow_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_feathers_closezz = function ()

    ObjDelete( "gfx_treehole_feathers" );
    ObjDelete( "spr_treehole_feathers_shadow" );
    ObjDelete( "spr_abandonedfarm_feather" );

  if ( cmn.IsEventDone( "get_feathers" ) and
       cmn.IsEventDone( "get_bicyclekey" ) and
       cmn.IsEventDone( "get_nut" ) and
       cmn.IsEventDone( "get_coin_1" ) ) then

      ObjDelete( "gzz_abandonedfarm_treehole" );

    end;

  end;

  cmn.AddSubscriber( "get_feathers", get_feathers_inv );
  cmn.AddSubscriber( "get_feathers", get_feathers_closezz, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_nut () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_nut" ] =
  {
    type = "get",
    get_obj = "spr_treehole_win",
    room = private.room_objname,
    zz = "zz_treehole",
    zz_gate = "gzz_abandonedfarm_treehole"
  };
  -----------------------------------------------
  local get_nut_inv = function ()

    int.InventoryItemAdd( "inv_handfulofnuts", "spr_treehole_win" );

  end;

  local get_nut_closezz = function ()

    for i = 1, #private.mini_ho_array, 1 do

      ObjDelete( private.mini_ho_array[ i ] );

    end;

    ObjDelete( "spr_abandonedfarm_nuts" );

    if ( cmn.IsEventDone( "get_feathers" ) and
         cmn.IsEventDone( "get_bicyclekey" ) and
         cmn.IsEventDone( "get_nut" ) and
         cmn.IsEventDone( "get_coin_1" ) ) then

        ObjDelete( "gzz_abandonedfarm_treehole" );

    end;

  end;

  cmn.AddSubscriber( "get_nut", get_nut_inv );
  cmn.AddSubscriber( "get_nut", get_nut_closezz, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_bicyclekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bicyclekey" ] =
  {
    type = "get",
    get_obj = "spr_treehole_bicyclekey",
    room = private.room_objname,
    zz = "zz_treehole",
    zz_gate = "gzz_abandonedfarm_treehole"
  };
  -----------------------------------------------
  local get_bicyclekey_inv = function ()

    int.InventoryItemAdd( "inv_bicyclekey", "spr_treehole_bicyclekey" );

  end;

  local get_bicyclekey_closezz = function ()

    ObjDelete( "gfx_treehole_bicyclekey" );
    ObjDelete( "spr_treehole_bicyclekey_shadow" );
    ObjDelete( "spr_treehole_bicyclekey_over" );
    ObjDelete( "spr_abandonedfarm_key" );

  if ( cmn.IsEventDone( "get_feathers" ) and
       cmn.IsEventDone( "get_bicyclekey" ) and
       cmn.IsEventDone( "get_nut" ) and
       cmn.IsEventDone( "get_coin_1" ) ) then

      ObjDelete( "gzz_abandonedfarm_treehole" );

    end;

  end;

  cmn.AddSubscriber( "get_bicyclekey", get_bicyclekey_inv );
  cmn.AddSubscriber( "get_bicyclekey", get_bicyclekey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coin_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_coin_1" ] =
  {
    type = "get",
    get_obj = "spr_treehole_coin_1",
    room = private.room_objname,
    zz = "zz_treehole",
    zz_gate = "gzz_abandonedfarm_treehole"
  };
  -----------------------------------------------
  local get_coin_1_inv = function ()

    int.InventoryItemAdd( "inv_coin_1", "spr_treehole_coin_1", "assets/levels/level1/rm_abandonedfarm/zz_treehole/inv/inv_coin_morph" );
    level1_inv.CheckCoin ();

  end;

  local get_coin_1_closezz = function ()

    ObjDelete( "gfx_treehole_coin_1" );
    ObjDelete( "spr_treehole_coin_1_over" );
    ObjDelete( "spr_treehole_coin_1_shadow" );
    ObjDelete( "spr_abandonedfarm_coin" );

    ObjSet( "spr_treehole_feathers", { input = true } );
    ObjSet( "gfx_treehole_feathers", { active = true } );

    if ( cmn.IsEventDone( "get_feathers" ) and
         cmn.IsEventDone( "get_bicyclekey" ) and
         cmn.IsEventDone( "get_nut" ) and
         cmn.IsEventDone( "get_coin_1" ) ) then

        ObjDelete( "gzz_abandonedfarm_treehole" );

      end;

  end;

  cmn.AddSubscriber( "get_coin_1", get_coin_1_inv );
  cmn.AddSubscriber( "get_coin_1", get_coin_1_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_bicyclekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bicyclekey" ] =
  {
    type = "use",
    use_obj = "inv_bicyclekey",
    use_place = "obj_bicyclezone_use_bicyclekey",
    room = private.room_objname,
    zz = "zz_bicyclezone",
    zz_gate = "gzz_abandonedfarm_bicyclezone"
  };
  -----------------------------------------------
  local use_bicyclekey_inv = function ()

    int.InventoryItemRemove( "inv_bicyclekey" );

  end;
  local use_bicyclekey_beg = function ()

    ObjDelete( "obj_bicyclezone_use_bicyclekey" );

  end;
  local use_bicyclekey_end = function ()

    ObjSet( "obj_bicyclezone_clk_bicyclekey",      { input = true } );
    ObjSet( "spr_bicyclezone_bicyclekey_1_shadow", { pos_x = -74, pos_y = 96 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_bicyclekey", use_bicyclekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_bicyclekey", use_bicyclekey_inv );
  cmn.AddSubscriber( "use_bicyclekey", use_bicyclekey_end, private.room_objname );
  cmn.AddSubscriber( "use_bicyclekey_inv", use_bicyclekey_inv, private.room_objname );
  cmn.AddSubscriber( "use_bicyclekey_beg", use_bicyclekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_bicyclekey_end", use_bicyclekey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shard () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_shard" ] =
  {
    type = "use",
    use_obj = "inv_shard",
    use_place = "obj_tent_use_shard",
    room = private.room_objname,
    zz = "zz_tent",
    zz_gate = "gzz_abandonedfarm_tent"
  };
  -----------------------------------------------
  local use_shard_inv = function ()

    int.InventoryItemRemove( "inv_shard" );

  end;
  local use_shard_beg = function ()

    ObjDelete( "obj_tent_use_shard" );

  end;
  local use_shard_end = function ()

    ObjDelete( "anm_tent_click" );
    ObjSet( "obj_tent_open",      { input = true } );
    ObjSet( "gfx_tent_coaltongs", { active = true } );
  
    ObjDelete( "spr_abandonedfarm_tent_closed" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_shard", use_shard_beg, private.room_objname );
  cmn.AddSubscriber( "use_shard", use_shard_inv );
  cmn.AddSubscriber( "use_shard", use_shard_end, private.room_objname );
  cmn.AddSubscriber( "use_shard_inv", use_shard_inv, private.room_objname );
  cmn.AddSubscriber( "use_shard_beg", use_shard_beg, private.room_objname );
  cmn.AddSubscriber( "use_shard_end", use_shard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_awl_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_awl_1" ] =
  {
    type = "use",
    use_obj = "inv_awl",
    use_place = "obj_tent_use_awl",
    room = private.room_objname,
    zz = "zz_tent",
    zz_gate = "gzz_abandonedfarm_tent"
  };
  -----------------------------------------------
  local use_awl_1_inv = function ()

    if ( cmn.IsEventDone( "use_awl_2" ) ) and
       ( cmn.IsEventDone( "use_awl_3" ) ) then

      int.InventoryItemRemove( "inv_awl" );

    end;

  end;
  local use_awl_1_beg = function ()

    ObjDelete( "obj_tent_use_awl" );

  end;
  local use_awl_1_end = function ()

    ObjDelete( "spr_abandonedfarm_ice" );
    ObjDelete( "anm_tent_awl" );
    ObjDelete( "anm_tent_caseclick" );

    ObjSet( "obj_tent_fridge",            { input = true } );
    ObjSet( "gfx_tent_ironpiece",         { active = true } );
    ObjSet( "gfx_tent_toggle",            { active = true } );
    ObjSet( "spr_tent_ice_open",          { alp = 1 } );
    ObjSet( "spr_abandonedfarm_ice_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_awl_1", use_awl_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_awl_1", use_awl_1_inv );
  cmn.AddSubscriber( "use_awl_1", use_awl_1_end, private.room_objname );
  cmn.AddSubscriber( "use_awl_1_inv", use_awl_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_awl_1_beg", use_awl_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_awl_1_end", use_awl_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_insectspray () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_insectspray" ] =
  {
    type = "use",
    use_obj = "inv_insectspray",
    use_place = "obj_tent_use_insectspray",
    room = private.room_objname,
    zz = "zz_tent",
    zz_gate = "gzz_abandonedfarm_tent"
  };
  -----------------------------------------------
  local use_insectspray_inv = function ()

    int.InventoryItemRemove( "inv_insectspray" );

  end;
  local use_insectspray_beg = function ()

    ObjDelete( "obj_tent_use_insectspray" );

  end;
  local use_insectspray_end = function ()

    ObjDelete( "vid_tent_scorpio_static" );
    ObjDelete( "vid_tent_scorpio_click" );
    ObjDelete( "vid_tent_scorpio_spray" );
    ObjDelete( "spr_abandonedfarm_scorpion" );

    ObjSet( "obj_tent_clk_bag", { input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_insectspray", use_insectspray_beg, private.room_objname );
  cmn.AddSubscriber( "use_insectspray", use_insectspray_inv );
  cmn.AddSubscriber( "use_insectspray", use_insectspray_end, private.room_objname );
  cmn.AddSubscriber( "use_insectspray_inv", use_insectspray_inv, private.room_objname );
  cmn.AddSubscriber( "use_insectspray_beg", use_insectspray_beg, private.room_objname );
  cmn.AddSubscriber( "use_insectspray_end", use_insectspray_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_triangularpart_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_triangularpart_2" ] =
  {
    type = "use",
    use_obj = "inv_triangularpart_1",
    use_place = "obj_savingbox_use_triangularpart_2",
    room = private.room_objname,
    zz = "zz_savingbox",
    zz_gate = "gzz_abandonedfarm_savingbox"
  };
  -----------------------------------------------
  local use_triangularpart_2_inv = function ()

    int.InventoryItemRemove( "inv_triangularpart_1" );

  end;
  local use_triangularpart_2_beg = function ()

    ObjDelete( "obj_savingbox_use_triangularpart_2" );

  end;
  local use_triangularpart_2_end = function ()

    ObjDelete( "gzz_abandonedfarm_savingbox" );
    ObjSet( "gmg_abandonedfarm_onthelid", { active = true, input = true, alp = 1 } );
    ObjSet( "spr_abandonedfarm_box_open", { alp = 1 } );
    ObjSet( "spr_abandonedfarm_mg_onthelid", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_triangularpart_2", use_triangularpart_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_triangularpart_2", use_triangularpart_2_inv );
  cmn.AddSubscriber( "use_triangularpart_2", use_triangularpart_2_end, private.room_objname );
  cmn.AddSubscriber( "use_triangularpart_2_inv", use_triangularpart_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_triangularpart_2_beg", use_triangularpart_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_triangularpart_2_end", use_triangularpart_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hammer_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hammer_1" ] =
  {
    type = "use",
    use_obj = "inv_hammer",
    use_place = "obj_doorstothehouse_use_hammer",
    room = private.room_objname,
    zz = "zz_doorstothehouse",
    zz_gate = "gzz_abandonedfarm_doorstothehouse"
  };
  -----------------------------------------------
  local use_hammer_1_inv = function ()

  end;
  local use_hammer_1_beg = function ()

    ObjDelete( "obj_doorstothehouse_use_hammer" );

  end;
  local use_hammer_1_end = function ()

    ObjDelete( "anm_doorstothehouse_hammer" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_hammer_1", use_hammer_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer_1", use_hammer_1_inv );
  cmn.AddSubscriber( "use_hammer_1", use_hammer_1_end, private.room_objname );
  cmn.AddSubscriber( "use_hammer_1_inv", use_hammer_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_hammer_1_beg", use_hammer_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer_1_end", use_hammer_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lockpick_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lockpick_2" ] =
  {
    type = "use",
    use_obj = "inv_lockpick",
    use_place = "obj_doorstothehouse_use_lockpick",
    room = private.room_objname,
    zz = "zz_doorstothehouse",
    zz_gate = "gzz_abandonedfarm_doorstothehouse"
  };
  -----------------------------------------------
  local use_lockpick_2_inv = function ()

    if cmn.IsEventDone( "use_lockpick_1" ) then

      int.InventoryItemRemove( "inv_lockpick" );

    end;

  end;
  local use_lockpick_2_beg = function ()

    ObjDelete( "obj_doorstothehouse_use_lockpick" );

  end;
  local use_lockpick_2_end = function ()

    ObjDelete( "gzz_abandonedfarm_doorstothehouse" );
    ObjSet( "gho_abandonedfarm_farmhouse", { active = true, input = true, alp = 1 } );
    ObjSet( "spr_abandonedfarm_door_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_lockpick_2", use_lockpick_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockpick_2", use_lockpick_2_inv );
  cmn.AddSubscriber( "use_lockpick_2", use_lockpick_2_end, private.room_objname );
  cmn.AddSubscriber( "use_lockpick_2_inv", use_lockpick_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_lockpick_2_beg", use_lockpick_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockpick_2_end", use_lockpick_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_awl_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_awl_2" ] =
  {
    type = "use",
    use_obj = "inv_awl",
    use_place = "obj_treehole_use_awl",
    room = private.room_objname,
    zz = "zz_treehole",
    zz_gate = "gzz_abandonedfarm_treehole"
  };
  -----------------------------------------------
  local use_awl_2_inv = function ()

    if ( cmn.IsEventDone( "use_awl_1" ) ) and
       ( cmn.IsEventDone( "use_awl_3" ) ) then

      int.InventoryItemRemove( "inv_awl" );

    end;

  end;
  local use_awl_2_beg = function ()

    ObjDelete( "obj_treehole_use_awl" );

  end;
  local use_awl_2_end = function ()

    ObjSet( "spr_treehole_coin_1", { input = true } );
    ObjSet( "gfx_treehole_coin_1", { active = true } );   
    ObjDelete( "anm_treehole_awl" );
    ObjDelete( "spr_abandonedfarm_tree_up" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_awl_2", use_awl_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_awl_2", use_awl_2_inv );
  cmn.AddSubscriber( "use_awl_2", use_awl_2_end, private.room_objname );
  cmn.AddSubscriber( "use_awl_2_inv", use_awl_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_awl_2_beg", use_awl_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_awl_2_end", use_awl_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lantern () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lantern" ] =
  {
    type = "use",
    use_obj = "inv_lantern",
    use_place = "obj_treehole_use_lantern",
    room = private.room_objname,
    zz = "zz_treehole",
    zz_gate = "gzz_abandonedfarm_treehole"
  };
  -----------------------------------------------
  local use_lantern_inv = function ()

    int.InventoryItemRemove( "inv_lantern" );

  end;
  local use_lantern_beg = function ()

    ObjSet( "obj_treehole_lantern", { alp = 1 } );
    ObjDelete( "obj_treehole_use_lantern" );

  end;
  local use_lantern_end = function ()

    ObjSet( "spr_treehole_dark",       { pos_x = 0, pos_y = 0 } );
    ObjSet( "obj_treehole_lantern",    { alp = 1 } );
    ObjSet( "spr_treehole_bicyclekey", { input = true } );
    ObjSet( "gfx_treehole_bicyclekey", { active = true } );
    ObjSet( "spr_abandonedfarm_lamp",  { alp = 1 } );
    ObjDelete( "anm_treehole_bat" );

    for i = 1, 7 do

      ObjSet( "spr_treehole_nut_"..i, { input = true} );
      ObjSet( "gfx_treehole_nut_"..i, { active = true} );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_lantern", use_lantern_beg, private.room_objname );
  cmn.AddSubscriber( "use_lantern", use_lantern_inv );
  cmn.AddSubscriber( "use_lantern", use_lantern_end, private.room_objname );
  cmn.AddSubscriber( "use_lantern_inv", use_lantern_inv, private.room_objname );
  cmn.AddSubscriber( "use_lantern_beg", use_lantern_beg, private.room_objname );
  cmn.AddSubscriber( "use_lantern_end", use_lantern_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_planks_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_planks_4" ] =
  {
    type = "use",
    use_obj = "inv_planks_2",
    use_place = "obj_abandonedfarm_use_planks_4",
    room = private.room_objname,
  };
  -----------------------------------------------
  local use_planks_4_inv = function ()

    int.InventoryItemRemove( "inv_planks_2" );

  end;
  local use_planks_4_beg = function ()

    ObjDelete( "obj_abandonedfarm_use_planks_4" );

  end;
  local use_planks_4_end = function ()

    ObjSet( "obj_abandonedfarm_use_nails_8", { input = true } );
    ObjSet( "anm_abandonedfarm_planks_end",  { alp = 1 } );
    ObjDelete( "anm_abandonedfarm_planks" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_planks_4", use_planks_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_planks_4", use_planks_4_inv );
  cmn.AddSubscriber( "use_planks_4", use_planks_4_end, private.room_objname );
  cmn.AddSubscriber( "use_planks_4_inv", use_planks_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_planks_4_beg", use_planks_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_planks_4_end", use_planks_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_nails_8 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_nails_8" ] =
  {
    type = "use",
    use_obj = "inv_nails_4",
    use_place = "obj_abandonedfarm_use_nails_8",
    room = private.room_objname,
  };
  -----------------------------------------------
  local use_nails_8_inv = function ()

    int.InventoryItemRemove( "inv_nails_4" );

  end;
  local use_nails_8_beg = function ()

    ObjDelete( "obj_abandonedfarm_use_nails_8" );

  end;
  local use_nails_8_end = function ()

    ObjSet( "obj_abandonedfarm_use_hammer", { input = true } );
    ObjSet( "anm_abandonedfarm_hammer",     { alp = 1 } );
    ObjDelete( "anm_abandonedfarm_nails" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_nails_8", use_nails_8_beg, private.room_objname );
  cmn.AddSubscriber( "use_nails_8", use_nails_8_inv );
  cmn.AddSubscriber( "use_nails_8", use_nails_8_end, private.room_objname );
  cmn.AddSubscriber( "use_nails_8_inv", use_nails_8_inv, private.room_objname );
  cmn.AddSubscriber( "use_nails_8_beg", use_nails_8_beg, private.room_objname );
  cmn.AddSubscriber( "use_nails_8_end", use_nails_8_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hammer_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hammer_3" ] =
  {
    type = "use",
    use_obj = "inv_hammer",
    use_place = "obj_abandonedfarm_use_hammer",
    room = private.room_objname,
  };
  -----------------------------------------------
  local use_hammer_3_inv = function ()

    int.InventoryItemRemove( "inv_hammer" );

  end;
  local use_hammer_3_beg = function ()

    ObjDelete( "obj_abandonedfarm_use_hammer" );

  end;
  local use_hammer_3_end = function ()

    ObjSet( "gzz_abandonedfarm_treehole", { active = true, input = true, alp = 1 } );
    ObjSet( "anm_abandonedfarm_hammer_end", { alp = 1 } );
    ObjDelete( "anm_abandonedfarm_hammer" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_hammer_3", use_hammer_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer_3", use_hammer_3_inv );
  cmn.AddSubscriber( "use_hammer_3", use_hammer_3_end, private.room_objname );
  cmn.AddSubscriber( "use_hammer_3_inv", use_hammer_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_hammer_3_beg", use_hammer_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer_3_end", use_hammer_3_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_vid_bat () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_vid_bat" ] =
  {
    type = "click",
    clk_obj = "obj_savingbox_clk_vid_bat",
    room = private.room_objname,
    zz = "zz_savingbox",
    zz_gate = "gzz_abandonedfarm_savingbox"
  };
  -----------------------------------------------
  local clk_vid_bat = function ()

  end;
  local clk_vid_bat_beg = function ()

    ObjDelete( "obj_savingbox_clk_vid_bat" );

  end;
  local clk_vid_bat_end = function ()

    ObjDelete( "spr_savingbox_keys_shadow" );
    ObjDelete( "spr_abandonedfarm_keys" );
    ObjDelete( "vid_abandonedfarm_bat" );
    ObjSet( "obj_savingbox_use_triangularpart_2", { input = true } );
    ObjSet( "spr_abandonedfarm_key", { alp = 1 } );
  
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_vid_bat", clk_vid_bat );
  cmn.AddSubscriber( "clk_vid_bat", clk_vid_bat_beg, private.room_objname );
  cmn.AddSubscriber( "clk_vid_bat", clk_vid_bat_end, private.room_objname );
  cmn.AddSubscriber( "clk_vid_bat_beg", clk_vid_bat_beg, private.room_objname );
  cmn.AddSubscriber( "clk_vid_bat_end", clk_vid_bat_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_bicyclekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_bicyclekey" ] =
  {
    type = "click",
    clk_obj = "obj_bicyclezone_clk_bicyclekey",
    room = private.room_objname,
    zz = "zz_bicyclezone",
    zz_gate = "gzz_abandonedfarm_bicyclezone"
  };
  -----------------------------------------------
  local clk_bicyclekey = function ()

  end;
  local clk_bicyclekey_beg = function ()

    ObjDelete( "obj_bicyclezone_clk_bicyclekey" );

  end;
  local clk_bicyclekey_end = function ()

    ObjDelete( "obj_bicyclezone_lock" );
    ObjDelete( "spr_abandonedfarm_close" );
    ObjDelete( "spr_abandonedfarm_close_3" );
    ObjSet( "spr_bicyclezone_bicycle",   { input = true } );
    ObjSet( "spr_abandonedfarm_close_2", { alp = 1 } );
    ObjSet( "gfx_bicyclezone_bicycle",   { active = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_bicyclekey", clk_bicyclekey );
  cmn.AddSubscriber( "clk_bicyclekey", clk_bicyclekey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bicyclekey", clk_bicyclekey_end, private.room_objname );
  cmn.AddSubscriber( "clk_bicyclekey_beg", clk_bicyclekey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bicyclekey_end", clk_bicyclekey_end, private.room_objname );
  -----------------------------------------------
  -- function clk_bag_lvl1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_bag_lvl1" ] =
  {
    type = "click",
    clk_obj = "obj_tent_clk_bag",
    room = private.room_objname,
    zz = "zz_tent",
    zz_gate = "gzz_abandonedfarm_tent"
  };
  -----------------------------------------------
  local clk_bag_lvl1 = function ()

  end;
  local clk_bag_lvl1_beg = function ()

    ObjDelete( "obj_tent_clk_bag" );

  end;
  local clk_bag_lvl1_end = function ()

    ObjSet( "obj_tent_bag_open",       { alp = 1, input = true } );
    ObjSet( "gfx_tent_smallbattery_2", { active = true } );
    ObjSet( "gfx_tent_pump",           { active = true } );
    ObjSet( "spr_abandonedfarm_open",  { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_bag_lvl1", clk_bag_lvl1 );
  cmn.AddSubscriber( "clk_bag_lvl1", clk_bag_lvl1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bag_lvl1", clk_bag_lvl1_end, private.room_objname );
  cmn.AddSubscriber( "clk_bag_lvl1_beg", clk_bag_lvl1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bag_lvl1_end", clk_bag_lvl1_end, private.room_objname );
  -----------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_1_4 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_1_4 = function ()

    ObjDelete( "obj_abandonedfarm_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_1_4", get_morphobject_1_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_1_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_1_2 = function ()

    ObjDelete( "spr_tent_collect2_1_2" );
    ObjDelete( "spr_abandonedfarm_collect2_1_2" );

    if ( cmn.IsEventDone( "get_ironpiece" ) and
         cmn.IsEventDone( "get_smallbattery_2" ) and
         cmn.IsEventDone( "get_triangularpart_2" ) and
         cmn.IsEventDone( "get_coaltongs" ) and
         cmn.IsEventDone( "get_toggle" ) and
         cmn.IsEventDone( "get_collect2_1_2" ) and
         cmn.IsEventDone( "get_pump" ) ) then

      ObjDelete( "gzz_abandonedfarm_tent" );

    end;

  end;

  cmn.AddSubscriber( "get_collect2_1_2", get_collect2_1_2, private.room_objname );
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function private.get_bicycle ()

  cmn.SetEventDone( "get_bicycle" );
  cmn.CallEventHandler( "get_bicycle" );
  
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_take_bike" );

  if ( not cmn.IsEventDone( "get_triangularpart_1" ) ) then

    private.get_triangularpart_1();

  end;

  cmn.CloseSubRoom();

end;
-------------------------------------------------
function private.get_triangularpart_1 ()

  cmn.SetEventDone( "get_triangularpart_1" );
  cmn.CallEventHandler( "get_triangularpart_1" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_ironpiece ()

  cmn.SetEventDone( "get_ironpiece" );
  cmn.CallEventHandler( "get_ironpiece" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_ironpiece" ) and
       cmn.IsEventDone( "get_smallbattery_2" ) and
       cmn.IsEventDone( "get_triangularpart_2" ) and
       cmn.IsEventDone( "get_coaltongs" ) and
       cmn.IsEventDone( "get_toggle" ) and
       cmn.IsEventDone( "get_collect2_1_2" ) and
       cmn.IsEventDone( "get_pump" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_smallbattery_2 ()

  cmn.SetEventDone( "get_smallbattery_2" );
  cmn.CallEventHandler( "get_smallbattery_2" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_ironpiece" ) and
       cmn.IsEventDone( "get_smallbattery_2" ) and
       cmn.IsEventDone( "get_triangularpart_2" ) and
       cmn.IsEventDone( "get_coaltongs" ) and
       cmn.IsEventDone( "get_toggle" ) and
       cmn.IsEventDone( "get_collect2_1_2" ) and
       cmn.IsEventDone( "get_pump" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_triangularpart_2 ()

  cmn.SetEventDone( "get_triangularpart_2" );
  cmn.CallEventHandler( "get_triangularpart_2" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_ironpiece" ) and
       cmn.IsEventDone( "get_smallbattery_2" ) and
       cmn.IsEventDone( "get_triangularpart_2" ) and
       cmn.IsEventDone( "get_coaltongs" ) and
       cmn.IsEventDone( "get_toggle" ) and
       cmn.IsEventDone( "get_collect2_1_2" ) and
       cmn.IsEventDone( "get_pump" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_coaltongs ()

  cmn.SetEventDone( "get_coaltongs" );
  cmn.CallEventHandler( "get_coaltongs" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_ironpiece" ) and
       cmn.IsEventDone( "get_smallbattery_2" ) and
       cmn.IsEventDone( "get_triangularpart_2" ) and
       cmn.IsEventDone( "get_coaltongs" ) and
       cmn.IsEventDone( "get_toggle" ) and
       cmn.IsEventDone( "get_collect2_1_2" ) and
       cmn.IsEventDone( "get_pump" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_toggle ()

  cmn.SetEventDone( "get_toggle" );
  cmn.CallEventHandler( "get_toggle" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_ironpiece" ) and
       cmn.IsEventDone( "get_smallbattery_2" ) and
       cmn.IsEventDone( "get_triangularpart_2" ) and
       cmn.IsEventDone( "get_coaltongs" ) and
       cmn.IsEventDone( "get_toggle" ) and
       cmn.IsEventDone( "get_collect2_1_2" ) and
       cmn.IsEventDone( "get_pump" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_pump ()

  cmn.SetEventDone( "get_pump" );
  cmn.CallEventHandler( "get_pump" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_ironpiece" ) and
       cmn.IsEventDone( "get_smallbattery_2" ) and
       cmn.IsEventDone( "get_triangularpart_2" ) and
       cmn.IsEventDone( "get_coaltongs" ) and
       cmn.IsEventDone( "get_toggle" ) and
       cmn.IsEventDone( "get_collect2_1_2" ) and
       cmn.IsEventDone( "get_pump" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_planks_2 ()

  cmn.SetEventDone( "get_planks_2" );
  cmn.CallEventHandler( "get_planks_2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_nails_4 ()

  cmn.SetEventDone( "get_nails_4" );
  cmn.CallEventHandler( "get_nails_4" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_feathers ()

  cmn.SetEventDone( "get_feathers" );
  cmn.CallEventHandler( "get_feathers" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_feathers" ) and
       cmn.IsEventDone( "get_bicyclekey" ) and
       cmn.IsEventDone( "get_nut" ) and
       cmn.IsEventDone( "get_coin_1" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_bicyclekey ()

  cmn.SetEventDone( "get_bicyclekey" );
  cmn.CallEventHandler( "get_bicyclekey" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_feathers" ) and
       cmn.IsEventDone( "get_bicyclekey" ) and
       cmn.IsEventDone( "get_nut" ) and
       cmn.IsEventDone( "get_coin_1" ) ) then

    cmn.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function public.get_nut ()

  if ( cmn.IsEventDone( "get_feathers" ) and
       cmn.IsEventDone( "get_bicyclekey" ) and
       cmn.IsEventDone( "get_nut" ) and
       cmn.IsEventDone( "get_coin_1" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_coin_1 ()

  cmn.SetEventDone( "get_coin_1" );
  cmn.CallEventHandler( "get_coin_1" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_feathers" ) and
       cmn.IsEventDone( "get_bicyclekey" ) and
       cmn.IsEventDone( "get_nut" ) and
       cmn.IsEventDone( "get_coin_1" ) ) then

    cmn.CloseSubRoom();

  end;

end;
---------------------------------------------------------------------------------
function private.get_collect2_1_2()

  int.AddCollectibles2( "spr_tent_collect2_1_2" );

  local func_end = function ()

    if ( cmn.IsEventDone( "get_ironpiece" ) and
         cmn.IsEventDone( "get_smallbattery_2" ) and
         cmn.IsEventDone( "get_triangularpart_2" ) and
         cmn.IsEventDone( "get_coaltongs" ) and
         cmn.IsEventDone( "get_toggle" ) and
         cmn.IsEventDone( "get_collect2_1_2" ) and
         cmn.IsEventDone( "get_pump" ) ) then

      cmn.CloseSubRoom();

    end;

  end;

  ObjAnimate( "rm_abandonedfarm", "alp", 0, 0, func_end,
  { 
    0.0, 0, 1.0, 
    0.7, 0, 1.0
  } );

end;
--*********************************************************************************************************************
function public.use_bicyclekey ()

  local item = "inv_bicyclekey";

  if ( cmn.ApplyObj( item, "gzz_abandonedfarm_bicyclezone", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bicyclezone" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bicyclezone_use_bicyclekey", true ) ) then

    cmn.CallEventHandler( "use_bicyclekey_inv" );
    cmn.CallEventHandler( "use_bicyclekey_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_bicyclekey" );
      cmn.CallEventHandler( "use_bicyclekey_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_bike_lock_insert" ); 
    ObjAnimate( "spr_bicyclezone_bicyclekey_1_shadow", "pos_xy", 0, 0, func_end,
    { 
      0.0, 2, 298, 282, 
      0.7, 2, -74,  96,
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
function public.use_shard ()

  local item = "inv_shard";

  if ( cmn.ApplyObj( item, "gzz_abandonedfarm_tent", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tent" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_tent_use_shard", true ) ) then

    cmn.CallEventHandler( "use_shard_inv" );
    cmn.CallEventHandler( "use_shard_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_shard" );
      cmn.CallEventHandler( "use_shard_end" );
      int.Lock( false );

    end;

--  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_shard" );  

    ObjSet( "anm_tent_shard", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_cut_rope" );
    AnimPlay( "anm_tent_shard", "DoAnim",
    function ()

      ObjAnimate( "anm_tent_click", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );

    end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
function public.use_awl_1 ()

  local item = "inv_awl";

  if ( cmn.ApplyObj( item, "gzz_abandonedfarm_tent", false ) ) and
     ( not cmn.IsEventDone( "use_awl_1" ) ) and
     ( cmn.IsEventDone( "use_shard" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tent" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_tent_use_awl", true ) ) and
         ( not cmn.IsEventDone( "use_awl_1" ) ) and
         ( cmn.IsEventDone( "use_shard" ) ) then

    cmn.CallEventHandler( "use_awl_1_inv" );
    cmn.CallEventHandler( "use_awl_1_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_awl_1" );
      cmn.CallEventHandler( "use_awl_1_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_awl_to_case_app" );

    ObjSet( "anm_tent_awl", { alp = 1 } );
    ObjSet( "anm_tent_caseclick", { alp = 0 } );
    AnimPlay( "anm_tent_awl", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
function public.use_insectspray ()

  local item = "inv_insectspray";

  if ( cmn.ApplyObj( item, "gzz_abandonedfarm_tent", false ) ) and
     ( cmn.IsEventDone( "use_shard" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tent" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_tent_use_insectspray", true ) ) and
         ( cmn.IsEventDone( "use_shard" ) ) then

    cmn.CallEventHandler( "use_insectspray_inv" );
    cmn.CallEventHandler( "use_insectspray_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_insectspray" );
      cmn.CallEventHandler( "use_insectspray_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_scorpio_die_fast" );  
    ObjSet( "vid_tent_scorpio_static", { alp = 0 } );
    ObjSet( "vid_tent_scorpio_spray", { alp = 1 } );
    VidPlay( "vid_tent_scorpio_spray", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
function public.use_triangularpart_2 ()

  local item = "inv_triangularpart_1";

  if ( cmn.ApplyObj( item, "gzz_abandonedfarm_savingbox", false ) ) and
     ( cmn.IsEventDone( "get_triangularpart_1" ) ) and
     ( cmn.IsEventDone( "get_triangularpart_2" ) ) and
     ( cmn.IsEventDone( "clk_vid_bat" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_savingbox" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_savingbox_use_triangularpart_2", true ) ) and
         ( cmn.IsEventDone( "get_triangularpart_1" ) ) and
         ( cmn.IsEventDone( "get_triangularpart_2" ) ) and
         ( cmn.IsEventDone( "clk_vid_bat" ) ) then

    cmn.CallEventHandler( "use_triangularpart_2_inv" );
    cmn.CallEventHandler( "use_triangularpart_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_triangularpart_2" );
      cmn.CallEventHandler( "use_triangularpart_2_end" );
      int.Lock( false );
      cmn.CloseSubRoom();
      cmn.GotoRoom( "mg_onthelid" );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_boxground_insert" );
    ObjAnimate( "anm_savingbox_open", "alp", 0, 0,
    function ()

      AnimPlay( "anm_savingbox_open", "DoAnim", func_end );

    end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "spr_savingbox_cup", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 1.0, 
      0.3, 0, 0.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
function public.use_hammer_1 ()

  local item = "inv_hammer";

  if ( cmn.ApplyObj( item, "gzz_abandonedfarm_doorstothehouse", false ) ) and
     ( not cmn.IsEventDone( "use_hammer_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_doorstothehouse" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_doorstothehouse_use_hammer", true ) ) and
         ( not cmn.IsEventDone( "use_hammer_1" ) ) then

    cmn.CallEventHandler( "use_hammer_1_inv" );
    cmn.CallEventHandler( "use_hammer_1_beg" );
    int.Lock( true );

    local func_end = function ()

      ObjSet( "obj_doorstothehouse_lock", { alp = 1 } );

      cmn.SetEventDone( "use_hammer_1" );
      cmn.CallEventHandler( "use_hammer_1_end" );
      int.Lock( false );

      private.get_planks_2();
      private.get_nails_4();

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_hammer_door_app" );

    ObjSet( "obj_doorstothehouse_lock", { alp = 0 } );
    AnimPlay( "anm_doorstothehouse_hammer", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
function public.use_lockpick_2 ()

  local item = "inv_lockpick";

  if ( cmn.ApplyObj( item, "gzz_abandonedfarm_doorstothehouse", false ) ) and
     ( cmn.IsEventDone( "get_planks_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_doorstothehouse" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_doorstothehouse_use_lockpick", true ) ) and
         ( cmn.IsEventDone( "get_planks_2" ) ) then

    cmn.CallEventHandler( "use_lockpick_2_inv" );
    cmn.CallEventHandler( "use_lockpick_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_lockpick_2" );
      cmn.CallEventHandler( "use_lockpick_2_end" );
      int.Lock( false );

      cmn.CloseSubRoom();

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_open_padlock" );

    ObjSet( "spr_doorstothehouse_lock",     { alp = 0 } );
    ObjSet( "anm_doorstothehouse_lockpick", { alp = 1 } );
    AnimPlay( "anm_doorstothehouse_lockpick", "DoAnim", func_end );

    ObjAnimate( "spr_doorstothehouse_lock_over", "alp", 0, 0, "", 
    {
      0.0, 3, 1.0,
      2.8, 3, 1.0,
      2.8, 3, 0.0,
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
function public.use_awl_2 ()

  local item = "inv_awl";

  if ( cmn.ApplyObj( item, "gzz_abandonedfarm_treehole", false ) ) and
     ( not cmn.IsEventDone( "use_awl_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_treehole" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_treehole_use_awl", true ) ) and
         ( not cmn.IsEventDone( "use_awl_2" ) ) then

    cmn.CallEventHandler( "use_awl_2_inv" );
    cmn.CallEventHandler( "use_awl_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_awl_2" );
      cmn.CallEventHandler( "use_awl_2_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_awl_to_tree_app" ); 
    AnimPlay( "anm_treehole_awl", "DoAnim", func_end ) 

    return true;

  end;

  return false;

end;
-------------------------------------------------
function public.use_lantern ()

  local item = "inv_lantern";

  if ( cmn.ApplyObj( item, "gzz_abandonedfarm_treehole", false ) ) and
     ( cmn.IsEventDone( "use_hammer_3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_treehole" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_treehole_use_lantern", true ) )and
         ( cmn.IsEventDone( "use_hammer_3" ) ) then

    cmn.CallEventHandler( "use_lantern_inv" );
    cmn.CallEventHandler( "use_lantern_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_lantern" );
      cmn.CallEventHandler( "use_lantern_end" );
      int.Lock( false );

      int_button_mini_ho.Show( "get_nut", "treehole", 7, "spr_treehole_nut_panel", private.mini_ho_array ); 

      private.BackAnim();

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_light_on" ); 
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_bat_away" ); 

    ObjAnimate( "spr_treehole_dark", "pos_xy", 0, 0, "",
    { 
      0.0, 0, 395, 235,
      0.3, 0,   0,   0
    } );
    ObjAnimate( "obj_treehole_lantern", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    AnimPlay( "anm_treehole_bat", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
function public.use_planks_4 ()

  local item = "inv_planks_2";

  if ( cmn.ApplyObj( item, "obj_abandonedfarm_use_planks_4", true ) ) and
     ( cmn.IsEventDone( "get_planks_2" ) ) and
     ( cmn.IsEventDone( "get_planks_4" ) ) then

    cmn.CallEventHandler( "use_planks_4_inv" );
    cmn.CallEventHandler( "use_planks_4_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_planks_4" );
      cmn.CallEventHandler( "use_planks_4_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_make_ladder" );

    AnimPlay( "anm_abandonedfarm_planks", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
function public.use_nails_8 ()

  local item = "inv_nails_4";

  if ( cmn.ApplyObj( item, "obj_abandonedfarm_use_nails_8", true ) and 
       cmn.IsEventDone( "use_planks_4" ) ) then

    cmn.CallEventHandler( "use_nails_8_inv" );
    cmn.CallEventHandler( "use_nails_8_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_nails_8" );
      cmn.CallEventHandler( "use_nails_8_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_nails_app" );
    AnimPlay( "anm_abandonedfarm_nails", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
function public.use_hammer_3 ()

  local item = "inv_hammer";

  if ( cmn.ApplyObj( item, "obj_abandonedfarm_use_hammer", true ) and 
       cmn.IsEventDone( "use_nails_8" ) and 
       not cmn.IsEventDone( "use_hammer_3" ) ) then

    cmn.CallEventHandler( "use_hammer_3_inv" );
    cmn.CallEventHandler( "use_hammer_3_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_hammer_3" );
      cmn.CallEventHandler( "use_hammer_3_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_hammer_ladder_app" );
    
    AnimPlay( "anm_abandonedfarm_hammer", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
function private.clk_vid_bat ()

  cmn.CallEventHandler( "clk_vid_bat_beg" );

  cmn.CloseSubRoom();

end;
-------------------------------------------------
function private.clk_bicyclekey ()

  local func_end = function ()

    cmn.SetEventDone( "clk_bicyclekey" );
    cmn.CallEventHandler( "clk_bicyclekey_end" );
    cmn.CallEventHandler( "clk_bicyclekey" );
    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_bicyclekey_beg" );

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_bike_lock_open" );

  ObjAnimate( "spr_bicyclezone_bicyclekey_1_shadow", "alp", 0, 0, "", 
  {
    0.0, 3, 1.0,
    0.3, 3, 0.0,
  } );

  ObjAnimate( "spr_bicyclezone_bicyclekey_2", "alp", 0, 0, "", 
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

  ObjAnimate( "obj_bicyclezone_lock_2", "pos_xy", 0, 0, "", 
  {
    0.0, 3,   0,  0,
    0.5, 3,   0,  0,
    1.0, 3, -30, 20,
  } );

  ObjAnimate( "obj_bicyclezone_lock", "alp", 0, 0, func_end, 
  {
    0.0, 3, 1,
    1.2, 3, 1,
    1.5, 3, 0,
  } );

end;
-------------------------------------------------
function private.clk_bag_lvl1 ()

  local func_end = function ()

    cmn.SetEventDone( "clk_bag_lvl1" );
    cmn.CallEventHandler( "clk_bag_lvl1_end" );
    cmn.CallEventHandler( "clk_bag_lvl1" );
    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_bag_lvl1_beg" );

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_open_textile_bag" );

  ObjAnimate( "obj_tent_bag_open", "alp", 0, 0, func_end, 
  {
    0.0, 3, 0,
    0.3, 3, 1,
  } );

end;
--*********************************************************************************************************************
function private.opn_abandonedfarm ()

  if not ( cmn.IsEventDone( "opn_abandonedfarm" ) ) then

    cmn.SetEventDone( "opn_abandonedfarm" );
    --cmn.ShowBbt( "bbt_abandonedfarm_open" );
    --ng_global.progress[ "std" ][ "opn_bygrayscar" ].wheel_open = 0;
    --ng_global.progress[ "std" ][ "opn_bygrayscar" ].inthecar = false;
    --cmn.PlayAudio( "mus", "audio/aud_moov_mus" );

    int.Lock( true );

    ObjAnimate( "rm_abandonedfarm", "scale_xy", 0, 0,
    function ()

      int.Lock( false );

    end, 
    {
      0.0, 3, 1.0, 1.0,
      0.3, 3, 1.0, 1.0,
      1.0, 3, 1.5, 1.5,
      2.5, 3, 1.5, 1.5,
      3.2, 3, 1.0, 1.0,
    } );

    ObjAnimate( "rm_abandonedfarm", "pos_xy", 0, 0, "", 
    {
      0.0, 3,  0,    0,
      0.3, 3,  0,    0,
      1.0, 3, 50, -230,
      2.5, 3, 50, -230,
      3.2, 3,  0,    0,
    } );

    ObjAnimate( "rm_abandonedfarm", "pos_z", 0, 0,
    function ()

      cmn.ShowBbt( "bbt_abandonedfarm_bike" );

    end, 
    {
      0.0, 3, 55,
      1.3, 3, 55,
    } );

  end;

end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopAllEnv( "audio/level1/env/aud_abandonedfarm_env", true );
  cmn.PlayAudio( "env", "audio/level1/env/aud_abandonedfarm_env", 1 );

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_abandonedfarm();

  private.BicyclezoneBag();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_bicycle",                { "clk_bicyclekey" } ); 
  int.AddedTaskMap( private.room_objname, "get_triangularpart_1",       { "opn_abandonedfarm" } ); 
  int.AddedTaskMap( private.room_objname, "get_ironpiece",              { "use_awl_1" } ); 
  int.AddedTaskMap( private.room_objname, "get_smallbattery_2",         { "clk_bag_lvl1" } ); 
  int.AddedTaskMap( private.room_objname, "get_triangularpart_2",       { "opn_abandonedfarm" } ); 
  int.AddedTaskMap( private.room_objname, "get_coaltongs",              { "use_shard" } ); 
  int.AddedTaskMap( private.room_objname, "get_toggle",                 { "use_awl_1" } ); 
  int.AddedTaskMap( private.room_objname, "get_pump",                   { "clk_bag_lvl1" } ); 
  int.AddedTaskMap( private.room_objname, "get_planks_2",               { "use_hammer_1" } ); 
  int.AddedTaskMap( private.room_objname, "get_nails_4",                { "use_hammer_1" } ); 
  int.AddedTaskMap( private.room_objname, "get_feathers",               { "get_coin_1" } ); 
  int.AddedTaskMap( private.room_objname, "get_nut",                    { "use_lantern" } ); 
  int.AddedTaskMap( private.room_objname, "get_bicyclekey",             { "use_lantern" } ); 
  int.AddedTaskMap( private.room_objname, "get_coin_1",                 { "use_awl_2" } );
 
  int.AddedTaskMap( private.room_objname, "use_bicyclekey",             { "get_bicyclekey" } ); 
  int.AddedTaskMap( private.room_objname, "use_shard",                  { "get_shard" } ); 
  int.AddedTaskMap( private.room_objname, "use_awl_1",                  { "get_awl", "use_shard" } ); 
  int.AddedTaskMap( private.room_objname, "use_insectspray",            { "get_insectspray", "use_shard" } ); 
  int.AddedTaskMap( private.room_objname, "use_triangularpart_2",       { "get_triangularpart_1", "get_triangularpart_2" } ); 
  int.AddedTaskMap( private.room_objname, "use_hammer_1",               { "get_hammer" } ); 
  int.AddedTaskMap( private.room_objname, "use_lockpick_2",             { "get_lockpick" } ); 
  int.AddedTaskMap( private.room_objname, "use_awl_2",                  { "get_awl", "use_lantern" } ); 
  int.AddedTaskMap( private.room_objname, "use_lantern",                { "get_lantern", "use_hammer_3" } ); 
  int.AddedTaskMap( private.room_objname, "use_planks_4",               { "get_planks_2", "get_planks_4" } ); 
  int.AddedTaskMap( private.room_objname, "use_nails_8",                { "get_nails_4", "get_nails_8", "use_planks_4" } ); 
  int.AddedTaskMap( private.room_objname, "use_hammer_3",               { "use_nails_8" } );
 
  int.AddedTaskMap( private.room_objname, "clk_vid_bat",                { "opn_abandonedfarm" } ); 
  int.AddedTaskMap( private.room_objname, "clk_bicyclekey",             { "use_bicyclekey" } ); 
  int.AddedTaskMap( private.room_objname, "clk_bag_lvl1",               { "use_insectspray" } );
  
  int.AddedTaskMap( private.room_objname, "win_farmhouse",              { "use_lockpick_2" } ); 

end;
--*********************************************************************************************************************
function private.InitSubroom ()

    private.mini_ho_array = { 
                                "spr_treehole_nut_1", 
                                "spr_treehole_nut_2", 
                                "spr_treehole_nut_3", 
                                "spr_treehole_nut_4", 
                                "spr_treehole_nut_5", 
                                "spr_treehole_nut_6",                 
                                "spr_treehole_nut_7" 
                            };
    for i = 1, #private.mini_ho_array do

      ObjSet( private.mini_ho_array[ i ], { event_mdown = function() 
        int_button_mini_ho.MiniHoTaskFind( "get_nut", "treehole", private.mini_ho_array[ i ], 7, "" ); 
      end; } );

    end;

  subroom.Define( "zz_treehole" );

  -------------------------------------------------
  function zz_treehole.PreOpen()

    if cmn.IsEventDone( "use_lantern" ) then
      private.BackAnim();
    end;

  end;
  -------------------------------------------------
  function zz_treehole.Open()

    if ( cmn.IsEventDone( "use_lantern" ) and not cmn.IsEventDone( "get_nut" ) ) then 

        int_button_mini_ho.Show( "get_nut", "treehole", 7, "spr_treehole_nut_panel", private.mini_ho_array ); 

    end;
  
  end;
  -------------------------------------------------
  -------------------------------------------------
  function zz_treehole.PreClose()

    if ( cmn.IsEventDone( "use_lantern" ) and not cmn.IsEventDone( "get_nut" ) ) then 

      int_button_mini_ho.Hide(); 
      int_button_mini_ho.UpdateLocation( "get_nut", "" );

    end;

  end;


  subroom.Define( "zz_savingbox" );

  -------------------------------------------------
  function zz_savingbox.Close()

    if ( not ObjGet( "obj_savingbox_clk_vid_bat" ) ) and ( not cmn.IsEventDone( "clk_vid_bat" ) ) then

      local func_end = function ()

        cmn.SetEventDone( "clk_vid_bat" );
        cmn.CallEventHandler( "clk_vid_bat_end" );
        cmn.CallEventHandler( "clk_vid_bat" );
        int.Lock( false );
        cmn.ShowBbt( "bbt_savingbox_after_bat" );
        cmn.GotoSubRoom( "zz_savingbox", { 450, 540 }, { 512, 384 } )

      end;

      int.Lock( true );
      
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_bat_get_keys" );
      VidPlay( "vid_abandonedfarm_bat", func_end );
      ObjAnimate( "spr_abandonedfarm_keys", "alp", 0, 0, "", 
      {
        0.0, 0, 1,
        1.5, 0, 1,
        1.5, 0, 0
      } );


    end;

  end;

end;
--*********************************************************************************************************************
function private.SavingboxCupClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_savingbox_use_triangularpart_2" );

  end;


  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_boxground_touch" );
  ObjAnimate( "spr_savingbox_cup", "pos_y", 0, 0, func_end, 
  {
    0.0, 3, -57,
    0.2, 3, -59,
    0.4, 3, -57,
    0.6, 3, -59,
    0.8, 3, -57
  } );

end;
--*********************************************************************************************************************
function private.DoorstothehouseClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_doorstothehouse_use_hammer" );

  end;


  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_wood_touch" );
  ObjAnimate( "anm_doorstothehouse_hammer", "pos_y", 0, 0, func_end, 
  {
    0.0, 3, -250,
    0.2, 3, -252,
    0.4, 3, -250,
    0.6, 3, -252,
    0.8, 3, -250
  } );

end;
--*********************************************************************************************************************
function private.BicyclezoneClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_bicyclezone_use_bicyclekey" );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_bikelock_touch" );
  ObjAnimate( "spr_bicyclezone_lock_1", "pos_xy", 0, 0, func_end, 
  {
    0.0, 3, -12, 34,
    0.2, 3, -18, 40,
    0.4, 3, -12, 34,
    0.6, 3, -18, 40,
    0.8, 3, -12, 34,
  } );

  ObjAnimate( "obj_bicyclezone_lock_2", "pos_xy", 0, 0, "", 
  {
    0.0, 3,  0, 0,
    0.2, 3, -6, 6,
    0.4, 3,  0, 0,
    0.6, 3, -6, 6,
    0.8, 3,  0, 0,
  } );

end;
--*********************************************************************************************************************
function private.Anims ()

  ObjAnimate( "spr_savingbox_light", "alp", 1, 0, "", 
  {
    0.0, 0, 0.3,
    0.7, 0, 1.0,
    1.4, 0, 0.2,
    1.9, 0, 0.8,
    2.4, 0, 0.3,
  } );

  ObjAnimate( "spr_bicyclezone_light", "alp", 1, 0, "", 
  {
    0.0, 0, 0.3,
    0.7, 0, 1.0,
    1.4, 0, 0.2,
    1.9, 0, 0.8,
    2.4, 0, 0.3,
  } );

  ObjAnimate( "spr_bicyclezone_bicycle_shadow", "alp", 1, 0, "", 
  {
    0.0, 0, 0.7,
    0.7, 0, 1.0,
    1.4, 0, 0.6,
    1.9, 0, 0.9,
    2.4, 0, 0.7,
  } );

  ObjAnimate( "spr_bicyclezone_bicyclekey_1_trinket", "ang", 1, 0, "", 
  {
    0.0, 3, -0.1,
    0.7, 3,  0.1,
    1.4, 3, -0.1,
  } );

  ObjAnimate( "spr_bicyclezone_bicyclekey_2_trinket", "ang", 1, 0, "", 
  {
    0.0, 3, -0.1,
    0.7, 3,  0.1,
    1.4, 3, -0.1,
  } );

  ObjAnimate( "spr_doorstothehouse_light", "alp", 1, 0, "", 
  {
    0.0, 0, 0.3,
    0.7, 0, 1.0,
    1.4, 0, 0.2,
    1.9, 0, 0.8,
    2.4, 0, 0.3,
  } );

  ObjAnimate( "spr_savingbox_keys_trinket", "ang", 1, 0, "", 
  {
    0.0, 3, -0.05,
    1.7, 3,  0.05,
    3.4, 3, -0.05,
  } );

  ObjAnimate( "spr_savingbox_keys_trinket_shadow", "ang", 1, 0, "", 
  {
    0.0, 3, -0.05,
    1.7, 3,  0.05,
    3.4, 3, -0.05,
  } );

  ObjAnimate( "spr_abandonedfarm_people", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.7,
    2.0, 0, 1,
  } );

  private.TreeholeFoliageAnim(); 

end;
--*****************************************************************************************
function private.TreeholeFoliageAnim ()

  ObjAnimate("spr_treehole_foliage_3", "ang", 1, 0, "", 
  {
    0.0,0, 0.03,
    2.5,3,-0.03,
    5.0,3, 0.03
  });
  ObjAnimate("spr_treehole_foliage_4", "ang", 1, 0, "", 
  {
    0.0,0, 0.03,
    2.2,3,-0.03,
    4.4,3, 0.03
  });
  ObjAnimate("spr_treehole_foliage_5", "ang", 1, 0, "", 
  {
    0.0,0,-0.03,
    3.0,3, 0.03,
    6.0,3,-0.03
  });

end;
--*****************************************************************************************
function private.DoorstothehouseLockClick ()

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_lock_touch" );
  ObjAnimate( "spr_doorstothehouse_lock", "ang", 0, 0,
  function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_doorstothehouse_use_lockpick" );

  end,
  {
    0.0,0, 0.00,
    0.2,3,-0.02,
    0.4,3, 0.02,
    0.6,3, 0.00
  } );

end;
--*****************************************************************************************
function private.TentClick ()

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_tent_touch" );
  AnimPlay( "anm_tent_click", "DoAnim",
  function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_tent_use_shard" );

  end );

end;
--*****************************************************************************************
function private.ScorpioClick ()

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_scorpio_click" );
  ObjSet( "vid_tent_scorpio_static", { alp = 0 } );
  ObjSet( "vid_tent_scorpio_click", { alp = 1 } );
  VidPlay( "vid_tent_scorpio_click",
  function ()

    int.Lock( false );
    ObjSet( "vid_tent_scorpio_static", { alp = 1 } );
    ObjSet( "vid_tent_scorpio_click", { alp = 0 } );
    cmn.ShowBbt( "bbt_tent_use_insectspray" );

  end );

end;
--*****************************************************************************************
function private.TreeholeClick ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_treehole_use_awl" );

  end;

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_clk_awl" );

  ObjAnimate( "spr_treehole_feathers", "pos_xy", 0, 0, func_end, 
  { 
    0.0,0,-164,-41,
    0.2,3,-160,-46,
    0.4,3,-164,-41,
    0.6,3,-160,-46,
    0.8,3,-164,-41
  });

  ObjAnimate( "spr_treehole_feathers", "ang", 0, 0, "", 
  {
    0.0,0,0,
    0.4,3,-0.05,
    0.8,3,0
  });

end;
--*****************************************************************************************
function private.BackAnim ()

  local func_end = function () private.BackAnim(); end;
  local room = common.GetCurrentSubRoom();
  if (room == "zz_treehole") then
    ObjSet( "trm_treehole_anim", { endtrig = func_end, time = 1/30, playing = 1 } );
    private.coin_delay = private.coin_delay + 1;
  else
    ObjSet( "trm_treehole_anim", { endtrig = "", time = 1/30, playing = 1 } );
  end;

  local res = common.AnimForCur( private.anim_obj, private.x, private.y );

  private.x = res[1];
  private.y = res[2];

  local xy = GetZoomCursorPos();

  local set_x = xy[1] - 512;
  local set_y = xy[2] - 384;
  ObjSet( "spr_treehole_dark", { pos_x = set_x, pos_y = set_y } ); 

  if ( (set_x > -234 and set_x < -194) and 
       (set_y > -41 and set_y < -1) ) then 

    if (ObjGet("spr_treehole_coin_1_shine").alp == 0) and ( private.coin_delay > 150 ) then
      ObjAnimate("spr_treehole_coin_1_shine", "alp", 0, 0, "", 
      {
        0.0,0,0,
        0.3,1,1,
        0.6,2,0,
        10.0,0,0        
      });
      private.coin_delay = 0;
    end;
  
  else

    ObjStopAnimate( "spr_treehole_coin_1_shine", " alp" );
    ObjSet( "spr_treehole_coin_1_shine", { alp = 0 } );

  end;

end;
--*****************************************************************************************
function private.BicyclezoneBag ()

  ObjSet( "obj_bicyclezone_bag", { input = true } );
  ObjSet( "anm_bicyclezone_bag", { frame = 0 } );
  AnimStop( "anm_bicyclezone_bag" );

  ObjAnimate( "obj_bicyclezone_bag", "pos_xy", 0, 0, "", 
  {
     0, 0, -166,  -10,
    30, 0, -115, -274,
  } );

end;
--*****************************************************************************************
function private.BicyclezoneBagClick ()

  ObjSet( "obj_bicyclezone_bag", { input = false } );

  ObjStopAnimate( "obj_bicyclezone_bag", "pos_xy" );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_insect_away" );
  AnimPlay( "anm_bicyclezone_bag", "DoAnim", "" );

end;
--*****************************************************************************************
function private.FridgeClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_tent_use_awl" );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_case_clk" );
  AnimPlay( "anm_tent_caseclick", "DoAnim", func_end);

end;
--*********************************************************************************************************************
--*********************************************************************************************************************