-- name=rm_bygrayscar
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_bygrayscar";

  ObjAttach( "zz_inthecar", "room_hub" );
  ObjAttach( "zz_trunk", "room_hub" );
  ObjAttach( "zz_path", "room_hub" );
  ObjAttach( "zz_pointer", "room_hub" );
  ObjAttach( "zz_wheels", "room_hub" );

  ObjSet( "obj_trunk_use_carkeys",           { event_mdown = private.clk_car } );  
  ObjSet( "obj_wheels_clk_jack",             { event_mdown = private.clk_jack } );  
  ObjSet( "spr_inthecar_folder",             { event_mdown = private.get_folder } );
  ObjSet( "spr_inthecar_rope",               { event_mdown = private.get_rope } );
  ObjSet( "spr_inthecar_areamap",            { event_mdown = private.get_areamap } );
  ObjSet( "spr_inthecar_amuletmechanics",    { event_mdown = private.get_amuletmechanics } );
  ObjSet( "spr_trunk_machete",               { event_mdown = private.get_machete } );
  ObjSet( "spr_trunk_extinguisher",          { event_mdown = private.get_extinguisher } );
  ObjSet( "spr_path_purse",                  { event_mdown = private.get_purse } );
  ObjSet( "spr_pointer_planks_4",            { event_mdown = private.get_planks_4 } );
  ObjSet( "spr_pointer_nails_8",             { event_mdown = private.get_nails_8 } );
  ObjSet( "spr_pointer_goldennut",           { event_mdown = private.get_goldennut } );
  ObjSet( "obj_bygrayscar_clk_survey",       { event_mdown = private.clk_bygrayscar_survey } );
  ObjSet( "obj_trunk_clk_carkeys",           { event_mdown = private.clk_carkeys } );
  ObjSet( "spr_wheels_wheel_new1_2",         { event_dragdrop = private.use_wheel_2 } );
  ObjSet( "spr_wheels_wheel_new1_1",         { event_dragdrop = private.use_wheel_1 } );
  ObjSet( "spr_wheels_wheel_new1_1",         { event_mdown = private.clk_wheel_1 } );
  ObjSet( "spr_wheels_wheel_new1_2",         { event_mdown = private.clk_wheel_2 } );
  ObjSet( "obj_inthecar_clk_box",            { event_mdown = private.clk_box } );
  ObjSet( "obj_inthecar_use_gloveboxslider", { event_mdown = private.clk_runner } );
  ObjSet( "obj_pointer_use_handfulofnuts",   { event_mdown = private.clk_squirrel } );
  ObjSet( "obj_trunk_use_amuletmechanics",   { event_mdown = private.TrunkBoxCoverClick } );
  --ObjSet( "spr_wheels_wheelwrench",          { event_startdrag = function () private.GetItem( ); end, event_drag = function () private.DragItem( ); end, event_dragdrop = function () private.UseItem( ); end, } );
  ObjSet( "obj_pointer_use_hammer",          { event_mdown = private.ClkPlate } );
  ObjSet( "obj_trunk_clk_open",              { event_mdown = private.ClkOpen } );
  ObjSet( "spr_inthecar_collect2_1_3",       { event_mdown = private.get_collect2_1_3 } );
  ObjSet( "spr_bygrayscar_note",             { event_mdown = function () private.ClkNote( 0 ) end  } );
  ObjSet( "spr_bygrayscar_note_1",           { event_mdown = function () private.ClkNote( 2 ) end  } );
  ObjSet( "spr_bygrayscar_note_2",           { event_mdown = function () private.ClkNote( 1 ) end  } );
  ObjSet( "obj_bygrayscar_note",             { event_mdown = function () private.ClkNote( 3 ) end  } );

  private.InitAnimations();
  private.InitSubroom();


  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_bygrayscar = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gzz_bygrayscar_inthecar",
        "gzz_bygrayscar_trunk",
        "gzz_bygrayscar_path",
        "gzz_bygrayscar_pointer",
        "gzz_bygrayscar_wheels"
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_inthecar", 
        "zz_trunk", 
        "zz_path", 
        "zz_pointer",
        "zz_wheels",
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_bygrayscar", update_game_mode_bygrayscar, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_folder () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_folder" ] =
  {
    type = "get",
    get_obj = "spr_inthecar_folder",
    room = private.room_objname,
    zz = "zz_inthecar",
    zz_gate = "gzz_bygrayscar_inthecar"
  };
  -----------------------------------------------
  local get_folder_inv = function ()

    int.InventoryItemAdd( "inv_folder", "spr_inthecar_folder" );
    ObjSet( "inv_folder", { drag = false } );

  end;

  local get_folder_closezz = function ()

    ObjDelete( "gfx_inthecar_folder" );

    if ( cmn.IsEventDone( "get_folder" ) and
         cmn.IsEventDone( "get_areamap" ) and
         cmn.IsEventDone( "get_amuletmechanics" ) and
         cmn.IsEventDone( "get_collect2_1_3" ) and
         cmn.IsEventDone( "get_rope" ) ) then

      ObjDelete( "gzz_bygrayscar_inthecar" );

    end;

    cmn.TutorialShow( "tutorial_page_5" );
    cmn.TutorialSetShown( "tutorial_page_5" );

  end;

  cmn.AddSubscriber( "get_folder", get_folder_inv );
  cmn.AddSubscriber( "get_folder", get_folder_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_areamap () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_areamap" ] =
  {
    type = "get",
    get_obj = "spr_inthecar_areamap",
    room = private.room_objname,
    zz = "zz_inthecar",
    zz_gate = "gzz_bygrayscar_inthecar"
  };
  -----------------------------------------------
  local get_areamap_inv = function ()

    ObjSet( "int_button_map_impl",
    {
      alp = 1,
      input = true,
      visible = true,
      active = true
    } );   

  end;
  local get_areamap_end = function ()

    ObjDelete( "spr_inthecar_areamap" );

  end;
  local get_areamap_closezz = function ()

    ObjDelete( "gfx_inthecar_areamap" );
    ObjDelete( "spr_inthecar_areamap_shadow" );
    ObjSet( "spr_inthecar_amuletmechanics", { alp = 1, input = true } );
    ObjSet( "gfx_inthecar_amuletmechanics", { active = true } );

    if ( cmn.IsEventDone( "get_folder" ) and
         cmn.IsEventDone( "get_areamap" ) and
         cmn.IsEventDone( "get_amuletmechanics" ) and
         cmn.IsEventDone( "get_collect2_1_3" ) and
         cmn.IsEventDone( "get_rope" ) ) then

      ObjDelete( "gzz_bygrayscar_inthecar" );

    end;

  end;

  cmn.AddSubscriber( "get_areamap", get_areamap_inv );
  cmn.AddSubscriber( "get_areamap", get_areamap_closezz, private.room_objname );

  cmn.AddSubscriber( "get_areamap", get_areamap_end, private.room_objname );
  cmn.AddSubscriber( "get_areamap_end", get_areamap_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletmechanics () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletmechanics" ] =
  {
    type = "get",
    get_obj = "spr_inthecar_amuletmechanics",
    room = private.room_objname,
    zz = "zz_inthecar",
    zz_gate = "gzz_bygrayscar_inthecar"
  };
  -----------------------------------------------
  local get_amuletmechanics_inv = function ()

    int.InventoryItemAdd( "inv_amuletmechanics", "spr_inthecar_amuletmechanics" );

  end;

  local get_amuletmechanics_closezz = function ()

    ObjDelete( "gfx_inthecar_amuletmechanics" );
    ObjDelete( "spr_inthecar_amuletmechanics_shad" );
    ObjDelete( "spr_inthecar_amuletmechanics_add" );

    if ( cmn.IsEventDone( "get_folder" ) and
         cmn.IsEventDone( "get_areamap" ) and
         cmn.IsEventDone( "get_amuletmechanics" ) and
         cmn.IsEventDone( "get_collect2_1_3" ) and
         cmn.IsEventDone( "get_rope" ) ) then

      ObjDelete( "gzz_bygrayscar_inthecar" );

    end;

  end;

  cmn.AddSubscriber( "get_amuletmechanics", get_amuletmechanics_inv );
  cmn.AddSubscriber( "get_amuletmechanics", get_amuletmechanics_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_machete () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_machete" ] =
  {
    type = "get",
    get_obj = "spr_trunk_machete",
    room = private.room_objname,
    zz = "zz_trunk",
    zz_gate = "gzz_bygrayscar_trunk"
  };
  -----------------------------------------------
  local get_machete_inv = function ()

    int.InventoryItemAdd( "inv_machete", "spr_trunk_machete" );

  end;

  local get_machete_closezz = function ()

    ObjDelete( "gfx_trunk_machete" );
    ObjDelete( "spr_bygrayscar_machete" );

    if ( cmn.IsEventDone( "get_machete" ) and
         cmn.IsEventDone( "get_extinguisher" ) ) then

      ObjDelete( "gzz_bygrayscar_trunk" );

    end;

  end;

  cmn.AddSubscriber( "get_machete", get_machete_inv );
  cmn.AddSubscriber( "get_machete", get_machete_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_extinguisher () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_extinguisher" ] =
  {
    type = "get",
    get_obj = "spr_trunk_extinguisher",
    room = private.room_objname,
    zz = "zz_trunk",
    zz_gate = "gzz_bygrayscar_trunk"
  };
  -----------------------------------------------
  local get_extinguisher_inv = function ()

    int.InventoryItemAdd( "inv_extinguisher", "spr_trunk_extinguisher" );

  end;

  local get_extinguisher_closezz = function ()

    ObjDelete( "gfx_trunk_extinguisher" );
    ObjDelete( "spr_bygrayscar_extinguisher" );

    if ( cmn.IsEventDone( "get_machete" ) and
         cmn.IsEventDone( "get_extinguisher" ) ) then

      ObjDelete( "gzz_bygrayscar_trunk" );

    end;

  end;

  cmn.AddSubscriber( "get_extinguisher", get_extinguisher_inv );
  cmn.AddSubscriber( "get_extinguisher", get_extinguisher_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_purse () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_purse" ] =
  {
    type = "get",
    get_obj = "spr_path_purse",
    room = private.room_objname,
    zz = "zz_path",
    zz_gate = "gzz_bygrayscar_path"
  };
  -----------------------------------------------
  local get_purse_inv = function ()

    int.InventoryItemAdd( "inv_purse", "spr_path_purse" );
    ObjSet( "inv_purse", { drag = false } );
    ObjSet( "inv_purse_plus_focus2", { alp = 0 } );

  end;

  local get_purse_closezz = function ()

    ObjDelete( "gfx_path_purse" );    
    ObjDelete( "spr_path_purse_shadow" );  
    ObjSet( "obj_path_back", { input = true } ); 
    ObjDelete( "spr_bygrayscar_purse" );

  end;

  cmn.AddSubscriber( "get_purse", get_purse_inv );
  cmn.AddSubscriber( "get_purse", get_purse_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_planks_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_planks_4" ] =
  {
    type = "get",
    get_obj = "spr_pointer_planks_4",
    room = private.room_objname,
    zz = "zz_pointer",
    zz_gate = "gzz_bygrayscar_pointer"
  };
  -----------------------------------------------
  local get_planks_4_inv = function ()

    int.InventoryItemAdd( "inv_planks_2", "obj_pointer_pointer", "assets/levels/level1/rm_abandonedfarm/zz_doorstothehouse/inv/inv_planks_morph" );
    level1_inv.CheckPlanks();

  end;

  local get_planks_4_closezz = function ()

    ObjDelete( "gfx_pointer_planks_4" );
    ObjDelete( "spr_pointer_plate1_shadow" );
    ObjDelete( "spr_pointer_plate2_shadow" );
    ObjSet( "spr_bygrayscar_overlap1", { alp = 1 } ); 
    
    if ( cmn.IsEventDone( "get_planks_4" ) and
         cmn.IsEventDone( "get_nails_8" ) and
         cmn.IsEventDone( "get_goldennut" ) ) then

      ObjDelete( "gzz_bygrayscar_pointer" );

    end;

  end;

  cmn.AddSubscriber( "get_planks_4", get_planks_4_inv );
  cmn.AddSubscriber( "get_planks_4", get_planks_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_nails_8 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_nails_8" ] =
  {
    type = "get",
    get_obj = "spr_pointer_nails_8",
    room = private.room_objname,
    zz = "zz_pointer",
    zz_gate = "gzz_bygrayscar_pointer"
  };
  -----------------------------------------------
  local get_nails_8_inv = function ()

    int.InventoryItemAdd( "inv_nails_4", "", "assets/levels/level1/rm_abandonedfarm/zz_doorstothehouse/inv/inv_planks_morph" );
    level1_inv.CheckNails();

  end;

  local get_nails_8_closezz = function ()

    if ( cmn.IsEventDone( "get_planks_4" ) and
         cmn.IsEventDone( "get_nails_8" ) and
         cmn.IsEventDone( "get_goldennut" ) ) then

      ObjDelete( "gzz_bygrayscar_pointer" );

    end;

  end;

  cmn.AddSubscriber( "get_nails_8", get_nails_8_inv );
  cmn.AddSubscriber( "get_nails_8", get_nails_8_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_goldennut () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_goldennut" ] =
  {
    type = "get",
    get_obj = "obj_pointer_use_handfulofnuts",
    room = private.room_objname,
    zz = "zz_pointer",
    zz_gate = "gzz_bygrayscar_pointer"
  };
  -----------------------------------------------
  local get_goldennut_inv = function ()

    int.InventoryItemAdd( "inv_goldennut", "spr_pointer_goldennut" );

    ObjSet( "inv_purse_plus_focus2", { alp = 1 } );

  end;

  local get_goldennut_closezz = function ()

    ObjDelete( "spr_bygrayscar_golden_nut" );

    if ( cmn.IsEventDone( "get_planks_4" ) and
         cmn.IsEventDone( "get_nails_8" ) and
         cmn.IsEventDone( "get_goldennut" ) ) then

      ObjDelete( "gzz_bygrayscar_pointer" );

    end;

  end;

  cmn.AddSubscriber( "get_goldennut", get_goldennut_inv );
  cmn.AddSubscriber( "get_goldennut", get_goldennut_closezz, private.room_objname );
  cmn.AddSubscriber( "get_goldennut_inv", get_goldennut_inv, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rope () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_rope" ] =
  {
    type = "get",
    get_obj = "spr_inthecar_rope",
    room = private.room_objname,
    zz = "zz_inthecar",
    zz_gate = "gzz_bygrayscar_inthecar"
  };
  -----------------------------------------------
  local get_rope_inv = function ()

    int.InventoryItemAdd( "inv_rope", "spr_inthecar_rope" );

  end;
  local get_rope_closezz = function ()

    ObjDelete( "gfx_inthecar_rope" );
    ObjDelete( "spr_inthecar_rope_shadow" );

    if ( cmn.IsEventDone( "get_folder" ) and
         cmn.IsEventDone( "get_areamap" ) and
         cmn.IsEventDone( "get_amuletmechanics" ) and
         cmn.IsEventDone( "get_collect2_1_3" ) and
         cmn.IsEventDone( "get_rope" ) ) then

      ObjDelete( "gzz_bygrayscar_inthecar" );

    end;


  end;
  -----------------------------------------------
  cmn.AddSubscriber( "get_rope", get_rope_inv );
  cmn.AddSubscriber( "get_rope", get_rope_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_gloveboxslider () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gloveboxslider" ] =
  {
    type = "use",
    use_obj = "inv_gloveboxslider",
    use_place = "obj_inthecar_use_gloveboxslider",
    room = private.room_objname,
    zz = "zz_inthecar",
    zz_gate = "gzz_bygrayscar_inthecar"
  };
  -----------------------------------------------
  local use_gloveboxslider_inv = function ()

    int.InventoryItemRemove( "inv_gloveboxslider" );

  end;
  local use_gloveboxslider_beg = function ()

    ObjDelete( "obj_inthecar_use_gloveboxslider" );

  end;
  local use_gloveboxslider_end = function ()

    ObjSet( "spr_inthecar_runner1", { alp = 1 } );
    ObjSet( "obj_inthecar_clk_box", { input = true } );
    ObjDelete( "spr_inthecar_pin" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_gloveboxslider", use_gloveboxslider_beg, private.room_objname );
  cmn.AddSubscriber( "use_gloveboxslider", use_gloveboxslider_inv );
  cmn.AddSubscriber( "use_gloveboxslider", use_gloveboxslider_end, private.room_objname );
  cmn.AddSubscriber( "use_gloveboxslider_inv", use_gloveboxslider_inv, private.room_objname );
  cmn.AddSubscriber( "use_gloveboxslider_beg", use_gloveboxslider_beg, private.room_objname );
  cmn.AddSubscriber( "use_gloveboxslider_end", use_gloveboxslider_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_carkeys () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_carkeys" ] =
  {
    type = "use",
    use_obj = "inv_carkeys",
    use_place = "obj_trunk_use_carkeys",
    room = private.room_objname,
    zz = "zz_trunk",
    zz_gate = "gzz_bygrayscar_trunk"
  };
  -----------------------------------------------
  local use_carkeys_inv = function ()

    int.InventoryItemRemove( "inv_carkeys" );

  end;
  local use_carkeys_beg = function ()

    ObjDelete( "obj_trunk_use_carkeys" );

  end;
  local use_carkeys_end = function ()

    ObjSet( "spr_trunk_key_1",       { alp = 1 } );
    ObjSet( "spr_bygrayscar_carkey", { alp = 1 } );
    ObjSet( "obj_trunk_clk_carkeys", { input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_carkeys", use_carkeys_beg, private.room_objname );
  cmn.AddSubscriber( "use_carkeys", use_carkeys_inv );
  cmn.AddSubscriber( "use_carkeys", use_carkeys_end, private.room_objname );
  cmn.AddSubscriber( "use_carkeys_inv", use_carkeys_inv, private.room_objname );
  cmn.AddSubscriber( "use_carkeys_beg", use_carkeys_beg, private.room_objname );
  cmn.AddSubscriber( "use_carkeys_end", use_carkeys_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletmechanics () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletmechanics" ] =
  {
    type = "use",
    use_obj = "inv_amuletmechanics",
    use_place = "obj_trunk_use_amuletmechanics",
    room = private.room_objname,
    zz = "zz_trunk",
    zz_gate = "gzz_bygrayscar_trunk"
  };
  -----------------------------------------------
  local use_amuletmechanics_inv = function ()

    int.InventoryItemRemove( "inv_amuletmechanics" );

  end;
  local use_amuletmechanics_beg = function ()

    ObjDelete( "obj_trunk_use_amuletmechanics" );
    ObjDelete( "spr_trunk_box_cover" );

  end;
  local use_amuletmechanics_end = function ()

    ObjSet( "obj_trunk_open_box",      { input = true, alp = 1 } );
    ObjSet( "gfx_trunk_machete",       { active = true } );
    ObjSet( "gfx_trunk_extinguisher",  { active = true } );
    ObjSet( "spr_bygrayscar_box_open", { alp = 1 } );
    ObjDelete( "spr_trunk_amulet" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_amuletmechanics", use_amuletmechanics_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletmechanics", use_amuletmechanics_inv );
  cmn.AddSubscriber( "use_amuletmechanics", use_amuletmechanics_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletmechanics_inv", use_amuletmechanics_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletmechanics_beg", use_amuletmechanics_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletmechanics_end", use_amuletmechanics_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_machete_0 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_machete_0" ] =
  {
    type = "use",
    use_obj = "inv_machete",
    use_place = "obj_path_use_machete_0",
    room = private.room_objname,
    zz = "zz_path",
    zz_gate = "gzz_bygrayscar_path"
  };
  -----------------------------------------------
  local use_machete_0_inv = function ()
  end;
  local use_machete_0_beg = function ()

    ObjDelete( "obj_path_use_machete_0" );

  end;
  local use_machete_0_end = function ()

    ObjDelete( "anm_path_block0_static" );
    ObjDelete( "anm_path_block0" );
    ObjDelete( "obj_path_use_machete_0" );
    ObjSet( "obj_path_use_machete_1", {  input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_machete_0", use_machete_0_beg, private.room_objname );
  cmn.AddSubscriber( "use_machete_0", use_machete_0_inv );
  cmn.AddSubscriber( "use_machete_0", use_machete_0_end, private.room_objname );
  cmn.AddSubscriber( "use_machete_0_inv", use_machete_0_inv, private.room_objname );
  cmn.AddSubscriber( "use_machete_0_beg", use_machete_0_beg, private.room_objname );
  cmn.AddSubscriber( "use_machete_0_end", use_machete_0_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_machete_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_machete_1" ] =
  {
    type = "use",
    use_obj = "inv_machete",
    use_place = "obj_path_use_machete_1",
    room = private.room_objname,
    zz = "zz_path",
    zz_gate = "gzz_bygrayscar_path"
  };
  -----------------------------------------------
  local use_machete_1_inv = function ()
    int.InventoryItemRemove( "inv_machete" );
  end;
  local use_machete_1_beg = function ()

    ObjDelete( "obj_path_use_machete_1" );

  end;
  local use_machete_1_end = function ()

    ObjDelete( "spr_path_1block_light" );
    ObjDelete( "anm_path_block1_static" );
    ObjDelete( "anm_path_block1" );
    ObjDelete( "obj_path_use_machete_1" );
    ObjSet( "obj_path_back", { pos_x = 1, pos_y = -30, scale_x = 2, scale_y = 2 } );

    --ObjSet( "obj_path_use_machete_2", { input = true } );
    ObjSet( "spr_path_light", { pos_y = -184 } );
    ObjDelete( "spr_path_1st_plane_left" );
    ObjDelete( "spr_path_1st_plane_right" );

    --ObjSet( "spr_path_1block_light_1", { pos_x = -2, pos_y = -35, scale_x = 1.7, scale_x = 1.7 } );
    --ObjSet( "spr_path_1block_light_2", { pos_x = -2, pos_y = -35, scale_x = 1.7, scale_x = 1.7 } );

    ObjDelete( "anm_bygrayscar_path_1" );
    ObjSet( "grm_bygrayscar_abandonedfarm", { active = true, input = true, visible = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_bygrayscar_abandonedfarm_focus");
    end;
    ObjDelete( "gzz_bygrayscar_path" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_machete_1", use_machete_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_machete_1", use_machete_1_inv );
  cmn.AddSubscriber( "use_machete_1", use_machete_1_end, private.room_objname );
  cmn.AddSubscriber( "use_machete_1_inv", use_machete_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_machete_1_beg", use_machete_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_machete_1_end", use_machete_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --[[
  -- function use_machete_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_machete_2" ] =
  {
    type = "use",
    use_obj = "inv_machete",
    use_place = "obj_path_use_machete_2",
    room = private.room_objname,
    zz = "zz_path",
    zz_gate = "gzz_bygrayscar_path"
  };
  -----------------------------------------------
  local use_machete_2_inv = function ()
  end;
  local use_machete_2_beg = function ()

    ObjDelete( "obj_path_use_machete_2" );

  end;
  local use_machete_2_end = function ()

    ObjDelete( "obj_path_use_machete_2" );
    ObjSet( "obj_path_use_machete_3", { input = true } );

    ObjSet( "obj_path_back", { scale_x = 1, scale_y = 1, pos_x = -11, pos_y = 64, } );
    ObjDelete( "anm_path_fog1" );
    ObjDelete( "anm_path_block2_static" );
    ObjDelete( "anm_path_block2" );
    ObjDelete( "spr_path_2block_light_1" );
    ObjSet( "spr_path_2nd_plane", { pos_y = 163 } );
    ObjSet( "spr_path_light", { pos_y = -213 } );

    ObjSet( "spr_path_2block_light_2", { pos_x = 9, pos_y = -62, scale_x = 1.35, scale_x = 1.35 } );

    ObjDelete( "spr_bygrayscar_path_2" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_machete_2", use_machete_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_machete_2", use_machete_2_inv );
  cmn.AddSubscriber( "use_machete_2", use_machete_2_end, private.room_objname );
  cmn.AddSubscriber( "use_machete_2_inv", use_machete_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_machete_2_beg", use_machete_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_machete_2_end", use_machete_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_machete_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_machete_3" ] =
  {
    type = "use",
    use_obj = "inv_machete",
    use_place = "obj_path_use_machete_3",
    room = private.room_objname,
    zz = "zz_path",
    zz_gate = "gzz_bygrayscar_path"
  };
  -----------------------------------------------
  local use_machete_3_inv = function ()

    int.InventoryItemRemove( "inv_machete" );

  end;
  local use_machete_3_beg = function ()

    ObjDelete( "obj_path_use_machete_3" );

  end;
  local use_machete_3_end = function ()

    ObjDelete( "obj_path_use_machete_3" );
    ObjSet( "grm_bygrayscar_abandonedfarm", { active = true, input = true, visible = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_bygrayscar_abandonedfarm_focus");
    end;
    ObjDelete( "gzz_bygrayscar_path" );

    ObjDelete( "spr_bygrayscar_path_3" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_machete_3", use_machete_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_machete_3", use_machete_3_inv );
  cmn.AddSubscriber( "use_machete_3", use_machete_3_end, private.room_objname );
  cmn.AddSubscriber( "use_machete_3_inv", use_machete_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_machete_3_beg", use_machete_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_machete_3_end", use_machete_3_end, private.room_objname );
  ]]
  --------------------------------------------------------------------------------------------
  -- function use_hammer_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hammer_2" ] =
  {
    type = "use",
    use_obj = "inv_hammer",
    use_place = "obj_pointer_use_hammer",
    room = private.room_objname,
    zz = "zz_pointer",
    zz_gate = "gzz_bygrayscar_pointer"
  };
  -----------------------------------------------
  local use_hammer_2_inv = function ()
  end;
  local use_hammer_2_beg = function ()

    ObjDelete( "obj_pointer_use_hammer" );

  end;
  local use_hammer_2_end = function ()

    ObjDelete( "anm_pointer_hammer" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_hammer_2", use_hammer_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer_2", use_hammer_2_inv );
  cmn.AddSubscriber( "use_hammer_2", use_hammer_2_end, private.room_objname );
  cmn.AddSubscriber( "use_hammer_2_inv", use_hammer_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_hammer_2_beg", use_hammer_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer_2_end", use_hammer_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_handfulofnuts () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_handfulofnuts" ] =
  {
    type = "use",
    use_obj = "inv_handfulofnuts",
    use_place = "obj_pointer_use_handfulofnuts",
    room = private.room_objname,
    zz = "zz_pointer",
    zz_gate = "gzz_bygrayscar_pointer"
  };
  -----------------------------------------------
  local use_handfulofnuts_inv = function ()

    int.InventoryItemRemove( "inv_handfulofnuts" );

  end;
  local use_handfulofnuts_beg = function ()

    ObjDelete( "obj_pointer_use_handfulofnuts" );

  end;
  local use_handfulofnuts_end = function ()

    ObjSet( "anm_pointer_squirrel_static_2", { playing = true, alp = 1 } );
    ObjDelete( "anm_pointer_squirrel_static" );
    ObjDelete( "anm_pointer_squirrel_click" );
    ObjDelete( "anm_pointer_squirrel_nuts" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_handfulofnuts", use_handfulofnuts_beg, private.room_objname );
  cmn.AddSubscriber( "use_handfulofnuts", use_handfulofnuts_inv );
  cmn.AddSubscriber( "use_handfulofnuts", use_handfulofnuts_end, private.room_objname );
  cmn.AddSubscriber( "use_handfulofnuts_inv", use_handfulofnuts_inv, private.room_objname );
  cmn.AddSubscriber( "use_handfulofnuts_beg", use_handfulofnuts_beg, private.room_objname );
  cmn.AddSubscriber( "use_handfulofnuts_end", use_handfulofnuts_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_jack () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_jack" ] =
  {
    type = "use",
    use_obj = "inv_jack",
    use_place = "obj_wheels_use_jack",
    room = private.room_objname,
    zz = "zz_wheels",
    zz_gate = "gzz_bygrayscar_wheels"
  };
  -----------------------------------------------
  local use_jack_inv = function ()

    int.InventoryItemRemove( "inv_jack" );

  end;
  local use_jack_beg = function ()

    ObjDelete( "obj_wheels_use_jack" );

  end;
  local use_jack_end = function ()
--
    ObjSet( "obj_wheels_use_wheelwrench_1", { input = true } );
    ObjSet( "anm_wheels_jackuse_nowheels", { alp = 1 } );
--    ObjSet( "spr_wheels_jack_shadow", { alp = 1 } );
    ObjSet( "obj_wheels_car1", { alp = 1 } );
    ObjSet( "spr_bygrayscar_jack", { alp = 1 } );
    ObjSet( "spr_wheels_bolts_1", { alp = 1 } );
    ObjDelete( "anm_wheels_jack_use" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_jack", use_jack_beg, private.room_objname );
  cmn.AddSubscriber( "use_jack", use_jack_inv );
  cmn.AddSubscriber( "use_jack", use_jack_end, private.room_objname );
  cmn.AddSubscriber( "use_jack_inv", use_jack_inv, private.room_objname );
  cmn.AddSubscriber( "use_jack_beg", use_jack_beg, private.room_objname );
  cmn.AddSubscriber( "use_jack_end", use_jack_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pump () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pump" ] =
  {
    type = "use",
    use_obj = "inv_pump",
    use_place = "obj_wheels_use_pump",
    room = private.room_objname,
    zz = "zz_wheels",
    zz_gate = "gzz_bygrayscar_wheels"
  };
  -----------------------------------------------
  local use_pump_inv = function ()

    int.InventoryItemRemove( "inv_pump" );
    int.TaskDone( 3 );

  end;
  local use_pump_beg = function ()

    ObjDelete( "obj_wheels_use_pump" );

  end;
  local use_pump_end = function ()

    ObjSet( "obj_wheels_use_wheelwrench_2", { input = true } );
    ObjDelete( "anm_wheels_pump_use" );
    ObjSet( "anm_wheels_pump_use_end", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_pump", use_pump_beg, private.room_objname );
  cmn.AddSubscriber( "use_pump", use_pump_inv );
  cmn.AddSubscriber( "use_pump", use_pump_end, private.room_objname );
  cmn.AddSubscriber( "use_pump_inv", use_pump_inv, private.room_objname );
  cmn.AddSubscriber( "use_pump_beg", use_pump_beg, private.room_objname );
  cmn.AddSubscriber( "use_pump_end", use_pump_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wheel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wheel" ] =
  {
    type = "use",
    use_obj = "inv_wheel",
    use_place = "obj_wheels_use_wheel",
    room = private.room_objname,
    zz = "zz_wheels",
    zz_gate = "gzz_bygrayscar_wheels"
  };
  -----------------------------------------------
  local use_wheel_inv = function ()

    int.InventoryItemRemove( "inv_wheel" );

  end;
  local use_wheel_beg = function ()

    ObjDelete( "obj_wheels_use_wheel" );

  end;
  local use_wheel_end = function ()

    ObjSet( "obj_wheels_use_wheels", { input = true } );
    ObjSet( "obj_wheels_new_wheels", { input = true, alp = 1 } );
    ObjSet( "spr_bygrayscar_wheel_onasphalt", { alp = 1 } );
    ObjSet( "spr_bygrayscar_wheel_onasphalt2", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_wheel", use_wheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_wheel", use_wheel_inv );
  cmn.AddSubscriber( "use_wheel", use_wheel_end, private.room_objname );
  cmn.AddSubscriber( "use_wheel_inv", use_wheel_inv, private.room_objname );
  cmn.AddSubscriber( "use_wheel_beg", use_wheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_wheel_end", use_wheel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bicycle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bicycle" ] =
  {
    type = "use",
    use_obj = "inv_bicycle",
    use_place = "obj_bygrayscar_use_bicycle",
    room = private.room_objname,
  };
  -----------------------------------------------
  local use_bicycle_inv = function ()

    int.InventoryItemRemove( "inv_bicycle" );

  end;
  local use_bicycle_beg = function ()

    ObjDelete( "obj_bygrayscar_use_bicycle" );

  end;
  local use_bicycle_end = function ()

    ObjSet( "grm_bygrayscar_track", { active = true, input = true, visible = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_bygrayscar_track_focus");
    end;
    ObjSet( "spr_bygrayscar_bike", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_bicycle", use_bicycle_beg, private.room_objname );
  cmn.AddSubscriber( "use_bicycle", use_bicycle_inv );
  cmn.AddSubscriber( "use_bicycle", use_bicycle_end, private.room_objname );
  cmn.AddSubscriber( "use_bicycle_inv", use_bicycle_inv, private.room_objname );
  cmn.AddSubscriber( "use_bicycle_beg", use_bicycle_beg, private.room_objname );
  cmn.AddSubscriber( "use_bicycle_end", use_bicycle_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_wheelwrench_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wheelwrench_1" ] =
  {
    type = "use",
    use_obj = "inv_wheelwrench",
    use_place = "obj_wheels_use_wheelwrench_1",
    room = private.room_objname,
    zz = "zz_wheels",
    zz_gate = "gzz_bygrayscar_wheels"
  };
  -----------------------------------------------
  local use_wheelwrench_1_inv = function ()
  end;
  local use_wheelwrench_1_beg = function ()

    ObjDelete( "obj_wheels_use_wheelwrench_1" );

  end;
  local use_wheelwrench_1_end = function ()

    ObjSet( "obj_wheels_use_wheel", { input = true } );
    ObjDelete( "obj_wheels_old_wheels" );
    ObjDelete( "spr_bygrayscar_wheel_old" );
    ObjSet( "spr_bygrayscar_wheel_no", { alp = 1 } );
    ObjDelete( "vid_wheels_wheels_1" );
    --ObjSet( "spr_wheels_wheelwrench", { alp = 1 } );
    ObjSet( "spr_wheels_bolts_2", { alp = 1 } );
    ObjDelete( "spr_wheels_bolts_1" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_wheelwrench_1", use_wheelwrench_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_wheelwrench_1", use_wheelwrench_1_inv );
  cmn.AddSubscriber( "use_wheelwrench_1", use_wheelwrench_1_end, private.room_objname );
  cmn.AddSubscriber( "use_wheelwrench_1_inv", use_wheelwrench_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_wheelwrench_1_beg", use_wheelwrench_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_wheelwrench_1_end", use_wheelwrench_1_end, private.room_objname );

--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_wheelwrench_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wheelwrench_2" ] =
  {
    type = "use",
    use_obj = "inv_wheelwrench",
    use_place = "obj_wheels_use_wheelwrench_2",
    room = private.room_objname,
    zz = "zz_wheels",
    zz_gate = "gzz_bygrayscar_wheels"
  };
  -----------------------------------------------
  local use_wheelwrench_2_inv = function ()

    int.InventoryItemRemove( "inv_wheelwrench" );

  end;
  local use_wheelwrench_2_beg = function ()

    ObjDelete( "obj_wheels_use_wheelwrench_2" );

  end;
  local use_wheelwrench_2_end = function ()

    ObjSet( "obj_wheels_clk_jack", { input = true } );
    --ObjSet( "spr_wheels_wheelwrench", { input = false } );
    ObjDelete( "vid_wheels_wheels_2" );
    --ObjSet( "spr_wheels_wheelwrench", { alp = 1 } );
    ObjDelete( "spr_wheels_bolts_2" );
    ObjSet( "anm_wheels_car_down_bolts", { alp = 1 } );


  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_wheelwrench_2", use_wheelwrench_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_wheelwrench_2", use_wheelwrench_2_inv );
  cmn.AddSubscriber( "use_wheelwrench_2", use_wheelwrench_2_end, private.room_objname );
  cmn.AddSubscriber( "use_wheelwrench_2_inv", use_wheelwrench_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_wheelwrench_2_beg", use_wheelwrench_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_wheelwrench_2_end", use_wheelwrench_2_end, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_bygrayscar_survey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_bygrayscar_survey" ] =
  {
    type = "click",
    clk_obj = "obj_bygrayscar_clk_survey",
    use_place = "obj_bygrayscar_clk_survey",
    room = private.room_objname,
  };
  -----------------------------------------------
  local clk_bygrayscar_survey = function ()
  end;
  -----------------------------------------------
  local clk_bygrayscar_survey_beg = function ()

    ObjDelete( "obj_bygrayscar_clk_survey" );

  end;
  -----------------------------------------------
  local clk_bygrayscar_survey_end = function ()


  end;

  cmn.AddSubscriber( "clk_bygrayscar_survey", clk_bygrayscar_survey );
  cmn.AddSubscriber( "clk_bygrayscar_survey", clk_bygrayscar_survey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bygrayscar_survey", clk_bygrayscar_survey_end, private.room_objname );
  cmn.AddSubscriber( "clk_bygrayscar_survey_beg", clk_bygrayscar_survey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bygrayscar_survey_end", clk_bygrayscar_survey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_carkeys () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_carkeys" ] =
  {
    type = "click",
    clk_obj = "obj_trunk_clk_carkeys",
    room = private.room_objname,
    zz = "zz_trunk",
    zz_gate = "gzz_bygrayscar_trunk"
  };
  -----------------------------------------------
  local clk_carkeys = function ()
  end;
  -----------------------------------------------
  local clk_carkeys_beg = function ()

    ObjDelete( "obj_trunk_clk_carkeys" );

  end;
  -----------------------------------------------
  local clk_carkeys_end = function ()

    ObjDelete( "obj_trunk_close_car" );
    ObjDelete( "spr_bygrayscar_carkey" );
    ObjSet( "obj_trunk_open_car",        { alp = 1, input = true } );
    ObjSet( "spr_bygrayscar_trunk_open", { alp = 1 } );
    ObjSet( "anm_bygrayscar_trunk_move", { active = true } );

  end;

  cmn.AddSubscriber( "clk_carkeys", clk_carkeys );
  cmn.AddSubscriber( "clk_carkeys", clk_carkeys_beg, private.room_objname );
  cmn.AddSubscriber( "clk_carkeys", clk_carkeys_end, private.room_objname );
  cmn.AddSubscriber( "clk_carkeys_beg", clk_carkeys_beg, private.room_objname );
  cmn.AddSubscriber( "clk_carkeys_end", clk_carkeys_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wheel_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wheel_1" ] =
  {
    type = "use",
    use_obj = "spr_wheels_wheel_new1_1",
    use_place = "obj_wheels_use_wheel1",
    room = private.room_objname,
    zz = "zz_wheels",
    zz_gate = "gzz_bygrayscar_wheels"
  };
  -----------------------------------------------
  local use_wheel_1 = function ()
  end;
  -----------------------------------------------
  local use_wheel_1_end = function ()

    ObjDelete( "spr_wheels_wheel_new1_1_shadow" );
    ObjDelete( "spr_wheels_wheel_new1_1" );
    ObjSet( "spr_bygrayscar_wheel_new", { alp = 1 } );
    ObjSet( "spr_wheels_wheel_new_1", { alp = 1 } );
    ObjDelete( "spr_bygrayscar_wheel_onasphalt2" );

    if cmn.IsEventDone( "use_wheel_2" ) then

      ObjSet( "obj_wheels_use_wheelwrench_2", { input = true } );
      ObjDelete( "obj_wheels_use_wheels" );
      ObjDelete( "anm_wheels_jackuse_nowheels" );
      ObjSet( "anm_wheels_car_down", { alp = 1 } );
      ObjDelete( "obj_wheels_car1" );

    end;

  end;

  cmn.AddSubscriber( "use_wheel_1", use_wheel_1 );
  cmn.AddSubscriber( "use_wheel_1", use_wheel_1_end, private.room_objname );
  cmn.AddSubscriber( "use_wheel_1_end", use_wheel_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_box () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_box" ] =
  {
    type = "click",
    clk_obj = "obj_inthecar_clk_box",
    room = private.room_objname,
    zz = "zz_inthecar",
    zz_gate = "gzz_bygrayscar_inthecar"
  };
  -----------------------------------------------
  local clk_box = function ()
  end;
  -----------------------------------------------
  local clk_box_beg = function ()

    ObjDelete( "obj_inthecar_clk_box" );

  end;
  -----------------------------------------------
  local clk_box_end = function ()

    ObjSet( "gfx_inthecar_areamap", { active = true } );
    ObjSet( "spr_inthecar_runner1", { alp = 1 } );
    ObjDelete( "spr_inthecar_pin" );
    ObjSet( "obj_inthecar_anim", { pos_x = - 118, pos_y = - 40 } );
    ObjSet( "obj_inthecar_open_box", { alp = 1, input = true } );

  end;

  cmn.AddSubscriber( "clk_box", clk_box );
  cmn.AddSubscriber( "clk_box", clk_box_beg, private.room_objname );
  cmn.AddSubscriber( "clk_box", clk_box_end, private.room_objname );
  cmn.AddSubscriber( "clk_box_beg", clk_box_beg, private.room_objname );
  cmn.AddSubscriber( "clk_box_end", clk_box_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_jack () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_jack" ] =
  {
    type = "click",
    clk_obj = "obj_wheels_clk_jack",
    room = private.room_objname,
    zz = "zz_wheels",
    zz_gate = "gzz_bygrayscar_wheels"
  };
  -----------------------------------------------
  local clk_jack = function ()
  end;
  -----------------------------------------------
  local clk_jack_beg = function ()

    ObjDelete( "obj_wheels_clk_jack" );

  end;
  -----------------------------------------------
  local clk_jack_end = function ()

    ObjSet( "obj_wheels_use_pump", { input = true } );
    ObjDelete( "anm_wheels_car_down" );
    ObjDelete( "anm_wheels_car_down_bolts" );
    ObjSet( "anm_wheels_pump_use", { alp = 1 } );
    ObjDelete( "spr_bygrayscar_jack" );

  end;

  cmn.AddSubscriber( "clk_jack", clk_jack );
  cmn.AddSubscriber( "clk_jack", clk_jack_beg, private.room_objname );
  cmn.AddSubscriber( "clk_jack", clk_jack_end, private.room_objname );
  cmn.AddSubscriber( "clk_jack_beg", clk_jack_beg, private.room_objname );
  cmn.AddSubscriber( "clk_jack_end", clk_jack_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wheel_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wheel_2" ] =
  {
    type = "use",
    use_obj = "spr_wheels_wheel_new1_2",
    use_place = "obj_wheels_use_wheel2",
    room = private.room_objname,
    zz = "zz_wheels",
    zz_gate = "gzz_bygrayscar_wheels"
  };
  -----------------------------------------------
  local use_wheel_2 = function ()
  end;
  -----------------------------------------------
  local use_wheel_2_end = function ()

    ObjDelete( "spr_wheels_wheel_new1_2_shadow" );
    ObjDelete( "spr_wheels_wheel_new1_2" );
    ObjDelete( "spr_bygrayscar_wheel_onasphalt" );
    ObjSet( "spr_wheels_wheel_new_2", { alp = 1 } );

    if cmn.IsEventDone( "use_wheel_1" ) then

      ObjSet( "obj_wheels_use_wheelwrench_2", { input = true } );
      ObjDelete( "obj_wheels_use_wheels" );
      ObjDelete( "anm_wheels_jackuse_nowheels" );
      ObjDelete( "obj_wheels_car1" );
      ObjSet( "anm_wheels_car_down", { alp = 1 } );

    end;

  end;

  cmn.AddSubscriber( "use_wheel_2", use_wheel_2 );
  cmn.AddSubscriber( "use_wheel_2", use_wheel_2_end, private.room_objname );
  cmn.AddSubscriber( "use_wheel_2_end", use_wheel_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_1_3 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_1_3 = function ()

    ObjDelete( "obj_bygrayscar_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_1_3", get_morphobject_1_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_1_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_1_3 = function ()

    ObjDelete( "spr_inthecar_collect2_1_3" );

    if ( cmn.IsEventDone( "get_folder" ) and
         cmn.IsEventDone( "get_areamap" ) and
         cmn.IsEventDone( "get_amuletmechanics" ) and
         cmn.IsEventDone( "get_collect2_1_3" ) and
         cmn.IsEventDone( "get_rope" ) ) then

      ObjDelete( "gzz_bygrayscar_inthecar" );

    end;

  end;

  cmn.AddSubscriber( "get_collect2_1_3", get_collect2_1_3, private.room_objname );
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function private.get_folder ()

  cmn.SetEventDone( "get_folder" );
  cmn.CallEventHandler( "get_folder" );
  
  cmn.GetObjectSfx();

  cmn.ShowBbt( "bbt_inthecar_get_folder" );

  if ( cmn.IsEventDone( "get_folder" ) and
       cmn.IsEventDone( "get_areamap" ) and
       cmn.IsEventDone( "get_amuletmechanics" ) and
       cmn.IsEventDone( "get_collect2_1_3" ) and
       cmn.IsEventDone( "get_rope" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_areamap ()
  
  cmn.GetObjectSfx();

  ObjSet( "spr_inthecar_amuletmechanics", { alp = 1, input = true } );
  ObjSet( "gfx_inthecar_amuletmechanics", { active = true } );

  local func_end = function ()

    int.Lock( false );
    cmn.SetEventDone( "get_areamap" );
    cmn.CallEventHandler( "get_areamap" );

  end;

  ObjDelete( "gfx_inthecar_areamap" );
  ObjSet( "spr_inthecar_amuletmechanics", { alp = 1, input = true } );
  ObjSet( "gfx_inthecar_amuletmechanics", { active = true } );
  ObjSet( "spr_inthecar_areamap_shadow", { alp = 0 } );

  int.Lock( true );
  local fly_obj_name = "spr_inthecar_areamap";

  ObjAttach( fly_obj_name, InterfaceWidget_Top_Name );

  local item_game_pos = GetObjPosByObj( object_name );

  ObjSet( fly_obj_name,
  {
    input      = 0,
    pos_x      = 783,
    pos_y      = 356
  } );

  ObjAnimate( fly_obj_name, "pos_xy", 0, 0, func_end, 
    { 
      0.0, 0, ObjGet( fly_obj_name ).pos_x, ObjGet( fly_obj_name ).pos_y,
      1.0, 0, ( 512+590 ), (384+300) 
    });

  ObjAnimate( fly_obj_name, "alp", 0, 0, "", 
    { 
      0.0, 0, 1,
      0.7, 0, 1,
      1.0, 0, 0
    });

  ObjAnimate( "int_button_map_impl", "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      0.7, 0, 0,
      1.0, 0, 1
    });

  if ( cmn.IsEventDone( "get_folder" ) and
       cmn.IsEventDone( "get_areamap" ) and
       cmn.IsEventDone( "get_amuletmechanics" ) and
       cmn.IsEventDone( "get_collect2_1_3" ) and
       cmn.IsEventDone( "get_rope" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_amuletmechanics ()

  cmn.SetEventDone( "get_amuletmechanics" );
  cmn.CallEventHandler( "get_amuletmechanics" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_folder" ) and
       cmn.IsEventDone( "get_areamap" ) and
       cmn.IsEventDone( "get_amuletmechanics" ) and
       cmn.IsEventDone( "get_collect2_1_3" ) and
       cmn.IsEventDone( "get_rope" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
-------------------------------------------------
function private.get_machete ()

  cmn.SetEventDone( "get_machete" );
  cmn.CallEventHandler( "get_machete" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_machete" ) and
       cmn.IsEventDone( "get_extinguisher" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_extinguisher ()

  cmn.SetEventDone( "get_extinguisher" );
  cmn.CallEventHandler( "get_extinguisher" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_machete" ) and
       cmn.IsEventDone( "get_extinguisher" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_purse ()

  cmn.SetEventDone( "get_purse" );
  cmn.CallEventHandler( "get_purse" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_planks_4 ()

  cmn.SetEventDone( "get_planks_4" );
  cmn.CallEventHandler( "get_planks_4" );
  
  if ( cmn.IsEventDone( "get_planks_4" ) and
       cmn.IsEventDone( "get_nails_8" ) and
       cmn.IsEventDone( "get_goldennut" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_nails_8 ()

  cmn.SetEventDone( "get_nails_8" );
  cmn.CallEventHandler( "get_nails_8" );
  
  if ( cmn.IsEventDone( "get_planks_4" ) and
       cmn.IsEventDone( "get_nails_8" ) and
       cmn.IsEventDone( "get_goldennut" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_goldennut ()

  cmn.SetEventDone( "get_goldennut" );
  cmn.CallEventHandler( "get_goldennut" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_planks_4" ) and
       cmn.IsEventDone( "get_nails_8" ) and
       cmn.IsEventDone( "get_goldennut" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_rope ()

  cmn.SetEventDone( "get_rope" );
  cmn.CallEventHandler( "get_rope" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_folder" ) and
       cmn.IsEventDone( "get_areamap" ) and
       cmn.IsEventDone( "get_amuletmechanics" ) and
       cmn.IsEventDone( "get_collect2_1_3" ) and
       cmn.IsEventDone( "get_rope" ) ) then

    cmn.CloseSubRoom();

  end;

end;
---------------------------------------------------------------------------------
function private.get_collect2_1_3()

--function () int.AddCollectibles2( "spr_inthecar_collect2_1_3" ) end;

  int.AddCollectibles2( "spr_inthecar_collect2_1_3" );

  local func_end = function ()

    if ( cmn.IsEventDone( "get_folder" ) and
         cmn.IsEventDone( "get_areamap" ) and
         cmn.IsEventDone( "get_amuletmechanics" ) and
         cmn.IsEventDone( "get_rope" ) ) then

      cmn.CloseSubRoom();

    end;

  end;

  ObjAnimate( "zz_inthecar", "alp", 0, 0, func_end,
  { 
    0.0, 0, 1.0, 
    0.7, 0, 1.0
  } );

end;

--*********************************************************************************************************************
function public.use_gloveboxslider ()

  local item = "inv_gloveboxslider";

  if ( cmn.ApplyObj( item, "gzz_bygrayscar_inthecar", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_inthecar" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_inthecar_use_gloveboxslider", true ) ) then

    cmn.CallEventHandler( "use_gloveboxslider_inv" );
    cmn.CallEventHandler( "use_gloveboxslider_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_gloveboxslider" );
      cmn.CallEventHandler( "use_gloveboxslider_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_use_gloveboxslider" );
    ObjAnimate( "spr_inthecar_pin", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    ObjAnimate( "spr_inthecar_runner1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_carkeys ()

  local item = "inv_carkeys";

  if ( cmn.ApplyObj( item, "gzz_bygrayscar_trunk", false ) ) and
     ( cmn.IsEventDone( "clk_bygrayscar_survey" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_trunk" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_trunk_use_carkeys", true ) ) and
         ( cmn.IsEventDone( "clk_bygrayscar_survey" ) )then

    cmn.CallEventHandler( "use_carkeys_inv" );
    cmn.CallEventHandler( "use_carkeys_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_carkeys" );
      cmn.CallEventHandler( "use_carkeys_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_insert_carkey" ); 
    ObjAnimate( "spr_trunk_key_1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_amuletmechanics ()

  local item = "inv_amuletmechanics";

  if ( cmn.ApplyObj( item, "gzz_bygrayscar_trunk", false ) and 
       cmn.IsEventDone( "clk_carkeys" ) )  then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_trunk" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_trunk_use_amuletmechanics", true ) and
           cmn.IsEventDone( "clk_carkeys" ) ) then

    cmn.CallEventHandler( "use_amuletmechanics_inv" );
    cmn.CallEventHandler( "use_amuletmechanics_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_amuletmechanics" );
      cmn.CallEventHandler( "use_amuletmechanics_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_apply_nut" );
    ObjAnimate( "spr_trunk_amulet", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 1.0,
      0.9, 0, 0.0 
    } );
    ObjAnimate( "obj_trunk_open_box", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.6, 0, 0.0,
      0.9, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
-------------------------------------------------
-------------------------------------------------
function public.use_machete_0 ()

  local item = "inv_machete";

  if ( cmn.ApplyObj( item, "gzz_bygrayscar_path", false ) and 
       cmn.IsEventDone( "get_purse" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_path" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_path_use_machete_0", true ) and
           cmn.IsEventDone( "get_purse" ) ) then

    --interface.ObjDoNotDrop( item );

    cmn.CallEventHandler( "use_machete_0_inv" );
    cmn.CallEventHandler( "use_machete_0_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_machete_0" );
      cmn.CallEventHandler( "use_machete_0_end" );
      int.Lock( false );

    end;

      ObjSet( "anm_path_block0", { alp = 1 } );
      ObjSet( "anm_path_block0_static", { alp = 0 } );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_cut_bushes1" );
      AnimPlay( "anm_path_block0", "DoAnim", func_end ) 

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_machete_1 ()

  local item = "inv_machete";

  if ( cmn.ApplyObj( item, "gzz_bygrayscar_path", false ) and 
       cmn.IsEventDone( "use_machete_0" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_path" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_path_use_machete_1", true ) and
           cmn.IsEventDone( "use_machete_0" ) ) then

    --interface.ObjDoNotDrop( item );

    cmn.CallEventHandler( "use_machete_1_inv" );
    cmn.CallEventHandler( "use_machete_1_beg" );
    int.Lock( true );

    local func_end = function ()

      local func_end = function ()

        cmn.SetEventDone( "use_machete_1" );
        cmn.CallEventHandler( "use_machete_1_end" );
        int.Lock( false );
        cmn.CloseSubRoom();

      end;

       ObjAnimate( "obj_path_back", "scale_xy", 0, 0, "",
      { 
        0.0, 0, 0.56, 0.56,
        0.3, 0, 0.78, 0.78
      } );
       ObjAnimate( "obj_path_back", "pos_xy", 0, 0, "",
      { 
        0.0, 0, 0.0, 0.0,
        0.3, 0, 1, -30
      } );
       ObjAnimate( "spr_path_1st_plane_left", "scale_xy", 0, 0, "",
      { 
        0.0, 0, 2, 2,
        0.3, 0, 2.4, 2.4
      } );
       ObjAnimate( "spr_path_1st_plane_right", "scale_xy", 0, 0, "",
      { 
        0.0, 0, 2, 2,
        0.3, 0, 2.4, 2.4
      } );
       ObjAnimate( "spr_path_1st_plane_left", "pos_xy", 0, 0, "",
      { 
        0.0, 0, -266, 2,
        0.3, 0, -379, 52
      } );
       ObjAnimate( "spr_path_1block_light", "alp", 0, 0, "",
      { 
        0.0, 0, 1,
        0.3, 0, 0
      } );
       ObjAnimate( "spr_path_1st_plane_right", "scale_xy", 0, 0, "",
      { 
        0.0, 0, 2, 2,
        0.3, 0, 2.4, 2.4
      } );
       ObjAnimate( "spr_path_light", "pos_y", 0, 0, func_end,
      { 
        0.0, 0, -345,
        0.3, 0, -184
      } );
      --[[
       ObjAnimate( "spr_path_2block_light_1", "pos_xy", 0, 0, "",
      { 
        0.0, 0, -2, -2,
        0.3, 0, -2, 35
      } );
       ObjAnimate( "spr_path_2block_light_1", "scale_xy", 0, 0, "",
      { 
        0.0, 0, 2.31, 2.4,
        0.3, 0, 1.7, 1.7
      } );
       ObjAnimate( "spr_path_2block_light_2", "pos_xy", 0, 0, "",
      { 
        0.0, 0, -2, -2,
        0.3, 0, -2, 35
      } );
       ObjAnimate( "spr_path_2block_light_2", "scale_xy", 0, 0, func_end,
      { 
        0.0, 0, 2.31, 2.4,
        0.3, 0, 1.7, 1.7
      } );
      ]]
    end;

      ObjSet( "anm_path_block1", { alp = 1 } );
      ObjSet( "anm_path_block1_static", { alp = 0 } );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_cut_bushes2" );
      AnimPlay( "anm_path_block1", "DoAnim", func_end ) 

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
--[[
function public.use_machete_2 ()

  local item = "inv_machete";

  if ( cmn.ApplyObj( item, "gzz_bygrayscar_path", false ) and
       cmn.IsEventDone( "use_machete_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_path" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_path_use_machete_2", true ) and
           cmn.IsEventDone( "use_machete_1" ) ) then

    --interface.ObjDoNotDrop( item );

    cmn.CallEventHandler( "use_machete_2_inv" );
    cmn.CallEventHandler( "use_machete_2_beg" );
    int.Lock( true );

    local func_end = function ()

      local func_end = function ()
        cmn.SetEventDone( "use_machete_2" );
        cmn.CallEventHandler( "use_machete_2_end" );
        int.Lock( false );

      end;

       ObjAnimate( "obj_path_back", "scale_xy", 0, 0, "",
      { 
        0.0, 0, 0.78, 0.78,
        0.3, 0, 1.0, 1.0
      } );
       ObjAnimate( "obj_path_back", "pos_xy", 0, 0, "",
      { 
        0.0, 0, 1, -30,
        0.3, 0, -11, 64
      } );
       ObjAnimate( "anm_path_fog1", "alp", 0, 0, "",
      { 
        0.0, 0, 1,
        0.3, 0, 0
      } );
       ObjAnimate( "spr_path_2block_light_1", "alp", 0, 0, "",
      { 
        0.0, 0, 1,
        0.3, 0, 0
      } );
       ObjAnimate( "spr_path_2nd_plane", "pos_y", 0, 0, "",
      { 
        0.0, 0, 132,
        0.3, 0, 163
      } );
       ObjAnimate( "spr_path_light", "pos_y", 0, 0, "",
      { 
        0.0, 0, -184,
        0.3, 0, -213
      } );
       ObjAnimate( "spr_path_2block_light_1", "pos_xy", 0, 0, "",
      { 
        0.0, 0, -2, 35,
        0.3, 0, 9, -62
      } );
       ObjAnimate( "spr_path_2block_light_1", "scale_xy", 0, 0, "",
      { 
        0.0, 0, 1.7, 1.7,
        0.3, 0, 1.35, 1.35
      } );
       ObjAnimate( "spr_path_2block_light_2", "pos_xy", 0, 0, "",
      { 
        0.0, 0, -2, 35,
        0.3, 0, 9, -62
      } );
       ObjAnimate( "spr_path_2block_light_2", "scale_xy", 0, 0, func_end,
      { 
        0.0, 0, 1.7, 1.7,
        0.3, 0, 1.35, 1.35
      } );

    end;

      ObjSet( "anm_path_block2", { alp = 1 } );
      ObjSet( "anm_path_block2_static", { alp = 0 } );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_cut_bushes3" );
      AnimPlay( "anm_path_block2", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_machete_3 ()

  local item = "inv_machete";

  if ( cmn.ApplyObj( item, "gzz_bygrayscar_path", false ) and
       cmn.IsEventDone( "use_machete_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_path" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_path_use_machete_3", true ) and
           cmn.IsEventDone( "use_machete_2" ) ) then

    cmn.CallEventHandler( "use_machete_3_inv" );
    cmn.CallEventHandler( "use_machete_3_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_machete_3" );
      cmn.CallEventHandler( "use_machete_3_end" );
      int.Lock( false );

      cmn.CloseSubRoom();

      cmn.TutorialShow( "tutorial_page_8" );
      cmn.TutorialSetShown( "tutorial_page_8" );

    end;

      ObjSet( "anm_path_block3", { alp = 1 } );
      ObjSet( "anm_path_block3_static", { alp = 0 } );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_cut_bushes4" );
      AnimPlay( "anm_path_block3", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
]]
-------------------------------------------------
-------------------------------------------------
function public.use_hammer_2 ()

  local item = "inv_hammer";

  if ( cmn.ApplyObj( item, "gzz_bygrayscar_pointer", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pointer" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_pointer_use_hammer", true ) ) then

    cmn.CallEventHandler( "use_hammer_2_inv" );
    cmn.CallEventHandler( "use_hammer_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_hammer_2" );
      cmn.CallEventHandler( "use_hammer_2_end" );
      int.Lock( false );
      private.get_planks_4 ();
      private.get_nails_8 ();

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_hammer_squirrel_app" );
    ObjStopAnimate( "spr_pointer_plate1", "ang" );
    ObjStopAnimate( "spr_pointer_plate2", "ang" );
    ObjSet( "spr_pointer_plate1", { ang = 0 } );
    ObjSet( "spr_pointer_plate2", { ang = 0 } );
    ObjSet( "spr_pointer_plate1_nails_1", { alp = 0 } );
    ObjSet( "spr_pointer_plate1_nails_2", { alp = 0 } );
    ObjSet( "spr_pointer_plate2_nails_1", { alp = 0 } );
    ObjSet( "spr_pointer_plate2_nails_2", { alp = 0 } );
    ObjSet( "anm_pointer_hammer", { alp = 1 } );

    AnimPlay( "anm_pointer_hammer", "DoAnim", func_end ) 

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_handfulofnuts ()

  local item = "inv_handfulofnuts";

  if ( cmn.ApplyObj( item, "gzz_bygrayscar_pointer", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pointer" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_pointer_use_handfulofnuts", true ) ) then

    cmn.CallEventHandler( "use_handfulofnuts_inv" );
    cmn.CallEventHandler( "use_handfulofnuts_beg" );
    int.Lock( true );

    local func_end = function ()

      ObjSet( "anm_pointer_squirrel_static_2", { playing = true, alp = 1 } );
      ObjSet( "anm_pointer_squirrel_nuts", { alp = 0 } );
      ObjSet( "spr_pointer_goldennut", { alp = 1 } );

      local func_end = function ()
        
        private.get_goldennut();
        cmn.SetEventDone( "use_handfulofnuts" );
        cmn.CallEventHandler( "use_handfulofnuts_end" );
        int.Lock( false );
        cmn.CloseSubRoom();

      end;

      ObjAnimate( "spr_pointer_back_branch1", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 1,
        0.6, 0, 1
      } );

    end;

    ObjSet( "anm_pointer_squirrel_static", { alp = 0 } );
    ObjSet( "anm_pointer_squirrel_nuts", { alp = 1 } );

    ObjAnimate( "anm_pointer_squirrel_nuts", "alp", 0, 0, function () --cmn.CallEventHandler( "get_goldennut_inv" );
      end, 
    {
      0.0, 0, 1,
      1.5, 0, 1
    } );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_squirrel_nuts" );
    AnimPlay( "anm_pointer_squirrel_nuts", "DoAnim", func_end ) 

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_jack ()

  local item = "inv_jack";

  if ( cmn.ApplyObj( item, "gzz_bygrayscar_wheels", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wheels" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wheels_use_jack", true ) ) then

    cmn.CallEventHandler( "use_jack_inv" );
    cmn.CallEventHandler( "use_jack_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_jack" );
      cmn.CallEventHandler( "use_jack_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_jack_app" );
    AnimPlay( "anm_wheels_jack_use", "DoAnim", func_end );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_pump ()

  local item = "inv_pump";

  if ( cmn.ApplyObj( item, "gzz_bygrayscar_wheels", false ) and
       cmn.IsEventDone( "use_wheel_1" ) and
       cmn.IsEventDone( "clk_jack" ) and
       cmn.IsEventDone( "use_wheel_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wheels" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wheels_use_pump", true ) and
           cmn.IsEventDone( "use_wheel_1" ) and
           cmn.IsEventDone( "clk_jack" ) and
           cmn.IsEventDone( "use_wheel_2" ) ) then

    cmn.CallEventHandler( "use_pump_inv" );
    cmn.CallEventHandler( "use_pump_beg" );
    int.Lock( true );

    local func_end = function ()

      --cmn.StopAudio( "sfx", "audio/level1/sfx/aud_watch" );
      --cmn.StopAudio( "voc", "audio/level1/voc/aud_watch_voc" );

      cmn.SetEventDone( "use_pump" );
      cmn.CallEventHandler( "use_pump_end" );
      int.Lock( false );
      cmn.CloseSubRoom();
      private.SeePresentTransfer();
      ObjSet( "rm_bygrayscar", { color_r = 0, color_g = 0, color_b = 0 } );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_pump_app" );  
    AnimPlay( "anm_wheels_pump_use", "DoAnim",  function () int.ShowTaskNote( 3, func_end ); end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
function public.use_wheel ()

  local item = "inv_wheel";

  if ( cmn.ApplyObj( item, "gzz_bygrayscar_wheels", false ) and 
      cmn.IsEventDone( "get_wheel" ) and
      cmn.IsEventDone( "get_wheel_2" ) and
      cmn.IsEventDone( "use_wheelwrench_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wheels" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wheels_use_wheel", true ) and
          cmn.IsEventDone( "get_wheel" ) and
          cmn.IsEventDone( "get_wheel_2" ) and
          cmn.IsEventDone( "use_wheelwrench_1" ) ) then

    cmn.CallEventHandler( "use_wheel_inv" );
    cmn.CallEventHandler( "use_wheel_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_wheel" );
      cmn.CallEventHandler( "use_wheel_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_unpack_wheels" );
    ObjAnimate( "obj_wheels_new_wheels", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_bicycle ()

  local item = "inv_bicycle";

  if ( cmn.ApplyObj( item, "obj_bygrayscar_use_bicycle", true ) ) then

    cmn.CallEventHandler( "use_bicycle_inv" );
    cmn.CallEventHandler( "use_bicycle_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_bicycle" );
      cmn.CallEventHandler( "use_bicycle_end" );
      int.Lock( false );
      ObjSet( "rm_bygrayscar", { color_r = 0, color_g = 0, color_b = 0 } );
      cmn.GotoRoom( "rm_track" );
      cmn.StopAudio( "sfx", "audio/level1/sfx/aud_bicycle_ride" );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_bike_app" );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_bicycle_ride" );
--  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_bicycle" );  
    --ObjAnimate( "spr", "alp", 0, 0, func_end,
    --{ 
    --  0.0, 0, 0.0, 
    --  0.3, 0, 1.0
    --} );

    common_impl.PlayDialogVideo( "vid_bygrayscar_bike", func_end ); 

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_wheelwrench_1 ()

  local item = "inv_wheelwrench";

  if ( cmn.ApplyObj( item, "gzz_bygrayscar_wheels", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wheels" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wheels_use_wheelwrench_1", true ) and
           cmn.IsEventDone( "use_jack" ) ) then

    cmn.CallEventHandler( "use_wheelwrench_1_inv" );
    cmn.CallEventHandler( "use_wheelwrench_1_beg" );

    int.Lock( true );

    local func_end = function ()

      local func_end2 = function ()

        cmn.SetEventDone( "use_wheelwrench_1" );
        cmn.CallEventHandler( "use_wheelwrench_1_end" );
        int.Lock( false );

      end;  
 
      ObjAnimate( "obj_wheels_old_wheels", "alp", 0, 0, func_end2,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );

      ObjAnimate( "vid_wheels_wheels", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );

      --ObjAnimate( "spr_wheels_wheelwrench", "alp", 0, 0, "",
      --{ 
      --  0.0, 0, 0.0, 
      --  0.3, 0, 1.0
      --} );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_unscrew_wheels" );

    ObjSet( "spr_wheels_bolts_1", { alp = 0 } );
    --ObjSet( "spr_wheels_wheelwrench", { alp = 0 } );
    ObjSet( "vid_wheels_wheels_1", { alp = 1 } );
    VidPlay( "vid_wheels_wheels_1", func_end );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wheels_use_wheelwrench_1", true ) and
           not cmn.IsEventDone( "use_jack" ) ) then

      cmn.ShowBbt( "bbt_bygrayscar_use_wrong" );
      cmn.PlayAudio( "sfx", "audio/aud_wrongapply1", 0, "", 0 );
      return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_wheelwrench_2 ()

  local item = "inv_wheelwrench";

  if ( cmn.ApplyObj( item, "gzz_bygrayscar_wheels", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wheels" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wheels_use_wheelwrench_2", true ) and
           cmn.IsEventDone( "use_wheel_1" ) and
           cmn.IsEventDone( "use_wheel_2" ) ) then

    cmn.CallEventHandler( "use_wheelwrench_2_inv" );
    cmn.CallEventHandler( "use_wheelwrench_2_beg" );

    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_wheelwrench_2" );
      cmn.CallEventHandler( "use_wheelwrench_2_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_screw_wheels" );
 
    --ObjAnimate( "spr", "alp", 0, 0, func_end,
    --{ 
    --  0.0, 0, 0.0, 
    --  0.3, 0, 1.0
    --} );
    --ObjSet( "spr_wheels_wheelwrench", { alp = 0 } );
    ObjSet( "spr_wheels_bolts_2", { alp = 0 } );

    ObjSet( "vid_wheels_wheels_2", { alp = 1 } );
    VidPlay( "vid_wheels_wheels_2", func_end );
    --func_end();

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function private.SeePresentTransfer ()

  local func_end = function ()

    cmn.StopAudio( "sfx", "audio/level1/sfx/aud_back_in_past" );

    cmn.SetEventDone( "use_wheelwrench_2" );
    cmn.CallEventHandler( "use_wheelwrench_2_end" );

    cmn.GotoRoom( "rm_policestation" );

    int.Lock( false );

  end;

  common_impl.PlayDialogVideo( "vid_bygrayscar_present_transfer", func_end ); 

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_back_in_past" );

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_bygrayscar_survey ()

  local func_end = function ()

    cmn.SetEventDone( "clk_bygrayscar_survey" );
    cmn.CallEventHandler( "clk_bygrayscar_survey_end" );
    cmn.CallEventHandler( "clk_bygrayscar_survey" );
    cmn.StopAudio( "sfx", "audio/level1/sfx/aud_bygrayscar_survey_1_mus" );
    cmn.StopAudio( "voc", "audio/level1/voc/aud_bygrayscar_survey_1_voc" );
    cmn.PlayAudio( "mus", "audio/aud_moov_mus" );
    int.Lock( false );
    --cmn.ShowBbt( "bbt_bygrayscar_after_survey" );

    cmn.TutorialShow( "tutorial_page_3" );
    cmn.TutorialSetShown( "tutorial_page_3" );

    cmn.AddPageDiary( 2 );

  end;

  cmn.CallEventHandler( "clk_bygrayscar_survey_beg" );

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_bygrayscar_survey_1", func_end ); 

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_bygrayscar_survey_1_mus" );
  cmn.PlayAudio( "voc", "audio/level1/voc/aud_bygrayscar_survey_1_voc" );

end;
-------------------------------------------------
function private.clk_box ()

  local func_end = function ()

    cmn.SetEventDone( "clk_box" );
    cmn.CallEventHandler( "clk_box_end" );
    cmn.CallEventHandler( "clk_box" );
    int.Lock( false );

  end;

  int.Lock( true );

  ObjAnimate( "obj_inthecar_anim", "pos_xy", 0, 0, "",
  { 
    0.0, 3, 0, 0,
    0.3, 3, 0, 0,
    0.7, 3, -118, -40
  } );

  ObjAnimate( "obj_inthecar_open_box", "alp", 0, 0, func_end,
  { 
    0.0, 0, 0, 
    0.7, 0, 0, 
    1.0, 0, 1
  } );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_app_slider" );

end;
-------------------------------------------------
function private.clk_carkeys ()

  local func_end = function ()

    cmn.SetEventDone( "clk_carkeys" );
    cmn.CallEventHandler( "clk_carkeys_end" );
    cmn.CallEventHandler( "clk_carkeys" );

    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_carkeys_beg" );

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_open_trunk" );
  ObjAnimate( "spr_trunk_key_1", "alp", 0, 0, "", 
  { 
    0.0, 0, 1,
    0.3, 0, 0
  } );
  ObjAnimate( "spr_trunk_key_2", "alp", 0, 0, "", 
  { 
    0.0, 0, 0,
    0.3, 0, 1
  } );
  ObjAnimate( "obj_trunk_close_car", "alp", 0, 0, "", 
  { 
    0.0, 0, 1,
    0.6, 0, 1,
    0.9, 0, 0
  } );
  ObjAnimate( "obj_trunk_open_car", "alp", 0, 0, func_end, 
  { 
    0.0, 0, 0,
    0.6, 0, 0,
    0.9, 0, 1
  } );

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_wheel_1 ()

  ObjSet( "spr_wheels_wheel_new1_1_shadow", { alp = 0 } );
  ObjSet( "spr_wheels_wheel_new1_1", { pos_z = 10 } );

end;
-------------------------------------------------
function private.use_wheel_1 ()

  local func_end = function ()

    cmn.SetEventDone( "use_wheel_1" );
    cmn.CallEventHandler( "use_wheel_1_end" );
    cmn.CallEventHandler( "use_wheel_1" );

    int.Lock( false );

  end;

  int.Lock( true );

  if ( cmn.ApplyObj( "obj_wheels_wheel_new1_1_tmp", "obj_wheels_use_wheels", true ) ) then

    ObjSet( "spr_wheels_wheel_new1_1", { alp = 0 } );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_place_wheel" );
    ObjAnimate( "spr_wheels_wheel_new_1", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.3, 0, 1
    } );

  else 

    ObjSet( "spr_wheels_wheel_new1_1_shadow", { alp = 1 } );
    ObjSet( "spr_wheels_wheel_new1_1", { pos_z = 2 } );
    int.Lock( false );

  end;

end;
-------------------------------------------------
function private.clk_wheel_2 ()

  ObjSet( "spr_wheels_wheel_new1_2_shadow", { alp = 0 } );
  ObjSet( "spr_wheels_wheel_new1_2", { pos_z = 10 } );

end;
-------------------------------------------------
function private.use_wheel_2 ()

  local func_end = function ()

    cmn.SetEventDone( "use_wheel_2" );
    cmn.CallEventHandler( "use_wheel_2_end" );
    cmn.CallEventHandler( "use_wheel_2" );

    int.Lock( false );

  end;

  int.Lock( true );

  if ( cmn.ApplyObj( "obj_wheels_wheel_new1_2_tmp", "obj_wheels_use_wheels", true ) ) then

    ObjSet( "spr_wheels_wheel_new1_2", { alp = 0 } );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_place_wheel" );
    ObjAnimate( "spr_wheels_wheel_new_2", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.3, 0, 1
    } );

  else 

    ObjSet( "spr_wheels_wheel_new1_2_shadow", { alp = 1 } );
    ObjSet( "spr_wheels_wheel_new1_2", { pos_z = 1 } );
    int.Lock( false );

  end;

end;
-------------------------------------------------
function private.clk_jack ()

  local func_end = function ()

    cmn.SetEventDone( "clk_jack" );
    cmn.CallEventHandler( "clk_jack_end" );
    cmn.CallEventHandler( "clk_jack" );
    int.Lock( false );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_jack_disapp" );
  AnimPlay( "anm_wheels_car_down", "DoAnim", func_end );
  AnimPlay( "anm_wheels_car_down_bolts", "DoAnim", "" );
 
end;
-------------------------------------------------
-------------------------------------------------
function private.InitAnimations ()

  ObjAnimate( "spr_wheels_branch", "ang", 1, 0, "", 
  { 
    0.0, 3, -0.05,
    3.0, 3, 0,
    6.0, 3, -0.05
  } );
  --[[
  ObjAnimate( "spr_wheels_light_add", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.5, 0, 0.4,
    3.0, 0, 1
  } );
  ObjAnimate( "spr_trunk_light", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.5, 0, 0.4,
    3.0, 0, 1
  } );
  ObjAnimate( "spr_path_light", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.5, 0, 0.4,
    3.0, 0, 1
  } );
  ]]
  ObjAnimate( "spr_pointer_back_branch1", "ang", 1, 0, "", 
  { 
    0.0, 3, 0.025,
    1.7, 3, 0.0,
    3.4, 3, 0.025
  } );
  ObjAnimate( "spr_pointer_back_branch2", "ang", 1, 0, "", 
  { 
    0.0, 3, -0.02,
    2.0, 3, 0.0,
    4.0, 3, -0.02
  } );
  ObjAnimate( "spr_pointer_branch_1st", "ang", 1, 0, "", 
  { 
    0.0, 3, -0.025,
    1.8, 3, 0.0,
    3.6, 3, -0.025
  } );
  ObjAnimate( "spr_pointer_plate1", "ang", 1, 0, "", 
  { 
    0.0, 0, 0.015,
    1.8, 0, 0.0,
    3.6, 0, 0.015
  } );
  ObjAnimate( "spr_pointer_plate2", "ang", 1, 0, "", 
  { 
    0.0, 0, -0.02,
    1.5, 0, 0.0,
    3.0, 0, -0.02
  } );
  ObjAnimate( "spr_inthecar_amuletmechanics_add", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.5, 0, 0.5,
    3.0, 0, 1
  } );
  ObjAnimate( "spr_pointer_light_add", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.5, 0, 0.3,
    3.0, 0, 1
  } );

  ObjAnimate( "obj_bygrayscar_clouds", "pos_x", 1, 0, "", 
  {
    0.0, 0, 0,
    85.0, 0, -864
  } );

  ObjAnimate( "spr_inthecar_nat", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.6,
    2.0, 0, 1,
    3.0, 0, 0.6,
    4.0, 0, 1,
    5.0, 0, 0.6,
    6.0, 0, 1,
    7.0, 0, 0.6,
    8.0, 0, 1,
    8.2, 0, 0.6,
    8.4, 0, 1,
    8.6, 0, 0.6,
    8.8, 0, 1
  } );

  ObjAnimate( "spr_bygrayscar_man", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.6,
    2.0, 0, 1,
    3.0, 0, 0.6,
    4.0, 0, 1,
    5.0, 0, 0.6,
    6.0, 0, 1,
    7.0, 0, 0.6,
    8.0, 0, 1,
    8.2, 0, 0.6,
    8.4, 0, 1,
    8.6, 0, 0.6,
    8.8, 0, 1
  } );

  ObjAnimate( "spr_inthecar_pin_hotspot_add", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.5, 0, 0,
    3.0, 0, 1
  } );

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "opn_track",                { "use_bicycle" } );
  int.AddedTaskMap( private.room_objname, "opn_abandonedfarm",        { "use_machete_3" } );

  int.AddedTaskMap( private.room_objname, "get_folder" );
  int.AddedTaskMap( private.room_objname, "get_rope" );
  int.AddedTaskMap( private.room_objname, "get_areamap",              { "use_gloveboxslider" } );
  int.AddedTaskMap( private.room_objname, "get_amuletmechanics",      { "use_gloveboxslider" } );
  int.AddedTaskMap( private.room_objname, "get_machete",              { "use_amuletmechanics" } );
  int.AddedTaskMap( private.room_objname, "get_extinguisher",         { "use_amuletmechanics" } );
  int.AddedTaskMap( private.room_objname, "get_smallbattery_1",       { "use_antirustsolution_2" } );
  int.AddedTaskMap( private.room_objname, "get_skull",                { "use_antirustsolution_2" } );
  int.AddedTaskMap( private.room_objname, "get_purse" );
  int.AddedTaskMap( private.room_objname, "get_planks_4",             { "use_hammer_2" } );
  int.AddedTaskMap( private.room_objname, "get_nails_8",              { "use_hammer_2" } );
  int.AddedTaskMap( private.room_objname, "get_goldennut",            { "use_handfulofnuts" } );

  int.AddedTaskMap( private.room_objname, "use_wheel_1",              { "use_wheel" } );
  int.AddedTaskMap( private.room_objname, "use_wheel_2",              { "use_wheel" } );
  int.AddedTaskMap( private.room_objname, "use_gloveboxslider",       { "get_gloveboxslider" } );
  int.AddedTaskMap( private.room_objname, "use_carkeys",              { "get_carkeys" } );
  int.AddedTaskMap( private.room_objname, "use_amuletmechanics",      { "use_carkeys" } );
  int.AddedTaskMap( private.room_objname, "use_machete_0",            { "get_machete" } );
  int.AddedTaskMap( private.room_objname, "use_machete_1",            { "get_machete" } );
  --int.AddedTaskMap( private.room_objname, "use_machete_2",            { "get_machete" } );
  --int.AddedTaskMap( private.room_objname, "use_machete_3",            { "get_machete" } );
  int.AddedTaskMap( private.room_objname, "use_hammer_2",             { "get_hammer" } );
  int.AddedTaskMap( private.room_objname, "use_handfulofnuts",        { "get_nut" } );
  int.AddedTaskMap( private.room_objname, "use_jack",                 { "get_jack" } );
  int.AddedTaskMap( private.room_objname, "use_pump",                 { "get_pump", "clk_jack" } );
  int.AddedTaskMap( private.room_objname, "use_wheel",                { "get_wheel", "get_wheel_2", "use_wheelwrench_1" } );
  int.AddedTaskMap( private.room_objname, "use_bicycle",              { "get_bicycle" } );
  int.AddedTaskMap( private.room_objname, "use_wheelwrench_1",        { "use_jack", "get_wheelwrench" } );
  int.AddedTaskMap( private.room_objname, "use_wheelwrench_2",        { "use_wheel_1", "use_wheel_2", "get_wheelwrench" } );

  int.AddedTaskMap( private.room_objname, "clk_jack",                 { "use_wheelwrench_2" } );
  int.AddedTaskMap( private.room_objname, "clk_carkeys",              { "use_carkeys" } );
  int.AddedTaskMap( private.room_objname, "clk_box",                  { "use_gloveboxslider" } );  

end;
--*********************************************************************************************************************
function private.opn_bygrayscar ()

  if not ( cmn.IsEventDone( "opn_bygrayscar" ) ) then

    cmn.SetEventDone( "opn_bygrayscar" );
    ng_global.progress[ "std" ][ "opn_bygrayscar" ].wheel_open = 0;
    ng_global.progress[ "std" ][ "opn_bygrayscar" ].inthecar = false;    

    int.Lock( true );

    ObjAnimate( "rm_bygrayscar", "scale_xy", 0, 0,
    function ()

      int.Lock( false );
      int.ShowTaskNote();
      cmn.ShowBbt( "bbt_bygrayscar_show_note" );

    end, 
    {
      0.0, 3, 1.0, 1.0,
      0.3, 3, 1.0, 1.0,
      1.0, 3, 1.3, 1.3,
      2.5, 3, 1.3, 1.3,
      3.2, 3, 1.0, 1.0,
    } );

    ObjAnimate( "rm_bygrayscar", "pos_xy", 0, 0, "", 
    {
      0.0, 3,  0,    0,
      0.3, 3,  0,    0,
      1.0, 3, 0, -230,
      2.5, 3, 0, -230,
      3.2, 3,  0,    0,
    } );

    ObjAnimate( "rm_bygrayscar", "pos_z", 0, 0, "", 
    {
      0.0, 3, 55,
      1.3, 3, 55,
    } );

  end;

end;
--*********************************************************************************************************************
function public.Load ()
  -- ���������� ����� ����� �������� �������

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopAllEnv( "audio/level1/env/aud_bygrayscar_env", true );
  cmn.PlayAudio( "env", "audio/level1/env/aud_bygrayscar_env", 1 );

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_bygrayscar();

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_wheels" );
  subroom.Define( "zz_inthecar" );
  subroom.Define( "zz_pointer" );

  -------------------------------------------------
  function zz_wheels.Open()

    if ng_global.progress[ "std" ][ "opn_bygrayscar" ].wheel_open == 0 then

      cmn.ShowBbt( "bbt_wheels_first_entry" );
      ng_global.progress[ "std" ][ "opn_bygrayscar" ].wheel_open = 1;

    end;

  end;
  -------------------------------------------------
  function zz_wheels.Close()
  end;
  -------------------------------------------------
  function zz_inthecar.Open()

    if ( not ng_global.progress[ "std" ][ "opn_bygrayscar" ].inthecar ) then

      ng_global.progress[ "std" ][ "opn_bygrayscar" ].inthecar = true;

      cmn.TutorialShow( "tutorial_page_4" );
      cmn.TutorialSetShown( "tutorial_page_4" );

    end;

  end;
  -------------------------------------------------
  function zz_pointer.Open()
  end;
  -------------------------------------------------
  function zz_pointer.Close()
  end;
  -------------------------------------------------

end;
--*********************************************************************************************************************
function private.clk_car ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_trunk_use_carkeys" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_clk_trunk" );
  ObjAnimate( "obj_trunk_close_car", "pos_x", 0, 0, func_end, 
  { 
    0.0, 3, 0,
    0.3, 3, -1,
    0.6, 3, 0
  } );

end;
--*********************************************************************************************************************
function private.clk_runner ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_inthecar_use_gloveboxslider" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_clk_metal1" );
  ObjAnimate( "obj_inthecar_anim", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 0, 0, 0,
    0.3, 0, -14, -6,
    0.6, 0, 0, 0
  } );

end;
--*********************************************************************************************************************
function private.clk_squirrel ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_pointer_use_handfulofnuts" );
    ObjSet( "anm_pointer_squirrel_static", { alp = 1 } );
    ObjSet( "anm_pointer_squirrel_click", { alp = 0 } );
    int.Lock( false );

  end;

  int.Lock( true );

  ObjSet( "anm_pointer_squirrel_static", { alp = 0 } );
  ObjSet( "anm_pointer_squirrel_click", { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_squirrel_touch" );
  AnimPlay( "anm_pointer_squirrel_click", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.TrunkBoxCoverClick ()

  int.Lock( true );

  local func_end = function ()

    cmn.ShowBbt( "bbt_trunk_use_amuletmechanics" );

    int.Lock( false );

  end;

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_box2_touch" );
  ObjAnimate( "spr_trunk_box_cover", "pos_x", 0, 0, func_end, 
  {
    0.0, 3, 41,
    0.2, 3, 42,
    0.4, 3, 40,
    0.6, 3, 42,
    0.8, 3, 41,
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.ClkPlate ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_pointer_use_hammer" );
    ObjAnimate( "spr_pointer_plate1", "ang", 1, 0, "", 
    { 
      0.0, 0, 0.015,
      1.8, 0, 0.0,
      3.6, 0, 0.015
    } );
    ObjAnimate( "spr_pointer_plate2", "ang", 1, 0, "", 
    { 
      0.0, 0, -0.02,
      1.5, 0, 0.0,
      3.0, 0, -0.02
    } );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_wood_squirrel_touch" );

  ObjAnimate( "spr_pointer_plate1", "ang", 0, 0, "", 
  { 
    0.0, 3, 0.015,
    0.3, 3, 0.05,
    0.6, 3, 0.015
  } );

  ObjAnimate( "spr_pointer_plate2", "ang", 0, 0, func_end, 
  { 
    0.0, 3, -0.02,
    0.3, 3, 0.05,
    0.6, 3, -0.02
  } );

end;
--*********************************************************************************************************************
function private.ClkOpen ()

  local func_end = function ()

    int.Lock( false );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_clk_open" );
  AnimPlay( "anm_path_opentrunk", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.ClkNote ( flag )

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/aud_paper" );

  if ( flag == 0 )then

    local func_end = function ()

      private.ClkNoteEnd( flag );

    end;

    ObjSet( "spr_bygrayscar_note_1", { scale_x = 1 } );
    ObjSet( "spr_bygrayscar_note_2", { scale_x = 0 } );

    ObjAnimate( "spr_bygrayscar_note", "alp", 0, 0, "", 
    { 
      0.0, 0, 1,
      0.3, 0, 0
    } );

    ObjAnimate( "obj_bygrayscar_note", "pos_xy", 0, 0, "", 
    { 
      0.0, 3, ObjGet( "spr_bygrayscar_note" ).pos_x, ObjGet( "spr_bygrayscar_note" ).pos_y,
      0.3, 3, 512, 384
    } );

    ObjAnimate( "obj_bygrayscar_note", "scale_xy", 0, 0, func_end, 
    { 
      0.0, 3, 0, 0,
      0.3, 3, 1, 1
    } );

  elseif ( flag == 1 )then

    local func_end = function ()

      private.ClkNoteEnd( flag );

    end;

    ObjAnimate( "spr_bygrayscar_note_1", "scale_x", 0, 0, func_end, 
    { 
      0.0, 3, 0,
      0.3, 3, 0,
      0.6, 3, 1
    } );
    ObjAnimate( "spr_bygrayscar_note_2", "scale_x", 0, 0, "", 
    { 
      0.0, 3, 1,
      0.3, 3, 0
    } );

  elseif ( flag == 2 )then

    local func_end = function ()

      private.ClkNoteEnd( flag );

    end;

    ObjAnimate( "spr_bygrayscar_note_1", "scale_x", 0, 0, "", 
    { 
      0.0, 3, 1,
      0.3, 3, 0,
    } );
    ObjAnimate( "spr_bygrayscar_note_2", "scale_x", 0, 0, func_end, 
    { 
      0.0, 3, 0,
      0.3, 3, 0,
      0.6, 3, 1
    } );

  elseif ( flag == 3 )then

    local func_end = function ()

      private.ClkNoteEnd( flag );

    end;

    ObjAnimate( "spr_bygrayscar_note", "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      0.3, 0, 1
    } );

    ObjAnimate( "obj_bygrayscar_note", "pos_xy", 0, 0, "", 
    { 
      0.0, 3, 512, 384,
      0.3, 3, ObjGet( "spr_bygrayscar_note" ).pos_x, ObjGet( "spr_bygrayscar_note" ).pos_y
    } );

    ObjAnimate( "obj_bygrayscar_note", "scale_xy", 0, 0, func_end, 
    { 
      0.0, 3, 1, 1,
      0.3, 3, 0, 0
    } );

  end;

end;
--*********************************************************************************************************************
function private.ClkNoteEnd( flag )

  if ( flag == 0 )then

    ObjSet( "obj_bygrayscar_note", { input = true } );

  elseif ( flag == 1 )then

  elseif ( flag == 2 )then

  elseif ( flag == 3 )then

    ObjSet( "obj_bygrayscar_note", { input = false } );

  end;

  int.Lock( false );

end;
--*********************************************************************************************************************
