-- name=rm_bypolicestation
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_bypolicestation";
  ObjSet( "obj_bypolicestation_clk_jackie",        { event_mdown = private.dlg_jackie_1_click } );  
  ObjSet( "obj_bypolicestation_clk_jackie_focus",  { event_mdown = private.dlg_jackie_1_click } );  

  private.InitAnims();
  

  --------------------------------------------------------------------------------------------
  -- function dlg_bypolicestation_jackie_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_bypolicestation_jackie_1" ] =
  {
    type = "click",
    clk_obj = "obj_bypolicestation_clk_jackie",
    room = private.room_objname
  };
  -----------------------------------------------------------------------------------
  local dlg_bypolicestation_jackie_1_beg = function ()



  end;
  local dlg_bypolicestation_jackie_1_end = function ()

    ObjDelete( "obj_bypolicestation_clk_jackie" );
    ObjDelete( "anm_bypolicestation_jackie" );
    ObjDelete( "anm_bypolicestation_jackie_walk" );


  end;
  cmn.AddSubscriber( "dlg_bypolicestation_jackie_1", dlg_bypolicestation_jackie_1_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_bypolicestation_jackie_1", dlg_bypolicestation_jackie_1_end, private.room_objname );
  cmn.AddSubscriber( "dlg_bypolicestation_jackie_1_beg", dlg_bypolicestation_jackie_1_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_bypolicestation_jackie_1_end", dlg_bypolicestation_jackie_1_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_1_1 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_1_1 = function ()

    ObjDelete( "obj_bypolicestation_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_1_1", get_morphobject_1_1, private.room_objname );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_bypolicestation ()

  if not ( cmn.IsEventDone( "opn_bypolicestation" ) ) then

    cmn.SetEventDone( "opn_bypolicestation" );
    cmn.SetEventDone( "clk_policeman" );
    cmn.CallEventHandler( "clk_policeman" );

  end;

end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.PreOpen ()

  if ( not cmn.IsEventDone( "beg_level1" ) ) then

    common_impl.InterfaceSetVisible( false );
    ObjSet( "rm_bypolicestation", { color_r = 0, color_g = 0, color_b = 0 } );


  else 

    ObjDelete( "anm_bypolicestation_taxi" );

  end;

  cmn.StopAllEnv( "audio/level1/env/aud_bypolicestation_env", true );
  cmn.PlayAudio( "env", "audio/level1/env/aud_bypolicestation_env", 1 );

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_bypolicestation();

  if ( not cmn.IsEventDone( "beg_level1" ) ) then

    private.IntroLvl1Open();

  end;

end;
--*********************************************************************************************************************
--------------------------------------------------------------------
function private.IntroLvl1Open()

  cmn.StopAllMus();
  cmn.StopAllEnv();

  local func_end = function ()

    cmn.SetEventDone( "beg_level1" );
    ObjSet( "rm_bypolicestation", { color_r = 1, color_g = 1, color_b = 1 } );
    int.Lock( false );
    cmn.ShowBbt( "bbt_bypolicestation_open" );
    cmn.StopAudio( "sfx", "audio/level1/sfx/aud_intro_mus" );
    cmn.StopAudio( "voc", "audio/level1/voc/aud_intro_voc" );
    private.AnimTaxi();
    common_impl.InterfaceSetVisible( true );
    cmn.PlayAudio( "env", "audio/level1/env/aud_bypolicestation_env", 1 );

    local pages = ng_global.progress[ "std" ][ "see_tutorial" ].state.pages;

    if ( ng_global.progress[ "std" ][ "see_tutorial" ].start == 0 ) then

      cmn.TutorialShow( "tutorial_page_1" );

    end;

    cmn.AddPageDiary( 1 );

  end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_bypolicestation_intro", func_end );  

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_intro_mus" );
  cmn.PlayAudio( "voc", "audio/level1/voc/aud_intro_voc" );

end;

--*********************************************************************************************************************
-- dlg_jackie_1
--*********************************************************************************************************************
function private.dlg_jackie_1_click()

  local func_end = function ()
    int.Lock( true );
    ObjSet( "anm_bypolicestation_jackie_walk", { alp = 1} );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_jackie_into" );
    AnimPlay( "anm_bypolicestation_jackie_walk", "DoAnim", 
      function ()
        int.Lock( false );
        cmn.CallEventHandler( "dlg_bypolicestation_jackie_1_end" );
      end
    );
  end;

  ObjAttach( "dlg_bypolicestation_jackie_1", "rm_bypolicestation" );
  common_impl.dialog_character_loc = "";
  private.dialog_voices_time = { 3 };
  ObjSet( "anm_bypolicestation_jackie", { alp = 0 } );
  common_impl.DialogCharacterStart( "jackie_1", 1, nil, nil, false, func_end );

  ObjSet( "tmr_bypolicestation_fordial", { playing = 1, time = 0.3, endtrig = "" } );

end;

-------------------------------------------------
--*********************************************************************************************************************
function private.InitAnims ()

  ObjAnimate( "obj_bypolicestation_clouds", "pos_x", 1, 0, "", 
  {
    0.0, 0, 0,
    150.0, 0, 1374
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.AnimTaxi ()

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_taxi_away" );
  AnimPlay( "anm_bypolicestation_taxi", "DoAnim", "" );

end;
--*********************************************************************************************************************