-- name=rm_carrepairshop
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_carrepairshop";

  ObjAttach( "zz_workdesk",   "room_hub" );
  ObjAttach( "zz_onthefloor", "room_hub" );
  ObjAttach( "zz_mechanism",  "room_hub" );
  ObjAttach( "zz_motorcycle", "room_hub" );
  
  ObjMultiSet( {
    { "spr_workdesk_amuletcar",           { event_mdown = private.get_amuletcar } },
    { "spr_onthefloor_coin_2",            { event_mdown = private.get_coin_2 } },
    { "spr_onthefloor_wheel",             { event_mdown = private.get_wheel } },
    { "spr_onthefloor_screwdriver",       { event_mdown = private.get_screwdriver } },
    { "spr_motorcycle_pliers",            { event_mdown = private.get_pliers } },
    { "spr_motorcycle_insectspray",       { event_mdown = private.get_insectspray } },
    { "spr_motorcycle_lighter",           { event_mdown = private.get_lighter } },
    { "obj_workdesk_clk_winchlever",      { event_mdown = private.clk_winchlever } },
    { "obj_carrepairshop_clk_atropos",       { event_mdown = private.dlg_carrepairshop_atropos_1 } },
    { "obj_carrepairshop_clk_atropos_focus", { event_mdown = private.dlg_carrepairshop_atropos_1 } },
    { "obj_carrepairshop_clk_motorcycle", { event_mdown = function () private.MotorcycleClick() end } },
    { "spr_motorcycle_newspaper",         { event_mdown = function () private.clk_newspaper() end } },
    { "spr_workdesk_collect2_1_1",        { event_mdown = private.get_collect2_1_1 } },
    { "obj_motorcycle_use_crossed_bones", { event_mdown = function () private.BagClick("b") end } },
    { "obj_motorcycle_use_skull",         { event_mdown = function () private.BagClick("s") end } }
  } );

  private.InitSubroom();

  private.WorkdeskToolsInit();
  private.Anims();

  private.InitMechanism();

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    int.InitMorphRandomState( 1 );

  end;

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_carrepairshop = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gzz_carrepairshop_workdesk",
        "gzz_carrepairshop_mechanism",
        "gzz_carrepairshop_onthefloor",
        "gzz_carrepairshop_motorcycle",
        "gmg_carrepairshop_mgboxes",
        "gmg_carrepairshop_mgremovecollapse"
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_workdesk", 
        "zz_onthefloor", 
        "zz_mechanism", 
        "zz_motorcycle", 
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_carrepairshop", update_game_mode_carrepairshop, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_amuletcar () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletcar" ] =
  {
    type = "get",
    get_obj = "spr_workdesk_amuletcar",
    room = private.room_objname,
    zz = "zz_workdesk",
    zz_gate = "gzz_carrepairshop_workdesk"
  };
  -----------------------------------------------
  local get_amuletcar_inv = function ()

    int.InventoryItemAdd( "inv_amuletcar", "spr_workdesk_amuletcar" );

  end;
  local get_amuletcar_closezz = function ()

    ObjDelete( "gfx_workdesk_amuletcar" );
    ObjDelete( "spr_workdesk_amuletcar_shadow" );
    ObjDelete( "spr_carrepairshop_car" );

    if ( cmn.IsEventDone( "get_amuletcar" ) and
         cmn.IsEventDone( "use_winchlever" ) and
         cmn.IsEventDone( "get_collect2_1_1" ) and
         cmn.IsEventDone( "clk_winchlever" ) ) then

      ObjDelete( "gzz_carrepairshop_workdesk" );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "get_amuletcar", get_amuletcar_inv );
  cmn.AddSubscriber( "get_amuletcar", get_amuletcar_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coin_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_coin_2" ] =
  {
    type = "get",
    get_obj = "spr_onthefloor_coin_2",
    room = private.room_objname,
    zz = "zz_onthefloor",
    zz_gate = "gzz_carrepairshop_onthefloor"
  };
  -----------------------------------------------
  local get_coin_2_inv = function ()

    int.InventoryItemAdd( "inv_coin_1", "spr_onthefloor_coin_2", "assets/levels/level1/rm_abandonedfarm/zz_treehole/inv/inv_coin_morph" );
    level1_inv.CheckCoin ();

  end;
  local get_coin_2_closezz = function ()

    ObjDelete( "gfx_onthefloor_coin_2" );
    ObjDelete( "spr_onthefloor_coin_shad" );
    ObjDelete( "spr_onthefloor_coin_light" );
    ObjDelete( "spr_onthefloor_coin_light_green" );
    ObjDelete( "spr_carrepairshop_coin" );

    if ( cmn.IsEventDone( "get_coin_2" ) and
         cmn.IsEventDone( "get_wheel" ) and
         cmn.IsEventDone( "get_screwdriver" ) ) then

      ObjDelete( "gzz_carrepairshop_onthefloor" );
      ObjSet( "obj_carrepairshop_clk_atropos", { input = true } );
      ObjSet( "anm_carrepairshop_atropos_static", { alp = 1 } );
      ObjSet( "anm_carrepairshop_atropos_over", { alp = 1 } );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "get_coin_2", get_coin_2_inv );
  cmn.AddSubscriber( "get_coin_2", get_coin_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wheel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wheel" ] =
  {
    type = "get",
    get_obj = "spr_onthefloor_wheel",
    room = private.room_objname,
    zz = "zz_onthefloor",
    zz_gate = "gzz_carrepairshop_onthefloor"
  };
  -----------------------------------------------
  local get_wheel_inv = function ()

    int.InventoryItemAdd( "inv_wheel", "spr_onthefloor_wheel" );

    if ( cmn.IsEventDone( "get_wheel_2" ) ) then

      ObjSet( "inv_wheel", { res = "assets/levels/level1/rm_track/inv/inv_wheel_2" } );  
      ObjDelete( "txt_wheel_num" );

    end;

  end;
  local get_wheel_closezz = function ()

    ObjDelete( "gfx_onthefloor_wheel" );
    ObjDelete( "spr_onthefloor_wheel_shad" );
    ObjDelete( "spr_carrepairshop_wheel" );

    if ( cmn.IsEventDone( "get_coin_2" ) and
         cmn.IsEventDone( "get_wheel" ) and
         cmn.IsEventDone( "get_screwdriver" ) ) then

      ObjDelete( "gzz_carrepairshop_onthefloor" );
      ObjSet( "obj_carrepairshop_clk_atropos", { input = true } );
      ObjSet( "anm_carrepairshop_atropos_static", { alp = 1 } );
      ObjSet( "anm_carrepairshop_atropos_over", { alp = 1 } );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "get_wheel", get_wheel_inv );
  cmn.AddSubscriber( "get_wheel", get_wheel_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_screwdriver () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_screwdriver" ] =
  {
    type = "get",
    get_obj = "spr_onthefloor_screwdriver",
    room = private.room_objname,
    zz = "zz_onthefloor",
    zz_gate = "gzz_carrepairshop_onthefloor"
  };
  -----------------------------------------------
  local get_screwdriver_inv = function ()

    int.InventoryItemAdd( "inv_screwdriver", "spr_onthefloor_screwdriver" );

  end;
  local get_screwdriver_closezz = function ()

    ObjDelete( "gfx_onthefloor_screwdriver" );
    ObjDelete( "spr_onthefloor_screwdriver_shad" );
    ObjDelete( "spr_carrepairshop_screwdriver" );

    if ( cmn.IsEventDone( "get_coin_2" ) and
         cmn.IsEventDone( "get_wheel" ) and
         cmn.IsEventDone( "get_screwdriver" ) ) then

      ObjDelete( "gzz_carrepairshop_onthefloor" );
      ObjSet( "obj_carrepairshop_clk_atropos", { input = true } );
      ObjSet( "anm_carrepairshop_atropos_static", { alp = 1 } );
      ObjSet( "anm_carrepairshop_atropos_over", { alp = 1 } );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "get_screwdriver", get_screwdriver_inv );
  cmn.AddSubscriber( "get_screwdriver", get_screwdriver_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pliers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pliers" ] =
  {
    type = "get",
    get_obj = "spr_motorcycle_pliers",
    room = private.room_objname,
    zz = "zz_motorcycle",
    zz_gate = "gzz_carrepairshop_motorcycle"
  };
  -----------------------------------------------
  local get_pliers_inv = function ()

    int.InventoryItemAdd( "inv_pliers", "spr_motorcycle_pliers" );

  end;
  local get_pliers_closezz = function ()

    ObjDelete( "gfx_motorcycle_pliers" );
    ObjDelete( "spr_motorcycle_pliers_shadow" );
    ObjDelete( "spr_carrepairshop_pliers" );

    ObjSet( "obj_motorcycle_use_crossed_bones", { event_mdown = function () private.ClkBag( "crossed_bones" ) end } ); 
    ObjSet( "obj_motorcycle_use_skull", { event_mdown = function () private.ClkBag( "skull" ) end } ); 

    if ( cmn.IsEventDone( "get_pliers" ) and
         cmn.IsEventDone( "get_insectspray" ) and
         cmn.IsEventDone( "get_lighter" ) ) then

      ObjDelete( "gzz_carrepairshop_motorcycle" );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "get_pliers", get_pliers_inv );
  cmn.AddSubscriber( "get_pliers", get_pliers_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_insectspray () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_insectspray" ] =
  {
    type = "get",
    get_obj = "spr_motorcycle_insectspray",
    room = private.room_objname,
    zz = "zz_motorcycle",
    zz_gate = "gzz_carrepairshop_motorcycle"
  };
  -----------------------------------------------
  local get_insectspray_inv = function ()

    int.InventoryItemAdd( "inv_insectspray", "spr_motorcycle_insectspray" );

  end;
  local get_insectspray_closezz = function ()

    ObjDelete( "gfx_motorcycle_insectspray" );
    ObjDelete( "spr_carrepairshop_container" );

    if ( cmn.IsEventDone( "get_pliers" ) and
         cmn.IsEventDone( "get_insectspray" ) and
         cmn.IsEventDone( "get_lighter" ) ) then

      ObjDelete( "gzz_carrepairshop_motorcycle" );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "get_insectspray", get_insectspray_inv );
  cmn.AddSubscriber( "get_insectspray", get_insectspray_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lighter () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lighter" ] =
  {
    type = "get",
    get_obj = "spr_motorcycle_lighter",
    room = private.room_objname,
    zz = "zz_motorcycle",
    zz_gate = "gzz_carrepairshop_motorcycle"
  };
  -----------------------------------------------
  local get_lighter_inv = function ()

    int.InventoryItemAdd( "inv_lighter", "spr_motorcycle_lighter" );

  end;
  local get_lighter_closezz = function ()

    ObjDelete( "gfx_motorcycle_lighter" );
    ObjDelete( "spr_motorcycle_lighter_shadow" );
    ObjDelete( "spr_carrepairshop_lighter" );
    ObjSet( "spr_motorcycle_newspaper", { input = true } );

    if ( cmn.IsEventDone( "get_pliers" ) and
         cmn.IsEventDone( "get_insectspray" ) and
         cmn.IsEventDone( "get_lighter" ) ) then

      ObjDelete( "gzz_carrepairshop_motorcycle" );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "get_lighter", get_lighter_inv );
  cmn.AddSubscriber( "get_lighter", get_lighter_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_winchlever () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_winchlever" ] =
  {
    type = "use",
    use_obj = "inv_winchlever",
    use_place = "obj_workdesk_use_winchlever",
    room = private.room_objname,
    zz = "zz_workdesk",
    zz_gate = "gzz_carrepairshop_workdesk"
  };
  -----------------------------------------------
  local use_winchlever_inv = function ()

    int.InventoryItemRemove( "inv_winchlever" );

  end;
  local use_winchlever_beg = function ()

    ObjDelete( "obj_workdesk_use_winchlever" );

  end;
  local use_winchlever_end = function ()

    ObjSet( "obj_workdesk_clk_winchlever", { input = true } );
    ObjSet( "spr_carrepairshop_lever", { alp = 1 } );
    ObjDelete( "spr_workdesk_chain" );
    ObjSet( "vid_workdesk_use_lever", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_winchlever", use_winchlever_beg, private.room_objname );
  cmn.AddSubscriber( "use_winchlever", use_winchlever_inv );
  cmn.AddSubscriber( "use_winchlever", use_winchlever_end, private.room_objname );
  cmn.AddSubscriber( "use_winchlever_inv", use_winchlever_inv, private.room_objname );
  cmn.AddSubscriber( "use_winchlever_beg", use_winchlever_beg, private.room_objname );
  cmn.AddSubscriber( "use_winchlever_end", use_winchlever_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_workshopfob () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_workshopfob" ] =
  {
    type = "use",
    use_obj = "inv_workshopfob",
    use_place = "obj_onthefloor_use_workshopfob",
    room = private.room_objname,
    zz = "zz_onthefloor",
    zz_gate = "gzz_carrepairshop_onthefloor"
  };
  -----------------------------------------------
  local use_workshopfob_loc = function ()

    ObjDelete( "spr_townoutskirts_close1" );

  end;
  local use_workshopfob_inv = function ()

    int.InventoryItemRemove( "inv_workshopfob" );

  end;
  local use_workshopfob_beg = function ()

    ObjDelete( "obj_onthefloor_use_workshopfob" );

  end;
  local use_workshopfob_end = function ()

    ObjSet( "obj_onthefloor_open", { input = true } );
    ObjSet( "gfx_onthefloor_wheel", { active = true } );
    ObjSet( "gfx_onthefloor_screwdriver", { active = true } );
    ObjDelete( "obj_onthefloor_workshopfob" );
    ObjDelete( "spr_onthefloor_door" );
    ObjDelete( "spr_onthefloor_door_shad" );
    ObjDelete( "spr_carrepairshop_close" );
    ObjDelete( "spr_onthefloor_up" );
    ObjSet( "spr_onthefloor_up_green", { alp = 1 } );
    ObjDelete( "spr_onthefloor_door_light" );
    ObjSet( "spr_onthefloor_door_light_green", { alp = 1 } );
    ObjDelete( "spr_townoutskirts_close1" );
    ObjDelete( "spr_carrepairshop_red_button" );
    ObjSet( "spr_carrepairshop_green_light", { visible = true } );

    if not cmn.IsEventDone( "get_coin_2" ) then

      ObjDelete( "spr_onthefloor_coin_light" );
      ObjSet( "spr_onthefloor_coin_light_green", { alp = 1 } );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_workshopfob", use_workshopfob_beg, private.room_objname );
  cmn.AddSubscriber( "use_workshopfob", use_workshopfob_loc, "rm_townoutskirts" );
  cmn.AddSubscriber( "use_workshopfob", use_workshopfob_inv );
  cmn.AddSubscriber( "use_workshopfob", use_workshopfob_end, private.room_objname );
  cmn.AddSubscriber( "use_workshopfob_inv", use_workshopfob_inv, private.room_objname );
  cmn.AddSubscriber( "use_workshopfob_beg", use_workshopfob_beg, private.room_objname );
  cmn.AddSubscriber( "use_workshopfob_end", use_workshopfob_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_acetoneandcottonwool () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_acetoneandcottonwool" ] =
  {
    type = "use",
    use_obj = "inv_acetoneandcottonwool",
    use_place = "obj_mechanism_use_acetoneandcottonwool",
    room = private.room_objname,
    zz = "zz_mechanism",
    zz_gate = "gzz_carrepairshop_mechanism"
  };
  -----------------------------------------------
  local use_acetoneandcottonwool_inv = function ()

    int.InventoryItemRemove( "inv_acetoneandcottonwool" );

  end;
  local use_acetoneandcottonwool_beg = function ()

    ObjDelete( "obj_mechanism_use_acetoneandcottonwool" );

  end;
  local use_acetoneandcottonwool_end = function ()

    ObjDelete( "anm_mechanism_acetone" );
    ObjDelete( "spr_carrepairshop_dirt" );
    ObjSet( "obj_mechanism_buttons", { input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_acetoneandcottonwool", use_acetoneandcottonwool_beg, private.room_objname );
  cmn.AddSubscriber( "use_acetoneandcottonwool", use_acetoneandcottonwool_inv );
  cmn.AddSubscriber( "use_acetoneandcottonwool", use_acetoneandcottonwool_end, private.room_objname );
  cmn.AddSubscriber( "use_acetoneandcottonwool_inv", use_acetoneandcottonwool_inv, private.room_objname );
  cmn.AddSubscriber( "use_acetoneandcottonwool_beg", use_acetoneandcottonwool_beg, private.room_objname );
  cmn.AddSubscriber( "use_acetoneandcottonwool_end", use_acetoneandcottonwool_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_skull () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_skull" ] =
  {
    type = "use",
    use_obj = "inv_skull",
    use_place = "obj_motorcycle_use_skull",
    room = private.room_objname,
    zz = "zz_motorcycle",
    zz_gate = "gzz_carrepairshop_motorcycle"
  };
  -----------------------------------------------
  local use_skull_inv = function ()

    int.InventoryItemRemove( "inv_skull" );

  end;
  local use_skull_beg = function ()

    ObjDelete( "obj_motorcycle_use_skull" );

  end;
  local use_skull_end = function ()

    ObjSet( "spr_motorcycle_skull", { alp = 1 } );
    ObjSet( "spr_carrepairshop_button_2", { alp = 1 } );

    if cmn.IsEventDone( "use_crossed_bones" ) then

      ObjDelete( "spr_motorcycle_close" );
      ObjSet( "obj_motorcycle_open_bag", { alp = 1, input = true } );
      ObjSet( "gfx_motorcycle_insectspray", { active = true } );
      ObjSet( "obj_carrepairshop_open", { alp = 1 } );

      ObjDelete( "spr_carrepairshop_button_2" );
      ObjDelete( "spr_carrepairshop_button_1" );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_skull", use_skull_beg, private.room_objname );
  cmn.AddSubscriber( "use_skull", use_skull_inv );
  cmn.AddSubscriber( "use_skull", use_skull_end, private.room_objname );
  cmn.AddSubscriber( "use_skull_inv", use_skull_inv, private.room_objname );
  cmn.AddSubscriber( "use_skull_beg", use_skull_beg, private.room_objname );
  cmn.AddSubscriber( "use_skull_end", use_skull_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crossed_bones () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_crossed_bones" ] =
  {
    type = "use",
    use_obj = "inv_crossed_bones",
    use_place = "obj_motorcycle_use_crossed_bones",
    room = private.room_objname,
    zz = "zz_motorcycle",
    zz_gate = "gzz_carrepairshop_motorcycle"
  };
  -----------------------------------------------
  local use_crossed_bones_inv = function ()

    int.InventoryItemRemove( "inv_crossed_bones" );

  end;
  local use_crossed_bones_beg = function ()

    ObjDelete( "obj_motorcycle_use_crossed_bones" );

  end;
  local use_crossed_bones_end = function ()

    ObjSet( "spr_motorcycle_crossed_bones", { alp = 1 } );
    ObjSet( "spr_carrepairshop_button_1", { alp = 1 } );

    if cmn.IsEventDone( "use_skull" ) then

      ObjDelete( "spr_motorcycle_close" );
      ObjSet( "obj_motorcycle_open_bag", { alp = 1, input = true } );
      ObjSet( "gfx_motorcycle_insectspray", { active = true } );
      ObjSet( "obj_carrepairshop_open", { alp = 1 } );

      ObjDelete( "spr_carrepairshop_button_2" );
      ObjDelete( "spr_carrepairshop_button_1" );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_crossed_bones", use_crossed_bones_beg, private.room_objname );
  cmn.AddSubscriber( "use_crossed_bones", use_crossed_bones_inv );
  cmn.AddSubscriber( "use_crossed_bones", use_crossed_bones_end, private.room_objname );
  cmn.AddSubscriber( "use_crossed_bones_inv", use_crossed_bones_inv, private.room_objname );
  cmn.AddSubscriber( "use_crossed_bones_beg", use_crossed_bones_beg, private.room_objname );
  cmn.AddSubscriber( "use_crossed_bones_end", use_crossed_bones_end, private.room_objname );
--*********************************************************************************************************************
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function dlg_carrepairshop_atropos_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_carrepairshop_atropos_1" ] =
  {
    type = "click",
    clk_obj = "obj_carrepairshop_clk_atropos",
    room = private.room_objname,
  };
  -----------------------------------------------
  local dlg_carrepairshop_atropos_1 = function ()

    int.LockRoomMap( "bygrayscar", 1 );
    int.LockRoomMap( "abandonedfarm", 1 );
    int.LockRoomMap( "track", 1 );
    int.LockRoomMap( "townoutskirts", 1 );
    --int.LockRoomMap( "carrepairshop", 1 );

  end;
  -----------------------------------------------
  local dlg_carrepairshop_atropos_1_beg = function ()

  end;
  -----------------------------------------------
  local dlg_carrepairshop_atropos_1_end = function ()

    ObjSet( "gmg_carrepairshop_mgremovecollapse", { active = true, input = true, alp = 1 } );
    ObjSet( "grm_carrepairshop_townoutskirts",    { active = false, input = false, visible = false } );
    if port.isPortable() == 1 then
        port.GrmEventLightOff("grm_carrepairshop_townoutskirts_focus");
    end;    
    ObjDelete( "obj_carrepairshop_clk_atropos" );
    ObjDelete( "anm_carrepairshop_atropos_1_atropos" );
    ObjDelete( "anm_carrepairshop_atropos_static" );
    ObjDelete( "anm_carrepairshop_atropos_over" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "dlg_carrepairshop_atropos_1", dlg_carrepairshop_atropos_1 );
  cmn.AddSubscriber( "dlg_carrepairshop_atropos_1", dlg_carrepairshop_atropos_1_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_carrepairshop_atropos_1", dlg_carrepairshop_atropos_1_end, private.room_objname );
  cmn.AddSubscriber( "dlg_carrepairshop_atropos_1_beg", dlg_carrepairshop_atropos_1_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_carrepairshop_atropos_1_end", dlg_carrepairshop_atropos_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_winchlever () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_winchlever" ] =
  {
    type = "click",
    clk_obj = "obj_workdesk_clk_winchlever",
    room = private.room_objname,
    zz = "zz_workdesk",
    zz_gate = "gzz_carrepairshop_workdesk"
  };
  -----------------------------------------------
  local clk_winchlever_beg = function ()

    ObjDelete( "obj_workdesk_clk_winchlever" );

  end;
  -----------------------------------------------
  local clk_winchlever_end = function ()

    if ( cmn.IsEventDone( "get_amuletcar" ) and
         cmn.IsEventDone( "use_winchlever" ) and
         cmn.IsEventDone( "get_collect2_1_1" ) and
         cmn.IsEventDone( "clk_winchlever" ) ) then

      ObjDelete( "gzz_carrepairshop_workdesk" );

    end;

    ObjSet( "gzz_carrepairshop_motorcycle", { active = true, input = true, alp = 1 } );
    ObjDelete( "vid_workdesk_use_lever" );
    ObjSet( "spr_workdesk_chain_1", { alp = 1 } );

    ObjDelete( "obj_carrepairshop_clk_motorcycle" );
    ObjDelete( "anm_carrepairshop_motorcycle_down" );
    ObjDelete( "anm_carrepairshop_motorcycle" );
    ObjSet( "spr_carrepairshop_motorcycle_shadow", { alp = 1 } );
    ObjSet( "spr_carrepairshop_motorcycle", { alp = 1 } );
    ObjSet( "anm_carrepairshop_motorcycle_chains", { alp = 1 } );
    ObjSet( "spr_carrepairshop_chain", { alp = 1, ang = -0.08  } );
    ObjSet( "spr_carrepairshop_chain1", { alp = 1, ang = 0.1 } );
    ObjSet( "spr_carrepairshop_pliers", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_winchlever", clk_winchlever_beg, private.room_objname );
  cmn.AddSubscriber( "clk_winchlever", clk_winchlever_end, private.room_objname );
  cmn.AddSubscriber( "clk_winchlever_beg", clk_winchlever_beg, private.room_objname );
  cmn.AddSubscriber( "clk_winchlever_end", clk_winchlever_end, private.room_objname );
  -----------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_newspaper () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_newspaper" ] =
  {
    type = "click",
    clk_obj = "spr_motorcycle_newspaper",
    room = private.room_objname,
    zz = "zz_motorcycle",
    zz_gate = "gzz_carrepairshop_motorcycle"
  };
  -----------------------------------------------
  local clk_newspaper = function ()


  end;
  -----------------------------------------------
  local clk_newspaper_beg = function ()

    ObjSet( "spr_motorcycle_newspaper", { input = false } );

  end;
  -----------------------------------------------
  local clk_newspaper_end = function ()

    ObjDelete( "spr_motorcycle_newspaper" );
    ObjSet( "spr_motorcycle_insectspray", { input = true } );
    ObjSet( "gfx_motorcycle_insectspray", { active = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_newspaper", clk_newspaper );
  cmn.AddSubscriber( "clk_newspaper", clk_newspaper_beg, private.room_objname );
  cmn.AddSubscriber( "clk_newspaper", clk_newspaper_end, private.room_objname );
  cmn.AddSubscriber( "clk_newspaper_beg", clk_newspaper_beg, private.room_objname );
  cmn.AddSubscriber( "clk_newspaper_end", clk_newspaper_end, private.room_objname );
  -----------------------------------------------
--------------------------------------------------------------------------------------------
  -- function win_mechanism () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_mechanism" ] =
  {
    type = "click",
    clk_obj = "obj_mechanism_hint_tmp",
    room = private.room_objname,
    zz = "zz_mechanism",
    zz_gate = "gzz_carrepairshop_mechanism"
  };

  local win_mechanism = function ()

    if cmn.IsEventDone( "win_mechanism" ) then
      ObjDelete( "gzz_carrepairshop_mechanism" );
      ObjSet( "gmg_carrepairshop_mgboxes", { active = true, input = true, alp = 1 } );
    else
      private.code = ng_global.progress[ "std" ][ "win_mechanism" ].code;
      ObjSet( "txt_mechanism_numbers", { text = private.code } );
    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "win_mechanism", win_mechanism, private.room_objname );
--------------------------------------------------------------------------------------------
  -- function win_mgboxes () end;
  --------------------------------------------------------------------------------------------
  local win_mgboxes = function ()

    if cmn.IsEventDone( "win_mechanism" ) then

      ObjDelete( "spr_carrepairshop_mg_1" );
      ObjSet( "spr_carrepairshop_mg_2", { alp = 1 } );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "win_mgboxes", win_mgboxes, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_1_6 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_1_6 = function ()

    ObjDelete( "obj_carrepairshop_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_1_6", get_morphobject_1_6, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_1_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_1_1 = function ()

    ObjDelete( "spr_workdesk_collect2_1_1" );
    ObjDelete( "spr_carrepairshop_collect2_1_1" );

    if ( cmn.IsEventDone( "get_amuletcar" ) and
         cmn.IsEventDone( "use_winchlever" ) and
         cmn.IsEventDone( "get_collect2_1_1" ) and
         cmn.IsEventDone( "clk_winchlever" ) ) then

      ObjDelete( "gzz_carrepairshop_workdesk" );

    end;

  end;

  cmn.AddSubscriber( "get_collect2_1_1", get_collect2_1_1, private.room_objname );
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function private.get_amuletcar ()

  cmn.SetEventDone( "get_amuletcar" );
  cmn.CallEventHandler( "get_amuletcar" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_amuletcar" ) and
       cmn.IsEventDone( "use_winchlever" ) and
       cmn.IsEventDone( "get_collect2_1_1" ) and
       cmn.IsEventDone( "clk_winchlever" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_coin_2 ()

  cmn.SetEventDone( "get_coin_2" );
  cmn.CallEventHandler( "get_coin_2" );
  
  cmn.GetObjectSfx();
  if ( cmn.IsEventDone( "get_coin_2" ) and
       cmn.IsEventDone( "get_wheel" ) and
       cmn.IsEventDone( "get_screwdriver" ) ) then

    private.SeeAtropos();
    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_wheel ()

  cmn.SetEventDone( "get_wheel" );
  cmn.CallEventHandler( "get_wheel" );

  cmn.GetObjectSfx();
  if ( cmn.IsEventDone( "get_coin_2" ) and
       cmn.IsEventDone( "get_wheel" ) and
       cmn.IsEventDone( "get_screwdriver" ) ) then

    cmn.CloseSubRoom();
    private.SeeAtropos();

  end;

end;
-------------------------------------------------
function private.get_screwdriver ()

  cmn.SetEventDone( "get_screwdriver" );
  cmn.CallEventHandler( "get_screwdriver" );
  
  cmn.GetObjectSfx();
  if ( cmn.IsEventDone( "get_coin_2" ) and
       cmn.IsEventDone( "get_wheel" ) and
       cmn.IsEventDone( "get_screwdriver" ) ) then

    cmn.CloseSubRoom();
    private.SeeAtropos();

  end;

end;
-------------------------------------------------
function private.SeeAtropos ()

  local func_end = function ()

    cmn.PlayAudio( "env", "audio/level1/env/aud_dialog_with_god_env", 1 );
    ObjSet( "anm_carrepairshop_atropos_static", { alp = 1 } );
    ObjSet( "anm_carrepairshop_atropos_over", { alp = 1 } );
    int.Lock( false );
    private.dlg_carrepairshop_atropos_1();
    
  end;

  local func_skip = function ()

    cmn.StopAudio( "sfx", "audio/level1/sfx/aud_carrepairshop_atropos_appearance_mus" );
    cmn.PlayAudio( "env", "audio/level1/env/aud_dialog_with_god_env", 1 );
    ObjSet( "anm_carrepairshop_atropos_static", { alp = 1 } );
    ObjSet( "anm_carrepairshop_atropos_over", { alp = 1 } );
    int.Lock( false );

  end;

  int.Lock( true );
  ObjSet( "anm_carrepairshop_atropos_static", { alp = 0 } );
  ObjSet( "anm_carrepairshop_atropos_over", { alp = 0 } );
  common_impl.PlayDialogVideo( "vid_carrepairshop_atropos_appearance", func_end, func_skip ); 

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_carrepairshop_atropos_appearance_mus" );
  --cmn.PlayAudio( "voc", "audio/level1/voc/aud_watch_voc" );

end;
-------------------------------------------------
function private.SeeCollaps ()

  local func_end = function ()

    cmn.GotoRoom( "mg_mgremovecollapse" );
    cmn.ShowBbt("bbt_carrepairshop_atropos_dlg");
    int.Lock( false );

  end;

  local func_skip = function ()

    cmn.GotoRoom( "mg_mgremovecollapse" );
    cmn.ShowBbt("bbt_carrepairshop_atropos_dlg");
    cmn.StopAudio( "sfx", "audio/level1/sfx/aud_carrepairshop_collapse_mus" );
    cmn.PlayAudio( "mus", "audio/level1/mus/aud_scare_mid_short_mus" );
    int.Lock( false );

  end;

  int.Lock( true );
  ObjSet( "rm_carrepairshop", { color_r = 0, color_g = 0, color_b = 0 } );
  common_impl.PlayDialogVideo( "vid_carrepairshop_collapse", func_end, func_skip ); 

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_carrepairshop_collapse_mus" );
  --cmn.PlayAudio( "voc", "audio/level1/voc/aud_watch_voc" );

end;
-------------------------------------------------
function private.get_pliers ()

  cmn.SetEventDone( "get_pliers" );
  cmn.CallEventHandler( "get_pliers" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_pliers" ) and
       cmn.IsEventDone( "get_insectspray" ) and
       cmn.IsEventDone( "get_lighter" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_insectspray ()

  cmn.SetEventDone( "get_insectspray" );
  cmn.CallEventHandler( "get_insectspray" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_pliers" ) and
       cmn.IsEventDone( "get_insectspray" ) and
       cmn.IsEventDone( "get_lighter" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_lighter ()

  cmn.SetEventDone( "get_lighter" );
  cmn.CallEventHandler( "get_lighter" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_pliers" ) and
       cmn.IsEventDone( "get_insectspray" ) and
       cmn.IsEventDone( "get_lighter" ) ) then

    cmn.CloseSubRoom();

  end;

end;
---------------------------------------------------------------------------------
function private.get_collect2_1_1()

  int.AddCollectibles2( "spr_workdesk_collect2_1_1" );

  local func_end = function ()

    if ( cmn.IsEventDone( "get_amuletcar" ) and
         cmn.IsEventDone( "use_winchlever" ) and
         cmn.IsEventDone( "clk_winchlever" ) ) then

      cmn.CloseSubRoom();

    end;

  end;

  ObjAnimate( "spr_workdesk_chain_1", "alp", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "spr_workdesk_chain_1" ).alp, 
    0.7, 0, ObjGet( "spr_workdesk_chain_1" ).alp
  } );

end;
--*********************************************************************************************************************
function public.use_winchlever ()

  local item = "inv_winchlever";

  if ( cmn.ApplyObj( item, "gzz_carrepairshop_workdesk", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_workdesk" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_workdesk_use_winchlever", true ) ) then

    cmn.CallEventHandler( "use_winchlever_inv" );
    cmn.CallEventHandler( "use_winchlever_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_winchlever" );
      cmn.CallEventHandler( "use_winchlever_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_lever_app" );  

    ObjAnimate( "spr_workdesk_chain", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0,
      0.25, 0, 1.0,  
      0.3, 0, 0.0
    } );
    ObjAnimate( "vid_workdesk_use_lever", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
function public.use_workshopfob ()

  local item = "inv_workshopfob";

  if ( cmn.ApplyObj( item, "gzz_carrepairshop_onthefloor", false ) and
       cmn.IsEventDone( "get_coin_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_onthefloor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_onthefloor_use_workshopfob", true ) and 
           cmn.IsEventDone( "get_coin_2" ) ) then

    cmn.CallEventHandler( "use_workshopfob_inv" );
    cmn.CallEventHandler( "use_workshopfob_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_workshopfob" );
      cmn.CallEventHandler( "use_workshopfob_end" );
      private.AnimGreenLight();
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_trinket_app" );

    ObjStopAnimate( "spr_onthefloor_signal_light", "alp" );
    ObjStopAnimate( "spr_onthefloor_door_light", "alp" );

    ObjAnimate( "obj_onthefloor_workshopfob", "pos_xy", 0, 0, "",
    { 
      0.0, 3, -340, -68, 
      0.6, 3, 0, 0
    } );
    ObjAnimate( "spr_onthefloor_trinket", "alp", 0, 0, "",
    { 
      0.0, 0, 1, 
      0.8, 0, 1,
      1.1, 0, 0
    } );
    ObjAnimate( "spr_onthefloor_up_green", "alp", 0, 0, "",
    { 
      0.0, 0, 0, 
      0.8, 0, 0,
      1.1, 0, 1
    } );
    ObjAnimate( "spr_onthefloor_up", "alp", 0, 0, "",
    { 
      0.0, 0, 1, 
      0.8, 0, 1,
      1.1, 0, 0
    } );
    if not cmn.IsEventDone( "get_coin_2" ) then

      ObjStopAnimate( "spr_onthefloor_coin_light", "alp" );
      ObjAnimate( "spr_onthefloor_coin_light_green", "alp", 0, 0, "",
      { 
        0.0, 0, 0, 
        0.8, 0, 0,
        1.1, 0, 1
      } );
      ObjAnimate( "spr_onthefloor_coin_light", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_onthefloor_coin_light" ).alp, 
        0.8, 0, ObjGet( "spr_onthefloor_coin_light" ).alp,
        1.1, 0, 0
      } );

    end;
    ObjAnimate( "spr_onthefloor_door_light_green", "alp", 0, 0, "",
    { 
      0.0, 0, 0, 
      0.8, 0, 0,
      1.1, 0, 1
    } );
    ObjAnimate( "spr_onthefloor_door_light", "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_onthefloor_door_light" ).alp, 
      0.8, 0, ObjGet( "spr_onthefloor_door_light" ).alp,
      1.1, 0, 0
    } );
    ObjAnimate( "spr_onthefloor_trinket_2", "alp", 0, 0, "",
    { 
      0.0, 0, 0, 
      0.8, 0, 0,
      1.1, 0, 1,
      1.3, 0, 1,
      1.6, 0, 0
    } );
    ObjAnimate( "spr_onthefloor_door", "pos_xy", 0, 0, "",
    { 
      0.0, 3, 93, -19, 
      2.0, 3, 93, -19,
      3.0, 3, -578, 404
    } );
    ObjAnimate( "spr_onthefloor_door_shad", "alp", 0, 0, func_end,
    { 
      0.0, 3, 1, 1, 
      2.0, 3, 1, 1,
      3.0, 3, 0, 0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
function public.use_acetoneandcottonwool ()

  local item = "inv_acetoneandcottonwool";

  if ( cmn.ApplyObj( item, "gzz_carrepairshop_mechanism", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_mechanism" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_mechanism_use_acetoneandcottonwool", true ) ) then

    cmn.CallEventHandler( "use_acetoneandcottonwool_inv" );
    cmn.CallEventHandler( "use_acetoneandcottonwool_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_acetoneandcottonwool" );
      cmn.CallEventHandler( "use_acetoneandcottonwool_end" );
      int.Lock( false );

      zz_mechanism.Reset();
      private.StartMechanism();

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_clean_code" );
    AnimPlay( "anm_mechanism_acetone", "DoAnim", func_end ) 

    return true;

  end;

  return false;

end;
-------------------------------------------------
function public.use_skull ()

  local item = "inv_skull";

  if ( cmn.ApplyObj( item, "gzz_carrepairshop_motorcycle", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_motorcycle" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_motorcycle_use_skull", true ) ) then

    cmn.CallEventHandler( "use_skull_inv" );
    cmn.CallEventHandler( "use_skull_beg" );
    int.Lock( true );

    local func_end = function ()

      local func_end = function ()

        cmn.SetEventDone( "use_skull" );
        cmn.CallEventHandler( "use_skull_end" );
        int.Lock( false );

      end;

      if cmn.IsEventDone( "use_crossed_bones" ) then

        ObjAnimate( "obj_motorcycle_open_bag", "alp", 0, 0, "",
        { 
          0.0, 0, 0.0, 
          0.3, 0, 0.0,
          0.6, 0, 1.0
        } );

        ObjAnimate( "spr_motorcycle_close", "alp", 0, 0, func_end,
        { 
          0.0, 0, 1.0, 
          0.3, 0, 1.0,
          0.6, 0, 0.0
        } );

      else 

        func_end();

      end;

    end;

    if cmn.IsEventDone( "use_crossed_bones" ) then
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_last_to_motobag_app" );
    else
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_first_to_motobag_app" );
    end;

    ObjAnimate( "spr_motorcycle_skull", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
function public.use_crossed_bones ()

  local item = "inv_crossed_bones";

  if ( cmn.ApplyObj( item, "gzz_carrepairshop_motorcycle", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_motorcycle" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_motorcycle_use_crossed_bones", true ) ) then

    cmn.CallEventHandler( "use_crossed_bones_inv" );
    cmn.CallEventHandler( "use_crossed_bones_beg" );
    int.Lock( true );

    local func_end = function ()

      local func_end = function ()

        cmn.SetEventDone( "use_crossed_bones" );
        cmn.CallEventHandler( "use_crossed_bones_end" );
        int.Lock( false );

      end;

      if cmn.IsEventDone( "use_skull" ) then

        ObjAnimate( "obj_motorcycle_open_bag", "alp", 0, 0, "",
        { 
          0.0, 0, 0.0, 
          0.3, 0, 0.0,
          0.6, 0, 1.0
        } );
        ObjAnimate( "spr_motorcycle_close", "alp", 0, 0, func_end,
        { 
          0.0, 0, 1.0, 
          0.3, 0, 1.0,
          0.6, 0, 0.0
        } );

      else 

        func_end();

      end;

    end;

    if cmn.IsEventDone( "use_skull" ) then
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_last_to_motobag_app" );
    else
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_first_to_motobag_app" );
    end;

    ObjAnimate( "spr_motorcycle_crossed_bones", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
function private.clk_winchlever ()

  local func_end = function ()

    cmn.SetEventDone( "clk_winchlever" );
    ng_global.progress[ "std" ][ "clk_winchlever" ].clk = 0;
    int.Lock( false );

    --if ( cmn.IsEventDone( "get_amuletcar" ) and
    --     cmn.IsEventDone( "use_winchlever" ) and
    --     cmn.IsEventDone( "get_collect2_1_1" ) and
    --     cmn.IsEventDone( "clk_winchlever" ) ) then

      cmn.CloseSubRoom();

    --end;

  end;

  cmn.CallEventHandler( "clk_winchlever_beg" );

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_only_lever_click" ); 

  VidPlay( "vid_workdesk_use_lever", func_end );
  

end;
--*********************************************************************************************************************
-- dlg_atropos_1
--*********************************************************************************************************************
-------------------------------------------------
function private.dlg_carrepairshop_atropos_1 ()

  local func_end = function ()
      
    int.Lock( true );
    ObjAnimate("spr_carrepairshop_atropos_1_black_loc", "alp", 0, 0, "", {0.0,0,0.5, 0.3,0,0});
    ObjSet( "anm_carrepairshop_atropos_static", { alp = 0 } );
    ObjSet( "anm_carrepairshop_atropos_over", { alp = 0 } );
    ObjSet( "anm_carrepairshop_atropos_disappear", { alp = 1 } );
    AnimPlay( "anm_carrepairshop_atropos_disappear", "DoAnim", 
    function () 
      int.Lock( false );
      private.SeeCollaps();
      cmn.CallEventHandler( "dlg_carrepairshop_atropos_1_end" );
      cmn.StopAudio( "env", "audio/level1/env/aud_dialog_with_god_env" );
      cmn.AddPageDiary( 5 );
      int.LockRoomMap( "bygrayscar", 1 );
      int.LockRoomMap( "abandonedfarm", 1 );
      int.LockRoomMap( "track", 1 );
      int.LockRoomMap( "townoutskirts", 1 );
      --int.LockRoomMap( "carrepairshop", 1 );
    end
    );   

  end;

  ObjAttach( "dlg_carrepairshop_atropos_1", "rm_carrepairshop" );
  common_impl.dialog_character_loc = "";
  private.dialog_voices_time = { 3 };
  ObjAnimate("spr_carrepairshop_atropos_1_black_loc", "alp", 0, 0, "", {0.0,0,0, 0.3,0,0.5});
  common_impl.DialogCharacterStart( "atropos_1", 2, nil, nil, false, func_end );

  ObjSet( "tmr_carrepairshop_atropos", { playing = 1, time = 0.3, endtrig = "" } );

end;
-------------------------------------------------
function private.clk_newspaper ()

  local func_end = function ()

    cmn.SetEventDone( "clk_newspaper" );
    cmn.CallEventHandler( "clk_newspaper_end" );
    cmn.CallEventHandler( "clk_newspaper" );
    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_newspaper_beg" );

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_newspaper_not_for_me" ); 
  ObjAnimate( "spr_motorcycle_newspaper", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 3, 14, -17,
    0.4, 3, -2, 55
  } );

end;
-------------------------------------------------
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_amuletcar" );
  int.AddedTaskMap( private.room_objname, "get_coin_2" );
  int.AddedTaskMap( private.room_objname, "get_wheel",                { "use_workshopfob" } );
  int.AddedTaskMap( private.room_objname, "get_screwdriver",          { "use_workshopfob" } );
  int.AddedTaskMap( private.room_objname, "get_pliers",               { "clk_winchlever" } );
  int.AddedTaskMap( private.room_objname, "get_insectspray",          { "clk_newspaper" } );
  int.AddedTaskMap( private.room_objname, "get_lighter",              { "use_skull", "use_crossed_bones" } );

  int.AddedTaskMap( private.room_objname, "get_rustyjack",            { "win_mgboxes" } );
  int.AddedTaskMap( private.room_objname, "get_scissors",             { "win_mgboxes" } );

  int.AddedTaskMap( private.room_objname, "use_winchlever",           { "get_winchlever" } );
  int.AddedTaskMap( private.room_objname, "use_workshopfob",          { "get_workshopfob" } );
  int.AddedTaskMap( private.room_objname, "use_acetoneandcottonwool", { "get_acetoneandcottonwool" } );
  int.AddedTaskMap( private.room_objname, "use_skull",                { "get_skull" } );
  int.AddedTaskMap( private.room_objname, "use_crossed_bones",        { "get_crossed_bones" } );


  int.AddedTaskMap( private.room_objname, "clk_winchlever",           { "use_winchlever" } );

  int.AddedTaskMap( private.room_objname, "dlg_carrepairshop_atropos_1",          { "get_wheel", "get_screwdriver" } );

  int.AddedTaskMap( private.room_objname, "clk_newspaper",            { "get_lighter" } );

  int.AddedTaskMap( private.room_objname, "win_mgboxes",              { "win_mechanism" } );
  int.AddedTaskMap( private.room_objname, "win_mgremovecollapse",     { "dlg_carrepairshop_atropos_1" } );
  int.AddedTaskMap( private.room_objname, "win_mechanism",            { "use_acetoneandcottonwool" } );

end;
--*********************************************************************************************************************
function private.opn_carrepairshop ()

  cmn.StopAllEnv( "audio/level1/env/aud_carrepairshop_env", true );
  cmn.PlayAudio( "env", "audio/level1/env/aud_carrepairshop_env", 1 );

  if not ( cmn.IsEventDone( "opn_carrepairshop" ) ) then

    cmn.SetEventDone( "opn_carrepairshop" );
    cmn.ShowBbt( "bbt_carrepairshop_open" );

  end;

  if ( cmn.IsEventDone( "clk_winchlever" ) ) then

    private.ChainAnims ();

  end;

  if ( cmn.IsEventDone( "get_coin_2" ) and
       cmn.IsEventDone( "get_wheel" ) and
       cmn.IsEventDone( "get_screwdriver" ) and
       not cmn.IsEventDone( "dlg_carrepairshop_atropos_1" ) ) then

    cmn.PlayAudio( "env", "audio/level1/env/aud_dialog_with_god_env", 1 );

  end;

  if (  not cmn.IsEventStart( "win_mgremovecollapse" ) and cmn.IsEventDone( "dlg_carrepairshop_atropos_1" ) ) then

    private.SeeCollaps();

  end;

end;
--*********************************************************************************************************************
function public.Load ()

end;

--*********************************************************************************************************************
function public.PreOpen ()

  if (  not cmn.IsEventStart( "win_mgremovecollapse" ) and cmn.IsEventDone( "dlg_carrepairshop_atropos_1" ) ) then

    ObjSet( "rm_carrepairshop", { color_r = 0, color_g = 0, color_b = 0 } );

  end;

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_carrepairshop();

end;
--*********************************************************************************************************************
function public.Close ()

  if ( cmn.IsEventDone( "clk_winchlever" ) ) then

    ObjStopAnimate( "spr_carrepairshop_chain", "ang" );
    ObjStopAnimate( "spr_carrepairshop_chain1", "ang" );
    ObjSet( "spr_carrepairshop_chain", { ang = -0.08  } );
    ObjSet( "spr_carrepairshop_chain1", { ang = 0.1 } );

  end;

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_mechanism" );
  subroom.Define( "zz_workdesk" );
  subroom.Define( "zz_onthefloor" );

  -------------------------------------------------
  function zz_onthefloor.PreOpen()

    if cmn.IsEventDone( "use_workshopfob" ) then

      ObjStopAnimate( "spr_onthefloor_signal_light_green_add", "alp" );
      ObjStopAnimate( "spr_onthefloor_door_light_green", "alp" );
      ObjStopAnimate( "spr_onthefloor_coin_light_green", "alp" );

      private.AnimGreenLight();

    end;

  end;
  -------------------------------------------------
  function zz_mechanism.Open()

    if cmn.IsEventDone( "use_acetoneandcottonwool" ) and not cmn.IsEventDone( "win_mechanism" ) then
      --cmn.MiniGameShow( "mechanism" );
    end;

  end;
  -------------------------------------------------
  function zz_mechanism.PreClose()

    if cmn.IsEventDone( "use_acetoneandcottonwool" ) and not cmn.IsEventDone( "win_mechanism" ) then
      --cmn.MiniGameHide( "mechanism" );
    end;

  end;
  -------------------------------------------------
  function zz_mechanism.Skip()

    private.code = "376*20";
    ObjSet( "txt_mechanism_numbers", { text = private.code } );
    private.ClkRunner();

  end;
  -------------------------------------------------
  function zz_mechanism.Reset()

    private.code = "";
    ng_global.progress[ "std" ][ "win_mechanism" ].code = private.code;
    ObjSet( "txt_mechanism_numbers", { text = private.code } );

  end;
  -------------------------------------------------
  function zz_workdesk.Close()

    if cmn.IsEventDone( "clk_winchlever" ) and ng_global.progress[ "std" ][ "clk_winchlever" ].clk == 0 then

      local func_end = function ()

        cmn.CallEventHandler( "clk_winchlever_end" );
        int.Lock( false );

        ObjAnimate( "spr_carrepairshop_chain", "ang", 0, 0, "", 
        { 
          0.0, 3, 0.0134,
          1.3, 3, -0.08
        } );
        ObjAnimate( "spr_carrepairshop_chain1", "ang", 0, 0, function () private.ChainAnims() end, 
        { 
          0.0, 3, 0,
          1.4, 3, 0.1
        } );

      end;
      ng_global.progress[ "std" ][ "clk_winchlever" ].clk = 1;
      ObjSet( "anm_carrepairshop_motorcycle", { alp = 0 } );
      ObjSet( "anm_carrepairshop_motorcycle_down", { alp = 1 } );
      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_lever_click" ); 
      AnimPlay( "anm_carrepairshop_motorcycle_down", "DoAnim", func_end ) 

    end;

  end;

end;
--*********************************************************************************************************************
function private.MotorcycleClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_carrepairshop_motorcycle" );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_moto_touch" );
  AnimPlay( "anm_carrepairshop_motorcycle", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.BagClick (obj)

  local func_end = function ()

    int.Lock( false );
    if obj == "s" then
      cmn.ShowBbt( "bbt_motorcycle_use_skull" );
    else 
      cmn.ShowBbt( "bbt_motorcycle_use_crossed_bones" );
    end;

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_leather_motobag_click" );
  func_end();

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.WorkdeskToolsInit ()

  for t = 1, 5 do

    ObjSet( "spr_workdesk_tool_"..t, { event_menter = function () private.WorkdeskToolEnter( t ) end; } );

  end;

end;
--*********************************************************************************************************************
function private.WorkdeskToolEnter ( idx )

  local func_end = function ()

    ObjSet( "spr_workdesk_tool_"..idx, { input = true } );

  end;

  ObjSet( "spr_workdesk_tool_"..idx, { input = false } );

  --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_watch" );
  ObjAnimate( "spr_workdesk_tool_"..idx, "ang", 0, 0, func_end, 
  {
    0.0, 2,  0.00,
    0.2, 3, -0.03,
    0.4, 3,  0.03,
    0.6, 3, -0.02,
    0.8, 3,  0.02,
    1.0, 3, -0.01,
    1.2, 3,  0.01,
    1.4, 3,  0.00,
  } );

end;
--*********************************************************************************************************************
function private.Anims ()

  ObjAnimate( "spr_workdesk_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    4.5, 3, 1.0,
    9.0, 3, 0.3,
  } );

  ObjAnimate("spr_mechanism_light_add", "alp", 1, 0, "", 
  {
    0.0,0,1,
    1.2,0,0.7,
    1.5,0,0.9,
    2.8,0,1
  });
  ObjAnimate("spr_mechanism_screen_light", "alp", 1, 0, "", 
  {
    0.0,0,1,
    2.0,0,1,
    2.1,0,0,
    2.2,0,1,
    5.0,0,1,
    5.1,0,0,
    5.2,0,1,
    5.3,0,0,
    5.4,0,1
  });
  ObjAnimate( "spr_onthefloor_signal_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    1.2, 3, 0,
    2.4, 3, 1
  } );
  ObjAnimate( "spr_onthefloor_door_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    1.2, 3, 0.5,
    2.4, 3, 1
  } );
  ObjAnimate( "spr_onthefloor_coin_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    1.2, 3, 0.5,
    2.4, 3, 1
  } );
  ObjAnimate( "spr_motorcycle_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0.6,
    4.0, 3, 1
  } );
  ObjAnimate( "spr_carrepairshop_green_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    1.2, 3, 0.5,
    2.4, 3, 1
  } );
  ObjAnimate( "spr_carrepairshop_red_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    1.2, 3, 0.5,
    2.4, 3, 1
  } );

end;
--*********************************************************************************************************************
function private.AnimGreenLight ()

  ObjAnimate( "spr_onthefloor_signal_light_green_add", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    1.2, 3, 0,
    2.4, 3, 1
  } );
  ObjAnimate( "spr_onthefloor_door_light_green", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    1.2, 3, 0.5,
    2.4, 3, 1
  } );
  ObjAnimate( "spr_onthefloor_coin_light_green", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    1.2, 3, 0.5,
    2.4, 3, 1
  } );

end;
--*********************************************************************************************************************
function private.ChainAnims ()

  ObjAnimate( "spr_carrepairshop_chain", "ang", 1, 0, "", 
  { 
    0.0, 3, -0.08,
    2.8, 3, 0.08,
    5.6, 3, -0.08
  } );
  ObjAnimate( "spr_carrepairshop_chain1", "ang", 1, 0, "", 
  { 
    0.0, 3, 0.1,
    3.0, 3, -0.1,
    6.0, 3, 0.1
  } );

end;
--*********************************************************************************************************************
--******function MMG_MECHANISM () *************************************************************************************
--*********************************************************************************************************************
  function private.InitMechanism ()

    private.code = "";

    for i=0, 11 do
      ObjSet( "spr_mechanism_button_"..i, {
        event_mdown = function () private.ClkKnob( i ); end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND); end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT); end,
      });
    end;
    ObjSet( "spr_mechanism_runner", {
      event_mdown = function () private.ClkRunner(); end,
      event_menter = function () cmn.SetCursor( CURSOR_HAND); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT); end,
    });

  end;
  --*********************************************************************************************************************
  function private.StartMechanism ()

    ng_global.progress[ "std" ][ "win_mechanism" ].code = "";
    ng_global.progress[ "std" ][ "win_mechanism" ].start = 1;
    --cmn.MiniGameShow( "mechanism" );

  end;
  --*********************************************************************************************************************
  function private.ClkKnob ( num )

    int.Lock( true );

    if ( #private.code < 10 ) then

      if ( num == 10 ) then

        private.code = private.code.."*";

      elseif ( num == 11 ) then

        private.code = private.code.."#";

      else

        private.code = private.code..num;

      end;

      ObjSet( "txt_mechanism_numbers", { text = private.code } );
      ng_global.progress[ "std" ][ "win_mechanism" ].code = private.code;

    end;

    local knob_y = ObjGet( "spr_mechanism_button_"..num ).pos_y;

    local n = math.random( 1, 5 );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_press_number"..n );
    ObjAnimate( "spr_mechanism_button_"..num, "pos_y", 0, 0, function () int.Lock( false ); end, 
    {
      0.0,0,knob_y,
      0.2,1,knob_y + 2,
      0.4,2,knob_y
    });

  end;
  --*********************************************************************************************************************
  function private.ClkRunner ()

    int.Lock( true );

    if ( private.code == "376*20" ) then
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_press_on" );
    else 
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_press_wrong" );
    end;

    ObjAnimate("spr_mechanism_runner", "pos_xy", 0, 0, function () private.CheckWin(); end, 
    {
      0.0,0,-78,-37,
      0.5,3,-121,22
    });

  end;
  --*********************************************************************************************************************
  function private.CheckWin ()

    if ( private.code == "376*20"  and cmn.IsEventStart( "win_mechanism" ) ) then

      ObjAnimate("spr_mechanism_on_green", "alp", 0, 0, function () private.Win(); end, 
      {
        0.0,0,0,
        0.3,1,1,
      });

    else   
   
      ObjAnimate("spr_mechanism_runner", "pos_xy", 0, 0, "", 
      {
        0.0,0,-121,22,
        0.4,0,-121,22,
        0.9,3,-78,-37
      });
      ObjAnimate("spr_mechanism_on_red", "alp", 0, 0, 
      function () 
        int.Lock( false );   
        private.code = "";
        ng_global.progress[ "std" ][ "win_mechanism" ].code = private.code;
        ObjSet( "txt_mechanism_numbers", { text = private.code } );      
      end, 
      {
        0.0,0,0,
        0.2,1,1,
        0.4,0,1,
        0.6,2,0
      });

    end;

  end;
  --*********************************************************************************************************************
  function private.Win ()

    --cmn.MiniGameHide( "mechanism" );

    cmn.SetEventDone( "win_mechanism" );
    cmn.CallEventHandler( "win_mechanism" ); 
   
    cmn.CloseSubRoom();
    cmn.GotoRoom( "mg_mgboxes" );

  end;
--*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.ClkBag ( name )

    int.Lock( true );

    local func_end = function ()

      cmn.ShowBbt( "bbt_motorcycle_use_"..name );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_leather_motobag_click" );
    ObjAnimate( "spr_motorcycle_close", "pos_xy", 0, 0, func_end, 
    {
      0.0,0,10,-25,
      0.2,3,8,-26,
      0.5,3,10,-25
    });

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************