-- name=rm_demo
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "rm_demo";
  private.MOUSE_OVER_ANIM_TIME = 0.3;

  ObjSet( "btn_demo_buttons", { 
    event_mdown = function () private.ButtonMouseClick(); end,
    event_menter = function () private.ButtonMouseEnter(); end,
    event_mleave = function () private.ButtonMouseLeave(); end 
  });
  
  if IsSurveyEdition() then
    
    ObjSet( "txt_demo_tnx", { text = "str_demo_txt_survey" } );

  elseif IsDemoEdition() then
    
    ObjSet( "txt_demo_tnx", { text = "str_demo_txt_demo" } );

  end; 

  private.InitLines();
  private.InitText();
  private.Anims();
  
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()
  
  if not ( ( IsSurveyEdition() ) or ( IsDemoEdition() ) ) then
    
    cmn.SetCursor(CURSOR_DEFAULT);
    local prg = ng_global.currentprogress;
    ng_global.progress[ prg ].common.chapter = "level2";
    ng_global.progress[ prg ].common.currentroom = nil;
    local level = ng_global.progress[ prg ].common.chapter;

    common.LevelSwitch( level );

  else

    if (IsCollectorsEdition()) then

      ObjSet( "spr_demo_collectors", { visible = 1 } );

    end;

  end;  

end;
--*********************************************************************************************************************
function public.PreOpen()

--  if ( (IsSurveyEdition() == 1 ) or ( IsDemoEdition() == 1) ) then
--
    ObjAnimate( "rm_demo", "color_rgb", 0, 0, "", 
    { 
      0.0, 0, 0, 0, 0,
      0.3, 0, 0, 0, 0,
      0.5, 0, 1, 1, 1
    } );

    int.InterfaceSetInput( 0 ); 
    int.InterfaceSetVisible( 0, 0 );
--
--  else
--
--    DbgTrace("enter")
--    ObjSet( "rm_demo", 
--    { 
--      color_r = 0.0,
--      color_g = 0.0,
--      color_b = 0.0
--    } );
--
--    interface.InterfaceSetInput( 0 ); 
--    interface.InterfaceSetVisible( 0, 0 );
--
--  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.ButtonMouseEnter()

  cmn.SetCursor( CURSOR_HAND );  
  local but_name = "spr_demo_ok_focus";
  local but_alp = ObjGet( but_name ).alp;
  ObjAnimate( but_name, 8, 0, 0, "", { 0, 0, but_alp, ( private.MOUSE_OVER_ANIM_TIME * ( 1 - but_alp ) ), 0, 1 } );

end;
--*********************************************************************************************************************
function private.ButtonMouseLeave()

  cmn.SetCursor( CURSOR_DEFAULT );  
  local but_name = "spr_demo_ok_focus";
  local but_alp = ObjGet( but_name ).alp;
  ObjAnimate( but_name, 8, 0, 0, "", { 0, 0, but_alp, ( private.MOUSE_OVER_ANIM_TIME * but_alp ), 0, 0 } );

end;
--*********************************************************************************************************************
function private.ButtonMouseClick()

  if ( IsSurveyEdition() ) then

    Quit();

  else

    SaveProfiles();
    SaveSettings();

--  common.SaveInterfaceTimers();
    cmn.SetCursor( CURSOR_DEFAULT );
    common.LevelSwitch( "menu", "game" );

  end;  

end;
--*********************************************************************************************************************
function private.InitText ()

  local text;
  local pos_y = 359;
  local pos_x = 440;
  local new_line = 0;

  if IsSurveyEdition() then

    text = StringGet( "str_demo_txt_survey" );

  else

    text = StringGet( "str_demo_txt_demo" );

  end;
  
  for i=1, #text do

    if ( string.sub(text, i, i) == "\n") then
      pos_y = pos_y + 49;
      pos_x = pos_x - ( 31 * ( i - new_line) );
      new_line = i;
    end;

    ObjCreate( "txt_demo_tnx_"..i, "text");
    ObjAttach( "txt_demo_tnx_"..i, "obj_demo_tnx");
    ObjSet( "txt_demo_tnx_"..i, {
      res = "assets/fonts/timesb",
      text = string.sub(text, i, i),
      disprawtext = true,      
      maxwidth = -1,
      fontsize = 47,
      fontcolor_r = 1,
      fontcolor_g = 0.8941,
      fontcolor_b = 0.6823,
      pos_x = pos_x + ( 31 * (i - 1) ),
      pos_y = pos_y,
      scale_x = 0.9
    });

  end;

end;
--*********************************************************************************************************************
function private.InitLines ()

  private.anim_exec = {0,0,0,0,0,0,0}  ;

  for num=1, 18 do
    for row=1, 7 do
      ObjCreate( "anm_demo_letter"..row..num, "anim" );
      ObjAttach( "anm_demo_letter"..row..num, "obj_demo_letter_anims");
      ObjSet( "anm_demo_letter"..row..num, {
        res = "assets/levels/level1/rm_demo/anims/anm_1letter",
        pos_x = 438 + ( 31.3 * (num - 1) ),
        pos_y = 354 + ( 49 * (row - 1) ),
        animfunc = "DoAnim",
        input = false
      } ); 
    end; 
  end;

  for row=1, 7 do
    ObjCreate( "tmr_demo_letter"..row, "timer" );
    ObjAttach( "tmr_demo_letter"..row, "obj_demo_letter_anims");
    ObjSet( "tmr_demo_letter"..row, {
      endtrig = function () private.AnimLines( row ); end,
      playing = true,
      time = 2 + (row*0.8)
    } ); 
  end;

end;
--*********************************************************************************************************************
function private.AnimLines ( row )

    if ( private.anim_exec[ row ] < 19 ) then
      ObjSet( "tmr_demo_letter"..row, { 
        playing = true, 
        time = 0.11,
        endtrig = function () 
                    private.AnimLines( row ); 
                    AnimPlay( "anm_demo_letter"..row..private.anim_exec[ row ] - 1, "DoAnim", "");
                  end
      } );
      private.anim_exec[ row ] = private.anim_exec[ row ] + 1;
    else
      ObjSet( "tmr_demo_letter"..row, { 
        playing = true, 
        time = 12,
        endtrig = function () private.AnimLines( row ); end
      } );
      private.anim_exec[ row ] = 0;
    end;

end;
--*********************************************************************************************************************
function private.Anims ()

  local tme = 2.8;
  local delay = 0.0;
  for i=1, 5 do
    delay = delay + 0.2;
    ObjAnimate("spr_demo_light_"..i, "alp", 1, 0, "", 
    {
      0.0     ,0,0,
      tme+delay     ,0,0,
      tme+0.3+delay ,0,1,
      tme+0.4+delay ,0,1,
      tme+0.7+delay ,0,0,
      tme+11.5 ,0,0
    });
  end;

  ObjAnimate("spr_demo_bush", "ang", 1, 0, "", 
  {
    0.0,0, 0.02,
    2.5,3,-0.02,
    5.5,3, 0.02
  });

  ObjAnimate("spr_demo_light_add", "alp", 1, o, "", 
  {
    0.0,0,1,
    0.8,0,1,
    1.5,0,0.8,
    2.5,0,1
  });

end;
--*********************************************************************************************************************