-- name=rm_policestation
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_policestation";
  ObjSet( "obj_policestation_clk_policeman_dialog_1",           { event_mdown = private.dlg_policestation_policeman_1 } );
  ObjSet( "obj_policestation_clk_policeman_dialog_1_focus",     { event_mdown = private.dlg_policestation_policeman_1 } );
  ObjSet( "obj_policestation_clk_policeman_dialog_2",           { event_mdown = private.dlg_policestation_policeman_2 } );
  ObjSet( "obj_policestation_clk_policeman_dialog_2_focus",     { event_mdown = private.dlg_policestation_policeman_2 } );
  ObjSet( "obj_policestation_clk_lamp",                         { event_mdown = private.ClkLamp } );
  ObjSet( "obj_policestation_clk_policeman",                    { event_mdown = private.clk_policeman } );
  ObjSet( "obj_policestation_clk_policeman_focus",              { event_mdown = private.clk_policeman } );

  private.InitAnim();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_policestation = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gho_policestation_investigatorsdesk"
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_policestation", update_game_mode_policestation, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_policestation () end;
  --------------------------------------------------------------------------------------------
  local opn_policestation = function ()

    ObjDelete( "anm_bypolicestation_jackie" );

  end;

  cmn.AddSubscriber( "opn_policestation", opn_policestation );
--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  common_impl.hint[ "get_carkeys" ] =
  {
    type = "click",
    clk_obj = "obj_policestation_clk_policeman_dialog_2",
    use_place = "obj_policestation_clk_policeman_dialog_2",
    room = private.room_objname,
  };
  --------------------------------------------------------------------------------------------
  -- function get_carkeys () end;
  --------------------------------------------------------------------------------------------
  local get_carkeys_inv = function ()

    int.InventoryItemAdd( "inv_carkeys", "spr_policestation_carkeys" );

  end;

  local get_carkeys_closezz = function ()

    ObjDelete( "spr_policestation_key_car_shadow" );

  end;

  cmn.AddSubscriber( "get_carkeys", get_carkeys_inv );
  cmn.AddSubscriber( "get_carkeys", get_carkeys_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function dlg_policestation_policeman_1 () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_policestation_policeman_1" ] =
  {
    type = "click",
    clk_obj = "obj_policestation_clk_policeman_dialog_1",
    use_place = "obj_policestation_clk_policeman_dialog_1",
    room = private.room_objname,
  };
  -----------------------------------------------
  local dlg_policestation_policeman_1_beg = function ()

  end;
  -----------------------------------------------
  local dlg_policestation_policeman_1_end = function ()

    ObjDelete( "obj_policestation_clk_policeman_dialog_1" );
    ObjSet( "gho_policestation_investigatorsdesk", { active = true, input = true, alp = 1 } );
    ObjSet( "anm_policestation_policeman1", { alp = 0 } );
    ObjDelete( "anm_policestation_head_rotate" );
    ObjSet( "anm_policestation_head_static", { alp = 1, playing = true } );

  end;

  cmn.AddSubscriber( "dlg_policestation_policeman_1", dlg_policestation_policeman_1_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_policestation_policeman_1", dlg_policestation_policeman_1_end, private.room_objname );
  cmn.AddSubscriber( "dlg_policestation_policeman_1_beg", dlg_policestation_policeman_1_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_policestation_policeman_1_end", dlg_policestation_policeman_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function dlg_policestation_policeman_2 () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_policestation_policeman_2" ] =
  {
    type = "click",
    clk_obj = "obj_policestation_clk_policeman_dialog_2",
    use_place = "obj_policestation_clk_policeman_dialog_2",
    room = private.room_objname,
  };
  -----------------------------------------------
  local dlg_policestation_policeman_2_beg = function ()

  end;
  -----------------------------------------------
  local dlg_policestation_policeman_2_end = function ()

    if ( cmn.IsEventDone( "get_carkeys" ) ) then

      ObjDelete( "obj_policestation_clk_policeman_dialog_2" );

    end;

  end;

  cmn.AddSubscriber( "dlg_policestation_policeman_2", dlg_policestation_policeman_2_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_policestation_policeman_2", dlg_policestation_policeman_2_end, private.room_objname );
  cmn.AddSubscriber( "dlg_policestation_policeman_2_beg", dlg_policestation_policeman_2_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_policestation_policeman_2_end", dlg_policestation_policeman_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_1_2 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_1_2 = function ()

    ObjDelete( "obj_policestation_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_1_2", get_morphobject_1_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_policeman () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_policeman" ] =
  {
    type = "click",
    clk_obj = "obj_policestation_clk_policeman",
    use_place = "obj_policestation_clk_policeman",
    room = private.room_objname,
  };
  -----------------------------------------------
  local clk_policeman = function ()


  end;
  -----------------------------------------------
  local clk_policeman_beg = function ()

    ObjDelete( "obj_policestation_clk_policeman" );

  end;
  -----------------------------------------------
  local clk_policeman_end = function ()

    ObjSet( "anm_policestation_policeman1", { alp = 1 } );
    ObjSet( "anm_policestation_head_static", { alp = 0 } );
    ObjSet( "obj_policestation_clk_policeman_dialog_1", { input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_policeman", clk_policeman );
  cmn.AddSubscriber( "clk_policeman", clk_policeman_beg, private.room_objname );
  cmn.AddSubscriber( "clk_policeman", clk_policeman_end, private.room_objname );
  cmn.AddSubscriber( "clk_policeman_beg", clk_policeman_beg, private.room_objname );
  cmn.AddSubscriber( "clk_policeman_end", clk_policeman_end, private.room_objname );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_policestation ()

  if not ( cmn.IsEventDone( "opn_policestation" ) ) then

    cmn.SetEventDone( "opn_policestation" );
    cmn.CallEventHandler( "opn_policestation" );
    cmn.ShowBbt( "bbt_policestation_open" );
    ng_global.progress[ "std" ][ "opn_policestation" ].flag = false;

  end;

end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopAllEnv( "audio/level1/env/aud_policestation_env", true );
  cmn.PlayAudio( "env", "audio/level1/env/aud_policestation_env", 1 );

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_policestation();

  if ( cmn.IsEventDone( "use_wheelwrench_2" ) ) then

    private.SeeOutro_1_1();

  end;

  if ( cmn.IsEventDone( "win_investigatorsdesk" ) and
      not ng_global.progress[ "std" ][ "opn_policestation" ].flag ) then

    ng_global.progress[ "std" ][ "opn_policestation" ].flag = true;

  end;

end;
--*********************************************************************************************************************
-------------------------------------------------
function private.SeeOutro_1_1()

  local func_end = function ()

    cmn.StopAudio( "sfx", "audio/level1/sfx/aud_policestation_outro_mus" );
    cmn.StopAudio( "voc", "audio/level1/voc/aud_policestation_outro_voc" );

    
    if (iOS_IsBought() == 0) then

      iOS_LogEvents(1);
      common.LevelSwitch("menu","unlock");
      
    else 

      local prg = ng_global.currentprogress;
      ng_global.progress[ prg ].common.chapter = "level2";
      ng_global.progress[ prg ].common.currentroom = nil;
      local level = ng_global.progress[ prg ].common.chapter;
      ng_global.task_current = nil;

      cmn.AddPageDiary( 7 );

      common.LevelSwitch( level );    

    end;

  end;

  common_impl.PlayDialogVideo( "vid_policestation_outro", func_end );  

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_policestation_outro_mus" );
  cmn.PlayAudio( "voc", "audio/level1/voc/aud_policestation_outro_voc" );

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_policeman ()

  local func_end = function ()

    cmn.SetEventDone( "clk_policeman" );
    cmn.CallEventHandler( "clk_policeman_end" );
    cmn.CallEventHandler( "clk_policeman" );
    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_policeman_beg" );

  int.Lock( true );

  ObjAnimate( "anm_policestation_head_static", "alp", 0, 0, "", 
  { 
    0.0, 0, 1,
    0.3, 0, 0,
  } );
  ObjAnimate( "anm_policestation_policeman1", "alp", 0, 0, func_end, 
  { 
    0.0, 0, 0,
    0.3, 0, 1,
  } );

end;
-------------------------------------------------
-------------------------------------------------
function private.dlg_policestation_policeman_1 ()

  local func_end = function ()
    ObjSet( "anm_policestation_policeman1", { alp = 0 } );
    ObjSet( "anm_policestation_head_rotate", { alp = 1 } );
    AnimPlay( "anm_policestation_head_rotate", "DoAnim", 
      function ()
        cmn.ShowBbt( "bbt_policestation_dlg1" );  
        cmn.TutorialShow( "tutorial_page_9" );
        cmn.TutorialSetShown( "tutorial_page_9" );
        cmn.CallEventHandler( "dlg_policestation_policeman_1_end" );  
      end
    );  
  end;

  ObjAttach( "dlg_policestation_policeman_1", "rm_policestation" );
  common_impl.dialog_character_loc = "";
  private.dialog_voices_time = { 3 };
  common_impl.DialogCharacterStart( "policeman_1", 2, nil, nil, false, func_end );

  ObjSet( "tmr_policestation_fordial", { playing = 1, time = 0.3, endtrig = "" } );

end;
-------------------------------------------------
-------------------------------------------------
function private.dlg_policestation_policeman_2 ()

  ObjAttach( "dlg_policestation_policeman_2", "rm_policestation" );
  common_impl.dialog_character_loc = "";
  private.dialog_voices_time = { 3 };
  common_impl.DialogCharacterStart( "policeman_2", 2, nil, nil, false, function () private.get_carkeys(); private.PastTransfer();  end );

  ObjSet( "tmr_policestation_fordial", { playing = 1, time = 0.3, endtrig = "" } );
    
end;
-------------------------------------------------
-------------------------------------------------
--------------------------------------------------------------------
function private.PastTransfer()

  local func_end = function ()

    cmn.SetEventDone( "get_carkeys" );
    cmn.SetEventDone( "dlg_policestation_policeman_2" );
    cmn.CallEventHandler( "dlg_policestation_policeman_2_end" );
    cmn.CallEventHandler( "dlg_policestation_policeman_2" );
    cmn.StopAudio( "sfx", "audio/level1/sfx/aud_back_in_past" );

    cmn.GotoRoom( "rm_bygrayscar" );
    int.Lock( false );
    common_impl.InterfaceSetVisible( true );
    cmn.ShowBbt( "bbt_bygrayscar_open" );

  end;

  common_impl.InterfaceSetVisible( false );
  ObjSet( "rm_policestation", { color_r = 0, color_g = 0, color_b = 0 } );
  common_impl.PlayDialogVideo( "vid_policestation_past_transfer", func_end ); 

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_back_in_past" );

end;
-------------------------------------------------
function private.get_carkeys ()

  cmn.CallEventHandler( "get_carkeys" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.ClkLamp ()

  local func_end = function ()

    --cmn.ShowBbt( "bbt_pointer_use_handfulofnuts" );
    ObjSet( "anm_policestation_lamp1", { alp = 1 } );
    ObjSet( "anm_policestation_lamp2", { alp = 0 } );
    int.Lock( false );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/aud_lamp_xx" );
  ObjSet( "anm_policestation_lamp1", { alp = 0 } );
  ObjSet( "anm_policestation_lamp2", { alp = 1 } );

  AnimPlay( "anm_policestation_lamp2", "DoAnim", func_end ); 

end;
-------------------------------------------------
function private.InitAnim ()

 ObjAnimate( "spr_policestation_sunlight", "alp", 1, 0, "",
  { 
    0.0, 0, 1,
    1, 0, 0.5,
    2, 0, 1,
    3.4, 0, 0.1,
    4.2, 0, 1
  } );

end;
-------------------------------------------------
