-- name=rm_townoutskirts
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_townoutskirts";

  ObjAttach( "zz_children",             "room_hub" );
  ObjAttach( "zz_policewindow",         "room_hub" );
  ObjAttach( "zz_doortocarreppairshop", "room_hub" );
  ObjAttach( "zz_policecar",            "room_hub" );
  ObjAttach( "zz_grille",               "room_hub" );
 
  ObjMultiSet( { 
    { "spr_children_amuletpicture",             { event_mdown = private.get_amuletpicture } },
    { "spr_children_bow",                       { event_mdown = private.get_bow } },
    { "spr_children_playdough",                 { event_mdown = private.get_playdough } },
    { "spr_children_adhesivetape",              { event_mdown = private.get_adhesivetape } },
    { "spr_policewindow_brokenworkshopfob",     { event_mdown = private.get_brokenworkshopfob } },
    { "spr_policewindow_awl",                   { event_mdown = private.get_awl } },
    { "spr_policewindow_handle",                { event_mdown = private.get_handle } },
    { "spr_policewindow_masterkey",             { event_mdown = private.get_masterkey } },
    { "spr_policewindow_winchlever",            { event_mdown = private.get_winchlever } },
    { "spr_policewindow_smallbattery_1",        { event_mdown = private.get_smallbattery_1 } },
    { "spr_policewindow_skull",                 { event_mdown = private.get_skull } },
    { "spr_policecar_cabinetkey",               { event_mdown = private.get_cabinetkey } },
    { "spr_grille_mallet",                      { event_mdown = private.get_mallet } },
    { "spr_policecar_acetoneandcottonwool",     { event_mdown = private.get_acetoneandcottonwool } },
    { "obj_townoutskirts_clk_survey",           { event_mdown = private.clk_townoutskirts_survey } },
    { "obj_policecar_clk_connectwires",         { event_mdown = private.clk_connectwires } },
    { "obj_policewindow_clk_cabinet",           { event_mdown = private.clk_cabinet } },
    { "obj_doortocarreppairshop_use_masterkey", { event_mdown = private.DoortocarreppairshopClick } },
    { "obj_children_use_amuletowl",             { event_mdown = private.ClkChildBag } },
    { "obj_children_use_notebooksheet",         { event_mdown = private.ClkChildBagSheet } },
    { "obj_policewindow_use_mallet",            { event_mdown = private.ClkPoliceWindow } },
    { "obj_policewindow_use_gloves",            { event_mdown = private.ClkBrokenPoliceWindow } },
    { "obj_policewindow_use_cabinetkey",        { event_mdown = private.ClkCabinet } },
    { "obj_policewindow_use_antirustsolution",  { event_mdown = private.ClkRustCabinet } },
    { "obj_policecar_use_suitcasebutton",       { event_mdown = private.ClkCarBox } },
    { "obj_policecar_use_amuletcar",            { event_mdown = private.ClkCarBox } },
    { "obj_policecar_use_screwdriver",          { event_mdown = private.ClkCarCase } },
    { "obj_grille_use_pliers",                  { event_mdown = private.ClkGrille } },
    { "spr_policecar_wheel",                    { event_mdown = private.AnimWheel } },
    { "spr_policecar_red_light",                { event_mdown = private.AnimRedlight } },
    { "spr_policecar_pedal_1",                  { event_mdown = function () private.AnimPedal(1); end } },
    { "spr_policecar_pedal_2",                  { event_mdown = function () private.AnimPedal(2); end } },
    { "spr_children_collect2_1_4",              { event_mdown = private.get_collect2_1_4 } }
  } );

  private.Anims();
  private.InitSubroom();
  private.InitPolicewindow();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_townoutskirts = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gho_townoutskirts_roundthecorner",
        "gzz_townoutskirts_children",
        "gzz_townoutskirts_policewindow",
        "gzz_townoutskirts_doortocarreppairshop",
        "gzz_townoutskirts_policecar",
        "gzz_townoutskirts_grille"
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_children", 
        "zz_policewindow", 
        "zz_doortocarreppairshop", 
        "zz_policecar",
        "zz_grille",
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_townoutskirts", update_game_mode_townoutskirts, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_bow () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bow" ] =
    {
      type = "get",
      get_obj = "spr_children_bow",
      room = private.room_objname,
      zz = "zz_children",
      zz_gate = "gzz_townoutskirts_children"
  };
  -----------------------------------------------
  local get_bow_inv = function ()

    int.InventoryItemAdd( "inv_bow", "spr_children_bow" );
    ObjSet( "inv_bow", { drag = false } );

    if ( not cmn.IsEventDone( "get_arrow" ) ) then

      ObjSet( "inv_bow_plus_focus2", { alp = 0 } );

    end;

  end;

  local get_bow_closezz = function ()

    ObjDelete( "gfx_children_bow" );
    ObjDelete( "spr_children_bow_over" );
    ObjDelete( "spr_townoutskirts_children_bow" );

    if ( cmn.IsEventDone( "get_playdough" ) and
         cmn.IsEventDone( "get_collect2_1_4" ) and
         cmn.IsEventDone( "get_bow" ) and
         cmn.IsEventDone( "get_adhesivetape" ) ) then

      ObjDelete( "gzz_townoutskirts_children" );

    end;

  end;

  cmn.AddSubscriber( "get_bow", get_bow_inv );
  cmn.AddSubscriber( "get_bow", get_bow_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_amuletpicture () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletpicture" ] =
    {
      type = "get",
      get_obj = "spr_children_amuletpicture",
      room = private.room_objname,
      zz = "zz_children",
      zz_gate = "gzz_townoutskirts_children"
  };
  -----------------------------------------------
  local get_amuletpicture_inv = function ()

    int.InventoryItemAdd( "inv_amuletpicture", "spr_children_amuletpicture" );

    ObjSet( "inv_ironpiece_plus_focus2", { alp = 1 } );

  end;

  local get_amuletpicture_closezz = function ()

    ObjDelete( "gfx_children_amuletpicture" );

  end;

  cmn.AddSubscriber( "get_amuletpicture", get_amuletpicture_inv );
  cmn.AddSubscriber( "get_amuletpicture", get_amuletpicture_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_playdough () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_playdough" ] =
    {
      type = "get",
      get_obj = "spr_children_playdough",
      room = private.room_objname,
      zz = "zz_children",
      zz_gate = "gzz_townoutskirts_children"
  };
  -----------------------------------------------
  local get_playdough_inv = function ()

    int.InventoryItemAdd( "inv_playdough", "spr_children_playdough" );

    if ( cmn.IsEventDone( "use_arrow" ) ) then

      ObjSet( "inv_bow_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_playdough_closezz = function ()

    ObjDelete( "gfx_children_playdough" );
    ObjDelete( "spr_townoutskirts_plasticine" );
    if ( cmn.IsEventDone( "get_playdough" ) and
         cmn.IsEventDone( "get_collect2_1_4" ) and
         cmn.IsEventDone( "get_bow" ) and
         cmn.IsEventDone( "get_adhesivetape" ) ) then

      ObjDelete( "gzz_townoutskirts_children" );

    end;

  end;

  cmn.AddSubscriber( "get_playdough", get_playdough_inv );
  cmn.AddSubscriber( "get_playdough", get_playdough_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_adhesivetape () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_adhesivetape" ] =
    {
      type = "get",
      get_obj = "spr_children_adhesivetape",
      room = private.room_objname,
      zz = "zz_children",
      zz_gate = "gzz_townoutskirts_children"
  };
  -----------------------------------------------
  local get_adhesivetape_inv = function ()

    int.InventoryItemAdd( "inv_adhesivetape", "spr_children_adhesivetape" );

    if ( cmn.IsEventDone( "clk_brokenworkshopfob_cup_close" ) ) then

      ObjSet( "inv_brokenworkshopfob_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_adhesivetape_closezz = function ()

    ObjDelete( "gfx_children_adhesivetape" );
    ObjDelete( "spr_townoutskirts_tape" );
    if ( cmn.IsEventDone( "get_playdough" ) and
         cmn.IsEventDone( "get_collect2_1_4" ) and
         cmn.IsEventDone( "get_bow" ) and
         cmn.IsEventDone( "get_adhesivetape" ) ) then

      ObjDelete( "gzz_townoutskirts_children" );

    end;

  end;

  cmn.AddSubscriber( "get_adhesivetape", get_adhesivetape_inv );
  cmn.AddSubscriber( "get_adhesivetape", get_adhesivetape_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokenworkshopfob () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brokenworkshopfob" ] =
    {
      type = "get",
      get_obj = "spr_policewindow_brokenworkshopfob",
      room = private.room_objname,
      zz = "zz_policewindow",
      zz_gate = "gzz_townoutskirts_policewindow"
  };
  -----------------------------------------------
  local get_brokenworkshopfob_inv = function ()

    int.InventoryItemAdd( "inv_brokenworkshopfob", "spr_policewindow_brokenworkshopfob" );
    ObjSet( "inv_brokenworkshopfob", { drag = false } );

  end;

  local get_brokenworkshopfob_closezz = function ()

    ObjDelete( "gfx_policewindow_brokenworkshopfob" );

    if ( cmn.IsEventDone( "get_smallbattery_1" ) and
         cmn.IsEventDone( "get_skull" ) and
         cmn.IsEventDone( "get_brokenworkshopfob" ) ) then

      ObjDelete( "gzz_townoutskirts_policewindow" );

    end;

  end;

  cmn.AddSubscriber( "get_brokenworkshopfob", get_brokenworkshopfob_inv );
  cmn.AddSubscriber( "get_brokenworkshopfob", get_brokenworkshopfob_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_awl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_awl" ] =
    {
      type = "get",
      get_obj = "spr_policewindow_awl",
      room = private.room_objname,
      zz = "zz_policewindow",
      zz_gate = "gzz_townoutskirts_policewindow"
  };
  -----------------------------------------------
  local get_awl_inv = function ()

    int.InventoryItemAdd( "inv_awl", "spr_policewindow_awl" );

    if ( cmn.IsEventDone( "win_ironpiece" ) ) then

      ObjSet( "inv_ironpiece_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_awl_closezz = function ()

    ObjDelete( "gfx_policewindow_awl" );
    ObjDelete( "spr_policewindow_awl_shadow" );

  end;

  cmn.AddSubscriber( "get_awl", get_awl_inv );
  cmn.AddSubscriber( "get_awl", get_awl_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_handle" ] =
    {
      type = "get",
      get_obj = "spr_policewindow_handle",
      room = private.room_objname,
      zz = "zz_policewindow",
      zz_gate = "gzz_townoutskirts_policewindow"
  };
  -----------------------------------------------
  local get_handle_inv = function ()

    int.InventoryItemAdd( "inv_handle", "spr_policewindow_handle" );

  end;

  local get_handle_closezz = function ()

    ObjDelete( "gfx_policewindow_handle" );
    ObjDelete( "spr_policewindow_handle_shadow" );

  end;

  cmn.AddSubscriber( "get_handle", get_handle_inv );
  cmn.AddSubscriber( "get_handle", get_handle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mallet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_mallet" ] =
  {
    type = "get",
    get_obj = "spr_grille_mallet",
    room = private.room_objname,
    zz = "zz_grille",
    zz_gate = "gzz_townoutskirts_grille"
  };
  -----------------------------------------------
  local get_mallet_inv = function ()

    int.InventoryItemAdd( "inv_mallet", "spr_grille_mallet" );

  end;
  local get_mallet_closezz = function ()

    ObjDelete( "gfx_grille_mallet" );
    ObjDelete( "spr_grille_mallet_shadow" );
    ObjDelete( "spr_townoutskirts_grille_mallet" );

  end;

  cmn.AddSubscriber( "get_mallet", get_mallet_inv );
  cmn.AddSubscriber( "get_mallet", get_mallet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_masterkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_masterkey" ] =
    {
      type = "get",
      get_obj = "spr_policewindow_masterkey",
      room = private.room_objname,
      zz = "zz_policewindow",
      zz_gate = "gzz_townoutskirts_policewindow"
  };
  -----------------------------------------------
  local get_masterkey_inv = function ()

    int.InventoryItemAdd( "inv_masterkey", "spr_policewindow_masterkey" );

  end;

  local get_masterkey_closezz = function ()

    ObjDelete( "gfx_policewindow_masterkey" );
    ObjDelete( "obj_policewindow_mmg" );

  end;

  cmn.AddSubscriber( "get_masterkey", get_masterkey_inv );
  cmn.AddSubscriber( "get_masterkey", get_masterkey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_winchlever () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_winchlever" ] =
    {
      type = "get",
      get_obj = "spr_policewindow_winchlever",
      room = private.room_objname,
      zz = "zz_policewindow",
      zz_gate = "gzz_townoutskirts_policewindow"
  };
  -----------------------------------------------
  local get_winchlever_inv = function ()

    int.InventoryItemAdd( "inv_winchlever", "spr_policewindow_winchlever" );

  end;

  local get_winchlever_closezz = function ()

    ObjDelete( "gfx_policewindow_winchlever" );

  end;

  cmn.AddSubscriber( "get_winchlever", get_winchlever_inv );
  cmn.AddSubscriber( "get_winchlever", get_winchlever_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cabinetkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cabinetkey" ] =
    {
      type = "get",
      get_obj = "spr_policecar_cabinetkey",
      room = private.room_objname,
      zz = "zz_policecar",
      zz_gate = "gzz_townoutskirts_policecar"
  };
  -----------------------------------------------
  local get_cabinetkey_inv = function ()

    int.InventoryItemAdd( "inv_cabinetkey", "spr_policecar_cabinetkey" );

  end;

  local get_cabinetkey_closezz = function ()

    ObjDelete( "gfx_policecar_cabinetkey" );
    ObjDelete( "spr_policecar_cabinetkey_shadow" );
    ObjDelete( "spr_policecar_cabinetkey_over" );

  end;

  cmn.AddSubscriber( "get_cabinetkey", get_cabinetkey_inv );
  cmn.AddSubscriber( "get_cabinetkey", get_cabinetkey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_smallbattery_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_smallbattery_1" ] =
  {
    type = "get",
    get_obj = "spr_policewindow_smallbattery_1",
    room = private.room_objname,
    zz = "zz_policewindow",
    zz_gate = "gzz_townoutskirts_policewindow"
  };
  -----------------------------------------------
  local get_smallbattery_1_inv = function ()

    int.InventoryItemAdd( "inv_smallbattery_1", "spr_policewindow_smallbattery_1", "assets/levels/level1/rm_bygrayscar/zz_trunk/inv/inv_smallbattery_morph" );
    level1_inv.CheckSmallbattery();

  end;

  local get_smallbattery_1_closezz = function ()

    ObjDelete( "gfx_policewindow_smallbattery_1" );
    ObjDelete( "spr_policewindow_smallbattery_1_shadow" );

    if ( cmn.IsEventDone( "get_smallbattery_1" ) and
         cmn.IsEventDone( "get_skull" ) and
         cmn.IsEventDone( "get_brokenworkshopfob" ) ) then

      ObjDelete( "gzz_townoutskirts_policewindow" );

    end;

  end;

  cmn.AddSubscriber( "get_smallbattery_1", get_smallbattery_1_inv );
  cmn.AddSubscriber( "get_smallbattery_1", get_smallbattery_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_skull () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_skull" ] =
  {
    type = "get",
    get_obj = "spr_policewindow_skull",
    room = private.room_objname,
    zz = "zz_policewindow",
    zz_gate = "gzz_townoutskirts_policewindow"
  };
  -----------------------------------------------
  local get_skull_inv = function ()

    int.InventoryItemAdd( "inv_skull", "spr_policewindow_skull" );

  end;

  local get_skull_closezz = function ()

    ObjDelete( "gfx_policewindow_skull" );
    ObjDelete( "spr_policewindow_skull_shadow" );

    if ( cmn.IsEventDone( "get_smallbattery_1" ) and
         cmn.IsEventDone( "get_skull" ) and
         cmn.IsEventDone( "get_brokenworkshopfob" ) ) then

      ObjDelete( "gzz_townoutskirts_policewindow" );

    end;

  end;

  cmn.AddSubscriber( "get_skull", get_skull_inv );
  cmn.AddSubscriber( "get_skull", get_skull_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_1_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_1_4 = function ()

    ObjDelete( "spr_children_collect2_1_4" );
    ObjDelete( "spr_townoutskirts_collect2_1_4" );

    if ( cmn.IsEventDone( "get_playdough" ) and
         cmn.IsEventDone( "get_collect2_1_4" ) and
         cmn.IsEventDone( "get_bow" ) and
         cmn.IsEventDone( "get_adhesivetape" ) ) then

      ObjDelete( "gzz_townoutskirts_children" );

    end;

  end;

  cmn.AddSubscriber( "get_collect2_1_4", get_collect2_1_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_acetoneandcottonwool () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_acetoneandcottonwool" ] =
  {
    type = "get",
    get_obj = "spr_policecar_acetoneandcottonwool",
    room = private.room_objname,
    zz = "zz_policecar",
    zz_gate = "gzz_townoutskirts_policecar"
  };
  -----------------------------------------------
  local get_acetoneandcottonwool_inv = function ()

    int.InventoryItemAdd( "inv_acetoneandcottonwool", "spr_policecar_acetoneandcottonwool" );

  end;

  local get_acetoneandcottonwool_closezz = function ()

    ObjDelete( "gfx_policecar_acetoneandcottonwool" );
    ObjDelete( "spr_policecar_acetoneandcottonwool_shadow" );

  end;

  cmn.AddSubscriber( "get_acetoneandcottonwool", get_acetoneandcottonwool_inv );
  cmn.AddSubscriber( "get_acetoneandcottonwool", get_acetoneandcottonwool_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_notebooksheet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_notebooksheet" ] =
    {
    type = "use",
      use_obj = "inv_notebooksheet",
      use_place = "obj_children_use_notebooksheet",
      room = private.room_objname,
      zz = "zz_children",
      zz_gate = "gzz_townoutskirts_children"
  };
  -----------------------------------------------
  local use_notebooksheet_inv = function ()

    int.InventoryItemRemove( "inv_notebooksheet" );

  end;
  local use_notebooksheet_beg = function ()

    ObjDelete( "obj_children_use_notebooksheet" );

  end;
  local use_notebooksheet_end = function ()

    ObjSet( "obj_children_use_handle", { input = true } );
    ObjSet( "spr_children_amuletpicture", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_notebooksheet", use_notebooksheet_beg, private.room_objname );
  cmn.AddSubscriber( "use_notebooksheet", use_notebooksheet_inv );
  cmn.AddSubscriber( "use_notebooksheet", use_notebooksheet_end, private.room_objname );
  cmn.AddSubscriber( "use_notebooksheet_inv", use_notebooksheet_inv, private.room_objname );
  cmn.AddSubscriber( "use_notebooksheet_beg", use_notebooksheet_beg, private.room_objname );
  cmn.AddSubscriber( "use_notebooksheet_end", use_notebooksheet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletowl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletowl" ] =
    {
    type = "use",
      use_obj = "inv_amuletowl",
      use_place = "obj_children_use_amuletowl",
      room = private.room_objname,
      zz = "zz_children",
      zz_gate = "gzz_townoutskirts_children"
  };
  -----------------------------------------------
  local use_amuletowl_inv = function ()

    int.InventoryItemRemove( "inv_amuletowl" );

  end;
  local use_amuletowl_beg = function ()

    ObjDelete( "obj_children_use_amuletowl" );

  end;
  local use_amuletowl_end = function ()

    ObjSet( "gfx_children_playdough", { active = true } );
    ObjSet( "gfx_children_adhesivetape", { active = true } );
    ObjSet( "obj_children_open_bag", { alp = 1, input = true } );
    ObjSet( "obj_townoutskirts_open_bag", { alp = 1 } );
    ObjDelete( "spr_children_amulet" );
    ObjDelete( "anm_children_clk_bag" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_amuletowl", use_amuletowl_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletowl", use_amuletowl_inv );
  cmn.AddSubscriber( "use_amuletowl", use_amuletowl_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletowl_inv", use_amuletowl_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletowl_beg", use_amuletowl_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletowl_end", use_amuletowl_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bow () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bow" ] =
    {
    type = "use",
      use_obj = "inv_bow",
      use_place = "obj_children_use_bow",
      room = private.room_objname,
      zz = "zz_children",
      zz_gate = "gzz_townoutskirts_children"
  };
  -----------------------------------------------
  local use_bow_inv = function ()

    int.InventoryItemRemove( "inv_bow" );

  end;
  local use_bow_beg = function ()

    ObjDelete( "obj_children_use_bow" );

  end;
  local use_bow_end = function ()


  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_bow", use_bow_beg, private.room_objname );
  cmn.AddSubscriber( "use_bow", use_bow_inv );
  cmn.AddSubscriber( "use_bow", use_bow_end, private.room_objname );
  cmn.AddSubscriber( "use_bow_inv", use_bow_inv, private.room_objname );
  cmn.AddSubscriber( "use_bow_beg", use_bow_beg, private.room_objname );
  cmn.AddSubscriber( "use_bow_end", use_bow_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_handle" ] =
    {
    type = "use",
      use_obj = "inv_handle",
      use_place = "obj_children_use_handle",
      room = private.room_objname,
      zz = "zz_children",
      zz_gate = "gzz_townoutskirts_children"
  };
  -----------------------------------------------
  local use_handle_inv = function ()

    int.InventoryItemRemove( "inv_handle" );

  end;
  local use_handle_beg = function ()

    ObjDelete( "obj_children_use_handle" );

  end;
  local use_handle_end = function ()

    ObjSet( "spr_children_amuletpicture", { input = true } );
    ObjSet( "obj_children_use_amuletowl", { active = true, input = true } );
    ObjSet( "gfx_children_amuletpicture", { active = true } );
    ObjSet( "spr_children_amuletpicture_pic_full", { alp = 1 } );
    ObjDelete( "anm_children_owl_paint" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_handle", use_handle_beg, private.room_objname );
  cmn.AddSubscriber( "use_handle", use_handle_inv );
  cmn.AddSubscriber( "use_handle", use_handle_end, private.room_objname );
  cmn.AddSubscriber( "use_handle_inv", use_handle_inv, private.room_objname );
  cmn.AddSubscriber( "use_handle_beg", use_handle_beg, private.room_objname );
  cmn.AddSubscriber( "use_handle_end", use_handle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gloves () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gloves" ] =
    {
    type = "use",
      use_obj = "inv_gloves",
      use_place = "obj_policewindow_use_gloves",
      room = private.room_objname,
      zz = "zz_policewindow",
      zz_gate = "gzz_townoutskirts_policewindow"
  };
  -----------------------------------------------
  local use_gloves_inv = function ()

    int.InventoryItemRemove( "inv_gloves" );

  end;
  local use_gloves_beg = function ()

    ObjDelete( "obj_policewindow_use_gloves" );

  end;
  local use_gloves_end = function ()

    ObjSet( "gfx_policewindow_awl", { active = true } );
    ObjSet( "gfx_policewindow_handle", { active = true } );
    ObjDelete( "spr_policewindow_window_closed" );
    ObjDelete( "anm_policewindow_opn_window" );

    ObjSet( "spr_townoutskirts_policewindow_open", { alp = 1 } );
    ObjDelete( "spr_townoutskirts_policewindow_light" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_gloves", use_gloves_beg, private.room_objname );
  cmn.AddSubscriber( "use_gloves", use_gloves_inv );
  cmn.AddSubscriber( "use_gloves", use_gloves_end, private.room_objname );
  cmn.AddSubscriber( "use_gloves_inv", use_gloves_inv, private.room_objname );
  cmn.AddSubscriber( "use_gloves_beg", use_gloves_beg, private.room_objname );
  cmn.AddSubscriber( "use_gloves_end", use_gloves_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bowwitharrow () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bowwitharrow" ] =
    {
    type = "use",
      use_obj = "inv_bowwitharrow",
      use_place = "obj_policewindow_use_bowwitharrow",
      room = private.room_objname,
      zz = "zz_policewindow",
      zz_gate = "gzz_townoutskirts_policewindow"
  };
  -----------------------------------------------
  local use_bowwitharrow_inv = function ()

    int.InventoryItemRemove( "inv_bowwitharrow" );

  end;
  local use_bowwitharrow_beg = function ()

    ObjDelete( "obj_policewindow_use_bowwitharrow" );

  end;
  local use_bowwitharrow_end = function ()

    ObjSet( "obj_policewindow_mmg", { alp = 1, input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_bowwitharrow", use_bowwitharrow_beg, private.room_objname );
  cmn.AddSubscriber( "use_bowwitharrow", use_bowwitharrow_inv );
  cmn.AddSubscriber( "use_bowwitharrow", use_bowwitharrow_end, private.room_objname );
  cmn.AddSubscriber( "use_bowwitharrow_inv", use_bowwitharrow_inv, private.room_objname );
  cmn.AddSubscriber( "use_bowwitharrow_beg", use_bowwitharrow_beg, private.room_objname );
  cmn.AddSubscriber( "use_bowwitharrow_end", use_bowwitharrow_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mallet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mallet" ] =
    {
    type = "use",
      use_obj = "inv_mallet",
      use_place = "obj_policewindow_use_mallet",
      room = private.room_objname,
      zz = "zz_policewindow",
      zz_gate = "gzz_townoutskirts_policewindow"
  };
  -----------------------------------------------
  local use_mallet_inv = function ()

    int.InventoryItemRemove( "inv_mallet" );

  end;
  local use_mallet_beg = function ()

    ObjDelete( "obj_policewindow_use_mallet" );

  end;
  local use_mallet_end = function ()

    ObjSet( "obj_policewindow_use_gloves", { input = true } );
    ObjSet( "spr_policewindow_glass_broken", { alp = 1 } );
    ObjDelete( "vid_policewindow_use_mallet" );
    ObjDelete( "anm_policewindow_clk_window" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_mallet", use_mallet_beg, private.room_objname );
  cmn.AddSubscriber( "use_mallet", use_mallet_inv );
  cmn.AddSubscriber( "use_mallet", use_mallet_end, private.room_objname );
  cmn.AddSubscriber( "use_mallet_inv", use_mallet_inv, private.room_objname );
  cmn.AddSubscriber( "use_mallet_beg", use_mallet_beg, private.room_objname );
  cmn.AddSubscriber( "use_mallet_end", use_mallet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cabinetkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cabinetkey" ] =
    {
    type = "use",
      use_obj = "inv_cabinetkey",
      use_place = "obj_policewindow_use_cabinetkey",
      room = private.room_objname,
      zz = "zz_policewindow",
      zz_gate = "gzz_townoutskirts_policewindow"
  };
  -----------------------------------------------
  local use_cabinetkey_inv = function ()

    int.InventoryItemRemove( "inv_cabinetkey" );

  end;
  local use_cabinetkey_beg = function ()

    ObjDelete( "obj_policewindow_use_cabinetkey" );

  end;
  local use_cabinetkey_end = function ()

    ObjSet( "gfx_policewindow_winchlever", { active = true } );
    ObjSet( "gfx_policewindow_brokenworkshopfob", { active = true } );
    ObjSet( "obj_policewindow_open_cabinet", { alp = 1, input = true } );
    ObjDelete( "spr_policewindow_closed_cabinet" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_cabinetkey", use_cabinetkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_cabinetkey", use_cabinetkey_inv );
  cmn.AddSubscriber( "use_cabinetkey", use_cabinetkey_end, private.room_objname );
  cmn.AddSubscriber( "use_cabinetkey_inv", use_cabinetkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_cabinetkey_beg", use_cabinetkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_cabinetkey_end", use_cabinetkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_masterkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_masterkey" ] =
    {
    type = "use",
      use_obj = "inv_masterkey",
      use_place = "obj_doortocarreppairshop_use_masterkey",
      room = private.room_objname,
      zz = "zz_doortocarreppairshop",
      zz_gate = "gzz_townoutskirts_doortocarreppairshop"
  };
  -----------------------------------------------
  local use_masterkey_inv = function ()

    int.InventoryItemRemove( "inv_masterkey" );

  end;
  local use_masterkey_beg = function ()

    ObjDelete( "obj_doortocarreppairshop_use_masterkey" );

  end;
  local use_masterkey_end = function ()

    ObjSet( "grm_townoutskirts_carrepairshop", { active = true, input = true, visible = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_townoutskirts_carrepairshop_focus");
    end;    
    ObjDelete( "spr_townoutskirts_close_door" );
    ObjDelete( "gzz_townoutskirts_doortocarreppairshop" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_masterkey", use_masterkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_masterkey", use_masterkey_inv );
  cmn.AddSubscriber( "use_masterkey", use_masterkey_end, private.room_objname );
  cmn.AddSubscriber( "use_masterkey_inv", use_masterkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_masterkey_beg", use_masterkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_masterkey_end", use_masterkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screwdriver () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriver" ] =
    {
    type = "use",
      use_obj = "inv_screwdriver",
      use_place = "obj_policecar_use_screwdriver",
      room = private.room_objname,
      zz = "zz_policecar",
      zz_gate = "gzz_townoutskirts_policecar"
  };
  -----------------------------------------------
  local use_screwdriver_inv = function ()

    int.InventoryItemRemove( "inv_screwdriver" );

  end;
  local use_screwdriver_beg = function ()

    ObjDelete( "obj_policecar_use_screwdriver" );

  end;
  local use_screwdriver_end = function ()
    
    ObjDelete( "vid_policecar_screw" );
    ObjDelete( "spr_policecar_closed_case" ); 
    ObjSet( "obj_policecar_open_case", { alp = 1 } );
    ObjSet( "obj_policecar_clk_connectwires", { active = true, input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_screwdriver", use_screwdriver_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver", use_screwdriver_inv );
  cmn.AddSubscriber( "use_screwdriver", use_screwdriver_end, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_inv", use_screwdriver_inv, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_beg", use_screwdriver_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_end", use_screwdriver_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_antirustsolution_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_antirustsolution_2" ] =
  {
    type = "use",
    use_obj = "inv_antirustsolution",
    use_place = "obj_policewindow_use_antirustsolution",
    room = private.room_objname,
    zz = "zz_policewindow",
    zz_gate = "gzz_townoutskirts_policewindow"
  };
  -----------------------------------------------
  local use_antirustsolution_2_inv = function ()

    if cmn.IsEventDone( "use_antirustsolution_1" ) then

      int.InventoryItemRemove( "inv_antirustsolution" );

    end;

  end;
  local use_antirustsolution_2_beg = function ()

    ObjDelete( "obj_policewindow_use_antirustsolution" );

  end;
  local use_antirustsolution_2_end = function ()

    ObjSet( "obj_policewindow_clk_cabinet",  { input = true } );
    ObjDelete( "anm_policewindow_antirust" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_antirustsolution_2", use_antirustsolution_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_antirustsolution_2", use_antirustsolution_2_inv );
  cmn.AddSubscriber( "use_antirustsolution_2", use_antirustsolution_2_end, private.room_objname );
  cmn.AddSubscriber( "use_antirustsolution_2_inv", use_antirustsolution_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_antirustsolution_2_beg", use_antirustsolution_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_antirustsolution_2_end", use_antirustsolution_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_scissors () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_scissors" ] =
    {
    type = "use",
      use_obj = "inv_scissors",
      use_place = "obj_policecar_use_scissors",
      room = private.room_objname,
      zz = "zz_policecar",
      zz_gate = "gzz_townoutskirts_policecar"
  };
  -----------------------------------------------
  local use_scissors_inv = function ()

    int.InventoryItemRemove( "inv_scissors" );

  end;
  local use_scissors_beg = function ()

    ObjDelete( "obj_policecar_use_scissors" );

  end;
  local use_scissors_end = function ()

    ObjSet( "obj_policecar_open_bag", { input = true, alp = 1 } );
    ObjSet( "gfx_policecar_cabinetkey", { active = true } );
    ObjDelete( "anm_policecar_scissors" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_scissors", use_scissors_beg, private.room_objname );
  cmn.AddSubscriber( "use_scissors", use_scissors_inv );
  cmn.AddSubscriber( "use_scissors", use_scissors_end, private.room_objname );
  cmn.AddSubscriber( "use_scissors_inv", use_scissors_inv, private.room_objname );
  cmn.AddSubscriber( "use_scissors_beg", use_scissors_beg, private.room_objname );
  cmn.AddSubscriber( "use_scissors_end", use_scissors_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pliers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pliers" ] =
    {
    type = "use",
      use_obj = "inv_pliers",
      use_place = "obj_grille_use_pliers",
      room = private.room_objname,
      zz = "zz_grille",
      zz_gate = "gzz_townoutskirts_grille"
  };
  -----------------------------------------------
  local use_pliers_inv = function ()

    int.InventoryItemRemove( "inv_pliers" );

  end;
  local use_pliers_beg = function ()

    ObjDelete( "obj_grille_use_pliers" );

  end;
  local use_pliers_end = function ()

    ObjSet( "gho_townoutskirts_roundthecorner", { active = true, input = true, alp = 1 } );
    ObjSet( "spr_grille_rabitz_2", { alp = 1 } );
    ObjDelete( "spr_townoutskirts_grille" );
    ObjDelete( "anm_grille_grilleclick" );
    ObjDelete( "anm_grille_grillecut" );
    ObjDelete( "gzz_townoutskirts_grille" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_pliers", use_pliers_beg, private.room_objname );
  cmn.AddSubscriber( "use_pliers", use_pliers_inv );
  cmn.AddSubscriber( "use_pliers", use_pliers_end, private.room_objname );
  cmn.AddSubscriber( "use_pliers_inv", use_pliers_inv, private.room_objname );
  cmn.AddSubscriber( "use_pliers_beg", use_pliers_beg, private.room_objname );
  cmn.AddSubscriber( "use_pliers_end", use_pliers_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletcar () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletcar" ] =
  {
    type = "use",
    use_obj = "inv_amuletcar",
    use_place = "obj_policecar_use_amuletcar",
    room = private.room_objname,
    zz = "zz_policecar",
    zz_gate = "gzz_townoutskirts_policecar"
  };
  -----------------------------------------------
  local use_amuletcar_inv = function ()

    int.InventoryItemRemove( "inv_amuletcar" );

  end;
  local use_amuletcar_beg = function ()

    ObjDelete( "obj_policecar_use_amuletcar" );

  end;
  local use_amuletcar_end = function ()

    ObjSet( "spr_policecar_car_1", { alp = 1 } );

    if cmn.IsEventDone( "use_suitcasebutton" ) then

      ObjDelete( "anm_policecar_open" );
      ObjDelete( "spr_policecar_car_1" );
      ObjDelete( "spr_policecar_car_2" );
      ObjDelete( "spr_policecar_closed_car_box" );
      ObjSet( "obj_policecar_open_box", { alp = 1, input = true } );
      ObjSet( "gfx_policecar_acetoneandcottonwool", { active = true } );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_amuletcar", use_amuletcar_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletcar", use_amuletcar_inv );
  cmn.AddSubscriber( "use_amuletcar", use_amuletcar_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletcar_inv", use_amuletcar_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletcar_beg", use_amuletcar_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletcar_end", use_amuletcar_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_suitcasebutton () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_suitcasebutton" ] =
  {
    type = "use",
    use_obj = "inv_suitcasebutton",
    use_place = "obj_policecar_use_suitcasebutton",
    room = private.room_objname,
    zz = "zz_policecar",
    zz_gate = "gzz_townoutskirts_policecar"
  };
  -----------------------------------------------
  local use_suitcasebutton_inv = function ()

    int.InventoryItemRemove( "inv_suitcasebutton" );

  end;
  local use_suitcasebutton_beg = function ()

    ObjDelete( "obj_policecar_use_suitcasebutton" );

  end;
  local use_suitcasebutton_end = function ()

    ObjSet( "spr_policecar_car_2", { alp = 1 } );

    if cmn.IsEventDone( "use_amuletcar" ) then

      ObjDelete( "anm_policecar_open" );
      ObjDelete( "spr_policecar_car_1" );
      ObjDelete( "spr_policecar_car_2" );
      ObjDelete( "spr_policecar_closed_car_box" );
      ObjSet( "obj_policecar_open_box", { alp = 1, input = true } );
      ObjSet( "gfx_policecar_acetoneandcottonwool", { active = true } );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_suitcasebutton", use_suitcasebutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_suitcasebutton", use_suitcasebutton_inv );
  cmn.AddSubscriber( "use_suitcasebutton", use_suitcasebutton_end, private.room_objname );
  cmn.AddSubscriber( "use_suitcasebutton_inv", use_suitcasebutton_inv, private.room_objname );
  cmn.AddSubscriber( "use_suitcasebutton_beg", use_suitcasebutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_suitcasebutton_end", use_suitcasebutton_end, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_townoutskirts_survey () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_townoutskirts_survey" ] =
  {
    type = "click",
    clk_obj = "obj_townoutskirts_clk_survey",
    use_place = "obj_townoutskirts_clk_survey",
    room = private.room_objname,
  };
  -----------------------------------------------
  local clk_townoutskirts_survey = function ()


  end;
  -----------------------------------------------
  local clk_townoutskirts_survey_beg = function ()

    ObjDelete( "obj_townoutskirts_clk_survey" );

  end;
  -----------------------------------------------
  local clk_townoutskirts_survey_end = function ()


  end;

  cmn.AddSubscriber( "clk_townoutskirts_survey", clk_townoutskirts_survey );
  cmn.AddSubscriber( "clk_townoutskirts_survey", clk_townoutskirts_survey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_townoutskirts_survey", clk_townoutskirts_survey_end, private.room_objname );
  cmn.AddSubscriber( "clk_townoutskirts_survey_beg", clk_townoutskirts_survey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_townoutskirts_survey_end", clk_townoutskirts_survey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_connectwires () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_connectwires" ] =
    {
      type = "click",
      clk_obj = "obj_policecar_clk_connectwires",
      room = private.room_objname,
      zz = "zz_policecar",
      zz_gate = "gzz_townoutskirts_policecar"
  };
  -----------------------------------------------
  local clk_connectwires_inv = function ()

    int.TaskDone( 2 );

  end;    
  local clk_connectwires_beg = function ()

    ObjDelete( "obj_policecar_clk_connectwires" );    

  end;
  local clk_connectwires_end = function ()

    ObjDelete( "spr_townoutskirts_car" );
    ObjDelete( "gzz_townoutskirts_policecar" );
    ObjSet( "spr_policecar_wire_1", { pos_x = -233, pos_y = -26, ang = -0.2});

  end;
  local clk_connectwires_track = function ()

    ObjSet( "obj_track_police", { alp = 1, input = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_connectwires", clk_connectwires_inv );
  cmn.AddSubscriber( "clk_connectwires", clk_connectwires_beg, private.room_objname );
  cmn.AddSubscriber( "clk_connectwires", clk_connectwires_end, private.room_objname );
  cmn.AddSubscriber( "clk_connectwires", clk_connectwires_track, "rm_track" );
  cmn.AddSubscriber( "clk_connectwires_beg", clk_connectwires_beg, private.room_objname );
  cmn.AddSubscriber( "clk_connectwires_end", clk_connectwires_end, private.room_objname );
  cmn.AddSubscriber( "clk_connectwires_track", clk_connectwires_track, "rm_track" );
  --------------------------------------------------------------------------------------------
  -- function clk_cabinet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_cabinet" ] =
    {
      type = "click",
      clk_obj = "obj_policewindow_clk_cabinet",
      room = private.room_objname,
      zz = "zz_policewindow",
      zz_gate = "gzz_townoutskirts_policewindow"
  };
  -----------------------------------------------
  local clk_cabinet_beg = function ()

    ObjDelete( "obj_policewindow_clk_cabinet" );

  end;
  local clk_cabinet_end = function ()

    ObjSet( "obj_policewindow_rust_cabinet_open",  { alp = 1, input = true } );
    ObjSet( "gfx_policewindow_smallbattery_1",     { active = true } );
    ObjSet( "gfx_policewindow_skull", { active = true } );
    ObjDelete( "spr_policewindow_rust_cabinet" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_cabinet", clk_cabinet_beg, private.room_objname );
  cmn.AddSubscriber( "clk_cabinet", clk_cabinet_end, private.room_objname );
  cmn.AddSubscriber( "clk_cabinet_beg", clk_cabinet_beg, private.room_objname );
  cmn.AddSubscriber( "clk_cabinet_end", clk_cabinet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function see_scare_1_1 () end;
  --------------------------------------------------------------------------------------------
  local see_scare_1_1_beg = function ()


  end;
  local see_scare_1_1_end = function ()


  end;
  cmn.AddSubscriber( "see_scare_1_1", see_scare_1_1_beg, private.room_objname );
  cmn.AddSubscriber( "see_scare_1_1", see_scare_1_1_end, private.room_objname );
  cmn.AddSubscriber( "see_scare_1_1_beg", see_scare_1_1_beg, private.room_objname );
  cmn.AddSubscriber( "see_scare_1_1_end", see_scare_1_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function win_policewindow () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_policewindow" ] =
  {
    room = private.room_objname,
    zz = "zz_policewindow",
    zz_gate = "gzz_townoutskirts_policewindow"
  };
  --*********************************************************************************************************************
  local win_policewindow = function ()

    if ( cmn.IsEventDone( "win_policewindow" ) ) then

      ObjSet( "spr_policewindow_masterkey", { alp = 1, input = true } );
      ObjSet( "gfx_policewindow_masterkey", { active = true } );
      ObjDelete( "anm_policewindow_masterkeykey" );
      ObjDelete( "obj_policewindow_mmg" );

    end;

  end;

  cmn.AddSubscriber( "win_policewindow", win_policewindow, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_1_5 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_1_5 = function ()

    ObjDelete( "obj_townoutskirts_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_1_5", get_morphobject_1_5, private.room_objname );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
function private.get_amuletpicture ()

  cmn.SetEventDone( "get_amuletpicture" );
  cmn.CallEventHandler( "get_amuletpicture" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_bow ()

  cmn.SetEventDone( "get_bow" );
  cmn.CallEventHandler( "get_bow" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_playdough" ) and
       cmn.IsEventDone( "get_collect2_1_4" ) and
       cmn.IsEventDone( "get_bow" ) and
       cmn.IsEventDone( "get_adhesivetape" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_playdough ()

  cmn.SetEventDone( "get_playdough" );
  cmn.CallEventHandler( "get_playdough" );
  
  cmn.GetObjectSfx();
  if ( cmn.IsEventDone( "get_playdough" ) and
       cmn.IsEventDone( "get_collect2_1_4" ) and
       cmn.IsEventDone( "get_bow" ) and
       cmn.IsEventDone( "get_adhesivetape" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_adhesivetape ()

  cmn.SetEventDone( "get_adhesivetape" );
  cmn.CallEventHandler( "get_adhesivetape" );
  
  cmn.GetObjectSfx();
  if ( cmn.IsEventDone( "get_playdough" ) and
       cmn.IsEventDone( "get_collect2_1_4" ) and
       cmn.IsEventDone( "get_bow" ) and
       cmn.IsEventDone( "get_adhesivetape" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_brokenworkshopfob ()

  cmn.SetEventDone( "get_brokenworkshopfob" );
  cmn.CallEventHandler( "get_brokenworkshopfob" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_smallbattery_1" ) and
       cmn.IsEventDone( "get_skull" ) and
       cmn.IsEventDone( "get_brokenworkshopfob" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_awl ()

  cmn.SetEventDone( "get_awl" );
  cmn.CallEventHandler( "get_awl" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_handle ()

  cmn.SetEventDone( "get_handle" );
  cmn.CallEventHandler( "get_handle" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_mallet ()

  cmn.SetEventDone( "get_mallet" );
  cmn.CallEventHandler( "get_mallet" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_masterkey ()
  
  cmn.SetEventDone( "get_masterkey" );
  cmn.CallEventHandler( "get_masterkey" );

  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_winchlever ()

  cmn.SetEventDone( "get_winchlever" );
  cmn.CallEventHandler( "get_winchlever" );
  
  cmn.GetObjectSfx();


end;
-------------------------------------------------
function private.get_cabinetkey ()

  cmn.SetEventDone( "get_cabinetkey" );
  cmn.CallEventHandler( "get_cabinetkey" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_smallbattery_1 ()

  cmn.SetEventDone( "get_smallbattery_1" );
  cmn.CallEventHandler( "get_smallbattery_1" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_smallbattery_1" ) and
       cmn.IsEventDone( "get_skull" ) and
       cmn.IsEventDone( "get_brokenworkshopfob" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_skull ()

  cmn.SetEventDone( "get_skull" );
  cmn.CallEventHandler( "get_skull" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_smallbattery_1" ) and
       cmn.IsEventDone( "get_skull" ) and
       cmn.IsEventDone( "get_brokenworkshopfob" ) ) then

    cmn.CloseSubRoom();

  end;

end;
---------------------------------------------------------------------------------
function private.get_collect2_1_4()
DbgTrace("get_collect2_1_4");
  int.AddCollectibles2( "spr_children_collect2_1_4" );

  local func_end = function ()
DbgTrace("func_end");
    if ( cmn.IsEventDone( "get_playdough" ) and
         cmn.IsEventDone( "get_bow" ) and
         cmn.IsEventDone( "get_adhesivetape" ) ) then
DbgTrace("CloseSubRoom");
      cmn.CloseSubRoom();

    end;

  end;

  ObjAnimate( "tmr_children_mmg", "alp", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "tmr_children_mmg" ).alp, 
    0.7, 0, ObjGet( "tmr_children_mmg" ).alp, 
  } );

end;
-------------------------------------------------
function private.get_acetoneandcottonwool ()

  cmn.SetEventDone( "get_acetoneandcottonwool" );
  cmn.CallEventHandler( "get_acetoneandcottonwool" );
  
  cmn.GetObjectSfx();

end;
--*********************************************************************************************************************
-------------------------------------------------
function public.use_notebooksheet ()

  local item = "inv_notebooksheet";

  if ( cmn.ApplyObj( item, "gzz_townoutskirts_children", false ) and cmn.IsEventDone( "clk_townoutskirts_survey" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_children" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_children_use_notebooksheet", true ) ) then

    cmn.CallEventHandler( "use_notebooksheet_inv" );
    cmn.CallEventHandler( "use_notebooksheet_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_notebooksheet" );
      cmn.CallEventHandler( "use_notebooksheet_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_paper_to_kid" );  
    ObjAnimate( "spr_children_amuletpicture", "alp", 0, 0, func_end,
    { 
      0.0,0,0, 
      0.3,0,1
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_amuletowl ()

  local item = "inv_amuletowl";

  if ( cmn.ApplyObj( item, "gzz_townoutskirts_children", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_children" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_children_use_amuletowl", true ) ) then

    cmn.CallEventHandler( "use_amuletowl_inv" );
    cmn.CallEventHandler( "use_amuletowl_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_amuletowl" );
      cmn.CallEventHandler( "use_amuletowl_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_owl_app" );
    ObjAnimate( "spr_children_amulet", "alp", 0, 0, func_end,
    { 
      0.0,0,0, 
      0.3,0,1,
      0.8,0,1
    } );
    ObjAnimate( "obj_children_open_bag", "alp", 0, 0, "",
    { 
      0.0,0,0, 
      0.5,0,0,
      0.8,0,1
    } );
    ObjAnimate( "anm_children_clk_bag", "alp", 0, 0, "",
    { 
      0.0,0,1, 
      0.5,0,1,
      0.8,0,0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_bow ()

  local item = "inv_bow";

  if ( cmn.ApplyObj( item, "gzz_townoutskirts_children", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_children" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_children_use_bow", true ) ) then

    cmn.CallEventHandler( "use_bow_inv" );
    cmn.CallEventHandler( "use_bow_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_bow" );
      cmn.CallEventHandler( "use_bow_end" );
      int.Lock( false );

    end;

    --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_bow_app" );  
    --ObjAnimate( "spr", "alp", 0, 0, func_end,
    --{ 
    --  0.0, 0, 0.0, 
    --  0.3, 0, 1.0
    --} );

    func_end();
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_handle ()

  local item = "inv_handle";

  if ( cmn.ApplyObj( item, "gzz_townoutskirts_children", false ) and
       cmn.IsEventDone( "use_notebooksheet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_children" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_children_use_handle", true ) and
           cmn.IsEventDone( "use_notebooksheet" ) ) then

    cmn.CallEventHandler( "use_handle_inv" );
    cmn.CallEventHandler( "use_handle_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_handle" );
      cmn.CallEventHandler( "use_handle_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_owl_paint" );  

    ObjAnimate("anm_children_owl_paint", "alp", 0, 0, 
    function ()
      AnimPlay( "anm_children_owl_paint", "DoAnim", func_end );
    end, 
    {
      0.0,0,0,
      0.2,0,1
    });   

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_gloves ()

  local item = "inv_gloves";

  if ( cmn.ApplyObj( item, "gzz_townoutskirts_policewindow", false ) and
       cmn.IsEventDone( "use_mallet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_policewindow" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_policewindow_use_gloves", true ) and
           cmn.IsEventDone( "use_mallet" )  ) then

    cmn.CallEventHandler( "use_gloves_inv" );
    cmn.CallEventHandler( "use_gloves_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_gloves" );
      cmn.CallEventHandler( "use_gloves_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_gloves_app" ); 

    AnimPlay( "anm_policewindow_use_gloves", "DoAnim", 
    function ()
      ObjSet( "spr_policewindow_window_closed", { alp = 0 } );
      ObjSet( "anm_policewindow_opn_window", { alp = 1 } );
      AnimPlay( "anm_policewindow_opn_window", "DoAnim", func_end);
    end );
 


    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_bowwitharrow ()

  local item = "inv_bowwitharrow";

  if ( cmn.ApplyObj( item, "gzz_townoutskirts_policewindow", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_policewindow" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_policewindow_use_bowwitharrow", true ) ) then

    cmn.CallEventHandler( "use_bowwitharrow_inv" );
    cmn.CallEventHandler( "use_bowwitharrow_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_bowwitharrow" );
      cmn.CallEventHandler( "use_bowwitharrow_end" );
      int.Lock( false );
      
      common_impl.PassingMgStart( "policewindow" );
      private.InitPolicewindownStart(); 

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_bow_app" );
    ObjAnimate( "obj_policewindow_mmg", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_mallet ()

  local item = "inv_mallet";

  if ( cmn.ApplyObj( item, "gzz_townoutskirts_policewindow", false ) and cmn.IsEventDone( "clk_townoutskirts_survey" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_policewindow" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_carcab_use_lockpick", true ) ) then

    cmn.ShowBbt( "bbt_carcab_wrong_use" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_policewindow_use_mallet", true ) ) then

    cmn.CallEventHandler( "use_mallet_inv" );
    cmn.CallEventHandler( "use_mallet_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_mallet" );
      cmn.CallEventHandler( "use_mallet_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_crash_window" );
    ObjSet( "vid_policewindow_use_mallet", { alp = 1 } );
    ObjSet( "anm_policewindow_clk_window", { alp = 0 } );
    VidPlay( "vid_policewindow_use_mallet", func_end);

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_cabinetkey ()

  local item = "inv_cabinetkey";

  if ( cmn.ApplyObj( item, "gzz_townoutskirts_policewindow", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_policewindow" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_policewindow_use_cabinetkey", true ) ) then

    cmn.CallEventHandler( "use_cabinetkey_inv" );
    cmn.CallEventHandler( "use_cabinetkey_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_cabinetkey" );
      cmn.CallEventHandler( "use_cabinetkey_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_key_to_case" );  
    ObjAnimate( "spr_policewindow_cabinetkey_1", "alp", 0, 0, "",
    { 
      0.0,0,0, 
      0.3,0,1,
      0.5,0,1,
      0.8,0,0
    } );
    ObjAnimate( "spr_policewindow_cabinetkey_shadow", "alp", 0, 0, "",
    { 
      0.0,0,0, 
      0.3,0,1
    } );
    ObjAnimate( "spr_policewindow_cabinetkey_2", "alp", 0, 0, "",
    { 
      0.0,0,0, 
      0.5,0,0,
      0.8,0,1
    } );
    ObjAnimate( "spr_policewindow_closed_cabinet", "alp", 0, 0, "",
    { 
      0.0,0,1, 
      1.0,0,1,
      1.3,0,0
    } );
    ObjAnimate( "obj_policewindow_open_cabinet", "alp", 0, 0, func_end,
    { 
      0.0,0,0, 
      1.0,0,0,
      1.3,0,1
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_lockpick_3 ()

  local item = "inv_lockpick";

  if ( cmn.ApplyObj( item, "obj_policewindow_use_cabinetkey", true ) ) then

    cmn.ShowBbt( "bbt_policewindow_wrong_lockpick" );
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_masterkey ()

  local item = "inv_masterkey";

  if ( cmn.ApplyObj( item, "gzz_townoutskirts_doortocarreppairshop", false ) and cmn.IsEventDone( "clk_townoutskirts_survey" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_doortocarreppairshop" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_doortocarreppairshop_use_masterkey", true ) ) then

    cmn.CallEventHandler( "use_masterkey_inv" );
    cmn.CallEventHandler( "use_masterkey_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_masterkey" );
      cmn.CallEventHandler( "use_masterkey_end" );
      int.Lock( false );
      cmn.CloseSubRoom();

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_open_garage" ); 
    ObjAnimate( "spr_doortocarreppairshop_masterkey", "pos_xy", 0, 0, "",
    { 
      0.0, 0, 256, 290, 
      0.5, 0, 174, 197,
    } );

    ObjAnimate( "spr_doortocarreppairshop_masterkey", "ang", 0, 0, "",
    { 
      0.0, 0,  0.00, 
      0.5, 0,  0.00, 
      0.7, 0, -0.14,
      0.9, 0,  0.00, 
      1.1, 0, -0.14,
      1.3, 0,  0.00, 
    } );

    ObjAnimate( "spr_doortocarreppairshop_masterkey_trinket", "ang", 0, 0, "",
    { 
      0.0, 0, 0.00, 
      0.5, 0, 0.00, 
      0.7, 0, 0.14,
      0.9, 0, 0.00, 
      1.1, 0, 0.14,
      1.3, 0, 0.00, 
    } );

    ObjAnimate( "spr_doortocarreppairshop_door_shadow", "pos_y", 0, 0, func_end,
    { 
      0.0, 0,  -29, 
      1.3, 0,  -29, 
      1.8, 0, -133,
      2.0, 0, -133,
    } );

    ObjAnimate( "spr_doortocarreppairshop_door_reflection", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      1.3, 0, 1.0, 
      1.5, 0, 0.0,
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_screwdriver ()

  local item = "inv_screwdriver";

  if ( cmn.ApplyObj( item, "gzz_townoutskirts_policecar", false )and cmn.IsEventDone( "clk_townoutskirts_survey" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_policecar" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_policecar_use_screwdriver", true ) ) then

    cmn.CallEventHandler( "use_screwdriver_inv" );
    cmn.CallEventHandler( "use_screwdriver_beg" );
    int.Lock( true );

    local func_end = function ()

      local func_end2 = function ()

        cmn.SetEventDone( "use_screwdriver" );
        cmn.CallEventHandler( "use_screwdriver_end" );
        int.Lock( false );    
      
      end;

      ObjAnimate( "obj_policecar_open_case", "alp", 0, 0, func_end2,
      { 
        0.0, 0, 0.0, 
        0.1, 0, 1.0
      } );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_unscrew_car" ); 
    ObjSet( "spr_policecar_closed_case", { alp = 0 } ); 

    VidPlay( "vid_policecar_screw", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
function public.use_antirustsolution_2 ()

  local item = "inv_antirustsolution";

  if ( cmn.ApplyObj( item, "gzz_townoutskirts_policewindow", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_policewindow" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_policewindow_use_antirustsolution", true ) ) then

    cmn.CallEventHandler( "use_antirustsolution_2_inv" );
    cmn.CallEventHandler( "use_antirustsolution_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_antirustsolution_2" );
      cmn.CallEventHandler( "use_antirustsolution_2_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_solvent_to_box" );

    AnimPlay( "anm_policewindow_antirust", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
function private.SeeCarjack ()

  local func_end = function ()

    --cmn.SetEventDone( "use_screwdriver" );
    --cmn.CallEventHandler( "use_screwdriver_end" );
    int.Lock( false );

    cmn.AddPageDiary( 6 );

    cmn.StopAudio( "sfx", "audio/level1/sfx/aud_townoutskirts_carjack_mus" );
    --cmn.StopAudio( "voc", "audio/level1/voc/aud_watch_voc" );

    int.ShowTaskNote( 2 );

  end;

  common_impl.PlayDialogVideo( "vid_townoutskirts_carjack", func_end );  

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_townoutskirts_carjack_mus" );
  --cmn.PlayAudio( "voc", "audio/level1/voc/aud_watch_voc" );

end;
-------------------------------------------------
function public.use_scissors ()

  local item = "inv_scissors";

  if ( cmn.ApplyObj( item, "gzz_townoutskirts_policecar", false ) and cmn.IsEventDone( "clk_townoutskirts_survey" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_policecar" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_policecar_use_scissors", true ) ) then

    cmn.CallEventHandler( "use_scissors_inv" );
    cmn.CallEventHandler( "use_scissors_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_scissors" );
      cmn.CallEventHandler( "use_scissors_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_scissors_app" );  
    AnimPlay( "anm_policecar_scissors", "DoAnim", func_end);
   
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_pliers ()

  local item = "inv_pliers";

  if ( cmn.ApplyObj( item, "gzz_townoutskirts_grille", false ) and cmn.IsEventDone( "clk_townoutskirts_survey" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_grille" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_grille_use_pliers", true ) and cmn.IsEventDone( "clk_townoutskirts_survey" ) ) then

    cmn.CallEventHandler( "use_pliers_inv" );
    cmn.CallEventHandler( "use_pliers_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_pliers" );
      cmn.CallEventHandler( "use_pliers_end" );
      int.Lock( false );

      cmn.CloseSubRoom();      

    end;

    ObjSet( "anm_grille_grillecut", { alp = 1 } );
    ObjSet( "anm_grille_grilleclick", { alp = 0 } );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_nippers_app" );
    AnimPlay( "anm_grille_grillecut", "DoAnim", func_end ) 

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_amuletcar ()

  local item = "inv_amuletcar";

  if ( cmn.ApplyObj( item, "gzz_townoutskirts_policecar", false ) and cmn.IsEventDone( "clk_townoutskirts_survey" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_policecar" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_policecar_use_amuletcar", true ) ) then


      cmn.CallEventHandler( "use_amuletcar_inv" );
      cmn.CallEventHandler( "use_amuletcar_beg" );
      int.Lock( true );

      local func_end = function ()

        local func_end = function ()

          cmn.SetEventDone( "use_amuletcar" );
          cmn.CallEventHandler( "use_amuletcar_end" );
          int.Lock( false );

        end;

        if cmn.IsEventDone( "use_suitcasebutton" ) then

          local anim_end = function ()

            ObjAnimate( "anm_policecar_open", "alp", 0, 0, "",
            { 
              0.0, 0, 1.0, 
              0.3, 0, 0.0
            } );
            ObjAnimate( "obj_policecar_open_box", "alp", 0, 0, func_end,
            { 
              0.0, 0, 0.0, 
              0.3, 0, 1.0
            } );

          end;

          cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_wood_box_open" );
          ObjSet( "spr_policecar_car_1", { alp = 0 } );
          ObjSet( "spr_policecar_car_2", { alp = 0 } );
          ObjSet( "anm_policecar_open", { alp = 1 } );
          ObjSet( "spr_policecar_closed_car_box", { alp = 0 } );
          AnimPlay( "anm_policecar_open", "DoAnim", anim_end ); 

        else 

          func_end();

        end;

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_wood_amulet_app" );

    ObjAnimate( "spr_policecar_car_1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_suitcasebutton ()

  local item = "inv_suitcasebutton";

  if ( cmn.ApplyObj( item, "gzz_townoutskirts_policecar", false ) and cmn.IsEventDone( "clk_townoutskirts_survey" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_policecar" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_policecar_use_suitcasebutton", true ) ) then

    cmn.CallEventHandler( "use_suitcasebutton_inv" );
    cmn.CallEventHandler( "use_suitcasebutton_beg" );
    int.Lock( true );

    local func_end = function ()

      local func_end = function ()

        cmn.SetEventDone( "use_suitcasebutton" );
        cmn.CallEventHandler( "use_suitcasebutton_end" );
        int.Lock( false );

      end;

      if cmn.IsEventDone( "use_amuletcar" ) then

        local anim_end = function ()

          ObjAnimate( "anm_policecar_open", "alp", 0, 0, "",
          { 
            0.0, 0, 1.0, 
            0.3, 0, 1.0,
            0.6, 0, 0.0
          } );
          ObjAnimate( "obj_policecar_open_box", "alp", 0, 0, func_end,
          { 
            0.0, 0, 0.0, 
            0.3, 0, 0.0,
            0.6, 0, 1.0
          } );

        end;

        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_wood_box_open" );
        ObjSet( "spr_policecar_car_1", { alp = 0 } );
        ObjSet( "spr_policecar_car_2", { alp = 0 } );
        ObjSet( "anm_policecar_open", { alp = 1 } );
        ObjSet( "spr_policecar_closed_car_box", { alp = 0 } );
        AnimPlay( "anm_policecar_open", "DoAnim", anim_end ); 

      else 

        func_end();

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_wood_amulet_app" );
    ObjAnimate( "spr_policecar_car_2", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_townoutskirts_survey ()

  local func_end = function ()

    cmn.SetEventDone( "clk_townoutskirts_survey" );
    cmn.CallEventHandler( "clk_townoutskirts_survey_end" );
    cmn.CallEventHandler( "clk_townoutskirts_survey" );
    cmn.StopAudio( "sfx", "audio/level1/sfx/aud_townoutskirts_survey_2_mus" );
    cmn.StopAudio( "voc", "audio/level1/voc/aud_townoutskirts_survey_2_voc" );
    cmn.PlayAudio( "mus", "audio/level1/mus/aud_normal_mus" );
    int.Lock( false );

    cmn.AddPageDiary( 4 );

  end;

  cmn.CallEventHandler( "clk_townoutskirts_survey_beg" );

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_townoutskirts_survey_2", func_end ); 

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_townoutskirts_survey_2_mus" );
  cmn.PlayAudio( "voc", "audio/level1/voc/aud_townoutskirts_survey_2_voc" );

end;
-------------------------------------------------
function private.clk_connectwires ()

  local func_end = function ()

    cmn.SetEventDone( "clk_connectwires" );
    cmn.CallEventHandler( "clk_connectwires_end" );
    cmn.CallEventHandler( "clk_connectwires_track" );

    int.Lock( false );

    cmn.CloseSubRoom();
    cmn.GotoRoom( "rm_track" );
    private.SeeCarjack();

  end;

  cmn.CallEventHandler( "clk_connectwires_beg" );

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_start_policecar" );

  ObjAnimate("spr_policecar_wire_1", "pos_xy", 0, 0, func_end, 
  {
    0.0,0,-241,-30,
    0.3,0,-233,-26
  });
  ObjAnimate("spr_policecar_wire_1", "ang", 0, 0, "", 
  {
    0.0,0, 0.0,
    0.3,0,-0.2
  });

end;
-------------------------------------------------
function private.clk_cabinet ()

  local func_end = function ()

    cmn.SetEventDone( "clk_cabinet" );
    cmn.CallEventHandler( "clk_cabinet_end" );
    cmn.CallEventHandler( "clk_cabinet" );

    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_cabinet_beg" );

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_open_up_metal_box" );

  ObjAnimate( "spr_policewindow_rust_cabinet", "alp", 0, 0, "",
  { 
    0.0,0,1, 
    0.3,0,0
  } );
  ObjAnimate( "obj_policewindow_rust_cabinet_open", "alp", 0, 0, func_end,
  { 
    0.0,0,0, 
    0.3,0,1
  } );

end;
-------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Task ()

  --int.DeleteTaskMap( "rm_track", "opn_townoutskirts" );
  int.AddedTaskMap( private.room_objname, "opn_carrepairshop",        { "use_masterkey" } );

  int.AddedTaskMap( private.room_objname, "get_amuletpicture",        { "use_handle" } );
  int.AddedTaskMap( private.room_objname, "get_bow" );
  int.AddedTaskMap( private.room_objname, "get_mallet"  ); 
  int.AddedTaskMap( private.room_objname, "get_playdough",            { "use_amuletowl" } );
  int.AddedTaskMap( private.room_objname, "get_adhesivetape",         { "use_amuletowl" } );
  int.AddedTaskMap( private.room_objname, "get_brokenworkshopfob",    { "use_cabinetkey" } );
  int.AddedTaskMap( private.room_objname, "get_awl",                  { "use_gloves", "use_mallet" } );
  int.AddedTaskMap( private.room_objname, "get_handle",               { "use_gloves", "use_mallet" } );
  int.AddedTaskMap( private.room_objname, "get_masterkey",            { "win_policewindow" } );
  int.AddedTaskMap( private.room_objname, "get_winchlever",           { "use_cabinetkey" } );
  int.AddedTaskMap( private.room_objname, "get_cabinetkey",           { "use_scissors" } );
  int.AddedTaskMap( private.room_objname, "get_acetoneandcottonwool", { "use_amuletcar", "use_suitcasebutton" } );


  int.AddedTaskMap( private.room_objname, "use_notebooksheet",        { "get_handle" } );
  int.AddedTaskMap( private.room_objname, "use_amuletowl",            { "get_amuletowl" } );
  --int.AddedTaskMap( private.room_objname, "use_bow",                  { "" } );
  int.AddedTaskMap( private.room_objname, "use_handle",               { "use_notebooksheet" } );
  int.AddedTaskMap( private.room_objname, "use_gloves",               { "get_gloves" } );
  int.AddedTaskMap( private.room_objname, "use_bowwitharrow",         { "get_bowwitharrow" } );
  int.AddedTaskMap( private.room_objname, "use_mallet",                { "get_mallet" } );
  int.AddedTaskMap( private.room_objname, "use_cabinetkey",           { "get_cabinetkey" } );
  --int.AddedTaskMap( private.room_objname, "use_lockpick_3",           { "" } );
  int.AddedTaskMap( private.room_objname, "use_masterkey",            { "get_masterkey" } );
  int.AddedTaskMap( private.room_objname, "use_screwdriver",          { "get_screwdriver" } );
  int.AddedTaskMap( private.room_objname, "use_scissors",             { "get_scissors" } );
  int.AddedTaskMap( private.room_objname, "use_pliers",               { "get_pliers" } );
  int.AddedTaskMap( private.room_objname, "use_antirustsolution_2",   { "win_roundthecorner" } );
  int.AddedTaskMap( private.room_objname, "use_amuletcar",            { "get_amuletcar" } );
  int.AddedTaskMap( private.room_objname, "use_suitcasebutton",       { "get_suitcasebutton" } );
  
  int.AddedTaskMap( private.room_objname, "clk_townoutskirts_survey", { "opn_townoutskirts" } );
  int.AddedTaskMap( private.room_objname, "clk_connectwires",         { "use_screwdriver" } );

  int.AddedTaskMap( private.room_objname, "win_roundthecorner",       { "use_pliers" } );
  --int.AddedTaskMap( private.room_objname, "win_children",             { "use_handle" } );
  int.AddedTaskMap( private.room_objname, "win_policewindow",         { "use_bowwitharrow" } );

end;
--*********************************************************************************************************************
function private.opn_townoutskirts ()

  if not ( cmn.IsEventDone( "opn_townoutskirts" ) ) then

    cmn.SetEventDone( "opn_townoutskirts" );
    cmn.ShowBbt( "bbt_townoutskirts_open" );
    ng_global.progress[ "std" ][ "opn_townoutskirts" ].policecar_open = 0;

  end;

end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.PreOpen ()

  if ( cmn.IsEventDone( "get_amuletowl" ) and not cmn.IsEventDone( "see_scare_1_1" ) ) then

    ObjSet( "rm_firsttowerfloor", { color_r = 0, color_g = 0, color_b = 0 } );

  end;

  cmn.StopAllEnv( "audio/level1/env/aud_townoutskirts_env", true );
  cmn.PlayAudio( "env", "audio/level1/env/aud_townoutskirts_env", 1 );

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_townoutskirts();

  if ( cmn.IsEventDone( "get_amuletowl" ) and not cmn.IsEventDone( "see_scare_1_1" ) ) then

    private.SeeScare_1_1();

  end;

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_policecar" );

  -------------------------------------------------
  function zz_policecar.Open()

    if ng_global.progress[ "std" ][ "opn_townoutskirts" ].policecar_open == 0 then

      cmn.ShowBbt( "bbt_policecar_first_entry" );
      ng_global.progress[ "std" ][ "opn_townoutskirts" ].policecar_open = 1;

    end;

  end;
  -------------------------------------------------
  function zz_policecar.Close()


  end;

-------------------------------------------------

  subroom.Define( "zz_policewindow" );

  function zz_policewindow.Open()

    if ( cmn.IsEventStart( "win_policewindow" ) and not cmn.IsEventDone( "win_policewindow" ) ) then

      local func_end = function ()

        int.Lock( false );

        ObjSet( "anm_policewindow_bow_onstart" , { alp = 0 } );
        ObjSet( "anm_policewindow_bow_sight" , { alp = 1, playing = true } );

        cmn.MiniGameShow( "policewindow" );
        common_impl.PassingMgStart( "policewindow" );

        private.AnimGauges();

      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_bow_app" );
      ObjSet( "anm_policewindow_bow_onstart", { alp = 1} );
      AnimPlay( "anm_policewindow_bow_onstart", "DoAnim", func_end );

    end;

  end;
  -------------------------------------------------
  function zz_policewindow.PreClose()

    if ( cmn.IsEventStart( "win_policewindow" ) and not cmn.IsEventDone( "win_policewindow" ) ) then

      cmn.MiniGameHide( "policewindow" );
      common_impl.PassingMgStop( "policewindow" );

      ObjStopAnimate( "spr_policewindow_gauge_v", "pos_y" );
      ObjStopAnimate( "spr_policewindow_gauge_h", "pos_x" );

    end;

  end;
  -------------------------------------------------
  function zz_policewindow.Close()

    if ( cmn.IsEventStart( "win_policewindow" ) and not cmn.IsEventDone( "win_policewindow" ) ) then

      ObjSet( "anm_policewindow_bow_sight" , { alp = 0, playing = false } );

    end;

  end;
  -----------------------------------------------
  function zz_policewindow.Skip ()

    private.WinPolicewindow();

  end;
  -------------------------------------------------
  function zz_policewindow.Reset ()

    private.stage = 0;
    ObjStopAnimate( "spr_policewindow_gauge_v", "pos_y" );
    ObjStopAnimate( "spr_policewindow_gauge_h", "pos_x" );
    private.AnimGauges();
    
  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.SeeScare_1_1 ()

  local func_end = function ()

    cmn.SetEventDone( "see_scare_1_1" );
    cmn.CallEventHandler( "see_scare_1_1" ); 
    ObjSet( "rm_firsttowerfloor", { color_r = 1, color_g = 1 ,color_b = 1 } );  

    cmn.StopAudio( "sfx", "audio/level1/sfx/aud_townoutskirts_scare_mus" );
    --cmn.StopAudio( "voc", "audio/level1/voc/aud_watch_voc" );

    cmn.ShowBbt( "bbt_carrepairshop_atropos_scare" );
    cmn.PlayAudio( "mus", "audio/level1/mus/aud_tiny_scare_mus" );
    int.Lock( false ) ;

  end;

  local func_skip = function ()

    cmn.SetEventDone( "see_scare_1_1" );
    cmn.CallEventHandler( "see_scare_1_1" ); 
    ObjSet( "rm_firsttowerfloor", { color_r = 1, color_g = 1 ,color_b = 1 } );  
    cmn.ShowBbt( "bbt_carrepairshop_atropos_scare" );
    cmn.PlayAudio( "mus", "audio/level1/mus/aud_tiny_scare_mus" );

    int.Lock( false ) ;

  end;

  int.Lock( true ) ;

  common_impl.PlayDialogVideo( "vid_townoutskirts_scare", func_skip, func_end );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_townoutskirts_scare_mus" );
  --cmn.PlayAudio( "voc", "audio/level1/voc/aud_watch_voc" );

end;
--*********************************************************************************************************************
function private.DoortocarreppairshopClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_doortocarrepairshop_use_masterkey" );

  end;


  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_garage_door_touch" );
  ObjAnimate( "spr_doortocarreppairshop_door_shadow", "pos_y", 0, 0, func_end, 
  {
    0.0, 3, -29,
    0.2, 3, -32,
    0.4, 3, -29,
    0.6, 3, -32,
    0.8, 3, -29,
  } );

  ObjAnimate( "spr_doortocarreppairshop_door_reflection", "pos_y", 0, 0, "", 
  {
    0.0, 3, 211,
    0.2, 3, 214,
    0.4, 3, 211,
    0.6, 3, 214,
    0.8, 3, 211,
  } );

end;
--*********************************************************************************************************************
function private.ClkChildBag ()

  int.Lock( true );  
  AnimPlay( "anm_children_clk_bag", "DoAnim", function () int.Lock( false ); cmn.ShowBbt( "bbt_children_use_amuletowl" ); end ); 

end;
--*********************************************************************************************************************
function private.ClkChildBagSheet ()

  int.Lock( true );  
  AnimPlay( "anm_children_clk_bag", "DoAnim", function () int.Lock( false ); cmn.ShowBbt( "bbt_children_use_notebooksheet" ); end ); 

end;
--*********************************************************************************************************************
function private.ClkPoliceWindow ()

  int.Lock( true );  
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_window_touch" );
  AnimPlay( "anm_policewindow_clk_window", "DoAnim", function () int.Lock( false ); cmn.ShowBbt( "bbt_policewindow_use_mallet" ); end ); 

end;
--*********************************************************************************************************************
function private.ClkBrokenPoliceWindow ()

  int.Lock( true );  
  AnimPlay( "anm_policewindow_clk_window_broken", "DoAnim", function () int.Lock( false ); cmn.ShowBbt( "bbt_policewindow_use_gloves" ); end ); 

end;
--*********************************************************************************************************************
function private.ClkCabinet ()

  int.Lock( true );  
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_gluebox_cp" );
  ObjAnimate("spr_policewindow_closed_cabinet", "pos_x", 0, 0, 
  function ()
    int.Lock( false );
    cmn.ShowBbt( "bbt_policewindow_use_cabinetkey" );
  end, 
  {
    0.0,0,117,
    0.2,0,116,
    0.4,0,117
  });

end;
--*********************************************************************************************************************
function private.ClkGrille ()

  int.Lock( true );  
  AnimPlay( "anm_grille_grilleclick", "DoAnim", function () int.Lock( false ); cmn.ShowBbt( "bbt_townoutskirts_use_pliers" ); end ); 

end;
--*********************************************************************************************************************
function private.ClkRustCabinet ()

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_gluebox_cp" );
  ObjAnimate("spr_policewindow_rust_cabinet", "pos_x", 0, 0, 
  function ()
    int.Lock( false );
    cmn.ShowBbt( "bbt_policewindow_use_antirustsolution" );
  end, 
  {
    0.0,0,116,
    0.2,0,115,
    0.4,0,116
  });

end;
--*********************************************************************************************************************
function private.ClkCarBox ()

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_policecar_underwheel_touch" );
  ObjAnimate("spr_policecar_closed_car_box", "pos_xy", 0, 0, 
  function ()
    int.Lock( false );
    cmn.ShowBbt( "bbt_policecar_use_amuletcar" );
  end, 
  {
    0.0,0,169,-160,
    0.2,0,171,-159,
    0.4,0,169,-161,
    0.5,0,171,-159,
    0.7,0,169,-160
  });

end;
--*********************************************************************************************************************
function private.ClkCarCase ()

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_policecar_underwheel_touch" );
  ObjAnimate("vid_policecar_screw", "pos_xy", 0, 0, 
  function ()
    int.Lock( false );
    cmn.ShowBbt( "bbt_policecar_use_screwdriver" );
  end, 
  {
    0.0,0,-157,77,
    0.2,0,-155,78,
    0.3,0,-157,76,
    0.5,0,-155,78,
    0.7,0,-157,77,
  });

end;
--*********************************************************************************************************************
function private.Anims ()

  ObjAnimate( "spr_doortocarreppairshop_light", "alp", 1, 0, "", 
  {
    0.0, 0, 0.0,
    0.1, 0, 1.0,
    0.2, 0, 1.0,
    0.3, 0, 0.0,
    1.0, 0, 0.0,
    1.2, 0, 1.0,
    1.3, 0, 1.0,
    1.5, 0, 0.0,
    1.7, 0, 1.0,
    1.8, 0, 1.0,
    2.0, 0, 0.0,
    2.8, 0, 0.0,
  } );
  ObjAnimate("spr_policecar_light_add", "alp", 1, 0, "", 
  {
    0.0,0,1,
    1.2,0,0.7,
    1.9,0,0.9,
    3.4,0,0.7,
    4.2,0,1
  });

  ObjAnimate("spr_policecar_dial_1", "ang", 1, 0, "", 
  {
    0.0,0,0.0,
    1.0,0,0.0,
    1.2,3,0.05,
    1.4,3,0.0,
    1.6,3,0.05,
    1.8,3,0.0,
    2.6,0,0.0
  });
  ObjAnimate("spr_policecar_dial_3", "ang", 1, 0, "", 
  {
    0.0,0,0.0,
    2.0,0,0.0,
    2.2,3,0.05,
    2.4,3,0.0,
    2.6,3,0.05,
    2.8,3,0.0,
    3.6,0,0.0
  });
  ObjAnimate("spr_policecar_dial_2", "ang", 1, 0, "", 
  {
    0.0,0,0.0,
    0.8,0,0.0,
    1.0,3,-0.05,
    1.2,3,0.0,
    1.4,3,-0.05,
    1.6,3,0.0,
    2.0,0,0.0
  });
  ObjAnimate("spr_policecar_dial_4", "ang", 1, 0, "", 
  {
    0.0,0,0.0,
    1.5,0,0.0,
    1.7,3,-0.05,
    1.9,3,0.0,
    2.1,3,-0.05,
    2.3,3,0.0,
    3.9,0,0.0
  });

  ObjAnimate( "obj_townoutskirts_children", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.6,
    2.0, 0, 1,
    3.0, 0, 0.6,
    4.0, 0, 1,
    5.0, 0, 0.6,
    6.0, 0, 1,
    7.0, 0, 0.6,
    8.0, 0, 1,
    8.2, 0, 0.6,
    8.4, 0, 1,
    8.6, 0, 0.6,
    8.8, 0, 1
  } );

  ObjAnimate( "obj_children_kid", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.6,
    2.0, 0, 1,
    3.0, 0, 0.6,
    4.0, 0, 1,
    5.0, 0, 0.6,
    6.0, 0, 1,
    7.0, 0, 0.6,
    8.0, 0, 1,
    8.2, 0, 0.6,
    8.4, 0, 1,
    8.6, 0, 0.6,
    8.8, 0, 1
  } );

  ObjAnimate( "spr_children_bow_over", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.6,
    2.0, 0, 1,
    3.0, 0, 0.6,
    4.0, 0, 1,
    5.0, 0, 0.6,
    6.0, 0, 1,
    7.0, 0, 0.6,
    8.0, 0, 1,
    8.2, 0, 0.6,
    8.4, 0, 1,
    8.6, 0, 0.6,
    8.8, 0, 1
  } );

  ObjAnimate("spr_townoutskirts_policewindow_light", "alp", 0, 0, "", 
  {
    0.0,0,1,
    1.0,0,1,
    1.8,0,0.8,
    2.8,0,1,
    3.6,0,1,
    4.2,0,0.7,
    4.8,0,1
  });

  ObjAnimate( "spr_townoutskirts_lamp_light", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    2.0, 3, 1.0,
    2.1, 3, 0.0,
    2.2, 3, 1.0,
    2.3, 3, 0.0,
    2.4, 3, 1.0,
    3.0, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.AnimWheel ()

  local func_end = function ()

    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_policecar_wheel_touch" );
  ObjAnimate("spr_policecar_wheel", "ang", 0, 0, func_end, 
  {
    0.0,0,0.0,
    0.3,0,0.1,
    0.6,0,0.0
  });

end;
--*********************************************************************************************************************
function private.AnimPedal ( num )

  local func_end = function ()

    int.Lock( false );

  end;

  int.Lock( true );

  local y = ObjGet( "spr_policecar_pedal_"..num ).pos_y
  ObjAnimate( "spr_policecar_pedal_"..num, "pos_y", 0, 0, func_end, 
  {
    0.0,0,y,
    0.2,0,y+6,
    0.4,0,y
  });

end;
--*********************************************************************************************************************
function private.AnimRedlight ()

  local func_end = function ()

    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_policecar_radio_touch" );
  ObjAnimate("spr_policecar_red_light", "alp", 0, 0, func_end, 
  {
    0.0,0,0,
    0.3,0,1,
    0.7,0,1,
    1.0,0,0
  });

end;
--********************************************************************************************************************
-- function *** MMG POLICEWINDOW ***  () end;
--********************************************************************************************************************
--********************************************************************************************************************
  function private.InitPolicewindow ()

    private.stage = 0;
    private.v_gauge_pos = -100;
    private.h_gauge_pos = -100;
  
    ObjSet( "obj_policewindow_shoot", { event_mdown = function () private.Shoot(); end } );

  end;
  --*********************************************************************************************************************
  function private.InitPolicewindownStart ()  

    local func_end = function ()

      int.Lock( false );
      ObjSet( "anm_policewindow_bow_onstart" , { alp = 0 } );
      ObjSet( "anm_policewindow_bow_sight" , { alp = 1, playing = true } );
      cmn.MiniGameShow( "policewindow");
      common_impl.PassingMgStart( "policewindow" ); 

      ObjSet( "obj_policewindow_mmg", { input = true } ); 
      private.AnimGauges();

    end;
  
    int.Lock( true );
    ObjSet( "anm_policewindow_bow_onstart", { alp = 1} );
    AnimPlay( "anm_policewindow_bow_onstart", "DoAnim", func_end );
    --cmn.PlayAudio( "env", "audio/level4/env/aud_vacuum_cleaner_env", 1 );

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.WinPolicewindow ()
    
    common_impl.PassingMgWin( "policewindow" );
    local func_end = function ()

      cmn.MiniGameHide( "policewindow" );
      cmn.SetEventDone( "win_policewindow" );
      cmn.CallEventHandler( "win_policewindow" );

      int.Lock( false ) ;

      --ObjSet( "spr_policewindow_masterkey", { alp = 1 } );
      private.get_masterkey();

    end;

    int.Lock( true ) ;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_shot" );

    ObjStopAnimate( "spr_policewindow_gauge_h", "pos_x" );

    ObjSet( "anm_policewindow_bow_sight", { alp = 0, playing = false } );
    ObjSet( "anm_policewindow_masterkeykey", { alp = 0, playing = false } );
    ObjSet( "anm_policewindow_bow_win", { alp = 1 } );
    AnimPlay( "anm_policewindow_bow_win", "DoAnim", func_end );

    ObjAnimate("obj_policewindow_mmg", "alp", 0, 0, func_end, 
    {
      0.0,0,1,
      1.2,0,1,
      1.5,0,0
    });

  end;
  --*********************************************************************************************************************
  function private.AnimGauges ()

    if private.stage == 0 then

      ObjAnimate("spr_policewindow_gauge_v", "pos_y", 1, 0, "", 
      {
        0.0,0,-80,
        3.0,3, 60,
        6.0,3,-80
      });

    elseif private.stage == 1 then

      ObjAnimate("spr_policewindow_gauge_h", "pos_x", 1, 0, "", 
      {
        0.0,0,-79,
        3.5,3, 61,
        7.0,3,-79
      });

    end;

  end;
  --*********************************************************************************************************************
  function private.LosePolicewindow ()

    local func_end = function ()

      int.Lock( false ) ;
      ObjSet( "spr_policewindow_arrow", { alp = 1, pos_x = -21, pos_y = -26, scale_x = 1, scale_y = 1, ang = 0 } );
      private.stage = 0;
      private.AnimGauges();

      ObjSet( "anm_policewindow_bow_restart" , { alp = 0 } );
      ObjSet( "anm_policewindow_bow_sight" , { alp = 1, playing = true } );

    end;

    int.Lock( true ) ;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_shot_fail" );

    ObjSet( "anm_policewindow_bow_sight", { alp = 0, playing = false } );
    ObjSet( "anm_policewindow_bow_blunder", { alp = 1 } );
    AnimPlay( "anm_policewindow_bow_blunder", "DoAnim", 
      function ()
        ObjSet( "anm_policewindow_bow_blunder", { alp = 0, playing = false } );
        ObjSet( "anm_policewindow_bow_restart", { alp = 1 } );
        AnimPlay( "anm_policewindow_bow_restart", "DoAnim", func_end ); 
      end
    );

  end;
  --*********************************************************************************************************************
  function private.Shoot ()

    if private.stage == 0 then

      ObjStopAnimate( "spr_policewindow_gauge_v", "pos_y" );
      private.v_gauge_pos = ObjGet( "spr_policewindow_gauge_v" ).pos_y;
      private.stage = private.stage + 1;      
      private.AnimGauges();

    elseif private.stage == 1 then

      ObjStopAnimate( "spr_policewindow_gauge_h", "pos_x" );
      private.h_gauge_pos = ObjGet( "spr_policewindow_gauge_h" ).pos_x;

      if ( ( ( private.v_gauge_pos > -19 ) and ( private.v_gauge_pos < -3 ) ) and 
         ( ( private.h_gauge_pos > -14 ) and ( private.h_gauge_pos < 1 ) ) ) then
      --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_shot" );
        private.WinPolicewindow();
      else
        --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_shot_fail" );
        private.LosePolicewindow();
      end;

    end;

  end;
--*********************************************************************************************************************