-- name=rm_track
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_track";

  ObjAttach( "zz_burningroad", "room_hub" );
  ObjAttach( "zz_pileofhay",   "room_hub" );
  ObjAttach( "zz_carcab",      "room_hub" );
  
  ObjSet( "spr_burningroad_flamingfirebrand",   { event_mdown = private.get_flamingfirebrand } );
  ObjSet( "spr_pileofhay_shard",                { event_mdown = private.get_shard } );
  ObjSet( "spr_pileofhay_lockpick",             { event_mdown = private.get_lockpick } );
  ObjSet( "spr_track_wheel",                    { event_mdown = private.get_wheel_2 } );
  ObjSet( "spr_carcab_stolenbag",               { event_mdown = private.get_stolenbag } );
  ObjSet( "spr_carcab_arrow",                   { event_mdown = private.get_arrow } );
  ObjSet( "spr_track_wheelwrench",              { event_mdown = private.get_wheelwrench } );
  --ObjSet( "gzz_track_burningroad",            { event_mdown = private.clk_vid_fire_1 } );
  ObjSet( "obj_track_clk_fire",                 { event_mdown = private.clk_vid_fire_1 } );
  ObjSet( "obj_pileofhay_clk_lockpick",         { event_mdown = private.clk_lockpick } );
  ObjSet( "spr_carcab_thumbler1",               { event_mdown = private.ClkRadio } );
  ObjSet( "spr_carcab_thumbler22",              { event_mdown = private.clk_toggle } );
  ObjSet( "spr_carcab_knifes_bag",              { event_mdown = function () private.ClkSmallBag( true ) end; } );
  ObjSet( "spr_carcab_knifes_bag1",             { event_mdown = function () private.ClkSmallBag( false ) end; } );
  ObjSet( "obj_carcab_big_bag_clk",             { event_mdown = private.ClkBigBag } );
  ObjSet( "spr_carcab_knifes_photo3",           { event_mdown = private.clk_photo_1 } );
  ObjSet( "spr_carcab_knifes_photo2",           { event_mdown = private.clk_photo_2 } );
  ObjSet( "obj_burningroad_use_chainsaw",       { event_mdown = private.BurningroadClickTree } );
  ObjSet( "obj_carcab_clk_rudder",              { event_mdown = private.ClkRudder } );
  ObjSet( "obj_carcab_use_lockpick",            { event_mdown = private.ClkHandle } );
  ObjSet( "obj_carcab_clk_lockpick",            { event_mdown = private.clk_handle } );
  ObjSet( "obj_carcab_use_toggle",              { event_mdown = private.ClkWires } );
  ObjSet( "obj_carcab_clk_man",                 { event_mdown = private.clk_man } );

  private.Anims();
  private.InitSubroom();
  private.InitCarcab();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_track = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gzz_track_burningroad",
        "gzz_track_pileofhay",
        "gzz_track_carcab"
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_children", 
        "zz_pileofhay", 
        "zz_carcab", 
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_track", update_game_mode_track, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_flamingfirebrand () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_flamingfirebrand" ] =
  {
    type = "get",
    get_obj = "spr_burningroad_flamingfirebrand",
    room = private.room_objname,
    zz = "zz_burningroad",
    zz_gate = "gzz_track_burningroad"
  };
  -----------------------------------------------
  local get_flamingfirebrand_inv = function ()

    int.InventoryItemAdd( "inv_flamingfirebrand", "spr_burningroad_flamingfirebrand" );

  end;
  local get_flamingfirebrand_closezz = function ()

  end;

  cmn.AddSubscriber( "get_flamingfirebrand", get_flamingfirebrand_inv );
  cmn.AddSubscriber( "get_flamingfirebrand", get_flamingfirebrand_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_shard () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_shard" ] =
  {
    type = "get",
    get_obj = "spr_pileofhay_shard",
    room = private.room_objname,
    zz = "zz_pileofhay",
    zz_gate = "gzz_track_pileofhay"
  };
  -----------------------------------------------
  local get_shard_inv = function ()

    int.InventoryItemAdd( "inv_shard", "spr_pileofhay_shard" );

  end;
  local get_shard_closezz = function ()

    ObjDelete( "gfx_pileofhay_shard" );
    ObjDelete( "spr_pileofhay_shard_shadow" );
    ObjDelete( "spr_track_bottle" );

    if ( cmn.IsEventDone( "get_shard" ) and
         cmn.IsEventDone( "get_lockpick" ) ) then

      ObjDelete( "gzz_track_pileofhay" );

    end;

  end;

  cmn.AddSubscriber( "get_shard", get_shard_inv );
  cmn.AddSubscriber( "get_shard", get_shard_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lockpick () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lockpick" ] =
  {
    type = "get",
    get_obj = "spr_pileofhay_lockpick",
    room = private.room_objname,
    zz = "zz_pileofhay",
    zz_gate = "gzz_track_pileofhay"
  };
  -----------------------------------------------
  local get_lockpick_inv = function ()

    int.InventoryItemAdd( "inv_lockpick", "spr_pileofhay_lockpick" );

  end;
  local get_lockpick_closezz = function ()

    ObjDelete( "gfx_pileofhay_lockpick" );
    ObjDelete( "spr_track_clip_down" );

    if ( cmn.IsEventDone( "get_shard" ) and
         cmn.IsEventDone( "get_lockpick" ) ) then

      ObjDelete( "gzz_track_pileofhay" );

    end;

  end;

  cmn.AddSubscriber( "get_lockpick", get_lockpick_inv );
  cmn.AddSubscriber( "get_lockpick", get_lockpick_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stolenbag () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stolenbag" ] =
  {
    type = "get",
    get_obj = "spr_carcab_stolenbag",
    room = private.room_objname,
    zz = "zz_carcab",
    zz_gate = "gzz_track_carcab"
  };
  -----------------------------------------------
  local get_stolenbag_inv = function ()

    int.InventoryItemAdd( "inv_stolenbag", "spr_carcab_stolenbag" );
    ObjSet( "inv_stolenbag", { drag = false } );
    
    if ( not cmn.IsEventDone( "get_medalliondove" ) ) then

      ObjSet( "inv_purse_plus_focus2", { alp = 0 } );

    end;

  end;
  local get_stolenbag_closezz = function ()

    ObjDelete( "gfx_carcab_stolenbag" );
    ObjDelete( "spr_carcab_stolenbag_shadow" );
    ObjSet( "obj_carcab_thumblers", { input = true } );
    ObjSet( "obj_carcab_use_toggle", { input = true } );

  end;

  cmn.AddSubscriber( "get_stolenbag", get_stolenbag_inv );
  cmn.AddSubscriber( "get_stolenbag", get_stolenbag_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_arrow () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_arrow" ] =
  {
    type = "get",
    get_obj = "spr_carcab_arrow",
    room = private.room_objname,
    zz = "zz_carcab",
    zz_gate = "gzz_track_carcab"
  };
  -----------------------------------------------
  local get_arrow_inv = function ()

    int.InventoryItemAdd( "inv_arrow", "spr_carcab_arrow" );

    ObjSet( "inv_bow_plus_focus2", { alp = 1 } );

  end;
  local get_arrow_closezz = function ()

    ObjDelete( "gfx_carcab_arrow" );
    ObjDelete( "spr_carcab_arrow_shad" );

  end;

  cmn.AddSubscriber( "get_arrow", get_arrow_inv );
  cmn.AddSubscriber( "get_arrow", get_arrow_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wheel_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wheel_2" ] =
  {
    type = "get",
    get_obj = "spr_track_wheel",
    room = private.room_objname
  };
  -----------------------------------------------
  local get_wheel_2_inv = function ()

    int.InventoryItemAdd( "inv_wheel", "spr_track_wheel" );

    if ( cmn.IsEventDone( "get_wheel" ) ) then

      ObjSet( "inv_wheel", { res = "assets/levels/level1/rm_track/inv/inv_wheel_2" } );  
      ObjDelete( "txt_wheel_num" );

    end;


  end;
  local get_wheel_2_closezz = function ()

    ObjDelete( "gfx_track_wheel" );

  end;

  cmn.AddSubscriber( "get_wheel_2", get_wheel_2_inv );
  cmn.AddSubscriber( "get_wheel_2", get_wheel_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wheelwrench () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wheelwrench" ] =
  {
    type = "get",
    get_obj = "spr_track_wheelwrench",
    room = private.room_objname
  };
  -----------------------------------------------
  local get_wheelwrench_inv = function ()

    int.InventoryItemAdd( "inv_wheelwrench", "spr_track_wheelwrench" );

  end;
  local get_wheelwrench_closezz = function ()

    ObjDelete( "gfx_track_wheelwrench" );

  end;

  cmn.AddSubscriber( "get_wheelwrench", get_wheelwrench_inv );
  cmn.AddSubscriber( "get_wheelwrench", get_wheelwrench_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_extinguisher () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_extinguisher" ] =
  {
    type = "use",
    use_obj = "inv_extinguisher",
    use_place = "obj_burningroad_use_extinguisher",
    room = private.room_objname,
    zz = "zz_burningroad",
    zz_gate = "gzz_track_burningroad"
  };
  -----------------------------------------------
  local use_extinguisher_inv = function ()

    int.InventoryItemRemove( "inv_extinguisher" );

  end;
  local use_extinguisher_beg = function ()

    ObjDelete( "obj_burningroad_use_extinguisher" );

  end;
  local use_extinguisher_end = function ()

    ObjSet( "obj_burningroad_use_chainsaw", { input = true } );
    ObjDelete( "vid_burningroad_fire" );
    ObjDelete( "vid_burningroad_extinguisher" );
    ObjDelete( "obj_track_fire" );
    ObjDelete( "spr_burningroad_fire_light" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_extinguisher", use_extinguisher_beg, private.room_objname );
  cmn.AddSubscriber( "use_extinguisher", use_extinguisher_inv );
  cmn.AddSubscriber( "use_extinguisher", use_extinguisher_end, private.room_objname );
  cmn.AddSubscriber( "use_extinguisher_inv", use_extinguisher_inv, private.room_objname );
  cmn.AddSubscriber( "use_extinguisher_beg", use_extinguisher_beg, private.room_objname );
  cmn.AddSubscriber( "use_extinguisher_end", use_extinguisher_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_coaltongs () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_coaltongs" ] =
  {
    type = "use",
    use_obj = "inv_coaltongs",
    use_place = "obj_burningroad_use_coaltongs",
    room = private.room_objname,
    zz = "zz_burningroad",
    zz_gate = "gzz_track_burningroad"
  };
  -----------------------------------------------
  local use_coaltongs_inv = function ()

    int.InventoryItemRemove( "inv_coaltongs" );

  end;
  local use_coaltongs_beg = function ()

    ObjDelete( "obj_burningroad_use_coaltongs" );

  end;
  local use_coaltongs_end = function ()

    ObjSet( "obj_burningroad_use_extinguisher", { input = true } );
    ObjDelete( "anm_burningroad_coaltongs" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_coaltongs", use_coaltongs_beg, private.room_objname );
  cmn.AddSubscriber( "use_coaltongs", use_coaltongs_inv );
  cmn.AddSubscriber( "use_coaltongs", use_coaltongs_end, private.room_objname );
  cmn.AddSubscriber( "use_coaltongs_inv", use_coaltongs_inv, private.room_objname );
  cmn.AddSubscriber( "use_coaltongs_beg", use_coaltongs_beg, private.room_objname );
  cmn.AddSubscriber( "use_coaltongs_end", use_coaltongs_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chainsaw () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chainsaw" ] =
  {
    type = "use",
    use_obj = "inv_chainsaw",
    use_place = "obj_burningroad_use_chainsaw",
    room = private.room_objname,
    zz = "zz_burningroad",
    zz_gate = "gzz_track_burningroad"
  };
  -----------------------------------------------
  local use_chainsaw_inv = function ()

    int.InventoryItemRemove( "inv_chainsaw" );

  end;
  local use_chainsaw_beg = function ()

    ObjDelete( "obj_burningroad_use_chainsaw" );
    ObjDelete( "obj_burningroad_tree" );

  end;
  local use_chainsaw_end = function ()

    ObjSet( "grm_track_townoutskirts", { active = true, input = true, visible = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_track_townoutskirts_focus");
    end;    
    ObjDelete( "spr_burningroad_tree_part_1" );
    ObjDelete( "spr_burningroad_tree_part_1" );
    ObjDelete( "gzz_track_burningroad" );
    ObjDelete( "spr_track_burningroad" );
    ObjSet( "spr_track_burningroad1", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_chainsaw", use_chainsaw_beg, private.room_objname );
  cmn.AddSubscriber( "use_chainsaw", use_chainsaw_inv );
  cmn.AddSubscriber( "use_chainsaw", use_chainsaw_end, private.room_objname );
  cmn.AddSubscriber( "use_chainsaw_inv", use_chainsaw_inv, private.room_objname );
  cmn.AddSubscriber( "use_chainsaw_beg", use_chainsaw_beg, private.room_objname );
  cmn.AddSubscriber( "use_chainsaw_end", use_chainsaw_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_flamingfirebrand () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_flamingfirebrand" ] =
  {
    type = "use",
    use_obj = "inv_flamingfirebrand",
    use_place = "obj_pileofhay_use_flamingfirebrand",
    room = private.room_objname,
    zz = "zz_pileofhay",
    zz_gate = "gzz_track_pileofhay"
  };
  -----------------------------------------------
  local use_flamingfirebrand_inv = function ()

    int.InventoryItemRemove( "inv_flamingfirebrand" );

  end;
  local use_flamingfirebrand_beg = function ()

    ObjDelete( "obj_pileofhay_use_flamingfirebrand" );

  end;
  local use_flamingfirebrand_end = function ()

    ObjSet( "spr_pileofhay_lockpick", { active = true, input = true, visible = true } );
    ObjDelete( "spr_pileofhay_grass_shadow" );
    ObjDelete( "vid_pileofhay_flamingfirebrand" );
    ObjDelete( "vid_pileofhay_flamingfirebrand_add" );
    ObjSet( "spr_track_clip_down",    { alp = 1 } );
    ObjDelete( "spr_track_grass" );
    ObjDelete( "anm_pileofay_web_free" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_flamingfirebrand", use_flamingfirebrand_beg, private.room_objname );
  cmn.AddSubscriber( "use_flamingfirebrand", use_flamingfirebrand_inv );
  cmn.AddSubscriber( "use_flamingfirebrand", use_flamingfirebrand_end, private.room_objname );
  cmn.AddSubscriber( "use_flamingfirebrand_inv", use_flamingfirebrand_inv, private.room_objname );
  cmn.AddSubscriber( "use_flamingfirebrand_beg", use_flamingfirebrand_beg, private.room_objname );
  cmn.AddSubscriber( "use_flamingfirebrand_end", use_flamingfirebrand_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_killersphoto () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_killersphoto" ] =
  {
    type = "use",
    use_obj = "inv_killersphoto",
    use_place = "obj_carcab_use_killersphoto",
    room = private.room_objname,
    zz = "zz_carcab",
    zz_gate = "gzz_track_carcab"
  };
  -----------------------------------------------
  local use_killersphoto_inv = function ()

    int.InventoryItemRemove( "inv_killersphoto" );

  end;
  local use_killersphoto_beg = function ()

    ObjDelete( "obj_carcab_use_killersphoto" );

  end;
  local use_killersphoto_end = function ()

    ObjSet( "spr_carcab_photo", { alp = 1 } );
    ObjSet( "obj_carcab_man", { input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_killersphoto", use_killersphoto_beg, private.room_objname );
  cmn.AddSubscriber( "use_killersphoto", use_killersphoto_inv );
  cmn.AddSubscriber( "use_killersphoto", use_killersphoto_end, private.room_objname );
  cmn.AddSubscriber( "use_killersphoto_inv", use_killersphoto_inv, private.room_objname );
  cmn.AddSubscriber( "use_killersphoto_beg", use_killersphoto_beg, private.room_objname );
  cmn.AddSubscriber( "use_killersphoto_end", use_killersphoto_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_toggle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_toggle" ] =
  {
    type = "use",
    use_obj = "inv_toggle",
    use_place = "obj_carcab_use_toggle",
    room = private.room_objname,
    zz = "zz_carcab",
    zz_gate = "gzz_track_carcab"
  };
  -----------------------------------------------
  local use_toggle_inv = function ()

    int.InventoryItemRemove( "inv_toggle" );

  end;
  local use_toggle_beg = function ()

    ObjDelete( "obj_carcab_use_toggle" );

  end;
  local use_toggle_end = function ()

    ObjSet( "spr_carcab_thumbler22", { alp = 1, input = true } );
    ObjSet( "spr_carcab_thumbler21", { alp = 1 } );
    ObjDelete( "anm_carcab_wires" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_toggle", use_toggle_beg, private.room_objname );
  cmn.AddSubscriber( "use_toggle", use_toggle_inv );
  cmn.AddSubscriber( "use_toggle", use_toggle_end, private.room_objname );
  cmn.AddSubscriber( "use_toggle_inv", use_toggle_inv, private.room_objname );
  cmn.AddSubscriber( "use_toggle_beg", use_toggle_beg, private.room_objname );
  cmn.AddSubscriber( "use_toggle_end", use_toggle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lockpick_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lockpick_1" ] =
  {
    type = "use",
    use_obj = "inv_lockpick",
    use_place = "obj_carcab_use_lockpick",
    room = private.room_objname,
    zz = "zz_carcab",
    zz_gate = "gzz_track_carcab"
  };
  -----------------------------------------------
  local use_lockpick_1_inv = function ()

    if cmn.IsEventDone( "use_lockpick_2" ) then

      int.InventoryItemRemove( "inv_lockpick" );

    end;

  end;
  local use_lockpick_1_beg = function ()

    ObjDelete( "obj_carcab_use_lockpick" );

  end;
  local use_lockpick_1_end = function ()

    ObjSet( "obj_carcab_clk_lockpick", { input = true } );
    ObjDelete( "anm_carcab_latchkey" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_lockpick_1", use_lockpick_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockpick_1", use_lockpick_1_inv );
  cmn.AddSubscriber( "use_lockpick_1", use_lockpick_1_end, private.room_objname );
  cmn.AddSubscriber( "use_lockpick_1_inv", use_lockpick_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_lockpick_1_beg", use_lockpick_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockpick_1_end", use_lockpick_1_end, private.room_objname );
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_rope () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_rope" ] =
  {
    type = "use",
    use_obj = "inv_rope",
    use_place = "obj_carcab_use_rope",
    room = private.room_objname,
    zz = "zz_carcab",
    zz_gate = "gzz_track_carcab"
  };
  -----------------------------------------------
  local use_rope_inv = function ()

    int.InventoryItemRemove( "inv_rope" );

  end;
  local use_rope_beg = function ()

    ObjDelete( "obj_carcab_use_rope" );

  end;
  local use_rope_end = function ()

    ObjDelete( "spr_carcab_man" );
    ObjSet( "anm_carcab_man_rope", { alp = 1 } );
    ObjSet( "obj_carcab_clk_man",  { input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_rope", use_rope_beg, private.room_objname );
  cmn.AddSubscriber( "use_rope", use_rope_inv );
  cmn.AddSubscriber( "use_rope", use_rope_end, private.room_objname );
  cmn.AddSubscriber( "use_rope_inv", use_rope_inv, private.room_objname );
  cmn.AddSubscriber( "use_rope_beg", use_rope_beg, private.room_objname );
  cmn.AddSubscriber( "use_rope_end", use_rope_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_vid_fire_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_vid_fire_1" ] =
  {
    type = "click",
    clk_obj = "gzz_track_burningroad",
    room = private.room_objname,
  };
  -----------------------------------------------------------------------------------
  local clk_vid_fire_1_beg = function ()

  end;
  local clk_vid_fire_1_end = function ()

    --ObjSet( "gzz_track_burningroad", { event_mdown = function () cmn.GotoSubRoom( "zz_burningroad", nil, { 512, 384 } ); end; } );
    ObjSet( "obj_track_fire",        { visible = true, active = true } );
    ObjSet( "spr_track_burningroad", { alp = 1 } );
    ObjDelete( "obj_track_clk_fire" );

  end;
  cmn.AddSubscriber( "clk_vid_fire_1", clk_vid_fire_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_vid_fire_1", clk_vid_fire_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_vid_fire_1_beg", clk_vid_fire_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_vid_fire_1_end", clk_vid_fire_1_end, private.room_objname );

--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_lockpick () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_lockpick" ] =
  {
    type = "click",
    clk_obj = "obj_pileofhay_clk_lockpick",
    room = private.room_objname,
    zz = "zz_pileofhay",
    zz_gate = "gzz_track_pileofhay"
  };
  -----------------------------------------------------------------------------------
  local clk_lockpick_beg = function ()

    ObjDelete( "obj_pileofhay_clk_lockpick" );

  end;
  local clk_lockpick_end = function ()

    ObjSet( "obj_pileofhay_use_flamingfirebrand", { input = true } );
    ObjSet( "anm_pileofay_web_free", { alp = 1, playing = true } );
    ObjDelete( "anm_pileofay_web_lockpick" );
    ObjDelete( "anm_pileofay_web_static" );
    ObjDelete( "spr_track_clip_up" );

  end;
  cmn.AddSubscriber( "clk_lockpick", clk_lockpick_beg, private.room_objname );
  cmn.AddSubscriber( "clk_lockpick", clk_lockpick_end, private.room_objname );
  cmn.AddSubscriber( "clk_lockpick_beg", clk_lockpick_beg, private.room_objname );
  cmn.AddSubscriber( "clk_lockpick_end", clk_lockpick_end, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_toggle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_toggle" ] =
  {
    type = "click",
    clk_obj = "spr_carcab_thumbler22",
    room = private.room_objname,
    zz = "zz_carcab",
    zz_gate = "gzz_track_carcab"
  };
  -----------------------------------------------------------------------------------
  local clk_toggle_beg = function ()

    ObjSet( "spr_carcab_thumbler22", { input = false } );

  end;
  local clk_toggle_end = function ()

    ObjSet( "spr_carcab_thumbler22", { ang = 0.71 } );
    ObjSet( "obj_carcab_open_cashe", { alp = 1, input = true } );
    ObjDelete( "obj_carcab_close_cashe" );

  end;
  cmn.AddSubscriber( "clk_toggle", clk_toggle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_toggle", clk_toggle_end, private.room_objname );
  cmn.AddSubscriber( "clk_toggle_beg", clk_toggle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_toggle_end", clk_toggle_end, private.room_objname );

--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_bag () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_bag" ] =
  {
    type = "click",
    clk_obj = "spr_carcab_knifes_bag",
    room = private.room_objname,
    zz = "zz_carcab",
    zz_gate = "gzz_track_carcab"
  };
  -----------------------------------------------------------------------------------
  local clk_bag_end = function ()

    ObjDelete( "spr_carcab_knifes_bag" );
    ObjSet( "spr_carcab_knifes_bag1", { input = true, alp = 1 } );
    ObjSet( "spr_carcab_arrow", { active = true, input = true } );

  end;

  cmn.AddSubscriber( "clk_bag", clk_bag_end, private.room_objname );
  cmn.AddSubscriber( "clk_bag_end", clk_bag_end, private.room_objname );

--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_handle" ] =
  {
    type = "click",
    clk_obj = "obj_carcab_clk_lockpick",
    room = private.room_objname,
    zz = "zz_carcab",
    zz_gate = "gzz_track_carcab"
  };
  -----------------------------------------------------------------------------------
  local clk_handle_end = function ()

    ObjSet( "obj_carcab_open", { input = true } );
    ObjDelete( "obj_carcab_close" );
    ObjSet( "spr_track_cardoor", { alp = 1 } );
    ObjDelete( "obj_carcab_clk_lockpick" );
    ObjDelete( "obj_carcab_killer_bbt" );

  end;

  cmn.AddSubscriber( "clk_handle", clk_handle_end, private.room_objname );
  cmn.AddSubscriber( "clk_handle_end", clk_handle_end, private.room_objname );

--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_man () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_man" ] =
  {
    type = "click",
    clk_obj = "obj_carcab_clk_man",
    room = private.room_objname,
    zz = "zz_carcab",
    zz_gate = "gzz_track_carcab"
  };
  -----------------------------------------------------------------------------------
  local clk_man_beg = function ()

    ObjDelete( "obj_carcab_clk_man" );

  end;
  local clk_man_end = function ()

    ObjDelete( "obj_carcab_man" );
    ObjDelete( "anm_carcab_people_fx" );
    ObjDelete( "spr_track_driver" );

    ObjSet( "spr_carcab_stolenbag", { input = true } );
    ObjSet( "gfx_carcab_stolenbag", { active = true } );
    ObjSet( "anm_track_people_fx",  { pos_x = - 190, pos_y = 10 } );
    ObjSet( "spr_track_man",        { alp = 1, input = true } );

  end;

  cmn.AddSubscriber( "clk_man", clk_man_beg, private.room_objname );
  cmn.AddSubscriber( "clk_man", clk_man_end, private.room_objname );
  cmn.AddSubscriber( "clk_man_beg", clk_man_beg, private.room_objname );
  cmn.AddSubscriber( "clk_man_end", clk_man_end, private.room_objname );
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_photo_1 () end;
  -----------------------------------------------------------------------------------
  local clk_photo_1_beg = function ()

    ObjSet( "spr_carcab_knifes_photo3",
    {
      event_mdown  = function() cmn.ShowBbt( "bbt_carcab_girl" ) end,
      event_menter = function() cmn.SetCursor( CURSOR_LOUPE ) end,
      event_mleave = function() cmn.SetCursor( CURSOR_DEFAULT ) end,
    } );

  end;
  local clk_photo_1_end = function ()

    ObjSet( "spr_carcab_knifes_photo2", { input = true } );
    ObjSet( "spr_carcab_knifes_photo3", { pos_x = -11, pos_y = -57 } );

  end;
  cmn.AddSubscriber( "clk_photo_1", clk_photo_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_photo_1", clk_photo_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_photo_1_beg", clk_photo_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_photo_1_end", clk_photo_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_photo_2 () end;
  -----------------------------------------------------------------------------------
  local clk_photo_2_beg = function ()

    ObjSet( "spr_carcab_knifes_photo2",
    {
      event_mdown  = function() cmn.ShowBbt( "bbt_carcab_girl" ) end,
      event_menter = function() cmn.SetCursor( CURSOR_LOUPE ) end,
      event_mleave = function() cmn.SetCursor( CURSOR_DEFAULT ) end,
    } );

  end;
  local clk_photo_2_end = function ()

    ObjSet( "spr_carcab_knifes_photo1", { input = true } );
    ObjSet( "spr_carcab_knifes_photo2", { pos_x = 130, pos_y = -109 } );

  end;
  cmn.AddSubscriber( "clk_photo_2", clk_photo_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_photo_2", clk_photo_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_photo_2_beg", clk_photo_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_photo_2_end", clk_photo_2_end, private.room_objname );
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function win_carcab () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_carcab" ] =
  {
    type = "click",
    clk_obj = "spr_carcab_photo",
    room = private.room_objname,
    zz = "zz_carcab",
    zz_gate = "gzz_track_carcab"
  };
  --*********************************************************************************************************************
  local win_carcab_inv = function ()

    if ( cmn.IsEventDone( "win_carcab" ) ) then

      --int.DeleteTaskMap( private.room_objname, "win_carcab" );
    int.TaskDone( 1 );

    end;

  end;
  --*********************************************************************************************************************
  local win_carcab = function ()

    if ( cmn.IsEventDone( "win_carcab" ) ) then

      ObjSet( "obj_carcab_use_rope", { input = true } );
      ObjDelete( "spr_carcab_photo" );
      ObjDelete( "spr_track_driver_cap" );
      ObjDelete( "spr_carcab_1" );
      ObjDelete( "spr_carcab_2" );
      ObjDelete( "spr_carcab_3" );
      ObjDelete( "spr_carcab_4" );

    else 

      ObjSet( "txt_carcab_counter", { text = ng_global.progress[ "std" ][ "win_carcab" ].counter.."/4" } );

      for i = 1, 4 do
        if ng_global.progress[ "std" ][ "win_carcab" ].completion[ i ] then
          ObjSet( "spr_carcab_mark"..i, { alp = 1 } );
          ObjSet( "spr_carcab_"..i, { alp = 0, input = false } );
          if i == 1 then
            ObjSet( "spr_track_driver_cap", { alp = 0 } );
          end;
        end;
      end;

    end;

  end;

  cmn.AddSubscriber( "win_carcab", win_carcab_inv );
  cmn.AddSubscriber( "win_carcab", win_carcab, private.room_objname );
  --*********************************************************************************************************************

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
function private.get_flamingfirebrand ()

  cmn.SetEventDone( "get_flamingfirebrand" );
  cmn.CallEventHandler( "get_flamingfirebrand" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_shard ()

  cmn.SetEventDone( "get_shard" );
  cmn.CallEventHandler( "get_shard" );
  
  cmn.GetObjectSfx();
  if ( cmn.IsEventDone( "get_shard" ) and
       cmn.IsEventDone( "get_lockpick" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_lockpick ()

  cmn.SetEventDone( "get_lockpick" );
  cmn.CallEventHandler( "get_lockpick" );
  
  cmn.GetObjectSfx();
  if ( cmn.IsEventDone( "get_shard" ) and
       cmn.IsEventDone( "get_lockpick" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_stolenbag ()

  cmn.SetEventDone( "get_stolenbag" );
  cmn.CallEventHandler( "get_stolenbag" );

  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_arrow ()

  cmn.SetEventDone( "get_arrow" );
  cmn.CallEventHandler( "get_arrow" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_wheel_2 ()

  cmn.SetEventDone( "get_wheel_2" );
  cmn.CallEventHandler( "get_wheel_2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_wheelwrench ()

  cmn.SetEventDone( "get_wheelwrench" );
  cmn.CallEventHandler( "get_wheelwrench" );
  
  cmn.GetObjectSfx();

  iOS_RateMe();
end;
--*********************************************************************************************************************
-------------------------------------------------
function public.use_extinguisher ()

  local item = "inv_extinguisher";

  if ( cmn.ApplyObj( item, "gzz_track_burningroad", false ) ) and
     ( cmn.IsEventDone( "clk_vid_fire_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_burningroad" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_carcab_use_lockpick", true ) ) then

    cmn.ShowBbt( "bbt_carcab_wrong_use" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_burningroad_use_extinguisher", true ) ) then

--    if ( not cmn.IsEventDone( "get_flamingfirebrand" ) ) then
--
--      cmn.ShowBbt( "bbt_burningroad_get_flamingfirebrand" );
--
--      return true;
--
--    end;

    cmn.CallEventHandler( "use_extinguisher_inv" );
    cmn.CallEventHandler( "use_extinguisher_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_extinguisher" );
      cmn.CallEventHandler( "use_extinguisher_end" );
      int.Lock( false );      

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_simmer_log" );
    cmn.StopAudio( "env", "audio/level1/env/aud_burningroad_env" );  
    VidPlay( "vid_burningroad_extinguisher", func_end );
    ObjAnimate( "spr_burningroad_fire_light", "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_burningroad_fire_light" ).alp, 
      3.0, 0, ObjGet( "spr_burningroad_fire_light" ).alp,
      3.5, 0, 0.0
    } );
    ObjAnimate( "vid_burningroad_fire", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      6.0, 0, 1.0, 
      7.0, 0, 0.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_coaltongs ()

  local item = "inv_coaltongs";

  if ( cmn.ApplyObj( item, "gzz_track_burningroad", false ) ) and
     ( cmn.IsEventDone( "clk_vid_fire_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_burningroad" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_burningroad_use_coaltongs", true ) ) and
         ( cmn.IsEventDone( "clk_vid_fire_1" ) ) then

    cmn.CallEventHandler( "use_coaltongs_inv" );
    cmn.CallEventHandler( "use_coaltongs_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_coaltongs" );
      cmn.CallEventHandler( "use_coaltongs_end" );
      int.Lock( false );

      private.get_flamingfirebrand();

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_take_coal" );  
    AnimPlay( "anm_burningroad_coaltongs", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_chainsaw ()

  local item = "inv_chainsaw";

  if ( cmn.ApplyObj( item, "gzz_track_burningroad", false ) and 
       cmn.IsEventDone( "use_extinguisher" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_burningroad" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_burningroad_use_chainsaw", true ) and
           cmn.IsEventDone( "use_extinguisher" ) ) then

    cmn.CallEventHandler( "use_chainsaw_inv" );
    cmn.CallEventHandler( "use_chainsaw_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_chainsaw" );
      cmn.CallEventHandler( "use_chainsaw_end" );
      int.Lock( false );
      cmn.CloseSubRoom();

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_cut_log" );

    ObjSet( "anm_burningroad_chainsaw", { alp = 1 } );
 
    AnimPlay( "anm_burningroad_chainsaw", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_flamingfirebrand ()

  local item = "inv_flamingfirebrand";

  if ( cmn.ApplyObj( item, "gzz_track_pileofhay", false ) ) and
     ( cmn.IsEventDone( "clk_lockpick" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pileofhay" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_pileofhay_use_flamingfirebrand", true ) ) and
         ( cmn.IsEventDone( "clk_lockpick" ) ) then

    cmn.CallEventHandler( "use_flamingfirebrand_inv" );
    cmn.CallEventHandler( "use_flamingfirebrand_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_flamingfirebrand" );
      cmn.CallEventHandler( "use_flamingfirebrand_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_app_coal" );  

    ObjSet( "spr_pileofhay_grass_shadow", { alp = 0 } );
    ObjSet( "anm_pileofay_web_free", { alp = 0 } );
    ObjSet( "vid_pileofhay_flamingfirebrand", { alp = 1 } );
    ObjSet( "vid_pileofhay_flamingfirebrand_add", { alp = 1 } );

    VidPlay( "vid_pileofhay_flamingfirebrand", func_end);
    VidPlay( "vid_pileofhay_flamingfirebrand_add", "");  

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_killersphoto ()

  local item = "inv_killersphoto";

  if ( cmn.ApplyObj( item, "gzz_track_carcab", false ) and
       cmn.IsEventDone( "clk_handle" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_carcab" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_carcab_use_killersphoto", true ) and
           cmn.IsEventDone( "clk_handle" ) ) then

    cmn.CallEventHandler( "use_killersphoto_inv" );
    cmn.CallEventHandler( "use_killersphoto_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_killersphoto" );
      cmn.CallEventHandler( "use_killersphoto_end" );
      int.Lock( false );
      ng_global.progress[ "std" ][ "win_carcab" ].completion = { false, false, false, false };
      ng_global.progress[ "std" ][ "win_carcab" ].counter = 0;

      cmn.MiniGameShow( "carcab" );
      common_impl.PassingMgStart( "carcab" );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_photo_app" );
    ObjAnimate( "spr_carcab_photo", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_toggle ()

  local item = "inv_toggle";

  if ( cmn.ApplyObj( item, "gzz_track_carcab", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_carcab" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_carcab_use_toggle", true ) ) then

    cmn.CallEventHandler( "use_toggle_inv" );
    cmn.CallEventHandler( "use_toggle_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_toggle" );
      cmn.CallEventHandler( "use_toggle_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_switch_app" );
    ObjAnimate( "anm_carcab_wires", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    ObjAnimate( "spr_carcab_thumbler21", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_carcab_thumbler22", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_lockpick_1 ()

  local item = "inv_lockpick";

  if ( cmn.ApplyObj( item, "gzz_track_carcab", false ) ) and
     ( not cmn.IsEventDone( "use_lockpick_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_carcab" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_carcab_use_lockpick", true ) )and
         ( not cmn.IsEventDone( "use_lockpick_1" ) ) then

    cmn.CallEventHandler( "use_lockpick_1_inv" );
    cmn.CallEventHandler( "use_lockpick_1_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_lockpick_1" );
      cmn.CallEventHandler( "use_lockpick_1_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_truck_use_keys" );
    AnimPlay( "anm_carcab_latchkey", "DoAnim", func_end ) 

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_rope ()

  local item = "inv_rope";

  if ( cmn.ApplyObj( item, "gzz_track_carcab", false ) ) and
     ( cmn.IsEventDone( "win_carcab" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_carcab" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_carcab_use_rope", true ) ) and
     ( cmn.IsEventDone( "win_carcab" ) ) then

    cmn.CallEventHandler( "use_rope_inv" );
    cmn.CallEventHandler( "use_rope_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_rope" );
      cmn.CallEventHandler( "use_rope_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_rope_to_man" );  

    ObjAnimate( "anm_carcab_man_rope", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "spr_carcab_man", "alp", 0, 0, func_end,
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
--*********************************************************************************************************************
-------------------------------------------------
function private.clk_vid_fire_1 ()

  cmn.CallEventHandler( "clk_vid_fire_1_beg" );
  int.Lock( true );
  
  local func_end = function ()

    cmn.SetEventDone( "clk_vid_fire_1" );
    cmn.CallEventHandler( "clk_vid_fire_1_end" );

    int.Lock( false );

    cmn.ShowBbt( "bbt_bygrayscar_after_fire" );

    cmn.StopAudio( "sfx", "audio/level1/sfx/aud_track_fire_mus" );
    cmn.StopAudio( "voc", "audio/level1/voc/aud_track_fire_voc" );

    cmn.PlayAudio( "mus", "audio/level1/mus/aud_scare_mid_mus" );

  end;

  common_impl.PlayDialogVideo( "vid_track_fire", func_end ); 

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_track_fire_mus" );
  cmn.PlayAudio( "voc", "audio/level1/voc/aud_track_fire_voc" );

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_lockpick ()

  cmn.CallEventHandler( "clk_lockpick_beg" );
  int.Lock( true );
  
  local func_end = function ()

    cmn.SetEventDone( "clk_lockpick" );
    cmn.CallEventHandler( "clk_lockpick_end" );

    int.Lock( false );

    cmn.ShowBbt( "bbt_pileofhay_clk_lockpick" );

  end;

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_drop_clip" );
  ObjSet( "anm_pileofay_web_static", { alp = 0 } );
  ObjSet( "anm_pileofay_web_lockpick", { alp = 1 } );
  AnimPlay( "anm_pileofay_web_lockpick", "DoAnim", func_end );

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_toggle ()

  cmn.CallEventHandler( "clk_toggle_beg" );
  int.Lock( true );
  
  local func_end = function ()

    cmn.SetEventDone( "clk_toggle" );
    cmn.CallEventHandler( "clk_toggle_end" );
    int.Lock( false );

  end;

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_switch_click" );

  ObjAnimate( "spr_carcab_thumbler22", "ang", 0, 0, "", 
  { 
    0.0, 0, 0,
    0.3, 0, 0.71
  } );
  ObjAnimate( "spr_carcab_light_lock", "alp", 0, 0, "", 
  { 
    0.0, 0, 1,
    0.3, 0, 0
  } );
  ObjAnimate( "spr_carcab_light_open", "alp", 0, 0, "", 
  { 
    0.0, 0, 0,
    0.3, 0, 1
  } );
  ObjAnimate( "obj_carcab_open_cashe", "alp", 0, 0, "", 
  { 
    0.0, 0, 0,
    0.9, 0, 0,
    1.2, 0, 1
  } );
  ObjAnimate( "obj_carcab_close_cashe", "alp", 0, 0, func_end, 
  { 
    0.0, 0, 1,
    0.9, 0, 1,
    1.2, 0, 0
  } );

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_handle ()

  cmn.CallEventHandler( "clk_handle_beg" );
  int.Lock( true );
  
  local func_end = function ()

    local func_end = function ()

      cmn.SetEventDone( "clk_handle" );
      cmn.CallEventHandler( "clk_handle_end" );

      int.Lock( false );

    end;

    ObjAnimate( "obj_carcab_close", "alp", 0, 0, func_end, 
    { 
      0.0, 3, 1, 
      0.3, 3, 0
    } );

  end;

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_truck_opendoor" );
  ObjAnimate( "spr_carcab_handle", "ang", 0, 0, func_end, 
  { 
    0.0, 3, 0, 
    0.3, 3, 0.03,
  } );

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_man ()

  cmn.CallEventHandler( "clk_man_beg" );
  int.Lock( true );
  
  local func_end = function ()

    cmn.SetEventDone( "clk_man" );
    cmn.CallEventHandler( "clk_man_end" );

    int.Lock( false );
    cmn.CloseSubRoom();

  end;

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_take_man" );
  AnimPlay( "anm_carcab_man_rope", "DoAnim", func_end );

end;
-------------------------------------------------
--*********************************************************************************************************************
function private.opn_track ()

  if not ( cmn.IsEventDone( "opn_track" ) ) then

    cmn.SetEventDone( "opn_track" );
    cmn.ShowBbt("bbt_track_open");

  end;

end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_carcab" );
  -------------------------------------------------
  function zz_carcab.Open()

    if ( cmn.IsEventStart( "win_carcab" ) and not cmn.IsEventDone( "win_carcab" ) ) then

      cmn.MiniGameShow( "carcab" );
      common_impl.PassingMgStart( "carcab" );

    end;

  end;
  -------------------------------------------------
  function zz_carcab.PreOpen()

    if ObjGet( "obj_carcab_knifes_big" ).input then

      if cmn.IsEventDone( "clk_bag" ) then

        ObjSet( "spr_carcab_knifes_bag1", { input = true, alp = 1 } );

      else 

        ObjSet( "spr_carcab_knifes_bag", { input = true, alp = 1 } );

      end;

      ObjSet( "obj_carcab_knifes_big", { input = false, scale_x = 0, scale_y = 0 } );

    end;

    if ObjGet( "spr_carcab_radio_light" ).alp == 1 then

      cmn.PlayAudio( "sfx", "audio/level1/mus/aud_moov_radio_mus", 1 );

    end;

  end;
  -------------------------------------------------
  function zz_carcab.PreClose()

    if ( cmn.IsEventStart( "win_carcab" ) and not cmn.IsEventDone( "win_carcab" ) ) then

      cmn.MiniGameHide( "carcab" );
      common_impl.PassingMgStop( "carcab" );

    end;

  end;
  -------------------------------------------------
  function zz_carcab.Close()

    if ObjGet( "spr_carcab_radio_light" ).alp == 1 then

      cmn.StopAudio( "sfx", "audio/level1/mus/aud_moov_radio_mus", 0.5 );

    end;

  end;
  -------------------------------------------------
  function zz_carcab.Skip ()

    int.Lock( true );

    for i = 1, 4 do
      if not ng_global.progress[ "std" ][ "win_carcab" ].completion[ i ] then

        ObjAnimate( "spr_carcab_"..i, "alp", 0, 0, "", 
        { 
          0.0, 0, 1,
          0.3, 0, 0
        } );

      end;
    end;

    local func_end = function ()

      private.WinCarcab();

    end;

    ObjSet( "tmr_carcab_skip", { playing = 1, time = 0.3, endtrig = func_end, } ); 

  end;
  -------------------------------------------------
  function zz_carcab.Reset ()

    for i = 1, 4 do
      if ng_global.progress[ "std" ][ "win_carcab" ].completion[ i ] then
        ObjSet( "spr_carcab_mark"..i, { alp = 0 } );
        ObjSet( "spr_track_driver_cap", { alp = 1 } );
        ObjSet( "spr_carcab_"..i, { alp = 1, input = true } );
        ng_global.progress[ "std" ][ "win_carcab" ].completion[ i ] = false;
      end;
    end;

    ObjSet( "txt_carcab_counter", { text = "0/4" } );
    ng_global.progress[ "std" ][ "win_carcab" ].counter = 0;

  end;
  -------------------------------------------------

  subroom.Define( "zz_burningroad" );

  -------------------------------------------------
  function zz_burningroad.PreOpen()

    if not cmn.IsEventDone( "use_extinguisher" ) then
        cmn.PlayAudio( "env", "audio/level1/env/aud_burningroad_env", 1 );
    end;

  end;
  -------------------------------------------------
  function zz_burningroad.PreClose()

    if not cmn.IsEventDone( "use_extinguisher" ) then
      cmn.StopAudio( "env", "audio/level1/env/aud_burningroad_env" );      
    end;

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopAllEnv( "audio/level1/env/aud_truck_env", true );
  cmn.PlayAudio( "env", "audio/level1/env/aud_truck_env", 1 );
  ObjSet( "rm_bygrayscar", { color_r = 1, color_g = 1, color_b = 1 } );

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_track();

  if cmn.IsEventDone( "clk_connectwires" ) then
    cmn.PlayAudio( "env", "audio/level1/env/aud_truck_police_car_env", 1 );
  end;

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "opn_townoutskirts",            { "use_chainsaw" }  ); 
  int.AddedTaskMap( private.room_objname, "get_flamingfirebrand",         { "use_coaltongs" } ); 
  int.AddedTaskMap( private.room_objname, "get_shard",                    { "clk_lockpick" } ); 
  int.AddedTaskMap( private.room_objname, "get_lockpick",                 { "use_flamingfirebrand" } ); 
  int.AddedTaskMap( private.room_objname, "get_stolenbag",                { "clk_man" } ); 
  int.AddedTaskMap( private.room_objname, "get_arrow",                    { "clk_bag" } );
  int.AddedTaskMap( private.room_objname, "get_wheel_2",                  { "clk_connectwires" } );
  int.AddedTaskMap( private.room_objname, "get_wheelwrench",              { "clk_connectwires" } );

  int.AddedTaskMap( private.room_objname, "use_extinguisher",             { "get_extinguisher" } ); 
  int.AddedTaskMap( private.room_objname, "use_coaltongs",                { "get_coaltongs", "clk_vid_fire_1" } ); 
  int.AddedTaskMap( private.room_objname, "use_chainsaw",                 { "win_farmhouse", "use_extinguisher" } ); 
  int.AddedTaskMap( private.room_objname, "use_flamingfirebrand",         { "get_flamingfirebrand", "clk_lockpick" } ); 
  int.AddedTaskMap( private.room_objname, "use_killersphoto",             { "win_investigatorsdesk", "clk_handle" } ); 
  int.AddedTaskMap( private.room_objname, "use_toggle",                   { "get_toggle", "clk_handle" } ); 
  int.AddedTaskMap( private.room_objname, "use_lockpick_1",               { "get_lockpick" } ); 
  int.AddedTaskMap( private.room_objname, "use_rope",                     { "get_rope", "clk_man" } ); 

  int.AddedTaskMap( private.room_objname, "clk_vid_fire_1",               { "opn_track" } ); 
  int.AddedTaskMap( private.room_objname, "clk_lockpick",                 { "opn_track" } ); 
  int.AddedTaskMap( private.room_objname, "clk_toggle",                   { "use_toggle" } ); 
  int.AddedTaskMap( private.room_objname, "clk_bag",                      { "clk_toggle" } ); 
  int.AddedTaskMap( private.room_objname, "clk_handle",                   { "use_lockpick_1" } ); 
  int.AddedTaskMap( private.room_objname, "clk_man",                      { "win_carcab" } ); 
  int.AddedTaskMap( private.room_objname, "win_carcab",                   { "use_killersphoto" } ); 

end;
--*********************************************************************************************************************
function private.Anims ()

  ObjAnimate( "spr_track_fire_light", "alp", 1, 0, "", 
  {
    0.0, 0, 0.3,
    0.7, 0, 1.0,
    1.4, 0, 0.2,
    1.9, 0, 0.8,
    2.4, 0, 0.3,
  } );

  ObjAnimate( "spr_burningroad_fire_light", "alp", 1, 0, "", 
  {
    0.0, 0, 0.3,
    0.7, 0, 1.0,
    1.4, 0, 0.2,
    1.9, 0, 0.8,
    2.4, 0, 0.3,
  } );

  ObjAnimate( "spr_burningroad_light", "alp", 1, 0, "", 
  {
    0.0, 0, 0.3,
    4.5, 0, 1.0,
    9.0, 0, 0.3,
  } );

  ObjAnimate( "spr_carcab_tree", "ang", 1, 0, "", 
  {
    0.0, 3, -0.14,
    2.0, 3, 0.18,
    4.0, 3, -0.14,
  } );

  ObjAnimate( "spr_track_police_car_add", "alp", 1, 0, "", 
  {
    0.0, 3, 1,
    0.8, 3, 0.5,
    1.6, 3, 1
  } );

  ObjAnimate( "spr_track_police_car_topadd", "alp", 1, 0, "", 
  {
    0.0, 3, 1,
    0.8, 3, 0.5,
    1.6, 3, 1
  } );

  ObjAnimate( "spr_track_policecar_backlights_add", "alp", 1, 0, "", 
  {
    0.0, 3, 1,
    0.8, 3, 0.5,
    1.6, 3, 1
  } );

  ObjAnimate( "spr_track_clouds", "pos_x", 1, 0, "", 
  {
     0, 0, 512,
    60, 0, 1878,
  } );

  ObjAnimate( "obj_carcab_man", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.6,
    2.0, 0, 1,
    3.0, 0, 0.6,
    4.0, 0, 1,
    5.0, 0, 0.6,
    6.0, 0, 1,
    7.0, 0, 0.6,
    8.0, 0, 1,
    8.2, 0, 0.6,
    8.4, 0, 1,
    8.6, 0, 0.6,
    8.8, 0, 1
  } );

  ObjAnimate( "obj_track_az", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.6,
    2.0, 0, 1,
    3.0, 0, 0.6,
    4.0, 0, 1,
    5.0, 0, 0.6,
    6.0, 0, 1,
    7.0, 0, 0.6,
    8.0, 0, 1,
    8.2, 0, 0.6,
    8.4, 0, 1,
    8.6, 0, 0.6,
    8.8, 0, 1
  } );

  ObjAnimate( "obj_track_driver", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.6,
    2.0, 0, 1,
    3.0, 0, 0.6,
    4.0, 0, 1,
    5.0, 0, 0.6,
    6.0, 0, 1,
    7.0, 0, 0.6,
    8.0, 0, 1,
    8.2, 0, 0.6,
    8.4, 0, 1,
    8.6, 0, 0.6,
    8.8, 0, 1
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG CARCAB *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.InitCarcab ()

    for i = 1, 4 do

      ObjSet( "spr_carcab_"..i,
      {
        event_mdown = function ()
  
          private.ClickMan ( i );
  
        end,

      } );
  
    end;

  end;
  --*********************************************************************************************************************
  function private.ClickMan ( id )

    id = tonumber( id );

    local func_end = function ()

      ng_global.progress[ "std" ][ "win_carcab" ].completion[ id ] = true;
      ng_global.progress[ "std" ][ "win_carcab" ].counter = ng_global.progress[ "std" ][ "win_carcab" ].counter + 1;
      ObjSet( "txt_carcab_counter", { text = ng_global.progress[ "std" ][ "win_carcab" ].counter.."/4" } );

      if id == 1 then
        ObjSet( "spr_track_driver_cap", { alp = 0 } );
      end;
      ObjSet( "spr_carcab_"..id, { input = false } );
      int.Lock( false );
      private.WinManCheck();

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_differences_man_click" );

    ObjAnimate( "spr_carcab_mark"..id, "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      0.3, 0, 1
    } );
    ObjAnimate( "spr_carcab_"..id, "alp", 0, 0, func_end, 
    { 
      0.0, 0, 1,
      0.3, 0, 0
    } );

  end;
  --*********************************************************************************************************************
  function private.WinManCheck ()

    local win = true;

    for i = 1, 4 do

      if not ng_global.progress[ "std" ][ "win_carcab" ].completion[ i ] then

        win = false;
        break;

      end;

    end;

    if win then

      private.WinCarcab ();

    end;

  end;
  --*********************************************************************************************************************
  function private.WinCarcab ()
    
    common_impl.PassingMgWin( "carcab" );
    cmn.MiniGameHide( "carcab" );
    cmn.SetEventDone( "win_carcab" );
    int.Lock( true );

    ObjAnimate( "spr_carcab_photo", "pos_xy", 0, 0, function() private.WinCarcab1() end, 
    { 
      0.0, 3, 136, 114,
      0.3, 3, 136, 114,
      1.0, 3, 240, 373
    } );

  end;
  --*********************************************************************************************************************
  function private.WinCarcab1 ()

    int.Lock( false );

    cmn.CallEventHandler( "win_carcab" );
    cmn.CallEventHandler( "win_carcab_inv" );

    cmn.AddPageDiary( 3 );

    int.ShowTaskNote( 1 );

  end;
  --*********************************************************************************************************************
--*********************************************************************************************************************
function private.ClkRadio ()

  local func_end = function ()

    cmn.StopAudio( "sfx", "audio/level1/mus/aud_moov_radio_mus", 0.5 );
    int.Lock( false );

  end;
  local func_end1 = function ()

    cmn.PlayAudio( "sfx", "audio/level1/mus/aud_moov_radio_mus", 1 );
    int.Lock( false );

  end;

  int.Lock( true );

  if ObjGet( "spr_carcab_radio_light" ).alp ~= 0 then

    ObjAnimate( "spr_carcab_thumbler1", "ang", 0, 0, "", 
    { 
      0.0, 0, 0.71,
      0.3, 0, 0
    } );
    ObjAnimate( "spr_carcab_radio_light", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 1,
      0.3, 0, 0
    } );

  else 

    ObjAnimate( "spr_carcab_thumbler1", "ang", 0, 0, "", 
    { 
      0.0, 0, 0,
      0.3, 0, 0.71
    } );
    ObjAnimate( "spr_carcab_radio_light", "alp", 0, 0, func_end1, 
    { 
      0.0, 0, 0,
      0.3, 0, 1
    } );

  end;

end;
--*********************************************************************************************************************
function private.ClkSmallBag ( is_first )

  local func_end = function ()

    ObjSet( "spr_carcab_knifes_bag", { input = false } );
    ObjSet( "obj_carcab_knifes_big", { input = true } );
    int.Lock( false );
    cmn.ShowBbt( "bbt_carcab_clk_parcel" )

    if ( is_first ) then

      cmn.SetEventDone( "clk_bag" );
      cmn.CallEventHandler( "clk_bag" );

      ObjSet( "spr_carcab_knifes_bag1", { input = false, alp = 0 } );

    end;

  end;

  int.Lock( true );
  local pos_x1 = 106;
  local pos_y1 = 189;
  local name = "bag1";

  if ( is_first ) then

    pos_x1 = 101; pos_y1 = -182; 
    name = "bag";
 
  end;

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_leather_bag_click" );
  ObjAnimate( "spr_carcab_knifes_"..name, "alp", 0, 0, "", 
  { 
    0.0, 0, 1,
    0.3, 0, 0
  } );
  ObjAnimate( "obj_carcab_knifes_big", "scale_xy", 0, 0, "", 
  { 
    0.0, 0, 0, 0,
    0.3, 0, 1, 1
  } );
  ObjAnimate( "obj_carcab_knifes_big", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 0, pos_x1, pos_y1,
    0.3, 0, 0, 0
  } );

end;
--*********************************************************************************************************************
function private.ClkBigBag ()

  local func_end = function ()

    int.Lock( false );
    ObjSet( "obj_carcab_knifes_big", { input = false } );
    ObjSet( "spr_carcab_knifes_bag1", { input = true } );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_bag_close" );
  ObjAnimate( "spr_carcab_knifes_bag1", "alp", 0, 0, "", 
  { 
    0.0, 0, 0,
    0.3, 0, 1
  } );
  ObjAnimate( "obj_carcab_knifes_big", "scale_xy", 0, 0, "", 
  { 
    0.0, 0, 1, 1,
    0.3, 0, 0, 0
  } );
  ObjAnimate( "obj_carcab_knifes_big", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 0, 0, 0,
    0.3, 0, 106, 189
  } );

end;
--*********************************************************************************************************************
function private.clk_photo_1 ()

  local func_end = function ()

    int.Lock( false );

    if not cmn.IsEventDone( "clk_photo_1" ) then

      cmn.SetEventDone( "clk_photo_1" );
      cmn.CallEventHandler( "clk_photo_1" );

    end;

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_photo_click" );
  ObjAnimate( "spr_carcab_knifes_photo3", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 0, 104, 37,
    0.3, 0, -11, -57
  } );

end;
--*********************************************************************************************************************
function private.clk_photo_2 ()

  local func_end = function ()

    int.Lock( false );

    if not cmn.IsEventDone( "clk_photo_2" ) then

      cmn.SetEventDone( "clk_photo_2" );
      cmn.CallEventHandler( "clk_photo_2" );

    end;

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_photo_click" );
  ObjAnimate( "spr_carcab_knifes_photo2", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 0, 106, 38,
    0.3, 0, 130, -109
  } );

end;
--*********************************************************************************************************************
function private.BurningroadClickTree ()

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_burningroad_use_chainsaw" );

  end;

  int.Lock( true );

  --ObjAnimate( "obj_burningroad_tree", "pos_y", 0, 0, func_end, 
  --{ 
  --  0.0, 3,  0,
  --  0.3, 3, -3,
  --  0.6, 3,  0,
  --} );

  func_end();

end;
--*********************************************************************************************************************
function private.ClkRudder ()

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_car_signal" );

end;
--*********************************************************************************************************************
function private.ClkHandle ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_carcab_use_lockpick" );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_truck_door_touch" );
  ObjAnimate( "spr_carcab_handle", "ang", 0, 0, func_end, 
  { 
    0.0, 3, 0,
    0.3, 3, 0.03,
    0.6, 3, 0
  } );

end;
--*********************************************************************************************************************
function private.ClkWires()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_carcab_use_toggle" );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_click_contacts" );
  ObjAnimate( "spr_carcab_light_open", "alp", 0, 0, func_end, 
  { 
    0.0, 3, 0,
    0.2, 3, 0.3,
    0.4, 3, 0,
    0.6, 3, 0.3,
    0.8, 3, 0,
  } );

  AnimPlay( "anm_carcab_wires", "DoAnim", "" );

end;
--*********************************************************************************************************************