-- name=ho_inbasement
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_inbasement" );
  game.relations[ "ho_inbasement" ].exitroom = "rm_basement";
  private.room_objname = "ho_inbasement";

  private.taskpanel = 
  {
    hammer = { "spr_inbasement_cat",   "spr_inbasement_chest",      "spr_inbasement_flask" },
    ballerina    = { "spr_inbasement_hat",   "spr_inbasement_magiclamp",    "spr_inbasement_violin" }

  };

  common_impl.hint[ "win_inbasement" ] =
  {
    type = "get",
    get_obj = "spr_inbasement_win",
    room = private.room_objname
  };

  private.InitAnim();
  --------------------------------------------------------------------------------------------------
  local win_inbasement_func = function ()

    if ( cmn.IsEventDone( "win_inbasement" ) ) then

      int.InventoryItemAdd( "inv_oldchest", "spr_inbasement_win" );
      ObjDelete( "gho_basement_inbasement" );
      ObjDelete( "obj_inbasement_taskpanel" );
      ObjSet( "inv_oldchest", { drag = false } );

    end;

  end;
  cmn.AddSubscriber( "win_inbasement", win_inbasement_func );
  --------------------------------------------------------------------------------------------------
  local start_inbasement_func = function ()

    if ( cmn.IsEventStart( "win_inbasement" ) ) then

      common_impl.ProcessHoStart( "inbasement" );
      local ho_found = ng_global.progress[ "std" ][ "win_inbasement" ].found;

      for i = 1, #ho_found, 1 do

        ObjDelete( ho_found[ i ][ "object" ] );

        for j = 1, #private.task do

          if ( ho_found[ i ][ "object" ] == "spr_inbasement_"..private.task[ j ] ) then

            ObjSet( "txt_inbasement_taskpanel_task"..j,
            {
              text = "tsk_inbasement_"..private.task[ j ],
              color_r = 0,
              color_g = 0.1,
              color_b = 0,
            } );

          end;

        end;

      end;

      if ( ng_global.progress[ ng_global.currentprogress ][ "win_inbasement" ].ballerina == 5 ) then

        ObjSet( "spr_inbasement_taskpanel_crack2", { alp = 1, input = true } );
        ObjSet( "obj_inbasement_taskpanel_box2_hint", { input = true } );
        ObjSet( "spr_inbasement_taskpanel_box2_key", { input = true } );

      elseif ( ng_global.progress[ ng_global.currentprogress ][ "win_inbasement" ].ballerina == 6 ) then

        ObjSet( "spr_inbasement_taskpanel_crack2", { alp = 1 } );
        ObjDelete( "spr_inbasement_taskpanel_box2_key" );
        ObjDelete( "spr_inbasement_taskpanel_box2" );
        ObjSet( "spr_inbasement_taskpanel_list2", { alp = 1, input = true } );
        private.OpenBox( "ballerina" );

      end;

      if ( ng_global.progress[ ng_global.currentprogress ][ "win_inbasement" ].hammer == 5 ) then

        ObjSet( "spr_inbasement_taskpanel_crack1", { alp = 1, input = true } );
        ObjSet( "obj_inbasement_taskpanel_box1_hint", { input = true } );
        ObjSet( "spr_inbasement_taskpanel_box1_key", { input = true } );

      elseif ( ng_global.progress[ ng_global.currentprogress ][ "win_inbasement" ].hammer == 6 ) then

        ObjSet( "spr_inbasement_taskpanel_crack1", { alp = 1 } );
        ObjDelete( "spr_inbasement_taskpanel_box1_key" );
        ObjDelete( "spr_inbasement_taskpanel_box1" );
        ObjSet( "spr_inbasement_taskpanel_list1", { alp = 1, input = true } );
        private.OpenBox( "hammer" );

      end;

    end;

  end;
  cmn.AddSubscriber( "win_inbasement", start_inbasement_func, "ho_inbasement" );
  --------------------------------------------------------------------------------------------------

  private.task = { "cat", "chest", "flask", "hat", "magiclamp", "violin" };

  for i = 1, #private.task do

    ObjSet( "spr_inbasement_"..private.task[ i ], { event_mdown = function () private.CompleteTask( private.task[ i ] ); end } );

  end;

  for i = 1, 5 do

    ObjSet( "spr_inbasement_hammer_"..i, { event_mdown = function () private.CompleteTask( "hammer_"..i ); end } );

  end;

  for i = 1, 5 do

    ObjSet( "spr_inbasement_ballerina_"..i, { event_mdown = function () private.CompleteTask( "ballerina_"..i ); end } );

  end;

  ObjSet( "spr_inbasement_taskpanel_box1_key", { event_startdrag = function () private.GetItem( "box1_key" ); end, event_dragdrop = function () private.UseItem( "box1_key" ); end, } );
  ObjSet( "spr_inbasement_taskpanel_box2_key", { event_startdrag = function () private.GetItem( "box2_key" ); end, event_dragdrop = function () private.UseItem( "box2_key" ); end } );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function public.PreOpen ()

  local ho_tasks = {};
  cmn.InterfaceSetVisible( true );
  int.VisitMapRoom( game.relations[ "ho_inbasement" ].exitroom );

  if ( not cmn.IsEventDone( "opn_inbasement" ) ) then

      cmn.SetEventDone( "opn_inbasement" );
      cmn.CallEventHandler( "opn_inbasement" );
      ng_global.progress[ ng_global.currentprogress ][ "win_inbasement" ].ballerina = 0;
      ng_global.progress[ ng_global.currentprogress ][ "win_inbasement" ].hammer = 0;

  end;

  if ( not cmn.IsEventStart( "win_inbasement" ) ) then

    cmn.InitHo( "inbasement" );

  end;

  for i = 1, #private.task do

    interface.TaskPanelTaskAdd( ho_tasks, private.task[ i ], 1, 0, { { "spr_inbasement_"..private.task[ i ] } } );

  end;

  for i = 1, 5 do

    interface.TaskPanelTaskAdd( ho_tasks, "hammer_"..i, 1, 0, { { "spr_inbasement_hammer_"..i } } );
    interface.TaskPanelTaskAdd( ho_tasks, "ballerina_"..i, 1, 0,    { { "spr_inbasement_ballerina_"..i } } );

  end;

  interface.TaskPanelTaskAdd( ho_tasks, "hammer", 1, 0, { { "spr_inbasement_taskpanel_box1_key", "obj_inbasement_taskpanel_box1_hint" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "ballerina", 1, 0, { { "spr_inbasement_taskpanel_box2_key", "obj_inbasement_taskpanel_box2_hint" } } );

  int.TaskPanelShow( ho_tasks );
  private.Panel();

  cmn.StopAllEnv( "audio/level1/env/aud_closet_env", true );
  cmn.PlayAudio( "env", "audio/level1/env/aud_closet_env", 1 );

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();
  cmn.StopAudio( "env", "audio/level1/env/aud_ho_theme_mus_env", 0.3 );

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();
  ObjSet( "spr_int_taskpanel", { alp = 1, input = true } );
  ObjSet( "obj_int_taskpanel", { alp = 1, input = true } );
  ObjSet( "int_inventory_impl", { input = true } );

end;
--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function private.CompleteTask ( task_name )

  cmn.HoTaskFind( "spr_inbasement_"..task_name, task_name );
  private.CheckTask( task_name );
  common_impl.PassingHoCheck();  

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "spr_int_taskpanel", { alp = 0, input = false } );
  ObjSet( "obj_int_taskpanel", { alp = 0, input = false } );
  ObjSet( "int_inventory_impl", { input = false } );
  ObjAttach( "obj_inbasement_taskpanel" , "int_taskpanel_impl" );
  ObjSet( "txt_inbasement_taskpanel_hammer_count", { text = ng_global.progress[ ng_global.currentprogress ][ "win_inbasement" ].hammer } );
  ObjSet( "txt_inbasement_taskpanel_ballerina_count", { text = ng_global.progress[ ng_global.currentprogress ][ "win_inbasement" ].ballerina } );
   
end;
--*********************************************************************************************************************
function private.CheckTask( obj )

  local ho_progress = ng_global.progress[ ng_global.currentprogress ][ "win_inbasement" ];
      
  if ( string.find( obj, "ballerina" ) ) then

    ng_global.progress[ ng_global.currentprogress ][ "win_inbasement" ].ballerina = ng_global.progress[ ng_global.currentprogress ][ "win_inbasement" ].ballerina + 1;
    local ballerina = ng_global.progress[ ng_global.currentprogress ][ "win_inbasement" ].ballerina;
    ObjSet( "txt_inbasement_taskpanel_ballerina_count", { text = ballerina } );

    if ( ballerina == 5 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );
        ObjSet( "spr_inbasement_taskpanel_crack2", { input = true } );
        ObjSet( "spr_inbasement_taskpanel_box2_key", { input = true } );
        ObjSet( "spr_inbasement_taskpanel_box2", { input = true } );
        ObjSet( "obj_inbasement_taskpanel_box2_hint", { input = true } );

      end;

      ObjAnimate( "spr_inbasement_taskpanel_ballerina", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 1.0, 
        0.6, 0, 0.0
      } );

      ObjAnimate( "spr_inbasement_taskpanel_crack2", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 0.0, 
        0.6, 0, 1.0
      } );

    end;

  elseif ( string.find( obj, "hammer" ) ) then

    ng_global.progress[ ng_global.currentprogress ][ "win_inbasement" ].hammer = ng_global.progress[ ng_global.currentprogress ][ "win_inbasement" ].hammer + 1;
    local hammer = ng_global.progress[ ng_global.currentprogress ][ "win_inbasement" ].hammer;
    ObjSet( "txt_inbasement_taskpanel_hammer_count", { text = hammer } );

    if ( hammer == 5 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );
        ObjSet( "spr_inbasement_taskpanel_crack1", { input = true } );
        ObjSet( "spr_inbasement_taskpanel_box1_key", { input = true } );
        ObjSet( "spr_inbasement_taskpanel_box1", { input = true } );
        ObjSet( "obj_inbasement_taskpanel_box1_hint", { input = true } );

      end;

      ObjAnimate( "spr_inbasement_taskpanel_hammer", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 1.0, 
        0.6, 0, 0.0
      } );

      ObjAnimate( "spr_inbasement_taskpanel_crack1", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 0.0, 
        0.6, 0, 1.0
      } );

    end;

  end;

  for i = 1, #private.task do

    if ( obj == private.task[i] ) then

      ObjSet( "txt_inbasement_taskpanel_task"..i,
      {
        text = "tsk_inbasement_"..private.task[ i ],
        color_r = 0,
        color_g = 0.1,
        color_b = 0,
      } );

    end;

  end;

end;
--*********************************************************************************************************************
function private.GetItem( name )

  local item = "spr_inbasement_taskpanel_"..name;
  ObjSet( item, { pos_z = 20 } );
  ObjAttach( item, "obj_inbasement_taskpanel" );
  cmn.PlayAudio( "sfx", "audio/aud_take_inventory" );

end;
--*********************************************************************************************************************
function private.UseItem( name )

  local item = "spr_inbasement_taskpanel_"..name;
  
  if ( ObjIntersect( item, "spr_inbasement_taskpanel_box1" ) and string.find( item, "box1" ) ) then
    
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_ho_inbasement_to_box" );

    ObjDelete( item );
    int.Lock( true );

    local trg_after = function()

      private.CompleteTask ( "hammer" );
      ObjDelete( "spr_inbasement_taskpanel_box1" );
      ObjSet( "spr_inbasement_taskpanel_list1", { input = true } );

    end;

    int.Lock( false );
    private.OpenBox( "hammer" );
    ObjAnimate( "spr_inbasement_taskpanel_box1", "alp", 0, 0, trg_after, 
    { 
      0.0,  0,  1,
      0.3,  0,  0
    } ); 

    ObjAnimate( "spr_inbasement_taskpanel_list1", "alp", 0, 0, "", 
    { 
      0.0,  0,  0,
      0.3,  0,  1
    } ); 
  elseif ( ObjIntersect( item, "spr_inbasement_taskpanel_box2" ) and string.find( item, "box2" ) ) then
    
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_ho_inbasement_to_box" );

    ObjDelete( item );
    int.Lock( true );
    local trg_after = function()

      private.CompleteTask ( "ballerina" );
      ObjDelete( "spr_inbasement_taskpanel_box2" );
      ObjSet( "spr_inbasement_taskpanel_list2", { input = true } );
      int.Lock( false );

    end;

    private.OpenBox( "ballerina" );
    ObjAnimate( "spr_inbasement_taskpanel_box2", "alp", 0, 0, trg_after, 
    { 
      0.0,  0,  1,
      0.3,  0,  0
    } ); 

    ObjAnimate( "spr_inbasement_taskpanel_list2", "alp", 0, 0, "", 
    { 
      0.0,  0,  0,
      0.3,  0,  1
    } ); 

  else

    if ( name == "box1_key" ) then

      ObjAttach( item, "spr_inbasement_taskpanel_crack1" );

    else 

      ObjAttach( item, "spr_inbasement_taskpanel_crack2" );

    end;

    ObjSet( "spr_inbasement_taskpanel_"..name, { pos_z = 1 } );
    cmn.WrongApply();

  end;

end;
--*********************************************************************************************************************
function private.OpenBox( name )

 for i = 1, #private.taskpanel[ name ] do

  ObjSet( private.taskpanel[ name ][ i ], { input = true } ); 

 end;

 for i = 1, #private.task do

  ObjSet( "txt_inbasement_taskpanel_task"..i,
  {
    text = "tsk_inbasement_"..private.task[ i ],
  } );

 end;

end;
--*********************************************************************************************************************
function private.InitAnim()

  ObjAnimate( "spr_inbasement_lamp", "ang", 1, 0, "",
  { 
    0.0, 3, 0.03, 
    6.0, 3, -0.03, 
    12.0, 3, 0.03
  } );

  ObjAnimate( "spr_inbasement_lamp", "pos_x", 1, 0, "",
  { 
    0.0, 3, 700, 
    6.0, 3, 650, 
    12.0, 3, 700
  } );

  ObjAnimate( "spr_inbasement_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    0.3, 3, 1.0,
    0.6, 3, 0.3,
  } );

  ObjAnimate( "spr_inbasement_plane_1", "ang", 1, 0, "", 
  {
    0, 3, 0.08,
    3, 3, -0.08,
    6, 3, 0.08,
  } );

  ObjAnimate( "spr_inbasement_plane_2", "ang", 1, 0, "", 
  {
    0.0, 3, -0.16,
    3.3, 3, 0.16,
    6.6, 3, -0.16,
  } );

end;
--*********************************************************************************************************************