-- name=mg_darkness
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_darkness";
  game.relations[ "mg_darkness" ].exitroom = "rm_yard";

  private.hidden_count = {136,139}
  private.stage = 1;
  private.opened_count = {0,0};

  for i = 1, private.hidden_count[ 1 ] do
    ObjSet( "spr_darkness_symbol_1_hide_"..i, {
      input = true,
      event_menter = function () private.EnterPart( i ); end,
      event_mleave = function () private.LeavePart( i ); end
    });
  end;

  for i = 1, private.hidden_count[ 2 ] do
    ObjSet( "spr_darkness_symbol_2_hide_"..i, {
      input = true,
      event_menter = function () private.EnterPart( i ); end,
      event_mleave = function () private.LeavePart( i ); end
    });
  end;   

  --------------------------------------------------------------------------------------------
  -- function win_darkness () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_darkness" ] =
  {
    type = "click",
    get_obj = "spr_darkness_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_darkness = function ()


    if ( cmn.IsEventDone( "win_darkness" ) ) then

      --int.DeleteTaskMap( "rm_abandonedfarm", "win_darkness" );
      ObjDelete( "gmg_yard_darkness" );
      ObjDelete( "obj_darkness_symdol_1" );
      ObjDelete( "obj_darkness_symdol_2" );
      ObjSet( "obj_yard_gates", { active = true, input = true, visible = true } );
      ObjSet( "obj_darkness_gates", { active = true, input = true, visible = true } );
      ObjSet( "rm_yard", { color_r = 1, color_g = 1, color_b = 1 } );
      int.LockRoomMap( "livingroom", 0 );
      int.LockRoomMap( "yard", 0 );
      int.LockRoomMap( "kitchen", 0 );
      int.LockRoomMap( "office", 0 );

    elseif ( cmn.IsEventStart( "win_darkness" ) ) then

      private.Load();

    end;

  end;
  -----------------------------------------------
  local win_darkness_yard = function ()

    if ( cmn.IsEventDone( "win_darkness" ) ) then
      ObjSet( "obj_yard_gates", { active = true, input = true, visible = true } );
      ObjSet( "rm_yard", { color_r = 1, color_g = 1, color_b = 1 } );
      int.LockRoomMap( "livingroom", 0 );
      int.LockRoomMap( "yard", 0 );
      int.LockRoomMap( "kitchen", 0 );
      int.LockRoomMap( "office", 0 );
    end;

  end;

  cmn.AddSubscriber( "win_darkness", win_darkness, private.room_objname );
  cmn.AddSubscriber( "win_darkness", win_darkness_yard, "rm_yard" );
  -----------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_newspaper () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_newspaper" ] =
    {
    type = "use",
      use_obj = "inv_newspaper",
      use_place = "obj_darkness_use_newspaper",
      room = private.room_objname,
  };
  -----------------------------------------------
  local use_newspaper_inv = function ()

    int.InventoryItemRemove( "inv_newspaper" );

  end;
  local use_newspaper_beg = function ()

    ObjDelete( "obj_darkness_use_newspaper" );

  end;
  local use_newspaper_end = function ()

    ObjSet( "obj_darkness_use_lighter2", { input = true } );
    ObjSet( "vid_darkness_use_lighter", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_newspaper", use_newspaper_beg, private.room_objname );
  cmn.AddSubscriber( "use_newspaper", use_newspaper_inv );
  cmn.AddSubscriber( "use_newspaper", use_newspaper_end, private.room_objname );
  cmn.AddSubscriber( "use_newspaper_inv", use_newspaper_inv, private.room_objname );
  cmn.AddSubscriber( "use_newspaper_beg", use_newspaper_beg, private.room_objname );
  cmn.AddSubscriber( "use_newspaper_end", use_newspaper_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lighter2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lighter2" ] =
    {
    type = "use",
      use_obj = "inv_lighter2",
      use_place = "obj_darkness_use_lighter2",
      room = private.room_objname,
  };
  -----------------------------------------------
  local use_lighter2_inv = function ()

    int.InventoryItemRemove( "inv_lighter2" );

  end;
  local use_lighter2_beg = function ()

    ObjDelete( "obj_darkness_use_lighter2" );

  end;
  local use_lighter2_end = function ()

    ObjSet( "obj_darkness_symdol_1", { input = true } );
    ObjDelete( "vid_darkness_use_lighter" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_lighter2", use_lighter2_beg, private.room_objname );
  cmn.AddSubscriber( "use_lighter2", use_lighter2_inv );
  cmn.AddSubscriber( "use_lighter2", use_lighter2_end, private.room_objname );
  cmn.AddSubscriber( "use_lighter2_inv", use_lighter2_inv, private.room_objname );
  cmn.AddSubscriber( "use_lighter2_beg", use_lighter2_beg, private.room_objname );
  cmn.AddSubscriber( "use_lighter2_end", use_lighter2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_darkness_atropos () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_darkness_atropos" ] =
  {
    type = "click",
    room = private.room_objname,
  };
  -----------------------------------------------
  local see_darkness_atropos = function ()

    ObjSet( "mg_darkness", { color_r = 0, color_g = 0, color_b = 0 } );

  end;
  cmn.AddSubscriber( "see_darkness_atropos", see_darkness_atropos, private.room_objname );

end;
-------------------------------------------------
function public.use_newspaper ()

  local item = "inv_newspaper";

  if ( cmn.ApplyObj( item, "obj_darkness_use_newspaper", true ) ) then

    cmn.CallEventHandler( "use_newspaper_inv" );
    cmn.CallEventHandler( "use_newspaper_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_newspaper" );
      cmn.CallEventHandler( "use_newspaper_end" );
      int.Lock( false );

    end;

--  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_newspaper" );  
    ObjAnimate( "vid_darkness_use_lighter", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_lighter2 ()

  local item = "inv_lighter2";

  if ( cmn.ApplyObj( item, "obj_darkness_use_lighter2", true ) ) and ( cmn.IsEventDone( "use_newspaper" ) ) then

    cmn.CallEventHandler( "use_lighter2_inv" );
    cmn.CallEventHandler( "use_lighter2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_lighter2" );
      cmn.CallEventHandler( "use_lighter2_end" );
      int.Lock( false );
      --cmn.GotoRoom( "mg_darkness" );
      private.Start();

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_app_lighting" ); 
   
    VidPlay( "vid_darkness_use_lighter", func_end ); 

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
function private.see_darkness_atropos ()

  local func_end = function ()

    --cmn.StopAudio( "sfx", "audio/level1/sfx/aud_watch" );
    --cmn.StopAudio( "voc", "audio/level1/voc/aud_watch_voc" );
    cmn.StopAudio( "sfx", "audio/level2/sfx/aud_yard_atropos_disappear" );
    cmn.PlayAudio( "mus", "audio/aud_scare_theme_mus" );
    int.Lock( false );

    cmn.SetEventDone( "win_darkness" );
    cmn.CallEventHandler( "win_darkness" );
    cmn.SetEventDone( "see_darkness_atropos" );
    cmn.CallEventHandler( "see_darkness_atropos" );

    cmn.GotoRoom( "rm_yard" );

    cmn.ShowBbt( "bbt_darkness_after_win" );

  end;

  int.Lock( true );  

  common_impl.PlayDialogVideo( "vid_darkness_atropos_disappear", func_end ); 

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_yard_atropos_disappear" );
  --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_watch" );
  --cmn.PlayAudio( "voc", "audio/level1/voc/aud_watch_voc" );

end;
-------------------------------------------------

--*********************************************************************************************************************
function private.Load ()

  private.stage = ng_global.progress[ "std" ][ "win_darkness" ].stage;
  private.opened_count[ 1 ] = ng_global.progress[ "std" ][ "win_darkness" ].opened_count[ 1 ];
  private.opened_count[ 2 ] = ng_global.progress[ "std" ][ "win_darkness" ].opened_count[ 2 ];

  if ( private.stage == 1 ) then
    ObjSet( "obj_darkness_symdol_1", { alp = 1, input = true } );
    ObjSet( "obj_darkness_symdol_2", { alp = 0, input = false } );
    ObjSet( "anm_darkness_atropos_left_hand_big", { alp = 1, playing = true } );
    ObjSet( "anm_darkness_atropos_left_hand", { alp = 0, playing = false } );
  elseif ( private.stage == 2 ) then
    ObjSet( "obj_darkness_symdol_2", { alp = 1, input = true } );
    ObjSet( "obj_darkness_symdol_1", { alp = 0, input = false } );
    ObjSet( "anm_darkness_atropos_right_hand_big", { alp = 1, playing = true } );
    ObjSet( "anm_darkness_atropos_right_hand", { alp = 0, playing = false } );
    ObjSet( "anm_darkness_atropos_left_hand_big", { alp = 1, playing = true } );
    ObjSet( "anm_darkness_atropos_left_hand", { alp = 0, playing = false } );    
  end

  for i = 1, private.opened_count[ private.stage ] do
    ObjSet( "spr_darkness_symbol_"..private.stage.."_hide_"..i, { alp = 0 } );
  end;

end;
--*********************************************************************************************************************
function public.PreOpen () 

  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

end;
--*********************************************************************************************************************
function public.Open () 

  if not cmn.IsEventDone( "see_yard_atropos" ) and not ( cmn.IsEventStart( "win_darkness" ) ) then
    cmn.ShowBbt( "bbt_darkness_first_open" );
    int.Lock( true ); 
    cmn.PlayAudio( "voc", "audio/level2/voc/aud_yard_atropos_appearance2_voc" );
    ObjSet( "tmr_darkness_voice", {
      time = 5,
      playing = true,
      endtrig = private.AfterVid
    } );
  end;

  if ( cmn.IsEventStart( "win_darkness" ) and not cmn.IsEventDone( "win_darkness" ) ) then
    
    cmn.MiniGameShow( "darkness" );
    common_impl.PassingMgStart( "darkness" );
    
  end;
  
  private.Anims();

  cmn.StopAllEnv( "audio/level2/env/aud_mg_darkness_env", true );
  cmn.PlayAudio( "env", "audio/level2/env/aud_mg_darkness_env", 1 );
  
end;
--*********************************************************************************************************************
function public.PreClose ()

  if ( cmn.IsEventStart( "win_darkness" ) and not cmn.IsEventDone( "win_darkness" ) ) then
    cmn.MiniGameHide();
    common_impl.PassingMgStop( "darkness" );
  end;

  cmn.StopAllEnv( );
  --cmn.MiniGameHide();
  --ObjSet( "obj_yard_gates", { active = true, input = true, visible = true } );
  --private.WinEnd ();

end;
--*********************************************************************************************************************
function public.Reset ()

  ObjStopAnimate( "spr_darkness_symbol_"..private.stage.."_over", "alp" );
  
  private.stage = 1;
  private.opened_count = {0,0};
  ng_global.progress[ "std" ][ "win_darkness" ].stage = 1;
  ng_global.progress[ "std" ][ "win_darkness" ].opened_count = {0,0};

  for i = 2, private.hidden_count[ 1 ] do
    ObjSet( "spr_darkness_symbol_1_hide_"..i, { alp = 1 } );
  end;

  for i = 2, private.hidden_count[ 2 ] do
    ObjSet( "spr_darkness_symbol_2_hide_"..i, { alp = 1 } );
  end; 

  ObjSet( "obj_darkness_symdol_1", { alp = 1, input = true } );
  ObjSet( "obj_darkness_symdol_2", { alp = 0, input = false } );

  ObjSet( "anm_darkness_atropos_right_hand_big", { alp = 0, playing = false } );
  ObjSet( "anm_darkness_atropos_right_hand", { alp = 1, playing = true } );

  private.Anims();  

end;
--*********************************************************************************************************************
function public.Skip ()
port.skip_mg = true;
  ObjAnimate("obj_darkness_symdol_"..private.stage, "alp", 0, 0, 
  function()
    private.WinEnd();
  end, 
  {
    0.0,0,1,
    0.3,0,0
  });


end;
--*********************************************************************************************************************
function private.Start ()

  ng_global.progress[ "std" ][ "win_darkness" ].stage = 1;
  ng_global.progress[ "std" ][ "win_darkness" ].opened_count = {0,0};  

  cmn.MiniGameShow( "darkness" );  
  common_impl.PassingMgStart( "darkness" );

end;
--*********************************************************************************************************************
function private.AfterVid ()

  local func_end = function ()

    int.Lock( false );

    ObjSet( "anm_darkness_atropos_left_hand_throw", { alp = 0, playing = false } );

    cmn.SetEventDone( "see_yard_atropos" );
    cmn.CallEventHandler( "see_yard_atropos_end" );
    cmn.CallEventHandler( "see_yard_atropos_mg" );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_darkness_miniwin" );
  ObjSet( "anm_darkness_atropos_left_hand_throw", { alp = 1 } );
  ObjSet( "anm_darkness_atropos_left_hand", { alp = 0, playing = false } );
  AnimPlay( "anm_darkness_atropos_left_hand_throw", "DoAnim", func_end );
  ObjAnimate("obj_darkness_symdol_1", "alp", 0, 0, "", 
  {
    0.0,0,0,
    0.9,0,0,
    1.2,0,1
  });

end;
--*********************************************************************************************************************
function private.WinEnd ()

  cmn.MiniGameHide();

  --cmn.SetEventDone( "win_darkness" );
  --cmn.CallEventHandler( "win_darkness" );
  private.see_darkness_atropos();

end;
--*********************************************************************************************************************
function private.Win ()

  int.Lock( true );
  common_impl.PassingMgWin("darkness");
  ObjAnimate("obj_darkness_symdol_2", "alp", 0, 0, 
  function ()
    int.Lock( false );
    private.WinEnd();
  end, 
  {
    0.0,0,1,
    0.3,0,0
  });

end;
--*********************************************************************************************************************
function private.ResetPath ()

  for i=2, private.hidden_count[ private.stage ] do
    ObjSet( "spr_darkness_symbol_"..private.stage.."_hide_"..i, { alp = 1 } );
    --ObjAnimate( "spr_darkness_symbol_1_hide_"..i, "alp", 0, 0, "", 
    --{
    --  0.0,0,0,
    --  0.2,0,1
    --} );
  end;

  private.opened_count[ private.stage ] = 0;

end;
--*********************************************************************************************************************
function private.EnterPart ( num )

  private.CustomCursorShow();
  if ( num > 1 ) then    
    if ( ObjGet( "spr_darkness_symbol_"..private.stage.."_hide_"..(num - 1) ).alp < 1 )and
       ( ObjGet( "spr_darkness_symbol_"..private.stage.."_hide_"..num ).alp == 1 ) then
      ObjStopAnimate( "spr_darkness_symbol_"..private.stage.."_start", "alp" );
      ObjSet(  "spr_darkness_symbol_"..private.stage.."_start", { alp = 0 } );
      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_darkness_one_pattern" );
      ObjAnimate( "spr_darkness_symbol_"..private.stage.."_hide_"..num, "alp", 0, 0, 
      function()
        private.opened_count[ private.stage ] = num;       
        if ( num == private.hidden_count[ private.stage ] ) then
          private.CheckWin();
        else
          ng_global.progress[ "std" ][ "win_darkness" ].opened_count[ private.stage ] = num;
        end;
      end, 
      {
        0.0,0,1,
        0.2,0,0
      } );
    end;
  else
    ObjSet( "spr_darkness_symbol_"..private.stage.."_hide_1", { alp = 0 } );
  end;

end;
--*********************************************************************************************************************
function private.LeavePart ( num )

    private.CustomCursorHide();
  
end;
--*********************************************************************************************************************
function private.CustomCursorShow ()

  local pos = GetZoomCursorPos();
  pos[2] = pos[2] - 80;
  local pcx = pos[1];
  local pcy = pos[2];

  --cmn.SetCursor( CURSOR_NULL );
  ObjSet( "anm_darkness_cursor", { pos_x = pcx + 22, pos_y = pcy + 20, alp = 1 } );

  ObjSet( "tmr_darkness_cursor", { playing = 1, time = 0.01, endtrig = function () private.CustomCursorShow(); end } );

end;
--*********************************************************************************************************************
function private.CustomCursorHide ()

  --cmn.SetCursor(CURSOR_DEFAULT);
  ObjSet( "tmr_darkness_cursor", { playing = false } ); 
  ObjSet( "anm_darkness_cursor", { alp = 0 } );
  

end;
--*********************************************************************************************************************
function private.CheckWin ()

  if ( private.stage == 1 ) then

    private.ChangeSymbol();

  elseif ( private.stage == 2 ) then

    private.Win();   

  end;

end;
--*********************************************************************************************************************
function private.ChangeSymbol ()

  local func_end = function ()

    int.Lock( false );

    ObjSet( "anm_darkness_atropos_right_hand_throw", { alp = 0, playing = false } );
    ObjSet( "anm_darkness_atropos_right_hand_big", { alp = 1, playing = true } );
    ObjSet( "obj_darkness_symdol_2", { alp = 1, input = true } );
    ObjSet( "obj_darkness_symdol_1", { input = false } );

    private.stage = 2;
    ng_global.progress[ "std" ][ "win_darkness" ].stage = private.stage;

    private.Anims();

  end;
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_darkness_miniwin" );
  ObjStopAnimate( "spr_darkness_symbol_1_over", "alp" );
  ObjAnimate("obj_darkness_symdol_1", "alp", 0, 0, 
  function ()
    ObjSet( "anm_darkness_atropos_right_hand_throw", { alp = 1 } );
    ObjSet( "anm_darkness_atropos_right_hand", { alp = 0, playing = false } );
    AnimPlay( "anm_darkness_atropos_right_hand_throw", "DoAnim", func_end );
    ObjAnimate("obj_darkness_symdol_2", "alp", 0, 0, "", 
    {
      0.0,0,0,
      0.9,0,0,
      1.2,0,1
    });
  end, 
  {
    0.0,0,1,
    0.3,0,0
  });

end;
--*********************************************************************************************************************
function private.Anims ()

  local obj= "";
  local obj_start = "";
  if private.stage == 1 then
    obj = "spr_darkness_symbol_1_over";
    obj_start = "spr_darkness_symbol_1_start";
  elseif private.stage == 2 then
    obj = "spr_darkness_symbol_2_over";
    obj_start = "spr_darkness_symbol_2_start";
  end;

  ObjAnimate( obj, "alp", 1, 0, "", 
  {
    0.0,0,0,
    3.0,0,0,
    3.6,0,0.3,
    4.2,0,0,
    10.0,0,0
  });
  if ( private.opened_count[ private.stage ] < 2 ) then
    ObjAnimate(obj_start, "alp", 1, 0, "", 
    {
      0.0,0,0,
      0.7,0,0,
      1.0,0,1,
      1.2,0,1,
      1.5,0,0,
      1.8,0,0
    });
  end;
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************