-- name=mg_onsafedoor
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_onsafedoor";
  game.relations[ "mg_onsafedoor" ].exitroom = "rm_office";
  --ObjSet( "spr_onsafedoor_switchroomplan", { event_mdown = private.get_switchroomplan } );
  ObjMultiSet( {
    { "spr_onsafedoor_file2",                                { event_mdown = private.get_file2 } };
    { "spr_onsafedoor_bell_3",                               { event_mdown = private.get_bell_3 } };
  } );

  private.limit_x = {
    { { -3,163}, {-116,150}, { -56, 68} },
    { {-52,114}, { -62, 90}, {-113,123} },
    { {-40,126}, { -90,119}, { -56, 65} }
  };
  private.init_x = {
    { 163, -116, 21   },
    { -51,  -61, -112 },
    { 125,  107, 65   }
  };
  private.pointer_pos = {
    {-84,280}, {-102,184}, {-35,132}, {-108,70}, {-26,31}, 
    {-119,-25}, {-33,-70}, {-110,-137}, {-36,-201}, {-89,-289}
  };

  private.drag_offset = 0;
  private.init_y = 0;

  private.current_num = 1;

  for pin=1, 3 do
    for part=1, 3 do
      ObjSet( "spr_onsafedoor_pin_"..pin.."_part_"..part, {
        input = true,
        event_menter = function () cmn.SetCursor(CURSOR_HAND); end,
        --event_mleave = function () cmn.SetCursor(CURSOR_DEFAULT); private.PartDrop( pin, part ); end,
        event_mdown = function () private.PartClick( pin, part );  end,
        event_mup = function () private.PartDrop( pin, part ); cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_onsafedoor_release" );  end,
      });
    end;
  end;
    
  ObjSet( "obj_onsafedoor_back_up",{event_mup = function () private.PartDropUp(); cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_onsafedoor_release" );  end});

  for i=1, 10 do
    ObjSet( "obj_onsafedoor_pin_num_"..i, {
      event_mdown = function () private.NumClick( i );  end
    } );
  end;

  ObjSet( "spr_onsafedoor_grille", {
    event_menter = function () cmn.SetCursor(CURSOR_HAND); end,
    event_leave = function () cmn.SetCursor(CURSOR_DEFAULT); end,
    event_mdown = private.clk_safedoor,
  } );

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_onsafedoor = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;

      local mas_parent_gfx = 
      {
        private.room_objname
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_onsafedoor", update_game_mode_onsafedoor, private.room_objname );

    --------------------------------------------------------------------------------------------
    -- function get_switchroomplan () end;
    --------------------------------------------------------------------------------------------
--    common_impl.hint[ "get_switchroomplan" ] =
--      {
--        type = "get",
--        get_obj = "spr_onsafedoor_switchroomplan",
--        room = private.room_objname,
--    };
--    -----------------------------------------------
--    local get_switchroomplan_inv = function ()
--  
--      int.InventoryItemAdd( "inv_switchroomplan", "spr_onsafedoor_switchroomplan" );
--      ObjSet( "inv_switchroomplan", { drag = false } );
--      ObjDelete( "gmg_office_onsafedoor" );
--
--    end;
--  
--    local get_switchroomplan_closezz = function ()
--  
--      ObjDelete( "gfx_onsafedoor_switchroomplan" );
--      ObjDelete( "spr_onsafedoor_switchroomplan_shadow" );
--  
--    end;
--  
--    cmn.AddSubscriber( "get_switchroomplan", get_switchroomplan_inv );
--    cmn.AddSubscriber( "get_switchroomplan", get_switchroomplan_closezz, private.room_objname );
    --------------------------------------------------------------------------------------------
    -- function get_file2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_file2" ] =
    {
      type = "get",
      get_obj = "spr_onsafedoor_file2",
      room = private.room_objname,
    };
    -----------------------------------------------
    local get_file2_inv = function ()

      int.InventoryItemAdd( "inv_file2", "spr_onsafedoor_file2" );

    end;

    local get_file2_closezz = function ()

      ObjDelete( "gfx_onsafedoor_file2" );
      ObjDelete( "spr_onsafedoor_file2_shadow" );

      if cmn.IsEventDone( "get_file2" ) and cmn.IsEventDone( "get_bell_3" ) then
        
        ObjDelete( "gmg_office_onsafedoor" );
        
      end;

    end;

    local get_file2_loc = function ()

      if cmn.IsEventDone( "get_file2" ) and cmn.IsEventDone( "get_bell_3" ) then
        
        ObjDelete( "gmg_office_onsafedoor" );
        
      end;

    end;

    cmn.AddSubscriber( "get_file2", get_file2_inv );
    cmn.AddSubscriber( "get_file2", get_file2_closezz, private.room_objname );
    cmn.AddSubscriber( "get_file2", get_file2_loc, "rm_office" );
    --------------------------------------------------------------------------------------------
    -- function get_bell_3 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_bell_3" ] =
    {
      type = "get",
      get_obj = "spr_onsafedoor_bell_3",
      room = private.room_objname,
    };
    -----------------------------------------------
    local get_bell_3_inv = function ()

      int.InventoryItemAdd( "inv_bell_3", "spr_onsafedoor_bell_3" );

    end;

    local get_bell_3_closezz = function ()

      ObjDelete( "gfx_onsafedoor_bell_3" );
      ObjDelete( "spr_onsafedoor_bell_3_shadow" );

      if cmn.IsEventDone( "get_file2" ) and cmn.IsEventDone( "get_bell_3" ) then
        
        ObjDelete( "gmg_office_onsafedoor" );
        
      end;

    end;

    local get_bell_3_loc = function ()

      if cmn.IsEventDone( "get_file2" ) and cmn.IsEventDone( "get_bell_3" ) then

        ObjDelete( "gmg_office_onsafedoor" );

      end;

    end;
    
    cmn.AddSubscriber( "get_bell_3", get_bell_3_inv );
    cmn.AddSubscriber( "get_bell_3", get_bell_3_closezz, private.room_objname );
    cmn.AddSubscriber( "get_bell_3", get_bell_3_loc, "rm_office" );
    --------------------------------------------------------------------------------------------
    -- function clk_safedoor () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_safedoor" ] =
    {
      type = "click",
      clk_obj = "spr_onsafedoor_grille",
      room = private.room_objname,
    };
    -----------------------------------------------
    local clk_safedoor_beg = function ()

    end;
    -----------------------------------------------
    local clk_safedoor = function ()

    end;
    -----------------------------------------------
    local clk_safedoor_end = function ()

      ObjSet( "spr_onsafedoor_grille", { input = false, pos_x = -241 } );
      ObjSet( "obj_onsafedoor_pick_objs", { input = true } );
      ObjSet( "gfx_onsafedoor_bell_3", { active = true } );
      ObjSet( "gfx_onsafedoor_file2", { active = true } );

    end;
    -----------------------------------------------
    cmn.AddSubscriber( "clk_safedoor", clk_safedoor_beg, private.room_objname );
    cmn.AddSubscriber( "clk_safedoor", clk_safedoor_end, private.room_objname );
    cmn.AddSubscriber( "clk_safedoor_beg", clk_safedoor_beg, private.room_objname );
    cmn.AddSubscriber( "clk_safedoor_end", clk_safedoor_end, private.room_objname );
    cmn.AddSubscriber( "clk_safedoor", clk_safedoor, private.room_objname );
    --------------------------------------------------------------------------------------------
    -- function win_onsafedoor () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "win_onsafedoor" ] =
    {
      type = "click",
      get_obj = "spr_onsafedoor_back",
      room = private.room_objname,
    };
    -----------------------------------------------
    local win_onsafedoor = function ()

      if ( cmn.IsEventDone( "win_onsafedoor" ) ) then

      ObjSet( "spr_onsafedoor_grille", { input = true } );
      ObjSet( "obj_onsafedoor_mg", { input = false } );
      ObjSet( "spr_onsafedoor_pin_1_base", { pos_x = 1318 } );
      ObjSet( "spr_onsafedoor_pin_2_base", { pos_x = 1366 } );
      ObjSet( "spr_onsafedoor_pin_3_base", { pos_x = 1356 } );

      elseif ( cmn.IsEventStart( "win_onsafedoor" ) ) then

        private.Load();

      end;

    end;

    cmn.AddSubscriber( "win_onsafedoor", win_onsafedoor, private.room_objname );

end;

-------------------------------------------------
--function private.get_switchroomplan ()
--
--  cmn.SetEventDone( "get_switchroomplan" );
--  cmn.CallEventHandler( "get_switchroomplan" );
--  
--  cmn.GetObjectSfx();
--
--  cmn.GotoRoom( "rm_office" );
--
--end;
-------------------------------------------------
function private.get_file2 ()

  cmn.SetEventDone( "get_file2" );
  cmn.CallEventHandler( "get_file2" );
  
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_file2" ) and cmn.IsEventDone( "get_bell_3" ) then
    cmn.GotoRoom( "rm_office" );
  end;

end;
-------------------------------------------------
function private.get_bell_3 ()

  cmn.SetEventDone( "get_bell_3" );
  cmn.CallEventHandler( "get_bell_3" );
  
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_file2" ) and cmn.IsEventDone( "get_bell_3" ) then
    cmn.GotoRoom( "rm_office" );
  end;

end;
-------------------------------------------------
function private.clk_safedoor ()

  local func_end = function ()

    cmn.SetEventDone( "clk_safedoor" );
    cmn.CallEventHandler( "clk_safedoor" );
    cmn.CallEventHandler( "clk_safedoor_end" );
    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_safedoor_beg" );

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_onsafedoor_click_afterwin" );  

  ObjAnimate( "spr_onsafedoor_grille", "pos_x", 0, 0, func_end, 
  {
    0.0,0, 548,
    0.6,1,-241
  });

end;
  

--*********************************************************************************************************************
function private.Start ()

  ng_global.progress[ "std" ][ "win_onsafedoor" ].current_num = 1;
  ng_global.progress[ "std" ][ "win_onsafedoor" ].cur_x = {
    { 163, -116, 21   },
    { -51,  -61, -112 },
    { 125,  107, 65   }
  };  

  cmn.MiniGameShow( "onsafedoor" );

end;
--*********************************************************************************************************************
function private.Load ()

  private.current_num = ng_global.progress[ "std" ][ "win_onsafedoor" ].current_num;

  for i=1, (private.current_num - 1) do
    ObjSet( "spr_onsafedoor_light_step_"..i, { alp = 1 } );
    ObjSet( "obj_onsafedoor_pin_num_"..i, { input = false } );
    ObjSet( "spr_onsafedoor_pin_num_"..i, { alp = 1 } );
  end;

  ObjSet( "spr_onsafedoor_pointer", { 
    pos_x = private.pointer_pos[ private.current_num ][ 1 ], 
    pos_y = private.pointer_pos[ private.current_num ][ 2 ]
  } );

  for pin=1, 3 do
    for part=1, 3 do
      ObjSet( "spr_onsafedoor_pin_"..pin.."_part_"..part, {
        pos_x = ng_global.progress[ "std" ][ "win_onsafedoor" ].cur_x[ pin ][ part ]
      });
    end;
  end;

end;
--*********************************************************************************************************************
function public.PreOpen () 

  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

end;
--*********************************************************************************************************************
function public.Open () 

  if ( not cmn.IsEventStart( "win_onsafedoor" ) ) then
    private.Start();
  end;

  if ( cmn.IsEventStart( "win_onsafedoor" ) and not cmn.IsEventDone( "win_onsafedoor" ) ) then
    cmn.MiniGameShow( "onsafedoor" );
    common_impl.PassingMgStart( "onsafedoor" );
  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  if ( cmn.IsEventStart( "win_onsafedoor" ) and not cmn.IsEventDone( "win_onsafedoor" ) ) then
    common_impl.PassingMgStop( "onsafedoor" );
    cmn.MiniGameHide();
  end;

end;
--*********************************************************************************************************************
function public.Reset ()

  private.current_num = 1;
  ng_global.progress[ "std" ][ "win_onsafedoor" ].current_num = 1;
  ng_global.progress[ "std" ][ "win_onsafedoor" ].cur_x = {
    { 163, -116, 21   },
    { -51,  -61, -112 },
    { 125,  107, 65   }
  }; 

  for i=1, 10 do
    ObjSet( "spr_onsafedoor_light_step_"..i, { alp = 0 } );
    ObjSet( "obj_onsafedoor_pin_num_"..i, { input = true } );
    ObjSet( "spr_onsafedoor_pin_num_"..i, { alp = 0 } );
  end; 

  ObjSet( "spr_onsafedoor_pointer", { 
    pos_x = private.pointer_pos[ 1 ][ 1 ], 
    pos_y = private.pointer_pos[ 1 ][ 2 ]
  } );

  for pin=1, 3 do
    for part=1, 3 do
      ObjSet( "spr_onsafedoor_pin_"..pin.."_part_"..part, {
        pos_x = ng_global.progress[ "std" ][ "win_onsafedoor" ].cur_x[ pin ][ part ]
      });
    end;
  end;

end;
--*********************************************************************************************************************
function public.Skip ()
port.skip_mg = true;
  for i=private.current_num, 10 do
    ObjAnimate( "spr_onsafedoor_light_step_"..i, "alp", 0, 0, "", 
    {
      0.0,0,0,
      0.3,0,1
    });
    ObjAnimate( "spr_onsafedoor_pin_num_"..i, "alp", 0, 0, "", 
    {
      0.0,0,0,
      0.3,0,1
    });
    ObjSet( "obj_onsafedoor_pin_num_"..i, { input = false } );
  end; 

  ObjAnimate( "spr_onsafedoor_pointer", "pos_xy", 0, 0, function () private.Win(); end, 
  {
    0.0,0,private.pointer_pos[ private.current_num ][ 1 ],private.pointer_pos[ private.current_num ][ 2 ],
    0.3,0,private.pointer_pos[ 10 ][ 1 ],private.pointer_pos[ 10 ][ 2 ]
  });

end;
--*********************************************************************************************************************
function private.GetDefaultState ()

  local state = { 0, 0, 0 };

  return state;

end;
--*********************************************************************************************************************
function private.WinEnd ()

  cmn.MiniGameHide();

  cmn.SetEventDone( "win_onsafedoor" );
  cmn.CallEventHandler( "win_onsafedoor" );
  common_impl.PassingMgWin( "onsafedoor" );

end;
--*********************************************************************************************************************
function private.Win ()
  
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_onsafedoor_win" );  

  local tme = 1.2;
  ObjAnimate( "spr_onsafedoor_coghwheel_up", "ang", 0, 0, "", 
  {
    0.0,0,0.0,
    tme,1,6.28
  });
  ObjAnimate( "spr_onsafedoor_coghwheel_down", "ang", 0, 0, "", 
  {
    0.0,0,0.0,
    tme,1,-6.28
  });

  ObjAnimate( "spr_onsafedoor_pin_1_base", "pos_x", 0, 0, "", 
  {
    0.0,0,568,
    tme,1,1318
  });
  ObjAnimate( "spr_onsafedoor_pin_2_base", "pos_x", 0, 0, "", 
  {
    0.0,0,616,
    tme,1,1366
  });

  ObjAnimate( "spr_onsafedoor_pin_3_base", "pos_x", 0, 0, 
  function()
    int.Lock( false );
    private.WinEnd();
  end, 
  {
    0.0,0,606,
    tme,1,1356
  });


end;
--*********************************************************************************************************************
function private.PartClick ( pin, part )
  
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_onsafedoor_click" );

  local init_cur_pos = GetZoomCursorPos();
  private.drag_offset = ObjGet( "spr_onsafedoor_pin_"..pin.."_part_"..part ).pos_x - init_cur_pos[ 1 ];
  
  private.current_pin = pin;
  private.current_part = part;
  
  private.PartDrag( pin, part );

end;
--*********************************************************************************************************************
function private.PartDrag ( pin, part )
  --DbgTrace("private.PartDrag pin="..tostring(pin).." part="..tostring(part));
  local pos = GetZoomCursorPos();

  local pos_x1 = pos[ 1 ] + private.drag_offset;

  if ( pos_x1 < private.limit_x[ pin ][ part ][ 1 ] ) then
    pos_x1 = private.limit_x[ pin ][ part ][ 1 ];
  elseif ( pos_x1 > private.limit_x[ pin ][ part ][ 2 ] ) then
    pos_x1 = private.limit_x[ pin ][ part ][ 2 ];
  end;

  ObjSet( "spr_onsafedoor_pin_"..pin.."_part_"..part, { pos_x = pos_x1 } )

  ObjSet( "tmr_onsafedoor_part", { playing = 1, time = 0.01, endtrig = function () private.PartDrag( pin, part ) end } );

end;
--*********************************************************************************************************************
private.current_pin = nil;
private.current_part = nil;
function private.PartDrop ( pin, part )  
    
  ObjSet( "tmr_onsafedoor_part", { playing = false } ); 

  ng_global.progress[ "std" ][ "win_onsafedoor" ].cur_x[ pin ][ part ] = ObjGet( "spr_onsafedoor_pin_"..pin.."_part_"..part ).pos_x;
  
  private.current_pin = nil;
  private.current_part = nil;
  
end;
--*********************************************************************************************************************
function private.PartDropUp()  
  
  if private.current_pin ~= nil and private.current_part ~= nil then
    private.PartDrop( private.current_pin, private.current_part );
  end;

end;
--*********************************************************************************************************************
function private.NumClick ( num )

  local func_end = function ()

    int.Lock( false );

    ObjSet( "obj_onsafedoor_pin_num_"..num, { input = false } );
    ng_global.progress[ "std" ][ "win_onsafedoor" ].current_num = private.current_num;

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_onsafedoor_button" );    

  if ( num == private.current_num ) then

    ObjAnimate("spr_onsafedoor_pin_num_"..num, "alp", 0, 0, "", 
    {
      0.0,0,0,
      0.2,0,1
    });

    if num == 10 then

      ObjAnimate( "spr_onsafedoor_light_step_10", "alp", 0, 0, 
      function ()
        private.Win();
      end,
      {
        0.0,0,0,
        0.3,0,1
      });

    else

      local old_x = private.pointer_pos[ private.current_num ][ 1 ];    
      local old_y = private.pointer_pos[ private.current_num ][ 2 ];
      local new_x = private.pointer_pos[ private.current_num + 1 ][ 1 ];    
      local new_y = private.pointer_pos[ private.current_num + 1 ][ 2 ];
      
      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_onsafedoor_move" );

      ObjAnimate( "spr_onsafedoor_light_step_"..num, "alp", 0, 0, "", 
      {
        0.0,0,0,
        0.3,0,1
      });
      ObjAnimate( "spr_onsafedoor_pointer", "pos_xy", 0, 0, func_end, 
      {
        0.0,0,old_x,old_y,
        0.5,0,old_x,old_y,
        0.9,0,new_x,new_y
      });

      private.current_num = private.current_num + 1;

    end;

  else

    ObjAnimate("spr_onsafedoor_pin_num_"..num, "alp", 0, 0, "", 
    {
      0.0,0,0,
      0.2,0,1,
      0.3,0,1,
      0.5,0,0
    });

    local old_x = private.pointer_pos[ private.current_num ][ 1 ];    
    local old_y = private.pointer_pos[ private.current_num ][ 2 ];
    local new_x = private.pointer_pos[ 1 ][ 1 ];    
    local new_y = private.pointer_pos[ 1 ][ 2 ];

    for i=1, (private.current_num - 1) do
      ObjAnimate( "spr_onsafedoor_light_step_"..i, "alp", 0, 0, "", 
      {
        0.0,0,1,
        0.3,0,0
      });
      ObjAnimate( "spr_onsafedoor_pin_num_"..i, "alp", 0, 0, "", 
      {
        0.0,0,1,
        0.3,0,1,
        0.5,0,0
      });
      ObjSet( "obj_onsafedoor_pin_num_"..i, { input = true } );
    end;

    ObjAnimate( "spr_onsafedoor_pointer", "pos_xy", 0, 0, function () int.Lock( false ); end, 
    {
      0.0,0,old_x,old_y,
      0.5,0,old_x,old_y,
      0.9,0,new_x,new_y
    });

    private.current_num = 1;

  end;

end;
--*********************************************************************************************************************