-- name=mg_repair
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_repair";
  game.relations[ "mg_repair" ].exitroom = "rm_switchroom";

  private.array = 
  { 
    { { 1, 1 }, { 2, -1 } }, 
    { { 3, 1 }, { 4, -1 } }, 
    { { 1, 1 }, { 4, -1 } }, 
    { { 2, 1 }, { 3, -1 } } 
  };

  private.pos = {};

  for i = 1, 4 do

    ObjSet( "obj_repair_mmg_drag_"..i,
    {
      event_mdown = function () private.ClkValve ( i ) end,
      event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end
    } );

  end;

  private.array_pos = { -2, -2, 1, 3 };

  for i = 1, 4 do

    local new_ang = - 1.05 * private.array_pos[ i ]; 
    ObjSet( "obj_repair_arrow"..i,
    {
      ang = new_ang,
    } );

  end;

  --------------------------------------------------------------------------------------------
  -- function win_repair () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_repair" ] =
  {
    type = "click",
    get_obj = "spr_repair_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_repair = function ()

    if ( cmn.IsEventDone( "win_repair" ) ) then

    elseif ( cmn.IsEventStart( "win_repair" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_repair", win_repair, private.room_objname ); 
  
end;
--*********************************************************************************************************************
function private.Load ()

  for i = 1, 4 do

    local ang1 = ng_global.progress[ "std" ][ "win_repair" ].valve[ i ];
    local ang2 = ng_global.progress[ "std" ][ "win_repair" ].arrow[ i ];
    ObjSet( "spr_repair_valve"..i, { ang = ang1 } );
    ObjSet( "obj_repair_arrow"..i, { ang = ang2 } );

    if ang2 == 0 then

      ObjSet( "spr_repair_light"..i, { alp = 1 } ); 

    end;

  end;

end;
--*********************************************************************************************************************
function public.PreOpen () 

  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventStart( "win_repair" ) ) then

    ng_global.progress[ "std" ][ "win_repair" ].arrow = {};
    for i = 1, 4 do

      local new_ang = - 1.05 * private.array_pos[ i ]; 
      ng_global.progress[ "std" ][ "win_repair" ].arrow[ i ] = new_ang;

    end;

    ng_global.progress[ "std" ][ "win_repair" ].valve = { 0, 0, 0, 0 };

  end;

end;
--*********************************************************************************************************************
function public.Open () 

  if ( not cmn.IsEventDone( "win_repair" ) ) then
    
    cmn.MiniGameShow( "repair" );
    common_impl.PassingMgStart( "repair" );
    
  else 
    
    private.PresentTransfer();
    
  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  cmn.MiniGameHide();
  common_impl.PassingMgStop( "repair" );

end;
--*********************************************************************************************************************
function public.Reset ()

  for i = 1, 4 do
   
    local new_ang = - 1.05 * private.array_pos[ i ]; 
    ObjSet( "spr_repair_valve"..i, { ang = 0 } );
    ObjSet( "obj_repair_arrow"..i, { ang = new_ang } );
    ObjSet( "spr_repair_light"..i, { alp = 0 } ); 
    ng_global.progress[ "std" ][ "win_repair" ].valve[ i ] = 0;
    ng_global.progress[ "std" ][ "win_repair" ].arrow[ i ] = new_ang;

  end;

end;
--*********************************************************************************************************************
function public.Skip ()
port.skip_mg = true;
  private.Win();

  for i = 1, 4 do

    ObjSet( "obj_repair_arrow"..i, { ang = 0 } );
    ObjSet( "spr_repair_light"..i, { alp = 1 } ); 

  end;

end;
--*********************************************************************************************************************
function private.ClkValve ( id )

  local cur_ang = ObjGet( "spr_repair_valve"..id ).ang;
  local new_ang = cur_ang - 1.05;

  local func_end = function ()
    if new_ang < - 6.28 then
      ObjSet( "spr_repair_valve"..id, { ang = 0 } );
    end;

    if ( private.IsWin() ) then

      private.Win();

    else

      private.SaveVar();

    end;  

  end;

  int.Lock( true );
  private.ArrowRotation ( id );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_rotate_wheel" );
  ObjAnimate( "spr_repair_valve"..id, "ang", 0, 0, func_end, 
  { 
    0.0, 0, cur_ang,
    0.3, 0, new_ang
  } );

end;
--------------------------------------------------------------------------------------------
function private.ArrowRotation ( id )

  for i = 1, 2 do

    local arrow_id = private.array[ id ][ i ][ 1 ];
    local dir = private.array[ id ][ i ][ 2 ];

    local cur_ang = ObjGet( "obj_repair_arrow"..arrow_id ).ang;
    local new_ang = cur_ang - ( 1.05 * dir );

    local func_end = function ()
      if ( new_ang < - 6.28 or new_ang > 6.28 ) then
        ObjSet( "obj_repair_arrow"..arrow_id, { ang = 0 } );
        new_ang = 0;
      end;
      if ( new_ang > - 0.5 and new_ang < 0 ) then
        ObjSet( "obj_repair_arrow"..arrow_id, { ang = 0 } );
        new_ang = 0;
      end;
      if ( new_ang < 0.5 and new_ang > 0 ) then
        ObjSet( "obj_repair_arrow"..arrow_id, { ang = 0 } );
        new_ang = 0;
      end;

      if new_ang == 0 then

        ObjAnimate( "spr_repair_light"..arrow_id, "alp", 0, 0, "", 
        { 
          0.0, 3, 0,
          0.2, 3, 1
        } );  

      elseif ObjGet( "spr_repair_light"..arrow_id ).alp == 1 then

        ObjAnimate( "spr_repair_light"..arrow_id, "alp", 0, 0, "", 
        { 
          0.0, 3, 1,
          0.2, 3, 0
        } );
  
      end;

    end;

    ObjAnimate( "obj_repair_arrow"..arrow_id, "ang", 0, 0, func_end, 
    { 
      0.0, 0, cur_ang,
      0.29, 0, new_ang
    } );

  end;

end;
--------------------------------------------------------------------------------------------
function private.SaveVar ()

  for i = 1, 4 do

    ng_global.progress[ "std" ][ "win_repair" ].valve[ i ] = ObjGet( "spr_repair_valve"..i ).ang;
    ng_global.progress[ "std" ][ "win_repair" ].arrow[ i ] = ObjGet( "obj_repair_arrow"..i ).ang;

  end;

  int.Lock( false );

end;
--------------------------------------------------------------------------------------------
function private.IsWin ()

  local flag = true;

  for i = 1, 4 do

    local ang = ObjGet( "obj_repair_arrow"..i ).ang;

    if ang ~= 0  then

      flag = false;
      break;

    end;

  end;

  return flag;

end;
--------------------------------------------------------------------------------------------
function private.Win ()

  int.Lock( true );
  
  local func_end = function ()

    private.PresentTransfer();

  end;

  int.Lock( true );
  cmn.MiniGameHide( "repair" );
  cmn.SetEventDone( "win_repair" );
  common_impl.PassingMgWin( "repair" );
  int.ShowTaskNote( 3, func_end ); 

end;
--------------------------------------------------------------------------------------------
function private.PresentTransfer()
  
  local func_end = function ()
  
    int.Lock( false );
    cmn.CallEventHandler( "win_repair" );
    cmn.GotoRoom( "rm_policestation2" );
    cmn.AddPageDiary( 12 );

    cmn.StopAudio( "sfx", "audio/level2/sfx/aud_repair_present_transfer" );
    --cmn.StopAudio( "voc", "audio/level1/voc/aud_watch_voc" );
      
  end;
  
  common_impl.PlayDialogVideo( "vid_repair_present_transfer", func_end );
  ObjSet( "mg_repair", { color_r = 0, color_g = 0, color_b = 0 } );
  --cmn.PlayAudio( "mus", "audio/aud_mainquestion_theme" );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_repair_present_transfer" );
  --cmn.PlayAudio( "voc", "audio/level1/voc/aud_watch_voc" );
    
end;  
-----------------------------------------------------------------------------------------------