-- name=level2_inv
--*********************************************************************************************************************
function public.Init ()
  
  if port.isPortable() == 1 then
    port.InventoryPopupInit("level2_inv_hub");
    port.VideoResizeInRoom("level2_inv");
  end;
  
  private.brokenelectricscrewdriver_init();
  private.doll_init();
  private.documentfolder_init();
  private.oldchest_init();
  private.wrappeditem_init();
  private.fork_init();
  private.brokenbutterfly_init();
  private.burntbag_init();
  private.switchroomplan_init();

  private.ScrewdriverInit();

  int.CreateDeployPlus( 2 );

  MsgSubscribe( Command_Interface_UpdateGameMode, private.UpdateGameMode );

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_level2_inv_deploy = function ()

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    common_impl.TurnChildGfx( { "level2_inv_deploy" } , "level2_inv_deploy", visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_level2_inv_deploy", update_game_mode_level2_inv_deploy, nil );

end;
--*********************************************************************************************************************
function private.UpdateGameMode ( msg, params )

--  if ( params.mode == 3 ) then
--    
--    if ( not ObjGet( "level2_inv_deploy" ) ) then
--
--      return;
--
--    end;
--
--    local relations = ObjGetRelations( "level2_inv_deploy" );
--    local table_multiset = {};
--
--    for i = 1, #relations.childs do
--
--      local obj = "spr_"..common.GetObjectName( common.GetObjectName( relations.childs[ i ] ) ).."_plus";      
--      table.insert( table_multiset, { obj, { visible = ng_global.gamemode_custom[ "plus_inv" ] } } );
--      table.insert( table_multiset, { obj.."_light", { visible = ng_global.gamemode_custom[ "plus_inv" ] } } );
--
--    end;
--
--    ObjMultiSet( table_multiset );
--  
--  end;

end;
--*********************************************************************************************************************
-- function *** brokenelectricscrewdriver *** ()
--*********************************************************************************************************************
  function private.brokenelectricscrewdriver_init ()

    ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver",  { event_mdown = private.get_screwdriver2 } );
    ObjSet( "obj_deploy_inv_brokenelectricscrewdriver_screwdriver_cover_clk",  { event_mdown = private.clk_battery_cover } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_screwdriver2" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_brokenelectricscrewdriver_screwdriver",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenelectricscrewdriver",
      zz_gate = "inv_brokenelectricscrewdriver"
    };
    -------------------------------------------------------------------------------------------
    function get_screwdriver2_inv ()

      interface.InventoryItemRemove( "inv_brokenelectricscrewdriver" );
      interface.InventoryItemAdd( "inv_screwdriver2", "obj_deploy_inv_brokenelectricscrewdriver" );

      ObjDelete( "gfx_deploy_inv_brokenelectricscrewdriver_screwdriver" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_screwdriver2", get_screwdriver2_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_battery_cover" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_brokenelectricscrewdriver_screwdriver_cover_clk",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenelectricscrewdriver",
      zz_gate = "inv_brokenelectricscrewdriver"
    };
    -------------------------------------------------------------------------------------------
    function clk_battery_cover_inv ()

      ObjSet( "inv_brokenelectricscrewdriver_plus_focus2", { alp = 0 } );

      if ( ( cmn.IsEventDone( "get_screwdrivercap" ) ) and
           ( not cmn.IsEventDone( "use_screwdrivercap" ) ) ) or
         ( cmn.IsEventDone( "get_battery" ) ) then

        ObjSet( "inv_brokenelectricscrewdriver_plus_focus2", { alp = 1 } );

      end;

      ObjSet( "spr_brokenelectricscrewdriver_batteryslot", { alp = 1 } );

    end;
    function clk_battery_cover_beg ()

      ObjDelete( "obj_deploy_inv_brokenelectricscrewdriver_screwdriver_cover_clk" );

    end;
    function clk_battery_cover_end ()

      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_cover", { input = false, pos_x = 92, pos_y = 277 } );
      ObjSet( "obj_deploy_inv_brokenelectricscrewdriver_use_battery", { input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_battery_cover", clk_battery_cover_beg );
    cmn.AddSubscriber( "clk_battery_cover", clk_battery_cover_inv );
    cmn.AddSubscriber( "clk_battery_cover", clk_battery_cover_end );
    cmn.AddSubscriber( "clk_battery_cover_beg", clk_battery_cover_beg );
    cmn.AddSubscriber( "clk_battery_cover_inv", clk_battery_cover_inv );
    cmn.AddSubscriber( "clk_battery_cover_end", clk_battery_cover_end );
    -------------------------------------------------------------------------------------------  
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_battery" ] =
    {
      type = "use",
      use_obj = "inv_battery",
      use_place = "obj_deploy_inv_brokenelectricscrewdriver_use_battery",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenelectricscrewdriver",
      zz_gate = "inv_brokenelectricscrewdriver"
    };
    -------------------------------------------------------------------------------------------
    function use_battery_inv ()
  
      interface.InventoryItemRemove( "inv_battery" );

      if ( not cmn.IsEventDone( "use_screwdrivercap" ) ) then

        ObjSet( "inv_brokenelectricscrewdriver_plus_focus2", { alp = 0 } );

      else

        ObjSet( "inv_brokenelectricscrewdriver", { res = "assets/levels/level2/common_inventory2/inv_brokenelectricscrewdriver/inv/screwdriver_open" } );
        ObjSet( "spr_brokenelectricscrewdriver_screwdrivercap", { alp = 0 } );

      end;

      ObjDelete( "spr_brokenelectricscrewdriver_batteryslot" );

      if ( cmn.IsEventDone( "get_screwdrivercap" ) ) and
         ( not cmn.IsEventDone( "use_screwdrivercap" ) ) then

        ObjSet( "inv_brokenelectricscrewdriver_plus_focus2", { alp = 1 } );

      end;

    end;
    function use_battery_beg ()

      ObjDelete( "obj_deploy_inv_brokenelectricscrewdriver_use_battery" );

    end;
    function use_battery_end ()

      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_battery", { alp = 1 } );
      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_cover", { pos_x = 81, pos_y = 221 } );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_battery", use_battery_beg, "inv_brokenelectricscrewdriver" );
    cmn.AddSubscriber( "use_battery", use_battery_inv );
    cmn.AddSubscriber( "use_battery", use_battery_end, "inv_brokenelectricscrewdriver" );
    cmn.AddSubscriber( "use_battery_inv", use_battery_inv );
    cmn.AddSubscriber( "use_battery_beg", use_battery_beg, "inv_brokenelectricscrewdriver" );
    cmn.AddSubscriber( "use_battery_end", use_battery_end, "inv_brokenelectricscrewdriver" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_screwdrivercap" ] =
    {
      type = "use",
      use_obj = "inv_screwdrivercap",
      use_place = "obj_deploy_inv_brokenelectricscrewdriver_use_screwdrivercap",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenelectricscrewdriver",
      zz_gate = "inv_brokenelectricscrewdriver"
    };
    -------------------------------------------------------------------------------------------
    function use_screwdrivercap_inv ()
  
      interface.InventoryItemRemove( "inv_screwdrivercap" );

      if ( not cmn.IsEventDone( "use_battery" ) ) then

        ObjSet( "spr_brokenelectricscrewdriver_screwdrivercap", { alp = 1 } );

      else

        ObjSet( "inv_brokenelectricscrewdriver", { res = "assets/levels/level2/common_inventory2/inv_brokenelectricscrewdriver/inv/screwdriver_open" } );
        ObjSet( "spr_brokenelectricscrewdriver_screwdrivercap", { alp = 0 } );

      end;

      ObjSet( "inv_brokenelectricscrewdriver_plus_focus2", { alp = 0 } );

      if ( ( cmn.IsEventDone( "get_battery" ) ) and
           ( not cmn.IsEventDone( "use_battery" ) ) ) or
         ( not cmn.IsEventDone( "clk_battery_cover" ) ) then

        ObjSet( "inv_brokenelectricscrewdriver_plus_focus2", { alp = 1 } );

      end;

    end;
    function use_screwdrivercap_beg ()

      ObjDelete( "obj_deploy_inv_brokenelectricscrewdriver_use_screwdrivercap" );

    end;
    function use_screwdrivercap_end ()

      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_cap", { alp = 1 } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_screwdrivercap", use_screwdrivercap_beg, "inv_brokenelectricscrewdriver" );
    cmn.AddSubscriber( "use_screwdrivercap", use_screwdrivercap_inv );
    cmn.AddSubscriber( "use_screwdrivercap", use_screwdrivercap_end, "inv_brokenelectricscrewdriver" );
    cmn.AddSubscriber( "use_screwdrivercap_inv", use_screwdrivercap_inv );
    cmn.AddSubscriber( "use_screwdrivercap_beg", use_screwdrivercap_beg, "inv_brokenelectricscrewdriver" );
    cmn.AddSubscriber( "use_screwdrivercap_end", use_screwdrivercap_end, "inv_brokenelectricscrewdriver" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_screwdriverrmanual" ] =
    {
      type = "use",
      use_obj = "inv_screwdriverrmanual",
      use_place = "obj_deploy_inv_brokenelectricscrewdriver_use_screwdriverrmanual",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenelectricscrewdriver",
      zz_gate = "inv_brokenelectricscrewdriver"
    };
    -------------------------------------------------------------------------------------------
    function use_screwdriverrmanual_inv ()
  
      interface.InventoryItemRemove( "inv_screwdriverrmanual" );

    end;
    function use_screwdriverrmanual_beg ()

      ObjDelete( "obj_deploy_inv_brokenelectricscrewdriver_use_screwdriverrmanual" );

    end;
    function use_screwdriverrmanual_end ()

      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_manual", { alp = 1 } );
      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver", { pos_x = -182 } );
      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_cap", { pos_x = -443 } );
      ObjSet( "obj_deploy_inv_brokenelectricscrewdriver_use_battery", { active = true, input = true } );
      ObjSet( "obj_deploy_inv_brokenelectricscrewdriver_use_screwdrivercap", { active = true, input = true } );
      ObjSet( "obj_deploy_inv_brokenelectricscrewdriver_screwdriver_cover_clk", { active = true, input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_screwdriverrmanual", use_screwdriverrmanual_beg, "inv_brokenelectricscrewdriver" );
    cmn.AddSubscriber( "use_screwdriverrmanual", use_screwdriverrmanual_inv );
    cmn.AddSubscriber( "use_screwdriverrmanual", use_screwdriverrmanual_end, "inv_brokenelectricscrewdriver" );
    cmn.AddSubscriber( "use_screwdriverrmanual_inv", use_screwdriverrmanual_inv );
    cmn.AddSubscriber( "use_screwdriverrmanual_beg", use_screwdriverrmanual_beg, "inv_brokenelectricscrewdriver" );
    cmn.AddSubscriber( "use_screwdriverrmanual_end", use_screwdriverrmanual_end, "inv_brokenelectricscrewdriver" );
    -------------------------------------------------------------------------------------------
    --------------------------------------------------------------------------------------------
    -- function win_brokenelectricscrewdriver () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "win_brokenelectricscrewdriver" ] =
    {
      type = "click",
      clk_obj = "inv_screwdriverrmanual",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenelectricscrewdriver",
      zz_gate = "inv_brokenelectricscrewdriver"
    };
    -----------------------------------------------
    local win_brokenelectricscrewdriver = function ()

      if ( cmn.IsEventStart( "win_brokenelectricscrewdriver" ) ) then

        ObjSet( "obj_deploy_inv_brokenelectricscrewdriver_mmg", { alp = 1, input = true } );
        ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_manual_1", { alp = 0 } );
        private.ScrewdriverLoad();

        ObjSet( "inv_brokenelectricscrewdriver", { res = "assets/levels/level2/rm_livingroom/zz_window/inv/inv_brokenelectricscrewdriver" } );
        ObjSet( "spr_brokenelectricscrewdriver_screwdrivercap", { alp = 1 } );

      end;

      if ( cmn.IsEventDone( "win_brokenelectricscrewdriver" ) ) then
     
        ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver", { input = true, pos_x = -82 } );
        ObjSet( "gfx_deploy_inv_brokenelectricscrewdriver_screwdriver", { active = true } );
        ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_cap", { pos_x = -343 } );

        ObjDelete( "obj_deploy_inv_brokenelectricscrewdriver_mmg" );
        ObjDelete( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_broken" );
        ObjDelete( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_manual" );

      end;

    end;

    cmn.AddSubscriber( "win_brokenelectricscrewdriver", win_brokenelectricscrewdriver );
    cmn.AddSubscriber( "win_brokenelectricscrewdriver", win_brokenelectricscrewdriver, "inv_brokenelectricscrewdriver" );

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.get_screwdriver2 ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_screwdriver2" );
    cmn.CallEventHandler( "get_screwdriver2", "inv_brokenelectricscrewdriver" );

    int.DeployInvHide();

  end;
--*********************************************************************************************************************
  function private.clk_battery_cover ()

    local func_end = function ()

      int.Lock( false );

      cmn.SetEventDone( "clk_battery_cover" );
      cmn.CallEventHandler( "clk_battery_cover_end" );
    
    end;

    cmn.CallEventHandler( "clk_battery_cover_inv" );
    cmn.CallEventHandler( "clk_battery_cover_beg" );

    int.Lock( true );  
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_drill_open_case" );
    ObjAnimate("spr_deploy_inv_brokenelectricscrewdriver_screwdriver_cover", "pos_xy", 0, 0, func_end, 
    {
      0.0,0,81,221,
      0.3,0,92,277
    });  

  end;
--*********************************************************************************************************************
  function public.use_battery ()

    local item = "inv_battery";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_brokenelectricscrewdriver_use_battery" ) ) and 
       cmn.IsEventDone( "clk_battery_cover" ) and 
       cmn.IsEventDone( "use_screwdriverrmanual" )  then

      cmn.CallEventHandler( "use_battery_inv" );
      cmn.CallEventHandler( "use_battery_beg", "inv_brokenelectricscrewdriver" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_battery" );
        cmn.CallEventHandler( "use_battery_end", "inv_brokenelectricscrewdriver" );

        if ( cmn.IsEventDone( "use_screwdrivercap" ) and
             cmn.IsEventDone( "use_screwdriverrmanual" ) ) then
             
          common_impl.PassingMgStart( "brokenelectricscrewdriver" );
          private.ScrewdriverStart();

        end;
      
      end;

      int.Lock( true );

      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_drill_insert_batt" );
      ObjAnimate("spr_deploy_inv_brokenelectricscrewdriver_screwdriver_battery", "alp", 0, 0, "", 
      {
        0.0,0,0,
        0.3,0,1
      });
      ObjAnimate("spr_deploy_inv_brokenelectricscrewdriver_screwdriver_cover", "pos_xy", 0, 0, func_end, 
      {
        0.0,0,92,277,
        0.5,0,92,277,
        0.8,0,81,221
      });

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
  function public.use_screwdrivercap ()

    local item = "inv_screwdrivercap";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_brokenelectricscrewdriver_use_screwdrivercap" ) )and 
       cmn.IsEventDone( "use_screwdriverrmanual" )  then

      cmn.CallEventHandler( "use_screwdrivercap_inv" );
      cmn.CallEventHandler( "use_screwdrivercap_beg", "inv_brokenelectricscrewdriver" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_screwdrivercap" );
        cmn.CallEventHandler( "use_screwdrivercap_end", "inv_brokenelectricscrewdriver" );

        if ( cmn.IsEventDone( "use_battery" ) and
             cmn.IsEventDone( "use_screwdriverrmanual" ) ) then
             
          common_impl.PassingMgStart( "brokenelectricscrewdriver" );
          private.ScrewdriverStart();

        end;
      
      end;

      int.Lock( true );

      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_drill_socket" );
      ObjAnimate("spr_deploy_inv_brokenelectricscrewdriver_screwdriver_cap", "alp", 0, 0, func_end, 
      {
        0.0,0,0,
        0.3,0,1
      });

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
  function public.use_screwdriverrmanual ()

    local item = "inv_screwdriverrmanual";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_brokenelectricscrewdriver_use_screwdriverrmanual" ) ) then

      cmn.CallEventHandler( "use_screwdriverrmanual_inv" );
      cmn.CallEventHandler( "use_screwdriverrmanual_beg", "inv_brokenelectricscrewdriver" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_screwdriverrmanual" );
        cmn.CallEventHandler( "use_screwdriverrmanual_end", "inv_brokenelectricscrewdriver" );

        if ( cmn.IsEventDone( "use_battery" ) and
             cmn.IsEventDone( "use_screwdrivercap" ) ) then
             
          common_impl.PassingMgStart( "brokenelectricscrewdriver" );
          private.ScrewdriverStart();

        end;

      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_app_paper_to_screwdriver" );
      ObjAnimate("spr_deploy_inv_brokenelectricscrewdriver_screwdriver_manual", "alp", 0, 0, func_end, 
      {
        0.0,0,0,
        0.3,0,1
      });
      ObjAnimate("spr_deploy_inv_brokenelectricscrewdriver_screwdriver", "pos_x", 0, 0, "", 
      {
        0.0,0,-82,
        0.3,0,-182
      });
      ObjAnimate("spr_deploy_inv_brokenelectricscrewdriver_screwdriver_cap", "pos_x", 0, 0, "", 
      {
        0.0,0,-343,
        0.3,0,-443
      });

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** doll *** ()
--*********************************************************************************************************************
  function private.doll_init ()

    ObjSet( "spr_deploy_inv_doll_counterbutton",  { event_mdown = private.get_counterbutton } );
    ObjSet( "spr_deploy_inv_doll_snailamulet_1",  { event_mdown = private.get_snailamulet_1 } );
    ObjSet( "obj_deploy_inv_doll_clk",            { event_mdown = private.clk_doll } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_counterbutton" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_doll_counterbutton",
      room = "int_deploy_inv",
      zz = "deploy_inv_doll",
      zz_gate = "inv_doll"
    };
    -------------------------------------------------------------------------------------------
    function get_counterbutton_inv ()

      if ( cmn.IsEventDone( "get_snailamulet_1" ) ) then

        interface.InventoryItemRemove( "inv_doll" );

      end;

      interface.InventoryItemAdd( "inv_counterbutton", "spr_deploy_inv_doll_counterbutton" );

      ObjDelete( "gfx_deploy_inv_doll_counterbutton" );
      ObjDelete( "spr_deploy_inv_doll_counterbutton_shadow" );
      ObjDelete( "spr_doll_counterbutton" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_counterbutton", get_counterbutton_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_snailamulet_1" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_doll_snailamulet_1",
      room = "int_deploy_inv",
      zz = "deploy_inv_doll",
      zz_gate = "inv_doll"
    };
    -------------------------------------------------------------------------------------------
    function get_snailamulet_1_inv ()

      if ( cmn.IsEventDone( "get_counterbutton" ) ) then

        interface.InventoryItemRemove( "inv_doll" );

      end;

      interface.InventoryItemAdd( "inv_snailamulet_1", "spr_deploy_inv_doll_snailamulet_1" );

      ObjDelete( "gfx_deploy_inv_doll_snailamulet_1" );
      ObjDelete( "spr_deploy_inv_doll_snailamulet_1_shadow" );
      ObjDelete( "spr_doll_snailamulet_1" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_snailamulet_1", get_snailamulet_1_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_doll" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_doll_clk",
      room = "int_deploy_inv",
      zz = "deploy_inv_doll",
      zz_gate = "inv_doll"
    };
    -------------------------------------------------------------------------------------------
    function clk_doll_inv ()

      ObjDelete( "spr_doll_hand_1" );
      ObjSet( "spr_doll_hand_2", { alp = 1 } );

    end;
    function clk_doll_beg ()

      ObjDelete( "obj_deploy_inv_doll_clk" );

    end;
    function clk_doll_end ()

      ObjSet( "spr_deploy_inv_doll_counterbutton", { input = true } );
      ObjSet( "spr_deploy_inv_doll_snailamulet_1", { input = true } );
      ObjSet( "gfx_deploy_inv_doll_counterbutton", { active = true } );
      ObjSet( "gfx_deploy_inv_doll_snailamulet_1", { active = true } );
      ObjSet( "spr_deploy_inv_doll_hand_down",     { alp = 1 } );
      ObjDelete( "spr_deploy_inv_doll_hand_up" );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_doll", clk_doll_inv );
    cmn.AddSubscriber( "clk_doll", clk_doll_beg, "inv_doll" );
    cmn.AddSubscriber( "clk_doll", clk_doll_end, "inv_doll" );
    cmn.AddSubscriber( "clk_doll_inv", clk_doll_inv );
    cmn.AddSubscriber( "clk_doll_beg", clk_doll_beg, "inv_doll" );
    cmn.AddSubscriber( "clk_doll_end", clk_doll_end, "inv_doll" );
    -------------------------------------------------------------------------------------------  

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.get_counterbutton ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_counterbutton" );
    cmn.CallEventHandler( "get_counterbutton", "inv_doll" );

    if ( cmn.IsEventDone( "get_snailamulet_1" ) ) then

      int.DeployInvHide();

    end;

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.get_snailamulet_1 ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_snailamulet_1" );
    cmn.CallEventHandler( "get_snailamulet_1", "inv_doll" );

    if ( cmn.IsEventDone( "get_counterbutton" ) ) then

      int.DeployInvHide();

    end;

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.clk_doll ()

    cmn.CallEventHandler( "clk_doll_inv", "inv_doll" );
    cmn.CallEventHandler( "clk_doll_beg", "inv_doll" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_doll" );
      cmn.CallEventHandler( "clk_doll_end", "inv_doll" );
    
    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_doll_hand" );
    ObjAnimate( "spr_deploy_inv_doll_hand_down", "alp", 0, 0, "", 
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    ObjAnimate( "spr_deploy_inv_doll_hand_up", "alp", 0, 0, func_end, 
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );

    return true;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** documentfolder *** ()
--*********************************************************************************************************************
  function private.documentfolder_init ()

    ObjMultiSet( {
      { "spr_deploy_inv_documentfolder_doordowel_1",      { event_mdown = private.get_doordowel_1 } };
      { "spr_deploy_inv_documentfolder_razorblade",       { event_mdown = private.get_razorblade } },
      { "obj_deploy_inv_documentfolder_clk_closed",       { event_mdown = private.clk_documentfolder_closed } },
      { "obj_deploy_inv_documentfolder_clk_open_1",       { event_mdown = private.clk_documentfolder_open_1 } },
      { "obj_deploy_inv_documentfolder_clk_open_2",       { event_mdown = private.clk_documentfolder_open_2 } },
      { "spr_deploy_inv_documentfoler_closed_bookmark",   { event_mdown = private.ClkBookmark } },
    } );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_doordowel_1" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_documentfolder_doordowel_1",
      room = "int_deploy_inv",
      zz = "deploy_inv_documentfolder",
      zz_gate = "inv_documentfolder"
    };
    -------------------------------------------------------------------------------------------
    function get_doordowel_1_inv ()

      if cmn.IsEventDone( "get_razorblade" ) then

        interface.InventoryItemRemove( "inv_documentfolder" );

      end;

      interface.InventoryItemAdd( "inv_doordowel_1", "spr_deploy_inv_documentfolder_doordowel_1", "assets/levels/level2/rm_kitchen/zz_shelvesonwall/inv/inv_doordowel_morph" );

      ObjDelete( "gfx_deploy_inv_documentfolder_doordowel_1" );
      ObjDelete( "spr_deploy_inv_documentfolder_doordowel_1_shadow" );
      ObjDelete( "spr_documentfolder_doordowel_1" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_doordowel_1", get_doordowel_1_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_razorblade" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_documentfolder_razorblade",
      room = "int_deploy_inv",
      zz = "deploy_inv_documentfolder",
      zz_gate = "inv_documentfolder"
    };
    -------------------------------------------------------------------------------------------
    function get_razorblade_inv ()

      if cmn.IsEventDone( "get_doordowel_1" ) then

        interface.InventoryItemRemove( "inv_documentfolder" );

      end;

      interface.InventoryItemAdd( "inv_razorblade", "spr_deploy_inv_documentfolder_razorblade" );

      ObjDelete( "gfx_deploy_inv_documentfolder_razorblade" );
      ObjDelete( "spr_deploy_inv_documentfolder_razorblade_shadow" );
      ObjDelete( "spr_documentfolder_razorblade" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_razorblade", get_razorblade_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_documentfolder_closed" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_documentfolder_clk_closed",
      room = "int_deploy_inv",
      zz = "deploy_inv_documentfolder",
      zz_gate = "inv_documentfolder"
    };
    -------------------------------------------------------------------------------------------
    function clk_documentfolder_closed_inv ()

      ObjSet( "inv_documentfolder", { res = "assets/levels/level2/common_inventory2/inv_documentfolder/inv/documentfolder_open" } );

    end;
    function clk_documentfolder_closed_beg ()

      ObjDelete( "obj_deploy_inv_documentfolder_clk_closed" );

    end;
    function clk_documentfolder_closed_end ()

      ObjSet( "obj_deploy_inv_documentfoler_open_1", { alp = 1, input = true } );
      ObjSet( "obj_deploy_inv_documentfolder_clk_open_1", { input = true } );
      ObjDelete( "obj_deploy_inv_documentfoler_closed" );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_documentfolder_closed", clk_documentfolder_closed_inv );
    cmn.AddSubscriber( "clk_documentfolder_closed", clk_documentfolder_closed_beg, "inv_documentfolder" );
    cmn.AddSubscriber( "clk_documentfolder_closed", clk_documentfolder_closed_end, "inv_documentfolder" );
    cmn.AddSubscriber( "clk_documentfolder_closed_inv", clk_documentfolder_closed_inv );
    cmn.AddSubscriber( "clk_documentfolder_closed_beg", clk_documentfolder_closed_beg, "inv_documentfolder" );
    cmn.AddSubscriber( "clk_documentfolder_closed_end", clk_documentfolder_closed_end, "inv_documentfolder" );
    ------------------------------------------------------------------------------------------- 
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_documentfolder_open_1" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_documentfolder_clk_open_1",
      room = "int_deploy_inv",
      zz = "deploy_inv_documentfolder",
      zz_gate = "inv_documentfolder"
    };
    -------------------------------------------------------------------------------------------
    function clk_documentfolder_open_1_inv ()

      ObjSet( "obj_documentfolder_open", { alp = 1 } );

    end;
    function clk_documentfolder_open_1_beg ()

      ObjDelete( "obj_deploy_inv_documentfolder_clk_open_1" );

    end;
    function clk_documentfolder_open_1_end ()

      ObjSet( "obj_deploy_inv_documentfoler_open_2", { alp = 1, input = true } );
      ObjSet( "gfx_deploy_inv_documentfolder_doordowel_1", { active = true } );
      ObjSet( "gfx_deploy_inv_documentfolder_razorblade", { active = true } );


    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_documentfolder_open_1", clk_documentfolder_open_1_inv );
    cmn.AddSubscriber( "clk_documentfolder_open_1", clk_documentfolder_open_1_beg, "inv_documentfolder" );
    cmn.AddSubscriber( "clk_documentfolder_open_1", clk_documentfolder_open_1_end, "inv_documentfolder" );
    cmn.AddSubscriber( "clk_documentfolder_open_1_inv", clk_documentfolder_open_1_inv );
    cmn.AddSubscriber( "clk_documentfolder_open_1_beg", clk_documentfolder_open_1_beg, "inv_documentfolder" );
    cmn.AddSubscriber( "clk_documentfolder_open_1_end", clk_documentfolder_open_1_end, "inv_documentfolder" );
    -------------------------------------------------------------------------------------------   
    -------------------------------------------------------------------------------------------  

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.get_doordowel_1 ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_doordowel_1" );
    cmn.CallEventHandler( "get_doordowel_1", "inv_documentfolder" );

    if cmn.IsEventDone( "get_razorblade" ) then

      int.DeployInvHide();

    end;

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.get_razorblade ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_razorblade" );
    cmn.CallEventHandler( "get_razorblade", "inv_documentfolder" );

    if cmn.IsEventDone( "get_doordowel_1" ) then

      int.DeployInvHide();

    end;

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.clk_documentfolder_closed ()

    cmn.CallEventHandler( "clk_documentfolder_closed_inv", "inv_documentfolder" );
    cmn.CallEventHandler( "clk_documentfolder_closed_beg", "inv_documentfolder" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_documentfolder_closed" );
      cmn.CallEventHandler( "clk_documentfolder_closed_end", "inv_documentfolder" );
      cmn.PlayAudio( "mus", "audio/aud_amnesia_theme_mus" );
    
    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_open_book_2" );
    ObjAnimate("obj_deploy_inv_documentfoler_closed", "alp", 0, 0, "", 
    {
      0.0,0,1,
      0.3,0,0
    });
    ObjAnimate("obj_deploy_inv_documentfoler_open_1", "alp", 0, 0, func_end, 
    {
      0.0,0,0,
      0.3,0,1
    });

    return true;

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.clk_documentfolder_open_1 ()

    cmn.CallEventHandler( "clk_documentfolder_open_1_inv", "inv_documentfolder" );
    cmn.CallEventHandler( "clk_documentfolder_open_1_beg", "inv_documentfolder" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_documentfolder_open_1" );
      cmn.CallEventHandler( "clk_documentfolder_open_1_end", "inv_documentfolder" );
    
    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_open_book_1" );
    ObjAnimate("obj_deploy_inv_documentfoler_open_2", "alp", 0, 0, func_end, 
    {
      0.0,0,0,
      0.3,0,1
    });

    return true;

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.ClkBookmark()

    int.Lock( true );

    ObjAnimate("spr_deploy_inv_documentfoler_closed_bookmark", "ang", 0, 0, 
    function ()
      int.Lock( false );
    end, 
    {
      0.0,0,0.0,
      0.2,2,0.1,
      0.6,3,-0.08,
      1.0,3,0.05,
      1.4,3,-0.02,
      1.8,3,0.0
    });

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** oldchest *** ()
--*********************************************************************************************************************
  function private.oldchest_init ()

    ObjSet( "spr_deploy_inv_oldchest_ambereye_1",  { event_mdown = private.get_ambereye_1 } );
    ObjSet( "spr_deploy_inv_oldchest_knife",  { event_mdown = private.get_knife } );
    ObjSet( "obj_deploy_inv_oldchest_clk",  { event_mdown = private.clk_oldchest } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_ambereye_1" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_oldchest_ambereye_1",
      room = "int_deploy_inv",
      zz = "deploy_inv_oldchest",
      zz_gate = "inv_oldchest"
    };
    -------------------------------------------------------------------------------------------
    function get_ambereye_1_inv ()

      if cmn.IsEventDone( "get_knife" ) then

        interface.InventoryItemRemove( "inv_oldchest" );

      end;

      interface.InventoryItemAdd( "inv_ambereye_1", "spr_deploy_inv_oldchest_ambereye_1" );

      ObjDelete( "gfx_deploy_inv_oldchest_ambereye_1" );
      ObjDelete( "spr_deploy_inv_oldchest_ambereye_1_shadow" );
      ObjDelete( "spr_oldchest_ambereye_1" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_ambereye_1", get_ambereye_1_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_knife" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_oldchest_knife",
      room = "int_deploy_inv",
      zz = "deploy_inv_oldchest",
      zz_gate = "inv_oldchest"
    };
    -------------------------------------------------------------------------------------------
    function get_knife_inv ()

      if cmn.IsEventDone( "get_ambereye_1" ) then

        interface.InventoryItemRemove( "inv_oldchest" );

      end;

      interface.InventoryItemAdd( "inv_knife", "spr_deploy_inv_oldchest_knife" );

      ObjDelete( "gfx_deploy_inv_oldchest_knife" );
      ObjDelete( "spr_deploy_inv_oldchest_knife_shadow" );
      ObjDelete( "spr_oldchest_knife" );
      ObjSet( "inv_burntbag_plus_focus2", { alp = 1 } );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_knife", get_knife_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_oldchest" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_oldchest_clk",
      room = "int_deploy_inv",
      zz = "deploy_inv_oldchest",
      zz_gate = "inv_oldchest"
    };
    -------------------------------------------------------------------------------------------
    function clk_oldchest_inv ()

      ObjSet( "obj_oldchest_open", { alp = 1 } );
      ObjSet( "inv_oldchest", { res = "assets/levels/level2/common_inventory2/inv_oldchest/inv/inv_oldchest_open" } );

    end;
    function clk_oldchest_beg ()

      ObjDelete( "obj_deploy_inv_oldchest_clk" );

    end;
    function clk_oldchest_end ()

      ObjSet( "spr_deploy_inv_oldchest_ambereye_1", { active = true, input = true } );
      ObjSet( "spr_deploy_inv_oldchest_knife",      { active = true, input = true } );
      ObjSet( "spr_deploy_inv_oldchest_cup_open",   { alp = 1 } );
      ObjDelete( "spr_deploy_inv_oldchest_cup_close" );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_oldchest", clk_oldchest_inv );
    cmn.AddSubscriber( "clk_oldchest", clk_oldchest_beg, "inv_oldchest" );
    cmn.AddSubscriber( "clk_oldchest", clk_oldchest_end, "inv_oldchest" );
    cmn.AddSubscriber( "clk_oldchest_inv", clk_oldchest_inv );
    cmn.AddSubscriber( "clk_oldchest_beg", clk_oldchest_beg, "inv_oldchest" );
    cmn.AddSubscriber( "clk_oldchest_end", clk_oldchest_end, "inv_oldchest" );
    -------------------------------------------------------------------------------------------  

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.get_ambereye_1 ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_ambereye_1" );
    cmn.CallEventHandler( "get_ambereye_1", "inv_oldchest" );

    if cmn.IsEventDone( "get_knife" ) then

      int.DeployInvHide();

    end;

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.get_knife ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_knife" );
    cmn.CallEventHandler( "get_knife", "inv_oldchest" );

    if cmn.IsEventDone( "get_ambereye_1" ) then

      int.DeployInvHide();

    end;

  end;
  --*********************************************************************************************************************
  function private.clk_oldchest ()

    cmn.CallEventHandler( "clk_oldchest_inv", "inv_oldchest" );
    cmn.CallEventHandler( "clk_oldchest_beg", "inv_oldchest" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_oldchest" );
      cmn.CallEventHandler( "clk_oldchest_end", "inv_oldchest" );
    
    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_chest_open" );
    ObjAnimate( "spr_deploy_inv_oldchest_cup_close", "alp", 0, 0, "", 
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );

    ObjAnimate( "spr_deploy_inv_oldchest_cup_open", "alp", 0, 0, func_end, 
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** wrappeditem *** ()
--*********************************************************************************************************************
  function private.wrappeditem_init ()

    ObjSet( "spr_deploy_inv_wrappeditem_catamulet",       { event_mdown = private.get_catamulet } );
    ObjSet( "obj_deploy_inv_wrappeditem_clk_1",           { event_mdown = private.clk_wrappeditem_1 } );
    ObjSet( "obj_deploy_inv_wrappeditem_clk_2",           { event_mdown = private.clk_wrappeditem_2 } );
    ObjSet( "obj_deploy_inv_wrappeditem_clk_3",           { event_mdown = private.clk_wrappeditem_3 } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_catamulet" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_wrappeditem_catamulet",
      room = "int_deploy_inv",
      zz = "deploy_inv_wrappeditem",
      zz_gate = "inv_wrappeditem"
    };
    -------------------------------------------------------------------------------------------
    function get_catamulet_inv ()

      interface.InventoryItemRemove( "inv_wrappeditem" );
      interface.InventoryItemAdd( "inv_catamulet", "spr_deploy_inv_wrappeditem_catamulet" );

      ObjDelete( "gfx_deploy_inv_wrappeditem_catamulet" );
      ObjDelete( "spr_deploy_inv_wrappeditem_catamulet_shadow" );
      ObjDelete( "spr_wrappeditem_catamulet" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_catamulet", get_catamulet_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_wrappeditem_1" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_wrappeditem_clk_1",
      room = "int_deploy_inv",
      zz = "deploy_inv_wrappeditem",
      zz_gate = "inv_wrappeditem"
    };
    -------------------------------------------------------------------------------------------
    function clk_wrappeditem_1_inv ()

      ObjSet( "inv_wrappeditem", { res = "assets/levels/level2/common_inventory2/inv_wrappeditem/inv/inv_wrappeditem_1" } );

    end;
    function clk_wrappeditem_1_beg ()

      ObjDelete( "obj_deploy_inv_wrappeditem_clk_1" );

    end;
    function clk_wrappeditem_1_end ()

      ObjSet( "obj_deploy_inv_wrappeditem_clk_2", { input = true } );
      ObjSet( "spr_deploy_inv_wrappeditem_rag_1", { alp = 1 } );
      ObjDelete( "spr_deploy_inv_wrappeditem_rag" );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_wrappeditem_1", clk_wrappeditem_1_inv );
    cmn.AddSubscriber( "clk_wrappeditem_1", clk_wrappeditem_1_beg, "inv_wrappeditem" );
    cmn.AddSubscriber( "clk_wrappeditem_1", clk_wrappeditem_1_end, "inv_wrappeditem" );
    cmn.AddSubscriber( "clk_wrappeditem_1_inv", clk_wrappeditem_1_inv );
    cmn.AddSubscriber( "clk_wrappeditem_1_beg", clk_wrappeditem_1_beg, "inv_wrappeditem" );
    cmn.AddSubscriber( "clk_wrappeditem_1_end", clk_wrappeditem_1_end, "inv_wrappeditem" );
    -------------------------------------------------------------------------------------------  
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_wrappeditem_2" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_wrappeditem_clk_2",
      room = "int_deploy_inv",
      zz = "deploy_inv_wrappeditem",
      zz_gate = "inv_wrappeditem"
    };
    -------------------------------------------------------------------------------------------
    function clk_wrappeditem_2_inv ()

      ObjSet( "inv_wrappeditem", { res = "assets/levels/level2/common_inventory2/inv_wrappeditem/inv/inv_wrappeditem_2" } );

    end;
    function clk_wrappeditem_2_beg ()

      ObjDelete( "obj_deploy_inv_wrappeditem_clk_2" );

    end;
    function clk_wrappeditem_2_end ()

      ObjSet( "obj_deploy_inv_wrappeditem_clk_3", { input = true } );
      ObjSet( "spr_deploy_inv_wrappeditem_rag_2", { alp = 1 } );
      ObjDelete( "spr_deploy_inv_wrappeditem_rag_1" );

    end;
    -------------------------------------------------------------------------------------------  
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_wrappeditem_2", clk_wrappeditem_2_inv );
    cmn.AddSubscriber( "clk_wrappeditem_2", clk_wrappeditem_2_beg, "inv_wrappeditem" );
    cmn.AddSubscriber( "clk_wrappeditem_2", clk_wrappeditem_2_end, "inv_wrappeditem" );
    cmn.AddSubscriber( "clk_wrappeditem_2_inv", clk_wrappeditem_2_inv );
    cmn.AddSubscriber( "clk_wrappeditem_2_beg", clk_wrappeditem_2_beg, "inv_wrappeditem" );
    cmn.AddSubscriber( "clk_wrappeditem_2_end", clk_wrappeditem_2_end, "inv_wrappeditem" );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_wrappeditem_3" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_wrappeditem_clk_3",
      room = "int_deploy_inv",
      zz = "deploy_inv_wrappeditem",
      zz_gate = "inv_wrappeditem"
    };
    -------------------------------------------------------------------------------------------
    function clk_wrappeditem_3_inv ()

      ObjSet( "inv_wrappeditem", { res = "assets/levels/level2/common_inventory2/inv_wrappeditem/inv/inv_wrappeditem_3" } );
      ObjSet( "obj_wrappeditem_open", { alp = 1 } );

    end;
    function clk_wrappeditem_3_beg ()

      ObjDelete( "obj_deploy_inv_wrappeditem_clk_3" );

    end;
    function clk_wrappeditem_3_end ()

      ObjSet( "obj_deploy_inv_wrappeditem_rag_3",          { alp = 1 } );
      ObjSet( "spr_deploy_inv_wrappeditem_catamulet",      { active = true, input = true } );
      ObjDelete( "spr_deploy_inv_wrappeditem_rag_2" );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_wrappeditem_3", clk_wrappeditem_3_inv );
    cmn.AddSubscriber( "clk_wrappeditem_3", clk_wrappeditem_3_beg, "inv_wrappeditem" );
    cmn.AddSubscriber( "clk_wrappeditem_3", clk_wrappeditem_3_end, "inv_wrappeditem" );
    cmn.AddSubscriber( "clk_wrappeditem_3_inv", clk_wrappeditem_3_inv );
    cmn.AddSubscriber( "clk_wrappeditem_3_beg", clk_wrappeditem_3_beg, "inv_wrappeditem" );
    cmn.AddSubscriber( "clk_wrappeditem_3_end", clk_wrappeditem_3_end, "inv_wrappeditem" );
    ------------------------------------------------------------------------------------------- 

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.get_catamulet ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_catamulet" );
    cmn.CallEventHandler( "get_catamulet", "inv_wrappeditem" );

    int.DeployInvHide();

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.clk_wrappeditem_1 ()

    cmn.CallEventHandler( "clk_wrappeditem_1_inv", "inv_wrappeditem" );
    cmn.CallEventHandler( "clk_wrappeditem_1_beg", "inv_wrappeditem" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_wrappeditem_1" );
      cmn.CallEventHandler( "clk_wrappeditem_1_end", "inv_wrappeditem" );
    
    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_take_from_cloth1" );
    ObjAnimate( "spr_deploy_inv_wrappeditem_rag", "alp", 0, 0, "", 
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );

    ObjAnimate( "spr_deploy_inv_wrappeditem_rag_1", "alp", 0, 0, func_end, 
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;
  --*********************************************************************************************************************
  function private.clk_wrappeditem_2 ()

    cmn.CallEventHandler( "clk_wrappeditem_2_inv", "inv_wrappeditem" );
    cmn.CallEventHandler( "clk_wrappeditem_2_beg", "inv_wrappeditem" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_wrappeditem_2" );
      cmn.CallEventHandler( "clk_wrappeditem_2_end", "inv_wrappeditem" );
    
    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_take_from_cloth2" );
    ObjAnimate( "spr_deploy_inv_wrappeditem_rag_1", "alp", 0, 0, "", 
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );

    ObjAnimate( "spr_deploy_inv_wrappeditem_rag_2", "alp", 0, 0, func_end, 
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;
  --*********************************************************************************************************************
  function private.clk_wrappeditem_3 ()

    cmn.CallEventHandler( "clk_wrappeditem_3_inv", "inv_wrappeditem" );
    cmn.CallEventHandler( "clk_wrappeditem_3_beg", "inv_wrappeditem" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_wrappeditem_3" );
      cmn.CallEventHandler( "clk_wrappeditem_3_end", "inv_wrappeditem" );
    
    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_take_from_cloth3" );
    ObjAnimate( "spr_deploy_inv_wrappeditem_rag_2", "alp", 0, 0, "", 
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );

    ObjAnimate( "obj_deploy_inv_wrappeditem_rag_3", "alp", 0, 0, func_end, 
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** fork *** ()
--*********************************************************************************************************************
  function private.fork_init ()

    ObjSet( "spr_deploy_inv_fork_twotinedfork",  { event_mdown = private.get_twotinedfork } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_twotinedfork" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_fork_twotinedfork",
      room = "int_deploy_inv",
      zz = "deploy_inv_fork",
      zz_gate = "inv_fork"
    };
    -------------------------------------------------------------------------------------------
    function get_twotinedfork_inv ()

      interface.InventoryItemRemove( "inv_fork" );
      interface.InventoryItemAdd( "inv_twotinedfork", "spr_deploy_inv_fork_twotinedfork" );

      ObjDelete( "gfx_deploy_inv_fork_twotinedfork" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_twotinedfork", get_twotinedfork_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_pliers2" ] =
    {
      type = "use",
      use_obj = "inv_pliers2",
      use_place = "obj_deploy_inv_fork_use_pliers2",
      room = "int_deploy_inv",
      zz = "deploy_inv_fork",
      zz_gate = "inv_fork"
    };
    -------------------------------------------------------------------------------------------
    function use_pliers2_inv ()
  
      interface.InventoryItemRemove( "inv_pliers2" );
      ObjSet( "inv_fork", { res = "assets/levels/level2/common_inventory2/inv_fork/inv/inv_twotinedfork" } );

    end;
    function use_pliers2_beg ()

      ObjDelete( "obj_deploy_inv_fork_use_pliers2" );

    end;
    function use_pliers2_end ()

      ObjSet( "spr_deploy_inv_fork_twotinedfork", { active = true, input = true } );
      ObjDelete( "anm_deploy_inv_fork_use_pliers" );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_pliers2", use_pliers2_beg, "inv_fork" );
    cmn.AddSubscriber( "use_pliers2", use_pliers2_inv );
    cmn.AddSubscriber( "use_pliers2", use_pliers2_end, "inv_fork" );
    cmn.AddSubscriber( "use_pliers2_inv", use_pliers2_inv );
    cmn.AddSubscriber( "use_pliers2_beg", use_pliers2_beg, "inv_fork" );
    cmn.AddSubscriber( "use_pliers2_end", use_pliers2_end, "inv_fork" );
    -------------------------------------------------------------------------------------------

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.get_twotinedfork ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_twotinedfork" );
    cmn.CallEventHandler( "get_twotinedfork", "inv_fork" );

    int.DeployInvHide();

  end;
--*********************************************************************************************************************
  function public.use_pliers2 ()

    local item = "inv_pliers2";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_fork_use_pliers2" ) ) then

      cmn.CallEventHandler( "use_pliers2_inv" );
      cmn.CallEventHandler( "use_pliers2_beg", "inv_fork" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_pliers2" );
        cmn.CallEventHandler( "use_pliers2_end", "inv_fork" );
      
      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_pliers" );
      AnimPlay( "anm_deploy_inv_fork_use_pliers", "DoAnim", func_end);

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** brokenbutterfly *** ()
--*********************************************************************************************************************
  function private.brokenbutterfly_init ()

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_butterfly" ] =
    {
      type = "get",
      get_obj = "obj_deploy_inv_brokenbutterfly",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenbutterfly",
      zz_gate = "inv_brokenbutterfly"
    };
    -------------------------------------------------------------------------------------------
    function get_butterfly_inv ()

      interface.InventoryItemRemove( "inv_brokenbutterfly" );
      interface.InventoryItemAdd( "inv_butterfly", "obj_deploy_inv_brokenbutterfly", "assets/levels/level2/common_inventory2/inv_brokenbutterfly/inv/inv_butterfly_morph" );

      ObjDelete( "gfx_deploy_inv_brokenbutterfly_butterfly" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_butterfly", get_butterfly_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_butterflypart_1" ] =
    {
      type = "use",
      use_obj = "inv_butterflypart_1",
      use_place = "obj_deploy_inv_brokenbutterfly_use_part",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenbutterfly",
      zz_gate = "inv_brokenbutterfly"
    };
    -------------------------------------------------------------------------------------------
    function use_butterflypart_1_inv ()
  
      interface.InventoryItemRemove( "inv_butterflypart_1" );
      ObjSet( "spr_butterfly_butterflypart1", { alp = 1 } );

      if ( ( cmn.IsEventDone( "get_butterflypart_2" ) and not cmn.IsEventDone( "use_butterflypart_2" ) ) or
           ( cmn.IsEventDone( "get_butterflypart_3" ) and not cmn.IsEventDone( "use_butterflypart_3" ) ) ) then

        ObjSet( "inv_brokenbutterfly_plus_focus2", { alp = 1 } );

      elseif cmn.IsEventDone( "use_butterflypart_2" ) and cmn.IsEventDone( "use_butterflypart_3" ) then

        ObjSet( "inv_brokenbutterfly_plus_focus2", { alp = 1 } );

      else 

        ObjSet( "inv_brokenbutterfly_plus_focus2", { alp = 0 } );

      end;

    end;
    function use_butterflypart_1_beg ()

    end;
    function use_butterflypart_1_end ()

      ObjSet( "spr_deploy_inv_brokenbutterfly_butterflypart_1", { alp = 1 } );

      if ( cmn.IsEventDone( "use_butterflypart_1" ) and
           cmn.IsEventDone( "use_butterflypart_2" ) and 
           cmn.IsEventDone( "use_butterflypart_3" ) ) then 

        ObjSet( "obj_deploy_inv_brokenbutterfly_use_part", { event_mdown = function () private.get_butterfly() end, event_menter = function () cmn.SetCursor( CURSOR_GET ); end } );
        ObjSet( "gfx_deploy_inv_brokenbutterfly_butterfly", { active = true } );

      end;

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_butterflypart_1", use_butterflypart_1_beg, "inv_brokenbutterfly" );
    cmn.AddSubscriber( "use_butterflypart_1", use_butterflypart_1_inv );
    cmn.AddSubscriber( "use_butterflypart_1", use_butterflypart_1_end, "inv_brokenbutterfly" );
    cmn.AddSubscriber( "use_butterflypart_1_inv", use_butterflypart_1_inv );
    cmn.AddSubscriber( "use_butterflypart_1_beg", use_butterflypart_1_beg, "inv_brokenbutterfly" );
    cmn.AddSubscriber( "use_butterflypart_1_end", use_butterflypart_1_end, "inv_brokenbutterfly" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_butterflypart_2" ] =
    {
      type = "use",
      use_obj = "inv_butterflypart_2",
      use_place = "obj_deploy_inv_brokenbutterfly_use_part",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenbutterfly",
      zz_gate = "inv_brokenbutterfly"
    };
    -------------------------------------------------------------------------------------------
    function use_butterflypart_2_inv ()
  
      interface.InventoryItemRemove( "inv_butterflypart_2" );
      ObjSet( "spr_butterfly_butterflypart2", { alp = 1 } );

      if ( ( cmn.IsEventDone( "get_butterflypart_1" ) and not cmn.IsEventDone( "use_butterflypart_1" ) ) or
           ( cmn.IsEventDone( "get_butterflypart_3" ) and not cmn.IsEventDone( "use_butterflypart_3" ) ) ) then

        ObjSet( "inv_brokenbutterfly_plus_focus2", { alp = 1 } );

      elseif cmn.IsEventDone( "use_butterflypart_1" ) and cmn.IsEventDone( "use_butterflypart_3" ) then

        ObjSet( "inv_brokenbutterfly_plus_focus2", { alp = 1 } );

      else 

        ObjSet( "inv_brokenbutterfly_plus_focus2", { alp = 0 } );

      end;

    end;
    function use_butterflypart_2_beg ()

    end;
    function use_butterflypart_2_end ()

      ObjSet( "spr_deploy_inv_brokenbutterfly_butterflypart_2", { alp = 1 } );

      if ( cmn.IsEventDone( "use_butterflypart_1" ) and
           cmn.IsEventDone( "use_butterflypart_3" ) ) then 

        ObjSet( "obj_deploy_inv_brokenbutterfly_use_part", { event_mdown = function () private.get_butterfly() end, event_menter = function () cmn.SetCursor( CURSOR_GET ); end } );
        ObjSet( "gfx_deploy_inv_brokenbutterfly_butterfly", { active = true } );

      end;

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_butterflypart_2", use_butterflypart_2_beg, "inv_brokenbutterfly" );
    cmn.AddSubscriber( "use_butterflypart_2", use_butterflypart_2_inv );
    cmn.AddSubscriber( "use_butterflypart_2", use_butterflypart_2_end, "inv_brokenbutterfly" );
    cmn.AddSubscriber( "use_butterflypart_2_inv", use_butterflypart_2_inv );
    cmn.AddSubscriber( "use_butterflypart_2_beg", use_butterflypart_2_beg, "inv_brokenbutterfly" );
    cmn.AddSubscriber( "use_butterflypart_2_end", use_butterflypart_2_end, "inv_brokenbutterfly" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_butterflypart_3" ] =
    {
      type = "use",
      use_obj = "inv_butterflypart_3",
      use_place = "obj_deploy_inv_brokenbutterfly_use_part",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenbutterfly",
      zz_gate = "inv_brokenbutterfly"
    };
    -------------------------------------------------------------------------------------------
    function use_butterflypart_3_inv ()

      interface.InventoryItemRemove( "inv_butterflypart_3" );
      ObjSet( "spr_butterfly_butterflypart3", { alp = 1 } );

      if ( ( cmn.IsEventDone( "get_butterflypart_1" ) and not cmn.IsEventDone( "use_butterflypart_1" ) ) or
           ( cmn.IsEventDone( "get_butterflypart_2" ) and not cmn.IsEventDone( "use_butterflypart_2" ) ) ) then

        ObjSet( "inv_brokenbutterfly_plus_focus2", { alp = 1 } );

      elseif cmn.IsEventDone( "use_butterflypart_1" ) and cmn.IsEventDone( "use_butterflypart_2" ) then

        ObjSet( "inv_brokenbutterfly_plus_focus2", { alp = 1 } );

      else 

        ObjSet( "inv_brokenbutterfly_plus_focus2", { alp = 0 } );

      end;

    end;
    function use_butterflypart_3_beg ()

    end;
    function use_butterflypart_3_end ()

      ObjSet( "spr_deploy_inv_brokenbutterfly_butterflypart_3", { alp = 1 } );

      if ( cmn.IsEventDone( "use_butterflypart_1" ) and
           cmn.IsEventDone( "use_butterflypart_2" ) and 
           cmn.IsEventDone( "use_butterflypart_3" ) ) then 

        ObjSet( "obj_deploy_inv_brokenbutterfly_use_part", { event_mdown = function () private.get_butterfly() end, event_menter = function () cmn.SetCursor( CURSOR_GET ); end } );
        ObjSet( "gfx_deploy_inv_brokenbutterfly_butterfly", { active = true } );

      end;

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_butterflypart_3", use_butterflypart_3_beg, "inv_brokenbutterfly" );
    cmn.AddSubscriber( "use_butterflypart_3", use_butterflypart_3_inv );
    cmn.AddSubscriber( "use_butterflypart_3", use_butterflypart_3_end, "inv_brokenbutterfly" );
    cmn.AddSubscriber( "use_butterflypart_3_inv", use_butterflypart_3_inv );
    cmn.AddSubscriber( "use_butterflypart_3_beg", use_butterflypart_3_beg, "inv_brokenbutterfly" );
    cmn.AddSubscriber( "use_butterflypart_3_end", use_butterflypart_3_end, "inv_brokenbutterfly" );
    -------------------------------------------------------------------------------------------

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.get_butterfly ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_butterfly" );
    cmn.CallEventHandler( "get_butterfly", "inv_brokenbutterfly" );

    int.DeployInvHide();

  end;
--*********************************************************************************************************************
  function public.use_butterflypart_1 ()

    local item = "inv_butterflypart_1";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_brokenbutterfly_use_part" ) ) then

      cmn.CallEventHandler( "use_butterflypart_1_inv" );
      cmn.CallEventHandler( "use_butterflypart_1_beg", "inv_brokenbutterfly" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_butterflypart_1" );
        cmn.CallEventHandler( "use_butterflypart_1_end", "inv_brokenbutterfly" );
      
      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_baterfly_assembly" );
      ObjAnimate( "spr_deploy_inv_brokenbutterfly_butterflypart_1", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
  function public.use_butterflypart_2 ()

    local item = "inv_butterflypart_2";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_brokenbutterfly_use_part" ) ) then

      cmn.CallEventHandler( "use_butterflypart_2_inv" );
      cmn.CallEventHandler( "use_butterflypart_2_beg", "inv_brokenbutterfly" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_butterflypart_2" );
        cmn.CallEventHandler( "use_butterflypart_2_end", "inv_brokenbutterfly" );
      
      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_baterfly_assembly" );
      ObjAnimate( "spr_deploy_inv_brokenbutterfly_butterflypart_2", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );

      return true;

    end;

    return false;

  end;

--*********************************************************************************************************************
--*********************************************************************************************************************
  function public.use_butterflypart_3 ()

    local item = "inv_butterflypart_3";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_brokenbutterfly_use_part" ) ) then

      cmn.CallEventHandler( "use_butterflypart_3_inv" );
      cmn.CallEventHandler( "use_butterflypart_3_beg", "inv_brokenbutterfly" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_butterflypart_3" );
        cmn.CallEventHandler( "use_butterflypart_3_end", "inv_brokenbutterfly" );
      
      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_baterfly_assembly" );
      ObjAnimate( "spr_deploy_inv_brokenbutterfly_butterflypart_3", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** burntbag *** ()
--*********************************************************************************************************************
  function private.burntbag_init ()

    ObjSet( "spr_deploy_inv_burntbag_toggleswitch_2", { event_mdown = private.get_toggleswitch_2 } );
    ObjSet( "spr_deploy_inv_burntbag_electricplug",   { event_mdown = private.get_electricplug } );
    ObjSet( "spr_deploy_inv_burntbag_fuse_2",         { event_mdown = private.get_fuse_2 } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_toggleswitch_2" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_burntbag_toggleswitch_2",
      room = "int_deploy_inv",
      zz = "deploy_inv_burntbag",
      zz_gate = "inv_burntbag"
    };
    -------------------------------------------------------------------------------------------
    function get_toggleswitch_2_inv ()

      interface.InventoryItemAdd( "inv_toggleswitch_2", "spr_deploy_inv_burntbag_toggleswitch_2" );

      ObjDelete( "gfx_deploy_inv_burntbag_toggleswitch_2" );
      ObjDelete( "spr_deploy_inv_burntbag_toggleswitch_2_shadow" );
      ObjSet( "obj_deploy_inv_burntbag_use_knife", { input = true } );
      ObjDelete( "spr_burntbag_toggleswitch_2" );

      if ( not cmn.IsEventDone( "get_knife" ) ) then

        ObjSet( "inv_burntbag_plus_focus2", { alp = 0 } );

      end;

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_toggleswitch_2", get_toggleswitch_2_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_fuse_2" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_burntbag_fuse_2",
      room = "int_deploy_inv",
      zz = "deploy_inv_burntbag",
      zz_gate = "inv_burntbag"
    };
    -------------------------------------------------------------------------------------------
    function get_fuse_2_inv ()

      if ( cmn.IsEventDone( "get_electricplug" ) ) then

        interface.InventoryItemRemove( "inv_burntbag" );

      end;

      interface.InventoryItemAdd( "inv_fuse_1", "spr_deploy_inv_burntbag_fuse_2" );
      --level2_inv.CheckFuse();

      ObjDelete( "gfx_deploy_inv_burntbag_fuse_2" );
      ObjDelete( "spr_deploy_inv_burntbag_fuse_2_shadow" );
      ObjDelete( "spr_burntbag_fuse_2" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_fuse_2", get_fuse_2_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_electricplug" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_burntbag_electricplug",
      room = "int_deploy_inv",
      zz = "deploy_inv_burntbag",
      zz_gate = "inv_burntbag"
    };
    -------------------------------------------------------------------------------------------
    function get_electricplug_inv ()

      if ( cmn.IsEventDone( "get_fuse_2" ) ) then

        interface.InventoryItemRemove( "inv_burntbag" );

      end;

      interface.InventoryItemAdd( "inv_electricplug", "spr_deploy_inv_burntbag_electricplug" );

      ObjDelete( "gfx_deploy_inv_burntbag_electricplug" );
      ObjDelete( "spr_deploy_inv_burntbag_electricplug_shadow" );
      ObjDelete( "spr_burntbag_electricplug" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_electricplug", get_electricplug_inv );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_knife" ] =
    {
      type = "use",
      use_obj = "inv_knife",
      use_place = "obj_deploy_inv_burntbag_use_knife",
      room = "int_deploy_inv",
      zz = "deploy_inv_burntbag",
      zz_gate = "inv_burntbag"
    };
    -------------------------------------------------------------------------------------------
    function use_knife_inv ()
  
      interface.InventoryItemRemove( "inv_knife" );
      ObjSet( "spr_burntbag_open", { alp = 1 } );

    end;
    function use_knife_beg ()

      ObjDelete( "obj_deploy_inv_burntbag_use_knife" );

    end;
    function use_knife_end ()

      ObjSet( "spr_deploy_inv_burntbag_fuse_2",       { active = true, input = true } );
      ObjSet( "spr_deploy_inv_burntbag_electricplug", { active = true, input = true } );
      ObjSet( "obj_deploy_inv_burntbag_open",         { alp = 1 } );
      ObjDelete( "anm_deploy_inv_burntbag_use_knife" );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_knife", use_knife_beg, "inv_burntbag" );
    cmn.AddSubscriber( "use_knife", use_knife_inv );
    cmn.AddSubscriber( "use_knife", use_knife_end, "inv_burntbag" );
    cmn.AddSubscriber( "use_knife_inv", use_knife_inv );
    cmn.AddSubscriber( "use_knife_beg", use_knife_beg, "inv_burntbag" );
    cmn.AddSubscriber( "use_knife_end", use_knife_end, "inv_burntbag" );
    -------------------------------------------------------------------------------------------  

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.get_toggleswitch_2 ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_toggleswitch_2" );
    cmn.CallEventHandler( "get_toggleswitch_2", "inv_burntbag" );

    --int.DeployInvHide();

  end;
  --*********************************************************************************************************************
  function private.get_fuse_2 ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_fuse_2" );
    cmn.CallEventHandler( "get_fuse_2", "inv_burntbag" );

    if ( cmn.IsEventDone( "get_electricplug" ) ) then

      int.DeployInvHide();

    end;

  end;
  --*********************************************************************************************************************
  function private.get_electricplug ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_electricplug" );
    cmn.CallEventHandler( "get_electricplug", "inv_burntbag" );

    if ( cmn.IsEventDone( "get_fuse_2" ) ) then

      int.DeployInvHide();

    end;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function public.use_knife ()

    local item = "inv_knife";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_burntbag_use_knife" ) ) then

      cmn.CallEventHandler( "use_knife_inv" );
      cmn.CallEventHandler( "use_knife_beg", "inv_burntbag" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_knife" );
        cmn.CallEventHandler( "use_knife_end", "inv_burntbag" );
      
      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_tear_bag" );
      AnimPlay( "anm_deploy_inv_burntbag_use_knife", "DoAnim", func_end );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** switchroomplan *** ()
--*********************************************************************************************************************
  function private.switchroomplan_init ()

    ObjSet( "spr_deploy_inv_switchroomplan_plan",  { event_mdown = private.get_plan } );
    ObjSet( "obj_deploy_inv_switchroomplan_clk",  { event_mdown = private.clk_switchroomplan } );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_plan" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_switchroomplan_plan",
      room = "int_deploy_inv",
      zz = "deploy_inv_switchroomplan",
      zz_gate = "inv_switchroomplan"
    };
    -------------------------------------------------------------------------------------------
    function get_plan_inv ()

      interface.InventoryItemRemove( "inv_switchroomplan" );
      interface.InventoryItemAdd( "inv_plan", "spr_deploy_inv_switchroomplan_plan" );

      ObjDelete( "gfx_deploy_inv_switchroomplan_plan" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_plan", get_plan_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_switchroomplan" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_switchroomplan_clk",
      room = "int_deploy_inv",
      zz = "deploy_inv_switchroomplan",
      zz_gate = "inv_switchroomplan"
    };
    -------------------------------------------------------------------------------------------
    function clk_switchroomplan_inv ()

      ObjSet( "inv_switchroomplan", { res = "assets/levels/level2/common_inventory2/inv_switchroomplan/inv/inv_plan" } );

    end;
    function clk_switchroomplan_beg ()

      ObjDelete( "obj_deploy_inv_switchroomplan_clk" );

    end;
    function clk_switchroomplan_end ()

      ObjSet( "spr_deploy_inv_switchroomplan_plan",      { active = true, input = true } );
      ObjSet( "obj_deploy_inv_switchroomplan_plan_open", { alp = 1 } );
      ObjDelete( "spr_deploy_inv_switchroomplan_plan_close" );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_switchroomplan", clk_switchroomplan_inv );
    cmn.AddSubscriber( "clk_switchroomplan", clk_switchroomplan_beg, "inv_switchroomplan" );
    cmn.AddSubscriber( "clk_switchroomplan", clk_switchroomplan_end, "inv_switchroomplan" );
    cmn.AddSubscriber( "clk_switchroomplan_inv", clk_switchroomplan_inv );
    cmn.AddSubscriber( "clk_switchroomplan_beg", clk_switchroomplan_beg, "inv_switchroomplan" );
    cmn.AddSubscriber( "clk_switchroomplan_end", clk_switchroomplan_end, "inv_switchroomplan" );
    -------------------------------------------------------------------------------------------  

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.get_plan ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_plan" );
    cmn.CallEventHandler( "get_plan", "inv_switchroomplan" );

    int.DeployInvHide();
    
    if cmn.IsEventDone( "get_plan" ) and not cmn.IsEventDone( "use_plan" ) and
      common.GetCurrentRoom() == "rm_switchroom" then
      
      ObjSet( "tmr_port_tap_down", { time = 1.5, playing = 1, endtrig = function()
        rm_switchroom.use_plan();
      end  } );

    end;

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.clk_switchroomplan ()

    cmn.CallEventHandler( "clk_switchroomplan_inv", "inv_switchroomplan" );
    cmn.CallEventHandler( "clk_switchroomplan_beg", "inv_switchroomplan" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_switchroomplan" );
      cmn.CallEventHandler( "clk_switchroomplan_end", "inv_switchroomplan" );
    
    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_unpaper" );
    ObjAnimate( "spr_deploy_inv_switchroomplan_plan_close", "alp", 0, 0, "", 
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );

    ObjAnimate( "obj_deploy_inv_switchroomplan_plan_open", "alp", 0, 0, func_end, 
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.CheckDoordowel ()

  local path = "inv_doordowel_1";

  if ( cmn.IsEventDone( "get_doordowel_1" ) and cmn.IsEventDone( "get_doordowel_2" ) ) then

    path = "inv_doordowel_2";

  end;

  ObjSet( "inv_doordowel_1", { res = "assets/levels/level2/rm_kitchen/zz_shelvesonwall/inv/"..path } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.CheckHand ()

  local path = "inv_hand_1";

  if ( cmn.IsEventDone( "get_hand_1" ) and cmn.IsEventDone( "get_hand_2" ) ) then

    path = "inv_hand_2";

  end;

  ObjSet( "inv_hand_1", { res = "assets/levels/level2/rm_kitchen/zz_flower/inv/"..path } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--function public.CheckFuse ()
--
--  local path = "inv_fuse_1";
--
--  if ( cmn.IsEventDone( "get_fuse_1" ) and cmn.IsEventDone( "get_fuse_2" ) ) then
--
--    path = "inv_fuse_2";
--
--  end;
--
--  ObjSet( "inv_fuse_1", { res = "assets/levels/level2/rm_yard/zz_icecreamvendor/inv/"..path } );
--
--end;
--*********************************************************************************************************************
--*** function *** MMG BROKENELECTRICSCREWDRIVER *** () end;
--*********************************************************************************************************************

  function private.ScrewdriverInit ()

    ObjMultiSet( {
      { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_brown", { 
          input = true,
          drag = true,
          event_startdrag = function () private.ScrewdriverPartPick( "brown" ); end,
          event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
          event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end ,
          event_dragdrop = function () private.ScrewdriverPartUse( "brown" ); end
      } },
      { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_yellow", { 
          input = true,
          drag = true,
          event_startdrag = function () private.ScrewdriverPartPick( "yellow" ); end,
          event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
          event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
          event_dragdrop = function () private.ScrewdriverPartUse( "yellow" ); end 
      } },
      { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_purple", { 
          input = true,
          drag = true,
          event_startdrag = function () private.ScrewdriverPartPick( "purple" ); end,
          event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
          event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
          event_dragdrop = function () private.ScrewdriverPartUse( "purple" ); end 
      } },
      { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_wire", { 
          input = true,
          drag = true,
          event_startdrag = function () private.ScrewdriverPartPick( "wire" ); end,
          event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
          event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
          event_dragdrop = function () private.ScrewdriverPartUse( "wire" ); end 
      } },
      { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_cord_broken", { 
          input = true,
          event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
          event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
          event_mdown = function () private.ScrewdriverCordClick(); end, 
      } },
      { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_arrow", { 
          input = true,
          event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
          event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
          event_mdown = function () private.ScrewdriverArrowClick(); end 
      } },
      { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_light_1", { 
          input = true,
          event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
          event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
          event_mdown = function () private.ScrewdriverLightClick( 1 ); end, 
      } },
      { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_light_2", { 
          input = true,
          event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
          event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
          event_mdown = function () private.ScrewdriverLightClick( 2 ); end, 
      } },
      { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_light_3", { 
          input = true,
          event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
          event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
          event_mdown = function () private.ScrewdriverLightClick( 3 ); end, 
      } },
    } );

    private.pos_z = 0;
    private.init_ar_ang = 0;
    private.init_cur_pos = {0,0};
    private.arrow_ang = 0;  
    private.parts_used = {
      ["brown"] = 0,
      ["yellow"] = 0,
      ["purple"] = 0,
      ["wire"] = 0,
      ["cord"] = 0,
      ["arrow"] = 0
    };
    private.lights = {0,0,0}; 

    int_deploy_inv.Define( "brokenelectricscrewdriver" );

    --*********************************************************************************************************************
    function brokenelectricscrewdriver.Reset ()

      ObjMultiSet( {
        { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_arrow", { ang = 0, input = true } },
        { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_brown_shadow", { alp = 0 } },
        { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_brown", { alp = 1, input = true } },
        { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_cord_broken", { alp = 1 , input = true } },
        { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_brown_placed", { alp = 0 } },
        { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_cord_fixed", { alp = 0 } },
        { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_purple_shadow", { alp = 0 } },
        { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_wire_shadow", { alp = 0 } },
        { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_light_1", { alp = 0 } },
        { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_light_2", { alp = 0 } },
        { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_light_3", { alp = 0 } },
        { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_purple", { alp = 1, input = true } },
        { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_wire", { alp = 1, input = true } },
        { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_yellow", { alp = 1, input = true } },
        { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_purple_placed", { alp = 0 } },
        { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_wire_placed", { alp = 0 } },
        { "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_yellow_placed", { alp = 0 } }
      } );

      ng_global.progress[ "std" ][ "win_brokenelectricscrewdriver" ].parts_used = {
        ["brown"] = 0,
        ["yellow"] = 0,
        ["purple"] = 0,
        ["wire"] = 0,
        ["cord"] = 0,
        ["arrow"] = 0
      };
      ng_global.progress[ "std" ][ "win_brokenelectricscrewdriver" ].lights = {0,0,0};      

      private.parts_used = {
        ["brown"] = 0,
        ["yellow"] = 0,
        ["purple"] = 0,
        ["wire"] = 0,
        ["cord"] = 0,
        ["arrow"] = 0
      };
      private.lights = {0,0,0};

    end;
    --*********************************************************************************************************************
    function brokenelectricscrewdriver.Skip ()

      private.ScrewdriverAnimWin();

    end;

  end;
--*********************************************************************************************************************
  function private.ScrewdriverStart ()

    local func_end = function ()

       cmn.MiniGameShow( "brokenelectricscrewdriver" );
       --common_impl.PassingMgStart( "brokenelectricscrewdriver" );

        ng_global.progress[ "std" ][ "win_brokenelectricscrewdriver" ].parts_used = {
          ["brown"] = 0,
          ["yellow"] = 0,
          ["purple"] = 0,
          ["wire"] = 0,
          ["cord"] = 0,
          ["arrow"] = 0
        };
        ng_global.progress[ "std" ][ "win_brokenelectricscrewdriver" ].lights = {0,0,0};
        ObjSet( "obj_deploy_inv_brokenelectricscrewdriver_mmg", { input = true } );
  
    end;

    ObjAnimate("obj_deploy_inv_brokenelectricscrewdriver_mmg", "alp", 0, 0, func_end, 
    {
      0.0,0,0,
      0.3,0,1
    });
    ObjAnimate("spr_deploy_inv_brokenelectricscrewdriver_screwdriver_manual_1", "alp", 0, 0, func_end, 
    {
      0.0,0,1,
      0.3,0,0
    });

  end;
--*********************************************************************************************************************
  function private.ScrewdriverLoad ()

    for key, value in pairs( private.parts_used ) do
      private.parts_used[ key ] = ng_global.progress[ "std" ][ "win_brokenelectricscrewdriver" ].parts_used[ key ];
      private.parts_used[ value ] = ng_global.progress[ "std" ][ "win_brokenelectricscrewdriver" ].parts_used[ value ];
    end 
    for i=1, #private.lights do
      private.lights[ i ] = ng_global.progress[ "std" ][ "win_brokenelectricscrewdriver" ].lights[ i ];
    end;
    private.arrow_ang = ng_global.progress[ "std" ][ "win_brokenelectricscrewdriver" ].arrow_ang;
    if ( private.parts_used[ "brown" ] == 1 ) then
      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_brown", { alp = 0, input = false } );
      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_brown_placed", { alp = 1 } );
      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_brown_shadow", { alp = 1 } );
    end;
    if ( private.parts_used[ "yellow" ] == 1 ) then
      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_yellow", { alp = 0, input = false } );
      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_yellow_placed", { alp = 1 } );
    end;
    if ( private.parts_used[ "purple" ] == 1 ) then
      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_purple", { alp = 0, input = false } );
      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_purple_placed", { alp = 1 } );
      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_purple_shadow", { alp = 1 } );
    end;
    if ( private.parts_used[ "wire" ] == 1 ) then
      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_wire", { alp = 0, input = false } );
      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_wire_placed", { alp = 1 } );
      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_wire_shadow", { alp = 1 } );
    end;
    if ( private.parts_used[ "cord" ] == 1 ) then
      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_cord_broken", { alp = 0, input = false } );
      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_cord_fixed", { alp = 1 } );
    end;
    if ( private.parts_used[ "arrow" ] == 1 ) then
      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_arrow", { ang = 0.23, input = false } );
    end;

    for i=1, #private.lights do
      if ( private.lights[ i ] == 1 ) then
        ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_light_"..i, { alp = 1 } );
      end; 
    end;

  end;
--*********************************************************************************************************************
  function private.ScrewdriverPartPick ( part )

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_drill_take_obj" );
    private.pos_z = ObjGet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_"..part ).pos_z;
    ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_"..part, { pos_z = 50 } );

  end;
--*********************************************************************************************************************
  function private.ScrewdriverPartUse ( part )

    local func_end = function ()

      int.Lock( false );
  
      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_"..part, { pos_z = private.pos_z } );
      private.pos_z = 0;

      private.parts_used[ part ] = 1;

      private.ScrewdriverIsWin();

    end;

    int.Lock( true );

    if ( int.ObjIntersectCheck( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_"..part, "obj_deploy_inv_brokenelectricscrewdriver_use_"..part ) ) then


      local name = "";
      if part == "wire" then
        name = "wire";
      elseif part == "purple" then
        name = "micro";
      elseif part == "brown" then
        name = "shunt";
      elseif part == "yellow" then
        name = "yellow_brown_smth";
      end;


      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_drill_place_"..name );

      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_"..part.."_placed", { alp = 1 } );
      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_"..part, { alp = 0, input = false } );

      if ( part ~= "yellow" ) then
        ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_"..part.."_shadow", { alp = 1 } );
      end;

    end;

    func_end();

    
  end;
--*********************************************************************************************************************
  function private.ScrewdriverLightClick ( num )

    local func_end = function ()

      int.Lock( false );

      private.ScrewdriverIsWin();      

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_drill_click_lamp" );
    if private.lights[ num ] == 0 then

      ObjAnimate("spr_deploy_inv_brokenelectricscrewdriver_screwdriver_light_"..num, "alp", 0, 0, func_end, 
      {
        0.0,0,0,
        0.0,0,1
      });

      private.lights[ num ] = 1;

    else

      ObjAnimate("spr_deploy_inv_brokenelectricscrewdriver_screwdriver_light_"..num, "alp", 0, 0, func_end, 
      {
        0.0,0,1,
        0.0,0,0
      });

      private.lights[ num ] = 0;

    end;
    
  end;
--*********************************************************************************************************************
  function private.ScrewdriverCordClick ()

    local func_end = function ()

      int.Lock( false );  
      private.parts_used["cord"] = 1;
      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_cord_broken", { input = false } );

      private.ScrewdriverIsWin();

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_drill_click_redwire" );
    ObjAnimate("spr_deploy_inv_brokenelectricscrewdriver_screwdriver_cord_broken", "alp", 0, 0, "", 
    {
      0.0,0,1,
      0.3,0,0
    });
    ObjAnimate("spr_deploy_inv_brokenelectricscrewdriver_screwdriver_cord_fixed", "alp", 0, 0, func_end, 
    {
      0.0,0,0,
      0.3,0,1
    });
    
  end;
--*********************************************************************************************************************
  function private.ScrewdriverArrowClick ()

  local func_end = function ()

      int.Lock( false );  
      private.parts_used["arrow"] = 1;
      ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_arrow", { input = false } );

      private.ScrewdriverIsWin();

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_drill_click_voltmeter" );
    ObjAnimate("spr_deploy_inv_brokenelectricscrewdriver_screwdriver_arrow", "ang", 0, 0, func_end, 
    {
      0.0,0,0.0,
      0.3,0,0.23
    });

  end;
--*********************************************************************************************************************
  function private.ScrewdriverIsWin ()

    local win = true;

    for key, value in pairs( private.parts_used ) do
      if ( value == 0 ) then
        win = false;
      end;
    end 

    if not ( private.lights[1] == 1 and private.lights[2] == 0 and private.lights[3] == 0 ) then
      win = false;
    end;

    if ( win ) then

      private.ScrewdriverAnimWin();

    else

      for key, value in pairs( private.parts_used ) do
        ng_global.progress[ "std" ][ "win_brokenelectricscrewdriver" ].parts_used[ key ] = private.parts_used[ key ];
        ng_global.progress[ "std" ][ "win_brokenelectricscrewdriver" ].parts_used[ value ] = private.parts_used[ value ];
      end 
      for i=1, #private.lights do
        ng_global.progress[ "std" ][ "win_brokenelectricscrewdriver" ].lights[ i ] = private.lights[ i ];
      end;

    end;

  end;
--*********************************************************************************************************************
  function private.ScrewdriverAnimWin ()

    local func_end = function ()

      int.Lock( false );
      private.ScrewdriverWin();
      common_impl.PassingMgWin( "brokenelectricscrewdriver" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_drill_complete" );
    ObjSet( "spr_deploy_inv_brokenelectricscrewdriver_screwdriver_broken", { alp = 0 } );
    ObjAnimate("obj_deploy_inv_brokenelectricscrewdriver_mmg", "alp", 0, 0, func_end, 
    {
      0.0,0,1,
      0.3,0,0
    });
    ObjAnimate("spr_deploy_inv_brokenelectricscrewdriver_screwdriver_manual", "alp", 0, 0, "", 
    {
      0.0,0,1,
      0.3,0,0
    });
    ObjAnimate("spr_deploy_inv_brokenelectricscrewdriver_screwdriver", "pos_x", 0, 0, "", 
    {
      0.0,0,-182,
      0.3,0,-82
    });
    ObjAnimate("spr_deploy_inv_brokenelectricscrewdriver_screwdriver_cap", "pos_x", 0, 0, "", 
    {
      0.0,0,-443,
      0.3,0,-343
    });

  end;
--*********************************************************************************************************************
  function private.ScrewdriverWin ()

    cmn.MiniGameHide( "brokenelectricscrewdriver" );
    --common_impl.PassingMgWin( "brokenelectricscrewdriver" );

    cmn.SetEventDone( "win_brokenelectricscrewdriver" );
    cmn.CallEventHandler( "win_brokenelectricscrewdriver", "win_brokenelectricscrewdriver" );

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************