-- name=rm_basement
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_basement";

  ObjAttach( "zz_firestand", "room_hub" );
  ObjAttach( "zz_switchroomentrance", "room_hub" );
  ObjAttach( "zz_irondoor", "room_hub" );
  
  ObjSet( "spr_firestand_pruners",           { event_mdown = private.get_pruners } );
  ObjSet( "spr_firestand_bucket",            { event_mdown = private.get_bucket } );
  ObjSet( "obj_switchroomentrance_handle_2", { event_mdown = private.ClkHandle } );
  ObjSet( "obj_irondoor_use_file2",          { event_mdown = private.ClkRasp } );
  ObjSet( "obj_switchroomentrance_key",      { event_mdown = private.clk_key } );
  ObjSet( "spr_irondoor_mushroomsmold",      { event_mdown = private.get_mushroomsmold } );
  ObjSet( "spr_switchroomentrance_hand",     { event_mdown = private.get_hand_2 } );
  ObjSet( "spr_firestand_toggleswitch",      { event_mdown = private.get_toggleswitch_1 } );

  private.InitAnimations();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_basement = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gho_basement_inbasement",
        "gzz_basement_firestand",
        "gzz_basement_switchroomentrance",
        "gzz_basement_irondoor",
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_firestand", 
        "zz_switchroomentrance", 
        "zz_irondoor",
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_basement", update_game_mode_basement, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_pruners () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pruners" ] =
  {
      type = "get",
      get_obj = "obj_firestand_pruners",
      room = private.room_objname,
      zz = "zz_firestand",
      zz_gate = "gzz_basement_firestand"
  };
  -----------------------------------------------
  local get_pruners_inv = function ()

    int.InventoryItemAdd( "inv_pruners", "obj_firestand_pruners" );

  end;

  local get_pruners_closezz = function ()

    ObjDelete( "gfx_firestand_pruners" );
    ObjDelete( "spr_firestand_pruners_shadow" );
    ObjDelete( "spr_basement_secateurs" );

    if ( cmn.IsEventDone( "get_toggleswitch_1" ) and
         cmn.IsEventDone( "get_pruners" ) and
         cmn.IsEventDone( "get_bucket" ) ) then

      ObjDelete( "gzz_basement_firestand" );

    end;

  end;

  cmn.AddSubscriber( "get_pruners", get_pruners_inv );
  cmn.AddSubscriber( "get_pruners", get_pruners_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_hand_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hand_2" ] =
  {
      type = "get",
      get_obj = "spr_switchroomentrance_hand",
      room = private.room_objname,
      zz = "zz_switchroomentrance",
      zz_gate = "gzz_basement_switchroomentrance"
  };
  -----------------------------------------------
  local get_hand_2_inv = function ()

    int.InventoryItemAdd( "inv_hand_1", "spr_switchroomentrance_hand", "assets/levels/level2/rm_kitchen/zz_flower/inv/inv_hand_2_morph" );
    level2_inv.CheckHand();

  end;

  local get_hand_2_closezz = function ()

    ObjDelete( "gfx_switchroomentrance_hand" );
    ObjDelete( "spr_switchroomentrance_hand_shadow" );
    ObjDelete( "spr_basement_hand_2" );

  end;

  cmn.AddSubscriber( "get_hand_2", get_hand_2_inv );
  cmn.AddSubscriber( "get_hand_2", get_hand_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mushroomsmold () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_mushroomsmold" ] =
  {
    type = "get",
    get_obj = "spr_irondoor_mushroomsmold",
    room = private.room_objname,
    zz = "zz_irondoor",
    zz_gate = "gzz_basement_irondoor"
  };
  -----------------------------------------------
  local get_mushroomsmold_inv = function ()

    int.InventoryItemAdd( "inv_mushroomsmold", "spr_irondoor_mushroomsmold" );

  end;

  local get_mushroomsmold_closezz = function ()

    ObjDelete( "spr_irondoor_mushroomsmold_shadow" );
    ObjDelete( "gfx_irondoor_mushroomsmold" );
    ObjDelete( "spr_basement_mushroomsmold" );

  end;

  cmn.AddSubscriber( "get_mushroomsmold", get_mushroomsmold_inv );
  cmn.AddSubscriber( "get_mushroomsmold", get_mushroomsmold_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_handle_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_handle_2" ] =
  {
    type = "click",
    clk_obj = "obj_switchroomentrance_handle_2",
    room = private.room_objname,
    zz = "zz_switchroomentrance",
    zz_gate = "gzz_basement_switchroomentrance"
  };
  -----------------------------------------------
  local clk_handle_2 = function ()
  end;
  -----------------------------------------------
  local clk_handle_2_beg = function ()

    ObjDelete( "obj_switchroomentrance_handle_2" );

  end;
  -----------------------------------------------
  local clk_handle_2_end = function ()

    ObjSet( "grm_basement_switchroom", { active = true, input = true, visible = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_basement_switchroom_focus");
    end;    
    ObjSet( "spr_basement_open_door", { alp = 1 } );    
    ObjDelete( "gzz_basement_switchroomentrance" );
    
    ObjSet( "anm_basement_smoke", { alp = 1 } );

  end;

  cmn.AddSubscriber( "clk_handle_2", clk_handle_2 );
  cmn.AddSubscriber( "clk_handle_2", clk_handle_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_handle_2", clk_handle_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_handle_2_beg", clk_handle_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_handle_2_end", clk_handle_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_key" ] =
  {
    type = "click",
    clk_obj = "obj_switchroomentrance_key",
    room = private.room_objname,
    zz = "zz_switchroomentrance",
    zz_gate = "gzz_basement_switchroomentrance"
  };
  -----------------------------------------------
  local clk_key = function ()
  end;
  -----------------------------------------------
  local clk_key_beg = function ()

    ObjSet( "obj_switchroomentrance_key", { input = false } );

  end;
  -----------------------------------------------
  local clk_key_end = function ()

    ObjSet( "spr_switchroomentrance_key1", { alp = 0 } );
    ObjSet( "spr_switchroomentrance_key2", { alp = 1 } );
    ObjDelete( "spr_switchroomentrance_key_over" );
    ObjDelete( "anm_switchroomentrance_door_click" );
    ObjSet( "anm_switchroomentrance_door_open", { alp = 1 } );
    ObjSet( "obj_switchroomentrance_handle_2", { event_mdown = private.clk_handle_2 } );

  end;

  cmn.AddSubscriber( "clk_key", clk_key );
  cmn.AddSubscriber( "clk_key", clk_key_beg, private.room_objname );
  cmn.AddSubscriber( "clk_key", clk_key_end, private.room_objname );
  cmn.AddSubscriber( "clk_key_beg", clk_key_beg, private.room_objname );
  cmn.AddSubscriber( "clk_key_end", clk_key_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bucket () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bucket" ] =
    {
      type = "get",
      get_obj = "spr_firestand_bucket",
      room = private.room_objname,
      zz = "zz_firestand",
      zz_gate = "gzz_basement_firestand"
  };
  -----------------------------------------------
  local get_bucket_inv = function ()

    int.InventoryItemAdd( "inv_bucket", "spr_firestand_bucket" );

  end;

  local get_bucket_closezz = function ()

    ObjDelete( "gfx_firestand_bucket" );
    ObjDelete( "spr_firestand_bucket_shadow" );
    ObjDelete( "spr_basement_bucket" );

    if ( cmn.IsEventDone( "get_toggleswitch_1" ) and
         cmn.IsEventDone( "get_pruners" ) and
         cmn.IsEventDone( "get_bucket" ) ) then

      ObjDelete( "gzz_basement_firestand" );

    end;

  end;

  cmn.AddSubscriber( "get_bucket", get_bucket_inv );
  cmn.AddSubscriber( "get_bucket", get_bucket_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_toggleswitch_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_toggleswitch_1" ] =
    {
      type = "get",
      get_obj = "spr_firestand_toggleswitch",
      room = private.room_objname,
      zz = "zz_firestand",
      zz_gate = "gzz_basement_firestand"
  };
  -----------------------------------------------
  local get_toggleswitch_1_inv = function ()

    int.InventoryItemAdd( "inv_toggleswitch_1", "spr_firestand_toggleswitch" );

  end;

  local get_toggleswitch_1_closezz = function ()

    ObjDelete( "gfx_firestand_toggleswitch" );
    ObjDelete( "spr_firestand_toggleswitch_shadow" );
    ObjDelete( "spr_basement_toggleswitch" );

    if ( cmn.IsEventDone( "get_toggleswitch_1" ) and
         cmn.IsEventDone( "get_pruners" ) and
         cmn.IsEventDone( "get_bucket" ) ) then

      ObjDelete( "gzz_basement_firestand" );

    end;

  end;

  cmn.AddSubscriber( "get_toggleswitch_1", get_toggleswitch_1_inv );
  cmn.AddSubscriber( "get_toggleswitch_1", get_toggleswitch_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_2_1 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_2_1 = function ()

    ObjDelete( "obj_basement_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_2_1", get_morphobject_2_1, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_hammer2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hammer2" ] =
    {
    type = "use",
      use_obj = "inv_hammer2",
      use_place = "obj_firestand_use_hammer2",
      room = private.room_objname,
      zz = "zz_firestand",
      zz_gate = "gzz_basement_firestand"
  };
  -----------------------------------------------
  local use_hammer2_inv = function ()

    int.InventoryItemRemove( "inv_hammer2" );

  end;
  local use_hammer2_beg = function ()

    ObjDelete( "obj_firestand_use_hammer2" );

  end;
  local use_hammer2_end = function ()

    ObjSet( "spr_firestand_bucket", { active = true, input = true, visible = true } );
    ObjSet( "spr_firestand_toggleswitch", { active = true, input = true } );
    ObjSet( "spr_firestand_glass_broken", { alp = 1, input = true } );
    ObjDelete( "vid_firestand_use_hammer" );
    ObjSet( "spr_basement_glass_1", { alp = 1 } );
    ObjDelete( "spr_basement_glass" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_hammer2", use_hammer2_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer2", use_hammer2_inv );
  cmn.AddSubscriber( "use_hammer2", use_hammer2_end, private.room_objname );
  cmn.AddSubscriber( "use_hammer2_inv", use_hammer2_inv, private.room_objname );
  cmn.AddSubscriber( "use_hammer2_beg", use_hammer2_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer2_end", use_hammer2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_switchroomkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_switchroomkey" ] =
    {
    type = "use",
      use_obj = "inv_switchroomkey",
      use_place = "obj_switchroomentrance_use_switchroomkey",
      room = private.room_objname,
      zz = "zz_switchroomentrance",
      zz_gate = "gzz_basement_switchroomentrance"
  };
  -----------------------------------------------
  local use_switchroomkey_inv = function ()

    int.InventoryItemRemove( "inv_switchroomkey" );

  end;
  local use_switchroomkey_beg = function ()

    ObjDelete( "obj_switchroomentrance_use_switchroomkey" );

  end;
  local use_switchroomkey_end = function ()

    ObjSet( "obj_switchroomentrance_key", { alp = 1, input = true, pos_x = 12, pos_y = 75 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_switchroomkey", use_switchroomkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_switchroomkey", use_switchroomkey_inv );
  cmn.AddSubscriber( "use_switchroomkey", use_switchroomkey_end, private.room_objname );
  cmn.AddSubscriber( "use_switchroomkey_inv", use_switchroomkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_switchroomkey_beg", use_switchroomkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_switchroomkey_end", use_switchroomkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_file2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_file2" ] =
    {
    type = "use",
      use_obj = "inv_file2",
      use_place = "obj_irondoor_use_file2",
      room = private.room_objname,
      zz = "zz_irondoor",
      zz_gate = "gzz_basement_irondoor"
  };
  -----------------------------------------------
  local use_file2_inv = function ()

    int.InventoryItemRemove( "inv_file2" );

  end;
  local use_file2_beg = function ()

    ObjDelete( "obj_irondoor_use_file2" );

  end;
  local use_file2_end = function ()

    ObjSet( "gho_basement_inbasement", { active = true, input = true, alp = 1 } );
    ObjSet( "spr_basement_open_ho", { alp = 1 } );
    ObjDelete( "gzz_basement_irondoor" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_file2", use_file2_beg, private.room_objname );
  cmn.AddSubscriber( "use_file2", use_file2_inv );
  cmn.AddSubscriber( "use_file2", use_file2_end, private.room_objname );
  cmn.AddSubscriber( "use_file2_inv", use_file2_inv, private.room_objname );
  cmn.AddSubscriber( "use_file2_beg", use_file2_beg, private.room_objname );
  cmn.AddSubscriber( "use_file2_end", use_file2_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
function private.get_pruners ()

  cmn.SetEventDone( "get_pruners" );
  cmn.CallEventHandler( "get_pruners" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_pruners" ) and
       cmn.IsEventDone( "get_toggleswitch_1" ) and
       cmn.IsEventDone( "get_bucket" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_hand_2 ()

  cmn.SetEventDone( "get_hand_2" );
  cmn.CallEventHandler( "get_hand_2" );
  
  cmn.GetObjectSfx();

  iOS_RateMe();
end;
-------------------------------------------------
-------------------------------------------------
function private.get_bucket ()

  cmn.SetEventDone( "get_bucket" );
  cmn.CallEventHandler( "get_bucket" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_pruners" ) and
       cmn.IsEventDone( "get_toggleswitch_1" ) and
       cmn.IsEventDone( "get_bucket" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_toggleswitch_1 ()

  cmn.SetEventDone( "get_toggleswitch_1" );
  cmn.CallEventHandler( "get_toggleswitch_1" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_pruners" ) and
       cmn.IsEventDone( "get_toggleswitch_1" ) and
       cmn.IsEventDone( "get_bucket" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_mushroomsmold ()

  cmn.SetEventDone( "get_mushroomsmold" );
  cmn.CallEventHandler( "get_mushroomsmold" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
--*********************************************************************************************************************
-------------------------------------------------
function public.use_hammer2 ()

  local item = "inv_hammer2";

  if ( cmn.ApplyObj( item, "gzz_basement_firestand", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_firestand" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_firestand_use_hammer2", true ) ) then

    cmn.CallEventHandler( "use_hammer2_inv" );
    cmn.CallEventHandler( "use_hammer2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_hammer2" );
      cmn.CallEventHandler( "use_hammer2_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_crash_glass" );  

    VidPlay( "vid_firestand_use_hammer", func_end);
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_switchroomkey ()

  local item = "inv_switchroomkey";

  if ( cmn.ApplyObj( item, "gzz_basement_switchroomentrance", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_switchroomentrance" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_switchroomentrance_use_switchroomkey", true ) ) then

    cmn.CallEventHandler( "use_switchroomkey_inv" );
    cmn.CallEventHandler( "use_switchroomkey_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_switchroomkey" );
      cmn.CallEventHandler( "use_switchroomkey_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_key" ); 
 
    ObjAnimate( "obj_switchroomentrance_key", "pos_xy", 0, 0, func_end,
    { 
      0.0, 0, -44, 54,
      0.3, 0, -44, 54,
      1.3, 0, 12, 75
    } );

    ObjAnimate( "obj_switchroomentrance_key", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_file2 ()

  local item = "inv_file2";

  if ( cmn.ApplyObj( item, "gzz_basement_irondoor", false ) and
       cmn.IsEventDone( "get_mushroomsmold" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_irondoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_irondoor_use_file2", true ) and
           cmn.IsEventDone( "get_mushroomsmold" ) ) then

    cmn.CallEventHandler( "use_file2_inv" );
    cmn.CallEventHandler( "use_file2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_file2" );
      cmn.CallEventHandler( "use_file2_end" );
      int.Lock( false );

      cmn.CloseSubRoom();

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_use_rasp" );
    ObjSet( "obj_irondoor_anim", { alp = 0 } );  
    ObjSet( "anm_irondoor_rasp", { alp = 1 } );  
    AnimPlay( "anm_irondoor_rasp", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_handle_2 ()

  local func_end = function ()

    cmn.SetEventDone( "clk_handle_2" );
    cmn.CallEventHandler( "clk_handle_2_end" );
    cmn.CallEventHandler( "clk_handle_2" );
    cmn.CloseSubRoom();

    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_handle_2_beg" );

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_open_switchroom_door" );

  AnimPlay( "anm_switchroomentrance_door_open", "DoAnim", func_end );

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_key ()

  local func_end = function ()

    cmn.SetEventDone( "clk_key" );
    cmn.CallEventHandler( "clk_key_end" );
    cmn.CallEventHandler( "clk_key" );

    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_key_beg" );

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_key_click" );

  ObjAnimate( "spr_switchroomentrance_key1", "alp", 0, 0, "", 
  { 
    0.0, 0, 1,
    0.3, 0, 0
  } );
  ObjAnimate( "spr_switchroomentrance_key2", "alp", 0, 0, "", 
  { 
    0.0, 0, 0,
    0.3, 0, 1
  } );
  ObjAnimate( "spr_switchroomentrance_key_over", "alp", 0, 0, func_end, 
  { 
    0.0, 0, 1,
    0.2, 0, 1,
    0.4, 0, 0
  } );

end;
-------------------------------------------------
--*********************************************************************************************************************
-------------------------------------------------
function private.InitAnimations ()

  ObjAnimate( "spr_switchroomentrance_chain", "ang", 1, 0, "", 
  { 
    0.0, 3, -0.1,
    3.0, 3, 0.1,
    6.0, 3, -0.1,
  } );

  ObjAnimate( "spr_switchroomentrance_chain_2", "ang", 1, 0, "", 
  { 
    0.0, 3, -0.1,
    3.0, 3, 0.1,
    6.0, 3, -0.1,
  } );

  ObjAnimate( "spr_inthecar_pin_hotspot_add", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.5, 0, 0,
    3.0, 0, 1
  } );

  ObjAnimate( "spr_irondoor_shine_1", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.5, 0, 0.3,
    3.0, 0, 1
  } );

  ObjAnimate( "spr_irondoor_shine_2", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.5, 0, 0.3,
    3.0, 0, 1
  } );

  ObjAnimate( "spr_firestand_light_add_05", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.5, 0, 0.3,
    3.0, 0, 1
  } );

  ObjAnimate( "spr_firestand_light1_add_05", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.5, 0, 0.3,
    3.0, 0, 1
  } );

  ObjAnimate( "spr_firestand_pruners", "ang", 1, 0, "", 
  { 
    0.0, 3, 0.05,
    3.0, 3, -0.05,
    6.0, 3, 0.05,
  } );

  ObjAnimate( "spr_firestand_pruners_shadow", "ang", 1, 0, "", 
  { 
    0.0, 3, 0.05,
    3.0, 3, -0.05,
    6.0, 3, 0.05,
  } );

  ObjAnimate( "obj_switchroomentrance_clock_hand", "ang", 1, 0, "", 
  { 
    0.0, 3, -0.2,
    3.0, 3, 0.2,
    6.0, 3, -0.2,
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_basement ()

  if not ( cmn.IsEventDone( "opn_basement" ) ) then

    cmn.SetEventDone( "opn_basement" );
    cmn.ShowBbt( "bbt_basement_first_entry" );
    
    cmn.PlayAudio( "mus", "audio/aud_main_theme_light_mus" );

  end;

end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopAllEnv( "audio/level2/env/aud_basement_env", true );
  cmn.PlayAudio( "env", "audio/level2/env/aud_basement_env", 1 );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Open ()

  private.opn_basement();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_pruners" ); 
  int.AddedTaskMap( private.room_objname, "get_hand_2" );
  int.AddedTaskMap( private.room_objname, "get_mushroomsmold" ); 

  int.AddedTaskMap( private.room_objname, "clk_handle_2",                  { "clk_key" } );
  int.AddedTaskMap( private.room_objname, "clk_key",             { "use_switchroomkey" } ); 

  int.AddedTaskMap( private.room_objname, "get_bucket",                { "use_hammer2" } );
  int.AddedTaskMap( private.room_objname, "get_toggleswitch_1",        { "use_hammer2" } );

  int.AddedTaskMap( private.room_objname, "use_hammer2",               { "get_hammer2" } ); 
  int.AddedTaskMap( private.room_objname, "use_switchroomkey",   { "get_switchroomkey" } ); 
  int.AddedTaskMap( private.room_objname, "use_file2",                   { "get_file2" } );  
 
  int.AddedTaskMap( private.room_objname, "opn_switchroom",           { "clk_handle_2" } );  

  int.AddedTaskMap( private.room_objname, "win_inbasement",              { "use_file2" } );  
  
end;
--*********************************************************************************************************************
function private.ClkHandle ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_switchroomentrance_wrong_clk_handle" );

  end;

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_handle_touch" );
  AnimPlay( "anm_switchroomentrance_door_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.ClkRasp ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_irondoor_use_file2" );

  end;

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_handle_touch" );
  ObjAnimate( "spr_irondoor_right_door", "pos_x", 0, 0, func_end, 
  { 
    0.0, 3, 91,
    0.3, 3, 93,
    0.6, 3, 91,
  } );

end;
--*********************************************************************************************************************
