-- name=rm_kitchen
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_kitchen";

  ObjAttach( "zz_stove",              "room_hub" );
  ObjAttach( "zz_wall",               "room_hub" );
  ObjAttach( "zz_shelvesonwall",      "room_hub" );
  ObjAttach( "zz_wallhangingcabinet", "room_hub" );
  ObjAttach( "zz_flower",             "room_hub" );
  
  ObjMultiSet( {
    { "spr_stove_butler",                              { event_mdown = private.get_butler } };
    { "spr_stove_sausage",                             { event_mdown = private.get_sausage } };
    { "spr_stove_toymushroom_mold",                    { event_mdown = private.get_toymushroom } };
    { "spr_flower_slingshotframe",                     { event_mdown = private.get_slingshotframe } };
    { "spr_flower_hand_1",                             { event_mdown = private.get_hand_1 } };
    { "spr_wallhangingcabinet_insulatingtape",         { event_mdown = private.get_insulatingtape } };
    { "spr_shelvesonwall_artificialflower",            { event_mdown = private.get_artificialflower_2 } };    
    { "spr_shelvesonwall_cuckoo",                      { event_mdown = private.get_cuckoo } };
    { "spr_shelvesonwall_plasticscrew",                { event_mdown = private.get_plasticscrew } };
    { "spr_shelvesonwall_cleaner",                     { event_mdown = private.get_cleaner } };
    { "spr_shelvesonwall_spraynozzle",                 { event_mdown = private.get_cleaner } };
    { "spr_wallhangingcabinet_rubbergloves",           { event_mdown = private.get_rubbergloves } };
    { "spr_wallhangingcabinet_penguin",                { event_mdown = private.get_penguin_2 } };
    { "spr_wall_hanky2",                               { event_mdown = private.get_hanky2 } },
    { "spr_wall_boxkey",                               { event_mdown = private.get_boxkey } },
    { "spr_wall_wire",                                 { event_mdown = private.get_wire } },
    { "obj_stove_clk_gas",                             { event_mdown = private.clk_gas } };
    { "obj_wall_clk_counterbutton",                    { event_mdown = private.clk_counterbutton } };
    { "obj_wallhangingcabinet_use_artificialflower_1", { event_mdown = private.KitchenCabinetDoorClick } };
    { "obj_wallhangingcabinet_use_artificialflower_2", { event_mdown = private.KitchenCabinetDoorClick } };
    { "obj_flower_use_razorblade",                     { event_mdown = private.ClkSlingshotframe } };
    { "obj_flower_use_pruners",                        { event_mdown = private.ClkClockHand } };
    { "obj_shelvesonwall_clk_book",                    { event_mdown = private.ClkBook } };
    { "obj_shelvesonwall_clk_timer",                   { event_mdown = private.ClkTimer } };
    { "obj_wallhangingcabinet_clk_glove",              { event_mdown = private.ClkGlove } };
    { "obj_kitchen_clk_candy",                         { event_mdown = private.ClkCandy } };
    { "obj_kitchen_toaster",                           { event_mdown = private.ClkToaster } };
    { "spr_flower_collect2_2_2",                       { event_mdown = private.get_collect2_2_2 } },
    { "obj_wall_use_counterbutton",                    { event_mdown = private.WireClk } },
    { "obj_shelvesonwall_use_snailamulet_1",           { event_mdown = private.SnailamuletBbt } },
    { "obj_shelvesonwall_use_snailamulet_2",           { event_mdown = private.SnailamuletBbt } },
  } );

  private.Anims();
  private.InitSubroom();
  private.WallhangingcabinetInit();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_kitchen = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gzz_kitchen_stove",
        "gzz_kitchen_wall",
        "gzz_kitchen_shelvesonwall",
        "gzz_kitchen_wallhangingcabinet",
        "gzz_kitchen_flower",
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_stove", 
        "zz_wall", 
        "zz_shelvesonwall", 
        "zz_wallhangingcabinet",
        "zz_flower",
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_kitchen", update_game_mode_kitchen, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_butler () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_butler" ] =
  {
    type = "get",
    get_obj = "spr_stove_butler",
    room = private.room_objname,
    zz = "zz_stove",
    zz_gate = "gzz_kitchen_stove"
  };
  -----------------------------------------------
  local get_butler_inv = function ()

    int.InventoryItemAdd( "inv_butler", "spr_stove_butler" );

  end;

  local get_butler_closezz = function ()

    ObjDelete( "gfx_stove_butler" );
    ObjDelete( "spr_stove_butler_shadow" );
    ObjDelete( "spr_kitchen_stove_man" );

    if ( cmn.IsEventDone( "get_butler" ) and
         cmn.IsEventDone( "get_sausage" ) and
         cmn.IsEventDone( "get_toymushroom" ) ) then

      ObjDelete( "gzz_kitchen_stove" );

    end;

  end;

  cmn.AddSubscriber( "get_butler", get_butler_inv );
  cmn.AddSubscriber( "get_butler", get_butler_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sausage () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sausage" ] =
  {
    type = "get",
    get_obj = "spr_stove_sausage",
    room = private.room_objname,
    zz = "zz_stove",
    zz_gate = "gzz_kitchen_stove"
  };
  -----------------------------------------------
  local get_sausage_inv = function ()

    int.InventoryItemAdd( "inv_sausage", "spr_stove_sausage" );

  end;

  local get_sausage_closezz = function ()

    ObjDelete( "gfx_stove_sausage" );
    ObjDelete( "spr_stove_sausage_shadow" );

    if ( cmn.IsEventDone( "get_butler" ) and
         cmn.IsEventDone( "get_sausage" ) and
         cmn.IsEventDone( "get_toymushroom" ) ) then

      ObjDelete( "gzz_kitchen_stove" );

    end;

  end;

  cmn.AddSubscriber( "get_sausage", get_sausage_inv );
  cmn.AddSubscriber( "get_sausage", get_sausage_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_toymushroom () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_toymushroom" ] =
  {
    type = "get",
    get_obj = "spr_stove_toymushroom_mold",
    room = private.room_objname,
    zz = "zz_stove",
    zz_gate = "gzz_kitchen_stove"
  };
  -----------------------------------------------
  local get_toymushroom_inv = function ()

    int.InventoryItemAdd( "inv_toymushroom", "spr_stove_toy_mushroom" );

  end;

  local get_toymushroom_closezz = function ()

    ObjDelete( "spr_stove_toymushroom_mold" );
    ObjDelete( "spr_kitchen_inform" );

    if ( cmn.IsEventDone( "get_butler" ) and
         cmn.IsEventDone( "get_sausage" ) and
         cmn.IsEventDone( "get_toymushroom" ) ) then

      ObjDelete( "gzz_kitchen_stove" );

    end;

  end;

  cmn.AddSubscriber( "get_toymushroom", get_toymushroom_inv );
  cmn.AddSubscriber( "get_toymushroom", get_toymushroom_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_slingshotframe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_slingshotframe" ] =
  {
    type = "get",
    get_obj = "spr_flower_slingshotframe",
    room = private.room_objname,
    zz = "zz_flower",
    zz_gate = "gzz_kitchen_flower"
  };
  -----------------------------------------------
  local get_slingshotframe_inv = function ()

    int.InventoryItemAdd( "inv_slingshotframe", "spr_flower_slingshotframe" );

  end;

  local get_slingshotframe_closezz = function ()

    ObjDelete( "gfx_flower_slingshotframe" );
    ObjDelete( "spr_flower_slingshotframe_shadow" );
    ObjDelete( "spr_kitchen_slingshotframe" );    

    if ( cmn.IsEventDone( "get_slingshotframe" ) and
         cmn.IsEventDone( "get_collect2_2_2" ) and
         cmn.IsEventDone( "get_penguin_1" ) and
         cmn.IsEventDone( "get_hand_1" ) ) then

      ObjDelete( "gzz_kitchen_flower" );

    end;

  end;

  cmn.AddSubscriber( "get_slingshotframe", get_slingshotframe_inv );
  cmn.AddSubscriber( "get_slingshotframe", get_slingshotframe_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hand_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hand_1" ] =
  {
    type = "get",
    get_obj = "spr_flower_hand_1",
    room = private.room_objname,
    zz = "zz_flower",
    zz_gate = "gzz_kitchen_flower"
  };
  -----------------------------------------------
  local get_hand_1_inv = function ()

    int.InventoryItemAdd( "inv_hand_1", "spr_flower_hand_1", "assets/levels/level2/rm_kitchen/zz_flower/inv/inv_hand_1_morph" );
    level2_inv.CheckHand();

  end;

  local get_hand_1_closezz = function ()

    ObjDelete( "gfx_flower_hand_1" );
    ObjDelete( "spr_flower_hand_1_shadow" );
    ObjDelete( "spr_kitchen_clockhand" );
    ObjDelete( "spr_flower_arrow_glow" );

    if ( cmn.IsEventDone( "get_slingshotframe" ) and
         cmn.IsEventDone( "get_collect2_2_2" ) and
         cmn.IsEventDone( "get_penguin_1" ) and
         cmn.IsEventDone( "get_hand_1" ) ) then

      ObjDelete( "gzz_kitchen_flower" );

    end;

  end;

  cmn.AddSubscriber( "get_hand_1", get_hand_1_inv );
  cmn.AddSubscriber( "get_hand_1", get_hand_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_artificialflower_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_artificialflower_2" ] =
  {
    type = "get",
    get_obj = "spr_shelvesonwall_artificialflower",
    room = private.room_objname,
    zz = "zz_shelvesonwall",
    zz_gate = "gzz_kitchen_shelvesonwall"
  };
  -----------------------------------------------
  local get_artificialflower_2_inv = function ()

    int.InventoryItemAdd( "inv_artificialflower_2", "spr_shelvesonwall_artificialflower" );

  end;

  local get_artificialflower_2_closezz = function ()

    ObjDelete( "gfx_shelvesonwall_artificialflower" );
    ObjDelete( "spr_shelvesonwall_artificialflower_shadow" );
    ObjDelete( "spr_kitchen_artificialflower_2" );

    if ( cmn.IsEventDone( "get_artificialflower_2" ) and
         --cmn.IsEventDone( "get_doordowel_1" ) and
         cmn.IsEventDone( "get_cuckoo" ) and
         cmn.IsEventDone( "get_cleaner" ) and
         cmn.IsEventDone( "get_plasticscrew" ) ) then

      ObjDelete( "gzz_kitchen_shelvesonwall" );

    end;

  end;

  cmn.AddSubscriber( "get_artificialflower_2", get_artificialflower_2_inv );
  cmn.AddSubscriber( "get_artificialflower_2", get_artificialflower_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_doordowel_1 () end;
  --------------------------------------------------------------------------------------------
  --common_impl.hint[ "get_doordowel_1" ] =
  --{
  --  type = "get",
  --  get_obj = "spr_shelvesonwall_doordowel_1",
  --  room = private.room_objname,
  --  zz = "zz_shelvesonwall",
  --  zz_gate = "gzz_kitchen_shelvesonwall"
  --};
  -----------------------------------------------
--  local get_doordowel_1_inv = function ()
--
--    int.InventoryItemAdd( "inv_doordowel_1", "spr_shelvesonwall_doordowel_1" );
--    level2_inv.CheckDoordowel ();
--
--  end;
--
--  local get_doordowel_1_closezz = function ()
--
--    ObjDelete( "gfx_shelvesonwall_doordowel_1" );
--    ObjDelete( "spr_kitchen_open_box_dowel" );
--
--    if ( cmn.IsEventDone( "get_artificialflower_2" ) and
--         cmn.IsEventDone( "get_doordowel_1" ) and
--         cmn.IsEventDone( "get_cuckoo" ) and
--         cmn.IsEventDone( "get_cleaner" ) and
--         cmn.IsEventDone( "get_plasticscrew" ) ) then
--
--      ObjDelete( "gzz_kitchen_shelvesonwall" );
--
--    end;
--
--  end;
--
--  cmn.AddSubscriber( "get_doordowel_1", get_doordowel_1_inv );
--  cmn.AddSubscriber( "get_doordowel_1", get_doordowel_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cuckoo () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cuckoo" ] =
  {
    type = "get",
    get_obj = "spr_shelvesonwall_cuckoo",
    room = private.room_objname,
    zz = "zz_shelvesonwall",
    zz_gate = "gzz_kitchen_shelvesonwall"
  };
  -----------------------------------------------
  local get_cuckoo_inv = function ()

    int.InventoryItemAdd( "inv_cuckoo", "spr_shelvesonwall_cuckoo", "assets/levels/level3/rm_window/zz_janitresstuff/inv/inv_bird_morph" );

  end;

  local get_cuckoo_closezz = function ()

    ObjDelete( "gfx_shelvesonwall_cuckoo" );
    ObjDelete( "spr_shelvesonwall_cuckoo_shadow" );
    ObjDelete( "spr_kitchen_clock_cuckoo" );

    if ( cmn.IsEventDone( "get_artificialflower_2" ) and
         --cmn.IsEventDone( "get_doordowel_1" ) and
         cmn.IsEventDone( "get_cuckoo" ) and
         cmn.IsEventDone( "get_cleaner" ) and
         cmn.IsEventDone( "get_plasticscrew" ) ) then

      ObjDelete( "gzz_kitchen_shelvesonwall" );

    end;

    ObjSet( "spr_shelvesonwall_plasticscrew", { active = true, input = true } );

  end;

  cmn.AddSubscriber( "get_cuckoo", get_cuckoo_inv );
  cmn.AddSubscriber( "get_cuckoo", get_cuckoo_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_plasticscrew () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_plasticscrew" ] =
  {
    type = "get",
    get_obj = "spr_shelvesonwall_plasticscrew",
    room = private.room_objname,
    zz = "zz_shelvesonwall",
    zz_gate = "gzz_kitchen_shelvesonwall"
  };
  -----------------------------------------------
  local get_plasticscrew_inv = function ()

    int.InventoryItemAdd( "inv_plasticscrew", "spr_shelvesonwall_plasticscrew" );

  end;

  local get_plasticscrew_closezz = function ()

    ObjDelete( "gfx_shelvesonwall_plasticscrew" );
    ObjDelete( "spr_shelvesonwall_plasticscrew_shadow" );
    ObjDelete( "spr_kitchen_clock_latch" );

    if ( cmn.IsEventDone( "get_artificialflower_2" ) and
         --cmn.IsEventDone( "get_doordowel_1" ) and
         cmn.IsEventDone( "get_cuckoo" ) and
         cmn.IsEventDone( "get_cleaner" ) and
         cmn.IsEventDone( "get_plasticscrew" ) ) then

      ObjDelete( "gzz_kitchen_shelvesonwall" );

    end;

  end;

  cmn.AddSubscriber( "get_plasticscrew", get_plasticscrew_inv );
  cmn.AddSubscriber( "get_plasticscrew", get_plasticscrew_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rubbergloves () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_rubbergloves" ] =
  {
    type = "get",
    get_obj = "spr_wallhangingcabinet_rubbergloves",
    room = private.room_objname,
    zz = "zz_wallhangingcabinet",
    zz_gate = "gzz_kitchen_wallhangingcabinet"
  };
  -----------------------------------------------
  local get_rubbergloves_inv = function ()

    int.InventoryItemAdd( "inv_rubbergloves", "spr_wallhangingcabinet_rubbergloves" );

  end;

  local get_rubbergloves_closezz = function ()

    ObjDelete( "gfx_wallhangingcabinet_rubbergloves" );
    ObjDelete( "spr_wallhangingcabinet_rubbergloves_shadow" );
    ObjDelete( "spr_kitchen_rubbergloves" );

    if ( cmn.IsEventDone( "get_insulatingtape" ) ) then

      ObjDelete( "gzz_kitchen_wallhangingcabinet" );

    end;

  end;

  cmn.AddSubscriber( "get_rubbergloves", get_rubbergloves_inv );
  cmn.AddSubscriber( "get_rubbergloves", get_rubbergloves_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_insulatingtape () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_insulatingtape" ] =
  {
    type = "get",
    get_obj = "spr_wallhangingcabinet_insulatingtape",
    room = private.room_objname,
    zz = "zz_wallhangingcabinet",
    zz_gate = "gzz_kitchen_wallhangingcabinet"
  };
  -----------------------------------------------
  local get_insulatingtape_inv = function ()

    int.InventoryItemAdd( "inv_insulatingtape", "spr_wallhangingcabinet_insulatingtape" );

  end;

  local get_insulatingtape_closezz = function ()

    ObjDelete( "gfx_wallhangingcabinet_insulatingtape" );
    ObjDelete( "spr_wallhangingcabinet_insulatingtape_shadow" );
    ObjDelete( "spr_kitchen_insulatingtape" );

    if ( cmn.IsEventDone( "get_rubbergloves" ) ) then

      ObjDelete( "gzz_kitchen_wallhangingcabinet" );

    end;

  end;

  cmn.AddSubscriber( "get_insulatingtape", get_insulatingtape_inv );
  cmn.AddSubscriber( "get_insulatingtape", get_insulatingtape_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_hanky2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hanky2" ] =
  {
    type = "get",
    get_obj = "spr_wall_hanky2",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_kitchen_wall"
  };
  -----------------------------------------------
  local get_hanky2_inv = function ()

    int.InventoryItemAdd( "inv_hanky2", "spr_wall_hanky2" );

  end;

  local get_hanky2_closezz = function ()

    ObjDelete( "spr_kitchen_shawl" );
    ObjDelete( "spr_wall_hanky2_shadow" );
    ObjDelete( "gfx_wall_hanky2" );
    ObjDelete( "anm_wall_hanky2" );

  end;

  cmn.AddSubscriber( "get_hanky2", get_hanky2_inv );
  cmn.AddSubscriber( "get_hanky2", get_hanky2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_boxkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_boxkey" ] =
  {
    type = "get",
    get_obj = "spr_wall_boxkey",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_kitchen_wall"
  };
  -----------------------------------------------
  local get_boxkey_inv = function ()

    int.InventoryItemAdd( "inv_boxkey", "spr_wall_boxkey" );

  end;

  local get_boxkey_closezz = function ()

    ObjDelete( "gfx_wall_boxkey" );
    ObjDelete( "spr_wall_boxkey_shadow" );
    ObjDelete( "spr_wall_boxkey_add" );
    ObjDelete( "spr_kitchen_boxkey" );

    if ( cmn.IsEventDone( "get_boxkey" ) and
         cmn.IsEventDone( "get_wire" ) ) then
      ObjDelete( "gzz_kitchen_wall" );
    end;

  end;

  cmn.AddSubscriber( "get_boxkey", get_boxkey_inv );
  cmn.AddSubscriber( "get_boxkey", get_boxkey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wire () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wire" ] =
  {
    type = "get",
    get_obj = "spr_wall_wire",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_kitchen_wall"
  };
  -----------------------------------------------
  local get_wire_inv = function ()

    int.InventoryItemAdd( "inv_wire", "spr_wall_wire" );

  end;

  local get_wire_closezz = function ()

    ObjDelete( "gfx_wall_wire" );
    ObjDelete( "spr_wall_wire_shadow" );
    ObjDelete( "spr_kitchen_wire" );

    if ( cmn.IsEventDone( "get_wire" ) and
         cmn.IsEventDone( "get_boxkey" ) ) then
      ObjDelete( "gzz_kitchen_wall" );
    end;

  end;

  cmn.AddSubscriber( "get_wire", get_wire_inv );
  cmn.AddSubscriber( "get_wire", get_wire_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cleaner () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cleaner" ] =
  {
    type = "get",
    get_obj = "obj_shelvesonwall_cleaner",
    room = private.room_objname,
    zz = "zz_shelvesonwall",
    zz_gate = "gzz_kitchen_shelvesonwall"
  };
  -----------------------------------------------
  local get_cleaner_inv = function ()

    int.InventoryItemAdd( "inv_cleaner", "obj_shelvesonwall_cleaner" );

  end;

  local get_cleaner_closezz = function ()

    ObjDelete( "gfx_shelvesonwall_cleaner" );
    ObjDelete( "spr_shelvesonwall_cleaner_shadow" );
    ObjDelete( "spr_kitchen_cleaner" );

  end;

  cmn.AddSubscriber( "get_cleaner", get_cleaner_inv );
  cmn.AddSubscriber( "get_cleaner", get_cleaner_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_penguin_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_penguin_1" ] =
  {
    type = "get",
    get_obj = "spr_flower_penguin",
    room = private.room_objname,
    zz = "zz_flower",
    zz_gate = "gzz_kitchen_flower"
  };
  -----------------------------------------------
  local get_penguin_1_inv = function ()

    int.InventoryItemAdd( "inv_penguin_1", "spr_flower_penguin" );

  end;

  local get_penguin_1_closezz = function ()

    ObjDelete( "spr_kitchen_dirt_penguin" );

    if ( cmn.IsEventDone( "get_slingshotframe" ) and
         cmn.IsEventDone( "get_collect2_2_2" ) and
         cmn.IsEventDone( "get_penguin_1" ) and
         cmn.IsEventDone( "get_hand_1" ) ) then

      ObjDelete( "gzz_kitchen_flower" );

    end;

  end;

  cmn.AddSubscriber( "get_penguin_1", get_penguin_1_inv );
  cmn.AddSubscriber( "get_penguin_1", get_penguin_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_penguin_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_penguin_2" ] =
  {
    type = "get",
    get_obj = "spr_wallhangingcabinet_penguin",
    room = private.room_objname,
    zz = "zz_wallhangingcabinet",
    zz_gate = "gzz_kitchen_wallhangingcabinet"
  };
  -----------------------------------------------
  local get_penguin_2_inv = function ()

    int.InventoryItemAdd( "inv_penguin_2", "spr_wallhangingcabinet_penguin" );

  end;

  local get_penguin_2_closezz = function ()

    ObjDelete( "spr_wallhangingcabinet_penguin_shadow" );
    ObjDelete( "gfx_wallhangingcabinet_penguin" );
    ObjDelete( "spr_wallhangingcabinet_overlap_penguin" );
    ObjDelete( "spr_kitchen_girl_penguin" );

  end;

  cmn.AddSubscriber( "get_penguin_2", get_penguin_2_inv );
  cmn.AddSubscriber( "get_penguin_2", get_penguin_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_2_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_2_2 = function ()

    ObjDelete( "spr_flower_collect2_2_2" );
    ObjDelete( "spr_flower_collect2_2_2_shadow" );

    if ( cmn.IsEventDone( "get_slingshotframe" ) and
         cmn.IsEventDone( "get_penguin_1" ) and
         cmn.IsEventDone( "get_hand_1" ) ) then

      ObjDelete( "gzz_kitchen_flower" );

    end;

  end;

  cmn.AddSubscriber( "get_collect2_2_2", get_collect2_2_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_2_2 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_2_2 = function ()

    ObjDelete( "obj_kitchen_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_2_2", get_morphobject_2_2, private.room_objname );
--*********************************************************************************************************************
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_plasticscrew () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_plasticscrew" ] =
  {
    type = "use",
    use_obj = "inv_plasticscrew",
    use_place = "obj_stove_use_plasticscrew",
    room = private.room_objname,
    zz = "zz_stove",
    zz_gate = "gzz_kitchen_stove"
  };
  -----------------------------------------------
  local use_plasticscrew_inv = function ()

    int.InventoryItemRemove( "inv_plasticscrew" );

  end;
  local use_plasticscrew_beg = function ()

    ObjDelete( "obj_stove_use_plasticscrew" );

  end;
  local use_plasticscrew_end = function ()

    ObjSet( "obj_stove_clk_gas", { input = true } );
    ObjSet( "spr_stove_toymushroom_mold", { alp = 1 } );
    ObjSet( "anm_stove_soldier_steam", { playing = true } );
    ObjSet( "spr_kitchen_inform", { alp = 1 } );
    ObjDelete( "anm_stove_soldier" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_plasticscrew", use_plasticscrew_beg, private.room_objname );
  cmn.AddSubscriber( "use_plasticscrew", use_plasticscrew_inv );
  cmn.AddSubscriber( "use_plasticscrew", use_plasticscrew_end, private.room_objname );
  cmn.AddSubscriber( "use_plasticscrew_inv", use_plasticscrew_inv, private.room_objname );
  cmn.AddSubscriber( "use_plasticscrew_beg", use_plasticscrew_beg, private.room_objname );
  cmn.AddSubscriber( "use_plasticscrew_end", use_plasticscrew_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mushroomsmold () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mushroomsmold" ] =
  {
    type = "use",
    use_obj = "inv_mushroomsmold",
    use_place = "obj_stove_use_mushroomsmold",
    room = private.room_objname,
    zz = "zz_stove",
    zz_gate = "gzz_kitchen_stove"
  };
  -----------------------------------------------
  local use_mushroomsmold_inv = function ()

    int.InventoryItemRemove( "inv_mushroomsmold" );

  end;
  local use_mushroomsmold_beg = function ()

    ObjDelete( "obj_stove_use_mushroomsmold" );

  end;
  local use_mushroomsmold_end = function ()

    ObjSet( "spr_stove_mushroomsmold",    { alp = 1 } );
    ObjSet( "spr_stove_mushroomsmold_red",    { alp = 1 } );
    ObjSet( "obj_stove_use_plasticscrew", { input = true } );
    ObjSet( "anm_stove_fire_mushroom", { alp = 1 } );
    ObjSet( "spr_kitchen_form", { alp = 1 } );
    ObjSet( "spr_kitchen_fire_add", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_mushroomsmold", use_mushroomsmold_beg, private.room_objname );
  cmn.AddSubscriber( "use_mushroomsmold", use_mushroomsmold_inv );
  cmn.AddSubscriber( "use_mushroomsmold", use_mushroomsmold_end, private.room_objname );
  cmn.AddSubscriber( "use_mushroomsmold_inv", use_mushroomsmold_inv, private.room_objname );
  cmn.AddSubscriber( "use_mushroomsmold_beg", use_mushroomsmold_beg, private.room_objname );
  cmn.AddSubscriber( "use_mushroomsmold_end", use_mushroomsmold_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tongs () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tongs" ] =
  {
    type = "use",
    use_obj = "inv_tongs",
    use_place = "obj_stove_use_tongs",
    room = private.room_objname,
    zz = "zz_stove",
    zz_gate = "gzz_kitchen_stove"
  };
  -----------------------------------------------
  local use_tongs_inv = function ()

    int.InventoryItemRemove( "inv_tongs" );

  end;
  local use_tongs_beg = function ()

    ObjDelete( "obj_stove_use_tongs" );

  end;
  local use_tongs_end = function ()

    --ObjSet( "spr_stove_gasstoveswitch_1", { alp = 1 } );
    --ObjSet( "obj_stove_clk_gas",          { input = true } );
    ObjDelete( "anm_stove_tongs" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_tongs", use_tongs_beg, private.room_objname );
  cmn.AddSubscriber( "use_tongs", use_tongs_inv );
  cmn.AddSubscriber( "use_tongs", use_tongs_end, private.room_objname );
  cmn.AddSubscriber( "use_tongs_inv", use_tongs_inv, private.room_objname );
  cmn.AddSubscriber( "use_tongs_beg", use_tongs_beg, private.room_objname );
  cmn.AddSubscriber( "use_tongs_end", use_tongs_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_razorblade () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_razorblade" ] =
  {
    type = "use",
    use_obj = "inv_razorblade",
    use_place = "obj_flower_use_razorblade",
    room = private.room_objname,
    zz = "zz_flower",
    zz_gate = "gzz_kitchen_flower"
  };
  -----------------------------------------------
  local use_razorblade_inv = function ()

    int.InventoryItemRemove( "inv_razorblade" );

  end;
  local use_razorblade_beg = function ()

    ObjDelete( "obj_flower_use_razorblade" );

  end;
  local use_razorblade_end = function ()

    ObjSet( "spr_flower_slingshotframe", { input = true, alp = 1 } );
    ObjSet( "gfx_flower_slingshotframe", { active = true } );
    ObjSet( "spr_flower_flower", { alp = 1 } );
    ObjSet( "spr_flower_hand_1_shadow", { alp = 1 } );
    ObjSet( "spr_flower_hand_1", { alp = 1 } );
    ObjSet( "spr_flower_stick", { alp = 1 } );
    ObjDelete( "anm_flower_clk_slingshotframe" );
    ObjDelete( "spr_flower_razor" );
    ObjDelete( "spr_kitchen_thread" );
    ObjDelete( "spr_flower_threads" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_razorblade", use_razorblade_beg, private.room_objname );
  cmn.AddSubscriber( "use_razorblade", use_razorblade_inv );
  cmn.AddSubscriber( "use_razorblade", use_razorblade_end, private.room_objname );
  cmn.AddSubscriber( "use_razorblade_inv", use_razorblade_inv, private.room_objname );
  cmn.AddSubscriber( "use_razorblade_beg", use_razorblade_beg, private.room_objname );
  cmn.AddSubscriber( "use_razorblade_end", use_razorblade_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_counterbutton () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_counterbutton" ] =
  {
    type = "use",
    use_obj = "inv_counterbutton",
    use_place = "obj_wall_use_counterbutton",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_kitchen_wall"
  };
  -----------------------------------------------
  local use_counterbutton_inv = function ()

    int.InventoryItemRemove( "inv_counterbutton" );

  end;
  local use_counterbutton_beg = function ()

    ObjDelete( "obj_wall_use_counterbutton" );

  end;
  local use_counterbutton_end = function ()

    ObjDelete( "anm_wall_2wires" );
    ObjDelete( "anm_wall_wires_click" );
    ObjSet( "obj_wall_button", { alp = 1 } );
    ObjSet( "obj_wall_clk_counterbutton", { input = true } );
    ObjSet( "spr_kitchen_button", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_counterbutton", use_counterbutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_counterbutton", use_counterbutton_inv );
  cmn.AddSubscriber( "use_counterbutton", use_counterbutton_end, private.room_objname );
  cmn.AddSubscriber( "use_counterbutton_inv", use_counterbutton_inv, private.room_objname );
  cmn.AddSubscriber( "use_counterbutton_beg", use_counterbutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_counterbutton_end", use_counterbutton_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pruners () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pruners" ] =
  {
    type = "use",
    use_obj = "inv_pruners",
    use_place = "obj_flower_use_pruners",
    room = private.room_objname,
    zz = "zz_flower",
    zz_gate = "gzz_kitchen_flower"
  };
  -----------------------------------------------
  local use_pruners_inv = function ()

    int.InventoryItemRemove( "inv_pruners" );

  end;
  local use_pruners_beg = function ()

    ObjDelete( "obj_flower_use_pruners" );

  end;
  local use_pruners_end = function ()

    ObjSet( "spr_flower_hand_1", { input = true } );
    ObjSet( "gfx_flower_hand_1", { active = true } );
    ObjDelete( "anm_flower_use_pruners" );
    ObjDelete( "anm_flower_clk_slingshotframe" );
    ObjDelete( "spr_flower_stick" );
    ObjDelete( "spr_kitchen_flower" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_pruners", use_pruners_beg, private.room_objname );
  cmn.AddSubscriber( "use_pruners", use_pruners_inv );
  cmn.AddSubscriber( "use_pruners", use_pruners_end, private.room_objname );
  cmn.AddSubscriber( "use_pruners_inv", use_pruners_inv, private.room_objname );
  cmn.AddSubscriber( "use_pruners_beg", use_pruners_beg, private.room_objname );
  cmn.AddSubscriber( "use_pruners_end", use_pruners_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_insulatingtape_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_insulatingtape_1" ] =
  {
    type = "use",
    use_obj = "inv_insulatingtape",
    use_place = "obj_wall_use_insulatingtape",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_kitchen_wall"
  };
  -----------------------------------------------
  local use_insulatingtape_1_inv = function ()

    if cmn.IsEventDone( "use_insulatingtape_2" ) then    
      int.InventoryItemRemove( "inv_insulatingtape" );    
    end;
    
    int.TaskDone( 1 );

  end;
  local use_insulatingtape_1_beg = function ()

    ObjDelete( "obj_wall_use_insulatingtape" );

  end;
  local use_insulatingtape_1_end = function ()

    ObjSet( "spr_wall_untanglewire_tape", { alp = 1 } );
    ObjSet( "spr_wall_boxkey", { input = true, active = true } );
    ObjDelete( "anm_wall_sparks" );
    ObjDelete( "anm_kitchen_wall_sparks" );
    ObjDelete( "anm_wall_smoke" );
    ObjDelete( "anm_kitchen_wall_smoke" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_insulatingtape_1", use_insulatingtape_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_insulatingtape_1", use_insulatingtape_1_inv );
  cmn.AddSubscriber( "use_insulatingtape_1", use_insulatingtape_1_end, private.room_objname );
  cmn.AddSubscriber( "use_insulatingtape_1_inv", use_insulatingtape_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_insulatingtape_1_beg", use_insulatingtape_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_insulatingtape_1_end", use_insulatingtape_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_snailamulet_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_snailamulet_1" ] =
  {
    type = "use",
    use_obj = "inv_snailamulet_1",
    use_place = "obj_shelvesonwall_use_snailamulet_1",
    room = private.room_objname,
    zz = "zz_shelvesonwall",
    zz_gate = "gzz_kitchen_shelvesonwall"
  };
  -----------------------------------------------
  local use_snailamulet_1_inv = function ()

    int.InventoryItemRemove( "inv_snailamulet_1" );

  end;
  local use_snailamulet_1_beg = function ()

    ObjDelete( "obj_shelvesonwall_use_snailamulet_1" );

  end;
  local use_snailamulet_1_end = function ()

    ObjSet( "spr_shelvesonwall_snail1", { alp = 1 } );
    ObjSet( "spr_kitchen_snail1", { alp = 1 } );

    if cmn.IsEventDone( "use_snailamulet_2" ) then

      ObjSet( "obj_shelvesonwall_open", { alp = 1, input = true } );
      ObjDelete( "spr_shelvesonwall_box_closed" );
      ObjSet( "spr_shelvesonwall_artificialflower", { active = true } );
      ObjSet( "spr_kitchen_open_box", { alp = 1 } );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_snailamulet_1", use_snailamulet_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_snailamulet_1", use_snailamulet_1_inv );
  cmn.AddSubscriber( "use_snailamulet_1", use_snailamulet_1_end, private.room_objname );
  cmn.AddSubscriber( "use_snailamulet_1_inv", use_snailamulet_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_snailamulet_1_beg", use_snailamulet_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_snailamulet_1_end", use_snailamulet_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hand_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hand_2" ] =
  {
    type = "use",
    use_obj = "inv_hand_1",
    use_place = "obj_shelvesonwall_use_hand_2",
    room = private.room_objname,
    zz = "zz_shelvesonwall",
    zz_gate = "gzz_kitchen_shelvesonwall"
  };
  -----------------------------------------------
  local use_hand_2_inv = function ()

    int.InventoryItemRemove( "inv_hand_1" );

  end;
  local use_hand_2_beg = function ()

    ObjDelete( "obj_shelvesonwall_use_hand_2" );

  end;
  local use_hand_2_end = function ()

    ObjSet( "spr_shelvesonwall_arrow1", { alp = 1, ang = -10.38 } );
    ObjSet( "spr_shelvesonwall_arrow2", { alp = 1, ang = -1.57 } );
    ObjSet( "obj_shelvesonwall_open_clock", { alp = 1, input = true } );
    ObjDelete( "spr_shelvesonwall_closed_door1" );
    ObjDelete( "spr_shelvesonwall_closed_door2" );

    ObjSet( "spr_shelvesonwall_cuckoo", { active = true } );

    ObjSet( "spr_kitchen_clockarrows", { alp = 1 } );
    ObjSet( "spr_kitchen_open_clock", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_hand_2", use_hand_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_hand_2", use_hand_2_inv );
  cmn.AddSubscriber( "use_hand_2", use_hand_2_end, private.room_objname );
  cmn.AddSubscriber( "use_hand_2_inv", use_hand_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_hand_2_beg", use_hand_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_hand_2_end", use_hand_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_spraynozzle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_spraynozzle" ] =
  {
    type = "use",
    use_obj = "inv_spraynozzle",
    use_place = "obj_shelvesonwall_use_spraynozzle",
    room = private.room_objname,
    zz = "zz_shelvesonwall",
    zz_gate = "gzz_kitchen_shelvesonwall"
  };
  -----------------------------------------------
  local use_spraynozzle_inv = function ()

    int.InventoryItemRemove( "inv_spraynozzle" );

  end;
  local use_spraynozzle_beg = function ()

    ObjDelete( "obj_shelvesonwall_use_spraynozzle" );

  end;
  local use_spraynozzle_end = function ()

    ObjSet( "spr_kitchen_cleaner_nozzle", { alp = 1 } );
    ObjSet( "spr_shelvesonwall_spraynozzle", { alp = 1 } );
    ObjSet( "obj_shelvesonwall_cleaner", { input = true } );
    ObjSet( "gfx_shelvesonwall_cleaner", { active = true, input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_spraynozzle", use_spraynozzle_beg, private.room_objname );
  cmn.AddSubscriber( "use_spraynozzle", use_spraynozzle_inv );
  cmn.AddSubscriber( "use_spraynozzle", use_spraynozzle_end, private.room_objname );
  cmn.AddSubscriber( "use_spraynozzle_inv", use_spraynozzle_inv, private.room_objname );
  cmn.AddSubscriber( "use_spraynozzle_beg", use_spraynozzle_beg, private.room_objname );
  cmn.AddSubscriber( "use_spraynozzle_end", use_spraynozzle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_cleaner () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cleaner" ] =
  {
    type = "use",
    use_obj = "inv_cleaner",
    use_place = "obj_flower_use_cleaner",
    room = private.room_objname,
    zz = "zz_flower",
    zz_gate = "gzz_kitchen_flower"
  };
  -----------------------------------------------
  local use_cleaner_inv = function ()

    int.InventoryItemRemove( "inv_cleaner" );

  end;
  local use_cleaner_beg = function ()

    ObjDelete( "obj_flower_use_cleaner" );

  end;
  local use_cleaner_end = function ()

    ObjDelete( "anm_flower_spray" );
    ObjSet( "spr_flower_penguin", { input = true, alp = 1 } );
    ObjSet( "gfx_flower_penguin", { active = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_cleaner", use_cleaner_beg, private.room_objname );
  cmn.AddSubscriber( "use_cleaner", use_cleaner_inv );
  cmn.AddSubscriber( "use_cleaner", use_cleaner_end, private.room_objname );
  cmn.AddSubscriber( "use_cleaner_inv", use_cleaner_inv, private.room_objname );
  cmn.AddSubscriber( "use_cleaner_beg", use_cleaner_beg, private.room_objname );
  cmn.AddSubscriber( "use_cleaner_end", use_cleaner_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_snailamulet_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_snailamulet_2" ] =
  {
    type = "use",
    use_obj = "inv_snailamulet_2",
    use_place = "obj_shelvesonwall_use_snailamulet_2",
    room = private.room_objname,
    zz = "zz_shelvesonwall",
    zz_gate = "gzz_kitchen_shelvesonwall"
  };
  -----------------------------------------------
  local use_snailamulet_2_inv = function ()

    int.InventoryItemRemove( "inv_snailamulet_2" );

  end;
  local use_snailamulet_2_beg = function ()

    ObjDelete( "obj_shelvesonwall_use_snailamulet_2" );

  end;
  local use_snailamulet_2_end = function ()

    ObjSet( "spr_shelvesonwall_snail2", { alp = 1 } );
    ObjSet( "spr_kitchen_snail2", { alp = 1 } );

    if cmn.IsEventDone( "use_snailamulet_1" ) then

      ObjSet( "obj_shelvesonwall_open", { alp = 1, input = true } );
      ObjDelete( "spr_shelvesonwall_box_closed" );
      ObjSet( "spr_shelvesonwall_artificialflower", { active = true } );
      ObjSet( "spr_kitchen_open_box", { alp = 1 } );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_snailamulet_2", use_snailamulet_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_snailamulet_2", use_snailamulet_2_inv );
  cmn.AddSubscriber( "use_snailamulet_2", use_snailamulet_2_end, private.room_objname );
  cmn.AddSubscriber( "use_snailamulet_2_inv", use_snailamulet_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_snailamulet_2_beg", use_snailamulet_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_snailamulet_2_end", use_snailamulet_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_artificialflower_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_artificialflower_2" ] =
  {
    type = "use",
    use_obj = "inv_artificialflower_2",
    use_place = "obj_wallhangingcabinet_use_artificialflower_2",
    room = private.room_objname,
    zz = "zz_wallhangingcabinet",
    zz_gate = "gzz_kitchen_wallhangingcabinet"
  };
  -----------------------------------------------
  local use_artificialflower_2_inv = function ()

    int.InventoryItemRemove( "inv_artificialflower_2" );

  end;
  local use_artificialflower_2_beg = function ()

    ObjDelete( "obj_wallhangingcabinet_use_artificialflower_2" );

  end;
  local use_artificialflower_2_end = function ()

    ObjSet( "obj_wallhangingcabinet_flower_red", { alp = 1 } );
    ObjSet( "spr_kitchen_wallflower_2", { alp = 1 } );

    if ( cmn.IsEventDone( "use_artificialflower_1" ) ) then

      ObjSet( "obj_wallhangingcabinet_left_door_close", { input = true } );
      ObjSet( "obj_wallhangingcabinet_right_door_close1", { input = true } );
      ObjDelete( "obj_wallhangingcabinet_clk_glove" );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_artificialflower_2", use_artificialflower_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_artificialflower_2", use_artificialflower_2_inv );
  cmn.AddSubscriber( "use_artificialflower_2", use_artificialflower_2_end, private.room_objname );
  cmn.AddSubscriber( "use_artificialflower_2_inv", use_artificialflower_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_artificialflower_2_beg", use_artificialflower_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_artificialflower_2_end", use_artificialflower_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_artificialflower_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_artificialflower_1" ] =
  {
    type = "use",
    use_obj = "inv_artificialflower_1",
    use_place = "obj_wallhangingcabinet_use_artificialflower_1",
    room = private.room_objname,
    zz = "zz_wallhangingcabinet",
    zz_gate = "gzz_kitchen_wallhangingcabinet"
  };
  -----------------------------------------------
  local use_artificialflower_1_inv = function ()

    int.InventoryItemRemove( "inv_artificialflower_1" );

  end;
  local use_artificialflower_1_beg = function ()

    ObjDelete( "obj_wallhangingcabinet_use_artificialflower_1" );

  end;
  local use_artificialflower_1_end = function ()

    ObjSet( "obj_wallhangingcabinet_flower_yellow", { alp = 1 } );
    ObjSet( "spr_kitchen_wallflower_1", { alp = 1 } );

    if ( cmn.IsEventDone( "use_artificialflower_2" ) ) then

      ObjSet( "obj_wallhangingcabinet_left_door_close", { input = true } );
      ObjSet( "obj_wallhangingcabinet_right_door_close1", { input = true } );
      ObjDelete( "obj_wallhangingcabinet_clk_glove" );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_artificialflower_1", use_artificialflower_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_artificialflower_1", use_artificialflower_1_inv );
  cmn.AddSubscriber( "use_artificialflower_1", use_artificialflower_1_end, private.room_objname );
  cmn.AddSubscriber( "use_artificialflower_1_inv", use_artificialflower_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_artificialflower_1_beg", use_artificialflower_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_artificialflower_1_end", use_artificialflower_1_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_gas () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_gas" ] =
  {
    type = "click",
    clk_obj = "obj_stove_clk_gas",
    room = private.room_objname,
    zz = "zz_stove",
    zz_gate = "gzz_kitchen_stove"
  };
  -----------------------------------------------
  local clk_gas = function ()


  end;
  -----------------------------------------------
  local clk_gas_beg = function ()

    ObjDelete( "obj_stove_clk_gas" );

  end;
  -----------------------------------------------
  local clk_gas_end = function ()

    ObjSet( "spr_stove_gasstoveswitch", { alp = 1 } );
    ObjSet( "spr_stove_mushroomsmold2", { alp = 1 } );
    
    ObjSet( "spr_stove_toymushroom_mold", { input = true } );
    ObjSet( "gfx_stove_toymushroom",      { active = true } );
    ObjDelete( "spr_stove_mushroomsmold" );
    ObjDelete( "anm_stove_soldier_steam" );
    ObjDelete( "anm_stove_fire2" );
    ObjDelete( "anm_stove_fire_mushroom" );
    ObjDelete( "spr_kitchen_fire" );
    ObjDelete( "spr_kitchen_inform_add" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_gas", clk_gas );
  cmn.AddSubscriber( "clk_gas", clk_gas_beg, private.room_objname );
  cmn.AddSubscriber( "clk_gas", clk_gas_end, private.room_objname );
  cmn.AddSubscriber( "clk_gas_beg", clk_gas_beg, private.room_objname );
  cmn.AddSubscriber( "clk_gas_end", clk_gas_end, private.room_objname );
  -----------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_counterbutton () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_counterbutton" ] =
  {
    type = "click",
    clk_obj = "obj_wall_clk_counterbutton",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_kitchen_wall"
  };
  -----------------------------------------------
  local clk_counterbutton = function ()


  end;
  -----------------------------------------------
  local clk_counterbutton_beg = function ()

    ObjDelete( "obj_wall_clk_counterbutton" );

  end;
  -----------------------------------------------
  local clk_counterbutton_end = function ()

    ObjSet( "spr_wall_button1", { pos_x = -198 } );
    ObjSet( "obj_wall_open", { input = true } );
    ObjSet( "spr_wall_door1", { alp = 1 } );
    --ObjSet( "spr_wall_file2", { active = true } );
    ObjSet( "spr_wall_electric_light", { active = true } );
    ObjSet( "spr_wall_sparks", { active = true } );
    ObjDelete( "spr_wall_door" );
    ObjSet( "spr_kitchen_open_wall", { alp = 1 } );
    ObjDelete( "spr_kitchen_closed_wall" );
    ObjDelete( "spr_wall_sparks_over" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_counterbutton", clk_counterbutton );
  cmn.AddSubscriber( "clk_counterbutton", clk_counterbutton_beg, private.room_objname );
  cmn.AddSubscriber( "clk_counterbutton", clk_counterbutton_end, private.room_objname );
  cmn.AddSubscriber( "clk_counterbutton_beg", clk_counterbutton_beg, private.room_objname );
  cmn.AddSubscriber( "clk_counterbutton_end", clk_counterbutton_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_wallhangingcabinet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_wallhangingcabinet" ] =
  {
    type = "win",
    room = private.room_objname,
    zz = "zz_wallhangingcabinet",
    zz_gate = "gzz_kitchen_wallhangingcabinet"
  };

  local win_wallhangingcabinet = function ()

    if ( cmn.IsEventDone( "win_wallhangingcabinet" ) ) then

      ObjDelete( "obj_wallhangingcabinet_cabinet_close" );
      ObjDelete( "spr_kitchen_wallflower_1" );
      ObjDelete( "spr_kitchen_wallflower_2" );
      ObjSet( "spr_wallhangingcabinet_insulatingtape", { active = true, input = true } );
      ObjSet( "spr_wallhangingcabinet_rubbergloves",   { active = true, input = true } );
      ObjSet( "obj_wallhangingcabinet_cabinet_open",   { alp = 1 } );
      ObjSet( "spr_kitchen_open_shelves",              { alp = 1 } );

    else

      private.WallhangingcabinetLoad();

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "win_wallhangingcabinet", win_wallhangingcabinet, private.room_objname );
  -----------------------------------------------

end;
--*********************************************************************************************************************
function private.get_butler ()

  cmn.SetEventDone( "get_butler" );
  cmn.CallEventHandler( "get_butler" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_butler" ) and
       cmn.IsEventDone( "get_sausage" ) and
       cmn.IsEventDone( "get_toymushroom" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_sausage ()

  cmn.SetEventDone( "get_sausage" );
  cmn.CallEventHandler( "get_sausage" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_butler" ) and
       cmn.IsEventDone( "get_sausage" ) and
       cmn.IsEventDone( "get_toymushroom" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_toymushroom ()

  ObjSet( "spr_stove_toy_mushroom", { alp = 1 } );

  cmn.SetEventDone( "get_toymushroom" );
  cmn.CallEventHandler( "get_toymushroom" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_butler" ) and
       cmn.IsEventDone( "get_sausage" ) and
       cmn.IsEventDone( "get_toymushroom" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_slingshotframe ()

  cmn.SetEventDone( "get_slingshotframe" );
  cmn.CallEventHandler( "get_slingshotframe" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_slingshotframe" ) and
       cmn.IsEventDone( "get_collect2_2_2" ) and
       cmn.IsEventDone( "get_penguin_1" ) and
       cmn.IsEventDone( "get_hand_1" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_hand_1 ()

  cmn.SetEventDone( "get_hand_1" );
  cmn.CallEventHandler( "get_hand_1" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_slingshotframe" ) and
       cmn.IsEventDone( "get_collect2_2_2" ) and
       cmn.IsEventDone( "get_penguin_1" ) and
       cmn.IsEventDone( "get_hand_1" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_artificialflower_2 ()

  cmn.SetEventDone( "get_artificialflower_2" );
  cmn.CallEventHandler( "get_artificialflower_2" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_artificialflower_2" ) and
       --cmn.IsEventDone( "get_doordowel_1" ) and
       cmn.IsEventDone( "get_cuckoo" ) and
       cmn.IsEventDone( "get_cleaner" ) and
       cmn.IsEventDone( "get_plasticscrew" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
--function private.get_doordowel_1 ()
--
--  cmn.SetEventDone( "get_doordowel_1" );
--  cmn.CallEventHandler( "get_doordowel_1" );
--  
--  cmn.GetObjectSfx();
--
--  if ( cmn.IsEventDone( "get_artificialflower_2" ) and
--       cmn.IsEventDone( "get_doordowel_1" ) and
--       cmn.IsEventDone( "get_cuckoo" ) and
--       cmn.IsEventDone( "get_cleaner" ) and
--       cmn.IsEventDone( "get_plasticscrew" ) ) then
--
--    cmn.CloseSubRoom();
--
--  end;
--
--end;
-------------------------------------------------
function private.get_cuckoo ()

  cmn.SetEventDone( "get_cuckoo" );
  cmn.CallEventHandler( "get_cuckoo" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_artificialflower_2" ) and
       --cmn.IsEventDone( "get_doordowel_1" ) and
       cmn.IsEventDone( "get_cuckoo" ) and
       cmn.IsEventDone( "get_cleaner" ) and
       cmn.IsEventDone( "get_plasticscrew" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_plasticscrew ()

  cmn.SetEventDone( "get_plasticscrew" );
  cmn.CallEventHandler( "get_plasticscrew" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_artificialflower_2" ) and
       --cmn.IsEventDone( "get_doordowel_1" ) and
       cmn.IsEventDone( "get_cuckoo" ) and
       cmn.IsEventDone( "get_cleaner" ) and
       cmn.IsEventDone( "get_plasticscrew" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_rubbergloves ()

  cmn.SetEventDone( "get_rubbergloves" );
  cmn.CallEventHandler( "get_rubbergloves" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_insulatingtape" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_insulatingtape ()

  cmn.SetEventDone( "get_insulatingtape" );
  cmn.CallEventHandler( "get_insulatingtape" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_rubbergloves" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_hanky2 ()

  cmn.SetEventDone( "get_hanky2" );
  cmn.CallEventHandler( "get_hanky2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_boxkey ()

  cmn.SetEventDone( "get_boxkey" );
  cmn.CallEventHandler( "get_boxkey" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_boxkey" ) and
       cmn.IsEventDone( "get_wire" ) ) then
    cmn.CloseSubRoom();
  end;

end;
-------------------------------------------------
function private.get_wire ()

  cmn.SetEventDone( "get_wire" );
  cmn.CallEventHandler( "get_wire" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_boxkey" ) and
       cmn.IsEventDone( "get_wire" ) ) then
    cmn.CloseSubRoom();
  end;

end;
-------------------------------------------------
function private.get_cleaner ()

  cmn.SetEventDone( "get_cleaner" );
  cmn.CallEventHandler( "get_cleaner" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_penguin_1 ()

  cmn.SetEventDone( "get_penguin_1" );
  cmn.CallEventHandler( "get_penguin_1" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_slingshotframe" ) and
       cmn.IsEventDone( "get_collect2_2_2" ) and
       cmn.IsEventDone( "get_penguin_1" ) and
       cmn.IsEventDone( "get_hand_1" ) ) then

    cmn.CloseSubRoom();

  end;

end;
---------------------------------------------------------------------------------
function private.get_penguin_2 ()

  cmn.SetEventDone( "get_penguin_2" );
  cmn.CallEventHandler( "get_penguin_2" );
  
  cmn.GetObjectSfx();

end;
---------------------------------------------------------------------------------
---------------------------------------------------------------------------------
function private.get_collect2_2_2()

  int.AddCollectibles2( "spr_flower_collect2_2_2" );

  local func_end = function ()

    if ( cmn.IsEventDone( "get_slingshotframe" ) and
         cmn.IsEventDone( "get_penguin_1" ) and
         cmn.IsEventDone( "get_hand_1" ) ) then

      cmn.CloseSubRoom();

    end;

  end;

  ObjAnimate( "zz_flower", "alp", 0, 0, func_end,
  { 
    0.0, 0, 1.0, 
    0.7, 0, 1.0
  } );

end;
--*********************************************************************************************************************
-------------------------------------------------
function public.use_plasticscrew ()

  local item = "inv_plasticscrew";

  if ( cmn.ApplyObj( item, "gzz_kitchen_stove", false ) and 
       cmn.IsEventDone( "use_mushroomsmold" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stove" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stove_use_plasticscrew", true ) and
           cmn.IsEventDone( "use_mushroomsmold" ) ) then

    cmn.CallEventHandler( "use_plasticscrew_inv" );
    cmn.CallEventHandler( "use_plasticscrew_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_plasticscrew" );
      cmn.CallEventHandler( "use_plasticscrew_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_melting_tin" );  
    ObjSet( "anm_stove_soldier", { alp = 1 } );
    AnimPlay( "anm_stove_soldier", "DoAnim", func_end ) 

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_mushroomsmold ()

  local item = "inv_mushroomsmold";

  if ( cmn.ApplyObj( item, "gzz_kitchen_stove", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stove" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stove_use_mushroomsmold", true ) ) then

    cmn.CallEventHandler( "use_mushroomsmold_inv" );
    cmn.CallEventHandler( "use_mushroomsmold_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_mushroomsmold" );
      cmn.CallEventHandler( "use_mushroomsmold_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_place_on_gas_stove" );  
    ObjAnimate( "spr_stove_mushroomsmold", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_stove_mushroomsmold_red", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.5, 0, 0.0, 
      0.8, 0, 1.0
    } );
    ObjAnimate( "anm_stove_fire_mushroom", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_tongs ()

  local item = "inv_tongs";

  if ( cmn.ApplyObj( item, "gzz_kitchen_stove", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stove" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stove_use_tongs", true ) ) then

    cmn.CallEventHandler( "use_tongs_inv" );
    cmn.CallEventHandler( "use_tongs_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_tongs" );
      cmn.CallEventHandler( "use_tongs_end" );
      int.Lock( false );

      private.get_sausage();

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_take_sausage" );  
    AnimPlay( "anm_stove_tongs", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_razorblade ()

  local item = "inv_razorblade";

  if ( cmn.ApplyObj( item, "gzz_kitchen_flower", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_flower" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_flower_use_razorblade", true ) ) then

    cmn.CallEventHandler( "use_razorblade_inv" );
    cmn.CallEventHandler( "use_razorblade_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_razorblade" );
      cmn.CallEventHandler( "use_razorblade_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_flower_cutting" );  
    ObjAnimate( "spr_flower_razor", "pos_xy", 0, 0, func_end,
    { 
      0.0,0,247,-175, 
      0.5,2, 19, -85,
      0.7,0, 19, -85,
      1.1,3, 22,  18,
      1.3,0, 22,  18,
      1.7,0,247,-175
    } );
    ObjAnimate("spr_flower_threads", "alp", 0, 0, "", 
    {
      0.0,0,1,
      0.7,0,1,
      1.1,0,0
    });

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_counterbutton ()

  local item = "inv_counterbutton";

  if ( cmn.ApplyObj( item, "gzz_kitchen_wall", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wall" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wall_use_counterbutton", true ) ) then

    cmn.CallEventHandler( "use_counterbutton_inv" );
    cmn.CallEventHandler( "use_counterbutton_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_counterbutton" );
      cmn.CallEventHandler( "use_counterbutton_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_electro_butt" );  
    ObjAnimate( "anm_wall_2wires", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    ObjAnimate( "obj_wall_button", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_pruners ()

  local item = "inv_pruners";

  if ( cmn.ApplyObj( item, "gzz_kitchen_flower", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_flower" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_flower_use_pruners", true ) ) then

    cmn.CallEventHandler( "use_pruners_inv" );
    cmn.CallEventHandler( "use_pruners_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_pruners" );
      cmn.CallEventHandler( "use_pruners_end" );
      ObjSet( "obj_flower_flower", { alp = 1 } );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_cutting_rose" );  
    ObjSet( "anm_flower_use_pruners", { alp = 1 } );
    ObjSet( "obj_flower_flower", { alp = 0 } );
    AnimPlay( "anm_flower_use_pruners", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_insulatingtape_1 ()

  local item = "inv_insulatingtape";

  if ( cmn.ApplyObj( item, "gzz_kitchen_wall", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wall" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wall_use_insulatingtape", true ) ) then

    cmn.CallEventHandler( "use_insulatingtape_1_inv" );
    cmn.CallEventHandler( "use_insulatingtape_1_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_insulatingtape_1" );
      cmn.CallEventHandler( "use_insulatingtape_1_end" );
      int.Lock( false );

    end;
    
    cmn.StopAudio( "env", "audio/level2/env/aud_zz_wall_open_env", 1 );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_use_tape" );  
    ObjAnimate( "spr_wall_untanglewire_tape", "alp", 0, 0, function () int.ShowTaskNote( 1, func_end ); end, 
    { 
      0.0, 0, 0,
      0.3, 0, 1,
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_snailamulet_1 ()

  local item = "inv_snailamulet_1";

  if ( cmn.ApplyObj( item, "gzz_kitchen_shelvesonwall", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shelvesonwall" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_shelvesonwall_use_snailamulet_1", true ) ) then

    cmn.CallEventHandler( "use_snailamulet_1_inv" );
    cmn.CallEventHandler( "use_snailamulet_1_beg" );
    int.Lock( true );

    local func_end = function ()

      local func_end = function ()

        cmn.SetEventDone( "use_snailamulet_1" );
        cmn.CallEventHandler( "use_snailamulet_1_end" );
        int.Lock( false );

      end;

      if cmn.IsEventDone( "use_snailamulet_2" ) then

        cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_snailbox_open" ); 
        ObjAnimate( "obj_shelvesonwall_open", "alp", 0, 0, "",
        { 
          0.0, 0, 0.0, 
          0.3, 0, 1.0
        } );
        ObjAnimate( "spr_shelvesonwall_box_closed", "alp", 0, 0, func_end,
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );

      else 

        func_end();

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_snail_app" );  

    ObjAnimate( "spr_shelvesonwall_snail1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_hand_2 ()

  local item = "inv_hand_1";

  if ( cmn.ApplyObj( item, "gzz_kitchen_shelvesonwall", false ) and 
       cmn.IsEventDone( "get_hand_1" ) and
       cmn.IsEventDone( "get_hand_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shelvesonwall" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_shelvesonwall_use_hand_2", true ) and
           cmn.IsEventDone( "get_hand_1" ) and
           cmn.IsEventDone( "get_hand_2" ) ) then

    cmn.CallEventHandler( "use_hand_2_inv" );
    cmn.CallEventHandler( "use_hand_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_hand_2" );
      cmn.CallEventHandler( "use_hand_2_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_apply_arrows_clock" );  

    ObjAnimate( "spr_shelvesonwall_arrow1", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_shelvesonwall_arrow2", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_shelvesonwall_arrow1", "ang", 0, 0, "",
    { 
      0.0, 3, 0.0,
      0.6, 3, 0.0,  
      1.6, 3, -10.38
    } );
    ObjAnimate( "spr_shelvesonwall_arrow2", "ang", 0, 0, "",
    { 
      0.0, 3, 0.0,
      0.6, 3, 0.0,  
      1.6, 3, -1.57
    } );
    ObjAnimate( "spr_shelvesonwall_closed_door1", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      1.6, 0, 1.0, 
      1.9, 0, 0.0
    } );
    ObjAnimate( "spr_shelvesonwall_closed_door2", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      1.6, 0, 1.0, 
      1.9, 0, 0.0
    } );
    ObjAnimate( "obj_shelvesonwall_open_clock", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      1.6, 0, 0.0, 
      1.9, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_spraynozzle ()

  local item = "inv_spraynozzle";

  if ( cmn.ApplyObj( item, "gzz_kitchen_shelvesonwall", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shelvesonwall" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_shelvesonwall_use_spraynozzle", true ) ) then

    cmn.CallEventHandler( "use_spraynozzle_inv" );
    cmn.CallEventHandler( "use_spraynozzle_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_spraynozzle" );
      cmn.CallEventHandler( "use_spraynozzle_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_assemble_sprayer" ); 

    ObjAnimate( "spr_shelvesonwall_spraynozzle", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_cleaner ()

  local item = "inv_cleaner";

  if ( cmn.ApplyObj( item, "gzz_kitchen_flower", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_flower" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_flower_use_cleaner", true ) ) then

    cmn.CallEventHandler( "use_cleaner_inv" );
    cmn.CallEventHandler( "use_cleaner_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_cleaner" );
      cmn.CallEventHandler( "use_cleaner_end" );
      int.Lock( false );
      private.get_penguin_1();

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_use_sprayer" );
    AnimPlay( "anm_flower_spray", "DoAnim", func_end ) 

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_snailamulet_2 ()

  local item = "inv_snailamulet_2";

  if ( cmn.ApplyObj( item, "gzz_kitchen_shelvesonwall", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shelvesonwall" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_shelvesonwall_use_snailamulet_2", true ) ) then

    cmn.CallEventHandler( "use_snailamulet_2_inv" );
    cmn.CallEventHandler( "use_snailamulet_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_snailamulet_2" );
      cmn.CallEventHandler( "use_snailamulet_2_end" );
      int.Lock( false );

    end;

    local func_end = function ()

      local func_end = function ()

        cmn.SetEventDone( "use_snailamulet_2" );
        cmn.CallEventHandler( "use_snailamulet_2_end" );
        int.Lock( false );

      end;

      if cmn.IsEventDone( "use_snailamulet_1" ) then

        cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_snailbox_open" );  
        ObjAnimate( "obj_shelvesonwall_open", "alp", 0, 0, "",
        { 
          0.0, 0, 0.0, 
          0.3, 0, 1.0
        } );
        ObjAnimate( "spr_shelvesonwall_box_closed", "alp", 0, 0, func_end,
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0
        } );

      else 

        func_end();

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_snail_app" );  

    ObjAnimate( "spr_shelvesonwall_snail2", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_artificialflower_2 ()

  local item = "inv_artificialflower_2";

  if ( cmn.ApplyObj( item, "gzz_kitchen_wallhangingcabinet", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wallhangingcabinet" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wallhangingcabinet_use_artificialflower_2", true ) ) then

    cmn.CallEventHandler( "use_artificialflower_2_inv" );
    cmn.CallEventHandler( "use_artificialflower_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_artificialflower_2" );
      cmn.CallEventHandler( "use_artificialflower_2_end" );
      int.Lock( false );

      if ( cmn.IsEventDone( "use_artificialflower_1" ) ) then

        ng_global.progress[ "std" ][ "win_wallhangingcabinet" ].flower =
        {
          [ "red" ]    = { "red", "violet", "violet", "yellow", "blue", "yellow", "red" },
          [ "violet" ] = { "blue", "red", "blue", "red", "yellow", "violet", "violet" },
          [ "blue" ]   = { "violet", "blue", "yellow", "violet", "red", "blue", "yellow" },
          [ "yellow" ] = { "yellow", "yellow", "red", "blue", "violet", "red", "blue" },
        };
        
        common_impl.PassingMgStart( "wallhangingcabinet" );

        cmn.MiniGameShow( "wallhangingcabinet" );

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_app_plastic_flower" ); 
    ObjAnimate( "obj_wallhangingcabinet_flower_red", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_artificialflower_1 ()

  local item = "inv_artificialflower_1";

  if ( cmn.ApplyObj( item, "gzz_kitchen_wallhangingcabinet", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wallhangingcabinet" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wallhangingcabinet_use_artificialflower_1", true ) ) then

    cmn.CallEventHandler( "use_artificialflower_1_inv" );
    cmn.CallEventHandler( "use_artificialflower_1_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_artificialflower_1" );
      cmn.CallEventHandler( "use_artificialflower_1_end" );
      int.Lock( false );

      if ( cmn.IsEventDone( "use_artificialflower_2" ) ) then

        ng_global.progress[ "std" ][ "win_wallhangingcabinet" ].flower =
        {
          [ "red" ]    = { "red", "violet", "violet", "yellow", "blue", "yellow", "red" },
          [ "violet" ] = { "blue", "red", "blue", "red", "yellow", "violet", "violet" },
          [ "blue" ]   = { "violet", "blue", "yellow", "violet", "red", "blue", "yellow" },
          [ "yellow" ] = { "yellow", "yellow", "red", "blue", "violet", "red", "blue" },
        };

        common_impl.PassingMgStart( "wallhangingcabinet" );
        cmn.MiniGameShow( "wallhangingcabinet" );

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_app_plastic_flower" ); 
    ObjAnimate( "obj_wallhangingcabinet_flower_yellow", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_gas ()

  local func_end = function ()

    cmn.SetEventDone( "clk_gas" );
    cmn.CallEventHandler( "clk_gas_end" );
    cmn.CallEventHandler( "clk_gas" );
    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_gas_beg" );

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_gas_stove_handle_off" );
  ObjAnimate( "spr_stove_gasstoveswitch", "alp", 0, 0, "", 
  {
    0.0,0,0,
    0.3,0,1
  } );
  ObjAnimate( "anm_stove_fire2", "alp", 0, 0, "", 
  {
    0.0,0,1,
    0.6,0,1,
    0.9,0,0
  } );
  ObjAnimate( "anm_stove_fire_mushroom", "alp", 0, 0, "", 
  {
    0.0,0,1,
    0.6,0,1,
    0.9,0,0
  } );
  ObjAnimate( "spr_stove_mushroomsmold", "alp", 0, 0, "", 
  {
    0.0,0,1,
    1.2,0,1,
    1.5,0,0
  } );
  ObjAnimate( "anm_stove_soldier_steam", "alp", 0, 0, func_end, 
  {
    0.0,0,1,
    1.2,0,1,
    1.5,0,0
  } );
  
  ObjAnimate( "spr_stove_mushroomsmold2", "alp", 0, 0, "", 
  {
    0.0,0,0,
    1.2,0,0,
    1.5,0,1
  } );

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_counterbutton ()

  if cmn.IsEventDone( "get_hanky2" ) then

    local func_end = function ()

      cmn.SetEventDone( "clk_counterbutton" );
      cmn.CallEventHandler( "clk_counterbutton_end" );
      cmn.CallEventHandler( "clk_counterbutton" );
      int.Lock( false );

    end;

    cmn.CallEventHandler( "clk_counterbutton_beg" );

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_push_electro_butt" );
    ObjAnimate( "spr_wall_button1", "pos_x", 0, 0, "", 
    { 
      0.0, 3, -204,
      0.2, 3, -198
    } );
    ObjAnimate( "spr_wall_door", "alp", 0, 0, "", 
    { 
      0.0, 0, 1,
      0.5, 0, 1,
      0.8, 0, 0
    } );
    ObjAnimate( "spr_wall_sparks_over", "alp", 0, 0, "",
    { 
      0.0, 0, 1,
      0.5, 0, 1,
      0.8, 0, 0
    } );
    ObjAnimate( "spr_wall_door1", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.5, 0, 0,
      0.8, 0, 1
    } );

  end;

end;
-------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_kitchen ()

  if not ( cmn.IsEventDone( "opn_kitchen" ) ) then

    cmn.SetEventDone( "opn_kitchen" );
    private.FirstOpen();

  end;

end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopAllEnv( "audio/level2/env/aud_kitchen_env", true );
  cmn.PlayAudio( "env", "audio/level2/env/aud_kitchen_env", 1 );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Open ()

  private.opn_kitchen();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_butler" ); 
  int.AddedTaskMap( private.room_objname, "get_sausage",                    { "use_tongs" } ); 
  int.AddedTaskMap( private.room_objname, "get_toymushroom",                { "clk_gas" } );
  int.AddedTaskMap( private.room_objname, "get_slingshotframe",             { "use_razorblade" } );
  int.AddedTaskMap( private.room_objname, "get_hand_1",                     { "use_pruners" } ); 
  int.AddedTaskMap( private.room_objname, "get_artificialflower_2",         { "use_snailamulet_1", "use_snailamulet_2" } ); 
  int.AddedTaskMap( private.room_objname, "get_cuckoo",                     { "use_hand_2" } );
  int.AddedTaskMap( private.room_objname, "get_plasticscrew",               { "get_cuckoo" } );  
  int.AddedTaskMap( private.room_objname, "get_rubbergloves",               { "win_wallhangingcabinet" } );  
  int.AddedTaskMap( private.room_objname, "get_insulatingtape",             { "win_wallhangingcabinet" } ); 
  int.AddedTaskMap( private.room_objname, "get_hanky2" );
  int.AddedTaskMap( private.room_objname, "get_boxkey",                     { "use_insulatingtape_1" } ); 
  int.AddedTaskMap( private.room_objname, "get_wire",                       { "clk_counterbutton" } ); 
  int.AddedTaskMap( private.room_objname, "get_cleaner",                    { "use_spraynozzle" } ); 
  int.AddedTaskMap( private.room_objname, "get_penguin_1",                  { "use_cleaner" } ); 
  int.AddedTaskMap( private.room_objname, "get_penguin_2" ); 

  int.AddedTaskMap( private.room_objname, "use_plasticscrew",               { "use_mushroomsmold", "get_plasticscrew" } );
  int.AddedTaskMap( private.room_objname, "use_mushroomsmold",              { "get_mushroomsmold" } );   
  int.AddedTaskMap( private.room_objname, "use_tongs",                      { "get_tongs" } );
  int.AddedTaskMap( private.room_objname, "use_razorblade",                 { "get_razorblade" } ); 
  int.AddedTaskMap( private.room_objname, "use_counterbutton",              { "get_counterbutton" } );  
  int.AddedTaskMap( private.room_objname, "use_pruners",                    { "get_pruners" } ); 
  int.AddedTaskMap( private.room_objname, "use_insulatingtape_1",           { "get_insulatingtape", "clk_counterbutton" } );  
  int.AddedTaskMap( private.room_objname, "use_snailamulet_1",              { "get_snailamulet_1" } );
  int.AddedTaskMap( private.room_objname, "use_hand_2",                     { "get_hand_1" }, { "get_hand_2" } ); 
  int.AddedTaskMap( private.room_objname, "use_spraynozzle",                { "get_spraynozzle" } );
  int.AddedTaskMap( private.room_objname, "use_cleaner",                    { "get_cleaner" } ); 
  int.AddedTaskMap( private.room_objname, "use_snailamulet_2",              { "get_snailamulet_2" } );  
  int.AddedTaskMap( private.room_objname, "use_artificialflower_1",         { "get_artificialflower_1" } ); 
  int.AddedTaskMap( private.room_objname, "use_artificialflower_2",         { "get_artificialflower_2" } );

  int.AddedTaskMap( private.room_objname, "clk_gas",                        { "use_plasticscrew" } );  
  int.AddedTaskMap( private.room_objname, "clk_counterbutton",              { "use_counterbutton" } );  

  int.AddedTaskMap( private.room_objname, "win_wallhangingcabinet",         { "use_artificialflower_1", "use_artificialflower_2" } );  

end;
--*********************************************************************************************************************
function private.InitSubroom ()
  
  subroom.Define( "zz_wallhangingcabinet" );
  subroom.Define( "zz_wall" );
  subroom.Define( "zz_shelvesonwall" );
  -------------------------------------------------
  function zz_shelvesonwall.Close ()
    
    if not ObjGet( "obj_shelvesonwall_clk_timer" ).input then
      cmn.StopAudio( "sfx", "audio/level2/sfx/aud_timer" );
      AnimStop( "anm_shelvesonwall_timer" );
      ObjSet( "obj_shelvesonwall_clk_timer", { input = true } ); 
    end;  
    
  end;  
  -------------------------------------------------
  function zz_wall.PreOpen ()

    if not ( cmn.IsEventDone( "use_insulatingtape_1" ) ) then
      cmn.PlayAudio( "env", "audio/level2/env/aud_zz_wall_open_env", 1 );
    end;

  end;
  -------------------------------------------------
  function zz_wall.Close ()
    if not ( cmn.IsEventDone( "use_insulatingtape_1" ) ) then
      cmn.StopAudio( "env", "audio/level2/env/aud_zz_wall_open_env", 1 );
    end;
  end;
  -------------------------------------------------
  function zz_wallhangingcabinet.Open ()

    if ( cmn.IsEventDone( "use_artificialflower_1" ) and
         cmn.IsEventDone( "use_artificialflower_2" ) and
         not cmn.IsEventDone( "win_wallhangingcabinet" ) ) then
         
      common_impl.PassingMgStart( "wallhangingcabinet" );
      cmn.MiniGameShow( "wallhangingcabinet" );

    end;

  end;
  -------------------------------------------------
  function zz_wallhangingcabinet.PreClose ()

    if ( cmn.IsEventDone( "use_artificialflower_1" ) and
         cmn.IsEventDone( "use_artificialflower_2" ) and
         not cmn.IsEventDone( "win_wallhangingcabinet" ) ) then

      common_impl.PassingMgStop( "wallhangingcabinet" );  
      cmn.MiniGameHide( "wallhangingcabinet" );

    end;

  end;
  -------------------------------------------------
  function zz_wallhangingcabinet.Skip ()

    int.Lock( true );

    for f = 1, private.flower_count do

      for c = 1, private.leaf_count do

        local leaf = "spr_wallhangingcabinet_flower_"..private.flower_color[ f ].."_"..c;

        ObjAnimate( leaf, "alp", 0, 0, "", 
        {
          0.0, 3, 1.0,
          0.3, 3, 0.0,
          0.6, 3, 1.0,
        } );

        ObjAnimate( leaf, "scale_x", 0, 0,
        function ()

          ObjAttach( leaf, "obj_wallhangingcabinet_flower_"..private.flower_color[ f ] );

        end, 
        {
          0.0, 3, 1.0,
          0.3, 3, 1.0,
        } );

      end;

    end;

    ObjSet( "tmr_wallhangingcabinet_win", { playing = 1, time = 0.7, endtrig = function() cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_kitchen_win" ); end  } ); 
    ObjAnimate( "obj_wallhangingcabinet_cabinet_close", "alp", 0, 0,
    function ()

      int.Lock( false );

      private.WallhangingcabinetWin();

    end, 
    {
      0.0, 3, 1.0,
      0.7, 3, 1.0,
      1.0, 3, 0.0,
    } );

    ObjAnimate( "obj_wallhangingcabinet_cabinet_open", "alp", 0, 0, "", 
    {
      0.0, 3, 0.0,
      0.7, 3, 0.0,
      1.0, 3, 1.0,
    } );

  end;
  -------------------------------------------------
  function zz_wallhangingcabinet.Reset ()

    ng_global.progress[ "std" ][ "win_wallhangingcabinet" ].flower =
    {
      [ "red" ]    = { "red", "violet", "violet", "yellow", "blue", "yellow", "red" },
      [ "violet" ] = { "blue", "red", "blue", "red", "yellow", "violet", "violet" },
      [ "blue" ]   = { "violet", "blue", "yellow", "violet", "red", "blue", "yellow" },
      [ "yellow" ] = { "yellow", "yellow", "red", "blue", "violet", "red", "blue" },
    };

    private.WallhangingcabinetLoad();

  end;

end;
--*********************************************************************************************************************
function private.Anims ()

  ObjAnimate( "spr_wall_light_add", "alp", 1, 0, "", 
  {
    0.0, 0, 1,
    1.5, 0, 0.5,
    3.0, 0, 1
  } );

  ObjAnimate( "spr_kitchen_light", "alp", 1, 0, "", 
  {
    0.0, 0, 0.3,
    1.5, 0, 1.0,
    3.0, 0, 0.3
  } );

  ObjAnimate( "spr_flower_light_add", "alp", 1, 0, "", 
  {
    0.0, 0, 1,
    1.5, 0, 0.5,
    3.0, 0, 1
  } );

  ObjAnimate( "spr_kitchen_tree", "ang", 1, 0, "", 
  {
    0.0, 3, 0.05,
    7.0, 3, 0,
    14.0, 3, 0.05
  } );

  ObjAnimate( "spr_flower_arrow_glow", "alp", 1, 0, "", 
  {
    0.0, 3, 1,
    2.0, 3, 0,
    4.0, 3, 1
  } );

  ObjAnimate( "spr_wall_boxkey_add", "alp", 1, 0, "", 
  {
    0.0, 3, 1,
    2.0, 3, 0,
    4.0, 3, 1
  } );

end;
--*********************************************************************************************************************
function private.KitchenCabinetDoorClick ()

  local func_end = function ()

    if cmn.IsEventDone( "use_artificialflower_1" ) or cmn.IsEventDone( "use_artificialflower_2" ) then
      cmn.ShowBbt( "bbt_wallhangingcabinet_use_artificialflower_2" );
    else 
      cmn.ShowBbt( "bbt_wallhangingcabinet_use_artificialflower_1" );
    end;

    int.Lock( false );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_buffet_touch" );

  ObjAnimate( "obj_wallhangingcabinet_penguin", "scale_x", 0, 0, "", 
  {
    0.0, 3, 1.00,
    0.2, 3, 0.99,
    0.4, 3, 1.00,
    0.6, 3, 0.99,
    0.8, 3, 1.00,
  } );

  ObjAnimate( "obj_wallhangingcabinet_right_door_close", "scale_x", 0, 0, "", 
  {
    0.0, 3, 1.00,
    0.2, 3, 0.99,
    0.4, 3, 1.00,
    0.6, 3, 0.99,
    0.8, 3, 1.00,
  } );

  ObjAnimate( "obj_wallhangingcabinet_left_door_close", "scale_x", 0, 0, func_end, 
  {
    0.0, 3, 1.00,
    0.2, 3, 0.99,
    0.4, 3, 1.00,
    0.6, 3, 0.99,
    0.8, 3, 1.00,
  } );

end;
--*********************************************************************************************************************
function private.ClkClockHand ()

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_arrow_touch" );
  ObjAnimate("spr_flower_arrow_glow", "ang", 0, 0,"", 
  {
    0.0,0, 0.00,
    0.2,0, 0.05,
    0.6,0,-0.05,
    0.8,0, 0.00
  });
  ObjAnimate("spr_flower_hand_1", "ang", 0, 0, 
  function()
    int.Lock( false );
    cmn.ShowBbt( "bbt_flower_use_pruners" );
  end, 
  {
    0.0,0, 0.00,
    0.2,0, 0.05,
    0.6,0,-0.05,
    0.8,0, 0.00
  });

end;
--*********************************************************************************************************************
function private.ClkSlingshotframe ()

  int.Lock( true );

  ObjSet( "obj_flower_flower", { alp = 0 } );
  ObjSet( "anm_flower_clk_slingshotframe", { alp = 1 } );
  AnimPlay( "anm_flower_clk_slingshotframe", "DoAnim", 
  function()
    int.Lock( false );
    cmn.ShowBbt( "bbt_flower_use_razorblade" );
    ObjSet( "obj_flower_flower", { alp = 1 } );
    ObjSet( "anm_flower_clk_slingshotframe", { alp = 0 } );
  end);

end;
-------------------------------------------------
function private.ClkBook ()

  local func_end = function ()

    int.Lock( false );
    ObjSet( "obj_shelvesonwall_clk_book", { input = true } );

  end;

  ObjSet( "obj_shelvesonwall_clk_book", { input = false } );
  AnimPlay( "anm_shelvesonwall_books", "DoAnim", func_end ) 

end;
-------------------------------------------------
function private.ClkTimer ()

  local func_end = function ()

    ObjSet( "obj_shelvesonwall_clk_timer", { input = true } );

  end;

  ObjSet( "obj_shelvesonwall_clk_timer", { input = false } );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_timer" );
  AnimPlay( "anm_shelvesonwall_timer", "DoAnim", func_end ) 

end;
-------------------------------------------------
function private.ClkGlove ()

  local func_end = function ()

    int.Lock( false );
    ObjSet( "obj_wallhangingcabinet_clk_glove", { input = true } );
    ObjSet( "spr_wallhangingcabinet_rubbergloves", { alp = 1 } );

  end;

  ObjSet( "obj_wallhangingcabinet_clk_glove", { input = false } );
  ObjSet( "spr_wallhangingcabinet_rubbergloves", { alp = 0 } );
  AnimPlay( "anm_wallhangingcabinet_gloveclick", "DoAnim", func_end ) 

end;
-------------------------------------------------
function private.ClkCandy()

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_touch_strawberry" );
  AnimPlay( "anm_kitchen_candy", "DoAnim", 
  function ()
    int.Lock( false );
  end ) 

end;
-------------------------------------------------
function private.ClkToaster()

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_toaster" );

  ObjAnimate("spr_kitchen_toaster_handle", "pos_y", 0, 0, "", 
  {
    0.0,0,22,
    0.5,3,32
  });
  ObjAnimate("spr_kitchen_toaster_bread", "pos_y", 0, 0, 
  function ()
    int.Lock( false );
  end, 
  {
    0.0,0,28,
    1.0,0,28,
    1.3,3,15,
    1.4,1,20
  });

end;
--*********************************************************************************************************************
--******function MMG WALLHANGINGCABINET () ****************************************************************************
--*********************************************************************************************************************
  function private.WallhangingcabinetInit ()

    private.flower_count = 4;
    private.leaf_count   = 7;
    private.flower_color = { "red", "violet", "blue", "yellow" };
    private.flower = 
    {
      [ "red" ]    = { "red", "violet", "violet", "yellow", "blue", "yellow", "red" },
      [ "violet" ] = { "blue", "red", "blue", "red", "yellow", "violet", "violet" },
      [ "blue" ]   = { "violet", "blue", "yellow", "violet", "red", "blue", "yellow" },
      [ "yellow" ] = { "yellow", "yellow", "red", "blue", "violet", "red", "blue" },
    };

    for f = 1, private.flower_count do

      for c = 1, private.leaf_count do

        ObjSet( "spr_wallhangingcabinet_flower_"..private.flower_color[ f ].."_"..c,
        {
          drag = true,
          event_menter = function ()

            cmn.SetCursor( CURSOR_HAND );

          end,
          event_mleave = function ()

            cmn.SetCursor( CURSOR_DEFAULT );

          end,
          event_startdrag = function ()

            private.WallhangingcabinetStartDrag( private.flower_color[ f ], c );

          end,
          event_dragdrop = function ()

            private.WallhangingcabinetDrop( private.flower_color[ f ], c );

          end,
        } );

      end;

    end;

  end;
--*********************************************************************************************************************
  function private.WallhangingcabinetStartDrag ( color, idx )

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_kitchen_take" );
    local leaf = "spr_wallhangingcabinet_flower_"..color.."_"..idx;

    ObjAttach( leaf, "obj_wallhangingcabinet_drag" );

    for f = 1, private.flower_count do

      if ( private.flower[ private.flower_color[ f ] ][ idx ] == color ) then

        private.flower[ private.flower_color[ f ] ][ idx ] = "empty";

      end;

    end;

  end;
--*********************************************************************************************************************
  private.twostep = false;
  function private.WallhangingcabinetDrop ( color, idx )
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_kitchen_take" );
    
    local leaf = "spr_wallhangingcabinet_flower_"..color.."_"..idx;

    for f = 1, private.flower_count do

      if ( ApplyObj( leaf, "obj_wallhangingcabinet_flower_"..private.flower_color[ f ].."_drop" ) ) then

        ObjAttach( leaf, "obj_wallhangingcabinet_flower_"..private.flower_color[ f ] );

        local value = private.flower[ private.flower_color[ f ] ][ idx ];

        private.flower[ private.flower_color[ f ] ][ idx ] = color;

        if ( value ~= "empty" ) then
          ObjSet( "tmr_wallhangingcabinet_drag",
          {
            time = 0.01, 
            playing = true,
            endtrig = function ()
        
              --ObjStartDrag( "spr_wallhangingcabinet_flower_"..value.."_"..idx );
                  
                  local eventstartdrag = ObjGet("spr_wallhangingcabinet_flower_"..value.."_"..idx).event_startdrag;
                  eventstartdrag();
                  --ObjSet( "spr_wallhangingcabinet_flower_"..value.."_"..idx ,{ pos_x = 1000, pos_y = 1000 });
                  local eventdragdrop = ObjGet("spr_wallhangingcabinet_flower_"..value.."_"..idx).event_dragdrop;
                  eventdragdrop();
            end;
          } );

          private.twostep = true;

          
        else
          if ( private.WallhangingcabinetIsWin() ) then

            int.Lock( true );
            ObjSet( "tmr_wallhangingcabinet_win", { playing = 1, time = 0.3, endtrig = function() cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_kitchen_win" ); end  } ); 
            ObjAnimate( "obj_wallhangingcabinet_cabinet_close", "alp", 0, 0,
            function ()

              int.Lock( false );

              private.WallhangingcabinetSaveProgress();
              private.WallhangingcabinetWin();
              common_impl.PassingMgWin( "wallhangingcabinet" );

            end, 
            {
              0.0, 3, 1.0,
              0.3, 3, 1.0,
              0.6, 3, 0.0,
            } );

            ObjAnimate( "obj_wallhangingcabinet_cabinet_open", "alp", 0, 0, "", 
            {
              0.0, 3, 0.0,
              0.3, 3, 0.0,
              0.6, 3, 1.0,
            } );

          else

            private.WallhangingcabinetSaveProgress();

          end;

        end;

        return;

      end;

    end;

    local flower = private.WallhangingcabinetGetFlower( idx );
    private.flower[ flower ][ idx ] = color;
    ObjAttach( leaf, "obj_wallhangingcabinet_flower_"..flower );
    
        if ( private.WallhangingcabinetIsWin() ) then

            int.Lock( true );
            ObjSet( "tmr_wallhangingcabinet_win", { playing = 1, time = 0.3, endtrig = function() cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_kitchen_win" ); end  } ); 
            ObjAnimate( "obj_wallhangingcabinet_cabinet_close", "alp", 0, 0,
            function ()

              int.Lock( false );

              private.WallhangingcabinetSaveProgress();
              private.WallhangingcabinetWin();
              common_impl.PassingMgWin( "wallhangingcabinet" );

            end, 
            {
              0.0, 3, 1.0,
              0.3, 3, 1.0,
              0.6, 3, 0.0,
            } );

            ObjAnimate( "obj_wallhangingcabinet_cabinet_open", "alp", 0, 0, "", 
            {
              0.0, 3, 0.0,
              0.3, 3, 0.0,
              0.6, 3, 1.0,
            } );

          else

            private.WallhangingcabinetSaveProgress();

          end;
  end;
--*********************************************************************************************************************
  function private.WallhangingcabinetIsWin ()

    for f = 1, private.flower_count do

      for c = 1, private.leaf_count do

        local color = private.flower_color[ f ];

        if ( private.flower[ color ][ c ] ~= color ) then

          return false;

        end;

      end;

    end;

    return true;

  end;
--*********************************************************************************************************************
  function private.WallhangingcabinetSaveProgress ()

    for f = 1, private.flower_count do

      for c = 1, private.leaf_count do

        ng_global.progress[ "std" ][ "win_wallhangingcabinet" ].flower[ private.flower_color[ f ] ][ c ] = private.flower[ private.flower_color[ f ] ][ c ];

      end;

    end;

  end;
--*********************************************************************************************************************
  function private.WallhangingcabinetLoad ()

    for f = 1, private.flower_count do

      for c = 1, private.leaf_count do

        private.flower[ private.flower_color[ f ] ][ c ] = ng_global.progress[ "std" ][ "win_wallhangingcabinet" ].flower[ private.flower_color[ f ] ][ c ];

        local leaf = "spr_wallhangingcabinet_flower_"..private.flower[ private.flower_color[ f ] ][ c ].."_"..c;

        ObjAttach( leaf, "obj_wallhangingcabinet_flower_"..private.flower_color[ f ] );

      end;

    end;

  end;
--*********************************************************************************************************************
  function private.WallhangingcabinetGetFlower ( idx )

    for f = 1, private.flower_count do

      if ( private.flower[ private.flower_color[ f ] ][ idx ] == "empty" ) then

        return private.flower_color[ f ];

      end;

    end;

  end;
--*********************************************************************************************************************
  function private.WallhangingcabinetWin ()

    cmn.MiniGameHide( "wallhangingcabinet" );
    cmn.SetEventDone( "win_wallhangingcabinet" );
    cmn.CallEventHandler( "win_wallhangingcabinet" ); 
    cmn.SetCursor( CURSOR_DEFAULT );

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.WireClk()

  local func_end = function ()

    ObjSet( "anm_wall_2wires", { alp = 1 } );
    AnimPlay( "anm_wall_2wires", "DoAnim", "" ) 
    ObjSet( "anm_wall_wires_click", { alp = 0 } );
    cmn.ShowBbt( "bbt_wall_use_counterbutton" );
    int.Lock( false );

  end;

  int.Lock( true);

  ObjSet( "anm_wall_2wires", { alp = 0 } );
  AnimStop( "anm_wall_2wires" ) 
  ObjSet( "anm_wall_wires_click", { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_touch_wires" );
  AnimPlay( "anm_wall_wires_click", "DoAnim", func_end ) 

end;
--******************************************************************************************************************
function private.FirstOpen()

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_kitchen_zoom" );
  cmn.PlayAudio( "mus", "audio/aud_location_theme_mus" );
  ObjAnimate( "rm_kitchen", "scale_xy", 0, 0,
  function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_kitchen_first_open" );

    cmn.AddPageDiary( 9 );

  end, 
  {
    0.0, 3, 1.0, 1.0,
    0.3, 3, 1.0, 1.0,
    1.0, 3, 1.5, 1.5,
    2.5, 3, 1.5, 1.5,
    3.2, 3, 1.0, 1.0,
  } );

  ObjAnimate( "rm_kitchen", "pos_xy", 0, 0, "", 
  {
    0.0, 3,  0,    0,
    0.3, 3,  0,    0,
    1.0, 3,  -170,  -70,
    2.5, 3,  -170,  -70,
    3.2, 3,  0,    0,
  } );

  ObjAnimate( "rm_kitchen", "pos_z", 0, 0, "", 
  {
    0.0, 3, 55,
    1.3, 3, 55,
  } );

end;
--******************************************************************************************************************
function private.SnailamuletBbt()

  if cmn.IsEventDone( "use_snailamulet_1" ) or cmn.IsEventDone( "use_snailamulet_2" ) then
    cmn.ShowBbt( "bbt_shelvesonwall_use_snailamulet_2" );
  else 
    cmn.ShowBbt( "bbt_shelvesonwall_use_snailamulet_1" );
  end;

end;
--******************************************************************************************************************