-- name=rm_livingroom
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_livingroom";

  ObjAttach( "zz_window",          "room_hub" );
  ObjAttach( "zz_deskwithschemes", "room_hub" );
  ObjAttach( "zz_toys",            "room_hub" );
  ObjAttach( "zz_stand",           "room_hub" );
  ObjAttach( "zz_kitchendoor",     "room_hub" );
  ObjAttach( "zz_officedoor",      "room_hub" );
  
  ObjMultiSet( {
    { "spr_window_brokenelectricscrewdriver", { event_mdown = private.get_brokenelectricscrewdriver } },
    { "spr_deskwithschemes_casebutton",       { event_mdown = private.get_casebutton } },
    { "spr_deskwithschemes_signet",           { event_mdown = private.get_signet } },
    { "spr_toys_battery",                     { event_mdown = private.get_battery } },
    { "spr_toys_spraynozzle",                 { event_mdown = private.get_spraynozzle } },
    { "spr_stand_screwdriverrmanual",         { event_mdown = private.get_screwdriverrmanual } },
    { "spr_stand_screwdrivercap",             { event_mdown = private.get_screwdrivercap } },
    { "spr_stand_documentfolder",             { event_mdown = private.get_documentfolder } },
    { "spr_stand_gasstoveswitch",             { event_mdown = private.get_gasstoveswitch } },
    { "spr_stand_pearl",                      { event_mdown = private.get_pearl } },
    { "obj_livingroom_clk_survey",            { event_mdown = private.clk_livingroom_survey } },
    { "obj_kitchendoor_clk_door",             { event_mdown = private.clk_door } },
    { "obj_kitchendoor_clk_cabinet_2",        { event_mdown = private.clk_cabinet_2 } },
    { "obj_stand_clk_openstand",              { event_mdown = private.clk_openstand } },
    { "obj_stand_clk_casebutton",             { event_mdown = private.clk_casebutton } },
    { "obj_toys_clk_harebackopen",            { event_mdown = private.clk_harebackopen } },
    { "obj_deskwithschemes_use_airplanewing", { event_mdown = private.DeskwithschemesBoxClick } },
    { "obj_deskwithschemes_use_airplanenose", { event_mdown = private.DeskwithschemesBoxClick } },
    { "obj_officedoor_use_wire",              { event_mdown = private.OfficedoorHandleClick } },
    { "obj_stand_use_boxkey",                 { event_mdown = private.ClkStand } },
    { "obj_stand_clk_boxkey",                 { event_mdown = private.clk_boxkey } },
    { "obj_stand_use_casebutton",             { event_mdown = private.ClkCase } },
    { "obj_stand_use_butterfly",              { event_mdown = private.ClkButterflybox } },
    { "obj_kitchendoor_use_screwdriver2",     { event_mdown = private.KitchendoorDoorClick } },
    { "spr_kitchendoor_ball",                 { event_mdown = private.KitchendoorBallClick } },
    { "spr_stand_collect2_2_1",               { event_mdown = private.get_collect2_2_1 } },
    { "obj_stand_clk_book",                   { event_mdown = private.ClkBook } },
    { "obj_deskwithschemes_clk_mirror",       { event_mdown = private.ClkMirror } },
    { "obj_window_use_slingshotframe",        { event_mdown = private.ClkWindow } },
    { "obj_window_clk_flower",                { event_mdown = private.ClkFlower } },
    { "obj_toys_clk_toy",                     { event_mdown = private.ClkToy } },
    { "obj_livingroom_toy",                   { event_mdown = private.ClkToyBunny } },
    { "obj_livingroom_clk_inyard",            { event_mdown = private.clk_vid_inyard } },
  } );

  private.InitSubroom();
  private.Anims();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_livingroom = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gho_livingroom_dollhouse",
        "gzz_livingroom_window",
        "gzz_livingroom_deskwithschemes",
        "gzz_livingroom_toys",
        "gzz_livingroom_kitchendoor",
        "gzz_livingroom_officedoor",
        "gzz_livingroom_stand",
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_window", 
        "zz_deskwithschemes", 
        "zz_toys", 
        "zz_stand",
        "zz_kitchendoor",
        "zz_officedoor",
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_livingroom", update_game_mode_livingroom, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_brokenelectricscrewdriver () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brokenelectricscrewdriver" ] =
  {
    type = "get",
    get_obj = "spr_window_brokenelectricscrewdriver",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_livingroom_window"
  };
  -----------------------------------------------
  local get_brokenelectricscrewdriver_inv = function ()

    int.InventoryItemAdd( "inv_brokenelectricscrewdriver", "spr_window_brokenelectricscrewdriver" );
    ObjSet( "inv_brokenelectricscrewdriver", { drag = false } );

    if ( not cmn.IsEventDone( "get_screwdriverrmanual" ) ) then

      ObjSet( "inv_brokenelectricscrewdriver_plus_focus2", { alp = 0 } );

    end;

  end;

  local get_brokenelectricscrewdriver_closezz = function ()

    ObjDelete( "spr_window_brokenelectricscrewdriver_shadow" );
    ObjDelete( "gfx_window_brokenelectricscrewdriver" );
    ObjDelete( "spr_livingroom_brokenelectricscrewdriver" );

  end;

  cmn.AddSubscriber( "get_brokenelectricscrewdriver", get_brokenelectricscrewdriver_inv );
  cmn.AddSubscriber( "get_brokenelectricscrewdriver", get_brokenelectricscrewdriver_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_casebutton () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_casebutton" ] =
  {
    type = "get",
    get_obj = "spr_deskwithschemes_casebutton",
    room = private.room_objname,
    zz = "zz_deskwithschemes",
    zz_gate = "gzz_livingroom_deskwithschemes"
  };
  -----------------------------------------------
  local get_casebutton_inv = function ()

    int.InventoryItemAdd( "inv_casebutton", "spr_deskwithschemes_casebutton" );

  end;

  local get_casebutton_closezz = function ()

    ObjDelete( "gfx_deskwithschemes_casebutton" );
    ObjDelete( "spr_deskwithschemes_casebutton_shadow" );
    ObjDelete( "spr_livingroom_casebutton" );

    if ( cmn.IsEventDone( "get_casebutton" ) and
         cmn.IsEventDone( "get_signet" ) ) then

      ObjDelete( "gzz_livingroom_deskwithschemes" );

    end;

  end;

  cmn.AddSubscriber( "get_casebutton", get_casebutton_inv );
  cmn.AddSubscriber( "get_casebutton", get_casebutton_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_signet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_signet" ] =
  {
    type = "get",
    get_obj = "spr_deskwithschemes_signet",
    room = private.room_objname,
    zz = "zz_deskwithschemes",
    zz_gate = "gzz_livingroom_deskwithschemes"
  };
  -----------------------------------------------
  local get_signet_inv = function ()

    int.InventoryItemAdd( "inv_signet", "spr_deskwithschemes_signet" );

  end;

  local get_signet_closezz = function ()

    ObjDelete( "gfx_deskwithschemes_signet" );
    ObjDelete( "obj_deskwithschemes_plane_whole" );
    ObjSet( "anm_deskwithschemes_plane_destroyed", { alp = 1 } );
    ObjDelete( "anm_deskwithschemes_plane_destroy" );
    ObjDelete( "anm_deskwithschemes_morrow_2_click" );
    ObjSet( "anm_deskwithschemes_morrow_3_click", { alp = 1 } );

    ObjDelete( "spr_livingroom_plane" );
    ObjSet( "spr_livingroom_mirror_broken", { alp = 1 } );
    ObjSet( "spr_livingroom_plane_destroy", { alp = 1 } );
    ObjDelete( "gzz_livingroom_deskwithschemes" );

  end;

  cmn.AddSubscriber( "get_signet", get_signet_inv );
  cmn.AddSubscriber( "get_signet", get_signet_closezz, private.room_objname );
  cmn.AddSubscriber( "get_signet_inv", get_signet_inv );
  cmn.AddSubscriber( "get_signet_closezz", get_signet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_battery () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_battery" ] =
  {
    type = "get",
    get_obj = "spr_toys_battery",
    room = private.room_objname,
    zz = "zz_toys",
    zz_gate = "gzz_livingroom_toys"
  };
  -----------------------------------------------
  local get_battery_inv = function ()

    int.InventoryItemAdd( "inv_battery", "spr_toys_battery" );

    if ( cmn.IsEventDone( "clk_battery_cover" ) ) then

      ObjSet( "inv_brokenelectricscrewdriver_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_battery_closezz = function ()

    ObjDelete( "gfx_toys_battery" );
    ObjDelete( "spr_livingroom_battery" );

  end;

  cmn.AddSubscriber( "get_battery", get_battery_inv );
  cmn.AddSubscriber( "get_battery", get_battery_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_spraynozzle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_spraynozzle" ] =
  {
    type = "get",
    get_obj = "spr_toys_spraynozzle",
    room = private.room_objname,
    zz = "zz_toys",
    zz_gate = "gzz_livingroom_toys"
  };
  -----------------------------------------------
  local get_spraynozzle_inv = function ()

    int.InventoryItemAdd( "inv_spraynozzle", "spr_toys_spraynozzle" );

  end;

  local get_spraynozzle_closezz = function ()

    ObjDelete( "gfx_toys_spraynozzle" );
    ObjDelete( "spr_toys_spraynozzle_shadow" );
    ObjDelete( "spr_livingroom_spraynozzle" );

  end;

  cmn.AddSubscriber( "get_spraynozzle", get_spraynozzle_inv );
  cmn.AddSubscriber( "get_spraynozzle", get_spraynozzle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_screwdriverrmanual () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_screwdriverrmanual" ] =
  {
    type = "get",
    get_obj = "spr_stand_screwdriverrmanual",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_livingroom_stand"
  };
  -----------------------------------------------
  local get_screwdriverrmanual_inv = function ()

    int.InventoryItemAdd( "inv_screwdriverrmanual", "spr_stand_screwdriverrmanual" );

    ObjSet( "inv_brokenelectricscrewdriver_plus_focus2", { alp = 1 } );

  end;

  local get_screwdriverrmanual_closezz = function ()

    ObjDelete( "gfx_stand_screwdriverrmanual" );
    ObjDelete( "spr_livingroom_screwdriverrmanual" );

    if ( cmn.IsEventDone( "get_screwdriverrmanual" ) and
         cmn.IsEventDone( "get_screwdrivercap" ) ) then

      ObjSet( "obj_stand_screwdriver_case_open", { alp = 0 } );      
      ObjSet( "spr_stand_screwdriver_case_closed", { alp = 1 } );
      ObjSet( "obj_stand_use_boxkey", { input = true } );
      ObjSet( "spr_stand_closed_box", { alp = 1 } );
      ObjSet( "spr_livingroom_screwdriver_case_open", { alp = 0 } );      

    end;

  end;

  cmn.AddSubscriber( "get_screwdriverrmanual", get_screwdriverrmanual_inv );
  cmn.AddSubscriber( "get_screwdriverrmanual", get_screwdriverrmanual_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_screwdrivercap () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_screwdrivercap" ] =
  {
    type = "get",
    get_obj = "spr_stand_screwdrivercap",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_livingroom_stand"
  };
  -----------------------------------------------
  local get_screwdrivercap_inv = function ()

    int.InventoryItemAdd( "inv_screwdrivercap", "spr_stand_screwdrivercap" );

    if ( cmn.IsEventDone( "use_screwdriverrmanual" ) ) then

      ObjSet( "inv_brokenelectricscrewdriver_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_screwdrivercap_closezz = function ()

    ObjDelete( "gfx_stand_screwdrivercap" );
    ObjDelete( "spr_stand_screwdrivercap_shadow" );

    if ( cmn.IsEventDone( "get_screwdriverrmanual" ) and
         cmn.IsEventDone( "get_screwdrivercap" ) ) then

      ObjSet( "obj_stand_screwdriver_case_open", { alp = 0 } );      
      ObjSet( "spr_stand_screwdriver_case_closed", { alp = 1 } );
      ObjSet( "obj_stand_use_boxkey", { input = true } );
      ObjSet( "spr_stand_closed_box", { alp = 1 } );
      ObjSet( "spr_livingroom_screwdriver_case_open", { alp = 0 } );      

    end;

  end;

  cmn.AddSubscriber( "get_screwdrivercap", get_screwdrivercap_inv );
  cmn.AddSubscriber( "get_screwdrivercap", get_screwdrivercap_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_documentfolder () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_documentfolder" ] =
  {
    type = "get",
    get_obj = "spr_stand_documentfolder",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_livingroom_stand"
  };
  -----------------------------------------------
  local get_documentfolder_inv = function ()

    int.InventoryItemAdd( "inv_documentfolder", "spr_stand_documentfolder" );
    ObjSet( "inv_documentfolder", { drag = false } );

  end;

  local get_documentfolder_closezz = function ()

    ObjDelete( "gfx_stand_documentfolder" );
    ObjDelete( "spr_stand_documentfolder_shadow" );

  end;

  cmn.AddSubscriber( "get_documentfolder", get_documentfolder_inv );
  cmn.AddSubscriber( "get_documentfolder", get_documentfolder_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pearl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pearl" ] =
  {
    type = "get",
    get_obj = "spr_stand_pearl",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_livingroom_stand"
  };
  -----------------------------------------------
  local get_pearl_inv = function ()

    int.InventoryItemAdd( "inv_pearl", "spr_stand_pearl" );

  end;

  local get_pearl_closezz = function ()

    ObjDelete( "gfx_stand_pearl" );
    ObjDelete( "spr_stand_pearl_shadow" );
    ObjDelete( "spr_livingroom_pearl" );

    if ( cmn.IsEventDone( "get_collect2_2_1" ) ) then

      ObjDelete( "gzz_livingroom_stand" );

    end;

  end;

  cmn.AddSubscriber( "get_pearl", get_pearl_inv );
  cmn.AddSubscriber( "get_pearl", get_pearl_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_2_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_2_1 = function ()

    ObjDelete( "spr_stand_collect2_2_1" );
    ObjDelete( "spr_stand_collect2_2_1_shadow" );

    if ( cmn.IsEventDone( "get_pearl" ) ) then

      ObjDelete( "gzz_livingroom_stand" );

    end;

  end;

  cmn.AddSubscriber( "get_collect2_2_1", get_collect2_2_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_2_3 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_2_3 = function ()

    ObjDelete( "obj_livingroom_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_2_3", get_morphobject_2_3, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_slingshotframe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_slingshotframe" ] =
  {
    type = "use",
    use_obj = "inv_slingshotframe",
    use_place = "obj_window_use_slingshotframe",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_livingroom_window"
  };
  -----------------------------------------------
  local use_slingshotframe_inv = function ()

    int.InventoryItemRemove( "inv_slingshotframe" );

  end;
  local use_slingshotframe_beg = function ()

    ObjDelete( "obj_window_use_slingshotframe" );

  end;
  local use_slingshotframe_end = function ()

    ObjSet( "grm_livingroom_yard", { active = true, input = true, visible = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_livingroom_yard_focus");
    end;    
    ObjDelete( "gzz_livingroom_window" );
    ObjDelete( "spr_livingroom_window_close" );
    ObjSet( "spr_livingroom_window_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_slingshotframe", use_slingshotframe_beg, private.room_objname );
  cmn.AddSubscriber( "use_slingshotframe", use_slingshotframe_inv );
  cmn.AddSubscriber( "use_slingshotframe", use_slingshotframe_end, private.room_objname );
  cmn.AddSubscriber( "use_slingshotframe_inv", use_slingshotframe_inv, private.room_objname );
  cmn.AddSubscriber( "use_slingshotframe_beg", use_slingshotframe_beg, private.room_objname );
  cmn.AddSubscriber( "use_slingshotframe_end", use_slingshotframe_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_airplanewing () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_airplanewing" ] =
  {
    type = "use",
    use_obj = "inv_airplanewing",
    use_place = "obj_deskwithschemes_use_airplanewing",
    room = private.room_objname,
    zz = "zz_deskwithschemes",
    zz_gate = "gzz_livingroom_deskwithschemes"
  };
  -----------------------------------------------
  local use_airplanewing_inv = function ()

    int.InventoryItemRemove( "inv_airplanewing" );

  end;
  local use_airplanewing_beg = function ()

    ObjDelete( "obj_deskwithschemes_use_airplanewing" );

  end;
  local use_airplanewing_end = function ()

    ObjSet( "spr_deskwithschemes_airplane_wing_shadow", { alp = 1 } );
    ObjSet( "anm_deskwithschemes_morrow_2_click",  { alp = 1 } );
    ObjDelete( "anm_deskwithschemes_morrow_1_click" );

    if ( cmn.IsEventDone( "use_airplanenose" ) ) then

      ObjSet( "obj_deskwithschemes_box_open",     { alp = 1 } );
      ObjSet( "spr_deskwithschemes_signet", { input = true } );
      ObjSet( "gfx_deskwithschemes_signet", { active = true } );
      ObjDelete( "spr_deskwithschemes_box_close" );
      ObjDelete( "spr_livingroom_plane_nowing" );
      ObjSet( "spr_livingroom_box_open", { alp = 1 } );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_airplanewing", use_airplanewing_beg, private.room_objname );
  cmn.AddSubscriber( "use_airplanewing", use_airplanewing_inv );
  cmn.AddSubscriber( "use_airplanewing", use_airplanewing_end, private.room_objname );
  cmn.AddSubscriber( "use_airplanewing_inv", use_airplanewing_inv, private.room_objname );
  cmn.AddSubscriber( "use_airplanewing_beg", use_airplanewing_beg, private.room_objname );
  cmn.AddSubscriber( "use_airplanewing_end", use_airplanewing_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_airplanenose () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_airplanenose" ] =
  {
    type = "use",
    use_obj = "inv_airplanenose",
    use_place = "obj_deskwithschemes_use_airplanenose",
    room = private.room_objname,
    zz = "zz_deskwithschemes",
    zz_gate = "gzz_livingroom_deskwithschemes"
  };
  --------------------------------------------------------------------------------------------
  local use_airplanenose_inv = function ()

    int.InventoryItemRemove( "inv_airplanenose" );

  end;
  local use_airplanenose_beg = function ()

    ObjDelete( "obj_deskwithschemes_use_airplanenose" );

  end;
  local use_airplanenose_end = function ()

    ObjSet( "spr_deskwithschemes_airplane_nose", { alp = 1 } );
    ObjSet( "spr_livingroom_plane_nose", { alp = 1 } );

    if ( cmn.IsEventDone( "use_airplanewing" ) ) then

      ObjSet( "anm_deskwithschemes_morrow_2_click",  { alp = 1 } );
      ObjDelete( "anm_deskwithschemes_morrow_1_click" );
      ObjSet( "obj_deskwithschemes_box_open",     { alp = 1 } );
      ObjSet( "spr_deskwithschemes_signet", { input = true } );
      ObjSet( "gfx_deskwithschemes_signet", { active = true } );
      ObjDelete( "spr_deskwithschemes_box_close" );
      ObjDelete( "spr_livingroom_plane_nowing" );
      ObjSet( "spr_livingroom_box_open", { alp = 1 } );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_airplanenose", use_airplanenose_beg, private.room_objname );
  cmn.AddSubscriber( "use_airplanenose", use_airplanenose_inv );
  cmn.AddSubscriber( "use_airplanenose", use_airplanenose_end, private.room_objname );
  cmn.AddSubscriber( "use_airplanenose_inv", use_airplanenose_inv, private.room_objname );
  cmn.AddSubscriber( "use_airplanenose_beg", use_airplanenose_beg, private.room_objname );
  cmn.AddSubscriber( "use_airplanenose_end", use_airplanenose_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_butler () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_butler" ] =
  {
    type = "use",
    use_obj = "inv_butler",
    use_place = "obj_toys_use_butler",
    room = private.room_objname,
    zz = "zz_toys",
    zz_gate = "gzz_livingroom_toys"
  };
  -----------------------------------------------
  local use_butler_inv = function ()

    int.InventoryItemRemove( "inv_butler" );

  end;
  local use_butler_beg = function ()

    ObjDelete( "obj_toys_use_butler" );

  end;
  local use_butler_end = function ()

    ObjDelete( "spr_toys_hotspot" );
    ObjSet( "spr_toys_butler", { alp = 1 } );
    ObjSet( "spr_livingroom_butler", { alp = 1 } );

    if ( cmn.IsEventDone( "use_penguin_1" ) and
         cmn.IsEventDone( "use_penguin_2" ) and
         cmn.IsEventDone( "use_butler" ) ) then

      ObjSet( "gho_livingroom_dollhouse", { active = true, input = true, alp = 1 } );
      ObjDelete( "gzz_livingroom_toys" );
      ObjSet( "spr_livingroom_toys_open", { alp = 1 } );
      ObjDelete( "spr_livingroom_toys_close" );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_butler", use_butler_beg, private.room_objname );
  cmn.AddSubscriber( "use_butler", use_butler_inv );
  cmn.AddSubscriber( "use_butler", use_butler_end, private.room_objname );
  cmn.AddSubscriber( "use_butler_inv", use_butler_inv, private.room_objname );
  cmn.AddSubscriber( "use_butler_beg", use_butler_beg, private.room_objname );
  cmn.AddSubscriber( "use_butler_end", use_butler_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_penguin_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_penguin_1" ] =
  {
    type = "use",
    use_obj = "inv_penguin_1",
    use_place = "obj_toys_use_penguin_1",
    room = private.room_objname,
    zz = "zz_toys",
    zz_gate = "gzz_livingroom_toys"
  };
  -----------------------------------------------
  local use_penguin_1_inv = function ()

    int.InventoryItemRemove( "inv_penguin_1" );

  end;
  local use_penguin_1_beg = function ()

    ObjDelete( "obj_toys_use_penguin_1" );

  end;
  local use_penguin_1_end = function ()

    ObjSet( "spr_toys_penguin_1", { alp = 1 } );
    ObjSet( "spr_livingroom_penguin_1", { alp = 1 } );

    if ( cmn.IsEventDone( "use_penguin_1" ) and
         cmn.IsEventDone( "use_penguin_2" ) and
         cmn.IsEventDone( "use_butler" ) ) then

      ObjSet( "gho_livingroom_dollhouse", { active = true, input = true, alp = 1 } );
      ObjDelete( "gzz_livingroom_toys" );
      ObjSet( "spr_livingroom_toys_open", { alp = 1 } );
      ObjDelete( "spr_livingroom_toys_close" );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_penguin_1", use_penguin_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_penguin_1", use_penguin_1_inv );
  cmn.AddSubscriber( "use_penguin_1", use_penguin_1_end, private.room_objname );
  cmn.AddSubscriber( "use_penguin_1_inv", use_penguin_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_penguin_1_beg", use_penguin_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_penguin_1_end", use_penguin_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_penguin_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_penguin_2" ] =
  {
    type = "use",
    use_obj = "inv_penguin_2",
    use_place = "obj_toys_use_penguin_2",
    room = private.room_objname,
    zz = "zz_toys",
    zz_gate = "gzz_livingroom_toys"
  };
  -----------------------------------------------
  local use_penguin_2_inv = function ()

    int.InventoryItemRemove( "inv_penguin_2" );

  end;
  local use_penguin_2_beg = function ()

    ObjDelete( "obj_toys_use_penguin_2" );

  end;
  local use_penguin_2_end = function ()

    ObjSet( "spr_toys_penguin_2", { alp = 1 } );
    ObjSet( "spr_livingroom_penguin_2", { alp = 1 } );

    if ( cmn.IsEventDone( "use_penguin_1" ) and
         cmn.IsEventDone( "use_penguin_2" ) and
         cmn.IsEventDone( "use_butler" ) ) then

      ObjSet( "gho_livingroom_dollhouse", { active = true, input = true, alp = 1 } );
      ObjDelete( "gzz_livingroom_toys" );
      ObjSet( "spr_livingroom_toys_open", { alp = 1 } );
      ObjDelete( "spr_livingroom_toys_close" );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_penguin_2", use_penguin_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_penguin_2", use_penguin_2_inv );
  cmn.AddSubscriber( "use_penguin_2", use_penguin_2_end, private.room_objname );
  cmn.AddSubscriber( "use_penguin_2_inv", use_penguin_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_penguin_2_beg", use_penguin_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_penguin_2_end", use_penguin_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_casebutton () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_casebutton" ] =
  {
    type = "use",
    use_obj = "inv_casebutton",
    use_place = "obj_stand_use_casebutton",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_livingroom_stand"
  };
  -----------------------------------------------
  local use_casebutton_inv = function ()

    int.InventoryItemRemove( "inv_casebutton" );

  end;
  local use_casebutton_beg = function ()

    ObjDelete( "obj_stand_use_casebutton" );

  end;
  local use_casebutton_end = function ()

    ObjSet( "spr_stand_screwdriver_case_button", { alp = 1 } );
    ObjSet( "obj_stand_clk_casebutton", { input = true } );

    ObjDelete( "anm_stand_screwdriver_case_spring" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_casebutton", use_casebutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_casebutton", use_casebutton_inv );
  cmn.AddSubscriber( "use_casebutton", use_casebutton_end, private.room_objname );
  cmn.AddSubscriber( "use_casebutton_inv", use_casebutton_inv, private.room_objname );
  cmn.AddSubscriber( "use_casebutton_beg", use_casebutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_casebutton_end", use_casebutton_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_boxkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_boxkey" ] =
  {
    type = "use",
    use_obj = "inv_boxkey",
    use_place = "obj_stand_use_boxkey",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_livingroom_stand"
  };
  -----------------------------------------------
  local use_boxkey_inv = function ()

    int.InventoryItemRemove( "inv_boxkey" );

  end;
  local use_boxkey_beg = function ()

    ObjDelete( "obj_stand_use_boxkey" );

  end;
  local use_boxkey_end = function ()

    ObjSet( "obj_stand_clk_boxkey",  { input = true } );
    ObjSet( "anm_stand_clk_boxkey",  { alp = 1 } );
    ObjSet( "spr_livingroom_boxkey", { alp = 1 } );
    ObjDelete( "anm_stand_use_boxkey" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_boxkey", use_boxkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_boxkey", use_boxkey_inv );
  cmn.AddSubscriber( "use_boxkey", use_boxkey_end, private.room_objname );
  cmn.AddSubscriber( "use_boxkey_inv", use_boxkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_boxkey_beg", use_boxkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_boxkey_end", use_boxkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_butterfly () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_butterfly" ] =
  {
    type = "use",
    use_obj = "inv_butterfly",
    use_place = "obj_stand_use_butterfly",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_livingroom_stand"
  };
  -----------------------------------------------
  local use_butterfly_inv = function ()

    int.InventoryItemRemove( "inv_butterfly" );

  end;
  local use_butterfly_beg = function ()

    ObjDelete( "obj_stand_use_butterfly" );

  end;
  local use_butterfly_end = function ()

    ObjSet( "gfx_stand_gasstoveswitch", { active = true } );
    ObjSet( "gfx_stand_pearl", { active = true } );
    ObjSet( "obj_stand_open_butterflybox", { input = true, alp = 1 } );
    ObjSet( "spr_livingroom_butterflybox_open", { alp = 1 } );

    ObjDelete( "spr_stand_closed_butterflybox" );  
    ObjDelete( "spr_stand_butterflybox_key" );  

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_butterfly", use_butterfly_beg, private.room_objname );
  cmn.AddSubscriber( "use_butterfly", use_butterfly_inv );
  cmn.AddSubscriber( "use_butterfly", use_butterfly_end, private.room_objname );
  cmn.AddSubscriber( "use_butterfly_inv", use_butterfly_inv, private.room_objname );
  cmn.AddSubscriber( "use_butterfly_beg", use_butterfly_beg, private.room_objname );
  cmn.AddSubscriber( "use_butterfly_end", use_butterfly_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screwdriver2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriver2" ] =
  {
    type = "use",
    use_obj = "inv_screwdriver2",
    use_place = "obj_kitchendoor_use_screwdriver2",
    room = private.room_objname,
    zz = "zz_kitchendoor",
    zz_gate = "gzz_livingroom_kitchendoor"
  };
  -----------------------------------------------
  local use_screwdriver2_inv = function ()

    int.InventoryItemRemove( "inv_screwdriver2" );

  end;
  local use_screwdriver2_beg = function ()

    ObjDelete( "obj_kitchendoor_use_screwdriver2" );

  end;
  local use_screwdriver2_end = function ()

    ObjSet( "obj_kitchendoor_clk_door", { input = true } );
    ObjSet( "anm_kitchendoor_door_push", { alp = 1 } );
    ObjDelete( "obj_kitchendoor_screws" );
    ObjDelete( "anm_kitchendoor_use_screwdriver" );
    ObjDelete( "anm_kitchendoor_door_click" );
    ObjDelete( "obj_kitchendoor_cabinet" )

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_screwdriver2", use_screwdriver2_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver2", use_screwdriver2_inv );
  cmn.AddSubscriber( "use_screwdriver2", use_screwdriver2_end, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver2_inv", use_screwdriver2_inv, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver2_beg", use_screwdriver2_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver2_end", use_screwdriver2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wire () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wire" ] =
  {
    type = "use",
    use_obj = "inv_wire",
    use_place = "obj_officedoor_use_wire",
    room = private.room_objname,
    zz = "zz_officedoor",
    zz_gate = "gzz_livingroom_officedoor"
  };
  -----------------------------------------------
  local use_wire_inv = function ()

    int.InventoryItemRemove( "inv_wire" );

  end;
  local use_wire_beg = function ()

    ObjDelete( "obj_officedoor_use_wire" );

  end;
  local use_wire_end = function ()

    ObjSet( "grm_livingroom_office", { active = true, input = true, visible = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_livingroom_office_focus");
    end;    
    ObjDelete( "gzz_livingroom_officedoor" );
    ObjSet( "anm_livingroom_door", { alp = 1 } );
    ObjSet( "spr_livingroom_officedoor_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_wire", use_wire_beg, private.room_objname );
  cmn.AddSubscriber( "use_wire", use_wire_inv );
  cmn.AddSubscriber( "use_wire", use_wire_end, private.room_objname );
  cmn.AddSubscriber( "use_wire_inv", use_wire_inv, private.room_objname );
  cmn.AddSubscriber( "use_wire_beg", use_wire_beg, private.room_objname );
  cmn.AddSubscriber( "use_wire_end", use_wire_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_livingroom_survey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_livingroom_survey" ] =
  {
    type = "click",
    clk_obj = "obj_livingroom_clk_survey",
    use_place = "obj_livingroom_clk_survey",
    room = private.room_objname,
  };
  -----------------------------------------------
  local clk_livingroom_survey = function ()


  end;
  -----------------------------------------------
  local clk_livingroom_survey_beg = function ()

    ObjDelete( "obj_livingroom_clk_survey" );

  end;
  -----------------------------------------------
  local clk_livingroom_survey_end = function ()


  end;

  cmn.AddSubscriber( "clk_livingroom_survey", clk_livingroom_survey );
  cmn.AddSubscriber( "clk_livingroom_survey", clk_livingroom_survey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_livingroom_survey", clk_livingroom_survey_end, private.room_objname );
  cmn.AddSubscriber( "clk_livingroom_survey_beg", clk_livingroom_survey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_livingroom_survey_end", clk_livingroom_survey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_door () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_door" ] =
  {
    type = "click",
    clk_obj = "obj_kitchendoor_clk_door",
    room = private.room_objname,
    zz = "zz_kitchendoor",
    zz_gate = "gzz_livingroom_kitchendoor"
  };
  -----------------------------------------------
  local clk_door = function ()


  end;
  -----------------------------------------------
  local clk_door_beg = function ()

    ObjDelete( "obj_kitchendoor_clk_door" );

  end;
  -----------------------------------------------
  local clk_door_end = function ()

    ObjSet( "obj_kitchendoor_clk_cabinet_2", { input = true } );
    ObjSet( "anm_kitchendoor_clk_cabinet", { alp = 1 } );
    ObjDelete( "anm_kitchendoor_door_push" );
    --ObjDelete( "obj_kitchendoor_cabinet" );
    ObjDelete( "spr_livingroom_kitchendoor_close" );
    ObjSet( "spr_livingroom_kitchendoor_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_door", clk_door );
  cmn.AddSubscriber( "clk_door", clk_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_door", clk_door_end, private.room_objname );
  cmn.AddSubscriber( "clk_door_beg", clk_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_door_end", clk_door_end, private.room_objname );
  -----------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_cabinet_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_cabinet_2" ] =
  {
    type = "click",
    clk_obj = "obj_kitchendoor_clk_cabinet_2",
    room = private.room_objname,
    zz = "zz_kitchendoor",
    zz_gate = "gzz_livingroom_kitchendoor"
  };
  -----------------------------------------------
  local clk_cabinet_2_beg = function ()

    ObjDelete( "obj_kitchendoor_clk_cabinet_2" );

  end;
  -----------------------------------------------
  local clk_cabinet_2_end = function ()

    ObjSet( "grm_livingroom_kitchen", { active = true, input = true, visible = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_livingroom_kitchen_focus");
    end;    
    ObjDelete( "gzz_livingroom_kitchendoor" );
    --ObjDelete( "anm_kitchendoor_clk_cabinet" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_cabinet_2", clk_cabinet_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_cabinet_2", clk_cabinet_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_cabinet_2_beg", clk_cabinet_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_cabinet_2_end", clk_cabinet_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_boxkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_boxkey" ] =
  {
    type = "click",
    clk_obj = "obj_stand_clk_boxkey",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_livingroom_stand"
  };
  -----------------------------------------------
  local clk_boxkey_beg = function ()

    ObjDelete( "obj_stand_clk_boxkey" );

  end;
  -----------------------------------------------
  local clk_boxkey_end = function ()

    ObjSet( "gfx_stand_documentfolder", { active = true } );
    ObjSet( "obj_stand_open_box", { input = true, alp = 1 } );

    ObjDelete( "spr_stand_closed_box" );
    ObjDelete( "anm_stand_clk_boxkey" );
    ObjDelete( "spr_livingroom_boxkey" );
    ObjSet( "spr_livingroom_stand_up_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_boxkey", clk_boxkey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_boxkey", clk_boxkey_end, private.room_objname );
  cmn.AddSubscriber( "clk_boxkey_beg", clk_boxkey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_boxkey_end", clk_boxkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_openstand() end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_openstand" ] =
  {
    type = "click",
    clk_obj = "obj_stand_clk_openstand",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_livingroom_stand"
  };
  -----------------------------------------------
  local clk_openstand_beg = function ()

    ObjDelete( "obj_stand_clk_openstand" );

  end;
  -----------------------------------------------
  local clk_openstand_end = function ()

    ObjSet( "obj_stand_open_stand", { alp = 1 } );
    ObjSet( "obj_stand_use_casebutton", { active = true, input = true } );
    ObjSet( "spr_livingroom_stand_down_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_openstand", clk_openstand_beg, private.room_objname );
  cmn.AddSubscriber( "clk_openstand", clk_openstand_end, private.room_objname );
  cmn.AddSubscriber( "clk_openstand_beg", clk_openstand_beg, private.room_objname );
  cmn.AddSubscriber( "clk_openstand_end", clk_openstand_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_casebutton() end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_casebutton" ] =
  {
    type = "click",
    clk_obj = "obj_stand_clk_casebutton",
    room = private.room_objname,
    zz = "zz_stand",
    zz_gate = "gzz_livingroom_stand"
  };
  -----------------------------------------------
  local clk_casebutton_beg = function ()

    ObjDelete( "obj_stand_clk_casebutton" );

  end;
  -----------------------------------------------
  local clk_casebutton_end = function ()

    ObjSet( "obj_stand_screwdriver_case_open", { input = true, alp = 1 } );
    ObjSet( "gfx_stand_screwdriverrmanual", { active = true } );
    ObjSet( "gfx_stand_screwdrivercap", { active = true } );
    
    ObjSet( "spr_stand_screwdriver_case_closed", { alp = 0 } );

    ObjSet( "obj_stand_use_boxkey", { input = false } );
    ObjSet( "spr_stand_closed_box", { alp = 0 } );
    ObjSet( "spr_livingroom_screwdriver_case_open", { alp = 1 } );      

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_casebutton", clk_casebutton_beg, private.room_objname );
  cmn.AddSubscriber( "clk_casebutton", clk_casebutton_end, private.room_objname );
  cmn.AddSubscriber( "clk_casebutton_beg", clk_casebutton_beg, private.room_objname );
  cmn.AddSubscriber( "clk_casebutton_end", clk_casebutton_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_harebackopen() end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_harebackopen" ] =
  {
    type = "click",
    clk_obj = "obj_toys_clk_harebackopen",
    room = private.room_objname,
    zz = "zz_toys",
    zz_gate = "gzz_livingroom_toys"
  };
  -----------------------------------------------
  local clk_harebackopen_beg = function ()

    ObjDelete( "obj_toys_clk_harebackopen" );

  end;
  -----------------------------------------------
  local clk_harebackopen_end = function ()

    ObjSet( "spr_toys_battery", { input = true } );
    ObjSet( "gfx_toys_battery", { active = true } );
    ObjSet( "obj_toys_open_car", { alp = 1 } );
    ObjSet( "spr_livingroom_opn_car", { alp = 1 } );
    ObjSet( "spr_livingroom_battery", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_harebackopen", clk_harebackopen_beg, private.room_objname );
  cmn.AddSubscriber( "clk_harebackopen", clk_harebackopen_end, private.room_objname );
  cmn.AddSubscriber( "clk_harebackopen_beg", clk_harebackopen_beg, private.room_objname );
  cmn.AddSubscriber( "clk_harebackopen_end", clk_harebackopen_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_vid_inyard () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_vid_inyard" ] =
  {
    type = "click",
    clk_obj = "obj_livingroom_clk_inyard",
    room = private.room_objname,
  };
  -----------------------------------------------------------------------------------
  local clk_vid_inyard_beg = function ()

    ObjDelete( "obj_livingroom_clk_inyard" );

  end;
  local clk_vid_inyard_end = function ()

    ObjSet( "gzz_livingroom_window", { input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_vid_inyard", clk_vid_inyard_beg, private.room_objname );
  cmn.AddSubscriber( "clk_vid_inyard", clk_vid_inyard_end, private.room_objname );
  cmn.AddSubscriber( "clk_vid_inyard_beg", clk_vid_inyard_beg, private.room_objname );
  cmn.AddSubscriber( "clk_vid_inyard_end", clk_vid_inyard_end, private.room_objname );
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.get_brokenelectricscrewdriver ()

  cmn.SetEventDone( "get_brokenelectricscrewdriver" );
  cmn.CallEventHandler( "get_brokenelectricscrewdriver" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_casebutton ()

  cmn.SetEventDone( "get_casebutton" );
  cmn.CallEventHandler( "get_casebutton" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_casebutton" ) and
       cmn.IsEventDone( "get_signet" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_signet ()

  int.Lock( true );

  local func_end = function ()

    local func_end = function ()

      int.Lock( false );

      cmn.SetEventDone( "get_signet" );
      cmn.CallEventHandler( "get_signet_closezz" );
      cmn.ShowBbt( "bbt_deskwithschemes_after_scare" );
      cmn.PlayAudio( "mus", "audio/aud_all_is_lost_mus" );
  
      if ( cmn.IsEventDone( "get_casebutton" ) and
           cmn.IsEventDone( "get_signet" ) ) then
  
        cmn.CloseSubRoom();
  
      end;

    end;

    ObjSet( "tmr_deskwithschemes_anm", { playing = true, time = 10.0, endtrig = func_end } ); 
    ObjSet( "anm_deskwithschemes_plane_destroy", { alp = 1 } ); 
    ObjSet( "obj_deskwithschemes_plane_whole",   { alp = 0 } ); 
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_plane_minicrash" );    
    AnimPlay( "anm_deskwithschemes_plane_destroy", "DoAnim", "" );

  end;

  cmn.CallEventHandler( "get_signet_inv" );
    
  ObjSet( "gfx_deskwithschemes_signet", { alp = 0 } );

  cmn.GetObjectSfx();
  ObjSet( "tmr_deskwithschemes_anm", { playing = true, time = 1.2, endtrig = func_end } ); 

end;
-------------------------------------------------
function private.get_battery ()

  cmn.SetEventDone( "get_battery" );
  cmn.CallEventHandler( "get_battery" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_spraynozzle ()

  cmn.SetEventDone( "get_spraynozzle" );
  cmn.CallEventHandler( "get_spraynozzle" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_screwdriverrmanual ()

  cmn.SetEventDone( "get_screwdriverrmanual" );
  cmn.CallEventHandler( "get_screwdriverrmanual" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_screwdriverrmanual" ) and
       cmn.IsEventDone( "get_screwdrivercap" ) ) then

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_close_plastic_chest" );
    ObjAnimate("obj_stand_screwdriver_case_open", "alp", 0, 0, "", 
    {
      0.0,0,1,
      0.3,0,0
    });
    ObjAnimate("spr_stand_screwdriver_case_closed", "alp", 0, 0, "", 
    {
      0.0,0,0,
      0.3,0,1
    });

  end;

end;
-------------------------------------------------
function private.get_screwdrivercap ()

  cmn.SetEventDone( "get_screwdrivercap" );
  cmn.CallEventHandler( "get_screwdrivercap" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_screwdriverrmanual" ) and
       cmn.IsEventDone( "get_screwdrivercap" ) ) then

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_close_plastic_chest" );
    ObjAnimate("obj_stand_screwdriver_case_open", "alp", 0, 0, "", 
    {
      0.0,0,1,
      0.3,0,0
    });
    ObjAnimate("spr_stand_screwdriver_case_closed", "alp", 0, 0, "", 
    {
      0.0,0,0,
      0.3,0,1
    });

  end;

end;
-------------------------------------------------
function private.get_documentfolder ()

  cmn.SetEventDone( "get_documentfolder" );
  cmn.CallEventHandler( "get_documentfolder" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_pearl ()

  cmn.SetEventDone( "get_pearl" );
  cmn.CallEventHandler( "get_pearl" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_collect2_2_1" ) ) then

    cmn.CloseSubRoom();

  end;

end;
---------------------------------------------------------------------------------
function private.get_collect2_2_1()

  int.AddCollectibles2( "spr_stand_collect2_2_1" );

  local func_end = function ()

    if ( cmn.IsEventDone( "get_pearl" ) ) then

      cmn.CloseSubRoom();

    end;

  end;

  ObjAnimate( "zz_stand", "alp", 0, 0, func_end,
  { 
    0.0, 0, 1.0, 
    0.7, 0, 1.0
  } );

end;
--*********************************************************************************************************************
-------------------------------------------------
function public.use_slingshotframe ()

  local item = "inv_slingshotframe";

  if ( cmn.ApplyObj( item, "gzz_livingroom_window", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_window" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_window_use_slingshotframe", true ) ) then

    cmn.CallEventHandler( "use_slingshotframe_inv" );
    cmn.CallEventHandler( "use_slingshotframe_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_slingshotframe" );
      cmn.CallEventHandler( "use_slingshotframe_end" );
      int.Lock( false );
      cmn.CloseSubRoom();

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_open_window" );  
    ObjSet( "anm_window_closed_click", { alp = 0 } );
    ObjSet( "anm_window_use_slingshotframe", { alp = 1 } );
    AnimPlay( "anm_window_use_slingshotframe", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_airplanewing ()

  local item = "inv_airplanewing";

  if ( cmn.ApplyObj( item, "gzz_livingroom_deskwithschemes", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_deskwithschemes" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_deskwithschemes_use_airplanewing", true ) ) then

    cmn.CallEventHandler( "use_airplanewing_inv" );
    cmn.CallEventHandler( "use_airplanewing_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_airplanewing" );
      cmn.CallEventHandler( "use_airplanewing_end" );
      int.Lock( false );

    end;

    if ( cmn.IsEventDone( "use_airplanenose" ) ) then

      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_plane_box_open" );  
      ObjAnimate( "spr_deskwithschemes_airplane_wing_shadow", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      ObjAnimate( "anm_deskwithschemes_morrow_2_click", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      ObjAnimate( "obj_deskwithschemes_box_open", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.5, 0, 0.0,
        0.8, 0, 1.0
      } );

      ObjAnimate( "spr_deskwithschemes_box_close", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0, 
        0.5, 0, 1.0,
        0.8, 0, 0.0
      } );

    else

      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_wing" );  
      ObjAnimate( "spr_deskwithschemes_airplane_wing_shadow", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      ObjAnimate( "anm_deskwithschemes_morrow_2_click", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

    end;

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_airplanenose ()

  local item = "inv_airplanenose";

  if ( cmn.ApplyObj( item, "gzz_livingroom_deskwithschemes", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_deskwithschemes" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_deskwithschemes_use_airplanenose", true ) ) then

    cmn.CallEventHandler( "use_airplanenose_inv" );
    cmn.CallEventHandler( "use_airplanenose_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_airplanenose" );
      cmn.CallEventHandler( "use_airplanenose_end" );
      int.Lock( false );

    end;

    if ( cmn.IsEventDone( "use_airplanewing" ) ) then

      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_plane_box_open" );  
      ObjAnimate( "spr_deskwithschemes_airplane_nose", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      ObjAnimate( "obj_deskwithschemes_box_open", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.5, 0, 0.0,
        0.8, 0, 1.0
      } );

      ObjAnimate( "spr_deskwithschemes_box_close", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0, 
        0.5, 0, 1.0,
        0.8, 0, 0.0
      } );

    else

      --cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_plane_box_open" );  
      ObjAnimate( "spr_deskwithschemes_airplane_nose", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

    end;

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_butler ()

  local item = "inv_butler";

  if ( cmn.ApplyObj( item, "gzz_livingroom_toys", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_toys" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_toys_use_butler", true ) ) then

    cmn.CallEventHandler( "use_butler_inv" );
    cmn.CallEventHandler( "use_butler_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_butler" );
      cmn.CallEventHandler( "use_butler_end" );
      int.Lock( false );

      if ( cmn.IsEventDone( "use_penguin_1" ) and
           cmn.IsEventDone( "use_penguin_2" ) and
           cmn.IsEventDone( "use_butler" ) ) then

        ObjSet( "tmr_toys_ho", { playing = 1, time = 0.3, endtrig = function() cmn.CloseSubRoom(); end } ); 

      end;

    end;

    ObjSet( "spr_toys_hotspot", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_human" );  
    ObjAnimate( "spr_toys_butler", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_penguin_1 ()

  local item = "inv_penguin_1";

  if ( cmn.ApplyObj( item, "gzz_livingroom_toys", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_toys" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_toys_use_penguin_1", true ) ) then

    cmn.CallEventHandler( "use_penguin_1_inv" );
    cmn.CallEventHandler( "use_penguin_1_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_penguin_1" );
      cmn.CallEventHandler( "use_penguin_1_end" );
      int.Lock( false );

      if ( cmn.IsEventDone( "use_penguin_1" ) and
           cmn.IsEventDone( "use_penguin_2" ) and
           cmn.IsEventDone( "use_butler" ) ) then

        ObjSet( "tmr_toys_ho", { playing = 1, time = 0.3, endtrig = function() cmn.CloseSubRoom(); end } ); 

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_penguin_app" );  
    ObjAnimate( "spr_toys_penguin_1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_penguin_2 ()

  local item = "inv_penguin_2";

  if ( cmn.ApplyObj( item, "gzz_livingroom_toys", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_toys" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_toys_use_penguin_2", true ) ) then

    cmn.CallEventHandler( "use_penguin_2_inv" );
    cmn.CallEventHandler( "use_penguin_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_penguin_2" );
      cmn.CallEventHandler( "use_penguin_2_end" );
      int.Lock( false );

      if ( cmn.IsEventDone( "use_penguin_1" ) and
           cmn.IsEventDone( "use_penguin_2" ) and
           cmn.IsEventDone( "use_butler" ) ) then

        ObjSet( "tmr_toys_ho", { playing = 1, time = 0.3, endtrig = function() cmn.CloseSubRoom(); end } ); 

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_penguin_app" );
    ObjAnimate( "spr_toys_penguin_2", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_casebutton ()

  local item = "inv_casebutton";

  if ( cmn.ApplyObj( item, "gzz_livingroom_stand", false ) and cmn.IsEventDone( "clk_openstand" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stand" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stand_use_casebutton", true ) and cmn.IsEventDone( "clk_openstand" ) ) then

    cmn.CallEventHandler( "use_casebutton_inv" );
    cmn.CallEventHandler( "use_casebutton_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_casebutton" );
      cmn.CallEventHandler( "use_casebutton_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_hex_app" );  
    ObjAnimate( "spr_stand_screwdriver_case_button", "alp", 0, 0, func_end,
    { 
      0.0,0,0, 
      0.3,0,1
    } );
    ObjAnimate( "anm_stand_screwdriver_case_spring", "alp", 0, 0, "",
    { 
      0.0,0,1, 
      0.3,0,0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_boxkey ()

  local item = "inv_boxkey";

  if ( cmn.ApplyObj( item, "gzz_livingroom_stand", false ) ) and
     ( cmn.IsEventDone( "get_screwdriverrmanual" ) and
       cmn.IsEventDone( "get_screwdrivercap" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stand" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stand_use_boxkey", true ) ) and
         ( cmn.IsEventDone( "get_screwdriverrmanual" ) and
           cmn.IsEventDone( "get_screwdrivercap" ) ) then

    cmn.CallEventHandler( "use_boxkey_inv" );
    cmn.CallEventHandler( "use_boxkey_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_boxkey" );
      cmn.CallEventHandler( "use_boxkey_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_comod_key" );
    ObjSet( "spr_stand_closed_box", { alp = 0 } );  
    AnimPlay( "anm_stand_use_boxkey", "DoAnim", func_end);

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_butterfly ()

  local item = "inv_butterfly";

  if ( cmn.ApplyObj( item, "gzz_livingroom_stand", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stand" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stand_use_butterfly", true ) ) then

    cmn.CallEventHandler( "use_butterfly_inv" );
    cmn.CallEventHandler( "use_butterfly_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_butterfly" );
      cmn.CallEventHandler( "use_butterfly_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_butterfly_box_open" );
    ObjAnimate( "spr_stand_butterflybox_key", "alp", 0, 0, "",
    { 
      0.0,0,0, 
      0.3,0,1,
      0.5,0,1,
      0.8,0,0
    } );
    ObjAnimate( "obj_stand_open_butterflybox", "alp", 0, 0, func_end,
    { 
      0.0,0,0, 
      0.5,0,0,
      0.8,0,1
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_screwdriver2 ()

  local item = "inv_screwdriver2";

  if ( cmn.ApplyObj( item, "gzz_livingroom_kitchendoor", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_kitchendoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_kitchendoor_use_screwdriver2", true ) ) then

    cmn.CallEventHandler( "use_screwdriver2_inv" );
    cmn.CallEventHandler( "use_screwdriver2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_screwdriver2" );
      cmn.CallEventHandler( "use_screwdriver2_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_unscrew_door" ); 
    ObjSet( "obj_kitchendoor_screws", { alp = 0 } );
    ObjSet( "anm_kitchendoor_door_click", { alp = 0 } );
    ObjSet( "anm_kitchendoor_use_screwdriver", { alp = 1 } );

    AnimPlay( "anm_kitchendoor_use_screwdriver", "DoAnim", func_end);

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_wire ()

  local item = "inv_wire";

  if ( cmn.ApplyObj( item, "gzz_livingroom_officedoor", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_officedoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_officedoor_use_wire", true ) ) then

    cmn.CallEventHandler( "use_wire_inv" );
    cmn.CallEventHandler( "use_wire_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_wire" );
      cmn.CallEventHandler( "use_wire_end" );
      int.Lock( false );
      cmn.CloseSubRoom();

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_skeleton_open_door" ); 
    ObjAnimate( "spr_officedoor_wire", "pos_xy", 0, 0, "",
    { 
      0.0, 0, -142, 264,
      0.6, 0,  -31, 156, 
    } );

    ObjAnimate( "spr_officedoor_wire", "ang", 0, 0, "", 
    {
      0.0, 3,  0.0,
      0.6, 3,  0.0,
      0.8, 3, -0.2,
      1.0, 3,  0.0,
      1.2, 3, -0.2,
      1.4, 3,  0.0,
    } );

    ObjAnimate( "spr_officedoor_doorhandle", "ang", 0, 0, func_end, 
    {
      0.0, 3,  0.00,
      1.4, 3,  0.00,
      1.7, 3, -0.05,
      2.0, 3, -0.05,
    } );

    return true;
    
  elseif ( cmn.ApplyObj( item, "obj_stand_use_boxkey", true ) ) then

    cmn.ShowBbt( "bbt_stand_use_boxkey_wrong" );
    cmn.PlayAudio( "sfx", "audio/aud_wrongapply1", 0, "", 0 );
    return true;
   
  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_livingroom_survey ()

  local func_end = function ()

    cmn.SetEventDone( "clk_livingroom_survey" );
    cmn.CallEventHandler( "clk_livingroom_survey_end" );
    cmn.CallEventHandler( "clk_livingroom_survey" );    
    cmn.StopAudio( "sfx", "audio/level2/sfx/aud_livingroom_survey_1" );
    cmn.StopAudio( "voc", "audio/level2/voc/aud_livingroom_survey_1_voc" );
    int.Lock( false );
    --cmn.ShowBbt( "bbt_livingroom_after_survey" );

    cmn.AddPageDiary( 8 );

  end;

  cmn.CallEventHandler( "clk_livingroom_survey_beg" );

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_livingroom_survey_1", func_end ); 

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_livingroom_survey_1" );  
  cmn.PlayAudio( "voc", "audio/level2/voc/aud_livingroom_survey_1_voc" );

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_door ()

  local func_end = function ()

    cmn.SetEventDone( "clk_door" );
    cmn.CallEventHandler( "clk_door_end" );
    cmn.CallEventHandler( "clk_door" );
    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_door_beg" );

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_door_away" );
  AnimPlay( "anm_kitchendoor_door_push", "DoAnim", func_end);

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_cabinet_2 ()

  local func_end = function ()

    cmn.SetEventDone( "clk_cabinet_2" );
    cmn.CallEventHandler( "clk_cabinet_2_end" );
    int.Lock( false );
    cmn.CloseSubRoom();

  end;

  cmn.CallEventHandler( "clk_cabinet_2_beg" );

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_cupboard_away" );
  AnimPlay( "anm_kitchendoor_clk_cabinet", "DoAnim", func_end);

end;
-------------------------------------------------
function private.clk_boxkey ()

  local func_end = function ()

    cmn.SetEventDone( "clk_boxkey" );
    cmn.CallEventHandler( "clk_boxkey_end" );
    int.Lock( false );
    ng_global.progress[ "std" ][ "clk_boxkey" ].book = 0;

  end;

  cmn.CallEventHandler( "clk_boxkey_beg" );

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_open_comod" );
  AnimPlay( "anm_stand_clk_boxkey", "DoAnim", func_end);

end;
-------------------------------------------------
function private.clk_openstand ()

  local func_end = function ()

    cmn.SetEventDone( "clk_openstand" );
    cmn.CallEventHandler( "clk_openstand_end" );
    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_openstand_beg" );

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_open_commode" );
  ObjAnimate("obj_stand_open_stand", "alp", 0, 0, func_end, 
  {
    0.0,0,0,
    0.3,0,1
  });

end;
-------------------------------------------------
function private.clk_casebutton ()

  local func_end = function ()

    cmn.SetEventDone( "clk_casebutton" );
    cmn.CallEventHandler( "clk_casebutton_end" );
    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_casebutton_beg" );

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_open_plastic_chest" );
  ObjSet( "spr_stand_closed_box", { alp = 0 } );
  ObjAnimate( "spr_stand_screwdriver_case_closed", "alp", 0, 0, "",
  { 
    0.0,0,1, 
    0.3,0,0
  } );
  ObjAnimate( "obj_stand_screwdriver_case_open", "alp", 0, 0, func_end,
  { 
    0.0,0,0, 
    0.3,0,1
  } );

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_harebackopen ()

  local func_end = function ()

    cmn.SetEventDone( "clk_harebackopen" );
    cmn.CallEventHandler( "clk_harebackopen_end" );
    cmn.CallEventHandler( "clk_harebackopen" );
    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_harebackopen_beg" );

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_open_toycar" );
  ObjAnimate( "obj_toys_open_car", "alp", 0, 0, func_end, 
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

end;
-------------------------------------------------
function private.clk_vid_inyard ()

  cmn.CallEventHandler( "clk_vid_inyard_beg" );
  int.Lock( true );
  
  local func_end = function ()

    cmn.SetEventDone( "clk_vid_inyard" );
    cmn.CallEventHandler( "clk_vid_inyard_end" );

    int.Lock( false );

    cmn.ShowBbt( "bbt_livingroom_inyard" );
    cmn.PlayAudio( "mus", "audio/level1/mus/aud_scare_mid_mus" );
    cmn.StopAudio( "voc", "audio/level2/voc/aud_livingroom_in_yard_voc" );
    cmn.StopAudio( "sfx", "audio/level2/sfx/aud_livingroom_in_yard" );

  end;

  common_impl.PlayDialogVideo( "vid_livingroom_inyard", func_end ); 

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_livingroom_in_yard" );
  cmn.PlayAudio( "voc", "audio/level2/voc/aud_livingroom_in_yard_voc" );

end;
-------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_livingroom ()

  if not ( cmn.IsEventDone( "opn_livingroom" ) ) then

    cmn.SetEventDone( "opn_livingroom" );
    ng_global.progress[ "std" ][ "opn_livingroom" ].open = 0;
    cmn.ShowBbt( "bbt_livingroom_open" );    

  end;

end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopAllEnv( "audio/level2/env/aud_childroom_env", true );
  cmn.PlayAudio( "env", "audio/level2/env/aud_childroom_env", 1 );

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_livingroom();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_brokenelectricscrewdriver" );  
  int.AddedTaskMap( private.room_objname, "get_casebutton" );
  int.AddedTaskMap( private.room_objname, "get_signet",                      { "use_airplanewing", "use_airplanenose" } );   
  int.AddedTaskMap( private.room_objname, "get_battery",                     { "clk_harebackopen" } );  
  int.AddedTaskMap( private.room_objname, "get_spraynozzle" ); 
  int.AddedTaskMap( private.room_objname, "get_screwdriverrmanual",          { "clk_casebutton" } ); 
  int.AddedTaskMap( private.room_objname, "get_screwdrivercap",              { "clk_casebutton" } );
  int.AddedTaskMap( private.room_objname, "get_documentfolder",              { "clk_boxkey" } ); 
  int.AddedTaskMap( private.room_objname, "get_pearl",                       { "use_butterfly" } ); 

  int.AddedTaskMap( private.room_objname, "use_slingshotframe",              { "get_slingshotframe" } ); 
  int.AddedTaskMap( private.room_objname, "use_airplanewing",                { "get_airplanewing" } ); 
  int.AddedTaskMap( private.room_objname, "use_airplanenose",                { "get_airplanenose" } ); 
  int.AddedTaskMap( private.room_objname, "use_butler",                      { "get_butler" } ); 
  int.AddedTaskMap( private.room_objname, "use_penguin_1",                   { "get_penguin_1" } );
  int.AddedTaskMap( private.room_objname, "use_penguin_2",                   { "get_penguin_2" } ); 
  int.AddedTaskMap( private.room_objname, "use_casebutton",                  { "clk_openstand", "get_casebutton" } ); 
  int.AddedTaskMap( private.room_objname, "use_boxkey",                      { "get_boxkey" } );
  int.AddedTaskMap( private.room_objname, "use_butterfly",                   { "get_butterfly" } );
  int.AddedTaskMap( private.room_objname, "use_screwdriver2",                { "get_screwdriver2" } );
  int.AddedTaskMap( private.room_objname, "use_wire",                        { "get_wire" } );

  int.AddedTaskMap( private.room_objname, "clk_door",                        { "use_screwdriver2" } ); 
  int.AddedTaskMap( private.room_objname, "clk_cabinet_2",                   { "clk_door" } ); 
  int.AddedTaskMap( private.room_objname, "clk_openstand" ); 
  int.AddedTaskMap( private.room_objname, "clk_casebutton",                  { "use_casebutton" } ); 
  int.AddedTaskMap( private.room_objname, "clk_harebackopen" ); 
  int.AddedTaskMap( private.room_objname, "clk_boxkey",                      { "use_boxkey" } ); 

  int.AddedTaskMap( private.room_objname, "opn_yard",                        { "use_slingshotframe" } ); 
  int.AddedTaskMap( private.room_objname, "opn_office",                      { "use_wire" } ); 
  int.AddedTaskMap( private.room_objname, "opn_kitchen",                     { "clk_cabinet_2" } );  

  int.AddedTaskMap( private.room_objname, "win_dollhouse",                   { "use_butler", "use_penguin_1", "use_penguin_2" } );  

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_stand" );
  -------------------------------------------------
  function zz_stand.PreOpen()

    if ( ng_global.progress[ "std" ][ "clk_boxkey" ].book == 1 ) then

      ObjDelete( "obj_stand_clk_book" );
      ObjSet( "spr_stand_open_book", { alp = 1, input = true } );

    end; 

  end;
  -------------------------------------------------

  subroom.Define( "zz_deskwithschemes" );
  -------------------------------------------------
  function zz_deskwithschemes.Open()

    if ng_global.progress[ "std" ][ "opn_livingroom" ].open == 0 then
      cmn.ShowBbt( "bbt_deskwithschemes_open" );
      ng_global.progress[ "std" ][ "opn_livingroom" ].open = 1;
    end;

  end;
  -------------------------------------------------
  function zz_deskwithschemes.Close()

    cmn.NoteScaleEnd( { "spr_deskwithschemes_note" }, true );

  end;

end;
--*********************************************************************************************************************
function private.DeskwithschemesBoxClick ()

  local func_end = function ()

    int.Lock( false );
    if cmn.IsEventDone( "use_airplanewing" ) or cmn.IsEventDone( "use_airplanenose" ) then

      cmn.ShowBbt( "bbt_deskwithschemes_2" );

    else

      cmn.ShowBbt( "bbt_deskwithschemes_1" );

    end;

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_plane_box_touch" );
  ObjAnimate( "spr_deskwithschemes_box_close", "pos_xy", 0, 0, func_end, 
  {
    0.0, 3, 145, 128,
    0.2, 3, 147, 130,
    0.4, 3, 145, 128,
    0.6, 3, 147, 130,
    0.8, 3, 145, 128,
  } );

end;
--*********************************************************************************************************************
function private.OfficedoorHandleClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_officedoor_use_wire" );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_touch_door_handle" );
  ObjAnimate( "spr_officedoor_doorhandle", "ang", 0, 0, func_end, 
  {
    0.0, 3,  0.00,
    0.2, 3, -0.05,
    0.4, 3,  0.00,
    0.6, 3, -0.05,
    0.8, 3,  0.00,
  } );

end;
--*********************************************************************************************************************
function private.ClkStand ()

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_comod_touch" );
  ObjAnimate( "spr_stand_closed_box", "pos_xy", 0, 0, 
  function ()
    int.Lock( false );
    cmn.ShowBbt( "bbt_stand_use_boxkey" );
  end, 
  {
    0.0,0,53,6,
    0.2,0,52,7,
    0.4,0,53,6
  } );

end;
--*********************************************************************************************************************
function private.ClkCase ()

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_box_xx" );
  ObjAnimate("spr_stand_screwdriver_case_closed", "pos_xy", 0, 0, 
  function ()
    int.Lock( false );
    cmn.ShowBbt( "bbt_stand_use_casebutton" );
  end, 
  {
    0.0,0,-49,141,
    0.2,0,-48,140,
    0.4,0,-49,141
  });

end;
--*********************************************************************************************************************
function private.ClkButterflybox ()

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_butterfly_box_touch" );
  ObjAnimate( "spr_stand_closed_butterflybox", "pos_xy", 0, 0, 
  function ()
    int.Lock( false );
    cmn.ShowBbt( "bbt_stand_use_butterfly" );
  end, 
  {
    0.0,0,12,-189,
    0.2,0,11,-190,
    0.4,0,12,-189
  } );

end;
--*********************************************************************************************************************
function private.KitchendoorDoorClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_kitchendoor_use_screwdriver" );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_door_touch" );
  AnimPlay( "anm_kitchendoor_door_click", "DoAnim", func_end);

end;
--*********************************************************************************************************************
function private.KitchendoorBallClick ()

  local func_end = function ()

    int.Lock( false );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_touch_ball" );
  ObjAnimate( "spr_kitchendoor_ball", "pos_x", 0, 0, "", 
  {
    0.0, 3, -106,
    0.2, 3, -100,
    0.4, 3, -106,
    0.6, 3, -102,
    0.8, 3, -106,
    1.0, 3, -104,
    1.2, 3, -106,
  } );

  ObjAnimate( "spr_kitchendoor_ball", "ang", 0, 0, func_end, 
  {
    0.0, 3,  0.00,
    0.2, 3, -0.15,
    0.4, 3,  0.00,
    0.6, 3, -0.10,
    0.8, 3,  0.00,
    1.0, 3, -0.05,
    1.2, 3,  0.00,
  } );

end;
--*********************************************************************************************************************
function private.Anims ()

  ObjAnimate( "spr_livingroom_light", "alp", 1, 0, "", 
  {
    0, 3, 1.0,
    1, 3, 0.0,
    2, 3, 1.0,
  } );

  ObjAnimate( "spr_officedoor_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    3.3, 3, 1.0,
    6.6, 3, 0.3,
  } );

  ObjAnimate( "spr_toys_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    3.3, 3, 1.0,
    6.6, 3, 0.3,
  } );

  ObjAnimate( "spr_toys_hotspot", "alp", 1, 0, "", 
  {
    0.0, 0, 1,
    1.5, 0, 0,
    3.0, 0, 1
  } );

  ObjAnimate( "spr_livingroom_lamp", "pos_x", 1, 0, "", 
  {
    0.0, 3, 340,
    3.0, 3, 350,
    6.0, 3, 340,
  } );

  ObjAnimate( "spr_livingroom_windowrope", "ang", 1, 0, "", 
  {
    0.0, 3, -0.02,
    2.3, 3,  0.02,
    4.6, 3, -0.02,
  } );

end;
--*********************************************************************************************************************
function private.ClkBook ()

  local func_end = function ()

    ng_global.progress[ "std" ][ "clk_boxkey" ].book = 1;
    ObjDelete( "obj_stand_clk_book" );
    ObjSet( "spr_stand_open_book", { input = true } );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_open_comod_book" );
  ObjAnimate( "spr_stand_open_book", "alp", 0, 0, func_end, 
  {
    0.0, 0, 0,
    0.3, 0, 1
  } );

end;
--*********************************************************************************************************************
function private.ClkMirror ()

  local func_end = function ()

    int.Lock( false );

  end;

  int.Lock( true );

  local number = "";

  if not cmn.IsEventDone( "use_airplanewing" ) then
    number = "1";
  elseif ( not cmn.IsEventDone( "get_signet" ) and cmn.IsEventDone( "use_airplanewing" ) ) then
    number = "2";
  else 
    number = "3";
  end;

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_touch_mirror" );
  AnimPlay( "anm_deskwithschemes_morrow_"..number.."_click", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.ClkWindow ()

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_touch_window" );
  AnimPlay( "anm_window_closed_click", "DoAnim", 
  function ()
    int.Lock( false );
    cmn.ShowBbt( "bbt_window_use_slingshotframe" );
  end);

end;
--*********************************************************************************************************************
function private.ClkFlower ()

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_touch_roses" );
  AnimPlay( "anm_window_flower_clk", "DoAnim", 
  function ()
    int.Lock( false );
  end);

end;
--*********************************************************************************************************************
function private.ClkToy ()

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_touch_springtoy" );
  AnimPlay( "anm_toys_bag_head", "DoAnim", 
  function ()
    int.Lock( false );
  end);

end;
--*********************************************************************************************************************
function private.ClkToyBunny ()

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_touch_rabbittoy" );
  AnimPlay( "anm_livingroom_toy", "DoAnim", 
  function ()

    int.Lock( false );

  end);

end;
--*********************************************************************************************************************