-- name=rm_office
--********************* ************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_office";

  ObjAttach( "zz_officedesk", "room_hub" );
  ObjAttach( "zz_closet",     "room_hub" );
  ObjAttach( "zz_fishtank",   "room_hub" );
  
  ObjMultiSet( {
    { "spr_officedesk_airplanenose",       { event_mdown = private.get_airplanenose } },
    { "spr_officedesk_pliers2",            { event_mdown = private.get_pliers2 } },
    { "spr_officedesk_bell_1",             { event_mdown = private.get_bell_1 } },
    { "spr_officedesk_doordowel_2",        { event_mdown = private.get_doordowel_2 } },
    { "spr_officedesk_switchroomplan",     { event_mdown = private.get_switchroomplan } },
    { "spr_closet_snailamulet_2",          { event_mdown = private.get_snailamulet_2 } },
    { "spr_closet_fountainpen",            { event_mdown = private.get_fountainpen } },
    { "spr_closet_boathook",               { event_mdown = private.get_boathook } },
    { "spr_fishtank_artificialflower_1",   { event_mdown = private.get_artificialflower_1 } },
    { "obj_officedesk_use_fountainpen",    { event_mdown = private.ClkPenCap } },
    { "spr_officedesk_stash_closed",       { event_mdown = private.ClkStashCover } },
    { "obj_officedesk_use_twotinedfork",   { event_mdown = private.ClkStash2Cover } },
    { "obj_closet_use_signet",             { event_mdown = private.ClosetDoorClick } },
    { "spr_officedesk_collect2_2_3",       { event_mdown = private.get_collect2_2_3 } },
    { "obj_fishtank_use_boathook",         { event_mdown = private.ClkArtificialFlower } },
    { "obj_officedesk_mouse_drag",         { event_startdrag = function() private.StartDragMouse() end } },
    { "obj_officedesk_mouse_drag",         { event_drag = function() private.DragMouse() end } },
    { "spr_officedesk_mouse",              { event_mdown = function() private.ClkMouse() end } },    
    { "obj_office_chair",                  { event_mdown = private.ClkChair } },
    { "obj_office_sconce",                 { event_mdown = private.ClkSconce } },
    { "obj_officedesk_use_ambereye_1",     { event_mdown = private.TigerBbt } },
    { "obj_officedesk_use_ambereye_2",     { event_mdown = private.TigerBbt } },
    { "obj_closet_use_toggleswitch_1",     { event_mdown = private.ToggleswitchBbt } },
    { "obj_closet_use_toggleswitch_2",     { event_mdown = private.ToggleswitchBbt } },
    { "spr_fishtank_airplanewing",         { event_mdown = private.get_airplanewing } },
  } );

  private.InitAnim();
  private.InitSubroom();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_office = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gzz_office_officedesk",
        "gzz_office_closet",
        "gzz_office_fishtank",
        "gmg_office_onsafedoor",
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_officedesk", 
        "zz_closet", 
        "zz_fishtank",
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_office", update_game_mode_office, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_fountainpen () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fountainpen" ] =
  {
    type = "get",
    get_obj = "spr_closet_fountainpen",
    room = private.room_objname,
    zz = "zz_closet",
    zz_gate = "gzz_office_closet"
  };
  -----------------------------------------------
  local get_fountainpen_inv = function ()

    int.InventoryItemAdd( "inv_fountainpen", "spr_closet_fountainpen" );

  end;

  local get_fountainpen_closezz = function ()

    ObjDelete( "gfx_closet_fountainpen" );
    ObjDelete( "spr_closet_fountainpen_shadow" );
    ObjDelete( "spr_office_fountainpen" );

  end;

  cmn.AddSubscriber( "get_fountainpen", get_fountainpen_inv );
  cmn.AddSubscriber( "get_fountainpen", get_fountainpen_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pliers2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pliers2" ] =
  {
    type = "get",
    get_obj = "spr_officedesk_pliers2",
    room = private.room_objname,
    zz = "zz_officedesk",
    zz_gate = "gzz_office_officedesk"
  };
  -----------------------------------------------
  local get_pliers2_inv = function ()

    int.InventoryItemAdd( "inv_pliers2", "spr_officedesk_pliers2" );
    ObjSet( "inv_fork_plus_focus2", { alp = 1 } );

  end;

  local get_pliers2_closezz = function ()

    ObjDelete( "gfx_officedesk_pliers2" );
    ObjDelete( "spr_officedesk_pliers2_shadow" );

    if ( cmn.IsEventDone( "get_airplanenose" ) ) then

      ObjSet( "obj_officedesk_use_twotinedfork", { input = true } );

    end;

  end;

  cmn.AddSubscriber( "get_pliers2", get_pliers2_inv );
  cmn.AddSubscriber( "get_pliers2", get_pliers2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bell_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bell_1" ] =
  {
    type = "get",
    get_obj = "spr_officedesk_bell_1",
    room = private.room_objname,
    zz = "zz_officedesk",
    zz_gate = "gzz_office_officedesk"
  };
  -----------------------------------------------
  local get_bell_1_inv = function ()

    int.InventoryItemAdd( "inv_bell_1", "spr_officedesk_bell_1" );

  end;

  local get_bell_1_closezz = function ()

    ObjDelete( "gfx_officedesk_bell_1" );
    ObjDelete( "spr_officedesk_bell_1_shadow" );
    ObjDelete( "spr_office_note" );

  end;

  cmn.AddSubscriber( "get_bell_1", get_bell_1_inv );
  cmn.AddSubscriber( "get_bell_1", get_bell_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bell_3 () end;
  --------------------------------------------------------------------------------------------
  local get_bell_3_closezz = function ()

    ObjDelete( "spr_office_note2" );

  end;

  cmn.AddSubscriber( "get_bell_3", get_bell_3_closezz, private.room_objname );
  ------------------------------------------------------------------------------------------
  -- function get_doordowel_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_doordowel_2" ] =
  {
    type = "get",
    get_obj = "spr_officedesk_doordowel_2",
    room = private.room_objname,
    zz = "zz_officedesk",
    zz_gate = "gzz_office_officedesk"
  };
  -----------------------------------------------
  local get_doordowel_2_inv = function ()

    int.InventoryItemAdd( "inv_doordowel_1", "spr_officedesk_doordowel_2", "assets/levels/level2/rm_kitchen/zz_shelvesonwall/inv/inv_doordowel_morph" );
    level2_inv.CheckDoordowel ();

  end;

  local get_doordowel_2_closezz = function ()

    ObjDelete( "gfx_officedesk_doordowel_2" );
    ObjDelete( "spr_officedesk_doordowel_2_shadow" );
    ObjSet( "spr_officedesk_letter", { input = true } );

  end;

  cmn.AddSubscriber( "get_doordowel_2", get_doordowel_2_inv );
  cmn.AddSubscriber( "get_doordowel_2", get_doordowel_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_switchroomplan () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_switchroomplan" ] =
  {
    type = "get",
    get_obj = "spr_officedesk_switchroomplan",
    room = private.room_objname,
    zz = "zz_officedesk",
    zz_gate = "gzz_office_officedesk"
  };
  -----------------------------------------------
  local get_switchroomplan_inv = function ()

    int.InventoryItemAdd( "inv_switchroomplan", "spr_officedesk_switchroomplan" );
    ObjSet( "inv_switchroomplan", { drag = false } );

  end;

  local get_switchroomplan_closezz = function ()

    ObjDelete( "gfx_officedesk_switchroomplan" );
    ObjDelete( "spr_officedesk_switchroomplan_shadow" );

  end;

  cmn.AddSubscriber( "get_switchroomplan", get_switchroomplan_inv );
  cmn.AddSubscriber( "get_switchroomplan", get_switchroomplan_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_snailamulet_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_snailamulet_2" ] =
  {
    type = "get",
    get_obj = "spr_closet_snailamulet_2",
    room = private.room_objname,
    zz = "zz_closet",
    zz_gate = "gzz_office_closet"
  };
  -----------------------------------------------
  local get_snailamulet_2_inv = function ()

    int.InventoryItemAdd( "inv_snailamulet_2", "spr_closet_snailamulet_2" );

  end;

  local get_snailamulet_2_closezz = function ()

    ObjDelete( "gfx_closet_snailamulet_2" );
    ObjDelete( "spr_closet_snailamulet_2_shadow" );
    ObjDelete( "spr_office_snailamulet_2" );

  end;

  cmn.AddSubscriber( "get_snailamulet_2", get_snailamulet_2_inv );
  cmn.AddSubscriber( "get_snailamulet_2", get_snailamulet_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_boathook () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_boathook" ] =
  {
    type = "get",
    get_obj = "spr_closet_boathook",
    room = private.room_objname,
    zz = "zz_closet",
    zz_gate = "gzz_office_closet"
  };
  -----------------------------------------------
  local get_boathook_inv = function ()

    int.InventoryItemAdd( "inv_boathook", "spr_closet_boathook" );

  end;

  local get_boathook_closezz = function ()

    ObjDelete( "gfx_closet_boathook" );
    ObjDelete( "spr_closet_boathook_shadow" );
    ObjDelete( "spr_closet_boathook_over" );
    ObjDelete( "spr_office_boathook" );

  end;

  cmn.AddSubscriber( "get_boathook", get_boathook_inv );
  cmn.AddSubscriber( "get_boathook", get_boathook_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_artificialflower_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_artificialflower_1" ] =
  {
    type = "get",
    get_obj = "spr_fishtank_artificialflower_1",
    room = private.room_objname,
    zz = "zz_fishtank",
    zz_gate = "gzz_office_fishtank"
  };
  -----------------------------------------------
  local get_artificialflower_1_inv = function ()

    int.InventoryItemAdd( "inv_artificialflower_1", "spr_fishtank_artificialflower_1" );

  end;

  local get_artificialflower_1_closezz = function ()

    ObjDelete( "gfx_fishtank_artificialflower_1" );
    if cmn.IsEventDone( "get_airplanewing" ) then    
      ObjDelete( "gzz_office_fishtank" );
    end;
    ObjDelete( "spr_office_artificialflower_1" );

  end;

  cmn.AddSubscriber( "get_artificialflower_1", get_artificialflower_1_inv );
  cmn.AddSubscriber( "get_artificialflower_1", get_artificialflower_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_airplanewing () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_airplanewing" ] =
  {
    type = "get",
    get_obj = "spr_fishtank_airplanewing",
    room = private.room_objname,
    zz = "zz_fishtank",
    zz_gate = "gzz_office_fishtank"
  };
  -----------------------------------------------
  local get_airplanewing_inv = function ()

    int.InventoryItemAdd( "inv_airplanewing", "spr_fishtank_airplanewing" );

  end;

  local get_airplanewing_closezz = function ()

    ObjDelete( "gfx_fishtank_airplanewing" );
    ObjDelete( "spr_fishtank_airplanewing_shadow" );
    ObjDelete( "spr_office_airplanewing" );


    if cmn.IsEventDone( "get_artificialflower_1" ) then    
      ObjDelete( "gzz_office_fishtank" );
    end;

  end;

  cmn.AddSubscriber( "get_airplanewing", get_airplanewing_inv );
  cmn.AddSubscriber( "get_airplanewing", get_airplanewing_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_airplanenose () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_airplanenose" ] =
  {
    type = "get",
    get_obj = "spr_officedesk_airplanenose",
    room = private.room_objname,
    zz = "zz_officedesk",
    zz_gate = "gzz_office_officedesk"
  };
  -----------------------------------------------
  local get_airplanenose_inv = function ()

    int.InventoryItemAdd( "inv_airplanenose", "spr_officedesk_airplanenose" );

  end;

  local get_airplanenose_closezz = function ()

    ObjDelete( "gfx_officedesk_airplanenose" );
    ObjDelete( "spr_officedesk_airplanenose_shadow" );

    if ( cmn.IsEventDone( "get_pliers2" ) ) then

      ObjSet( "obj_officedesk_use_twotinedfork", { input = true } );

    end;

  end;

  cmn.AddSubscriber( "get_airplanenose", get_airplanenose_inv );
  cmn.AddSubscriber( "get_airplanenose", get_airplanenose_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_2_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_2_3 = function ()

    ObjDelete( "spr_officedesk_collect2_2_3" );
    ObjDelete( "spr_officedesk_collect2_2_3_shadow" );

  end;

  cmn.AddSubscriber( "get_collect2_2_3", get_collect2_2_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_2_4 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_2_4 = function ()

    ObjDelete( "obj_office_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_2_4", get_morphobject_2_4, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_fountainpen () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fountainpen" ] =
  {
    type = "use",
    use_obj = "inv_fountainpen",
    use_place = "obj_officedesk_use_fountainpen",
    room = private.room_objname,
    zz = "zz_officedesk",
    zz_gate = "gzz_office_officedesk"
  };
  -----------------------------------------------
  local use_fountainpen_inv = function ()

    int.InventoryItemRemove( "inv_fountainpen" );

  end;
  local use_fountainpen_beg = function ()

    ObjDelete( "obj_officedesk_use_fountainpen" );

  end;
  local use_fountainpen_end = function ()

    ObjSet( "spr_officedesk_airplanenose", { input = true } );
    ObjSet( "gfx_officedesk_airplanenose", { active = true } );
    ObjSet( "spr_officedesk_pliers2", { input = true } );
    ObjSet( "gfx_officedesk_pliers2", { active = true } );
    ObjSet( "spr_officedesk_pen", { alp = 1 } );
    ObjSet( "spr_officedesk_pen_over", { alp = 1 }  );
    ObjSet( "spr_officedesk_pen_shadow", { alp = 1 } );
    ObjSet( "spr_officedesk_stash_open", { alp = 1 } );
    ObjSet( "obj_officedesk_stash_2_open", { alp = 1 } );
    ObjDelete( "spr_officedesk_stash_closed" );
    ObjDelete( "anm_officedesk_use_fountainpen" );
    ObjDelete( "spr_officedesk_pen_cap" );
    ObjSet( "spr_office_pen", { alp = 1 } );
    ObjSet( "spr_office_opn_table", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_fountainpen", use_fountainpen_beg, private.room_objname );
  cmn.AddSubscriber( "use_fountainpen", use_fountainpen_inv );
  cmn.AddSubscriber( "use_fountainpen", use_fountainpen_end, private.room_objname );
  cmn.AddSubscriber( "use_fountainpen_inv", use_fountainpen_inv, private.room_objname );
  cmn.AddSubscriber( "use_fountainpen_beg", use_fountainpen_beg, private.room_objname );
  cmn.AddSubscriber( "use_fountainpen_end", use_fountainpen_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_twotinedfork () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_twotinedfork" ] =
  {
    type = "use",
    use_obj = "inv_twotinedfork",
    use_place = "obj_officedesk_use_twotinedfork",
    room = private.room_objname,
    zz = "zz_officedesk",
    zz_gate = "gzz_office_officedesk"
  };
  -----------------------------------------------
  local use_twotinedfork_inv = function ()

    int.InventoryItemRemove( "inv_twotinedfork" );

  end;
  local use_twotinedfork_beg = function ()

    ObjDelete( "obj_officedesk_use_twotinedfork" );

  end;
  local use_twotinedfork_end = function ()

    ObjSet( "spr_officedesk_stash_2_closed", { pos_x = -78, pos_y = 64, alp = 1 } );
    ObjSet( "obj_officedesk_stash_2_open", { input = true } );
    ObjSet( "spr_officedesk_doordowel_2", { input = true } );
    ObjSet( "gfx_officedesk_doordowel_2", { active = true } );

    ObjDelete( "anm_officedesk_use_twotinedfork" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_twotinedfork", use_twotinedfork_beg, private.room_objname );
  cmn.AddSubscriber( "use_twotinedfork", use_twotinedfork_inv );
  cmn.AddSubscriber( "use_twotinedfork", use_twotinedfork_end, private.room_objname );
  cmn.AddSubscriber( "use_twotinedfork_inv", use_twotinedfork_inv, private.room_objname );
  cmn.AddSubscriber( "use_twotinedfork_beg", use_twotinedfork_beg, private.room_objname );
  cmn.AddSubscriber( "use_twotinedfork_end", use_twotinedfork_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ambereye_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ambereye_1" ] =
  {
    type = "use",
    use_obj = "inv_ambereye_1",
    use_place = "obj_officedesk_use_ambereye_1",
    room = private.room_objname,
    zz = "zz_officedesk",
    zz_gate = "gzz_office_officedesk"
  };
  -----------------------------------------------
  local use_ambereye_1_inv = function ()

    int.InventoryItemRemove( "inv_ambereye_1" );

  end;
  local use_ambereye_1_beg = function ()

    ObjDelete( "obj_officedesk_use_ambereye_1" );

  end;
  local use_ambereye_1_end = function ()

    ObjSet( "spr_officedesk_tiger_1", { alp = 1 } );
    ObjSet( "spr_office_tiger1", { alp = 1 } );  

    if cmn.IsEventDone( "use_ambereye_2" ) then

      ObjSet( "spr_office_opn_tigerstand", { alp = 1 } );   
      ObjSet( "obj_officedesk_box_open", { input = true, alp = 1 } );
      ObjSet( "gfx_officedesk_switchroomplan", { active = true } ); 
      ObjDelete( "anm_officedesk_use_ambereye" ); 

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_ambereye_1", use_ambereye_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_ambereye_1", use_ambereye_1_inv );
  cmn.AddSubscriber( "use_ambereye_1", use_ambereye_1_end, private.room_objname );
  cmn.AddSubscriber( "use_ambereye_1_inv", use_ambereye_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_ambereye_1_beg", use_ambereye_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_ambereye_1_end", use_ambereye_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ambereye_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ambereye_2" ] =
  {
    type = "use",
    use_obj = "inv_ambereye_2",
    use_place = "obj_officedesk_use_ambereye_2",
    room = private.room_objname,
    zz = "zz_officedesk",
    zz_gate = "gzz_office_officedesk"
  };
  -----------------------------------------------
  local use_ambereye_2_inv = function ()

    int.InventoryItemRemove( "inv_ambereye_2" );

  end;
  local use_ambereye_2_beg = function ()

    ObjDelete( "obj_officedesk_use_ambereye_2" );

  end;
  local use_ambereye_2_end = function ()

    ObjSet( "spr_officedesk_tiger_2", { alp = 1 } );
    ObjSet( "spr_office_tiger2", { alp = 1 } );  

    if cmn.IsEventDone( "use_ambereye_1" ) then

      ObjSet( "spr_office_opn_tigerstand", { alp = 1 } );   
      ObjSet( "obj_officedesk_box_open", { input = true, alp = 1 } );
      ObjSet( "gfx_officedesk_switchroomplan", { active = true } ); 
      ObjDelete( "anm_officedesk_use_ambereye" ); 

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_ambereye_2", use_ambereye_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_ambereye_2", use_ambereye_2_inv );
  cmn.AddSubscriber( "use_ambereye_2", use_ambereye_2_end, private.room_objname );
  cmn.AddSubscriber( "use_ambereye_2_inv", use_ambereye_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_ambereye_2_beg", use_ambereye_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_ambereye_2_end", use_ambereye_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_signet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_signet" ] =
  {
    type = "use",
    use_obj = "inv_signet",
    use_place = "obj_closet_use_signet",
    room = private.room_objname,
    zz = "zz_closet",
    zz_gate = "gzz_office_closet"
  };
  -----------------------------------------------
  local use_signet_inv = function ()

    int.InventoryItemRemove( "inv_signet" );

  end;
  local use_signet_beg = function ()

    ObjDelete( "obj_closet_use_signet" );

  end;
  local use_signet_end = function ()

    ObjSet( "obj_closet_toggleswitch",  { input = true } );
    ObjSet( "spr_closet_boathook",      { input = true, active = true } );
    ObjSet( "spr_closet_snailamulet_2", { input = true, active = true } );
    ObjSet( "obj_closet_doors_open",    { alp = 1 } );
    ObjDelete( "obj_closet_doors_close" );
    ObjSet( "obj_office_closet",   { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_signet", use_signet_beg, private.room_objname );
  cmn.AddSubscriber( "use_signet", use_signet_inv );
  cmn.AddSubscriber( "use_signet", use_signet_end, private.room_objname );
  cmn.AddSubscriber( "use_signet_inv", use_signet_inv, private.room_objname );
  cmn.AddSubscriber( "use_signet_beg", use_signet_beg, private.room_objname );
  cmn.AddSubscriber( "use_signet_end", use_signet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_toggleswitch_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_toggleswitch_1" ] =
  {
    type = "use",
    use_obj = "inv_toggleswitch_1",
    use_place = "obj_closet_use_toggleswitch_1",
    room = private.room_objname,
    zz = "zz_closet",
    zz_gate = "gzz_office_closet"
  };
  -----------------------------------------------
  local use_toggleswitch_1_inv = function ()

    int.InventoryItemRemove( "inv_toggleswitch_1" );

  end;
  local use_toggleswitch_1_beg = function ()

    ObjDelete( "obj_closet_use_toggleswitch_1" );

  end;
  local use_toggleswitch_1_end = function ()

    ObjSet( "spr_closet_toggleswitch_1", { alp = 1 } );
    ObjSet( "spr_office_safelock1", { alp = 1 } );

    if ( cmn.IsEventDone( "use_toggleswitch_2" ) ) then

      ObjDelete( "spr_office_safelock1" );
      ObjDelete( "spr_office_safelock2" );
      ObjSet( "obj_office_closet_mg", { alp = 1 } );
      ObjDelete( "gzz_office_closet" );
      ObjSet( "gmg_office_onsafedoor", { active = true, input = true, alp = 1 } );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_toggleswitch_1", use_toggleswitch_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_toggleswitch_1", use_toggleswitch_1_inv );
  cmn.AddSubscriber( "use_toggleswitch_1", use_toggleswitch_1_end, private.room_objname );
  cmn.AddSubscriber( "use_toggleswitch_1_inv", use_toggleswitch_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_toggleswitch_1_beg", use_toggleswitch_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_toggleswitch_1_end", use_toggleswitch_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_toggleswitch_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_toggleswitch_2" ] =
  {
    type = "use",
    use_obj = "inv_toggleswitch_2",
    use_place = "obj_closet_use_toggleswitch_2",
    room = private.room_objname,
    zz = "zz_closet",
    zz_gate = "gzz_office_closet"
  };
  -----------------------------------------------
  local use_toggleswitch_2_inv = function ()

    int.InventoryItemRemove( "inv_toggleswitch_2" );

  end;
  local use_toggleswitch_2_beg = function ()

    ObjDelete( "obj_closet_use_toggleswitch_2" );

  end;
  local use_toggleswitch_2_end = function ()

    ObjSet( "spr_closet_toggleswitch_2", { alp = 1 } );
    ObjSet( "spr_office_safelock2", { alp = 1 } );

    if ( cmn.IsEventDone( "use_toggleswitch_1" ) ) then

      ObjDelete( "spr_office_safelock1" );
      ObjDelete( "spr_office_safelock2" );
      ObjSet( "obj_office_closet_mg", { alp = 1 } );
      ObjDelete( "gzz_office_closet" );
      ObjSet( "gmg_office_onsafedoor", { active = true, input = true, alp = 1 } );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_toggleswitch_2", use_toggleswitch_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_toggleswitch_2", use_toggleswitch_2_inv );
  cmn.AddSubscriber( "use_toggleswitch_2", use_toggleswitch_2_end, private.room_objname );
  cmn.AddSubscriber( "use_toggleswitch_2_inv", use_toggleswitch_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_toggleswitch_2_beg", use_toggleswitch_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_toggleswitch_2_end", use_toggleswitch_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_boathook () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_boathook" ] =
  {
    type = "use",
    use_obj = "inv_boathook",
    use_place = "obj_fishtank_use_boathook",
    room = private.room_objname,
    zz = "zz_fishtank",
    zz_gate = "gzz_office_fishtank"
  };
  -----------------------------------------------
  local use_boathook_inv = function ()

    int.InventoryItemRemove( "inv_boathook" );

  end;
  local use_boathook_beg = function ()

    ObjDelete( "obj_fishtank_use_boathook" );

  end;
  local use_boathook_end = function ()

    ObjSet( "spr_fishtank_artificialflower_1", { active = true, input = true, visible = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_boathook", use_boathook_beg, private.room_objname );
  cmn.AddSubscriber( "use_boathook", use_boathook_inv );
  cmn.AddSubscriber( "use_boathook", use_boathook_end, private.room_objname );
  cmn.AddSubscriber( "use_boathook_inv", use_boathook_inv, private.room_objname );
  cmn.AddSubscriber( "use_boathook_beg", use_boathook_beg, private.room_objname );
  cmn.AddSubscriber( "use_boathook_end", use_boathook_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function win_onsafedoor () end;
  --------------------------------------------------------------------------------------------
  local win_onsafedoor_closezz = function ()

    ObjSet( "obj_office_closet_mg_open", { alp = 1 } );

  end;

  cmn.AddSubscriber( "win_onsafedoor", win_onsafedoor_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_safedoor () end;
  --------------------------------------------------------------------------------------------
  local clk_safedoor_closezz = function ()

    ObjDelete( "spr_office_grille" );

  end;

  cmn.AddSubscriber( "clk_safedoor", clk_safedoor_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
function private.get_fountainpen ()

  cmn.SetEventDone( "get_fountainpen" );
  cmn.CallEventHandler( "get_fountainpen" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_pliers2 ()

  cmn.SetEventDone( "get_pliers2" );
  cmn.CallEventHandler( "get_pliers2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_bell_1 ()

  cmn.SetEventDone( "get_bell_1" );
  cmn.CallEventHandler( "get_bell_1" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_doordowel_2 ()

  cmn.SetEventDone( "get_doordowel_2" );
  cmn.CallEventHandler( "get_doordowel_2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_switchroomplan ()

  cmn.SetEventDone( "get_switchroomplan" );
  cmn.CallEventHandler( "get_switchroomplan" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_snailamulet_2 ()

  cmn.SetEventDone( "get_snailamulet_2" );
  cmn.CallEventHandler( "get_snailamulet_2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_boathook ()

  cmn.SetEventDone( "get_boathook" );
  cmn.CallEventHandler( "get_boathook" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_artificialflower_1 ()

  cmn.SetEventDone( "get_artificialflower_1" );
  cmn.CallEventHandler( "get_artificialflower_1" );
  
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_airplanewing" ) then    
    cmn.CloseSubRoom();
  end;

end;
-------------------------------------------------
function private.get_airplanewing ()

  cmn.SetEventDone( "get_airplanewing" );
  cmn.CallEventHandler( "get_airplanewing" );
  
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_artificialflower_1" ) then    
    cmn.CloseSubRoom();
  end;

end;
--------------------------------------------------
function private.get_airplanenose ()

  cmn.SetEventDone( "get_airplanenose" );
  cmn.CallEventHandler( "get_airplanenose" );
  
  cmn.GetObjectSfx();

end;
---------------------------------------------------------------------------------
function private.get_collect2_2_3()

  int.AddCollectibles2( "spr_officedesk_collect2_2_3" );

end;
--*********************************************************************************************************************
-------------------------------------------------
function public.use_fountainpen ()

  local item = "inv_fountainpen";

  if ( cmn.ApplyObj( item, "gzz_office_officedesk", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_officedesk" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_officedesk_use_fountainpen", true ) ) then

    cmn.CallEventHandler( "use_fountainpen_inv" );
    cmn.CallEventHandler( "use_fountainpen_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_fountainpen" );
      cmn.CallEventHandler( "use_fountainpen_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_pen_open" );  
    ObjSet( "spr_officedesk_stash_closed", { alp = 0 }  );
    ObjSet( "spr_officedesk_pen_cap", { alp = 0 }  );
    ObjSet( "anm_officedesk_use_fountainpen", { alp = 1 }  );
    AnimPlay( "anm_officedesk_use_fountainpen", "DoAnim", func_end);

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_twotinedfork ()

  local item = "inv_twotinedfork";

  if ( cmn.ApplyObj( item, "gzz_office_officedesk", false ) and 
       cmn.IsEventDone( "get_pliers2" ) and
       cmn.IsEventDone( "get_airplanenose" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_officedesk" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_officedesk_use_twotinedfork", true ) and
           cmn.IsEventDone( "use_fountainpen" )and
           cmn.IsEventDone( "get_airplanenose" ) ) then

    cmn.CallEventHandler( "use_twotinedfork_inv" );
    cmn.CallEventHandler( "use_twotinedfork_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_twotinedfork" );
      cmn.CallEventHandler( "use_twotinedfork_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_app_fork" );  
    ObjSet( "spr_officedesk_stash_2_closed", { alp = 0 } );
    ObjSet( "anm_officedesk_use_twotinedfork", { alp = 1 } );
    AnimPlay( "anm_officedesk_use_twotinedfork", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_ambereye_1 ()

  local item = "inv_ambereye_1";

  if ( cmn.ApplyObj( item, "gzz_office_officedesk", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_officedesk" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_officedesk_use_ambereye_1", true ) ) then 

    cmn.CallEventHandler( "use_ambereye_1_inv" );
    cmn.CallEventHandler( "use_ambereye_1_beg" );
    int.Lock( true );

    local func_end = function ()

      local func_end = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_ambereye_1" );
        cmn.CallEventHandler( "use_ambereye_1_end" );

      end;

      if cmn.IsEventDone( "use_ambereye_2" ) then

        cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_open_lion" );
        AnimPlay( "anm_officedesk_use_ambereye", "DoAnim", func_end );

      else 

        func_end();

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_app_lions" );
    ObjAnimate( "spr_officedesk_tiger_1", "alp", 0, 0, func_end,
    { 
      0.0,0,0, 
      0.3,0,1
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_ambereye_2 ()

  local item = "inv_ambereye_2";

  if ( cmn.ApplyObj( item, "gzz_office_officedesk", false ) ) then 

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_officedesk" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_officedesk_use_ambereye_2", true ) ) then

    cmn.CallEventHandler( "use_ambereye_2_inv" );
    cmn.CallEventHandler( "use_ambereye_2_beg" );

    int.Lock( true );

    local func_end = function ()

      local func_end = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_ambereye_2" );
        cmn.CallEventHandler( "use_ambereye_2_end" );

      end;

      if cmn.IsEventDone( "use_ambereye_1" ) then

        cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_open_lion" );
        AnimPlay( "anm_officedesk_use_ambereye", "DoAnim", func_end );

      else 

        func_end();

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_app_lions" );
    ObjAnimate( "spr_officedesk_tiger_2", "alp", 0, 0, func_end,
    { 
      0.0,0,0, 
      0.3,0,1
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_signet ()

  local item = "inv_signet";

  if ( cmn.ApplyObj( item, "gzz_office_closet", false ) ) and
     ( cmn.IsEventDone( "get_fountainpen" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_closet" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_closet_use_signet", true ) ) and
         ( cmn.IsEventDone( "get_fountainpen" ) ) then

    cmn.CallEventHandler( "use_signet_inv" );
    cmn.CallEventHandler( "use_signet_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_signet" );
      cmn.CallEventHandler( "use_signet_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mezzanine_open" );  
    ObjAnimate( "spr_closet_signet", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "spr_closet_lock_1", "ang", 0, 0, "",
    { 
      0.0, 0,  0.0, 
      0.5, 0,  0.0,
      0.8, 0, -0.4,
    } );

    ObjAnimate( "spr_closet_lock_2", "ang", 0, 0, "",
    { 
      0.0, 0,  0.0, 
      0.5, 0,  0.0,
      0.8, 0,  0.4,
    } );

    ObjAnimate( "obj_closet_doors_open", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      1.0, 0, 0.0,
      1.3, 0, 1.0
    } );

    ObjAnimate( "obj_closet_doors_close", "alp", 0, 0, func_end,
    { 
      0.0, 0, 1.0, 
      1.0, 0, 1.0,
      1.3, 0, 0.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_toggleswitch_1 ()

  local item = "inv_toggleswitch_1";

  if ( cmn.ApplyObj( item, "gzz_office_closet", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_closet" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_closet_use_toggleswitch_1", true ) ) then

    cmn.CallEventHandler( "use_toggleswitch_1_inv" );
    cmn.CallEventHandler( "use_toggleswitch_1_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_toggleswitch_1" );
      cmn.CallEventHandler( "use_toggleswitch_1_end" );
      int.Lock( false );

      if ( cmn.IsEventDone( "use_toggleswitch_2" ) ) then

        cmn.CloseSubRoom();
        cmn.GotoRoom( "mg_onsafedoor" );

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_app_metalpart_to_safe" );  
    ObjAnimate( "spr_closet_toggleswitch_1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.5, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_toggleswitch_2 ()

  local item = "inv_toggleswitch_2";

  if ( cmn.ApplyObj( item, "gzz_office_closet", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_closet" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_closet_use_toggleswitch_2", true ) ) then

    cmn.CallEventHandler( "use_toggleswitch_2_inv" );
    cmn.CallEventHandler( "use_toggleswitch_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_toggleswitch_2" );
      cmn.CallEventHandler( "use_toggleswitch_2_end" );
      int.Lock( false );

      if ( cmn.IsEventDone( "use_toggleswitch_1" ) ) then

        cmn.CloseSubRoom();
        cmn.GotoRoom( "mg_onsafedoor" );

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_app_metalpart_to_safe" ); 
    ObjAnimate( "spr_closet_toggleswitch_2", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.5, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_boathook ()

  local item = "inv_boathook";

  if ( cmn.ApplyObj( item, "gzz_office_fishtank", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fishtank" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_fishtank_use_boathook", true ) ) then

    cmn.CallEventHandler( "use_boathook_inv" );
    cmn.CallEventHandler( "use_boathook_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_boathook" );
      cmn.CallEventHandler( "use_boathook_end" );
      int.Lock( false );
      private.get_artificialflower_1();

    end;

    local func_end2 = function ()

      AnimPlay( "anm_fishtank_crawfish_click", "DoAnim", func_end2 );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_take_from_aquarium" );  

    ObjSet( "anm_fishtank_crawfish_static", { alp = 0 } );
    ObjSet( "anm_fishtank_crawfish_click", { alp = 1 } );
    AnimPlay( "anm_fishtank_crawfish_click", "DoAnim", func_end2 );
    AnimPlay( "anm_fishtank_netuse", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_office ()

  if not ( cmn.IsEventDone( "opn_office" ) ) then

    cmn.SetEventDone( "opn_office" );

    ng_global.progress[ "std" ][ "opn_office" ].sconse_on = 0;
    cmn.ShowBbt( "bbt_office_first_entry" );

  end;

end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.PreOpen ()

  if ( ng_global.progress[ "std" ][ "opn_office" ].sconse_on == 1 ) then

    ObjSet( "spr_office_sconce_light", { alp = 1 } );

  end;

  cmn.StopAllEnv( "audio/level2/env/aud_office_env", true );
  cmn.PlayAudio( "env", "audio/level2/env/aud_office_env", 1 );

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_office();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_fountainpen" ); 
  int.AddedTaskMap( private.room_objname, "get_pliers2",                         { "use_fountainpen" } );
  int.AddedTaskMap( private.room_objname, "get_bell_1" );
  int.AddedTaskMap( private.room_objname, "get_doordowel_2",                     { "use_twotinedfork" } );
  int.AddedTaskMap( private.room_objname, "get_switchroomplan",                  { "use_ambereye_1", "use_ambereye_2" } );
  int.AddedTaskMap( private.room_objname, "get_snailamulet_2",                   { "use_signet" } );  
  int.AddedTaskMap( private.room_objname, "get_boathook",                        { "use_signet" } );
  int.AddedTaskMap( private.room_objname, "get_artificialflower_1",              { "use_boathook" } );  
  int.AddedTaskMap( private.room_objname, "get_airplanewing" );
  int.AddedTaskMap( private.room_objname, "get_airplanenose",                    { "use_fountainpen" } );
  int.AddedTaskMap( private.room_objname, "get_bell_3",                          { "clk_safedoor" } );
  int.AddedTaskMap( private.room_objname, "get_file2",                           { "clk_safedoor" } );
  int.AddedTaskMap( private.room_objname, "clk_safedoor",                        { "win_onsafedoor" } );

  int.AddedTaskMap( private.room_objname, "use_fountainpen",                     { "get_fountainpen" } );
  int.AddedTaskMap( private.room_objname, "use_twotinedfork",                    { "get_pliers2", "get_airplanenose", "get_twotinedfork" } ); 
  int.AddedTaskMap( private.room_objname, "use_ambereye_1",                      { "get_ambereye_1" } );
  int.AddedTaskMap( private.room_objname, "use_ambereye_2",                      { "get_ambereye_2" } );  
  int.AddedTaskMap( private.room_objname, "use_signet",                          { "get_signet" } );
  int.AddedTaskMap( private.room_objname, "use_toggleswitch_1",                  { "get_toggleswitch_1" } ); 
  int.AddedTaskMap( private.room_objname, "use_toggleswitch_2",                  { "get_toggleswitch_2" } ); 
  int.AddedTaskMap( private.room_objname, "use_boathook",                        { "get_boathook" } );

  int.AddedTaskMap( private.room_objname, "win_onsafedoor",                      { "use_toggleswitch_1", "use_toggleswitch_2" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_officedesk" );

  -------------------------------------------------
  function zz_officedesk.Close()

    cmn.NoteScaleEnd( { "spr_officedesk_note" }, true );
    cmn.NoteScaleEnd( { "spr_officedesk_letter" }, true );

  end;
  
  -------------------------------------------------
  -------------------------------------------------
  
  subroom.Define( "zz_fishtank" );

  -------------------------------------------------
  function zz_fishtank.PreOpen()

    cmn.PlayAudio( "env", "audio/level2/env/aud_aquarium_env", 1 );

  end;
  function zz_fishtank.Close()

    cmn.StopAudio( "env", "audio/level2/env/aud_aquarium_env" );

  end;

end;
--*********************************************************************************************************************
function private.InitAnim ()

  ObjAnimate( "spr_office_desktop_add", "pos_x", 1, 0, "",
  { 
    0.0, 3, -32, 
    2.8, 3, 98,
    2.9, 3, 98,
  } );

  ObjAnimate( "spr_office_light_add", "alp", 1, 0, "",
  { 
    0.0, 0, 1, 
    1.5, 0, 0.3,
    3.0, 0, 1,
  } );

  ObjAnimate( "spr_officedesk_pen_shine", "alp", 1, 0, "", 
  {
    0.0,0,0,
    2.0,0,0,
    2.4,2,1,
    2.8,1,0,
    8.0,0,0
  } );

  ObjAnimate( "spr_office_sconce_rope", "ang", 1, 0, "", 
  {
    0.0, 3, -0.03,
    1.0, 3,  0.03,
    2.0, 3, -0.03,
  } );

  ObjAnimate( "spr_office_computer_red_light", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    1.3, 3, 1.0,
    1.4, 3, 0.0,
    1.5, 3, 1.0,
    2.6, 3, 1.0,
    2.7, 3, 0.0,
    2.8, 3, 1.0,
    4.8, 3, 1.0,
    4.9, 3, 0.0,
    5.0, 3, 1.0,
    5.1, 3, 0.0,
    5.2, 3, 1.0,
    6.0, 3, 1.0,
  } );

  ObjAnimate( "spr_office_computer_green_light", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    1.6, 3, 1.0,
    1.7, 3, 0.0,
    1.8, 3, 0.0,
    1.9, 3, 1.0,
    2.9, 3, 1.0,
    3.0, 3, 0.0,
    3.1, 3, 0.0,
    3.2, 3, 1.0,
    5.0, 3, 1.0,
  } );

  ObjAnimate( "spr_officedesk_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

end;
--*********************************************************************************************************************
function private.ClkPenCap ()

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_touch_pen" );
  ObjAnimate("spr_officedesk_pen_cap", "ang", 0, 0, 
  function ()
    int.Lock( false );
    cmn.ShowBbt( "bbt_officedesk_use_fountainpen" );
  end, 
  {
    0.0,0, 0.00,
    0.2,2, 0.03,
    0.6,3,-0.02,
    0.8,2, 0.00
  });

end;
--*********************************************************************************************************************
function private.ClkStashCover ()

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_touch_table" );

  ObjAnimate("spr_officedesk_stash_closed", "pos_xy", 0, 0, 
  function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_officedesk_use_fountainpen" );

  end, 
  {
    0.0,0,29,114,
    0.2,0,30,115,
    0.4,0,29,114
  });

end;
--*********************************************************************************************************************
function private.ClkStash2Cover ()

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_touch_table" );
  ObjAnimate("spr_officedesk_stash_2_closed", "pos_xy", 0, 0, 
  function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_officedesk_use_twotinedfork" );

  end, 
  {
    0.0,0,17,124,
    0.2,0,16,123,
    0.4,0,17,124
  });

end;
--*********************************************************************************************************************
function private.ClkArtificialFlower ()

 local func_end = function ()

    cmn.ShowBbt( "bbt_fishtank_use_boathook" );
    int.Lock( false );
    ObjSet( "anm_fishtank_crawfish_static", { alp = 1 } );
    ObjSet( "anm_fishtank_crawfish_click", { alp = 0 } );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_claw" );
  ObjSet( "anm_fishtank_crawfish_static", { alp = 0 } );
  ObjSet( "anm_fishtank_crawfish_click", { alp = 1 } );
  AnimPlay( "anm_fishtank_crawfish_click", "DoAnim", func_end );  
  
end;
--*********************************************************************************************************************
function private.ClosetDoorClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_closet_use_signet" );
    int.Lock( false );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mezzanine_touch" );

  ObjAnimate( "obj_closet_door_right", "scale_x", 0, 0, "", 
  {
    0.0, 3, 1.000,
    0.2, 3, 0.995,
    0.4, 3, 1.000,
    0.6, 3, 0.995,
    0.8, 3, 1.000,
  } );

  ObjAnimate( "obj_closet_door_left", "scale_x", 0, 0, "", 
  {
    0.0, 3, 1.000,
    0.2, 3, 0.995,
    0.4, 3, 1.000,
    0.6, 3, 0.995,
    0.8, 3, 1.000,
  } );

  ObjAnimate( "spr_closet_lock_1", "ang", 0, 0, "", 
  {
    0.0, 3,  0.00,
    0.2, 3, -0.05,
    0.4, 3,  0.00,
    0.6, 3, -0.05,
    0.8, 3,  0.00,
  } );

  ObjAnimate( "spr_closet_lock_2", "ang", 0, 0, "", 
  {
    0.0, 3,  0.00,
    0.2, 3,  0.05,
    0.4, 3,  0.00,
    0.6, 3,  0.05,
    0.8, 3,  0.00,
  } );

  ObjAnimate( "spr_closet_lock_1_over", "pos_x", 0, 0, "", 
  {
    0.0, 3, -14,
    0.2, 3, -15,
    0.4, 3, -14,
    0.6, 3, -15,
    0.8, 3, -14,
  } );

  ObjAnimate( "spr_closet_lock_2_over", "pos_x", 0, 0, "", 
  {
    0.0, 3,  27,
    0.2, 3,  28,
    0.4, 3,  27,
    0.6, 3,  28,
    0.8, 3,  27,
  } );

  ObjAnimate( "spr_closet_handle_1", "ang", 0, 0, "", 
  {
    0.0, 3,   0.00,
    0.2, 3,   0.05,
    0.6, 3,  -0.05,
    1.0, 3,   0.03,
    1.2, 3,  -0.01,
    1.3, 3,   0.00,
  } );

  ObjAnimate( "spr_closet_handle_2", "ang", 0, 0, func_end, 
  {
    0.0, 3,   0.00,
    0.2, 3,   0.05,
    0.6, 3,  -0.05,
    1.0, 3,   0.03,
    1.2, 3,  -0.01,
    1.3, 3,   0.00,
  } );

end;
--*********************************************************************************************************************
function private.ClkMouse ()

 ObjStartDrag( "obj_officedesk_mouse_drag" );

end;
--*********************************************************************************************************************
function private.StartDragMouse ()

  local pos = GetZoomCursorPos();
  private.pos_x_old_cursor = pos[ 1 ] - 512;
  private.pos_y_old_cursor = pos[ 2 ] - 384;

end;
--*********************************************************************************************************************
function private.DragMouse ()

  local pos = GetZoomCursorPos();
  local pos_x1 = pos[ 1 ] - 512;
  local pos_y1 = pos[ 2 ] - 384;

  if ( cmn.ApplyObj( "obj_officedesk_mouse_drag", "obj_officedesk_mouse_cross_drag", false ) ) then --если мы находимся в области коврика 

    private.pos_x_old_mouse = ObjGet( "spr_officedesk_mouse" ).pos_x;
    private.pos_y_old_mouse = ObjGet( "spr_officedesk_mouse" ).pos_y;

    local dx = pos_x1 - private.pos_x_old_cursor;
    local dy = pos_y1 - private.pos_y_old_cursor;

    local new_x_mouse = private.pos_x_old_mouse + dx;
    local new_y_mouse = private.pos_y_old_mouse + dy;

    if new_x_mouse < 330 then

      ObjSet( "spr_officedesk_mouse", { pos_x = new_x_mouse, pos_y = new_y_mouse  } );

      if ( cmn.ApplyObj( "obj_officedesk_mouse_tmp", "obj_officedesk_mouse_cross", false ) ) then --если новое положение мышки находится в области коврика

        private.DragCursor( dx, dy );
        private.DragWire();

      else 

        ObjSet( "spr_officedesk_mouse", { pos_x = private.pos_x_old_mouse , pos_y = private.pos_y_old_mouse } );--если нет, то ставим обратно
        cmn.SetCursor( CURSOR_DEFAULT );
        ObjStopDrag( "obj_officedesk_mouse_drag" );
        
      end;

    end;
    
  else 
    
    cmn.SetCursor( CURSOR_DEFAULT );
    ObjStopDrag( "obj_officedesk_mouse_drag" );
    
  end;

  private.pos_x_old_cursor = pos_x1;
  private.pos_y_old_cursor = pos_y1;

end;
--*********************************************************************************************************************
function private.DragCursor (dx,dy)

  if ( cmn.ApplyObj( "spr_officedesk_cursor", "obj_officedesk_monitor_cross1", false ) or 
       cmn.ApplyObj( "obj_officedesk_cursor_tmp", "obj_officedesk_monitor_cross2", false ) ) then 

    private.pos_x_old_arrow = ObjGet( "spr_officedesk_cursor" ).pos_x;
    private.pos_y_old_arrow = ObjGet( "spr_officedesk_cursor" ).pos_y;
    new_x_arrow = private.pos_x_old_arrow + dx;
    new_y_arrow = private.pos_y_old_arrow + dy;

    ObjSet( "spr_officedesk_cursor", { pos_x = new_x_arrow, pos_y = new_y_arrow  } );

  else 

    ObjSet( "spr_officedesk_cursor", { pos_x = private.pos_x_old_arrow, pos_y = private.pos_y_old_arrow } );

  end;

end;
--*********************************************************************************************************************
function private.DragWire()

   lenght = 17;
   pos_x1 = 208;
   pos_y1 = -145;
   pos_x2 = ObjGet( "spr_officedesk_mouse" ).pos_x - 40;
   pos_y2 = ObjGet( "spr_officedesk_mouse" ).pos_y - 30;

   dx1 = pos_x1 - pos_x2;
   dy1 = pos_y1 - pos_y2;

   s1 = math.sqrt(dx1^2+dy1^2);--длина шнура
   angl1 = (math.atan2(dy1,dx1)*(-1)); 

   ObjSet( "spr_officedesk_wire",
   {
    pos_x = pos_x1,
    pos_y = pos_y1,
    ang = angl1,
    scale_x = s1 / lenght,
   } );

end;
--*********************************************************************************************************************
function private.ClkChair ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

  end;

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_chair_touch" );
  AnimPlay( "anm_office_chair", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.ClkSconce ()

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_lamp_off_on" );
  local sconse_on = ng_global.progress[ "std" ][ "opn_office" ].sconse_on;
  ng_global.progress[ "std" ][ "opn_office" ].sconse_on = math.abs( sconse_on - 1 );

  local func_end = function ()

    int.Lock( false );

  end;

  ObjAnimate( "spr_office_sconce_rope", "pos_y", 0, 0, func_end, 
  {
    0.0, 3, 190,
    0.2, 3, 198,
    0.4, 3, 190,
  } );

  ObjAnimate( "spr_office_sconce_light", "alp", 0, 0, "", 
  {
    0.0, 3, sconse_on,
    0.2, 3, sconse_on,
    0.2, 3, math.abs( sconse_on - 1 ),
  } );

end;
--*********************************************************************************************************************
function private.TigerBbt ()

  if cmn.IsEventDone( "use_ambereye_1" ) or cmn.IsEventDone( "use_ambereye_2" ) then
    cmn.ShowBbt( "bbt_officedesk_use_ambereye_2" );
  else 
    cmn.ShowBbt( "bbt_officedesk_use_ambereye_1" );
  end;

end;
--*********************************************************************************************************************
function private.ToggleswitchBbt ()

  if cmn.IsEventDone( "use_toggleswitch_1" ) or cmn.IsEventDone( "use_toggleswitch_2" ) then
    cmn.ShowBbt( "bbt_closet_use_toggleswitch_2" );
  else 
    cmn.ShowBbt( "bbt_closet_use_toggleswitch_1" );
  end;

end;
--*********************************************************************************************************************