-- name=rm_switchroom
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_switchroom";

  ObjAttach( "zz_panelboard", "room_hub" );
  
  ObjMultiSet( {
    { "spr_switchroom_hammer", { event_mdown = private.get_hammer2 } },
    { "spr_switchroom_burntbag", { event_mdown = private.get_burntbag } },
    { "obj_panelboard_clk_cap", { event_mdown = private.clk_cap } },
    { "obj_panelboard_clk_electricplug", { event_mdown = private.clk_electricplug } },
    { "obj_panelboard_clk_fuse", { event_mdown = private.clk_fuse } },
    { "obj_switchroom_clk_jacket", { event_mdown = private.ClkJacket } },
  } );

  for i=1, 4 do
    ObjSet( "spr_switchroom_panel_"..i, {      
      event_mdown = function () private.ClkPanel( i ); end,
      event_menter = function () cmn.SetCursor(CURSOR_HAND); end,
      event_mleave = function () cmn.SetCursor(CURSOR_DEFAULT); end
    } );
  end;

  private.InitAnims();

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    int.InitMorphRandomState( 2 );

  end;

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_switchroom = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gzz_switchroom_panelboard",
        "gmg_switchroom_repair"
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_panelboard",
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_switchroom", update_game_mode_switchroom, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_hammer2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hammer2" ] =
    {
      type = "get",
      get_obj = "spr_switchroom_hammer",
      room = private.room_objname,
  };
  -----------------------------------------------
  local get_hammer2_inv = function ()

    int.InventoryItemAdd( "inv_hammer2", "spr_switchroom_hammer" );

  end;

  local get_hammer2_closezz = function ()

    ObjDelete( "gfx_switchroom_hammer" );
    ObjDelete( "spr_switchroom_hammer_shad" );
    ObjDelete( "spr_switchroom_hammer_add" );

  end;

  cmn.AddSubscriber( "get_hammer2", get_hammer2_inv );
  cmn.AddSubscriber( "get_hammer2", get_hammer2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_burntbag () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_burntbag" ] =
    {
      type = "get",
      get_obj = "obj_switchroom_burntbag_hint",
      room = private.room_objname,
  };
  -----------------------------------------------
  local get_burntbag_inv = function ()

    int.InventoryItemAdd( "inv_burntbag", "spr_switchroom_burntbag", "assets/levels/level2/rm_switchroom/layers/burntbag" );
    ObjSet( "inv_burntbag", { drag = false } );

  end;

  local get_burntbag_closezz = function ()

    ObjDelete( "gfx_switchroom_burntbag" );
    ObjDelete( "spr_switchroom_burntbag_shad" );
    ObjSet( "obj_switchroom_burntbag", { active = false } );
    
  end;

  cmn.AddSubscriber( "get_burntbag", get_burntbag_inv );
  cmn.AddSubscriber( "get_burntbag", get_burntbag_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_2_5 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_2_5 = function ()

    ObjDelete( "obj_switchroom_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_2_5", get_morphobject_2_5, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_fuse_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fuse_2" ] =
    {
    type = "use",
      use_obj = "inv_fuse_1",
      use_place = "obj_panelboard_use_fuse_2",
      room = private.room_objname,
      zz = "zz_panelboard",
      zz_gate = "gzz_switchroom_panelboard"
  };
  -----------------------------------------------
  local use_fuse_2_inv = function ()

    int.InventoryItemRemove( "inv_fuse_1" );

  end;
  local use_fuse_2_beg = function ()

    ObjDelete( "obj_panelboard_use_fuse_2" );    

  end;
  local use_fuse_2_end = function ()

    if ( cmn.IsEventDone( "use_fuse_2" ) and
         cmn.IsEventDone( "use_insulatingtape_2" ) and
         cmn.IsEventDone( "use_electricplug" ) ) then

      ObjSet( "gmg_switchroom_repair", { active = true, input = true, alp = 1 } );
      ObjDelete( "gzz_switchroom_panelboard" );
      ObjSet( "spr_switchroom_mg", { alp = 1 } );

    end;

    ObjSet( "spr_panelboard_fuse", { alp = 1 } );
    ObjSet( "spr_panelboard_fuse_2", { alp = 1 } );
    ObjSet( "spr_panelboard_fuse_shadow", { alp = 1 } );
    ObjSet( "spr_panelboard_fuse_2_shadow", { alp = 1 } );
    ObjSet( "spr_switchroom_fixed_fuse", { alp = 1 } );
    ObjDelete( "anm_panelboard_fuse_replace" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_fuse_2", use_fuse_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_fuse_2", use_fuse_2_inv );
  cmn.AddSubscriber( "use_fuse_2", use_fuse_2_end, private.room_objname );
  cmn.AddSubscriber( "use_fuse_2_inv", use_fuse_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_fuse_2_beg", use_fuse_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_fuse_2_end", use_fuse_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_rubbergloves () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_rubbergloves" ] =
    {
    type = "use",
      use_obj = "inv_rubbergloves",
      use_place = "obj_panelboard_use_rubbergloves",
      room = private.room_objname,
      zz = "zz_panelboard",
      zz_gate = "gzz_switchroom_panelboard"
  };
  -----------------------------------------------
  local use_rubbergloves_inv = function ()

    int.InventoryItemRemove( "inv_rubbergloves" );    

  end;
  local use_rubbergloves_beg = function ()

    ObjDelete( "obj_panelboard_use_rubbergloves" );

  end;
  local use_rubbergloves_end = function ()

    ObjSet( "obj_panelboard_use_insulatingtape", { input = true } );
    ObjSet( "obj_panelboard_clk_fuse", { input = true } );
    ObjSet( "obj_panelboard_clk_electricplug", { input = true } );
    ObjDelete( "spr_panelboard_rubbergloves" );   

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_rubbergloves", use_rubbergloves_beg, private.room_objname );
  cmn.AddSubscriber( "use_rubbergloves", use_rubbergloves_inv );
  cmn.AddSubscriber( "use_rubbergloves", use_rubbergloves_end, private.room_objname );
  cmn.AddSubscriber( "use_rubbergloves_inv", use_rubbergloves_inv, private.room_objname );
  cmn.AddSubscriber( "use_rubbergloves_beg", use_rubbergloves_beg, private.room_objname );
  cmn.AddSubscriber( "use_rubbergloves_end", use_rubbergloves_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_insulatingtape_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_insulatingtape_2" ] =
    {
    type = "use",
      use_obj = "inv_insulatingtape",
      use_place = "obj_panelboard_use_insulatingtape",
      room = private.room_objname,
      zz = "zz_panelboard",
      zz_gate = "gzz_switchroom_panelboard"
  };
  -----------------------------------------------
  local use_insulatingtape_2_inv = function ()

    if cmn.IsEventDone( "use_insulatingtape_1" ) then
      int.InventoryItemRemove( "inv_insulatingtape" );
    end;

  end;
  local use_insulatingtape_2_beg = function ()

    ObjDelete( "obj_panelboard_use_insulatingtape" );

  end;
  local use_insulatingtape_2_end = function ()

    if ( cmn.IsEventDone( "use_fuse_2" ) and
         cmn.IsEventDone( "use_insulatingtape_2" ) and
         cmn.IsEventDone( "use_electricplug" ) ) then

      ObjSet( "gmg_switchroom_repair", { active = true, input = true, alp = 1 } );
      ObjDelete( "gzz_switchroom_panelboard" );
      ObjSet( "spr_switchroom_mg", { alp = 1 } );

    end;

    ObjDelete( "spr_panelboard_wire_1" );
    ObjSet( "spr_panelboard_wire_2", { alp = 1 } );
    ObjDelete( "spr_switchroom_broken_wire" );
    ObjSet( "spr_switchroom_fixed_wire", { alp = 1 } );
    ObjDelete( "anm_panelboard_sparks" );
    ObjDelete( "vid_panelboard_use_insulatingtape" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_insulatingtape_2", use_insulatingtape_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_insulatingtape_2", use_insulatingtape_2_inv );
  cmn.AddSubscriber( "use_insulatingtape_2", use_insulatingtape_2_end, private.room_objname );
  cmn.AddSubscriber( "use_insulatingtape_2_inv", use_insulatingtape_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_insulatingtape_2_beg", use_insulatingtape_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_insulatingtape_2_end", use_insulatingtape_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_electricplug () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_electricplug" ] =
    {
    type = "use",
      use_obj = "inv_electricplug",
      use_place = "obj_panelboard_use_electricplug",
      room = private.room_objname,
      zz = "zz_panelboard",
      zz_gate = "gzz_switchroom_panelboard"
  };
  -----------------------------------------------
  local use_electricplug_inv = function ()

    int.InventoryItemRemove( "inv_electricplug" );

  end;
  local use_electricplug_beg = function ()

    ObjDelete( "obj_panelboard_use_electricplug" );

  end;
  local use_electricplug_end = function ()

    if ( cmn.IsEventDone( "use_fuse_2" ) and
         cmn.IsEventDone( "use_insulatingtape_2" ) and
         cmn.IsEventDone( "use_electricplug" ) ) then

         ObjSet( "gmg_switchroom_repair", { active = true, input = true, alp = 1 } );
      ObjDelete( "gzz_switchroom_panelboard" );
      ObjSet( "spr_switchroom_mg", { alp = 1 } );

    end;

    ObjSet( "spr_panelboard_plug_shadow", { alp = 1 } );
    ObjSet( "spr_panelboard_plug_fixed", { alp = 1 } );
    ObjSet( "spr_switchroom_plug", { alp = 1 } );
    ObjDelete( "anm_panelboard_plug_replace" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_electricplug", use_electricplug_beg, private.room_objname );
  cmn.AddSubscriber( "use_electricplug", use_electricplug_inv );
  cmn.AddSubscriber( "use_electricplug", use_electricplug_end, private.room_objname );
  cmn.AddSubscriber( "use_electricplug_inv", use_electricplug_inv, private.room_objname );
  cmn.AddSubscriber( "use_electricplug_beg", use_electricplug_beg, private.room_objname );
  cmn.AddSubscriber( "use_electricplug_end", use_electricplug_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sandbucket () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sandbucket" ] =
    {
    type = "use",
      use_obj = "inv_sandbucket",
      use_place = "obj_switchroom_use_sandbucket",
      room = private.room_objname,
  };
  -----------------------------------------------
  local use_sandbucket_inv = function ()

    int.InventoryItemRemove( "inv_sandbucket" );

  end;
  local use_sandbucket_beg = function ()

    ObjDelete( "obj_switchroom_use_sandbucket" );

  end;
  local use_sandbucket_end = function ()

    ObjSet( "spr_switchroom_burntbag", { input = true } );
    ObjSet( "gfx_switchroom_burntbag", { active = true } );
    ObjSet( "obj_switchroom_use_plan", { input = true } );
    ObjSet( "obj_switchroom_clk_jacket", { input = true } );
    ObjSet( "anm_switchroom_smoke", { alp = 1, playing = true } );
    ObjDelete( "vid_switchroom_fire" );
    ObjDelete( "vid_switchroom_sandbucket" );
    ObjDelete( "vid_switchroom_smoke_add" );

  end;
  local use_sandbucket_loc = function ()
    
    ObjDelete( "anm_basement_smoke" );  
  
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_sandbucket", use_sandbucket_beg, private.room_objname );
  cmn.AddSubscriber( "use_sandbucket", use_sandbucket_inv );
  cmn.AddSubscriber( "use_sandbucket", use_sandbucket_end, private.room_objname );
  cmn.AddSubscriber( "use_sandbucket", use_sandbucket_loc, "rm_basement" );
  cmn.AddSubscriber( "use_sandbucket_inv", use_sandbucket_inv, private.room_objname );
  cmn.AddSubscriber( "use_sandbucket_beg", use_sandbucket_beg, private.room_objname );
  cmn.AddSubscriber( "use_sandbucket_end", use_sandbucket_end, private.room_objname );
  cmn.AddSubscriber( "use_sandbucket_loc", use_sandbucket_loc, "rm_basement" );
  --------------------------------------------------------------------------------------------
  -- function use_plan () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_plan" ] =
    {
    type = "use",
      use_obj = "inv_plan",
      use_place = "obj_switchroom_use_plan",
      room = private.room_objname,
  };
  -----------------------------------------------
  local use_plan_inv = function ()

    int.InventoryItemRemove( "inv_plan" );

  end;
  local use_plan_beg = function ()

    ObjDelete( "obj_switchroom_use_plan" );

  end;
  local use_plan_end = function ()

    ObjSet( "gzz_switchroom_panelboard", { active = true, input = true, alp = 1 } );
    ObjSet( "obj_switchroom_panels", { input = true } );

    ObjDelete( "spr_switchroom_dark" );
    ObjDelete( "spr_switchroom_plan" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_plan", use_plan_beg, private.room_objname );
  cmn.AddSubscriber( "use_plan", use_plan_inv );
  cmn.AddSubscriber( "use_plan", use_plan_end, private.room_objname );
  cmn.AddSubscriber( "use_plan_inv", use_plan_inv, private.room_objname );
  cmn.AddSubscriber( "use_plan_beg", use_plan_beg, private.room_objname );
  cmn.AddSubscriber( "use_plan_end", use_plan_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_cap () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_cap" ] =
  {
    type = "click",
    clk_obj = "obj_panelboard_clk_cap",
    room = private.room_objname,
    zz = "zz_panelboard",
    zz_gate = "gzz_switchroom_panelboard"
  };
  -----------------------------------------------
  local clk_cap = function ()


  end;
  -----------------------------------------------
  local clk_cap_beg = function ()

    ObjDelete( "obj_panelboard_clk_cap" );

  end;
  -----------------------------------------------
  local clk_cap_end = function ()

    ObjDelete( "spr_panelboard_cap" );
    ObjSet( "obj_panelboard_open", { alp = 1, input = true } );
    ObjSet( "spr_switchroom_open_panelboard", { alp = 1 } );
    ObjSet( "spr_switchroom_panel_2", { input = false } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_cap", clk_cap );
  cmn.AddSubscriber( "clk_cap", clk_cap_beg, private.room_objname );
  cmn.AddSubscriber( "clk_cap", clk_cap_end, private.room_objname );
  cmn.AddSubscriber( "clk_cap_beg", clk_cap_beg, private.room_objname );
  cmn.AddSubscriber( "clk_cap_end", clk_cap_end, private.room_objname );
  -----------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_fuse () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_fuse" ] =
  {
    type = "click",
    clk_obj = "obj_panelboard_clk_fuse",
    room = private.room_objname,
    zz = "zz_panelboard",
    zz_gate = "gzz_switchroom_panelboard"
  };
  -----------------------------------------------
  local clk_fuse = function ()


  end;
  -----------------------------------------------
  local clk_fuse_beg = function ()

    ObjDelete( "obj_panelboard_clk_fuse" );

  end;
  -----------------------------------------------
  local clk_fuse_end = function ()

    ObjSet( "spr_panelboard_fuse_shadow", { alp = 0 } );
    ObjDelete( "spr_panelboard_fuse_broke" );
    ObjDelete( "anm_panelboard_fuse_remove" );
    ObjDelete( "spr_switchroom_broken_fuse" );
    ObjSet( "obj_panelboard_use_fuse_2", { input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_fuse", clk_fuse );
  cmn.AddSubscriber( "clk_fuse", clk_fuse_beg, private.room_objname );
  cmn.AddSubscriber( "clk_fuse", clk_fuse_end, private.room_objname );
  cmn.AddSubscriber( "clk_fuse_beg", clk_fuse_beg, private.room_objname );
  cmn.AddSubscriber( "clk_fuse_end", clk_fuse_end, private.room_objname );
  -----------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_electricplug () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_electricplug" ] =
  {
    type = "click",
    clk_obj = "obj_panelboard_clk_electricplug",
    room = private.room_objname,
    zz = "zz_panelboard",
    zz_gate = "gzz_switchroom_panelboard"
  };
  -----------------------------------------------
  local clk_electricplug = function ()


  end;
  -----------------------------------------------
  local clk_electricplug_beg = function ()

    ObjDelete( "obj_panelboard_clk_electricplug" );

  end;
  -----------------------------------------------
  local clk_electricplug_end = function ()
    
    ObjSet( "spr_panelboard_plug_shadow", { alp = 0 } );
    ObjSet( "spr_switchroom_plug", { alp = 0 } );
    ObjSet( "obj_panelboard_use_electricplug", { input = true } );
    ObjDelete( "spr_panelboard_plug_broken" );
    ObjDelete( "anm_panelboard_plug_remove" );
    ObjDelete( "anm_panelboard_sparks_plug" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_electricplug", clk_electricplug );
  cmn.AddSubscriber( "clk_electricplug", clk_electricplug_beg, private.room_objname );
  cmn.AddSubscriber( "clk_electricplug", clk_electricplug_end, private.room_objname );
  cmn.AddSubscriber( "clk_electricplug_beg", clk_electricplug_beg, private.room_objname );
  cmn.AddSubscriber( "clk_electricplug_end", clk_electricplug_end, private.room_objname );
  -----------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function opn_switchroom () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_switchroom" ] =
  {
    type = "click",
    --clk_obj = "obj_panelboard_clk_electricplug",
    room = private.room_objname,
    --zz = "zz_panelboard",
    --zz_gate = "gzz_switchroom_panelboard"
  };
  -----------------------------------------------
  local opn_switchroom_loc = function ()
  
    ObjSet( "anm_basement_smoke", { playing = true } );
    
  end;
  local opn_switchroom = function ()
  
    int.TaskDone( 2 );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "opn_switchroom", opn_switchroom_loc, "rm_basement" );
  cmn.AddSubscriber( "opn_switchroom", opn_switchroom );

--*********************************************************************************************************************
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
function private.get_hammer2 ()

  cmn.SetEventDone( "get_hammer2" );
  cmn.CallEventHandler( "get_hammer2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_burntbag ()

  cmn.SetEventDone( "get_burntbag" );
  cmn.CallEventHandler( "get_burntbag" );
  
  cmn.GetObjectSfx();

end;
--*********************************************************************************************************************
-------------------------------------------------
function public.use_fuse_2 ()

  local item = "inv_fuse_1";

  if ( cmn.ApplyObj( item, "gzz_switchroom_panelboard", false ) and
       cmn.IsEventDone( "clk_fuse" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_panelboard" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_panelboard_use_fuse_2", true ) and
           cmn.IsEventDone( "clk_fuse" ) ) then

    cmn.CallEventHandler( "use_fuse_2_inv" );
    cmn.CallEventHandler( "use_fuse_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_fuse_2" );
      cmn.CallEventHandler( "use_fuse_2_end" );
      int.Lock( false );

      if ( cmn.IsEventDone( "use_insulatingtape_2" ) and
           cmn.IsEventDone( "use_fuse_2" ) and
           cmn.IsEventDone( "use_electricplug" ) ) then

        ObjAnimate("spr_panelboard_open_mg", "alp", 0, 0, 
        function ()
          cmn.CloseSubRoom();
          cmn.GotoRoom( "mg_repair" );
        end, 
        {
          0.0,0,0,
          0.3,0,1,
          0.6,0,1
        });

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_place_auto_fuse" );  

    AnimPlay( "anm_panelboard_fuse_replace", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_rubbergloves ()

  local item = "inv_rubbergloves";

  if ( cmn.ApplyObj( item, "gzz_switchroom_panelboard", false ) ) and
   cmn.IsEventDone( "use_plan") then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_panelboard" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_panelboard_use_rubbergloves", true ) ) then

    cmn.CallEventHandler( "use_rubbergloves_inv" );
    cmn.CallEventHandler( "use_rubbergloves_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_rubbergloves" );
      cmn.CallEventHandler( "use_rubbergloves_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_latex_gloves" );  
    ObjAnimate("spr_panelboard_rubbergloves", "pos_y", 0, 0, func_end, 
    {
      0.0,0,540,
      0.5,2,130,
      1.0,0,130,
      1.5,1,540
    });

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_insulatingtape_2 ()

  local item = "inv_insulatingtape";

  if ( cmn.ApplyObj( item, "gzz_switchroom_panelboard", false ) and 
       cmn.IsEventDone( "use_rubbergloves" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_panelboard" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_panelboard_use_insulatingtape", true ) and
           cmn.IsEventDone( "use_rubbergloves" ) ) then

    cmn.CallEventHandler( "use_insulatingtape_2_inv" );
    cmn.CallEventHandler( "use_insulatingtape_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_insulatingtape_2" );
      cmn.CallEventHandler( "use_insulatingtape_2_end" );
      int.Lock( false );

      if ( cmn.IsEventDone( "use_insulatingtape_2" ) and
           cmn.IsEventDone( "use_fuse_2" ) and
           cmn.IsEventDone( "use_electricplug" ) ) then

        ObjAnimate("spr_panelboard_open_mg", "alp", 0, 0, 
        function ()
          cmn.CloseSubRoom();
          cmn.GotoRoom( "mg_repair" );
        end, 
        {
          0.0,0,0,
          0.3,0,1,
          0.6,0,1
        });

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_tape" );

    ObjSet( "vid_panelboard_use_insulatingtape", { alp = 1 } ); 
    VidPlay( "vid_panelboard_use_insulatingtape", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_electricplug ()

  local item = "inv_electricplug";

  if ( cmn.ApplyObj( item, "gzz_switchroom_panelboard", false ) and 
       cmn.IsEventDone( "clk_electricplug" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_panelboard" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_panelboard_use_electricplug", true ) and
           cmn.IsEventDone( "clk_electricplug" ) ) then

    cmn.CallEventHandler( "use_electricplug_inv" );
    cmn.CallEventHandler( "use_electricplug_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_electricplug" );
      cmn.CallEventHandler( "use_electricplug_end" );
      int.Lock( false );

      if ( cmn.IsEventDone( "use_insulatingtape_2" ) and
           cmn.IsEventDone( "use_fuse_2" ) and
           cmn.IsEventDone( "use_electricplug" ) ) then

        ObjAnimate("spr_panelboard_open_mg", "alp", 0, 0, 
        function ()
          cmn.CloseSubRoom();
          cmn.GotoRoom( "mg_repair" );
        end, 
        {
          0.0,0,0,
          0.3,0,1,
          0.6,0,1
        });

      end;

    end;
    
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_new_safer" ); 

    AnimPlay( "anm_panelboard_plug_replace", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_sandbucket ()

  local item = "inv_sandbucket";

  if ( cmn.ApplyObj( item, "obj_switchroom_use_sandbucket", true ) ) then

    cmn.CallEventHandler( "use_sandbucket_inv" );
    cmn.CallEventHandler( "use_sandbucket_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_sandbucket" );
      cmn.CallEventHandler( "use_sandbucket_end" );
      cmn.CallEventHandler( "use_sandbucket_loc" );
      cmn.ShowBbt( "bbt_switchroom_after_fire" );
      int.Lock( false );
      cmn.StopAllEnv( "audio/level2/env/aud_switch_room_fire_off_env", true );
      cmn.PlayAudio( "env", "audio/level2/env/aud_switch_room_fire_off_env", 1 );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_extinguish" );
    VidPlay( "vid_switchroom_sandbucket",func_end );
    VidPlay( "vid_switchroom_smoke_add", "" );
    
    ObjAnimate("vid_switchroom_fire", "alp", 0, 0, "", 
    {
      0.0,0,1,
      3.0,0,1,
      5.0,0,0
    });
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_plan ()

--  local item = "inv_plan";
--
--  if ( cmn.ApplyObj( item, "obj_switchroom_use_plan", true ) ) then
--
    cmn.CallEventHandler( "use_plan_inv" );
    cmn.CallEventHandler( "use_plan_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_plan" );
      cmn.CallEventHandler( "use_plan_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_rm_switchroom_look" );  
    ObjAnimate("spr_switchroom_plan", "pos_y", 0, 0, "",
    {
      0.0,0,1030,
      0.8,2,510,
      1.6,0,510,
      2.4,1,1030
    });
    ObjAnimate("spr_switchroom_dark", "alp", 0, 0, func_end, 
    {
      0.0,0,0,
      2.2,0,0,
      2.6,0,1,
      3.2,0,1,
      3.6,0,0
    });
    ObjAnimate("rm_switchroom", "scale_xy", 0, 0, "", 
    {
      0.0,0,1,1,
      2.2,0,1,1,
      2.6,0,1.15,1.15,
      3.2,0,1.15,1.15,
      3.6,0,1,1
    });
    ObjAnimate("rm_switchroom", "pos_x", 0, 0, "", 
    {
      0.0,0,0,
      2.2,0,0,
      2.6,0,-180,
      3.2,0,-180,
      3.6,0,0
    });

--    return true;
--
--  end;
--
--  return false;

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_cap ()

  local func_end = function ()

    cmn.SetEventDone( "clk_cap" );
    cmn.CallEventHandler( "clk_cap_end" );
    cmn.CallEventHandler( "clk_cap" );
    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_cap_beg" );

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_open_panel" );
  ObjAnimate( "spr_panelboard_cap", "alp", 0, 0, "", 
  { 
    0.0, 0, 1,
    0.3, 0, 0,
  } );
  ObjAnimate( "obj_panelboard_open", "alp", 0, 0, func_end, 
  { 
    0.0, 0, 0,
    0.3, 0, 1,
  } );

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_fuse ()

  local func_end = function ()

    cmn.SetEventDone( "clk_fuse" );
    cmn.CallEventHandler( "clk_fuse_end" );
    cmn.CallEventHandler( "clk_fuse" );
    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_fuse_beg" );

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_take_auto_fuse" );
  ObjSet( "spr_panelboard_fuse_shadow", { alp = 0 } );  
  ObjSet( "spr_panelboard_fuse_broke", { alp = 0 } );
  ObjSet( "anm_panelboard_fuse_remove", { alp = 1 } );
  AnimPlay( "anm_panelboard_fuse_remove", "DoAnim", func_end );

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_electricplug ()

  local func_end = function ()

    cmn.SetEventDone( "clk_electricplug" );
    cmn.CallEventHandler( "clk_electricplug_end" );
    cmn.CallEventHandler( "clk_electricplug" );
    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_electricplug_beg" );

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_remove_safer" );

  ObjSet( "spr_panelboard_plug_broken", { alp = 0 } );  
  ObjSet( "spr_panelboard_plug_shadow", { alp = 0 } );
  ObjSet( "anm_panelboard_sparks_plug", { alp = 0 } );
  ObjSet( "anm_panelboard_plug_remove", { alp = 1 } );
  AnimPlay( "anm_panelboard_plug_remove", "DoAnim", func_end );

end;
-------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.PreOpen ()

  if not ( cmn.IsEventDone( "opn_switchroom" ) ) then

    ObjSet( "rm_switchroom", { color_r = 0, color_g = 0, color_b = 0 } );

  else 

    VidPlay( "vid_switchroom_fire", "" );
    ObjDelete( "spr_switchroom_burntbag_part" );
    ObjSet( "spr_switchroom_afterfire", { alp = 1 } );

  end;

  if not ( cmn.IsEventDone( "use_sandbucket" ) ) and cmn.IsEventDone( "opn_switchroom" ) then

    cmn.StopAllEnv( "audio/level2/env/aud_switch_room_env", true );
    cmn.PlayAudio( "env", "audio/level2/env/aud_switch_room_env", 1 );

  else

    cmn.StopAllEnv( "audio/level2/env/aud_switch_room_fire_off_env", true );
    cmn.PlayAudio( "env", "audio/level2/env/aud_switch_room_fire_off_env", 1 );

  end;

end;
--*********************************************************************************************************************
function private.opn_switchroom ()

  if not ( cmn.IsEventDone( "opn_switchroom" ) ) then

    local func_end = function ()

      cmn.SetEventDone( "opn_switchroom" );
      cmn.CallEventHandler( "opn_switchroom" );
      cmn.StopAudio( "sfx", "audio/level2/sfx/aud_switchroom_fire_beginning" );
      cmn.StopAudio( "sfx", "audio/level2/sfx/aud_switchroom_fire_beginning_voc" );
      cmn.StopAudio( "env", "audio/level2/env/aud_switch_room_fire_off_env" );
      cmn.PlayAudio( "env", "audio/level2/env/aud_switch_room_env", 1 );
      cmn.PlayAudio( "voc", "audio/level2/voc/aud_atropos_after_fire" );
      cmn.PlayAudio( "mus", "audio/aud_inseption_mus" );
      int.Lock( false );      
      ObjSet( "rm_switchroom", { color_r = 1, color_g = 1, color_b = 1 } );
      VidPlay( "vid_switchroom_fire", "" );
      ObjDelete( "spr_switchroom_burntbag_part" );
      ObjSet( "spr_switchroom_afterfire", { alp = 1 } );
      int.ShowTaskNote( 2, function () cmn.ShowBbt( "bbt_switchroom_first_entry" ); end );

      cmn.AddPageDiary( 11 );

    end;

    int.Lock( true );

    common_impl.PlayDialogVideo( "vid_switchroom_fire_beginning", func_end ); 

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_switchroom_fire_beginning" );
    --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_watch" );
    cmn.PlayAudio( "voc", "audio/level2/voc/aud_switchroom_fire_beginning_voc" );

  end;

end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_switchroom();

  if cmn.IsEventDone( "get_plan" ) and not cmn.IsEventDone( "use_plan" ) then
    public.use_plan();
  end;

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_hammer2" ); 
  int.AddedTaskMap( private.room_objname, "get_burntbag",                   { "use_sandbucket" } ); 

  int.AddedTaskMap( private.room_objname, "use_fuse_2",                     { "get_fuse_2", "clk_fuse" } ); 
  int.AddedTaskMap( private.room_objname, "use_rubbergloves",             { "clk_cap", "get_rubbergloves" } ); 
  int.AddedTaskMap( private.room_objname, "use_insulatingtape_2",           { "get_insulatingtape", "use_rubbergloves" } ); 
  int.AddedTaskMap( private.room_objname, "use_electricplug",               { "get_electricplug", "clk_electricplug" } );
  int.AddedTaskMap( private.room_objname, "use_sandbucket",                 { "get_sandbucket" } ); 
  int.AddedTaskMap( private.room_objname, "use_plan",                       { "get_plan" } );

  int.AddedTaskMap( private.room_objname, "clk_cap",                        { "use_plan", "use_sandbucket" }  );  
  int.AddedTaskMap( private.room_objname, "clk_fuse",                       { "use_rubbergloves" } );  
  int.AddedTaskMap( private.room_objname, "clk_electricplug",               { "use_rubbergloves" } ); 

  int.AddedTaskMap( private.room_objname, "win_repair",                     { "use_fuse_2","use_electricplug","use_insulatingtape_2" } );  

end;
--*********************************************************************************************************************
function private.ClkPanel( num )

  local x = ObjGet( "spr_switchroom_panel_"..num ).pos_x;

  int.Lock( true );

  ObjAnimate( "spr_switchroom_panel_"..num, "pos_x", 0, 0, 
  function ()
    int.Lock( false );
  end, 
  {
    0.0,0,x,
    0.2,0,x-1,
    0.4,0,x
  });

end;
--*********************************************************************************************************************
function private.InitAnims ()

  ObjAnimate( "spr_switchroom_hammer_add", "alp", 1, 0, "", 
  {
    0.0, 0, 0.3,
    0.7, 0, 1.0,
    1.4, 0, 0.2,
    1.9, 0, 0.8,
    2.4, 0, 0.3,
  } );

  ObjAnimate( "spr_switchroom_burntbag", "ang", 1, 0, "", 
  {
    0.0, 3, 0.03,
    3, 3, -0.03,
    6, 3, 0.03
  } );

  ObjAnimate( "spr_switchroom_burntbag_shad", "ang", 1, 0, "", 
  {
    0.0, 3, 0.03,
    3, 3, -0.03,
    6, 3, 0.03
  } );

  ObjAnimate( "spr_panelboard_light", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.3,
    2.0, 0, 1
  } );
  ObjAnimate("spr_panelboard_light_add", "alp", 1, 0, "", 
  {
    0.0,0,1,
    1.5,0,1,
    1.9,0,0.8,
    2.3,0,1,
    3.5,0,1,
    4.1,0,0.7,
    4.5,0,1
  });
  ObjAnimate("spr_panelboard_arrow", "ang", 1, 0, "", 
  {
    0.0,0,0.00,
    1.0,0,-0.5,
    1.5,0,0.00,
    2.2,0,-0.5,
    2.7,0,0.00,
    4.0,0,0.00
  });

end;
--*********************************************************************************************************************
function private.ClkJacket()

  int.Lock( true );
  AnimPlay( "anm_switchroom_jacket_move", "DoAnim", function () int.Lock( false ); end );

end;
--*********************************************************************************************************************
