-- name=rm_yard
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_yard";

  ObjAttach( "zz_sandbox",         "room_hub" );
  ObjAttach( "zz_postmachine",     "room_hub" );
  ObjAttach( "zz_nanny",           "room_hub" );
  ObjAttach( "zz_basemententrace", "room_hub" );
  ObjAttach( "zz_icecreamvendor",  "room_hub" );
  
  ObjMultiSet( {
    { "spr_postmachine_newspaper",         { event_mdown = private.get_newspaper } },
    { "spr_sandbox_brokenbutterfly",       { event_mdown = private.get_brokenbutterfly } },
    { "spr_sandbox_switchroomkey",         { event_mdown = private.get_switchroomkey } },
    { "spr_sandbox_bell",                  { event_mdown = private.get_bell_2 } },
    { "spr_postmachine_wrappeditem",       { event_mdown = private.get_wrappeditem } },
    { "spr_nanny_tongs",                   { event_mdown = private.get_tongs } },
    { "spr_nanny_fork",                    { event_mdown = private.get_fork } },
    { "spr_icecreamvendor_ambereye_2",     { event_mdown = private.get_ambereye_2 } },
    { "obj_basemententrace_clk_hook",      { event_mdown = private.clk_hook } },
    { "obj_postmachine_use_coins_2",       { event_mdown = private.ClkPostmachineDoor } },
    { "spr_nanny_collect2_2_4",            { event_mdown = private.get_collect2_2_4 } },
    { "obj_sandbox_use_toymushroom",       { event_mdown = private.ClkBook } },
    { "obj_nanny_use_catamulet",           { event_mdown = private.ClkBox} },
    { "obj_icecreamvendor_flower_clk",     { event_mdown = private.FlowerClk} },
    { "obj_postmachine_use_sausage",       { event_mdown = private.CatClk } },
    { "obj_yard_clk_swing",                { event_mdown = private.SwingClk } },
    { "obj_icecreamvendor_use_bell_1",     { event_mdown = function() private.NoteBbt() end } },
    { "obj_icecreamvendor_use_bell_2",     { event_mdown = function() private.NoteBbt() end } },
    { "obj_icecreamvendor_use_bell_3",     { event_mdown = function() private.NoteBbt() end } },
    { "spr_postmachine_butterflypart",     { event_mdown = private.get_butterflypart_1 } },
    { "spr_basemententrace_butterflypart", { event_mdown = private.get_butterflypart_2 } },
    { "spr_icecreamvendor_butterflypart",  { event_mdown = private.get_butterflypart_3 } },
  } );

  private.InitBasemententrace();
  private.InitSandbox();
  private.InitIcecreamvendor();
  private.InitSubroom();
  private.InitAnim();
  private.StartPlaneAnim();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_yard = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gzz_yard_sandbox",
        "gzz_yard_postmachine",
        "gzz_yard_nanny",
        "gzz_yard_basemententrace",
        "gzz_yard_icecreamvendor",
        "gmg_yard_darkness",
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_sandbox", 
        "zz_postmachine", 
        "zz_nanny", 
        "zz_basemententrace",
        "zz_icecreamvendor",
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_yard", update_game_mode_yard, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_sandbucket () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sandbucket" ] =
  {
    type = "get",
    get_obj = "spr_sandbox_sandbucket",
    room = private.room_objname,
    zz = "zz_sandbox",
    zz_gate = "gzz_yard_sandbox"
  };
  -----------------------------------------------
  local get_sandbucket_inv = function ()

    int.InventoryItemAdd( "inv_sandbucket", "spr_sandbox_bucket" );

  end;

  local get_sandbucket_closezz = function ()

    ObjDelete( "gfx_sandbox_sandbucket" );
    ObjDelete( "spr_sandbox_bucket_shadow" );

    if ( cmn.IsEventDone( "get_sandbucket" ) and
         cmn.IsEventDone( "get_brokenbutterfly" )  and
         cmn.IsEventDone( "get_bell_2" ) ) then

      ObjDelete( "gzz_yard_sandbox" );

    end;

  end;

  cmn.AddSubscriber( "get_sandbucket", get_sandbucket_inv );
  cmn.AddSubscriber( "get_sandbucket", get_sandbucket_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokenbutterfly () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brokenbutterfly" ] =
  {
    type = "get",
    get_obj = "spr_sandbox_brokenbutterfly",
    room = private.room_objname,
    zz = "zz_sandbox",
    zz_gate = "gzz_yard_sandbox"
  };
  -----------------------------------------------
  local get_brokenbutterfly_inv = function ()

    int.InventoryItemAdd( "inv_brokenbutterfly", "spr_sandbox_brokenbutterfly" );
    ObjSet( "inv_brokenbutterfly", { drag = false } );

    if ( cmn.IsEventDone( "get_butterflypart_1" ) or 
         cmn.IsEventDone( "get_butterflypart_2" ) or
         cmn.IsEventDone( "get_butterflypart_3" ) ) then

      ObjSet( "inv_brokenbutterfly_plus_focus2", { alp = 1 } );

    else 

      ObjSet( "inv_brokenbutterfly_plus_focus2", { alp = 0 } );

    end;

  end;

  local get_brokenbutterfly_closezz = function ()

    ObjDelete( "gfx_sandbox_brokenbutterfly" );
    ObjDelete( "spr_sandbox_brokenbutterfly_shadow" );
    ObjDelete( "spr_yard_brokenbutterfly" );

    if ( cmn.IsEventDone( "get_sandbucket" ) and
         cmn.IsEventDone( "get_brokenbutterfly" ) and
         cmn.IsEventDone( "get_bell_2" ) ) then

      ObjDelete( "gzz_yard_sandbox" );

    end;

  end;

  cmn.AddSubscriber( "get_brokenbutterfly", get_brokenbutterfly_inv );
  cmn.AddSubscriber( "get_brokenbutterfly", get_brokenbutterfly_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bell_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bell_2" ] =
  {
    type = "get",
    get_obj = "spr_sandbox_bell",
    room = private.room_objname,
    zz = "zz_sandbox",
    zz_gate = "gzz_yard_sandbox"
  };
  ---------------------------------------------
  local get_bell_2_inv = function ()

    int.InventoryItemAdd( "inv_bell_2", "spr_sandbox_bell" );

  end;

  local get_bell_2_closezz = function ()

    ObjDelete( "gfx_sandbox_bell" );
    ObjDelete( "spr_sandbox_bell_shadow" );

    if ( cmn.IsEventDone( "get_switchroomkey" ) and
         cmn.IsEventDone( "get_bell_2" ) ) then

      ObjSet( "spr_sandbox_close", { alp = 1 } );
      ObjDelete( "obj_sandbox_mmg" );
      ObjDelete( "spr_yard_open_book1" );

    end;

    if ( cmn.IsEventDone( "get_sandbucket" ) and
         cmn.IsEventDone( "get_brokenbutterfly" ) and
         cmn.IsEventDone( "get_switchroomkey" ) and
         cmn.IsEventDone( "get_bell_2" ) ) then

      ObjDelete( "gzz_yard_sandbox" );

    end;

  end;

  cmn.AddSubscriber( "get_bell_2", get_bell_2_inv );
  cmn.AddSubscriber( "get_bell_2", get_bell_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_switchroomkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_switchroomkey" ] =
  {
    type = "get",
    get_obj = "spr_sandbox_switchroomkey",
    room = private.room_objname,
    zz = "zz_sandbox",
    zz_gate = "gzz_yard_sandbox"
  };
  ---------------------------------------------
  local get_switchroomkey_inv = function ()

    int.InventoryItemAdd( "inv_switchroomkey", "spr_sandbox_switchroomkey" );

  end;

  local get_switchroomkey_closezz = function ()

    ObjDelete( "gfx_sandbox_switchroomkey" );
    ObjDelete( "spr_sandbox_switchroomkey_shadow" );

    if ( cmn.IsEventDone( "get_switchroomkey" ) and
         cmn.IsEventDone( "get_bell_2" ) ) then

      ObjSet( "spr_sandbox_close", { alp = 1 } );
      ObjDelete( "obj_sandbox_mmg" );
      ObjDelete( "spr_yard_open_book1" );

    end;

    if ( cmn.IsEventDone( "get_sandbucket" ) and
         cmn.IsEventDone( "get_brokenbutterfly" ) and
         cmn.IsEventDone( "get_switchroomkey" ) and
         cmn.IsEventDone( "get_bell_2" ) ) then

      ObjDelete( "gzz_yard_sandbox" );

    end;

  end;

  cmn.AddSubscriber( "get_switchroomkey", get_switchroomkey_inv );
  cmn.AddSubscriber( "get_switchroomkey", get_switchroomkey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_newspaper () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_newspaper" ] =
  {
    type = "get",
    get_obj = "spr_postmachine_newspaper",
    room = private.room_objname,
    zz = "zz_postmachine",
    zz_gate = "gzz_yard_postmachine"
  };
  -----------------------------------------------
  local get_newspaper_inv = function ()

    int.InventoryItemAdd( "inv_newspaper", "spr_postmachine_newspaper" );

  end;

  local get_newspaper_closezz = function ()

    ObjDelete( "gfx_postmachine_newspaper" );
    ObjDelete( "spr_postmachine_newspaper_shadow" );
    ObjDelete( "spr_yard_newspaper" );

    if ( cmn.IsEventDone( "get_newspaper" ) and
         cmn.IsEventDone( "get_wrappeditem" ) ) then

      ObjDelete( "gzz_yard_postmachine" );

    end;

  end;

  cmn.AddSubscriber( "get_newspaper", get_newspaper_inv );
  cmn.AddSubscriber( "get_newspaper", get_newspaper_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_butterflypart_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_butterflypart_1" ] =
  {
    type = "get",
    get_obj = "spr_postmachine_butterflypart",
    room = private.room_objname,
    zz = "zz_postmachine",
    zz_gate = "gzz_yard_postmachine"
  };
  -----------------------------------------------
  local get_butterflypart_1_inv = function ()

    int.InventoryItemAdd( "inv_butterflypart_1", "spr_postmachine_butterflypart" );
    if cmn.IsEventDone( "get_brokenbutterfly" ) then
      ObjSet( "inv_brokenbutterfly_plus_focus2", { alp = 1 } );
    end;

  end;

  local get_butterflypart_1_closezz = function ()

    ObjDelete( "obj_postmachine_butterflypart" );
    ObjDelete( "spr_yard_butterflypart_1" );
    ObjDelete( "gfx_postmachine_butterflypart" );

  end;

  cmn.AddSubscriber( "get_butterflypart_1", get_butterflypart_1_inv );
  cmn.AddSubscriber( "get_butterflypart_1", get_butterflypart_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_butterflypart_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_butterflypart_2" ] =
  {
    type = "get",
    get_obj = "spr_basemententrace_butterflypart",
    room = private.room_objname,
    zz = "zz_basemententrace",
    zz_gate = "gzz_yard_basemententrace"
  };
  -----------------------------------------------
  local get_butterflypart_2_inv = function ()

    int.InventoryItemAdd( "inv_butterflypart_2", "spr_basemententrace_butterflypart" );

    if cmn.IsEventDone( "get_brokenbutterfly" ) then

      ObjSet( "inv_brokenbutterfly_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_butterflypart_2_closezz = function ()

    ObjSet( "obj_basemententrace_clk_hook", { input = true } );
    ObjDelete( "obj_basemententrace_butterflypart" );
    ObjDelete( "gfx_basemententrace_butterflypart" );
    ObjDelete( "spr_yard_butterflypart_2" );

  end;

  cmn.AddSubscriber( "get_butterflypart_2", get_butterflypart_2_inv );
  cmn.AddSubscriber( "get_butterflypart_2", get_butterflypart_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_butterflypart_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_butterflypart_3" ] =
  {
    type = "get",
    get_obj = "spr_icecreamvendor_butterflypart",
    room = private.room_objname,
    zz = "zz_icecreamvendor",
    zz_gate = "gzz_yard_icecreamvendor"
  };
  -----------------------------------------------
  local get_butterflypart_3_inv = function ()

    int.InventoryItemAdd( "inv_butterflypart_3", "spr_icecreamvendor_butterflypart" );

    if cmn.IsEventDone( "get_brokenbutterfly" ) then

      ObjSet( "inv_brokenbutterfly_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_butterflypart_3_closezz = function ()

    ObjDelete( "gfx_icecreamvendor_butterflypart" );
    ObjDelete( "spr_icecreamvendor_butterflypart_shadow" );
    ObjDelete( "spr_yard_butterflypart_3" );

    if ( cmn.IsEventDone( "get_ambereye_2" ) and
         cmn.IsEventDone( "get_butterflypart_3" ) ) then

      ObjDelete( "gzz_yard_icecreamvendor" );

    end;

  end;

  cmn.AddSubscriber( "get_butterflypart_3", get_butterflypart_3_inv );
  cmn.AddSubscriber( "get_butterflypart_3", get_butterflypart_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wrappeditem () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wrappeditem" ] =
  {
    type = "get",
    get_obj = "spr_postmachine_wrappeditem",
    room = private.room_objname,
    zz = "zz_postmachine",
    zz_gate = "gzz_yard_postmachine"
  };
  ---------------------------------------------
  local get_wrappeditem_inv = function ()

    int.InventoryItemAdd( "inv_wrappeditem", "spr_postmachine_wrappeditem" );
    ObjSet( "inv_wrappeditem", { drag = false } );

  end;

  local get_wrappeditem_closezz = function ()

    ObjDelete( "gfx_postmachine_wrappeditem" );
    ObjDelete( "spr_postmachine_wrappeditem_shadow" );
    ObjDelete( "spr_yard_wrappeditem" );

    if ( cmn.IsEventDone( "get_newspaper" ) and
         cmn.IsEventDone( "get_wrappeditem" ) ) then

      ObjDelete( "gzz_yard_postmachine" );

    end;

  end;

  cmn.AddSubscriber( "get_wrappeditem", get_wrappeditem_inv );
  cmn.AddSubscriber( "get_wrappeditem", get_wrappeditem_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tongs () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tongs" ] =
  {
    type = "get",
    get_obj = "spr_nanny_tongs",
    room = private.room_objname,
    zz = "zz_nanny",
    zz_gate = "gzz_yard_nanny"
  };
  -----------------------------------------------
  local get_tongs_inv = function ()

    int.InventoryItemAdd( "inv_tongs", "spr_nanny_tongs" );

  end;

  local get_tongs_closezz = function ()

    ObjDelete( "gfx_nanny_tongs" );
    ObjDelete( "spr_nanny_tongs_shadow" );
    ObjDelete( "spr_yard_tongs" );

  end;

  cmn.AddSubscriber( "get_tongs", get_tongs_inv );
  cmn.AddSubscriber( "get_tongs", get_tongs_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fork () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fork" ] =
  {
    type = "get",
    get_obj = "spr_nanny_fork",
    room = private.room_objname,
    zz = "zz_nanny",
    zz_gate = "gzz_yard_nanny"
  };
  -----------------------------------------------
  local get_fork_inv = function ()

    int.InventoryItemAdd( "inv_fork", "spr_nanny_fork" );
    ObjSet( "inv_fork", { drag = false } );

    if ( not cmn.IsEventDone( "get_pliers2" ) ) then

      ObjSet( "inv_fork_plus_focus2", { alp = 0 } );

    end;

  end;

  local get_fork_closezz = function ()

    ObjDelete( "gfx_nanny_fork" );
    ObjDelete( "spr_yard_fork" );

  end;

  cmn.AddSubscriber( "get_fork", get_fork_inv );
  cmn.AddSubscriber( "get_fork", get_fork_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ambereye_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ambereye_2" ] =
  {
    type = "get",
    get_obj = "spr_icecreamvendor_ambereye_2",
    room = private.room_objname,
    zz = "zz_icecreamvendor",
    zz_gate = "gzz_yard_icecreamvendor"
  };
  -----------------------------------------------
  local get_ambereye_2_inv = function ()

    int.InventoryItemAdd( "inv_ambereye_2", "spr_icecreamvendor_ambereye_2" );

  end;

  local get_ambereye_2_closezz = function ()

    ObjDelete( "gfx_icecreamvendor_ambereye_2" );
    ObjDelete( "spr_icecreamvendor_ambereye_shadow" );
    ObjDelete( "spr_yard_eye" );

    if ( cmn.IsEventDone( "get_ambereye_2" ) and
         cmn.IsEventDone( "get_butterflypart_3" ) ) then

      ObjDelete( "gzz_yard_icecreamvendor" );

    end;

  end;

  cmn.AddSubscriber( "get_ambereye_2", get_ambereye_2_inv );
  cmn.AddSubscriber( "get_ambereye_2", get_ambereye_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_2_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_2_4 = function ()

    ObjDelete( "spr_nanny_collect_2_4_shadow" );
    ObjDelete( "spr_nanny_collect2_2_4" );
    ObjDelete( "spr_yard_collect_2_4" );

  end;

  cmn.AddSubscriber( "get_collect2_2_4", get_collect2_2_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_2_6 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_2_6 = function ()

    ObjDelete( "obj_yard_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_2_6", get_morphobject_2_6, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_toymushroom () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_toymushroom" ] =
  {
    type = "use",
    use_obj = "inv_toymushroom",
    use_place = "obj_sandbox_use_toymushroom",
    room = private.room_objname,
    zz = "zz_sandbox",
    zz_gate = "gzz_yard_sandbox"
  };
  -----------------------------------------------
  local use_toymushroom_inv = function ()

    int.InventoryItemRemove( "inv_toymushroom" );

  end;
  local use_toymushroom_beg = function ()

    ObjDelete( "obj_sandbox_use_toymushroom" );

  end;
  local use_toymushroom_end = function ()

    ObjSet( "obj_sandbox_mmg", { input = true } );
    ObjSet( "obj_sandbox_figures", { input = true } );
    ObjSet( "spr_sandbox_close", { alp = 0 } );
    ObjSet( "obj_sandbox_mmg", { alp = 1 } );
    ObjSet( "spr_yard_open_book", { alp = 1 } );
    ObjSet( "spr_yard_toymushroom", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_toymushroom", use_toymushroom_beg, private.room_objname );
  cmn.AddSubscriber( "use_toymushroom", use_toymushroom_inv );
  cmn.AddSubscriber( "use_toymushroom", use_toymushroom_end, private.room_objname );
  cmn.AddSubscriber( "use_toymushroom_inv", use_toymushroom_inv, private.room_objname );
  cmn.AddSubscriber( "use_toymushroom_beg", use_toymushroom_beg, private.room_objname );
  cmn.AddSubscriber( "use_toymushroom_end", use_toymushroom_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bucket () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bucket" ] =
  {
    type = "use",
    use_obj = "inv_bucket",
    use_place = "obj_sandbox_use_bucket",
    room = private.room_objname,
    zz = "zz_sandbox",
    zz_gate = "gzz_yard_sandbox"
  };
  -----------------------------------------------
  local use_bucket_inv = function ()

    int.InventoryItemRemove( "inv_bucket" );

  end;
  local use_bucket_beg = function ()

    ObjDelete( "obj_sandbox_use_bucket" );

  end;
  local use_bucket_end = function ()

    ObjDelete( "anm_sandbox_sandinbucket" );
    ObjSet( "spr_sandbox_bucketsand", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_bucket", use_bucket_beg, private.room_objname );
  cmn.AddSubscriber( "use_bucket", use_bucket_inv );
  cmn.AddSubscriber( "use_bucket", use_bucket_end, private.room_objname );
  cmn.AddSubscriber( "use_bucket_inv", use_bucket_inv, private.room_objname );
  cmn.AddSubscriber( "use_bucket_beg", use_bucket_beg, private.room_objname );
  cmn.AddSubscriber( "use_bucket_end", use_bucket_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sausage () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sausage" ] =
  {
    type = "use",
    use_obj = "inv_sausage",
    use_place = "obj_postmachine_use_sausage",
    room = private.room_objname,
    zz = "zz_postmachine",
    zz_gate = "gzz_yard_postmachine"
  };
  -----------------------------------------------
  local use_sausage_inv = function ()

    int.InventoryItemRemove( "inv_sausage" );

  end;
  local use_sausage_beg = function ()

    ObjDelete( "obj_postmachine_use_sausage" );

  end;
  local use_sausage_end = function ()

    ObjDelete( "anm_postmachine_cat_static" );
    ObjDelete( "anm_postmachine_cat_use_sausage" );
    ObjDelete( "anm_postmachine_cat_coin" );
    ObjDelete( "anm_yard_cat" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_sausage", use_sausage_beg, private.room_objname );
  cmn.AddSubscriber( "use_sausage", use_sausage_inv );
  cmn.AddSubscriber( "use_sausage", use_sausage_end, private.room_objname );
  cmn.AddSubscriber( "use_sausage_inv", use_sausage_inv, private.room_objname );
  cmn.AddSubscriber( "use_sausage_beg", use_sausage_beg, private.room_objname );
  cmn.AddSubscriber( "use_sausage_end", use_sausage_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_coins_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_coins_2" ] =
  {
    type = "use",
    use_obj = "inv_coins_2",
    use_place = "obj_postmachine_use_coins_2",
    room = private.room_objname,
    zz = "zz_postmachine",
    zz_gate = "gzz_yard_postmachine"
  };
  -----------------------------------------------
  local use_coins_2_inv = function ()

    int.InventoryItemRemove( "inv_coins_2" );

  end;
  local use_coins_2_beg = function ()

    ObjDelete( "obj_postmachine_use_coins_2" );

  end;
  local use_coins_2_end = function ()

    ObjDelete( "spr_postmachine_closed" );
    ObjSet( "spr_postmachine_opened", { alp = 1 } );
    ObjSet( "obj_postmachine_open", { input = true } );
    ObjSet( "gfx_postmachine_newspaper", { active = true } );
    ObjSet( "spr_postmachine_wrappeditem", { active = true } );
    ObjDelete( "spr_yard_close" );
    ObjDelete( "anm_postmachine_use_coins" );
    ObjSet( "spr_yard_open1", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_coins_2", use_coins_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_coins_2", use_coins_2_inv );
  cmn.AddSubscriber( "use_coins_2", use_coins_2_end, private.room_objname );
  cmn.AddSubscriber( "use_coins_2_inv", use_coins_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_coins_2_beg", use_coins_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_coins_2_end", use_coins_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_catamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_catamulet" ] =
  {
    type = "use",
    use_obj = "inv_catamulet",
    use_place = "obj_nanny_use_catamulet",
    room = private.room_objname,
    zz = "zz_nanny",
    zz_gate = "gzz_yard_nanny"
  };
  -----------------------------------------------
  local use_catamulet_inv = function ()

    int.InventoryItemRemove( "inv_catamulet" );

  end;
  local use_catamulet_beg = function ()

    ObjDelete( "obj_nanny_use_catamulet" );

  end;
  local use_catamulet_end = function ()

    ObjDelete( "spr_nanny_cup_up" );
    ObjSet( "obj_nanny_open_box", { input = true, alp = 1 } );
    ObjSet( "gfx_nanny_fork", { active = true } );
    ObjSet( "spr_yard_open_lunchbox", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_catamulet", use_catamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_catamulet", use_catamulet_inv );
  cmn.AddSubscriber( "use_catamulet", use_catamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_catamulet_inv", use_catamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_catamulet_beg", use_catamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_catamulet_end", use_catamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pearl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pearl" ] =
  {
    type = "use",
    use_obj = "inv_pearl",
    use_place = "obj_nanny_use_pearl",
    room = private.room_objname,
    zz = "zz_nanny",
    zz_gate = "gzz_yard_nanny"
  };
  -----------------------------------------------
  local use_pearl_inv = function ()

    int.InventoryItemRemove( "inv_pearl" );

  end;
  local use_pearl_beg = function ()

    ObjDelete( "obj_nanny_use_pearl" );

  end;
  local use_pearl_end = function ()

    ObjDelete( "anm_nanny_opn_bag" );
    ObjSet( "obj_nanny_open_bag", { input = true, alp = 1 } );
    ObjSet( "gfx_nanny_tongs",    { active = true } );
    ObjSet( "spr_yard_open_bag",  { alp = 1 } );
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_pearl", use_pearl_beg, private.room_objname );
  cmn.AddSubscriber( "use_pearl", use_pearl_inv );
  cmn.AddSubscriber( "use_pearl", use_pearl_end, private.room_objname );
  cmn.AddSubscriber( "use_pearl_inv", use_pearl_inv, private.room_objname );
  cmn.AddSubscriber( "use_pearl_beg", use_pearl_beg, private.room_objname );
  cmn.AddSubscriber( "use_pearl_end", use_pearl_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_doordowel_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_doordowel_2" ] =
  {
    type = "use",
    use_obj = "inv_doordowel_1",
    use_place = "obj_basemententrace_use_doordowel_2",
    room = private.room_objname,
    zz = "zz_basemententrace",
    zz_gate = "gzz_yard_basemententrace"
  };
  -----------------------------------------------
  local use_doordowel_2_inv = function ()

    int.InventoryItemRemove( "inv_doordowel_1" );

  end;
  local use_doordowel_2_beg = function ()

    ObjDelete( "obj_basemententrace_use_doordowel_2" );

  end;
  local use_doordowel_2_end = function ()

    ObjSet( "spr_basemententrace_spring_up1", { alp = 0 } );
    ObjSet( "spr_basemententrace_spring_up2", { alp = 0 } );
    ObjSet( "spr_basemententrace_spring_down1", { alp = 1 } );
    ObjSet( "spr_basemententrace_spring_down2", { alp = 1 } );
    ObjSet( "spr_basemententrace_gold_pin1", { alp = 1 } );
    ObjSet( "spr_basemententrace_gold_pin2", { alp = 1 } );
    ObjSet( "obj_basemententrace_mmg", { input = true } );
    ObjSet( "spr_yard_pin",  { alp = 1 } );
    ObjSet( "spr_yard_pin1", { alp = 1 } );
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_doordowel_2", use_doordowel_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_doordowel_2", use_doordowel_2_inv );
  cmn.AddSubscriber( "use_doordowel_2", use_doordowel_2_end, private.room_objname );
  cmn.AddSubscriber( "use_doordowel_2_inv", use_doordowel_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_doordowel_2_beg", use_doordowel_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_doordowel_2_end", use_doordowel_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bell_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bell_3" ] =
  {
    type = "use",
    use_obj = "inv_bell_3",
    use_place = "obj_icecreamvendor_use_bell_3",
    room = private.room_objname,
    zz = "zz_icecreamvendor",
    zz_gate = "gzz_yard_icecreamvendor"
  };
  -----------------------------------------------
  local use_bell_3_inv = function ()

    int.InventoryItemRemove( "inv_bell_3" );

  end;
  local use_bell_3_beg = function ()

    ObjDelete( "obj_icecreamvendor_use_bell_3" );

  end;
  local use_bell_3_end = function ()

    ObjSet( "spr_icecreamvendor_button_5", { alp = 1 } );
    ObjSet( "spr_yard_button3", { alp = 1 } );

    if ( cmn.IsEventDone( "use_bell_1" ) and
         cmn.IsEventDone( "use_bell_2" ) and
         cmn.IsEventDone( "use_bell_3" ) ) then

      ObjSet( "obj_icecreamvendor_mmg", { input = true } );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_bell_3", use_bell_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_bell_3", use_bell_3_inv );
  cmn.AddSubscriber( "use_bell_3", use_bell_3_end, private.room_objname );
  cmn.AddSubscriber( "use_bell_3_inv", use_bell_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_bell_3_beg", use_bell_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_bell_3_end", use_bell_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bell_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bell_1" ] =
  {
    type = "use",
    use_obj = "inv_bell_1",
    use_place = "obj_icecreamvendor_use_bell_1",
    room = private.room_objname,
    zz = "zz_icecreamvendor",
    zz_gate = "gzz_yard_icecreamvendor"
  };
  -----------------------------------------------
  local use_bell_1_inv = function ()

    int.InventoryItemRemove( "inv_bell_1" );

  end;
  local use_bell_1_beg = function ()

    ObjDelete( "obj_icecreamvendor_use_bell_1" );

  end;
  local use_bell_1_end = function ()

    ObjSet( "spr_icecreamvendor_button_2", { alp = 1 } );
    ObjSet( "spr_yard_button1", { alp = 1 } );

    if ( cmn.IsEventDone( "use_bell_1" ) and
         cmn.IsEventDone( "use_bell_2" ) and
         cmn.IsEventDone( "use_bell_3" ) ) then

      ObjSet( "obj_icecreamvendor_mmg", { input = true } );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_bell_1", use_bell_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_bell_1", use_bell_1_inv );
  cmn.AddSubscriber( "use_bell_1", use_bell_1_end, private.room_objname );
  cmn.AddSubscriber( "use_bell_1_inv", use_bell_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_bell_1_beg", use_bell_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_bell_1_end", use_bell_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bell_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bell_2" ] =
  {
    type = "use",
    use_obj = "inv_bell_2",
    use_place = "obj_icecreamvendor_use_bell_2",
    room = private.room_objname,
    zz = "zz_icecreamvendor",
    zz_gate = "gzz_yard_icecreamvendor"
  };
  -----------------------------------------------
  local use_bell_2_inv = function ()

    int.InventoryItemRemove( "inv_bell_2" );

  end;
  local use_bell_2_beg = function ()

    ObjDelete( "obj_icecreamvendor_use_bell_2" );

  end;
  local use_bell_2_end = function ()

    ObjSet( "spr_icecreamvendor_button_4", { alp = 1 } );
    ObjSet( "spr_yard_button2", { alp = 1 } );

    if ( cmn.IsEventDone( "use_bell_1" ) and
         cmn.IsEventDone( "use_bell_2" ) and
         cmn.IsEventDone( "use_bell_3" ) ) then

      ObjSet( "obj_icecreamvendor_mmg", { input = true } );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_bell_2", use_bell_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_bell_2", use_bell_2_inv );
  cmn.AddSubscriber( "use_bell_2", use_bell_2_end, private.room_objname );
  cmn.AddSubscriber( "use_bell_2_inv", use_bell_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_bell_2_beg", use_bell_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_bell_2_end", use_bell_2_end, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_hook () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_hook" ] =
  {
    type = "click",
    clk_obj = "obj_basemententrace_clk_hook",
    room = private.room_objname,
    zz = "zz_basemententrace",
    zz_gate = "gzz_yard_basemententrace"
  };
  -----------------------------------------------
  local clk_hook = function ()


  end;
  -----------------------------------------------
  local clk_hook_beg = function ()

    ObjDelete( "obj_basemententrace_clk_hook" );

  end;
  -----------------------------------------------
  local clk_hook_end = function ()

    ObjSet( "obj_basemententrace_mmg", { alp = 1 } );
    ObjSet( "obj_basemententrace_use_doordowel_2", { input = true } );
    ObjDelete( "obj_basemententrace_close" );
    ObjSet( "spr_yard_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_hook", clk_hook );
  cmn.AddSubscriber( "clk_hook", clk_hook_beg, private.room_objname );
  cmn.AddSubscriber( "clk_hook", clk_hook_end, private.room_objname );
  cmn.AddSubscriber( "clk_hook_beg", clk_hook_beg, private.room_objname );
  cmn.AddSubscriber( "clk_hook_end", clk_hook_end, private.room_objname );
  -----------------------------------------------
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function win_basemententrace () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_basemententrace" ] =
  {
    type = "click",
    clk_obj = "obj_basemententrace_pin1",
    room = private.room_objname,
    zz = "zz_basemententrace",
    zz_gate = "gzz_yard_basemententrace"
  };
  --*********************************************************************************************************************
  local win_basemententrace_inv = function ()

    if ( cmn.IsEventDone( "win_basemententrace" ) ) then

      --int.DeleteTaskMap( private.room_objname, "win_basemententrace" );

    end;

  end;
  --*********************************************************************************************************************
  local win_basemententrace = function ()

    if ( cmn.IsEventDone( "win_basemententrace" ) ) then

      ObjSet( "grm_yard_basement", { active = true, input = true, visible = true } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_yard_basement_focus");
      end;    
      ObjDelete( "gzz_yard_basemententrace" );
      ObjDelete( "spr_yard_open" );

    else 

      for i = 1, 4 do
        ObjSet( "obj_basemententrace_pin"..i, { pos_x = ng_global.progress[ "std" ][ "win_basemententrace" ].position[ i ] } );
      end;

      if ng_global.progress[ "std" ][ "win_basemententrace" ].win[ 1 ] then
        ObjSet( "spr_basemententrace_button_off1", { alp = 0 } );
        ObjSet( "spr_basemententrace_button_on1", { alp = 1 } );
      elseif ng_global.progress[ "std" ][ "win_basemententrace" ].win[ 2 ] then
        ObjSet( "spr_basemententrace_button_off2", { alp = 0 } );
        ObjSet( "spr_basemententrace_button_on2", { alp = 1 } );
      end;

    end;

  end;

  cmn.AddSubscriber( "win_basemententrace", win_basemententrace_inv );
  cmn.AddSubscriber( "win_basemententrace", win_basemententrace, private.room_objname );
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function win_sandbox () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_sandbox" ] =
  {
    type = "click",
    clk_obj = "spr_sandbox_gnome",
    room = private.room_objname,
    zz = "zz_sandbox",
    zz_gate = "gzz_yard_sandbox"
  };
  --*********************************************************************************************************************
  local win_sandbox_inv = function ()

    if ( cmn.IsEventDone( "win_sandbox" ) ) then

      --int.DeleteTaskMap( private.room_objname, "win_sandbox" );

    end;

  end;
  --*********************************************************************************************************************
  local win_sandbox = function ()

    if ( cmn.IsEventDone( "win_sandbox" ) ) then

      ObjSet( "spr_yard_open_book1", { alp = 1 } );
      ObjSet( "obj_sandbox_wins1", { pos_y = 0 } );
      ObjSet( "obj_sandbox_wins", { input = true } );
      ObjSet( "spr_sandbox_switchroomkey", { active = true } );
      ObjSet( "spr_sandbox_bell", { active = true } );
      ObjSet( "obj_sandbox_figures", { input = false } );
      ObjDelete( "spr_yard_open_book" );

      for i = 1, 6 do
     
        ObjSet( "spr_sandbox_"..private.name[ i ],
        {
          pos_x = private.place_position[ i ][ 1 ],
          pos_y = private.place_position[ i ][ 2 ]
        } );

      end;

    else 

      for i = 1, 6 do
     
        local place = ng_global.progress[ "std" ][ "win_sandbox" ].position[ i ];      

        ObjSet( "spr_sandbox_"..private.name[ i ],
        {
          pos_x = private.place_position[ place ][ 1 ],
          pos_y = private.place_position[ place ][ 2 ]
        } );

      end;

    end;

  end;

  cmn.AddSubscriber( "win_sandbox", win_sandbox_inv );
  cmn.AddSubscriber( "win_sandbox", win_sandbox, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function see_yard_atropos () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_yard_atropos" ] =
  {
    type = "click",
    room = private.room_objname,
  };
  -----------------------------------------------
  local see_yard_atropos_beg = function ()


  end;
  local see_yard_atropos_end = function ()

    ObjSet( "rm_yard", { color_r = 0, color_g = 0, color_b = 0 } );

  end;
  local see_yard_atropos_mg = function ()

    ObjSet( "anm_darkness_atropos_left_hand_big", { alp = 1, playing = true } );
    ObjSet( "obj_darkness_symdol_1", { alp = 1 } );
    ObjDelete( "anm_darkness_atropos_left_hand" );
    ObjDelete( "anm_darkness_atropos_left_hand_throw" );
    int.LockRoomMap( "livingroom", 1 );
    int.LockRoomMap( "yard", 1 );
    int.LockRoomMap( "kitchen", 1 );
    int.LockRoomMap( "office", 1 );

  end;
  cmn.AddSubscriber( "see_yard_atropos", see_yard_atropos_beg, private.room_objname );
  cmn.AddSubscriber( "see_yard_atropos", see_yard_atropos_end, private.room_objname );
  cmn.AddSubscriber( "see_yard_atropos", see_yard_atropos_mg, "mg_darkness" );
  cmn.AddSubscriber( "see_yard_atropos_beg", see_yard_atropos_beg, private.room_objname );
  cmn.AddSubscriber( "see_yard_atropos_end", see_yard_atropos_end, private.room_objname );
  cmn.AddSubscriber( "see_yard_atropos_mg", see_yard_atropos_mg, "mg_darkness" );
  --*********************************************************************************************************************
  --*********************************************************************************************************************
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function win_icecreamvendor () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_icecreamvendor" ] =
  {
    type = "click",
    clk_obj = "spr_icecreamvendor_button_1",
    room = private.room_objname,
    zz = "zz_icecreamvendor",
    zz_gate = "gzz_yard_icecreamvendor"
  };
  --*********************************************************************************************************************
  local win_icecreamvendor_inv = function ()

    if ( cmn.IsEventDone( "win_icecreamvendor" ) ) then

      --int.DeleteTaskMap( private.room_objname, "win_icecreamvendor" );

    end;

  end;
  --*********************************************************************************************************************
  local win_icecreamvendor = function ()

    if ( cmn.IsEventDone( "win_icecreamvendor" ) ) then

      ObjDelete( "spr_icecreamvendor_door" );
      ObjDelete( "spr_icecreamvendor_door_shadow" );
      ObjSet( "obj_icecreamvendor_mmg", { input = false } );
      ObjSet( "obj_icecreamvendor_open", { input = true, active = true } );
      ObjSet( "spr_yard_open_car", { alp = 1 } );

    end;

  end;

  cmn.AddSubscriber( "win_icecreamvendor", win_icecreamvendor_inv );
  cmn.AddSubscriber( "win_icecreamvendor", win_icecreamvendor, private.room_objname );
  --*********************************************************************************************************************
  --*********************************************************************************************************************

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
function private.get_sandbucket ()

  cmn.SetEventDone( "get_sandbucket" );
  cmn.CallEventHandler( "get_sandbucket" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_sandbucket" ) and
    cmn.IsEventDone( "get_brokenbutterfly" ) and
       cmn.IsEventDone( "get_bell_2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_brokenbutterfly ()

  cmn.SetEventDone( "get_brokenbutterfly" );
  cmn.CallEventHandler( "get_brokenbutterfly" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_sandbucket" ) and
       cmn.IsEventDone( "get_brokenbutterfly" ) ) then
       --cmn.IsEventDone( "get_doordowel_2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_bell_2 ()

  cmn.SetEventDone( "get_bell_2" );
  cmn.CallEventHandler( "get_bell_2" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_sandbucket" ) and
       cmn.IsEventDone( "get_brokenbutterfly" ) and
       cmn.IsEventDone( "get_switchroomkey" ) and
       cmn.IsEventDone( "get_bell_2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_switchroomkey ()

  cmn.SetEventDone( "get_switchroomkey" );
  cmn.CallEventHandler( "get_switchroomkey" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_sandbucket" ) and
       cmn.IsEventDone( "get_brokenbutterfly" ) and
       cmn.IsEventDone( "get_switchroomkey" ) and
       cmn.IsEventDone( "get_bell_2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_newspaper ()

  cmn.SetEventDone( "get_newspaper" );
  cmn.CallEventHandler( "get_newspaper" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_newspaper" ) and
       cmn.IsEventDone( "get_wrappeditem" ) ) then

    cmn.CloseSubRoom();

  end;
  
  if ( cmn.IsEventDone( "get_doordowel_2" ) and
       cmn.IsEventDone( "get_newspaper" ) and
       cmn.IsEventDone( "get_lighter2" ) and
       not cmn.IsEventDone( "see_yard_atropos" ) ) then
       --ObjSet( "rm_yard", { color_r = 0, color_g = 0, color_b = 0 } );    
    private.see_yard_atropos();
  end;

end;
-------------------------------------------------
function private.get_butterflypart_1 ()

  cmn.SetEventDone( "get_butterflypart_1" );
  cmn.CallEventHandler( "get_butterflypart_1" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_butterflypart_2 ()

  cmn.SetEventDone( "get_butterflypart_2" );
  cmn.CallEventHandler( "get_butterflypart_2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
-------------------------------------------------
function private.get_wrappeditem ()

  cmn.SetEventDone( "get_wrappeditem" );
  cmn.CallEventHandler( "get_wrappeditem" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_newspaper" ) and
       cmn.IsEventDone( "get_wrappeditem" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_tongs ()

  cmn.SetEventDone( "get_tongs" );
  cmn.CallEventHandler( "get_tongs" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_fork ()

  cmn.SetEventDone( "get_fork" );
  cmn.CallEventHandler( "get_fork" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_ambereye_2 ()

  cmn.SetEventDone( "get_ambereye_2" );
  cmn.CallEventHandler( "get_ambereye_2" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_ambereye_2" ) and
       cmn.IsEventDone( "get_butterflypart_3" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_butterflypart_3 ()

  cmn.SetEventDone( "get_butterflypart_3" );
  cmn.CallEventHandler( "get_butterflypart_3" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_ambereye_2" ) and
       cmn.IsEventDone( "get_butterflypart_3" ) ) then

    cmn.CloseSubRoom();

  end;

end;
---------------------------------------------------------------------------------
function private.get_collect2_2_4()

  int.AddCollectibles2( "spr_nanny_collect2_2_4" );
  ObjSet( "spr_nanny_collect_2_4_shadow", { alp = 0 } );

end;
--*********************************************************************************************************************
-------------------------------------------------
function public.use_toymushroom ()

  local item = "inv_toymushroom";

  if ( cmn.ApplyObj( item, "gzz_yard_sandbox", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_sandbox" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_sandbox_use_toymushroom", true ) ) then

    cmn.CallEventHandler( "use_toymushroom_inv" );
    cmn.CallEventHandler( "use_toymushroom_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_toymushroom" );
      cmn.CallEventHandler( "use_toymushroom_end" );
      int.Lock( false );

      ng_global.progress[ "std" ][ "win_sandbox" ].position = { 3, 6, 5, 2, 1, 4 };
      cmn.MiniGameShow( "sandbox" );
      common_impl.PassingMgStart( "sandbox" );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_open_sand_game" );  

    ObjAnimate( "spr_sandbox_toymushroom", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_sandbox_close", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.6, 0, 1.0,
      0.9, 0, 0.0
    } );
    ObjAnimate( "obj_sandbox_mmg", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.6, 0, 0.0,
      0.9, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_bucket ()

  local item = "inv_bucket";

  if ( cmn.ApplyObj( item, "gzz_yard_sandbox", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_sandbox" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_sandbox_use_bucket", true ) ) then

    cmn.CallEventHandler( "use_bucket_inv" );
    cmn.CallEventHandler( "use_bucket_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_bucket" );
      cmn.CallEventHandler( "use_bucket_end" );
      int.Lock( false );
      private.get_sandbucket ();

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_take_sand" );  
    AnimPlay( "anm_sandbox_sandinbucket", "DoAnim", func_end ) 

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_sausage ()

  local item = "inv_sausage";

  if ( cmn.ApplyObj( item, "gzz_yard_postmachine", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_postmachine" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_postmachine_use_sausage", true ) ) then

    cmn.CallEventHandler( "use_sausage_inv" );
    cmn.CallEventHandler( "use_sausage_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_sausage" );
      cmn.CallEventHandler( "use_sausage_end" );
      ObjSet( "anm_postmachine_use_coins", { alp = 1 } );
      int.Lock( false );

    end;

    ObjSet( "anm_postmachine_cat_static", { alp = 0 } );
    ObjSet( "anm_postmachine_use_coins", { alp = 0 } );
    ObjSet( "anm_postmachine_cat_use_sausage", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_app_sausage" );
    AnimPlay( "anm_postmachine_cat_use_sausage", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_coins_2 ()

  local item = "inv_coins_2";

  if ( cmn.ApplyObj( item, "gzz_yard_postmachine", false ) and
       cmn.IsEventDone( "use_sausage" ) and
       cmn.IsEventDone( "get_butterflypart_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_postmachine" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_postmachine_use_coins_2", true ) and
           cmn.IsEventDone( "use_sausage" ) and
           cmn.IsEventDone( "get_butterflypart_1" ) ) then

    cmn.CallEventHandler( "use_coins_2_inv" );
    cmn.CallEventHandler( "use_coins_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_coins_2" );
      cmn.CallEventHandler( "use_coins_2_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_newspaper_robot_open" );
    ObjSet( "anm_postmachine_use_coins", { alp = 1 } );
    ObjSet( "spr_postmachine_closed", { alp = 0 } );
    AnimPlay( "anm_postmachine_use_coins", "DoAnim", func_end);

    return true;

  elseif ( cmn.ApplyObj( item, "obj_postmachine_use_coins_2", true ) and
           not cmn.IsEventDone( "use_sausage" ) ) then

    int.Lock( true );
    local func_end = function ()
      ObjSet( "anm_postmachine_cat_static", { alp = 1, playing = true } );
      ObjSet( "anm_postmachine_cat_coin", { alp = 0 } );
      int.Lock( false );
    end;

    ObjSet( "anm_postmachine_cat_static", { alp = 0, playing = false } );
    ObjSet( "anm_postmachine_cat_coin", { alp = 1 } );
    AnimPlay( "anm_postmachine_cat_coin", "DoAnim", func_end );

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_catamulet ()

  local item = "inv_catamulet";

  if ( cmn.ApplyObj( item, "gzz_yard_nanny", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_nanny" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_nanny_use_catamulet", true ) ) then

    cmn.CallEventHandler( "use_catamulet_inv" );
    cmn.CallEventHandler( "use_catamulet_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_catamulet" );
      cmn.CallEventHandler( "use_catamulet_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_app_pear" );  

    ObjAnimate( "spr_nanny_pear", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "obj_nanny_open_box", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.6, 0, 0.0,
      0.9, 0, 1.0
    } );
    ObjAnimate( "spr_nanny_cup_up", "alp", 0, 0, func_end,
    { 
      0.0, 0, 1.0, 
      0.6, 0, 1.0,
      0.9, 0, 0.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_pearl ()

  local item = "inv_pearl";

  if ( cmn.ApplyObj( item, "gzz_yard_nanny", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_nanny" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_nanny_use_pearl", true ) ) then

    cmn.CallEventHandler( "use_pearl_inv" );
    cmn.CallEventHandler( "use_pearl_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_pearl" );
      cmn.CallEventHandler( "use_pearl_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_sweetgirl_bag_open" );  

    AnimPlay( "anm_nanny_opn_bag", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_doordowel_2 ()

  local item = "inv_doordowel_1";

  if ( cmn.ApplyObj( item, "gzz_yard_basemententrace", false ) and 
     ( cmn.IsEventDone( "get_doordowel_1" ) ) and
     ( cmn.IsEventDone( "get_doordowel_2" ) ) and
       cmn.IsEventDone( "clk_hook" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_basemententrace" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_basemententrace_use_doordowel_2", true ) and 
         ( cmn.IsEventDone( "get_doordowel_1" ) ) and
         ( cmn.IsEventDone( "get_doordowel_2" ) ) and
           cmn.IsEventDone( "clk_hook" ) ) then

    cmn.CallEventHandler( "use_doordowel_2_inv" );
    cmn.CallEventHandler( "use_doordowel_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_doordowel_2" );
      cmn.CallEventHandler( "use_doordowel_2_end" );
      int.Lock( false );

      ng_global.progress[ "std" ][ "win_basemententrace" ].position = { 56, -38, 56, -38 };
      ng_global.progress[ "std" ][ "win_basemententrace" ].win = { false, false };

      cmn.MiniGameShow( "basemententrace" );
      common_impl.PassingMgStart( "basemententrace" );

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_basemententrance_place_sticks" );
    ObjAnimate( "spr_basemententrace_spring_up1", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    ObjAnimate( "spr_basemententrace_spring_up2", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    ObjAnimate( "spr_basemententrace_spring_down1", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_basemententrace_spring_down2", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_basemententrace_gold_pin1", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_basemententrace_gold_pin2", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_bell_3 ()

  local item = "inv_bell_3";

  if ( cmn.ApplyObj( item, "gzz_yard_icecreamvendor", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_icecreamvendor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_icecreamvendor_use_bell_3", true ) ) then

    cmn.CallEventHandler( "use_bell_3_inv" );
    cmn.CallEventHandler( "use_bell_3_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_bell_3" );
      cmn.CallEventHandler( "use_bell_3_end" );
      int.Lock( false );

      if ( cmn.IsEventDone( "use_bell_1" ) and
           cmn.IsEventDone( "use_bell_2" ) and
           cmn.IsEventDone( "use_bell_3" ) ) then

        ng_global.progress[ "std" ][ "win_icecreamvendor" ].count = 0;
        ng_global.progress[ "std" ][ "win_icecreamvendor" ].stage = 1;
        cmn.MiniGameShow( "icecreamvendor" );
        private.PlayTune ( 1 );
        common_impl.PassingMgStart( "icecreamvendor" );

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_note" );  
    ObjAnimate( "spr_icecreamvendor_button_5", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_bell_1 ()

  local item = "inv_bell_1";

  if ( cmn.ApplyObj( item, "gzz_yard_icecreamvendor", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_icecreamvendor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_icecreamvendor_use_bell_1", true ) ) then

    cmn.CallEventHandler( "use_bell_1_inv" );
    cmn.CallEventHandler( "use_bell_1_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_bell_1" );
      cmn.CallEventHandler( "use_bell_1_end" );
      int.Lock( false );

      if ( cmn.IsEventDone( "use_bell_1" ) and
           cmn.IsEventDone( "use_bell_2" ) and
           cmn.IsEventDone( "use_bell_3" ) ) then

        ng_global.progress[ "std" ][ "win_icecreamvendor" ].count = 0;
        ng_global.progress[ "std" ][ "win_icecreamvendor" ].stage = 1;
        cmn.MiniGameShow( "icecreamvendor" );
        private.PlayTune ( 1 );
        common_impl.PassingMgStart( "icecreamvendor" );

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_note" );  
    ObjAnimate( "spr_icecreamvendor_button_2", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_bell_2 ()

  local item = "inv_bell_2";

  if ( cmn.ApplyObj( item, "gzz_yard_icecreamvendor", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_icecreamvendor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_icecreamvendor_use_bell_2", true ) ) then

    cmn.CallEventHandler( "use_bell_2_inv" );
    cmn.CallEventHandler( "use_bell_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_bell_2" );
      cmn.CallEventHandler( "use_bell_2_end" );
      int.Lock( false );

      if ( cmn.IsEventDone( "use_bell_1" ) and
           cmn.IsEventDone( "use_bell_2" ) and
           cmn.IsEventDone( "use_bell_3" ) ) then

        ng_global.progress[ "std" ][ "win_icecreamvendor" ].count = 0;
        ng_global.progress[ "std" ][ "win_icecreamvendor" ].stage = 1;
        cmn.MiniGameShow( "icecreamvendor" );
        private.PlayTune ( 1 );
        common_impl.PassingMgStart( "icecreamvendor" );

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_note" ); 
    ObjAnimate( "spr_icecreamvendor_button_4", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_hook ()

  local func_end = function ()

    cmn.SetEventDone( "clk_hook" );
    cmn.CallEventHandler( "clk_hook_end" );
    cmn.CallEventHandler( "clk_hook" );
    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_hook_beg" );

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_open_metallock" );
  ObjAnimate( "spr_basemententrace_close", "ang", 0, 0, "", 
  {
    0.0, 3, 0,
    0.3, 3, 2.14,
  } );
  ObjAnimate( "obj_basemententrace_mmg", "alp", 0, 0, "", 
  {
    0.0, 0, 0,
    0.6, 0, 0,
    0.9, 0, 1
  } );
  ObjAnimate( "obj_basemententrace_close", "alp", 0, 0, func_end, 
  {
    0.0, 0, 1,
    0.6, 0, 1,
    0.9, 0, 0
  } );

end;
-------------------------------------------------
--*********************************************************************************************************************
function private.opn_yard ()

  if not ( cmn.IsEventDone( "opn_yard" ) ) then

    local func_end = function ()

      cmn.SetEventDone( "opn_yard" );
      --cmn.StopAudio( "sfx", "audio/level1/sfx/aud_watch" );
      --cmn.StopAudio( "voc", "audio/level1/voc/aud_watch_voc" );
      int.Lock( false );
      cmn.ShowBbt( "bbt_yard_first_entry" );      
      --ObjSet( "rm_yard", { color_r = 1, color_g = 1, color_b = 1 } ); 

      cmn.AddPageDiary( 10 );

    end;

    int.Lock( true );
    
    ObjAnimate("rm_yard", "scale_xy", 0, 0, "", 
    {
      0.0,0,1,1,
      0.3,0,1,1,
      0.9,3,1.25,1.25,
      1.6,0,1.25,1.25,
      2.2,3,1,1
    });
    ObjAnimate("rm_yard", "pos_x", 0, 0, func_end, 
    {
      0.0,0,0,
      0.3,0,0,
      0.9,3,-126,
      1.6,0,-126,
      2.2,3,0
    });

    --common_impl.PlayDialogVideo( "vid_yard_survey_2", func_end ); 

    --cmn.PlayAudio( "mus", "audio/aud_mainquestion_theme" );
    --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_watch" );
    cmn.PlayAudio( "mus", "audio/aud_moov_mus" );
    cmn.PlayAudio( "voc", "audio/level2/voc/aud_yard_survey_x_2" );

  end;

  if ( cmn.IsEventDone( "get_doordowel_2" ) and
       cmn.IsEventDone( "get_newspaper" ) and
       cmn.IsEventDone( "get_lighter2" ) and
       not cmn.IsEventDone( "see_yard_atropos" ) ) then
    ObjSet( "rm_yard", { color_r = 0, color_g = 0, color_b = 0 } );    
    private.see_yard_atropos();
  else 
    ObjSet( "rm_yard", { color_r = 1, color_g = 1, color_b = 1 } );   
  end;

end;
--*********************************************************************************************************************
function private.see_yard_atropos ()

  local func_end = function ()

    --cmn.StopAudio( "sfx", "audio/level1/sfx/aud_watch" );
    cmn.StopAudio( "sfx", "audio/level2/sfx/aud_yard_atropos_appearance" );
    cmn.StopAudio( "voc", "audio/level2/voc/aud_yard_atropos_appearance_voc" );
    int.Lock( false );
    --cmn.ShowBbt( "bbt_yard_after_survey" );
    --ObjSet( "rm_yard", { color_r = 1, color_g = 1, color_b = 1 } );
    --ObjSet( "obj_yard_use_newspaper", { input = true } );
    --ObjSet( "obj_yard_gates", { active = false, input = false, visible = false } );

    cmn.GotoRoom( "mg_darkness" );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "see_yard_atropos_beg" );

  common_impl.PlayDialogVideo( "vid_yard_atropos_appearance", func_end ); 

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_yard_atropos_appearance" );  
  cmn.PlayAudio( "voc", "audio/level2/voc/aud_yard_atropos_appearance_voc" );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  if not ( cmn.IsEventDone( "opn_yard" ) ) then

    --ObjSet( "rm_yard", { color_r = 0, color_g = 0, color_b = 0 } );
    ng_global.progress[ "std" ][ "opn_yard" ].atropos = 0;

  end;

    if cmn.IsEventDone( "win_basemententrace" ) then
      ObjSet( "spr_yard_open_door", { alp = 1 } );
      ObjDelete( "anm_yard_op_door" );
    end;

  cmn.StopAllEnv( "audio/level2/env/aud_city_env", true );
  cmn.PlayAudio( "env", "audio/level2/env/aud_city_env", 1 );


end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

  if ( not ng_global.progress[ "std" ][ "opn_yard" ].atropos ) then 
    ng_global.progress[ "std" ][ "opn_yard" ].atropos = 0;
  end;

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_basemententrace" );
  subroom.Define( "zz_postmachine" );
  subroom.Define( "zz_nanny" );
  subroom.Define( "zz_sandbox" );
  subroom.Define( "zz_icecreamvendor" );
  -------------------------------------------------
  function zz_icecreamvendor.PreOpen()

    if ng_global.progress[ "std" ][ "win_icecreamvendor" ].stage == 2 and not cmn.IsEventDone( "win_icecreamvendor" )then

      ObjStopAnimate( "spr_icecreamvendor_light_lamp1", "alp" );
      ObjSet( "spr_icecreamvendor_light_lamp1", { alp = 1 } );
      private.IcecreamvendorLightLamp1();

    end;
    if cmn.IsEventDone( "win_icecreamvendor" ) then 

      ObjStopAnimate( "spr_icecreamvendor_light_lamp1", "alp" );
      ObjSet( "spr_icecreamvendor_light_lamp1", { alp = 1 } );
      private.IcecreamvendorLightLamp1();
      ObjStopAnimate( "spr_icecreamvendor_light_lamp2", "alp" );
      ObjSet( "spr_icecreamvendor_light_lamp2", { alp = 1 } );
      private.IcecreamvendorLightLamp2();

    end;

  end;
  -------------------------------------------------
  function zz_icecreamvendor.Open()
  
    if ( cmn.IsEventStart( "win_icecreamvendor" ) and not cmn.IsEventDone( "win_icecreamvendor" ) ) then

      cmn.MiniGameShow( "icecreamvendor" );
      common_impl.PassingMgStart( "icecreamvendor" );

    end;

  end;
  -------------------------------------------------
  function zz_icecreamvendor.PreClose()

    if ( cmn.IsEventStart( "win_icecreamvendor" ) and not cmn.IsEventDone( "win_icecreamvendor" ) ) then

      cmn.MiniGameHide( "icecreamvendor" );
      common_impl.PassingMgStop( "icecreamvendor" );

    end;

  end;
  -------------------------------------------------
  function zz_icecreamvendor.Skip ()

    int.Lock( true );
    if ng_global.progress[ "std" ][ "win_icecreamvendor" ].stage == 1 then

      local func_end = function ()
        private.IcecreamvendorLightLamp1 ();
      end;

      ObjAnimate( "spr_icecreamvendor_light_lamp1", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );

      local func_end1 = function ()
        private.IcecreamvendorLightLamp2 ();
      end;

      ObjAnimate( "spr_icecreamvendor_light_lamp2", "alp", 0, 0, func_end1, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );

    else 

      local func_end = function ()
        private.IcecreamvendorLightLamp2 ();
      end;

      ObjAnimate( "spr_icecreamvendor_light_lamp2", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );

    end;
          
    private.WinIcecreamvendor();

  end;
  -------------------------------------------------
  function zz_icecreamvendor.Reset ()

    ObjStopAnimate( "spr_icecreamvendor_light_lamp1", "alp" );
    ObjStopAnimate( "spr_icecreamvendor_light_lamp2", "alp" );
    ObjAnimate( "spr_icecreamvendor_light_lamp1", "alp", 0, 0, "", 
    { 
      0.0, 0, ObjGet( "spr_icecreamvendor_light_lamp1" ).alp,
      0.3, 0, 0,
    } );
    ObjAnimate( "spr_icecreamvendor_light_lamp2", "alp", 0, 0, "", 
    { 
      0.0, 0, ObjGet( "spr_icecreamvendor_light_lamp2" ).alp,
      0.3, 0, 0,
    } );
    ng_global.progress[ "std" ][ "win_icecreamvendor" ].stage = 1;
    private.PlayTune ( 1 );

  end;
  -------------------------------------------------
  function zz_sandbox.Open()

    if ( cmn.IsEventStart( "win_sandbox" ) and not cmn.IsEventDone( "win_sandbox" ) ) then

      cmn.MiniGameShow( "sandbox" );
      common_impl.PassingMgStart( "sandbox" );

    end;

  end;
  -------------------------------------------------
  function zz_sandbox.PreClose()

    if ( cmn.IsEventStart( "win_sandbox" ) and not cmn.IsEventDone( "win_sandbox" ) ) then

      cmn.MiniGameHide( "sandbox" );
      common_impl.PassingMgStop( "sandbox" );

    end;

  end;
  -------------------------------------------------
  function zz_sandbox.Skip ()

    int.Lock( true );
    for i = 1, 6 do

      if ( ng_global.progress[ "std" ][ "win_sandbox" ].position[ i ] ~= i ) then
 
        ObjSet( "spr_sandbox_"..private.name[ i ],
        {
          pos_x = private.place_position[ i ][ 1 ],
          pos_y = private.place_position[ i ][ 2 ]
        } );

      end;

    end;

    private.WinSandbox ();

  end;
  -------------------------------------------------
  function zz_sandbox.Reset ()


    for i = 1, 6 do

      local place = private.old_figure_place [ i ]
      if ( ng_global.progress[ "std" ][ "win_sandbox" ].position[ i ] ~= place ) then
 
        ObjSet( "spr_sandbox_"..private.name[ i ],
        {
          pos_x = private.place_position[ place ][ 1 ],
          pos_y = private.place_position[ place ][ 2 ]
        } );

        ng_global.progress[ "std" ][ "win_sandbox" ].position[ i ] = place;

      end;

    end;

  end;
  -------------------------------------------------
  -------------------------------------------------
  function zz_nanny.Close()

    cmn.NoteScaleEnd( { "spr_nanny_note" }, true );
    cmn.NoteScaleEnd( { "spr_nanny_note2" }, true );

  end;
  -------------------------------------------------
  function zz_basemententrace.Open()

    if ( cmn.IsEventStart( "win_basemententrace" ) and not cmn.IsEventDone( "win_basemententrace" ) ) then

      cmn.MiniGameShow( "basemententrace" );
      common_impl.PassingMgStart( "basemententrace" );

    end;

  end;
  -------------------------------------------------
  function zz_basemententrace.PreOpen()

    if ( cmn.IsEventStart( "win_basemententrace" ) and not cmn.IsEventDone( "win_basemententrace" ) ) then

      if ng_global.progress[ "std" ][ "win_basemententrace" ].win[ 1 ] then

        ObjStopAnimate( "spr_basemententrace_lamp_light1", "alp" );
        ObjStopAnimate( "spr_basemententrace_lamp_reflex_1", "alp" );
        ObjSet( "spr_basemententrace_lamp_light1", { alp = 1 } );
        ObjSet( "spr_basemententrace_lamp_reflex_1", { alp = 1 } );
        private.LightAnim1();

      elseif ng_global.progress[ "std" ][ "win_basemententrace" ].win[ 2 ] then

        ObjStopAnimate( "spr_basemententrace_lamp_light2", "alp" );
        ObjStopAnimate( "spr_basemententrace_lamp_reflex_2", "alp" );
        ObjSet( "spr_basemententrace_lamp_light2", { alp = 1 } );
        ObjSet( "spr_basemententrace_lamp_reflex_2", { alp = 1 } );
        private.LightAnim2();

      end;

    end;

  end;
  -------------------------------------------------
  function zz_basemententrace.PreClose()

    if ( cmn.IsEventStart( "win_basemententrace" ) and not cmn.IsEventDone( "win_basemententrace" ) ) then

      cmn.MiniGameHide( "basemententrace" );
      common_impl.PassingMgStop( "basemententrace" );

    end;

  end;
  -------------------------------------------------
  function zz_basemententrace.Close()

    if cmn.IsEventDone( "win_basemententrace" ) then

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_basemententrance_win" );
      ObjSet( "anm_yard_op_door", { alp = 1 } );
      AnimPlay( "anm_yard_op_door", "DoAnim", 
      function () int.Lock( false );
        ObjSet( "spr_yard_open_door", { alp = 1 } );
        ObjDelete( "anm_yard_op_door" ); 
      end ); 

    end;

  end;
  -------------------------------------------------
  function zz_basemententrace.Skip ()

    int.Lock( true );

    local func_end = function ()

      private.WinBasemententrace();
      cmn.MiniGameHide( "basemententrace" );
      cmn.SetEventDone( "win_basemententrace" );

    end;

    ObjSet( "tmr_basemententrace_mmg", { playing = 1, time = 0.6, endtrig = func_end } ); 

    if not ng_global.progress[ "std" ][ "win_basemententrace" ].win[ 1 ] then
      ObjAnimate( "spr_basemententrace_button_off1", "alp", 0, 0, "", 
      { 
        0.0, 0, 1,
        0.3, 0, 0
      } );
      ObjAnimate( "spr_basemententrace_button_on1", "alp", 0, 0, "", 
      { 
        0.0, 0, 0,
        0.3, 0, 1
      } );
      ObjAnimate( "spr_basemententrace_lamp_light1", "alp", 0, 0, function () private.LightAnim1() end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1
      } );
      ObjAnimate( "spr_basemententrace_lamp_reflex_1", "alp", 0, 0, "", 
      { 
        0.0, 0, 0,
        0.3, 0, 1
      } );
    end;

    if not ng_global.progress[ "std" ][ "win_basemententrace" ].win[ 2 ] then
      ObjAnimate( "spr_basemententrace_button_off2", "alp", 0, 0, "", 
      { 
        0.0, 0, 1,
        0.3, 0, 0
      } );
      ObjAnimate( "spr_basemententrace_button_on2", "alp", 0, 0, "", 
      { 
        0.0, 0, 0,
        0.3, 0, 1
      } );
      ObjAnimate( "spr_basemententrace_lamp_light2", "alp", 0, 0, function () private.LightAnim2() end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1
      } );
      ObjAnimate( "spr_basemententrace_lamp_reflex_2", "alp", 0, 0, "", 
      { 
        0.0, 0, 0,
        0.3, 0, 1
      } );
    end;

  end;
  -------------------------------------------------
  function zz_basemententrace.Reset ()

      for i = 1, 4 do
        ObjSet( "obj_basemententrace_pin"..i, { pos_x = private.old_position[ i ] } );
        ng_global.progress[ "std" ][ "win_basemententrace" ].position[ i ] = private.old_position[ i ];
      end;

      if ng_global.progress[ "std" ][ "win_basemententrace" ].win[ 1 ] then
        ObjSet( "spr_basemententrace_button_off1", { alp = 1 } );
        ObjSet( "spr_basemententrace_button_on1", { alp = 0 } );
        ObjStopAnimate( "spr_basemententrace_lamp_light1", "alp" );
        ObjStopAnimate( "spr_basemententrace_lamp_reflex_1", "alp" );
        ObjSet( "spr_basemententrace_lamp_light1", { alp = 0 } );
        ObjSet( "spr_basemententrace_lamp_reflex_1", { alp = 0 } );
        ng_global.progress[ "std" ][ "win_basemententrace" ].win[ 1 ] = false;
      elseif ng_global.progress[ "std" ][ "win_basemententrace" ].win[ 2 ] then
        ObjSet( "spr_basemententrace_button_off2", { alp = 1 } );
        ObjSet( "spr_basemententrace_button_on2", { alp = 0 } );
        ObjStopAnimate( "spr_basemententrace_lamp_light2", "alp" );
        ObjStopAnimate( "spr_basemententrace_lamp_reflex_2", "alp" );
        ObjSet( "spr_basemententrace_lamp_light2", { alp = 0 } );
        ObjSet( "spr_basemententrace_lamp_reflex_2", { alp = 0 } );
        ng_global.progress[ "std" ][ "win_basemententrace" ].win[ 2 ] = false;
      end;

      private.row = 0;

  end;
  -------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Open ()

  private.opn_yard();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_sandbucket",                    { "use_bucket" } ); 
  int.AddedTaskMap( private.room_objname, "get_brokenbutterfly" ); 
  int.AddedTaskMap( private.room_objname, "get_bell_2",                        { "win_sandbox" } ); 
  int.AddedTaskMap( private.room_objname, "get_switchroomkey",                 { "win_sandbox" } ); 
  int.AddedTaskMap( private.room_objname, "get_newspaper",                     { "use_coins_2" } ); 
  int.AddedTaskMap( private.room_objname, "get_butterflypart_1" ); 
  int.AddedTaskMap( private.room_objname, "get_butterflypart_2" );
  int.AddedTaskMap( private.room_objname, "get_butterflypart_3" ); 
  int.AddedTaskMap( private.room_objname, "get_wrappeditem",                   { "use_coins_2" } );
  int.AddedTaskMap( private.room_objname, "get_tongs",                         { "use_pearl" } ); 
  int.AddedTaskMap( private.room_objname, "get_fork",                          { "use_catamulet" } ); 
  int.AddedTaskMap( private.room_objname, "get_ambereye_2",                    { "win_icecreamvendor" } );
  
  int.AddedTaskMap( private.room_objname, "use_toymushroom",                   { "get_toymushroom" } ); 
  int.AddedTaskMap( private.room_objname, "use_bucket",                        { "get_bucket" } ); 
  int.AddedTaskMap( private.room_objname, "use_sausage",                       { "get_sausage" } );  
  int.AddedTaskMap( private.room_objname, "use_coins_2",                       { "use_sausage" } );
  int.AddedTaskMap( private.room_objname, "use_catamulet",                     { "get_catamulet" } );  
  int.AddedTaskMap( private.room_objname, "use_pearl",                         { "get_pearl" } );   
  int.AddedTaskMap( private.room_objname, "use_doordowel_2",                   { "clk_hook","get_doordowel_2", "get_doordowel_1" } );

  int.AddedTaskMap( private.room_objname, "use_bell_3",                        { "get_bell_3" } );
  int.AddedTaskMap( private.room_objname, "use_bell_1",                        { "get_bell_1" } ); 
  int.AddedTaskMap( private.room_objname, "use_bell_2",                        { "get_bell_2" } );

  int.AddedTaskMap( private.room_objname, "clk_hook",                          { "get_butterflypart_2" } );

  int.AddedTaskMap( private.room_objname, "win_basemententrace",               { "use_doordowel_2" } ); 
  int.AddedTaskMap( private.room_objname, "win_sandbox",                       { "use_toymushroom" } ); 
  int.AddedTaskMap( private.room_objname, "win_icecreamvendor",                { "use_bell_1", "use_bell_2", "use_bell_3" } ); 
  int.AddedTaskMap( private.room_objname, "win_darkness",                      { "get_doordowel_2","get_newspaper", "get_newspaper" } ); 

  int.AddedTaskMap( private.room_objname, "opn_basement",                      { "win_basemententrace" } );   

end;
--*********************************************************************************************************************
function private.InitAnim ()

  ObjAnimate( "spr_postmachine_rose_1", "ang", 1, 0, "",
  { 
    0.0, 3, 0.12, 
    3.0, 3, 0,
    6.0, 3, 0.12,
  } );
  ObjAnimate( "spr_postmachine_rose_2", "ang", 1, 0, "",
  { 
    0.0, 3, -0.14, 
    3.2, 3, 0,
    6.4, 3, -0.14,
  } );
  ObjAnimate( "spr_postmachine_light_add_05", "alp", 1, 0, "",
  { 
    0.0, 3, 1, 
    1.5, 3, 0.5,
    3.0, 3, 1,
  } );
  ObjAnimate( "spr_nanny_tree1", "ang", 1, 0, "",
  { 
    0.0, 3, 0.07, 
    2.0, 3, 0,
    4.0, 3, 0.07,
  } );
  ObjAnimate( "spr_nanny_tree2", "ang", 1, 0, "",
  { 
    0.0, 3, -0.05, 
    2.2, 3, 0,
    4.4, 3, -0.05,
  } );
  ObjAnimate( "spr_nanny_light", "alp", 1, 0, "",
  { 
    0.0, 3, 1, 
    1.5, 3, 0.5,
    3.0, 3, 1,
  } );
  ObjAnimate( "spr_sandbox_light", "alp", 1, 0, "",
  { 
    0.0, 3, 1, 
    1.5, 3, 0.5,
    3.0, 3, 1,
  } );
  ObjAnimate( "spr_icecreamvendor_light", "alp", 1, 0, "",
  { 
    0.0, 3, 1, 
    1.5, 3, 0.5,
    3.0, 3, 1,
  } );
  ObjAnimate( "spr_basemententrace_light_add", "alp", 1, 0, "",
  { 
    0.0, 3, 1, 
    1.5, 3, 0.5,
    3.0, 3, 1,
  } );
  ObjAnimate( "obj_nanny_nanny", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.6,
    2.0, 0, 1,
    3.0, 0, 0.6,
    4.0, 0, 1,
    5.0, 0, 0.6,
    6.0, 0, 1,
    7.0, 0, 0.6,
    8.0, 0, 1,
    8.2, 0, 0.6,
    8.4, 0, 1,
    8.6, 0, 0.6,
    8.8, 0, 1
  } );

  ObjAnimate( "obj_yard_clouds", "pos_x", 1, 0, "", 
  {
    0.0, 0, 0,
    85.0, 0, -864
  } );

  ObjAnimate( "spr_postmachine_shine_add", "alp", 1, 0, "",
  { 
    0.0, 3, 1, 
    2.0, 3, 0,
    4.0, 3, 1,
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG BASEMENTENTRANCE *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.InitBasemententrace ()

    for i = 1, 4 do

      for j = 1, 2 do

        ObjSet( "spr_basemententrace_pin_"..i.."_"..j,
        {
          event_mdown = function ()
    
            private.clk_pin ( i );
    
          end,

          event_menter = function ()
    
            cmn.SetCursor( CURSOR_HAND );
    
          end,

          event_mleave = function ()
    
            private.Leave( i );
    
          end,

        } );

      end;
  
    end;

    ObjSet( "obj_basemententrace_drag", { event_drag = function () private.PinDrag() end, event_dragdrop = function () private.PinDrop() end  } );

    private.link = {
                    { 3, true }, 
                    { 0 }, 
                    { 4, false }, 
                    { 0 } 
                   };--массив связей одних штырей с другими, второй параметр направление движения

    private.old_position = { 56, -38, 56, -38 };
    private.row = 0;
                    
  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.Leave( row )

    cmn.SetCursor( CURSOR_DEFAULT );
    if private.row ~= 0 then--если есть драг какого-то штыря
      if row == private.row then--мы покидаем тот штырь, за который взялись
        private.PinDrop();
      end;
    end;

  end;
  --*********************************************************************************************************************
  function private.clk_pin( row )

    local pos = GetZoomCursorPos();
    private.old_pos_x = pos[ 1 ] - 512;
    private.row = row;
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_basemententrance_click_on" );
    ObjStartDrag( "obj_basemententrace_drag" );

  end;
  --*********************************************************************************************************************
  function private.PinDrag()

    local pos = GetZoomCursorPos();
    local pos_x1 = pos[ 1 ] - 512;

    if ( pos_x1 > - 225 and pos_x1 < 225 ) then--если мы не выходим за края зз

      local row = private.row;
      local old_x_pin = ObjGet( "obj_basemententrace_pin"..row ).pos_x;
      local dx = pos_x1 - private.old_pos_x;
     
      local new_x_pin = old_x_pin + dx;

      if ( new_x_pin > - 127 and new_x_pin < 145 ) then--если новое положение штыря не выходит за границы


        ObjSet( "obj_basemententrace_pin"..row, { pos_x = new_x_pin } );--двигаем текущий штырь

        if private.link[ row ][ 1 ] ~= 0 then--проверка на связь

          private.PinDragLink ( row, dx );

        end;

      end;

    end;

    private.old_pos_x = pos_x1;

  end;
  --*********************************************************************************************************************
  function private.PinDragLink ( row, d )--драг штыря, связанного с текущим

    local link_row = private.link [ row ][ 1 ];
    local old_x_link = ObjGet( "obj_basemententrace_pin"..link_row ).pos_x;

    local new_x_link; 

    if ( private.link [ row ][ 2 ] ) then--направление движения

      new_x_link = old_x_link - d;--то же направление, что и у текущего штыря

    else 

      new_x_link = old_x_link + d;--противоход

    end;

    if ( new_x_link > - 127 and new_x_link < 145 ) then--если новое положение штыря не выходит за границы

      ObjSet( "obj_basemententrace_pin"..link_row, { pos_x = new_x_link } );

    end;

  end;
  --*********************************************************************************************************************
  function private.PinDrop()

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_basemententrance_click_off" );
    local row = private.row;
    local pos_x1 = ObjGet( "obj_basemententrace_pin"..row ).pos_x; 

    if pos_x1 > -54 and pos_x1 < -30 then--если рядом с выигрышной позицией, то выставляем в выигрушную позицию
      pos_x1 = -38;
    elseif pos_x1 > 33 and pos_x1 < 65 then
      pos_x1 = 56;
    end;

    ObjSet( "obj_basemententrace_pin"..row, { pos_x = pos_x1 } );
    ng_global.progress[ "std" ][ "win_basemententrace" ].position[ row ] = pos_x1;

    if private.link[ row ][ 1 ] ~= 0 then--проверка на связь

      local link_row = private.link [ row ][ 1 ];
      local pos_x2 = ObjGet( "obj_basemententrace_pin"..link_row ).pos_x; 

      if pos_x2 > -54 and pos_x2 < -30 then
        pos_x2 = -38;
      elseif pos_x2 > 33 and pos_x2 < 65 then
        pos_x2 = 56;
      end;

      ObjSet( "obj_basemententrace_pin"..link_row, { pos_x = pos_x2 } );
      ng_global.progress[ "std" ][ "win_basemententrace" ].position[ link_row ] = pos_x2;

    end;

    private.row = 0;
    private.BasemententraceWinCheck();

  end;
  --*********************************************************************************************************************
  function private.BasemententraceWinCheck()

----------------------
    if not ng_global.progress[ "std" ][ "win_basemententrace" ].win[ 1 ] then--если левая сторона не горит
      local win = true;
      for i = 1, 4 do
        if ng_global.progress[ "std" ][ "win_basemententrace" ].position[ i ] ~= -38 then
          win = false;
          break;
        end;
      end

      if win then--если правильно выставили левую сторону 

        int.Lock( true );
        ng_global.progress[ "std" ][ "win_basemententrace" ].win[ 1 ] = true;

        if ng_global.progress[ "std" ][ "win_basemententrace" ].win[ 2 ] then

          cmn.MiniGameHide( "basemententrace" );
          cmn.SetEventDone( "win_basemententrace" );
          common_impl.PassingMgWin( "basemententrace" );

        end; 

        local func_end = function ()

          if ng_global.progress[ "std" ][ "win_basemententrace" ].win[ 2 ] then--если до этого была правильно выставлена правая сторона

            private.WinBasemententrace ();

          else 

            int.Lock( false );

          end;

          return true;

        end;

        cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_basemententrance_stick_ok" );
        ObjAnimate( "spr_basemententrace_spring_down1", "alp", 0, 0, "", 
        { 
          0.0, 0, 1,
          0.3, 0, 0,
          1.3, 0, 0,
          1.6, 0, 1
        } );
        ObjAnimate( "spr_basemententrace_spring_up1", "alp", 0, 0, "", 
        { 
          0.0, 0, 0,
          0.3, 0, 1,
          1.3, 0, 1,
          1.6, 0, 0
        } );
        ObjAnimate( "spr_basemententrace_gold_pin1", "pos_y", 0, 0, "", 
        { 
          0.0, 3, 95,
          0.8, 3, -96,
          1.6, 3, 95
        } );
        ObjAnimate( "spr_basemententrace_button_off1", "alp", 0, 0, "", 
        { 
          0.0, 0, 1,
          0.5, 0, 1,
          0.8, 0, 0
        } );
        ObjAnimate( "spr_basemententrace_button_on1", "alp", 0, 0, "", 
        { 
          0.0, 0, 0,
          0.5, 0, 0,
          0.8, 0, 1
        } );
        ObjAnimate( "spr_basemententrace_lamp_light1", "alp", 0, 0, function () private.LightAnim1() end, 
        { 
          0.0, 0, 0,
          0.5, 0, 0,
          0.8, 0, 1
        } );
        ObjAnimate( "spr_basemententrace_lamp_reflex_1", "alp", 0, 0, func_end, 
        { 
          0.0, 0, 0,
          0.5, 0, 0,
          0.8, 0, 1,
        } );

      end;

    end;
--------------------------------

    if not ng_global.progress[ "std" ][ "win_basemententrace" ].win[ 2 ] then--если правая сторона не горит
      local win = true;
      for i = 1, 4 do
        if ng_global.progress[ "std" ][ "win_basemententrace" ].position[ i ] ~= 56 then
          win = false;
          break;
        end;
      end

      if win then--если правильно выставили правую сторону

        int.Lock( true );
        ng_global.progress[ "std" ][ "win_basemententrace" ].win[ 2 ] = true;

        if ng_global.progress[ "std" ][ "win_basemententrace" ].win[ 1 ] then

          cmn.MiniGameHide( "basemententrace" );
          cmn.SetEventDone( "win_basemententrace" );
          common_impl.PassingMgWin( "basemententrace" );

        end; 

        local func_end = function ()

          if ng_global.progress[ "std" ][ "win_basemententrace" ].win[ 1 ] then

            private.WinBasemententrace ();

          else 

            int.Lock( false );

          end;

        end;

        cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_basemententrance_stick_ok" );
        ObjAnimate( "spr_basemententrace_spring_down2", "alp", 0, 0, "", 
        { 
          0.0, 0, 1,
          0.3, 0, 0,
          1.3, 0, 0,
          1.6, 0, 1
        } );
        ObjAnimate( "spr_basemententrace_spring_up2", "alp", 0, 0, "", 
        { 
          0.0, 0, 0,
          0.3, 0, 1,
          1.3, 0, 1,
          1.6, 0, 0
        } );
        ObjAnimate( "spr_basemententrace_gold_pin2", "pos_y", 0, 0, func_end, 
        { 
          0.0, 3, 95,
          0.8, 3, -96,
          1.6, 3, 95
        } );
        ObjAnimate( "spr_basemententrace_button_off2", "alp", 0, 0, "", 
        { 
          0.0, 0, 1,
          0.5, 0, 1,
          0.8, 0, 0
        } );
        ObjAnimate( "spr_basemententrace_button_on2", "alp", 0, 0, "", 
        { 
          0.0, 0, 0,
          0.5, 0, 0,
          0.8, 0, 1
        } );
        ObjAnimate( "spr_basemententrace_lamp_light2", "alp", 0, 0, function () private.LightAnim2() end, 
        { 
          0.0, 0, 0,
          0.5, 0, 0,
          0.8, 0, 1
        } );
        ObjAnimate( "spr_basemententrace_lamp_reflex_2", "alp", 0, 0, func_end, 
        { 
          0.0, 0, 0,
          0.5, 0, 0,
          0.8, 0, 1
        } );

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.WinBasemententrace ()

    local func_end = function ()

      int.Lock( false );
      cmn.CloseSubRoom();
      --common_impl.PassingMgWin( "basemententrace" );
      cmn.CallEventHandler( "win_basemententrace" );
      cmn.CallEventHandler( "win_basemententrace_inv" );

    end;

    ObjSet( "tmr_basemententrace_mmg", { playing = 1, time = 0.9, endtrig = func_end } ); 

  end;
  --*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG SANDBOX *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.InitSandbox ()

    private.name = { "gnome", "gnome1", "gnome2", "horns", "sail", "sun" };

    private.place_position = {
                              { -6, -57 }, 
                              { 70, 1 },
                              { 12, 53 },
                              { 210, 27 },
                              { -93, -2 },
                              { 70, -121 }        
                             };

    private.old_figure_place = { 3, 6, 5, 2, 1, 4 };--в скобках места, где располагаются номера фигур

    for i = 1, 6 do
   
      local place = private.old_figure_place[ i ];      

      ObjSet( "spr_sandbox_"..private.name[ i ],
      {
        event_mdown = function ()
  
          private.ClkFigure ( private.name[ i ] );
  
        end,

        event_dragdrop = function ()
  
          private.DropFigure ( i, private.name[ i ] );
  
        end,

        event_menter = function ()
  
          cmn.SetCursor( CURSOR_HAND );
  
        end,

        event_mleave = function ()
  
          cmn.SetCursor( CURSOR_DEFAULT );
  
        end,

        pos_x = private.place_position[ place ][ 1 ],

        pos_y = private.place_position[ place ][ 2 ]

      } );

    end;
                    
  end;
  --*********************************************************************************************************************
  function private.ClkFigure (name)

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_sandbox_take" );
    ObjSet( "spr_sandbox_"..name, { pos_z = 5 } );

  end;
  --*********************************************************************************************************************
  function private.DropFigure ( id, name )

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_sandbox_place" );
    local id = tonumber( id );--номер взятой фигруы
    local item = "obj_sandbox_"..name.."_tmp"; 
    local place = ng_global.progress[ "std" ][ "win_sandbox" ].position[ id ];--место, где находится взятая фигура
    local move = false;

    for i = 1, 6 do--i --место фигруры, с которой произошло пересечение

      if ( cmn.ApplyObj( item, "obj_sandbox_place"..i, true ) and i ~= place ) then

        for j = 1, 6 do--j --номер фигуры, с которой произошло пересечение

          if ng_global.progress[ "std" ][ "win_sandbox" ].position[ j ] == i then

            local cross_name = private.name[ j ];--имя фигуры, с которой произошло пересечение
            ObjSet( "spr_sandbox_"..name, { pos_x = private.place_position[ i ][ 1 ], pos_y = private.place_position[ i ][ 2 ] } );
            move = true;

            local func_end = function ()

              ObjSet( "spr_sandbox_"..name, { pos_z = 0 } );
              ng_global.progress[ "std" ][ "win_sandbox" ].position[ id ] = i;
              ng_global.progress[ "std" ][ "win_sandbox" ].position[ j ] = place;
              private.SandboxWinCheck();

            end;

            int.Lock( true );
            ObjAnimate( "spr_sandbox_"..cross_name, "pos_xy", 0, 0, func_end, 
            { 
              0.0, 3, ObjGet( "spr_sandbox_"..cross_name ).pos_x, ObjGet( "spr_sandbox_"..cross_name ).pos_y,
              0.3, 3, private.place_position[ place ][ 1 ], private.place_position[ place ][ 2 ]
            } );
            break;

          end;

        end; 

        break;

      end;

    end;

    if not move then--если никакого перемещения не произошло
      ObjSet( "spr_sandbox_"..name, { pos_z = 0 } );
    end;

  end;
  --*********************************************************************************************************************
  function private.SandboxWinCheck()

    local win = true;

    for i = 1, 6 do
      if ng_global.progress[ "std" ][ "win_sandbox" ].position[ i ] ~= i then
        win = false;
        break;
      end; 
    end;

    if win then
      private.WinSandbox();
    else 
      int.Lock( false );
    end;

  end
  --*********************************************************************************************************************
  function private.WinSandbox()
    
    common_impl.PassingMgWin( "sandbox" );
    cmn.MiniGameHide( "sandbox" );
    cmn.SetEventDone( "win_sandbox" );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_sandbox_win" );
    ObjAnimate( "obj_sandbox_wins1", "pos_y", 0, 0, function () private.WinSandboxEnd () end, 
    { 
      0.0, 3, 78,
      0.6, 3, 0,
    } );

  end;
  --*********************************************************************************************************************
  function private.WinSandboxEnd ()

    int.Lock( false );

    --common_impl.PassingMgWin( "sandbox" );

    cmn.CallEventHandler( "win_sandbox" );
    cmn.CallEventHandler( "win_sandbox_inv" );

  end;
  --********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG ICECREAMVENDOR *** () end;
--*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.InitIcecreamvendor ()

    private.tune = {
                     { 2, 3, 5 },
                     { 3, 4, 5, 1, 2 }
                   };

    for i = 1, 5 do
   
      ObjSet( "spr_icecreamvendor_button_"..i,
      {
        event_mdown = function ()

          private.ClkNote ( i );

        end,

        event_menter = function ()

          cmn.SetCursor( CURSOR_HAND );

        end,

        event_mleave = function ()

          cmn.SetCursor( CURSOR_DEFAULT );

        end,

      } );

    end;

  end;
  --*********************************************************************************************************************
  function private.ClkNote ( id )

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_icecreamvendor_note"..id );
    local func_end = function ()

      local stage = ng_global.progress[ "std" ][ "win_icecreamvendor" ].stage;
      local count = ng_global.progress[ "std" ][ "win_icecreamvendor" ].count;
      
      if id == private.tune[ stage ][ count + 1 ] then--правильно нажали ноту

        ng_global.progress[ "std" ][ "win_icecreamvendor" ].count = ng_global.progress[ "std" ][ "win_icecreamvendor" ].count + 1;

        if ng_global.progress[ "std" ][ "win_icecreamvendor" ].count == #private.tune[ stage ] then--если мы верно сыграли мелодию

          if stage == 1 then

            ng_global.progress[ "std" ][ "win_icecreamvendor" ].stage = 2;
            private.PlayTune ( 2 );

            local func_end = function ()
              private.IcecreamvendorLightLamp1 ();
            end;

            ObjAnimate( "spr_icecreamvendor_light_lamp1", "alp", 0, 0, func_end, 
            { 
              0.0, 0, 0,
              0.3, 0, 1,
            } );

          else 

            private.WinIcecreamvendor ();
            local func_end = function ()
              private.IcecreamvendorLightLamp2 ();
            end;

            ObjAnimate( "spr_icecreamvendor_light_lamp2", "alp", 0, 0, func_end, 
            { 
              0.0, 0, 0,
              0.3, 0, 1,
            } );
            
          end;

        else 

          int.Lock( false );

        end;

      else--если неправильно нажали ноту 
        
        private.PlayTune ( stage );

      end;

    end;

    ObjAnimate( "spr_icecreamvendor_button_light"..id, "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.05, 0, 1,
      0.45, 0, 1,
      0.5, 0, 0
    } );

  end;
  --*********************************************************************************************************************
  function private.PlayTune ( stage )

    int.Lock( true );
    ng_global.progress[ "std" ][ "win_icecreamvendor" ].count = 0;

    local func_end = function ()

      if stage == 1 then
        private.PlayTune1 ( 1, 1 );
      else
        private.PlayTune1 ( 2, 1 );
      end;

    end;

    ObjSet( "tmr_icecreamvendor_mmg", { playing = 1, time = 0.5, endtrig = func_end } ); 

  end;
  --*********************************************************************************************************************
  function private.PlayTune1 ( stage, n )--играем мелодию

    if n > #private.tune[ stage ] then

      int.Lock( false );
      return true;

    end;

    local id = private.tune[ stage ][ n ];
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_icecreamvendor_note"..id );
    ObjAnimate( "spr_icecreamvendor_button_light"..id, "alp", 0, 0, function() private.PlayTune1 ( stage, n + 1 ) end, 
    { 
      0.0, 0, 0,
      0.05, 0, 1,
      0.45, 0, 1,
      0.5, 0, 0,
    } );

  end;
  --*********************************************************************************************************************
  function private.WinIcecreamvendor ()
    
    common_impl.PassingMgWin( "icecreamvendor" );
    cmn.MiniGameHide( "icecreamvendor" );
    cmn.SetEventDone( "win_icecreamvendor" );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_icecream_bus_door" );
    ObjAnimate( "spr_icecreamvendor_door_shadow", "alp", 0, 0, "", 
    { 
      0.0, 0, 1,
      0.4, 0, 0,
    } );
    ObjAnimate( "spr_icecreamvendor_door", "pos_x", 0, 0, function () private.WinIcecreamvendorEnd () end, 
    { 
      0.0, 3, -95,
      0.8, 3, -217,
    } );

  end;
  --*********************************************************************************************************************
  function private.WinIcecreamvendorEnd ()

    int.Lock( false );

    --common_impl.PassingMgWin( "icecreamvendor" );

    cmn.CallEventHandler( "win_icecreamvendor" );
    cmn.CallEventHandler( "win_icecreamvendor_inv" );

  end;
--********************************************************************************************************************
function private.IcecreamvendorLightLamp1 ()

  ObjAnimate( "spr_icecreamvendor_light_lamp1", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.5,
    2.0, 0, 1,
  } );

end;
--*********************************************************************************************************************
function private.IcecreamvendorLightLamp2 ()

  ObjAnimate( "spr_icecreamvendor_light_lamp2", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.5,
    2.0, 0, 1,
  } );

end;
--*********************************************************************************************************************
function private.LightAnim1 ()

  ObjAnimate( "spr_basemententrace_lamp_light1", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.5,
    2.0, 0, 1,
  } );
  ObjAnimate( "spr_basemententrace_lamp_reflex_1", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.5,
    2.0, 0, 1,
  } );

end;
--*********************************************************************************************************************
function private.LightAnim2 ()

  ObjAnimate( "spr_basemententrace_lamp_light2", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.5,
    2.0, 0, 1,
  } );
  ObjAnimate( "spr_basemententrace_lamp_reflex_2", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.5,
    2.0, 0, 1,
  } );

end;
--*********************************************************************************************************************
function private.ClkPostmachineDoor ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_postmachine_use_coins_2" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_newspaper_robot_touch" );
  ObjAnimate( "spr_postmachine_note", "pos_x", 0, 0, "", 
  { 
    0.0, 3, -66,
    0.3, 3, -67,
    0.6, 3, -66,
  } );
  ObjAnimate( "anm_postmachine_use_coins", "pos_x", 0, 0, func_end, 
  { 
    0.0, 3, -200,
    0.3, 3, -201,
    0.6, 3, -200
  } );
  ObjAnimate( "obj_postmachine_butterflypart", "pos_x", 0, 0, func_end, 
  { 
    0.0, 3, 0,
    0.3, 3, -1,
    0.6, 3, 0
  } );

end;
--*********************************************************************************************************************
function private.ClkBook ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_sandbox_use_toymushroom" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mushroom_touch" );
  ObjAnimate( "spr_sandbox_close", "ang", 0, 0, func_end, 
  { 
    0.0, 3, 0,
    0.3, 3, 0.01,
    0.6, 3, 0,
  } );

end;
--*********************************************************************************************************************
function private.ClkBox ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_nanny_use_catamulet" );
    int.Lock( false );

  end;

  int.Lock( true );

  ObjAnimate( "spr_nanny_cup_up", "pos_y", 0, 0, func_end, 
  { 
    0.0, 3, 71,
    0.2, 3, 70,
    0.4, 3, 71,
    0.6, 3, 70,
    0.8, 3, 71
  } );

end;
--*********************************************************************************************************************
function private.StartPlaneAnim()

  local func_end = function ()

    ObjSet( "tmr_yard_palne", { playing = true, time = 20, endtrig = private.StartPlaneAnim } );

  end;

  AnimPlay( "anm_yard_plane", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.FlowerClk()

  local func_end = function ()

    ObjSet( "anm_icecreamvendor_flower", { alp = 1 } );
    AnimPlay( "anm_icecreamvendor_flower", "DoAnim", "" ) 
    ObjSet( "anm_icecreamvendor_flower_click", { alp = 0 } );
    int.Lock( false );

  end;

  int.Lock( true);

  ObjSet( "anm_icecreamvendor_flower", { alp = 0 } );
  AnimStop( "anm_icecreamvendor_flower" ) 
  ObjSet( "anm_icecreamvendor_flower_click", { alp = 1 } );

  AnimPlay( "anm_icecreamvendor_flower_click", "DoAnim", func_end ) 

end;
--*********************************************************************************************************************
function private.CatClk()

  local func_end = function ()

    ObjSet( "anm_postmachine_cat_static", { alp = 1 } );
    AnimPlay( "anm_postmachine_cat_static", "DoAnim", "" ) 
    ObjSet( "anm_postmachine_cat_click", { alp = 0 } );
    int.Lock( false );
    cmn.ShowBbt( "bbt_postmachine_use_sausage" );

  end;

  int.Lock( true);

  ObjSet( "anm_postmachine_cat_static", { alp = 0 } );
  AnimStop( "anm_postmachine_cat_static" ) 
  ObjSet( "anm_postmachine_cat_click", { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_angry_cat" );
  AnimPlay( "anm_postmachine_cat_click", "DoAnim", func_end ) 

end;
--*********************************************************************************************************************
function private.SwingClk()

  local func_end = function ()
    int.Lock( false );
  end;

  int.Lock( true);
  AnimPlay( "anm_yard_swing", "DoAnim", func_end );
 
end;
--*********************************************************************************************************************
function private.NoteBbt()

  local count = 0;
  for i = 1, 3 do
    if cmn.IsEventDone( "use_bell_"..i ) then
      count = count + 1;
    end;
  end;

  cmn.ShowBbt( "bbt_icecreamvendor_use_bell_"..count );

end;
--*********************************************************************************************************************