-- name=ho_crashreport
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------

  room.Define( "ho_crashreport" );

  private.room_objname = "ho_crashreport";
  game.relations[ private.room_objname ].exitroom = "rm_policestation3";

  private.win_crashreport = {};

  private.InitAnim();
  private.win_crashreport.time = { 9, 4.5, 9, 4.5, 5.5, 12, 13, 7.5, 6, 8, 8, 9 };
  --------------------------------------------------------------------------------------------
  -- function opn_crashreport () end;
  --------------------------------------------------------------------------------------------
  local opn_crashreport = function ()

  end;

  cmn.AddSubscriber( "opn_crashreport", opn_crashreport, private.room_objname );
  --------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_crashreport" ] =
  {
    type    = "get",
    get_obj = "spr_crashreport_win",
    room    = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_crashreport_func = function ()

    if ( cmn.IsEventDone( "win_crashreport" ) ) then

        --int.InventoryItemAdd( "inv_apartment_planning", "spr_crashreport_win" );
        ObjDelete( "gho_policestation3_crashreport" );
        ObjDelete( "obj_crashreport_taskpanel" );
        --ObjDelete( "anm_policestation2_policeman1" );     
        --ObjSet( "anm_policestation2_policeman2", { alp = 1 } );
        --ObjSet( "obj_policestation2_clk_past_transfer", { input = true} );
        --int.DeleteTaskMap( "rm_policestation", "win_crashreport" );
        --ObjSet( "rm_policestation2", { color_r = 0, color_g = 0, color_b = 0 } );
        ObjSet( "int_button_map_impl",
        {
          alp = 1,
          input = true,
          visible = true,
          active = true
        } );   

    end;
 
  end;
  cmn.AddSubscriber( "win_crashreport", win_crashreport_func );
  --------------------------------------------------------------------------------------------------
  local start_crashreport_func = function ()

    if ( cmn.IsEventStart( "win_crashreport" ) ) then

        common_impl.ProcessHoStart( "crashreport" );

        local ho_found = ng_global.progress[ "std" ][ "win_crashreport" ].found;

        for i = 1, #ho_found, 1 do

            ObjDelete( ho_found[ i ][ "object" ] );

        end;

        for i = 1,3 do

          local idx = ng_global.progress["std"]["win_crashreport"].note[ i ][ 1 ];

          if ( ng_global.progress["std"]["win_crashreport"].note[ i ][ 2 ] ) then

            ObjSet( "spr_crashreport_"..i.."check", { alp = 1 } );

          end;

        end;

    end;

  end;
  cmn.AddSubscriber( "win_crashreport", start_crashreport_func, "ho_crashreport" );
  --------------------------------------------------------------------------------------------------

  private.win_crashreport.task = { "april", "plane", "taxi", "key", "clock", "wings", "suitcase", "money", "case_file", "court", "photo", "plan" };

  for i = 1, #private.win_crashreport.task do

    ObjSet( "spr_crashreport_"..private.win_crashreport.task[ i ], { input = false, event_mdown = function () private.CompleteTask( private.win_crashreport.task[ i ] ); end } );

  end;
  --------------------------------------------------------------------------------------------------  
end;
--*********************************************************************************************************************
function public.Load ()


end;
--*********************************************************************************************************************
function public.PreOpen ()


  cmn.InterfaceSetVisible( true );
  --int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventDone( "opn_crashreport" ) ) then

    cmn.SetEventDone( "opn_crashreport" );
    cmn.CallEventHandler( "opn_crashreport" );

    ng_global.progress[ "std" ][ "win_crashreport" ].number = 1;
    ng_global.progress[ "std" ][ "win_crashreport" ].note = { { 5, false }, { 8, false }, { 12, false } };
    --cmn.TutorialShow( "tutorial_page_10" );
    --cmn.TutorialSetShown( "tutorial_page_10" );

  end;

  private.TaskStart();

  local ho_tasks = {};

  interface.TaskPanelTaskAdd( ho_tasks, "april",     1, 0, { { "spr_crashreport_april"        } } );
  interface.TaskPanelTaskAdd( ho_tasks, "plane",     1, 0, { { "spr_crashreport_plane"    } } );
  interface.TaskPanelTaskAdd( ho_tasks, "taxi",      1, 0, { { "spr_crashreport_taxi"   } } );
  interface.TaskPanelTaskAdd( ho_tasks, "key",       1, 0, { { "spr_crashreport_key"       } } );
  interface.TaskPanelTaskAdd( ho_tasks, "clock",     1, 0, { { "spr_crashreport_clock"     } } );
  interface.TaskPanelTaskAdd( ho_tasks, "wings",     1, 0, { { "spr_crashreport_wings"      } } );
  interface.TaskPanelTaskAdd( ho_tasks, "suitcase",  1, 0, { { "spr_crashreport_suitcase"       } } );
  interface.TaskPanelTaskAdd( ho_tasks, "money",     1, 0, { { "spr_crashreport_money"         } } );
  interface.TaskPanelTaskAdd( ho_tasks, "case_file", 1, 0, { { "spr_crashreport_case_file"       } } );
  interface.TaskPanelTaskAdd( ho_tasks, "court",     1, 0, { { "spr_crashreport_court"        } } );
  interface.TaskPanelTaskAdd( ho_tasks, "photo",     1, 0, { { "spr_crashreport_photo" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "plan",      1, 0, { { "spr_crashreport_plan"    } } );


  if ( not cmn.IsEventStart( "win_crashreport" ) ) then

      cmn.InitHo( "crashreport" );

  end;

  int.TaskPanelShow( ho_tasks );
  private.Panel();

  common_impl.StopMusEnv( false );

  --cmn.StopAllEnv( "audio/level3/env/aud_policestation_env" );

  --cmn.PlayAudio( "env", "audio/level3/env/aud_policestation_env", 1 );

  --cmn.PlayAudio( "env", "audio/level1/env/aud_ho_theme_mus_env", 1 );

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();
  private.TimerStart();

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();
  --cmn.StopAudio( "env", "audio/level1/env/aud_ho_theme_mus_env", 0.3 );
  cmn.StopAllVoc();

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();
  ObjSet( "int_inventory_impl", { input = true } );
--  if ( cmn.IsEventDone( "win_crashreport" ) ) then
--  end;
--
end;
--*********************************************************************************************************************
function public.HoComplete ()

  --common_impl.PassingHoWin();

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )

  local postfix = "";

  if ( number ) then

     postfix = "_1"

  end;

  cmn.HoTaskFind( "spr_crashreport_"..name..postfix, name..postfix );
  common_impl.PassingHoCheck();
  private.CheckDone();
  if ( ng_global.progress["std"]["win_crashreport"].number ~= 12) then

    ng_global.progress["std"]["win_crashreport"].number = ng_global.progress["std"]["win_crashreport"].number + 1;
    private.Task();

  end;

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );
  ObjAttach( "obj_crashreport_taskpanel" , "int_taskpanel_impl" );

end;
--*********************************************************************************************************************
function private.TaskStart()

  local number = ng_global.progress[ "std" ][ "win_crashreport" ].number;
  ObjSet( "txt_crashreport_taskpanel", { alp = 1, text = "tsk_crashreport_"..private.win_crashreport.task[ number ] } );
  ObjSet( "spr_crashreport_"..private.win_crashreport.task[ number ], { input = true } );

end;
--*********************************************************************************************************************
function private.Task ()
  
  local func_end = function ()

    local number = ng_global.progress["std"]["win_crashreport"].number;
    ObjSet( "txt_crashreport_taskpanel", { text = "tsk_crashreport_"..private.win_crashreport.task[ number ] } );
    ObjSet( "spr_crashreport_"..private.win_crashreport.task[ number ], { input = true } );

  end;

  local func_end2 = function ()

    int.Lock( false );

  end;

  int.Lock( true );

  ObjAnimate( "txt_crashreport_taskpanel", "alp", 0, 0, func_end2,
  { 
    0.0, 0, 1, 
    0.3, 0, 0,
    0.4, 0, 0,
    0.7, 0, 1

  } );

  ObjAnimate( "ho_crashreport", "alp", 0, 0, func_end,
  { 
    0.0, 0, 1, 
    0.3, 0, 1
  } );

  private.TimerDone();
  private.TimerStart();

end;
--*********************************************************************************************************************
function private.TimerStart ()

  local number = ng_global.progress[ "std" ][ "win_crashreport" ].number;

  ObjSet( "tmr_crashreport_voice", 
    { 
    playing = true, 
    time = private.win_crashreport.time[ number ],
    endtrig = private.TimerDone
    } );

  cmn.StopAllVoc();
  cmn.PlayAudio( "voc", "audio/level3/voc/aud_jackie_dict_"..number.."_voc", 0 ); 

  ObjSet( "obj_crashreport_button", { input = false } );
  ObjSet( "anm_crashreport_recorder", { active = true } );
  ObjAnimate( "spr_crashreport_play2", "alp", 0, 0, "",
  { 
    0.0, 0, ObjGet( "spr_crashreport_play2" ).alp, 
    0.3, 0, 1
  } );

end;
--*********************************************************************************************************************
function private.TimerDone ()

  local func_end = function ()

    private.TimerStart();
    cmn.PlayAudio( "env", "audio/level1/env/aud_investigatorsdesk_in", 0 );
 
  end;

  local number = ng_global.progress[ "std" ][ "win_crashreport" ].number;

  cmn.StopAllVoc();
  cmn.PlayAudio( "env", "audio/level1/env/aud_investigatorsdesk_in", 0 );
  ObjSet( "obj_crashreport_button", { input = true, event_mdown = func_end } );
  ObjSet( "anm_crashreport_recorder", { active = false } );
  ObjAnimate( "spr_crashreport_play2", "alp", 0, 0, "",
  { 
    0.0, 0, ObjGet( "spr_crashreport_play2" ).alp, 
    0.3, 0, 0
  } );

end;

--*********************************************************************************************************************
function private.CheckDone ()

  local number = ng_global.progress["std"]["win_crashreport"].number;

  for i = 1,3 do

    local idx = ng_global.progress["std"]["win_crashreport"].note[ i ][ 1 ];

    if ( number == idx ) and not ( ng_global.progress["std"]["win_crashreport"].note[ i ][ 2 ] ) then

      ng_global.progress["std"]["win_crashreport"].note[ i ][ 2 ] = true;
      ObjAnimate( "spr_crashreport_"..i.."check", "alp", 0, 0, "",
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      } );

      AnimPlay( "anm_crashreport_sighnfx_"..i, "DoAnim", "" );

    end;


  end;

end;
--*********************************************************************************************************************
function private.InitAnim ()

  ObjAnimate( "spr_crashreport_light", "alp", 1, 0, "",
  { 
    0.0, 0, 1, 
    2, 0, 0.1,
    4, 0, 1 
  } );

end;