-- name=ho_serverroom
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_serverroom" );

  private.room_objname = "ho_serverroom";
  game.relations[ private.room_objname ].exitroom = "rm_controltower";
  private.InitAnim();

  private.win_serverroom = {};

  private.win_serverroom.task = { "pc_mouse", "scotch_tape", "suitcase", "paper", "keyboard", "tea_bag", "folder", "glasses", "microphone", "screw_nut", "backpack", "disk" };
  private.win_serverroom.task_text = { "pc_mouse", "suitcase", "keyboard", "folder", "microphone", "backpack" };

  common_impl.hint[ "win_serverroom" ] =
  {
    type = "get",
    get_obj = "spr_serverroom_win",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_serverroom_func = function ()

    if ( cmn.IsEventDone( "win_serverroom" ) ) then

      int.InventoryItemAdd( "inv_oldbackpack", "spr_serverroom_win" );
      ObjDelete( "gho_controltower_serverroom" );
      ObjSet( "inv_oldbackpack", { drag = false } );

    end;

  end;
  cmn.AddSubscriber( "win_serverroom", win_serverroom_func );
  --------------------------------------------------------------------------------------------------
  local start_serverroom_func = function ()

    local ho_found = ng_global.progress[ "std" ][ "win_serverroom" ].found;
    local ho_idx   = ng_global.progress[ "std" ][ "win_serverroom" ].stage;

    for i = 1, ( ng_global.progress[ "std" ][ "win_serverroom" ].stage - 1 ) do

      ObjSet( "spr_serverroom_light_add_"..i, { alp = 1 } );

    end;

    for i = 1, #ho_found do

      local name = common.GetObjectName( ho_found[ i ].item );
      local flag = false;

      ObjDelete( "spr_"..name );
      ObjDelete( "obj_"..name );
      ObjDelete( "spr_serverroom_"..private.win_serverroom.task[ ho_idx - 1 ] );

      for j = 1, 6 do

        if ( private.win_serverroom.task[ ho_idx - 1 ] == private.win_serverroom.task_text[ i ] ) then

          flag = true;

        end;

      end;
 
      if ( flag ) then

        ObjDelete( "spr_serverroom_"..private.win_serverroom.task[ ho_idx ] );

      end;

    end;

    if ( cmn.IsEventDone( "win_serverroom" ) ) then

      common_impl.ProcessHoStart( "serverroom" );

    end;

  end;
  cmn.AddSubscriber( "win_serverroom", start_serverroom_func, "ho_serverroom" );
  --------------------------------------------------------------------------------------------------
  for i = 1, #private.win_serverroom.task do

    ObjSet( "itm_serverroom"..private.win_serverroom.task[ i ], { input = false } );
    ObjSet( "obj_serverroom_"..private.win_serverroom.task[ i ], { input = false } );

  end;

  for i = 1, #private.win_serverroom.task_text do

    ObjSet( "spr_serverroom_"..private.win_serverroom.task_text[ i ], { event_mdown = function () private.CompleteTask( private.win_serverroom.task_text[ i ] ); end } );

  end;

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function public.PreOpen ()
  
  cmn.StopAllEnv( "audio/level3/env/aud_serverroom_env", true );
  cmn.PlayAudio( "env", "audio/level3/env/aud_serverroom_env", 1 );
  
  cmn.InterfaceSetVisible( true );
  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventDone( "opn_serverroom" ) ) then

      cmn.SetEventDone( "opn_serverroom" );
      cmn.CallEventHandler( "opn_serverroom" );
      ng_global.progress[ "std" ][ "win_serverroom" ].stage = 1;
      
      cmn.TutorialShow( "tutorial_page_30" );
      cmn.TutorialSetShown( "tutorial_page_30" );
      
  end;

  local ho_tasks = {};

  if ( not cmn.IsEventStart( "win_serverroom" ) ) then

    cmn.InitHo( "serverroom" );

  end;

  for i = 1, #private.win_serverroom.task do

      interface.ItemPanelItemAdd( ho_tasks, private.win_serverroom.task[ i ] );

  end;

  private.Panel();
  int.ItemPanelShow( ho_tasks );
  private.Sorting();
  private.Active();

  common_impl.StopMusEnv( false );

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.ItemPanelHide();
  interface.TutorialHide();
  
end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();
  ObjSet( "int_inventory_impl", { input = true, alp = 1 } );
  ObjSet( "spr_int_itempanel", { alp = 1 } );

end;
--*********************************************************************************************************************
function public.HoComplete ()

end;
--*********************************************************************************************************************
function private.CompleteTask ( name )
  
  cmn.PlayAudio( "sfx", "audio/aud_hide_sfx" );
 
  local flag = false;

  for i = 1, #private.win_serverroom.task_text do

      if ( name == private.win_serverroom.task_text[ i ] ) then
     
        flag = true;
        break;

      end;

  end;

  private.Sorting();

  if ( flag ) then

      int.Lock( true );

      local func_end = function()

          ObjDelete( "spr_serverroom_"..name );
          private.GetItem();
          private.Stage();
          
      end;

      ObjAnimate( "spr_serverroom_"..name, "alp", 0, 0, func_end,
      { 
        0.0, 0, 1, 
        1.0, 0, 0 
      } );

      ObjAnimate( "anm_serverroom_obj_fx", "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "anm_serverroom_obj_fx" ).alp, 
        0.3, 0, 0.0 
      } );

      private.PFX( name, name );

  else 

      local func_end = function()

          ObjDelete( "obj_serverroom_"..name );
          private.Active();

      end;

      ObjAnimate( "spr_serverroom_"..name.."_2", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1, 
        0.3, 0, 0 
      } );

  end;
   
  common_impl.PassingHoCheck();
   
end;
--*********************************************************************************************************************
function private.GetItem()      

    local idx = ng_global.progress[ "std" ][ "win_serverroom" ].stage;
    
    local func_end = function()

      --private.HoItemFindClick( "itm_serverroom_"..private.win_serverroom.task[ idx ] );
      private.Active();

    end;

    private.HoItemFindClick( "itm_serverroom_"..private.win_serverroom.task[ idx ] );
    ObjAnimate( "spr_serverroom_"..private.win_serverroom.task[ idx+1 ], "alp", 0, 0, func_end, 
    { 
      0.0,  0,  1,
      0.8,  0,  0
    } ); 

    ObjAttach( "spr_serverroom_"..private.win_serverroom.task[ idx+1 ], "obj_serverroom_panel" );  
    ObjSet( "spr_serverroom_"..private.win_serverroom.task[ idx+1 ], { pos_z = 5 });
    private.FlyPFX( private.win_serverroom.task[ idx+1 ] );
    ObjAnimate( "spr_serverroom_"..private.win_serverroom.task[ idx+1 ], "pos_xy", 0, 0, "", 
    { 
      0.0,  0,  ObjGet( "spr_serverroom_"..private.win_serverroom.task[ idx+1 ] ).pos_x-512, ObjGet( "spr_serverroom_"..private.win_serverroom.task[ idx+1 ] ).pos_y-715,
      0.8,  0,  0, 0 
    } ); 

    ObjAnimate( "anm_fly_"..private.win_serverroom.task[ idx+1 ], "alp", 0, 0, "", 
    { 
      0.0,   0,  1,
      0.85,  0,  1,
      1.0,   0,  0
    } ); 

end;
--*********************************************************************************************************************
function private.UseItem ( name )

  local item = "itm_serverroom_"..name;

  if ( cmn.ApplyObj( item, "obj_serverroom_"..name ) ) then

    int.Lock( true );

    local func_end = function()

      private.CompleteTask( name );

    end;

    local func_end2 = function()

      private.PFX( name, name.."_2" );

    end;

    --cmn.PlayAudio( "sfx", "audio/aud_hide_sfx" );
    ObjSet( "itm_serverroom_"..name, { alp = 0 } );
    cmn.HoItemFind( "itm_serverroom_"..name );
    private.Stage();

    ObjAnimate( "spr_serverroom_"..name.."_1", "alp", 0, 0, func_end, 
    { 
      0.0,  0,  1,
      0.3,  0,  1,
      0.4,  0,  0,
      0.7,  0,  0
    } ); 

    ObjAnimate( "spr_serverroom_"..name.."_2", "alp", 0, 0, func_end2, 
    { 
      0.0,  0,  0,
      0.3,  0,  1
    } ); 

  else 

    ObjAnimate( "anm_serverroom_obj_fx", "alp", 0, 0, "",
    { 
      0.0, 0, 0, 
      0.3, 0, 0.5 
    } );

  end;
  
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "int_inventory_impl", { input = false } );

  for i = 1, #private.win_serverroom.task do

      local obj_name = "itm_serverroom_"..private.win_serverroom.task[ i ];
      local sub_name = "obj_serverroom_item";
      ObjCreate( obj_name, "spr" );
      ObjAttach( obj_name, sub_name );  
      ObjSet( obj_name, 
          { 
          event_mdown     = function () private.GetObj(); end,
          res             = "assets/levels/level3/ho_serverroom/layers/inv/"..private.win_serverroom.task[ i ].."_inv",
          inputrect_init  = true,
          inputrect_x     = -50,
          inputrect_y     = -50,
          inputrect_w     = 100,
          inputrect_h     = 100,
          event_dragdrop  = function () private.UseItem( private.win_serverroom.task[ i ] ); end,
          event_menter    = function () port.ShowPopUpHO( "pop_serverroom_"..private.win_serverroom.task[ i ] ); end,
            --event_mleave    = interface.PopupHide,
          event_startdrag = function () cmn.HoItemOff( "itm_serverroom_"..private.win_serverroom.task[ i ] ); end
          });

  end;

 for i = 1, #private.win_serverroom.task_text do

      local obj_name = "itm_serverroom_"..private.win_serverroom.task_text[ i ];
      ObjSet( obj_name, 
          { 
          res             = "",
          });

 end;

end;
--*********************************************************************************************************************
function private.Sorting ()

  ObjSet( "spr_int_itempanel", { alp = 0, input = false } );
  ObjSet( "txt_serverroom_panel_task", { alp = 0 } );

  for i = 1, #private.win_serverroom.task do
      
      local obj_name = "hub_int_itempanel_serverroom_"..private.win_serverroom.task[ i ];

        for j = 1, #private.win_serverroom.task_text do

          if ( private.win_serverroom.task[ i ] ~= private.win_serverroom.task_text[ j ] ) then

            ObjSet( obj_name, 
                { 
                input           = false,
                alp             =   0,
                pos_x           =   0,
                pos_y           =   0,
                scale_x         =   1,
                scale_y         =   1,
                });

            ObjAttach( obj_name , "obj_serverroom_task" );

        else 

          ObjSet( "txt_serverroom_panel_task", { alp = 0, text = "pop_serverroom_"..private.win_serverroom.task_text[ j ] } );

        end;

      end;

  end;

  ObjAttach( "obj_serverroom_panel" , "int_itempanel_impl" );

end;
--*********************************************************************************************************************
function private.Active ()

  local idx  = ng_global.progress[ "std" ][ "win_serverroom" ].stage;
  local flag = true;

  for i = 1, #private.win_serverroom.task_text do

      if ( private.win_serverroom.task[ idx ] == private.win_serverroom.task_text[ i ] ) then
     
        flag = false;
        break;

      end;

  end;

  local obj_name = "hub_int_itempanel_serverroom_"..private.win_serverroom.task[ idx ];
  local name     = "obj_serverroom_"..private.win_serverroom.task[ idx ];

  int.Lock( false );

  if ( flag ) then
   
      ObjSet( "txt_serverroom_panel_task", { alp = 0 } );

      ObjSet( obj_name, { input = true, pos_x = 0, pos_y = 0, scale_x = 1, scale_y = 1 } );
      ObjSet( name, { input = true } );
      
      ObjAnimate( obj_name, "alp", 0, 0, "",
      { 
        0.0, 0, 0, 
        0.3, 0, 1 
      } );

    ObjAnimate( "anm_serverroom_obj_fx", "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "anm_serverroom_obj_fx" ).alp, 
      0.3, 0, 0.5 
    } );

  else 

      ObjSet( name, { input = true } );

      ObjAnimate( "txt_serverroom_panel_task", "alp", 0, 0, "",
      { 
        0.0, 0, 0, 
        0.3, 0, 1 
      } );

      ObjSet( "txt_serverroom_panel_task", { alp = 1, text = "pop_serverroom_"..private.win_serverroom.task[ idx ] } );
      ObjSet( "spr_serverroom_"..private.win_serverroom.task[ idx ], { input = true } );

      ObjSet( obj_name, { input = false } );

  end;

end;
--*********************************************************************************************************************
function private.Stage ()

  if ( ng_global.progress[ "std" ][ "win_serverroom" ].stage ~= 12 ) then

    ObjSet( "spr_serverroom_light_add_"..ng_global.progress[ "std" ][ "win_serverroom" ].stage, { alp = 1 } );
    ng_global.progress[ "std" ][ "win_serverroom" ].stage = ng_global.progress[ "std" ][ "win_serverroom" ].stage + 1;

  else 

    MsgSend( Event_DialogHo_Show, {} );

  end;
  
  if ( ng_global.progress[ "std" ][ "win_serverroom" ].stage == 3 ) then
 
    interface.TutorialHide();
  
  end;
  
  if ( ng_global.progress[ "std" ][ "win_serverroom" ].stage == 2 ) then
 
    cmn.TutorialShow( "tutorial_page_31" );
    cmn.TutorialSetShown( "tutorial_page_31" );
  
  end;
  
end;
--*********************************************************************************************************************
function private.GetObj ()

  ObjAnimate( "anm_serverroom_obj_fx", "alp", 0, 0, "",
  { 
    0.0, 0, ObjGet( "anm_serverroom_obj_fx" ).alp, 
    0.3, 0, 0.0 
  } );

end;
--*********************************************************************************************************************
function private.PFX ( name, name_dub )

    local pfx_hide_name = "pfx_hide_"..name;

    local collect_pos = GetObjPosByObj( "spr_serverroom_"..name, "ho_serverroom" );
    local collect_drawoff_x = 0;
    local collect_drawoff_y = 0;

    if ( name == name_dub ) then

      collect_drawoff_x = ObjGet( "spr_serverroom_"..name ).drawoff_x;
      collect_drawoff_y = ObjGet( "spr_serverroom_"..name ).drawoff_y;

      ObjSet( "spr_serverroom_"..name ,{ pos_x = collect_pos[ 1 ], pos_y = collect_pos[ 2 ] } );

    else 

       local collect_pos_2 = GetObjPosByObj( "obj_serverroom_"..name, "ho_serverroom" );
       local posx = ObjGet( "spr_serverroom_"..name_dub ).drawoff_x + collect_pos_2[ 1 ];
       local posy = ObjGet( "spr_serverroom_"..name_dub ).drawoff_y + collect_pos_2[ 2 ];

       collect_drawoff_x = posx;
       collect_drawoff_y = posy;

    end;

    ObjCreate( pfx_hide_name, "partsys" );
    ObjAttach( pfx_hide_name, "ho_serverroom" );
    ObjSet( pfx_hide_name,
    {
      res = "assets/levels/level1/mg_mgremovecollapse/anims/pfx_effects",
      pos_x = collect_drawoff_x, pos_y = collect_drawoff_y,
      input = false
    } );

    ObjSet( pfx_hide_name, { blendmode = 2 } );
    
    if ( name == name_dub ) then

      PartSysSetMaskObj( pfx_hide_name, "spr_serverroom_"..name );

    else 

      PartSysSetMaskObj( pfx_hide_name, "spr_serverroom_"..name_dub );

    end;
end;
--*********************************************************************************************************************
function private.FlyPFX ( name )

    local anm_fly_name = "anm_fly_"..name;

    local collect_pos = GetObjPosByObj( "spr_serverroom_"..name, "obj_serverroom_panel" );

    local collect_drawoff_x = ObjGet( "spr_serverroom_"..name ).drawoff_x;
    local collect_drawoff_y = ObjGet( "spr_serverroom_"..name ).drawoff_y;

    ObjSet( "spr_serverroom_"..name ,{ pos_x = collect_pos[ 1 ], pos_y = collect_pos[ 2 ] } );

    ObjCreate( anm_fly_name, "anim" );

    ObjSet( anm_fly_name,
    {
      res = "assets/levels/level3/ho_serverroom/anims/anm_fly_fx",
      pos_x = collect_drawoff_x, pos_y = collect_drawoff_y,
      input = false
    } );
    AnimPlay( anm_fly_name, "DoAnim", "" );
    ObjAttach( anm_fly_name, "obj_serverroom_panel" );

    ObjSet( anm_fly_name, { blendmode = 2, pos_z = 50 } );
    ObjAnimate( anm_fly_name, "pos_xy", 0, 0, "", 
    { 
      0.0,  0,  ObjGet( "spr_serverroom_"..name ).pos_x-512, ObjGet( "spr_serverroom_"..name ).pos_y-715,
      0.8,  0,  0, 0 
    } );
    ObjAnimate( anm_fly_name, "alp", 0, 0, "", 
    { 
      0.0,  1, 
      1.0,  0,
    } );

end;
--*********************************************************************************************************************
function private.HoItemFindClick( sender )

    local ho_name          = common.GetObjectName( GetCurrentRoom() );
    local item_name        = sender;
    local item_object_name = "obj_"..common.GetObjectName( item_name );

    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].start = 1;

    local item_found = { item = item_name, object = item_object_name };

    table.insert( ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found, item_found );

    interface.ItemPanelItemRemove( item_name );
    ObjSet( item_object_name, { input = false } );

end;
--*********************************************************************************************************************
function private.InitAnim ()

  ObjAnimate( "anm_serverroom_obj_fx", "scale_xy", 1, 0, "",
  { 
    0.0, 3, 2.05,2.05,
    2.0, 3, 1.95,1.95,
    3.0, 3, 2.05,2.05
  } );

  ObjAnimate( "obj_serverroom_task", "scale_xy", 1, 0, "",
  { 
    0.0, 3, 1.05,1.05,
    2.0, 3, 0.95,0.95,
    3.0, 3, 1.05,1.05
  } );

  ObjAnimate( "spr_serverroom_light_1", "alp", 1, 0, "",
  { 
    0.0, 0,   1, 
    1.5, 0, 0.1,
      3, 0,   1 
  } );

  ObjAnimate( "spr_serverroom_light_3", "alp", 1, 0, "",
  { 
    0.0, 0, 1, 
    0.1, 0, 0.7,
    0.2, 0, 1 
  } );

  ObjAnimate( "spr_serverroom_light_4", "alp", 1, 0, "",
  { 
    0.0, 0,   1, 
      5, 0,   1,
    5.1, 0, 0.2,
    5.2, 0,   1,
    5.3, 0, 0.2,
    5.4, 0,   1 
  } );

  ObjAnimate( "spr_serverroom_light_5", "alp", 1, 0, "",
  { 
    0.0, 0,   1, 
      3, 0,   1,
    3.1, 0, 0.2,
    3.2, 0,   1 
  } );

  ObjAnimate( "spr_serverroom_wire_1", "ang", 1, 0, "",
  { 
    0.0, 3, 0.09, 
      5, 3,-0.09,
     10, 3, 0.09 
  } );

  ObjAnimate( "spr_serverroom_wire_3", "ang", 1, 0, "",
  { 
    0.0, 3,-0.09, 
      2, 3, 0.09,
      4, 3,-0.09 
  } );

  ObjAnimate( "spr_serverroom_wire_4", "ang", 1, 0, "",
  { 
    0.0, 3, 0.15, 
      3, 3,-0.15,
      6, 3, 0.15 
  } );

end;