-- name=mg_cashtill
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_cashtill";
  game.relations[ "mg_cashtill" ].exitroom = "rm_waitinghall";

  ObjMultiSet( {
    { "spr_cashtill_twister",     { event_mdown = private.get_twister } },
    { "spr_cashtill_button_open", { event_mdown = private.clk_cashtill } },
    { "spr_cashtill_fork",        { event_mdown = private.ForkClick } },
    { "obj_cashtill_candy_click", { event_mdown = private.CandyClick } },
    { "obj_cashtill_ice_click",   { event_mdown = private.IceClick } },
  } );

  private.Init();
  private.Anims();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_cashtill = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;
  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    

      visible_sparkle_area = false;

    end;

    local visible_sparkle_ho = true;  

    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    

      visible_sparkle_ho = false;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then

      ObjMultiSet( table_multiset );

    end;

  end;

  cmn.AddSubscriber( "update_game_mode_cashtill", update_game_mode_cashtill, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_twister () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_twister" ] =
  {
    type = "get",
    get_obj = "spr_cashtill_twister",
    room = private.room_objname,
    --zz = "zz_cashtill",
    --zz_gate = "gzz_cashtill_cashtill"
  };
  -----------------------------------------------
  local get_twister_inv = function ()

    int.InventoryItemAdd( "inv_twister", "spr_cashtill_twister" );

  end;

  local get_twister_closezz = function ()

    ObjDelete( "gfx_cashtill_twister" );
    ObjDelete( "spr_cashtill_twister_shadow" );

  end;

  cmn.AddSubscriber( "get_twister", get_twister_inv );
  cmn.AddSubscriber( "get_twister", get_twister_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_cashtill" ] =
  {
    type = "click",
    clk_obj = "spr_cashtill_button_open",
    room = private.room_objname,
  };
  -----------------------------------------------------------------------------------
  local clk_cashtill_end = function ()

    ObjSet( "spr_cashtill_twister",      { input = true, active = true } );
    ObjSet( "obj_cashtill_cashbox_open", { pos_x = 0, pos_y = 0 } );
    ObjSet( "obj_cashtill_button_open",  { input = false, active = false } );

  end;

  cmn.AddSubscriber( "clk_cashtill", clk_cashtill_end, private.room_objname );
  cmn.AddSubscriber( "clk_cashtill_end", clk_cashtill_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_cashtill () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_cashtill" ] =
  {
    type = "click",
    get_obj = "spr_cashtill_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_cashtill = function ()

    if ( cmn.IsEventStart( "win_cashtill" ) ) then

      private.Load();

    end;

    if ( cmn.IsEventDone( "win_cashtill" ) ) then

      --int.DeleteTaskMap( "rm_waitinghall", "win_cashtill" );

      ObjSet( "obj_cashtill_button_open", { input = true, active = true } );
      ObjSet( "obj_cashtill_buttons",     { input = false } );
      ObjDelete( "spr_cashtill_button_open_inactive" );

    end;

  end;

  cmn.AddSubscriber( "win_cashtill", win_cashtill, private.room_objname );

end;
-------------------------------------------------
function private.get_twister ()

  cmn.SetEventDone( "get_twister" );
  cmn.CallEventHandler( "get_twister" );
  
  cmn.GetObjectSfx();

  cmn.GotoRoom( "rm_waitinghall" );

end;
-------------------------------------------------
function private.clk_cashtill ()

  cmn.CallEventHandler( "clk_cashtill_beg" );
  int.Lock( true );
  
  local func_end = function ()

    cmn.SetEventDone( "clk_cashtill" );
    cmn.CallEventHandler( "clk_cashtill_end" );

    int.Lock( false );

  end;

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_click_to_open_button" );

  ObjAnimate( "obj_cashtill_button_open", "scale_xy", 0, 0, "", 
  {
    0.0, 3, 1.00, 1.00,
    0.3, 3, 0.95, 0.95,
    0.6, 3, 1.00, 1.00,
  } );

  ObjAnimate( "obj_cashtill_cashbox_open", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 3, 84, -155, 
    0.6, 3, 84, -155, 
    1.6, 3, 0, 0,
  } );

  ObjAnimate( "spr_cashtill_button_open_light", "alp", 0, 0, "", 
  { 
    0.0, 3, ObjGet( "spr_cashtill_button_open_light" ).alp, 
    0.5, 3, 0, 0,
  } );


end;
--*********************************************************************************************************************
function private.Init ()

  private.button_pos = { { 481, 119 }, { 593, 176 }, { 704, 232 }, { 425, 232 }, { 537, 289 }, { 649, 344 }, { 369, 344 }, { 482, 402 }, { 596, 456 } };

  private.count_buttons = 9;
  private.count_lamps   = 16;

  for b = 1, private.count_buttons do

    ObjSet( "spr_cashtill_button_"..b,
    {
      input = true,
      event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      event_mdown  = function () private.ButtonClick( b ) end,
    } );

  end;

end;
--*********************************************************************************************************************
function private.Load ()

  for b = 1, private.count_buttons do

    local idx = ng_global.progress[ "std" ][ "win_cashtill" ].field[ b ];

    ObjSet( "obj_cashtill_button_"..idx,
    {
      pos_x = private.button_pos[ b ][ 1 ],
      pos_y = private.button_pos[ b ][ 2 ],
    } );

  end;

  if ( ng_global.progress[ "std" ][ "win_cashtill" ].button ) then

    ObjSet( "spr_cashtill_button_"..ng_global.progress[ "std" ][ "win_cashtill" ].button.."_light", { alp = 1 } );

  end;

  private.IsWin();

end;
--*********************************************************************************************************************
function public.PreOpen () 

  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventStart( "win_cashtill" ) ) then

    ng_global.progress[ "std" ][ "win_cashtill" ].field  = { 7, 8, 9, 4, 5, 6, 1, 2, 3 };
    ng_global.progress[ "std" ][ "win_cashtill" ].button = nil;

  end;

  if ( ng_global.progress[ "std" ][ "win_cashtill" ].candy ) then

    ObjDelete( "obj_cashtill_candy" );

  end;

  --cmn.StopAllEnv( "audio/level3/env/aud_secontowerfloor_env" );
  --cmn.PlayAudio( "env", "audio/level3/env/aud_secontowerfloor_env", 1 );

  --common_impl.PlayMusEnv();

end;
--*********************************************************************************************************************
function public.Open () 

  if ( not cmn.IsEventDone( "win_cashtill" ) ) then

    cmn.MiniGameShow( "cashtill" );
    common_impl.PassingMgStart( "cashtill" );

  end;

  if ( not cmn.IsEventDone( "opn_cashtill" ) ) then

    cmn.SetEventDone( "opn_cashtill" );

  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  cmn.MiniGameHide();
  common_impl.PassingMgStop( "cashtill" );

end;
--*********************************************************************************************************************
function public.Reset ()

  int.Lock( true );

  local start_state = { 7, 8, 9, 4, 5, 6, 1, 2, 3 };

  for b = 1, private.count_buttons do

    local pos = ObjGet( "obj_cashtill_button_"..start_state[ b ] );

    if ( ( pos.pos_x ~= private.button_pos[ b ][ 1 ] ) or ( pos.pos_y ~= private.button_pos[ b ][ 2 ] ) ) then

      ObjAnimate( "obj_cashtill_button_"..start_state[ b ], "pos_xy", 0, 0, "", 
      {
        0.0, 3, pos.pos_x, pos.pos_y,
        0.5, 3, private.button_pos[ b ][ 1 ], private.button_pos[ b ][ 2 ],
      } );

      ObjAnimate( "spr_cashtill_button_"..start_state[ b ].."_shadow", "alp", 0, 0, "", 
      {
        0.00, 3, 1,
        0.15, 3, 0,
        0.35, 3, 0,
        0.50, 3, 1,
      } );

    end;

  end;

  local lamps_light = { 0, 0, 0, 1, 1, 1, 0, 1, 1, 0, 1, 1, 1, 0, 0, 0 };

  for b = 1, private.count_lamps do

    local alp = ObjGet( "spr_cashtill_lamp_"..b ).alp;

    ObjAnimate( "spr_cashtill_lamp_"..b, "alp", 0, 0, "", 
    {
      0.0, 3, alp,
      0.3, 3, lamps_light[ b ],
    } );

  end;

  if ( ng_global.progress[ "std" ][ "win_cashtill" ].button ) then

    ObjSet( "spr_cashtill_button_"..ng_global.progress[ "std" ][ "win_cashtill" ].button.."_light", { alp = 0 } );

  end;

  ObjSet( "tmr_cashtill_reset", 
  { 
    playing = 1,
    time = 0.5,
    endtrig = function ()

      int.Lock( false );

      ng_global.progress[ "std" ][ "win_cashtill" ].field  = { 7, 8, 9, 4, 5, 6, 1, 2, 3 };
      ng_global.progress[ "std" ][ "win_cashtill" ].button = nil;

    end
  } );

end;
--*********************************************************************************************************************
function public.Skip ()
port.skip_mg = true;
  int.Lock( true );

  local win_state = { 8, 1, 6, 3, 5, 7, 4, 9, 2 };

  for b = 1, private.count_buttons do

    local pos = ObjGet( "obj_cashtill_button_"..win_state[ b ] );

    if ( ( pos.pos_x ~= private.button_pos[ b ][ 1 ] ) or ( pos.pos_y ~= private.button_pos[ b ][ 2 ] ) ) then

      ObjAnimate( "obj_cashtill_button_"..win_state[ b ], "pos_xy", 0, 0, "", 
      {
        0.0, 3, pos.pos_x, pos.pos_y,
        0.5, 3, private.button_pos[ b ][ 1 ], private.button_pos[ b ][ 2 ],
      } );

      ObjAnimate( "spr_cashtill_button_"..win_state[ b ].."_shadow", "alp", 0, 0, "", 
      {
        0.00, 3, 1,
        0.15, 3, 0,
        0.35, 3, 0,
        0.50, 3, 1,
      } );

    end;

  end;

  for b = 1, private.count_lamps do

    local alp = ObjGet( "spr_cashtill_lamp_"..b ).alp;

    ObjAnimate( "spr_cashtill_lamp_"..b, "alp", 0, 0, "", 
    {
      0.0, 3, alp,
      0.3, 3, 1,
    } );

  end;

  if ( ng_global.progress[ "std" ][ "win_cashtill" ].button ) then

    ObjSet( "spr_cashtill_button_"..ng_global.progress[ "std" ][ "win_cashtill" ].button.."_light", { alp = 0 } );

  end;

  ObjSet( "tmr_cashtill_reset", 
  { 
    playing = 1,
    time = 0.5,
    endtrig = function ()

      int.Lock( false );

      ng_global.progress[ "std" ][ "win_cashtill" ].field  = { 8, 1, 6, 3, 5, 7, 4, 9, 2 };
      ng_global.progress[ "std" ][ "win_cashtill" ].button = nil;

      private.Win();

    end
  } );

end;
--*********************************************************************************************************************
function private.Win ()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_cashtill" );
  cmn.CallEventHandler( "win_cashtill" );
  common_impl.PassingMgWin( "cashtill" );
  
  cmn.PlayAudio( "mus", "audio/aud_amnesia_theme_mus" );

end;
--*********************************************************************************************************************
function private.GetPos ( idx )

  for b = 1, private.count_buttons do

    if ( ng_global.progress[ "std" ][ "win_cashtill" ].field[ b ] == idx ) then

      return b;

    end;

  end;

end;
--*********************************************************************************************************************
function private.IsWin ()

  local lamps   = { { 1, 2 }, { 8, 9 }, { 15, 16 }, { 3, 10 }, { 5, 12 }, { 7, 14 }, { 4, 13 }, { 6, 11 } };
  local buttons = { { 1, 2, 3 }, { 4, 5, 6 }, { 7, 8, 9 }, { 1, 4, 7 }, { 2, 5, 8 }, { 3, 6, 9 }, { 1, 5, 9 }, { 3, 5, 7 } };

  local is_win = true;

  for b = 1, #buttons do

    local kit = buttons[ b ];
    local sum = 0;

    for k = 1, #kit do

      sum = sum + ng_global.progress[ "std" ][ "win_cashtill" ].field[ kit[ k ] ]; 

    end;

    if ( sum == 15 ) then

      ObjSet( "spr_cashtill_lamp_"..lamps[ b ][ 1 ], { alp = 1 } );
      ObjSet( "spr_cashtill_lamp_"..lamps[ b ][ 2 ], { alp = 1 } );

    else

      is_win = false;

      ObjSet( "spr_cashtill_lamp_"..lamps[ b ][ 1 ], { alp = 0 } );
      ObjSet( "spr_cashtill_lamp_"..lamps[ b ][ 2 ], { alp = 0 } );

    end;

  end;

  return is_win;

end;
--*********************************************************************************************************************
function private.ButtonClick ( idx )

  local current = ng_global.progress[ "std" ][ "win_cashtill" ].button;

  int.Lock( true );

  if ( current ) then

    if ( current == idx ) then

      local func_end = function ()

        int.Lock( false );

        ng_global.progress[ "std" ][ "win_cashtill" ].button = nil;

      end;
      
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_cashtill_click" );
      ObjAnimate( "spr_cashtill_button_"..idx.."_light", "alp", 0, 0, func_end, 
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

    else

      local name_1 = "obj_cashtill_button_"..idx;
      local name_2 = "obj_cashtill_button_"..current;

      local pos_1 = ObjGet( name_1 );
      local pos_2 = ObjGet( name_2 );

      ObjSet( name_1, { pos_z = 10 } );
      ObjSet( name_2, { pos_z = 10 } );

      local func_end = function ()

        int.Lock( false );

        ObjSet( name_1, { pos_z = 2 } );
        ObjSet( name_2, { pos_z = 2 } );

        local idx_1 = private.GetPos( idx );
        local idx_2 = private.GetPos( current );

        ng_global.progress[ "std" ][ "win_cashtill" ].field[ idx_1 ] = current;
        ng_global.progress[ "std" ][ "win_cashtill" ].field[ idx_2 ] = idx;
        ng_global.progress[ "std" ][ "win_cashtill" ].button = nil;

        if ( private.IsWin() ) then

          private.Win();

        end;

      end;
      
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_cashtill_switch" );
      ObjAnimate( "spr_cashtill_button_"..idx.."_light", "alp", 0, 0, "", 
      {
        0.0, 3, 0,
        0.3, 3, 1,
        0.5, 3, 1,
        0.8, 3, 0,
      } );

      ObjAnimate( "spr_cashtill_button_"..current.."_light", "alp", 0, 0, "", 
      {
        0.0, 3, 1,
        0.5, 3, 1,
        0.8, 3, 0,
      } );

      ObjAnimate( "spr_cashtill_button_"..idx.."_shadow", "alp", 0, 0, "", 
      {
        0.00, 3, 1,
        0.50, 3, 1,
        0.65, 3, 0,
        0.85, 3, 0,
        1.00, 3, 1,
      } );

      ObjAnimate( "spr_cashtill_button_"..current.."_shadow", "alp", 0, 0, "", 
      {
        0.00, 3, 1,
        0.50, 3, 1,
        0.65, 3, 0,
        0.85, 3, 0,
        1.00, 3, 1,
      } );

      ObjAnimate( name_1, "pos_xy", 0, 0, "", 
      {
        0.0, 3, pos_1.pos_x, pos_1.pos_y,
        0.5, 3, pos_1.pos_x, pos_1.pos_y,
        1.0, 3, pos_2.pos_x, pos_2.pos_y,
      } );

      ObjAnimate( name_2, "pos_xy", 0, 0, func_end, 
      {
        0.0, 3, pos_2.pos_x, pos_2.pos_y,
        0.5, 3, pos_2.pos_x, pos_2.pos_y,
        1.0, 3, pos_1.pos_x, pos_1.pos_y,
      } );

    end;

  else

    local func_end = function ()

      int.Lock( false );

      ng_global.progress[ "std" ][ "win_cashtill" ].button = idx;

    end;
    
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_cashtill_click" );
    ObjAnimate( "spr_cashtill_button_"..idx.."_light", "alp", 0, 0, func_end, 
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

  end;

end;
--*********************************************************************************************************************
function private.Anims ()

  ObjAnimate( "spr_cashtill_light_down", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    3.0, 3, 1.0,
    6.0, 3, 0.3,
  } );

  ObjAnimate( "spr_cashtill_light_up", "alp", 0, 1, "", 
  {
    0.0, 3, 0.3,
    3.0, 3, 1.0,
    6.0, 3, 0.3,
  } );

  ObjAnimate( "spr_cashtill_light", "alp", 0, 1, "", 
  {
    0.0, 3, 0.3,
    3.0, 3, 1.0,
    6.0, 3, 0.3,
  } );

  ObjAnimate( "spr_cashtill_monitor_light", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    2.0, 3, 1.0,
    2.1, 3, 0.5,
    2.2, 3, 1.0,
    2.3, 3, 0.5,
    2.4, 3, 1.0,
    8.0, 3, 1.0,
  } );

  ObjAnimate( "spr_cashtill_button_open_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.0,
    0.8, 3, 1.0,
    1.6, 3, 0.0,
  } );

end;
--*********************************************************************************************************************
function private.ForkClick ()

  local func_end = function ()

    int.Lock( false );

  end;

  int.Lock( true );

  ObjAnimate( "spr_cashtill_fork", "ang", 0, 0, func_end, 
  {
    0.0, 3,  0.0,
    0.5, 3, -0.05,
    1.0, 3,  0.0,
  } );

end;
--*********************************************************************************************************************
function private.CandyClick ()

  local func_end = function ()

    int.Lock( false );

    ng_global.progress[ "std" ][ "win_cashtill" ].candy = true;

    ObjDelete( "obj_cashtill_candy" );

  end;

  int.Lock( true );

  ObjAnimate( "spr_cashtill_candy_1", "alp", 0, 0, "", 
  {
    0.0, 3,  1.0,
    0.1, 3,  1.0,
    0.4, 3,  0.0,
  } );

  ObjAnimate( "spr_cashtill_candy_2", "alp", 0, 0, func_end, 
  {
    0.0, 3,  1.0,
    0.6, 3,  1.0,
    0.9, 3,  0.0,
  } );

end;
--*********************************************************************************************************************
function private.IceClick ()

  local func_end = function ()

    int.Lock( false );

    ObjSet( "anm_cashtill_ice",       { alp = 1, frame = 0 } );
    ObjSet( "anm_cashtill_ice_click", { alp = 0 } );

  end;

  int.Lock( true );

  ObjSet( "anm_cashtill_ice",       { alp = 0 } );
  ObjSet( "anm_cashtill_ice_click", { alp = 1 } );

  AnimPlay( "anm_cashtill_ice_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************