-- name=mg_ondoor
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_ondoor";
  game.relations[ "mg_ondoor" ].exitroom = "rm_technicalroom";

  ObjMultiSet(
  {
    { "spr_ondoor_cleaningagent",           { event_mdown = private.get_cleaningagent } },
    { "spr_ondoor_controltowerkey",         { event_mdown = private.get_controltowerkey } },
    { "spr_ondoor_controltowerkey_trinket", { event_mdown = private.get_controltowerkey } },
  } );

  private.Init();
  private.Animations();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_ondoor = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;
  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    

      visible_sparkle_area = false;

    end;

    local visible_sparkle_ho = true;  

    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    

      visible_sparkle_ho = false;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then

      ObjMultiSet( table_multiset );

    end;

  end;

  cmn.AddSubscriber( "update_game_mode_ondoor", update_game_mode_ondoor, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_cleaningagent () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cleaningagent" ] =
  {
    type = "get",
    get_obj = "spr_ondoor_cleaningagent",
    room = private.room_objname,
  };
  -----------------------------------------------
  local get_cleaningagent_inv = function ()

    int.InventoryItemAdd( "inv_cleaningagent", "spr_ondoor_cleaningagent" );

  end;
  local get_cleaningagent_closezz = function ()

    ObjDelete( "gfx_ondoor_cleaningagent" );
    ObjDelete( "spr_ondoor_cleaningagent_shadow" );

  end;
  local get_cleaningagent_loc = function ()

    ObjDelete( "spr_technicalroom_cleaningagent" );
    if ( cmn.IsEventDone( "get_controltowerkey" ) ) then

      ObjDelete( "gmg_technicalroom_ondoor" );

    end;

  end;

  cmn.AddSubscriber( "get_cleaningagent", get_cleaningagent_inv );
  cmn.AddSubscriber( "get_cleaningagent", get_cleaningagent_closezz, private.room_objname );
  cmn.AddSubscriber( "get_cleaningagent", get_cleaningagent_loc, "rm_technicalroom" );
  --------------------------------------------------------------------------------------------
  -- function get_controltowerkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_controltowerkey" ] =
  {
    type = "get",
    get_obj = "spr_ondoor_controltowerkey",
    room = private.room_objname,
  };
  -----------------------------------------------
  local get_controltowerkey_inv = function ()

    int.InventoryItemAdd( "inv_controltowerkey", "spr_ondoor_controltowerkey" );

  end;
  local get_controltowerkey_closezz = function ()

    ObjDelete( "gfx_ondoor_controltowerkey" );
    ObjDelete( "spr_ondoor_controltowerkey_shadow" );
    ObjDelete( "spr_ondoor_controltowerkey_trinket_shadow" );
    ObjDelete( "spr_ondoor_controltowerkey_light" );
    ObjDelete( "spr_ondoor_controltowerkey_trinket_light" );

  end;
  local get_controltowerkey_loc = function ()

    ObjDelete( "spr_technicalroom_controltowerkey" );
    if ( cmn.IsEventDone( "get_cleaningagent" ) ) then

      ObjDelete( "gmg_technicalroom_ondoor" );

    end;

  end;

  cmn.AddSubscriber( "get_controltowerkey", get_controltowerkey_inv );
  cmn.AddSubscriber( "get_controltowerkey", get_controltowerkey_closezz, private.room_objname );
  cmn.AddSubscriber( "get_controltowerkey", get_controltowerkey_loc, "rm_technicalroom" );
  --------------------------------------------------------------------------------------------
  -- function win_ondoor () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_ondoor" ] =
  {
    type = "click",
    get_obj = "spr_ondoor_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_ondoor = function ()

    if ( cmn.IsEventDone( "win_ondoor" ) ) then

      --int.DeleteTaskMap( "rm_technicalroom", "win_ondoor" );

      ObjSet( "obj_ondoor_cabinet_open",    { alp = 1, input = true } );
      ObjSet( "gfx_ondoor_cleaningagent",   { active = true } );
      ObjSet( "gfx_ondoor_controltowerkey", { active = true } );
      ObjSet( "anm_ondoor_keys",            { active = true } );
      ObjDelete( "obj_ondoor_cabinet_close" );

    elseif ( cmn.IsEventStart( "win_ondoor" ) ) then

      private.Load();

    end;

  end;

  local win_ondoor_loc = function ()

    if ( cmn.IsEventDone( "win_ondoor" ) ) then

      ObjSet( "spr_technicalroom_keystand_open", { alp = 1 } );

    end;

  end;

  cmn.AddSubscriber( "win_ondoor", win_ondoor, private.room_objname );
  cmn.AddSubscriber( "win_ondoor", win_ondoor_loc, "rm_technicalroom" );

end;
-------------------------------------------------
function private.get_cleaningagent ()

  cmn.SetEventDone( "get_cleaningagent" );
  cmn.CallEventHandler( "get_cleaningagent" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_controltowerkey" ) ) then

    cmn.GotoRoom( "rm_technicalroom" );

  end;

end;
-------------------------------------------------
function private.get_controltowerkey ()

  cmn.SetEventDone( "get_controltowerkey" );
  cmn.CallEventHandler( "get_controltowerkey" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_cleaningagent" ) ) then

    cmn.GotoRoom( "rm_technicalroom" );

  end;

end;
--*********************************************************************************************************************
function private.Init ()

  private.locks_count   = 6;
  private.chains_count  = 4;
  private.buttons_count = 4;

  private.lock_pos = { { 587, 251 }, { 662, 380 }, { 586, 506 }, { 437, 509 }, { 362, 380 }, { 438, 252 } };
  private.chain = { { 1, 4, 3, 2, 1 }, { 3, 6, 1, 2, 3 }, { 4, 1, 6, 5, 4 }, { 6, 3, 4, 5, 6 } };
  private.button = { 1, 3, 4, 6 };
  private.button_input = { 3, 4, 1, 2 };

  for b = 1, private.buttons_count do

    ObjSet( "obj_ondoor_button_"..b,
    {
      event_mdown  = function () private.ButtonClick( b ) end,
      event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
    } );

  end;

end;
--*********************************************************************************************************************
function private.Load ()

  for i = 1, private.locks_count do

    local lock = ng_global.progress[ "std" ][ "win_ondoor" ].lock[ i ];

    ObjSet( "obj_ondoor_lock_"..lock, { pos_x = private.lock_pos[ i ][ 1 ], pos_y = private.lock_pos[ i ][ 2 ] } );

  end;  

  local button = ng_global.progress[ "std" ][ "win_ondoor" ].button;

  if ( button ) then

    ObjSet( "spr_ondoor_lock_"..ng_global.progress[ "std" ][ "win_ondoor" ].lock[ button ].."_light", { alp = 1 } );

    private.SetInput( button );

  end;

end;
--*********************************************************************************************************************
function public.PreOpen () 

  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventStart( "win_ondoor" ) ) then

    ng_global.progress[ "std" ][ "win_ondoor" ].lock  = { 3, 1, 2, 5, 4, 6 };
    ng_global.progress[ "std" ][ "win_ondoor" ].button = nil;

  end;

  --cmn.StopAllEnv( "audio/level3/env/aud_secontowerfloor_env" );
  --cmn.PlayAudio( "env", "audio/level3/env/aud_secontowerfloor_env", 1 );

  --common_impl.PlayMusEnv();

end;
--*********************************************************************************************************************
function public.Open () 

  if ( not cmn.IsEventDone( "win_ondoor" ) ) then

    cmn.MiniGameShow( "ondoor" );
    common_impl.PassingMgStart( "ondoor" );

  end;

  if ( not cmn.IsEventDone( "opn_ondoor" ) ) then

    cmn.SetEventDone( "opn_ondoor" );

  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  cmn.MiniGameHide();
  common_impl.PassingMgStop( "ondoor" );

end;
--*********************************************************************************************************************
function public.Reset ()

  ng_global.progress[ "std" ][ "win_ondoor" ].lock  = { 3, 1, 2, 5, 4, 6 };
  ng_global.progress[ "std" ][ "win_ondoor" ].button = nil;

  for i = 1, private.locks_count do

    ObjSet( "obj_ondoor_lock_"..ng_global.progress[ "std" ][ "win_ondoor" ].lock[ i ], { pos_x = private.lock_pos[ i ][ 1 ], pos_y = private.lock_pos[ i ][ 2 ] } );
    ObjSet( "spr_ondoor_lock_"..i.."_light",                                           { alp = 0 } );

  end;  

  private.SetInput();

end;
--*********************************************************************************************************************
function public.Skip ()
port.skip_mg = true;
  int.Lock( true );

  ObjAnimate( "obj_ondoor_cabinet_open", "alp", 0, 0,
  function ()

    int.Lock( false );

    private.Win();

  end, 
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
function private.Win ()

  cmn.PlayAudio( "mus", "audio/aud_main_theme_light_mus" );
  cmn.MiniGameHide();
  cmn.SetEventDone( "win_ondoor" );
  cmn.CallEventHandler( "win_ondoor" );
  common_impl.PassingMgWin( "ondoor" );    

end;
--*********************************************************************************************************************
function private.IsWin ()

  for i = 1, private.locks_count do

    if ( private.locks[ i ] ~= i ) then

      private.SaveProgress();

      return false;

    end;

  end;

  return true;

end;
--*********************************************************************************************************************
function private.ButtonClick ( idx )

  local current = ng_global.progress[ "std" ][ "win_ondoor" ].button;

  int.Lock( true );

  if ( current ) then

    if ( current == idx ) then

      local func_end = function ()

        int.Lock( false );

        ng_global.progress[ "std" ][ "win_ondoor" ].button = nil;

        private.SetInput();

      end;
      
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_keystand_click" );
      ObjAnimate( "spr_ondoor_lock_"..ng_global.progress[ "std" ][ "win_ondoor" ].lock[ private.button[ idx ] ].."_light", "alp", 0, 0, func_end, 
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

    else

      private.locks = {};

      for i = 1, private.locks_count do

        private.locks[ i ] = ng_global.progress[ "std" ][ "win_ondoor" ].lock[ i ];

      end;

      local func_end = function ()

        int.Lock( false );
        private.SetInput();

        for c = 1, private.chains_count do

          private.locks[ private.chain[ current ][ c + 1 ] ] = ng_global.progress[ "std" ][ "win_ondoor" ].lock[ private.chain[ current ][ c ] ];

        end;

        if ( private.IsWin() ) then

          int.Lock( true );

          ObjAnimate( "obj_ondoor_cabinet_open", "alp", 0, 0,
          function ()

            int.Lock( false );

            private.SaveProgress();
            private.Win();

          end, 
          {
            0.0, 3, 0.0,
            0.2, 3, 0.0,
            0.5, 3, 1.0,
          } );

        end;

      end;

      ObjAnimate( "spr_ondoor_lock_"..ng_global.progress[ "std" ][ "win_ondoor" ].lock[ private.button[ idx ] ].."_light", "alp", 0, 0, "", 
      {
        0.0, 3, 0,
        0.3, 3, 1,
        0.5, 3, 1,
        0.8, 3, 0,
      } );

      ObjAnimate( "spr_ondoor_lock_"..ng_global.progress[ "std" ][ "win_ondoor" ].lock[ private.button[ current ] ].."_light", "alp", 0, 0, func_end, 
      {
        0.0, 3, 1,
        0.5, 3, 1,
        0.8, 3, 0,
        1.0, 3, 0,
      } );

      
      local func_end_aud = function ()
      
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_keystand_switch" );
        
      end;
    
      local chain = private.chain[ current ];

      ObjSet( "tmr_ondoor_1", { playing = 1, time = 0.5, endtrig = func_end_aud } ); 
      for c = 1, private.chains_count do

        local pos_1 = private.lock_pos[ chain[ c ] ];
        local pos_2 = private.lock_pos[ chain[ c + 1 ] ];

        ObjAnimate( "obj_ondoor_lock_"..private.locks[ chain[ c ] ], "pos_xy", 0, 0, "", 
        {
          0.0, 3, pos_1[ 1 ], pos_1[ 2 ],
          0.5, 3, pos_1[ 1 ], pos_1[ 2 ],
          1.0, 3, pos_2[ 1 ], pos_2[ 2 ],
        } );

      end;

    end;

  else

    private.SetInput( idx );

    local func_end = function ()

      int.Lock( false );

      ng_global.progress[ "std" ][ "win_ondoor" ].button = idx;

    end;
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_keystand_click" );
    ObjAnimate( "spr_ondoor_lock_"..ng_global.progress[ "std" ][ "win_ondoor" ].lock[ private.button[ idx ] ].."_light", "alp", 0, 0, func_end, 
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

  end;

end;
--*********************************************************************************************************************
function private.SaveProgress ()

  for i = 1, private.locks_count do

    ng_global.progress[ "std" ][ "win_ondoor" ].lock[ i ] = private.locks[ i ];

  end;

  ng_global.progress[ "std" ][ "win_ondoor" ].button = nil;

end;
--*********************************************************************************************************************
function private.SetInput ( idx )

  if ( not idx ) then

    for b = 1, private.buttons_count do

      ObjSet( "obj_ondoor_button_"..b, { input = true } );

    end;

  else

    for b = 1, private.buttons_count do

      ObjSet( "obj_ondoor_button_"..b, { input = false } );

    end;

    ObjSet( "obj_ondoor_button_"..idx,                         { input = true } );
    ObjSet( "obj_ondoor_button_"..private.button_input[ idx ], { input = true } );

  end;

end;
--*********************************************************************************************************************
function private.Animations ()

  ObjAnimate( "obj_ondoor_controltowerkey_trinket", "ang", 1, 0, "", 
  {
    0.0, 3, -0.05,
    1.3, 3,  0.05,
    2.6, 3, -0.05,
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************