-- name=level3

function public.Start ( param )

  int.WidgetAdd( InterfaceWidget_Pause, 1800 );

  int.WidgetAdd( InterfaceWidget_BtnMenu, 12 );


  int.WidgetAdd( InterfaceWidget_BtnHint, 9  );
  int.WidgetAdd( InterfaceWidget_BtnSkip, 9 );
  int.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  int.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  --int.WidgetAdd( InterfaceWidget_TaskHeader );
  int.WidgetAdd( InterfaceWidget_Inventory, 21 );
  int.WidgetAdd( InterfaceWidget_TaskPanel, 22 );
  int.WidgetAdd( InterfaceWidget_ItemPanel, 22 );

  int.WidgetAdd( InterfaceWidget_Effects, 23 );

  int.WidgetAdd( InterfaceWidget_BtnMap, 13 );

  int.WidgetAdd( InterfaceWidget_DialogHo );

  int.ButtonLockAdd();

  int.WidgetAdd( InterfaceWidget_FrameSubroom, 8 );

  int.WidgetAdd( InterfaceWidget_Popup, 31 );

  int.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  int.WidgetAdd( InterfaceWidget_Dialog );

  int.WidgetAdd( InterfaceWidget_DialogVideo, 1491 );
  int.WidgetAdd( InterfaceWidget_DialogStory, 1491 );
  int.WidgetAdd( InterfaceWidget_DialogCharacter, 1491 );

  int.WidgetAdd( InterfaceWidget_StrategyGuide );
  int.WidgetAdd( InterfaceWidget_Window );

  int.WidgetAdd( InterfaceWidget_Tutorial );
  int.WidgetAdd( InterfaceWidget_Map, 24  );
  int.PanelNotificationAdd();
  int.DeployInvAdd(9);
  int.DialogHintAdd( 10 );
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );
  int.InitMiniho( 18 );

  ObjSet( "int_button_map_impl",
  {
    alp = 0,
    input = false,
    visible = true,
    active = true
  } );   
    
  --
  private.Init();
  ModLoad( "assets/levels/level3/mod_level3_inv" );
  level3_inv.Init();
  --
  
  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

      int.WidgetAdd( InterfaceWidget_BtnGuide, 10 );
    interface.AchievementsAdd( 10 );
    int.MorphingAdd( 10 );
    int.CollectiblesAdd( 10 );
    int.Collectibles2Add( 22 );

  end;  

  common.LevelLoad( "level3", "std", "rm_policestation3", param, private.menu_moduls );
  
  private.TutorialSetParams(); 
  interface.KeyUpdate(); 
  int.UpdateTask( 3 );

  if not IsCollectorsEdition() and not IsSurveyEdition() then

    ObjSet( "btn_map_button_diary", { pos_x = 10 } );
    ObjSet( "btn_map_button_collectibles", { visible = 0, active = 0, input = 0  } );
    ObjSet( "btn_map_button_achievements", { visible = 0, active = 0, input = 0  } );    

    local collect = 
    {
      "get_collect2_3_1"
      ,"get_collect2_3_2"
      ,"get_collect2_3_3"
      ,"get_collect2_3_4"
    }
    local collect_morph = 
    {
      "get_morphobject_3_1"
      ,"get_morphobject_3_2"
      ,"get_morphobject_3_3"
      ,"get_morphobject_3_4"
      ,"get_morphobject_3_5"
      ,"get_morphobject_3_6"
    };

    for i = 1, #collect do
      cmn.SetEventDone( collect[ i ] );
      cmn.CallEventHandler( collect[ i ] );
    end;
    for i = 1, #collect_morph do
      cmn.SetEventDone( collect_morph[ i ] );
      cmn.CallEventHandler( collect_morph[ i ] );
    end;

  end;

end;

function private.Init ()

  game = {};
  game.room_names =
  {
     "rm_policestation3"
    ,"rm_waitinghall"
    ,"ho_crashreport"
    ,"rm_window"
    ,"rm_aircompaniesstand"
    ,"rm_secondfloorcorridor"
    ,"rm_technicalroom"
    ,"rm_controltower"
    ,"ho_hosecuritypoint"
    ,"mg_cashtill"
    ,"mg_ondoor"
    ,"mg_worriedmessage"
    ,"ho_serverroom"
  };

  game.progress_names =
  {
   "beg_level3"
  ,"opn_policestation3"
  ,"dlg_policestation3_jackie_1"
  ,"get_bird_1"
  ,"get_hanky3"
  ,"opn_crashreport"
  ,"win_crashreport"
  ,"dlg_policestation3_jackie_2"
  ,"see_pasttransfer3"

  ,"opn_waitinghall"
  ,"clk_waitinghall_survey"
  ,"get_threedollar_1"
  ,"get_threedollar_2"
  ,"get_securitybadge"

  ,"opn_window"  
  ,"clk_bag_pocket"
  ,"get_threedollar_3"
  ,"get_screw3"
  ,"use_threedollar"
  ,"clk_burger_1"
  ,"clk_burger_2"
  ,"get_cutlet"
  ,"use_cutlet"
  ,"get_cartwheel"  
  ,"get_screwdriver3"
  ,"use_cartwheel"
  ,"use_screw3"
  ,"use_screwdriver3"
  ,"clk_cart"

  ,"opn_aircompaniesstand"  
  ,"use_securitybadge"
  ,"win_securitypoint"
  ,"get_notloadedgun"
  ,"get_toggle3"
  ,"use_toggle3"
  ,"win_janitresstuff"
  ,"get_marksamulet_3"
  ,"get_boothbutton_1"
  ,"get_bird_2"
  ,"use_bird"
  ,"get_pencil"
  ,"use_pencil"
  ,"get_boothbutton_2"
  ,"use_boothbutton_1"
  ,"use_boothbutton_2"

  ,"opn_cashtill"
  ,"win_cashtill"
  ,"clk_cashtill"
  ,"get_twister"
  ,"use_twister"
  ,"get_bullet"
  ,"get_oil"
  ,"use_oil"
  ,"use_bullet"
  ,"get_gun"
  ,"use_gun"

  ,"opn_secondfloorcorridor"
  ,"vid_closing_door"
  ,"get_marksamulet_2"
  ,"get_bowknot"
  ,"get_glassshard"
  ,"use_glassshard"
  ,"clk_securitybag"
  ,"get_marksamulet_1"
  ,"use_marksamulet"
  ,"get_knittingneedle"
  ,"get_torch"
  ,"use_knittingneedle"
  ,"get_lamp"
  ,"clk_torch"
  ,"clk_torch1"
  ,"use_lamp"
  ,"get_mountedtorch"
  ,"use_mountedtorch"
  ,"clk_switch3"

  ,"opn_hosecuritypoint"
  ,"win_hosecuritypoint"
  ,"use_trianglekey3"

  ,"opn_technicalroom"
  ,"get_staramulet"
  ,"get_purse3"
  ,"use_bowknot"
  ,"get_pattern_1"
  ,"get_handle3"
  ,"see_scare_3_1"
  ,"use_handle3"
  ,"get_spade"
  ,"use_staramulet"
  ,"get_pattern_2"
  ,"use_spade"
  ,"get_pattern_3"
  ,"get_figure7"
  ,"use_figure7"
  ,"get_shell_1"
  ,"get_pattern_4"
  ,"use_pattern"

  ,"opn_ondoor"
  ,"win_ondoor"
  ,"get_controltowerkey"
  ,"get_cleaningagent"
  ,"use_cleaningagent"
  ,"use_hanky3"
  ,"use_controltowerkey"
  ,"clk_controltowerkey"
  ,"win_controltowerdoor"

  ,"opn_controltower"
  ,"see_atropos_3_1"
  ,"get_ruler"
  ,"get_wire3_1"
  ,"use_ruler"
  ,"get_snowdropamulet"
  ,"get_switch3_1"
  ,"get_glue3"
  ,"use_snowdropamulet"
  ,"win_janitresdaughter"
  ,"get_brokenframe"
  ,"get_toyscissors"
  ,"use_toyscissors"
  ,"get_photo3"
  ,"clk_framepart_1"
  ,"clk_framepart_2"
  ,"clk_framepart_3"
  ,"clk_framepart_4"
  ,"clk_framepart_5"
  ,"clk_framepart_6"
  ,"use_glue3"
  ,"use_photo3"
  ,"get_framedpic"
  ,"use_framedpic"
  ,"get_switch3_2"
  ,"get_airhostess"
  ,"use_switch3"
  ,"clk_booklet"
  ,"get_pass"
  ,"use_pass"

  ,"opn_serverroom"
  ,"win_serverroom"
  ,"clk_oldbackpack"
  ,"get_pilot"
  ,"get_wire3_2"
  ,"get_wrench3"
  ,"use_wrench3"
  ,"get_planeamulet"
  ,"use_planeamulet"
  ,"get_mechanic"
  ,"get_button_1"
  ,"use_mechanic"
  ,"use_pilot"
  ,"use_airhostess"
  ,"get_wire3_3"
  ,"get_shell_2"
  ,"use_shell"
  ,"get_button_2"
  ,"use_wire3"
  ,"win_controlpanel"
  ,"get_pliers3"
  ,"use_pliers3"
  ,"get_diamond"
  ,"use_diamond"
  ,"get_keyboard"
  ,"get_tweezers3"
  ,"use_tweezers3"
  ,"get_demonmedallion"
  ,"use_demonmedallion"
  ,"win_stand3"
  ,"get_lever3"
  ,"use_lever3"
  ,"clk_brokenkeyboard"
  ,"use_keyboard"
  ,"use_button_1"
  ,"use_button_2"

  ,"opn_worriedmessage"
  ,"clk_lever_mg"
  ,"clk_keyboard_mg"
  ,"win_worriedmessage"
  ,"get_morphobject_3_1"
  ,"get_morphobject_3_2"
  ,"get_morphobject_3_3"
  ,"get_morphobject_3_4"
  ,"get_morphobject_3_5"
  ,"get_morphobject_3_6"
  ,"get_collect2_3_1"
  ,"get_collect2_3_2"
  ,"get_collect2_3_3"
  ,"get_collect2_3_4"
  };

  game.relations = {};
  
  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      --"rm_collectibles2",
      "rm_collectibles",
      "rm_achievements",
    }
    for i = 1, #menu_moduls_ce do
      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );
    end;

  end;  

end;

function private.TutorialSetParams()

  if not ng_global.progress[ "std" ][ "see_tutorial" ] then

    ng_global.progress[ "std" ][ "see_tutorial" ] = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].done  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].start = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].state.no = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage = "tutorial_page_1";
    ng_global.progress[ "std" ][ "see_tutorial" ].func = function() end;
    
    local offset = 0;

    if ( GetWideScreen() ) then

      offset = 0.5 * ( GetAppWidth() - 1024 );

    end;

      ng_global.progress[ "std" ][ "see_tutorial" ].state.pages = {

      [ "tutorial_page_1" ]  = { shown = 0, noskip = true,  posx = 512, posy = 250, input = true,  arrows = {} },       -- Показать туториал?

      [ "tutorial_page_2" ] = { shown = 0, noskip = false, posx = 512, posy = 170, arrows = { 
                                                                              { pos_x = 230, pos_y = 200, ang =  2.0 }
                                                                            } },   -- �� �����

      [ "tutorial_page_3" ] = { shown = 0, noskip = false, posx = 512, posy = 330, arrows = { 
                                                                              { pos_x = 120, pos_y = 0, ang =  1.57, target = "obj_int_button_info" }
                                                                            } },   -- ������ ���� � ��
      [ "tutorial_page_4" ] = { shown = 0, noskip = false, posx = 512, posy = 330, arrows = { 
                                                                              { pos_x = 120, pos_y = 0, ang =  1.57,  target = "obj_int_button_reset" },
                                                                              { pos_x = 100, pos_y = -50, ang = -4,  target = "int_button_skip_impl" }
                                                                            } },   -- ������ ���� � ��
      [ "tutorial_page_5" ] = { shown = 0, noskip = false, posx = 600, posy = 320, arrows = { 
                                                                              { pos_x = -100, pos_y = -2, ang = -1.57, target = "obj_int_button_clue" }
                                                                            } },   -- ���� � ������ ���� � ���� ��� �������� ��������.
      [ "tutorial_page_6" ] = { shown = 0, noskip = false, posx = 600, posy = 350, arrows = { 
                                                                              { pos_x = -100, pos_y = 80, ang = -1.57, target = "obj_int_button_clue" }
                                                                            } },   -- ���� �� ������ � ������ �����.
      [ "tutorial_page_7" ] = { shown = 0, noskip = false, posx = 600, posy = 350, arrows = { 
                                                                              { pos_x = -100, pos_y = 176, ang = -1.57, target = "obj_int_button_clue" }
                                                                            } },   -- ������ ����� ���� ����.
      [ "tutorial_page_8" ] = { shown = 0, noskip = false, posx = 700, posy = 200, arrows = { 
                                                                              { pos_x = 850, pos_y = 400, ang = -2.3 }
                                                                            } },  -- 
      [ "tutorial_page_9" ] = { shown = 0, noskip = false, posx = 550, posy = 300, arrows = { 
                                                                              { pos_x = 800, pos_y = 250, ang = -1.2 }
                                                                            } },  -- ������� � �� ������ �����.
      [ "tutorial_page_10" ] = { shown = 0, noskip = fase, posx = 650, posy = 400, arrows = { 
                                                                              { pos_x = 50, pos_y = -50, ang =  2.14, target = "spr_deerhead_familyring"}
                                                                            } },   -- ������ �� ������.
      [ "tutorial_page_11" ] = { shown = 0, noskip = false, posx = 512, posy = 400, arrows = { 
                                                                              { pos_x = 512, pos_y = 600, ang = 3.14 }
                                                                              --{ pos_x = 40, pos_y = 200, ang =  0.5 }
                                                                            } },   -- ������ �� ���������
      [ "tutorial_page_12" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                              { pos_x = 200, pos_y = 200, ang =  2.14 }
                                                                            } },   
      [ "tutorial_page_13" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                              { pos_x = 200, pos_y = 250, ang =  2.14 }
                                                                            } },   -- ������ �� ����� � �������
      [ "tutorial_page_14" ] = { shown = 0, noskip = false, posx = 512, posy = 400, arrows = { 
                                                                              { pos_x = 512, pos_y = 600, ang = 3.14 }
                                                                            } },   -- ����� ��� ��������
      [ "tutorial_page_15" ] = { shown = 0, noskip = false, posx = 512, posy = 400, arrows = { 
                                                                              { pos_x = 820, pos_y = 650, ang = 3.14 }
                                                                            } },   -- ���������� ��������
      [ "tutorial_page_16" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                              { pos_x = 450, pos_y = 360, ang =  2.3 }
                                                                            } },   -- 
      [ "tutorial_page_17" ] = { shown = 0, noskip = false, posx = 300, posy = 400, arrows = { 
                                                                              { pos_x = 130, pos_y = 0, ang = 2.3, target = "int_button_hint_impl" }
                                                                            } },   -- �� ����

      [ "tutorial_page_18" ] = { shown = 0, noskip = false, posx = 512, posy = 350, arrows = { 
                                                                              { pos_x = 100, pos_y = 0, ang =  1.6, target = "spr_focus_arrow_left" }
                                                                            } },   -- ������� �� �������
      --[ "tutorial_page_19" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
      --                                                                        { pos_x = 100, pos_y = 0, ang =  1.72, target = "spr_focus_arrow_right" },
      --                                                                        { pos_x = 100, pos_y = 0, ang =  1.72, target = "spr_focus_arrow_left" }
      --                                                                      } },   -- ???????? ?? ??????? 
      [ "tutorial_page_19" ] = { shown = 0, noskip = false, posx = 512, posy = 400, arrows = { 
                                                                                    { pos_x = 512, pos_y = 600, ang = 3.14 }
                                                                                  } },   -- ��_����������
      [ "tutorial_page_20" ] = { shown = 0, noskip = false, posx = 512, posy = 400, arrows = { 
                                                                                    { pos_x = 512, pos_y = 600, ang = 3.14 }
                                                                                  } },   -- ��_������ ������
      [ "tutorial_page_22" ] = { shown = 0, noskip = false, posx = 512, posy = 400, arrows = { 
                                                                                    { pos_x = 0, pos_y = -80, ang = -3.14, target = "hub_int_inventory_messagebox" }
                                                                                  } },   -- ������� �����������
      [ "tutorial_page_23" ] = { shown = 0, noskip = false, posx = 512, posy = 400, arrows = { 
                                                                                    { pos_x = 0, pos_y = -80, ang = -3.14, target = "hub_int_inventory_brokenfishingrod" }
                                                                                  } },   -- ������� �����������
      [ "tutorial_page_21" ] = { shown = 0, noskip = false, posx = 250, posy = 300, arrows = { 
                                                                              { pos_x = 500, pos_y = 350, ang = -1.5 }
                                                                                     } },   -- ��_������ ������
      [ "tutorial_page_30" ] = { shown = 0, noskip = false, posx = 620, posy = 380, input = false, arrows = { 
                                                                              { pos_x = 0, pos_y = -90, ang = 3.14, target = "int_itempanel_impl" }, 
                                                                              { pos_x = 260, pos_y = 400, ang = 2.2 }  
                                                                                                                } },   -- ��_������ ������
      [ "tutorial_page_31" ] = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = { 
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "int_itempanel_impl" },  
                                                                              { pos_x = 80, pos_y = -180, ang = -2.2, target = "int_itempanel_impl" }                                              } },  -- ������� � ��������.
   };

  end;
  
end;
--***********************************************************************************************************************************
--***********************************************************************************************************************************