-- name=level3_inv
--*********************************************************************************************************************
function public.Init ()
  if port.isPortable() == 1 then
    
    port.InventoryPopupInit("level3_inv_hub");
    port.VideoResizeInRoom("level3_inv");
  end;
  
  private.notloadedgun_init();
  private.torch_init();
  private.purse3_init();
  private.brokenframe_init(); 
  private.oldbackpack_init();

  int.CreateDeployPlus( 3 );


  --MsgSubscribe( Command_Interface_UpdateGameMode, private.UpdateGameMode );

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_level3_inv_deploy = function ()

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    common_impl.TurnChildGfx( { "level3_inv_deploy" } , "level3_inv_deploy", visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_level3_inv_deploy", update_game_mode_level3_inv_deploy, nil );

end;
--*********************************************************************************************************************
-- function *** notloadedgun *** ()
--*********************************************************************************************************************
  function private.notloadedgun_init ()

    ObjSet( "spr_deploy_inv_notloadedgun_gun",  { event_mdown = private.get_gun } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_gun" ] =
    {
      type = "get",
      get_obj = "obj_deploy_inv_notloadedgun_get_bullet_hint",
      room = "int_deploy_inv",
      zz = "deploy_inv_notloadedgun",
      zz_gate = "inv_notloadedgun"
    };
    -------------------------------------------------------------------------------------------
    function get_gun_inv ()

      interface.InventoryItemRemove( "inv_notloadedgun" );
      interface.InventoryItemAdd( "inv_gun", "spr_deploy_inv_notloadedgun_gun" );

      ObjDelete( "gfx_deploy_inv_notloadedgun_gun" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_gun", get_gun_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_oil" ] =
    {
      type = "use",
      use_obj = "inv_oil",
      use_place = "obj_deploy_inv_notloadedgun_use_oil",
      room = "int_deploy_inv",
      zz = "deploy_inv_notloadedgun",
      zz_gate = "inv_notloadedgun"
    };
    -------------------------------------------------------------------------------------------
    function use_oil_inv ()
  
      interface.InventoryItemRemove( "inv_oil" );
      if not cmn.IsEventDone( "get_bullet" ) then
        ObjSet( "inv_notloadedgun_plus_focus2", { alp = 0 } );
      end;
      ObjDelete( "spr_notloadedgun_rust" );
      --ObjSet( "inv_notloadedgun", { res = "assets/levels/level2/common_inventory2/inv_notloadedgun/inv/inv_gun" } );

    end;
    function use_oil_beg ()

      ObjDelete( "obj_deploy_inv_notloadedgun_use_oil" );

    end;
    function use_oil_end ()

      ObjDelete( "anm_deploy_inv_notloadedgun_oiluse" );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_oil", use_oil_beg, "inv_notloadedgun" );
    cmn.AddSubscriber( "use_oil", use_oil_inv );
    cmn.AddSubscriber( "use_oil", use_oil_end, "inv_notloadedgun" );
    cmn.AddSubscriber( "use_oil_inv", use_oil_inv );
    cmn.AddSubscriber( "use_oil_beg", use_oil_beg, "inv_notloadedgun" );
    cmn.AddSubscriber( "use_oil_end", use_oil_end, "inv_notloadedgun" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_bullet" ] =
    {
      type = "use",
      use_obj = "inv_bullet",
      use_place = "obj_deploy_inv_notloadedgun_use_bullet",
      room = "int_deploy_inv",
      zz = "deploy_inv_notloadedgun",
      zz_gate = "inv_notloadedgun"
    };
    -------------------------------------------------------------------------------------------
    function use_bullet_inv ()
  
      interface.InventoryItemRemove( "inv_bullet" );
      --ObjSet( "inv_notloadedgun", { res = "assets/levels/level2/common_inventory2/inv_notloadedgun/inv/inv_gun" } );

    end;
    function use_bullet_beg ()

      ObjDelete( "obj_deploy_inv_notloadedgun_use_bullet" );

    end;
    function use_bullet_end ()

      ObjSet( "spr_deploy_inv_notloadedgun_bullet", { pos_x = 105 } );
      ObjSet( "spr_deploy_inv_notloadedgun_gun", { input = true } );
      ObjSet( "gfx_deploy_inv_notloadedgun_gun", { active = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_bullet", use_bullet_beg, "inv_notloadedgun" );
    cmn.AddSubscriber( "use_bullet", use_bullet_inv );
    cmn.AddSubscriber( "use_bullet", use_bullet_end, "inv_notloadedgun" );
    cmn.AddSubscriber( "use_bullet_inv", use_bullet_inv );
    cmn.AddSubscriber( "use_bullet_beg", use_bullet_beg, "inv_notloadedgun" );
    cmn.AddSubscriber( "use_bullet_end", use_bullet_end, "inv_notloadedgun" );
    -------------------------------------------------------------------------------------------

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.get_gun ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_gun" );
    cmn.CallEventHandler( "get_gun", "inv_notloadedgun" );

    int.DeployInvHide();

  end;
--*********************************************************************************************************************
  function public.use_oil ()

    local item = "inv_oil";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_notloadedgun_use_oil" ) ) then

      cmn.CallEventHandler( "use_oil_inv" );
      cmn.CallEventHandler( "use_oil_beg", "inv_notloadedgun" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_oil" );
        cmn.CallEventHandler( "use_oil_end", "inv_notloadedgun" );
      
      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_wash_pistol" );
      AnimPlay( "anm_deploy_inv_notloadedgun_oiluse", "DoAnim", func_end ) 

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
  function public.use_bullet ()

    local item = "inv_bullet";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_notloadedgun_use_bullet" ) ) and
       ( cmn.IsEventDone( "use_oil" ) ) then

      cmn.CallEventHandler( "use_bullet_inv" );
      cmn.CallEventHandler( "use_bullet_beg", "inv_notloadedgun" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_bullet" );
        cmn.CallEventHandler( "use_bullet_end", "inv_notloadedgun" );
      
      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_insert_bullet" );
      ObjAnimate("spr_deploy_inv_notloadedgun_bullet", "pos_x", 0, 0, func_end, 
      {
        0.0,0, 730,
        0.6,2, 105
      } );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
-- function *** torch *** ()
--*********************************************************************************************************************
  function private.torch_init ()

    ObjSet( "spr_deploy_inv_torch_mountedtorch",  { event_mdown = private.get_mountedtorch } );
    ObjSet( "obj_deploy_inv_torch_clk",  { event_mdown = private.clk_torch } );
    ObjSet( "obj_deploy_inv_torch_clk1",  { event_mdown = private.clk_torch1 } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_mountedtorch" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_torch_mountedtorch",
      room = "int_deploy_inv",
      zz = "deploy_inv_torch",
      zz_gate = "inv_torch"
    };
    -------------------------------------------------------------------------------------------
    function get_mountedtorch_inv ()

      interface.InventoryItemRemove( "inv_torch" );
      interface.InventoryItemAdd( "inv_mountedtorch", "spr_deploy_inv_torch_mountedtorch" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_mountedtorch", get_mountedtorch_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_torch" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_torch_clk",
      room = "int_deploy_inv",
      zz = "deploy_inv_torch",
      zz_gate = "inv_torch"
    };
    -------------------------------------------------------------------------------------------
    function clk_torch_inv ()

      ObjSet( "inv_torch", { res = "assets/levels/level3/common_inventory3/inv_torch/inv/inv_torch" } );
      ObjSet( "spr_torch_glass", { alp = 1 } );

    end;
    -------------------------------------------------------------------------------------------
    function clk_torch_beg ()

      ObjDelete( "obj_deploy_inv_torch_clk" );

    end;
    function clk_torch_end ()

      ObjSet( "obj_deploy_inv_torch_clk1", { input = true } );
      ObjDelete( "spr_deploy_inv_torch_glass_broken" );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_torch", clk_torch_inv );
    cmn.AddSubscriber( "clk_torch_inv", clk_torch_inv );
    cmn.AddSubscriber( "clk_torch", clk_torch_beg, "inv_torch" );
    cmn.AddSubscriber( "clk_torch", clk_torch_end, "inv_torch" );
    cmn.AddSubscriber( "clk_torch_beg", clk_torch_beg, "inv_torch" );
    cmn.AddSubscriber( "clk_torch_end", clk_torch_end, "inv_torch" );
    -------------------------------------------------------------------------------------------  
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_torch1" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_torch_clk1",
      room = "int_deploy_inv",
      zz = "deploy_inv_torch",
      zz_gate = "inv_torch"
    };
    -------------------------------------------------------------------------------------------
    function clk_torch1_inv ()

      if not cmn.IsEventDone( "get_lamp" ) then
        ObjSet( "inv_torch_plus_focus2", { alp = 0 } );
      end;
      ObjDelete( "spr_torch_glass" );

    end;
    function clk_torch1_beg ()

      ObjDelete( "obj_deploy_inv_torch_clk1" );

    end;
    function clk_torch1_end ()

      ObjSet( "obj_deploy_inv_torch_use_lamp", { input = true } );
      ObjDelete( "spr_deploy_inv_torch_lamp_broken" );


    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_torch1", clk_torch1_beg, "inv_torch" );
    cmn.AddSubscriber( "clk_torch1", clk_torch1_inv );
    cmn.AddSubscriber( "clk_torch1", clk_torch1_end, "inv_torch" );
    cmn.AddSubscriber( "clk_torch1_beg", clk_torch1_beg, "inv_torch" );
    cmn.AddSubscriber( "clk_torch1_inv", clk_torch1_inv );
    cmn.AddSubscriber( "clk_torch1_end", clk_torch1_end, "inv_torch" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_lamp" ] =
    {
      type = "use",
      use_obj = "inv_lamp",
      use_place = "obj_deploy_inv_torch_use_lamp",
      room = "int_deploy_inv",
      zz = "deploy_inv_torch",
      zz_gate = "inv_torch"
    };
    -------------------------------------------------------------------------------------------
    function use_lamp_inv ()
  
      interface.InventoryItemRemove( "inv_lamp" ); 
      ObjSet( "spr_torch_lamp", { alp = 1 } );
      ObjSet( "spr_torch_light_add", { alp = 1 } ); 
    
    end;
    function use_lamp_beg ()

      ObjDelete( "obj_deploy_inv_torch_use_lamp" );

    end;
    function use_lamp_end ()

      ObjSet( "spr_deploy_inv_torch_mountedtorch", { input = true } );
      ObjSet( "gfx_deploy_inv_torch_mountedtorch", { active = true } );
      ObjSet( "spr_deploy_inv_torch_lamp", { alp = 1 } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_lamp", use_lamp_beg, "inv_torch" );
    cmn.AddSubscriber( "use_lamp", use_lamp_inv );
    cmn.AddSubscriber( "use_lamp", use_lamp_end, "inv_torch" );
    cmn.AddSubscriber( "use_lamp_inv", use_lamp_inv );
    cmn.AddSubscriber( "use_lamp_beg", use_lamp_beg, "inv_torch" );
    cmn.AddSubscriber( "use_lamp_end", use_lamp_end, "inv_torch" );
    ------------------------------------------------------------------------------------------- 

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.get_mountedtorch ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_mountedtorch" );
    cmn.CallEventHandler( "get_mountedtorch", "inv_torch" );

    int.DeployInvHide();

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.clk_torch ()

    cmn.CallEventHandler( "clk_torch_beg", "inv_torch" );
    cmn.CallEventHandler( "clk_torch_inv" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_torch" );
      cmn.CallEventHandler( "clk_torch_end", "inv_torch" );
    
    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_lamp_unglass" );

    ObjAnimate("spr_deploy_inv_torch_glass_broken", "alp", 0, 0, func_end, 
    {
      0.0,0,1,
      0.3,0,0
    });

    return true;

  end;
  --*********************************************************************************************************************
  function private.clk_torch1 ()

    cmn.CallEventHandler( "clk_torch1_inv" );
    cmn.CallEventHandler( "clk_torch1_beg", "inv_torch" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_torch1" );
      cmn.CallEventHandler( "clk_torch1_inv" );
      cmn.CallEventHandler( "clk_torch1_end", "inv_torch" );
    
    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_lamp_unlamp" );

    ObjAnimate("spr_deploy_inv_torch_lamp_broken", "alp", 0, 0, func_end, 
    {
      0.0,0,1,
      0.3,0,0
    });

    return true;

  end;
--*********************************************************************************************************************
  function public.use_lamp ()

    local item = "inv_lamp";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_torch_use_lamp" ) ) and
       ( cmn.IsEventDone( "clk_torch1" ) )  then

      cmn.CallEventHandler( "use_lamp_inv" );
      cmn.CallEventHandler( "use_lamp_beg", "inv_torch" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_lamp" );
        cmn.CallEventHandler( "use_lamp_end", "inv_torch" );
      
      end;

      int.Lock( true );
      
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_lamp_screwlamp" );
      ObjAnimate("spr_deploy_inv_torch_lamp", "alp", 0, 0, func_end, 
      {
        0.0,0,0,
        0.3,0,1
      });

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
-- function *** purse3 *** ()
--*********************************************************************************************************************
  function private.purse3_init ()

    ObjSet( "spr_deploy_inv_shell_1",           { event_mdown = private.get_shell_1 } );
    ObjSet( "spr_deploy_inv_pattern_4",         { event_mdown = private.get_pattern_4 } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_shell_1" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_shell_1",
      room = "int_deploy_inv",
      zz = "deploy_inv_purse3",
      zz_gate = "inv_purse3"
    };
    -------------------------------------------------------------------------------------------
    function get_shell_1_inv ()

      if ( cmn.IsEventDone( "get_pattern_4" ) ) then

        interface.InventoryItemRemove( "inv_purse3" )        

      end;

      interface.InventoryItemAdd( "inv_shell", "spr_deploy_inv_shell_1", "assets/levels/level3/common_inventory3/inv_purse3/inv/part3_morph" );
      public.CheckShell();

      ObjDelete( "spr_deploy_inv_shell_1_shadow" );
      ObjDelete( "gfx_deploy_inv_shell_1" );
      ObjDelete( "spr_purse3_shell" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_shell_1", get_shell_1_inv );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_pattern_4" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_pattern_4",
      room = "int_deploy_inv",
      zz = "deploy_inv_purse3",
      zz_gate = "inv_purse3"
    };
    -------------------------------------------------------------------------------------------
    function get_pattern_4_inv ()

      public.CheckPattern();
      if ( cmn.IsEventDone( "get_shell_1" ) ) then

        interface.InventoryItemRemove( "inv_purse3" );        

      end;

      interface.InventoryItemAdd( "inv_pattern", "spr_deploy_inv_pattern_4", "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/inv/inv_pattern_4_morph" );

      ObjDelete( "spr_deploy_inv_pattern_4_shadow" );
      ObjDelete( "gfx_deploy_inv_pattern_4" );
      ObjDelete( "spr_purse3_pattern" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_pattern_4", get_pattern_4_inv );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_figure7" ] =
    {
      type = "use",
      use_obj = "inv_figure7",
      use_place = "obj_deploy_inv_use_figure7",
      room = "int_deploy_inv",
      zz = "deploy_inv_purse3",
      zz_gate = "inv_purse3"
    };
    -------------------------------------------------------------------------------------------
    function use_figure7_inv ()
  
      interface.InventoryItemRemove( "inv_figure7" );

      ObjSet( "inv_purse3", { res = "assets/levels/level3/common_inventory3/inv_purse3/inv/inv_purse3" } );
      ObjSet( "obj_purse3_open", { alp = 1 } );
      ObjSet( "spr_purse3_shell", { alp = 1 } );
      ObjSet( "spr_purse3_pattern", { alp = 1 } );

    end;
    function use_figure7_beg ()

      ObjDelete( "obj_deploy_inv_use_figure7" );

    end;
    function use_figure7_end ()

      ObjDelete( "obj_deploy_inv_purse3_closed" );
      ObjSet( "obj_deploy_inv_purse3_open",    { alp = 1, input = true } );
      ObjSet( "spr_deploy_inv_shell_1", { input = true } );
      ObjSet( "spr_deploy_inv_pattern_4", { input = true } );
      ObjSet( "gfx_deploy_inv_shell_1", { active = true } );
      ObjSet( "gfx_deploy_inv_pattern_4", { active = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_figure7", use_figure7_beg, "inv_purse3" );
    cmn.AddSubscriber( "use_figure7", use_figure7_inv );
    cmn.AddSubscriber( "use_figure7", use_figure7_end, "inv_purse3" );
    cmn.AddSubscriber( "use_figure7_inv", use_figure7_inv );
    cmn.AddSubscriber( "use_figure7_beg", use_figure7_beg, "inv_purse3" );
    cmn.AddSubscriber( "use_figure7_end", use_figure7_end, "inv_purse3" );
  end;
  --*********************************************************************************************************************
  function private.get_shell_1 ()

    cmn.GetObjectSfx();

    cmn.SetEventDone( "get_shell_1" );
    cmn.CallEventHandler( "get_shell_1", "inv_shell_1" );

    if ( cmn.IsEventDone( "get_pattern_4" ) ) then

      int.DeployInvHide();

    end;

  end;
  --*********************************************************************************************************************
  function private.get_pattern_4 ()

    cmn.GetObjectSfx();

    cmn.SetEventDone( "get_pattern_4" );
    cmn.CallEventHandler( "get_pattern_4", "inv_pattern_4" );

    if ( cmn.IsEventDone( "get_shell_1" ) ) then

      int.DeployInvHide();

    end;

  end;
  --*********************************************************************************************************************
  function public.use_figure7 ()

    local item = "inv_figure7";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_use_figure7", "deploy_inv_purse3" ) ) then

      cmn.CallEventHandler( "use_figure7_inv" );
      cmn.CallEventHandler( "use_figure7_beg", "inv_purse3" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_figure7" );
        cmn.CallEventHandler( "use_figure7_end", "inv_purse3" );
      
      end;

      int.Lock( true );

      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_nuts_amulet" );
      ObjAnimate( "spr_deploy_inv_purse3_figure7", "alp", 0, 0, "", 
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

      ObjAnimate( "obj_deploy_inv_purse3_open", "alp", 0, 0, "", 
      {
        0.0, 3, 0.0,
        0.5, 3, 0.0,
        0.8, 3, 1.0,
      } );

      ObjAnimate( "obj_deploy_inv_purse3_closed", "alp", 0, 0, func_end, 
      {
        0.0, 3, 1.0,
        0.5, 3, 1.0,
        0.8, 3, 0.0,
      } );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
-- function *** brokenframe *** ()
--*********************************************************************************************************************
  function private.brokenframe_init ()

    private.fin_pos = {
      {  -6,-131},
      {-230,-123},
      { 116, -17},
      {  30, 116},
      {-165, 116},
      {-231,  57}
    }

    private.init_pos = {
      { -36,-206,-0.1},
      {-337,-137,0.15},
      { 124, -88,-0.1},
      {  17, 180,   0},
      {-205, 152,-0.1},
      {-332,  73,   0},
    }

    for i=1, 6 do
      ObjSet( "spr_deploy_inv_brokenframe_part_"..i, {
        input = true,
        event_mdown = function () private.clk_framepart( i ); end,
        event_menter = function () cmn.SetCursor(CURSOR_HAND); end,
        event_mleave = function () cmn.SetCursor(CURSOR_DEFAULT); end
      });
    end;

   ObjSet( "obj_deploy_inv_brokenframe_get_framedpic", {
      event_mdown = private.get_framedpic,
      event_menter = function () cmn.SetCursor(CURSOR_GET); end,
      event_mleave = function () cmn.SetCursor(CURSOR_DEFAULT); end
    } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_framedpic" ] =
    {
      type = "get",
      get_obj = "obj_deploy_inv_brokenframe",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenframe",
      zz_gate = "inv_brokenframe"
    };
    -------------------------------------------------------------------------------------------
    function get_framedpic_inv ()

      interface.InventoryItemRemove( "inv_brokenframe" );
      interface.InventoryItemAdd( "inv_framedpic", "obj_deploy_inv_brokenframe" );

      ObjDelete( "gfx_deploy_inv_brokenframe_get_framedpic" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_framedpic", get_framedpic_inv );
    -------------------------------------------------------------------------------------------  
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_framepart_1" ] =
    {
      type = "click",
      clk_obj = "spr_deploy_inv_brokenframe_part_1",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenframe",
      zz_gate = "inv_brokenframe"
    };
    -------------------------------------------------------------------------------------------
    function clk_framepart_1 ()

      ObjSet( "spr_deploy_inv_brokenframe_part_1", { 
        pos_x = private.fin_pos[ 1 ][ 1 ], 
        pos_y = private.fin_pos[ 1 ][ 2 ], 
        ang = 0,
        input = false
      } );
      private.check_fragments();

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_framepart_1", clk_framepart_1, "inv_brokenframe" );
    -------------------------------------------------------------------------------------------  
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_framepart_2" ] =
    {
      type = "click",
      clk_obj = "spr_deploy_inv_brokenframe_part_2",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenframe",
      zz_gate = "inv_brokenframe"
    };
    -------------------------------------------------------------------------------------------
    function clk_framepart_2 ()

      ObjSet( "spr_deploy_inv_brokenframe_part_2", { 
        pos_x = private.fin_pos[ 2 ][ 1 ], 
        pos_y = private.fin_pos[ 2 ][ 2 ], 
        ang = 0,
        input = false
      } );
      private.check_fragments();

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_framepart_2", clk_framepart_2, "inv_brokenframe" );
    -------------------------------------------------------------------------------------------  
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_framepart_3" ] =
    {
      type = "click",
      clk_obj = "spr_deploy_inv_brokenframe_part_3",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenframe",
      zz_gate = "inv_brokenframe"
    };
    -------------------------------------------------------------------------------------------
    function clk_framepart_3 ()

      ObjSet( "spr_deploy_inv_brokenframe_part_3", { 
        pos_x = private.fin_pos[ 3 ][ 1 ], 
        pos_y = private.fin_pos[ 3 ][ 2 ], 
        ang = 0,
        input = false
      } );
      private.check_fragments();

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_framepart_3", clk_framepart_3, "inv_brokenframe" );
    -------------------------------------------------------------------------------------------  
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_framepart_4" ] =
    {
      type = "click",
      clk_obj = "spr_deploy_inv_brokenframe_part_4",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenframe",
      zz_gate = "inv_brokenframe"
    };
    -------------------------------------------------------------------------------------------
    function clk_framepart_4 ()

      ObjSet( "spr_deploy_inv_brokenframe_part_4", { 
        pos_x = private.fin_pos[ 4 ][ 1 ], 
        pos_y = private.fin_pos[ 4 ][ 2 ], 
        ang = 0,
        input = false
      } );
      private.check_fragments();

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_framepart_4", clk_framepart_4, "inv_brokenframe" );
    -------------------------------------------------------------------------------------------  
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_framepart_5" ] =
    {
      type = "click",
      clk_obj = "spr_deploy_inv_brokenframe_part_5",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenframe",
      zz_gate = "inv_brokenframe"
    };
    -------------------------------------------------------------------------------------------
    function clk_framepart_5 ()

      ObjSet( "spr_deploy_inv_brokenframe_part_5", { 
        pos_x = private.fin_pos[ 5 ][ 1 ], 
        pos_y = private.fin_pos[ 5 ][ 2 ], 
        ang = 0,
        input = false
      } );
      private.check_fragments();

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_framepart_5", clk_framepart_5, "inv_brokenframe" );
    -------------------------------------------------------------------------------------------  
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_framepart_6" ] =
    {
      type = "click",
      clk_obj = "spr_deploy_inv_brokenframe_part_6",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenframe",
      zz_gate = "inv_brokenframe"
    };
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    function clk_framepart_6 ()

      ObjSet( "spr_deploy_inv_brokenframe_part_6", { 
        pos_x = private.fin_pos[ 6 ][ 1 ], 
        pos_y = private.fin_pos[ 6 ][ 2 ], 
        ang = 0,
        input = false
      } );
      private.check_fragments();      

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_framepart_6", clk_framepart_6, "inv_brokenframe" );
    -------------------------------------------------------------------------------------------  
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_glue3" ] =
    {
      type = "use",
      use_obj = "inv_glue3",
      use_place = "obj_deploy_inv_brokenframe_use_glue3",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenframe",
      zz_gate = "inv_brokenframe"
    };
    -------------------------------------------------------------------------------------------
    function use_glue3_inv ()
  
      interface.InventoryItemRemove( "inv_glue3" );
      if not cmn.IsEventDone( "get_photo3" ) then
        ObjSet( "inv_brokenframe_plus_focus2", { alp = 0 } );
      end;

    end;
    function use_glue3_beg ()

      ObjDelete( "obj_deploy_inv_brokenframe_use_glue3" );

    end;
    function use_glue3_end ()

      ObjSet( "obj_deploy_inv_brokenframe_use_photo3", { input = true } );
      ObjSet( "spr_deploy_inv_brokenframe_glue_used", { alp = 1 } );
      ObjSet( "obj_deploy_inv_brokenframe_mmg", { alp = 1 } );
      ObjSet( "spr_inv_brokenframe_glue", { alp = 1 } );
      ObjDelete( "anm_deploy_inv_brokenframe_use_glue3" );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_glue3", use_glue3_beg, "inv_brokenframe" );
    cmn.AddSubscriber( "use_glue3", use_glue3_inv );
    cmn.AddSubscriber( "use_glue3", use_glue3_end, "inv_brokenframe" );
    cmn.AddSubscriber( "use_glue3_inv", use_glue3_inv );
    cmn.AddSubscriber( "use_glue3_beg", use_glue3_beg, "inv_brokenframe" );
    cmn.AddSubscriber( "use_glue3_end", use_glue3_end, "inv_brokenframe" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_photo3" ] =
    {
      type = "use",
      use_obj = "inv_photo3",
      use_place = "obj_deploy_inv_brokenframe_use_photo3",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenframe",
      zz_gate = "inv_brokenframe"
    };
    -------------------------------------------------------------------------------------------
    function use_photo3_inv ()
  
      interface.InventoryItemRemove( "inv_photo3" );

    end;
    function use_photo3_beg ()

      ObjDelete( "obj_deploy_inv_brokenframe_use_photo3" );

    end;
    function use_photo3_end ()

      ObjSet( "spr_deploy_inv_brokenframe_photo", { alp = 1 } );
      ObjSet( "inv_brokenframe", { res = "assets/levels/level3/common_inventory3/inv_brokenframe/inv/inv_framedpic" } );
      ObjSet( "obj_deploy_inv_brokenframe_get_framedpic", { input = true } );
      ObjSet( "gfx_deploy_inv_brokenframe_get_framedpic", { active = true } );
      ObjDelete( "anm_deploy_inv_brokenframe_use_photo3" );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_photo3", use_photo3_beg, "inv_brokenframe" );
    cmn.AddSubscriber( "use_photo3", use_photo3_inv );
    cmn.AddSubscriber( "use_photo3", use_photo3_end, "inv_brokenframe" );
    cmn.AddSubscriber( "use_photo3_inv", use_photo3_inv );
    cmn.AddSubscriber( "use_photo3_beg", use_photo3_beg, "inv_brokenframe" );
    cmn.AddSubscriber( "use_photo3_end", use_photo3_end, "inv_brokenframe" );
    -------------------------------------------------------------------------------------------
    --------------------------------------------------------------------------------------------
    function private.check_fragments ()

      if cmn.IsEventDone( "clk_framepart_1" ) and
         cmn.IsEventDone( "clk_framepart_2" ) and
         cmn.IsEventDone( "clk_framepart_3" ) and
         cmn.IsEventDone( "clk_framepart_4" ) and
         cmn.IsEventDone( "clk_framepart_5" ) and
         cmn.IsEventDone( "clk_framepart_6" ) then
        ObjSet( "obj_deploy_inv_brokenframe_use_glue3", { input = true } );        
        ObjSet( "inv_brokenframe", { res = "assets/levels/level3/common_inventory3/inv_brokenframe/inv/frame" } );
      end;  

    end;

  end;  
  --*********************************************************************************************************************
  --*********************************************************************************************************************  
  function private.get_framedpic ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_framedpic" );
    cmn.CallEventHandler( "get_framedpic", "inv_brokenframe" );

    int.DeployInvHide();

  end;
  --*********************************************************************************************************************
  function private.clk_framepart ( num )

    int.Lock( true );

    local func_end = function ()

      int.Lock( false );

      cmn.SetEventDone( "clk_framepart_"..num );
      cmn.CallEventHandler( "clk_framepart_"..num, "inv_brokenframe" );

    end;
    local id = math.random( 1,3 );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_frame_part_move"..id );
    ObjAnimate("spr_deploy_inv_brokenframe_part_"..num, "pos_xy", 0, 0, func_end, 
    {
      0.0,0,private.init_pos[ num ][ 1 ], private.init_pos[ num ][ 2 ],
      0.5,3,private.fin_pos[ num ][ 1 ], private.fin_pos[ num ][ 2 ]
    });
    ObjAnimate("spr_deploy_inv_brokenframe_part_"..num, "ang", 0, 0, "", 
    {
      0.0,0,private.init_pos[ num ][ 3 ],
      0.5,3,0
    });

  end;
--*********************************************************************************************************************
  function public.use_glue3 ()

    local item = "inv_glue3";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_brokenframe_use_glue3" ) ) and
       ( cmn.IsEventDone( "clk_framepart_1" ) ) and
       ( cmn.IsEventDone( "clk_framepart_2" ) ) and
       ( cmn.IsEventDone( "clk_framepart_3" ) ) and
       ( cmn.IsEventDone( "clk_framepart_4" ) ) and
       ( cmn.IsEventDone( "clk_framepart_5" ) ) and
       ( cmn.IsEventDone( "clk_framepart_6" ) ) then

      cmn.CallEventHandler( "use_glue3_inv" );
      cmn.CallEventHandler( "use_glue3_beg", "inv_brokenframe" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_glue3" );
        cmn.CallEventHandler( "use_glue3_end", "inv_brokenframe" );

--        if ( cmn.IsEventDone( "use_photo3" ) and
--             cmn.IsEventDone( "use_screwdriverrmanual" ) ) then
--
--          private.BrokenframeStart();
--
--        end;
      
      end;

      int.Lock( true );

      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_glue" );
      
      ObjSet( "anm_deploy_inv_brokenframe_use_glue3", { alp = 1 } );
      ObjSet( "obj_deploy_inv_brokenframe_mmg", { alp = 0 } );
      AnimPlay( "anm_deploy_inv_brokenframe_use_glue3", "DoAnim", func_end );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
  function public.use_photo3 ()

    local item = "inv_photo3";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_brokenframe_use_photo3" ) ) and
       ( cmn.IsEventDone( "use_glue3" ) ) then

      cmn.CallEventHandler( "use_photo3_inv" );
      cmn.CallEventHandler( "use_photo3_beg", "inv_brokenframe" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_photo3" );
        cmn.CallEventHandler( "use_photo3_end", "inv_brokenframe" );

--        if ( cmn.IsEventDone( "use_glue3" ) and
--             cmn.IsEventDone( "use_screwdriverrmanual" ) ) then
--
--          private.BrokenframeStart();
--
--        end;
      
      end;

      int.Lock( true );

      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_place_photo" );
      
      ObjSet( "anm_deploy_inv_brokenframe_use_photo3", { alp = 1 } );
      AnimPlay( "anm_deploy_inv_brokenframe_use_photo3", "DoAnim", func_end );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
-- function *** oldbackpack *** ()
--*********************************************************************************************************************
  function private.oldbackpack_init ()

    ObjSet( "spr_deploy_inv_oldbackpack_pilot",  { event_mdown = private.get_pilot } );
    ObjSet( "spr_deploy_inv_oldbackpack_wire3_2",  { event_mdown = private.get_wire3_2 } );
    ObjSet( "spr_deploy_inv_oldbackpack_wrench3",  { event_mdown = private.get_wrench3 } );
    ObjSet( "obj_deploy_inv_oldbackpack_clk",  { event_mdown = private.clk_oldbackpack } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_pilot" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_oldbackpack_pilot",
      room = "int_deploy_inv",
      zz = "deploy_inv_oldbackpack",
      zz_gate = "inv_oldbackpack"
    };
    -------------------------------------------------------------------------------------------
    function get_pilot_inv ()

      if ( cmn.IsEventDone( "get_wrench3" ) ) and 
         ( cmn.IsEventDone( "get_wire3_2" ) ) and 
         ( cmn.IsEventDone( "get_pilot" ) ) then

        interface.InventoryItemRemove( "inv_oldbackpack" );

      end;

      interface.InventoryItemAdd( "inv_pilot", "spr_deploy_inv_oldbackpack_pilot" );

      ObjDelete( "gfx_deploy_inv_oldbackpack_pilot" );
      ObjDelete( "spr_deploy_inv_oldbackpack_pilot_shadow" );
      --ObjDelete( "spr_deploy_inv_oldbackpack_pilot_shadow" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_pilot", get_pilot_inv );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_wire3_2" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_oldbackpack_wire3_2",
      room = "int_deploy_inv",
      zz = "deploy_inv_oldbackpack",
      zz_gate = "inv_oldbackpack"
    };
    -------------------------------------------------------------------------------------------
    function get_wire3_2_inv ()

      if ( cmn.IsEventDone( "get_wrench3" ) ) and 
         ( cmn.IsEventDone( "get_wire3_2" ) ) and 
         ( cmn.IsEventDone( "get_pilot" ) ) then

        interface.InventoryItemRemove( "inv_oldbackpack" );

      end;

      interface.InventoryItemAdd( "inv_wire3", "spr_deploy_inv_oldbackpack_wire3_2", "assets/levels/level3/rm_controltower/zz_chestofdrawers/inv/inv_wire_2_morph" );
      public.CheckWire3();

      ObjDelete( "gfx_deploy_inv_oldbackpack_wire3_2" );
      --ObjDelete( "spr_deploy_inv_oldbackpack_wire3_2_shadow" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_wire3_2", get_wire3_2_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_wrench3" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_oldbackpack_wrench3",
      room = "int_deploy_inv",
      zz = "deploy_inv_oldbackpack",
      zz_gate = "inv_oldbackpack"
    };
    -------------------------------------------------------------------------------------------
    function get_wrench3_inv ()

      if ( cmn.IsEventDone( "get_wrench3" ) ) and 
         ( cmn.IsEventDone( "get_wire3_2" ) ) and 
         ( cmn.IsEventDone( "get_pilot" ) ) then

        interface.InventoryItemRemove( "inv_oldbackpack" );

      end;

      interface.InventoryItemAdd( "inv_wrench3", "spr_deploy_inv_oldbackpack_wrench3" );

      ObjDelete( "gfx_deploy_inv_oldbackpack_wrench3" );
      ObjDelete( "spr_deploy_inv_oldbackpack_wrench3_shadow" );
      ObjDelete( "spr_deploy_inv_oldbackpack_wrench3_shadow_over" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_wrench3", get_wrench3_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_oldbackpack" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_oldbackpack_clk",
      room = "int_deploy_inv",
      zz = "deploy_inv_oldbackpack",
      zz_gate = "inv_oldbackpack"
    };
    -------------------------------------------------------------------------------------------
    function clk_oldbackpack_inv ()

    end;
    function clk_oldbackpack_beg ()

      ObjDelete( "obj_deploy_inv_oldbackpack_clk" );

    end;
    function clk_oldbackpack_end ()

      ObjSet( "obj_deploy_inv_oldbackack_open", {alp = 1, input = true } );
      ObjSet( "gfx_deploy_inv_oldbackpack_pilot",   { active = true } );
      ObjSet( "gfx_deploy_inv_oldbackpack_wrench3", { active = true } );
      ObjSet( "gfx_deploy_inv_oldbackpack_wire3_2", { active = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_oldbackpack", clk_oldbackpack_inv );
    cmn.AddSubscriber( "clk_oldbackpack", clk_oldbackpack_beg, "inv_oldbackpack" );
    cmn.AddSubscriber( "clk_oldbackpack", clk_oldbackpack_end, "inv_oldbackpack" );
    cmn.AddSubscriber( "clk_oldbackpack_inv", clk_oldbackpack_inv );
    cmn.AddSubscriber( "clk_oldbackpack_beg", clk_oldbackpack_beg, "inv_oldbackpack" );
    cmn.AddSubscriber( "clk_oldbackpack_end", clk_oldbackpack_end, "inv_oldbackpack" );
    -------------------------------------------------------------------------------------------  

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.get_pilot ()

    cmn.GetObjectSfx();

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_pilot" );
    cmn.CallEventHandler( "get_pilot", "inv_oldbackpack" );

    if ( cmn.IsEventDone( "get_wrench3" ) ) and 
       ( cmn.IsEventDone( "get_wire3_2" ) ) and 
       ( cmn.IsEventDone( "get_pilot" ) ) then

      int.DeployInvHide();

    end;

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.get_wire3_2 ()

    cmn.GetObjectSfx();

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_wire3_2" );
    cmn.CallEventHandler( "get_wire3_2", "inv_oldbackpack" );

    if ( cmn.IsEventDone( "get_wrench3" ) ) and 
       ( cmn.IsEventDone( "get_wire3_2" ) ) and 
       ( cmn.IsEventDone( "get_pilot" ) ) then

      int.DeployInvHide();

    end;

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.get_wrench3 ()

    cmn.GetObjectSfx();

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_wrench3" );
    cmn.CallEventHandler( "get_wrench3", "inv_oldbackpack" );

    if ( cmn.IsEventDone( "get_wrench3" ) ) and 
       ( cmn.IsEventDone( "get_wire3_2" ) ) and 
       ( cmn.IsEventDone( "get_pilot" ) ) then

      int.DeployInvHide();

    end;

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.clk_oldbackpack ()

    cmn.CallEventHandler( "clk_oldbackpack_inv", "inv_oldbackpack" );
    cmn.CallEventHandler( "clk_oldbackpack_beg", "inv_oldbackpack" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_oldbackpack" );
      cmn.CallEventHandler( "clk_oldbackpack_end", "inv_oldbackpack" );
    
    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_leather_bag_open" );

    ObjAnimate("obj_deploy_inv_oldbackack_open", "alp", 0, 0, func_end, 
    {
      0.0,0,0,
      0.3,0,1
    });

    return true;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.CheckShell ()

  if cmn.IsEventDone( "get_shell_1" ) and cmn.IsEventDone( "get_shell_2" ) then
    ObjSet( "inv_shell", { res = "assets/levels/level3/common_inventory3/inv_purse3/inv/part4" } );
  end;

end;
--*********************************************************************************************************************
function public.CheckSwitch ()

  if cmn.IsEventDone( "get_switch3_1" ) and cmn.IsEventDone( "get_switch3_2" ) then
    ObjSet( "inv_switch3", { res = "assets/levels/level3/rm_technicalroom/zz_stafdrawers/inv/inv_switch_2" } );
  end;

end;
--*********************************************************************************************************************
function public.CheckBird ()

  if cmn.IsEventDone( "get_bird_1" ) and cmn.IsEventDone( "get_bird_2" ) then
    ObjSet( "inv_bird", { res = "assets/levels/level3/rm_window/zz_janitresstuff/inv/inv_bird" } );
  end;

end;
--*********************************************************************************************************************
function public.CheckThreeDollar ()

  if ( cmn.IsEventDone( "get_threedollar_1" ) and cmn.IsEventDone( "get_threedollar_2" ) and cmn.IsEventDone( "get_threedollar_3" ) ) then
    ObjSet( "inv_threedollar", { res = "assets/levels/level3/rm_window/zz_bag/inv/inv_threedollar_3"  } );
  elseif ( cmn.IsEventDone( "get_threedollar_1" ) and cmn.IsEventDone( "get_threedollar_2" ) ) or 
         ( cmn.IsEventDone( "get_threedollar_1" ) and cmn.IsEventDone( "get_threedollar_3" ) ) or
         ( cmn.IsEventDone( "get_threedollar_2" ) and cmn.IsEventDone( "get_threedollar_3" ) ) then
    ObjSet( "inv_threedollar", { res = "assets/levels/level3/rm_window/zz_bag/inv/inv_threedollar_2"  } );
  else
    ObjSet( "inv_threedollar", { res = "assets/levels/level3/rm_window/zz_bag/inv/inv_threedollar_1"  } );
  end;
  
end;
--*********************************************************************************************************************
function public.CheckWire3 ()

  if ( cmn.IsEventDone( "get_wire3_1" ) and cmn.IsEventDone( "get_wire3_2" ) and cmn.IsEventDone( "get_wire3_3" ) ) then
    ObjSet( "inv_wire3", { res = "assets/levels/level3/rm_controltower/zz_chestofdrawers/inv/inv_wire_3"  } );
  elseif ( cmn.IsEventDone( "get_wire3_1" ) and cmn.IsEventDone( "get_wire3_2" ) ) or 
         ( cmn.IsEventDone( "get_wire3_1" ) and cmn.IsEventDone( "get_wire3_3" ) ) or
         ( cmn.IsEventDone( "get_wire3_2" ) and cmn.IsEventDone( "get_wire3_3" ) ) then
    ObjSet( "inv_wire3", { res = "assets/levels/level3/rm_controltower/zz_chestofdrawers/inv/inv_wire_2"  } );
  else
    ObjSet( "inv_wire3", { res = "assets/levels/level3/rm_controltower/zz_chestofdrawers/inv/inv_wire_1"  } );
  end;
  
end;
--*********************************************************************************************************************
function public.CheckMarksamulet ()

  if ( cmn.IsEventDone( "get_marksamulet_1" ) and cmn.IsEventDone( "get_marksamulet_2" ) and cmn.IsEventDone( "get_marksamulet_3" ) ) then
    ObjSet( "inv_marksamulet", { res = "assets/levels/level3/rm_waitinghall/zz_hallsecurity/inv/inv_marksamulet_3"  } );
  elseif ( cmn.IsEventDone( "get_marksamulet_1" ) and cmn.IsEventDone( "get_marksamulet_2" ) ) or 
         ( cmn.IsEventDone( "get_marksamulet_1" ) and cmn.IsEventDone( "get_marksamulet_3" ) ) or
         ( cmn.IsEventDone( "get_marksamulet_2" ) and cmn.IsEventDone( "get_marksamulet_3" ) ) then
    ObjSet( "inv_marksamulet", { res = "assets/levels/level3/rm_waitinghall/zz_hallsecurity/inv/inv_marksamulet_2"  } );
  else
    ObjSet( "inv_marksamulet", { res = "assets/levels/level3/rm_waitinghall/zz_hallsecurity/inv/inv_marksamulet_1"  } );
  end;
  
end;
--*********************************************************************************************************************
function public.CheckPattern ()

  if ( cmn.IsEventDone( "get_pattern_1" ) and cmn.IsEventDone( "get_pattern_2" ) and cmn.IsEventDone( "get_pattern_3" ) and cmn.IsEventDone( "get_pattern_4" ) ) then
    ObjSet( "inv_pattern", { res = "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/inv/inv_pattern_4"  } );
  elseif ( cmn.IsEventDone( "get_pattern_1" ) and cmn.IsEventDone( "get_pattern_2" ) and cmn.IsEventDone( "get_pattern_3" ) ) or
         ( cmn.IsEventDone( "get_pattern_1" ) and cmn.IsEventDone( "get_pattern_2" ) and cmn.IsEventDone( "get_pattern_4" ) ) or
         ( cmn.IsEventDone( "get_pattern_1" ) and cmn.IsEventDone( "get_pattern_3" ) and cmn.IsEventDone( "get_pattern_4" ) ) or
         ( cmn.IsEventDone( "get_pattern_2" ) and cmn.IsEventDone( "get_pattern_3" ) and cmn.IsEventDone( "get_pattern_4" ) ) then
    ObjSet( "inv_pattern", { res = "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/inv/inv_pattern_3"  } ); 
  elseif ( cmn.IsEventDone( "get_pattern_1" ) and cmn.IsEventDone( "get_pattern_2" ) ) or 
         ( cmn.IsEventDone( "get_pattern_1" ) and cmn.IsEventDone( "get_pattern_3" ) ) or
         ( cmn.IsEventDone( "get_pattern_1" ) and cmn.IsEventDone( "get_pattern_4" ) ) or
         ( cmn.IsEventDone( "get_pattern_2" ) and cmn.IsEventDone( "get_pattern_3" ) ) or
         ( cmn.IsEventDone( "get_pattern_2" ) and cmn.IsEventDone( "get_pattern_4" ) ) or
         ( cmn.IsEventDone( "get_pattern_3" ) and cmn.IsEventDone( "get_pattern_4" ) ) then
    ObjSet( "inv_pattern", { res = "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/inv/inv_pattern_2"  } );
  else
    ObjSet( "inv_pattern", { res = "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/inv/inv_pattern_1"  } );
  end;
  
end;