-- name=rm_aircompaniesstand
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_aircompaniesstand";

  ObjAttach( "zz_stand3",          "room_hub" );
  ObjAttach( "zz_securitypoint",   "room_hub" );
  ObjAttach( "zz_secondfloordoor", "room_hub" );

  ObjMultiSet( {  
    { "spr_stand3_boothbutton_2",             { event_mdown = private.get_boothbutton_2 } },
    { "spr_stand3_keyboard",                  { event_mdown = private.get_keyboard } },
    { "spr_stand3_tweezers3",                 { event_mdown = private.get_tweezers3 } },
    { "spr_stand3_lever3",                    { event_mdown = private.get_lever3 } },
    { "spr_securitypoint_toggle3",            { event_mdown = private.get_toggle3 } },
    { "spr_securitypoint_notloadedgun",       { event_mdown = private.get_notloadedgun } },
    { "obj_securitypoint_clk_switch3",        { event_mdown = private.clk_switch3 } },
    { "obj_securitypoint_use_securitybadge",  { event_mdown = private.ClkSecurityDoor } },
    { "obj_secondfloordoor_use_gun",          { event_mdown = private.SecondfloordoorClick } },
    { "obj_stand3_use_demonmedallion",        { event_mdown = private.ClkClosedBox } },
  } );

  private.InitAnims();
  private.InitSubroom();
  private.InitStand3();
  private.InitSecuritypoint();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_aircompaniesstand = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gho_aircompaniesstand_hosecuritypoint",
        "gzz_aircompaniesstand_stand3",
        "gzz_aircompaniesstand_securitypoint",
        "gzz_aircompaniesstand_secondfloordoor",
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_stand3", 
        "zz_securitypoint", 
        "zz_secondfloordoor",
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_aircompaniesstand", update_game_mode_aircompaniesstand, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_boothbutton_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_boothbutton_2" ] =
  {
    type = "get",
    get_obj = "spr_stand3_boothbutton_2",
    room = private.room_objname,
    zz = "zz_stand3",
    zz_gate = "gzz_aircompaniesstand_stand3"
  };
  -----------------------------------------------
  local get_boothbutton_2_inv = function ()

    int.InventoryItemAdd( "inv_boothbutton_2", "spr_stand3_boothbutton_2" );

  end;

  local get_boothbutton_2_closezz = function ()

    ObjDelete( "gfx_stand3_boothbutton_2" );
    ObjDelete( "spr_stand3_boothbutton_2_over" );

  end;

  cmn.AddSubscriber( "get_boothbutton_2", get_boothbutton_2_inv );
  cmn.AddSubscriber( "get_boothbutton_2", get_boothbutton_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_keyboard () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_keyboard" ] =
  {
    type = "get",
    get_obj = "spr_stand3_keyboard",
    room = private.room_objname,
    zz = "zz_stand3",
    zz_gate = "gzz_aircompaniesstand_stand3"
  };
  -----------------------------------------------
  local get_keyboard_inv = function ()

    int.InventoryItemAdd( "inv_keyboard", "spr_stand3_keyboard" );

  end;

  local get_keyboard_closezz = function ()

    ObjDelete( "gfx_stand3_keyboard" );
    ObjDelete( "spr_stand3_keyboard_shadow" );
    ObjDelete( "spr_stand3_open_over" );
    ObjDelete( "spr_stand3_open_box_key" );   
    ObjSet( "anm_stand3_use_demonmedallion", { res = "assets/levels/level3/rm_aircompaniesstand/zz_stand3/anims/anm_open" } );
    ObjSet( "spr_stand3_open_box", { alp = 1 } );    
    
    if cmn.IsEventDone( "get_lever3" ) then
      ObjDelete( "gzz_aircompaniesstand_stand3" );
    end;     

  end;

  cmn.AddSubscriber( "get_keyboard", get_keyboard_inv );
  cmn.AddSubscriber( "get_keyboard", get_keyboard_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tweezers3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tweezers3" ] =
  {
    type = "get",
    get_obj = "spr_stand3_tweezers3",
    room = private.room_objname,
    zz = "zz_stand3",
    zz_gate = "gzz_aircompaniesstand_stand3"
  };
  -----------------------------------------------
  local get_tweezers3_inv = function ()

    int.InventoryItemAdd( "inv_tweezers3", "spr_stand3_tweezers3" );

  end;

  local get_tweezers3_closezz = function ()

    ObjDelete( "gfx_stand3_tweezers3" );
    ObjDelete( "spr_stand3_tweezers3_shadow" );
    ObjDelete( "spr_aircompaniesstand_stand3_tweezers" );

  end;

  cmn.AddSubscriber( "get_tweezers3", get_tweezers3_inv );
  cmn.AddSubscriber( "get_tweezers3", get_tweezers3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lever3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lever3" ] =
  {
    type = "get",
    get_obj = "spr_stand3_lever3",
    room = private.room_objname,
    zz = "zz_stand3",
    zz_gate = "gzz_aircompaniesstand_stand3"
  };
  -----------------------------------------------
  local get_lever3_inv = function ()

    int.InventoryItemAdd( "inv_lever3", "spr_stand3_lever3" );

  end;

  local get_lever3_closezz = function ()

    ObjDelete( "gfx_stand3_lever3" );
    ObjDelete( "spr_stand3_lever3_shadow" );    
    ObjDelete( "spr_aircompaniesstand_stand3_lever3" );
    
    if cmn.IsEventDone( "get_keyboard" ) then
      ObjDelete( "gzz_aircompaniesstand_stand3" );
    end;  

  end;

  cmn.AddSubscriber( "get_lever3", get_lever3_inv );
  cmn.AddSubscriber( "get_lever3", get_lever3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_toggle3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_toggle3" ] =
  {
    type = "get",
    get_obj = "spr_securitypoint_toggle3",
    room = private.room_objname,
    zz = "zz_securitypoint",
    zz_gate = "gzz_aircompaniesstand_securitypoint"
  };
  -----------------------------------------------
  local get_toggle3_inv = function ()

    int.InventoryItemAdd( "inv_toggle3", "spr_securitypoint_toggle3" );

  end;

  local get_toggle3_closezz = function ()

    ObjDelete( "gfx_securitypoint_toggle3" );
    ObjDelete( "spr_securitypoint_toggle3_shadow" );
    ObjDelete( "spr_aircompaniesstand_securitypoint_toggle3" );
    --ObjDelete( "gzz_aircompaniesstand_securitypoint" );

  end;

  cmn.AddSubscriber( "get_toggle3", get_toggle3_inv );
  cmn.AddSubscriber( "get_toggle3", get_toggle3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_notloadedgun () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_notloadedgun" ] =
  {
    type = "get",
    get_obj = "spr_securitypoint_notloadedgun",
    room = private.room_objname,
    zz = "zz_securitypoint",
    zz_gate = "gzz_aircompaniesstand_securitypoint"
  };
  -----------------------------------------------
  local get_notloadedgun_inv = function ()

    int.InventoryItemAdd( "inv_notloadedgun", "spr_securitypoint_notloadedgun" );
    ObjSet( "inv_notloadedgun", { drag = false } );
    ObjSet( "inv_notloadedgun_plus_focus2", { alp = 0 } );

  end;

  local get_notloadedgun_closezz = function ()

    ObjDelete( "gfx_securitypoint_notloadedgun" );
    ObjDelete( "spr_securitypoint_notloadedgun_shadow" );
    ObjDelete( "spr_aircompaniesstand_securitypoint_notloadedgun" );
    --ObjDelete( "gzz_aircompaniesstand_securitypoint" );

  end;

  cmn.AddSubscriber( "get_notloadedgun", get_notloadedgun_inv );
  cmn.AddSubscriber( "get_notloadedgun", get_notloadedgun_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_3_3 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_3_3 = function ()

    ObjDelete( "obj_aircompaniesstand_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_3_3", get_morphobject_3_3, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_pencil () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pencil" ] =
  {
    type = "use",
    use_obj = "inv_pencil",
    use_place = "obj_stand3_use_pencil",
    room = private.room_objname,
    zz = "zz_stand3",
    zz_gate = "gzz_aircompaniesstand_stand3"
  };
  -----------------------------------------------
  local use_pencil_inv = function ()

    int.InventoryItemRemove( "inv_pencil" );

  end;
  local use_pencil_beg = function ()

    ObjDelete( "obj_stand3_use_pencil" );

  end;
  local use_pencil_end = function ()

    ObjSet( "spr_stand3_boothbutton_2", { input = true, alp = 1 } );
    ObjSet( "gfx_stand3_boothbutton_2", { active = true } );
    ObjDelete( "anm_stand3_use_pencil" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_pencil", use_pencil_beg, private.room_objname );
  cmn.AddSubscriber( "use_pencil", use_pencil_inv );
  cmn.AddSubscriber( "use_pencil", use_pencil_end, private.room_objname );
  cmn.AddSubscriber( "use_pencil_inv", use_pencil_inv, private.room_objname );
  cmn.AddSubscriber( "use_pencil_beg", use_pencil_beg, private.room_objname );
  cmn.AddSubscriber( "use_pencil_end", use_pencil_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_diamond () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_diamond" ] =
  {
    type = "use",
    use_obj = "inv_diamond",
    use_place = "obj_stand3_use_diamond",
    room = private.room_objname,
    zz = "zz_stand3",
    zz_gate = "gzz_aircompaniesstand_stand3"
  };
  -----------------------------------------------
  local use_diamond_inv = function ()

    int.InventoryItemRemove( "inv_diamond" );

  end;
  local use_diamond_beg = function ()

    ObjDelete( "obj_stand3_use_diamond" );

  end;
  local use_diamond_end = function ()

    ObjSet( "obj_stand3_open", { alp = 1, input = true } );
    ObjSet( "gfx_stand3_keyboard", { active = true } );
    ObjSet( "gfx_stand3_tweezers3", { active = true } );
    ObjSet( "spr_aircompaniesstand_stand3_open", { alp = 1 } );
    ObjDelete( "anm_stand3_use_diamond" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_diamond", use_diamond_beg, private.room_objname );
  cmn.AddSubscriber( "use_diamond", use_diamond_inv );
  cmn.AddSubscriber( "use_diamond", use_diamond_end, private.room_objname );
  cmn.AddSubscriber( "use_diamond_inv", use_diamond_inv, private.room_objname );
  cmn.AddSubscriber( "use_diamond_beg", use_diamond_beg, private.room_objname );
  cmn.AddSubscriber( "use_diamond_end", use_diamond_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_demonmedallion () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_demonmedallion" ] =
  {
    type = "use",
    use_obj = "inv_demonmedallion",
    use_place = "obj_stand3_use_demonmedallion",
    room = private.room_objname,
    zz = "zz_stand3",
    zz_gate = "gzz_aircompaniesstand_stand3"
  };
  -----------------------------------------------
  local use_demonmedallion_inv = function ()

    int.InventoryItemRemove( "inv_demonmedallion" );

  end;
  local use_demonmedallion_beg = function ()

    ObjDelete( "obj_stand3_use_demonmedallion" );

  end;
  local use_demonmedallion_end = function ()

    ObjSet( "spr_stand3_mmg", { alp = 1 } );
    ObjSet( "obj_stand3_mmg", { alp = 1, input = true } );
    ObjSet( "spr_aircompaniesstand_stand3_mmg", { alp = 1 } );
    ObjSet( "spr_stand3_keyboard", { input = false } );
    ObjDelete( "anm_stand3_use_demonmedallion" );
    ObjDelete( "obj_stand3_closed_box" );
    ObjDelete( "spr_stand3_closed_box_over_1" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_demonmedallion", use_demonmedallion_beg, private.room_objname );
  cmn.AddSubscriber( "use_demonmedallion", use_demonmedallion_inv );
  cmn.AddSubscriber( "use_demonmedallion", use_demonmedallion_end, private.room_objname );
  cmn.AddSubscriber( "use_demonmedallion_inv", use_demonmedallion_inv, private.room_objname );
  cmn.AddSubscriber( "use_demonmedallion_beg", use_demonmedallion_beg, private.room_objname );
  cmn.AddSubscriber( "use_demonmedallion_end", use_demonmedallion_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_securitybadge () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_securitybadge" ] =
  {
    type = "use",
    use_obj = "inv_securitybadge",
    use_place = "obj_securitypoint_use_securitybadge",
    room = private.room_objname,
    zz = "zz_securitypoint",
    zz_gate = "gzz_aircompaniesstand_securitypoint"
  };
  -----------------------------------------------
  local use_securitybadge_inv = function ()

    int.InventoryItemRemove( "inv_securitybadge" );

  end;
  local use_securitybadge_beg = function ()

    ObjDelete( "obj_securitypoint_use_securitybadge" );

  end;
  local use_securitybadge_end = function ()

    ObjSet( "spr_securitypoint_securitybadge", { alp = 1 } );
    ObjSet( "obj_securitypoint_buttons", { input = true } );
    ObjSet( "spr_aircompaniesstand_securitypoint_securitybadge", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_securitybadge", use_securitybadge_beg, private.room_objname );
  cmn.AddSubscriber( "use_securitybadge", use_securitybadge_inv );
  cmn.AddSubscriber( "use_securitybadge", use_securitybadge_end, private.room_objname );
  cmn.AddSubscriber( "use_securitybadge_inv", use_securitybadge_inv, private.room_objname );
  cmn.AddSubscriber( "use_securitybadge_beg", use_securitybadge_beg, private.room_objname );
  cmn.AddSubscriber( "use_securitybadge_end", use_securitybadge_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mountedtorch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mountedtorch" ] =
  {
    type = "use",
    use_obj = "inv_mountedtorch",
    use_place = "obj_securitypoint_use_mountedtorch",
    room = private.room_objname,
    zz = "zz_securitypoint",
    zz_gate = "gzz_aircompaniesstand_securitypoint"
  };
  -----------------------------------------------
  local use_mountedtorch_inv = function ()

    int.InventoryItemRemove( "inv_mountedtorch" );

  end;
  local use_mountedtorch_beg = function ()

    ObjDelete( "obj_securitypoint_use_mountedtorch" );

  end;
  local use_mountedtorch_end = function ()

    ObjSet( "obj_securitypoint_lamp", { alp = 1 } );
    ObjSet( "obj_securitypoint_clk_switch3", { input = true } );
    ObjSet( "spr_aircompaniesstand_securitypoint_mountedtorch", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_mountedtorch", use_mountedtorch_beg, private.room_objname );
  cmn.AddSubscriber( "use_mountedtorch", use_mountedtorch_inv );
  cmn.AddSubscriber( "use_mountedtorch", use_mountedtorch_end, private.room_objname );
  cmn.AddSubscriber( "use_mountedtorch_inv", use_mountedtorch_inv, private.room_objname );
  cmn.AddSubscriber( "use_mountedtorch_beg", use_mountedtorch_beg, private.room_objname );
  cmn.AddSubscriber( "use_mountedtorch_end", use_mountedtorch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gun () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gun" ] =
  {
    type = "use",
    use_obj = "inv_gun",
    use_place = "obj_secondfloordoor_use_gun",
    room = private.room_objname,
    zz = "zz_secondfloordoor",
    zz_gate = "gzz_aircompaniesstand_secondfloordoor"
  };
  -----------------------------------------------
  local use_gun_inv = function ()

    int.InventoryItemRemove( "inv_gun" );

  end;
  local use_gun_beg = function ()

    ObjDelete( "obj_secondfloordoor_use_gun" );

  end;
  local use_gun_end = function ()

    ObjSet( "grm_aircompaniesstand_secondfloorcorridor", { active = true, input = true, visible = true } );  
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_aircompaniesstand_secondfloorcorridor_focus");
    end;   
    ObjSet( "spr_aircompaniesstand_open_door", { alp = 1 } );
    ObjDelete( "gzz_aircompaniesstand_secondfloordoor" );
    ObjDelete( "spr_secondfloordoor_door" );
    ObjDelete( "vid_secondfloordoor_use_gun" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_gun", use_gun_beg, private.room_objname );
  cmn.AddSubscriber( "use_gun", use_gun_inv );
  cmn.AddSubscriber( "use_gun", use_gun_end, private.room_objname );
  cmn.AddSubscriber( "use_gun_inv", use_gun_inv, private.room_objname );
  cmn.AddSubscriber( "use_gun_beg", use_gun_beg, private.room_objname );
  cmn.AddSubscriber( "use_gun_end", use_gun_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_switch3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_switch3" ] =
  {
    type = "click",
    clk_obj = "obj_securitypoint_clk_switch3",
    room = private.room_objname,
    zz = "zz_securitypoint",
    zz_gate = "gzz_aircompaniesstand_securitypoint"
  };
  -----------------------------------------------
  local clk_switch3_beg = function ()

    ObjDelete( "obj_securitypoint_clk_switch3" );

  end;
  -----------------------------------------------
  local clk_switch3_end = function ()

  ObjSet( "gho_aircompaniesstand_hosecuritypoint", { active = true, input = true, alp = 1 } );  
    ObjSet( "spr_aircompaniesstand_securitypoint_lighten", {alp = 1 } );
    ObjDelete( "gzz_aircompaniesstand_securitypoint" );
    ObjDelete( "spr_securitypoint_dark" );
    ObjDelete( "spr_securitypoint_switch" );
    ObjDelete( "spr_aircompaniesstand_securitypoint_dark" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_switch3", clk_switch3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_switch3", clk_switch3_end, private.room_objname );
  cmn.AddSubscriber( "clk_switch3_beg", clk_switch3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_switch3_end", clk_switch3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_stand3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_stand3" ] =
  {
    room = private.room_objname,
    zz = "zz_stand3",
    zz_gate = "gzz_aircompaniesstand_stand3"
  };
  --*********************************************************************************************************************
  local win_stand3 = function ()

    if ( cmn.IsEventDone( "win_stand3" ) ) then

      ObjSet( "obj_stand3_open_box", { input = true, alp = 1 } );
      ObjSet( "gfx_stand3_lever3", { active = true } );
      ObjSet( "spr_aircompaniesstand_stand3_mmg_open", { alp = 1 } );
      ObjDelete( "obj_stand3_mmg" );
      
      if not ( cmn.IsEventDone( "get_keyboard" ) ) then
        ObjSet( "spr_stand3_keyboard", { input = true } );
      end;

    elseif ( cmn.IsEventStart( "win_stand3" ) ) then

      private.LoadStand3();   

    end;

  end;

  cmn.AddSubscriber( "win_stand3", win_stand3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_securitypoint () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_securitypoint" ] =
  {
    type = "click",
    clk_obj = "spr_securitypoint_securitybadge",
    room = private.room_objname,
    zz = "zz_securitypoint",
    zz_gate = "gzz_aircompaniesstand_securitypoint"
  };
  --*********************************************************************************************************************
  local win_securitypoint = function ()

    if ( cmn.IsEventDone( "win_securitypoint" ) ) then

      ObjSet( "obj_securitypoint_open", { input = true } );
      ObjSet( "gfx_securitypoint_toggle3", { active = true } );
      ObjSet( "gfx_securitypoint_notloadedgun", { active = true } );
      ObjSet( "obj_aircompaniesstand_securitypoint_open", { alp = 1 } );
      ObjDelete( "obj_securitypoint_closed" );
      ObjDelete( "spr_aircompaniesstand_securitypoint_door_closed" );

    elseif ( cmn.IsEventStart( "win_securitypoint" ) ) then

      --private.code = ng_global.progress[ "std" ][ "win_securitypoint" ].code;

    end;

  end;

  cmn.AddSubscriber( "win_securitypoint", win_securitypoint, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
function private.get_boothbutton_2 ()

  cmn.SetEventDone( "get_boothbutton_2" );
  cmn.CallEventHandler( "get_boothbutton_2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_keyboard ()

  cmn.SetEventDone( "get_keyboard" );
  cmn.CallEventHandler( "get_keyboard" );
  
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_lever3" ) then
    cmn.CloseSubRoom();
  end;  

  iOS_RateMe();
end;
-------------------------------------------------
function private.get_tweezers3 ()

  cmn.SetEventDone( "get_tweezers3" );
  cmn.CallEventHandler( "get_tweezers3" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_lever3 ()

  cmn.SetEventDone( "get_lever3" );
  cmn.CallEventHandler( "get_lever3" );
  
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_keyboard" ) then
    cmn.CloseSubRoom();
  end;

end;
-------------------------------------------------
function private.get_toggle3 ()

  cmn.SetEventDone( "get_toggle3" );
  cmn.CallEventHandler( "get_toggle3" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_notloadedgun ()

  cmn.SetEventDone( "get_notloadedgun" );
  cmn.CallEventHandler( "get_notloadedgun" );
  
  cmn.GetObjectSfx();

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
function public.use_pencil ()

  local item = "inv_pencil";

  if ( cmn.ApplyObj( item, "gzz_aircompaniesstand_stand3", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stand3" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stand3_use_pencil", true ) ) then

    cmn.CallEventHandler( "use_pencil_inv" );
    cmn.CallEventHandler( "use_pencil_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_pencil" );
      cmn.CallEventHandler( "use_pencil_end" );
      int.Lock( false );

      private.get_boothbutton_2();

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_take_button" );  
    AnimPlay( "anm_stand3_use_pencil", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_diamond ()

  local item = "inv_diamond";

  if ( cmn.ApplyObj( item, "gzz_aircompaniesstand_stand3", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stand3" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stand3_use_diamond", true ) ) then

    cmn.CallEventHandler( "use_diamond_inv" );
    cmn.CallEventHandler( "use_diamond_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_diamond" );
      cmn.CallEventHandler( "use_diamond_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_glasscutter" );
    AnimPlay( "anm_stand3_use_diamond", "DoAnim", func_end );  

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_demonmedallion ()

  local item = "inv_demonmedallion";

  if ( cmn.ApplyObj( item, "gzz_aircompaniesstand_stand3", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stand3" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stand3_use_demonmedallion", true ) ) then

    cmn.CallEventHandler( "use_demonmedallion_inv" );
    cmn.CallEventHandler( "use_demonmedallion_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_demonmedallion" );
      cmn.CallEventHandler( "use_demonmedallion_end" );
      int.Lock( false );
      
      common_impl.PassingMgStart( "stand3" );
      
      private.InitStand3Start();

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_insert_figure_for_mg" );  
    ObjSet( "obj_stand3_closed_box", { alp = 0 } );
    ObjSet( "spr_stand3_collect2_3_4", { input = false } );
    ObjSet( "spr_stand3_closed_box_over_1", { alp = 0 } );
    ObjSet( "anm_stand3_use_demonmedallion", { alp = 1 } );
    AnimPlay( "anm_stand3_use_demonmedallion", "DoAnim", 
    function ()
      ObjAnimate("obj_stand3_mmg", "alp", 0, 0, func_end, 
      {
        0.0,0,0,
        0.5,0,0,
        0.8,0,1
      });
    end );    

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_securitybadge ()

  local item = "inv_securitybadge";

  if ( cmn.ApplyObj( item, "gzz_aircompaniesstand_securitypoint", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_securitypoint" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_securitypoint_use_securitybadge", true ) ) then

    cmn.CallEventHandler( "use_securitybadge_inv" );
    cmn.CallEventHandler( "use_securitybadge_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_securitybadge" );
      cmn.CallEventHandler( "use_securitybadge_end" );
      int.Lock( false );

      private.StartSecuritypoint();

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_apply_police_sign" );  
    ObjAnimate("spr_securitypoint_securitybadge", "alp", 0, 0, "", 
    {
      0.0,0,0,
      0.3,0,1
    });

    for i=0, 11 do
      ObjAnimate("spr_securitypoint_button_"..i, "alp", 0, 0, "", 
      {
        0.0,0,0,
        0.5,0,0,
        0.7,0,1,
        0.9,0,1,
        1.1,0,0
      });
    end;
    ObjAnimate("spr_securitypoint_button_lock", "alp", 0, 0, func_end, 
    {
      0.0,0,0,
      0.5,0,0,
      0.7,0,1,
      0.9,0,1,
      1.1,0,0
    });

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_mountedtorch ()

  local item = "inv_mountedtorch";

  if ( cmn.ApplyObj( item, "gzz_aircompaniesstand_securitypoint", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_securitypoint" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_securitypoint_use_mountedtorch", true ) ) then

    cmn.CallEventHandler( "use_mountedtorch_inv" );
    cmn.CallEventHandler( "use_mountedtorch_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_mountedtorch" );
      cmn.CallEventHandler( "use_mountedtorch_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_lamp_put" );  
    ObjAnimate("obj_securitypoint_lamp", "alp", 0, 0, func_end, 
    {
      0.0,0,0,
      0.3,0,1
    });

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_gun ()

  local item = "inv_gun";

  if ( cmn.ApplyObj( item, "gzz_aircompaniesstand_secondfloordoor", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_secondfloordoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_secondfloordoor_use_gun", true ) ) then

    cmn.CallEventHandler( "use_gun_inv" );
    cmn.CallEventHandler( "use_gun_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_gun" );
      cmn.CallEventHandler( "use_gun_end" );
      cmn.CloseSubRoom();
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_use_pistol" );
    ObjSet( "spr_secondfloordoor_door",    { alp = 0 } );  
    ObjSet( "vid_secondfloordoor_use_gun", { alp = 1 } );  
    VidPlay( "vid_secondfloordoor_use_gun", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
function private.clk_switch3 ()

  local func_end = function ()

    cmn.SetEventDone( "clk_switch3" );
    cmn.CallEventHandler( "clk_switch3_end" );
    int.Lock( false );

    cmn.CloseSubRoom();

  end;

  cmn.CallEventHandler( "clk_switch3_beg" );

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_lamp_on" ); 
  ObjAnimate("spr_securitypoint_switch", "alp", 0, 0, "", 
  {
    0.0,0,1,
    0.3,0,0
  });
  ObjAnimate("spr_securitypoint_dark", "alp", 0, 0, func_end, 
  {
    0.0,0,1,
    0.3,0,0
  });  

end;
-------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_aircompaniesstand ()

  if not ( cmn.IsEventDone( "opn_aircompaniesstand" ) ) then

    cmn.SetEventDone( "opn_aircompaniesstand" );
    cmn.ShowBbt( "bbt_aircompaniesstand_first_entry" );
    cmn.PlayAudio( "mus", "audio/aud_location_theme_mus" );

  end;

end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.PreOpen ()
  
  cmn.StopAllEnv( "audio/level3/env/aud_aircompaniestand_env", true );
  cmn.PlayAudio( "env", "audio/level3/env/aud_aircompaniestand_env", 1 );
  
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_aircompaniesstand();

end;
--*********************************************************************************************************************
function public.Task ()
  
  int.AddedTaskMap( private.room_objname, "get_boothbutton_2",                         { "use_pencil" } );  
  int.AddedTaskMap( private.room_objname, "get_keyboard",                              { "use_diamond" } );
  int.AddedTaskMap( private.room_objname, "get_tweezers3",                             { "use_diamond" } ); 
  int.AddedTaskMap( private.room_objname, "get_lever3",                                { "win_stand3" } );
  int.AddedTaskMap( private.room_objname, "get_toggle3",                               { "win_securitypoint" } );
  int.AddedTaskMap( private.room_objname, "get_notloadedgun",                          { "win_securitypoint" } );  
  
  int.AddedTaskMap( private.room_objname, "use_pencil",                                { "get_pencil" } ); 
  int.AddedTaskMap( private.room_objname, "use_diamond",                               { "get_diamond" } );
  int.AddedTaskMap( private.room_objname, "use_demonmedallion",                        { "use_diamond", "get_demonmedallion" } );
  int.AddedTaskMap( private.room_objname, "use_securitybadge",                         { "get_securitybadge" } );
  int.AddedTaskMap( private.room_objname, "use_mountedtorch",                          { "get_mountedtorch" } ); 
  int.AddedTaskMap( private.room_objname, "use_gun",                                   { "get_gun" } );  
  
  int.AddedTaskMap( private.room_objname, "clk_switch3",                               { "use_mountedtorch" } );  
  
  int.AddedTaskMap( private.room_objname, "win_stand3",                                { "use_demonmedallion" } ); 
  int.AddedTaskMap( private.room_objname, "win_securitypoint",                         { "use_securitybadge" } ); 
  int.AddedTaskMap( private.room_objname, "win_hosecuritypoint",                       { "clk_switch3" } );
  
  int.AddedTaskMap( private.room_objname, "opn_secondfloorcorridor",                   { "use_gun" } );    
  
end;  
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_stand3" );

  function zz_stand3.Open()

    if ( cmn.IsEventStart( "win_stand3" ) and not cmn.IsEventDone( "win_stand3" ) ) then

      cmn.MiniGameShow( "stand3" );
      common_impl.PassingMgStart( "stand3" );

    end;

  end;
  -------------------------------------------------
  function zz_stand3.PreClose()

    if ( cmn.IsEventStart( "win_stand3" ) and not cmn.IsEventDone( "win_stand3" ) ) then

      cmn.MiniGameHide( "stand3" );
      common_impl.PassingMgStop( "stand3" );

    end;

  end;
  -----------------------------------------------
  function zz_stand3.Skip ()

    ObjSet( "spr_stand3_imp", { pos_x = private.imp_win_coord[ 1 ], pos_y = private.imp_win_coord[ 2 ] } );
    ObjSet( "spr_stand3_angel", { pos_x = private.angel_win_coord[ 1 ], pos_y = private.angel_win_coord[ 2 ] } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_miniwin_mg_stand3" );
    local scx = ObjGet( "spr_stand3_imp" ).scale_x;
    local scy = ObjGet( "spr_stand3_imp" ).scale_y;
    ObjAnimate("spr_stand3_imp", "scale_xy", 0, 0, "", 
    {
      0.0,0,scx,scy,
      0.3,0,scx,scy,
      0.8,0,0,0
    });
    scx = ObjGet( "spr_stand3_angel" ).scale_x;
    scy = ObjGet( "spr_stand3_angel" ).scale_y;
    ObjAnimate("spr_stand3_angel", "scale_xy", 0, 0, 
    function ()
      private.WinStand3();
    end, 
    {
      0.0,0,scx,scy,
      0.3,0,scx,scy,
      0.8,0,0,0
    });    

  end;
  -------------------------------------------------
  function zz_stand3.Reset ()

    private.imp_pos = {1,1};
    private.angel_pos = {1,4};
    private.imp_win = false;
    private.angel_win = false;
    ng_global.progress[ "std" ][ "win_stand3" ].imp_pos = {1,1};
    ng_global.progress[ "std" ][ "win_stand3" ].angel_pos = {1,4};
    ng_global.progress[ "std" ][ "win_stand3" ].imp_win = false;
    ng_global.progress[ "std" ][ "win_stand3" ].angel_win = false;
    ObjSet( "spr_stand3_imp", {
      scale_x = 1,
      scale_y = 1,
      alp = 1,
      pos_x = private.coord[ private.imp_pos[ 1 ] ][ private.imp_pos[ 2 ] ][ 1 ],
      pos_y = private.coord[ private.imp_pos[ 1 ] ][ private.imp_pos[ 2 ] ][ 2 ]
    } );
    ObjSet( "spr_stand3_angel", {
      scale_x = 1,
      scale_y = 1,
      alp = 1,
      pos_x = private.coord[ private.angel_pos[ 1 ] ][ private.angel_pos[ 2 ] ][ 1 ],
      pos_y = private.coord[ private.angel_pos[ 1 ] ][ private.angel_pos[ 2 ] ][ 2 ]
    } );
    ObjSet( "obj_stand3_arrows_imp", { input = true } );
    ObjSet( "obj_stand3_arrows_angel", { input = true } );
    
  end;

end;
--*********************************************************************************************************************
function private.SecondfloordoorClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_secondfloordoor_use_gun" );
    int.Lock( false );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_metal_door_touch" );  
  ObjAnimate( "spr_secondfloordoor_door", "scale_x", 0, 0, func_end,
  { 
    0.0, 0, 1.000, 
    0.2, 0, 0.995,
    0.4, 0, 1.000, 
    0.6, 0, 0.995,
    0.8, 0, 1.000, 
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.InitAnims ()

  ObjAnimate( "spr_secondfloordoor_light_1", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate("obj_aircompaniesstand_lights", "alp", 1, 0, "", 
  {
    0.0,0,1,
    1.5,0,0.6,
    3.0,0,1
  });

  ObjAnimate( "spr_aircompaniesstand_man", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.6,
    2.0, 0, 1,
    3.0, 0, 0.6,
    4.0, 0, 1,
    5.0, 0, 0.6,
    6.0, 0, 1,
    7.0, 0, 0.6,
    8.0, 0, 1,
    8.2, 0, 0.6,
    8.4, 0, 1,
    8.6, 0, 0.6,
    8.8, 0, 1
  } );

  ObjAnimate("spr_stand3_angel_gate_light", "alp", 1, 0, "", 
  {
    0.0,0,1,
    1.3,0,1,
    1.8,0,0.7,
    2.2,0,1,
    3.5,0,1,
    3.8,0,0.8,
    4.1,0,1
  });
  ObjAnimate("spr_stand3_imp_gate_light", "alp", 1, 0, "", 
  {
    0.0,0,1,
    1.3,0,1,
    1.8,0,0.7,
    2.2,0,1,
    3.5,0,1,
    3.8,0,0.8,
    4.1,0,1
  });

end;
--*********************************************************************************************************************
function private.ClkSecurityDoor ()

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_acsess_denied" );
  ObjAnimate("spr_securitypoint_red_light", "alp", 0, 0, 
  function ()
    int.Lock( false );
    cmn.ShowBbt( "bbt_securitypoint_use_securitybadge" );
  end, 
  {
    0.0,0,0,
    0.2,1,1,
    0.4,0,1,
    0.6,2,0
  });

end;
--*********************************************************************************************************************
function private.ClkClosedBox ()

  int.Lock( true );

  ObjAnimate("obj_stand3_closed_box", "pos_x", 0, 0, 
  function ()
    int.Lock( false );
    cmn.ShowBbt( "bbt_stand3_use_demonmedallion" );
  end, 
  {
    0.0,0,0,
    0.2,1,-1,
    0.4,0,0
  });

end;
--*********************************************************************************************************************
--********************************************************************************************************************
-- function *** MMG STAND3 ***  () end;
--********************************************************************************************************************
--********************************************************************************************************************
  function private.InitStand3 ()

    private.imp_pos = {1,1};
    private.angel_pos = {1,4};
    private.imp_win = false;
    private.angel_win = false;

    private.coord = {
      { {280,-39},{346,-39},{412,-39},{477,-39} },
      { {280, 25},{346, 25},{412, 25},{477, 25} },
      { {280, 92},{346, 92},{412, 92},{477, 92} },
      { {280,155},{346,155},{412,155},{477,155} }
    };

    private.imp_win_coord = {343,-107};
    private.angel_win_coord = {553,23};

    for i=1, 2 do
      for j = 1, 4 do
        ObjSet( "spr_stand3_arrow_light_"..i.."_"..j, {
          input = true;
          event_menter = function () private.EnterArrow ( i, j ); end,
          event_mleave = function () private.LeaveArrow ( i, j ); end
        } );
      end;
    end;

    ObjMultiSet( {
      { "spr_stand3_arrow_light_1_1", { event_mdown = function () private.ClkArrow( "imp", "up" ); end } },
      { "spr_stand3_arrow_light_1_2", { event_mdown = function () private.ClkArrow( "imp", "right" ); end } },
      { "spr_stand3_arrow_light_1_3", { event_mdown = function () private.ClkArrow( "imp", "down" ); end } },
      { "spr_stand3_arrow_light_1_4", { event_mdown = function () private.ClkArrow( "imp", "left" ); end } },
      { "spr_stand3_arrow_light_2_1", { event_mdown = function () private.ClkArrow( "angel", "up" ); end } },
      { "spr_stand3_arrow_light_2_2", { event_mdown = function () private.ClkArrow( "angel", "right" ); end } },
      { "spr_stand3_arrow_light_2_3", { event_mdown = function () private.ClkArrow( "angel", "down" ); end } },
      { "spr_stand3_arrow_light_2_4", { event_mdown = function () private.ClkArrow( "angel", "left" ); end } },
    } );

  end;
  --*********************************************************************************************************************
  function private.InitStand3Start ()  

    cmn.MiniGameShow( "stand3" );

    ng_global.progress[ "std" ][ "win_stand3" ].imp_pos = {1,1};
    ng_global.progress[ "std" ][ "win_stand3" ].angel_pos = {1,4};
    ng_global.progress[ "std" ][ "win_stand3" ].imp_win = false;
    ng_global.progress[ "std" ][ "win_stand3" ].angel_win = false;

  end;
  --********************************************************************************************************************
  function private.LoadStand3 ()

    private.imp_pos[ 1 ] = ng_global.progress[ "std" ][ "win_stand3" ].imp_pos[ 1 ];
    private.imp_pos[ 2 ] = ng_global.progress[ "std" ][ "win_stand3" ].imp_pos[ 2 ];
    private.angel_pos[ 1 ] = ng_global.progress[ "std" ][ "win_stand3" ].angel_pos[ 1 ];
    private.angel_pos[ 2 ] = ng_global.progress[ "std" ][ "win_stand3" ].angel_pos[ 2 ];
    private.imp_win = ng_global.progress[ "std" ][ "win_stand3" ].imp_win;
    private.angel_win = ng_global.progress[ "std" ][ "win_stand3" ].angel_win;

    if not ( private.imp_win ) then
      ObjSet( "spr_stand3_imp", {
        pos_x = private.coord[ private.imp_pos[ 1 ] ][ private.imp_pos[ 2 ] ][ 1 ],
        pos_y = private.coord[ private.imp_pos[ 1 ] ][ private.imp_pos[ 2 ] ][ 2 ]
      } );
    else
      ObjSet( "spr_stand3_imp", { alp = 0 } );
      ObjSet( "obj_stand3_arrows_imp", { input = false } );
    end;

    if not ( private.angel_win ) then
      ObjSet( "spr_stand3_angel", {
        pos_x = private.coord[ private.angel_pos[ 1 ] ][ private.angel_pos[ 2 ] ][ 1 ],
        pos_y = private.coord[ private.angel_pos[ 1 ] ][ private.angel_pos[ 2 ] ][ 2 ]
      } );
    else
      ObjSet( "spr_stand3_angel", { alp = 0 } );
      ObjSet( "obj_stand3_arrows_angel", { input = false } );
    end;

  end;
  --*********************************************************************************************************************
  function private.EnterArrow ( i, j )

    cmn.SetCursor(CURSOR_HAND);

    local alp_beg = ObjGet( "spr_stand3_arrow_light_"..i.."_"..j ).alp;
    ObjAnimate("spr_stand3_arrow_light_"..i.."_"..j, "alp", 0, 0, "", 
    {
      0.0,0,alp_beg,
      0.1,0,1
    });

  end;
  --*********************************************************************************************************************
  function private.LeaveArrow ( i, j )

    cmn.SetCursor(CURSOR_DEFAULT);

    local alp_beg = ObjGet( "spr_stand3_arrow_light_"..i.."_"..j ).alp;
    ObjAnimate("spr_stand3_arrow_light_"..i.."_"..j, "alp", 0, 0, "", 
    {
      0.0,0,alp_beg,
      0.1,0,0
    });

  end;
  --*********************************************************************************************************************
  function private.ClkArrow ( type, direction )

    if ( type == "imp" ) then

      if ( direction == "up" ) then

        local new_pos = 1;
        if ( private.imp_pos[2] == private.angel_pos[2] ) then
          for i=private.imp_pos[1]-1, 1, -1 do
            if ( i == private.angel_pos[1] ) then
              new_pos = i + 1;
              break;
            end;
          end;
        end;
        private.imp_pos[1] = new_pos;

        if ( private.imp_pos[1] == 1 ) and ( private.imp_pos[2] == 2 ) then
          private.imp_win = true;
          private.imp_pos = {0,0}
        end;

      elseif ( direction == "right" ) then

        local new_pos = 4;
        if ( private.imp_pos[1] == private.angel_pos[1] ) then
          for i=private.imp_pos[2]+1, 4, 1 do
            if ( i == private.angel_pos[2] ) then
              new_pos = i - 1;
              break;
            end;
          end;
        end;
        private.imp_pos[2] = new_pos;

      elseif ( direction == "down" ) then

        local new_pos = 4;

        if ( private.imp_pos[2] == 1 ) then
          new_pos = 3;
        end;

        if ( private.imp_pos[2] == private.angel_pos[2] ) then
          for i=private.imp_pos[1]+1, 4, 1 do
            if ( i == private.angel_pos[1] ) then
              new_pos = i - 1;
              break;
            end;
          end;
        end;
        private.imp_pos[1] = new_pos;

      elseif ( direction == "left" ) then

        local new_pos = 1;

        if ( private.imp_pos[1] == 4 ) then
          new_pos = 2;
        end;

        if ( private.imp_pos[1] == private.angel_pos[1] ) then
          for i=private.imp_pos[2]-1, 1, -1 do
            if ( i == private.angel_pos[2] ) then
              new_pos = i + 1;
              break;
            end;
          end;
        end;
        private.imp_pos[2] = new_pos;

      end;

      private.AnimFigures( "imp" );

    elseif ( type == "angel" ) then

      if ( direction == "up" ) then
        local new_pos = 1;
        if ( private.imp_pos[2] == private.angel_pos[2] ) then
          for i=private.angel_pos[1]-1, 1, -1 do
            if ( i == private.imp_pos[1] ) then
              new_pos = i + 1;
              break;
            end;
          end;
        end;
        private.angel_pos[1] = new_pos;

      elseif ( direction == "right" ) then

        local new_pos = 4;
        if ( private.imp_pos[1] == private.angel_pos[1] ) then
          for i=private.angel_pos[2]+1, 4, 1 do
            if ( i == private.imp_pos[2] ) then
              new_pos = i - 1;
              break;
            end;
          end;
        end;
        private.angel_pos[2] = new_pos;

        if ( private.angel_pos[1] == 2 ) and ( private.angel_pos[2] == 4 ) then
          private.angel_win = true;
          private.angel_pos = {0,0}
        end;

      elseif ( direction == "down" ) then

        local new_pos = 4;

        if ( private.angel_pos[2] == 1 ) then
          new_pos = 3;
        end;

        if ( private.imp_pos[2] == private.angel_pos[2] ) then
          for i=private.angel_pos[1]+1, 4, 1 do
            if ( i == private.imp_pos[1] ) then
              new_pos = i - 1;
              break;
            end;
          end;
        end;
        private.angel_pos[1] = new_pos;

      elseif ( direction == "left" ) then

        local new_pos = 1;

        if ( private.angel_pos[1] == 4 ) then
          new_pos = 2;
        end;

        if ( private.imp_pos[1] == private.angel_pos[1] ) then
          for i=private.angel_pos[2]-1, 1, -1 do
            if ( i == private.imp_pos[2] ) then
              new_pos = i + 1;
              break;
            end;
          end;
        end;
        private.angel_pos[2] = new_pos;

      end;

      private.AnimFigures( "angel" );

    end;

  end;
  --*********************************************************************************************************************
  function private.AnimFigures ( type )

    local old_x = ObjGet( "spr_stand3_"..type ).pos_x;
    local old_y = ObjGet( "spr_stand3_"..type ).pos_y;

    local new_x = 0;
    local new_y = 0;
--DbgTrace("private.imp_pos[ 1 ] = "..private.imp_pos[ 1 ]);
--DbgTrace("private.imp_pos[ 2 ] = "..private.imp_pos[ 2 ]);
--DbgTrace("private.angel_pos[ 1 ] = "..private.angel_pos[ 1 ]);
--DbgTrace("private.angel_pos[ 2 ] = "..private.angel_pos[ 2 ]);
   if ( type == "imp" ) then
      if ( private.imp_win ) then
        new_x = private.imp_win_coord[ 1 ];
        new_y = private.imp_win_coord[ 2 ];
      else
        new_x = private.coord[ private.imp_pos[ 1 ] ][ private.imp_pos[ 2 ] ][ 1 ];
        new_y = private.coord[ private.imp_pos[ 1 ] ][ private.imp_pos[ 2 ] ][ 2 ];
      end;
    elseif ( type == "angel" ) then
      if ( private.angel_win ) then
        new_x = private.angel_win_coord[ 1 ];
        new_y = private.angel_win_coord[ 2 ];
      else
        new_x = private.coord[ private.angel_pos[ 1 ] ][ private.angel_pos[ 2 ] ][ 1 ];
        new_y = private.coord[ private.angel_pos[ 1 ] ][ private.angel_pos[ 2 ] ][ 2 ];
      end;
    end;

    local func_end = function ()

      local func_end_1 = function ()

        int.Lock( false );
        private.CheckWinStand3();

      end;

      if ( type == "imp" ) and ( private.imp_win ) then
        
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_miniwin_mg_stand3" );
        ObjAnimate("spr_stand3_imp", "scale_xy", 0, 0, func_end_1, 
        {
          0.0,0,1,1,
          0.5,0,0,0
        });
        ObjSet( "obj_stand3_arrows_imp", { input = false } );

      elseif ( type == "angel" ) and ( private.angel_win ) then
        
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_miniwin_mg_stand3" );
        ObjAnimate("spr_stand3_angel", "scale_xy", 0, 0, func_end_1, 
        {
          0.0,0,1,1,
          0.5,0,0,0
        });
        ObjSet( "obj_stand3_arrows_angel", { input = false } );

      else

        func_end_1();

      end;

    end;

    int.Lock( true );
    if ( old_x ~= new_x or old_y ~= new_y ) then
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_stand3_click" );
    end;  
    ObjAnimate("spr_stand3_"..type, "pos_xy", 0, 0, func_end, 
    {
      0.0,0,old_x,old_y,
      0.3,3,new_x,new_y
    });

  end;
  --*********************************************************************************************************************
  function private.CheckWinStand3 ()

    if ( private.imp_win ) and ( private.angel_win ) then
      private.WinStand3();
    else
      ng_global.progress[ "std" ][ "win_stand3" ].imp_pos[ 1 ] = private.imp_pos[ 1 ];
      ng_global.progress[ "std" ][ "win_stand3" ].imp_pos[ 2 ] = private.imp_pos[ 2 ];
      ng_global.progress[ "std" ][ "win_stand3" ].angel_pos[ 1 ] = private.angel_pos[ 1 ];
      ng_global.progress[ "std" ][ "win_stand3" ].angel_pos[ 2 ] = private.angel_pos[ 2 ];
      ng_global.progress[ "std" ][ "win_stand3" ].imp_win = private.imp_win;
      ng_global.progress[ "std" ][ "win_stand3" ].angel_win = private.angel_win;
    end;

  end;
  --*********************************************************************************************************************
  function private.WinStand3 ()

    local func_end = function ()

      cmn.MiniGameHide( "stand3" );
      cmn.SetEventDone( "win_stand3" );
      cmn.CallEventHandler( "win_stand3" );
      common_impl.PassingMgWin( "stand3" );
      ObjSet( "spr_stand3_collect2_3_4", { input = true } );

      int.Lock( false ) ;

    end;

    int.Lock( true ) ;
    local func_end_aud = function ()
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_open_mg_box" );
    end;
    ObjSet( "tmr_stand3_1", { playing = 1, time = 0.5, endtrig = func_end_aud } );

    ObjAnimate("obj_stand3_mmg", "alp", 0, 0, "", 
    {
      0.0,0,1,
      0.3,0,0
    });
    ObjAnimate("obj_stand3_open_box", "alp", 0, 0, func_end, 
    {
      0.0,0,0,
      0.5,0,0,
      0.8,0,1
    });


  end;
  --*********************************************************************************************************************
--*********************************************************************************************************************
--******function *** MMG_SECURITYPOINT *** () *************************************************************************************
--*********************************************************************************************************************
  function private.InitSecuritypoint ()

    private.code = "";

    for i=0, 11 do
      ObjSet( "spr_securitypoint_button_"..i, {
        input = true,
        inputrect_init = true,
        inputrect_x = -15,
        inputrect_y = -15,
        inputrect_w = 30,
        inputrect_h = 30,
        event_mdown = function () private.ClkKnob( i ); end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND); end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT); end,
      });
    end;
    ObjSet( "spr_securitypoint_button_lock", {
      input = true,
        inputrect_init = true,
        inputrect_x = -15,
        inputrect_y = -15,
        inputrect_w = 30,
        inputrect_h = 30,
      event_mdown = function () private.ClkButtonLock(); end,
      event_menter = function () cmn.SetCursor( CURSOR_HAND); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT); end,
    });

  end;
  --*********************************************************************************************************************
  function private.StartSecuritypoint ()

    --ng_global.progress[ "std" ][ "win_securitypoint" ].code = "";
    ng_global.progress[ "std" ][ "win_securitypoint" ].start = 1;

    ObjSet( "obj_securitypoint_buttons", { input = true } );
    --cmn.MiniGameShow( "securitypoint" );

  end;
  --*********************************************************************************************************************
  function private.ClkKnob ( num )

    int.Lock( true );
    
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_press_button" );
    
    if ( #private.code < 10 ) then

      if ( num == 10 ) then

        private.code = private.code.."*";

      elseif ( num == 11 ) then

        private.code = private.code.."#";

      else

        private.code = private.code..num;

      end;

      --ObjSet( "txt_securitypoint_numbers", { text = private.code } );
      ng_global.progress[ "std" ][ "win_securitypoint" ].code = private.code;

    end;

    --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_press_number"..n );
    ObjAnimate( "spr_securitypoint_button_"..num, "alp", 0, 0, function () int.Lock( false ); end, 
    {
      0.0,0,0,
      0.2,0,1,
      0.3,0,1,
      0.5,0,0
    });

  end;
  --*********************************************************************************************************************
  function private.ClkButtonLock ()

    int.Lock( true );

    if ( private.code == "4255" ) then
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_press_on" );
    else 
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_press_wrong" );
    end;

    ObjAnimate("spr_securitypoint_button_lock", "alp", 0, 0, function () private.CheckWin(); end, 
    {
      0.0,0,0,
      0.2,0,1,
      0.3,0,1,
      0.5,0,0
    });

  end;
  --*********************************************************************************************************************
  function private.CheckWin ()

    if ( private.code == "4255"  and cmn.IsEventStart( "win_securitypoint" ) ) then
      
      local func_end_aud = function ()
      
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_open_police_box" );
        
      end;

      ObjSet( "tmr_securitypoint_1", { playing = 1, time = 0.6, endtrig = func_end_aud } );
      ObjAnimate("spr_securitypoint_green_light", "alp", 0, 0, "", 
      {
        0.0,0,0,
        0.3,1,1,
      });
      ObjAnimate("obj_securitypoint_closed", "alp", 0, 0, function () private.Win(); end, 
      {
        0.0,0,1,
        0.6,0,1,
        0.9,0,0
      });

    else   
   
      ObjAnimate("spr_securitypoint_red_light", "alp", 0, 0, 
      function () 
        int.Lock( false );   
        private.code = "";
        --ng_global.progress[ "std" ][ "win_securitypoint" ].code = private.code;      
      end, 
      {
        0.0,0,0,
        0.2,1,1,
        0.4,0,1,
        0.6,2,0
      });

    end;

  end;
  --*********************************************************************************************************************
  function private.Win ()

    --cmn.MiniGameHide( "securitypoint" );

    int.Lock( false );

    cmn.SetEventDone( "win_securitypoint" );
    cmn.CallEventHandler( "win_securitypoint" ); 
   
    --cmn.CloseSubRoom();
    --cmn.GotoRoom( "mg_mgboxes" );

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
