-- name=rm_controltower
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_controltower";

  ObjAttach( "zz_controlpanel",   "room_hub" );
  ObjAttach( "zz_chestofdrawers", "room_hub" );
  ObjAttach( "zz_desktop",        "room_hub" );
  ObjAttach( "zz_serverroomdoor", "room_hub" );
  
  ObjMultiSet( {
    { "spr_controlpanel_pliers3",      { event_mdown = private.get_pliers3 } },
    { "spr_controlpanel_planeamulet",  { event_mdown = private.get_planeamulet } },
    { "spr_controlpanel_ruler",        { event_mdown = private.get_ruler } },
    { "spr_chestofdrawers_wire3_1",    { event_mdown = private.get_wire3_1 } },
    { "spr_chestofdrawers_switch3_2",  { event_mdown = private.get_switch3_2 } },
    { "spr_chestofdrawers_airhostess", { event_mdown = private.get_airhostess } },
    { "spr_desktop_demonmedallion",    { event_mdown = private.get_demonmedallion } },
    { "spr_desktop_shell_2",           { event_mdown = private.get_shell_2 } },
    { "spr_desktop_wire3_3",           { event_mdown = private.get_wire3_3 } },
    { "spr_desktop_pass",              { event_mdown = private.get_pass } },
    { "obj_desktop_use_switch3",       { event_mdown = private.ClkSafe } },
    { "obj_controlpanel_use_wrench3",  { event_mdown = private.ClkPanel } },
    { "obj_serverroomdoor_use_pass",   { event_mdown = private.ServerroomdoorClick } },
    { "obj_desktop_use_tweezers3",     { event_mdown = private.ShelfClick } },
    { "obj_desktop_use_mechanic",      { event_mdown = private.BoxClick } },
    { "obj_desktop_use_airhostess",    { event_mdown = private.BoxClick } },
    { "obj_desktop_use_pilot",         { event_mdown = private.BoxClick } },
    { "spr_desktop_booklet",           { event_mdown = function () private.ClkNote( true ) end } },
    { "obj_desktop_booklet_big",       { event_mdown = function () private.ClkNote( false ) end } },
    { "obj_controlpanel_clk_brokenkeyboard", { event_mdown = private.clk_brokenkeyboard } },
    
  } );

  private.InitSubroom();
  private.InitAnims();

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    int.InitMorphRandomState( 3 );

  end;

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_controltower = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gho_controltower_serverroom",
        "gmg_controltower_worriedmessage",
        "gzz_controltower_controlpanel",
        "gzz_controltower_chestofdrawers",
        "gzz_controltower_desktop",
        "gzz_controltower_serverroomdoor",
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_controlpanel", 
        "zz_chestofdrawers", 
        "zz_desktop",
        "zz_serverroomdoor",
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_controltower", update_game_mode_controltower, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_pliers3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pliers3" ] =
  {
    type = "get",
    get_obj = "spr_controlpanel_pliers3",
    room = private.room_objname,
    zz = "zz_controlpanel",
    zz_gate = "gzz_controltower_controlpanel"
  };
  -----------------------------------------------
  local get_pliers3_inv = function ()

    int.InventoryItemAdd( "inv_pliers3", "spr_controlpanel_pliers3" );

  end;

  local get_pliers3_closezz = function ()

    ObjDelete( "gfx_controlpanel_pliers3" );
    ObjDelete( "spr_controlpanel_pliers3_shad" );
    ObjDelete( "spr_controltower_pliers" );

  end;

  cmn.AddSubscriber( "get_pliers3", get_pliers3_inv );
  cmn.AddSubscriber( "get_pliers3", get_pliers3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_planeamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_planeamulet" ] =
  {
    type = "get",
    get_obj = "spr_controlpanel_planeamulet",
    room = private.room_objname,
    zz = "zz_controlpanel",
    zz_gate = "gzz_controltower_controlpanel"
  };
  -----------------------------------------------
  local get_planeamulet_inv = function ()

    int.InventoryItemAdd( "inv_planeamulet", "spr_controlpanel_planeamulet" );

  end;

  local get_planeamulet_closezz = function ()

    ObjDelete( "gfx_controlpanel_planeamulet" );
    ObjDelete( "spr_controlpanel_planeamulet_shad" );
    ObjDelete( "spr_controlpanel_planeamulet_add" );
    ObjDelete( "spr_controltower_planeamulet" );
    --ObjDelete( "gzz_controltower_controlpanel" );

  end;

  cmn.AddSubscriber( "get_planeamulet", get_planeamulet_inv );
  cmn.AddSubscriber( "get_planeamulet", get_planeamulet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ruler () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ruler" ] =
  {
    type = "get",
    get_obj = "spr_controlpanel_ruler",
    room = private.room_objname,
    zz = "zz_controlpanel",
    zz_gate = "gzz_controltower_controlpanel"
  };
  -----------------------------------------------
  local get_ruler_inv = function ()

    int.InventoryItemAdd( "inv_ruler", "spr_controlpanel_ruler" );

  end;

  local get_ruler_closezz = function ()

    ObjDelete( "gfx_controlpanel_ruler" );
    ObjDelete( "spr_controlpanel_ruler_shad" );
    ObjDelete( "spr_controltower_ruler" );
    --ObjDelete( "gzz_controltower_controlpanel" );

  end;

  cmn.AddSubscriber( "get_ruler", get_ruler_inv );
  cmn.AddSubscriber( "get_ruler", get_ruler_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wire3_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wire3_1" ] =
  {
    type = "get",
    get_obj = "spr_chestofdrawers_wire3_1",
    room = private.room_objname,
    zz = "zz_chestofdrawers",
    zz_gate = "gzz_controltower_chestofdrawers"
  };
  -----------------------------------------------
  local get_wire3_1_inv = function ()

    int.InventoryItemAdd( "inv_wire3", "spr_chestofdrawers_wire3_1", "assets/levels/level3/rm_controltower/zz_chestofdrawers/inv/inv_wire_1_morph" );
    level3_inv.CheckWire3();

  end;

  local get_wire3_1_closezz = function ()

    ObjDelete( "gfx_chestofdrawers_wire3_1" );
    ObjDelete( "spr_chestofdrawers_wire3_1_shadow" );
    ObjDelete( "spr_controltower_wire3_1" );

    if ( cmn.IsEventDone( "get_airhostess" ) ) and
       ( cmn.IsEventDone( "get_switch3_2" ) ) then

        ObjDelete( "gzz_controltower_chestofdrawers" );

    end;

  end;

  cmn.AddSubscriber( "get_wire3_1", get_wire3_1_inv );
  cmn.AddSubscriber( "get_wire3_1", get_wire3_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_switch3_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_switch3_2" ] =
  {
    type = "get",
    get_obj = "spr_chestofdrawers_switch3_2",
    room = private.room_objname,
    zz = "zz_chestofdrawers",
    zz_gate = "gzz_controltower_chestofdrawers"
  };
  -----------------------------------------------
  local get_switch3_2_inv = function ()

    int.InventoryItemAdd( "inv_switch3", "spr_chestofdrawers_switch3_2", "assets/levels/level3/rm_technicalroom/zz_stafdrawers/inv/inv_switch_morph" );
    level3_inv.CheckSwitch();

  end;

  local get_switch3_2_closezz = function ()

    ObjDelete( "gfx_chestofdrawers_switch3_2" );
    ObjDelete( "spr_chestofdrawers_switch3_2_shadow" );

    if ( cmn.IsEventDone( "get_airhostess" ) ) and
       ( cmn.IsEventDone( "get_wire3_1" ) ) then

        ObjDelete( "gzz_controltower_chestofdrawers" );

    end;

  end;

  cmn.AddSubscriber( "get_switch3_2", get_switch3_2_inv );
  cmn.AddSubscriber( "get_switch3_2", get_switch3_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_airhostess () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_airhostess" ] =
  {
    type = "get",
    get_obj = "spr_chestofdrawers_airhostess",
    room = private.room_objname,
    zz = "zz_chestofdrawers",
    zz_gate = "gzz_controltower_chestofdrawers"
  };
  -----------------------------------------------
  local get_airhostess_inv = function ()

    int.InventoryItemAdd( "inv_airhostess", "spr_chestofdrawers_airhostess" );

  end;

  local get_airhostess_closezz = function ()

    ObjDelete( "gfx_chestofdrawers_airhostess" );
    ObjDelete( "spr_chestofdrawers_airhostess_shadow" );
    ObjDelete( "spr_controltower_airhostess" );

    if ( cmn.IsEventDone( "get_switch3_2" ) ) and
       ( cmn.IsEventDone( "get_wire3_1" ) ) then

        ObjDelete( "gzz_controltower_chestofdrawers" );

    end;

  end;

  cmn.AddSubscriber( "get_airhostess", get_airhostess_inv );
  cmn.AddSubscriber( "get_airhostess", get_airhostess_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_demonmedallion () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_demonmedallion" ] =
  {
    type = "get",
    get_obj = "spr_desktop_demonmedallion",
    room = private.room_objname,
    zz = "zz_desktop",
    zz_gate = "gzz_controltower_desktop"
  };
  -----------------------------------------------
  local get_demonmedallion_inv = function ()

    int.InventoryItemAdd( "inv_demonmedallion", "spr_desktop_demonmedallion" );

  end;

  local get_demonmedallion_closezz = function ()

    ObjDelete( "gfx_desktop_demonmedallion" );

    if ( cmn.IsEventDone( "get_demonmedallion" ) and
         cmn.IsEventDone( "get_shell_2" ) ) then

      ObjDelete( "gzz_controltower_desktop" );

    end;

  end;

  cmn.AddSubscriber( "get_demonmedallion", get_demonmedallion_inv );
  cmn.AddSubscriber( "get_demonmedallion", get_demonmedallion_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_shell_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_shell_2" ] =
  {
    type = "get",
    get_obj = "spr_desktop_shell_2",
    room = private.room_objname,
    zz = "zz_desktop",
    zz_gate = "gzz_controltower_desktop"
  };
  -----------------------------------------------
  local get_shell_2_inv = function ()

  int.InventoryItemAdd( "inv_shell", "spr_desktop_shell_2", "assets/levels/level3/common_inventory3/inv_purse3/inv/part4_morph" );
    level3_inv.CheckShell();

  end;

  local get_shell_2_closezz = function ()

    ObjDelete( "gfx_desktop_shell_2" );
    ObjDelete( "spr_controltower_shell_2" );
    ObjDelete( "spr_desktop_shell_2_shadow" );

    if ( cmn.IsEventDone( "get_demonmedallion" ) and
         cmn.IsEventDone( "get_shell_2" ) ) then

      ObjDelete( "gzz_controltower_desktop" );

    end;

  end;

  cmn.AddSubscriber( "get_shell_2", get_shell_2_inv );
  cmn.AddSubscriber( "get_shell_2", get_shell_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wire3_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wire3_3" ] =
  {
    type = "get",
    get_obj = "spr_desktop_wire3_3",
    room = private.room_objname,
    zz = "zz_desktop",
    zz_gate = "gzz_controltower_desktop"
  };
  -----------------------------------------------
  local get_wire3_3_inv = function ()

    int.InventoryItemAdd( "inv_wire3", "spr_desktop_wire3_3", "assets/levels/level3/rm_controltower/zz_chestofdrawers/inv/inv_wire_3_morph" );
    level3_inv.CheckWire3();

  end;

  local get_wire3_3_closezz = function ()

    ObjDelete( "gfx_desktop_wire3_3" );
    --ObjDelete( "gzz_controltower_desktop" );

  end;

  cmn.AddSubscriber( "get_wire3_3", get_wire3_3_inv );
  cmn.AddSubscriber( "get_wire3_3", get_wire3_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pass () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pass" ] =
  {
    type = "get",
    get_obj = "spr_desktop_pass",
    room = private.room_objname,
    zz = "zz_desktop",
    zz_gate = "gzz_controltower_desktop"
  };
  -----------------------------------------------
  local get_pass_inv = function ()

    int.InventoryItemAdd( "inv_pass", "spr_desktop_pass" );

  end;

  local get_pass_closezz = function ()

    ObjDelete( "gfx_desktop_pass" );
    ObjSet( "obj_desktop_safe", { input = false } );
    --ObjDelete( "gzz_controltower_desktop" );

  end;

  cmn.AddSubscriber( "get_pass", get_pass_inv );
  cmn.AddSubscriber( "get_pass", get_pass_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_3_6 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_3_6 = function ()

    ObjDelete( "obj_controltower_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_3_6", get_morphobject_3_6, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_keyboard () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_keyboard" ] =
  {
    type = "use",
    use_obj = "inv_keyboard",
    use_place = "obj_controlpanel_use_keyboard",
    room = private.room_objname,
    zz = "zz_controlpanel",
    zz_gate = "gzz_controltower_controlpanel"
  };
  -----------------------------------------------
  local use_keyboard_inv = function ()

    int.InventoryItemRemove( "inv_keyboard" );

  end;
  local use_keyboard_beg = function ()

    ObjDelete( "obj_controlpanel_use_keyboard" );

  end;
  local use_keyboard_end = function ()

    if cmn.IsEventDone( "use_keyboard" ) and
       cmn.IsEventDone( "use_lever3" ) and
       cmn.IsEventDone( "use_button_1" ) and
       cmn.IsEventDone( "use_button_2" ) then

      ObjSet( "gmg_controltower_worriedmessage", { active = true, input = true, alp = 1 } );
      ObjDelete( "gzz_controltower_controlpanel" );

    end;

      if ( cmn.IsEventDone( "use_button_1" ) and
           cmn.IsEventDone( "use_button_2" ) ) then
        ObjSet( "obj_controlpanel_anim_panel2", { alp = 1 } );
      end;

    ObjSet( "spr_controltower_keyboard_new", { alp = 1 } );
    ObjSet( "spr_controlpanel_keyboard_new", { alp = 1 } );
    ObjDelete( "anm_controlpanel_keyboard_new" );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_keyboard", use_keyboard_beg, private.room_objname );
  cmn.AddSubscriber( "use_keyboard", use_keyboard_inv );
  cmn.AddSubscriber( "use_keyboard", use_keyboard_end, private.room_objname );
  cmn.AddSubscriber( "use_keyboard_inv", use_keyboard_inv, private.room_objname );
  cmn.AddSubscriber( "use_keyboard_beg", use_keyboard_beg, private.room_objname );
  cmn.AddSubscriber( "use_keyboard_end", use_keyboard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lever3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lever3" ] =
  {
    type = "use",
    use_obj = "inv_lever3",
    use_place = "obj_controlpanel_use_lever3",
    room = private.room_objname,
    zz = "zz_controlpanel",
    zz_gate = "gzz_controltower_controlpanel"
  };
  -----------------------------------------------
  local use_lever3_inv = function ()

    int.InventoryItemRemove( "inv_lever3" );

  end;
  local use_lever3_beg = function ()

    ObjDelete( "obj_controlpanel_use_lever3" );

  end;
  local use_lever3_end = function ()

    if cmn.IsEventDone( "use_keyboard" ) and
       cmn.IsEventDone( "use_lever3" ) and
       cmn.IsEventDone( "use_button_1" ) and
       cmn.IsEventDone( "use_button_2" ) then
      ObjSet( "gmg_controltower_worriedmessage", { active = true, input = true, alp = 1 } );
      ObjDelete( "gzz_controltower_controlpanel" );
    end;

    ObjSet( "obj_controlpanel_lever", { alp = 1 } );
    ObjSet( "spr_controltower_lever_1", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_lever3", use_lever3_beg, private.room_objname );
  cmn.AddSubscriber( "use_lever3", use_lever3_inv );
  cmn.AddSubscriber( "use_lever3", use_lever3_end, private.room_objname );
  cmn.AddSubscriber( "use_lever3_inv", use_lever3_inv, private.room_objname );
  cmn.AddSubscriber( "use_lever3_beg", use_lever3_beg, private.room_objname );
  cmn.AddSubscriber( "use_lever3_end", use_lever3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_button_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_button_1" ] =
  {
    type = "use",
    use_obj = "inv_button_1",
    use_place = "obj_controlpanel_use_button_1",
    room = private.room_objname,
    zz = "zz_controlpanel",
    zz_gate = "gzz_controltower_controlpanel"
  };
  -----------------------------------------------
  local use_button_1_inv = function ()

    int.InventoryItemRemove( "inv_button_1" );

  end;
  local use_button_1_beg = function ()

    ObjDelete( "obj_controlpanel_use_button_1" );

  end;
  local use_button_1_end = function ()

    if cmn.IsEventDone( "use_keyboard" ) and
       cmn.IsEventDone( "use_lever3" ) and
       cmn.IsEventDone( "use_button_1" ) and
       cmn.IsEventDone( "use_button_2" ) then

      ObjSet( "gmg_controltower_worriedmessage", { active = true, input = true, alp = 1 } );
      ObjDelete( "gzz_controltower_controlpanel" );

    end;

    if cmn.IsEventDone( "use_button_1" ) and
       cmn.IsEventDone( "use_button_2" ) then

      ObjDelete( "obj_controlpanel_button" );
      ObjSet( "obj_controlpanel_anim_panel1", { alp = 1 } );

      if ( cmn.IsEventDone( "use_keyboard" ) ) then
        ObjSet( "obj_controlpanel_anim_panel2", { alp = 1 } );
      end;

    end;

    ObjDelete( "spr_controlpanel_nobutton2" );
    ObjDelete( "spr_controltower_nobutton_1" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_button_1", use_button_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_1", use_button_1_inv );
  cmn.AddSubscriber( "use_button_1", use_button_1_end, private.room_objname );
  cmn.AddSubscriber( "use_button_1_inv", use_button_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_button_1_beg", use_button_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_1_end", use_button_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_button_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_button_2" ] =
  {
    type = "use",
    use_obj = "inv_button_2",
    use_place = "obj_controlpanel_use_button_2",
    room = private.room_objname,
    zz = "zz_controlpanel",
    zz_gate = "gzz_controltower_controlpanel"
  };
  -----------------------------------------------
  local use_button_2_inv = function ()

    int.InventoryItemRemove( "inv_button_2" );

  end;
  local use_button_2_beg = function ()

    ObjDelete( "obj_controlpanel_use_button_2" );

  end;
  local use_button_2_end = function ()

    if cmn.IsEventDone( "use_keyboard" ) and
       cmn.IsEventDone( "use_lever3" ) and
       cmn.IsEventDone( "use_button_1" ) and
       cmn.IsEventDone( "use_button_2" ) then

      ObjSet( "gmg_controltower_worriedmessage", { active = true, input = true, alp = 1 } );
      ObjDelete( "gzz_controltower_controlpanel" );

    end;

    if cmn.IsEventDone( "use_button_1" ) and
       cmn.IsEventDone( "use_button_2" ) then

      ObjDelete( "obj_controlpanel_button" );
      ObjSet( "obj_controlpanel_anim_panel1", { alp = 1 } );

      if ( cmn.IsEventDone( "use_keyboard" ) ) then
        ObjSet( "obj_controlpanel_anim_panel2", { alp = 1 } );
      end;

    end;

    ObjDelete( "spr_controlpanel_nobutton1" );
    ObjDelete( "spr_controltower_nobutton_2" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_button_2", use_button_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_2", use_button_2_inv );
  cmn.AddSubscriber( "use_button_2", use_button_2_end, private.room_objname );
  cmn.AddSubscriber( "use_button_2_inv", use_button_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_button_2_beg", use_button_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_2_end", use_button_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wrench3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wrench3" ] =
  {
    type = "use",
    use_obj = "inv_wrench3",
    use_place = "obj_controlpanel_use_wrench3",
    room = private.room_objname,
    zz = "zz_controlpanel",
    zz_gate = "gzz_controltower_controlpanel"
  };
  -----------------------------------------------
  local use_wrench3_inv = function ()

    int.InventoryItemRemove( "inv_wrench3" );

  end;
  local use_wrench3_beg = function ()

    ObjDelete( "obj_controlpanel_use_wrench3" );

  end;
  local use_wrench3_end = function ()

    ObjSet( "spr_controlpanel_planeamulet", { input = true } );
    ObjSet( "gfx_controlpanel_planeamulet", { active = true } );
    ObjSet( "spr_controlpanel_airplane_opn", { alp = 1, input = true } );
    ObjSet( "spr_controltower_stash_open", { alp = 1 } );
    ObjSet( "spr_controlpanel_planeamulet_add", { active = true } );
    ObjDelete( "anm_controlpanel_use_wrench3" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_wrench3", use_wrench3_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrench3", use_wrench3_inv );
  cmn.AddSubscriber( "use_wrench3", use_wrench3_end, private.room_objname );
  cmn.AddSubscriber( "use_wrench3_inv", use_wrench3_inv, private.room_objname );
  cmn.AddSubscriber( "use_wrench3_beg", use_wrench3_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrench3_end", use_wrench3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wire3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wire3" ] =
  {
    type = "use",
    use_obj = "inv_wire3",
    use_place = "obj_controlpanel_use_wire3",
    room = private.room_objname,
    zz = "zz_controlpanel",
    zz_gate = "gzz_controltower_controlpanel"
  };
  -----------------------------------------------
  local use_wire3_inv = function ()

    int.InventoryItemRemove( "inv_wire3" );

  end;
  local use_wire3_beg = function ()

    ObjDelete( "obj_controlpanel_use_wire3" );

  end;
  local use_wire3_end = function ()

    ObjSet( "spr_controlpanel_pliers3",    { input = true } );
    ObjSet( "gfx_controlpanel_pliers3",    { active = true } );
    ObjSet( "spr_controlpanel_wires",      { alp = 1 } );
    ObjSet( "obj_controlpanel_open_2",     { input = true } );
    ObjSet( "spr_controltower_wires",      { alp = 1 } );
    ObjSet( "spr_controltower_cache_open", { alp = 1 } );
    ObjDelete( "anm_controlpanel_opened" );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_wire3", use_wire3_beg, private.room_objname );
  cmn.AddSubscriber( "use_wire3", use_wire3_inv );
  cmn.AddSubscriber( "use_wire3", use_wire3_end, private.room_objname );
  cmn.AddSubscriber( "use_wire3_inv", use_wire3_inv, private.room_objname );
  cmn.AddSubscriber( "use_wire3_beg", use_wire3_beg, private.room_objname );
  cmn.AddSubscriber( "use_wire3_end", use_wire3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_framedpic () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_framedpic" ] =
  {
    type = "use",
    use_obj = "inv_framedpic",
    use_place = "obj_chestofdrawers_use_framedpic",
    room = private.room_objname,
    zz = "zz_chestofdrawers",
    zz_gate = "gzz_controltower_chestofdrawers"
  };
  -----------------------------------------------
  local use_framedpic_inv = function ()

    int.InventoryItemRemove( "inv_framedpic" );

  end;
  local use_framedpic_beg = function ()

    ObjDelete( "obj_chestofdrawers_use_framedpic" );

  end;
  local use_framedpic_end = function ()

    ObjSet( "obj_chestofdrawers_box_open",   { alp = 1, input = true } );
    ObjSet( "spr_chestofdrawers_framedpic",  { alp = 1 } );
    ObjSet( "gfx_chestofdrawers_switch3_2",  { active = true } );
    ObjSet( "gfx_chestofdrawers_airhostess", { active = true } );
    ObjSet( "spr_controltower_open_box", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_framedpic", use_framedpic_beg, private.room_objname );
  cmn.AddSubscriber( "use_framedpic", use_framedpic_inv );
  cmn.AddSubscriber( "use_framedpic", use_framedpic_end, private.room_objname );
  cmn.AddSubscriber( "use_framedpic_inv", use_framedpic_inv, private.room_objname );
  cmn.AddSubscriber( "use_framedpic_beg", use_framedpic_beg, private.room_objname );
  cmn.AddSubscriber( "use_framedpic_end", use_framedpic_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tweezers3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tweezers3" ] =
  {
    type = "use",
    use_obj = "inv_tweezers3",
    use_place = "obj_desktop_use_tweezers3",
    room = private.room_objname,
    zz = "zz_desktop",
    zz_gate = "gzz_controltower_desktop"
  };
  -----------------------------------------------
  local use_tweezers3_inv = function ()

    int.InventoryItemRemove( "inv_tweezers3" );

  end;
  local use_tweezers3_beg = function ()

    ObjDelete( "obj_desktop_use_tweezers3" );

  end;
  local use_tweezers3_end = function ()

    ObjSet( "spr_desktop_demonmedallion", { input = true } );
    ObjSet( "gfx_desktop_demonmedallion", { active = true } );
    ObjSet( "spr_desktop_shelf", { input = true, pos_x = 53, pos_y = 164 } );
    ObjSet( "anm_desktop_shelf_click", { alp = 1 } );
    ObjDelete( "spr_desktop_lock" );
    ObjDelete( "anm_desktop_use_tweezers3" );    

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_tweezers3", use_tweezers3_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers3", use_tweezers3_inv );
  cmn.AddSubscriber( "use_tweezers3", use_tweezers3_end, private.room_objname );
  cmn.AddSubscriber( "use_tweezers3_inv", use_tweezers3_inv, private.room_objname );
  cmn.AddSubscriber( "use_tweezers3_beg", use_tweezers3_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers3_end", use_tweezers3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mechanic () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mechanic" ] =
  {
    type = "use",
    use_obj = "inv_mechanic",
    use_place = "obj_desktop_use_mechanic",
    room = private.room_objname,
    zz = "zz_desktop",
    zz_gate = "gzz_controltower_desktop"
  };
  -----------------------------------------------
  local use_mechanic_inv = function ()

    int.InventoryItemRemove( "inv_mechanic" );

  end;
  local use_mechanic_beg = function ()

    ObjDelete( "obj_desktop_use_mechanic" );

  end;
  local use_mechanic_end = function ()

    ObjSet( "spr_desktop_working", { alp = 1 } );
    ObjSet( "spr_controltower_mechanic", { alp = 1 } );
    ObjSet( "anm_desktop_mechanic", { alp = 1 } );
    ObjSet( "obj_desktop_mechanic", { input = true } );

    if cmn.IsEventDone( "use_mechanic" ) and
       cmn.IsEventDone( "use_airhostess" ) and
       cmn.IsEventDone( "use_pilot" ) then

      ObjSet( "gfx_desktop_shell_2", { active = true } );
      ObjSet( "gfx_desktop_wire3_3", { active = true } );
      ObjSet( "obj_desktop_open_box", { alp = 1, input = true } );
      ObjSet( "spr_controltower_shell_2", { alp = 1 } );
      ObjDelete( "anm_desktop_box_click" );
      ObjDelete( "anm_desktop_box_open" );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_mechanic", use_mechanic_beg, private.room_objname );
  cmn.AddSubscriber( "use_mechanic", use_mechanic_inv );
  cmn.AddSubscriber( "use_mechanic", use_mechanic_end, private.room_objname );
  cmn.AddSubscriber( "use_mechanic_inv", use_mechanic_inv, private.room_objname );
  cmn.AddSubscriber( "use_mechanic_beg", use_mechanic_beg, private.room_objname );
  cmn.AddSubscriber( "use_mechanic_end", use_mechanic_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_switch3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_switch3" ] =
  {
    type = "use",
    use_obj = "inv_switch3",
    use_place = "obj_desktop_use_switch3",
    room = private.room_objname,
    zz = "zz_desktop",
    zz_gate = "gzz_controltower_desktop"
  };
  -----------------------------------------------
  local use_switch3_inv = function ()

    int.InventoryItemRemove( "inv_switch3" );

  end;
  local use_switch3_beg = function ()

    ObjDelete( "obj_desktop_use_switch3" );

  end;
  local use_switch3_end = function ()

    ObjSet( "spr_desktop_pass", { input = true } );
    ObjSet( "gfx_desktop_pass", { active = true } );
    ObjDelete( "spr_desktop_safe_door" );
    ObjDelete( "anm_desktop_safe_open" );
    ObjSet( "spr_desktop_open_safe",      { alp = 1, input = true  } );
    ObjSet( "spr_controltower_safe_open", { alp = 1  } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_switch3", use_switch3_beg, private.room_objname );
  cmn.AddSubscriber( "use_switch3", use_switch3_inv );
  cmn.AddSubscriber( "use_switch3", use_switch3_end, private.room_objname );
  cmn.AddSubscriber( "use_switch3_inv", use_switch3_inv, private.room_objname );
  cmn.AddSubscriber( "use_switch3_beg", use_switch3_beg, private.room_objname );
  cmn.AddSubscriber( "use_switch3_end", use_switch3_end, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function use_airhostess () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_airhostess" ] =
  {
    type = "use",
    use_obj = "inv_airhostess",
    use_place = "obj_desktop_use_airhostess",
    room = private.room_objname,
    zz = "zz_desktop",
    zz_gate = "gzz_controltower_desktop"
  };
  -----------------------------------------------
  local use_airhostess_inv = function ()

    int.InventoryItemRemove( "inv_airhostess" );

  end;
  local use_airhostess_beg = function ()

    ObjDelete( "obj_desktop_use_airhostess" );

  end;
  local use_airhostess_end = function ()

    ObjSet( "spr_desktop_stewardess", { alp = 1 } );
    ObjSet( "spr_controltower_airhostess2", { alp = 1 } );
    ObjSet( "anm_desktop_airhostess", { alp = 1 } );
    ObjSet( "obj_desktop_airhostess", { input = true } );

    if cmn.IsEventDone( "use_mechanic" ) and
       cmn.IsEventDone( "use_airhostess" ) and
       cmn.IsEventDone( "use_pilot" ) then

      ObjSet( "gfx_desktop_shell_2", { active = true } );
      ObjSet( "gfx_desktop_wire3_3", { active = true } );
      ObjSet( "obj_desktop_open_box", { alp = 1, input = true } );
      ObjSet( "spr_controltower_shell_2", { alp = 1 } );
      ObjDelete( "anm_desktop_box_click" );
      ObjDelete( "anm_desktop_box_open" );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_airhostess", use_airhostess_beg, private.room_objname );
  cmn.AddSubscriber( "use_airhostess", use_airhostess_inv );
  cmn.AddSubscriber( "use_airhostess", use_airhostess_end, private.room_objname );
  cmn.AddSubscriber( "use_airhostess_inv", use_airhostess_inv, private.room_objname );
  cmn.AddSubscriber( "use_airhostess_beg", use_airhostess_beg, private.room_objname );
  cmn.AddSubscriber( "use_airhostess_end", use_airhostess_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pilot () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pilot" ] =
  {
    type = "use",
    use_obj = "inv_pilot",
    use_place = "obj_desktop_use_pilot",
    room = private.room_objname,
    zz = "zz_desktop",
    zz_gate = "gzz_controltower_desktop"
  };
  -----------------------------------------------
  local use_pilot_inv = function ()

    int.InventoryItemRemove( "inv_pilot" );

  end;
  local use_pilot_beg = function ()

    ObjDelete( "obj_desktop_use_pilot" );

  end;
  local use_pilot_end = function ()

    ObjSet( "spr_desktop_pilot", { alp = 1 } );
    ObjSet( "spr_controltower_pilot", { alp = 1 } );
    ObjSet( "anm_desktop_pilot", { alp = 1 } );
    ObjSet( "obj_desktop_pilot", { input = true } );

    if cmn.IsEventDone( "use_mechanic" ) and
       cmn.IsEventDone( "use_airhostess" ) and
       cmn.IsEventDone( "use_pilot" ) then

      ObjSet( "gfx_desktop_shell_2", { active = true } );
      ObjSet( "gfx_desktop_wire3_3", { active = true } );
      ObjSet( "obj_desktop_open_box", { alp = 1, input = true } );
      ObjSet( "spr_controltower_shell_2", { alp = 1 } );
      ObjDelete( "anm_desktop_box_click" );
      ObjDelete( "anm_desktop_box_open" );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_pilot", use_pilot_beg, private.room_objname );
  cmn.AddSubscriber( "use_pilot", use_pilot_inv );
  cmn.AddSubscriber( "use_pilot", use_pilot_end, private.room_objname );
  cmn.AddSubscriber( "use_pilot_inv", use_pilot_inv, private.room_objname );
  cmn.AddSubscriber( "use_pilot_beg", use_pilot_beg, private.room_objname );
  cmn.AddSubscriber( "use_pilot_end", use_pilot_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pass () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pass" ] =
  {
    type = "use",
    use_obj = "inv_pass",
    use_place = "obj_serverroomdoor_use_pass",
    room = private.room_objname,
    zz = "zz_serverroomdoor",
    zz_gate = "gzz_controltower_serverroomdoor"
  };
  -----------------------------------------------
  local use_pass_inv = function ()

    int.InventoryItemRemove( "inv_pass" );

  end;
  local use_pass_beg = function ()

    ObjDelete( "obj_serverroomdoor_use_pass" );

  end;
  local use_pass_end = function ()

    ObjSet( "gho_controltower_serverroom", { active = true, input = true, alp = 1 } );
    ObjSet( "spr_controltower_door_open", { alp = 1 } );
    ObjDelete( "gzz_controltower_serverroomdoor" );
    ObjDelete( "anm_serverroomdoor_click" );
    ObjDelete( "anm_serverroomdoor_open" );
    ObjDelete( "anm_serverroomdoor_pass" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_pass", use_pass_beg, private.room_objname );
  cmn.AddSubscriber( "use_pass", use_pass_inv );
  cmn.AddSubscriber( "use_pass", use_pass_end, private.room_objname );
  cmn.AddSubscriber( "use_pass_inv", use_pass_inv, private.room_objname );
  cmn.AddSubscriber( "use_pass_beg", use_pass_beg, private.room_objname );
  cmn.AddSubscriber( "use_pass_end", use_pass_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_booklet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_booklet" ] =
  {
    type = "click",
    clk_obj = "obj_desktop_clk_booklet",
    room = private.room_objname,
    zz = "zz_desktop",
    zz_gate = "gzz_controltower_desktop"
  };
  -----------------------------------------------
  local clk_booklet = function ()


  end;
  -----------------------------------------------
  local clk_booklet_beg = function ()

    --ObjDelete( "obj_desktop_clk_booklet" );

  end;
  -----------------------------------------------
  local clk_booklet_end = function ()

    --ObjSet( "obj_kitchendoor_clk_cabinet_2", { input = true } );
    --ObjSet( "anm_kitchendoor_clk_cabinet", { alp = 1 } );
    --ObjDelete( "anm_kitchendoor_door_push" );
    --ObjDelete( "obj_kitchendoor_cabinet" );
    --ObjDelete( "spr_livingroom_kitchendoor_close" );
    --ObjSet( "spr_livingroom_kitchendoor_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_booklet", clk_booklet );
  cmn.AddSubscriber( "clk_booklet", clk_booklet_beg, private.room_objname );
  cmn.AddSubscriber( "clk_booklet", clk_booklet_end, private.room_objname );
  cmn.AddSubscriber( "clk_booklet_beg", clk_booklet_beg, private.room_objname );
  cmn.AddSubscriber( "clk_booklet_end", clk_booklet_end, private.room_objname );
  -----------------------------------------------
    --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_brokenkeyboard () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_brokenkeyboard" ] =
  {
    type = "click",
    clk_obj = "obj_controlpanel_clk_brokenkeyboard",
    room = private.room_objname,
    zz = "zz_controlpanel",
    zz_gate = "gzz_controltower_controlpanel"
  };
  -----------------------------------------------
  local clk_brokenkeyboard = function ()


  end;
  -----------------------------------------------
  local clk_brokenkeyboard_beg = function ()

    ObjDelete( "obj_controlpanel_clk_brokenkeyboard" );

  end;
  -----------------------------------------------
  local clk_brokenkeyboard_end = function ()

    ObjSet( "obj_controlpanel_use_keyboard", { active = true, input = true } );
    ObjDelete( "anm_controlpanel_broken_keyboard" );
    ObjDelete( "spr_controltower_broken_keyboard" );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_brokenkeyboard", clk_brokenkeyboard );
  cmn.AddSubscriber( "clk_brokenkeyboard", clk_brokenkeyboard_beg, private.room_objname );
  cmn.AddSubscriber( "clk_brokenkeyboard", clk_brokenkeyboard_end, private.room_objname );
  cmn.AddSubscriber( "clk_brokenkeyboard_beg", clk_brokenkeyboard_beg, private.room_objname );
  cmn.AddSubscriber( "clk_brokenkeyboard_end", clk_brokenkeyboard_end, private.room_objname );
  -----------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function opn_controltower () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_controltower" ] =
  {
    type = "click",
    room = private.room_objname,
  };
  local opn_controltower_task = function ()
  
    int.TaskDone( 2 );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "opn_controltower", opn_controltower_task );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
function private.get_pliers3 ()

  cmn.SetEventDone( "get_pliers3" );
  cmn.CallEventHandler( "get_pliers3" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_planeamulet ()

  cmn.SetEventDone( "get_planeamulet" );
  cmn.CallEventHandler( "get_planeamulet" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_ruler ()

  cmn.SetEventDone( "get_ruler" );
  cmn.CallEventHandler( "get_ruler" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_wire3_1 ()

  cmn.SetEventDone( "get_wire3_1" );
  cmn.CallEventHandler( "get_wire3_1" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_airhostess" ) ) and
     ( cmn.IsEventDone( "get_switch3_2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_switch3_2 ()

  cmn.SetEventDone( "get_switch3_2" );
  cmn.CallEventHandler( "get_switch3_2" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_airhostess" ) ) and
     ( cmn.IsEventDone( "get_wire3_1" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_airhostess ()

  cmn.SetEventDone( "get_airhostess" );
  cmn.CallEventHandler( "get_airhostess" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_switch3_2" ) ) and
     ( cmn.IsEventDone( "get_wire3_1" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_demonmedallion ()

  cmn.SetEventDone( "get_demonmedallion" );
  cmn.CallEventHandler( "get_demonmedallion" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_demonmedallion" ) and
       cmn.IsEventDone( "get_shell_2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_shell_2 ()

  cmn.SetEventDone( "get_shell_2" );
  cmn.CallEventHandler( "get_shell_2" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_demonmedallion" ) and
       cmn.IsEventDone( "get_shell_2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_wire3_3 ()

  cmn.SetEventDone( "get_wire3_3" );
  cmn.CallEventHandler( "get_wire3_3" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_pass ()

  cmn.SetEventDone( "get_pass" );
  cmn.CallEventHandler( "get_pass" );
  
  cmn.GetObjectSfx();
  private.ClkNote( false );

end;
--*********************************************************************************************************************
-------------------------------------------------
function public.use_keyboard ()

  local item = "inv_keyboard";

  if ( cmn.ApplyObj( item, "gzz_controltower_controlpanel", false ) ) and
     ( cmn.IsEventDone( "clk_brokenkeyboard" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_controlpanel" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_controlpanel_use_keyboard", true ) ) and
         ( cmn.IsEventDone( "clk_brokenkeyboard" ) ) then

    cmn.CallEventHandler( "use_keyboard_inv" );
    cmn.CallEventHandler( "use_keyboard_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_keyboard" );
      cmn.CallEventHandler( "use_keyboard_end" );
      int.Lock( false );

      if cmn.IsEventDone( "use_keyboard" ) and
         cmn.IsEventDone( "use_lever3" ) and
         cmn.IsEventDone( "use_button_1" ) and
         cmn.IsEventDone( "use_button_2" ) then

        cmn.CloseSubRoom();
        cmn.GotoRoom( "mg_worriedmessage" );

      end;

    end;

    if ( cmn.IsEventDone( "use_button_1" ) and
         cmn.IsEventDone( "use_button_2" ) ) then 

      ObjAnimate( "obj_controlpanel_anim_panel2", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0,
      } );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_keyboard_put" ); 
    AnimPlay( "anm_controlpanel_keyboard_new", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_lever3 ()

  local item = "inv_lever3";

  if ( cmn.ApplyObj( item, "gzz_controltower_controlpanel", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_controlpanel" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_controlpanel_use_lever3", true ) ) then

    cmn.CallEventHandler( "use_lever3_inv" );
    cmn.CallEventHandler( "use_lever3_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_lever3" );
      cmn.CallEventHandler( "use_lever3_end" );
      int.Lock( false );

      if cmn.IsEventDone( "use_keyboard" ) and
         cmn.IsEventDone( "use_lever3" ) and
         cmn.IsEventDone( "use_button_1" ) and
         cmn.IsEventDone( "use_button_2" ) then

        cmn.CloseSubRoom();
        cmn.GotoRoom( "mg_worriedmessage" );

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_place_lever" );  
    ObjAnimate( "obj_controlpanel_lever", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_button_1 ()

  local item = "inv_button_1";

  if ( cmn.ApplyObj( item, "gzz_controltower_controlpanel", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_controlpanel" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_controlpanel_use_button_1", true ) ) then

    cmn.CallEventHandler( "use_button_1_inv" );
    cmn.CallEventHandler( "use_button_1_beg" );
    int.Lock( true );

    local func_end = function ()

      local func_end = function ()

        cmn.SetEventDone( "use_button_1" );
        cmn.CallEventHandler( "use_button_1_end" );
        int.Lock( false );

        if cmn.IsEventDone( "use_keyboard" ) and
           cmn.IsEventDone( "use_lever3" ) and
           cmn.IsEventDone( "use_button_1" ) and
           cmn.IsEventDone( "use_button_2" ) then

          cmn.CloseSubRoom();
          cmn.GotoRoom( "mg_worriedmessage" );

        end;

      end;

      if ( cmn.IsEventDone( "use_button_2" ) ) then

        ObjAnimate( "obj_controlpanel_anim_panel1", "alp", 0, 0, func_end, 
        { 
          0.0, 0, 0,
          0.3, 0, 1,
        } );

        if ( cmn.IsEventDone( "use_keyboard" ) ) then

          ObjAnimate( "obj_controlpanel_anim_panel2", "alp", 0, 0, "",
          { 
            0.0, 0, 0.0, 
            0.3, 0, 1.0,
          } );

        end;

      else 
        func_end();
      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_place_button" );  

    ObjAnimate( "spr_controlpanel_nobutton2", "alp", 0, 0, func_end,
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_button_2 ()

  local item = "inv_button_2";

  if ( cmn.ApplyObj( item, "gzz_controltower_controlpanel", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_controlpanel" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_controlpanel_use_button_2", true ) ) then

    cmn.CallEventHandler( "use_button_2_inv" );
    cmn.CallEventHandler( "use_button_2_beg" );
    int.Lock( true );

    local func_end = function ()

      local func_end = function ()

        cmn.SetEventDone( "use_button_2" );
        cmn.CallEventHandler( "use_button_2_end" );
        int.Lock( false );

        if cmn.IsEventDone( "use_keyboard" ) and
           cmn.IsEventDone( "use_lever3" ) and
           cmn.IsEventDone( "use_button_1" ) and
           cmn.IsEventDone( "use_button_2" ) then

          cmn.CloseSubRoom();
          cmn.GotoRoom( "mg_worriedmessage" );

        end;

      end;

      if ( cmn.IsEventDone( "use_button_1" ) ) then

        ObjAnimate( "obj_controlpanel_anim_panel1", "alp", 0, 0, func_end, 
        { 
          0.0, 0, 0,
          0.3, 0, 1,
        } );

        if ( cmn.IsEventDone( "use_keyboard" ) ) then

          ObjAnimate( "obj_controlpanel_anim_panel2", "alp", 0, 0, "",
          { 
            0.0, 0, 0.0, 
            0.3, 0, 1.0,
          } );

        end;

      else
 
        func_end();

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_place_button" );  

    ObjAnimate( "spr_controlpanel_nobutton1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_wrench3 ()

  local item = "inv_wrench3";

  if ( cmn.ApplyObj( item, "gzz_controltower_controlpanel", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_controlpanel" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_controlpanel_use_wrench3", true ) ) then

    cmn.CallEventHandler( "use_wrench3_inv" );
    cmn.CallEventHandler( "use_wrench3_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_wrench3" );
      cmn.CallEventHandler( "use_wrench3_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_unscrew" );  
 
    AnimPlay( "anm_controlpanel_use_wrench3", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_wire3 ()

  local item = "inv_wire3";

  if ( cmn.ApplyObj( item, "gzz_controltower_controlpanel", false ) ) and
     ( cmn.IsEventDone( "get_wire3_1" ) ) and
     ( cmn.IsEventDone( "get_wire3_2" ) ) and
     ( cmn.IsEventDone( "get_wire3_3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_controlpanel" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_controlpanel_use_wire3", true ) ) and
         ( cmn.IsEventDone( "get_wire3_1" ) ) and
         ( cmn.IsEventDone( "get_wire3_2" ) ) and
         ( cmn.IsEventDone( "get_wire3_3" ) ) then

    cmn.CallEventHandler( "use_wire3_inv" );
    cmn.CallEventHandler( "use_wire3_beg" );
    int.Lock( true );

    local func_end = function ()


      local func_end2 = function ()

        cmn.SetEventDone( "use_wire3" );
        cmn.CallEventHandler( "use_wire3_end" );
        int.Lock( false );

      end;
     
      AnimPlay( "anm_controlpanel_opened", "DoAnim", func_end2 );
      
    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_wire_plug" );  

    ObjAnimate( "spr_controlpanel_wires", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_framedpic ()

  local item = "inv_framedpic";

  if ( cmn.ApplyObj( item, "gzz_controltower_chestofdrawers", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_chestofdrawers" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_chestofdrawers_use_framedpic", true ) ) then

    cmn.CallEventHandler( "use_framedpic_inv" );
    cmn.CallEventHandler( "use_framedpic_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_framedpic" );
      cmn.CallEventHandler( "use_framedpic_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_place_photoframe" );  
    ObjAnimate( "spr_chestofdrawers_framedpic", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "obj_chestofdrawers_box_open", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.5, 0, 0.0, 
      0.8, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_tweezers3 ()

  local item = "inv_tweezers3";

  if ( cmn.ApplyObj( item, "gzz_controltower_desktop", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_desktop" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_desktop_use_tweezers3", true ) ) then

    cmn.CallEventHandler( "use_tweezers3_inv" );
    cmn.CallEventHandler( "use_tweezers3_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_tweezers3" );
      cmn.CallEventHandler( "use_tweezers3_end" );
      int.Lock( false );
      private.get_demonmedallion();

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_use_tongs" );  
    ObjSet( "anm_desktop_use_tweezers3", { alp = 1 } );
    ObjSet( "anm_desktop_shelf_click", { alp = 0 } );
    AnimPlay( "anm_desktop_use_tweezers3", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_mechanic ()

  local item = "inv_mechanic";

  if ( cmn.ApplyObj( item, "gzz_controltower_desktop", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_desktop" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_desktop_use_mechanic", true ) ) then

    cmn.CallEventHandler( "use_mechanic_inv" );
    cmn.CallEventHandler( "use_mechanic_beg" );
    int.Lock( true );

    local func_end = function ()

      local func_end2 = function ()

        cmn.SetEventDone( "use_mechanic" );
        cmn.CallEventHandler( "use_mechanic_end" );
        int.Lock( false );

      end;

      if cmn.IsEventDone( "use_airhostess" ) and
         cmn.IsEventDone( "use_pilot" ) then

        ObjSet( "anm_desktop_box_open", { alp = 1 } );
        ObjSet( "anm_desktop_box_click", { alp = 0 } );
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_open_figure_case" );  
        AnimPlay( "anm_desktop_box_open", "DoAnim", func_end2 );

      else 

        cmn.SetEventDone( "use_mechanic" );
        cmn.CallEventHandler( "use_mechanic_end" );
        int.Lock( false );

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_place_figure" );  
    ObjAnimate( "spr_desktop_working", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "anm_desktop_mechanic", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_switch3 ()

  local item = "inv_switch3";

  if ( cmn.ApplyObj( item, "gzz_controltower_desktop", false ) ) and
     ( cmn.IsEventDone( "get_switch3_1" ) ) and
     ( cmn.IsEventDone( "get_switch3_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_desktop" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_desktop_use_switch3", true ) ) and
         ( cmn.IsEventDone( "get_switch3_1" ) ) and
         ( cmn.IsEventDone( "get_switch3_2" ) ) then

    cmn.CallEventHandler( "use_switch3_inv" );
    cmn.CallEventHandler( "use_switch3_beg" );
    int.Lock( true );

    local func_end = function ()

      local func_end2 = function ()

        cmn.SetEventDone( "use_switch3" );
        cmn.CallEventHandler( "use_switch3_end" );
        int.Lock( false );

      end;

      AnimPlay( "anm_desktop_safe_open", "DoAnim", func_end2 );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_insert_super_levers" );  
    ObjAnimate( "anm_desktop_safe_open", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.5, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_airhostess ()

  local item = "inv_airhostess";

  if ( cmn.ApplyObj( item, "gzz_controltower_desktop", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_desktop" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_desktop_use_airhostess", true ) ) then

    cmn.CallEventHandler( "use_airhostess_inv" );
    cmn.CallEventHandler( "use_airhostess_beg" );
    int.Lock( true );

    local func_end = function ()

      local func_end2 = function ()

        cmn.SetEventDone( "use_airhostess" );
        cmn.CallEventHandler( "use_airhostess_end" );
        int.Lock( false );

      end;

      if cmn.IsEventDone( "use_mechanic" ) and
         cmn.IsEventDone( "use_pilot" ) then

        ObjSet( "anm_desktop_box_open", { alp = 1 } );
        ObjSet( "anm_desktop_box_click", { alp = 0 } );
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_open_figure_case" );  
        AnimPlay( "anm_desktop_box_open", "DoAnim", func_end2 );

      else 

        cmn.SetEventDone( "use_airhostess" );
        cmn.CallEventHandler( "use_airhostess_end" );
        int.Lock( false );

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_place_figure" );  
    ObjAnimate( "spr_desktop_stewardess", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "anm_desktop_airhostess", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_pilot ()

  local item = "inv_pilot";

  if ( cmn.ApplyObj( item, "gzz_controltower_desktop", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_desktop" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_desktop_use_pilot", true ) ) then

    cmn.CallEventHandler( "use_pilot_inv" );
    cmn.CallEventHandler( "use_pilot_beg" );
    int.Lock( true );

    local func_end = function ()

      local func_end2 = function ()

        cmn.SetEventDone( "use_pilot" );
        cmn.CallEventHandler( "use_pilot_end" );
        int.Lock( false );

      end;

      if cmn.IsEventDone( "use_mechanic" ) and
         cmn.IsEventDone( "use_airhostess" ) then

        ObjSet( "anm_desktop_box_open", { alp = 1 } );
        ObjSet( "anm_desktop_box_click", { alp = 0 } );
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_open_figure_case" );  
        AnimPlay( "anm_desktop_box_open", "DoAnim", func_end2 );

      else 

        cmn.SetEventDone( "use_pilot" );
        cmn.CallEventHandler( "use_pilot_end" );
        int.Lock( false );

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_place_figure" );   
    ObjAnimate( "spr_desktop_pilot", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "anm_desktop_pilot", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_pass ()

  local item = "inv_pass";

  if ( cmn.ApplyObj( item, "gzz_controltower_serverroomdoor", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_serverroomdoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_serverroomdoor_use_pass", true ) ) then

    cmn.CallEventHandler( "use_pass_inv" );
    cmn.CallEventHandler( "use_pass_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_pass" );
      cmn.CallEventHandler( "use_pass_end" );
      int.Lock( false );

      cmn.CloseSubRoom();

    end;
    
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_card_open_door" );
    ObjSet( "anm_serverroomdoor_pass",  { alp = 1 } );
    ObjSet( "anm_serverroomdoor_click", { alp = 0 } );

--  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_pass" );  
    AnimPlay( "anm_serverroomdoor_pass", "DoAnim",
    function ()

      ObjSet( "anm_serverroomdoor_pass", { alp = 0 } );
      ObjSet( "anm_serverroomdoor_open", { alp = 1 } );

      AnimPlay( "anm_serverroomdoor_open", "DoAnim", func_end );

    end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
-------------------------------------------------
function private.clk_booklet ()

  local func_end = function ()

    cmn.SetEventDone( "clk_booklet" );
    cmn.CallEventHandler( "clk_booklet_end" );
    cmn.CallEventHandler( "clk_booklet" );
    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_booklet_beg" );

  int.Lock( true );

  --AnimPlay( "anm_kitchendoor_door_push", "DoAnim", func_end);

end;
-------------------------------------------------
function private.clk_brokenkeyboard ()

  local func_end = function ()

    cmn.SetEventDone( "clk_brokenkeyboard" );
    cmn.CallEventHandler( "clk_brokenkeyboard_end" );
    cmn.CallEventHandler( "clk_brokenkeyboard" );
    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_brokenkeyboard_beg" );

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_keyboard_away" );
  AnimPlay( "anm_controlpanel_broken_keyboard", "DoAnim", func_end);

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.PreOpen ()

  if not ( cmn.IsEventDone( "opn_controltower" ) ) then
    ObjSet( "rm_controltower", { color_r = 0, color_g = 0, color_b = 0 } );
  end;

end;
--*********************************************************************************************************************
function private.opn_controltower ()

  if not ( cmn.IsEventDone( "opn_controltower" ) ) then
    
    ng_global.progress[ "std" ][ "opn_controltower" ].listen_music = 0;

    local func_end = function ()

      int.Lock( false );
      cmn.StopAudio( "sfx", "audio/level3/sfx/aud_controltower_atropos_appearance" );
      cmn.StopAudio( "voc", "audio/level3/voc/aud_controltower_atropos_appearance_voc" );
      cmn.PlayAudio( "mus", "audio/aud_scare_theme_mus" );
      --cmn.PlayAudio( "env", "audio/level1/env/aud_bypolicestation_env", 1 );
      ObjSet( "rm_controltower", { color_r = 1, color_g = 1, color_b = 1 } );
      cmn.SetEventDone( "opn_controltower" );
      
      int.ShowTaskNote( 2, function () cmn.ShowBbt( "bbt_controltower_after_atropos" ); end );

      ObjSet( "anm_controltower_smoke", { visible = true, active = true } );
      
      cmn.AddPageDiary( 17 );

    end;

    int.Lock( true );

    common_impl.PlayDialogVideo( "vid_controltower_atropos_appearance", func_end );  

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_controltower_atropos_appearance" );
    cmn.PlayAudio( "voc", "audio/level3/voc/aud_controltower_atropos_appearance_voc" );

  end;  

end;
--*********************************************************************************************************************
function public.Load ()

  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.Open ()
  
  cmn.StopAllEnv( "audio/level3/env/aud_controltower_env", true );
  cmn.PlayAudio( "env", "audio/level3/env/aud_controltower_env", 1 );
  private.opn_controltower();
  
  if ( cmn.IsEventDone( "win_serverroom" ) ) and ( ng_global.progress[ "std" ][ "opn_controltower" ].listen_music == 0 ) then
    ng_global.progress[ "std" ][ "opn_controltower" ].listen_music = 1;
    cmn.PlayAudio( "mus", "audio/aud_location_theme_mus" );
  end;

end;
--*********************************************************************************************************************
function public.Task ()
  
  int.AddedTaskMap( private.room_objname, "get_pliers3",                             { "use_wire3" } );  
  int.AddedTaskMap( private.room_objname, "get_planeamulet",                         { "use_wrench3" } );  
  int.AddedTaskMap( private.room_objname, "get_ruler" );
  int.AddedTaskMap( private.room_objname, "get_wire3_1" );
  int.AddedTaskMap( private.room_objname, "get_switch3_2",                           { "use_framedpic" } ); 
  int.AddedTaskMap( private.room_objname, "get_airhostess",                          { "use_framedpic" } );
  int.AddedTaskMap( private.room_objname, "get_demonmedallion",                      { "use_tweezers3" } );
  int.AddedTaskMap( private.room_objname, "get_shell_2",                             { "use_mechanic", "use_pilot", "use_airhostess" } );  
  int.AddedTaskMap( private.room_objname, "get_wire3_3",                             { "use_mechanic", "use_pilot", "use_airhostess" } );
  int.AddedTaskMap( private.room_objname, "get_pass",                                { "clk_booklet" } ); 
  
  int.AddedTaskMap( private.room_objname, "use_keyboard",                            { "get_keyboard" } ); 
  int.AddedTaskMap( private.room_objname, "use_lever3",                              { "get_lever3" } );
  int.AddedTaskMap( private.room_objname, "use_button_1",                            { "get_button_1" } ); 
  int.AddedTaskMap( private.room_objname, "use_button_2",                            { "get_button_2" } );
  int.AddedTaskMap( private.room_objname, "use_wrench3",                             { "get_wrench3" } ); 
  int.AddedTaskMap( private.room_objname, "use_wire3",                               { "get_wire3_3" } );   
  int.AddedTaskMap( private.room_objname, "use_framedpic",                           { "get_framedpic" } );  
  int.AddedTaskMap( private.room_objname, "use_tweezers3",                           { "get_tweezers3" } );
  int.AddedTaskMap( private.room_objname, "use_mechanic",                            { "get_mechanic" } );
  int.AddedTaskMap( private.room_objname, "use_switch3",                             { "get_switch3_1", "get_switch3_2" } ); 
  int.AddedTaskMap( private.room_objname, "use_airhostess",                          { "get_airhostess" } ); 
  int.AddedTaskMap( private.room_objname, "use_pilot",                               { "get_pilot" } );
  int.AddedTaskMap( private.room_objname, "use_pass",                                { "get_pass" } ); 
  
  int.AddedTaskMap( private.room_objname, "clk_booklet",                             { "use_switch3" } ); 
  int.AddedTaskMap( private.room_objname, "clk_lever_mg",                            { "use_lever3", "use_keyboard", "use_button_1", "use_button_2" } );
  int.AddedTaskMap( private.room_objname, "clk_keyboard_mg",                         { "clk_lever_mg" } );
    
  int.AddedTaskMap( private.room_objname, "win_serverroom",                          { "use_pass" } );
  int.AddedTaskMap( private.room_objname, "win_worriedmessage",                      { "clk_keyboard_mg" } ); 
  
end;
--*********************************************************************************************************************
function private.ClkPanel ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_controlpanel_use_wrench3" );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_metal_xx" );
  ObjAnimate( "anm_controlpanel_use_wrench3", "pos_xy", 0, 0, func_end, 
  {
    0.0, 3, 0, 0,
    0.2, 3, 1, 1,
    0.4, 3, 0, 0
  } );

end;
--*********************************************************************************************************************
function private.ClkSafe ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_desktop_use_switch3" );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_safe_xx" );
  ObjAnimate( "spr_desktop_safe_door", "scale_xy", 0, 0, func_end, 
  {
    0.0, 3, 1, 1,
    0.2, 3, 1.005, 1.005,
    0.3, 3, 0.995, 0.995,
    0.4, 3, 1.005, 1.005,
    0.6, 3, 1, 1
  } );

end;
--*********************************************************************************************************************
function private.ServerroomdoorClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_serverroomdoor_use_pass" );

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_door" );
  AnimPlay( "anm_serverroomdoor_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.ShelfClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_desktop_use_tweezers3" );

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_box_case_touch" );  
  AnimPlay( "anm_desktop_shelf_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.BoxClick ()

  local func_end = function ()

    int.Lock( false );

    local count = 0;

    if cmn.IsEventDone( "use_mechanic" ) then
      count = count + 1;
    end;
    if cmn.IsEventDone( "use_airhostess" ) then
      count = count + 1;
    end;
    if cmn.IsEventDone( "use_pilot" ) then
      count = count + 1;
    end;

    cmn.ShowBbt( "bbt_desktop_"..count );

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mini_case_xx" );
  AnimPlay( "anm_desktop_box_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.ClkNote ( flag )

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/aud_paper" );

  if ( flag )then

    local func_end = function ()

      private.ClkNoteEnd( flag );

    end;

    ObjAnimate( "spr_desktop_booklet", "alp", 0, 0, "", 
    { 
      0.0, 0, 1,
      0.3, 0, 0
    } );

    ObjAnimate( "obj_desktop_booklet_big", "pos_xy", 0, 0, "", 
    { 
      0.0, 3, 120, -120,
      0.3, 3, 0, 0
    } );

    ObjAnimate( "obj_desktop_booklet_big", "scale_xy", 0, 0, func_end, 
    { 
      0.0, 3, 0, 0,
      0.3, 3, 1, 1
    } );

  else

    local func_end = function ()

      private.ClkNoteEnd( flag );

    end;

    ObjAnimate( "spr_desktop_booklet", "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      0.3, 0, 1
    } );

    ObjAnimate( "obj_desktop_booklet_big", "pos_xy", 0, 0, "", 
    { 
      0.0, 3, 0, 0,
      0.3, 3, 120, -120
    } );

    ObjAnimate( "obj_desktop_booklet_big", "scale_xy", 0, 0, func_end, 
    { 
      0.0, 3, 1, 1,
      0.3, 3, 0, 0
    } );

  end;

end;
--*********************************************************************************************************************
function private.ClkNoteEnd( flag )

  if ( flag )then

    ObjSet( "spr_desktop_booklet",     { input = false } );
    ObjSet( "obj_desktop_booklet_big", { input = true } );
    ng_global.progress[ "std" ][ "clk_booklet" ].done = 1;

  else

    ObjSet( "obj_desktop_booklet_big", { input = false } );

    if not cmn.IsEventDone( "get_pass" ) then

      ng_global.progress[ "std" ][ "clk_booklet" ].done = 0;
      ObjSet( "spr_desktop_booklet",     { input = true } );

    end;
    
  end;

  int.Lock( false );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_desktop" );
  -------------------------------------------------
  function zz_desktop.PreOpen()

    if ( not cmn.IsEventDone( "get_pass" ) and
        -- cmn.IsEventDone( "use_switch3_2" ) and
         cmn.IsEventDone( "use_switch3" ) ) then

      ng_global.progress[ "std" ][ "clk_booklet" ].done = 0;

    end; 

  end;
  -------------------------------------------------
  function zz_desktop.PreClose()

    if ( cmn.IsEventDone( "clk_booklet" ) and
         not cmn.IsEventDone( "get_pass" )) then

      private.ClkNote( false );

    end; 

  end;

end;
--*********************************************************************************************************************
function private.DesktopHeadClick ( head )

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_figure_touch" );
  AnimPlay( "anm_desktop_"..head, "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.InitAnims ()

  local head = { "mechanic", "pilot", "dispatcher", "airhostess" };

  for h = 1, 4 do

    ObjSet( "obj_desktop_"..head[ h ], { event_mdown = function () private.DesktopHeadClick( head[ h ] ) end } );

  end;


  ObjAnimate( "obj_controlpanel_anim", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    2.0, 3, 1.0,
    2.1, 3, 0.8,
    2.2, 3, 1.0,
    2.3, 3, 0.8,
    2.4, 3, 1.0,
    4.0, 3, 1.0,
  } );

  ObjAnimate( "spr_controlpanel_red_button_1_add", "alp", 1, 0, "", 
  {
    0.0,0,1,
    1.5,0,1,
    1.8,0,0,
    2.0,0,0,
    2.3,0,1,
    4.5,0,1
  } );

  ObjAnimate( "spr_controlpanel_red_button_3_add", "alp", 1, 0, "", 
  {
    0.0,0,0,
    1.0,0,0,
    1.3,0,1,
    1.6,0,1,
    3.0,0,0,
    4.2,0,0,
    4.5,0,1
  } );

  ObjAnimate( "spr_controlpanel_radarlight", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    0.03, 3, 0.9,
    0.06, 3, 1.0
  } );

  ObjAnimate( "spr_controlpanel_radar_run", "ang", 1, 0, "", 
  {
    0.0, 0, 0.0,
    2.5, 0, -6.28
  } );

  ObjAnimate("spr_controlpanel_red_sqbutton_1_add", "alp", 1, 0, "", 
  {
    0.0,0,1,
    1.5,0,1,
    1.8,0,0,
    2.0,0,0,
    2.3,0,1,
    4.5,0,1
  });
  ObjAnimate("spr_controlpanel_red_sqbutton_2_add", "alp", 1, 0, "", 
  {
    0.0,0,1,
    2.0,0,1,
    2.3,0,0,
    2.5,0,0,
    2.8,0,1,
    4.5,0,1
  });

  ObjAnimate( "spr_controlpanel_planeamulet_add", "alp", 1, 0, "", 
  {
    0.0, 0, 0.3,
    0.5, 0, 1.0,
    1.0, 0, 0.2,
    1.5, 0, 0.8,
    2.0, 0, 0.3,
  } );

  ObjAnimate( "spr_controltower_man_1", "alp", 1, 0, "", 
  { 
    0.0, 3, 1.0,
    1.0, 3, 0.6,
    2.0, 3, 1.0,
    3.0, 3, 0.6,
    4.0, 3, 1.0,
    5.0, 3, 0.6,
    6.0, 3, 1.0,
    7.0, 3, 0.6,
    8.0, 3, 1.0,
    8.2, 3, 0.6,
    8.4, 3, 1.0,
    8.6, 3, 0.6,
    8.8, 3, 1.0,
  } );

  ObjAnimate( "spr_controltower_man_2", "alp", 1, 0, "", 
  { 
    0.0, 3, 1.0,
    0.3, 3, 1.0,
    1.3, 3, 0.6,
    2.3, 3, 1.0,
    3.3, 3, 0.6,
    4.3, 3, 1.0,
    5.3, 3, 0.6,
    6.3, 3, 1.0,
    7.3, 3, 0.6,
    8.3, 3, 1.0,
    8.5, 3, 0.6,
    8.7, 3, 1.0,
    8.9, 3, 0.6,
    9.1, 3, 1.0,
  } );

  ObjAnimate( "spr_serverroomdoor_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_desktop_light_act_add_05", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    1.8, 3, 0.5,
    3.6, 3, 1.0,
  } );

  ObjAnimate( "spr_chestofdrawers_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_controlpane_web", "pos_x", 1, 0, "", 
  {
    0.0, 3, 33, 
    2.5, 3, 26,
    5.0, 3, 33
  } );
  
  ObjAnimate("spr_technicalroom_purse3", "ang", 1, 0, "", 
  {
    0.0,0,0.03,
    2.0,3,-0.03,
    4.0,3,0.03
  });

end;
--*********************************************************************************************************************