-- name=rm_secondfloorcorridor
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_secondfloorcorridor";

  ObjAttach( "zz_bench",             "room_hub" );
  ObjAttach( "zz_technicalroomdoor", "room_hub" );
  ObjAttach( "zz_barrel",            "room_hub" );
  ObjAttach( "zz_controltowerdoor",  "room_hub" );
  
  ObjMultiSet( {
    { "spr_bench_lamp",                             { event_mdown = private.get_lamp } },
    { "spr_bench_photo3",                           { event_mdown = private.get_photo3 } },
    { "spr_bench_mechanic",                         { event_mdown = private.get_mechanic } },
    { "spr_bench_button_1",                         { event_mdown = private.get_button_1 } },
    { "spr_barrel_glassshard",                      { event_mdown = private.get_glassshard } },
    { "spr_barrel_bowknot",                         { event_mdown = private.get_bowknot } },
    { "spr_barrel_pattern_3",                       { event_mdown = private.get_pattern_3 } },
    { "spr_barrel_figure7",                         { event_mdown = private.get_figure7 } },
    { "spr_bench_marksamulet_2",                    { event_mdown = private.get_marksamulet_2 } },
    { "obj_bench_use_knittingneedle",               { event_mdown = private.ClkClose } },
    { "obj_technicalroomdoor_use_trianglekey3",     { event_mdown = private.ClkTechnicalroomDoor } },
    { "obj_controltowerdoor_clk_controltowerkey",   { event_mdown = private.clk_controltowerkey } },
    { "spr_barrel_collect2_3_3",                    { event_mdown = private.get_collect2_3_3 } },
    { "obj_bench_use_toyscissors",                  { event_mdown = private.ClkCloth } },
    
  } );

  private.InitAnims();
  private.InitControltowerdoor();
  private.InitSubroom();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_secondfloorcorridor = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gzz_secondfloorcorridor_bench",
        "gzz_secondfloorcorridor_technicalroomdoor",
        "gzz_secondfloorcorridor_barrel",
        "gzz_secondfloorcorridor_controltowerdoor",
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_bench", 
        "zz_technicalroomdoor", 
        "zz_barrel",
        "zz_controltowerdoor",
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_secondfloorcorridor", update_game_mode_secondfloorcorridor, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_lamp () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lamp" ] =
  {
    type = "get",
    get_obj = "spr_bench_lamp",
    room = private.room_objname,
    zz = "zz_bench",
    zz_gate = "gzz_secondfloorcorridor_bench"
  };
  -----------------------------------------------
  local get_lamp_inv = function ()

    int.InventoryItemAdd( "inv_lamp", "spr_bench_lamp" );
    ObjSet( "inv_torch_plus_focus2", { alp = 1 } );

  end;

  local get_lamp_closezz = function ()

    ObjDelete( "gfx_bench_lamp" );
    ObjDelete( "spr_bench_lamp_shadow" );
    ObjDelete( "spr_secondfloorcorridor_bench_lamp" );

    if ( cmn.IsEventDone( "get_lamp" ) and
       cmn.IsEventDone( "get_photo3" ) and
       cmn.IsEventDone( "get_mechanic" ) and
       cmn.IsEventDone( "get_button_1" ) and
       cmn.IsEventDone( "get_marksamulet_2" ) ) then

      ObjDelete( "gzz_secondfloorcorridor_bench" );

    end;

  end;

  cmn.AddSubscriber( "get_lamp", get_lamp_inv );
  cmn.AddSubscriber( "get_lamp", get_lamp_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_photo3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_photo3" ] =
  {
    type = "get",
    get_obj = "spr_bench_photo3",
    room = private.room_objname,
    zz = "zz_bench",
    zz_gate = "gzz_secondfloorcorridor_bench"
  };
  -----------------------------------------------
  local get_photo3_inv = function ()

    int.InventoryItemAdd( "inv_photo3", "spr_bench_photo3" );
    if cmn.IsEventDone( "get_glue3" ) then
      ObjSet( "inv_brokenframe_plus_focus2", { alp = 1 } );
    end;

  end;

  local get_photo3_closezz = function ()

    ObjDelete( "gfx_bench_photo3" );
    ObjDelete( "spr_bench_photo3_shadow" );
    ObjDelete( "spr_secondfloorcorridor_bench_photo_open" );
    ObjSet( "spr_secondfloorcorridor_bench_photo_empty", { alp = 1 } );

    if ( cmn.IsEventDone( "get_lamp" ) and
       cmn.IsEventDone( "get_photo3" ) and
       cmn.IsEventDone( "get_mechanic" ) and
       cmn.IsEventDone( "get_button_1" ) and
       cmn.IsEventDone( "get_marksamulet_2" ) ) then

      ObjDelete( "gzz_secondfloorcorridor_bench" );

    end;

  end;

  cmn.AddSubscriber( "get_photo3", get_photo3_inv );
  cmn.AddSubscriber( "get_photo3", get_photo3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mechanic () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_mechanic" ] =
  {
    type = "get",
    get_obj = "spr_bench_mechanic",
    room = private.room_objname,
    zz = "zz_bench",
    zz_gate = "gzz_secondfloorcorridor_bench"
  };
  -----------------------------------------------
  local get_mechanic_inv = function ()

    int.InventoryItemAdd( "inv_mechanic", "spr_bench_mechanic" );

  end;

  local get_mechanic_closezz = function ()

    ObjDelete( "gfx_bench_mechanic" );
    ObjDelete( "spr_bench_mechanic_shadow" );
    ObjDelete( "spr_secondfloorcorridor_bench_mechanic" );

    if ( cmn.IsEventDone( "get_lamp" ) and
       cmn.IsEventDone( "get_photo3" ) and
       cmn.IsEventDone( "get_mechanic" ) and
       cmn.IsEventDone( "get_button_1" ) and
       cmn.IsEventDone( "get_marksamulet_2" ) ) then

      ObjDelete( "gzz_secondfloorcorridor_bench" );

    end;

  end;

  cmn.AddSubscriber( "get_mechanic", get_mechanic_inv );
  cmn.AddSubscriber( "get_mechanic", get_mechanic_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_button_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_button_1" ] =
  {
    type = "get",
    get_obj = "spr_bench_button_1",
    room = private.room_objname,
    zz = "zz_bench",
    zz_gate = "gzz_secondfloorcorridor_bench"
  };
  -----------------------------------------------
  local get_button_1_inv = function ()

    int.InventoryItemAdd( "inv_button_1", "spr_bench_button_1" );

  end;

  local get_button_1_closezz = function ()

    ObjDelete( "gfx_bench_button_1" );
    ObjDelete( "spr_bench_button_1_shadow" );
    ObjDelete( "spr_secondfloorcorridor_bench_button_1" );

    if ( cmn.IsEventDone( "get_lamp" ) and
       cmn.IsEventDone( "get_photo3" ) and
       cmn.IsEventDone( "get_mechanic" ) and
       cmn.IsEventDone( "get_button_1" ) and
       cmn.IsEventDone( "get_marksamulet_2" ) ) then

      ObjDelete( "gzz_secondfloorcorridor_bench" );

    end;

  end;

  cmn.AddSubscriber( "get_button_1", get_button_1_inv );
  cmn.AddSubscriber( "get_button_1", get_button_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_glassshard () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_glassshard" ] =
  {
    type = "get",
    get_obj = "spr_barrel_glassshard",
    room = private.room_objname,
    zz = "zz_barrel",
    zz_gate = "gzz_secondfloorcorridor_barrel"
  };
  -----------------------------------------------
  local get_glassshard_inv = function ()

    int.InventoryItemAdd( "inv_glassshard", "spr_barrel_glassshard" );

  end;

  local get_glassshard_closezz = function ()

    ObjDelete( "gfx_barrel_glassshard" );
    ObjDelete( "spr_barrel_glassshard_shadow" );
    ObjDelete( "spr_secondfloorcorridor_barrel_glassshard" );

  end;

  cmn.AddSubscriber( "get_glassshard", get_glassshard_inv );
  cmn.AddSubscriber( "get_glassshard", get_glassshard_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bowknot () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bowknot" ] =
  {
    type = "get",
    get_obj = "spr_barrel_bowknot",
    room = private.room_objname,
    zz = "zz_barrel",
    zz_gate = "gzz_secondfloorcorridor_barrel"
  };
  -----------------------------------------------
  local get_bowknot_inv = function ()

    int.InventoryItemAdd( "inv_bowknot", "spr_barrel_bowknot" );

  end;

  local get_bowknot_closezz = function ()

    ObjDelete( "gfx_barrel_bowknot" );
    ObjDelete( "spr_barrel_bowknot_shadow" );
    ObjDelete( "spr_secondfloorcorridor_barrel_bowknot" );

    if cmn.IsEventDone( "get_figure7" ) and
       cmn.IsEventDone( "get_collect2_3_3" ) and
       cmn.IsEventDone( "get_pattern_3" ) then

      ObjDelete( "gzz_secondfloorcorridor_barrel" );

    end;

  end;

  cmn.AddSubscriber( "get_bowknot", get_bowknot_inv );
  cmn.AddSubscriber( "get_bowknot", get_bowknot_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pattern_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pattern_3" ] =
  {
    type = "get",
    get_obj = "spr_barrel_pattern_3",
    room = private.room_objname,
    zz = "zz_barrel",
    zz_gate = "gzz_secondfloorcorridor_barrel"
  };
  -----------------------------------------------
  local get_pattern_3_inv = function ()

    int.InventoryItemAdd( "inv_pattern", "spr_barrel_pattern_3", "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/inv/inv_pattern_3_morph" );
    level3_inv.CheckPattern();

  end;

  local get_pattern_3_closezz = function ()

    ObjDelete( "gfx_barrel_pattern_3" );
    ObjDelete( "spr_barrel_pattern_3_shadow" );
    ObjDelete( "spr_secondfloorcorridor_barrel_pattern_3" );

    if cmn.IsEventDone( "get_figure7" ) and
       cmn.IsEventDone( "get_collect2_3_3" ) and
       cmn.IsEventDone( "get_bowknot" ) then

      ObjDelete( "gzz_secondfloorcorridor_barrel" );

    end;

  end;

  cmn.AddSubscriber( "get_pattern_3", get_pattern_3_inv );
  cmn.AddSubscriber( "get_pattern_3", get_pattern_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_figure7 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_figure7" ] =
  {
    type = "get",
    get_obj = "spr_barrel_figure7",
    room = private.room_objname,
    zz = "zz_barrel",
    zz_gate = "gzz_secondfloorcorridor_barrel"
  };
  -----------------------------------------------
  local get_figure7_inv = function ()

    int.InventoryItemAdd( "inv_figure7", "spr_barrel_figure7" );
    ObjSet( "inv_purse3_plus_focus2", { alp = 1 } );

  end;

  local get_figure7_closezz = function ()

    ObjDelete( "gfx_barrel_figure7" );
    ObjDelete( "spr_barrel_figure7_shadow" );
    ObjDelete( "spr_barrel_hotspot" );

    if cmn.IsEventDone( "get_pattern_3" ) and
       cmn.IsEventDone( "get_collect2_3_3" ) and
       cmn.IsEventDone( "get_bowknot" ) then

      ObjDelete( "gzz_secondfloorcorridor_barrel" );

    end;

  end;

  cmn.AddSubscriber( "get_figure7", get_figure7_inv );
  cmn.AddSubscriber( "get_figure7", get_figure7_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_marksamulet_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_marksamulet_2" ] =
  {
    type = "get",
    get_obj = "spr_bench_marksamulet_2",
    room = private.room_objname,
    zz = "zz_bench",
    zz_gate = "gzz_secondfloorcorridor_bench"
  };
  -----------------------------------------------
  local get_marksamulet_2_inv = function ()

    int.InventoryItemAdd( "inv_marksamulet", "spr_bench_marksamulet_2", "assets/levels/level3/rm_waitinghall/zz_hallsecurity/inv/inv_marksamulet_morph" );
    level3_inv.CheckMarksamulet();

  end;

  local get_marksamulet_2_closezz = function ()

    ObjDelete( "gfx_bench_marksamulet_2" );
    ObjDelete( "spr_bench_marksamulet_2_shadow" );
    ObjDelete( "spr_secondfloorcorridor_bench_marksamulet_2" );

    if ( cmn.IsEventDone( "get_lamp" ) and
       cmn.IsEventDone( "get_photo3" ) and
       cmn.IsEventDone( "get_mechanic" ) and
       cmn.IsEventDone( "get_button_1" ) and
       cmn.IsEventDone( "get_marksamulet_2" ) ) then

      ObjDelete( "gzz_secondfloorcorridor_bench" );

    end;

  end;

  cmn.AddSubscriber( "get_marksamulet_2", get_marksamulet_2_inv );
  cmn.AddSubscriber( "get_marksamulet_2", get_marksamulet_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_3_4 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_3_4 = function ()

    ObjDelete( "obj_secondfloorcorridor_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_3_4", get_morphobject_3_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_3_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_3_3 = function ()

    ObjDelete( "spr_barrel_collect_shadow" );
    ObjDelete( "spr_barrel_collect2_3_3" );
    ObjDelete( "spr_secondfloorcorridor_collect" );

    if cmn.IsEventDone( "get_pattern_3" ) and
       cmn.IsEventDone( "get_figure7" ) and
       cmn.IsEventDone( "get_bowknot" ) then

      ObjDelete( "gzz_secondfloorcorridor_barrel" );

    end;

  end;

  cmn.AddSubscriber( "get_collect2_3_3", get_collect2_3_3, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_knittingneedle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_knittingneedle" ] =
  {
    type = "use",
    use_obj = "inv_knittingneedle",
    use_place = "obj_bench_use_knittingneedle",
    room = private.room_objname,
    zz = "zz_bench",
    zz_gate = "gzz_secondfloorcorridor_bench"
  };
  -----------------------------------------------
  local use_knittingneedle_inv = function ()  

    int.InventoryItemRemove( "inv_knittingneedle" );

  end;
  local use_knittingneedle_beg = function ()

    ObjDelete( "obj_bench_use_knittingneedle" );

  end;
  local use_knittingneedle_end = function ()

    ObjSet( "spr_bench_lamp", { input = true } );
    ObjSet( "gfx_bench_lamp", { active = true } );
    ObjSet( "obj_bench_open", { alp = 1, input = true } );
    ObjSet( "obj_secondfloorcorridor_bench_open", { alp = 1 } );
    ObjDelete( "obj_bench_close" );
    ObjDelete( "anm_bench_use_knittingneedle" );
    ObjDelete( "obj_secondfloorcorridor_bench_closed" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_knittingneedle", use_knittingneedle_beg, private.room_objname );
  cmn.AddSubscriber( "use_knittingneedle", use_knittingneedle_inv );
  cmn.AddSubscriber( "use_knittingneedle", use_knittingneedle_end, private.room_objname );
  cmn.AddSubscriber( "use_knittingneedle_inv", use_knittingneedle_inv, private.room_objname );
  cmn.AddSubscriber( "use_knittingneedle_beg", use_knittingneedle_beg, private.room_objname );
  cmn.AddSubscriber( "use_knittingneedle_end", use_knittingneedle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cleaningagent () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cleaningagent" ] =
  {
    type = "use",
    use_obj = "inv_cleaningagent",
    use_place = "obj_bench_use_cleaningagent",
    room = private.room_objname,
    zz = "zz_bench",
    zz_gate = "gzz_secondfloorcorridor_bench"
  };
  -----------------------------------------------
  local use_cleaningagent_inv = function ()

    int.InventoryItemRemove( "inv_cleaningagent" );

  end;
  local use_cleaningagent_beg = function ()

    ObjDelete( "obj_bench_use_cleaningagent" );

  end;
  local use_cleaningagent_end = function ()

    ObjSet( "obj_bench_use_hanky3", { input = true } );
    ObjSet( "anm_bench_use_nahky3", { alp = 1 } );
    ObjDelete( "anm_bench_use_cleaningagent" );    

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_cleaningagent", use_cleaningagent_beg, private.room_objname );
  cmn.AddSubscriber( "use_cleaningagent", use_cleaningagent_inv );
  cmn.AddSubscriber( "use_cleaningagent", use_cleaningagent_end, private.room_objname );
  cmn.AddSubscriber( "use_cleaningagent_inv", use_cleaningagent_inv, private.room_objname );
  cmn.AddSubscriber( "use_cleaningagent_beg", use_cleaningagent_beg, private.room_objname );
  cmn.AddSubscriber( "use_cleaningagent_end", use_cleaningagent_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hanky3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hanky3" ] =
  {
    type = "use",
    use_obj = "inv_hanky3",
    use_place = "obj_bench_use_hanky3",
    room = private.room_objname,
    zz = "zz_bench",
    zz_gate = "gzz_secondfloorcorridor_bench"
  };
  -----------------------------------------------
  local use_hanky3_inv = function ()

    int.InventoryItemRemove( "inv_hanky3" );

  end;
  local use_hanky3_beg = function ()

    ObjDelete( "obj_bench_use_hanky3" );

  end;
  local use_hanky3_end = function ()

    ObjDelete( "anm_bench_use_nahky3" );
    ObjDelete( "spr_secondfloorcorridor_bench_dirt" );
    if cmn.IsEventDone( "clk_controltowerkey" ) then
      ObjSet( "obj_controltowerdoor_mmg", { input = true } );
    end;
    ObjDelete( "obj_controltowerdoor_before_mmg_bbt" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_hanky3", use_hanky3_beg, private.room_objname );
  cmn.AddSubscriber( "use_hanky3", use_hanky3_inv );
  cmn.AddSubscriber( "use_hanky3", use_hanky3_end, private.room_objname );
  cmn.AddSubscriber( "use_hanky3_inv", use_hanky3_inv, private.room_objname );
  cmn.AddSubscriber( "use_hanky3_beg", use_hanky3_beg, private.room_objname );
  cmn.AddSubscriber( "use_hanky3_end", use_hanky3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_toyscissors () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_toyscissors" ] =
  {
    type = "use",
    use_obj = "inv_toyscissors",
    use_place = "obj_bench_use_toyscissors",
    room = private.room_objname,
    zz = "zz_bench",
    zz_gate = "gzz_secondfloorcorridor_bench"
  };
  -----------------------------------------------
  local use_toyscissors_inv = function ()

    int.InventoryItemRemove( "inv_toyscissors" );

  end;
  local use_toyscissors_beg = function ()

    ObjDelete( "obj_bench_use_toyscissors" );

  end;
  local use_toyscissors_end = function ()

    ObjSet( "spr_bench_photo3", { input = true, alp = 1 } );
    ObjSet( "spr_bench_photo3_shadow", {  alp = 1 } );
    ObjSet( "gfx_bench_photo3", { active = true } );
    ObjSet( "spr_bench_open_2", { alp = 1 } );
    ObjSet( "spr_secondfloorcorridor_bench_photo_open", { alp = 1 } );
    ObjDelete( "anm_bench_use_toyscissors" );
    ObjDelete( "spr_secondfloorcorridor_bench_photo_closed" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_toyscissors", use_toyscissors_beg, private.room_objname );
  cmn.AddSubscriber( "use_toyscissors", use_toyscissors_inv );
  cmn.AddSubscriber( "use_toyscissors", use_toyscissors_end, private.room_objname );
  cmn.AddSubscriber( "use_toyscissors_inv", use_toyscissors_inv, private.room_objname );
  cmn.AddSubscriber( "use_toyscissors_beg", use_toyscissors_beg, private.room_objname );
  cmn.AddSubscriber( "use_toyscissors_end", use_toyscissors_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_planeamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_planeamulet" ] =
  {
    type = "use",
    use_obj = "inv_planeamulet",
    use_place = "obj_bench_use_planeamulet",
    room = private.room_objname,
    zz = "zz_bench",
    zz_gate = "gzz_secondfloorcorridor_bench"
  };
  -----------------------------------------------
  local use_planeamulet_inv = function ()

    int.InventoryItemRemove( "inv_planeamulet" );

  end;
  local use_planeamulet_beg = function ()

    ObjDelete( "obj_bench_use_planeamulet" );

  end;
  local use_planeamulet_end = function ()

    ObjSet( "spr_bench_mechanic", { input = true } );
    ObjSet( "gfx_bench_mechanic", { active = true } );
    ObjSet( "spr_bench_button_1", { input = true } );
    ObjSet( "gfx_bench_button_1", { active = true } );
    ObjSet( "spr_bench_open_1",   { alp = 1, input = true } );
    ObjSet( "obj_secondfloorcorridor_bench_open_1",   { alp = 1 } );
    ObjDelete( "spr_bench_airplane" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_planeamulet", use_planeamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_planeamulet", use_planeamulet_inv );
  cmn.AddSubscriber( "use_planeamulet", use_planeamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_planeamulet_inv", use_planeamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_planeamulet_beg", use_planeamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_planeamulet_end", use_planeamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_trianglekey3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_trianglekey3" ] =
  {
    type = "use",
    use_obj = "inv_trianglekey3",
    use_place = "obj_technicalroomdoor_use_trianglekey3",
    room = private.room_objname,
    zz = "zz_technicalroomdoor",
    zz_gate = "gzz_secondfloorcorridor_technicalroomdoor"
  };
  -----------------------------------------------
  local use_trianglekey3_inv = function ()

    int.InventoryItemRemove( "inv_trianglekey3" );

  end;
  local use_trianglekey3_beg = function ()

    ObjDelete( "obj_technicalroomdoor_use_trianglekey3" );

  end;
  local use_trianglekey3_end = function ()

    ObjSet( "grm_secondfloorcorridor_technicalroom", { active = true, input = true, visible = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_secondfloorcorridor_technicalroom_focus");
    end;    
    ObjSet( "spr_secondfloorcorridor_technicalroomdoor_open", { alp = 1 } );
    ObjDelete( "gzz_secondfloorcorridor_technicalroomdoor" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_trianglekey3", use_trianglekey3_beg, private.room_objname );
  cmn.AddSubscriber( "use_trianglekey3", use_trianglekey3_inv );
  cmn.AddSubscriber( "use_trianglekey3", use_trianglekey3_end, private.room_objname );
  cmn.AddSubscriber( "use_trianglekey3_inv", use_trianglekey3_inv, private.room_objname );
  cmn.AddSubscriber( "use_trianglekey3_beg", use_trianglekey3_beg, private.room_objname );
  cmn.AddSubscriber( "use_trianglekey3_end", use_trianglekey3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spade () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_spade" ] =
  {
    type = "use",
    use_obj = "inv_spade",
    use_place = "obj_barrel_use_spade",
    room = private.room_objname,
    zz = "zz_barrel",
    zz_gate = "gzz_secondfloorcorridor_barrel"
  };
  -----------------------------------------------
  local use_spade_inv = function ()

    int.InventoryItemRemove( "inv_spade" );

  end;
  local use_spade_beg = function ()

    ObjDelete( "obj_barrel_use_spade" );

  end;
  local use_spade_end = function ()

    ObjSet( "spr_barrel_pattern_3", { input = true } );
    ObjSet( "gfx_barrel_pattern_3", { active = true } );
    ObjSet( "spr_barrel_figure7",   { input = true } );
    ObjSet( "gfx_barrel_figure7",   { active = true } );
    ObjSet( "spr_barrel_soil_removed",   { alp = 1 } );
    ObjSet( "spr_secondfloorcorridor_barrel_soil_2",   { alp = 1 } );
    ObjDelete( "anm_barrel_use_spade" );
    ObjDelete( "spr_secondfloorcorridor_barrel_soil_1" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_spade", use_spade_beg, private.room_objname );
  cmn.AddSubscriber( "use_spade", use_spade_inv );
  cmn.AddSubscriber( "use_spade", use_spade_end, private.room_objname );
  cmn.AddSubscriber( "use_spade_inv", use_spade_inv, private.room_objname );
  cmn.AddSubscriber( "use_spade_beg", use_spade_beg, private.room_objname );
  cmn.AddSubscriber( "use_spade_end", use_spade_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_controltowerkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_controltowerkey" ] =
  {
    type = "use",
    use_obj = "inv_controltowerkey",
    use_place = "obj_controltowerdoor_use_controltowerkey",
    room = private.room_objname,
    zz = "zz_controltowerdoor",
    zz_gate = "gzz_secondfloorcorridor_controltowerdoor"
  };
  -----------------------------------------------
  local use_controltowerkey_inv = function ()

    int.InventoryItemRemove( "inv_controltowerkey" );

  end;
  local use_controltowerkey_beg = function ()

    ObjDelete( "obj_controltowerdoor_use_controltowerkey" );

  end;
  local use_controltowerkey_end = function ()

    ObjSet( "spr_controltowerdoor_key_1", { alp = 1 } );
    ObjSet( "obj_controltowerdoor_clk_controltowerkey", { input = true } );
    ObjSet( "spr_secondfloorcorridor_controltowerdoor_key", { alp = 1 } );
    

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_controltowerkey", use_controltowerkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_controltowerkey", use_controltowerkey_inv );
  cmn.AddSubscriber( "use_controltowerkey", use_controltowerkey_end, private.room_objname );
  cmn.AddSubscriber( "use_controltowerkey_inv", use_controltowerkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_controltowerkey_beg", use_controltowerkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_controltowerkey_end", use_controltowerkey_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_controltowerkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_controltowerkey" ] =
  {
    type = "click",
    clk_obj = "obj_controltowerdoor_clk_controltowerkey",
    room = private.room_objname,
    zz = "zz_controltowerdoor",
    zz_gate = "gzz_secondfloorcorridor_controltowerdoor"
  };
  -----------------------------------------------
  local clk_controltowerkey = function ()


  end;
  -----------------------------------------------
  local clk_controltowerkey_beg = function ()

    ObjDelete( "obj_controltowerdoor_clk_controltowerkey" );

  end;
  -----------------------------------------------
  local clk_controltowerkey_end = function ()

    ObjDelete( "spr_controltowerdoor_key_1" );
    ObjDelete( "spr_controltowerdoor_latch_1" );
    ObjDelete( "spr_controltowerdoor_latch_2" );
    ObjDelete( "spr_controltowerdoor_cap" );
    ObjSet( "spr_controltowerdoor_cap_open", { alp = 1 } );
    ObjSet( "spr_controltowerdoor_key_2", { alp = 1 } );

    ObjSet( "spr_secondfloorcorridor_controltowerdoor_key_2", { alp = 1 } );
    ObjDelete( "spr_secondfloorcorridor_controltowerdoor_key" );
    ObjSet( "spr_secondfloorcorridor_controltowerdoor_mmg_open", { alp = 1 } );
    ObjDelete( "spr_secondfloorcorridor_controltowerdoor_mmg_closed" );

    if cmn.IsEventDone( "use_hanky3" ) then
      ObjSet( "obj_controltowerdoor_mmg", { input = true } );
    else 
      ObjSet( "obj_controltowerdoor_before_mmg_bbt", { input = true } );
    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_controltowerkey", clk_controltowerkey );
  cmn.AddSubscriber( "clk_controltowerkey", clk_controltowerkey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_controltowerkey", clk_controltowerkey_end, private.room_objname );
  cmn.AddSubscriber( "clk_controltowerkey_beg", clk_controltowerkey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_controltowerkey_end", clk_controltowerkey_end, private.room_objname );
  -----------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function win_controltowerdoor () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_controltowerdoor" ] =
  {
    type = "click",
    clk_obj = "spr_controltowerdoor_number_1_1",
    room = private.room_objname,
    zz = "zz_controltowerdoor",
    zz_gate = "gzz_secondfloorcorridor_controltowerdoor"
  };
  --*********************************************************************************************************************
  local win_controltowerdoor_inv = function ()

    if ( cmn.IsEventDone( "win_controltowerdoor" ) ) then

      --int.DeleteTaskMap( private.room_objname, "win_controltowerdoor" );

    end;

  end;
  --*********************************************************************************************************************
  local win_controltowerdoor = function ()

    if ( cmn.IsEventDone( "win_controltowerdoor" ) ) then
      ObjSet( "grm_secondfloorcorridor_controltower", { active = true, input = true, visible = true } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_secondfloorcorridor_controltower_focus");
      end;
      ObjDelete( "gzz_secondfloorcorridor_controltowerdoor" );
      ObjSet( "spr_secondfloorcorridor_controltowerdoor_open", { alp = 1 } );
      ObjDelete( "spr_secondfloorcorridor_controltowerdoor_mmg_open" );
      ObjDelete( "spr_secondfloorcorridor_controltowerdoor_key_2" );
    else 

      for i = 1, 5 do
        for j = 1, 3 do
          local number = ng_global.progress[ "std" ][ "win_controltowerdoor" ].row_number[ i ][ j ];
          ObjSet( "spr_controltowerdoor_number_"..i.."_"..j, { res = "assets/levels/level3/rm_secondfloorcorridor/zz_controltowerdoor/layers/number_"..number } );
        end;
      end;

    end;

  end;

  cmn.AddSubscriber( "win_controltowerdoor", win_controltowerdoor_inv );
  cmn.AddSubscriber( "win_controltowerdoor", win_controltowerdoor, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function opn_secondfloorcorridor () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_secondfloorcorridor" ] =
  {
    type = "click",
    room = private.room_objname,
  };
  local opn_secondfloorcorridor_task = function ()
  
    int.TaskDone( 1 );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "opn_secondfloorcorridor", opn_secondfloorcorridor_task );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.get_lamp ()

  cmn.SetEventDone( "get_lamp" );
  cmn.CallEventHandler( "get_lamp" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_lamp" ) and
     cmn.IsEventDone( "get_photo3" ) and
     cmn.IsEventDone( "get_mechanic" ) and
     cmn.IsEventDone( "get_button_1" ) and
     cmn.IsEventDone( "get_marksamulet_2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_photo3 ()

  cmn.SetEventDone( "get_photo3" );
  cmn.CallEventHandler( "get_photo3" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_lamp" ) and
     cmn.IsEventDone( "get_photo3" ) and
     cmn.IsEventDone( "get_mechanic" ) and
     cmn.IsEventDone( "get_button_1" ) and
     cmn.IsEventDone( "get_marksamulet_2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_mechanic ()

  cmn.SetEventDone( "get_mechanic" );
  cmn.CallEventHandler( "get_mechanic" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_lamp" ) and
     cmn.IsEventDone( "get_photo3" ) and
     cmn.IsEventDone( "get_mechanic" ) and
     cmn.IsEventDone( "get_button_1" ) and
     cmn.IsEventDone( "get_marksamulet_2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_button_1 ()

  cmn.SetEventDone( "get_button_1" );
  cmn.CallEventHandler( "get_button_1" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_lamp" ) and
     cmn.IsEventDone( "get_photo3" ) and
     cmn.IsEventDone( "get_mechanic" ) and
     cmn.IsEventDone( "get_button_1" ) and
     cmn.IsEventDone( "get_marksamulet_2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_glassshard ()

  cmn.SetEventDone( "get_glassshard" );
  cmn.CallEventHandler( "get_glassshard" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_bowknot ()

  cmn.SetEventDone( "get_bowknot" );
  cmn.CallEventHandler( "get_bowknot" );
  
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_figure7" ) and
     cmn.IsEventDone( "get_collect2_3_3" ) and
     cmn.IsEventDone( "get_pattern_3" ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_marksamulet_2 ()

  cmn.SetEventDone( "get_marksamulet_2" );
  cmn.CallEventHandler( "get_marksamulet_2" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_lamp" ) and
     cmn.IsEventDone( "get_photo3" ) and
     cmn.IsEventDone( "get_mechanic" ) and
     cmn.IsEventDone( "get_button_1" ) and
     cmn.IsEventDone( "get_marksamulet_2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_pattern_3 ()

  cmn.SetEventDone( "get_pattern_3" );
  cmn.CallEventHandler( "get_pattern_3" );
  
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_figure7" ) and
     cmn.IsEventDone( "get_collect2_3_3" ) and
     cmn.IsEventDone( "get_bowknot" ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_figure7 ()

  cmn.SetEventDone( "get_figure7" );
  cmn.CallEventHandler( "get_figure7" );
  
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_pattern_3" ) and
     cmn.IsEventDone( "get_collect2_3_3" ) and
     cmn.IsEventDone( "get_bowknot" ) then

    cmn.CloseSubRoom();

  end;

end;
---------------------------------------------------------------------------------
function private.get_collect2_3_3()

  int.AddCollectibles2( "spr_barrel_collect2_3_3" );
  ObjSet( "spr_barrel_collect_shadow", { alp = 0 } );

  if cmn.IsEventDone( "get_pattern_3" ) and
     cmn.IsEventDone( "get_figure7" ) and
     cmn.IsEventDone( "get_bowknot" ) then

    cmn.CloseSubRoom();

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
function public.use_knittingneedle ()

  local item = "inv_knittingneedle";

  if ( cmn.ApplyObj( item, "gzz_secondfloorcorridor_bench", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bench" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bench_use_knittingneedle", true ) ) then

    cmn.CallEventHandler( "use_knittingneedle_inv" );
    cmn.CallEventHandler( "use_knittingneedle_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_knittingneedle" );
      cmn.CallEventHandler( "use_knittingneedle_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_case_open" ); 
    ObjSet( "obj_bench_close", { alp = 0 } ); 
    ObjSet( "anm_bench_use_knittingneedle", { alp = 1 } ); 
    AnimPlay( "anm_bench_use_knittingneedle", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_cleaningagent ()

  local item = "inv_cleaningagent";

  if ( cmn.ApplyObj( item, "gzz_secondfloorcorridor_bench", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bench" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bench_use_cleaningagent", true ) ) then

    cmn.CallEventHandler( "use_cleaningagent_inv" );
    cmn.CallEventHandler( "use_cleaningagent_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_cleaningagent" );
      cmn.CallEventHandler( "use_cleaningagent_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_spray" );  
    AnimPlay( "anm_bench_use_cleaningagent", "DoAnim", func_end );
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_hanky3 ()

  local item = "inv_hanky3";

  if ( cmn.ApplyObj( item, "gzz_secondfloorcorridor_bench", false ) and
       cmn.IsEventDone( "use_cleaningagent" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bench" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bench_use_hanky3", true ) and
           cmn.IsEventDone( "use_cleaningagent" ) ) then

    cmn.CallEventHandler( "use_hanky3_inv" );
    cmn.CallEventHandler( "use_hanky3_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_hanky3" );
      cmn.CallEventHandler( "use_hanky3_end" );
      int.Lock( false );

      if cmn.IsEventDone( "clk_controltowerkey" ) then

        ng_global.progress[ "std" ][ "win_controltowerdoor" ].row_number = {
                                                                            { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 },
                                                                            { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 },
                                                                            { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 },
                                                                            { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 },
                                                                            { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 }
                                                                           };


      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_rubbing" );      
    AnimPlay( "anm_bench_use_nahky3", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_toyscissors ()

  local item = "inv_toyscissors";

  if ( cmn.ApplyObj( item, "gzz_secondfloorcorridor_bench", false ) and
       cmn.IsEventDone( "use_knittingneedle" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bench" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bench_use_toyscissors", true ) and
           cmn.IsEventDone( "use_knittingneedle" ) ) then

    cmn.CallEventHandler( "use_toyscissors_inv" );
    cmn.CallEventHandler( "use_toyscissors_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_toyscissors" );
      cmn.CallEventHandler( "use_toyscissors_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_scissors_cutting" );  

    AnimPlay( "anm_bench_use_toyscissors", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_planeamulet ()

  local item = "inv_planeamulet";

  if ( cmn.ApplyObj( item, "gzz_secondfloorcorridor_bench", false ) and
       cmn.IsEventDone( "use_knittingneedle" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bench" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bench_use_planeamulet", true ) and
           cmn.IsEventDone( "use_knittingneedle" ) ) then

    cmn.CallEventHandler( "use_planeamulet_inv" );
    cmn.CallEventHandler( "use_planeamulet_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_planeamulet" );
      cmn.CallEventHandler( "use_planeamulet_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_insert_plane" );  
    ObjAnimate( "spr_bench_airplane", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "spr_bench_open_1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 0.0,
      0.6, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_trianglekey3 ()

  local item = "inv_trianglekey3";

  if ( cmn.ApplyObj( item, "gzz_secondfloorcorridor_technicalroomdoor", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_technicalroomdoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_technicalroomdoor_use_trianglekey3", true ) ) then

    cmn.CallEventHandler( "use_trianglekey3_inv" );
    cmn.CallEventHandler( "use_trianglekey3_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_trianglekey3" );
      cmn.CallEventHandler( "use_trianglekey3_end" );
      int.Lock( false );

      cmn.CloseSubRoom();

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_insert_tirangle_key" );  
    ObjAnimate( "spr_technicalroomdoor_trianglekey3_1", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      1.0, 0, 1.0,
      1.3, 0, 0.0,
    } );

    ObjAnimate( "spr_technicalroomdoor_trianglekey3_over", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 0.0,
      0.7, 0, 1.0,
    } );

    ObjAnimate( "spr_technicalroomdoor_trianglekey3_2", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      1.0, 0, 0.0,
      1.3, 0, 1.0,
      1.5, 0, 1.0,
    } );

    ObjAnimate( "spr_technicalroomdoor_trianglekey3_1", "pos_xy", 0, 0, "",
    { 
      0.0, 0, -106, -32, 
      0.4, 0, -106, -32, 
      0.7, 0,  -80,  41,
    } );

    ObjAnimate("spr_technicalroomdoor_handle", "ang", 0, 0, func_end, 
    {
      0.0,0,0,
      1.5,0,0,
      1.8,0,-0.05,
      2.1,0,-0.05
    });

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_spade ()

  local item = "inv_spade";

  if ( cmn.ApplyObj( item, "gzz_secondfloorcorridor_barrel", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_barrel" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_barrel_use_spade", true ) ) then

    cmn.CallEventHandler( "use_spade_inv" );
    cmn.CallEventHandler( "use_spade_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_spade" );
      cmn.CallEventHandler( "use_spade_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_digging" );  
    AnimPlay( "anm_barrel_use_spade", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_controltowerkey ()

  local item = "inv_controltowerkey";

  if ( cmn.ApplyObj( item, "gzz_secondfloorcorridor_controltowerdoor", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_controltowerdoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_controltowerdoor_use_controltowerkey", true ) ) then

    cmn.CallEventHandler( "use_controltowerkey_inv" );
    cmn.CallEventHandler( "use_controltowerkey_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_controltowerkey" );
      cmn.CallEventHandler( "use_controltowerkey_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_controltowerdoor_insert" );
    ObjAnimate( "spr_controltowerdoor_key_1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_controltowerkey ()

  local func_end = function ()

    cmn.SetEventDone( "clk_controltowerkey" );
    cmn.CallEventHandler( "clk_controltowerkey_end" );
    cmn.CallEventHandler( "clk_controltowerkey" );

    if cmn.IsEventDone( "use_hanky3" ) then

      ng_global.progress[ "std" ][ "win_controltowerdoor" ].row_number = {
                                                                          { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 },
                                                                          { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 },
                                                                          { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 },
                                                                          { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 },
                                                                          { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 }
                                                                         };

      cmn.MiniGameShow( "controltowerdoor" );
      common_impl.PassingMgStart( "controltowerdoor" );

    end;

    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_controltowerkey_beg" );

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_controltowerdoor_rotate" );
  ObjAnimate( "spr_controltowerdoor_key_1", "alp", 0, 0, "", 
  {
    0.0, 0, 1,
    0.3, 0, 0
  } );
  ObjAnimate( "spr_controltowerdoor_key_2", "alp", 0, 0, "", 
  {
    0.0, 0, 0,
    0.3, 0, 1
  } );
  ObjAnimate( "spr_controltowerdoor_latch_1", "pos_x", 0, 0, "", 
  {
    0.0, 0, -66,
    0.3, 0, -66,
    0.6, 0, -109
  } );
  ObjAnimate( "spr_controltowerdoor_latch_2", "pos_x", 0, 0, "", 
  {
    0.0, 0, 67,
    0.3, 0, 67,
    0.6, 0, 112
  } );
  ObjAnimate( "spr_controltowerdoor_latch_1", "alp", 0, 0, "", 
  {
    0.0, 0, 1,
    0.8, 0, 1,
    1.1, 0, 0
  } );
  ObjAnimate( "spr_controltowerdoor_latch_2", "alp", 0, 0, "", 
  {
    0.0, 0, 1,
    0.8, 0, 1,
    1.1, 0, 0
  } );
  ObjAnimate( "spr_controltowerdoor_cap", "alp", 0, 0, "", 
  {
    0.0, 0, 1,
    0.8, 0, 1,
    1.1, 0, 0
  } );
  ObjAnimate( "spr_controltowerdoor_cap_open", "alp", 0, 0, func_end, 
  {
    0.0, 0, 0,
    0.8, 0, 0,
    1.1, 0, 1
  } );

end;
-------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.PreOpen ()

  if not ( cmn.IsEventDone( "opn_secondfloorcorridor" ) ) then
    ObjSet( "rm_secondfloorcorridor", { color_r = 0, color_g = 0, color_b = 0 } );
  end;

end;
--*********************************************************************************************************************
function private.opn_secondfloorcorridor ()

  if not ( cmn.IsEventDone( "opn_secondfloorcorridor" ) ) then

    local func_end = function ()

      int.Lock( false );
      cmn.StopAudio( "sfx", "audio/level3/sfx/aud_secondfloorcorridor_closing_door" );
      cmn.PlayAudio( "env", "audio/level3/env/aud_secondfloorcorridor_env", 1 );
      cmn.PlayAudio( "mus", "audio/aud_inseption_mus" );
      --cmn.StopAudio( "voc", "audio/level1/voc/aud_intro_voc" );
      --cmn.PlayAudio( "env", "audio/level1/env/aud_bypolicestation_env", 1 );
      ObjSet( "rm_secondfloorcorridor", { color_r = 1, color_g = 1, color_b = 1 } );
      cmn.SetEventDone( "opn_secondfloorcorridor" );
      int.ShowTaskNote( 1, function () cmn.ShowBbt( "bbt_secondfloorcorridor_after_closed_door" ); end );

      cmn.AddPageDiary( 15 );

    end;

    int.Lock( true );

    common_impl.PlayDialogVideo( "vid_secondfloorcorridor_closing_door", func_end );  

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_secondfloorcorridor_closing_door" );
    --cmn.PlayAudio( "voc", "audio/level1/voc/aud_intro_voc" );

  end;

end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_controltowerdoor" );
  -------------------------------------------------
  function zz_controltowerdoor.Open ()

    if ( cmn.IsEventDone( "use_hanky3" ) and cmn.IsEventDone( "clk_controltowerkey" ) and not cmn.IsEventDone( "win_controltowerdoor" ) ) then

      cmn.MiniGameShow( "controltowerdoor" );
      common_impl.PassingMgStart( "controltowerdoor" );

    end;

  end;
  -------------------------------------------------
  function zz_controltowerdoor.PreClose ()

    if ( cmn.IsEventDone( "use_hanky3" ) and cmn.IsEventDone( "clk_controltowerkey" ) and not cmn.IsEventDone( "win_controltowerdoor" ) ) then

      cmn.MiniGameHide( "controltowerdoor" );
      common_impl.PassingMgStop( "controltowerdoor" );

    end;

  end;
  -------------------------------------------------
  function zz_controltowerdoor.Skip ()
    private.WinControltowerdoor ();
  end;
  -------------------------------------------------
  function zz_controltowerdoor.Reset ()

    ng_global.progress[ "std" ][ "win_controltowerdoor" ].row_number = {
                                                                        { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 },
                                                                        { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 },
                                                                        { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 },
                                                                        { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 },
                                                                        { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 }
                                                                       };
    for i = 1, 5 do
      for j = 1, 3 do
        local number = ng_global.progress[ "std" ][ "win_controltowerdoor" ].row_number[ i ][ j ];
        ObjSet( "spr_controltowerdoor_number_"..i.."_"..j, { res = "assets/levels/level3/rm_secondfloorcorridor/zz_controltowerdoor/layers/number_"..number } );
      end;
    end;

  end;
  -------------------------------------------------

end;
--*********************************************************************************************************************
function public.Open ()
  
  cmn.StopAllEnv( "audio/level3/env/aud_secondfloorcorridor_env", true );
  cmn.PlayAudio( "env", "audio/level3/env/aud_secondfloorcorridor_env", 1 );
  
  private.opn_secondfloorcorridor();  

end;
--*********************************************************************************************************************
function public.Task ()
  
  int.AddedTaskMap( private.room_objname, "get_lamp",                                   { "use_knittingneedle" } );  
  int.AddedTaskMap( private.room_objname, "get_photo3",                                 { "use_toyscissors" } );  
  int.AddedTaskMap( private.room_objname, "get_mechanic",                               { "use_planeamulet" } );  
  int.AddedTaskMap( private.room_objname, "get_button_1",                               { "use_planeamulet" } ); 
  int.AddedTaskMap( private.room_objname, "get_glassshard" );
  int.AddedTaskMap( private.room_objname, "get_bowknot" );
  int.AddedTaskMap( private.room_objname, "get_pattern_3",                              { "use_spade" } ); 
  int.AddedTaskMap( private.room_objname, "get_figure7",                                { "use_spade" } );
  int.AddedTaskMap( private.room_objname, "get_marksamulet_2" ); 
  
  int.AddedTaskMap( private.room_objname, "use_knittingneedle",                         { "get_knittingneedle" } );
  int.AddedTaskMap( private.room_objname, "use_cleaningagent",                          { "get_cleaningagent" } );
  int.AddedTaskMap( private.room_objname, "use_hanky3",                                 { "use_cleaningagent", "get_hanky3" } );
  int.AddedTaskMap( private.room_objname, "use_toyscissors",                            { "get_toyscissors" } ); 
  int.AddedTaskMap( private.room_objname, "use_planeamulet",                            { "get_planeamulet" } ); 
  int.AddedTaskMap( private.room_objname, "use_trianglekey3",                           { "win_hosecuritypoint" } );
  int.AddedTaskMap( private.room_objname, "use_spade",                                  { "get_spade" } );  
  int.AddedTaskMap( private.room_objname, "use_controltowerkey",                        { "get_controltowerkey" } ); 
  
  int.AddedTaskMap( private.room_objname, "clk_controltowerkey",                        { "use_controltowerkey" } ); 
  
  int.AddedTaskMap( private.room_objname, "win_controltowerdoor",                       { "use_hanky3","clk_controltowerkey" } ); 
  
  int.AddedTaskMap( private.room_objname, "opn_technicalroom",                          { "use_trianglekey3" } ); 
  int.AddedTaskMap( private.room_objname, "opn_controltower",                           { "win_controltowerdoor" } );   
  
end;
--*********************************************************************************************************************
function private.ClkTechnicalroomDoor ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_technicalroomdoor_use_trianglekey3" );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_touch_door_handle" );
  ObjAnimate("spr_technicalroomdoor_handle", "ang", 0, 0, func_end, 
  {
    0.0,0,0,
    0.2,0,-0.05,
    0.4,0,0
  });

end;
--*********************************************************************************************************************
function private.ClkClose ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_bench_use_knittingneedle" );

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_case_touch" );
  ObjAnimate( "spr_bench_closed", "scale_xy", 0, 0, func_end, 
  {
    0.0, 3, 1, 1,
    0.2, 3, 1.005, 1.005,
    0.3, 3, 0.995, 0.995,
    0.4, 3, 1.005, 1.005,
    0.6, 3, 1, 1
  } );

end;
--*********************************************************************************************************************
function private.ClkCloth ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_bench_use_toyscissors" );
    
    ObjSet( "anm_bench_use_toyscissors", { alp = 1 });
    ObjSet( "anm_bench_clothgrid", { alp = 0 });
        
  end;

  int.Lock( true );
  
  ObjSet( "anm_bench_clothgrid", { alp = 1 });
  ObjSet( "anm_bench_use_toyscissors", { alp = 0 });
  
  --cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_case_touch" );
  AnimPlay( "anm_bench_clothgrid", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.InitAnims ()

  ObjAnimate( "spr_barrel_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_bench_light_act_add_05", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_barrel_hotspot", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    0.7, 3, 1.0,
    3.0, 3, 0.3,
  } );

  ObjAnimate( "spr_secondfloorcorridor_woman", "alp", 1, 0, "", 
  { 
    0.0, 3, 1.0,
    1.0, 3, 0.6,
    2.0, 3, 1.0,
    3.0, 3, 0.6,
    4.0, 3, 1.0,
    5.0, 3, 0.6,
    6.0, 3, 1.0,
    7.0, 3, 0.6,
    8.0, 3, 1.0,
    8.2, 3, 0.6,
    8.4, 3, 1.0,
    8.6, 3, 0.6,
    8.8, 3, 1.0,
  } );

  ObjAnimate( "spr_technicalroomdoor_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.1,
    2.5, 3, 0.5,
    5.0, 3, 0.1,
  } );

  ObjAnimate( "spr_controltowerdoor_light", "alp", 1, 0, "", 
  {
    0.0, 3, 1,
    2.5, 3, 0.3,
    5.0, 3, 1,
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG CONTROLTOWERDOOR *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.InitControltowerdoor ()

    private.tmp_row_position = {
                                { { -131, 1 }, { -132, 42 }, { -132, 81 } },
                                { { -64, 1 }, { -64, 43 }, { -65, 82 } },
                                { { 2, 0 }, { 2, 42 }, { 1, 81 } },
                                { { 65, -1 }, { 65, 41 }, { 66, 81 } },
                                { { 129, 2 }, { 130, 41 }, { 131, 83 } }   
                               };

    private.win_number = { 4, 7, 3, 8, 2 };

    for i = 1, 5 do
   
      ObjSet( "obj_controltowerdoor_clk_row"..i,
      {
        event_mdown = function ()

          private.ClkRow ( i );

        end,

        event_menter = function ()

          cmn.SetCursor( CURSOR_HAND );

        end,

        event_mleave = function ()

          cmn.SetCursor( CURSOR_DEFAULT );

        end,

      } );

    end;

                    
  end;
  --*********************************************************************************************************************
  function private.ClkRow ( id )
    
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_controltowerdoor_click" );
    int.Lock( true );
    local tmp_array = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

    for i = 1, 9 do
      tmp_array[ i + 1 ] = ng_global.progress[ "std" ][ "win_controltowerdoor" ].row_number[ id ][ i ];
    end;
    tmp_array[ 1 ] = ng_global.progress[ "std" ][ "win_controltowerdoor" ].row_number[ id ][ 10 ];

    for i = 1, 3 do

      local new_number = tmp_array[ i ];
      local func_end = function ()

        ObjSet( "spr_controltowerdoor_number_"..id.."_"..i, { res = "assets/levels/level3/rm_secondfloorcorridor/zz_controltowerdoor/layers/number_"..new_number, alp = 1 } );
        ObjSet( "spr_controltowerdoor_number_"..i, { alp = 0 } );
        ng_global.progress[ "std" ][ "win_controltowerdoor" ].row_number[ id ] = tmp_array;

      end;

      ObjSet( "spr_controltowerdoor_number_"..i, { 
                                                   res = "assets/levels/level3/rm_secondfloorcorridor/zz_controltowerdoor/layers/number_"..new_number,
                                                   pos_x = private.tmp_row_position[ id ][ i ][ 1 ], 
                                                   pos_y = private.tmp_row_position[ id ][ i ][ 2 ]  
                                                 } );

      ObjAnimate( "spr_controltowerdoor_number_"..id.."_"..i, "alp", 0, 0, "", 
      { 
        0.0, 0, 1,
        0.3, 0, 0
      } );
      ObjAnimate( "spr_controltowerdoor_number_"..i, "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1
      } );
      
    end;

    ObjSet( "tmr_controltowerdoor_mmg", { playing = 1, time = 0.3, endtrig = private.ControltowerdoorWinChech } ); 

  end;
  --*********************************************************************************************************************
  function private.ControltowerdoorWinChech ()

    local win = true; 

    for i = 1, 5 do
      if ng_global.progress[ "std" ][ "win_controltowerdoor" ].row_number[ i ][ 2 ] ~= private.win_number[ i ] then
        win = false;
        break;
      end;
    end;

    if win then
      private.WinControltowerdoor ();
    else 
      int.Lock( false );
    end;

  end;
  --*********************************************************************************************************************
  function private.WinControltowerdoor ()

    cmn.MiniGameHide( "controltowerdoor" );
    cmn.SetEventDone( "win_controltowerdoor" );

    int.Lock( false );

    common_impl.PassingMgWin( "controltowerdoor" );

    cmn.CallEventHandler( "win_controltowerdoor" );
    cmn.CallEventHandler( "win_controltowerdoor_inv" );

    cmn.CloseSubRoom();

  end;
  --*********************************************************************************************************************