-- name=rm_technicalroom
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_technicalroom";

  ObjAttach( "zz_keystand",         "room_hub" );
  ObjAttach( "zz_stafdrawers",      "room_hub" );
  ObjAttach( "zz_janitresdaughter", "room_hub" );
  
  ObjMultiSet( {
    { "spr_keystand_staramulet",                    { event_mdown = private.get_staramulet } },
    { "spr_stafdrawers_purse3",                     { event_mdown = private.get_purse3 } },
    { "spr_stafdrawers_snowdropamulet",             { event_mdown = private.get_snowdropamulet } },
    { "spr_stafdrawers_switch3_1",                  { event_mdown = private.get_switch3_1 } },
    { "spr_stafdrawers_glue3",                      { event_mdown = private.get_glue3 } },
    { "spr_stafdrawers_button_2",                   { event_mdown = private.get_button_2 } },
    { "spr_janitresdaughter_handle",                { event_mdown = private.get_handle3 } },
    { "spr_janitresdaughter_toyscissors",           { event_mdown = private.get_toyscissors } },
    { "spr_janitresdaughter_pattern_1",             { event_mdown = private.get_pattern_1 } },
    { "spr_janitresdaughter_brokenframe",           { event_mdown = private.get_brokenframe } },
    { "obj_stafdrawers_use_ruler",                  { event_mdown = private.StafdrawersDoorClick } },
    { "obj_technicalroom_clk_mop",                  { event_mdown = private.ClkMop } },
    { "obj_technicalroom_clk_lamp",                 { event_mdown = private.ClkLamp } },
    { "obj_stafdrawers_turtle_click",               { event_mdown = private.StafdrawersTurtleClick } },
    { "obj_janitresdaughter_bear_clk",              { event_mdown = private.BearClk } },
    { "obj_janitresdaughter_use_bowknot",           { event_mdown = private.BearClk } },
    { "obj_janitresdaughter_use_snowdropamulet",    { event_mdown = private.JanitresdaughterBoxClk } },
    { "spr_janitresdaughter_collect2_3_1",{ event_mdown = private.get_collect2_3_1 } },
  } );

  private.InitSubroom();
  private.InitAnims();
  private.InitJanitresdaughter();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_technicalroom = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gzz_technicalroom_keystand",
        "gmg_technicalroom_ondoor",
        "gzz_technicalroom_stafdrawers",
        "gzz_technicalroom_janitresdaughter",
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_keystand", 
        "zz_stafdrawers", 
        "zz_janitresdaughter",
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_technicalroom", update_game_mode_technicalroom, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_staramulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_staramulet" ] =
  {
    type = "get",
    get_obj = "spr_keystand_staramulet",
    room = private.room_objname,
    zz = "zz_keystand",
    zz_gate = "gzz_technicalroom_keystand"
  };
  -----------------------------------------------
  local get_staramulet_inv = function ()

    int.InventoryItemAdd( "inv_staramulet", "spr_keystand_staramulet" );

  end;

  local get_staramulet_closezz = function ()

    ObjDelete( "gfx_keystand_staramulet" );
    ObjDelete( "spr_keystand_staramulet_add" );
    ObjDelete( "spr_keystand_staramulet_shadow" );
    ObjDelete( "spr_technicalroom_staramulet" );
    --ObjDelete( "gzz_technicalroom_keystand" );

  end;

  cmn.AddSubscriber( "get_staramulet", get_staramulet_inv );
  cmn.AddSubscriber( "get_staramulet", get_staramulet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_purse3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_purse3" ] =
  {
    type = "get",
    get_obj = "spr_stafdrawers_purse3",
    room = private.room_objname,
    zz = "zz_stafdrawers",
    zz_gate = "gzz_technicalroom_stafdrawers"
  };
  -----------------------------------------------
  local get_purse3_inv = function ()

    int.InventoryItemAdd( "inv_purse3", "spr_stafdrawers_purse3" );
    ObjSet( "inv_purse3", { drag = false } );

    if ( not cmn.IsEventDone( "get_figure7" ) ) then

      ObjSet( "inv_purse3_plus_focus2", { alp = 0 } );

    end;

  end;

  local get_purse3_closezz = function ()

    ObjDelete( "gfx_stafdrawers_purse3" );
    ObjDelete( "spr_stafdrawers_purse3_shadow" );
    ObjDelete( "spr_stafdrawers_purse3_over" );
    ObjDelete( "spr_technicalroom_purse3" );

  end;

  cmn.AddSubscriber( "get_purse3", get_purse3_inv );
  cmn.AddSubscriber( "get_purse3", get_purse3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_snowdropamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_snowdropamulet" ] =
  {
    type = "get",
    get_obj = "spr_stafdrawers_snowdropamulet",
    room = private.room_objname,
    zz = "zz_stafdrawers",
    zz_gate = "gzz_technicalroom_stafdrawers"
  };
  -----------------------------------------------
  local get_snowdropamulet_inv = function ()

    int.InventoryItemAdd( "inv_snowdropamulet", "spr_stafdrawers_snowdropamulet" );

  end;

  local get_snowdropamulet_closezz = function ()

    ObjDelete( "gfx_stafdrawers_snowdropamulet" );
    ObjDelete( "spr_stafdrawers_snowdropamulet_shadow" );
    ObjDelete( "spr_technicalroom_snowdropamulet" );

  end;

  cmn.AddSubscriber( "get_snowdropamulet", get_snowdropamulet_inv );
  cmn.AddSubscriber( "get_snowdropamulet", get_snowdropamulet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_switch3_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_switch3_1" ] =
  {
    type = "get",
    get_obj = "spr_stafdrawers_switch3_1",
    room = private.room_objname,
    zz = "zz_stafdrawers",
    zz_gate = "gzz_technicalroom_stafdrawers"
  };
  -----------------------------------------------
  local get_switch3_1_inv = function ()

    int.InventoryItemAdd( "inv_switch3", "spr_stafdrawers_switch3_1", "assets/levels/level3/rm_technicalroom/zz_stafdrawers/inv/inv_switch_morph" );
    level3_inv.CheckSwitch();

  end;

  local get_switch3_1_closezz = function ()

    ObjDelete( "gfx_stafdrawers_switch3_1" );
    ObjDelete( "spr_stafdrawers_switch3_1_shadow" );
    ObjDelete( "spr_technicalroom_switch3_1" );

  end;

  cmn.AddSubscriber( "get_switch3_1", get_switch3_1_inv );
  cmn.AddSubscriber( "get_switch3_1", get_switch3_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_glue3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_glue3" ] =
  {
    type = "get",
    get_obj = "spr_stafdrawers_glue3",
    room = private.room_objname,
    zz = "zz_stafdrawers",
    zz_gate = "gzz_technicalroom_stafdrawers"
  };
  -----------------------------------------------
  local get_glue3_inv = function ()

    int.InventoryItemAdd( "inv_glue3", "spr_stafdrawers_glue3" );
    ObjSet( "inv_brokenframe_plus_focus2", { alp = 1 } );

  end;

  local get_glue3_closezz = function ()

    ObjDelete( "gfx_stafdrawers_glue3" );
    ObjDelete( "spr_stafdrawers_glue3_shadow" );
    ObjDelete( "spr_technicalroom_glue3" );

  end;

  cmn.AddSubscriber( "get_glue3", get_glue3_inv );
  cmn.AddSubscriber( "get_glue3", get_glue3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_button_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_button_2" ] =
  {
    type = "get",
    get_obj = "spr_stafdrawers_button_2",
    room = private.room_objname,
    zz = "zz_stafdrawers",
    zz_gate = "gzz_technicalroom_stafdrawers"
  };
  -----------------------------------------------
  local get_button_2_inv = function ()

    int.InventoryItemAdd( "inv_button_2", "spr_stafdrawers_button_2" );

  end;

  local get_button_2_closezz = function ()

    ObjDelete( "gfx_stafdrawers_button_2" );
    ObjDelete( "spr_stafdrawers_button_2_shadow" );
    ObjDelete( "gzz_technicalroom_stafdrawers" );
    ObjDelete( "spr_technicalroom_button_2" );

  end;

  cmn.AddSubscriber( "get_button_2", get_button_2_inv );
  cmn.AddSubscriber( "get_button_2", get_button_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_handle3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_handle3" ] =
  {
    type = "get",
    get_obj = "spr_janitresdaughter_handle",
    room = private.room_objname,
    zz = "zz_janitresdaughter",
    zz_gate = "gzz_technicalroom_janitresdaughter"
  };
  -----------------------------------------------
  local get_handle3_inv = function ()

    int.InventoryItemAdd( "inv_handle3", "spr_janitresdaughter_handle" );

  end;

  local get_handle3_closezz = function ()

    ObjDelete( "gfx_janitresdaughter_handle" );
    ObjDelete( "spr_janitresdaughter_handle_shadow" );
    ObjDelete( "spr_janitresdaughter_handle_over" );
    ObjDelete( "spr_technicalroom_handle" );

    if cmn.IsEventDone( "get_toyscissors" ) and
       cmn.IsEventDone( "get_brokenframe" ) and
       cmn.IsEventDone( "get_pattern_1" ) and
       cmn.IsEventDone( "get_collect2_3_1" ) and
       cmn.IsEventDone( "get_handle3" ) then
      ObjDelete( "gzz_technicalroom_janitresdaughter" );
    end;

  end;

  cmn.AddSubscriber( "get_handle3", get_handle3_inv );
  cmn.AddSubscriber( "get_handle3", get_handle3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_toyscissors () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_toyscissors" ] =
  {
    type = "get",
    get_obj = "spr_janitresdaughter_toyscissors",
    room = private.room_objname,
    zz = "zz_janitresdaughter",
    zz_gate = "gzz_technicalroom_janitresdaughter"
  };
  -----------------------------------------------
  local get_toyscissors_inv = function ()

    int.InventoryItemAdd( "inv_toyscissors", "spr_janitresdaughter_toyscissors" );

  end;

  local get_toyscissors_closezz = function ()

    ObjDelete( "gfx_janitresdaughter_toyscissors" );
    ObjDelete( "spr_janitresdaughter_toyscissors_shadow" );
    ObjDelete( "spr_technicalroom_toyscissors" );

    if cmn.IsEventDone( "get_toyscissors" ) and
       cmn.IsEventDone( "get_brokenframe" ) and
       cmn.IsEventDone( "get_pattern_1" ) and
       cmn.IsEventDone( "get_collect2_3_1" ) and
       cmn.IsEventDone( "get_handle3" ) then
      ObjDelete( "gzz_technicalroom_janitresdaughter" );
    end;

  end;

  cmn.AddSubscriber( "get_toyscissors", get_toyscissors_inv );
  cmn.AddSubscriber( "get_toyscissors", get_toyscissors_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pattern_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pattern_1" ] =
  {
    type = "get",
    get_obj = "spr_janitresdaughter_pattern_1",
    room = private.room_objname,
    zz = "zz_janitresdaughter",
    zz_gate = "gzz_technicalroom_janitresdaughter"
  };
  -----------------------------------------------
  local get_pattern_1_inv = function ()

    int.InventoryItemAdd( "inv_pattern", "spr_janitresdaughter_pattern_1", "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/inv/inv_pattern_1_morph" );
    level3_inv.CheckPattern();

  end;

  local get_pattern_1_closezz = function ()

    ObjDelete( "gfx_janitresdaughter_pattern_1" );
    ObjDelete( "spr_technicalroom_pattern_1" );

    if cmn.IsEventDone( "get_toyscissors" ) and
       cmn.IsEventDone( "get_brokenframe" ) and
       cmn.IsEventDone( "get_pattern_1" ) and
       cmn.IsEventDone( "get_collect2_3_1" ) and
       cmn.IsEventDone( "get_handle3" ) then
      ObjDelete( "gzz_technicalroom_janitresdaughter" );
    end;

  end;

  cmn.AddSubscriber( "get_pattern_1", get_pattern_1_inv );
  cmn.AddSubscriber( "get_pattern_1", get_pattern_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokenframe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brokenframe" ] =
  {
    type = "get",
    get_obj = "spr_janitresdaughter_brokenframe",
    room = private.room_objname,
    zz = "zz_janitresdaughter",
    zz_gate = "gzz_technicalroom_janitresdaughter"
  };
  -----------------------------------------------
  local get_brokenframe_inv = function ()

    int.InventoryItemAdd( "inv_brokenframe", "spr_janitresdaughter_brokenframe" );
    ObjSet( "inv_brokenframe", { drag = false } );    

  end;

  local get_brokenframe_closezz = function ()

    ObjDelete( "gfx_janitresdaughter_brokenframe" );
    ObjDelete( "spr_technicalroom_brokenframe" );

    if cmn.IsEventDone( "get_toyscissors" ) and
       cmn.IsEventDone( "get_brokenframe" ) and
       cmn.IsEventDone( "get_pattern_1" ) and
       cmn.IsEventDone( "get_collect2_3_1" ) and
       cmn.IsEventDone( "get_handle3" ) then
      ObjDelete( "gzz_technicalroom_janitresdaughter" );
    end;

  end;

  cmn.AddSubscriber( "get_brokenframe", get_brokenframe_inv );
  cmn.AddSubscriber( "get_brokenframe", get_brokenframe_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_3_5 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_3_5 = function ()

    ObjDelete( "obj_technicalroom_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_3_5", get_morphobject_3_5, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_3_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_3_1 = function ()

    ObjDelete( "spr_janitresdaughter_collect_shadow" );
    ObjDelete( "spr_janitresdaughter_collect2_3_1" );
    ObjDelete( "spr_technicalroom_collect" );

    if cmn.IsEventDone( "get_toyscissors" ) and
       cmn.IsEventDone( "get_brokenframe" ) and
       cmn.IsEventDone( "get_pattern_1" ) and
       cmn.IsEventDone( "get_handle3" ) then

      ObjDelete( "gzz_technicalroom_janitresdaughter" );

    end;

  end;

  cmn.AddSubscriber( "get_collect2_3_1", get_collect2_3_1, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_pattern () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pattern" ] =
  {
    type = "use",
    use_obj = "inv_pattern",
    use_place = "obj_keystand_use_pattern",
    room = private.room_objname,
    zz = "zz_keystand",
    zz_gate = "gzz_technicalroom_keystand"
  };
  -----------------------------------------------
  local use_pattern_inv = function ()

    int.InventoryItemRemove( "inv_pattern" );

  end;
  local use_pattern_beg = function ()

    ObjDelete( "obj_keystand_use_pattern" );

  end;
  local use_pattern_end = function ()

    ObjSet( "obj_keystand_figures_hidden", { alp = 1 } );
    ObjSet( "gmg_technicalroom_ondoor", { active = true, input = true, alp = 1 } );    
    ObjDelete( "gzz_technicalroom_keystand" );
    ObjSet( "spr_technicalroom_pattern", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_pattern", use_pattern_beg, private.room_objname );
  cmn.AddSubscriber( "use_pattern", use_pattern_inv );
  cmn.AddSubscriber( "use_pattern", use_pattern_end, private.room_objname );
  cmn.AddSubscriber( "use_pattern_inv", use_pattern_inv, private.room_objname );
  cmn.AddSubscriber( "use_pattern_beg", use_pattern_beg, private.room_objname );
  cmn.AddSubscriber( "use_pattern_end", use_pattern_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ruler () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ruler" ] =
  {
    type = "use",
    use_obj = "inv_ruler",
    use_place = "obj_stafdrawers_use_ruler",
    room = private.room_objname,
    zz = "zz_stafdrawers",
    zz_gate = "gzz_technicalroom_stafdrawers"
  };
  -----------------------------------------------
  local use_ruler_inv = function ()

    int.InventoryItemRemove( "inv_ruler" );

  end;
  local use_ruler_beg = function ()

    ObjDelete( "obj_stafdrawers_use_ruler" );

  end;
  local use_ruler_end = function ()

    ObjSet( "spr_stafdrawers_cabinet_open",   { alp = 1 } );
    ObjSet( "obj_stafdrawers_cabinet",        { input = true } );
    ObjSet( "gfx_stafdrawers_snowdropamulet", { active = true } );
    ObjSet( "gfx_stafdrawers_switch3_1",      { active = true } );
    ObjSet( "gfx_stafdrawers_glue3",          { active = true } );
    ObjDelete( "obj_stafdrawers_cabinet_close" );
    ObjSet( "spr_technicalroom_cabinet_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_ruler", use_ruler_beg, private.room_objname );
  cmn.AddSubscriber( "use_ruler", use_ruler_inv );
  cmn.AddSubscriber( "use_ruler", use_ruler_end, private.room_objname );
  cmn.AddSubscriber( "use_ruler_inv", use_ruler_inv, private.room_objname );
  cmn.AddSubscriber( "use_ruler_beg", use_ruler_beg, private.room_objname );
  cmn.AddSubscriber( "use_ruler_end", use_ruler_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shell () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_shell" ] =
  {
    type = "use",
    use_obj = "inv_shell",
    use_place = "obj_stafdrawers_use_shell",
    room = private.room_objname,
    zz = "zz_stafdrawers",
    zz_gate = "gzz_technicalroom_stafdrawers"
  };
  -----------------------------------------------
  local use_shell_inv = function ()

    int.InventoryItemRemove( "inv_shell" );

  end;
  local use_shell_beg = function ()

    ObjDelete( "obj_stafdrawers_use_shell" );

  end;
  local use_shell_end = function ()

    ObjSet( "spr_stafdrawers_shell_1",     { alp = 1 } );
    ObjSet( "spr_stafdrawers_shell_2",     { alp = 1 } );
    ObjSet( "obj_stafdrawers_turtle_open", { alp = 1, input = true } );
    ObjSet( "gfx_stafdrawers_button_2",    { active = true } );
    ObjDelete( "anm_stafdrawers_turtle_open" );
    ObjSet( "spr_technicalroom_shell_1",     { alp = 1 } );
    ObjSet( "spr_technicalroom_shell_2",     { alp = 1 } );
    ObjSet( "spr_technicalroom_turtle_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_shell", use_shell_beg, private.room_objname );
  cmn.AddSubscriber( "use_shell", use_shell_inv );
  cmn.AddSubscriber( "use_shell", use_shell_end, private.room_objname );
  cmn.AddSubscriber( "use_shell_inv", use_shell_inv, private.room_objname );
  cmn.AddSubscriber( "use_shell_beg", use_shell_beg, private.room_objname );
  cmn.AddSubscriber( "use_shell_end", use_shell_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bowknot () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bowknot" ] =
  {
    type = "use",
    use_obj = "inv_bowknot",
    use_place = "obj_janitresdaughter_use_bowknot",
    room = private.room_objname,
    zz = "zz_janitresdaughter",
    zz_gate = "gzz_technicalroom_janitresdaughter"
  };
  -----------------------------------------------
  local use_bowknot_inv = function ()

    int.InventoryItemRemove( "inv_bowknot" );

  end;
  local use_bowknot_beg = function ()

    ObjDelete( "obj_janitresdaughter_use_bowknot" );

  end;
  local use_bowknot_end = function ()

    ObjSet( "obj_janitresdaughter_open_giftbox", { input = true } );
    ObjSet( "spr_janitresdaughter_close", { alp = 1, pos_x = -235, pos_y = 44 } );
    ObjSet( "spr_janitresdaughter_bow_shadow", { alp = 1 } );
    ObjSet( "spr_janitresdaughter_bow", { alp = 1 } );
    ObjSet( "gfx_janitresdaughter_handle", { active = true } );
    ObjSet( "gfx_janitresdaughter_pattern_1", { active = true } );
    ObjDelete( "anm_janitresdaughter_open" );
    ObjSet( "spr_technicalroom_box_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_bowknot", use_bowknot_beg, private.room_objname );
  cmn.AddSubscriber( "use_bowknot", use_bowknot_inv );
  cmn.AddSubscriber( "use_bowknot", use_bowknot_end, private.room_objname );
  cmn.AddSubscriber( "use_bowknot_inv", use_bowknot_inv, private.room_objname );
  cmn.AddSubscriber( "use_bowknot_beg", use_bowknot_beg, private.room_objname );
  cmn.AddSubscriber( "use_bowknot_end", use_bowknot_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_snowdropamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_snowdropamulet" ] =
  {
    type = "use",
    use_obj = "inv_snowdropamulet",
    use_place = "obj_janitresdaughter_use_snowdropamulet",
    room = private.room_objname,
    zz = "zz_janitresdaughter",
    zz_gate = "gzz_technicalroom_janitresdaughter"
  };
  -----------------------------------------------
  local use_snowdropamulet_inv = function ()

    int.InventoryItemRemove( "inv_snowdropamulet" );

  end;
  local use_snowdropamulet_beg = function ()

    ObjDelete( "obj_janitresdaughter_use_snowdropamulet" );

  end;
  local use_snowdropamulet_end = function ()

    ObjSet( "obj_janitresdaughter_snowflake_2", { alp = 1 } );
    ObjSet( "spr_janitresdaughter_snowflakes_over_1", { alp = 1 } );
    ObjSet( "obj_janitresdaughter_mmg", { input = true } );
    ObjSet( "spr_technicalroom_snowdropamulet_2", { alp = 1 } );
    ObjDelete( "anm_janitresdaughter_open_box" );
    ObjDelete( "spr_janitresdaughter_closed_box" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_snowdropamulet", use_snowdropamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_snowdropamulet", use_snowdropamulet_inv );
  cmn.AddSubscriber( "use_snowdropamulet", use_snowdropamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_snowdropamulet_inv", use_snowdropamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_snowdropamulet_beg", use_snowdropamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_snowdropamulet_end", use_snowdropamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_janitresdaughter () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_janitresdaughter" ] =
  {
    room = private.room_objname,
    zz = "zz_janitresdaughter",
    zz_gate = "gzz_technicalroom_janitresdaughter"
  };
  --*********************************************************************************************************************
  local win_janitresdaughter = function ()

    if ( cmn.IsEventDone( "win_janitresdaughter" ) ) then

      ObjSet( "obj_janitresdaughter_open_box", { alp = 1, input = true } );
      ObjSet( "obj_janitresdaughter_mmg", { input = false } );
      ObjSet( "gfx_janitresdaughter_toyscissors", { active = true } );
      ObjSet( "gfx_janitresdaughter_brokenframe", { active = true } );
      ObjSet( "spr_technicalroom_chest_open", { alp = 1 } );

      for i=1, 4 do
        local ind = private.win[ i ];
        ObjSet( "anm_janitresdaughter_snowflake_"..i.."_close", { 
          res = "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/anims/snowflakes/"..ind.."_snowflake_close",
          animfunc = "DoAnim"
        } );
      end;

    elseif ( cmn.IsEventStart( "win_janitresdaughter" ) ) then

      private.LoadJanitresdaughter();   

    end;

  end;
  cmn.AddSubscriber( "win_janitresdaughter", win_janitresdaughter, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
function private.get_staramulet ()

  cmn.SetEventDone( "get_staramulet" );
  cmn.CallEventHandler( "get_staramulet" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_purse3 ()

  cmn.SetEventDone( "get_purse3" );
  cmn.CallEventHandler( "get_purse3" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_snowdropamulet ()

  cmn.SetEventDone( "get_snowdropamulet" );
  cmn.CallEventHandler( "get_snowdropamulet" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_switch3_1 ()

  cmn.SetEventDone( "get_switch3_1" );
  cmn.CallEventHandler( "get_switch3_1" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_glue3 ()

  cmn.SetEventDone( "get_glue3" );
  cmn.CallEventHandler( "get_glue3" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_button_2 ()

  cmn.SetEventDone( "get_button_2" );
  cmn.CallEventHandler( "get_button_2" );
  cmn.CloseSubRoom();
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_handle3 ()

  cmn.SetEventDone( "get_handle3" );
  cmn.CallEventHandler( "get_handle3" );
  
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_toyscissors" ) and
     cmn.IsEventDone( "get_brokenframe" ) and
     cmn.IsEventDone( "get_pattern_1" ) and
     cmn.IsEventDone( "get_collect2_3_1" ) and
     cmn.IsEventDone( "get_handle3" ) then
    cmn.CloseSubRoom();
  end;

end;
-------------------------------------------------
function private.get_toyscissors ()

  cmn.SetEventDone( "get_toyscissors" );
  cmn.CallEventHandler( "get_toyscissors" );
  
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_toyscissors" ) and
     cmn.IsEventDone( "get_brokenframe" ) and
     cmn.IsEventDone( "get_pattern_1" ) and
     cmn.IsEventDone( "get_collect2_3_1" ) and
     cmn.IsEventDone( "get_handle3" ) then
    cmn.CloseSubRoom();
  end;

end;
-------------------------------------------------
function private.get_pattern_1 ()

  cmn.SetEventDone( "get_pattern_1" );
  cmn.CallEventHandler( "get_pattern_1" );
  
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_toyscissors" ) and
     cmn.IsEventDone( "get_brokenframe" ) and
     cmn.IsEventDone( "get_pattern_1" ) and
     cmn.IsEventDone( "get_collect2_3_1" ) and
     cmn.IsEventDone( "get_handle3" ) then
    cmn.CloseSubRoom();
  end;

end;
-------------------------------------------------
function private.get_brokenframe ()

  cmn.SetEventDone( "get_brokenframe" );
  cmn.CallEventHandler( "get_brokenframe" );
  
  cmn.GetObjectSfx(); 

  if cmn.IsEventDone( "get_toyscissors" ) and
     cmn.IsEventDone( "get_brokenframe" ) and
     cmn.IsEventDone( "get_pattern_1" ) and
     cmn.IsEventDone( "get_collect2_3_1" ) and
     cmn.IsEventDone( "get_handle3" ) then
    cmn.CloseSubRoom();
  end; 

end;
---------------------------------------------------------------------------------
function private.get_collect2_3_1()

  int.AddCollectibles2( "spr_janitresdaughter_collect2_3_1" );
  ObjSet( "spr_janitresdaughter_collect_shadow", { alp = 0 } );

  if cmn.IsEventDone( "get_toyscissors" ) and
     cmn.IsEventDone( "get_brokenframe" ) and
     cmn.IsEventDone( "get_pattern_1" ) and
     cmn.IsEventDone( "get_handle3" ) then
    cmn.CloseSubRoom();
  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
function public.use_pattern ()

  local item = "inv_pattern";

  if ( cmn.ApplyObj( item, "gzz_technicalroom_keystand", false ) ) and
     ( cmn.IsEventDone( "get_pattern_1" ) ) and
     ( cmn.IsEventDone( "get_pattern_2" ) ) and
     ( cmn.IsEventDone( "get_pattern_3" ) ) and
     ( cmn.IsEventDone( "get_pattern_4" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_keystand" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_keystand_use_pattern", true ) ) and
         ( cmn.IsEventDone( "get_pattern_1" ) ) and
         ( cmn.IsEventDone( "get_pattern_2" ) ) and
         ( cmn.IsEventDone( "get_pattern_3" ) ) and
         ( cmn.IsEventDone( "get_pattern_4" ) ) then

    cmn.CallEventHandler( "use_pattern_inv" );
    cmn.CallEventHandler( "use_pattern_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_pattern" );
      cmn.CallEventHandler( "use_pattern_end" );
      int.Lock( false );

      cmn.CloseSubRoom();
      cmn.GotoRoom( "mg_ondoor" )

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_start_mg" );  
    ObjAnimate("obj_keystand_figures_hidden", "alp", 0, 0, func_end, 
    {
      0.0,0,0,
      0.3,0,1
    });

    return true;

  end;

  return false;

end;
---------------------------------------------------
---------------------------------------------------
function public.use_ruler ()

  local item = "inv_ruler";

  if ( cmn.ApplyObj( item, "gzz_technicalroom_stafdrawers", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stafdrawers" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stafdrawers_use_ruler", true ) ) then

    cmn.CallEventHandler( "use_ruler_inv" );
    cmn.CallEventHandler( "use_ruler_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_ruler" );
      cmn.CallEventHandler( "use_ruler_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_open_metal_box" );  
    ObjSet( "anm_stafdrawers_ruler",      { alp = 1 } );
    ObjSet( "anm_stafdrawers_door_click", { alp = 0 } );

    AnimPlay( "anm_stafdrawers_ruler", "DoAnim",
    function ()

      ObjAnimate( "obj_stafdrawers_cabinet_close", "alp", 0, 0, "", 
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "spr_stafdrawers_cabinet_open", "alp", 0, 0, func_end, 
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end
    );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_shell ()

  local item = "inv_shell";

  if ( cmn.ApplyObj( item, "gzz_technicalroom_stafdrawers", false ) ) and
     ( cmn.IsEventDone( "use_ruler" ) ) and
     ( cmn.IsEventDone( "get_shell_1" ) ) and
     ( cmn.IsEventDone( "get_shell_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stafdrawers" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stafdrawers_use_shell", true ) ) and
         ( cmn.IsEventDone( "get_shell_1" ) ) and
         ( cmn.IsEventDone( "get_shell_2" ) ) and
         ( cmn.IsEventDone( "use_ruler" ) ) then

    cmn.CallEventHandler( "use_shell_inv" );
    cmn.CallEventHandler( "use_shell_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_shell" );
      cmn.CallEventHandler( "use_shell_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_place_into_turtle" );  
    ObjAnimate( "spr_stafdrawers_shell_2", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "spr_stafdrawers_shell_1", "alp", 0, 0,
    function ()

      AnimPlay( "anm_stafdrawers_turtle_open", "DoAnim", func_end );

    end,
    { 
      0.0, 0, 0.0, 
      0.5, 0, 0.0, 
      0.8, 0, 1.0
    } );

    --ObjAnimate( "obj_stafdrawers_turtle_open", "alp", 0, 0, func_end,
    --{ 
    --  0.0, 0, 0.0, 
    --  1.0, 0, 0.0, 
    --  1.3, 0, 1.0
    --} );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_bowknot ()

  local item = "inv_bowknot";

  if ( cmn.ApplyObj( item, "gzz_technicalroom_janitresdaughter", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_janitresdaughter" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_janitresdaughter_use_bowknot", true ) ) then

    cmn.CallEventHandler( "use_bowknot_inv" );
    cmn.CallEventHandler( "use_bowknot_beg" );
    int.Lock( true );

    local func_end = function ()

      local func_end = function ()

        cmn.SetEventDone( "use_bowknot" );
        cmn.CallEventHandler( "use_bowknot_end" );
        int.Lock( false );

      end;

      AnimPlay( "anm_janitresdaughter_open", "DoAnim", func_end );
 
    end;
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_open_bear_box" );  
    ObjAnimate( "spr_janitresdaughter_close", "alp", 0, 0, "", 
    { 
      0.0, 0, 1,
      0.3, 0, 0,
    } );
    ObjAnimate( "anm_janitresdaughter_open", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.3, 0, 1,
      0.6, 0, 1,
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_snowdropamulet ()

  local item = "inv_snowdropamulet";

  if ( cmn.ApplyObj( item, "gzz_technicalroom_janitresdaughter", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_janitresdaughter" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_janitresdaughter_use_snowdropamulet", true ) ) then

    cmn.CallEventHandler( "use_snowdropamulet_inv" );
    cmn.CallEventHandler( "use_snowdropamulet_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_snowdropamulet" );
      cmn.CallEventHandler( "use_snowdropamulet_end" );
      int.Lock( false );
      common_impl.PassingMgStart( "janitresdaughter" );
      private.InitJanitresdaughterStart();

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_snowflake_app" );  
    AnimPlay( "anm_janitresdaughter_open_box", "DoAnim",
    function ()
     
      ObjAnimate( "obj_janitresdaughter_snowflake_2", "alp", 0, 0, func_end, 
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );
      
    end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_technicalroom ()

  if not ( cmn.IsEventDone( "opn_technicalroom" ) ) then

    cmn.SetEventDone( "opn_technicalroom" );
    cmn.ShowBbt( "bbt_technicalroom_first_entry" );

  end;

end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_technicalroom();
  
  cmn.StopAllEnv( "audio/level3/env/aud_technicalroom_env", true );
  cmn.PlayAudio( "env", "audio/level3/env/aud_technicalroom_env", 1 );

end;
--*********************************************************************************************************************
function public.Task ()
  
  int.AddedTaskMap( private.room_objname, "get_staramulet" );
  int.AddedTaskMap( private.room_objname, "get_purse3" );  
  int.AddedTaskMap( private.room_objname, "get_snowdropamulet",                           { "use_ruler" } );  
  int.AddedTaskMap( private.room_objname, "get_switch3_1",                                { "use_ruler" } );   
  int.AddedTaskMap( private.room_objname, "get_glue3",                                    { "use_ruler" } ); 
  int.AddedTaskMap( private.room_objname, "get_button_2",                                 { "use_shell" } );
  int.AddedTaskMap( private.room_objname, "get_handle3",                                  { "use_bowknot" } );  
  int.AddedTaskMap( private.room_objname, "get_toyscissors",                              { "win_janitresdaughter" } );  
  int.AddedTaskMap( private.room_objname, "get_pattern_1",                                { "use_bowknot" } );
  int.AddedTaskMap( private.room_objname, "get_brokenframe",                              { "win_janitresdaughter" } );  
  int.AddedTaskMap( private.room_objname, "get_cleaningagent",                            { "win_ondoor" } ); 
  int.AddedTaskMap( private.room_objname, "get_controltowerkey",                          { "win_ondoor" } );  


  int.AddedTaskMap( private.room_objname, "use_pattern",                                  { "get_pattern_1", "get_pattern_2", "get_pattern_3", "get_pattern_4" } ); 
  int.AddedTaskMap( private.room_objname, "use_ruler",                                    { "get_ruler" } ); 
  int.AddedTaskMap( private.room_objname, "use_shell",                                    { "get_shell_1", "get_shell_2" } );   
  int.AddedTaskMap( private.room_objname, "use_bowknot",                                  { "get_bowknot" } );
  int.AddedTaskMap( private.room_objname, "use_snowdropamulet",                           { "get_snowdropamulet" } );  
 
  int.AddedTaskMap( private.room_objname, "win_janitresdaughter",                         { "use_snowdropamulet" } );  
  int.AddedTaskMap( private.room_objname, "win_ondoor",                                   { "use_pattern" } ); 
  
end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_janitresdaughter" );

  function zz_janitresdaughter.Open()

    if ( cmn.IsEventStart( "win_janitresdaughter" ) and not cmn.IsEventDone( "win_janitresdaughter" ) ) then

      cmn.MiniGameShow( "janitresdaughter" );
      common_impl.PassingMgStart( "janitresdaughter" );

    end;

  end;
  -------------------------------------------------
  function zz_janitresdaughter.PreClose()

    if ( cmn.IsEventStart( "win_janitresdaughter" ) and not cmn.IsEventDone( "win_janitresdaughter" ) ) then

      cmn.MiniGameHide( "janitresdaughter" );
      common_impl.PassingMgStop( "janitresdaughter" );

    end;

  end;
  -----------------------------------------------
  function zz_janitresdaughter.Skip ()

    for num=1, 4 do
      local ind = private.win[ num ];
      ObjSet( "anm_janitresdaughter_snowflake_"..num.."_close", { 
        res = "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/anims/snowflakes/"..private.types[ num ][ ind ].."_snowflake_close",
        animfunc = "DoAnim"
      } );
    end;

    private.WinJanitresdaughter();

  end;
  -------------------------------------------------
  function zz_janitresdaughter.Reset ()

    for num=1, 4 do
      private.state[ num ] = private.init_state[ num ];
      ng_global.progress[ "std" ][ "win_janitresdaughter" ].state[ num ] = private.init_state[ num ];
      local ind = private.init_state[ num ];
      ObjSet( "anm_janitresdaughter_snowflake_"..num.."_close", { 
        res = "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/anims/snowflakes/"..private.types[ num ][ ind ].."_snowflake_close",
        animfunc = "DoAnim"
      } );
      if ( ind == 3 ) then
        ObjSet( "anm_janitresdaughter_snowflake_"..num.."_open", { 
          res = "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/anims/snowflakes/"..private.types[ num ][ 1 ].."_snowflake_open",
          animfunc = "DoAnim"
        } );
      else
        ObjSet( "anm_janitresdaughter_snowflake_"..num.."_open", { 
        res = "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/anims/snowflakes/"..private.types[ num ][ ind+1 ].."_snowflake_open",
          animfunc = "DoAnim"
        } );
      end;
    end;
    
  end;

end;
--*********************************************************************************************************************
function private.InitAnims ()

  ObjAnimate( "spr_stafdrawers_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "obj_stafdrawers_purse", "ang", 1, 0, "", 
  {
    0.0, 3, -0.05,
    2.1, 3,  0.00,
    4.2, 3, -0.05,
  } );

  ObjAnimate( "spr_janitresdaughter_light_add", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_keystand_light_add_up", "alp", 1, 0, "", 
  {
    0.0, 3, 0.7,
    2.5, 3, 1.0,
    5.0, 3, 0.7,
  } );
  ObjAnimate( "spr_keystand_light_add_down", "alp", 1, 0, "", 
  {
    0.0, 3, 0.5,
    2.0, 3, 1.0,
    4.0, 3, 0.5,
  } );
  
  ObjAnimate( "obj_technicalroom_pers", "alp", 1, 0, "", 
  { 
    0.0, 3, 1.0,
    0.3, 3, 1.0,
    1.3, 3, 0.6,
    2.3, 3, 1.0,
    3.3, 3, 0.6,
    4.3, 3, 1.0,
    5.3, 3, 0.6,
    6.3, 3, 1.0,
    7.3, 3, 0.6,
    8.3, 3, 1.0,
    8.5, 3, 0.6,
    8.7, 3, 1.0,
    8.9, 3, 0.6,
    9.1, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
function private.JanitresdaughterBoxClk ()

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ice_box_touch" ); 
 
  ObjAnimate("spr_janitresdaughter_closed_box", "pos_x", 0, 0, 
  function ()
    int.Lock( false );
    cmn.ShowBbt( "bbt_janitresdaughter_use_snowdropamulet" );
  end, 
  {
    0.0,0,127,
    0.2,0,126,
    0.4,0,127
  });

end;
--*********************************************************************************************************************
function private.StafdrawersDoorClick ()

  int.Lock( true );

  local func_end = function ()

    cmn.ShowBbt( "bbt_stafdrawers_use_ruler" );
    int.Lock( false );

  end;

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_touch_metal_box" );  
  AnimPlay( "anm_stafdrawers_door_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.StafdrawersTurtleClick ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

  end;

  --cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_snowdropamulet" );  
  AnimPlay( "anm_stafdrawers_turtle_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--********************************************************************************************************************
-- function *** MMG JANITRESDAUGHTER ***  () end;
--********************************************************************************************************************
--********************************************************************************************************************
  function private.InitJanitresdaughter ()

    private.init_state = { 2,2,1,3 };
    private.state = { 2,2,1,3 };
    private.win = { 1,1,1,1 };
    
    private.types = 
    {
      {1,2,3},
      {1,3,4},
      {1,3,4},
      {1,2,4}
    };

    for num = 1, 4 do

      ObjSet( "spr_janitresdaughter_button_"..num, {
        event_mdown = function () private.ClkButton ( num ); end
      } );

      local ind = private.init_state[ num ];
      ObjSet( "anm_janitresdaughter_snowflake_"..num.."_close", { 
      res = "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/anims/snowflakes/"..private.types[ num ][ ind ].."_snowflake_close", 
        animfunc = "DoAnim"
      } );
      if ( ind == 3 ) then
        ObjSet( "anm_janitresdaughter_snowflake_"..num.."_open", { 
          res = "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/anims/snowflakes/"..private.types[ num ][ 1 ].."_snowflake_open",
          animfunc = "DoAnim"
        } );
      else
        ObjSet( "anm_janitresdaughter_snowflake_"..num.."_open", { 
        res = "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/anims/snowflakes/"..private.types[ num ][ ind+1 ].."_snowflake_open",
          animfunc = "DoAnim"
        } );
      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.InitJanitresdaughterStart ()  

    cmn.MiniGameShow( "janitresdaughter" );

    ng_global.progress[ "std" ][ "win_janitresdaughter" ].state = { 2,2,1,3 };

  end;
  --********************************************************************************************************************
  function private.LoadJanitresdaughter ()

    for num=1, 4 do
      private.state[ num ] = ng_global.progress[ "std" ][ "win_janitresdaughter" ].state[ num ];
      local ind = private.state[ num ];
      ObjSet( "anm_janitresdaughter_snowflake_"..num.."_close", { 
        res = "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/anims/snowflakes/"..private.types[ num ][ ind ].."_snowflake_close",
        animfunc = "DoAnim"
      } );
      if ( ind == 3 ) then
        ObjSet( "anm_janitresdaughter_snowflake_"..num.."_open", { 
          res = "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/anims/snowflakes/"..private.types[ num ][ 1 ].."_snowflake_open",
          animfunc = "DoAnim"
        } );
      else
        ObjSet( "anm_janitresdaughter_snowflake_"..num.."_open", { 
        res = "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/anims/snowflakes/"..private.types[ num ][ ind+1 ].."_snowflake_open",
          animfunc = "DoAnim"
        } );
      end;
    end;

  end;
  --*********************************************************************************************************************
  function private.CheckWinJanitresdaughter ()

    local win = true;

    for i=1, 4 do
      if ( private.state[ i ] ~= private.win[ i ] ) then
        win = false;
      end;
    end;

    if ( win ) then
      private.WinJanitresdaughter();
    else
      for i=1, 4 do
        ng_global.progress[ "std" ][ "win_janitresdaughter" ].state[ i ] = private.state[ i ];
      end;
    end;

  end;
  --*********************************************************************************************************************
  function private.WinJanitresdaughter ()

    local func_end = function ()

      cmn.MiniGameHide( "janitresdaughter" );
      cmn.SetEventDone( "win_janitresdaughter" );
      cmn.CallEventHandler( "win_janitresdaughter" );
      common_impl.PassingMgWin( "janitresdaughter" );

      int.Lock( false ) ;

    end;

    int.Lock( true ) ;
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_snowflake_open" );
    ObjAnimate("obj_janitresdaughter_open_box", "alp", 0, 0, func_end, 
    {
      0.0,0,0,
      0.3,0,1
    });

  end;
  --*********************************************************************************************************************
  function private.ClkButton ( num )

    local func_end = function ()

      int.Lock( false );

      if ( private.state[ num ] == 3 ) then
        private.state[ num ] = 1;
      else
        private.state[ num ] = private.state[ num ] + 1;
      end;

      local ind = private.state[ num ];
      ObjSet( "anm_janitresdaughter_snowflake_"..num.."_close", { 
        res = "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/anims/snowflakes/"..private.types[ num ][ ind ].."_snowflake_close",
        animfunc = "DoAnim"
      } );
      if ( ind == 3 ) then
        ObjSet( "anm_janitresdaughter_snowflake_"..num.."_open", { 
          res = "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/anims/snowflakes/"..private.types[ num ][ 1 ].."_snowflake_open",
          animfunc = "DoAnim"
        } );
      else
        ObjSet( "anm_janitresdaughter_snowflake_"..num.."_open", { 
        res = "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/anims/snowflakes/"..private.types[ num ][ ind+1 ].."_snowflake_open",
          animfunc = "DoAnim"
        } );
      end;
      ObjSet( "anm_janitresdaughter_snowflake_"..num.."_close", { alp = 1, frame = 0 } );
      ObjSet( "anm_janitresdaughter_snowflake_"..num.."_open", { alp = 0, frame = 0 } );

      private.CheckWinJanitresdaughter();

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_snowflake_click" );
    AnimPlay( "anm_janitresdaughter_snowflake_"..num.."_close", "DoAnim",
    function()
      ObjSet( "anm_janitresdaughter_snowflake_"..num.."_close", { alp = 0 } );
      ObjSet( "anm_janitresdaughter_snowflake_"..num.."_open", { alp = 1 } );
      AnimPlay( "anm_janitresdaughter_snowflake_"..num.."_open", "DoAnim", func_end );
    end );

  end;
  --*********************************************************************************************************************
--********************************************************************************************************************
function private.ClkMop ()

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mop_fall" );
  AnimPlay( "anm_technicalroom_mop_click", "DoAnim", 
  function () 
    int.Lock( false );
    ObjSet( "anm_technicalroom_mop_click", { alp = 0 } );
    ObjSet( "anm_technicalroom_mop_down", { alp = 1 } );
    ObjSet( "obj_technicalroom_clk_mop", { input = false } );
  end );

end;
--********************************************************************************************************************
function private.ClkLamp ()

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_lamp_touch" );
  ObjSet( "anm_technicalroom_lamp_click", { alp = 1 } );
  ObjSet( "anm_technicalroom_lamp_static", { alp = 0, playing = false } );
  AnimPlay( "anm_technicalroom_lamp_click", "DoAnim", 
  function () 
    int.Lock( false );
    ObjSet( "anm_technicalroom_lamp_click", { alp = 0 } );
    ObjSet( "anm_technicalroom_lamp_static", { alp = 1, playing = true } );
  end );

end;
--********************************************************************************************************************
function private.BearClk()

  local func_end = function ()
    if not cmn.IsEventDone( "use_bowknot" ) then
      cmn.ShowBbt( "bbt_janitresdaughter_use_bowknot" );
    end;
    int.Lock( false );
  end;
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_bear_touch" );
  ObjAnimate( "spr_janitresdaughter_ear", "ang", 0, 0, "", 
  { 
    0.0, 3, 0,
    0.3, 3, -0.06,
    0.6, 3, 0,
  } );
  ObjAnimate( "spr_janitresdaughter_ear2", "ang", 0, 0, "", 
  { 
    0.0, 3, 0,
    0.3, 3, 0.14,
    0.6, 3, 0,
  } );
  ObjAnimate( "spr_janitresdaughter_leg", "ang", 0, 0, "", 
  { 
    0.0, 3, 0,
    0.3, 3, 0.09,
    0.6, 3, 0,
  } );
  ObjAnimate( "spr_janitresdaughter_leg1", "ang", 0, 0, func_end, 
  { 
    0.0, 3, 0,
    0.3, 3, -0.1,
    0.6, 3, 0,
  } );

end;
--********************************************************************************************************************