-- name=rm_waitinghall
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_waitinghall";

  ObjAttach( "zz_foodbooth",    "room_hub" );
  ObjAttach( "zz_mailcargo",    "room_hub" );
  ObjAttach( "zz_cart",         "room_hub" );
  ObjAttach( "zz_hallsecurity", "room_hub" );

  ObjMultiSet( {  
    { "spr_foodbooth_cutlet",                     { event_mdown = private.get_cutlet } },
    { "spr_mailcargo_cartwheel",                  { event_mdown = private.get_cartwheel } },
    { "spr_mailcargo_knittingneedle",             { event_mdown = private.get_knittingneedle } },
    { "spr_mailcargo_torch",                      { event_mdown = private.get_torch } },
    { "spr_mailcargo_spade",                      { event_mdown = private.get_spade } },
    { "spr_mailcargo_spade_handle",               { event_mdown = private.get_spade } },
    { "spr_cart_screwdriver3",                    { event_mdown = private.get_screwdriver3 } },
    { "spr_hallsecurity_marksamulet_1",           { event_mdown = private.get_marksamulet_1 } },
    { "spr_hallsecurity_securitybadge",           { event_mdown = private.get_securitybadge } },
    { "spr_hallsecurity_pattern_2",               { event_mdown = private.get_pattern_2 } },
    { "obj_cart_clk_cart",                        { event_mdown = private.clk_cart } },
    { "spr_cart_threedollar_2",                   { event_mdown = private.get_threedollar_2 } },
    { "spr_mailcargo_threedollar_1",              { event_mdown = private.get_threedollar_1 } },
    { "obj_mailcargo_use_marksamulet",            { event_mdown = private.MailcargoBoxClick } },
    { "obj_mailcargo_use_handle",                 { event_mdown = private.MailcargoSpadeClick } },
    { "obj_foodbooth_clk_burger_1",               { event_mdown = private.clk_burger_1 } },
    { "obj_foodbooth_clk_burger_2",               { event_mdown = private.clk_burger_2 } },
    { "obj_hallsecurity_clk_securitybag",         { event_mdown = private.clk_securitybag } },
    { "obj_foodbooth_use_threedollar",            { event_mdown = private.FoodboothClick } },
    { "obj_foodbooth_napkins",                    { event_mdown = private.NapkinsClick } },
    { "obj_cart_use_cartwheel",                   { event_mdown = private.CartClick } },
    { "obj_cart_use_screw3",                      { event_mdown = private.CartClick } },
    { "obj_mailcargo_use_cutlet",                 { event_mdown = private.DogClick } },
    { "obj_hallsecurity_use_glassshard",          { event_mdown = private.SecurityBagclick } },
    { "spr_mailcargo_collect2_3_4",               { event_mdown = private.get_collect2_3_4 } },
    { "obj_cart_use_screwdriver3",                { event_mdown = private.ScrewdriverCartClick } },
  } );
  
  private.BoothbuttonInit();
  private.InitAnims();
  private.InitSubroom();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_waitinghall = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gzz_waitinghall_foodbooth",
        "gzz_waitinghall_mailcargo",
        "gzz_waitinghall_cart",
        "gzz_waitinghall_hallsecurity",
        "gmg_waitinghall_cashtill"
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_foodbooth", 
        "zz_mailcargo", 
        "zz_cart",
        "zz_hallsecurity",
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_waitinghall", update_game_mode_waitinghall, private.room_objname );

--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function see_scare_3_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "see_scare_3_1" ] =
  {
    type = "click",
    room = private.room_objname,
  };
  -----------------------------------------------
  local see_scare_3_1_beg = function ()


  end;
  local see_scare_3_1_end = function ()


  end;

  cmn.AddSubscriber( "see_scare_3_1", see_scare_3_1_beg, private.room_objname );
  cmn.AddSubscriber( "see_scare_3_1", see_scare_3_1_end, private.room_objname );
  cmn.AddSubscriber( "see_scare_3_1_beg", see_scare_3_1_beg, private.room_objname );
  cmn.AddSubscriber( "see_scare_3_1_end", see_scare_3_1_end, private.room_objname );
  --*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_cutlet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cutlet" ] =
  {
    type = "get",
    get_obj = "spr_foodbooth_cutlet",
    room = private.room_objname,
    zz = "zz_foodbooth",
    zz_gate = "gzz_waitinghall_foodbooth"
  };
  -----------------------------------------------
  local get_cutlet_inv = function ()

    int.InventoryItemAdd( "inv_cutlet", "spr_foodbooth_cutlet" );

  end;

  local get_cutlet_closezz = function ()

    ObjDelete( "gfx_foodbooth_cutlet" );
    ObjDelete( "spr_foodbooth_cutlet_shadow" );

  end;

  cmn.AddSubscriber( "get_cutlet", get_cutlet_inv );
  cmn.AddSubscriber( "get_cutlet", get_cutlet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cartwheel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cartwheel" ] =
  {
    type = "get",
    get_obj = "spr_mailcargo_cartwheel",
    room = private.room_objname,
    zz = "zz_mailcargo",
    zz_gate = "gzz_waitinghall_mailcargo"
  };
  -----------------------------------------------
  local get_cartwheel_inv = function ()

    int.InventoryItemAdd( "inv_cartwheel", "spr_mailcargo_cartwheel" );

  end;

  local get_cartwheel_closezz = function ()

    ObjDelete( "gfx_mailcargo_cartwheel" );
    ObjDelete( "spr_mailcargo_cartwheel_shadow" );
    ObjDelete( "spr_waitinghall_mailcargo_cartwheel" );

  end;

  cmn.AddSubscriber( "get_cartwheel", get_cartwheel_inv );
  cmn.AddSubscriber( "get_cartwheel", get_cartwheel_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_knittingneedle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_knittingneedle" ] =
  {
    type = "get",
    get_obj = "spr_mailcargo_knittingneedle",
    room = private.room_objname,
    zz = "zz_mailcargo",
    zz_gate = "gzz_waitinghall_mailcargo"
  };
  -----------------------------------------------
  local get_knittingneedle_inv = function ()

    int.InventoryItemAdd( "inv_knittingneedle", "spr_mailcargo_knittingneedle" );

  end;

  local get_knittingneedle_closezz = function ()

    ObjDelete( "gfx_mailcargo_knittingneedle" );
    ObjDelete( "spr_mailcargo_knittingneedle_shadow" );
    ObjDelete( "spr_mailcargo_knittingneedle_over" );
    ObjDelete( "spr_mailcargo_hotspot" );
    ObjDelete( "spr_waitinghall_mailcargo_knittingneedle" );

  end;

  cmn.AddSubscriber( "get_knittingneedle", get_knittingneedle_inv );
  cmn.AddSubscriber( "get_knittingneedle", get_knittingneedle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_torch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_torch" ] =
  {
    type = "get",
    get_obj = "spr_mailcargo_torch",
    room = private.room_objname,
    zz = "zz_mailcargo",
    zz_gate = "gzz_waitinghall_mailcargo"
  };
  -----------------------------------------------
  local get_torch_inv = function ()

    int.InventoryItemAdd( "inv_torch", "spr_mailcargo_torch" );
    ObjSet( "inv_torch", { drag = false } );

  end;

  local get_torch_closezz = function ()

    ObjDelete( "gfx_mailcargo_torch" );
    ObjDelete( "spr_mailcargo_torch_shadow" );
    ObjDelete( "spr_waitinghall_mailcargo_torch" );

  end;

  cmn.AddSubscriber( "get_torch", get_torch_inv );
  cmn.AddSubscriber( "get_torch", get_torch_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_spade () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_spade" ] =
  {
    type = "get",
    get_obj = "obj_mailcargo_spade1",
    room = private.room_objname,
    zz = "zz_mailcargo",
    zz_gate = "gzz_waitinghall_mailcargo"
  };
  -----------------------------------------------
  local get_spade_inv = function ()

    int.InventoryItemAdd( "inv_spade", "obj_mailcargo_spade1" );

  end;

  local get_spade_closezz = function ()

    ObjDelete( "gfx_mailcargo_spade" );
    ObjDelete( "spr_mailcargo_spade_shadow" );
    ObjDelete( "spr_mailcargo_spade_over" );
    ObjDelete( "spr_waitinghall_mailcargo_spade" );

    if ( cmn.IsEventDone( "get_collect2_3_4" ) ) then
      
      ObjDelete( "gzz_waitinghall_mailcargo" );
      
    end;
    
  end;

  cmn.AddSubscriber( "get_spade", get_spade_inv );
  cmn.AddSubscriber( "get_spade", get_spade_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_screwdriver3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_screwdriver3" ] =
  {
    type = "get",
    get_obj = "spr_cart_screwdriver3",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_waitinghall_cart"
  };
  -----------------------------------------------
  local get_screwdriver3_inv = function ()

    int.InventoryItemAdd( "inv_screwdriver3", "spr_cart_screwdriver3" );

  end;

  local get_screwdriver3_closezz = function ()

    ObjDelete( "gfx_cart_screwdriver3" );
    ObjDelete( "spr_cart_screwdriver3_shadow" );
    ObjDelete( "spr_cart_screwdriwer3_shadow_over" );
    --ObjDelete( "gzz_waitinghall_cart" );

  end;

  cmn.AddSubscriber( "get_screwdriver3", get_screwdriver3_inv );
  cmn.AddSubscriber( "get_screwdriver3", get_screwdriver3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_marksamulet_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_marksamulet_1" ] =
  {
    type = "get",
    get_obj = "spr_hallsecurity_marksamulet_1",
    room = private.room_objname,
    zz = "zz_hallsecurity",
    zz_gate = "gzz_waitinghall_hallsecurity"
  };
  -----------------------------------------------
  local get_marksamulet_1_inv = function ()

    int.InventoryItemAdd( "inv_marksamulet", "spr_hallsecurity_marksamulet_1", "assets/levels/level3/rm_waitinghall/zz_hallsecurity/inv/inv_marksamulet_morph" );
    level3_inv.CheckMarksamulet();

  end;
  local get_marksamulet_1_beg = function ()

  end;
  local get_marksamulet_1_end = function ()

    ObjDelete( "gfx_hallsecurity_marksamulet_1" );
    ObjDelete( "spr_hallsecurity_marksamulet_1_shadow" );
    ObjDelete( "obj_hallsecurity_bag_open" );
    ObjDelete( "spr_waitinghall_hallsecurity_marksamulet_1" );
    ObjSet( "spr_hallsecurity_bag_thread_2", { alp = 1 } );

  end;

  --cmn.AddSubscriber( "get_marksamulet_1", get_marksamulet_1_inv );
  --cmn.AddSubscriber( "get_marksamulet_1", get_marksamulet_1_closezz, private.room_objname );

  cmn.AddSubscriber( "get_marksamulet_1", get_marksamulet_1_beg, private.room_objname );
  cmn.AddSubscriber( "get_marksamulet_1", get_marksamulet_1_inv );
  cmn.AddSubscriber( "get_marksamulet_1", get_marksamulet_1_end, private.room_objname );
  cmn.AddSubscriber( "get_marksamulet_1_inv", get_marksamulet_1_inv, private.room_objname );
  cmn.AddSubscriber( "get_marksamulet_1_beg", get_marksamulet_1_beg, private.room_objname );
  cmn.AddSubscriber( "get_marksamulet_1_end", get_marksamulet_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_securitybadge () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_securitybadge" ] =
  {
    type = "get",
    get_obj = "spr_hallsecurity_securitybadge",
    room = private.room_objname,
    zz = "zz_hallsecurity",
    zz_gate = "gzz_waitinghall_hallsecurity"
  };
  -----------------------------------------------
  local get_securitybadge_inv = function ()

    int.InventoryItemAdd( "inv_securitybadge", "spr_hallsecurity_securitybadge" );

  end;

  local get_securitybadge_closezz = function ()

    ObjDelete( "gfx_hallsecurity_securitybadge" );
    ObjDelete( "spr_hallsecurity_securitybadge_shadow" );
    ObjDelete( "spr_waitinghall_hallsecurity_securitybadge" );

  end;

  cmn.AddSubscriber( "get_securitybadge", get_securitybadge_inv );
  cmn.AddSubscriber( "get_securitybadge", get_securitybadge_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pattern_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pattern_2" ] =
  {
    type = "get",
    get_obj = "spr_hallsecurity_pattern_2",
    room = private.room_objname,
    zz = "zz_hallsecurity",
    zz_gate = "gzz_waitinghall_hallsecurity"
  };
  -----------------------------------------------
  local get_pattern_2_inv = function ()

    int.InventoryItemAdd( "inv_pattern", "spr_hallsecurity_pattern_2", "assets/levels/level3/rm_technicalroom/zz_janitresdaughter/inv/inv_pattern_2_morph" );
    level3_inv.CheckPattern();

  end;

  local get_pattern_2_closezz = function ()

    ObjDelete( "gfx_hallsecurity_pattern_2" );
    ObjDelete( "spr_hallsecurity_pattern_2_shadow" );
    ObjDelete( "gzz_waitinghall_hallsecurity" );
    ObjDelete( "spr_waitinghall_hallsecurity_pattern_2" );

  end;

  cmn.AddSubscriber( "get_pattern_2", get_pattern_2_inv );
  cmn.AddSubscriber( "get_pattern_2", get_pattern_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_threedollar_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_threedollar_1" ] =
  {
    type = "get",
    get_obj = "spr_mailcargo_threedollar_1",
    room = private.room_objname,
    zz = "zz_mailcargo",
    zz_gate = "gzz_waitinghall_mailcargo"
  };
  -----------------------------------------------
  local get_threedollar_1_inv = function ()

    int.InventoryItemAdd( "inv_threedollar", "spr_mailcargo_threedollar_1", "assets/levels/level3/rm_window/zz_bag/inv/inv_threedollar_morph" );
    level3_inv.CheckThreeDollar();

  end;

  local get_threedollar_1_closezz = function ()

    ObjDelete( "gfx_mailcargo_threedollar_1" );
    ObjDelete( "spr_mailcargo_threedollar_1_shadow" );

  end;

  cmn.AddSubscriber( "get_threedollar_1", get_threedollar_1_inv );
  cmn.AddSubscriber( "get_threedollar_1", get_threedollar_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_threedollar_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_threedollar_2" ] =
  {
    type = "get",
    get_obj = "spr_cart_threedollar_2",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_waitinghall_cart"
  };
  -----------------------------------------------
  local get_threedollar_2_inv = function ()

    int.InventoryItemAdd( "inv_threedollar", "spr_cart_threedollar_2", "assets/levels/level3/rm_window/zz_bag/inv/inv_threedollar_morph" );
    level3_inv.CheckThreeDollar();

  end;

  local get_threedollar_2_closezz = function ()

    ObjDelete( "gfx_cart_threedollar_2" );
    ObjDelete( "spr_cart_threedollar_2_shadow" );
    --ObjDelete( "gzz_window_bag" );

  end;

  cmn.AddSubscriber( "get_threedollar_2", get_threedollar_2_inv );
  cmn.AddSubscriber( "get_threedollar_2", get_threedollar_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_twister () end;
  --------------------------------------------------------------------------------------------
  local get_twister_loc = function ()

    ObjDelete( "gmg_waitinghall_cashtill" );

  end;

  cmn.AddSubscriber( "get_twister", get_twister_loc, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_3_1 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_3_1 = function ()

    ObjDelete( "obj_waitinghall_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_3_1", get_morphobject_3_1, private.room_objname );
---------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_collect2_3_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_3_4 = function ()

    ObjDelete( "spr_mailcargo_collect_3_4_shadow" );
    ObjDelete( "spr_mailcargo_collect2_3_4" );

    if ( cmn.IsEventDone( "get_spade" ) ) then
      
      ObjDelete( "gzz_waitinghall_mailcargo" );
      
    end;
    
  end;

  cmn.AddSubscriber( "get_collect2_3_4", get_collect2_3_4, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_threedollar () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_threedollar" ] =
  {
    type = "use",
    use_obj = "inv_threedollar",
    use_place = "obj_foodbooth_use_threedollar",
    room = private.room_objname,
    zz = "zz_foodbooth",
    zz_gate = "gzz_waitinghall_foodbooth"
  };
  -----------------------------------------------
  local use_threedollar_inv = function ()

    int.InventoryItemRemove( "inv_threedollar" );

  end;
  local use_threedollar_beg = function ()

    ObjDelete( "obj_foodbooth_use_threedollar" );

  end;
  local use_threedollar_end = function ()

    ObjDelete( "obj_foodbooth_booth_close" );
    ObjDelete( "anm_foodbooth_threedollar" );
    ObjSet( "obj_foodbooth_booth_open",   { alp = 1 } );
    ObjSet( "obj_foodbooth_clk_burger_1", { input = true } );
    ObjSet( "obj_waitinghall_foorbooth_open",   { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_threedollar", use_threedollar_beg, private.room_objname );
  cmn.AddSubscriber( "use_threedollar", use_threedollar_inv );
  cmn.AddSubscriber( "use_threedollar", use_threedollar_end, private.room_objname );
  cmn.AddSubscriber( "use_threedollar_inv", use_threedollar_inv, private.room_objname );
  cmn.AddSubscriber( "use_threedollar_beg", use_threedollar_beg, private.room_objname );
  cmn.AddSubscriber( "use_threedollar_end", use_threedollar_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_boothbutton_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_boothbutton_1" ] =
  {
    type = "use",
    use_obj = "inv_boothbutton_1",
    use_place = "obj_foodbooth_use_boothbutton_1",
    room = private.room_objname,
    zz = "zz_foodbooth",
    zz_gate = "gzz_waitinghall_foodbooth"
  };
  -----------------------------------------------
  local use_boothbutton_1_inv = function ()

    int.InventoryItemRemove( "inv_boothbutton_1" );

  end;
  local use_boothbutton_1_beg = function ()

    ObjDelete( "obj_foodbooth_use_boothbutton_1" );

  end;
  local use_boothbutton_1_end = function ()

    ObjSet( "spr_foodbooth_boothbutton_1", { alp = 1, input = true } );

    if ( cmn.IsEventDone( "use_boothbutton_2" ) ) then

      ObjSet( "gmg_waitinghall_cashtill", { active = true, input = true, alp = 1 } );
      ObjDelete( "gzz_waitinghall_foodbooth" );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_boothbutton_1", use_boothbutton_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_boothbutton_1", use_boothbutton_1_inv );
  cmn.AddSubscriber( "use_boothbutton_1", use_boothbutton_1_end, private.room_objname );
  cmn.AddSubscriber( "use_boothbutton_1_inv", use_boothbutton_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_boothbutton_1_beg", use_boothbutton_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_boothbutton_1_end", use_boothbutton_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_boothbutton_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_boothbutton_2" ] =
  {
    type = "use",
    use_obj = "inv_boothbutton_2",
    use_place = "obj_foodbooth_use_boothbutton_2",
    room = private.room_objname,
    zz = "zz_foodbooth",
    zz_gate = "gzz_waitinghall_foodbooth"
  };
  -----------------------------------------------
  local use_boothbutton_2_inv = function ()

    int.InventoryItemRemove( "inv_boothbutton_2" );

  end;
  local use_boothbutton_2_beg = function ()

    ObjDelete( "obj_foodbooth_use_boothbutton_2" );

  end;
  local use_boothbutton_2_end = function ()

    ObjSet( "spr_foodbooth_boothbutton_2", { alp = 1, input = true } );

    if ( cmn.IsEventDone( "use_boothbutton_1" ) ) then

      ObjSet( "gmg_waitinghall_cashtill", { active = true, input = true, alp = 1 } );
      ObjDelete( "gzz_waitinghall_foodbooth" );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_boothbutton_2", use_boothbutton_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_boothbutton_2", use_boothbutton_2_inv );
  cmn.AddSubscriber( "use_boothbutton_2", use_boothbutton_2_end, private.room_objname );
  cmn.AddSubscriber( "use_boothbutton_2_inv", use_boothbutton_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_boothbutton_2_beg", use_boothbutton_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_boothbutton_2_end", use_boothbutton_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cutlet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cutlet" ] =
  {
    type = "use",
    use_obj = "inv_cutlet",
    use_place = "obj_mailcargo_use_cutlet",
    room = private.room_objname,
    zz = "zz_mailcargo",
    zz_gate = "gzz_waitinghall_mailcargo"
  };
  -----------------------------------------------
  local use_cutlet_inv = function ()

    int.InventoryItemRemove( "inv_cutlet" );

  end;
  local use_cutlet_beg = function ()

    ObjDelete( "obj_mailcargo_use_cutlet" );

  end;
  local use_cutlet_end = function ()

    ObjDelete( "anm_mailcargo_dog_static_wheel" );
    ObjDelete( "anm_mailcargo_dog_click" );
    ObjDelete( "anm_mailcargo_dog_cutlet" );
    ObjSet( "anm_mailcargo_dog_cutlet_static", { playing = true, alp = 1 } );
    ObjSet( "spr_mailcargo_cartwheel_shadow", { alp = 1 } );
    ObjSet( "spr_mailcargo_cartwheel", { input = true, alp = 1 } );
    ObjSet( "gfx_mailcargo_cartwheel", { active = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_cutlet", use_cutlet_beg, private.room_objname );
  cmn.AddSubscriber( "use_cutlet", use_cutlet_inv );
  cmn.AddSubscriber( "use_cutlet", use_cutlet_end, private.room_objname );
  cmn.AddSubscriber( "use_cutlet_inv", use_cutlet_inv, private.room_objname );
  cmn.AddSubscriber( "use_cutlet_beg", use_cutlet_beg, private.room_objname );
  cmn.AddSubscriber( "use_cutlet_end", use_cutlet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_marksamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_marksamulet" ] =
  {
    type = "use",
    use_obj = "inv_marksamulet",
    use_place = "obj_mailcargo_use_marksamulet",
    room = private.room_objname,
    zz = "zz_mailcargo",
    zz_gate = "gzz_waitinghall_mailcargo"
  };
  -----------------------------------------------
  local use_marksamulet_inv = function ()

    int.InventoryItemRemove( "inv_marksamulet" );

  end;
  local use_marksamulet_beg = function ()

    ObjDelete( "obj_mailcargo_use_marksamulet" );

  end;
  local use_marksamulet_end = function ()

    ObjDelete( "obj_mailcargo_box_close" );
    ObjDelete( "anm_mailcargo_opnbox" );
    ObjSet( "obj_mailcargo_box_open",       { alp = 1, input = true } );
    ObjSet( "gfx_mailcargo_knittingneedle", { active = true } );
    ObjSet( "gfx_mailcargo_torch",          { active = true } );
    ObjSet( "spr_waitinghall_mailcargo_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_marksamulet", use_marksamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_marksamulet", use_marksamulet_inv );
  cmn.AddSubscriber( "use_marksamulet", use_marksamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_marksamulet_inv", use_marksamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_marksamulet_beg", use_marksamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_marksamulet_end", use_marksamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_handle3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_handle3" ] =
  {
    type = "use",
    use_obj = "inv_handle3",
    use_place = "obj_mailcargo_use_handle",
    room = private.room_objname,
    zz = "zz_mailcargo",
    zz_gate = "gzz_waitinghall_mailcargo"
  };
  -----------------------------------------------
  local use_handle3_inv = function ()

    int.InventoryItemRemove( "inv_handle3" );

  end;
  local use_handle3_beg = function ()

    ObjDelete( "obj_mailcargo_use_handle" );

  end;
  local use_handle3_end = function ()

    ObjSet( "spr_mailcargo_spade", { input = true, alp = 1 } );
    ObjSet( "spr_mailcargo_spade_handle", { alp = 1 } );
    ObjSet( "gfx_mailcargo_spade", { active = true } );
    ObjSet( "spr_waitinghall_mailcargo_spade_handle", { alp = 1 } );
    --ObjSet( "obj_mailcargo_spade1", { pos_x = 279, pos_y = 77 } );
    ObjSet( "spr_mailcargo_spade_shadow", { alp = 1 } ); 

    ObjDelete( "anm_mailcargo_spade" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_handle3", use_handle3_beg, private.room_objname );
  cmn.AddSubscriber( "use_handle3", use_handle3_inv );
  cmn.AddSubscriber( "use_handle3", use_handle3_end, private.room_objname );
  cmn.AddSubscriber( "use_handle3_inv", use_handle3_inv, private.room_objname );
  cmn.AddSubscriber( "use_handle3_beg", use_handle3_beg, private.room_objname );
  cmn.AddSubscriber( "use_handle3_end", use_handle3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cartwheel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cartwheel" ] =
  {
    type = "use",
    use_obj = "inv_cartwheel",
    use_place = "obj_cart_use_cartwheel",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_waitinghall_cart"
  };
  -----------------------------------------------
  local use_cartwheel_inv = function ()

    int.InventoryItemRemove( "inv_cartwheel" );

  end;
  local use_cartwheel_beg = function ()

    ObjDelete( "obj_cart_use_cartwheel" );

  end;
  local use_cartwheel_end = function ()

    ObjDelete( "spr_cart_reflex_1" );
    ObjSet( "obj_cart_cart",              { pos_y = -30 } );
    ObjSet( "vid_cart_move_cart",        { alp = 1 } );
    ObjSet( "spr_cart_reflex_2",          { alp = 1 } );
    ObjSet( "spr_cart_cart_wheel_shadow", { alp = 1 } );
    ObjSet( "obj_cart_use_screw3",        { input = true } );
    ObjSet( "spr_waitinghall_cart2",      { alp = 1 } );
    ObjDelete( "spr_waitinghall_cart1" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_cartwheel", use_cartwheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_cartwheel", use_cartwheel_inv );
  cmn.AddSubscriber( "use_cartwheel", use_cartwheel_end, private.room_objname );
  cmn.AddSubscriber( "use_cartwheel_inv", use_cartwheel_inv, private.room_objname );
  cmn.AddSubscriber( "use_cartwheel_beg", use_cartwheel_beg, private.room_objname );
  cmn.AddSubscriber( "use_cartwheel_end", use_cartwheel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screw3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screw3" ] =
  {
    type = "use",
    use_obj = "inv_screw3",
    use_place = "obj_cart_use_screw3",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_waitinghall_cart"
  };
  -----------------------------------------------
  local use_screw3_inv = function ()

    int.InventoryItemRemove( "inv_screw3" );

  end;
  local use_screw3_beg = function ()

    ObjDelete( "obj_cart_use_screw3" );

  end;
  local use_screw3_end = function ()

    ObjSet( "obj_cart_use_screwdriver3", { input = true } );
    ObjSet( "vid_cart_cart_screwdrive",  { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_screw3", use_screw3_beg, private.room_objname );
  cmn.AddSubscriber( "use_screw3", use_screw3_inv );
  cmn.AddSubscriber( "use_screw3", use_screw3_end, private.room_objname );
  cmn.AddSubscriber( "use_screw3_inv", use_screw3_inv, private.room_objname );
  cmn.AddSubscriber( "use_screw3_beg", use_screw3_beg, private.room_objname );
  cmn.AddSubscriber( "use_screw3_end", use_screw3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screwdriver3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriver3" ] =
  {
    type = "use",
    use_obj = "inv_screwdriver3",
    use_place = "obj_cart_use_screwdriver3",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_waitinghall_cart"
  };
  -----------------------------------------------
  local use_screwdriver3_inv = function ()

    int.InventoryItemRemove( "inv_screwdriver3" );

  end;
  local use_screwdriver3_beg = function ()

    ObjDelete( "obj_cart_use_screwdriver3" );

  end;
  local use_screwdriver3_end = function ()

    ObjSet( "obj_cart_clk_cart", { input = true } );
    ObjDelete( "vid_cart_cart_screwdrive" );
    ObjSet( "spr_cart_cart_screw3", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_screwdriver3", use_screwdriver3_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver3", use_screwdriver3_inv );
  cmn.AddSubscriber( "use_screwdriver3", use_screwdriver3_end, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver3_inv", use_screwdriver3_inv, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver3_beg", use_screwdriver3_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver3_end", use_screwdriver3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_glassshard () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_glassshard" ] =
  {
    type = "use",
    use_obj = "inv_glassshard",
    use_place = "obj_hallsecurity_use_glassshard",
    room = private.room_objname,
    zz = "zz_hallsecurity",
    zz_gate = "gzz_waitinghall_hallsecurity"
  };
  -----------------------------------------------
  local use_glassshard_inv = function ()

    int.InventoryItemRemove( "inv_glassshard" );

  end;
  local use_glassshard_beg = function ()

    ObjDelete( "obj_hallsecurity_use_glassshard" );

  end;
  local use_glassshard_end = function ()

    ObjSet( "obj_hallsecurity_clk_securitybag", { input = true } );
    ObjDelete( "anm_hallsecurity_glassshard" );
    ObjDelete( "anm_hallsecurity_bag_click" );
    ObjSet( "spr_hallsecurity_bag_thread_2", { alp = 1 } );    

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_glassshard", use_glassshard_beg, private.room_objname );
  cmn.AddSubscriber( "use_glassshard", use_glassshard_inv );
  cmn.AddSubscriber( "use_glassshard", use_glassshard_end, private.room_objname );
  cmn.AddSubscriber( "use_glassshard_inv", use_glassshard_inv, private.room_objname );
  cmn.AddSubscriber( "use_glassshard_beg", use_glassshard_beg, private.room_objname );
  cmn.AddSubscriber( "use_glassshard_end", use_glassshard_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_staramulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_staramulet" ] =
  {
    type = "use",
    use_obj = "inv_staramulet",
    use_place = "obj_hallsecurity_use_staramulet",
    room = private.room_objname,
    zz = "zz_hallsecurity",
    zz_gate = "gzz_waitinghall_hallsecurity"
  };
  -----------------------------------------------
  local use_staramulet_inv = function ()

    int.InventoryItemRemove( "inv_staramulet" );

  end;
  local use_staramulet_beg = function ()

    ObjDelete( "obj_hallsecurity_use_staramulet" );

  end;
  local use_staramulet_end = function ()

    ObjSet( "obj_hallsecurity_wallet_open", { alp = 1 } );
    ObjSet( "spr_hallsecurity_pattern_2", { input = true } );
    ObjSet( "gfx_hallsecurity_pattern_2", { active = true } );
    ObjDelete( "obj_hallsecurity_wallet_close" );
    ObjDelete( "spr_waitinghall_hallsecurity_wallet_closed" );
    ObjSet( "spr_waitinghall_hallsecurity_wallet_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_staramulet", use_staramulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_staramulet", use_staramulet_inv );
  cmn.AddSubscriber( "use_staramulet", use_staramulet_end, private.room_objname );
  cmn.AddSubscriber( "use_staramulet_inv", use_staramulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_staramulet_beg", use_staramulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_staramulet_end", use_staramulet_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_cart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_cart" ] =
  {
    type = "click",
    clk_obj = "obj_cart_clk_cart",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_waitinghall_cart"
  };
  -----------------------------------------------
  local clk_cart_beg = function ()

    ObjDelete( "obj_cart_clk_cart" );

  end;
  local clk_cart_end = function ()
    
    ObjSet( "obj_cart_cart", { pos_x = 200 } );
    ObjSet( "grm_waitinghall_aircompaniesstand", { active = true, input = true, visible = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_waitinghall_aircompaniesstand_focus");
    end;    
    ObjDelete( "gzz_waitinghall_cart" );
    ObjDelete( "spr_waitinghall_cart2" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_cart", clk_cart_beg, private.room_objname );
  cmn.AddSubscriber( "clk_cart", clk_cart_end, private.room_objname );
  cmn.AddSubscriber( "clk_cart_beg", clk_cart_beg, private.room_objname );
  cmn.AddSubscriber( "clk_cart_end", clk_cart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_burger_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_burger_1" ] =
  {
    type = "click",
    clk_obj = "obj_foodbooth_clk_burger_1",
    room = private.room_objname,
    zz = "zz_foodbooth",
    zz_gate = "gzz_waitinghall_foodbooth"
  };
  -----------------------------------------------
  local clk_burger_1_beg = function ()

    ObjDelete( "obj_foodbooth_clk_burger_1" );

  end;
  local clk_burger_1_end = function ()
    
    ObjSet( "obj_foodbooth_burger_open",  { alp = 1 } );
    ObjSet( "obj_foodbooth_clk_burger_2", { input = true } );
    ObjSet( "spr_waitinghall_foodbooth_burger_open",  { alp = 1 } );
    ObjDelete( "spr_foodbooth_burger_close" );
    ObjDelete( "spr_waitinghall_foodbooth_burger_closed" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_burger_1", clk_burger_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_burger_1", clk_burger_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_burger_1_beg", clk_burger_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_burger_1_end", clk_burger_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_burger_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_burger_2" ] =
  {
    type = "click",
    clk_obj = "obj_foodbooth_clk_burger_2",
    room = private.room_objname,
    zz = "zz_foodbooth",
    zz_gate = "gzz_waitinghall_foodbooth"
  };
  -----------------------------------------------
  local clk_burger_2_beg = function ()

    ObjDelete( "obj_foodbooth_clk_burger_2" );

  end;
  local clk_burger_2_end = function ()
    
    ObjSet( "spr_foodbooth_burger_open",  { alp = 1 } );
    ObjSet( "spr_foodbooth_cutlet",       { input = true } );
    ObjSet( "gfx_foodbooth_cutlet",       { active = true } );
    ObjDelete( "spr_foodbooth_burger_up" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_burger_2", clk_burger_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_burger_2", clk_burger_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_burger_2_beg", clk_burger_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_burger_2_end", clk_burger_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_securitybag () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_securitybag" ] =
  {
    type = "click",
    clk_obj = "obj_hallsecurity_clk_securitybag",
    room = private.room_objname,
    zz = "zz_hallsecurity",
    zz_gate = "gzz_waitinghall_hallsecurity"
  };
  -----------------------------------------------
  local clk_securitybag_beg = function ()

    ObjDelete( "obj_hallsecurity_clk_securitybag" );

  end;
  local clk_securitybag_end = function ()

    ObjSet( "obj_hallsecurity_bag_open",      { alp = 1 } );
    ObjSet( "spr_hallsecurity_bag_thread_2",  { alp = 0 } );
    ObjSet( "spr_hallsecurity_marksamulet_1", { input = true } );
    ObjSet( "gfx_hallsecurity_marksamulet_1", { active = true } );
    ObjSet( "spr_waitinghall_hallsecurity_bag_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_securitybag", clk_securitybag_beg, private.room_objname );
  cmn.AddSubscriber( "clk_securitybag", clk_securitybag_end, private.room_objname );
  cmn.AddSubscriber( "clk_securitybag_beg", clk_securitybag_beg, private.room_objname );
  cmn.AddSubscriber( "clk_securitybag_end", clk_securitybag_end, private.room_objname );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
function private.get_cutlet ()

  cmn.SetEventDone( "get_cutlet" );
  cmn.CallEventHandler( "get_cutlet" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_cartwheel ()

  cmn.SetEventDone( "get_cartwheel" );
  cmn.CallEventHandler( "get_cartwheel" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_knittingneedle ()

  cmn.SetEventDone( "get_knittingneedle" );
  cmn.CallEventHandler( "get_knittingneedle" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_torch ()

  cmn.SetEventDone( "get_torch" );
  cmn.CallEventHandler( "get_torch" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_spade ()

  cmn.SetEventDone( "get_spade" );
  cmn.CallEventHandler( "get_spade" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_collect2_3_4" ) ) then
      
    cmn.CloseSubRoom();
      
  end;
    
end;
-------------------------------------------------
function private.get_screwdriver3 ()

  cmn.SetEventDone( "get_screwdriver3" );
  cmn.CallEventHandler( "get_screwdriver3" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_marksamulet_1 ()

  cmn.SetEventDone( "get_marksamulet_1" );
  cmn.CallEventHandler( "get_marksamulet_1_inv" );
  cmn.CallEventHandler( "get_marksamulet_1_beg" );
  cmn.GetObjectSfx();

  int.Lock( true );

  local func_end = function ()

    cmn.CallEventHandler( "get_marksamulet_1_end" );
    int.Lock( false );

  end;
  
  ObjAnimate( "obj_hallsecurity_bag_open", "alp", 0, 0, "",
  { 
    0.0, 3, 1.0, 
    0.3, 3, 0.0
  } );

  ObjAnimate( "spr_hallsecurity_bag_thread_2", "alp", 0, 0, func_end,
  { 
    0.0, 3, 0.0, 
    0.3, 3, 1.0
  } );

end;
-------------------------------------------------
function private.get_securitybadge ()

  cmn.SetEventDone( "get_securitybadge" );
  cmn.CallEventHandler( "get_securitybadge" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_pattern_2 ()

  cmn.SetEventDone( "get_pattern_2" );
  cmn.CallEventHandler( "get_pattern_2" );
  cmn.CloseSubRoom();
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_threedollar_1 ()

  cmn.SetEventDone( "get_threedollar_1" );
  cmn.CallEventHandler( "get_threedollar_1" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_threedollar_2 ()

  cmn.SetEventDone( "get_threedollar_2" );
  cmn.CallEventHandler( "get_threedollar_2" );
  
  cmn.GetObjectSfx();

end;
---------------------------------------------------------------------------------
function private.get_collect2_3_4()

  int.AddCollectibles2( "spr_mailcargo_collect2_3_4" );
  ObjSet( "spr_mailcargo_collect_3_4_shadow", { alp = 0 } );

  if ( cmn.IsEventDone( "get_spade" ) ) then
      
    cmn.CloseSubRoom();
      
  end;

end;
--*********************************************************************************************************************
-------------------------------------------------
function public.use_threedollar ()

  local item = "inv_threedollar";

  if ( cmn.ApplyObj( item, "gzz_waitinghall_foodbooth", false ) ) and
     ( cmn.IsEventDone( "get_threedollar_1" ) ) and
     ( cmn.IsEventDone( "get_threedollar_2" ) ) and
     ( cmn.IsEventDone( "get_threedollar_3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_foodbooth" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_foodbooth_use_threedollar", true ) ) and
         ( cmn.IsEventDone( "get_threedollar_1" ) ) and
         ( cmn.IsEventDone( "get_threedollar_2" ) ) and
         ( cmn.IsEventDone( "get_threedollar_3" ) ) then

    cmn.CallEventHandler( "use_threedollar_inv" );
    cmn.CallEventHandler( "use_threedollar_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_threedollar" );
      cmn.CallEventHandler( "use_threedollar_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_insert_dollars" );

    ObjSet( "obj_foodbooth_booth_close", { alp = 0 } );
    AnimPlay( "anm_foodbooth_threedollar", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_boothbutton_1 ()

  local item = "inv_boothbutton_1";

  if ( cmn.ApplyObj( item, "gzz_waitinghall_foodbooth", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_foodbooth" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_foodbooth_use_boothbutton_1", true ) ) then

    cmn.CallEventHandler( "use_boothbutton_1_inv" );
    cmn.CallEventHandler( "use_boothbutton_1_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_boothbutton_1" );
      cmn.CallEventHandler( "use_boothbutton_1_end" );
      int.Lock( false );

      if cmn.IsEventDone( "use_boothbutton_2" ) then

        cmn.CloseSubRoom();
        cmn.GotoRoom( "mg_cashtill" );

      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_insert_button" );  
    ObjAnimate( "spr_foodbooth_boothbutton_1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_boothbutton_2 ()

  local item = "inv_boothbutton_2";

  if ( cmn.ApplyObj( item, "gzz_waitinghall_foodbooth", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_foodbooth" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_foodbooth_use_boothbutton_2", true ) ) then

    cmn.CallEventHandler( "use_boothbutton_2_inv" );
    cmn.CallEventHandler( "use_boothbutton_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_boothbutton_2" );
      cmn.CallEventHandler( "use_boothbutton_2_end" );
      int.Lock( false );

      if cmn.IsEventDone( "use_boothbutton_1" ) then
        cmn.CloseSubRoom();
        cmn.GotoRoom( "mg_cashtill" );
      end;

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_insert_button" );  
    ObjAnimate( "spr_foodbooth_boothbutton_2", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_cutlet ()

  local item = "inv_cutlet";

  if ( cmn.ApplyObj( item, "gzz_waitinghall_mailcargo", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_mailcargo" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_mailcargo_use_cutlet", true ) ) then

    cmn.CallEventHandler( "use_cutlet_inv" );
    cmn.CallEventHandler( "use_cutlet_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_cutlet" );
      cmn.CallEventHandler( "use_cutlet_end" );
      cmn.PlayAudio( "env", "audio/level3/env/aud_dog_env", 1 );
      int.Lock( false );

    end;

    cmn.StopAudio( "env", "audio/level3/env/aud_dog_env", 1 ); 
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_dog_eat" );
    ObjSet( "anm_mailcargo_dog_static_wheel", { alp = 0 } );
    ObjSet( "anm_mailcargo_dog_cutlet", { alp = 1 } );
    AnimPlay( "anm_mailcargo_dog_cutlet", "DoAnim", func_end ); 
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_marksamulet ()

  local item = "inv_marksamulet";

  if ( cmn.ApplyObj( item, "gzz_waitinghall_mailcargo", false ) ) and
     ( cmn.IsEventDone( "get_marksamulet_1" ) ) and
     ( cmn.IsEventDone( "get_marksamulet_2" ) ) and
     ( cmn.IsEventDone( "get_marksamulet_3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_mailcargo" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_mailcargo_use_marksamulet", true ) ) and
         ( cmn.IsEventDone( "get_marksamulet_1" ) ) and
         ( cmn.IsEventDone( "get_marksamulet_2" ) ) and
         ( cmn.IsEventDone( "get_marksamulet_3" ) ) then

    cmn.CallEventHandler( "use_marksamulet_inv" );
    cmn.CallEventHandler( "use_marksamulet_beg" );
    int.Lock( true );

    local func_end = function ()

      local func_end = function ()

        cmn.SetEventDone( "use_marksamulet" );
        cmn.CallEventHandler( "use_marksamulet_end" );
        int.Lock( false );

      end;
      
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_wood_apply" ); 
      AnimPlay( "anm_mailcargo_opnbox", "DoAnim", func_end );
 
    end;

    ObjAnimate( "spr_mailcargo_box_close", "alp", 0, 0, "", 
    { 
      0.0, 0, 1,
      0.3, 0, 0,
    } );
    ObjAnimate( "anm_mailcargo_opnbox", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.3, 0, 1,
      0.6, 0, 1,
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_handle3 ()

  local item = "inv_handle3";

  if ( cmn.ApplyObj( item, "gzz_waitinghall_mailcargo", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_mailcargo" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_mailcargo_use_handle", true ) ) then

    cmn.CallEventHandler( "use_handle3_inv" );
    cmn.CallEventHandler( "use_handle3_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_handle3" );
      cmn.CallEventHandler( "use_handle3_end" );
      ObjSet( "obj_mailcargo_spade1", { pos_x = 130, pos_y = 290 } );
      --ObjSet( "spr_mailcargo_spade_shadow", { alp = 1 } ); 
      --ObjSet( "spr_mailcargo_spade", { alp = 1 } );
      --ObjSet( "spr_mailcargo_spade_handle", { alp = 1 } );
      private.get_spade ();
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_assemble_shovel" ); 
    ObjSet( "spr_mailcargo_spade_shadow", { alp = 0 } ); 
    ObjSet( "spr_mailcargo_spade", { alp = 0 } );
    ObjSet( "spr_mailcargo_spade_over", { alp = 0 } );
    ObjSet( "anm_mailcargo_spade", { alp = 1 } );    
    AnimPlay( "anm_mailcargo_spade", "DoAnim", func_end ) 

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_cartwheel ()

  local item = "inv_cartwheel";

  if ( cmn.ApplyObj( item, "gzz_waitinghall_cart", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cart" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cart_use_cartwheel", true ) ) then

    cmn.CallEventHandler( "use_cartwheel_inv" );
    cmn.CallEventHandler( "use_cartwheel_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_cartwheel" );
      cmn.CallEventHandler( "use_cartwheel_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_apply_wheel" );

    ObjAnimate( "obj_cart_cart", "pos_y", 0, 0, "",
    { 
      0.0, 0,  0,
      0.3, 0, -30
    } );

    ObjAnimate( "spr_cart_reflex_1", "alp", 0, 0, "",
    { 
      0.0, 0, 1,
      0.3, 0, 0
    } );

    ObjAnimate( "vid_cart_move_cart", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0,
      0.3, 0, 0,
      0.6, 0, 1
    } );

    ObjAnimate( "spr_cart_cart_wheel_shadow", "alp", 0, 0, "",
    { 
      0.0, 0, 0,
      0.3, 0, 0,
      0.6, 0, 1
    } );

    ObjAnimate( "spr_cart_reflex_2", "alp", 0, 0, "",
    { 
      0.0, 0, 0,
      0.3, 0, 1,
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_screw3 ()

  local item = "inv_screw3";

  if ( cmn.ApplyObj( item, "gzz_waitinghall_cart", false ) ) and 
     ( cmn.IsEventDone( "use_cartwheel" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cart" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cart_use_screw3", true ) ) and 
         ( cmn.IsEventDone( "use_cartwheel" ) ) then

    cmn.CallEventHandler( "use_screw3_inv" );
    cmn.CallEventHandler( "use_screw3_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_screw3" );
      cmn.CallEventHandler( "use_screw3_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_apply_bolt" );  

    ObjAnimate( "vid_cart_cart_screwdrive", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_screwdriver3 ()

  local item = "inv_screwdriver3";

  if ( cmn.ApplyObj( item, "gzz_waitinghall_cart", false ) ) and 
     ( cmn.IsEventDone( "use_screw3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cart" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cart_use_screwdriver3", true ) ) and 
         ( cmn.IsEventDone( "use_screw3" ) ) then

    cmn.CallEventHandler( "use_screwdriver3_inv" );
    cmn.CallEventHandler( "use_screwdriver3_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_screwdriver3" );
      cmn.CallEventHandler( "use_screwdriver3_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_screwdriver" );  

    VidPlay( "vid_cart_cart_screwdrive", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_cart ()

  cmn.CallEventHandler( "clk_cart_beg" );
  int.Lock( true );

  local func_end = function ()

    cmn.SetEventDone( "clk_cart" );
    cmn.CallEventHandler( "clk_cart_end" );
    int.Lock( false );
    cmn.CloseSubRoom();

  end;

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_move_stretcher" );  
  ObjAnimate( "obj_cart_cart", "pos_x", 0, 0, func_end,
  { 
    0.0, 3, 0.0, 
    0.1, 3, 0.0, 
    2.2, 3, 200
  } );
  VidPlay( "vid_cart_move_cart", "" );
  
end;
-------------------------------------------------
-------------------------------------------------
function private.clk_burger_1 ()

  cmn.CallEventHandler( "clk_burger_1_beg" );
  int.Lock( true );

  local func_end = function ()

    cmn.SetEventDone( "clk_burger_1" );
    cmn.CallEventHandler( "clk_burger_1_end" );
    int.Lock( false );

  end;

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_humburger_open_paper" );  
  ObjAnimate( "spr_foodbooth_burger_close", "alp", 0, 0, "",
  { 
    0.0, 3, 1.0, 
    0.3, 3, 0.0
  } );

  ObjAnimate( "obj_foodbooth_burger_open", "alp", 0, 0, func_end,
  { 
    0.0, 3, 0.0, 
    0.3, 3, 1.0
  } );

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_burger_2 ()

  cmn.CallEventHandler( "clk_burger_2_beg" );
  int.Lock( true );

  local func_end = function ()

    cmn.SetEventDone( "clk_burger_2" );
    cmn.CallEventHandler( "clk_burger_2_end" );
    int.Lock( false );

  end;

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_open_humburger" );  
  ObjAnimate( "spr_foodbooth_burger_up", "alp", 0, 0, "",
  { 
    0.0, 3, 1.0, 
    0.3, 3, 0.0
  } );

  ObjAnimate( "spr_foodbooth_burger_open", "alp", 0, 0, func_end,
  { 
    0.0, 3, 0.0, 
    0.3, 3, 1.0
  } );

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_securitybag ()

  cmn.CallEventHandler( "clk_securitybag_beg" );
  int.Lock( true );

  local func_end = function ()

    cmn.SetEventDone( "clk_securitybag" );
    cmn.CallEventHandler( "clk_securitybag_end" );
    int.Lock( false );

  end;

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_open_police_bag" );  
  ObjAnimate( "obj_hallsecurity_bag_open", "alp", 0, 0, "",
  { 
    0.0, 3, 0.0, 
    0.3, 3, 1.0
  } );

  ObjAnimate( "spr_hallsecurity_bag_thread_2", "alp", 0, 0, func_end,
  { 
    0.0, 3, 1.0, 
    0.3, 3, 0.0
  } );

end;
-------------------------------------------------
-------------------------------------------------
function public.use_glassshard ()

  local item = "inv_glassshard";

  if ( cmn.ApplyObj( item, "gzz_waitinghall_hallsecurity", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_hallsecurity" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_hallsecurity_use_glassshard", true ) ) then

    cmn.CallEventHandler( "use_glassshard_inv" );
    cmn.CallEventHandler( "use_glassshard_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_glassshard" );
      cmn.CallEventHandler( "use_glassshard_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_cut_police_bag" );  

    ObjSet( "anm_hallsecurity_bag_click", { alp = 0 } );
    ObjSet( "anm_hallsecurity_glassshard", { alp = 1 } );

    AnimPlay( "anm_hallsecurity_glassshard", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_staramulet ()

  local item = "inv_staramulet";

  if ( cmn.ApplyObj( item, "gzz_waitinghall_hallsecurity", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_hallsecurity" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_hallsecurity_use_staramulet", true ) ) then

    cmn.CallEventHandler( "use_staramulet_inv" );
    cmn.CallEventHandler( "use_staramulet_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_staramulet" );
      cmn.CallEventHandler( "use_staramulet_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_apply_star" );  
    ObjAnimate( "spr_hallsecurity_staramulet", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "obj_hallsecurity_wallet_open", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.5, 0, 0.0, 
      0.8, 0, 1.0
    } );

    ObjAnimate( "obj_hallsecurity_wallet_close", "alp", 0, 0, func_end,
    { 
      0.0, 0, 1.0, 
      0.5, 0, 1.0, 
      0.8, 0, 0.0
    } );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopAllEnv( "audio/level3/env/aud_airport_env", true );
  cmn.PlayAudio( "env", "audio/level3/env/aud_airport_env", 1 );
  
  if ( cmn.IsEventDone( "get_handle3" ) and 
       not cmn.IsEventDone( "see_scare_3_1" ) ) then

    ObjSet( "rm_waitinghall", { color_r = 0, color_g = 0, color_b = 0 } );

  end;

end;
--*********************************************************************************************************************
function private.opn_waitinghall ()

  if not ( cmn.IsEventDone( "opn_waitinghall" ) ) then

    local func_end = function ()

      cmn.SetEventDone( "opn_waitinghall" );

      int.Lock( false );
      --cmn.ShowBbt( "bbt_yard_first_entry" );
      cmn.StopAudio( "voc", "audio/level3/voc/aud_waitinghall_survey_1_voc" );
      cmn.StopAudio( "sfx", "audio/level3/sfx/aud_waitinghall_survey_1" );
      cmn.PlayAudio( "mus", "audio/aud_moov_mus" );
      
    end;
    
    int.Lock( true );
    common_impl.PlayDialogVideo( "vid_waitinghall_survey_1", func_end ); 
    cmn.PlayAudio( "voc", "audio/level3/voc/aud_waitinghall_survey_1_voc" );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_waitinghall_survey_1" );
    
  end;

  if ( cmn.IsEventDone( "get_handle3" ) and 
       not cmn.IsEventDone( "see_scare_3_1" ) ) then

    private.see_scare_3_1 ();

  end;


end;
--*********************************************************************************************************************
function private.see_scare_3_1 ()

  local func_end = function ()

    int.Lock( false );
    cmn.StopAudio( "sfx", "audio/level3/sfx/aud_waitinghall_scare_3_1_sfx" ); 
    cmn.ShowBbt( "bbt_waitinghall_after_scare" );
    ObjSet( "rm_waitinghall", { color_r = 1, color_g = 1, color_b = 1 } );
    cmn.SetEventDone( "see_scare_3_1" );

    cmn.AddPageDiary( 16 );
    
    cmn.PlayAudio( "mus", "audio/aud_very_ugly_mus" );

  end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_waitinghall_scare_3_1", func_end );  
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_waitinghall_scare_3_1_sfx" ); 

end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_waitinghall();

end;
--*********************************************************************************************************************
function public.Task ()
  
  int.AddedTaskMap( private.room_objname, "get_cutlet",                                  { "clk_burger_2" } );
  int.AddedTaskMap( private.room_objname, "get_cartwheel",                               { "use_cutlet" } );
  int.AddedTaskMap( private.room_objname, "get_knittingneedle",                          { "use_marksamulet" } );
  int.AddedTaskMap( private.room_objname, "get_torch",                                   { "use_marksamulet" } );
  int.AddedTaskMap( private.room_objname, "get_spade",                                   { "use_handle3" } );
  int.AddedTaskMap( private.room_objname, "get_screwdriver3" );
  int.AddedTaskMap( private.room_objname, "get_marksamulet_1",                           { "clk_securitybag" } );
  int.AddedTaskMap( private.room_objname, "get_securitybadge" );
  int.AddedTaskMap( private.room_objname, "get_pattern_2",                               { "use_staramulet" } );
  int.AddedTaskMap( private.room_objname, "get_threedollar_1" );
  int.AddedTaskMap( private.room_objname, "get_threedollar_2" );
  int.AddedTaskMap( private.room_objname, "get_twister",                                 { "clk_cashtill" } );
    
  int.AddedTaskMap( private.room_objname, "use_threedollar",                             { "get_threedollar_1", "get_threedollar_2", "get_threedollar_3" } );
  int.AddedTaskMap( private.room_objname, "use_boothbutton_1",                           { "get_boothbutton_1" } );
  int.AddedTaskMap( private.room_objname, "use_boothbutton_2",                           { "get_boothbutton_2" } );
  int.AddedTaskMap( private.room_objname, "use_cutlet",                                  { "get_cutlet" } );
  int.AddedTaskMap( private.room_objname, "use_marksamulet",                             { "get_marksamulet_1", "get_marksamulet_2","get_marksamulet_3" } );
  int.AddedTaskMap( private.room_objname, "use_handle3",                                 { "get_handle3" } );
  int.AddedTaskMap( private.room_objname, "use_cartwheel",                               { "get_cartwheel" } );
  int.AddedTaskMap( private.room_objname, "use_screw3",                                  { "use_cartwheel", "get_screw3" } );
  int.AddedTaskMap( private.room_objname, "use_screwdriver3",                            { "get_screwdriver3", "use_screw3" } );
  int.AddedTaskMap( private.room_objname, "use_glassshard",                              { "get_glassshard" } );
  int.AddedTaskMap( private.room_objname, "use_staramulet",                              { "get_staramulet" } );
  
  int.AddedTaskMap( private.room_objname, "clk_cart",                                    { "use_screwdriver3" } );
  int.AddedTaskMap( private.room_objname, "clk_burger_1",                                { "use_threedollar" } );
  int.AddedTaskMap( private.room_objname, "clk_burger_2",                                { "clk_burger_1" } );
  int.AddedTaskMap( private.room_objname, "clk_securitybag",                             { "use_glassshard" } );
  int.AddedTaskMap( private.room_objname, "clk_cashtill",                                { "win_cashtill" } );
  
  int.AddedTaskMap( private.room_objname, "win_cashtill",                                { "use_boothbutton_1", "use_boothbutton_2" } );
  
  int.AddedTaskMap( private.room_objname, "opn_aircompaniesstand",                       { "clk_cart" } );
  int.AddedTaskMap( private.room_objname, "opn_window" );


  
end;  
--*********************************************************************************************************************
function private.InitSubroom ()
  
  subroom.Define( "zz_mailcargo" );
  -------------------------------------------------
  function zz_mailcargo.PreOpen ()
    
    if not cmn.IsEventDone( "use_cutlet" ) then
      
      ObjSet( "anm_mailcargo_dog_static_wheel", { playing = 0 } );
      ObjSet( "anm_mailcargo_dog_static_wheel", { playing = 1 } );
      
    else 
      
      ObjSet( "anm_mailcargo_dog_cutlet_static", { playing = 0 } );
      ObjSet( "anm_mailcargo_dog_cutlet_static", { playing = 1 } );
      
    end;

    cmn.PlayAudio( "env", "audio/level3/env/aud_dog_env", 1 );

  end;
  -------------------------------------------------
  function zz_mailcargo.Close ()

    cmn.StopAudio( "env", "audio/level3/env/aud_dog_env", 1 );

  end;
  -------------------------------------------------
  
end;
--*********************************************************************************************************************
function private.InitAnims ()

  ObjAnimate( "spr_cart_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_cart_cart_tag", "ang", 1, 0, "", 
  {
    0.0, 3, -0.1,
    1.8, 3,  0.1,
    3.6, 3, -0.1,
  } );

  ObjAnimate( "spr_mailcargo_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_mailcargo_hotspot", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    0.7, 3, 1.0,
    3.0, 3, 0.3,
  } );

  ObjAnimate( "spr_foodbooth_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_foodbooth_price_light", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    1.0, 3, 0.3,
    2.0, 3, 1.0,
  } );

  ObjAnimate( "spr_foodbooth_acceptor_light", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    1.0, 3, 0.3,
    2.0, 3, 1.0,
  } );

  ObjAnimate( "spr_hallsecurity_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_hallsecurity_man", "alp", 1, 0, "", 
  { 
    0.0, 3, 1.0,
    0.3, 3, 1.0,
    1.3, 3, 0.6,
    2.3, 3, 1.0,
    3.3, 3, 0.6,
    4.3, 3, 1.0,
    5.3, 3, 0.6,
    6.3, 3, 1.0,
    7.3, 3, 0.6,
    8.3, 3, 1.0,
    8.5, 3, 0.6,
    8.7, 3, 1.0,
    8.9, 3, 0.6,
    9.1, 3, 1.0,
  } );

  ObjAnimate( "obj_waitinghall_people", "alp", 1, 0, "", 
  { 
    0.0, 3, 1.0,
    0.3, 3, 1.0,
    1.3, 3, 0.6,
    2.3, 3, 1.0,
    3.3, 3, 0.6,
    4.3, 3, 1.0,
    5.3, 3, 0.6,
    6.3, 3, 1.0,
    7.3, 3, 0.6,
    8.3, 3, 1.0,
    8.5, 3, 0.6,
    8.7, 3, 1.0,
    8.9, 3, 0.6,
    9.1, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
function private.MailcargoBoxClick ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_mailcargo_use_marksamulet" );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_touch_box" );
  ObjAnimate( "spr_mailcargo_box_close", "pos_y", 0, 0, func_end, 
  {
    0.0, 3, 122,
    0.1, 3, 123,
    0.3, 3, 121,
    0.5, 3, 123,
    0.7, 3, 121,
    0.8, 3, 122,
  } );

end;
--*********************************************************************************************************************
function private.MailcargoSpadeClick ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_mailcargo_use_handle" );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_shovel_touch" );
  ObjAnimate( "spr_mailcargo_spade", "pos_xy", 0, 0, func_end, 
  {
    0.0, 3,  0, 0,
    0.2, 3, -1, 1,
    0.4, 3,  0, 0,
    0.6, 3, -1, 1,
    0.8, 3,  0, 0,
  } );

  ObjAnimate( "spr_mailcargo_spade_shadow", "pos_xy", 0, 0, "", 
  {
    0.0, 3, 1, 2,
    0.2, 3, 0, 3,
    0.4, 3, 1, 2,
    0.6, 3, 0, 3,
    0.8, 3, 1, 2,
  } );

end;
--*********************************************************************************************************************
function private.FoodboothClick ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_foodbooth_use_threedollar" );

  end;

  ObjAnimate( "spr_foodbooth_booth_close", "pos_xy", 0, 0, func_end, 
  {
    0.0, 3, -144, 65,
    0.2, 3, -143, 66,
    0.4, 3, -144, 65,
    0.6, 3, -143, 66,
    0.8, 3, -144, 65,
  } );

end;
--*********************************************************************************************************************
function private.NapkinsClick ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_touch_leather_bag" );
  AnimPlay( "anm_foodbooth_napkins_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.BoothbuttonInit ()

  for b = 1, 8 do

    ObjSet( "spr_foodbooth_boothbutton_"..b,
    {
      event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      event_mdown  = function () private.BoothbuttonClick( b ); end,
    } );

  end;

end;
--*********************************************************************************************************************
function private.BoothbuttonClick ( idx )

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_button_click" );
  ObjAnimate( "spr_foodbooth_boothbutton_"..idx, "scale_xy", 0, 0, func_end, 
  {
    0.0, 3, 1.000, 1.000,
    0.3, 3, 0.95, 0.95,
    0.6, 3, 1.000, 1.000,
  } );

end;
--*********************************************************************************************************************
function private.CartClick ()

  int.Lock( true );

  local func_end = function ()

    if not cmn.IsEventDone( "use_cartwheel" ) then
      ObjSet( "anm_cart_cartclick1", { alp = 0 } );
      cmn.ShowBbt( "bbt_cart_use_cartwheel" );
    else
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_touch_stretcher_wheel" );
      cmn.ShowBbt( "bbt_cart_use_screw3" );

    end;

    ObjSet( "obj_cart_cart", { alp = 1 } );

    int.Lock( false );

  end;

  ObjSet( "obj_cart_cart", { alp = 0 } );

  if not cmn.IsEventDone( "use_cartwheel" ) then
    
    ObjSet( "anm_cart_cartclick1", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_bags_stretcher_touch" );
    AnimPlay( "anm_cart_cartclick1", "DoAnim", func_end );
    
  else
    
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_touch_stretcher_wheel" );
    func_end();
    
  end;

  if not cmn.IsEventDone( "get_threedollar_2" ) then

    ObjAnimate( "spr_cart_threedollar_2_shadow", "ang", 0, 0, "", 
    { 
      0.0, 0, 0,
      0.3, 0, -0.0336,
      0.3833, 0, 0,
    } );
    ObjAnimate( "spr_cart_threedollar_2", "ang", 0, 0, "", 
    { 
      0.0, 0, 0,
      0.3, 0, -0.0336,
      0.3833, 0, 0,
    } );
    ObjAnimate( "spr_cart_threedollar_2_shadow", "pos_y", 0, 0, "", 
    { 
      0.0, 0, -101,
      0.3, 0, -114,
      0.3833, 0, -101,
    } );
    ObjAnimate( "spr_cart_threedollar_2", "pos_y", 0, 0, "", 
    { 
      0.0, 0, -117,
      0.3, 0, -130,
      0.3833, 0, -117,
    } );

  end;

end;
--*********************************************************************************************************************
function private.ScrewdriverCartClick ()
  
  cmn.ShowBbt( "bbt_cart_use_screwdriver3" );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_touch_stretcher_wheel" );
  
end;
--*********************************************************************************************************************
function private.DogClick ()

  int.Lock( true );

  local func_end = function ()

    ObjSet( "anm_mailcargo_dog_click", { alp = 0 } );
    ObjSet( "anm_mailcargo_dog_static_wheel", { alp = 1 } );
    cmn.ShowBbt( "bbt_mailcargo_use_cutlet" );
    cmn.PlayAudio( "env", "audio/level3/env/aud_dog_env", 1 );
    int.Lock( false );

  end;
  
  cmn.StopAudio( "env", "audio/level3/env/aud_dog_env", 1 );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_dog_click" );
  ObjSet( "anm_mailcargo_dog_click", { alp = 1 } );
  ObjSet( "anm_mailcargo_dog_static_wheel", { alp = 0 } );
  AnimPlay( "anm_mailcargo_dog_click", "DoAnim", func_end ) 

end;
--*********************************************************************************************************************
function private.SecurityBagclick ()

  int.Lock( true );

  local func_end = function ()

    cmn.ShowBbt( "bbt_hallsecurity_use_glassshard" );
    int.Lock( false );

  end;

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_police_bag_touch" );
  AnimPlay( "anm_hallsecurity_bag_click", "DoAnim", func_end ) 

end;
--*********************************************************************************************************************