-- name=rm_window
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_window";

  ObjAttach( "zz_janitresstuff", "room_hub" );
  ObjAttach( "zz_bag",           "room_hub" );
  
  ObjMultiSet( {
    { "spr_janitresstuff_screw3",        { event_mdown = private.get_screw3 } },
    { "spr_janitresstuff_boothbutton_1", { event_mdown = private.get_boothbutton_1 } },
    { "spr_janitresstuff_bird_2",        { event_mdown = private.get_bird_2 } },
    { "spr_janitresstuff_bullet",        { event_mdown = private.get_bullet } },
    { "spr_janitresstuff_oil",           { event_mdown = private.get_oil } },
    { "spr_bag_threedollar_3",           { event_mdown = private.get_threedollar_3 } },
    { "spr_bag_pencil",                  { event_mdown = private.get_pencil } },
    { "spr_bag_diamond",                 { event_mdown = private.get_diamond } },
    { "obj_bag_clk_pocket",              { event_mdown = private.clk_bag_pocket } },
    { "spr_janitresstuff_marksamulet_3", { event_mdown = private.get_marksamulet_3 } },
    { "obj_bag_use_pliers3",             { event_mdown = private.BagDiamonClick } },
    { "obj_bag_use_bird",                { event_mdown = private.BagCloseClick } },
    { "obj_janitresstuff_use_toggle3",   { event_mdown = private.CaseClick } },
    { "obj_janitresstuff_use_twister",   { event_mdown = private.BoxClick } },
    { "spr_bag_collect2_3_2",            { event_mdown = private.get_collect2_3_2 } },
  } );   

  private.InitSubroom();
  private.InitAnims();
  private.JanitresstuffInit();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_window = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gzz_window_janitresstuff",
        "gzz_window_bag",
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_janitresstuff", 
        "zz_bag",
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_window", update_game_mode_window, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_screw3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_screw3" ] =
  {
    type = "get",
    get_obj = "spr_janitresstuff_screw3",
    room = private.room_objname,
    zz = "zz_janitresstuff",
    zz_gate = "gzz_window_janitresstuff"
  };
  -----------------------------------------------
  local get_screw3_inv = function ()

    int.InventoryItemAdd( "inv_screw3", "spr_janitresstuff_screw3" );

  end;
  local get_screw3_closezz = function ()

    ObjDelete( "gfx_janitresstuff_screw3" );
    ObjDelete( "spr_janitresstuff_screw3_shadow" );
    ObjDelete( "spr_window_janitresstuff_screw3" );

  end;

  cmn.AddSubscriber( "get_screw3", get_screw3_inv );
  cmn.AddSubscriber( "get_screw3", get_screw3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_boothbutton_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_boothbutton_1" ] =
  {
    type = "get",
    get_obj = "spr_janitresstuff_boothbutton_1",
    room = private.room_objname,
    zz = "zz_janitresstuff",
    zz_gate = "gzz_window_janitresstuff"
  };
  -----------------------------------------------
  local get_boothbutton_1_inv = function ()

    int.InventoryItemAdd( "inv_boothbutton_1", "spr_janitresstuff_boothbutton_1" );

  end;
  local get_boothbutton_1_closezz = function ()

    ObjDelete( "gfx_janitresstuff_boothbutton_1" );
    ObjDelete( "spr_janitresstuff_boothbutton_1_shadow" );

  end;

  cmn.AddSubscriber( "get_boothbutton_1", get_boothbutton_1_inv );
  cmn.AddSubscriber( "get_boothbutton_1", get_boothbutton_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bird_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bird_2" ] =
  {
    type = "get",
    get_obj = "spr_janitresstuff_bird_2",
    room = private.room_objname,
    zz = "zz_janitresstuff",
    zz_gate = "gzz_window_janitresstuff"
  };
  -----------------------------------------------
  local get_bird_2_inv = function ()

    int.InventoryItemAdd( "inv_bird", "spr_janitresstuff_bird_2", "assets/levels/level3/rm_window/zz_janitresstuff/inv/inv_bird_morph" );
    level3_inv.CheckBird();

  end;
  local get_bird_2_closezz = function ()

    ObjDelete( "gfx_janitresstuff_bird_2" );
    ObjDelete( "spr_janitresstuff_bird_2_shadow" );

  end;

  cmn.AddSubscriber( "get_bird_2", get_bird_2_inv );
  cmn.AddSubscriber( "get_bird_2", get_bird_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bullet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bullet" ] =
  {
    type = "get",
    get_obj = "spr_janitresstuff_bullet",
    room = private.room_objname,
    zz = "zz_janitresstuff",
    zz_gate = "gzz_window_janitresstuff"
  };
  -----------------------------------------------
  local get_bullet_inv = function ()

    int.InventoryItemAdd( "inv_bullet", "spr_janitresstuff_bullet" );
    if cmn.IsEventDone( "get_oil" ) then
      ObjSet( "inv_notloadedgun_plus_focus2", { alp = 1 } );
    end;

  end;
  local get_bullet_closezz = function ()

    ObjDelete( "gfx_janitresstuff_bullet" );
    ObjDelete( "spr_janitresstuff_bullet_shadow" );
    ObjDelete( "spr_window_janitresstuff_bullet" );

    if ( cmn.IsEventDone( "get_oil" ) ) then

      ObjDelete( "gzz_window_janitresstuff" );

    end;

  end;

  cmn.AddSubscriber( "get_bullet", get_bullet_inv );
  cmn.AddSubscriber( "get_bullet", get_bullet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_oil () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_oil" ] =
  {
    type = "get",
    get_obj = "spr_janitresstuff_oil",
    room = private.room_objname,
    zz = "zz_janitresstuff",
    zz_gate = "gzz_window_janitresstuff"
  };
  -----------------------------------------------
  local get_oil_inv = function ()

    int.InventoryItemAdd( "inv_oil", "spr_janitresstuff_oil" );
    ObjSet( "inv_notloadedgun_plus_focus2", { alp = 1 } );


  end;
  local get_oil_closezz = function ()

    ObjDelete( "gfx_janitresstuff_oil" );
    ObjDelete( "spr_janitresstuff_oil_shadow" );
    ObjDelete( "spr_window_janitresstuff_oil" );

    if ( cmn.IsEventDone( "get_bullet" ) ) then

      ObjDelete( "gzz_window_janitresstuff" );

    end;

  end;

  cmn.AddSubscriber( "get_oil", get_oil_inv );
  cmn.AddSubscriber( "get_oil", get_oil_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_threedollar_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_threedollar_3" ] =
  {
    type = "get",
    get_obj = "spr_bag_threedollar_3",
    room = private.room_objname,
    zz = "zz_bag",
    zz_gate = "gzz_window_bag"
  };
  -----------------------------------------------
  local get_threedollar_3_inv = function ()

    int.InventoryItemAdd( "inv_threedollar", "spr_bag_threedollar_3", "assets/levels/level3/rm_window/zz_bag/inv/inv_threedollar_morph" );
    level3_inv.CheckThreeDollar();

  end;
  local get_threedollar_3_closezz = function ()

    ObjDelete( "gfx_bag_threedollar_3" );
    ObjDelete( "spr_bag_threedollar_3_shadow" );
    ObjDelete( "spr_bag_threedollar_3_over" );
    ObjDelete( "spr_window_bag_threedollar_3" );

  end;

  cmn.AddSubscriber( "get_threedollar_3", get_threedollar_3_inv );
  cmn.AddSubscriber( "get_threedollar_3", get_threedollar_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pencil () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pencil" ] =
  {
    type = "get",
    get_obj = "spr_bag_pencil",
    room = private.room_objname,
    zz = "zz_bag",
    zz_gate = "gzz_window_bag"
  };
  -----------------------------------------------
  local get_pencil_inv = function ()

    int.InventoryItemAdd( "inv_pencil", "spr_bag_pencil" );

  end;
  local get_pencil_closezz = function ()

    ObjDelete( "gfx_bag_pencil" );
    ObjDelete( "spr_bag_pencil_shadow" );
    ObjDelete( "spr_window_bag_pencil" );

  end;

  cmn.AddSubscriber( "get_pencil", get_pencil_inv );
  cmn.AddSubscriber( "get_pencil", get_pencil_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_diamond () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_diamond" ] =
  {
    type = "get",
    get_obj = "spr_bag_diamond",
    room = private.room_objname,
    zz = "zz_bag",
    zz_gate = "gzz_window_bag"
  };
  -----------------------------------------------
  local get_diamond_inv = function ()

    int.InventoryItemAdd( "inv_diamond", "spr_bag_diamond" );

  end;
  local get_diamond_closezz = function ()

    ObjDelete( "spr_window_bracelet" );
    
    if ( cmn.IsEventDone( "get_collect2_3_2" ) ) then
      ObjDelete( "gzz_window_bag" );
    end;

  end;

  cmn.AddSubscriber( "get_diamond", get_diamond_inv );
  cmn.AddSubscriber( "get_diamond", get_diamond_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_marksamulet_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_marksamulet_3" ] =
  {
    type = "get",
    get_obj = "spr_janitresstuff_marksamulet_3",
    room = private.room_objname,
    zz = "zz_janitresstuff",
    zz_gate = "gzz_window_janitresstuff"
  };
  -----------------------------------------------
  local get_marksamulet_3_inv = function ()

    int.InventoryItemAdd( "inv_marksamulet", "spr_janitresstuff_marksamulet_3", "assets/levels/level3/rm_waitinghall/zz_hallsecurity/inv/inv_marksamulet_morph" );
    level3_inv.CheckMarksamulet();

  end;
  local get_marksamulet_3_closezz = function ()

    ObjDelete( "gfx_janitresstuff_marksamulet_3" );
    ObjDelete( "spr_janitresstuff_marksamulet_3_shadow" );

  end;

  cmn.AddSubscriber( "get_marksamulet_3", get_marksamulet_3_inv );
  cmn.AddSubscriber( "get_marksamulet_3", get_marksamulet_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_3_2 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_3_2 = function ()

    ObjDelete( "obj_window_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_3_2", get_morphobject_3_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_3_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_3_2 = function ()

    ObjDelete( "spr_bag_collect_3_2_shadow" );
    ObjDelete( "spr_bag_collect2_3_2" );
    ObjDelete( "spr_window_collect" );
    
    if ( cmn.IsEventDone( "get_diamond" ) ) then
      ObjDelete( "gzz_window_bag" );
    end;

  end;

  cmn.AddSubscriber( "get_collect2_3_2", get_collect2_3_2, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_toggle3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_toggle3" ] =
  {
    type = "use",
    use_obj = "inv_toggle3",
    use_place = "obj_janitresstuff_use_toggle3",
    room = private.room_objname,
    zz = "zz_janitresstuff",
    zz_gate = "gzz_window_janitresstuff"
  };
  -----------------------------------------------
  local use_toggle3_inv = function ()

    int.InventoryItemRemove( "inv_toggle3" );

  end;
  local use_toggle3_beg = function ()

    ObjDelete( "obj_janitresstuff_use_toggle3" );

  end;
  local use_toggle3_end = function ()

    ObjSet( "obj_janitresstuff_toggle_3_1", { alp = 1 } );
    ObjSet( "obj_janitresstuff_case_close", { input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_toggle3", use_toggle3_beg, private.room_objname );
  cmn.AddSubscriber( "use_toggle3", use_toggle3_inv );
  cmn.AddSubscriber( "use_toggle3", use_toggle3_end, private.room_objname );
  cmn.AddSubscriber( "use_toggle3_inv", use_toggle3_inv, private.room_objname );
  cmn.AddSubscriber( "use_toggle3_beg", use_toggle3_beg, private.room_objname );
  cmn.AddSubscriber( "use_toggle3_end", use_toggle3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_twister () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_twister" ] =
  {
    type = "use",
    use_obj = "inv_twister",
    use_place = "obj_janitresstuff_use_twister",
    room = private.room_objname,
    zz = "zz_janitresstuff",
    zz_gate = "gzz_window_janitresstuff"
  };
  -----------------------------------------------
  local use_twister_inv = function ()

    int.InventoryItemRemove( "inv_twister" );

  end;
  local use_twister_beg = function ()

    ObjDelete( "obj_janitresstuff_use_twister" );

  end;
  local use_twister_end = function ()

    ObjDelete( "obj_janitresstuff_box_close" );
    ObjDelete( "anm_janitresstuff_box_open" );

    ObjSet( "obj_janitresstuff_box_open",   { alp = 1, input = true } );
    ObjSet( "spr_janitresstuff_oil",        { alp = 1, input = true } );
    ObjSet( "spr_janitresstuff_oil_shadow", { alp = 1 } );
    ObjSet( "gfx_janitresstuff_bullet",     { active = true } );
    ObjSet( "gfx_janitresstuff_oil",        { active = true } );

    ObjSet( "obj_window_janitresstuff_open_box", { alp = 1 } );
    ObjDelete( "spr_window_janitresstuff_closed_box" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_twister", use_twister_beg, private.room_objname );
  cmn.AddSubscriber( "use_twister", use_twister_inv );
  cmn.AddSubscriber( "use_twister", use_twister_end, private.room_objname );
  cmn.AddSubscriber( "use_twister_inv", use_twister_inv, private.room_objname );
  cmn.AddSubscriber( "use_twister_beg", use_twister_beg, private.room_objname );
  cmn.AddSubscriber( "use_twister_end", use_twister_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bird () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bird" ] =
  {
    type = "use",
    use_obj = "inv_bird",
    use_place = "obj_bag_use_bird",
    room = private.room_objname,
    zz = "zz_bag",
    zz_gate = "gzz_window_bag"
  };
  -----------------------------------------------
  local use_bird_inv = function ()

    int.InventoryItemRemove( "inv_bird" );

  end;
  local use_bird_beg = function ()

    ObjDelete( "obj_bag_use_bird" );

  end;
  local use_bird_end = function ()

    ObjSet( "obj_bag_open",   { alp = 1, input = true } );
    ObjSet( "gfx_bag_pencil", { active = true } );
    ObjSet( "spr_window_open_bag",   { alp = 1 } );
    ObjDelete( "spr_bag_bird_1" );
    ObjDelete( "spr_bag_bird_2" );
    ObjDelete( "spr_bag_close" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_bird", use_bird_beg, private.room_objname );
  cmn.AddSubscriber( "use_bird", use_bird_inv );
  cmn.AddSubscriber( "use_bird", use_bird_end, private.room_objname );
  cmn.AddSubscriber( "use_bird_inv", use_bird_inv, private.room_objname );
  cmn.AddSubscriber( "use_bird_beg", use_bird_beg, private.room_objname );
  cmn.AddSubscriber( "use_bird_end", use_bird_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pliers3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pliers3" ] =
  {
    type = "use",
    use_obj = "inv_pliers3",
    use_place = "obj_bag_use_pliers3",
    room = private.room_objname,
    zz = "zz_bag",
    zz_gate = "gzz_window_bag"
  };
  -----------------------------------------------
  local use_pliers3_inv = function ()

    int.InventoryItemRemove( "inv_pliers3" );

  end;
  local use_pliers3_beg = function ()

    ObjDelete( "obj_bag_use_pliers3" );

  end;
  local use_pliers3_end = function ()

    ObjSet( "spr_bag_diamond", { input = true } );
    ObjSet( "gfx_bag_diamond", { active = true } );
    ObjDelete( "anm_bag_diamond_click" );
    ObjDelete( "anm_bag_pliers" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_pliers3", use_pliers3_beg, private.room_objname );
  cmn.AddSubscriber( "use_pliers3", use_pliers3_inv );
  cmn.AddSubscriber( "use_pliers3", use_pliers3_end, private.room_objname );
  cmn.AddSubscriber( "use_pliers3_inv", use_pliers3_inv, private.room_objname );
  cmn.AddSubscriber( "use_pliers3_beg", use_pliers3_beg, private.room_objname );
  cmn.AddSubscriber( "use_pliers3_end", use_pliers3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_bag_pocket () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_bag_pocket" ] =
  {
    type = "click",
    clk_obj = "obj_bag_clk_pocket",
    room = private.room_objname,
    zz = "zz_bag",
    zz_gate = "gzz_window_bag"
  };
  -----------------------------------------------
  local clk_bag_pocket_beg = function ()

    ObjDelete( "obj_bag_clk_pocket" );

  end;
  local clk_bag_pocket_end = function ()
    
    ObjSet( "obj_bag_pocket_open", { alp = 1, input = true } );
    ObjSet( "gfx_bag_threedollar_3", { active = true } );
    ObjSet( "spr_window_open_pocket", { alp = 1 } );
    ObjDelete( "spr_bag_pocket_light" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_bag_pocket", clk_bag_pocket_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bag_pocket", clk_bag_pocket_end, private.room_objname );
  cmn.AddSubscriber( "clk_bag_pocket_beg", clk_bag_pocket_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bag_pocket_end", clk_bag_pocket_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_janitresstuff () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_janitresstuff" ] =
  {
    room = private.room_objname,
    zz = "zz_janitresstuff",
    zz_gate = "gzz_window_janitresstuff"
  };
  --*********************************************************************************************************************
  local win_janitresstuff = function ()

    if ( cmn.IsEventDone( "win_janitresstuff" ) ) then

      ObjSet( "obj_janitresstuff_case_open", { alp = 1, input = true } );
      ObjDelete( "obj_janitresstuff_case_close" );

      ObjSet( "gfx_janitresstuff_marksamulet_3", { active = true } );
      ObjSet( "gfx_janitresstuff_bird_2",        { active = true } );
      ObjSet( "gfx_janitresstuff_boothbutton_1", { active = true } );
      ObjSet( "gfx_janitresstuff_oil",           { active = true } );

      ObjSet( "obj_window_janitresstuff_open", { alp = 1 } );      
      ObjDelete( "obj_window_janitresstuff_closed" );

    elseif ( cmn.IsEventStart( "win_janitresstuff" ) ) then

      private.JanitresstuffLoad();

    end;

  end;

  cmn.AddSubscriber( "win_janitresstuff", win_janitresstuff, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
function private.get_screw3 ()

  cmn.SetEventDone( "get_screw3" );
  cmn.CallEventHandler( "get_screw3" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_boothbutton_1 ()

  cmn.SetEventDone( "get_boothbutton_1" );
  cmn.CallEventHandler( "get_boothbutton_1" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_bird_2 ()

  cmn.SetEventDone( "get_bird_2" );
  cmn.CallEventHandler( "get_bird_2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_bullet ()

  cmn.SetEventDone( "get_bullet" );
  cmn.CallEventHandler( "get_bullet" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_oil" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_oil ()

  cmn.SetEventDone( "get_oil" );
  cmn.CallEventHandler( "get_oil" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_bullet" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_threedollar_3 ()

  cmn.SetEventDone( "get_threedollar_3" );
  cmn.CallEventHandler( "get_threedollar_3" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_marksamulet_3 ()

  cmn.SetEventDone( "get_marksamulet_3" );
  cmn.CallEventHandler( "get_marksamulet_3" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_pencil ()

  cmn.SetEventDone( "get_pencil" );
  cmn.CallEventHandler( "get_pencil" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_diamond ()

  ObjSet( "spr_bag_diamond", { alp = 1 } );

  cmn.SetEventDone( "get_diamond" );
  cmn.CallEventHandler( "get_diamond" );

  cmn.GetObjectSfx();
  
  if ( cmn.IsEventDone( "get_collect2_3_2" ) ) then
    cmn.CloseSubRoom();
  end;

end;
---------------------------------------------------------------------------------
function private.get_collect2_3_2()

  int.AddCollectibles2( "spr_bag_collect2_3_2" );
  ObjSet( "spr_bag_collect_3_2_shadow", { alp = 0 } );
  
  if ( cmn.IsEventDone( "get_diamond" ) ) then
    cmn.CloseSubRoom();
  end;

end;
--*********************************************************************************************************************
-------------------------------------------------
function public.use_toggle3 ()

  local item = "inv_toggle3";

  if ( cmn.ApplyObj( item, "gzz_window_janitresstuff", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_janitresstuff" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_janitresstuff_use_toggle3", true ) ) then

    cmn.CallEventHandler( "use_toggle3_inv" );
    cmn.CallEventHandler( "use_toggle3_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_toggle3" );
      cmn.CallEventHandler( "use_toggle3_end" );
      int.Lock( false );

      ng_global.progress[ "std" ][ "win_janitresstuff" ].state = { { 0, 1, 0 }, { 0, 0, 1 }, { 1, 0, 0 } };
      common_impl.PassingMgStart( "janitresstuff" );
      cmn.MiniGameShow( "janitresstuff" );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_apply_rotator" );  
    ObjAnimate( "obj_janitresstuff_toggle_3_1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_twister ()

  local item = "inv_twister";

  if ( cmn.ApplyObj( item, "gzz_window_janitresstuff", false ) ) and
     ( cmn.IsEventDone( "win_janitresstuff" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_janitresstuff" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_janitresstuff_use_twister", true ) ) and
         ( cmn.IsEventDone( "win_janitresstuff" ) ) then

    cmn.CallEventHandler( "use_twister_inv" );
    cmn.CallEventHandler( "use_twister_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_twister" );
      cmn.CallEventHandler( "use_twister_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_lever_insert" );  

    ObjAnimate( "anm_janitresstuff_box_open", "alp", 0, 0,
    function ()

      AnimPlay( "anm_janitresstuff_box_open", "DoAnim", func_end );

    end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "obj_janitresstuff_box_close", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 1.0, 
      0.3, 0, 0.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_bird ()

  local item = "inv_bird";

  if ( cmn.ApplyObj( item, "gzz_window_bag", false ) ) and
     ( cmn.IsEventDone( "get_bird_1" ) ) and
     ( cmn.IsEventDone( "get_bird_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bag" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bag_use_bird", true ) ) and
         ( cmn.IsEventDone( "get_bird_1" ) ) and
         ( cmn.IsEventDone( "get_bird_2" ) ) then

    cmn.CallEventHandler( "use_bird_inv" );
    cmn.CallEventHandler( "use_bird_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_bird" );
      cmn.CallEventHandler( "use_bird_end" );
      int.Lock( false );

    end;

    local func_anim_end = function ()

      ObjAnimate( "obj_bag_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_open_women_bag" );  
    ObjAnimate( "spr_bag_bird_1", "alp", 0, 0, func_anim_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.5, 0, 1.0
    } );
    ObjAnimate( "spr_bag_bird_2", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.5, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_pliers3 ()

  local item = "inv_pliers3";

  if ( cmn.ApplyObj( item, "gzz_window_bag", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bag" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bag_use_pliers3", true ) ) then

    cmn.CallEventHandler( "use_pliers3_inv" );
    cmn.CallEventHandler( "use_pliers3_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_pliers3" );
      cmn.CallEventHandler( "use_pliers3_end" );

      private.get_diamond();

      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_cut_diamond" );  

    ObjSet( "anm_bag_diamond_click", { alp = 0 } );
    ObjSet( "anm_bag_pliers", { alp = 1 } );
    AnimPlay( "anm_bag_pliers", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_bag_pocket ()

  cmn.CallEventHandler( "clk_bag_pocket_beg" );
  int.Lock( true );

  local func_end = function ()

    cmn.SetEventDone( "clk_bag_pocket" );
    cmn.CallEventHandler( "clk_bag_pocket_end" );
    int.Lock( false );

  end;

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_women_bag_pocket" );  
  ObjAnimate( "obj_bag_pocket_open", "alp", 0, 0, func_end,
  { 
    0.0, 3, 0.0, 
    0.3, 3, 1.0
  } );

  ObjAnimate( "spr_bag_pocket_light", "alp", 0, 0, "",
  { 
    0.0, 3, 1.0, 
    0.3, 3, 0.0
  } );

end;
-------------------------------------------------
-------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_window ()

  if not ( cmn.IsEventDone( "opn_window" ) ) then

    cmn.SetEventDone( "opn_window" );
    cmn.ShowBbt( "bbt_window_first_entry" );
    cmn.AddPageDiary( 14 );

  end;

end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_window();

end;
--*********************************************************************************************************************
function public.Task ()
  
  int.AddedTaskMap( private.room_objname, "get_screw3" );
  int.AddedTaskMap( private.room_objname, "get_boothbutton_1",                                    { "win_janitresstuff" } );
  int.AddedTaskMap( private.room_objname, "get_bird_2",                                           { "win_janitresstuff" } );
  int.AddedTaskMap( private.room_objname, "get_bullet",                                           { "use_twister" } );
  int.AddedTaskMap( private.room_objname, "get_oil",                                              { "use_twister" } );
  int.AddedTaskMap( private.room_objname, "get_threedollar_3",                                    { "clk_bag_pocket" } );
  int.AddedTaskMap( private.room_objname, "get_pencil",                                           { "use_bird" } );
  int.AddedTaskMap( private.room_objname, "get_diamond",                                          { "use_pliers3" } );
  int.AddedTaskMap( private.room_objname, "get_marksamulet_3",                                    { "win_janitresstuff" } );
  
  int.AddedTaskMap( private.room_objname, "use_toggle3",                                          { "get_toggle3" } );
  int.AddedTaskMap( private.room_objname, "use_twister",                                          { "get_twister" } );
  int.AddedTaskMap( private.room_objname, "use_bird",                                             { "get_bird_2" } );
  int.AddedTaskMap( private.room_objname, "use_pliers3",                                          { "get_pliers3" } );
  
  int.AddedTaskMap( private.room_objname, "clk_bag_pocket" );
  
  int.AddedTaskMap( private.room_objname, "win_janitresstuff",                                    { "use_toggle3" } );
  
end;  
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_janitresstuff" );
  -------------------------------------------------
  function zz_janitresstuff.Open()

    if ( cmn.IsEventStart( "win_janitresstuff" ) and not cmn.IsEventDone( "win_janitresstuff" ) ) then

      cmn.MiniGameShow( "janitresstuff" );
      common_impl.PassingMgStart( "janitresstuff" );

    end;

  end;
  -------------------------------------------------
  function zz_janitresstuff.PreClose()

    if ( cmn.IsEventStart( "win_janitresstuff" ) and not cmn.IsEventDone( "win_janitresstuff" ) ) then

      cmn.MiniGameHide( "janitresstuff" );
      common_impl.PassingMgStop( "janitresstuff" );

    end;

  end;
  -----------------------------------------------
  function zz_janitresstuff.Skip ()

    private.JanitresstuffSkip();

  end;
  -------------------------------------------------
  function zz_janitresstuff.Reset ()

    private.JanitresstuffReset();

  end;

end;
--*********************************************************************************************************************
function private.BagDiamonClick ()

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_bag_use_pliers3" );

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_pendant_touch" );
  AnimPlay( "anm_bag_diamond_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.BagCloseClick ()

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_bag_use_bird_1" );

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_women_bag_touch" );
  ObjAnimate( "spr_bag_close", "scale_y", 0, 0, func_end, 
  {
    0.0, 3, 1.000,
    0.3, 3, 0.990,
    0.6, 3, 1.000,
    0.9, 3, 0.990,
    1.2, 3, 1.000,
  } );

end;
--*********************************************************************************************************************
function private.CaseClick ()

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_janitresstuff_use_toggle3" );

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_touch_lost_and_found" );
  ObjAnimate( "obj_janitresstuff_case_close", "pos_xy", 0, 0, func_end, 
  {
    0.0,0,0,0,
    0.2,0,1,1,
    0.4,0,0,0
  } );

end;
--*********************************************************************************************************************
function private.BoxClick ()

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_janitresstuff_use_twister" );

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_noclown_box_touch" );
  ObjAnimate( "spr_janitresstuff_box_close", "pos_xy", 0, 0, func_end, 
  {
    0.0, 3, -105, 56,
    0.2, 3, -106, 57,
    0.4, 3, -105, 56,
    0.6, 3, -106, 57,
    0.8, 3, -105, 56,
  } );

end;
--*********************************************************************************************************************
function private.InitAnims ()

  ObjAnimate( "spr_janitresstuff_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_bag_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_bag_diamond_flare", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_bag_diamond_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_bag_woman", "alp", 1, 0, "", 
  { 
    0.0, 3, 1.0,
    0.3, 3, 1.0,
    1.3, 3, 0.6,
    2.3, 3, 1.0,
    3.3, 3, 0.6,
    4.3, 3, 1.0,
    5.3, 3, 0.6,
    6.3, 3, 1.0,
    7.3, 3, 0.6,
    8.3, 3, 1.0,
    8.5, 3, 0.6,
    8.7, 3, 1.0,
    8.9, 3, 0.6,
    9.1, 3, 1.0,
  } );

  ObjAnimate( "spr_bag_woman_hand", "alp", 1, 0, "", 
  { 
    0.0, 3, 1.0,
    0.3, 3, 1.0,
    1.3, 3, 0.6,
    2.3, 3, 1.0,
    3.3, 3, 0.6,
    4.3, 3, 1.0,
    5.3, 3, 0.6,
    6.3, 3, 1.0,
    7.3, 3, 0.6,
    8.3, 3, 1.0,
    8.5, 3, 0.6,
    8.7, 3, 1.0,
    8.9, 3, 0.6,
    9.1, 3, 1.0,
  } );

  ObjAnimate( "obj_bag_hand", "alp", 1, 0, "", 
  { 
    0.0, 3, 1.0,
    0.3, 3, 1.0,
    1.3, 3, 0.6,
    2.3, 3, 1.0,
    3.3, 3, 0.6,
    4.3, 3, 1.0,
    5.3, 3, 0.6,
    6.3, 3, 1.0,
    7.3, 3, 0.6,
    8.3, 3, 1.0,
    8.5, 3, 0.6,
    8.7, 3, 1.0,
    8.9, 3, 0.6,
    9.1, 3, 1.0,
  } );

  ObjAnimate( "obj_window_people", "alp", 1, 0, "", 
  { 
    0.0, 3, 1.0,
    0.3, 3, 1.0,
    1.3, 3, 0.6,
    2.3, 3, 1.0,
    3.3, 3, 0.6,
    4.3, 3, 1.0,
    5.3, 3, 0.6,
    6.3, 3, 1.0,
    7.3, 3, 0.6,
    8.3, 3, 1.0,
    8.5, 3, 0.6,
    8.7, 3, 1.0,
    8.9, 3, 0.6,
    9.1, 3, 1.0,
  } );

  ObjAnimate( "spr_window_woman", "alp", 1, 0, "", 
  { 
    0.0, 3, 1.0,
    0.3, 3, 1.0,
    1.3, 3, 0.6,
    2.3, 3, 1.0,
    3.3, 3, 0.6,
    4.3, 3, 1.0,
    5.3, 3, 0.6,
    6.3, 3, 1.0,
    7.3, 3, 0.6,
    8.3, 3, 1.0,
    8.5, 3, 0.6,
    8.7, 3, 1.0,
    8.9, 3, 0.6,
    9.1, 3, 1.0,
  } );

  ObjAnimate("obj_window_sky_1", "pos_x", 1, 0, "", 
  {
    0.0,0,0,
    60.0,0,1404,
    60.0,0,0
  });

end;
--*********************************************************************************************************************
--***** function MMG JANITRESSTUFF () end; ****************************************************************************
--*********************************************************************************************************************
  function private.JanitresstuffInit ()

    private.row_count = 3;
    private.col_count = 3;

    for r = 1, private.row_count do

      for c = 1, private.col_count do

        ObjSet( "obj_janitresstuff_toggle_"..r.."_"..c,
        {
          event_mdown  = function () private.JanitresstuffClick( r, c ); end,
          event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
          event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
        } );

      end;

    end;

  end;
--*********************************************************************************************************************
  function private.JanitresstuffClick ( row, col )

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_rotate_lost_found" );
    private.tmp_state = {};

    for r = 1, private.row_count do

      private.tmp_state[ r ] = {};

      for c = 1, private.col_count do

        private.tmp_state[ r ][ c ] = ng_global.progress[ "std" ][ "win_janitresstuff" ].state[ r ][ c ];

      end;

    end;

    for i = 1, private.col_count do

      local state_1 = private.tmp_state[ row ][ i ];
      local state_2 = math.abs( 1 - private.tmp_state[ row ][ i ] );

      private.tmp_state[ row ][ i ] = state_2;

      ObjAnimate( "obj_janitresstuff_toggle_"..row.."_"..i.."_"..state_1, "alp", 0, 0, "", 
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "obj_janitresstuff_toggle_"..row.."_"..i.."_"..state_2, "alp", 0, 0, "", 
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;  

    for i = 1, private.row_count do

      if ( i ~= row ) then

        local state_1 = private.tmp_state[ i ][ col ];
        local state_2 = math.abs( 1 - private.tmp_state[ i ][ col ] );

        private.tmp_state[ i ][ col ] = state_2;

        ObjAnimate( "obj_janitresstuff_toggle_"..i.."_"..col.."_"..state_1, "alp", 0, 0, "",
        {
          0.0, 3, 1.0,
          0.3, 3, 0.0,
        } );

        ObjAnimate( "obj_janitresstuff_toggle_"..i.."_"..col.."_"..state_2, "alp", 0, 0, "", 
        {
          0.0, 3, 0.0,
          0.3, 3, 1.0,
        } );

      end;

    end;

    ObjSet( "tmr_janitresstuff_save", 
    { 
      playing = 1, 
      time = 0.30,  
      endtrig = function ()

        if ( private.JanitresstuffIsWin() ) then
          
          common_impl.PassingMgWin( "janitresstuff" );
          cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_open_lost_found" );
          ObjAnimate( "obj_janitresstuff_case_open", "alp", 0, 0,
          function ()

            int.Lock( false );

            private.JanitresstuffSave();
            private.JanitresstuffWin();

          end, 
          {
            0.0, 3, 0.0,
            0.2, 3, 0.0,
            0.5, 3, 1.0,
          } );

        else

          int.Lock( false );

          private.JanitresstuffSave();

        end;

      end,
    } );

  end;
--*********************************************************************************************************************
  function private.JanitresstuffReset ()

    int.Lock( true );

    private.tmp_state = { { 0, 1, 0 }, { 0, 0, 1 }, { 1, 0, 0 } };

    for r = 1, private.row_count do

      for c = 1, private.col_count do

        local state_1 = private.tmp_state[ r ][ c ];
        local state_2 = math.abs( 1 - state_1 );
        local name_1  = "obj_janitresstuff_toggle_"..r.."_"..c.."_"..state_1;
        local name_2  = "obj_janitresstuff_toggle_"..r.."_"..c.."_"..state_2;

        ObjAnimate( name_1, "alp", 0, 0, "", 
        {
          0.0, 3, ObjGet( name_1 ).alp,
          0.3, 3, 1.0,
        } );

        ObjAnimate( name_2, "alp", 0, 0, "", 
        {
          0.0, 3, ObjGet( name_2 ).alp,
          0.3, 3, 0.0,
        } );

      end;

    end;  

    ObjSet( "tmr_janitresstuff_save", 
    { 
      playing = 1, 
      time = 0.30,  
      endtrig = function ()

        int.Lock( false );

        private.JanitresstuffSave();

      end,
    } );

  end;
--*********************************************************************************************************************
  function private.JanitresstuffSkip ()

    int.Lock( true );

    private.tmp_state = { { 1, 1, 1 }, { 1, 1, 1 }, { 1, 1, 1 } };

    for r = 1, private.row_count do

      for c = 1, private.col_count do

        local state_1 = private.tmp_state[ r ][ c ];
        local state_2 = math.abs( 1 - state_1 );
        local name_1  = "obj_janitresstuff_toggle_"..r.."_"..c.."_"..state_1;
        local name_2  = "obj_janitresstuff_toggle_"..r.."_"..c.."_"..state_2;

        ObjAnimate( name_1, "alp", 0, 0, "", 
        {
          0.0, 3, ObjGet( name_1 ).alp,
          0.3, 3, 1.0,
        } );

        ObjAnimate( name_2, "alp", 0, 0, "", 
        {
          0.0, 3, ObjGet( name_2 ).alp,
          0.3, 3, 0.0,
        } );

      end;

    end;  

    ObjSet( "tmr_janitresstuff_save", 
    { 
      playing = 1, 
      time = 0.30,  
      endtrig = function ()
      
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_open_lost_found" );
        ObjAnimate( "obj_janitresstuff_case_open", "alp", 0, 0,
        function ()

          int.Lock( false );

          private.JanitresstuffSave();
          private.JanitresstuffWin();

        end, 
        {
          0.0, 3, 0.0,
          0.2, 3, 0.0,
          0.5, 3, 1.0,
        } );

      end,
    } );

  end;
--*********************************************************************************************************************
  function private.JanitresstuffIsWin ()

    for r = 1, private.row_count do

      for c = 1, private.col_count do

        if ( private.tmp_state[ r ][ c ] ~= 1 ) then

          return false;

        end;

      end;

    end;

    return true;

  end;
--*********************************************************************************************************************
  function private.JanitresstuffWin ()

    cmn.MiniGameHide( "janitresstuff" );
    cmn.SetEventDone( "win_janitresstuff" );
    cmn.CallEventHandler( "win_janitresstuff" );
    --common_impl.PassingMgWin( "janitresstuff" );

  end;
--*********************************************************************************************************************
  function private.JanitresstuffLoad ()

    for r = 1, private.row_count do

      for c = 1, private.col_count do

        local state_1 = ng_global.progress[ "std" ][ "win_janitresstuff" ].state[ r ][ c ];
        local state_2 = math.abs( 1 - state_1 );

        ObjSet( "obj_janitresstuff_toggle_"..r.."_"..c.."_"..state_1, { alp = 1 } );
        ObjSet( "obj_janitresstuff_toggle_"..r.."_"..c.."_"..state_2, { alp = 0 } );

      end;

    end;

  end;
--*********************************************************************************************************************
  function private.JanitresstuffSave ()

    for r = 1, private.row_count do

      for c = 1, private.col_count do

        ng_global.progress[ "std" ][ "win_janitresstuff" ].state[ r ][ c ] = private.tmp_state[ r ][ c ];

      end;

    end;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************