-- name=ho_hofridge
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------

  room.Define( "ho_hofridge" );

  private.room_objname = "ho_hofridge";
  game.relations[ private.room_objname ].exitroom = "rm_stewardessroom";


  private.win_hofridge = {};

  private.win_hofridge.pos_inv = 
  {-240, -120, 0, 120, 240, 360, 480, 600, 720, 840, 960, 1080};
  private.Animation ();

  --------------------------------------------------------------------------------------------
  -- function opn_hofridge () end;
  --------------------------------------------------------------------------------------------
  local opn_hofridge = function ()

  end;

  cmn.AddSubscriber( "opn_hofridge", opn_hofridge, private.room_objname );
  --------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_hofridge" ] =
  {
    type    = "get",
    get_obj = "spr_hofridge_win",
    room    = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_hofridge_func = function ()

    if ( cmn.IsEventDone( "win_hofridge" ) ) then

        int.InventoryItemAdd( "inv_amuletwatch", "spr_hofridge_win" );
        ObjDelete( "gho_stewardessroom_hofridge" );
        ObjDelete( "obj_hofridge_panel" );
        --int.DeleteTaskMap( "rm_stewardessroom", "win_hofridge" );

    end;

  end;
  cmn.AddSubscriber( "win_hofridge", win_hofridge_func );
  --------------------------------------------------------------------------------------------------
  local UnmarkBank = function () 

      ObjSet( "spr_hofridge_bank", { alp = 1, input = true, event_mdown = function () private.CompleteTask( "bank" ); end } ); 
      ObjSet( "spr_hofridge_op_bank", { alp = 1 } ); 
      ObjDelete( "spr_hofridge_opener" );
      ObjDelete( "spr_hofridge_opener_shadow" );
      ObjDelete( "obj_hofridge_use_opener" );
    
  end;

  cmn.AddSubscriber( "UnmarkBank", UnmarkBank, "ho_hofridge" );  
  --------------------------------------------------------------------------------------------------
  local UnmarkCanape = function () 

      ObjSet( "spr_hofridge_canape", { alp = 1, input = true, event_mdown = function () private.CompleteTask( "canape" ); end } );
      ObjSet( "spr_hofridge_skewer_2", { alp = 1 } );  
      ObjDelete( "spr_hofridge_skewer" );
      ObjDelete( "obj_hofridge_use_skewer" );
    
  end;

  cmn.AddSubscriber( "UnmarkCanape", UnmarkCanape, "ho_hofridge" );  
  --------------------------------------------------------------------------------------------------
  local UnmarkNoodles = function () 

      ObjSet( "spr_hofridge_noodles", { alp = 1, input = true, event_mdown = function () private.CompleteTask( "noodles" ); end } );
      ObjDelete( "spr_hofridge_noodles_1" );
      ObjDelete( "spr_hofridge_sticks" );
      ObjDelete( "spr_hofridge_sticks_shadow" );
      ObjDelete( "obj_hofridge_use_sticks" );
    
  end;

  cmn.AddSubscriber( "UnmarkNoodles", UnmarkNoodles, "ho_hofridge" ); 
  -------------------------------------------------------------------------------------------------- 
  local start_hofridge_func = function ()

    if ( cmn.IsEventStart( "win_hofridge" ) ) then

        common_impl.ProcessHoStart( "hofridge" );

        local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_hofridge" ].found;

        if cmn.IsUnmarkedTask( "hofridge", "bank" ) then

            cmn.CallEventHandler( "UnmarkBank" );

        end;

        if cmn.IsUnmarkedTask( "hofridge", "canape" ) then

            cmn.CallEventHandler( "UnmarkCanape" );

        end;
          
        if cmn.IsUnmarkedTask( "hofridge", "noodles" ) then

            cmn.CallEventHandler( "UnmarkNoodles" );

        end;
          
        for i = 1, #ho_found, 1 do

            ObjDelete( ho_found[ i ][ "object" ] );

        end;

    end;

  end;
  cmn.AddSubscriber( "win_hofridge", start_hofridge_func, "ho_hofridge" );
  --------------------------------------------------------------------------------------------------

  private.win_hofridge.task = { "bank", "noodles", "cake", "cheese", "canape", "cockerel", "crab", "figs", "fork", "leg", 
                                "snail", "spoon", "banana", "biscuit", "candy", "candy1", "pepper", "pills", "pineapple", "wafers", 
                                "bay_leaf" };

  for i = 1, #private.win_hofridge.task do

    ObjSet( "spr_hofridge_"..private.win_hofridge.task[ i ], { event_mdown = function () private.CompleteTask( private.win_hofridge.task[ i ] ); end, input = false } );

  end;

  --------------------------------------------------------------------------------------------------  
end;
--*********************************************************************************************************************
function public.Load ()

  if not cmn.IsEventStart( "win_hofridge" ) or not cmn.IsUnmarkedTask( "hofridge", "bank" ) then

    local find_Bank = function () 

        cmn.UnmarkTask( "hofridge", "bank" ); 
        cmn.CallEventHandler( "UnmarkBank" );

    end;

    ObjSet( "spr_hofridge_bank", 
    { 
      input          = false
    } );

    ObjSet( "spr_hofridge_opener", 
    { 
      drag           = true,
      event_mdown    = function () private.GetItem ( "opener" ); end,
      event_dragdrop = function () private.UseItem ( "opener" ); end, 
      event_menter   = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave   = function () cmn.SetCursor( CURSOR_DEFAULT ); end, 
      input          = true
    } );

    ObjSet( "obj_hofridge_use_opener", 
    { 
      event_mdown    = function () cmn.ShowBbt( "bbt_hofridge_use_opener" ); end,
      event_menter   = function () cmn.SetCursor( CURSOR_USE ); end,
      event_mleave   = function () cmn.SetCursor( CURSOR_DEFAULT ); end, 
      input          = true
    } );

  end;

  if not cmn.IsEventStart( "win_hofridge" ) or not cmn.IsUnmarkedTask( "hofridge", "canape" ) then

    local find_Canape = function () 

        cmn.UnmarkTask( "hofridge", "canape" ); 
        cmn.CallEventHandler( "UnmarkCanape" );

    end

    ObjSet( "spr_hofridge_canape", 
    { 
      input          = false
    } );

    ObjSet( "spr_hofridge_skewer", 
    { 
      drag           = true,
      event_mdown    = function () private.GetItem ( "skewer" ); end,
      event_dragdrop = function () private.UseItem ( "skewer" ); end, 
      event_menter   = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave   = function () cmn.SetCursor( CURSOR_DEFAULT ); end, 
      input          = true
    } );

    ObjSet( "obj_hofridge_use_skewer", 
    { 
      event_mdown    = function () cmn.ShowBbt( "bbt_hofridge_use_skewer" ); end,
      event_menter   = function () cmn.SetCursor( CURSOR_USE ); end,
      event_mleave   = function () cmn.SetCursor( CURSOR_DEFAULT ); end, 
      input          = true
    } );

  end;
  
  if not cmn.IsEventStart( "win_hofridge" ) or not cmn.IsUnmarkedTask( "hofridge", "noodles" ) then

    local find_Noodles = function () 

        cmn.UnmarkTask( "hofridge", "noodles" ); 
        cmn.CallEventHandler( "UnmarkNoodles" );

    end;

    ObjSet( "spr_hofridge_noodles", 
    { 
      alp            = 0,
      input          = false
    } );

    ObjSet( "spr_hofridge_sticks", 
    { 
      drag           = true,
      event_mdown    = function () private.GetItem ( "sticks" ); end,
      event_dragdrop = function () private.UseItem ( "sticks" ); end, 
      event_menter   = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave   = function () cmn.SetCursor( CURSOR_DEFAULT ); end, 
      input          = true
    } );

    ObjSet( "obj_hofridge_use_sticks", 
    { 
      event_mdown    = function () cmn.ShowBbt( "bbt_hofridge_use_sticks" ); end,
      event_menter   = function () cmn.SetCursor( CURSOR_USE ); end,
      event_mleave   = function () cmn.SetCursor( CURSOR_DEFAULT ); end, 
      input          = true
    } );

  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.InterfaceSetVisible( true );
  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventDone( "opn_hofridge" ) ) then

      cmn.SetEventDone( "opn_hofridge" );
      cmn.CallEventHandler( "opn_hofridge" );

  end;

  local ho_tasks = {};

  interface.TaskPanelTaskAdd( ho_tasks, "bay_leaf",  1, 0, { { "spr_hofridge_bay_leaf"        } } );
  interface.TaskPanelTaskAdd( ho_tasks, "cake",      1, 0, { { "spr_hofridge_cake"   } } );
  interface.TaskPanelTaskAdd( ho_tasks, "cheese",    1, 0, { { "spr_hofridge_cheese"  } } );
  interface.TaskPanelTaskAdd( ho_tasks, "canape",    1, 1, { { "spr_hofridge_skewer", "obj_hofridge_use_skewer" }, { "spr_hofridge_canape" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "cockerel",  1, 0, { { "spr_hofridge_cockerel"     } } );
  interface.TaskPanelTaskAdd( ho_tasks, "crab",      1, 0, { { "spr_hofridge_crab"       } } );
  interface.TaskPanelTaskAdd( ho_tasks, "figs",      1, 0, { { "spr_hofridge_figs"      } } );
  interface.TaskPanelTaskAdd( ho_tasks, "fork",      1, 0, { { "spr_hofridge_fork"      } } );
  interface.TaskPanelTaskAdd( ho_tasks, "bank",      1, 1, { { "spr_hofridge_opener", "obj_hofridge_use_opener" }, { "spr_hofridge_bank" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "leg",       1, 0, { { "spr_hofridge_leg"       } } );
  interface.TaskPanelTaskAdd( ho_tasks, "snail",     1, 0, { { "spr_hofridge_snail" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "spoon",     1, 0, { { "spr_hofridge_spoon"     } } );
  interface.TaskPanelTaskAdd( ho_tasks, "banana",    1, 0, { { "spr_hofridge_banana"     } } );
  interface.TaskPanelTaskAdd( ho_tasks, "biscuit",   1, 0, { { "spr_hofridge_biscuit"     } } );
  interface.TaskPanelTaskAdd( ho_tasks, "candy",     1, 0, { { "spr_hofridge_candy"     } } );
  interface.TaskPanelTaskAdd( ho_tasks, "candy1",    1, 0, { { "spr_hofridge_candy1"     } } );
  interface.TaskPanelTaskAdd( ho_tasks, "pepper",    1, 0, { { "spr_hofridge_pepper"     } } );
  interface.TaskPanelTaskAdd( ho_tasks, "pills",     1, 0, { { "spr_hofridge_pills"     } } );
  interface.TaskPanelTaskAdd( ho_tasks, "pineapple", 1, 0, { { "spr_hofridge_pineapple"     } } );
  interface.TaskPanelTaskAdd( ho_tasks, "wafers",    1, 0, { { "spr_hofridge_wafers"     } } );
  interface.TaskPanelTaskAdd( ho_tasks, "noodles",   1, 1, { { "spr_hofridge_sticks", "obj_hofridge_use_sticks" }, { "spr_hofridge_noodles" } } );
  
  if ( not cmn.IsEventStart( "win_hofridge" ) ) then

      cmn.InitHo( "hofridge" );
      cmn.SetMarkedTask( "hofridge", "bank" );
      cmn.SetMarkedTask( "hofridge", "canape" );
      cmn.SetMarkedTask( "hofridge", "noodles" );
      
  end;

  int.TaskPanelShow( ho_tasks );
  private.Panel();

  common_impl.StopMusEnv( false );

--  cmn.StopAllEnv( "audio/level1/env/aud_hall_env" );
--
--  cmn.PlayAudio( "env", "audio/level1/env/aud_hall_env", 1 );
--  cmn.PlayAudio( "env", "audio/level1/env/aud_ho_theme_mus_env", 1 );

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();
  --cmn.StopAudio( "env", "audio/level1/env/aud_ho_theme_mus_env", 0.3 );

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();
  ObjSet( "int_inventory_impl", { input = true } );
  ObjAttach( "obj_hofridge_panel", "ho_hofridge" );
  
end;
--*********************************************************************************************************************
function public.HoComplete ()

  --common_impl.PassingHoWin();

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )

  int.Lock( true );

  cmn.HoTaskFind( "spr_hofridge_"..name, name );
  for i = 1,#private.win_hofridge.task do

      if ( private.win_hofridge.task[i] == name ) then 

          local object_name = "obj_"..i; 
          local collect_name  = "pfx_hofridge_collect_"..object_name.."_effect";
          ng_global.progress[ ng_global.currentprogress ][ "win_hofridge" ].task_check[ i ] = 1;
          ObjCreate( collect_name, "partsys" );

          if  ( cmn.IsEventDone( "win_hofridge" ) ) then

              --int.Lock( false );

          end;

          ObjSet( collect_name,
          {
            res    = "assets/interface/resources/effects_ho_hint",
            pos_x  = ObjGet( object_name ).pos_x, pos_y = ObjGet( object_name ).pos_y,
            active = 1, visible = 1, input = 0
          } );

          ObjAttach( collect_name, "obj_hofridge_panel" );
          ObjSet( collect_name, { blendmode = 2, scale_x = 0.8, scale_y = 0.8 } );
          --PartSysSetMaskObj( collect_name, object_name );  
          local func_end = function () private.AnimInv( i ); end;
          ObjAnimate( object_name, 8,0,0, func_end,
          { 
              0.0, 0, 1.0,
              0.5, 0, 0.0
          } );
--
      end;

  end;

  common_impl.PassingHoCheck();

end;
--*********************************************************************************************************************
function private.GetItem ( name )

  local item = "spr_hofridge_"..name;
  ObjAttach( item, "ho_hofridge" );
  ObjSet( item, { pos_z = 14 } );
  ObjSet( item.."_shadow", { alp = 0 } );
  cmn.PlayAudio( "sfx", "audio/aud_take_inventory" );

end;
--*********************************************************************************************************************
function private.UseItem ( name ) 

  cmn.SetCursor( CURSOR_DEFAULT );

  local item = "spr_hofridge_"..name;

  if ( name == "opener" ) and
      ( cmn.ApplyObj( item, "obj_hofridge_use_opener", true ) ) then
      
      int.Lock( true );

      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_canned" );
      local func_end = function () private.UseItemEnd ( "bank" ); end;

      ObjDelete( item );
      ObjDelete( "obj_hofridge_use_opener" );
      ObjAnimate( "spr_hofridge_op_bank", "alp", 0, 0, func_end, 
      { 
        0.0,  0,  0,
        0.3,  0,  1
      } );

      return true;

  elseif ( name == "skewer" ) and
      ( cmn.ApplyObj( item, "obj_hofridge_use_skewer", true ) ) then

      int.Lock( true );

      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_makekanape" );
      local func_end = function () private.UseItemEnd ( "canape" ); end;

      ObjDelete( item );
      ObjDelete( "obj_hofridge_use_skewer" );
      ObjAnimate( "spr_hofridge_skewer_2", "alp", 0, 0, func_end, 
      { 
        0.0,  0,  0,
        0.3,  0,  1
      } );

      return true;
      
  elseif ( name == "sticks" ) and
      ( cmn.ApplyObj( item, "obj_hofridge_use_sticks", true ) ) then

      int.Lock( true );

      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_sticks" );
      local func_end = function () private.UseItemEnd ( "noodles" ); end;

      ObjDelete( item );
      ObjDelete( "obj_hofridge_use_sticks" );
      ObjAnimate( "spr_hofridge_noodles", "alp", 0, 0, func_end, 
      { 
        0.0,  0,  0,
        0.3,  0,  1
      } );
      
      ObjAnimate( "spr_hofridge_noodles_1", "alp", 0, 0, "", 
      { 
        0.0,  0,  1,
        0.2,  0,  1,
        0.3,  0,  0
      } );
      
      return true;
      
  else

      ObjAttach( item, "obj_hofridge_objects" );
      ObjSet( item, { pos_z = 5 } );
      ObjSet( item.."_shadow", { alp = 1 } );
      cmn.WrongApply();
      return false;

  end;

end;
--*********************************************************************************************************************
function private.UseItemEnd ( name )

  int.Lock( false );

  cmn.UnmarkTask( "hofridge", name );

  if ( name == "bank" ) then 

      cmn.CallEventHandler( "UnmarkBank" );

  elseif ( name == "canape" ) then

      cmn.CallEventHandler( "UnmarkCanape" );
      
  elseif ( name == "noodles" ) then

      cmn.CallEventHandler( "UnmarkNoodles" );
      
  end;

end;
--*********************************************************************************************************************
function private.Panel ()
  
  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );
  ObjAttach( "obj_hofridge_panel" , "spr_int_taskpanel" );
  
  if ( not ng_global.progress[ ng_global.currentprogress ]["win_hofridge"].task_check ) then

    ng_global.progress[ng_global.currentprogress]["win_hofridge"].task_check = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };

  end;

  local posx = -240;
  local tmp = 0;

  ObjSet( "obj_hofridge_panel", { croprect_init = true, croprect_x = -308, croprect_y = -200, croprect_w = 617, croprect_h = 400 } );

  for i = 1,#private.win_hofridge.task do 

     local obj = "obj_"..i;

     if ( ng_global.progress[ng_global.currentprogress]["win_hofridge"].task_check[i] == 0 ) and
        ( not ObjGet( obj ) ) then

        ObjCreate( obj, "obj" );
        ObjAttach( obj, "obj_hofridge_panel" );
        ObjSet( obj, { pos_x = posx, pos_y = 17, inputrect_init = true, inputrect_x = -45, inputrect_y = -45, inputrect_w = 90, inputrect_h = 90, alp = 1, input = 0  } );
        local spr = "spr_hofridge_"..private.win_hofridge.task[i].."_inv";
        ObjCreate( spr, "spr" );
        ObjSet( spr, { res = "assets/levels/levelext/ho_hofridge/layers/inv/"..private.win_hofridge.task[i], scale_x = 0.75, scale_y = 0.75 } );
        ObjAttach( spr, obj );
        tmp = tmp + 1;
        if ( tmp < 6 ) then

           private.CheckPanel( i, tmp );
          
        end;

        posx = posx + 120;

        if ( tmp == 21 ) then

          ng_global.progress[ ng_global.currentprogress ][ "win_hofridge" ].set = 1;

        end;

     else

     end;

  end;
   
end;
--********************************************************************************************************************* 
function private.CheckPanel ( i, tmp ) 

   local obj = "obj_"..i;

   if ( tmp < 6 ) then

      ObjSet( obj, { input = 1 } );

      ObjAnimate( obj, "alp", 0, 0, "", 
      { 
        0,0,0, 
        0.3,0,1 
      });

      ObjSet( "spr_hofridge_"..private.win_hofridge.task[i], { alp = 1, input = 1 } );

         if ( private.win_hofridge.task[ i ] == "bank" or 
              private.win_hofridge.task[ i ] == "canape" or 
              private.win_hofridge.task[ i ] == "noodles" ) then

          public.Load ();

         end;

   end;
   
end;
--*********************************************************************************************************************
function private.AnimInv ( num )

  local item = "obj_"..num;
  local tmp = num + 1;

      for i = tmp,#private.win_hofridge.task do

          local obj_tmp = "obj_"..i;

          if obj_tmp ~= nil and ng_global.progress[ ng_global.currentprogress ][ "win_hofridge" ].task_check[ i ] ~= 1 then

              ObjAnimate( "obj_"..i, "pos_x", 0, 0, "", 
              { 
                0,3,ObjGet( "obj_"..i ).pos_x, 
                0.6,3,ObjGet( "obj_"..i ).pos_x-120
              });

               if ObjGet( "obj_"..i ).pos_x-120 == 240 then

                  ObjAnimate( "obj_"..i, "scale_xy", 0, 0, "", 
                  { 
                    0.0,0,0.2,0.2, 
                    0.7,0,1,1
                  });

               end;

          end;

      end;

  private.Check( num );

end;
--*********************************************************************************************************************
function private.Check ( num )  

   local tmp = 0;

   for i = 1,#private.win_hofridge.task do

       local item = "obj_"..i;

       if ( item and ng_global.progress[ ng_global.currentprogress ][ "win_hofridge" ].task_check[ i ] ~= 1 ) then

          tmp = tmp + 1;

          if ( tmp < 6 ) then

             ObjSet( "spr_hofridge_"..private.win_hofridge.task[ i ], { alp = 1, input = 1 } );

             if ( private.win_hofridge.task[ i ] == "bank" or 
                  private.win_hofridge.task[ i ] == "canape" or 
                  private.win_hofridge.task[ i ] == "noodles" ) then

              public.Load ();

             end;

          end;

          num = num + 1;

       end;

   end;
   
   local func_end = function () int.Lock( false ) end;

   ObjAnimate( "ho_hofridge", "alp", 0, 0, func_end, 
   { 
    0,3,1, 
    0.6,3,1
   });

end;
--*********************************************************************************************************************
function private.Animation ()

  ObjAnimate( "spr_hofridge_add_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );
end;
--*********************************************************************************************************************