-- name=ho_hoscrypt
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_hoscrypt" );

  private.room_objname = "ho_hoscrypt";
  game.relations[ private.room_objname ].exitroom = "rm_farm";

  ObjSet( "spr_hoscrypt_amuletgate_2", { event_mdown = private.GetAmulet } );

   private.InitAnims();
  --------------------------------------------------------------------------------------------
  -- function opn_hoscrypt () end;
  --------------------------------------------------------------------------------------------
  local opn_hoscrypt = function ()

  end;

  cmn.AddSubscriber( "opn_hoscrypt", opn_hoscrypt, private.room_objname );
  --------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_hoscrypt" ] =
  {
    type = "get",
    get_obj = "spr_hoscrypt_win",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_hoscrypt_func = function ()

    if ( cmn.IsEventDone( "win_hoscrypt" ) ) then

      int.InventoryItemAdd( "inv_amuletgate_2", "spr_hoscrypt_win" );
      ObjDelete( "gho_farm_hoscrypt" );
      ObjDelete( "obj_hoscrypt_panel" );

    end;

  end;
  cmn.AddSubscriber( "win_hoscrypt", win_hoscrypt_func );
    --------------------------------------------------------------------------------------------------
  local win_hoscrypt_loc = function ()

    --if ( cmn.IsEventDone( "win_hoscrypt" ) ) and ( cmn.IsEventDone( "get_amuletgate_1" ) ) then
    if ( cmn.IsEventDone( "get_amuletgate_1" ) ) then

      ObjSet( "vid_nearcar_smoke_2", { alp = 1, playing = true, looped = true } );
      ObjDelete( "vid_nearcar_smoke_1" );

    end;

  end;
  cmn.AddSubscriber( "win_hoscrypt", win_hoscrypt_loc, "rm_nearcar" );
  --------------------------------------------------------------------------------------------------
  local UnmarkAmulet = function () 

    ObjSet( "spr_hoscrypt_shield",         { input = false, pos_x = 690, pos_y = 590  } ); 
    ObjSet( "spr_hoscrypt_amuletgate_2",   { input = true } ); 
    
  end;

  cmn.AddSubscriber( "UnmarkAmulet", UnmarkAmulet, "ho_hoscrypt" );  
  --------------------------------------------------------------------------------------------------
  local start_hoscrypt_func = function ()

    if ( cmn.IsEventStart( "win_hoscrypt" ) ) then

      common_impl.ProcessHoStart( "hoscrypt" );
      local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt" ].found;

        if cmn.IsUnmarkedTask( "hoscrypt", "amulet" ) then

            UnmarkAmulet();

        end;

      for i = 1, #ho_found, 1 do

        ObjDelete( ho_found[ i ][ "object" ] );

      end;



    end;

  end;
  cmn.AddSubscriber( "win_hoscrypt", start_hoscrypt_func, "ho_hoscrypt" );
  --------------------------------------------------------------------------------------------------
  for i = 1, 12 do

    ObjSet( "spr_hoscrypt_pic_"..i, { event_mdown = function () private.CompleteTask( "pic_"..i, i ); end, input = false  } );

  end;

  for i = 1, 12 do

    ObjSet( "spr_hoscrypt_rose_"..i, { event_mdown = function () private.CompleteTask( "rose_"..i, i ); end, input = false  } );

  end;
  --------------------------------------------------------------------------------------------------  
end;

--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function public.PreOpen ()

  local ho_tasks = {};
  cmn.InterfaceSetVisible( true );
  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventDone( "opn_hoscrypt" ) ) then

      cmn.SetEventDone( "opn_hoscrypt" );
      cmn.CallEventHandler( "opn_hoscrypt" );
      ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt" ].stage = 1;
      ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt" ].count = 12;
      ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt" ].all = { { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 }, { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 } };

  end;

  if ( not cmn.IsEventStart( "win_hoscrypt" ) ) then

    cmn.InitHo( "hoscrypt" );
    cmn.SetMarkedTask( "hoscrypt", "amulet" );

  end;

  for i = 1, 12 do

    interface.TaskPanelTaskAdd( ho_tasks, "pic_"..i,    1, 0, { { "spr_hoscrypt_pic_"..i } } );

  end;

  for i = 1, 12 do

    interface.TaskPanelTaskAdd( ho_tasks, "rose_"..i,    1, 0, { { "spr_hoscrypt_rose_"..i } } );

  end;

  interface.TaskPanelTaskAdd( ho_tasks, "amulet", 1, 1, { { "spr_hoscrypt_amuletgate_2" } } );

  int.TaskPanelShow( ho_tasks );
  private.Panel();

  common_impl.StopMusEnv( false );

--  cmn.StopAllEnv( "audio/level1/env/aud_townoutskirts_env" );
--
--  cmn.PlayAudio( "env", "audio/level1/env/aud_hoscrypt_env", 1 );
--  cmn.PlayAudio( "env", "audio/level1/env/aud_ho_theme_mus_env", 1 );
--
end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close ()

  --int.TaskPanelHide();
  common_impl.PassingHoStop();
  ObjAttach( "obj_hoscrypt_panel","ho_hoscrypt" );
  ObjSet( "int_inventory_impl", { input = true, alp = 1 } );
  
end;
--*********************************************************************************************************************
function public.HoComplete ()

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )

  int.Lock( true );

  local postfix = "";

  if ( number ) then

      local stage = ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt" ].stage;
      ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt" ].all[ stage ][ number ] = 0

  end;

  cmn.HoTaskFind( "spr_hoscrypt_"..name, name );
  common_impl.PassingHoCheck();
  private.ChangeTask();

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );
  ObjAttach( "obj_hoscrypt_panel" , "spr_int_taskpanel" );

  private.CheckTask();

end;
--********************************************************************************************************************* 
function private.ChangeTask () 

   ObjAnimate( "txt_hoscrypt_count", "ang", 0, 0, "", 
   {
     0.0, 3, 0.0,
     0.1, 3, 0.5,
     0.2, 3, -0.5,
     0.3, 3, 0.0
   } );

   ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt" ].count = ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt" ].count - 1;

   local stage = ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt" ].stage;
   local count = ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt" ].count;

   ObjSet( "txt_hoscrypt_count", { text = count } );

   if ( ( stage == 1 or stage == 2 ) and count == 0 ) then

      ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt" ].stage = ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt" ].stage + 1;

      local func_end = function ()

        ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt" ].count = 12;
        private.CheckTask();

      end;

      ObjAnimate( "txt_hoscrypt_task", "alp", 0, 0, "", 
      { 
        0,   0, 1, 
        0.3, 0, 0, 
        0.6, 0, 0, 
        0.9, 0, 1 
      })

      ObjAnimate( "ho_hoscrypt", "alp", 0, 0, func_end, 
      { 
        0,   0, 1, 
        0.3, 0, 1
      })

   else 

     int.Lock( false );

   end;
   
end;
--********************************************************************************************************************* 
function private.CheckTask () 

   local stage = ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt" ].stage;

   ObjSet( "txt_hoscrypt_task",  { text = "tsk_hoscrypt_task_"..stage } );
   ObjSet( "txt_hoscrypt_count", { text = ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt" ].count } );

   local func_end = function ()

     int.Lock( false );

   end;

   ObjAnimate( "txt_hoscrypt_task", "alp", 0, 0, func_end, 
   { 
     0,   0, 0, 
     0.3, 0, 1
   })

   if ( stage == 1 ) then

     ObjSet( "txt_hoscrypt_task", { pos_x = 50 } );
     ObjSet( "txt_hoscrypt_num",  { pos_x = 10 } );

      for i = 1, 12 do

        if ( ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt" ].all[ stage ][ i ] == 1 ) then

          ObjSet( "spr_hoscrypt_rose_"..i, { input = true  } );

        end;

      end;

   elseif ( stage == 2 ) then

      ObjSet( "txt_hoscrypt_task", { pos_x = 50 } );
      ObjSet( "txt_hoscrypt_num",  { pos_x = 10 } );

      for i = 1, 12 do

        if ( ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt" ].all[ stage ][ i ] == 1 ) then

          ObjSet( "spr_hoscrypt_pic_"..i, { input = true  } );

        end;    

      end;

  elseif ( stage == 3 ) then
   
    ObjSet( "txt_hoscrypt_num",          { alp = 0 } );
    ObjSet( "spr_hoscrypt_amuletgate_2", { input = true } ); 
    ObjSet( "spr_hoscrypt_shield",       { event_mdown = private.ClkShield, input = true } );
    ObjSet( "txt_hoscrypt_task",         { pos_x = 50 } );

  end;

end;
--*********************************************************************************************************************
function private.ClkShield ()

  local func_end = function ()

    int.Lock( false );
    cmn.UnmarkTask( "hoscrypt", "amulet" );
    cmn.CallEventHandler( "UnmarkAmulet" );
    int.Lock( false );

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_moveshield" ); 

  ObjAnimate( "spr_hoscrypt_shield", "pos_xy", 0, 0, func_end, 
  {
    0.0, 3, 645,552,
    0.5, 3, 690,590
  } );

end;
--*********************************************************************************************************************
function private.GetAmulet ()

  local func_end = function ()

    int.Lock( false );
    cmn.CallEventHandler( "win_hoscrypt_loc" );

  end;

  int.Lock( true );
  MsgSend( Event_DialogHo_Show, {} );
  ObjAnimate( "spr_hoscrypt_amuletgate_2", "alp", 0, 0, func_end, 
  {
    0.0, 3, 1.0,
    0.3, 3, 0.0,
  } );

end;
--*********************************************************************************************************************
function private.InitAnims ()

  ObjAnimate( "txt_hoscrypt_num", "scale_xy", 1, 0, "",
  { 
    0.0, 3, 1.05,1.05,
    2.0, 3, 0.95,0.95,
    3.0, 3, 1.05,1.05
  } );

end;
--********************************************************************************************************************* 