-- name=ho_house
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_house" );
  game.relations[ "ho_house" ].exitroom = "rm_livingroomext";
  private.room_objname = "ho_house";

  ObjSet( "spr_house_amuletfire_1", { event_mdown = private.GetAmulet } );
  private.pairs = {"",""};
  private.win_house = {};

  private.Animations();
  ObjMultiSet( {
   { "obj_house_head",       { event_mdown = private.ClkHead } },
  } );
  --------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_house" ] =
  {
    type = "win",
    win_ho = "",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_house_func = function ()

    if ( cmn.IsEventDone( "win_house" ) ) then

      int.InventoryItemAdd( "inv_amuletfire_1", "spr_house_win" );
      ObjDelete( "gho_livingroomext_house" );
      ObjDelete( "spr_house_panel" );

    else 

    end;

  end;
  cmn.AddSubscriber( "win_house", win_house_func );
  --------------------------------------------------------------------------------------------------
  local start_house_func = function ()

    if ( cmn.IsEventStart( "win_house" ) ) then

        common_impl.ProcessHoStart( "house" );

    end;

  end;
  cmn.AddSubscriber( "win_house", start_house_func, "ho_house" );
  --------------------------------------------------------------------------------------------------
  private.win_house.task = { "broom_1", "broom_2", "bulb_1", "bulb_2", "card_1", "card_2", "clown_1", "clown_2", "derby_1", "derby_2", 
                             "magic_ball_1", "magic_ball_2", "animal_1", "animal_2", "bird_1", "bird_2", "drupel_1", "drupel_2", "fly_1", "fly_2", 
                             "horse_1", "horse_2", "snake_1", "snake_2" };

  for i = 1, #private.win_house.task do

    ObjSet( "spr_house_"..private.win_house.task[ i ], { event_mdown = function () private.ClkItem( private.win_house.task[ i ] ); end } );

  end;
 
  -------------------------------------------------
end;

--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.InterfaceSetVisible( true );
  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  local ho_tasks = {};

  if ( not cmn.IsEventStart( "win_house" ) ) then

    cmn.InitHo( "house" );

  end;

  if ( not cmn.IsEventDone( "opn_house" ) ) then

      cmn.SetEventDone( "opn_house" );
      cmn.CallEventHandler( "opn_house" );

      ng_global.progress[ ng_global.currentprogress ][ "win_house" ].stage = 0;
      ng_global.progress[ ng_global.currentprogress ][ "win_house" ].clk_head = false;
      
      cmn.PlayAudio( "mus", "audio/aud_all_is_boost_mus" );
      
  end;

  interface.TaskPanelTaskAdd( ho_tasks, "broom_1",        1, 0, { { "spr_house_broom_1","spr_house_broom_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "broom_2",        1, 0, { { "spr_house_broom_2","spr_house_broom_1" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "bulb_1",         1, 0, { { "spr_house_bulb_1","spr_house_bulb_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "bulb_2",         1, 0, { { "spr_house_bulb_2","spr_house_bulb_1" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "card_1",         1, 0, { { "spr_house_card_1","spr_house_card_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "card_2",         1, 0, { { "spr_house_card_2","spr_house_card_1" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "clown_1",        1, 0, { { "spr_house_clown_1","spr_house_clown_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "clown_2",        1, 0, { { "spr_house_clown_2","spr_house_clown_1" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "derby_1",        1, 0, { { "spr_house_derby_1","spr_house_derby_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "derby_2",        1, 0, { { "spr_house_derby_2","spr_house_derby_1" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "magic_ball_1",   1, 0, { { "spr_house_magic_ball_1","spr_house_magic_ball_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "magic_ball_2",   1, 0, { { "spr_house_magic_ball_2","spr_house_magic_ball_1" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "animal_1",       1, 0, { { "spr_house_animal_1","spr_house_animal_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "animal_2",       1, 0, { { "spr_house_animal_2","spr_house_animal_1" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "bird_1",         1, 0, { { "spr_house_bird_1","spr_house_bird_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "bird_2",         1, 0, { { "spr_house_bird_2","spr_house_bird_1" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "drupel_1",       1, 0, { { "spr_house_drupel_1","spr_house_drupel_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "drupel_2",       1, 0, { { "spr_house_drupel_2","spr_house_drupel_1" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "fly_1",          1, 0, { { "spr_house_fly_1","spr_house_fly_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "fly_2",          1, 0, { { "spr_house_fly_2","spr_house_fly_1" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "horse_1",        1, 0, { { "spr_house_horse_1","spr_house_horse_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "horse_2",        1, 0, { { "spr_house_horse_2","spr_house_horse_1" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "snake_1",        1, 0, { { "spr_house_snake_1","spr_house_snake_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "snake_2",        1, 0, { { "spr_house_snake_2","spr_house_snake_1" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "amuletfire",     1, 0, { { "spr_house_amuletfire_1" } } );

  int.TaskPanelShow( ho_tasks );
  private.Panel();
  
  if ( ng_global.progress[ ng_global.currentprogress ][ "win_house" ].clk_head ) then 
    
    ObjDelete( "obj_house_head" );
    ObjDelete( "anm_house_head" );
    ObjSet( "anm_house_head_end", { alp = 1 } );
    
  end;
  
  common_impl.StopMusEnv( false );

--  cmn.StopAllEnv( "audio/level4/env/aud_townoutskirts_env" );
--  cmn.PlayAudio( "env", "audio/level4/env/aud_townoutskirts_env", 1 );
--
--  cmn.PlayAudio( "env", "audio/level1/env/aud_ho_theme_mus_env", 1 );

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();
  ObjSet( "int_inventory_impl", { input = true } );
  ObjAttach( "obj_house_panel", "ho_house" );

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();
  --cmn.StopAudio( "env", "audio/level1/env/aud_ho_theme_mus_env", 0.3 );

end;
--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function private.CompleteTask ( name )

  int.Lock( false );    

  ObjSet( "spr_house_"..name, { input = 0 } );

  if ( private.pairs[1] == "" ) then

     private.pairs[1] = name;
     int.Lock( true );
     private.AttachObj( name, 1 );

  else

     private.pairs[2] = name;
     int.Lock( true );
     private.AttachObj( name, 2 );

  end;

  common_impl.PassingHoCheck();
   
end;
--*********************************************************************************************************************
function private.ClkItem ( name )

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_click" );
  for i = 1,24 do

      if ( private.win_house.task[i] == name ) then

          private.CompleteTask( name );

          ObjSet( "spr_house_"..name, { input = 0 } ); 

          break;

      end; 

  end;              

end;
--*********************************************************************************************************************
function private.AttachObj ( name, pos )

  local spr = "spr_house_"..name.."_obj";
  local item_add = "spr_house_"..name.."_add";

  local func_end = function ()

      private.Check();

  end;

  ObjDelete( spr );
  ObjCreate( spr, "spr" );

  ObjSet( spr, { alp = 0, res = "assets/levels/levelext/ho_house/layers/inv/"..name } );

  ObjAnimate( "txt_house_task", "alp", 0, 0, "", 
  { 
    0,0,ObjGet( "txt_house_task" ).alp, 
    0.3,0,0 
  });

  ObjAnimate( spr, "alp", 0, 0, "", 
  { 
    0,0,0, 
    0.3,0,1 
  });

  ObjAnimate( item_add, "alp", 0, 0, "", 
  { 
    0.0,  0,  ObjGet( item_add ).alp,
    0.3,  0,  1
  } );     

  ObjAnimate( "obj_house_obj"..pos, "scale_xy", 0, 0, func_end, 
  { 
    0,0,1,1, 
    0.2,0,1.3,1.3, 
    0.4,0,1,1
  });
  
  ObjAttach( spr , "obj_house_obj"..pos );

end;
--*********************************************************************************************************************
function private.Check ()

  int.Lock( false );

  if ( private.pairs[1] ~= "" and private.pairs[2] ~= "" ) then

     local pairs1_full_len = string.len( private.pairs[1] );
     local pairs_len1 = string.sub( private.pairs[1], 1, pairs1_full_len-2 );
     local pairs2_full_len = string.len( private.pairs[2] );
     local pairs_len2 = string.sub( private.pairs[2], 1, pairs2_full_len-2 );
   
     if ( pairs_len1 == pairs_len2 ) then

        int.Lock( true );
        private.AnimateStage();
        
     else 
        
        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_home_ho_anim" );

        int.Lock( true );

        local func_end = function ()

            private.Default();

        end;

        for i = 1,2 do

            ObjAnimate( "obj_house_obj"..i, "ang", 0, 0, "", 
            { 
              0,0,0, 
              0.1,0,0.2,
              0.3,0,-0.2,
              0.4,0,0
            });

        end;

        ObjAnimate( "ho_house", "alp", 0, 0, func_end, 
        { 
          0,0,1, 
          0.5,0,1 
        });

        private.Back();

     end;

  end;

end;
--*********************************************************************************************************************
function private.AnimateStage ()

  cmn.HoTaskFind( "spr_house_"..private.pairs[1], private.pairs[ 1 ] );
  cmn.StopAudio( "sfx", "audio/aud_hide_sfx" );
  cmn.HoTaskFind( "spr_house_"..private.pairs[2], private.pairs[ 2 ] );

  --common_impl.PassingHoCheck();

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_home_ho_anim" );
  ng_global.progress[ ng_global.currentprogress ][ "win_house" ].stage = ng_global.progress[ ng_global.currentprogress ][ "win_house" ].stage + 1;

  for i = 1,2 do

      ObjAnimate( "obj_house_obj"..i, "scale_xy", 0, 0, "", 
      { 
        0,0,ObjGet( "obj_house_obj"..i ).scale_x,ObjGet( "obj_house_obj"..i ).scale_y,
        0.3,0,ObjGet( "obj_house_obj"..i ).scale_x,ObjGet( "obj_house_obj"..i ).scale_y, 
        1,0,0.7,0.7
      });  

      ObjAnimate( "obj_house_obj"..i, "pos_xy", 0, 0, "", 
      { 
        0,0,ObjGet( "obj_house_obj"..i ).pos_x,ObjGet( "obj_house_obj"..i ).pos_y, 
        0.3,0,ObjGet( "obj_house_obj"..i ).pos_x,ObjGet( "obj_house_obj"..i ).pos_y, 
        1,0,0,22
      });  

  end;

  local func_end = function ()

      private.AnimatePFX();
      private.Stage();

  end;

  ObjAnimate( "ho_house", "alp", 0, 0, func_end, 
  { 
    0,0,1, 
    0.9,0,1 
  });
  
end;
--*********************************************************************************************************************
function private.AnimatePFX ()

  int.Lock( true );

  local func_end = function ()

      int.Lock( false );

  end;

  ObjAnimate( "ho_house", "alp", 0, 0, func_end, 
  { 
    0,0,1, 
    2,0,1
  });

  local collect_name  = "pfx_house_"..private.pairs[1].."_effect";
  ObjCreate( collect_name, "partsys" );

  ObjSet( collect_name,
  {
    res = "assets/interface/resources/effects_ho_hint",
    pos_y = 20,
    active = 1, visible = 1, input = 0
  } );

  ObjAttach( collect_name, "obj_house_panel" );
  ObjSet(collect_name, { blendmode = 2, scale_x  = 1.7, scale_y  = 1.7, pos_z = 10 } );

  local func_end2 = function ()

      private.Default();

  end;

  ObjAnimate( "txt_house_task", "alp", 0, 0, func_end2, 
  { 
    0,0,ObjGet( "txt_house_task" ).alp, 
    1,0,ObjGet( "txt_house_task" ).alp, 
    1.3,0,1 
  });

  local spr1 = "spr_house_"..private.pairs[1].."_obj";
  local spr2 = "spr_house_"..private.pairs[2].."_obj";

  ObjAnimate( spr1, "alp", 0, 0, "", 
  { 
    0,0,1,
    0.3,0,0 
  });

  ObjAnimate( spr2, "alp", 0, 0, "", 
  { 
    0,0,1, 
    0.3,0,0 
  });

  ObjSet( "obj_house_obj1", { pos_x = -150, scale_x  = 1.1, scale_y = 1.1 } );
  ObjSet( "obj_house_obj2", { pos_x = 150, scale_x  = 1.1, scale_y = 1.1 } );

end;
--*********************************************************************************************************************
function private.Back ()

  for i = 1,24 do

      for j = 1,2 do

          if ( private.win_house.task[i] == private.pairs[j] ) then
              
              ObjSet( "spr_house_"..private.pairs[j], { input = 1 } );

          end;

      end;

  end;

end;
--*********************************************************************************************************************
function private.Default ()

  ObjSet( "obj_house_obj1", { pos_x = -150, scale_x  = 1.0, scale_y = 1.0 } );
  ObjSet( "obj_house_obj2", { pos_x = 150, scale_x  = 1.0, scale_y = 1.0 } );

  local spr1 = "spr_house_"..private.pairs[1].."_obj";
  local spr2 = "spr_house_"..private.pairs[2].."_obj";

  local item_add_1 = "spr_house_"..private.pairs[1].."_add";
  local item_add_2 = "spr_house_"..private.pairs[2].."_add";

  ObjAnimate( spr1, "alp", 0, 0, "", 
  { 
    0,0,ObjGet( spr1 ).alp,
    0.3,0,0 
  });

  ObjAnimate( spr2, "alp", 0, 0, "", 
  { 
    0,0,ObjGet( spr2 ).alp, 
    0.3,0,0 
  });

  private.pairs[1] = "";
  private.pairs[2] = "";

  local func_end = function ()

      int.Lock( false );

  end;

  ObjAnimate( "txt_house_task", "alp", 0, 0, func_end, 
  { 
    0,0,ObjGet( "txt_house_task" ).alp, 
    0.5,0,ObjGet( "txt_house_task" ).alp, 
    1,0,1 
  });
  
  if ( ObjGet( item_add_1 ) ) then
    
  ObjAnimate( item_add_1, "alp", 0, 0, "", 
  { 
    0.0,  0,  ObjGet( item_add_1 ).alp,
    0.3,  0,  0
  } ); 

  ObjAnimate( item_add_2, "alp", 0, 0, "", 
  { 
    0.0,  0,  ObjGet( item_add_2 ).alp,
    0.3,  0,  0
  } ); 
  
  end;

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0, input = false } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );
  private.Stage();

  ObjAttach( "obj_house_panel", "int_taskpanel_impl" );
  
end;

--*********************************************************************************************************************
function private.Stage ()

  for i = 1,ng_global.progress[ ng_global.currentprogress ][ "win_house" ].stage do

         ObjSet( "spr_house_light_add_"..i, { alp = 1 } );

  end; 

  if ( ng_global.progress[ ng_global.currentprogress ][ "win_house" ].stage == 12 ) then

    ObjSet( "txt_house_task", { text = "tsk_house_task_2" } );
    ObjSet( "spr_house_amuletfire_1", { input = true } );
    ObjSet( "gfx_house_amuletfire_1", { alp = true, active = true } );

  end;

end;
--*********************************************************************************************************************
function private.GetAmulet ()

  local func_end = function ()

    int.Lock( false );

  end;

  int.Lock( true );
  MsgSend( Event_DialogHo_Show, {} );
  ObjAnimate( "spr_house_amuletfire_1", "alp", 0, 0, func_end, 
  {
    0.0, 3, 1.0,
    0.3, 3, 0.0,
  } );

end;
--*********************************************************************************************************************
function private.Animations ()

  ObjAnimate( "spr_house_derby_2_light", "alp", 1, 0, "", 
  { 
    0,3,1, 
    0.7,3,0.5,
    1.4,3,1      
  });

  ObjAnimate( "spr_house_magic_ball_2_light", "alp", 1, 0, "", 
  { 
    0,  3, 1, 
    1,  3, 0.5,
    1.4,3, 1,
    3,  3, 0.3,
    5,  3, 1         
  });

  ObjAnimate( "spr_house_magic_ball_1_light", "alp", 1, 0, "", 
  { 
    0,  3, 1, 
    2,  3, 0.5,
    2.4,3, 1,
    4,  3, 0.3,
    4.5,  3, 1          
  });

  ObjAnimate( "spr_house_monster", "ang", 1, 0, "", 
  {
    0.0, 3, 0.1,
    2.5, 3, -0.1,
    5.0, 3, 0.1,
  } );
  ObjAnimate( "spr_house_girl_1", "ang", 1, 0, "", 
  {
    0.0, 3, -0.12,
    4.5, 3, 0.12,
    9.0, 3, -0.12
  } );
  ObjAnimate( "spr_house_girl_2", "ang", 1, 0, "", 
  {
    0.0, 3, 0.06,
    3.5, 3, -0.06,
    7.0, 3, 0.06
  } );
  ObjAnimate( "spr_house_girl_3", "ang", 1, 0, "", 
  {
    0.0, 3, -0.05,
    5.5, 3, 0.05,
    11.0, 3, -0.05
  } );

end;
--*********************************************************************************************************************
function private.ClkHead ()

  local func_end = function ()

    int.Lock( false );
    --cmn.ShowBbt( "bbt_pit_use_chisel" );
    ng_global.progress[ ng_global.currentprogress ][ "win_house" ].clk_head = true;
    
  end;

  int.Lock( true );
  ObjSet( "obj_house_head", { input = false } );
  --cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_case_touch" );
  AnimPlay( "anm_house_head", "DoAnim", func_end );

end;
--*********************************************************************************************************************