-- name=mg_mgbook
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_mgbook";
  game.relations[ "mg_mgbook" ].exitroom = "rm_nearcar";

  private.Init();
  private.InitAnims();

  ObjSet( "spr_mgbook_book", { event_mdown = private.get_book } );

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mgbook = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;
  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    

      visible_sparkle_area = false;

    end;

    local visible_sparkle_ho = true;  

    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    

      visible_sparkle_ho = false;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then

      ObjMultiSet( table_multiset );

    end;

  end;

  cmn.AddSubscriber( "update_game_mode_mgbook", update_game_mode_mgbook, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_book () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_book" ] =
  {
    type = "get",
    get_obj = "spr_mgbook_book",
    room = private.room_objname,
  };
  -----------------------------------------------
  local get_book_inv = function ()

    int.InventoryItemAdd( "inv_book", "spr_mgbook_book" );
    ObjSet( "inv_book", { drag = false } );

  end;

  local get_book_closezz = function ()

    ObjDelete( "gfx_mgbook_book" );
    ObjDelete( "spr_mgbook_book_shadow" );

  end;

  local get_book_loc = function ()

    ObjDelete( "gmg_nearcar_mgbook" );
    ObjDelete( "spr_nearcar_zzbook_book" );

  end;
  
  cmn.AddSubscriber( "get_book", get_book_inv );
  cmn.AddSubscriber( "get_book", get_book_closezz, private.room_objname );
  cmn.AddSubscriber( "get_book", get_book_loc, "rm_nearcar" );
  --------------------------------------------------------------------------------------------
  -- function win_mgbook () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_mgbook" ] =
  {
    type = "click",
    get_obj = "spr_mgbook_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_mgbook = function ()

    if ( cmn.IsEventDone( "win_mgbook" ) ) then

      --int.DeleteTaskMap( "rm_nearcar", "win_mgbook" );

      ObjSet( "spr_mgbook_book",        { input = true, active = true } );
      ObjSet( "obj_mgbook_chain_open",  { alp = 1 } );
      ObjDelete( "obj_mgbook_lock_up" );
      ObjDelete( "obj_mgbook_lock_down" );
      ObjDelete( "obj_mgbook_chain_close" );

    elseif ( cmn.IsEventStart( "win_mgbook" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_mgbook", win_mgbook, private.room_objname );

end;
-------------------------------------------------
function private.get_book ()

  cmn.SetEventDone( "get_book" );
  cmn.CallEventHandler( "get_book" );
  
  cmn.GetObjectSfx();

  cmn.GotoRoom( "rm_nearcar" );

end;
--*********************************************************************************************************************
function private.Init ()

  private.colors =
  {
    { { "red",   "blue"   }, { "blue",   "green"  }, { "green",  "yellow" }, { "yellow", "green" }, { "green", "red"   } },
    { { "blue",  "yellow" }, { "yellow", "green"  }, { "green",  "blue"   }, { "blue",   "red"   }, { "red",   "blue"  } },
    { { "green", "red"    }, { "red",    "yellow" }, { "yellow", "green"  }, { "green",  "blue"  }, { "blue",  "green" } },
  };

  private.count_stars = 3;
  private.delta = -1.256;

  for s = 1, private.count_stars do

    ObjSet( "spr_mgbook_star_"..s,
    {
      input = true,
      event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      event_mdown  = function () private.StarClick( s ) end,
    } );

  end;

end;
--*********************************************************************************************************************
function private.Load ()

  private.SetColors();

  for s = 1, private.count_stars do

    local ang = ng_global.progress[ "ext" ][ "win_mgbook" ].pos[ s ] * private.delta;

    ObjSet( "obj_mgbook_star_"..s,            { ang = ang } );
    ObjSet( "obj_mgbook_star_"..s.."_shadow", { ang = ang } );

  end;

end;
--*********************************************************************************************************************
function public.PreOpen () 

  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventStart( "win_mgbook" ) ) then

    ng_global.progress[ "ext" ][ "win_mgbook" ].pos = { 4, 2, 3 };

  end;

  --cmn.StopAllEnv( "audio/levelext/env/aud_nearcar_env" );
  --cmn.PlayAudio( "env", "audio/levelext/env/aud_nearcar_env", 1 );

  --common_impl.PlayMusEnv();

end;
--*********************************************************************************************************************
function public.Open () 

  if ( not cmn.IsEventDone( "win_mgbook" ) ) then

    cmn.MiniGameShow( "mgbook" );
    common_impl.PassingMgStart( "mgbook" );

  end;

  if ( not cmn.IsEventDone( "opn_mgbook" ) ) then

    cmn.SetEventDone( "opn_mgbook" );

  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  cmn.MiniGameHide();
  common_impl.PassingMgStop( "mgbook" );

end;
--*********************************************************************************************************************
function public.Reset ()

  local ang_start = { -5.024, -2.512, -3.768 };

  for s = 1, private.count_stars do

    ObjSet( "obj_mgbook_star_"..s,            { ang = ang_start[ s ] } );
    ObjSet( "obj_mgbook_star_"..s.."_shadow", { ang = ang_start[ s ] } );

  end;

  ng_global.progress[ "ext" ][ "win_mgbook" ].pos = { 4, 2, 3 };

  private.SetColors();

end;
--*********************************************************************************************************************
function public.Skip ()
port.skip_mg = true;
  private.WinAnim();

end;
--*********************************************************************************************************************
function private.WinAnim ( idx, pos_end )

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

    if ( idx and pos_end ) then

      ng_global.progress[ "ext" ][ "win_mgbook" ].pos[ idx ] = pos_end;

    end;

    private.Win();

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_skull_mg_win" );

  ObjAnimate( "obj_mgbook_chain_close", "alp", 0, 0, "", 
  {
    0.0, 3, 1.0,
    0.3, 3, 0.0,
  } );

  ObjAnimate( "obj_mgbook_chain_open", "alp", 0, 0, "", 
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

  ObjAnimate( "obj_mgbook_lock_up", "pos_y", 0, 0, "", 
  {
    0.0, 3,    0,
    0.3, 3,    0,
    2.0, 3, -280,
  } );

  ObjAnimate( "obj_mgbook_lock_down", "pos_y", 0, 0, func_end, 
  {
    0.0, 3,   0,
    0.3, 3,   0,
    2.0, 3, 770,
  } );

end;
--*********************************************************************************************************************
function private.Win ()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_mgbook" );
  cmn.CallEventHandler( "win_mgbook" );
  common_impl.PassingMgWin( "mgbook" );
  
  cmn.PlayAudio( "mus", "audio/aud_all_is_lost_mus" );

end;
--*********************************************************************************************************************
function private.StarClick ( idx )

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_rotate_mg" ); 
  local star   = "obj_mgbook_star_"..idx;
  local shadow = "obj_mgbook_star_"..idx.."_shadow";

  local pos_start = ng_global.progress[ "ext" ][ "win_mgbook" ].pos[ idx ];
  local pos_end = pos_start + 1;

  local ang_start = private.delta * pos_start;
  local ang_end   = private.delta * pos_end;

  local func_end = function ()

    int.Lock( false );

    if ( pos_end > 5 ) then pos_end = 1 end;

    if ( private.IsWin( idx, pos_end ) ) then

      private.WinAnim( idx, pos_end );

    else

      ng_global.progress[ "ext" ][ "win_mgbook" ].pos[ idx ] = pos_end;

    end;

  end;

  ObjAnimate( shadow, "ang", 0, 0, "", 
  {
    0.0, 3, ang_start,
    0.5, 3, ang_end,
  } );

  ObjAnimate( star, "ang", 0, 0, func_end, 
  {
    0.0, 3, ang_start,
    0.5, 3, ang_end,
  } );

  ObjAnimate( "spr_mgbook_color_"..idx.."_1", "alp", 0, 0, "", 
  {
    0.00, 3, 1.0,
    0.25, 3, 0.0,
    0.50, 3, 1.0,
  } );

  ObjAnimate( "spr_mgbook_color_"..idx.."_2", "alp", 0, 0, "", 
  {
    0.00, 3, 1.0,
    0.25, 3, 0.0,
    0.50, 3, 1.0,
  } );
  ObjAnimate( "spr_mgbook_color_"..idx.."_1", "scale_x", 0, 0,
  function ()

    if ( pos_end > 5 ) then pos_end = 1 end;

    ObjSet( "spr_mgbook_color_"..idx.."_1", { res = "assets/levels/levelext/mg_mgbook/layers/"..private.colors[ idx ][ pos_end ][ 1 ] } );
    ObjSet( "spr_mgbook_color_"..idx.."_2", { res = "assets/levels/levelext/mg_mgbook/layers/"..private.colors[ idx ][ pos_end ][ 2 ] } );

  end, 
  {
    0.00, 3, 1.0,
    0.25, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
function private.SetColors ()

  for s = 1, private.count_stars do

    local pos = ng_global.progress[ "ext" ][ "win_mgbook" ].pos[ s ];

    ObjSet( "spr_mgbook_color_"..s.."_1",     { res = "assets/levels/levelext/mg_mgbook/layers/"..private.colors[ s ][ pos ][ 1 ] } );
    ObjSet( "spr_mgbook_color_"..s.."_2",     { res = "assets/levels/levelext/mg_mgbook/layers/"..private.colors[ s ][ pos ][ 2 ] } );

  end;

end;
--*********************************************************************************************************************
function private.IsWin ( idx, pos_end )

  local tmp_stars = {};
  local colors    = { {}, {}, {} };

  for s = 1, private.count_stars do

    tmp_stars[ s ] = ng_global.progress[ "ext" ][ "win_mgbook" ].pos[ s ];

  end;

  tmp_stars[ idx ] = pos_end;

  for s = 1, private.count_stars do

    colors[ s ][ 1 ] = private.colors[ s ][ tmp_stars[ s ] ][ 1 ];
    colors[ s ][ 2 ] = private.colors[ s ][ tmp_stars[ s ] ][ 2 ];

  end;

  if ( colors[ 1 ][ 2 ] == colors[ 2 ][ 1 ] ) and
     ( colors[ 1 ][ 1 ] == colors[ 3 ][ 2 ] ) and
     ( colors[ 2 ][ 2 ] == colors[ 3 ][ 1 ] ) then

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
function private.InitAnims ()

  ObjAnimate( "spr_mgbook_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_mgbook_star_1_eyes", "alp", 1, 0, "", 
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
    0.6, 3, 0.0,
    5.6, 3, 0.0,
  } );

  ObjAnimate( "spr_mgbook_star_2_eyes", "alp", 1, 0, "", 
  {
    0.0, 3, 0.0,
    3.0, 3, 0.0,
    3.3, 3, 1.0,
    3.6, 3, 0.0,
    8.6, 3, 0.0,
  } );

  ObjAnimate( "spr_mgbook_star_3_eyes", "alp", 1, 0, "", 
  {
    0.0, 3, 0.0,
    1.5, 3, 0.0,
    1.8, 3, 1.0,
    2.1, 3, 0.0,
    9.6, 3, 0.0,
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************