-- name=mg_mgstatue
--*********************************************************************************************************************
function public.Init ()
  
  private.obj_names = {};

  private.room_objname = "mg_mgstatue";
  game.relations[ "mg_mgstatue" ].exitroom = "rm_cemetery";
  
  private.objs = { "ball","car","cat","girl","luggage","man","man1","people","pointer","toy", 
                   "sign", "bag", "bag1", "bike", "drawing", "kettle", "man2", "squirrel", "thorns", "wheel" 
                 };
  private.state = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }; 
 
  ObjSet( "spr_mgstatue_brokenlantern", { event_mdown = private.get_brokenlantern } ); 
  
  for i=1, #private.objs do
    ObjSet( "spr_mgstatue_final_"..private.objs[i], {
      --input = true,
      event_mdown = function() private.ItemMEnter ( private.objs[i], true ); end,
      --event_mleave = function() private.ItemMLeave ( private.objs[i], true ); end,
    } );
    ObjSet( "spr_mgstatue_init_"..private.objs[i], {
      --input = true,      
      drag = true,
      --event_menter = function() private.ItemMEnter ( private.objs[i], false ); end,
      --event_mleave = function() private.ItemMLeave ( private.objs[i], false ); end,
      event_startdrag = function() private.ItemStartDrag ( private.objs[i] ); end,
      event_dragdrop = function() private.ItemDragDrop ( private.objs[i] ); end,
      } );
  end;

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_mgstatue = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;

      local mas_parent_gfx = 
      {
        private.room_objname
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_mgstatue", update_game_mode_mgstatue, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function win_mgstatue () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_mgstatue" ] =
  {
    type = "click",
    get_obj = "spr_mgstatue_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_mgstatue = function ()

    if ( cmn.IsEventDone( "win_mgstatue" ) ) then

      for i=1, #private.state do        
        ObjSet( "spr_mgstatue_final_"..private.objs[ i ], { alp = 1, input = true } );
      end;
      ObjSet( "obj_mgstatue_open", { alp = 1, input = true } );
      ObjSet( "gfx_mgstatue_brokenlantern", { active = true } );
      ObjSet( "obj_mgstatue_final", { input = false } );
      ObjDelete( "anm_mgstatue_open" );
      ObjDelete( "obj_mgstatue_initial" );
      ObjDelete( "spr_mgstatue_final_man1" );
      ObjDelete( "spr_mgstatue_final_people" );
      ObjDelete( "spr_mgstatue_final_luggage" );
      
    elseif ( cmn.IsEventStart( "win_mgstatue" ) ) then

      private.Load();

    end;

  end;
  
  local win_mgstatue_loc = function ()
  
    if ( cmn.IsEventDone( "win_mgstatue" ) ) then
      
      ObjDelete( "spr_cemetery_statue_mg_statue_2" );
      ObjSet( "spr_cemetery_statue_mg_statue_1", { alp = 1 } );
      
    end;
  
  end;
  
  cmn.AddSubscriber( "win_mgstatue", win_mgstatue, private.room_objname );
  cmn.AddSubscriber( "win_mgstatue", win_mgstatue_loc, "rm_cemetery" );
  
  --------------------------------------------------------------------------------------------
  -- function get_brokenlantern () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brokenlantern" ] =
  {
    type = "get",
    get_obj = "spr_mgstatue_brokenlantern",
    room = private.room_objname,
  };
  -----------------------------------------------
  local get_brokenlantern_inv = function ()

    int.InventoryItemAdd( "inv_brokenlantern", "spr_mgstatue_brokenlantern" );
    ObjSet( "inv_brokenlantern", { drag = false } );

  end;

  local get_brokenlantern_closezz = function ()

    ObjDelete( "gfx_mgstatue_brokenlantern" );
    ObjDelete( "spr_mgstatue_brokenlantern_shadow" );

  end;
  local get_brokenlantern_loc = function ()

    ObjDelete( "gmg_cemetery_mgstatue" );
    ObjDelete( "spr_cemetery_statue_lamp" );
        
  end;

  cmn.AddSubscriber( "get_brokenlantern", get_brokenlantern_inv );
  cmn.AddSubscriber( "get_brokenlantern", get_brokenlantern_closezz, private.room_objname );
  cmn.AddSubscriber( "get_brokenlantern", get_brokenlantern_loc, "rm_cemetery" );


end;

-------------------------------------------------
function private.get_brokenlantern ()

  cmn.SetEventDone( "get_brokenlantern" );
  cmn.CallEventHandler( "get_brokenlantern" );
  
  cmn.GetObjectSfx();
  
  cmn.GotoRoom( "rm_cemetery" );

end;
  
--*********************************************************************************************************************
function private.Start ()
  
  cmn.MiniGameShow( "mgstatue" );
  
  ng_global.progress[ "ext" ][ "win_mgstatue" ].state = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };  

end;
--*********************************************************************************************************************
function private.Load ()
  
  for i=1, #private.state do
    
    private.state[ i ] = ng_global.progress[ "ext" ][ "win_mgstatue" ].state[ i ];
    if ( private.state[ i ] == 1 ) then
      ObjSet( "spr_mgstatue_init_"..private.objs[ i ], { alp = 0, input = false } );
      ObjSet( "spr_mgstatue_final_"..private.objs[ i ], { alp = 1, input = true } );
    else
    end;
    
  end;  

end;
--*********************************************************************************************************************
function public.PreOpen () 

  --int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

end;
--*********************************************************************************************************************
function public.Open () 

  if ( not cmn.IsEventStart( "win_mgstatue" ) ) then
    private.Start();
  end;

  if ( cmn.IsEventStart( "win_mgstatue" ) and not cmn.IsEventDone( "win_mgstatue" ) ) then
    cmn.MiniGameShow( "mgstatue" );
    common_impl.PassingMgStart( "mgstatue" );
  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  if ( cmn.IsEventStart( "win_mgstatue" ) and not cmn.IsEventDone( "win_mgstatue" ) ) then
    cmn.MiniGameHide();
    common_impl.PassingMgStop( "mgstatue" );
  end;

end;
--*********************************************************************************************************************
function public.Reset ()
  
  private.state = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }; 
  ng_global.progress[ "ext" ][ "win_mgstatue" ].state = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };  
 
  for i=1, #private.state do
    ObjSet( "spr_mgstatue_init_"..private.objs[ i ], { alp = 1, input = true } );
    ObjSet( "spr_mgstatue_final_"..private.objs[ i ], { alp = 0, input = false } );
  end;

end;
--*********************************************************************************************************************
function public.Skip ()
port.skip_mg = true;
  for i=1, #private.state do
    ObjSet( "spr_mgstatue_init_"..private.objs[ i ], { alp = 0, input = false } );
    ObjSet( "spr_mgstatue_final_"..private.objs[ i ], { alp = 1, input = true } );
  end;
  private.Win();

end;
--*********************************************************************************************************************
function private.ItemMEnter ( obj, isFinal )

  local item = "";
  
  if (isFinal) then    
    
    item = "spr_mgstatue_final_"..obj.."_light";
    ObjAnimate(item, "alp", 0, 0, "", 
    {
      0.0,0,ObjGet( item ).alp,
      0.2,0,1
    });
    item = "anm_mgstatue_final_"..obj.."_fx";
    AnimPlay( item, "DoAnim", function() private.ItemMLeaveTimer(obj); end  );
    
  else
    
    cmn.SetCursor(CURSOR_GET);
    
    item = "spr_mgstatue_init_"..obj.."_light";
    ObjAnimate(item, "alp", 0, 0, "", 
    {
      0.0,0,ObjGet( item ).alp,
      0.2,0,1
    });
    
  end;

end;

function private.ItemMLeaveTimer( num )
  private.ItemMLeave ( num, true );
end;
--*********************************************************************************************************************
function private.ItemMLeave ( obj, isFinal )
  
  cmn.SetCursor(CURSOR_DEFAULT);
  
  local item = "";
  
  if (isFinal) then
    
    item = "spr_mgstatue_final_"..obj.."_light";
    ObjAnimate(item, "alp", 0, 0, "", 
    {
      0.0,0,ObjGet( item ).alp,
      0.2,0,0
    });
    
  else
    
    item = "spr_mgstatue_init_"..obj.."_light";
    ObjAnimate(item, "alp", 0, 0, "", 
    {
      0.0,0,ObjGet( item ).alp,
      0.2,0,0
    });
    
  end;


end;
--*********************************************************************************************************************
function private.ItemStartDrag ( obj )
  
  private.ItemMEnter ( obj, false );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mgstatue_take" );
  ObjSet( "spr_mgstatue_init_"..obj, { pos_z = 10 } );

end;
--*********************************************************************************************************************
function private.ItemDragDrop ( obj )
  
  private.ItemMLeave ( obj, false );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mgstatue_put" );
  local item = "spr_mgstatue_init_"..obj;
  
  ObjSet( item, { pos_z = 0 } );
  
  if ( cmn.ApplyObj( item, "obj_mgstatue_use_"..obj, true ) ) then
    
    ObjSet( item, { alp = 0, input = false } );
    ObjSet( "spr_mgstatue_final_"..obj, { alp = 1, input = true } );
    
    local ind = 0;
    for i=1, #private.objs do
      if ( private.objs[ i ] == obj  ) then
        ind = i;
        break;
      end;
    end;
    
    private.state[ ind ] = 1;
    
    private.CheckWin();
    
  end;

end;
--*********************************************************************************************************************
function private.WinEnd ()

  cmn.SetEventDone( "win_mgstatue" );
  cmn.CallEventHandler( "win_mgstatue" );
  
  cmn.PlayAudio( "mus", "audio/aud_grave_agressive_mus" );
  
--  cmn.GotoRm( "" );

end;
--*********************************************************************************************************************
function private.Win ()
  
  common_impl.PassingMgWin( "mgstatue" );
  
  cmn.MiniGameHide();

  ObjSet( "anm_mgstatue_open", { alp = 1 } );
  ObjSet( "obj_mgstatue_final", { input = false } );
  ObjSet( "spr_mgstatue_final_man1", { alp = 0, input = false } );
  ObjSet( "spr_mgstatue_final_luggage", { alp = 0, input = false } );
  ObjSet( "spr_mgstatue_final_people", { alp = 0, input = false } );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mgstatue_win" );
  AnimPlay( "anm_mgstatue_open", "DoAnim", function () private.WinEnd (); end);

end;
--*********************************************************************************************************************
function private.CheckWin ()
  
  local win = true;
  
  for i=1, #private.state do
    if ( private.state[ i ] == 0 ) then
      win = false;
      break;
    end;
  end;
  
  if ( win ) then
    private.Win();
  else
    for i=1, #private.state do
      ng_global.progress[ "ext" ][ "win_mgstatue" ].state[ i ] = private.state[ i ];
    end;
  end;
  
end;
--*********************************************************************************************************************