-- name=levelext_inv
--*********************************************************************************************************************
function public.Init ()

  if port.isPortable() == 1 then
    port.InventoryPopupInit("levelext_inv_hub");
    port.VideoResizeInRoom("levelext_inv");
  end;
  
  private.brokenlantern_init(); 
  private.prunerpart_1_init(); 
  private.book_init(); 
  private.shovelblade_init(); 
  private.recipeext_init(); 
  private.hookext_init(); 
  private.brokenflashlight_init(); 
  private.swissknife_init(); 
  private.tombstonebasis_init(); 
  private.HerbicideInit();
  private.Anim(); 


  int.CreateDeployPlus( "ext" );

  --MsgSubscribe( Command_Interface_UpdateGameMode, private.UpdateGameMode );

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_levelext_inv_deploy = function ()

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    common_impl.TurnChildGfx( { "levelext_inv_deploy" } , "levelext_inv_deploy", visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_levelext_inv_deploy", update_game_mode_levelext_inv_deploy, nil );

end;

--*********************************************************************************************************************
-- function *** brokenlantern *** ()
--*********************************************************************************************************************
  function private.brokenlantern_init ()

    ObjSet( "spr_deploy_inv_brokenlantern_lantern",  { event_mdown = private.get_blacklantern } );
    ObjSet( "obj_deploy_inv_brokenlantern_clk",  { event_mdown = private.clk_brokenlantern } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_blacklantern" ] =
    {
      type = "get",
      get_obj = "obj_deploy_inv_brokenlantern",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenlantern",
      zz_gate = "inv_brokenlantern"
    };
    -------------------------------------------------------------------------------------------
    function get_blacklantern_inv ()

      interface.InventoryItemRemove( "inv_brokenlantern" );
      interface.InventoryItemAdd( "inv_blacklantern", "obj_deploy_inv_brokenlantern" );

      ObjDelete( "gfx_deploy_inv_brokenlantern_blacklantern" );
      ObjDelete( "obj_deploy_inv_brokenlantern_lens_light" );

    end;
    function get_blacklantern_loc ()

      ObjSet( "vid_nearcar_smoke_3", { alp = 1, playing = true, looped = true } );
      ObjDelete( "vid_nearcar_smoke_2" );
      
    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_blacklantern", get_blacklantern_inv );
    cmn.AddSubscriber( "get_blacklantern", get_blacklantern_loc, "rm_nearcar" );
    cmn.AddSubscriber( "get_blacklantern_loc", get_blacklantern_loc, "rm_nearcar" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_bluegem" ] =
    {
      type = "use",
      use_obj = "inv_bluegem",
      use_place = "obj_deploy_inv_brokenlantern_use_bluegem",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenlantern",
      zz_gate = "inv_brokenlantern"
    };
    -------------------------------------------------------------------------------------------
    function use_bluegem_inv ()
  
      interface.InventoryItemRemove( "inv_bluegem" );
      ObjSet( "inv_brokenlantern_stone", { alp = 1 } );
      if not cmn.IsEventDone( "get_lens" ) then
        ObjSet( "inv_brokenlantern_plus_focus2", { alp = 0 } );
      end;

    end;
    function use_bluegem_beg ()

      ObjDelete( "obj_deploy_inv_brokenlantern_use_bluegem" );

    end;
    function use_bluegem_end ()

      ObjSet( "obj_deploy_inv_brokenlantern_bluegem_light", { alp = 1 } );
      ObjSet( "spr_deploy_inv_brokenlantern_bluegem", { alp = 1 } );
      ObjSet( "obj_deploy_inv_brokenlantern_use_lens", { input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_bluegem", use_bluegem_beg, "inv_brokenlantern" );
    cmn.AddSubscriber( "use_bluegem", use_bluegem_inv );
    cmn.AddSubscriber( "use_bluegem", use_bluegem_end, "inv_brokenlantern" );
    cmn.AddSubscriber( "use_bluegem_inv", use_bluegem_inv );
    cmn.AddSubscriber( "use_bluegem_beg", use_bluegem_beg, "inv_brokenlantern" );
    cmn.AddSubscriber( "use_bluegem_end", use_bluegem_end, "inv_brokenlantern" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_lens" ] =
    {
      type = "use",
      use_obj = "inv_lens",
      use_place = "obj_deploy_inv_brokenlantern_use_lens",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenlantern",
      zz_gate = "inv_brokenlantern"
    };
    -------------------------------------------------------------------------------------------
    function use_lens_inv ()
  
      interface.InventoryItemRemove( "inv_lens" );
      ObjSet( "inv_brokenlantern_lens", { alp = 1 } );

    end;
    function use_lens_beg ()

      ObjDelete( "obj_deploy_inv_brokenlantern_use_lens" );

    end;
    function use_lens_end ()

      ObjSet( "obj_deploy_inv_brokenlantern_lens_light", { alp = 1 } );
      ObjSet( "spr_deploy_inv_brokenlantern_lens", { alp = 1 } );
      ObjDelete( "obj_deploy_inv_brokenlantern_bluegem_light" );

      ObjSet( "spr_deploy_inv_brokenlantern_lantern", { input = true } );
      ObjSet( "gfx_deploy_inv_brokenlantern_blacklantern", { active = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_lens", use_lens_beg, "inv_brokenlantern" );
    cmn.AddSubscriber( "use_lens", use_lens_inv );
    cmn.AddSubscriber( "use_lens", use_lens_end, "inv_brokenlantern" );
    cmn.AddSubscriber( "use_lens_inv", use_lens_inv );
    cmn.AddSubscriber( "use_lens_beg", use_lens_beg, "inv_brokenlantern" );
    cmn.AddSubscriber( "use_lens_end", use_lens_end, "inv_brokenlantern" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_brokenlantern" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_brokenlantern_clk",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenlantern",
      zz_gate = "inv_brokenlantern"
    };
    -------------------------------------------------------------------------------------------
    function clk_brokenlantern_inv ()

      if not cmn.IsEventDone( "get_bluegem" ) then
        ObjSet( "inv_brokenlantern_plus_focus2", { alp = 0 } );
      end;

    end;
    function clk_brokenlantern_beg ()

      ObjDelete( "obj_deploy_inv_brokenlantern_clk" );

    end;
    function clk_brokenlantern_end ()

      ObjDelete( "spr_deploy_inv_brokenlantern_lens_glass" );
      ObjSet( "obj_deploy_inv_brokenlantern_use_bluegem", { input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_brokenlantern", clk_brokenlantern_inv );
    cmn.AddSubscriber( "clk_brokenlantern", clk_brokenlantern_beg, "inv_brokenlantern" );
    cmn.AddSubscriber( "clk_brokenlantern", clk_brokenlantern_end, "inv_brokenlantern" );
    cmn.AddSubscriber( "clk_brokenlantern_inv", clk_brokenlantern_inv );
    cmn.AddSubscriber( "clk_brokenlantern_beg", clk_brokenlantern_beg, "inv_brokenlantern" );
    cmn.AddSubscriber( "clk_brokenlantern_end", clk_brokenlantern_end, "inv_brokenlantern" );
    -------------------------------------------------------------------------------------------  

  end;
  --*********************************************************************************************************************
  function private.get_blacklantern ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_blacklantern" );
    cmn.CallEventHandler( "get_blacklantern", "inv_brokenlantern" );
    cmn.CallEventHandler( "get_blacklantern_loc" );

    int.DeployInvHide();

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function public.use_bluegem ()

    local item = "inv_bluegem";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_brokenlantern_use_bluegem" ) and 
         cmn.IsEventDone( "clk_brokenlantern" ) ) then

      cmn.CallEventHandler( "use_bluegem_inv" );
      cmn.CallEventHandler( "use_bluegem_beg", "inv_brokenlantern" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_bluegem" );
        cmn.CallEventHandler( "use_bluegem_end", "inv_brokenlantern" );
      
      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_insert_energy_stone" );
      ObjAnimate( "spr_deploy_inv_brokenlantern_bluegem", "alp", 0, 0, "", 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );
      ObjAnimate( "obj_deploy_inv_brokenlantern_bluegem_light", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
  function public.use_lens ()

    local item = "inv_lens";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_brokenlantern_use_lens" ) and
         cmn.IsEventDone( "use_bluegem" ) ) then

      cmn.CallEventHandler( "use_lens_inv" );
      cmn.CallEventHandler( "use_lens_beg", "inv_brokenlantern" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_lens" );
        cmn.CallEventHandler( "use_lens_end", "inv_brokenlantern" );
      
      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_insert_eye" );
      ObjAnimate( "obj_deploy_inv_brokenlantern_bluegem_light", "alp", 0, 0, "", 
      { 
        0.0, 0, 1,
        0.3, 0, 0,
      } );
      ObjAnimate( "spr_deploy_inv_brokenlantern_lens", "alp", 0, 0, "", 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );
      ObjAnimate( "obj_deploy_inv_brokenlantern_lens_light", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );

      return true;

    end;

    return false;

  end;
  --*********************************************************************************************************************
  function private.clk_brokenlantern ()

    cmn.CallEventHandler( "clk_brokenlantern_inv", "inv_brokenlantern" );
    cmn.CallEventHandler( "clk_brokenlantern_beg", "inv_brokenlantern" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_brokenlantern" );
      cmn.CallEventHandler( "clk_brokenlantern_end", "inv_brokenlantern" );
    
    end;

    int.Lock( true );
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_removeglass" );

    ObjAnimate( "spr_deploy_inv_brokenlantern_lens_glass", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 1,
      0.3, 0, 0,
    } );

    return true;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** prunerpart_1 *** ()
--*********************************************************************************************************************
  function private.prunerpart_1_init ()

    ObjSet( "spr_deploy_inv_prunerpart_1_prunerpart_1",  { event_mdown = private.get_prunerext } );
    ObjSet( "spr_deploy_inv_prunerpart_1_prunerpart_2",  { event_mdown = private.get_prunerext } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_prunerext" ] =
    {
      type = "get",
      get_obj = "obj_deploy_inv_prunerpart_1",
      room = "int_deploy_inv",
      zz = "deploy_inv_prunerpart_1",
      zz_gate = "inv_prunerpart_1"
    };
    -------------------------------------------------------------------------------------------
    function get_prunerext_inv ()

      interface.InventoryItemRemove( "inv_prunerpart_1" );
      interface.InventoryItemAdd( "inv_prunerext", "obj_deploy_inv_prunerpart_1" );
      ObjDelete( "gfx_deploy_inv_prunerpart_1_prunerext" );
      ObjDelete( "obj_deploy_inv_prunerpart_1_shine_add" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_prunerext", get_prunerext_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_prunerpart_2" ] =
    {
      type = "use",
      use_obj = "inv_prunerpart_2",
      use_place = "obj_deploy_inv_prunerpart_1_use_prunerpart_2",
      room = "int_deploy_inv",
      zz = "deploy_inv_prunerpart_1",
      zz_gate = "inv_prunerpart_1"
    };
    -------------------------------------------------------------------------------------------
    function use_prunerpart_2_inv ()

      interface.InventoryItemRemove( "inv_prunerpart_2" );
      ObjSet( "inv_prunerpart_1_part_2", { alp = 1 } );

      if not cmn.IsEventDone( "get_rivet" ) then
        ObjSet( "inv_prunerpart_1_plus_focus2", { alp = 0 } );
      end;

    end;
    function use_prunerpart_2_beg ()

      ObjDelete( "obj_deploy_inv_prunerpart_1_use_prunerpart_2" );

    end;
    function use_prunerpart_2_end ()

      ObjSet( "obj_deploy_inv_prunerpart_1_use_rivet", { input = true } );
      ObjSet( "spr_deploy_inv_prunerpart_1_prunerpart_2", { alp = 1 } );      

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_prunerpart_2", use_prunerpart_2_beg, "inv_prunerpart_1" );
    cmn.AddSubscriber( "use_prunerpart_2", use_prunerpart_2_inv );
    cmn.AddSubscriber( "use_prunerpart_2", use_prunerpart_2_end, "inv_prunerpart_1" );
    cmn.AddSubscriber( "use_prunerpart_2_inv", use_prunerpart_2_inv );
    cmn.AddSubscriber( "use_prunerpart_2_beg", use_prunerpart_2_beg, "inv_prunerpart_1" );
    cmn.AddSubscriber( "use_prunerpart_2_end", use_prunerpart_2_end, "inv_prunerpart_1" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_rivet" ] =
    {
      type = "use",
      use_obj = "inv_rivet",
      use_place = "obj_deploy_inv_prunerpart_1_use_rivet",
      room = "int_deploy_inv",
      zz = "deploy_inv_prunerpart_1",
      zz_gate = "inv_prunerpart_1"
    };
    -------------------------------------------------------------------------------------------
    function use_rivet_inv ()
  
      interface.InventoryItemRemove( "inv_rivet" );
      ObjSet( "inv_prunerpart_1_rivet_1", { alp = 1 } );
      if not cmn.IsEventDone( "get_coinext" ) then
        ObjSet( "inv_prunerpart_1_plus_focus2", { alp = 0 } );
      end;

    end;
    function use_rivet_beg ()

      ObjDelete( "obj_deploy_inv_prunerpart_1_use_rivet" );

    end;
    function use_rivet_end ()

      ObjSet( "obj_deploy_inv_prunerpart_1_use_coinext", { input = true } );
      ObjSet( "spr_deploy_inv_prunerpart_1_rivet_1", { alp = 1 } );      

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_rivet", use_rivet_beg, "inv_prunerpart_1" );
    cmn.AddSubscriber( "use_rivet", use_rivet_inv );
    cmn.AddSubscriber( "use_rivet", use_rivet_end, "inv_prunerpart_1" );
    cmn.AddSubscriber( "use_rivet_inv", use_rivet_inv );
    cmn.AddSubscriber( "use_rivet_beg", use_rivet_beg, "inv_prunerpart_1" );
    cmn.AddSubscriber( "use_rivet_end", use_rivet_end, "inv_prunerpart_1" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_coinext" ] =
    {
      type = "use",
      use_obj = "inv_coinext",
      use_place = "obj_deploy_inv_prunerpart_1_use_coinext",
      room = "int_deploy_inv",
      zz = "deploy_inv_prunerpart_1",
      zz_gate = "inv_prunerpart_1"
    };
    -------------------------------------------------------------------------------------------
    function use_coinext_inv ()
  
      interface.InventoryItemRemove( "inv_coinext" );
      ObjSet( "inv_prunerpart_1_rivet_2", { alp = 1 } );
      ObjDelete( "inv_prunerpart_1_rivet_1" );
      if not cmn.IsEventDone( "get_grindstoneext" ) then
        ObjSet( "inv_prunerpart_1_plus_focus2", { alp = 0 } );
      end;

    end;
    function use_coinext_beg ()

      ObjDelete( "obj_deploy_inv_prunerpart_1_use_coinext" );

    end;
    function use_coinext_end ()

      ObjSet( "obj_deploy_inv_prunerpart_1_use_grindstoneext", { input = true } );
      ObjSet( "spr_deploy_inv_prunerpart_1_rivet_2", { alp = 1 } );      
      ObjDelete( "spr_deploy_inv_prunerpart_1_rivet_1" );
      ObjDelete( "anm_deploy_inv_prunerpart_1_coin" );      

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_coinext", use_coinext_beg, "inv_prunerpart_1" );
    cmn.AddSubscriber( "use_coinext", use_coinext_inv );
    cmn.AddSubscriber( "use_coinext", use_coinext_end, "inv_prunerpart_1" );
    cmn.AddSubscriber( "use_coinext_inv", use_coinext_inv );
    cmn.AddSubscriber( "use_coinext_beg", use_coinext_beg, "inv_prunerpart_1" );
    cmn.AddSubscriber( "use_coinext_end", use_coinext_end, "inv_prunerpart_1" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_grindstoneext" ] =
    {
      type = "use",
      use_obj = "inv_grindstoneext",
      use_place = "obj_deploy_inv_prunerpart_1_use_grindstoneext",
      room = "int_deploy_inv",
      zz = "deploy_inv_prunerpart_1",
      zz_gate = "inv_prunerpart_1"
    };
    -------------------------------------------------------------------------------------------
    function use_grindstoneext_inv ()
  
      interface.InventoryItemRemove( "inv_grindstoneext" );
      ObjSet( "inv_prunerpart_1", { res = "assets/levels/levelext/common_inventory4/inv_prunerpart_1/inv/inv_prunerext" } );
      ObjDelete( "inv_prunerpart_1_part_2" );
      ObjDelete( "inv_prunerpart_1_rivet_2" );
      ObjDelete( "inv_prunerpart_1_rust_1" ); 

    end;
    function use_grindstoneext_beg ()

      ObjDelete( "obj_deploy_inv_prunerpart_1_use_grindstoneext" );

    end;
    function use_grindstoneext_end ()

      ObjDelete( "anm_deploy_inv_prunerpart_1_grindstone" );
      ObjDelete( "spr_deploy_inv_prunerpart_1_prunerpart_1_over" );
      ObjDelete( "spr_deploy_inv_prunerpart_1_prunerpart_2_over" );      
      ObjSet( "obj_deploy_inv_prunerpart_1_shine_add", { alp = 1 } );
      ObjSet( "gfx_deploy_inv_prunerpart_1_prunerext", { active = true } );
      ObjSet( "spr_deploy_inv_prunerpart_1_shine_add", { active = true } );
      ObjSet( "spr_deploy_inv_prunerpart_1_prunerpart_1", { input = true } );
      ObjSet( "spr_deploy_inv_prunerpart_1_prunerpart_2", { input = true } );               

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_grindstoneext", use_grindstoneext_beg, "inv_prunerpart_1" );
    cmn.AddSubscriber( "use_grindstoneext", use_grindstoneext_inv );
    cmn.AddSubscriber( "use_grindstoneext", use_grindstoneext_end, "inv_prunerpart_1" );
    cmn.AddSubscriber( "use_grindstoneext_inv", use_grindstoneext_inv );
    cmn.AddSubscriber( "use_grindstoneext_beg", use_grindstoneext_beg, "inv_prunerpart_1" );
    cmn.AddSubscriber( "use_grindstoneext_end", use_grindstoneext_end, "inv_prunerpart_1" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------

  end;
  --*********************************************************************************************************************
  function private.get_prunerext ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_prunerext" );
    cmn.CallEventHandler( "get_prunerext", "inv_prunerpart_1" );

    int.DeployInvHide();

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function public.use_prunerpart_2 ()


    local item = "inv_prunerpart_2";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_prunerpart_1_use_prunerpart_2", "deploy_inv_prunerpart_1" ) ) then

      cmn.CallEventHandler( "use_prunerpart_2_inv" );
      cmn.CallEventHandler( "use_prunerpart_2_beg", "inv_prunerpart_1" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_prunerpart_2" );
        cmn.CallEventHandler( "use_prunerpart_2_end", "inv_prunerpart_1" );
      
      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_scissorspart" );
      ObjAnimate( "spr_deploy_inv_prunerpart_1_prunerpart_2", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
  function public.use_rivet ()

    local item = "inv_rivet";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_prunerpart_1_use_rivet", "deploy_inv_prunerpart_1" ) and 
         cmn.IsEventDone( "use_prunerpart_2" ) ) then

      cmn.CallEventHandler( "use_rivet_inv" );
      cmn.CallEventHandler( "use_rivet_beg", "inv_prunerpart_1" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_rivet" );
        cmn.CallEventHandler( "use_rivet_end", "inv_prunerpart_1" );
      
      end;

      int.Lock( true );
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_bolt" );
      ObjAnimate( "spr_deploy_inv_prunerpart_1_rivet_1", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
  function public.use_coinext ()

    local item = "inv_coinext";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_prunerpart_1_use_coinext", "deploy_inv_prunerpart_1" ) and
         cmn.IsEventDone( "use_rivet" ) ) then

      cmn.CallEventHandler( "use_coinext_inv" );
      cmn.CallEventHandler( "use_coinext_beg", "inv_prunerpart_1" );

      local func_end = function ()
      
        local func_end = function ()
        
          int.Lock( false );

          cmn.SetEventDone( "use_coinext" );
          cmn.CallEventHandler( "use_coinext_end", "inv_prunerpart_1" );
          
        end;
                
        AnimPlay( "anm_deploy_inv_prunerpart_1_coin", "DoAnim", func_end );
        
      end;

      int.Lock( true );
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_coin" );

      ObjAnimate( "spr_deploy_inv_prunerpart_1_rivet_1", "alp", 0, 0, "", 
      { 
        0.0, 0, 1,
        0.7, 0, 1,
        0.8, 0, 0,
      } );
      ObjAnimate( "anm_deploy_inv_prunerpart_1_coin", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
  function public.use_grindstoneext ()

    local item = "inv_grindstoneext";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_prunerpart_1_use_grindstoneext", "deploy_inv_prunerpart_1" ) and
         cmn.IsEventDone( "use_coinext" ) ) then

      cmn.CallEventHandler( "use_grindstoneext_inv" );
      cmn.CallEventHandler( "use_grindstoneext_beg", "inv_prunerpart_1" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_grindstoneext" );
        cmn.CallEventHandler( "use_grindstoneext_end", "inv_prunerpart_1" );
      
      end;

      int.Lock( true );

      ObjSet( "anm_deploy_inv_prunerpart_1_grindstone", { alp = 1 } );
      ObjSet( "spr_deploy_inv_prunerpart_1_prunerpart_1_over", { alp = 0 } );
      ObjSet( "spr_deploy_inv_prunerpart_1_prunerpart_2_over", { alp = 0 } );
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_sharpen" );
      AnimPlay( "anm_deploy_inv_prunerpart_1_grindstone", "DoAnim", func_end ) 
      ObjAnimate( "obj_deploy_inv_prunerpart_1_shine_add", "alp", 0, 0, "", 
      { 
        0.0, 0, 0,
        2.25, 0, 0,
        2.55, 0, 1,
      } );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** book *** ()
--*********************************************************************************************************************
  function private.book_init ()

    ObjSet( "spr_deploy_inv_book_amuletspider",  { event_mdown = private.get_amuletspider } );
    ObjSet( "spr_deploy_inv_book_lens",  { event_mdown = private.get_lens } );
    ObjSet( "spr_deploy_inv_book_amuletfire_2",  { event_mdown = private.get_amuletfire_2 } );
    ObjSet( "obj_deploy_inv_book_clk_1",  { event_mdown = private.clk_book_1 } );
    ObjSet( "obj_deploy_inv_book_clk_2",  { event_mdown = private.clk_book_2 } );
    ObjSet( "obj_deploy_inv_book_use_amuletbook_1",  { event_mdown = private.ClkBookCover } );
    ObjSet( "obj_deploy_inv_book_use_amuletbook_2",  { event_mdown = private.ClkBookCover } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_amuletspider" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_book_amuletspider",
      room = "int_deploy_inv",
      zz = "deploy_inv_book",
      zz_gate = "inv_book"
    };
    -------------------------------------------------------------------------------------------
    function get_amuletspider_inv ()

      if ( cmn.IsEventDone( "get_amuletfire_2" ) and
           cmn.IsEventDone( "get_lens" ) ) then

        ObjSet( "obj_deploy_inv_book_clk_2",  { input = true } );

      end;

      if ( not cmn.IsEventDone( "get_amuletbook_1" ) and not cmn.IsEventDone( "get_amuletbook_2" ) and
           cmn.IsEventDone( "get_lens" ) ) then

        ObjSet( "inv_book_plus_focus2", { alp = 0 } );

      end;

      interface.InventoryItemAdd( "inv_amuletspider", "spr_deploy_inv_book_amuletspider" );

      ObjDelete( "gfx_deploy_inv_book_amuletspider" );
      ObjDelete( "spr_deploy_inv_book_amuletspider_shadow" );
      
      ObjDelete( "inv_book_spider" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_amuletspider", get_amuletspider_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_lens" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_book_lens",
      room = "int_deploy_inv",
      zz = "deploy_inv_book",
      zz_gate = "inv_book"
    };
    -------------------------------------------------------------------------------------------
    function get_lens_inv ()

      if ( cmn.IsEventDone( "get_amuletspider" ) and
           cmn.IsEventDone( "get_amuletfire_2" ) ) then

        ObjSet( "obj_deploy_inv_book_clk_2",  { input = true } );

      end;
      if ( not cmn.IsEventDone( "get_amuletbook_1" ) and not cmn.IsEventDone( "get_amuletbook_2" ) and
           cmn.IsEventDone( "get_amuletspider" ) ) then

        ObjSet( "inv_book_plus_focus2", { alp = 0 } );

      end;

      if cmn.IsEventDone( "use_bluegem" ) then
        ObjSet( "inv_brokenlantern_plus_focus2", { alp = 1 } );
      end;

      interface.InventoryItemAdd( "inv_lens", "spr_deploy_inv_book_lens" );

      ObjDelete( "gfx_deploy_inv_book_lens" );
      ObjDelete( "spr_deploy_inv_book_amuletspider_lens_shadow" );
      
      ObjDelete( "inv_book_lens" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_lens", get_lens_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_amuletfire_2" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_book_amuletfire_2",
      room = "int_deploy_inv",
      zz = "deploy_inv_book",
      zz_gate = "inv_book"
    };
    -------------------------------------------------------------------------------------------
    function get_amuletfire_2_inv ()

      interface.InventoryItemAdd( "inv_amuletfire_2", "spr_deploy_inv_book_amuletfire_2" );
      ObjDelete( "gfx_deploy_inv_book_amuletfire" );
      ObjDelete( "spr_deploy_inv_book_amuletfire_2_shadow" );
      interface.InventoryItemRemove( "inv_book" );
      
      ObjDelete( "inv_book_amuletfire" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_amuletfire_2", get_amuletfire_2_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_book_1" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_book_clk_1",
      room = "int_deploy_inv",
      zz = "deploy_inv_book",
      zz_gate = "inv_book"
    };
    -------------------------------------------------------------------------------------------
    function clk_book_1_inv ()
      
      ObjSet( "inv_book", { res = "assets/levels/levelext/common_inventory4/inv_book/inv/page_1" } );
      ObjSet( "obj_book_page_1", { alp = 1 } );

    end;
    function clk_book_1_beg ()

      ObjDelete( "obj_deploy_inv_book_clk_1" );

    end;
    function clk_book_1_end ()

      ObjDelete( "spr_deploy_inv_book_closedbook" );
      ObjSet( "spr_deploy_inv_book_openbook1", { alp = 1 } );
      ObjSet( "spr_deploy_inv_book_amuletspider", { active = true, input = true } );
      ObjSet( "spr_deploy_inv_book_lens", { active = true, input = true } );
      ObjSet( "spr_deploy_inv_book_openbook1", { input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_book_1", clk_book_1_inv );
    cmn.AddSubscriber( "clk_book_1", clk_book_1_beg, "inv_book" );
    cmn.AddSubscriber( "clk_book_1", clk_book_1_end, "inv_book" );
    cmn.AddSubscriber( "clk_book_1_inv", clk_book_1_inv );
    cmn.AddSubscriber( "clk_book_1_beg", clk_book_1_beg, "inv_book" );
    cmn.AddSubscriber( "clk_book_1_end", clk_book_1_end, "inv_book" );
    ------------------------------------------------------------------------------------------- 
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_book_2" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_book_clk_2",
      room = "int_deploy_inv",
      zz = "deploy_inv_book",
      zz_gate = "inv_book"
    };
    -------------------------------------------------------------------------------------------
    function clk_book_2_inv ()
      
      ObjSet( "inv_book", { res = "assets/levels/levelext/common_inventory4/inv_book/inv/page_2" } );
      ObjSet( "obj_book_page_2", { alp = 1 } );
      ObjDelete( "obj_book_page_1" );

    end;
    function clk_book_2_beg ()

      ObjDelete( "obj_deploy_inv_book_clk_2" );

    end;
    function clk_book_2_end ()

      ObjSet( "gfx_deploy_inv_book_amuletfire", { active = true } );
      ObjSet( "spr_deploy_inv_book_openbook2", { alp = 1, input = true } );
      ObjDelete( "spr_deploy_inv_book_openbook1" );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_book_2", clk_book_2_inv );
    cmn.AddSubscriber( "clk_book_2", clk_book_2_beg, "inv_book" );
    cmn.AddSubscriber( "clk_book_2", clk_book_2_end, "inv_book" );
    cmn.AddSubscriber( "clk_book_2_inv", clk_book_2_inv );
    cmn.AddSubscriber( "clk_book_2_beg", clk_book_2_beg, "inv_book" );
    cmn.AddSubscriber( "clk_book_2_end", clk_book_2_end, "inv_book" );
    ------------------------------------------------------------------------------------------- 
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_amuletbook_1" ] =
    {
      type = "use",
      use_obj = "inv_amuletbook_1",
      use_place = "obj_deploy_inv_book_use_amuletbook_1",
      room = "int_deploy_inv",
      zz = "deploy_inv_book",
      zz_gate = "inv_book"
    };
    -------------------------------------------------------------------------------------------
    function use_amuletbook_1_inv ()
  
      interface.InventoryItemRemove( "inv_amuletbook_1" );
      ObjSet( "inv_book_amulet_1", { alp = 1 } );

      if ( cmn.IsEventDone( "get_amuletspider" ) and cmn.IsEventDone( "get_lens" ) and
           not cmn.IsEventDone( "get_amuletbook_2" ) ) then

        ObjSet( "inv_book_plus_focus2", { alp = 0 } );

      end;

    end;
    function use_amuletbook_1_beg ()

      ObjDelete( "obj_deploy_inv_book_use_amuletbook_1" );

    end;
    function use_amuletbook_1_end ()

      ObjSet( "spr_deploy_inv_book_amuletbook_1", { alp = 1 } );
      if cmn.IsEventDone( "use_amuletbook_2" ) then
        
        if ( cmn.IsEventDone( "get_lens" ) and
           cmn.IsEventDone( "get_amuletspider" ) ) then

          ObjSet( "obj_deploy_inv_book_clk_2", { input = true } );

        end;
        
      end;

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_amuletbook_1", use_amuletbook_1_beg, "inv_book" );
    cmn.AddSubscriber( "use_amuletbook_1", use_amuletbook_1_inv );
    cmn.AddSubscriber( "use_amuletbook_1", use_amuletbook_1_end, "inv_book" );
    cmn.AddSubscriber( "use_amuletbook_1_inv", use_amuletbook_1_inv );
    cmn.AddSubscriber( "use_amuletbook_1_beg", use_amuletbook_1_beg, "inv_book" );
    cmn.AddSubscriber( "use_amuletbook_1_end", use_amuletbook_1_end, "inv_book" );
    ------------------------------------------------------------------------------------------- 
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_amuletbook_2" ] =
    {
      type = "use",
      use_obj = "inv_amuletbook_2",
      use_place = "obj_deploy_inv_book_use_amuletbook_2",
      room = "int_deploy_inv",
      zz = "deploy_inv_book",
      zz_gate = "inv_book"
    };
    -------------------------------------------------------------------------------------------
    function use_amuletbook_2_inv ()
  
      interface.InventoryItemRemove( "inv_amuletbook_2" );
      ObjSet( "inv_book_amulet_2", { alp = 1 } );

      if ( cmn.IsEventDone( "get_amuletspider" ) and cmn.IsEventDone( "get_lens" ) and
           not cmn.IsEventDone( "get_amuletbook_1" ) ) then

        ObjSet( "inv_book_plus_focus2", { alp = 0 } );

      end;

    end;
    function use_amuletbook_2_beg ()

      ObjDelete( "obj_deploy_inv_book_use_amuletbook_2" );

    end;
    function use_amuletbook_2_end ()
      
      ObjSet( "spr_deploy_inv_book_amuletbook_2", { alp = 1 } );
      if cmn.IsEventDone( "use_amuletbook_1" ) then
        
        if ( cmn.IsEventDone( "get_lens" ) and
           cmn.IsEventDone( "get_amuletspider" ) ) then

          ObjSet( "obj_deploy_inv_book_clk_2", { input = true } );

        end;
        
      end;

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_amuletbook_2", use_amuletbook_2_beg, "inv_book" );
    cmn.AddSubscriber( "use_amuletbook_2", use_amuletbook_2_inv );
    cmn.AddSubscriber( "use_amuletbook_2", use_amuletbook_2_end, "inv_book" );
    cmn.AddSubscriber( "use_amuletbook_2_inv", use_amuletbook_2_inv );
    cmn.AddSubscriber( "use_amuletbook_2_beg", use_amuletbook_2_beg, "inv_book" );
    cmn.AddSubscriber( "use_amuletbook_2_end", use_amuletbook_2_end, "inv_book" );
    ------------------------------------------------------------------------------------------- 

  end;
  --*********************************************************************************************************************
  function private.get_amuletspider ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_amuletspider" );
    cmn.CallEventHandler( "get_amuletspider", "inv_book" );

  end;
--***********************************************************************************************************************
  --*********************************************************************************************************************
  function private.get_lens ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_lens" );
    cmn.CallEventHandler( "get_lens", "inv_book" );

  end;
--*********************************************************************************************************************
  function private.get_amuletfire_2 ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_amuletfire_2" );
    cmn.CallEventHandler( "get_amuletfire_2", "inv_book" );
    
    int.DeployInvHide();

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function public.use_amuletbook_1 ()

    local item = "inv_amuletbook_1";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_book_use_amuletbook_1" ) ) then

      cmn.CallEventHandler( "use_amuletbook_1_inv" );
      cmn.CallEventHandler( "use_amuletbook_1_beg", "inv_book" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_amuletbook_1" );
        cmn.CallEventHandler( "use_amuletbook_1_end", "inv_book" );
      
      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_insert_to_book" );
      ObjAnimate( "spr_deploy_inv_book_amuletbook_1", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function public.use_amuletbook_2 ()

    local item = "inv_amuletbook_2";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_book_use_amuletbook_2" ) ) then 

      cmn.CallEventHandler( "use_amuletbook_2_inv" );
      cmn.CallEventHandler( "use_amuletbook_2_beg", "inv_book" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_amuletbook_2" );
        cmn.CallEventHandler( "use_amuletbook_2_end", "inv_book" );
      
      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_insert_to_book" );
      ObjAnimate( "spr_deploy_inv_book_amuletbook_2", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.clk_book_1 ()

    cmn.CallEventHandler( "clk_book_1_inv", "inv_book" );
    cmn.CallEventHandler( "clk_book_1_beg", "inv_book" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_book_1" );
      cmn.CallEventHandler( "clk_book_1_end", "inv_book" );
      
      cmn.AddPageDiary( 21 );
    
    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_open_book" );
    ObjAnimate( "spr_deploy_inv_book_closedbook", "alp", 0, 0, "", 
    { 
      0.0, 0, 1,
      0.3, 0, 0,
    } );
    ObjAnimate( "spr_deploy_inv_book_openbook1", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.3, 0, 1,
    } );

    return true;

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.clk_book_2 ()

    cmn.CallEventHandler( "clk_book_2_inv", "inv_book" );
    cmn.CallEventHandler( "clk_book_2_beg", "inv_book" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_book_2" );
      cmn.CallEventHandler( "clk_book_2_end", "inv_book" );
    
    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_book_leaf" );
    ObjAnimate( "spr_deploy_inv_book_openbook1", "alp", 0, 0, "", 
    { 
      0.0, 0, 1,
      0.3, 0, 0,
    } );
    ObjAnimate( "spr_deploy_inv_book_openbook2", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.3, 0, 1,
    } );

    return true;

  end;
  --*********************************************************************************************************************
  function private.ClkBookCover ()
    
    local func_end = function ()
    
    int.Lock( false );
      cmn.ShowBbt( "bbt_levelext_inv_amuletbook_use");
    
    end;
  
    int.Lock( true );
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_book_touch" );
  
    ObjAnimate("spr_deploy_inv_book_cover", "pos_y", 0, 0, func_end, 
    {
      0.0,0,6,
      0.2,0,5,
      0.4,0,7,
      0.6,0,6
    });
    
  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** shovelblade *** ()
--*********************************************************************************************************************
  function private.shovelblade_init ()

    ObjSet( "spr_obj_deploy_inv_shovelblade_stick",  { event_mdown = private.get_shovelext } );
    ObjSet( "spr_deploy_inv_shovelblade_shovel",  { event_mdown = private.get_shovelext } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_shovelext" ] =
    {
      type = "get",
      get_obj = "spr_obj_deploy_inv_shovelblade_stick",
      room = "int_deploy_inv",
      zz = "deploy_inv_shovelblade",
      zz_gate = "inv_shovelblade"
    };
    -------------------------------------------------------------------------------------------
    function get_shovelext_inv ()

      interface.InventoryItemRemove( "inv_shovelblade" );
      interface.InventoryItemAdd( "inv_shovelext", "obj_deploy_inv_shovelblade" );

      ObjDelete( "gfx_deploy_inv_shovelblade_shovelext" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_shovelext", get_shovelext_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_stick" ] =
    {
      type = "use",
      use_obj = "inv_stick",
      use_place = "obj_deploy_inv_shovelblade_use_stick",
      room = "int_deploy_inv",
      zz = "deploy_inv_shovelblade",
      zz_gate = "inv_shovelblade"
    };
    -------------------------------------------------------------------------------------------
    function use_stick_inv ()
  
      interface.InventoryItemRemove( "inv_stick" );
      ObjSet( "inv_shovelblade", { res = "assets/levels/levelext/common_inventory4/inv_shovelblade/inv/shovel_1" } );
      if not cmn.IsEventDone( "get_nailsext" ) then
        ObjSet( "inv_shovelblade_plus_focus2", { alp = 0 } );
      end;

    end;
    function use_stick_beg ()

      ObjDelete( "obj_deploy_inv_shovelblade_use_stick" );

    end;
    function use_stick_end ()

      ObjSet( "obj_deploy_inv_shovelblade_use_nailsext", { input = true } );
      ObjSet( "spr_obj_deploy_inv_shovelblade_stick", { alp = 1 } );
      ObjSet( "spr_obj_deploy_inv_shovelblade_overlay", { alp = 1 } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_stick", use_stick_beg, "inv_shovelblade" );
    cmn.AddSubscriber( "use_stick", use_stick_inv );
    cmn.AddSubscriber( "use_stick", use_stick_end, "inv_shovelblade" );
    cmn.AddSubscriber( "use_stick_inv", use_stick_inv );
    cmn.AddSubscriber( "use_stick_beg", use_stick_beg, "inv_shovelblade" );
    cmn.AddSubscriber( "use_stick_end", use_stick_end, "inv_shovelblade" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_nailsext" ] =
    {
      type = "use",
      use_obj = "inv_nailsext",
      use_place = "obj_deploy_inv_shovelblade_use_nailsext",
      room = "int_deploy_inv",
      zz = "deploy_inv_shovelblade",
      zz_gate = "inv_shovelblade"
    };
    -------------------------------------------------------------------------------------------
    function use_nailsext_inv ()
  
      interface.InventoryItemRemove( "inv_nailsext" );
      ObjSet( "inv_shovelblade_nail", { alp = 1 } );
      if not cmn.IsEventDone( "get_stoneext" ) then
        ObjSet( "inv_shovelblade_plus_focus2", { alp = 0 } );
      end;

    end;
    function use_nailsext_beg ()

      ObjDelete( "obj_deploy_inv_shovelblade_use_nailsext" );

    end;
    function use_nailsext_end ()

      ObjSet( "obj_deploy_inv_shovelblade_use_stoneext", { input = true } );
      ObjSet( "spr_obj_deploy_inv_shovelblade_nail", { alp = 1 } );
      ObjSet( "spr_obj_deploy_inv_shovelblade_over_shadow", { alp = 1 } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_nailsext", use_nailsext_beg, "inv_shovelblade" );
    cmn.AddSubscriber( "use_nailsext", use_nailsext_inv );
    cmn.AddSubscriber( "use_nailsext", use_nailsext_end, "inv_shovelblade" );
    cmn.AddSubscriber( "use_nailsext_inv", use_nailsext_inv );
    cmn.AddSubscriber( "use_nailsext_beg", use_nailsext_beg, "inv_shovelblade" );
    cmn.AddSubscriber( "use_nailsext_end", use_nailsext_end, "inv_shovelblade" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_stoneext_1" ] =
    {
      type = "use",
      use_obj = "inv_stoneext",
      use_place = "obj_deploy_inv_shovelblade_use_stoneext",
      room = "int_deploy_inv",
      zz = "deploy_inv_shovelblade",
      zz_gate = "inv_shovelblade"
    };
    -------------------------------------------------------------------------------------------
    function use_stoneext_1_inv ()
      
      interface.InventoryItemRemove( "inv_stoneext" );
      ObjSet( "inv_shovelblade", { res = "assets/levels/levelext/common_inventory4/inv_shovelblade/inv/inv_shovelext" } );
      ObjDelete( "inv_shovelblade_nail" );
  
    end;
    function use_stoneext_1_beg ()

    end;
    function use_stoneext_1_end ()

      ObjSet( "spr_obj_deploy_inv_shovelblade_nail", { pos_x = -66, pos_y = -20 } );
      ObjDelete( "spr_obj_deploy_inv_shovelblade_over_shadow" );
      ObjDelete( "anm_deploy_inv_shovelblade_stone" );
      ObjDelete( "obj_deploy_inv_shovelblade_use_stoneext" );
      ObjSet( "spr_obj_deploy_inv_shovelblade_stick", { input = true } );
      ObjSet( "spr_deploy_inv_shovelblade_shovel", { alp = 1 } );
      ObjSet( "spr_deploy_inv_shovelblade_shovel", { input = true } );
      ObjSet( "gfx_deploy_inv_shovelblade_shovelext", { active = true } );
 
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_stoneext_1", use_stoneext_1_beg, "inv_shovelblade" );
    cmn.AddSubscriber( "use_stoneext_1", use_stoneext_1_inv );
    cmn.AddSubscriber( "use_stoneext_1", use_stoneext_1_end, "inv_shovelblade" );
    cmn.AddSubscriber( "use_stoneext_1_inv", use_stoneext_1_inv );
    cmn.AddSubscriber( "use_stoneext_1_beg", use_stoneext_1_beg, "inv_shovelblade" );
    cmn.AddSubscriber( "use_stoneext_1_end", use_stoneext_1_end, "inv_shovelblade" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------

  end;
  --*********************************************************************************************************************
  function private.get_shovelext ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_shovelext" );
    cmn.CallEventHandler( "get_shovelext", "inv_shovelblade" );

    int.DeployInvHide();

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function public.use_stick ()

    local item = "inv_stick";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_shovelblade_use_stick" ) ) then

      cmn.CallEventHandler( "use_stick_inv" );
      cmn.CallEventHandler( "use_stick_beg", "inv_shovelblade" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_stick" );
        cmn.CallEventHandler( "use_stick_end", "inv_shovelblade" );
      
      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_stalk" );
      ObjAnimate( "spr_obj_deploy_inv_shovelblade_overlay", "alp", 0, 0, "", 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );
      ObjAnimate( "spr_obj_deploy_inv_shovelblade_stick", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
  function public.use_nailsext ()

    local item = "inv_nailsext";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_shovelblade_use_nailsext" ) and 
         cmn.IsEventDone( "use_stick" ) ) then

      cmn.CallEventHandler( "use_nailsext_inv" );
      cmn.CallEventHandler( "use_nailsext_beg", "inv_shovelblade" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_nailsext" );
        cmn.CallEventHandler( "use_nailsext_end", "inv_shovelblade" );
      
      end;

      int.Lock( true );
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_nail" );

      ObjAnimate( "spr_obj_deploy_inv_shovelblade_nail", "alp", 0, 0, "", 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );
      ObjAnimate( "spr_obj_deploy_inv_shovelblade_over_shadow", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
  function public.use_stoneext_1 ()

    local item = "inv_stoneext";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_shovelblade_use_stoneext" ) and 
         cmn.IsEventDone( "use_nailsext" ) ) then


      cmn.CallEventHandler( "use_stoneext_1_inv" );
      cmn.CallEventHandler( "use_stoneext_1_beg", "inv_shovelblade" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_stoneext_1" );
        cmn.CallEventHandler( "use_stoneext_1_end", "inv_shovelblade" );
        ObjSet( "spr_obj_deploy_inv_shovelblade_stick", { alp = 1 } );
        ObjSet( "spr_obj_deploy_inv_shovelblade_nail", { alp = 1 } );
        ObjSet( "spr_obj_deploy_inv_shovelblade_overlay", { alp = 1 } );
        ObjSet( "spr_obj_deploy_inv_shovelblade_over_shadow", { alp = 1 } );
        
      end;

      int.Lock( true );
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_stone" );

      ObjSet( "spr_obj_deploy_inv_shovelblade_stick", { alp = 0 } );
      ObjSet( "spr_obj_deploy_inv_shovelblade_shovel_broken", { alp = 0 } );
      ObjSet( "spr_obj_deploy_inv_shovelblade_nail", { alp = 0 } );
      ObjSet( "spr_obj_deploy_inv_shovelblade_overlay", { alp = 0 } );
      ObjSet( "spr_obj_deploy_inv_shovelblade_over_shadow", { alp = 0 } );
      ObjSet( "anm_deploy_inv_shovelblade_stone", { alp = 1 } );
      AnimPlay( "anm_deploy_inv_shovelblade_stone", "DoAnim", func_end ); 
      
      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** recipeext *** ()
--*********************************************************************************************************************
  function private.recipeext_init ()

    ObjSet( "spr_deploy_inv_recipeext_herbicide",  { event_mdown = private.get_herbicide } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_herbicide" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_recipeext_herbicide",
      room = "int_deploy_inv",
      zz = "deploy_inv_recipeext",
      zz_gate = "inv_recipeext"
    };
    -------------------------------------------------------------------------------------------
    function get_herbicide_inv ()

      interface.InventoryItemRemove( "inv_recipeext" );
      interface.InventoryItemAdd( "inv_herbicide", "spr_deploy_inv_recipeext_herbicide" );

      ObjDelete( "gfx_deploy_inv_recipeext_herbicide" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_herbicide", get_herbicide_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_poisons" ] =
    {
      type = "use",
      use_obj = "inv_poisons",
      use_place = "obj_deploy_inv_recipeext_use_poisons",
      room = "int_deploy_inv",
      zz = "deploy_inv_recipeext",
      zz_gate = "inv_recipeext"
    };
    -------------------------------------------------------------------------------------------
    function use_poisons_inv ()
  
      interface.InventoryItemRemove( "inv_poisons" );

    end;
    function use_poisons_beg ()

      ObjDelete( "obj_deploy_inv_recipeext_use_poisons" );

    end;
    function use_poisons_end ()

      ObjSet( "spr_deploy_inv_recipeext_blue_bulb", { alp = 1 } );
      ObjSet( "spr_deploy_inv_recipeext_violet_bulb", { alp = 1 } );
      ObjSet( "spr_deploy_inv_recipeext_poisons", { alp = 1 } );
      ObjSet( "spr_deploy_inv_recipeext_blue_bulb_up", { alp = 1 } );
      ObjSet( "spr_deploy_inv_recipeext_violet_bulb_up", { alp = 1 } );
      ObjSet( "spr_deploy_inv_recipeext_poisons_up", { alp = 1 } );
      ObjSet( "spr_deploy_inv_recipeext_pipette", { input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_poisons", use_poisons_beg, "inv_recipeext" );
    cmn.AddSubscriber( "use_poisons", use_poisons_inv );
    cmn.AddSubscriber( "use_poisons", use_poisons_end, "inv_recipeext" );
    cmn.AddSubscriber( "use_poisons_inv", use_poisons_inv );
    cmn.AddSubscriber( "use_poisons_beg", use_poisons_beg, "inv_recipeext" );
    cmn.AddSubscriber( "use_poisons_end", use_poisons_end, "inv_recipeext" );
    -------------------------------------------------------------------------------------------
    --------------------------------------------------------------------------------------------
    -- function win_recipeext () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "win_recipeext" ] =
    {
      type = "click",
      clk_obj = "spr_deploy_inv_recipeext_herbicide",
      room = "int_deploy_inv",
      zz = "deploy_inv_recipeext",
      zz_gate = "inv_recipeext"
    };
    -----------------------------------------------
    local win_recipeext = function ()

      if ( cmn.IsEventStart( "win_recipeext" ) ) then

        local new_r = ng_global.progress[ "ext" ][ "win_recipeext" ].color[ 1 ];
        local new_g = ng_global.progress[ "ext" ][ "win_recipeext" ].color[ 2 ];
        local new_b = ng_global.progress[ "ext" ][ "win_recipeext" ].color[ 3 ];

        if ( new_r ~= 0 or new_g ~= 0 or new_b ~= 0 ) then
          ObjSet( "spr_deploy_inv_recipeext_fluid", { color_r = new_r, color_g = new_g, color_b = new_b, alp = 1 } );
        end;

      end;

      if ( cmn.IsEventDone( "win_recipeext" ) ) then

        ObjSet( "spr_deploy_inv_recipeext_herbicide", { input = true, alp = 1 } );
        ObjSet( "gfx_deploy_inv_recipeext_herbicide", { active = true} );
        ObjDelete( "obj_deploy_inv_recipeext_mmg" );

      end;

    end;

    cmn.AddSubscriber( "win_recipeext", win_recipeext );
    cmn.AddSubscriber( "win_recipeext", win_recipeext, "inv_recipeext" );

  --*********************************************************************************************************************

  end;
  --*********************************************************************************************************************
  function private.get_herbicide ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_herbicide" );
    cmn.CallEventHandler( "get_herbicide", "inv_recipeext" );

    int.DeployInvHide();

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function public.use_poisons ()

    local item = "inv_poisons";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_recipeext_use_poisons" ) ) then

      cmn.CallEventHandler( "use_poisons_inv" );
      cmn.CallEventHandler( "use_poisons_beg", "inv_recipeext" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_poisons" );
        cmn.CallEventHandler( "use_poisons_end", "inv_recipeext" );

       cmn.MiniGameShow( "recipeext" );
       common_impl.PassingMgStart( "recipeext" );

       ng_global.progress[ "ext" ][ "win_recipeext" ].toxin_array = { 0, 0, 0 };
       ng_global.progress[ "ext" ][ "win_recipeext" ].spoil = false; 
       ng_global.progress[ "ext" ][ "win_recipeext" ].color = { 0, 0, 0}; 
      
      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_app_bulbs" );
      ObjAnimate( "spr_deploy_inv_recipeext_blue_bulb", "alp", 0, 0, "", 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );
      ObjAnimate( "spr_deploy_inv_recipeext_blue_bulb_up", "alp", 0, 0, "", 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );      
      ObjAnimate( "spr_deploy_inv_recipeext_violet_bulb", "alp", 0, 0, "", 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );
      ObjAnimate( "spr_deploy_inv_recipeext_violet_bulb_up", "alp", 0, 0, "", 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );
      ObjAnimate( "spr_deploy_inv_recipeext_poisons", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );
      ObjAnimate( "spr_deploy_inv_recipeext_poisons_up", "alp", 0, 0, "", 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );      

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
-- function *** hookext *** ()
--*********************************************************************************************************************
  function private.hookext_init ()

    ObjSet( "spr_deploy_inv_hookext_hookchain",  { event_mdown = private.get_chainwithhook } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_chainwithhook" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_hookext_hookchain",
      room = "int_deploy_inv",
      zz = "deploy_inv_hookext",
      zz_gate = "inv_hookext"
    };
    -------------------------------------------------------------------------------------------
    function get_chainwithhook_inv ()

      interface.InventoryItemRemove( "inv_hookext" );
      interface.InventoryItemAdd( "inv_chainwithhook", "spr_deploy_inv_hookext_hookchain" );

      ObjDelete( "gfx_deploy_inv_hookext_chainwithhook" );
      ObjDelete( "spr_deploy_inv_hookext_hookchain_add" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_chainwithhook", get_chainwithhook_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_chain" ] =
    {
      type = "use",
      use_obj = "inv_chain",
      use_place = "obj_deploy_inv_hookext_use_chain",
      room = "int_deploy_inv",
      zz = "deploy_inv_hookext",
      zz_gate = "inv_hookext"
    };
    -------------------------------------------------------------------------------------------
    function use_chain_inv ()
  
      interface.InventoryItemRemove( "inv_chain" );
      ObjSet( "inv_hookext" , { res = "assets/levels/levelext/common_inventory4/inv_hookext/inv/inv_chainwithhook" } );

    end;
    function use_chain_beg ()

      ObjDelete( "obj_deploy_inv_hookext_use_chain" );

    end;
    function use_chain_end ()

      ObjSet( "spr_deploy_inv_hookext_hookchain", { input = true } );
      ObjSet( "gfx_deploy_inv_hookext_chainwithhook", { active = true } );
      ObjSet( "spr_deploy_inv_hookext_hookchain", { alp = 1 } );
      ObjDelete( "spr_deploy_inv_hookext_hook1" );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_chain", use_chain_beg, "inv_hookext" );
    cmn.AddSubscriber( "use_chain", use_chain_inv );
    cmn.AddSubscriber( "use_chain", use_chain_end, "inv_hookext" );
    cmn.AddSubscriber( "use_chain_inv", use_chain_inv );
    cmn.AddSubscriber( "use_chain_beg", use_chain_beg, "inv_hookext" );
    cmn.AddSubscriber( "use_chain_end", use_chain_end, "inv_hookext" );
    -------------------------------------------------------------------------------------------

  end;
  --*********************************************************************************************************************
  function private.get_chainwithhook ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_chainwithhook" );
    cmn.CallEventHandler( "get_chainwithhook", "inv_hookext" );

    int.DeployInvHide();

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function public.use_chain ()

    local item = "inv_chain";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_hookext_use_chain" ) ) then

      cmn.CallEventHandler( "use_chain_inv" );
      cmn.CallEventHandler( "use_chain_beg", "inv_hookext" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_chain" );
        cmn.CallEventHandler( "use_chain_end", "inv_hookext" );
      
      end;

      int.Lock( true );
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_chaintohook" );
      
      ObjAnimate( "spr_deploy_inv_hookext_hook1", "alp", 0, 0, "", 
      { 
        0.0, 0, 1,
        0.3, 0, 0,
      } );
      ObjAnimate( "spr_deploy_inv_hookext_hookchain", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** brokenflashlight *** ()
--*********************************************************************************************************************
  function private.brokenflashlight_init ()

    ObjSet( "spr_deploy_inv_brokenflashlight_flashlight",  { event_mdown = private.get_flashlight } );
    ObjSet( "spr_deploy_inv_brokenflashlight_cover",  { event_mdown = private.get_flashlight } );
    ObjSet( "obj_deploy_inv_brokenflashlight_open_clk",  { event_mdown = private.clk_open } );
    ObjSet( "obj_deploy_inv_brokenflashlight_close_clk",  { event_mdown = private.clk_close } );
    ObjSet( "obj_deploy_inv_brokenflashlight_clk_button",  { event_mdown = private.clk_button } );
    ObjSet( "spr_deploy_inv_brokenflashlight_wrench",  { event_mdown = private.get_wrenchext } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_flashlight" ] =
    {
      type = "get",
      get_obj = "obj_deploy_inv_brokenflashlight",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenflashlight",
      zz_gate = "inv_brokenflashlight"
    };
    -------------------------------------------------------------------------------------------
    function get_flashlight_inv ()

      interface.InventoryItemRemove( "inv_brokenflashlight" );
      interface.InventoryItemAdd( "inv_flashlight", "obj_deploy_inv_brokenflashlight" );

      ObjDelete( "gfx_deploy_inv_brokenflashlight_flashlight" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_flashlight", get_flashlight_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_wrenchext" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_brokenflashlight_wrench",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenflashlight",
      zz_gate = "inv_brokenflashlight"
    };
    -------------------------------------------------------------------------------------------
    function get_wrenchext_inv ()

      interface.InventoryItemAdd( "inv_wrenchext", "spr_deploy_inv_brokenflashlight_wrench" );

      if ( not cmn.IsEventDone( "get_batteryext_1" ) and
           not cmn.IsEventDone( "get_batteryext_2" ) and
           not cmn.IsEventDone( "get_bulbext" ) ) then

        ObjSet( "inv_brokenflashlight_plus_focus2", { alp = 0 } );

      end;

      ObjDelete( "gfx_deploy_inv_brokenflashlight_wrench" );
      ObjDelete( "spr_deploy_inv_brokenflashlight_wrench_shadow" );
      ObjSet( "obj_deploy_inv_brokenflashlight_use_batteryext", { input = true } );
      
      ObjDelete( "inv_brokenflashlight_wrench" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_wrenchext", get_wrenchext_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_bulbext" ] =
    {
      type = "use",
      use_obj = "inv_bulbext",
      use_place = "obj_deploy_inv_brokenflashlight_use_bulbext",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenflashlight",
      zz_gate = "inv_brokenflashlight"
    };
    -------------------------------------------------------------------------------------------
    function use_bulbext_inv ()
  
      if not cmn.IsEventDone( "get_batteryext_1" ) and
         not cmn.IsEventDone( "get_batteryext_2" ) then

        ObjSet( "inv_brokenflashlight_plus_focus2", { alp = 0 } );

      end;

      interface.InventoryItemRemove( "inv_bulbext" );
      ObjSet( "inv_brokenflashlight_lamp", { alp = 1 } );

    end;
    function use_bulbext_beg ()

      ObjDelete( "obj_deploy_inv_brokenflashlight_use_bulbext" );

    end;
    function use_bulbext_end ()

      ObjSet( "spr_deploy_inv_brokenflashlight_cover_bulb", { alp = 1 } );
      if cmn.IsEventDone( "clk_close" ) then
        ObjSet( "obj_deploy_inv_brokenflashlight_clk_button", { input = true } );
      end;

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_bulbext", use_bulbext_beg, "inv_brokenflashlight" );
    cmn.AddSubscriber( "use_bulbext", use_bulbext_inv );
    cmn.AddSubscriber( "use_bulbext", use_bulbext_end, "inv_brokenflashlight" );
    cmn.AddSubscriber( "use_bulbext_inv", use_bulbext_inv );
    cmn.AddSubscriber( "use_bulbext_beg", use_bulbext_beg, "inv_brokenflashlight" );
    cmn.AddSubscriber( "use_bulbext_end", use_bulbext_end, "inv_brokenflashlight" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_batteryext" ] =
    {
      type = "use",
      use_obj = "inv_batteryext",
      use_place = "obj_deploy_inv_brokenflashlight_use_batteryext",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenflashlight",
      zz_gate = "inv_brokenflashlight"
    };
    -------------------------------------------------------------------------------------------
    function use_batteryext_inv ()
  
      interface.InventoryItemRemove( "inv_batteryext" );
      ObjSet( "inv_brokenflashlight_battery", { alp = 1 } );

      if not cmn.IsEventDone( "get_bulbext" ) then

        ObjSet( "inv_brokenflashlight_plus_focus2", { alp = 0 } );

      end;

    end;
    function use_batteryext_beg ()

      ObjDelete( "obj_deploy_inv_brokenflashlight_use_batteryext" );

    end;
    function use_batteryext_end ()

      ObjSet( "spr_deploy_inv_brokenflashlight_battery1",  { alp = 1 } );
      ObjSet( "spr_deploy_inv_brokenflashlight_battery2",  { alp = 1 } );
      ObjSet( "obj_deploy_inv_brokenflashlight_close_clk", { input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_batteryext", use_batteryext_beg, "inv_brokenflashlight" );
    cmn.AddSubscriber( "use_batteryext", use_batteryext_inv );
    cmn.AddSubscriber( "use_batteryext", use_batteryext_end, "inv_brokenflashlight" );
    cmn.AddSubscriber( "use_batteryext_inv", use_batteryext_inv );
    cmn.AddSubscriber( "use_batteryext_beg", use_batteryext_beg, "inv_brokenflashlight" );
    cmn.AddSubscriber( "use_batteryext_end", use_batteryext_end, "inv_brokenflashlight" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_open" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_brokenflashlight_open_clk",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenflashlight",
      zz_gate = "inv_brokenflashlight"
    };
    -------------------------------------------------------------------------------------------
    function clk_open_inv ()
      
      ObjSet( "inv_brokenflashlight_open", { alp = 1 } );

    end;
    function clk_open_beg ()

      ObjDelete( "obj_deploy_inv_brokenflashlight_open_clk" );

    end;
    function clk_open_end ()

      ObjSet( "obj_deploy_inv_brokenflashlight_open", { alp = 1, input = true } );
      ObjSet( "spr_deploy_inv_brokenflashlight_wrench", { active = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_open", clk_open_inv );
    cmn.AddSubscriber( "clk_open", clk_open_beg, "inv_brokenflashlight" );
    cmn.AddSubscriber( "clk_open", clk_open_end, "inv_brokenflashlight" );
    cmn.AddSubscriber( "clk_open_inv", clk_open_inv );
    cmn.AddSubscriber( "clk_open_beg", clk_open_beg, "inv_brokenflashlight" );
    cmn.AddSubscriber( "clk_open_end", clk_open_end, "inv_brokenflashlight" );
    ------------------------------------------------------------------------------------------- 
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_close" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_brokenflashlight_close_clk",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenflashlight",
      zz_gate = "inv_brokenflashlight"
    };
    -------------------------------------------------------------------------------------------
    function clk_close_inv ()
      
      ObjDelete( "inv_brokenflashlight_open" );
      if not cmn.IsEventDone( "get_bulbext" ) then

        ObjSet( "inv_brokenflashlight_plus_focus2", { alp = 0 } );

      end;

    end;
    function clk_close_beg ()

      ObjDelete( "obj_deploy_inv_brokenflashlight_close_clk" );

    end;
    function clk_close_end ()

      ObjDelete( "obj_deploy_inv_brokenflashlight_open" );
      if cmn.IsEventDone( "use_bulbext" ) then
        ObjSet( "obj_deploy_inv_brokenflashlight_clk_button", { input = true } );
      end;

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_close", clk_close_inv );
    cmn.AddSubscriber( "clk_close", clk_close_beg, "inv_brokenflashlight" );
    cmn.AddSubscriber( "clk_close", clk_close_end, "inv_brokenflashlight" );
    cmn.AddSubscriber( "clk_close_inv", clk_close_inv );
    cmn.AddSubscriber( "clk_close_beg", clk_close_beg, "inv_brokenflashlight" );
    cmn.AddSubscriber( "clk_close_end", clk_close_end, "inv_brokenflashlight" );
    ------------------------------------------------------------------------------------------- 
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_button" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_brokenflashlight_clk_button",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenflashlight",
      zz_gate = "inv_brokenflashlight"
    };
    -------------------------------------------------------------------------------------------
    function clk_button_inv ()
      
      ObjSet( "inv_brokenflashlight", {res = "assets/levels/levelext/common_inventory4/inv_brokenflashlight/inv/inv_flashlight" } );

    end;
    function clk_button_beg ()

      ObjDelete( "obj_deploy_inv_brokenflashlight_clk_button" );

    end;
    function clk_button_end ()

      ObjSet( "spr_deploy_inv_brokenflashlight_press_button", { alp = 1 } );
      ObjSet( "spr_deploy_inv_brokenflashlight_light_add", { alp = 1 } );
      ObjSet( "spr_deploy_inv_brokenflashlight_flashlight", { input = true } );
      ObjSet( "spr_deploy_inv_brokenflashlight_cover", { input = true } );
      ObjSet( "gfx_deploy_inv_brokenflashlight_flashlight", { active = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_button", clk_button_inv );
    cmn.AddSubscriber( "clk_button", clk_button_beg, "inv_brokenflashlight" );
    cmn.AddSubscriber( "clk_button", clk_button_end, "inv_brokenflashlight" );
    cmn.AddSubscriber( "clk_button_inv", clk_button_inv );
    cmn.AddSubscriber( "clk_button_beg", clk_button_beg, "inv_brokenflashlight" );
    cmn.AddSubscriber( "clk_button_end", clk_button_end, "inv_brokenflashlight" );
    ------------------------------------------------------------------------------------------- 

  end;
  --*********************************************************************************************************************
  function private.get_flashlight ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_flashlight" );
    cmn.CallEventHandler( "get_flashlight", "inv_brokenflashlight" );

    int.DeployInvHide();

  end;
  --*********************************************************************************************************************
  function private.get_wrenchext ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_wrenchext" );
    cmn.CallEventHandler( "get_wrenchext", "inv_brokenflashlight" );

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
  function public.use_bulbext ()

    local item = "inv_bulbext";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_brokenflashlight_use_bulbext" ) ) then

      cmn.CallEventHandler( "use_bulbext_inv" );
      cmn.CallEventHandler( "use_bulbext_beg", "inv_brokenflashlight" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_bulbext" );
        cmn.CallEventHandler( "use_bulbext_end", "inv_brokenflashlight" );
      
      end;

      int.Lock( true );
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_lillamp" );

      ObjAnimate( "spr_deploy_inv_brokenflashlight_cover_bulb", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
  function public.use_batteryext ()

    local item = "inv_batteryext";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_brokenflashlight_use_batteryext" ) and 
         cmn.IsEventDone( "get_wrenchext" ) and
         cmn.IsEventDone( "get_batteryext_1" ) and
         cmn.IsEventDone( "get_batteryext_2" ) ) then

      cmn.CallEventHandler( "use_batteryext_inv" );
      cmn.CallEventHandler( "use_batteryext_beg", "inv_brokenflashlight" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_batteryext" );
        cmn.CallEventHandler( "use_batteryext_end", "inv_brokenflashlight" );
      
      end;

      int.Lock( true );
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_battery" );

      ObjAnimate( "spr_deploy_inv_brokenflashlight_battery1", "alp", 0, 0, "", 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );

      ObjAnimate( "spr_deploy_inv_brokenflashlight_battery2", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.4, 0, 0,
        0.7, 0, 1,
      } );
      
      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.clk_open ()

    cmn.CallEventHandler( "clk_open_inv", "inv_brokenflashlight" );
    cmn.CallEventHandler( "clk_open_beg", "inv_brokenflashlight" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_open" );
      cmn.CallEventHandler( "clk_open_end", "inv_brokenflashlight" );
    
    end;

    int.Lock( true );
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_openflashlitht" );

    ObjAnimate( "obj_deploy_inv_brokenflashlight_open", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.3, 0, 1,
    } );

    return true;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.clk_close ()

    cmn.CallEventHandler( "clk_close_inv", "inv_brokenflashlight" );
    cmn.CallEventHandler( "clk_close_beg", "inv_brokenflashlight" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_close" );
      cmn.CallEventHandler( "clk_close_end", "inv_brokenflashlight" );
    
    end;

    int.Lock( true );
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_closeflashlight" );
    ObjAnimate( "obj_deploy_inv_brokenflashlight_open", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 1,
      0.3, 0, 0,
    } );

    return true;

  end;
--*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.clk_button ()

    cmn.CallEventHandler( "clk_button_inv", "inv_brokenflashlight" );
    cmn.CallEventHandler( "clk_button_beg", "inv_brokenflashlight" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_button" );
      cmn.CallEventHandler( "clk_button_end", "inv_brokenflashlight" );
    
    end;

    int.Lock( true );
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_lighton" );

    ObjAnimate( "spr_deploy_inv_brokenflashlight_press_button", "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      0.3, 0, 1,
    } );
    ObjAnimate( "spr_deploy_inv_brokenflashlight_light_add", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.3, 0, 1,
    } );

    return true;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** swissknife *** ()
--*********************************************************************************************************************
  function private.swissknife_init ()

    ObjSet( "spr_deploy_inv_swissknife_base", { event_mdown = private.get_corkscrewext } );
    ObjSet( "spr_deploy_inv_swissknife_corkscrew", { event_mdown = private.get_corkscrewext } );
    ObjSet( "spr_deploy_inv_swissknife_opener_2_1", { event_mdown = private.get_corkscrewext } );
    ObjSet( "obj_deploy_inv_swissknife_clk_1",  { event_mdown = private.clk_swissknife_1 } );
    ObjSet( "obj_deploy_inv_swissknife_clk_2",  { event_mdown = private.clk_swissknife_2 } );
    ObjSet( "obj_deploy_inv_swissknife_blade_clk",  { event_mdown = private.clk_blade } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_corkscrewext" ] =
    {
      type = "get",
      get_obj = "obj_deploy_inv_swissknife_hint_tmp",
      room = "int_deploy_inv",
      zz = "deploy_inv_swissknife",
      zz_gate = "inv_swissknife"
    };
    -------------------------------------------------------------------------------------------
    function get_corkscrewext_inv ()

      interface.InventoryItemRemove( "inv_swissknife" );
      interface.InventoryItemAdd( "inv_corkscrewext", "obj_deploy_inv_swissknife" );

      ObjDelete( "gfx_deploy_inv_swissknife_corkscrewext" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_corkscrewext", get_corkscrewext_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_swissknife_1" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_swissknife_clk_1",
      room = "int_deploy_inv",
      zz = "deploy_inv_swissknife",
      zz_gate = "inv_swissknife"
    };
    -------------------------------------------------------------------------------------------
    function clk_swissknife_1_inv ()
      
      ObjSet( "inv_swissknife_open", { alp = 1 } );
      ObjDelete( "inv_swissknife_close" );

    end;
    function clk_swissknife_1_beg ()

      ObjDelete( "obj_deploy_inv_swissknife_clk_1" );      

    end;
    function clk_swissknife_1_end ()

      ObjDelete( "anm_deploy_inv_swissknife_open" );
      ObjSet( "spr_deploy_inv_swissknife_opener_2_1", { alp = 1 } );
      ObjSet( "spr_deploy_inv_swissknife_opener_2_2", { alp = 1 } );
      ObjSet( "obj_deploy_inv_swissknife_clk_2", { input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_swissknife_1", clk_swissknife_1_inv );
    cmn.AddSubscriber( "clk_swissknife_1", clk_swissknife_1_beg, "inv_swissknife" );
    cmn.AddSubscriber( "clk_swissknife_1", clk_swissknife_1_end, "inv_swissknife" );
    cmn.AddSubscriber( "clk_swissknife_1_inv", clk_swissknife_1_inv );
    cmn.AddSubscriber( "clk_swissknife_1_beg", clk_swissknife_1_beg, "inv_swissknife" );
    cmn.AddSubscriber( "clk_swissknife_1_end", clk_swissknife_1_end, "inv_swissknife" );
        -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------  
    common_impl.hint[ "clk_swissknife_2" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_swissknife_clk_2",
      room = "int_deploy_inv",
      zz = "deploy_inv_swissknife",
      zz_gate = "inv_swissknife"
    };
    -------------------------------------------------------------------------------------------
    function clk_swissknife_2_inv ()
      
      ObjSet( "inv_swissknife", { res = "assets/levels/levelext/common_inventory4/inv_swissknife/inv/inv_corkscrewext" } );
      ObjDelete( "inv_swissknife_open" );

    end;
    function clk_swissknife_2_beg ()

      ObjDelete( "obj_deploy_inv_swissknife_clk_2" );

    end;
    function clk_swissknife_2_end ()

      ObjSet( "spr_deploy_inv_swissknife_corkscrew", { pos_x = -30, pos_y = -150, ang = 0 } );
      ObjSet( "gfx_deploy_inv_swissknife_corkscrewext", { active = true } );
      ObjSet( "spr_deploy_inv_swissknife_base", { input = true } );
      ObjSet( "spr_deploy_inv_swissknife_corkscrew", { input = true } );
      ObjSet( "spr_deploy_inv_swissknife_opener_2_1", { input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_swissknife_2", clk_swissknife_2_inv );
    cmn.AddSubscriber( "clk_swissknife_2", clk_swissknife_2_beg, "inv_swissknife" );
    cmn.AddSubscriber( "clk_swissknife_2", clk_swissknife_2_end, "inv_swissknife" );
    cmn.AddSubscriber( "clk_swissknife_2_inv", clk_swissknife_2_inv );
    cmn.AddSubscriber( "clk_swissknife_2_beg", clk_swissknife_2_beg, "inv_swissknife" );
    cmn.AddSubscriber( "clk_swissknife_2_end", clk_swissknife_2_end, "inv_swissknife" );
    ------------------------------------------------------------------------------------------- 
    -------------------------------------------------------------------------------------------  

  end;
  --*********************************************************************************************************************
  function private.get_corkscrewext ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_corkscrewext" );
    cmn.CallEventHandler( "get_corkscrewext", "inv_swissknife" );

    int.DeployInvHide();

  end;
--***********************************************************************************************************************
  --*********************************************************************************************************************
  function private.clk_swissknife_1 ()

    cmn.CallEventHandler( "clk_swissknife_1_inv", "inv_swissknife" );
    cmn.CallEventHandler( "clk_swissknife_1_beg", "inv_swissknife" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_swissknife_1" );
      cmn.CallEventHandler( "clk_swissknife_1_end", "inv_swissknife" );
    
    end;

    int.Lock( true );
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_clk_knife" );

    AnimPlay( "anm_deploy_inv_swissknife_open", "DoAnim", func_end );

    return true;

  end;
  --*********************************************************************************************************************
  function private.clk_swissknife_2 ()

    cmn.CallEventHandler( "clk_swissknife_2_inv", "inv_swissknife" );
    cmn.CallEventHandler( "clk_swissknife_2_beg", "inv_swissknife" );

    local func_end = function ()

      int.Lock( false );
      
      cmn.SetEventDone( "clk_swissknife_2" );
      cmn.CallEventHandler( "clk_swissknife_2_end", "inv_swissknife" );
    
    end;

    int.Lock( true );        
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_clk_knife" );

    ObjAnimate("spr_deploy_inv_swissknife_corkscrew", "pos_xy", 0, 0, "", 
    {
      0.0,0,-33,-156,
      0.3,0,-30,-150
    });
    ObjAnimate("spr_deploy_inv_swissknife_corkscrew", "ang", 0, 0, func_end, 
    {
      0.0,0,1.39,
      0.3,0,0
    });    

    return true;

  end;
--*********************************************************************************************************************
  function private.clk_blade ()

    local func_end = function ()

      int.Lock( false );
    
    end;

    int.Lock( true );

    ObjAnimate( "spr_deploy_inv_swissknife_blade", "ang", 0, 0, func_end, 
    { 
      0.0, 3, 0,
      0.4, 3, -1.22,
      1.0, 1, -1.22,
      1.4, 1, 0,
    } );

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** tombstonebasis *** ()
--*********************************************************************************************************************
  function private.tombstonebasis_init ()

    ObjSet( "spr_deploy_inv_tombstonebasis_tombstonebasis",  { event_mdown = private.get_tombstone } );
    ObjSet( "spr_deploy_inv_tombstonebasis_tombstonepart_1",  { event_mdown = private.get_tombstone } );
    ObjSet( "spr_deploy_inv_tombstonebasis_tombstonepart_2",  { event_mdown = private.get_tombstone } );

    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_tombstone" ] =
    {
      type = "get",
      get_obj = "obj_deploy_inv_tombstonebasis",
      room = "int_deploy_inv",
      zz = "deploy_inv_tombstonebasis",
      zz_gate = "inv_tombstonebasis"
    };
    -------------------------------------------------------------------------------------------
    function get_tombstone_inv ()

      interface.InventoryItemRemove( "inv_tombstonebasis" );
      interface.InventoryItemAdd( "inv_tombstone", "obj_deploy_inv_tombstonebasis" );

      ObjDelete( "gfx_deploy_inv_tombstonebasis_tombstone" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_tombstone", get_tombstone_inv );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_tombstonepart_1" ] =
    {
      type = "use",
      use_obj = "inv_tombstonepart_1",
      use_place = "obj_deploy_inv_tombstonebasis_use_tombstonepart_1",
      room = "int_deploy_inv",
      zz = "deploy_inv_tombstonebasis",
      zz_gate = "inv_tombstonebasis"
    };
    -------------------------------------------------------------------------------------------
    function use_tombstonepart_1_inv ()
  
      interface.InventoryItemRemove( "inv_tombstonepart_1" );
      ObjSet( "inv_tombstonebasis", { res = "assets/levels/levelext/common_inventory4/inv_tombstonebasis/inv/stone_2" } );

      if ( not cmn.IsEventDone( "get_tombstonepart_2" ) ) then

        ObjSet( "inv_tombstonebasis_plus_focus2", { alp = 0 } );

      end;

    end;
    function use_tombstonepart_1_beg ()

      ObjDelete( "obj_deploy_inv_tombstonebasis_use_tombstonepart_1" );

    end;
    function use_tombstonepart_1_end ()

      ObjSet( "spr_deploy_inv_tombstonebasis_tombstonepart_1", { alp = 1 } );
      ObjSet( "obj_deploy_inv_tombstonebasis_use_tombstonepart_2", { input = true } );      

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_tombstonepart_1", use_tombstonepart_1_beg, "inv_tombstonebasis" );
    cmn.AddSubscriber( "use_tombstonepart_1", use_tombstonepart_1_inv );
    cmn.AddSubscriber( "use_tombstonepart_1", use_tombstonepart_1_end, "inv_tombstonebasis" );
    cmn.AddSubscriber( "use_tombstonepart_1_inv", use_tombstonepart_1_inv );
    cmn.AddSubscriber( "use_tombstonepart_1_beg", use_tombstonepart_1_beg, "inv_tombstonebasis" );
    cmn.AddSubscriber( "use_tombstonepart_1_end", use_tombstonepart_1_end, "inv_tombstonebasis" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_tombstonepart_2" ] =
    {
      type = "use",
      use_obj = "inv_tombstonepart_2",
      use_place = "obj_deploy_inv_tombstonebasis_use_tombstonepart_2",
      room = "int_deploy_inv",
      zz = "deploy_inv_tombstonebasis",
      zz_gate = "inv_tombstonebasis"
    };
    -------------------------------------------------------------------------------------------
    function use_tombstonepart_2_inv ()
  
      interface.InventoryItemRemove( "inv_tombstonepart_2" );
      ObjSet( "inv_tombstonebasis", { res = "assets/levels/levelext/common_inventory4/inv_tombstonebasis/inv/stone_3" } );

      if ( not cmn.IsEventDone( "get_glueext" ) ) then

        ObjSet( "inv_tombstonebasis_plus_focus2", { alp = 0 } );

      end;

    end;
    function use_tombstonepart_2_beg ()

      ObjDelete( "obj_deploy_inv_tombstonebasis_use_tombstonepart_2" );

    end;
    function use_tombstonepart_2_end ()

      ObjSet( "obj_deploy_inv_brokenflashlight_use_glueext", { input = true } );
      ObjSet( "obj_deploy_inv_tombstonebasis_use_glueext", { input = true } );
      ObjSet( "spr_deploy_inv_tombstonebasis_tombstonepart_2", { alp = 1 } );      

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_tombstonepart_2", use_tombstonepart_2_beg, "inv_tombstonebasis" );
    cmn.AddSubscriber( "use_tombstonepart_2", use_tombstonepart_2_inv );
    cmn.AddSubscriber( "use_tombstonepart_2", use_tombstonepart_2_end, "inv_tombstonebasis" );
    cmn.AddSubscriber( "use_tombstonepart_2_inv", use_tombstonepart_2_inv );
    cmn.AddSubscriber( "use_tombstonepart_2_beg", use_tombstonepart_2_beg, "inv_tombstonebasis" );
    cmn.AddSubscriber( "use_tombstonepart_2_end", use_tombstonepart_2_end, "inv_tombstonebasis" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_glueext" ] =
    {
      type = "use",
      use_obj = "inv_glueext",
      use_place = "obj_deploy_inv_tombstonebasis_use_glueext",
      room = "int_deploy_inv",
      zz = "deploy_inv_tombstonebasis",
      zz_gate = "inv_tombstonebasis"
    };
    -------------------------------------------------------------------------------------------
    function use_glueext_inv ()
  
      interface.InventoryItemRemove( "inv_glueext" );
      ObjSet( "inv_tombstonebasis", { res = "assets/levels/levelext/common_inventory4/inv_tombstonebasis/inv/inv_tombstone" } );

    end;
    function use_glueext_beg ()

      ObjDelete( "obj_deploy_inv_tombstonebasis_use_glueext" );

    end;
    function use_glueext_end ()

      ObjSet( "spr_deploy_inv_tombstonebasis_tombstonebasis", { input = true } );
      ObjSet( "spr_deploy_inv_tombstonebasis_tombstonepart_1", { input = true } );
      ObjSet( "spr_deploy_inv_tombstonebasis_tombstonepart_2", { input = true } );
      ObjSet( "spr_deploy_inv_tombstonebasis_glue1", { alp = 1 } );
      ObjSet( "spr_deploy_inv_tombstonebasis_glue2", { alp = 1 } );
      ObjSet( "gfx_deploy_inv_tombstonebasis_tombstone", { active = true } );
      ObjDelete( "anm_deploy_inv_tombstonebasis_use_glue" );      

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_glueext", use_glueext_beg, "inv_tombstonebasis" );
    cmn.AddSubscriber( "use_glueext", use_glueext_inv );
    cmn.AddSubscriber( "use_glueext", use_glueext_end, "inv_tombstonebasis" );
    cmn.AddSubscriber( "use_glueext_inv", use_glueext_inv );
    cmn.AddSubscriber( "use_glueext_beg", use_glueext_beg, "inv_tombstonebasis" );
    cmn.AddSubscriber( "use_glueext_end", use_glueext_end, "inv_tombstonebasis" );
    -------------------------------------------------------------------------------------------

  end;
  --*********************************************************************************************************************
  function private.get_tombstone ()

    cmn.PlayAudio( "sfx", "audio/aud_get_inv_sfx" );

    cmn.SetEventDone( "get_tombstone" );
    cmn.CallEventHandler( "get_tombstone", "inv_tombstonebasis" );

    int.DeployInvHide();

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function public.use_tombstonepart_1 ()

    local item = "inv_tombstonepart_1";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_tombstonebasis_use_tombstonepart_1" ) ) then

      cmn.CallEventHandler( "use_tombstonepart_1_inv" );
      cmn.CallEventHandler( "use_tombstonepart_1_beg", "inv_tombstonebasis" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_tombstonepart_1" );
        cmn.CallEventHandler( "use_tombstonepart_1_end", "inv_tombstonebasis" );
      
      end;

      int.Lock( true );
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_putstone" );

      ObjAnimate( "spr_deploy_inv_tombstonebasis_tombstonepart_1", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function public.use_tombstonepart_2 ()

    local item = "inv_tombstonepart_2";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_tombstonebasis_use_tombstonepart_2" ) and
         cmn.IsEventDone( "use_tombstonepart_1" ) ) then

      cmn.CallEventHandler( "use_tombstonepart_2_inv" );
      cmn.CallEventHandler( "use_tombstonepart_2_beg", "inv_tombstonebasis" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_tombstonepart_2" );
        cmn.CallEventHandler( "use_tombstonepart_2_end", "inv_tombstonebasis" );
      
      end;

      int.Lock( true );
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_putstone" );

      ObjAnimate( "spr_deploy_inv_tombstonebasis_tombstonepart_2", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );

      return true;

    end;

    return false;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function public.use_glueext ()

    local item = "inv_glueext";

    if ( int.ObjIntersectCheck( item, "obj_deploy_inv_tombstonebasis_use_glueext" ) and
         cmn.IsEventDone( "use_tombstonepart_2" ) ) then

      cmn.CallEventHandler( "use_glueext_inv" );
      cmn.CallEventHandler( "use_glueext_beg", "inv_tombstonebasis" );

      local func_end = function ()

        int.Lock( false );

        cmn.SetEventDone( "use_glueext" );
        cmn.CallEventHandler( "use_glueext_end", "inv_tombstonebasis" );
      
      end;

      int.Lock( true );
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_useglue" );

      AnimPlay( "anm_deploy_inv_tombstonebasis_use_glue", "DoAnim", func_end );

      return true;
    
    end;

    return false;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.Anim ()

  ObjAnimate( "spr_deploy_inv_brokenlantern_bluegem_light", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.2, 0, 0.5,
    2.4, 0, 1,
  } );
  ObjAnimate( "spr_deploy_inv_brokenlantern_lens_light", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.2, 0, 0.5,
    2.4, 0, 1,
  } );
  ObjAnimate( "spr_deploy_inv_hookext_hook1_add", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.2, 0, 0.5,
    2.4, 0, 1,
  } );
  ObjAnimate( "spr_deploy_inv_hookext_hookchain_add", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.2, 0, 0.5,
    2.4, 0, 1,
  } );
  ObjAnimate( "spr_deploy_inv_prunerpart_1_shine_add", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.2, 0, 0.5,
    2.4, 0, 1,
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*** function *** MMG HERBICIDE *** () end;
--*********************************************************************************************************************
  function private.HerbicideInit ()

    private.toxin_win = { 2, 1, 3 };

    private.color_code = 
    {
      { 0.082, 0.38, 0.772 },--синий
      { 0.5, 0.121, 0.54 },--фиолетовый
      { 0.82, 0.752, 0.25 },--желтый

      { { 1, 0, 3 },{ 0.8, 1, 0.1 } },--желто-зеленый ( 1с : 3ж )
      { { 1, 0, 2 },{ 0.6, 0.9, 0.1 } },--желто-зеленый ( 1с : 2ж )
      { { 2, 0, 3 },{ 0.5, 0.8, 0.2 } },--желто-зеленый ( 2с : 3ж )
      { { 1, 0, 1 },{ 0.4, 0.9, 0.15 } },--зеленый ( 1с : 1ж )
      { { 2, 0, 1 },{ 0.15, 0.8, 0.4 } },--сине-зеленый ( 2с : 1ж )
      { { 2, 0, 2 },{ 0.4, 0.9, 0.15 } },--зеленый ( 2с : 2ж )

      { { 0 }, { 0.26, 0.3, 0.21 } }--грязный
    };

    private.bulb_pos = { { -394, -343 }, { -230, -214 }, { 304, -324 },{ -8, -186 } };--расположение колб с реагентами слева направо, последний массив с колбой, где получаем гербецид
    ObjSet( "spr_deploy_inv_recipeext_pipette", { event_dragdrop = private.HerbicideDrop } );     
    int_deploy_inv.Define( "recipeext" );

    --*********************************************************************************************************************
    function recipeext.Reset ()

      ObjSet( "spr_deploy_inv_recipeext_fluid", { alp = 0 } );
      ng_global.progress[ "ext" ][ "win_recipeext" ].spoil = false;
      ng_global.progress[ "ext" ][ "win_recipeext" ].toxin_array = { 0, 0, 0 };
      ng_global.progress[ "ext" ][ "win_recipeext" ].color = { 0, 0, 0 };

    end;
    --*********************************************************************************************************************
    function recipeext.Skip ()
      
      private.HerbicideWin();

    end;

  end;
--*********************************************************************************************************************
  function private.HerbicideDrop ()

    local pipette_id = 0;
    local btype = "";

    if ( int.ObjIntersectCheck( "obj_deploy_inv_recipeext_pipette_tmp", "spr_deploy_inv_recipeext_blue_bulb" ) ) then
      pipette_id = 1;--синий
      btype = "blue";
    elseif ( int.ObjIntersectCheck( "obj_deploy_inv_recipeext_pipette_tmp", "spr_deploy_inv_recipeext_violet_bulb" ) ) then
      pipette_id = 2;--фиолетовый
      btype = "violet";
    elseif ( int.ObjIntersectCheck( "obj_deploy_inv_recipeext_pipette_tmp", "spr_deploy_inv_recipeext_poisons" ) ) then
      pipette_id = 3;--желтый
      btype = "yellow";
    end;

    if pipette_id ~= 0 then--если опустили пипетку в какую-нибудь из колб

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_pipette" ); 
      ObjSet( "spr_deploy_inv_recipeext_pipette", { alp = 0 } );
      ObjSet( "anm_deploy_inv_recipeext_"..btype.."_bulb", { alp = 1 } );
      AnimPlay( "anm_deploy_inv_recipeext_"..btype.."_bulb", "DoAnim", 
        function ()
          ObjSet( "spr_deploy_inv_recipeext_pipette", { alp = 1 } );
          ObjSet( "anm_deploy_inv_recipeext_"..btype.."_bulb", { alp = 0, frame = 0 } );
        end
      );

      private.HerbicideBulb ( pipette_id );

    end;

  end;
  --*********************************************************************************************************************
  function private.HerbicideBulb ( pipette_id )

    local tmp_array = {};

    for i = 1, 3 do
      tmp_array[ i ] = ng_global.progress[ "ext" ][ "win_recipeext" ].toxin_array[ i ];
    end;

    tmp_array[ pipette_id ] = tmp_array[ pipette_id ] + 1;
    local spoil = false;

    if ng_global.progress[ "ext" ][ "win_recipeext" ].spoil then--если раствор испорчен

      local bubble_id = 0;

      for i = 1, #ng_global.progress[ "ext" ][ "win_recipeext" ].toxin_array do

        if ng_global.progress[ "ext" ][ "win_recipeext" ].toxin_array[ i ] ~= 0 then

          if bubble_id == 0 then
            bubble_id = i;
          else 
            bubble_id = - 1;
            break;
          end;
          
        end;

      end;

      if ( bubble_id ~= - 1 and --если в колбе только одно вещесто и это вещество не то же, что и в пипетке
           bubble_id ~= pipette_id ) then

        private.HerbicideAnimBulbPoly ( 10 );--красим в грязный

      end;

    else--если мы еще не испортили раствор

      local empty = true;

      for i = 1, #ng_global.progress[ "ext" ][ "win_recipeext" ].toxin_array do
        if ng_global.progress[ "ext" ][ "win_recipeext" ].toxin_array[ i ] ~= 0 then
          empty = false;
          break;
        end;
      end;

      if empty then--если колба пуста

        private.HerbicideAnimBulbMono ( pipette_id );--красим раствор в тот цвет, который взяли

      else
  ------------------------------------------------------- 
        local code = 0;

        if pipette_id == 2 then--если взяли фиолетовый

          if ( ng_global.progress[ "ext" ][ "win_recipeext" ].toxin_array[ 1 ] == private.toxin_win[ 1 ] and 
               ng_global.progress[ "ext" ][ "win_recipeext" ].toxin_array[ 2 ] < 1 and
               ng_global.progress[ "ext" ][ "win_recipeext" ].toxin_array[ 3 ] == private.toxin_win[ 3 ] ) then

            ObjAnimate( "obj_deploy_inv_recipeext_mmg", "alp", 0, 0, "", 
            { 
              0.0, 0, 1,
              2.7, 0, 1,
              3.0, 0, 0
            } );
            ObjAnimate( "spr_deploy_inv_recipeext_herbicide", "alp", 0, 0, function() private.HerbicideWin() end, 
            { 
              0.0, 0, 0,
              2.7, 0, 0,
              3.0, 0, 1
            } );

          elseif ng_global.progress[ "ext" ][ "win_recipeext" ].toxin_array[ 2 ] >= 1 then

            code = 10;--красим в грязный, отмечаем, что состав испорчен
            spoil = true;
            private.HerbicideAnimBulbPoly ( code );
       
          end;

        else--если взяли желтый или синий 

          local bubble_id = 0;

          for i = 1, #ng_global.progress[ "ext" ][ "win_recipeext" ].toxin_array do

            if ng_global.progress[ "ext" ][ "win_recipeext" ].toxin_array[ i ] ~= 0 then

              if bubble_id == 0 then
                bubble_id = i;
              else 
                bubble_id = - 1;
                break;
              end;
              
            end;

          end;

          if ( bubble_id ~= - 1 ) then--если в колбе только одно вещесто 

            if ( bubble_id ~= pipette_id ) then--и это вещество не то же, что и в пипетке

              if tmp_array[ pipette_id ] <= private.toxin_win[ pipette_id ] then

                for i = 4, 9 do

                  if ( tmp_array[ 1 ] == private.color_code[ i ][ 1 ][ 1 ]and
                       tmp_array[ 3 ] == private.color_code[ i ][ 1 ][ 3 ] ) then

                    code = i;--красим в цвет по коду
                    private.HerbicideAnimBulbPoly ( code );
                    break;   

                  end;

                end;

              else

                code = 10;--красим в грязный, отмечаем, что состав испорчен
                spoil = true;
                private.HerbicideAnimBulbPoly ( code );
                
              end;

            else--берем такое же вещество, что и в колбе у нас 

              if tmp_array[ pipette_id ] > private.toxin_win[ pipette_id ] then--превысили допустимую норму
                spoil = true;--отмечаем раствор испорченным
              end;

            end;

          else--если в колбе 2 вещества

            if tmp_array[ pipette_id ] <= private.toxin_win[ pipette_id ] then

              for i = 4, 9 do

                if ( tmp_array[ 1 ] == private.color_code[ i ][ 1 ][ 1 ]and
                     tmp_array[ 3 ] == private.color_code[ i ][ 1 ][ 3 ] ) then

                  code = i;--красим в цвет по коду
                  private.HerbicideAnimBulbPoly ( code );

                  break;   

                end;

              end;

            else

              code = 10;--красим в грязный, отмечаем, что состав испорчен
              spoil = true;
              private.HerbicideAnimBulbPoly ( code );
              
            end;

          end;

        end;

      end;

  ------------------------------------------------------- 
    end;

    local func_end = function ()

      if spoil then
        ng_global.progress[ "ext" ][ "win_recipeext" ].spoil = true;

      end;

      ng_global.progress[ "ext" ][ "win_recipeext" ].toxin_array = tmp_array;
      int.Lock( false );

    end;

    ObjSet( "tmr_deploy_inv_recipeext_mmg", { playing = 1, time = 1.3, endtrig = func_end } ); 

  end;
  --*********************************************************************************************************************
  function private.HerbicideAnimBulbMono ( code )

    local code = tonumber( code );
    local new_r = private.color_code[ code ][ 1 ];
    local new_g = private.color_code[ code ][ 2 ];
    local new_b = private.color_code[ code ][ 3 ];

    local func_end = function ()
      ng_global.progress[ "ext" ][ "win_recipeext" ].color = { new_r, new_g, new_b };
      private.HerbicideCheckWin();
    end;

    ObjSet( "spr_deploy_inv_recipeext_fluid", { color_r = new_r, color_g = new_g, color_b = new_b } );
    ObjAnimate( "spr_deploy_inv_recipeext_fluid", "alp", 0, 0, func_end, 
    { 
      0.3, 0, 0,
      2.7, 0, 0,
      3.0, 0, 1
    } );

  end;
  --*********************************************************************************************************************
  function private.HerbicideAnimBulbPoly ( code )

    local code = tonumber( code );

    local cur_r = ObjGet( "spr_deploy_inv_recipeext_fluid" ).color_r;
    local cur_g = ObjGet( "spr_deploy_inv_recipeext_fluid" ).color_g;
    local cur_b = ObjGet( "spr_deploy_inv_recipeext_fluid" ).color_b;

    local new_r = private.color_code[ code ][ 2 ][ 1 ];
    local new_g = private.color_code[ code ][ 2 ][ 2 ];
    local new_b = private.color_code[ code ][ 2 ][ 3 ];

    local func_end = function ()
      ng_global.progress[ "ext" ][ "win_recipeext" ].color = { new_r, new_g, new_b };
      private.HerbicideCheckWin();
    end;

    ObjAnimate( "spr_deploy_inv_recipeext_fluid", "color_rgb", 0, 0, func_end, 
    { 
      0.3, 0, cur_r, cur_g, cur_b,
      2.7, 0, cur_r, cur_g, cur_b,
      3.0, 0, new_r, new_g, new_b,
    } );

  end;
  --*********************************************************************************************************************
  function private.HerbicideCheckWin ()

    if ( ng_global.progress[ "ext" ][ "win_recipeext" ].toxin_array[ 1 ] == private.toxin_win[ 1 ] and 
         ng_global.progress[ "ext" ][ "win_recipeext" ].toxin_array[ 2 ] == private.toxin_win[ 2 ] and 
         ng_global.progress[ "ext" ][ "win_recipeext" ].toxin_array[ 3 ] == private.toxin_win[ 3 ] ) then
         
      private.HerbicideWin();
      
    end;
    
  end;
--*********************************************************************************************************************
  function private.HerbicideWin ()

    local func_end = function ()
    
      int.Lock( false );
      cmn.MiniGameHide( "recipeext" );
      common_impl.PassingMgWin( "recipeext" );

      cmn.SetEventDone( "win_recipeext" );
      cmn.CallEventHandler( "win_recipeext" );
      
    end;
    
    int.Lock( true );
    
    ObjAnimate("obj_deploy_inv_recipeext_mmg", "alp", 0, 0, "", 
    {
      0.0,0,1,
      0.3,0,0
    });
    ObjAnimate("spr_deploy_inv_recipeext_herbicide", "alp", 0, 0, func_end, 
    {
      0.0,0,0,
      0.3,0,1
    });

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.CheckAmuletskull ()

  local count = 0;
  
  for i = 1, 3 do
    
    local name = "get_amuletskull_"..i;
    
    if ( cmn.IsEventDone( name ) ) then
      
      count = count + 1;
      
    end;
    
  end;
  
  ObjSet( "inv_amuletskull", { res = "assets/levels/levelext/rm_farm/zz_skeletons/inv/inv_amuletskull_"..count } );
  
end;
--*********************************************************************************************************************
function public.CheckPortrait ( num )
  
  local count = 0;
  
  for i = 1, 3 do
    
    local name = "get_portrait_"..i;
    
    if ( cmn.IsEventDone( name ) ) then

      count = count + 1;
      
    end;
    
  end;
  
  for i = 1, count do
    
    ObjSet( "spr_portrait_"..i, { alp = 1 } );
    
  end;
  
  ObjSet( "spr_portrait_"..count, { res = "assets/levels/levelext/rm_cemetery/zz_gravestone/inv/inv_portrait_"..num } );
  
  if ( count < 3 ) then
  
    ObjSet( "spr_portrait_count",   { res = "assets/levels/levelext/rm_cemetery/zz_gravestone/inv/inv_portrait_count_"..count } );
  
  else
  
    ObjSet( "spr_portrait_count",   { alp = 0 } );
    
  end;
  
end;
--*********************************************************************************************************************
function public.CheckBasrelief ()
  
  local count = 0;
  
  for i = 1, 3 do
    
    local name = "get_basrelief_"..i;
    
    if ( cmn.IsEventDone( name ) ) then
      
      count = count + 1;
      
    end;
    
  end;
  
  ObjSet( "inv_basrelief", { res = "assets/levels/levelext/rm_nearcar/zz_pit/inv/inv_basrelief_"..count } );
  
end;
--*********************************************************************************************************************
function public.CheckPhoenixfeather ()
  
  local count = 0;
  
  for i = 1, 3 do
    
    local name = "get_phoenixfeather_"..i;
    
    if ( cmn.IsEventDone( name ) ) then
      
      count = count + 1;
      
    end;
    
  end;
  
  ObjSet( "inv_phoenixfeather", { res = "assets/levels/levelext/rm_livingroomext/zz_windowext/inv/inv_phoenixfeather_"..count } );
  
end;
--*********************************************************************************************************************
function public.CheckPlane ()
  
  local path = "inv_plane_1";
  
  if ( cmn.IsEventDone( "get_plane_1" ) and cmn.IsEventDone( "get_plane_2" ) ) then
    
    path = "inv_plane_2";
    
  end;
  
  ObjSet( "inv_plane", { res = "assets/levels/levelext/rm_livingroomext/zz_windowext/inv/"..path } );
  
end;
--*********************************************************************************************************************
function public.CheckBatteryext ()
  
  local path = "inv_batteryext_1";
  
  if ( cmn.IsEventDone( "get_batteryext_1" ) and cmn.IsEventDone( "get_batteryext_2" ) ) then
    
    path = "inv_batteryext_2";
    
  end;
  
  ObjSet( "inv_batteryext", { res = "assets/levels/levelext/rm_flightdeck/zz_panelext/inv/"..path } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************