-- name=rm_basementext
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_basementext";

  ObjAttach( "zz_tree4",   "room_hub" );
  ObjAttach( "zz_rift",    "room_hub" );
  ObjAttach( "zz_picture", "room_hub" );

  ObjMultiSet( {
    { "spr_tree4_flute",              { event_mdown = private.get_flute } },
    { "spr_tree4_tuningforkext",      { event_mdown = private.get_tuningforkext } },
    { "spr_tree4_brushext",           { event_mdown = private.get_brushext } },
    { "spr_rift_fileext",             { event_mdown = private.get_fileext } },
    { "spr_rift_spring_2",            { event_mdown = private.get_spring_2 } },
    { "spr_rift_safehandle",          { event_mdown = private.get_safehandle } },
    { "spr_picture_amuletviolin",     { event_mdown = private.get_amuletviolin } },
    { "spr_picture_phoenixfeather_2", { event_mdown = private.get_phoenixfeather_2 } },
    { "spr_picture_phoenixfeather_3", { event_mdown = private.get_phoenixfeather_3 } },
    { "spr_picture_bronzering",       { event_mdown = private.get_bronzering } },
    { "obj_tree4_clk_bells",          { event_mdown = private.clk_bells } },
    { "obj_rift_clk_chain",           { event_mdown = private.clk_chain } },
    { "obj_rift_clk_chest",           { event_mdown = private.clk_chest } },
    { "obj_tree4_use_bells",          { event_mdown = private.Tree4BellsClick } },
    { "obj_picture_clk_safehandle",   { event_mdown = private.clk_safehandle } },
    { "spr_rift_collect2_4_3",        { event_mdown = private.get_collect2_4_3 } },
    { "obj_picture_use_brushext",     { event_mdown = private.PictureWebClick } },
    { "obj_rift_use_bronzering",      { event_mdown = private.RiftLockClick } },
  } );

  private.InitAnims();
  --private.InitAnimGhost();
  private.InitPicture();
  private.InitSubroom();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_basementext = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gzz_basementext_tree4",
        "gzz_basementext_rift",
        "gzz_basementext_picture"
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_tree4", 
        "zz_rift", 
        "zz_picture", 
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_basementext", update_game_mode_basementext, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_flute () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_flute" ] =
  {
    type = "get",
    get_obj = "spr_tree4_flute",
    room = private.room_objname,
    zz = "zz_tree4",
    zz_gate = "gzz_basementext_tree4"
  };
  -----------------------------------------------
  local get_flute_inv = function ()

    int.InventoryItemAdd( "inv_flute", "spr_tree4_flute" );

  end;

  local get_flute_closezz = function ()

    ObjDelete( "spr_basementext_tree4_flute" );

    if ( cmn.IsEventDone( "get_brushext" ) ) and
       ( cmn.IsEventDone( "get_tuningforkext" ) ) then

      ObjDelete( "gzz_basementext_tree4" );

    end;

  end;

  cmn.AddSubscriber( "get_flute", get_flute_inv );
  cmn.AddSubscriber( "get_flute", get_flute_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tuningforkext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tuningforkext" ] =
  {
    type = "get",
    get_obj = "spr_tree4_tuningforkext",
    room = private.room_objname,
    zz = "zz_tree4",
    zz_gate = "gzz_basementext_tree4"
  };
  -----------------------------------------------
  local get_tuningforkext_inv = function ()

    int.InventoryItemAdd( "inv_tuningforkext", "spr_tree4_tuningforkext" );

  end;

  local get_tuningforkext_closezz = function ()

    ObjDelete( "gfx_tree4_tuningforkext" );
    ObjDelete( "spr_tree4_tuningforkext_shadow" );
    ObjDelete( "spr_basementext_tree4_camerton" );

    if ( cmn.IsEventDone( "get_flute" ) ) and
       ( cmn.IsEventDone( "get_brushext" ) ) then

      ObjDelete( "gzz_basementext_tree4" );

    end;

  end;

  cmn.AddSubscriber( "get_tuningforkext", get_tuningforkext_inv );
  cmn.AddSubscriber( "get_tuningforkext", get_tuningforkext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brushext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brushext" ] =
  {
    type = "get",
    get_obj = "spr_tree4_brushext",
    room = private.room_objname,
    zz = "zz_tree4",
    zz_gate = "gzz_basementext_tree4"
  };
  -----------------------------------------------
  local get_brushext_inv = function ()

    int.InventoryItemAdd( "inv_brushext", "spr_tree4_brushext" );

  end;

  local get_brushext_closezz = function ()

    ObjDelete( "gfx_tree4_brushext" );
    ObjDelete( "spr_tree4_brushext_shadow" );
    ObjDelete( "spr_basementext_tree4_brush" );
    
    if ( cmn.IsEventDone( "get_flute" ) ) and
       ( cmn.IsEventDone( "get_tuningforkext" ) ) then

      ObjDelete( "gzz_basementext_tree4" );

    end;

  end;

  cmn.AddSubscriber( "get_brushext", get_brushext_inv );
  cmn.AddSubscriber( "get_brushext", get_brushext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fileext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fileext" ] =
  {
    type = "get",
    get_obj = "spr_rift_fileext",
    room = private.room_objname,
    zz = "zz_rift",
    zz_gate = "gzz_basementext_rift"
  };
  -----------------------------------------------
  local get_fileext_inv = function ()

    int.InventoryItemAdd( "inv_fileext", "spr_rift_fileext" );

  end;

  local get_fileext_closezz = function ()

    ObjDelete( "gfx_rift_fileext" );
    ObjDelete( "spr_basementext_rift_file" );

  end;

  cmn.AddSubscriber( "get_fileext", get_fileext_inv );
  cmn.AddSubscriber( "get_fileext", get_fileext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_spring_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_spring_2" ] =
  {
    type = "get",
    get_obj = "spr_rift_spring_2",
    room = private.room_objname,
    zz = "zz_rift",
    zz_gate = "gzz_basementext_rift"
  };
  -----------------------------------------------
  local get_spring_2_inv = function ()

    int.InventoryItemAdd( "inv_spring_2", "spr_rift_spring_2" );

  end;

  local get_spring_2_closezz = function ()

    ObjDelete( "gfx_rift_spring_2" );
    ObjDelete( "spr_basementext_rift_spring" );
    ObjDelete( "spr_rift_spring_2_shadow" );
        
    if ( cmn.IsEventDone( "get_safehandle" )  and 
       cmn.IsEventDone( "get_collect2_4_3" ) ) then

      ObjDelete( "gzz_basementext_rift" );

    end;

  end;

  cmn.AddSubscriber( "get_spring_2", get_spring_2_inv );
  cmn.AddSubscriber( "get_spring_2", get_spring_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_safehandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_safehandle" ] =
  {
    type = "get",
    get_obj = "spr_rift_safehandle",
    room = private.room_objname,
    zz = "zz_rift",
    zz_gate = "gzz_basementext_rift"
  };
  -----------------------------------------------
  local get_safehandle_inv = function ()

    int.InventoryItemAdd( "inv_safehandle", "spr_rift_safehandle" );

  end;

  local get_safehandle_closezz = function ()

    ObjDelete( "gfx_rift_safehandle" );
    ObjDelete( "spr_basementext_rift_valve_rife" );
    ObjDelete( "spr_rift_safehandle_shadow" );
    
    if ( cmn.IsEventDone( "get_spring_2" )  and 
       cmn.IsEventDone( "get_collect2_4_3" ) ) then

      ObjDelete( "gzz_basementext_rift" );

    end;

  end;

  cmn.AddSubscriber( "get_safehandle", get_safehandle_inv );
  cmn.AddSubscriber( "get_safehandle", get_safehandle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletviolin () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletviolin" ] =
  {
    type = "get",
    get_obj = "spr_picture_amuletviolin",
    room = private.room_objname,
    zz = "zz_picture",
    zz_gate = "gzz_basementext_picture"
  };
  -----------------------------------------------
  local get_amuletviolin_inv = function ()

    int.InventoryItemAdd( "inv_amuletviolin", "spr_picture_amuletviolin" );

  end;

  local get_amuletviolin_closezz = function ()

    ObjDelete( "gfx_picture_amuletviolin" );
    ObjDelete( "spr_picture_amuletviolin_shadow" );
    ObjDelete( "spr_basementext_picture_amulet" );

    if cmn.IsEventDone( "use_paints" ) then
      
      ObjSet( "spr_picture_brush", { input = true } );
      
    end;

  end;

  cmn.AddSubscriber( "get_amuletviolin", get_amuletviolin_inv );
  cmn.AddSubscriber( "get_amuletviolin", get_amuletviolin_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_phoenixfeather_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_phoenixfeather_2" ] =
  {
    type = "get",
    get_obj = "spr_picture_phoenixfeather_2",
    room = private.room_objname,
    zz = "zz_picture",
    zz_gate = "gzz_basementext_picture"
  };
  -----------------------------------------------
  local get_phoenixfeather_2_inv = function ()

    int.InventoryItemAdd( "inv_phoenixfeather", "spr_picture_phoenixfeather_2", "assets/levels/levelext/rm_livingroomext/zz_windowext/inv/inv_phoenixfeather_morph" );
    levelext_inv.CheckPhoenixfeather();
    
  end;

  local get_phoenixfeather_2_closezz = function ()

    ObjDelete( "gfx_picture_phoenixfeather_2" );
    ObjDelete( "spr_picture_phoenixfeather_2_shadow" );
    ObjDelete( "spr_basementext_picture_feather_1" );
    
    if cmn.IsEventDone( "get_bronzering" ) then
      ObjSet( "obj_picture_use_safehandle", { input = true } );
    end;

  end;

  cmn.AddSubscriber( "get_phoenixfeather_2", get_phoenixfeather_2_inv );
  cmn.AddSubscriber( "get_phoenixfeather_2", get_phoenixfeather_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_phoenixfeather_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_phoenixfeather_3" ] =
  {
    type = "get",
    get_obj = "spr_picture_phoenixfeather_3",
    room = private.room_objname,
    zz = "zz_picture",
    zz_gate = "gzz_basementext_picture"
  };
  -----------------------------------------------
  local get_phoenixfeather_3_inv = function ()

    int.InventoryItemAdd( "inv_phoenixfeather", "spr_picture_phoenixfeather_3", "assets/levels/levelext/rm_livingroomext/zz_windowext/inv/inv_phoenixfeather_morph" );
    levelext_inv.CheckPhoenixfeather();

  end;

  local get_phoenixfeather_3_closezz = function ()

    ObjDelete( "gfx_picture_phoenixfeather_3" );
    ObjDelete( "gzz_basementext_picture" );
    ObjDelete( "spr_basementext_picture_feather_2" );
    ObjDelete( "spr_picture_phoenixfeather_3_shadow" );
    
  end;

  cmn.AddSubscriber( "get_phoenixfeather_3", get_phoenixfeather_3_inv );
  cmn.AddSubscriber( "get_phoenixfeather_3", get_phoenixfeather_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bronzering () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bronzering" ] =
  {
    type = "get",
    get_obj = "spr_picture_bronzering",
    room = private.room_objname,
    zz = "zz_picture",
    zz_gate = "gzz_basementext_picture"
  };
  -----------------------------------------------
  local get_bronzering_inv = function ()

    int.InventoryItemAdd( "inv_bronzering", "spr_picture_bronzering" );

  end;

  local get_bronzering_closezz = function ()

    ObjDelete( "gfx_picture_bronzering" );
    ObjDelete( "spr_picture_bronzering_shadow" );
    ObjDelete( "spr_basementext_picture_ring" );
    ObjDelete( "anm_picture_hotspot" );
    
    if cmn.IsEventDone( "get_phoenixfeather_2" ) then
      ObjSet( "obj_picture_use_safehandle", { input = true } );
    end;

  end;

  cmn.AddSubscriber( "get_bronzering", get_bronzering_inv );
  cmn.AddSubscriber( "get_bronzering", get_bronzering_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_4_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_4_3 = function ()

    ObjDelete( "spr_rift_collect2_4_3" );
    ObjDelete( "spr_basementext_rift_collect" );

    if ( cmn.IsEventDone( "get_spring_2" ) and
         cmn.IsEventDone( "get_safehandle" ) ) then

         ObjDelete( "gzz_basementext_rift" );

    end;
    
  end;

  cmn.AddSubscriber( "get_collect2_4_3", get_collect2_4_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_4_1 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_4_1 = function ()

    ObjDelete( "obj_basementext_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_4_1", get_morphobject_4_1, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_trebleclef () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_trebleclef" ] =
  {
    type = "use",
    use_obj = "inv_trebleclef",
    use_place = "obj_tree4_use_trebleclef",
    room = private.room_objname,
    zz = "zz_tree4",
    zz_gate = "gzz_basementext_tree4"
  };
  -----------------------------------------------
  local use_trebleclef_inv = function ()

    int.InventoryItemRemove( "inv_trebleclef" );

  end;
  local use_trebleclef_beg = function ()

    ObjDelete( "obj_tree4_use_trebleclef" );

  end;
  local use_trebleclef_end = function ()

    ObjSet( "obj_tree4_harp_open",     { alp = 1 } );
    ObjSet( "spr_basementext_tree4_harp_open", { alp = 1 } );
    ObjSet( "spr_tree4_tuningforkext", { input = true, active = true } );
    ObjDelete( "spr_tree4_trebleclef" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_trebleclef", use_trebleclef_beg, private.room_objname );
  cmn.AddSubscriber( "use_trebleclef", use_trebleclef_inv );
  cmn.AddSubscriber( "use_trebleclef", use_trebleclef_end, private.room_objname );
  cmn.AddSubscriber( "use_trebleclef_inv", use_trebleclef_inv, private.room_objname );
  cmn.AddSubscriber( "use_trebleclef_beg", use_trebleclef_beg, private.room_objname );
  cmn.AddSubscriber( "use_trebleclef_end", use_trebleclef_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bells () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bells" ] =
  {
    type = "use",
    use_obj = "inv_bells",
    use_place = "obj_tree4_use_bells",
    room = private.room_objname,
    zz = "zz_tree4",
    zz_gate = "gzz_basementext_tree4"
  };
  -----------------------------------------------
  local use_bells_inv = function ()

    int.InventoryItemRemove( "inv_bells" );

  end;
  local use_bells_beg = function ()

    ObjDelete( "obj_tree4_use_bells" );

  end;
  local use_bells_end = function ()

    ObjSet( "spr_tree4_bell_3",    { alp = 1 } );
    ObjSet( "spr_tree4_bell_4",    { alp = 1 } );
    ObjSet( "obj_tree4_clk_bells", { input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_bells", use_bells_beg, private.room_objname );
  cmn.AddSubscriber( "use_bells", use_bells_inv );
  cmn.AddSubscriber( "use_bells", use_bells_end, private.room_objname );
  cmn.AddSubscriber( "use_bells_inv", use_bells_inv, private.room_objname );
  cmn.AddSubscriber( "use_bells_beg", use_bells_beg, private.room_objname );
  cmn.AddSubscriber( "use_bells_end", use_bells_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chainwithhook () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chainwithhook" ] =
  {
    type = "use",
    use_obj = "inv_chainwithhook",
    use_place = "obj_rift_use_chainwithhook",
    room = private.room_objname,
    zz = "zz_rift",
    zz_gate = "gzz_basementext_rift"
  };
  -----------------------------------------------
  local use_chainwithhook_inv = function ()

    int.InventoryItemRemove( "inv_chainwithhook" );

  end;
  local use_chainwithhook_beg = function ()

    ObjDelete( "obj_rift_use_chainwithhook" );

  end;
  local use_chainwithhook_end = function ()

    ObjSet( "anm_rift_box_lift", { alp = 1 } );
    ObjSet( "obj_rift_clk_chain", { input = true } );
    ObjSet( "spr_basementext_rift_circuit", { alp = 1 } );
    ObjDelete( "anm_rift_chain_trow" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_chainwithhook", use_chainwithhook_beg, private.room_objname );
  cmn.AddSubscriber( "use_chainwithhook", use_chainwithhook_inv );
  cmn.AddSubscriber( "use_chainwithhook", use_chainwithhook_end, private.room_objname );
  cmn.AddSubscriber( "use_chainwithhook_inv", use_chainwithhook_inv, private.room_objname );
  cmn.AddSubscriber( "use_chainwithhook_beg", use_chainwithhook_beg, private.room_objname );
  cmn.AddSubscriber( "use_chainwithhook_end", use_chainwithhook_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bronzering () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bronzering" ] =
  {
    type = "use",
    use_obj = "inv_bronzering",
    use_place = "obj_rift_use_bronzering",
    room = private.room_objname,
    zz = "zz_rift",
    zz_gate = "gzz_basementext_rift"
  };
  -----------------------------------------------
  local use_bronzering_inv = function ()

    int.InventoryItemRemove( "inv_bronzering" );

  end;
  local use_bronzering_beg = function ()

    ObjDelete( "obj_rift_use_bronzering" );

  end;
  local use_bronzering_end = function ()

    ObjSet("spr_rift_ring_1",    { alp = 1 } );
    ObjSet("obj_rift_clk_chest", { input = true });

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_bronzering", use_bronzering_beg, private.room_objname );
  cmn.AddSubscriber( "use_bronzering", use_bronzering_inv );
  cmn.AddSubscriber( "use_bronzering", use_bronzering_end, private.room_objname );
  cmn.AddSubscriber( "use_bronzering_inv", use_bronzering_inv, private.room_objname );
  cmn.AddSubscriber( "use_bronzering_beg", use_bronzering_beg, private.room_objname );
  cmn.AddSubscriber( "use_bronzering_end", use_bronzering_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_paints () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_paints" ] =
  {
    type = "use",
    use_obj = "inv_paints",
    use_place = "obj_picture_use_paints",
    room = private.room_objname,
    zz = "zz_picture",
    zz_gate = "gzz_basementext_picture"
  };
  -----------------------------------------------
  local use_paints_inv = function ()

    int.InventoryItemRemove( "inv_paints" );

  end;
  local use_paints_beg = function ()

    ObjDelete( "obj_picture_use_paints" );

  end;
  local use_paints_end = function ()

    ObjSet( "spr_picture_paints", { alp = 1 } );
    ObjSet( "spr_picture_brush", { alp = 1 } );
    ObjSet( "spr_basementext_picture_paint", { alp = 1 } );
    
    if cmn.IsEventDone( "get_amuletviolin" ) then
      
      ObjSet( "spr_picture_brush", { input = true } );
      
    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_paints", use_paints_beg, private.room_objname );
  cmn.AddSubscriber( "use_paints", use_paints_inv );
  cmn.AddSubscriber( "use_paints", use_paints_end, private.room_objname );
  cmn.AddSubscriber( "use_paints_inv", use_paints_inv, private.room_objname );
  cmn.AddSubscriber( "use_paints_beg", use_paints_beg, private.room_objname );
  cmn.AddSubscriber( "use_paints_end", use_paints_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_brushext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_brushext" ] =
  {
    type = "use",
    use_obj = "inv_brushext",
    use_place = "obj_picture_use_brushext",
    room = private.room_objname,
    zz = "zz_picture",
    zz_gate = "gzz_basementext_picture"
  };
  -----------------------------------------------
  local use_brushext_inv = function ()

    int.InventoryItemRemove( "inv_brushext" );

  end;
  local use_brushext_beg = function ()

    ObjDelete( "obj_picture_use_brushext" );

  end;
  local use_brushext_end = function ()

    ObjSet( "spr_picture_amuletviolin", { input = true, active = true } );
    ObjDelete( "anm_picture_web" );
    ObjDelete( "anm_picture_brushext" );
    ObjDelete( "spr_basementext_picture_web" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_brushext", use_brushext_beg, private.room_objname );
  cmn.AddSubscriber( "use_brushext", use_brushext_inv );
  cmn.AddSubscriber( "use_brushext", use_brushext_end, private.room_objname );
  cmn.AddSubscriber( "use_brushext_inv", use_brushext_inv, private.room_objname );
  cmn.AddSubscriber( "use_brushext_beg", use_brushext_beg, private.room_objname );
  cmn.AddSubscriber( "use_brushext_end", use_brushext_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_safehandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_safehandle" ] =
  {
    type = "use",
    use_obj = "inv_safehandle",
    use_place = "obj_picture_use_safehandle",
    room = private.room_objname,
    zz = "zz_picture",
    zz_gate = "gzz_basementext_picture"
  };
  -----------------------------------------------
  local use_safehandle_inv = function ()

    int.InventoryItemRemove( "inv_safehandle" );

  end;
  local use_safehandle_beg = function ()

    ObjDelete( "obj_picture_use_safehandle" );

  end;
  local use_safehandle_end = function ()

    ObjSet( "spr_picture_safehandle_shadow", { alp = 1 } );
    ObjSet( "spr_picture_safehandle", { alp = 1 } );
    ObjSet( "spr_basementext_picture_valve", { alp = 1 } );
    ObjSet( "obj_picture_clk_safehandle", { input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_safehandle", use_safehandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_safehandle", use_safehandle_inv );
  cmn.AddSubscriber( "use_safehandle", use_safehandle_end, private.room_objname );
  cmn.AddSubscriber( "use_safehandle_inv", use_safehandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_safehandle_beg", use_safehandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_safehandle_end", use_safehandle_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_bells () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_bells" ] =
  {
    type = "click",
    clk_obj = "obj_tree4_clk_bells",
    room = private.room_objname,
    zz = "zz_tree4",
    zz_gate = "gzz_basementext_tree4"
  };
  -----------------------------------------------
  local clk_bells_beg = function ()

    ObjDelete( "obj_tree4_clk_bells" );

  end;
  local clk_bells_end = function ()

    ObjSet( "spr_basementext_tree4_people_2", { alp = 1 } );    
    ObjDelete( "spr_basementext_tree4_people_1" );
    ObjDelete( "anm_tree4_flute" );
    ObjDelete( "anm_tree4_flutetake" );
    ObjSet( "spr_tree4_figure_1", { alp = 1 } );
    ObjSet( "spr_tree4_figure_2", { alp = 1 } );    
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_bells", clk_bells_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bells", clk_bells_end, private.room_objname );
  cmn.AddSubscriber( "clk_bells_beg", clk_bells_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bells_end", clk_bells_end, private.room_objname );

--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_chain () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_chain" ] =
  {
    type = "click",
    clk_obj = "obj_rift_clk_chain",
    room = private.room_objname,
    zz = "zz_rift",
    zz_gate = "gzz_basementext_rift"
  };
  -----------------------------------------------
  local clk_chain_beg = function ()

    ObjDelete( "obj_rift_clk_chain" );

  end;
  local clk_chain_end = function ()

    ObjSet( "obj_rift_box_close", { alp = 1 } );
    ObjSet( "spr_basementext_rift_box", { alp = 1 } );
    ObjSet( "obj_rift_use_bronzering",    { active = true, input = true } );
    ObjDelete( "anm_rift_box_lift" );
    ObjDelete( "spr_basementext_rift_circuit" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_chain", clk_chain_beg, private.room_objname );
  cmn.AddSubscriber( "clk_chain", clk_chain_end, private.room_objname );
  cmn.AddSubscriber( "clk_chain_beg", clk_chain_beg, private.room_objname );
  cmn.AddSubscriber( "clk_chain_end", clk_chain_end, private.room_objname );

--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_chest () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_chest" ] =
  {
    type = "click",
    clk_obj = "obj_rift_clk_chest",
    room = private.room_objname,
    zz = "zz_rift",
    zz_gate = "gzz_basementext_rift"
  };
  -----------------------------------------------
  local clk_chest_beg = function ()

    ObjDelete( "obj_rift_clk_chest" );

  end;
  local clk_chest_end = function ()

    ObjSet( "obj_rift_box_open", { alp = 1, input = true } );
    ObjSet( "spr_basementext_rift_open_box", { alp = 1 } );
    ObjDelete( "obj_rift_box_close" );
    ObjDelete( "spr_basementext_rift_close_box" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_chest", clk_chest_beg, private.room_objname );
  cmn.AddSubscriber( "clk_chest", clk_chest_end, private.room_objname );
  cmn.AddSubscriber( "clk_chest_beg", clk_chest_beg, private.room_objname );
  cmn.AddSubscriber( "clk_chest_end", clk_chest_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_safehandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_safehandle" ] =
  {
    type = "click",
    clk_obj = "obj_picture_clk_safehandle",
    room = private.room_objname,
    zz = "zz_picture",
    zz_gate = "gzz_basementext_picture"
  };
  -----------------------------------------------
  local clk_safehandle_beg = function ()

    ObjDelete( "obj_picture_clk_safehandle" );

  end;
  local clk_safehandle_end = function ()
  
    ObjDelete( "spr_picture_bronzering_over" );
    ObjDelete( "spr_picture_safehandle_shadow" );
    ObjDelete( "spr_picture_safehandle" );
    ObjSet( "obj_picture_open_safe", { alp = 1, input = true } );
    ObjSet( "spr_picture_phoenixfeather_3", { active = true } );
    ObjDelete( "spr_basementext_picture_cap_close" );
    ObjSet( "spr_basementext_picture_cap_open", { alp = 1 } );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_safehandle", clk_safehandle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_safehandle", clk_safehandle_end, private.room_objname );
  cmn.AddSubscriber( "clk_safehandle_beg", clk_safehandle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_safehandle_end", clk_safehandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  --function win_picture () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_picture" ] =
  {
    type = "click",
    clk_obj = "spr_picture_puzzle_1_1",
    room = private.room_objname,
    zz = "zz_picture",
    zz_gate = "gzz_basementext_picture"
  };
  --*********************************************************************************************************************
  local win_picture_inv = function ()

    if ( cmn.IsEventDone( "win_picture" ) ) then


    end;

  end;
  --*********************************************************************************************************************
  local win_picture = function ()

    if ( cmn.IsEventDone( "win_picture" ) ) then
      
      ObjDelete( "obj_picture_picture" );
      ObjDelete( "vid_picture_disappear" );
      ObjDelete( "spr_basementext_picture_shabby" );
      ObjSet( "obj_picture_safe", { input = true } );
      ObjSet( "spr_picture_bronzering", { active = true } );
      ObjSet( "spr_picture_phoenixfeather_2", { active = true } );
      ObjSet( "spr_picture_brush", { input = false } );
      ObjSet( "spr_basementext_picture_cap_close", { alp = 1 } );

    else 
      
      for i = 1, 7 do 
         if ng_global.progress[ "ext" ][ "win_picture" ].puzzle[ i ] ~= 0 then
           if ng_global.progress[ "ext" ][ "win_picture" ].puzzle[ i ] == private.win_puzzle[ i ] then
             ObjSet( "spr_picture_puzzle_"..i.."_1", { alp = 1 } );
           else 
             ObjSet( "spr_picture_puzzle_"..i.."_2", { 
                                                      alp = 1,
                                                      color_r = private.color[ ng_global.progress[ "ext" ][ "win_picture" ].puzzle[ i ] ][ 1 ],
                                                      color_g = private.color[ ng_global.progress[ "ext" ][ "win_picture" ].puzzle[ i ] ][ 2 ], 
                                                      color_b = private.color[ ng_global.progress[ "ext" ][ "win_picture" ].puzzle[ i ] ][ 3 ]
                                                     } );
           end;
         end;  
      end;
       
    end;

  end;

  cmn.AddSubscriber( "win_picture", win_picture_inv );
  cmn.AddSubscriber( "win_picture", win_picture, private.room_objname );
  --------------------------------------------------------------------------------------------
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
function private.get_flute ()

  cmn.SetEventDone( "get_flute" );
  cmn.CallEventHandler( "get_flute" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_brushext" ) ) and
     ( cmn.IsEventDone( "get_tuningforkext" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_tuningforkext ()

  cmn.SetEventDone( "get_tuningforkext" );
  cmn.CallEventHandler( "get_tuningforkext" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_brushext" ) ) and
     ( cmn.IsEventDone( "get_flute" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_brushext ()

  cmn.SetEventDone( "get_brushext" );
  cmn.CallEventHandler( "get_brushext" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_flute" ) ) and
     ( cmn.IsEventDone( "get_tuningforkext" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_fileext ()

  cmn.SetEventDone( "get_fileext" );
  cmn.CallEventHandler( "get_fileext" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_spring_2 ()

  cmn.SetEventDone( "get_spring_2" );
  cmn.CallEventHandler( "get_spring_2" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_safehandle" ) and 
       cmn.IsEventDone( "get_collect2_4_3" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_safehandle ()

  cmn.SetEventDone( "get_safehandle" );
  cmn.CallEventHandler( "get_safehandle" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_spring_2" ) and 
       cmn.IsEventDone( "get_collect2_4_3" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_amuletviolin ()

  cmn.SetEventDone( "get_amuletviolin" );
  cmn.CallEventHandler( "get_amuletviolin" );
  
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "use_paints" ) then
    ng_global.progress[ "ext" ][ "win_picture" ].puzzle = { 0, 0, 0, 0, 0, 0, 0 };
    cmn.MiniGameShow( "picture" );
     --common_impl.PassingMgStart( "picture" ); 
  end;
  
end;
-------------------------------------------------
function private.get_phoenixfeather_2 ()

  cmn.SetEventDone( "get_phoenixfeather_2" );
  cmn.CallEventHandler( "get_phoenixfeather_2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_phoenixfeather_3 ()

  cmn.SetEventDone( "get_phoenixfeather_3" );
  cmn.CallEventHandler( "get_phoenixfeather_3" );
  
  cmn.GetObjectSfx();
  
  cmn.CloseSubRoom();

end;
-------------------------------------------------
function private.get_bronzering ()

  cmn.SetEventDone( "get_bronzering" );
  cmn.CallEventHandler( "get_bronzering" );
  
  cmn.GetObjectSfx();

end;
---------------------------------------------------------------------------------
function private.get_collect2_4_3()

  int.AddCollectibles2( "spr_rift_collect2_4_3" );
  
  if ( cmn.IsEventDone( "get_spring_2" ) and
       cmn.IsEventDone( "get_safehandle" ) ) then

    cmn.CloseSubRoom();

  end;
  
end;
--*********************************************************************************************************************
-------------------------------------------------
function public.use_trebleclef ()

  local item = "inv_trebleclef";

  if ( cmn.ApplyObj( item, "gzz_basementext_tree4", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tree4" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_tree4_use_trebleclef", true ) ) then

    cmn.CallEventHandler( "use_trebleclef_inv" );
    cmn.CallEventHandler( "use_trebleclef_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_trebleclef" );
      cmn.CallEventHandler( "use_trebleclef_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_trebleclef" ); 

    ObjAnimate( "spr_tree4_trebleclef", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "obj_tree4_harp_open", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.5, 0, 0.0,
      0.8, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_bells ()

  local item = "inv_bells";

  if ( cmn.ApplyObj( item, "gzz_basementext_tree4", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tree4" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_tree4_use_bells", true ) ) then

    cmn.CallEventHandler( "use_bells_inv" );
    cmn.CallEventHandler( "use_bells_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_bells" );
      cmn.CallEventHandler( "use_bells_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_bells" );  

    ObjAnimate( "spr_tree4_bell_3", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "spr_tree4_bell_4", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.5, 0, 0.0, 
      0.8, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_chainwithhook ()

  local item = "inv_chainwithhook";

  if ( cmn.ApplyObj( item, "gzz_basementext_rift", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_rift" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_rift_use_chainwithhook", true ) ) then

    cmn.CallEventHandler( "use_chainwithhook_inv" );
    cmn.CallEventHandler( "use_chainwithhook_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_chainwithhook" );
      cmn.CallEventHandler( "use_chainwithhook_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_chaintochest" );

    AnimPlay("anm_rift_chain_trow", "DoAnim", func_end);

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_bronzering ()

  local item = "inv_bronzering";

  if ( cmn.ApplyObj( item, "gzz_basementext_rift", false ) ) and
     ( cmn.IsEventDone( "clk_chain" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_rift" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_rift_use_bronzering", true ) ) and
         ( cmn.IsEventDone( "clk_chain" ) ) then

    cmn.CallEventHandler( "use_bronzering_inv" );
    cmn.CallEventHandler( "use_bronzering_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_bronzering" );
      cmn.CallEventHandler( "use_bronzering_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_ringtochest" );  

    ObjAnimate( "spr_rift_ring_1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_paints ()

  local item = "inv_paints";

  if ( cmn.ApplyObj( item, "gzz_basementext_picture", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_picture" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_picture_use_paints", true ) ) then

    cmn.CallEventHandler( "use_paints_inv" );
    cmn.CallEventHandler( "use_paints_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_paints" );
      cmn.CallEventHandler( "use_paints_end" );
      int.Lock( false );
      
      if cmn.IsEventDone( "get_amuletviolin" ) then
        
        ng_global.progress[ "ext" ][ "win_picture" ].puzzle = { 0, 0, 0, 0, 0, 0, 0 }; 
        cmn.MiniGameShow( "picture" );
        common_impl.PassingMgStart( "picture" );
        
      end;

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_palette" ); 

    ObjAnimate( "spr_picture_paints", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_picture_brush", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_brushext ()

  local item = "inv_brushext";

  if ( cmn.ApplyObj( item, "gzz_basementext_picture", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_picture" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_picture_use_brushext", true ) ) then

    cmn.CallEventHandler( "use_brushext_inv" );
    cmn.CallEventHandler( "use_brushext_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_brushext" );
      cmn.CallEventHandler( "use_brushext_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_usebrush" ); 

    ObjSet( "anm_picture_brushext", { alp = 1 } );
    ObjSet( "anm_picture_web",      { alp = 0 } );
    
    AnimPlay( "anm_picture_brushext", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_safehandle ()

  local item = "inv_safehandle";

  if ( cmn.ApplyObj( item, "gzz_basementext_picture", false ) and 
       cmn.IsEventDone( "get_bronzering" ) and
       cmn.IsEventDone( "get_phoenixfeather_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_picture" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_picture_use_safehandle", true ) and
           cmn.IsEventDone( "get_bronzering" ) and
           cmn.IsEventDone( "get_phoenixfeather_2" ) ) then

    cmn.CallEventHandler( "use_safehandle_inv" );
    cmn.CallEventHandler( "use_safehandle_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_safehandle" );
      cmn.CallEventHandler( "use_safehandle_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_valvetosafe" );  

    ObjAnimate( "spr_picture_safehandle_shadow", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_picture_safehandle", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
function private.clk_bells ()

  cmn.CallEventHandler( "clk_bells_beg" );
  int.Lock( true );

  local func_end = function ()

    local func_end = function ()
          
      local func_end = function ()
        
        cmn.SetEventDone( "clk_bells" );
        cmn.CallEventHandler( "clk_bells_end" );
        int.Lock( false );
        private.get_flute ();
          
      end;  
      
      ObjSet( "anm_tree4_flute", { alp = 0 } );
      ObjSet( "anm_tree4_flutetake", { alp = 1 } );
      AnimPlay( "anm_tree4_flutetake", "DoAnim", func_end ); 
      
    end;
    
    AnimPlay( "anm_tree4_flute", "DoAnim", func_end ); 

  end;

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_bell_1" );
  ObjAnimate( "spr_tree4_bell_1", "ang", 0, 0, "",
  { 
    0.0, 3,  0.00, 
    0.3, 3, -0.05,
    0.6, 3,  0.00
  } );

  ObjAnimate( "spr_tree4_bell_3_rope", "ang", 0, 0, "",
  { 
    0.0, 3,  0.00, 
    0.6, 3,  0.00, 
    0.9, 3,  0.03,
    1.2, 3,  0.00
  } );

  ObjAnimate( "spr_tree4_bell_2", "ang", 0, 0, "",
  { 
    0.0, 3,  0.00, 
    1.2, 3,  0.00, 
    1.5, 3, -0.04,
    1.8, 3,  0.00
  } );

  ObjAnimate( "spr_tree4_bell_4_rope", "ang", 0, 0, func_end,
  { 
    0.0, 3,  0.00, 
    1.8, 3,  0.00, 
    2.1, 3,  0.05,
    2.4, 3,  0.00
  } );

end;
--*********************************************************************************************************************
-------------------------------------------------
function private.clk_chain ()

  cmn.CallEventHandler( "clk_chain_beg" );
  int.Lock( true );

  local func_end = function ()

    cmn.SetEventDone( "clk_chain" );
    cmn.CallEventHandler( "clk_chain_end" );
    int.Lock( false );

  end;

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_getthechest" );  

  AnimPlay( "anm_rift_box_lift", "DoAnim", func_end );

end;
-------------------------------------------------
function private.clk_chest ()

  cmn.CallEventHandler( "clk_chest_beg" );
  int.Lock( true );

  local func_end = function ()

    cmn.SetEventDone( "clk_chest" );
    cmn.CallEventHandler( "clk_chest_end" );
    int.Lock( false );

  end;

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_openchest1" );  

  ObjAnimate( "spr_rift_ring_1", "alp", 0, 0, "",
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0,
  } );

  ObjAnimate( "spr_rift_ring_2", "alp", 0, 0, "",
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0,
    0.5, 0, 1.0,
    0.8, 0, 0.0,
  } );

  ObjAnimate( "spr_rift_ring_3", "alp", 0, 0, "",
  { 
    0.0, 0, 0.0, 
    0.5, 0, 0.0,
    0.8, 0, 1.0,
  } );

  ObjAnimate( "obj_rift_box_close", "alp", 0, 0, "",
  { 
    0.0, 3, 1, 
    1.0, 3, 1, 
    1.3, 3, 0
  } );

  ObjAnimate( "obj_rift_box_open", "alp", 0, 0, func_end,
  { 
    0.0, 3, 0, 
    1.0, 3, 0, 
    1.3, 3, 1
  } );

end;
--*********************************************************************************************************************
-------------------------------------------------
function private.clk_safehandle ()

  cmn.CallEventHandler( "clk_safehandle_beg" );
  int.Lock( true );

  local func_end = function ()

    cmn.SetEventDone( "clk_safehandle" );
    cmn.CallEventHandler( "clk_safehandle_end" );
    int.Lock( false );

  end;

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_opensafe" );  
 
  ObjAnimate( "spr_picture_safehandle", "ang", 0, 0, "",
  { 
    0.0, 3, 0, 
    0.3, 3, 0.72,
    0.9, 3, -0.9
  } );
  
  ObjAnimate( "spr_picture_safehandle_shadow", "ang", 0, 0, "",
  { 
    0.0, 3, 0, 
    0.3, 3, 0.72,
    0.9, 3, -0.9
  } );
  
  ObjAnimate( "spr_picture_bronzering_over", "alp", 0, 0, "",
  { 
    0.0, 3, 1, 
    0.9, 3, 1, 
    1.2, 3, 0
  } );
  
  ObjAnimate( "spr_picture_safehandle_shadow", "alp", 0, 0, "",
  { 
    0.0, 3, 1, 
    0.9, 3, 1, 
    1.2, 3, 0
  } );

  ObjAnimate( "spr_picture_safehandle", "alp", 0, 0, "",
  { 
    0.0, 3, 1, 
    0.9, 3, 1, 
    1.2, 3, 0
  } );
  
  ObjAnimate( "obj_picture_open_safe", "alp", 0, 0, func_end,
  { 
    0.0, 3, 0, 
    0.9, 3, 0, 
    1.2, 3, 1
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_basementext ()

  if not ( cmn.IsEventDone( "opn_basementext" ) ) then

    cmn.SetEventDone( "opn_basementext" );
    cmn.ShowBbt( "bbt_basementext_first_open" );
    
    ng_global.progress[ "ext" ][ "opn_basementext" ].see_hourglass3 = 0;
    
    cmn.PlayAudio( "mus", "audio/aud_amnesia_theme_mus" );

  end; 
  
end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_basementext();
  
  cmn.StopAllEnv( "audio/level4/env/aud_basementnext_env", true );
  cmn.PlayAudio( "env", "audio/level4/env/aud_basementnext_env", 1, 2.5 );
  
  if ( cmn.IsEventDone( "get_paints" ) ) and ( ng_global.progress[ "ext" ][ "opn_basementext" ].see_hourglass3 == 0 ) then
    int_dialog_task.UpdateHourglassStage( false );
    ng_global.progress[ "ext" ][ "opn_basementext" ].see_hourglass3 = 1;
  end;

end;
--*********************************************************************************************************************
function public.Task ()
  
  int.AddedTaskMap( private.room_objname, "get_flute",                            { "use_bells" } );
  int.AddedTaskMap( private.room_objname, "get_tuningforkext",                    { "use_trebleclef" } );
  int.AddedTaskMap( private.room_objname, "get_brushext" );
  int.AddedTaskMap( private.room_objname, "get_fileext" );
  int.AddedTaskMap( private.room_objname, "get_spring_2",                         { "clk_chest" } );
  int.AddedTaskMap( private.room_objname, "get_safehandle",                       { "clk_chest" } );
  int.AddedTaskMap( private.room_objname, "get_amuletviolin",                     { "use_brushext" } );
  int.AddedTaskMap( private.room_objname, "get_phoenixfeather_2",                 { "win_picture" } );
  int.AddedTaskMap( private.room_objname, "get_phoenixfeather_3",                 { "clk_safehandle" } );

  int.AddedTaskMap( private.room_objname, "get_bronzering",                       { "win_picture" } );
  
  int.AddedTaskMap( private.room_objname, "use_trebleclef",                       { "get_trebleclef" } );
  int.AddedTaskMap( private.room_objname, "use_bells",                            { "get_bells" } );
  int.AddedTaskMap( private.room_objname, "use_chainwithhook",                    { "get_chainwithhook" } );
  int.AddedTaskMap( private.room_objname, "use_bronzering",                       { "clk_chain" } );
  int.AddedTaskMap( private.room_objname, "use_paints",                           { "get_paints" } );
  int.AddedTaskMap( private.room_objname, "use_brushext",                         { "get_brushext" } );
  int.AddedTaskMap( private.room_objname, "use_safehandle",                       { "get_safehandle", "get_bronzering", "get_phoenixfeather_2" } );
  
  int.AddedTaskMap( private.room_objname, "clk_bells",                            { "use_bells" } );
  int.AddedTaskMap( private.room_objname, "clk_chain",                            { "use_chainwithhook" } );
  int.AddedTaskMap( private.room_objname, "clk_chest",                            { "use_bronzering" } );
  int.AddedTaskMap( private.room_objname, "clk_safehandle",                       { "use_safehandle" } );
  
  int.AddedTaskMap( private.room_objname, "win_picture",                          { "use_paints" } );
    
end;  
--*********************************************************************************************************************
function private.InitSubroom ()
  
  subroom.Define( "zz_picture" );  
  -------------------------------------------------
  function zz_picture.Open()
    
    if ( cmn.IsEventStart( "win_picture" ) and not cmn.IsEventDone( "win_picture" ) ) then

      cmn.MiniGameShow( "picture" );
      common_impl.PassingMgStart( "picture" );

    end;
    
  end;
  -------------------------------------------------
  function zz_picture.PreClose()

    if ( cmn.IsEventStart( "win_picture" ) and not cmn.IsEventDone( "win_picture" ) ) then

      cmn.MiniGameHide( "picture" );
      common_impl.PassingMgStop( "picture" );

    end;

  end;
  -------------------------------------------------
  function zz_picture.Skip ()
    
    for i = 1, 7 do 
      
      ObjSet( "spr_picture_puzzle_"..i.."_2", { alp = 0 } );
      ObjSet( "spr_picture_puzzle_"..i.."_1", { alp = 1 } );
            
    end;
    
    private.PictureWin();
    
  end;
  -------------------------------------------------
  function zz_picture.Reset ()
    
    for i = 1, 7 do
      
      ng_global.progress[ "ext" ][ "win_picture" ].puzzle[ i ] = 0;
      ObjSet( "spr_picture_puzzle_"..i.."_1", { alp = 0 } );
      ObjSet( "spr_picture_puzzle_"..i.."_2", { alp = 0 } );
      
    end;
    
    ObjSet( "spr_picture_tip", { alp = 0 } );
    private.brush = 0;
    
  end;  
  -------------------------------------------------  
  
end;
--*********************************************************************************************************************
function private.Tree4BellsClick ()

  int.Lock( true );

  local func_end = function ()

    cmn.ShowBbt( "bbt_tree4_use_bells" );

    int.Lock( false );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_bells" ); 

  ObjAnimate( "spr_tree4_bell_1", "ang", 0, 0, "",
  { 
    0.0, 3,  0.00, 
    0.3, 3, -0.05,
    0.6, 3,  0.00
  } );

  ObjAnimate( "spr_tree4_bell_2", "ang", 0, 0, func_end,
  { 
    0.0, 3,  0.00, 
    0.6, 3,  0.00, 
    0.9, 3,  0.03,
    1.2, 3,  0.00
  } );

end;
--*********************************************************************************************************************
function private.PictureWebClick ()

  int.Lock( true );

  local func_end = function ()

    cmn.ShowBbt( "bbt_picture_use_brushext" );

    int.Lock( false );

  end;

  AnimPlay( "anm_picture_web", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.RiftLockClick ()

  int.Lock( true );

  local func_end = function ()

    cmn.ShowBbt( "bbt_rift_use_bronzering" );

    int.Lock( false );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_chest1" );  

  AnimPlay( "anm_rift_lockroar", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.InitAnims ()

  ObjAnimate( "spr_tree4_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_rift_add_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );
  
  ObjAnimate( "spr_picture_add_light", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    2.5, 3, 0.5,
    5.0, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
function private.InitAnimGhost ()
  
  ObjSet( "tmr_basementext_ghost", {
    endtrig = function ()
      AnimPlay( "anm_basementext_ghost", "DoAnim", function () private.InitAnimGhost(); end );
    end,
    time = 10,
    playing = 1
  });
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG PICTURE *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.InitPicture()
    
    private.color = { 
                     { 0.62, 0.38, 0.38 },
                     { 0.44, 0.26, 0.3 },
                     { 0.22, 0.34, 0.74 },
                     { 0.63, 0.53, 0.51 },
                     { 0.61, 0.34, 0.3 },
                     { 0.2, 0.16, 0.17 },
                     { 0.45, 0.12, 0.15 }
                     };
                    
    private.win_puzzle = { 3, 1, 1, 6, 4, 1, 5 }; --в массиве номер краски, которой нужно покрасить для выигрыша 
    private.brush = 0;
    ObjSet( "spr_picture_brush", { event_mdown = private.ClkBrush } );
    ObjSet( "spr_picture_brush", { event_dragdrop = private.DropBrush } );
    ObjSet( "spr_picture_brush", { event_startdrag = private.StartDrag } );
    
  end;  
  --*********************************************************************************************************************
  function private.ClkBrush()

    ObjSet( "spr_picture_brush", { ang = 0.54 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_drag_brush" );

  end;
    --*********************************************************************************************************************
  function private.StartDrag()
    
    --cmn.SetCursor( CURSOR_NULL );
    
  end;
  --*********************************************************************************************************************
  function private.DropBrush()   
    
    for i = 1, 7 do
      
      if ( cmn.ApplyObj( "obj_picture_tmp", "obj_picture_color"..i, true ) ) then--если макаем кисточку в краску 
      
        private.brush = i;
        ObjSet( "spr_picture_tip", { 
                                    alp = 1,
                                    color_r = private.color[ i ][ 1 ], 
                                    color_g = private.color[ i ][ 2 ],
                                    color_b = private.color[ i ][ 3 ] 
                                   } );
        --ObjDoNotDrop( "spr_picture_brush" );
        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_colorbrush" );
        return;
        
      end; 
      
    end; 
    
    if private.brush ~= 0 then--если мы взяли краску
      
      for i = 1, 7 do
        
        if ( cmn.ApplyObj( "obj_picture_tmp", "spr_picture_puzzle_"..i.."_2", true ) ) then 
          
          local puzzle = {}; 
          
          for k = 1, 7 do
            puzzle[ k ] = ng_global.progress[ "ext" ][ "win_picture" ].puzzle[ k ];
          end;
          puzzle[ i ] = private.brush;
          
          if private.win_puzzle[ i ] == private.brush then
            
            ObjSet( "spr_picture_puzzle_"..i.."_2", { alp = 0 } );
            ObjSet( "spr_picture_puzzle_"..i.."_1", { alp = 1 } );
            
            local win = true;
            for i = 1, 7 do

              if puzzle[ i ] ~= private.win_puzzle[ i ] then
                win = false;                
              end;
              
            end;
            
            if win then
              private.PictureWin();
              return;
            else
              ng_global.progress[ "ext" ][ "win_picture" ].puzzle[ i ] = private.brush;  
            end;
            
          else  
            
            ng_global.progress[ "ext" ][ "win_picture" ].puzzle[ i ] = private.brush;
            ObjSet( "spr_picture_puzzle_"..i.."_1", { alp = 0 } );
            ObjSet( "spr_picture_puzzle_"..i.."_2", { 
                                                      alp = 1,
                                                      color_r = private.color[ private.brush ][ 1 ],
                                                      color_g = private.color[ private.brush ][ 2 ], 
                                                      color_b = private.color[ private.brush ][ 3 ]
                                                     } );
                                                     
          end;
                                                                                         
          --ObjDoNotDrop( "spr_picture_brush" ); 
          cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_paint" );
          return;        
           
        end;
        
      end;  
      
    end;
    
    ObjSet( "spr_picture_brush", { ang = 0 } );
    --cmn.SetCursor( CURSOR_DEFAULT );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_drop_brush" );
                                                                                                                                                                                                                                                                                                                                                                                                         
  end;
--*********************************************************************************************************************
  function private.PictureWin()
        
    ObjSet( "spr_picture_brush", { ang = 0 } );
    cmn.SetCursor( CURSOR_DEFAULT );
    
    int.Lock( true );
    
    local func_end = function ()
    
      common_impl.PassingMgWin( "picture" );
      cmn.MiniGameHide( "picture" );
      cmn.SetEventDone( "win_picture" );
      cmn.CallEventHandler( "win_picture" );
      cmn.CallEventHandler( "win_picture_inv" );
      int.Lock( false );
      
    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_win_picture" );
       
    ObjSet( "vid_picture_disappear", { alp = 1 } );
    ObjSet( "obj_picture_picture", { alp = 0 } );
    VidPlay( "vid_picture_disappear", func_end );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_atropos_scare_paint" ); 
    
  end;
--*********************************************************************************************************************