-- name=rm_cemetery
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_cemetery";

  ObjAttach( "zz_statue",       "room_hub" );
  ObjAttach( "zz_lodge",        "room_hub" );
  ObjAttach( "zz_gravestone",   "room_hub" );
  ObjAttach( "zz_zzbasrelief",  "room_hub" );

  ObjMultiSet( {
    { "spr_statue_acidext",             { event_mdown = private.get_acidext } },
    { "spr_lodge_saw",                  { event_mdown = private.get_saw } },
    { "spr_lodge_yin",                  { event_mdown = private.get_yin }},
    { "spr_lodge_pieceofiron",          { event_mdown = private.get_pieceofiron } },
    { "spr_lodge_bowl_1",               { event_mdown = private.get_bowl_1 } },
    { "spr_lodge_basrelief_2",          { event_mdown = private.get_basrelief_2 } },
    { "spr_gravestone_skeletonkey",     { event_mdown = private.get_skeletonkey } },
    { "spr_gravestone_bone_2",          { event_mdown = private.get_bone_2 } },
    { "spr_gravestone_nippersext",      { event_mdown = private.get_nippersext } },
    { "spr_gravestone_portrait_1",      { event_mdown = private.get_portrait_1 } },
    { "spr_gravestone_shovelblade",     { event_mdown = private.get_shovelblade } },
    { "spr_zzbasrelief_amuletgrave",    { event_mdown = private.get_amuletgrave } },
    { "spr_zzbasrelief_stoneext",       { event_mdown = private.get_stoneext } },
    { "spr_zzbasrelief_nailsext",       { event_mdown = private.get_nailsext } },
    { "obj_statue_use_portrait",        { event_mdown = private.StatuePanelClick } },
    { "obj_statue_use_nippersext",      { event_mdown = private.StatueAcidClick } },
    { "obj_gravestone_use_pieceofiron", { event_mdown = private.GravestoneStoneClick } },
    { "obj_gravestone_use_amuletgrave", { event_mdown = private.GravestonePlateClick } },
    { "spr_gravestone_collect2_4_1",    { event_mdown = private.get_collect2_4_1 } },
    { "obj_lodge_use_acidext",          { event_mdown = private.ClkLock } },
  } );

  private.InitAnims();
  private.InitSubroom();
  private.InitBasrelief();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_cemetery = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gzz_cemetery_statue",
        "gzz_cemetery_lodge",
        "gzz_cemetery_gravestone",
        "gzz_cemetery_zzbasrelief",
        "gmg_cemetery_mgstatue",
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_statue", 
        "zz_lodge", 
        "zz_gravestone", 
        "zz_zzbasrelief", 
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_cemetery", update_game_mode_cemetery, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_acidext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_acidext" ] =
  {
    type = "get",
    get_obj = "spr_statue_acidext",
    room = private.room_objname,
    zz = "zz_statue",
    zz_gate = "gzz_cemetery_statue"
  };
  -----------------------------------------------
  local get_acidext_inv = function ()

    int.InventoryItemAdd( "inv_acidext", "spr_statue_acidext" );

  end;

  local get_acidext_closezz = function ()

    ObjDelete( "gfx_statue_acidext" );
    ObjDelete( "spr_statue_acidext_shadow" );
    ObjDelete( "spr_cemetery_statue_bottle" );

  end;

  cmn.AddSubscriber( "get_acidext", get_acidext_inv );
  cmn.AddSubscriber( "get_acidext", get_acidext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_saw () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_saw" ] =
  {
    type = "get",
    get_obj = "spr_lodge_saw",
    room = private.room_objname,
    zz = "zz_lodge",
    zz_gate = "gzz_cemetery_lodge"
  };
  -----------------------------------------------
  local get_saw_inv = function ()

    int.InventoryItemAdd( "inv_saw", "spr_lodge_saw" );

  end;

  local get_saw_closezz = function ()

    ObjDelete( "gfx_lodge_saw" );
    --ObjDelete( "gzz_cemetery_lodge" );
    ObjDelete( "spr_lodge_saw_over" );

  end;

  cmn.AddSubscriber( "get_saw", get_saw_inv );
  cmn.AddSubscriber( "get_saw", get_saw_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_yin () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_yin" ] =
  {
    type = "get",
    get_obj = "spr_lodge_yin",
    room = private.room_objname,
    zz = "zz_lodge",
    zz_gate = "gzz_cemetery_lodge"
  };
  -----------------------------------------------
  local get_yin_inv = function ()

    int.InventoryItemAdd( "inv_yin", "spr_lodge_yin" );

  end;

  local get_yin_closezz = function ()

    ObjDelete( "gfx_lodge_yin" );
    ObjDelete( "spr_lodge_yin_shadow" );
    ObjDelete( "spr_cemetery_lodge_yan" );
    
    if ( cmn.IsEventDone( "get_basrelief_2" ) ) then

      ObjDelete( "gzz_cemetery_lodge" );

    end;

  end;

  cmn.AddSubscriber( "get_yin", get_yin_inv );
  cmn.AddSubscriber( "get_yin", get_yin_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pieceofiron () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pieceofiron" ] =
  {
    type = "get",
    get_obj = "spr_lodge_pieceofiron",
    room = private.room_objname,
    zz = "zz_lodge",
    zz_gate = "gzz_cemetery_lodge"
  };
  -----------------------------------------------
  local get_pieceofiron_inv = function ()

    int.InventoryItemAdd( "inv_pieceofiron", "spr_lodge_pieceofiron" );

  end;

  local get_pieceofiron_closezz = function ()

    ObjDelete( "gfx_lodge_pieceofiron" );
    ObjDelete( "spr_lodge_pieceofiron_shadow" );
    ObjDelete( "spr_cemetery_lodge_fittings" );

  end;

  cmn.AddSubscriber( "get_pieceofiron", get_pieceofiron_inv );
  cmn.AddSubscriber( "get_pieceofiron", get_pieceofiron_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bowl_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bowl_1" ] =
  {
    type = "get",
    get_obj = "obj_lodge_box_hint",
    room = private.room_objname,
    zz = "zz_lodge",
    zz_gate = "gzz_cemetery_lodge"
  };
  -----------------------------------------------
  local get_bowl_1_inv = function ()

    int.InventoryItemAdd( "inv_bowl_1", "spr_lodge_bowl_1" );

  end;

  local get_bowl_1_closezz = function ()

    ObjDelete( "gfx_lodge_bowl_1" );
    ObjDelete( "spr_cemetery_lodge_bowl" );

  end;

  cmn.AddSubscriber( "get_bowl_1", get_bowl_1_inv );
  cmn.AddSubscriber( "get_bowl_1", get_bowl_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_basrelief_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_basrelief_2" ] =
  {
    type = "get",
    get_obj = "spr_lodge_basrelief_2",
    room = private.room_objname,
    zz = "zz_lodge",
    zz_gate = "gzz_cemetery_lodge"
  };
  -----------------------------------------------
  local get_basrelief_2_inv = function ()

    int.InventoryItemAdd( "inv_basrelief", "spr_lodge_basrelief_2", "assets/levels/levelext/rm_nearcar/zz_pit/inv/inv_basrelief_2_morph" );
    levelext_inv.CheckBasrelief();

  end;

  local get_basrelief_2_closezz = function ()

    ObjDelete( "gfx_lodge_basrelief_2" );
    ObjDelete( "spr_lodge_basrelief_2_shadow" );
    ObjDelete( "spr_cemetery_lodge_relief_part" );

    if ( cmn.IsEventDone( "get_yin" ) ) then

      ObjDelete( "gzz_cemetery_lodge" );

    end;

  end;

  cmn.AddSubscriber( "get_basrelief_2", get_basrelief_2_inv );
  cmn.AddSubscriber( "get_basrelief_2", get_basrelief_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_skeletonkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_skeletonkey" ] =
  {
    type = "get",
    get_obj = "spr_gravestone_skeletonkey",
    room = private.room_objname,
    zz = "zz_gravestone",
    zz_gate = "gzz_cemetery_gravestone"
  };
  -----------------------------------------------
  local get_skeletonkey_inv = function ()

    int.InventoryItemAdd( "inv_skeletonkey", "spr_gravestone_skeletonkey" );

  end;

  local get_skeletonkey_closezz = function ()

    ObjDelete( "gfx_gravestone_skeletonkey" );
    ObjDelete( "spr_gravestone_skeletonkey_shadow" );

    if ( cmn.IsEventDone( "get_portrait_1" ) ) and
       ( cmn.IsEventDone( "get_shovelblade" ) ) and
       ( cmn.IsEventDone( "get_collect2_4_1" ) ) and
       ( cmn.IsEventDone( "get_bone_2" ) ) then

      ObjDelete( "gzz_cemetery_gravestone" );

    end;

  end;

  cmn.AddSubscriber( "get_skeletonkey", get_skeletonkey_inv );
  cmn.AddSubscriber( "get_skeletonkey", get_skeletonkey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bone_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bone_2" ] =
  {
    type = "get",
    get_obj = "spr_gravestone_bone_2",
    room = private.room_objname,
    zz = "zz_gravestone",
    zz_gate = "gzz_cemetery_gravestone"
  };
  -----------------------------------------------
  local get_bone_2_inv = function ()

    int.InventoryItemAdd( "inv_bone_2", "spr_gravestone_bone_2" );

  end;

  local get_bone_2_closezz = function ()

    ObjDelete( "gfx_gravestone_bone_2" );
    ObjDelete( "spr_gravestone_bone_2_shadow" );
    ObjDelete( "spr_cemetery_gravestone_bone" );
    
    if ( cmn.IsEventDone( "get_portrait_1" ) ) and
       ( cmn.IsEventDone( "get_shovelblade" ) ) and
       ( cmn.IsEventDone( "get_collect2_4_1" ) ) and
       ( cmn.IsEventDone( "get_skeletonkey" ) ) then

      ObjDelete( "gzz_cemetery_gravestone" );

    end;

  end;

  cmn.AddSubscriber( "get_bone_2", get_bone_2_inv );
  cmn.AddSubscriber( "get_bone_2", get_bone_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_nippersext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_nippersext" ] =
  {
    type = "get",
    get_obj = "spr_gravestone_nippersext",
    room = private.room_objname,
    zz = "zz_gravestone",
    zz_gate = "gzz_cemetery_gravestone"
  };
  -----------------------------------------------
  local get_nippersext_inv = function ()

    int.InventoryItemAdd( "inv_nippersext", "spr_gravestone_nippersext" );

  end;

  local get_nippersext_closezz = function ()

    ObjDelete( "gfx_gravestone_nippersext" );
    ObjDelete( "spr_gravestone_nippersext_shadow" );
    ObjDelete( "spr_cemetery_gravestone_nippers" );
    
  end;

  cmn.AddSubscriber( "get_nippersext", get_nippersext_inv );
  cmn.AddSubscriber( "get_nippersext", get_nippersext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_portrait_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_portrait_1" ] =
  {
    type = "get",
    get_obj = "spr_gravestone_portrait_1",
    room = private.room_objname,
    zz = "zz_gravestone",
    zz_gate = "gzz_cemetery_gravestone"
  };
  -----------------------------------------------
  local get_portrait_1_inv = function ()

    int.InventoryItemAdd( "inv_portrait", "spr_gravestone_portrait_1", "assets/levels/levelext/rm_cemetery/zz_gravestone/inv/inv_portrait_1" );
    levelext_inv.CheckPortrait( 1 );
    
  end;

  local get_portrait_1_closezz = function ()

    ObjDelete( "gfx_gravestone_portrait_1" );
    ObjDelete( "spr_gravestone_portrait_1_shadow" );
    ObjDelete( "spr_cemetery_gravestone_medalion" );
    
    if ( cmn.IsEventDone( "get_bone_2" ) ) and
       ( cmn.IsEventDone( "get_shovelblade" ) ) and
       ( cmn.IsEventDone( "get_collect2_4_1" ) ) and
       ( cmn.IsEventDone( "get_skeletonkey" ) ) then

      ObjDelete( "gzz_cemetery_gravestone" );

    end;

  end;

  cmn.AddSubscriber( "get_portrait_1", get_portrait_1_inv );
  cmn.AddSubscriber( "get_portrait_1", get_portrait_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_shovelblade () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_shovelblade" ] =
  {
    type = "get",
    get_obj = "spr_gravestone_shovelblade",
    room = private.room_objname,
    zz = "zz_gravestone",
    zz_gate = "gzz_cemetery_gravestone"
  };
  -----------------------------------------------
  local get_shovelblade_inv = function ()

    int.InventoryItemAdd( "inv_shovelblade", "spr_gravestone_shovelblade" );
    ObjSet( "inv_shovelblade", { drag = false } );
    
    if not cmn.IsEventDone( "get_stick" ) then
      
      ObjSet( "inv_shovelblade_plus_focus2", { alp = 0 } );
      
    end;

  end;

  local get_shovelblade_closezz = function ()

    ObjDelete( "gfx_gravestone_shovelblade" );
    ObjDelete( "spr_gravestone_shovelblade_shadow" );
    ObjDelete( "spr_cemetery_gravestone_shovel" );
    
    if ( cmn.IsEventDone( "get_bone_2" ) ) and
       ( cmn.IsEventDone( "get_portrait_1" ) ) and
       ( cmn.IsEventDone( "get_collect2_4_1" ) ) and
       ( cmn.IsEventDone( "get_skeletonkey" ) ) then

      ObjDelete( "gzz_cemetery_gravestone" );

    end;

  end;

  cmn.AddSubscriber( "get_shovelblade", get_shovelblade_inv );
  cmn.AddSubscriber( "get_shovelblade", get_shovelblade_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletgrave () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletgrave" ] =
  {
    type = "get",
    get_obj = "spr_zzbasrelief_amuletgrave",
    room = private.room_objname,
    zz = "zz_zzbasrelief",
    zz_gate = "gzz_cemetery_zzbasrelief"
  };
  -----------------------------------------------
  local get_amuletgrave_inv = function ()

    int.InventoryItemAdd( "inv_amuletgrave", "spr_zzbasrelief_amuletgrave" );

  end;

  local get_amuletgrave_closezz = function ()

    ObjDelete( "gfx_zzbasrelief_amuletgrave" );
    ObjDelete( "spr_zzbasrelief_amuletgrave_shadow" );
    ObjDelete( "gzz_cemetery_zzbasrelief" );
    ObjDelete( "spr_cemetery_zzbasrelief_amulet_1" );
    
  end;

  cmn.AddSubscriber( "get_amuletgrave", get_amuletgrave_inv );
  cmn.AddSubscriber( "get_amuletgrave", get_amuletgrave_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stoneext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stoneext" ] =
  {
    type = "get",
    get_obj = "spr_zzbasrelief_stoneext",
    room = private.room_objname,
    zz = "zz_zzbasrelief",
    zz_gate = "gzz_cemetery_zzbasrelief"
  };
  -----------------------------------------------
  local get_stoneext_inv = function ()

    int.InventoryItemAdd( "inv_stoneext", "spr_zzbasrelief_stoneext" );
    if cmn.IsEventDone( "use_nailsext" ) then
      ObjSet( "inv_shovelblade_plus_focus2", { alp = 1 } );
    end;

  end;

  local get_stoneext_closezz = function ()

    ObjDelete( "gfx_zzbasrelief_stoneext" );
    ObjDelete( "spr_zzbasrelief_stoneext_shadow" );
    ObjDelete( "spr_cemetery_zzbasrelief_stone" );
        
    if ( cmn.IsEventDone( "get_nailsext" ) ) then
      ObjSet( "obj_zzbasrelief_use_basrelief", { input = true } );
    end;
    --ObjDelete( "gzz_cemetery_zzbasrelief" );

  end;

  cmn.AddSubscriber( "get_stoneext", get_stoneext_inv );
  cmn.AddSubscriber( "get_stoneext", get_stoneext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_nailsext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_nailsext" ] =
  {
    type = "get",
    get_obj = "spr_zzbasrelief_nailsext",
    room = private.room_objname,
    zz = "zz_zzbasrelief",
    zz_gate = "gzz_cemetery_zzbasrelief"
  };
  -----------------------------------------------
  local get_nailsext_inv = function ()

    int.InventoryItemAdd( "inv_nailsext", "spr_zzbasrelief_nailsext" );
    
    if cmn.IsEventDone( "use_stick" ) then
      
      ObjSet( "inv_shovelblade_plus_focus2", { alp = 1 } );
      
    end;

  end;

  local get_nailsext_closezz = function ()

    ObjDelete( "gfx_zzbasrelief_nailsext" );
    ObjDelete( "spr_zzbasrelief_nailsext_shadow" );
    ObjDelete( "spr_zzbasrelief_nailsext_light" );
    ObjDelete( "spr_cemetery_zzbasrelief_nail" );
        
    if ( cmn.IsEventDone( "get_stoneext" ) ) then
      
      ObjSet( "obj_zzbasrelief_use_basrelief", { input = true } );
      
    end;
    --ObjDelete( "gzz_cemetery_zzbasrelief" );

  end;

  cmn.AddSubscriber( "get_nailsext", get_nailsext_inv );
  cmn.AddSubscriber( "get_nailsext", get_nailsext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_4_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_4_1 = function ()

    ObjDelete( "spr_gravestone_collect2_4_1" );
    ObjDelete( "spr_cemetery_gravestone_collect" );
    
    if ( cmn.IsEventDone( "get_bone_2" ) ) and
       ( cmn.IsEventDone( "get_portrait_1" ) ) and
       ( cmn.IsEventDone( "get_shovelblade" ) ) and
       ( cmn.IsEventDone( "get_skeletonkey" ) ) then

       ObjDelete( "gzz_cemetery_gravestone" );

    end;
    
  end;

  cmn.AddSubscriber( "get_collect2_4_1", get_collect2_4_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_4_2 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_4_2 = function ()

    ObjDelete( "obj_cemetery_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_4_2", get_morphobject_4_2, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_nippersext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_nippersext" ] =
  {
    type = "use",
    use_obj = "inv_nippersext",
    use_place = "obj_statue_use_nippersext",
    room = private.room_objname,
    zz = "zz_statue",
    zz_gate = "gzz_cemetery_statue"
  };
  -----------------------------------------------
  local use_nippersext_inv = function ()

    int.InventoryItemRemove( "inv_nippersext" );

  end;
  local use_nippersext_beg = function ()

    ObjDelete( "obj_statue_use_nippersext" );

  end;
  local use_nippersext_end = function ()

    ObjSet( "spr_statue_wire_open", { alp = 1 } );
    ObjSet( "spr_statue_acidext",   { input = true } );
    ObjSet( "gfx_statue_acidext",   { active = true } );
    ObjDelete( "spr_cemetery_statue_brush_1" );
    ObjSet( "spr_cemetery_statue_brush_2", { alp = 1 } );
    ObjDelete( "anm_statue_wirecut" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_nippersext", use_nippersext_beg, private.room_objname );
  cmn.AddSubscriber( "use_nippersext", use_nippersext_inv );
  cmn.AddSubscriber( "use_nippersext", use_nippersext_end, private.room_objname );
  cmn.AddSubscriber( "use_nippersext_inv", use_nippersext_inv, private.room_objname );
  cmn.AddSubscriber( "use_nippersext_beg", use_nippersext_beg, private.room_objname );
  cmn.AddSubscriber( "use_nippersext_end", use_nippersext_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_portrait () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_portrait" ] =
  {
    type = "use",
    use_obj = "inv_portrait",
    use_place = "obj_statue_use_portrait",
    room = private.room_objname,
    zz = "zz_statue",
    zz_gate = "gzz_cemetery_statue"
  };
  -----------------------------------------------
  local use_portrait_inv = function ()

    int.InventoryItemRemove( "inv_portrait" );

  end;
  local use_portrait_beg = function ()

    ObjDelete( "obj_statue_use_portrait" );

  end;
  local use_portrait_end = function ()

    ObjDelete( "gzz_cemetery_statue" );
    ObjSet( "spr_cemetery_statue_medalion_1", { alp = 1 } );
    ObjSet( "spr_cemetery_statue_medalion_2", { alp = 1 } );
    ObjSet( "spr_cemetery_statue_medalion_3", { alp = 1 } );
    ObjSet( "spr_cemetery_statue_cup_over", { alp = 1 } );
    
    ObjSet( "gmg_cemetery_mgstatue", { input = true, active = true, alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_portrait", use_portrait_beg, private.room_objname );
  cmn.AddSubscriber( "use_portrait", use_portrait_inv );
  cmn.AddSubscriber( "use_portrait", use_portrait_end, private.room_objname );
  cmn.AddSubscriber( "use_portrait_inv", use_portrait_inv, private.room_objname );
  cmn.AddSubscriber( "use_portrait_beg", use_portrait_beg, private.room_objname );
  cmn.AddSubscriber( "use_portrait_end", use_portrait_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_balletdancer () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_balletdancer" ] =
  {
    type = "use",
    use_obj = "inv_balletdancer",
    use_place = "obj_lodge_use_balletdancer",
    room = private.room_objname,
    zz = "zz_lodge",
    zz_gate = "gzz_cemetery_lodge"
  };
  -----------------------------------------------
  local use_balletdancer_inv = function ()

    int.InventoryItemRemove( "inv_balletdancer" );

  end;
  local use_balletdancer_beg = function ()

    ObjDelete( "obj_lodge_use_balletdancer" );

  end;
  local use_balletdancer_end = function ()

    ObjSet( "spr_lodge_balletdancer", { alp = 1 } );
    ObjSet( "obj_lodge_box_open",     { alp = 1, input = true } );
    ObjSet( "gfx_lodge_yin",          { active = true } );
    ObjSet( "gfx_lodge_basrelief_2",  { active = true } );
    ObjDelete( "anm_lodge_ballerina" );
    ObjSet( "spr_cemetery_lodge_ballerina", { alp = 1 } );
    ObjSet( "spr_cemetery_lodge_box_open", { alp = 1 } );
        
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_balletdancer", use_balletdancer_beg, private.room_objname );
  cmn.AddSubscriber( "use_balletdancer", use_balletdancer_inv );
  cmn.AddSubscriber( "use_balletdancer", use_balletdancer_end, private.room_objname );
  cmn.AddSubscriber( "use_balletdancer_inv", use_balletdancer_inv, private.room_objname );
  cmn.AddSubscriber( "use_balletdancer_beg", use_balletdancer_beg, private.room_objname );
  cmn.AddSubscriber( "use_balletdancer_end", use_balletdancer_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_acidext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_acidext" ] =
  {
    type = "use",
    use_obj = "inv_acidext",
    use_place = "obj_lodge_use_acidext",
    room = private.room_objname,
    zz = "zz_lodge",
    zz_gate = "gzz_cemetery_lodge"
  };
  -----------------------------------------------
  local use_acidext_inv = function ()

    int.InventoryItemRemove( "inv_acidext" );

  end;
  local use_acidext_beg = function ()

    ObjDelete( "obj_lodge_use_acidext" );

  end;
  local use_acidext_end = function ()

    ObjDelete( "obj_lodge_close" );
    ObjDelete( "anm_lodge_acid" );
    ObjSet( "obj_lodge_open",  { alp = 1 } );
    ObjSet( "obj_lodge_items", { input = true, active = true } );
    ObjSet( "spr_cemetery_lodge_door_open",  { alp = 1 } );
    ObjDelete( "spr_cemetery_lodge_lock_1" );
    ObjDelete( "anm_lodge_close_door1" );
    ObjDelete( "spr_lodge_door_close" );    

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_acidext", use_acidext_beg, private.room_objname );
  cmn.AddSubscriber( "use_acidext", use_acidext_inv );
  cmn.AddSubscriber( "use_acidext", use_acidext_end, private.room_objname );
  cmn.AddSubscriber( "use_acidext_inv", use_acidext_inv, private.room_objname );
  cmn.AddSubscriber( "use_acidext_beg", use_acidext_beg, private.room_objname );
  cmn.AddSubscriber( "use_acidext_end", use_acidext_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pieceofiron () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pieceofiron" ] =
  {
    type = "use",
    use_obj = "inv_pieceofiron",
    use_place = "obj_gravestone_use_pieceofiron",
    room = private.room_objname,
    zz = "zz_gravestone",
    zz_gate = "gzz_cemetery_gravestone"
  };
  -----------------------------------------------
  local use_pieceofiron_inv = function ()

    int.InventoryItemRemove( "inv_pieceofiron" );

  end;
  local use_pieceofiron_beg = function ()

    ObjDelete( "obj_gravestone_use_pieceofiron" );

  end;
  local use_pieceofiron_end = function ()

    ObjDelete( "anm_gravestone_gravestone" );
    ObjSet( "spr_gravestone_gravestone_open", { alp = 1 } );
    ObjSet( "obj_gravestone_grave_close",     { input = true } );
    ObjSet( "gfx_gravestone_nippersext",      { active = true } );
    ObjSet( "gfx_gravestone_shovelblade",     { active = true } );
    ObjDelete( "spr_cemetery_gravestone_stone_2" );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_pieceofiron", use_pieceofiron_beg, private.room_objname );
  cmn.AddSubscriber( "use_pieceofiron", use_pieceofiron_inv );
  cmn.AddSubscriber( "use_pieceofiron", use_pieceofiron_end, private.room_objname );
  cmn.AddSubscriber( "use_pieceofiron_inv", use_pieceofiron_inv, private.room_objname );
  cmn.AddSubscriber( "use_pieceofiron_beg", use_pieceofiron_beg, private.room_objname );
  cmn.AddSubscriber( "use_pieceofiron_end", use_pieceofiron_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletgrave () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletgrave" ] =
  {
    type = "use",
    use_obj = "inv_amuletgrave",
    use_place = "obj_gravestone_use_amuletgrave",
    room = private.room_objname,
    zz = "zz_gravestone",
    zz_gate = "gzz_cemetery_gravestone"
  };
  -----------------------------------------------
  local use_amuletgrave_inv = function ()

    int.InventoryItemRemove( "inv_amuletgrave" );

  end;
  local use_amuletgrave_beg = function ()

    ObjDelete( "obj_gravestone_use_amuletgrave" );

  end;
  local use_amuletgrave_end = function ()

    ObjDelete( "anm_gravestone_plate" );
    ObjSet( "obj_gravestone_grave_open", { input = true, active = true } );
    ObjSet( "spr_gravestone_plate_open", { alp = 1 } );
    ObjSet( "spr_cemetery_gravestone_cup_2_open", { alp = 1 } );
    ObjDelete( "spr_cemetery_gravestone_cup_2" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_amuletgrave", use_amuletgrave_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletgrave", use_amuletgrave_inv );
  cmn.AddSubscriber( "use_amuletgrave", use_amuletgrave_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletgrave_inv", use_amuletgrave_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletgrave_beg", use_amuletgrave_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletgrave_end", use_amuletgrave_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_basrelief () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_basrelief" ] =
  {
    type = "use",
    use_obj = "inv_basrelief",
    use_place = "obj_zzbasrelief_use_basrelief",
    room = private.room_objname,
    zz = "zz_zzbasrelief",
    zz_gate = "gzz_cemetery_zzbasrelief"
  };
  -----------------------------------------------
  local use_basrelief_inv = function ()

    int.InventoryItemRemove( "inv_basrelief" );

  end;
  local use_basrelief_beg = function ()

    ObjDelete( "obj_zzbasrelief_use_basrelief" );

  end;
  local use_basrelief_end = function ()

    ObjSet( "spr_zzbasrelief_part_1", { alp = 1 } );
    ObjSet( "spr_zzbasrelief_part_2", { alp = 1 } );
    ObjSet( "spr_zzbasrelief_part_3", { alp = 1 } );
    ObjSet( "obj_zzbasrelief_mmg", { input = true } );
    ObjSet( "spr_cemetery_zzbasrelief_relief_2", { alp = 1 } );
    ObjDelete( "spr_cemetery_zzbasrelief_relief_1" );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_basrelief", use_basrelief_beg, private.room_objname );
  cmn.AddSubscriber( "use_basrelief", use_basrelief_inv );
  cmn.AddSubscriber( "use_basrelief", use_basrelief_end, private.room_objname );
  cmn.AddSubscriber( "use_basrelief_inv", use_basrelief_inv, private.room_objname );
  cmn.AddSubscriber( "use_basrelief_beg", use_basrelief_beg, private.room_objname );
  cmn.AddSubscriber( "use_basrelief_end", use_basrelief_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
  -- function win_zzbasrelief() end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_zzbasrelief" ] =
  {
    room = private.room_objname,
    zz = "zz_zzbasrelief",
    zz_gate = "gzz_cemetery_zzbasrelief"
  };
  --*********************************************************************************************************************
  local win_zzbasrelief = function ()

    if ( cmn.IsEventDone( "win_zzbasrelief" ) ) then
      
      ObjSet( "obj_zzbasrelief_open", { alp = 1, input = true } );
      ObjSet( "gfx_zzbasrelief_amuletgrave", { active = true } );
      ObjDelete( "obj_zzbasrelief_mmg" );
      ObjDelete( "spr_cemetery_zzbasrelief_relief_2" );
      
    elseif ( cmn.IsEventStart( "win_zzbasrelief" ) ) then

      private.LoadBasrelief();   

    end;

  end;

  cmn.AddSubscriber( "win_zzbasrelief", win_zzbasrelief, private.room_objname );
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
function private.get_acidext ()

  cmn.SetEventDone( "get_acidext" );
  cmn.CallEventHandler( "get_acidext" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_saw ()

  cmn.SetEventDone( "get_saw" );
  cmn.CallEventHandler( "get_saw" );
  
  cmn.GetObjectSfx();

  if ( not cmn.IsEventDone( "get_bowl_1" ) ) then

    private.get_bowl_1();

  end;

end;
-------------------------------------------------
function private.get_yin ()

  cmn.SetEventDone( "get_yin" );
  cmn.CallEventHandler( "get_yin" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_basrelief_2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_pieceofiron ()

  cmn.SetEventDone( "get_pieceofiron" );
  cmn.CallEventHandler( "get_pieceofiron" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_bowl_1 ()

  cmn.SetEventDone( "get_bowl_1" );
  cmn.CallEventHandler( "get_bowl_1" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_basrelief_2 ()

  cmn.SetEventDone( "get_basrelief_2" );
  cmn.CallEventHandler( "get_basrelief_2" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_yin" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_skeletonkey ()

  cmn.SetEventDone( "get_skeletonkey" );
  cmn.CallEventHandler( "get_skeletonkey" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_portrait_1" ) ) and
     ( cmn.IsEventDone( "get_shovelblade" ) ) and
     ( cmn.IsEventDone( "get_collect2_4_1" ) ) and
     ( cmn.IsEventDone( "get_bone_2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_bone_2 ()

  cmn.SetEventDone( "get_bone_2" );
  cmn.CallEventHandler( "get_bone_2" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_portrait_1" ) ) and
     ( cmn.IsEventDone( "get_shovelblade" ) ) and
     ( cmn.IsEventDone( "get_collect2_4_1" ) ) and
     ( cmn.IsEventDone( "get_skeletonkey" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_nippersext ()

  cmn.SetEventDone( "get_nippersext" );
  cmn.CallEventHandler( "get_nippersext" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_portrait_1 ()

  cmn.SetEventDone( "get_portrait_1" );
  cmn.CallEventHandler( "get_portrait_1" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_bone_2" ) ) and
     ( cmn.IsEventDone( "get_shovelblade" ) ) and
     ( cmn.IsEventDone( "get_collect2_4_1" ) ) and
     ( cmn.IsEventDone( "get_skeletonkey" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_shovelblade ()

  cmn.SetEventDone( "get_shovelblade" );
  cmn.CallEventHandler( "get_shovelblade" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_bone_2" ) ) and
     ( cmn.IsEventDone( "get_portrait_1" ) ) and
     ( cmn.IsEventDone( "get_collect2_4_1" ) ) and
     ( cmn.IsEventDone( "get_skeletonkey" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_amuletgrave ()

  cmn.SetEventDone( "get_amuletgrave" );
  cmn.CallEventHandler( "get_amuletgrave" );
  
  cmn.GetObjectSfx();
  
  cmn.CloseSubRoom();

end;
-------------------------------------------------
function private.get_stoneext ()

  cmn.SetEventDone( "get_stoneext" );
  cmn.CallEventHandler( "get_stoneext" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_nailsext ()

  cmn.SetEventDone( "get_nailsext" );
  cmn.CallEventHandler( "get_nailsext" );
  
  cmn.GetObjectSfx();

end;
---------------------------------------------------------------------------------
function private.get_collect2_4_1()

  int.AddCollectibles2( "spr_gravestone_collect2_4_1" );
  
  if ( cmn.IsEventDone( "get_bone_2" ) ) and
     ( cmn.IsEventDone( "get_portrait_1" ) ) and
     ( cmn.IsEventDone( "get_shovelblade" ) ) and
     ( cmn.IsEventDone( "get_skeletonkey" ) ) then

    cmn.CloseSubRoom();

  end;
  
end;
--*********************************************************************************************************************
-------------------------------------------------
function public.use_nippersext ()

  local item = "inv_nippersext";

  if ( cmn.ApplyObj( item, "gzz_cemetery_statue", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_statue" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_statue_use_nippersext", true ) ) then

    cmn.CallEventHandler( "use_nippersext_inv" );
    cmn.CallEventHandler( "use_nippersext_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_nippersext" );
      cmn.CallEventHandler( "use_nippersext_end" );
      int.Lock( false );
      private.get_acidext();
      
    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_cutwires" );
    
    AnimPlay( "anm_statue_wirecut","DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_portrait ()

  local item = "inv_portrait";

  if ( cmn.ApplyObj( item, "gzz_cemetery_statue", false ) ) and
     ( cmn.IsEventDone( "get_portrait_1" ) ) and
     ( cmn.IsEventDone( "get_portrait_2" ) ) and
     ( cmn.IsEventDone( "get_portrait_3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_statue" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_statue_use_portrait", true ) ) and
         ( cmn.IsEventDone( "get_portrait_1" ) ) and
         ( cmn.IsEventDone( "get_portrait_2" ) ) and
         ( cmn.IsEventDone( "get_portrait_3" ) )  then

    cmn.CallEventHandler( "use_portrait_inv" );
    cmn.CallEventHandler( "use_portrait_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_portrait" );
      cmn.CallEventHandler( "use_portrait_end" );
      int.Lock( false );
      cmn.CloseSubRoom();
      cmn.GotoRoom( "mg_mgstatue" );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_insert_photos" );
    ObjAnimate( "spr_statue_portrait_1", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "spr_statue_portrait_2", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.4, 0, 0.0, 
      0.7, 0, 1.0
    } );

    ObjAnimate( "spr_statue_portrait_3", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.8, 0, 0.0, 
      1.1, 0, 1.0
    } );

    ObjAnimate( "obj_statue_panel", "pos_y", 0, 0, "",
    { 
      0.0, 3, 250, 
      1.3, 3, 250,
      2.8, 3, 430,
    } );

    ObjAnimate( "obj_statue_panel", "scale_xy", 0, 0, func_end,
    { 
      0.0, 3, 1.0, 1.0,
      1.3, 3, 1.0, 1.0,
      2.8, 3, 0.8, 0.8,
      3.0, 3, 0.8, 0.8,
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_balletdancer ()

  local item = "inv_balletdancer";

  if ( cmn.ApplyObj( item, "gzz_cemetery_lodge", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_lodge" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_lodge_use_balletdancer", true ) ) then

    cmn.CallEventHandler( "use_balletdancer_inv" );
    cmn.CallEventHandler( "use_balletdancer_beg" );
    int.Lock( true );

    local func_end = function ()
    
      local func_end = function ()
      
        cmn.SetEventDone( "use_balletdancer" );
        cmn.CallEventHandler( "use_balletdancer_end" );
        int.Lock( false );
        
      end;
     
      ObjAnimate( "spr_lodge_balletdancer", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      ObjAnimate( "obj_lodge_box_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.5, 0, 0.0,
        0.8, 0, 1.0
      } );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_musical_box" );
    AnimPlay( "anm_lodge_ballerina", "DoAnim", func_end ) 
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_acidext ()

  local item = "inv_acidext";

  if ( cmn.ApplyObj( item, "gzz_cemetery_lodge", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_lodge" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_lodge_use_acidext", true ) ) then

    cmn.CallEventHandler( "use_acidext_inv" );
    cmn.CallEventHandler( "use_acidext_beg" );
    int.Lock( true );

    local func_end = function ()
    
      local func_end = function ()
      
        cmn.SetEventDone( "use_acidext" );
        cmn.CallEventHandler( "use_acidext_end" );
        int.Lock( false );
        
      end;
      
      ObjAnimate( "obj_lodge_close", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 1.0, 
        0.6, 0, 0.0
      } );

      ObjAnimate( "obj_lodge_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 0.0,
        0.6, 0, 1.0
      } );

    end;
    
    ObjSet( "anm_lodge_close_door1", { alp = 0 } );
    ObjSet( "spr_lodge_door_close", { alp = 1 } );
    ObjSet( "obj_lodge_lock", { alp = 0 } );
    ObjSet( "anm_lodge_acid", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_acid" );
    AnimPlay( "anm_lodge_acid", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_pieceofiron ()

  local item = "inv_pieceofiron";

  if ( cmn.ApplyObj( item, "gzz_cemetery_gravestone", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_gravestone" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_gravestone_use_pieceofiron", true ) ) then

    cmn.CallEventHandler( "use_pieceofiron_inv" );
    cmn.CallEventHandler( "use_pieceofiron_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_pieceofiron" );
      cmn.CallEventHandler( "use_pieceofiron_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_moove_stone" );
    AnimPlay( "anm_gravestone_gravestone", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_amuletgrave ()

  local item = "inv_amuletgrave";

  if ( cmn.ApplyObj( item, "gzz_cemetery_gravestone", false ) ) and
     ( cmn.IsEventDone( "get_shovelblade" ) ) and
     ( cmn.IsEventDone( "get_nippersext" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_gravestone" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_gravestone_use_amuletgrave", true ) ) and
         ( cmn.IsEventDone( "get_shovelblade" ) ) and
         ( cmn.IsEventDone( "get_nippersext" ) ) then

    cmn.CallEventHandler( "use_amuletgrave_inv" );
    cmn.CallEventHandler( "use_amuletgrave_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_amuletgrave" );
      cmn.CallEventHandler( "use_amuletgrave_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_open_grave" );
    AnimPlay( "anm_gravestone_plate", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_basrelief ()

  local item = "inv_basrelief";

  if ( cmn.ApplyObj( item, "gzz_cemetery_zzbasrelief", false ) ) and
     ( cmn.IsEventDone( "get_stoneext" ) ) and
     ( cmn.IsEventDone( "get_nailsext" ) ) and
     ( cmn.IsEventDone( "get_basrelief_1" ) ) and
     ( cmn.IsEventDone( "get_basrelief_2" ) ) and
     ( cmn.IsEventDone( "get_basrelief_3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_zzbasrelief" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_zzbasrelief_use_basrelief", true ) ) and
         ( cmn.IsEventDone( "get_stoneext" ) ) and
         ( cmn.IsEventDone( "get_nailsext" ) ) and
         ( cmn.IsEventDone( "get_basrelief_1" ) ) and
         ( cmn.IsEventDone( "get_basrelief_2" ) ) and
         ( cmn.IsEventDone( "get_basrelief_3" ) ) then

    cmn.CallEventHandler( "use_basrelief_inv" );
    cmn.CallEventHandler( "use_basrelief_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_basrelief" );
      cmn.CallEventHandler( "use_basrelief_end" );
      int.Lock( false );
      common_impl.PassingMgStart( "zzbasrelief" );
      private.InitBasreliefStart();

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_insert_stones" );
    ObjAnimate("spr_zzbasrelief_part_1", "alp", 0, 0, func_end, 
    {
      0.0,0,0,
      0.3,0,1
    });
    ObjAnimate("spr_zzbasrelief_part_2", "alp", 0, 0, "", 
    {
      0.0,0,0,
      0.3,0,1
    });
    ObjAnimate("spr_zzbasrelief_part_3", "alp", 0, 0, "", 
    {
      0.0,0,0,
      0.3,0,1
    });
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_cemetery ()

  if not ( cmn.IsEventDone( "opn_cemetery" ) ) then

    cmn.SetEventDone( "opn_cemetery" );
    cmn.ShowBbt( "bbt_cemetery_first_open" );
    cmn.PlayAudio( "mus", "audio/aud_grave_mus" );
    
  end;
  
end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.PreOpen ()
  
  ObjSet( "tmr_cemetery_anims", { playing = 0 } ); 
  for i = 1, 7 do
    AnimStop( "anm_cemetery_ghost"..i ) 
  end;  
  
  private.GhostAnims ();
  
  cmn.StopAllEnv( "audio/level4/env/aud_cemetery_env", true );
  cmn.PlayAudio( "env", "audio/level4/env/aud_cemetery_env", 1, 2.5 );
  
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_cemetery();

end;
--*********************************************************************************************************************
function public.Task ()
  
  int.AddedTaskMap( private.room_objname, "get_acidext",                                      { "use_nippersext" } );
  int.AddedTaskMap( private.room_objname, "get_saw",                                          { "use_acidext" } );
  int.AddedTaskMap( private.room_objname, "get_yin",                                          { "use_balletdancer" } );
  int.AddedTaskMap( private.room_objname, "get_pieceofiron",                                  { "use_amuletgate_1","use_amuletgate_2" } );
  int.AddedTaskMap( private.room_objname, "get_bowl_1",                                       { "use_acidext" } );
  int.AddedTaskMap( private.room_objname, "get_basrelief_2",                                  { "use_balletdancer" } );
  int.AddedTaskMap( private.room_objname, "get_skeletonkey",                                  { "use_amuletgrave" } );
  int.AddedTaskMap( private.room_objname, "get_bone_2",                                       { "use_amuletgrave" } );
  int.AddedTaskMap( private.room_objname, "get_nippersext",                                   { "use_pieceofiron" } );
  int.AddedTaskMap( private.room_objname, "get_portrait_1",                                   { "use_amuletgrave" } );
  int.AddedTaskMap( private.room_objname, "get_shovelblade",                                  { "use_pieceofiron" } );
  int.AddedTaskMap( private.room_objname, "get_amuletgrave",                                  { "win_zzbasrelief" } );
  int.AddedTaskMap( private.room_objname, "get_stoneext" );
  int.AddedTaskMap( private.room_objname, "get_nailsext" );
  int.AddedTaskMap( private.room_objname, "get_brokenlantern",                                { "use_portrait" } );--изменить после добавления игры Статуя
  
  int.AddedTaskMap( private.room_objname, "use_nippersext",                                   { "get_nippersext" } );
  int.AddedTaskMap( private.room_objname, "use_portrait",                                     { "get_portrait_1", "get_portrait_2", "get_portrait_3" } );
  int.AddedTaskMap( private.room_objname, "use_balletdancer",                                 { "get_balletdancer" } );
  int.AddedTaskMap( private.room_objname, "use_acidext",                                      { "get_acidext" } );
  int.AddedTaskMap( private.room_objname, "use_pieceofiron",                                  { "get_pieceofiron" } );
  int.AddedTaskMap( private.room_objname, "use_amuletgrave",                                  { "get_amuletgrave" } );
  int.AddedTaskMap( private.room_objname, "use_basrelief",                                    { "get_basrelief_1", "get_basrelief_2", "get_basrelief_3" } );
  
  int.AddedTaskMap( private.room_objname, "win_zzbasrelief",                                  { "use_basrelief" } );
  --int.AddedTaskMap( private.room_objname, "win_mgstatue",                                     { "use_portrait" } );--изменить после добавления игры Статуя
  
end;
--*********************************************************************************************************************
function private.StatueAcidClick ()

  int.Lock( true );

  local func_end = function ()

    cmn.ShowBbt( "bbt_statue_use_nippersext" );

    int.Lock( false );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_bottle" );

  ObjAnimate( "spr_statue_acidext", "pos_y", 0, 0, func_end,
  { 
    0.0, 3, -135, 
    0.2, 3, -136, 
    0.4, 3, -135,
    0.6, 3, -136,
    0.8, 3, -135
  } );

  ObjAnimate( "spr_statue_acidext_shadow", "pos_y", 0, 0, "",
  { 
    0.0, 3, -141, 
    0.2, 3, -142, 
    0.4, 3, -141,
    0.6, 3, -142,
    0.8, 3, -141
  } );

end;
--*********************************************************************************************************************
function private.StatuePanelClick ()

  int.Lock( true );

  local func_end = function ()

    cmn.ShowBbt( "bbt_statue_use_portrait" );

    int.Lock( false );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_headstone" );

  ObjAnimate( "obj_statue_panel", "pos_y", 0, 0, func_end,
  { 
    0.0, 3, 250, 
    0.2, 3, 251, 
    0.4, 3, 250,
    0.6, 3, 251,
    0.8, 3, 250
  } );

end;
--*********************************************************************************************************************
function private.GravestoneStoneClick ()

  int.Lock( true );

  local func_end = function ()

    cmn.ShowBbt( "bbt_gravestone_use_pieceofiron" );

    int.Lock( false );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_gravestone" );

  ObjAnimate( "anm_gravestone_gravestone", "pos_y", 0, 0, func_end,
  { 
    0.0, 3, -250,
    0.2, 3, -248,
    0.4, 3, -250,
    0.6, 3, -248,
    0.8, 3, -250,
  } );

end;
--*********************************************************************************************************************
function private.GravestonePlateClick ()

  int.Lock( true );

  local func_end = function ()

    cmn.ShowBbt( "bbt_gravestone_use_amuletgrave" );

    int.Lock( false );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_gravestone" );

  ObjAnimate( "obj_gravestone_grave_close", "pos_x", 0, 0, func_end,
  { 
    0.0, 3, 0,
    0.2, 3, 2,
    0.4, 3, 0,
    0.6, 3, 2,
    0.8, 3, 0,
  } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_zzbasrelief" );
  -------------------------------------------------
  function zz_zzbasrelief.Open()

    if ( cmn.IsEventStart( "win_zzbasrelief" ) and not cmn.IsEventDone( "win_zzbasrelief" ) ) then

      cmn.MiniGameShow( "zzbasrelief" );
      common_impl.PassingMgStart( "zzbasrelief" );

    end;

  end;
  -------------------------------------------------
  function zz_zzbasrelief.PreClose()

    if ( cmn.IsEventStart( "win_zzbasrelief" ) and not cmn.IsEventDone( "win_zzbasrelief" ) ) then

      cmn.MiniGameHide( "zzbasrelief" );
      common_impl.PassingMgStop( "zzbasrelief" );

    end;

  end;
  -------------------------------------------------
  function zz_zzbasrelief.Skip ()

    for n=1, 12 do
      ObjSet( "spr_zzbasrelief_part_"..n, { 
        pos_x = private.coords[ n ][1],
        pos_y = private.coords[ n ][2],
      } );
    end;
    private.WinBasrelief();
    
  end;
  -------------------------------------------------
  function zz_zzbasrelief.Reset ()
    
    if ( private.prev ~= 0 ) then      
      ObjSet( "spr_zzbasrelief_part_"..private.prev, { scale_x = 1, scale_y = 1 } );
    end;
    private.prev = 0;   
    private.state = {1,5,12,4,2,9,7,10,11,8,6,3};
    ng_global.progress[ "ext" ][ "win_zzbasrelief" ].state = {1,5,12,4,2,9,7,10,11,8,6,3};
    for n=1, 12 do
      ObjSet( "spr_zzbasrelief_part_"..n, { 
        input = true,
        pos_x = private.coords[ private.state[n] ][1],
        pos_y = private.coords[ private.state[n] ][2],
      } );
    end;

  end;
  
end;
--*********************************************************************************************************************
function private.InitAnims ()

  ObjAnimate( "obj_lodge_light_1", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "obj_lodge_light_2", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_lodge_bowl_1", "ang", 1, 0, "", 
  {
    0.0, 3, -0.05,
    1.5, 3,  0.05,
    3.0, 3, -0.05,
  } );

  ObjAnimate( "obj_statue_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_gravestone_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );
  ObjAnimate("spr_zzbasrelief_light_add", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    3.0, 3, 0.7,
    6.0, 3, 1.0,
  } );
  ObjAnimate( "spr_lodge_tree_1", "ang", 1, 0, "", 
  {
    0.0, 3, -0.06,
    3.0, 3, 0,
    6.0, 3, -0.06,
  } );
  ObjAnimate( "spr_lodge_tree_2", "ang", 1, 0, "", 
  {
    0.0, 3, 0.08,
    3.1, 3, 0,
    6.2, 3, 0.08,
  } );
  
  ObjAnimate( "obj_cemetery_clouds", "pos_x", 1, 0, "", 
  {
    0.0, 0, 0,
    85.0, 0, -1482
  } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG ZZBASRELIEF***  () end;
--********************************************************************************************************************
--********************************************************************************************************************
  function private.InitBasrelief ()

    private.state = {1,5,12,4,2,9,7,10,11,8,6,3};
    private.win = {1,2,3,4,5,6,7,8,9,10,11,12};
    private.prev = 0;    

    private.coords = { {-180,-152},{-46,-136},{88,-121},{222,-105},
                       {-192, -29},{-61, -13},{73,   2},{207,  18},
                       {-210,  94},{-75, 110},{59, 126},{192, 140}
                     };
    
    for n=1, 12 do
      
      ObjSet( "spr_zzbasrelief_part_"..n, { 
        input = true,
        event_mdown = function () private.PartClk ( n ); end,
        event_menter = function () private.PartEnter ( n ) end,
        event_mleave = function () private.PartLeave ( n ) end,
        pos_x = private.coords[ private.state[n] ][1],
        pos_y = private.coords[ private.state[n] ][2],
      } );
      
      ObjCreate( "spr_zzbasrelief_part_"..n.."light", "spr" );
      ObjAttach( "spr_zzbasrelief_part_"..n.."light", "spr_zzbasrelief_part_"..n );
      ObjSet( "spr_zzbasrelief_part_"..n.."light", { 
        res = "assets/levels/levelext/rm_cemetery/zz_zzbasrelief/layers/light",
        pos_y = -7
      } );
      
      ObjCreate( "spr_zzbasrelief_part_"..n.."dark", "spr" );
      ObjAttach( "spr_zzbasrelief_part_"..n.."dark", "spr_zzbasrelief_part_"..n );
      ObjSet( "spr_zzbasrelief_part_"..n.."dark", {       
        res = "assets/levels/levelext/rm_cemetery/zz_zzbasrelief/layers/shad",
        pos_x = -1,
        pos_y = 8
      } );
      
    end;

  end;
  --*********************************************************************************************************************
  function private.InitBasreliefStart ()  

    cmn.MiniGameShow( "zzbasrelief" );

    ng_global.progress[ "ext" ][ "win_zzbasrelief" ].state = {1,5,12,4,2,9,7,10,11,8,6,3};

  end;
  --********************************************************************************************************************
  function private.LoadBasrelief ()
    
    for n=1, 12 do
      private.state[ n ] = ng_global.progress[ "ext" ][ "win_zzbasrelief" ].state[ n ];
      ObjSet( "spr_zzbasrelief_part_"..n, { 
        --input = not ( private.state[ n ] == private.win[ n ] ),
        pos_x = private.coords[ private.state[n] ][1],
        pos_y = private.coords[ private.state[n] ][2],
      } );
    end;

  end;
  --*********************************************************************************************************************
  function private.CheckWinBasrelief ()
    
    local win = true;
    
    for n=1, 12 do
      if ( private.state[ n ] ~= private.win[ n ] ) then
        win = false;
        break;
      end;       
    end;
    
    if ( win ) then
      private.WinBasrelief();
    else
      for n=1, 12 do
        ng_global.progress[ "ext" ][ "win_zzbasrelief" ].state[ n ] = private.state[ n ];
      end;
    end;

  end;
  --*********************************************************************************************************************
  function private.WinBasrelief ()

    local func_end = function ()

      cmn.MiniGameHide( "zzbasrelief" );
      cmn.SetEventDone( "win_zzbasrelief" );
      cmn.CallEventHandler( "win_zzbasrelief" );
      common_impl.PassingMgWin( "zzbasrelief" );

      int.Lock( false ) ;
      
      cmn.PlayAudio( "mus", "audio/aud_scare_theme_mus" );

      --cmn.CloseSubRoom();

    end;

    int.Lock( true ) ;
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mg_win" );
    ObjSet( "obj_zzbasrelief_open", { alp = 1 } );
    ObjAnimate("obj_zzbasrelief_mmg", "pos_xy", 0, 0, func_end, 
    {
      0.0,0,0,0,
      0.5,1,-555,-65
    });

  end;
  --*********************************************************************************************************************
  function private.PartClk ( n )
    
    local func_end = function ()
    
      int.Lock( false );      
      
      --ObjSet( "spr_zzbasrelief_part_"..n, { 
      --input = not ( private.state[ n ] == private.win[ n ] ),
      --} );
      --ObjSet( "spr_zzbasrelief_part_"..private.prev, { 
      --input = not ( private.state[ private.prev ] == private.win[ private.prev ] ),
      --} );
      
      ObjSet( "spr_zzbasrelief_part_"..n, { pos_z = 0 } );
      ObjSet( "spr_zzbasrelief_part_"..private.prev, { pos_z = 0 } );
      
      private.prev = 0;
      private.CheckWinBasrelief();
    
    end;

    if ( private.prev == 0 ) then
      
      private.prev = n;
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_stone_click" );
      ObjAnimate("spr_zzbasrelief_part_"..n, "scale_xy", 0, 0, "", 
      {
        0.0,0,ObjGet( "spr_zzbasrelief_part_"..n ).scale_x,ObjGet( "spr_zzbasrelief_part_"..n ).scale_y,
        0.2,0,1.05,1.05
      });
      
    elseif ( private.prev == n ) then
      
      private.prev = 0;
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_stone_click" );
      ObjAnimate("spr_zzbasrelief_part_"..n, "scale_xy", 0, 0, "", 
      {
        0.0,0,ObjGet( "spr_zzbasrelief_part_"..n ).scale_x,ObjGet( "spr_zzbasrelief_part_"..n ).scale_y,
        0.2,0,1,1
      });
      
    else

      int.Lock( true );     

      local tmp = private.state[ private.prev ];
      private.state[ private.prev ] = private.state[ n ];
      private.state[ n ] = tmp;      
      
      ObjSet( "spr_zzbasrelief_part_"..n, { pos_z = 20 } );
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_stone_moove" );
      ObjAnimate("spr_zzbasrelief_part_"..n, "pos_xy", 0, 0, func_end, 
      {
        0.0,0,ObjGet("spr_zzbasrelief_part_"..n).pos_x,ObjGet("spr_zzbasrelief_part_"..n).pos_y,
        0.3,0,private.coords[ private.state[n] ][1],private.coords[ private.state[n] ][2]
      });

      ObjSet( "spr_zzbasrelief_part_"..private.prev, { pos_z = 21 } );
      ObjAnimate("spr_zzbasrelief_part_"..private.prev, "pos_xy", 0, 0, "", 
      {
        0.0,0,ObjGet("spr_zzbasrelief_part_"..private.prev).pos_x,ObjGet("spr_zzbasrelief_part_"..private.prev).pos_y,
        0.3,0,private.coords[ private.state[ private.prev ] ][1],private.coords[ private.state[ private.prev ] ][2]
      });
      ObjAnimate("spr_zzbasrelief_part_"..private.prev, "scale_xy", 0, 0, "", 
      {
        0.0,0,ObjGet("spr_zzbasrelief_part_"..private.prev).scale_x,ObjGet("spr_zzbasrelief_part_"..private.prev).scale_y,
        0.2,0,1,1
      });
      
    end;

  end;
  --*********************************************************************************************************************
  function private.PartEnter ( n )

    cmn.SetCursor(CURSOR_HAND);

  end;
  --*********************************************************************************************************************
  function private.PartLeave ( n )

    cmn.SetCursor(CURSOR_DEFAULT);

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.GhostAnims ()
  
  local array = { 0, 0 };
  local count = math.random( 1, 4 );
  
  if count == 1 then
    
    array[ 1 ] = 1;
    array[ 2 ] = math.random( 3, 4 );
    ObjSet( "tmr_cemetery_anims", { playing = 1, time = 16.0, endtrig = function () private.GhostAnims() end } ); 
    
  elseif count == 2 then
    
    array[ 1 ] = 2;
    array[ 2 ] = 5;
    ObjSet( "tmr_cemetery_anims", { playing = 1, time = 30.0, endtrig = function () private.GhostAnims() end } ); 
    
  elseif count == 3 then
    
    array[ 1 ] = math.random( 3, 4 );
    array[ 2 ] = 6;
    
    ObjSet( "tmr_cemetery_anims", { playing = 1, time = 16.0, endtrig = function () private.GhostAnims() end } ); 
    
  elseif count == 4 then
    
    array[ 1 ] = 7;
    ObjSet( "tmr_cemetery_anims", { playing = 1, time = 32.0, endtrig = function () private.GhostAnims() end } ); 
    
  end;  
 
  for i = 1, 2 do
    
    if array[ i ] ~= 0 then
      
      AnimPlay( "anm_cemetery_ghost"..array[ i ], "DoAnim", "" )

    else 
      break;  
    end;
    
  end;
  
end;
--*********************************************************************************************************************
function private.ClkLock ()
  
  local func_end = function ()
  
    int.Lock( false ); 
    cmn.ShowBbt( "bbt_lodge_use_acidext" );
    
  end;

  int.Lock( true ); 
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_doorlodge" );
  AnimPlay( "anm_lodge_close_door1", "DoAnim", func_end );
  
end;
--*********************************************************************************************************************
