-- name=rm_farm
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_farm";

  ObjAttach( "zz_hollow",    "room_hub" );
  ObjAttach( "zz_skeletons", "room_hub" );
  ObjAttach( "zz_car",       "room_hub" );
  ObjAttach( "zz_scrypt",    "room_hub" );

  ObjMultiSet( {
    { "spr_hollow_prunerpart_2",      { event_mdown = private.get_prunerpart_2 } },
    { "spr_hollow_birdext_1",         { event_mdown = private.get_birdext_1 } },
    { "spr_hollow_carlever",          { event_mdown = private.get_carlever } },
    { "spr_hollow_yang",              { event_mdown = private.get_yang } },
    { "spr_hollow_bluegem",           { event_mdown = private.get_bluegem } },
    { "spr_skeletons_amuletskull_1",  { event_mdown = private.get_amuletskull_1 } },
    { "spr_skeletons_portrait_2",     { event_mdown = private.get_portrait_2 } },
    { "spr_car_amuletgate_1",         { event_mdown = private.get_amuletgate_1 } },
    { "spr_car_tweezersext",          { event_mdown = private.get_tweezersext } },
    { "spr_car_amuletcrypt_2",        { event_mdown = private.get_amuletcrypt_2 } },
    { "spr_car_rivet",                { event_mdown = private.get_rivet } },
    { "spr_car_recipeext",            { event_mdown = private.get_recipeext } },
    { "spr_car_portrait_3",           { event_mdown = private.get_portrait_3 } },
    { "spr_scrypt_angelstatuette",    { event_mdown = private.get_angelstatuette } },
    { "spr_farm_stick",               { event_mdown = private.get_stick } },
    { "obj_car_clk_carlever",         { event_mdown = private.clk_carlever } },
    { "obj_car_clk_button4",          { event_mdown = private.clk_button4 } },
    { "obj_scrypt_use_amuletcrypt_1", { event_mdown = private.ScryptDoorsClick } },
    { "obj_scrypt_use_amuletcrypt_2", { event_mdown = private.ScryptDoorsClick } },
    { "obj_scrypt_use_tweezersext",   { event_mdown = private.ScryptCoinClick } },
    { "obj_car_use_carlever",         { event_mdown = private.CarSeatClick } },
    { "obj_skeletons_use_bone_1",     { event_mdown = private.SceletonsAmuletscullClick } },
    { "obj_skeletons_use_bone_2",     { event_mdown = private.SceletonsPortreitClick } },
    { "obj_car_use_yang",             { event_mdown = private.YinYangClick } },
    { "obj_car_use_yin",              { event_mdown = private.YinYangClick } },
    { "obj_hollow_use_amuletspider",  { event_mdown = private.ClkNet } },
    { "spr_farm_stick",               { event_mdown = private.get_stick } },
  } );

  private.InitAnim();
  private.AnimEyes();
  private.InitSubroom();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_farm = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gho_farm_hoscrypt",
        "gzz_farm_hollow",
        "gzz_farm_skeletons",
        "gzz_farm_car",
        "gzz_farm_scrypt",
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_hollow", 
        "zz_skeletons", 
        "zz_car", 
        "zz_scrypt", 
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_farm", update_game_mode_farm, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_prunerpart_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_prunerpart_2" ] =
  {
    type = "get",
    get_obj = "spr_hollow_prunerpart_2",
    room = private.room_objname,
    zz = "zz_hollow",
    zz_gate = "gzz_farm_hollow"
  };
  -----------------------------------------------
  local get_prunerpart_2_inv = function ()

    int.InventoryItemAdd( "inv_prunerpart_2", "spr_hollow_prunerpart_2" );    
    if cmn.IsEventDone( "get_prunerpart_1" ) then
      ObjSet( "inv_prunerpart_1_plus_focus2", { alp = 1 } );
    end;

  end;

  local get_prunerpart_2_closezz = function ()

    ObjDelete( "gfx_hollow_prunerpart_2" );
    ObjDelete( "spr_hollow_prunerpart_2_shadow" );
    ObjDelete( "spr_farm_hollow_part" );
    
  end;

  cmn.AddSubscriber( "get_prunerpart_2", get_prunerpart_2_inv );
  cmn.AddSubscriber( "get_prunerpart_2", get_prunerpart_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_birdext_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_birdext_1" ] =
  {
    type = "get",
    get_obj = "spr_hollow_birdext_1",
    room = private.room_objname,
    zz = "zz_hollow",
    zz_gate = "gzz_farm_hollow"
  };
  -----------------------------------------------
  local get_birdext_1_inv = function ()

    int.InventoryItemAdd( "inv_birdext_1", "spr_hollow_birdext_1" );

  end;

  local get_birdext_1_closezz = function ()

    ObjDelete( "gfx_hollow_birdext_1" );
    ObjDelete( "spr_hollow_birdie_shadow" );
    ObjDelete( "spr_farm_hollow_bird" );
        
    if cmn.IsEventDone( "get_bluegem" ) and
       cmn.IsEventDone( "get_yang" )and
       cmn.IsEventDone( "get_birdext_1" ) then
      ObjDelete( "gzz_farm_hollow" );
    end;

  end;

  cmn.AddSubscriber( "get_birdext_1", get_birdext_1_inv );
  cmn.AddSubscriber( "get_birdext_1", get_birdext_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_carlever () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_carlever" ] =
  {
    type = "get",
    get_obj = "spr_hollow_carlever",
    room = private.room_objname,
    zz = "zz_hollow",
    zz_gate = "gzz_farm_hollow"
  };
  -----------------------------------------------
  local get_carlever_inv = function ()

    int.InventoryItemAdd( "inv_carlever", "spr_hollow_carlever" );

  end;

  local get_carlever_closezz = function ()

    ObjDelete( "gfx_hollow_carlever" );
    ObjDelete( "spr_hollow_lever_shadow" );
    ObjDelete( "spr_farm_hollow_lever" );
    
  end;

  cmn.AddSubscriber( "get_carlever", get_carlever_inv );
  cmn.AddSubscriber( "get_carlever", get_carlever_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_yang () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_yang" ] =
  {
    type = "get",
    get_obj = "spr_hollow_yang",
    room = private.room_objname,
    zz = "zz_hollow",
    zz_gate = "gzz_farm_hollow"
  };
  -----------------------------------------------
  local get_yang_inv = function ()

    int.InventoryItemAdd( "inv_yang", "spr_hollow_yang" );

  end;

  local get_yang_closezz = function ()

    ObjDelete( "gfx_hollow_yang" );
    ObjDelete( "spr_farm_hollow_yin" );
        
    if cmn.IsEventDone( "get_bluegem" ) and
       cmn.IsEventDone( "get_yang" )and
       cmn.IsEventDone( "get_birdext_1" ) then
      ObjDelete( "gzz_farm_hollow" );
    end;

  end;

  cmn.AddSubscriber( "get_yang", get_yang_inv );
  cmn.AddSubscriber( "get_yang", get_yang_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bluegem () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bluegem" ] =
  {
    type = "get",
    get_obj = "spr_hollow_bluegem",
    room = private.room_objname,
    zz = "zz_hollow",
    zz_gate = "gzz_farm_hollow"
  };
  -----------------------------------------------
  local get_bluegem_inv = function ()

    int.InventoryItemAdd( "inv_bluegem", "spr_hollow_bluegem" );
    if cmn.IsEventDone( "clk_brokenlantern" ) then
      ObjSet( "inv_brokenlantern_plus_focus2", { alp = 1 } );
    end;

  end;

  local get_bluegem_closezz = function ()

    if cmn.IsEventDone( "get_bluegem" ) and
       cmn.IsEventDone( "get_yang" )and
       cmn.IsEventDone( "get_birdext_1" ) then
      ObjDelete( "gzz_farm_hollow" );
    end;

  end;

  cmn.AddSubscriber( "get_bluegem", get_bluegem_inv );
  cmn.AddSubscriber( "get_bluegem", get_bluegem_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletskull_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletskull_1" ] =
  {
    type = "get",
    get_obj = "spr_skeletons_amuletskull_1",
    room = private.room_objname,
    zz = "zz_skeletons",
    zz_gate = "gzz_farm_skeletons"
  };
  -----------------------------------------------
  local get_amuletskull_1_inv = function ()

    int.InventoryItemAdd( "inv_amuletskull", "spr_skeletons_amuletskull_1", "assets/levels/levelext/rm_farm/zz_skeletons/inv/inv_amuletskull_morph" );
    levelext_inv.CheckAmuletskull();

  end;

  local get_amuletskull_1_closezz = function ()

    ObjDelete( "gfx_skeletons_amuletskull_1" );
    ObjDelete( "anm_skeletons_amuletskull_1_fx" );
    ObjDelete( "spr_farm_skeletons_amulet_scull_1" );
    
  end;

  cmn.AddSubscriber( "get_amuletskull_1", get_amuletskull_1_inv );
  cmn.AddSubscriber( "get_amuletskull_1", get_amuletskull_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_portrait_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_portrait_2" ] =
  {
    type = "get",
    get_obj = "spr_skeletons_portrait_2",
    room = private.room_objname,
    zz = "zz_skeletons",
    zz_gate = "gzz_farm_skeletons"
  };
  -----------------------------------------------
  local get_portrait_2_inv = function ()

    int.InventoryItemAdd( "inv_portrait", "spr_skeletons_portrait_2", "assets/levels/levelext/rm_cemetery/zz_gravestone/inv/inv_portrait_2" );
    levelext_inv.CheckPortrait( 2 );
    
  end;

  local get_portrait_2_closezz = function ()

    ObjDelete( "gfx_skeletons_portrait_2" );
    ObjDelete( "gzz_farm_skeletons" );
    ObjDelete( "spr_farm_skeletons_portrait_2" );

  end;

  cmn.AddSubscriber( "get_portrait_2", get_portrait_2_inv );
  cmn.AddSubscriber( "get_portrait_2", get_portrait_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletgate_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletgate_1" ] =
  {
    type = "get",
    get_obj = "spr_car_amuletgate_1",
    room = private.room_objname,
    zz = "zz_car",
    zz_gate = "gzz_farm_car"
  };
  -----------------------------------------------
  local get_amuletgate_1_inv = function ()

    int.InventoryItemAdd( "inv_amuletgate_1", "spr_car_amuletgate_1" );

  end;
  local get_amuletgate_1_closezz = function ()

    ObjDelete( "gfx_car_amuletgate_1" );
    ObjDelete( "spr_car_amuletgate_1_shadow" );
    
  end;
  local get_amuletgate_1_loc = function ()

  if ( cmn.IsEventDone( "win_hoscrypt" ) ) then

    ObjSet( "vid_nearcar_smoke_2", { alp = 1, playing = true, looped = true } );
    ObjDelete( "vid_nearcar_smoke_1" );

  end;

  end;  

  cmn.AddSubscriber( "get_amuletgate_1", get_amuletgate_1_inv );
  cmn.AddSubscriber( "get_amuletgate_1", get_amuletgate_1_closezz, private.room_objname );
  cmn.AddSubscriber( "get_amuletgate_1", get_amuletgate_1_loc, "rm_nearcar" );
  --------------------------------------------------------------------------------------------
  -- function get_tweezersext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tweezersext" ] =
  {
    type = "get",
    get_obj = "spr_car_tweezersext",
    room = private.room_objname,
    zz = "zz_car",
    zz_gate = "gzz_farm_car"
  };
  -----------------------------------------------
  local get_tweezersext_inv = function ()

    int.InventoryItemAdd( "inv_tweezersext", "spr_car_tweezersext" );

  end;

  local get_tweezersext_closezz = function ()

    ObjDelete( "gfx_car_tweezersext" );
    ObjDelete( "spr_car_tweezersext_shadow" );
    
  end;

  cmn.AddSubscriber( "get_tweezersext", get_tweezersext_inv );
  cmn.AddSubscriber( "get_tweezersext", get_tweezersext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletcrypt_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletcrypt_2" ] =
  {
    type = "get",
    get_obj = "spr_car_amuletcrypt_2",
    room = private.room_objname,
    zz = "zz_car",
    zz_gate = "gzz_farm_car"
  };
  -----------------------------------------------
  local get_amuletcrypt_2_inv = function ()

    int.InventoryItemAdd( "inv_amuletcrypt_2", "spr_car_amuletcrypt_2" );

  end;

  local get_amuletcrypt_2_closezz = function ()

    ObjDelete( "gfx_car_amuletcrypt_2" );
    ObjDelete( "spr_car_amuletcrypt_2_shadow" );
    
  end;

  cmn.AddSubscriber( "get_amuletcrypt_2", get_amuletcrypt_2_inv );
  cmn.AddSubscriber( "get_amuletcrypt_2", get_amuletcrypt_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rivet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_rivet" ] =
  {
    type = "get",
    get_obj = "spr_car_rivet",
    room = private.room_objname,
    zz = "zz_car",
    zz_gate = "gzz_farm_car"
  };
  -----------------------------------------------
  local get_rivet_inv = function ()

    int.InventoryItemAdd( "inv_rivet", "spr_car_rivet" );
    
    if cmn.IsEventDone( "use_prunerpart_2" ) then
      
      ObjSet( "inv_prunerpart_1_plus_focus2", { alp = 1 } );
      
    end;

  end;

  local get_rivet_closezz = function ()

    ObjDelete( "gfx_car_rivet" );
    ObjDelete( "spr_car_rivet_shadow" );
    
  end;

  cmn.AddSubscriber( "get_rivet", get_rivet_inv );
  cmn.AddSubscriber( "get_rivet", get_rivet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_recipeext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_recipeext" ] =
  {
    type = "get",
    get_obj = "spr_car_recipeext",
    room = private.room_objname,
    zz = "zz_car",
    zz_gate = "gzz_farm_car"
  };
  -----------------------------------------------
  local get_recipeext_inv = function ()

    int.InventoryItemAdd( "inv_recipeext", "spr_car_recipeext_inv" );
    
    ObjSet( "inv_recipeext", { drag = false } );
    ObjDelete( "spr_car_recipeext" );
    ObjDelete( "spr_car_recipeext_shadow" );
    
    if not cmn.IsEventDone( "get_poisons" ) then
      
      ObjSet( "inv_recipeext_plus_focus2", { alp = 0 } );
      
    end;

  end;

  local get_recipeext_closezz = function ()

    ObjSet( "spr_car_portrait_3", { input = true, active = true } );
    if ( cmn.IsEventDone( "get_portrait_3" ) ) then

      ObjDelete( "gzz_farm_car" );

    end;

  end;

  cmn.AddSubscriber( "get_recipeext", get_recipeext_inv );
  cmn.AddSubscriber( "get_recipeext", get_recipeext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_portrait_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_portrait_3" ] =
  {
    type = "get",
    get_obj = "spr_car_portrait_3",
    room = private.room_objname,
    zz = "zz_car",
    zz_gate = "gzz_farm_car"
  };
  -----------------------------------------------
  local get_portrait_3_inv = function ()

    int.InventoryItemAdd( "inv_portrait", "spr_car_portrait_3", "assets/levels/levelext/rm_cemetery/zz_gravestone/inv/inv_portrait_3" );
    levelext_inv.CheckPortrait( 3 );
    
  end;

  local get_portrait_3_closezz = function ()

    ObjDelete( "gfx_car_portrait_3" );
    ObjDelete( "spr_car_portrait_3_shadow" );
    
    if ( cmn.IsEventDone( "get_recipeext" ) ) then

      ObjDelete( "gzz_farm_car" );

    end;

  end;

  cmn.AddSubscriber( "get_portrait_3", get_portrait_3_inv );
  cmn.AddSubscriber( "get_portrait_3", get_portrait_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_angelstatuette () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_angelstatuette" ] =
  {
    type = "get",
    get_obj = "spr_scrypt_angelstatuette",
    room = private.room_objname,
    zz = "zz_scrypt",
    zz_gate = "gzz_farm_scrypt"
  };
  -----------------------------------------------
  local get_angelstatuette_inv = function ()

    int.InventoryItemAdd( "inv_angelstatuette", "spr_scrypt_angelstatuette" );

  end;

  local get_angelstatuette_closezz = function ()

    ObjDelete( "gfx_scrypt_angelstatuette" );
    ObjDelete( "spr_scrypt_angelstatuette_shadow" );
    ObjDelete( "spr_farm_scrypt_angel" );
    
  end;

  cmn.AddSubscriber( "get_angelstatuette", get_angelstatuette_inv );
  cmn.AddSubscriber( "get_angelstatuette", get_angelstatuette_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coinext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_coinext" ] =
  {
    type = "get",
    get_obj = "spr_scrypt_coinext",
    room = private.room_objname,
    zz = "zz_scrypt",
    zz_gate = "gzz_farm_scrypt"
  };
  -----------------------------------------------
  local get_coinext_inv = function ()

    int.InventoryItemAdd( "inv_coinext", "spr_scrypt_coinext" );
    if cmn.IsEventDone( "use_rivet" ) then
      ObjSet( "inv_prunerpart_1_plus_focus2", { alp = 1 } );
    end;

  end;

  local get_coinext_closezz = function ()
  
    ObjDelete( "spr_farm_scrypt_coin" );
    ObjDelete( "spr_scrypt_coinext_shadow" );
    
  end;

  cmn.AddSubscriber( "get_coinext", get_coinext_inv );
  cmn.AddSubscriber( "get_coinext", get_coinext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stick () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stick" ] =
  {
    type = "get",
    get_obj = "spr_farm_stick",
    room = private.room_objname
  };
  -----------------------------------------------
  local get_stick_inv = function ()

    int.InventoryItemAdd( "inv_stick", "spr_farm_stick" );

    if cmn.IsEventDone( "get_shovelblade" ) then
      ObjSet( "inv_shovelblade_plus_focus2", { alp = 1 } );
    end;

  end;

  local get_stick_closezz = function ()

    ObjDelete( "spr_farm_stick_shadow" );
    ObjDelete( "gfx_farm_stick" );
  
  end;

  cmn.AddSubscriber( "get_stick", get_stick_inv );
  cmn.AddSubscriber( "get_stick", get_stick_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_dimgem () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_dimgem" ] =
  {
    type = "use",
    use_obj = "inv_dimgem",
    use_place = "obj_hollow_use_dimgem",
    room = private.room_objname,
    zz = "zz_hollow",
    zz_gate = "gzz_farm_hollow"
  };
  -----------------------------------------------
  local use_dimgem_inv = function ()

    int.InventoryItemRemove( "inv_dimgem" );

  end;
  local use_dimgem_beg = function ()

    ObjDelete( "obj_hollow_use_dimgem" );

  end;
  local use_dimgem_end = function ()

    ObjSet( "spr_hollow_yang", { alp = 1, input = true } );
    ObjSet( "gfx_hollow_yang", { active = true } );
    ObjSet( "spr_farm_hollow_yin", { alp = 1 } );
    ObjDelete( "anm_hollow_fire" );
    ObjDelete( "anm_hollow_gem_use" );
    ObjDelete( "anm_farm_hollow_bluefire" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_dimgem", use_dimgem_beg, private.room_objname );
  cmn.AddSubscriber( "use_dimgem", use_dimgem_inv );
  cmn.AddSubscriber( "use_dimgem", use_dimgem_end, private.room_objname );
  cmn.AddSubscriber( "use_dimgem_inv", use_dimgem_inv, private.room_objname );
  cmn.AddSubscriber( "use_dimgem_beg", use_dimgem_beg, private.room_objname );
  cmn.AddSubscriber( "use_dimgem_end", use_dimgem_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletspider () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletspider" ] =
  {
    type = "use",
    use_obj = "inv_amuletspider",
    use_place = "obj_hollow_use_amuletspider",
    room = private.room_objname,
    zz = "zz_hollow",
    zz_gate = "gzz_farm_hollow"
  };
  -----------------------------------------------
  local use_amuletspider_inv = function ()

    int.InventoryItemRemove( "inv_amuletspider" );

  end;
  local use_amuletspider_beg = function ()

    ObjDelete( "obj_hollow_use_amuletspider" );

  end;
  local use_amuletspider_end = function ()

    ObjSet( "obj_hollow_net_open", { input = true } );
    ObjSet( "gfx_hollow_birdext_1", { active = true } );
    ObjSet( "gfx_hollow_carlever", { active = true } );
    ObjSet( "obj_hollow_use_dimgem", { input = true } );
    ObjSet( "spr_hollow_net_open", { alp = 1 } );
    ObjDelete( "obj_hollow_net_closed" );
    ObjDelete( "spr_farm_hollow_web_close" );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_amuletspider", use_amuletspider_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletspider", use_amuletspider_inv );
  cmn.AddSubscriber( "use_amuletspider", use_amuletspider_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletspider_inv", use_amuletspider_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletspider_beg", use_amuletspider_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletspider_end", use_amuletspider_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bone_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bone_1" ] =
  {
    type = "use",
    use_obj = "inv_bone_1",
    use_place = "obj_skeletons_use_bone_1",
    room = private.room_objname,
    zz = "zz_skeletons",
    zz_gate = "gzz_farm_skeletons"
  };
  -----------------------------------------------
  local use_bone_1_inv = function ()

    int.InventoryItemRemove( "inv_bone_1" );

  end;
  local use_bone_1_beg = function ()

    ObjDelete( "obj_skeletons_use_bone_1" );

  end;
  local use_bone_1_end = function ()

    ObjSet( "spr_skeletons_amuletskull_1",      { input = true, alp = 1 } );
    ObjSet( "gfx_skeletons_amuletskull_1",      { active = true } );
    ObjSet( "anm_skeletons_skeleton_1_alive", { alp = 1, playing = true } );
    ObjSet( "anm_skeletons_amuletskull_1_fx", { playing = true } );
    ObjDelete( "anm_skeletons_skeleton_1_static" );
    ObjDelete( "anm_skeletons_skeleton_1_click" );
    ObjDelete( "anm_skeletons_skeleton_1_use_bone" );
    
    ObjDelete( "anm_farm_skeletons_static1_left" );
    ObjSet( "anm_farm_skeletons_static2_left",      { alp = 1 } );
    ObjSet( "spr_farm_skeletons_amulet_scull_1",      { alp = 1 } );
      
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_bone_1", use_bone_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_bone_1", use_bone_1_inv );
  cmn.AddSubscriber( "use_bone_1", use_bone_1_end, private.room_objname );
  cmn.AddSubscriber( "use_bone_1_inv", use_bone_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_bone_1_beg", use_bone_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_bone_1_end", use_bone_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bone_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bone_2" ] =
  {
    type = "use",
    use_obj = "inv_bone_2",
    use_place = "obj_skeletons_use_bone_2",
    room = private.room_objname,
    zz = "zz_skeletons",
    zz_gate = "gzz_farm_skeletons"
  };
  -----------------------------------------------
  local use_bone_2_inv = function ()

    int.InventoryItemRemove( "inv_bone_2" );

  end;
  local use_bone_2_beg = function ()

    ObjDelete( "obj_skeletons_use_bone_2" );

  end;
  local use_bone_2_end = function ()

    ObjSet( "spr_skeletons_portrait_2",      { input = true, alp = 1 } );
    ObjSet( "gfx_skeletons_portrait_2",      { active = true } );
    ObjSet( "anm_skeletons_skeleton_2_alive", { alp = 1, playing = true } );
    ObjDelete( "anm_skeletons_skeleton_2_static" );
    ObjDelete( "anm_skeletons_skeleton_2_click" );
    ObjDelete( "anm_skeletons_skeleton_2_use_bone" );    
    
    ObjDelete( "anm_farm_skeletons_static1_right" );
    ObjSet( "anm_farm_skeletons_static2_right",      { alp = 1 } );
    ObjSet( "spr_farm_skeletons_portrait_2",      { alp = 1 } );
        
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_bone_2", use_bone_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_bone_2", use_bone_2_inv );
  cmn.AddSubscriber( "use_bone_2", use_bone_2_end, private.room_objname );
  cmn.AddSubscriber( "use_bone_2_inv", use_bone_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_bone_2_beg", use_bone_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_bone_2_end", use_bone_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_button4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_button4" ] =
  {
    type = "use",
    use_obj = "inv_button4",
    use_place = "obj_car_use_button4",
    room = private.room_objname,
    zz = "zz_car",
    zz_gate = "gzz_farm_car"
  };
  -----------------------------------------------
  local use_button4_inv = function ()

    int.InventoryItemRemove( "inv_button4" );

  end;
  local use_button4_beg = function ()

    ObjDelete( "obj_car_use_button4" );

  end;
  local use_button4_end = function ()

    ObjSet( "obj_car_clk_button4", { input = true } );
    ObjSet( "spr_car_button4", { alp = 1 } );
    ObjDelete( "anm_car_spring" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_button4", use_button4_beg, private.room_objname );
  cmn.AddSubscriber( "use_button4", use_button4_inv );
  cmn.AddSubscriber( "use_button4", use_button4_end, private.room_objname );
  cmn.AddSubscriber( "use_button4_inv", use_button4_inv, private.room_objname );
  cmn.AddSubscriber( "use_button4_beg", use_button4_beg, private.room_objname );
  cmn.AddSubscriber( "use_button4_end", use_button4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_carlever () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_carlever" ] =
  {
    type = "use",
    use_obj = "inv_carlever",
    use_place = "obj_car_use_carlever",
    room = private.room_objname,
    zz = "zz_car",
    zz_gate = "gzz_farm_car"
  };
  -----------------------------------------------
  local use_carlever_inv = function ()

    int.InventoryItemRemove( "inv_carlever" );

  end;
  local use_carlever_beg = function ()

    ObjDelete( "obj_car_use_carlever" );

  end;
  local use_carlever_end = function ()

    ObjDelete( "spr_car_seat_light" );
    ObjSet( "spr_car_carlever",     { alp = 1 } );
    ObjSet( "obj_car_clk_carlever", { input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_carlever", use_carlever_beg, private.room_objname );
  cmn.AddSubscriber( "use_carlever", use_carlever_inv );
  cmn.AddSubscriber( "use_carlever", use_carlever_end, private.room_objname );
  cmn.AddSubscriber( "use_carlever_inv", use_carlever_inv, private.room_objname );
  cmn.AddSubscriber( "use_carlever_beg", use_carlever_beg, private.room_objname );
  cmn.AddSubscriber( "use_carlever_end", use_carlever_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_yang () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_yang" ] =
  {
    type = "use",
    use_obj = "inv_yang",
    use_place = "obj_car_use_yang",
    room = private.room_objname,
    zz = "zz_car",
    zz_gate = "gzz_farm_car"
  };
  -----------------------------------------------
  local use_yang_inv = function ()

    int.InventoryItemRemove( "inv_yang" );

  end;
  local use_yang_beg = function ()

    ObjDelete( "obj_car_use_yang" );

  end;
  local use_yang_end = function ()

    ObjSet( "spr_car_yang", { alp = 1 } );

    if ( cmn.IsEventDone( "use_yin" ) ) then

      ObjDelete( "spr_car_box_cover" );
      ObjSet( "obj_car_box_open",   { alp = 1, input = true } );
      ObjSet( "gfx_car_recipeext",  { active = true } );
      ObjSet( "gfx_car_portrait_3", { active = true } );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_yang", use_yang_beg, private.room_objname );
  cmn.AddSubscriber( "use_yang", use_yang_inv );
  cmn.AddSubscriber( "use_yang", use_yang_end, private.room_objname );
  cmn.AddSubscriber( "use_yang_inv", use_yang_inv, private.room_objname );
  cmn.AddSubscriber( "use_yang_beg", use_yang_beg, private.room_objname );
  cmn.AddSubscriber( "use_yang_end", use_yang_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_yin () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_yin" ] =
  {
    type = "use",
    use_obj = "inv_yin",
    use_place = "obj_car_use_yin",
    room = private.room_objname,
    zz = "zz_car",
    zz_gate = "gzz_farm_car"
  };
  -----------------------------------------------
  local use_yin_inv = function ()

    int.InventoryItemRemove( "inv_yin" );

  end;
  local use_yin_beg = function ()

    ObjDelete( "obj_car_use_yin" );

  end;
  local use_yin_end = function ()

    ObjSet( "spr_car_yin", { alp = 1 } );

    if ( cmn.IsEventDone( "use_yang" ) ) then

      ObjDelete( "spr_car_box_cover" );
      ObjSet( "obj_car_box_open",   { alp = 1, input = true } );
      ObjSet( "gfx_car_recipeext",  { active = true } );
      ObjSet( "gfx_car_portrait_3", { active = true } );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_yin", use_yin_beg, private.room_objname );
  cmn.AddSubscriber( "use_yin", use_yin_inv );
  cmn.AddSubscriber( "use_yin", use_yin_end, private.room_objname );
  cmn.AddSubscriber( "use_yin_inv", use_yin_inv, private.room_objname );
  cmn.AddSubscriber( "use_yin_beg", use_yin_beg, private.room_objname );
  cmn.AddSubscriber( "use_yin_end", use_yin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletcrypt_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletcrypt_1" ] =
  {
    type = "use",
    use_obj = "inv_amuletcrypt_1",
    use_place = "obj_scrypt_use_amuletcrypt_1",
    room = private.room_objname,
    zz = "zz_scrypt",
    zz_gate = "gzz_farm_scrypt"
  };
  -----------------------------------------------
  local use_amuletcrypt_1_inv = function ()

    int.InventoryItemRemove( "inv_amuletcrypt_1" );

  end;
  local use_amuletcrypt_1_beg = function ()

    ObjDelete( "obj_scrypt_use_amuletcrypt_1" );

  end;
  local use_amuletcrypt_1_end = function ()

    ObjSet( "spr_scrypt_amuletcrypt_1", { alp = 1 } );
    ObjSet( "spr_farm_scrypt_amulet_part_2", { alp = 1 } );

    if ( cmn.IsEventDone( "use_amuletcrypt_2" ) ) then

      ObjDelete( "spr_farm_scrypt_amulet_part_1" );
      ObjDelete( "spr_farm_scrypt_amulet_part_2" );
      ObjSet( "spr_farm_scrypt_door_open", { alp = 1 } );
            
      ObjDelete( "gzz_farm_scrypt" );
      ObjDelete( "obj_scrypt_doors" );
      ObjSet( "gho_farm_hoscrypt", { input = true, alp = 1, active = true } );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_amuletcrypt_1", use_amuletcrypt_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletcrypt_1", use_amuletcrypt_1_inv );
  cmn.AddSubscriber( "use_amuletcrypt_1", use_amuletcrypt_1_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletcrypt_1_inv", use_amuletcrypt_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletcrypt_1_beg", use_amuletcrypt_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletcrypt_1_end", use_amuletcrypt_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tweezersext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tweezersext" ] =
  {
    type = "use",
    use_obj = "inv_tweezersext",
    use_place = "obj_scrypt_use_tweezersext",
    room = private.room_objname,
    zz = "zz_scrypt",
    zz_gate = "gzz_farm_scrypt"
  };
  -----------------------------------------------
  local use_tweezersext_inv = function ()

    int.InventoryItemRemove( "inv_tweezersext" );

  end;
  local use_tweezersext_beg = function ()

    ObjDelete( "obj_scrypt_use_tweezersext" );

  end;
  local use_tweezersext_end = function ()

    ObjDelete( "anm_scrypt_tweezersext" );
    ObjDelete( "obj_scrypt_door_right_coin" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_tweezersext", use_tweezersext_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezersext", use_tweezersext_inv );
  cmn.AddSubscriber( "use_tweezersext", use_tweezersext_end, private.room_objname );
  cmn.AddSubscriber( "use_tweezersext_inv", use_tweezersext_inv, private.room_objname );
  cmn.AddSubscriber( "use_tweezersext_beg", use_tweezersext_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezersext_end", use_tweezersext_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletcrypt_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletcrypt_2" ] =
  {
    type = "use",
    use_obj = "inv_amuletcrypt_2",
    use_place = "obj_scrypt_use_amuletcrypt_2",
    room = private.room_objname,
    zz = "zz_scrypt",
    zz_gate = "gzz_farm_scrypt"
  };
  -----------------------------------------------
  local use_amuletcrypt_2_inv = function ()

    int.InventoryItemRemove( "inv_amuletcrypt_2" );

  end;
  local use_amuletcrypt_2_beg = function ()

    ObjDelete( "obj_scrypt_use_amuletcrypt_2" );

  end;
  local use_amuletcrypt_2_end = function ()

    ObjSet( "spr_scrypt_amuletcrypt_2", { alp = 1 } );
    ObjSet( "spr_farm_scrypt_amulet_part_1", { alp = 1 } );
    
    if ( cmn.IsEventDone( "use_amuletcrypt_1" ) ) then
      
      ObjDelete( "spr_farm_scrypt_amulet_part_1" );
      ObjDelete( "spr_farm_scrypt_amulet_part_2" );
      ObjSet( "spr_farm_scrypt_door_open", { alp = 1 } );
          
      ObjDelete( "gzz_farm_scrypt" );
      ObjDelete( "obj_scrypt_doors" );
      ObjSet( "gho_farm_hoscrypt", { input = true, alp = 1, active = true } );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_amuletcrypt_2", use_amuletcrypt_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletcrypt_2", use_amuletcrypt_2_inv );
  cmn.AddSubscriber( "use_amuletcrypt_2", use_amuletcrypt_2_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletcrypt_2_inv", use_amuletcrypt_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletcrypt_2_beg", use_amuletcrypt_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletcrypt_2_end", use_amuletcrypt_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_saw () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_saw" ] =
  {
    type = "use",
    use_obj = "inv_saw",
    use_place = "obj_farm_use_saw",
    room = private.room_objname
  };
  -----------------------------------------------
  local use_saw_inv = function ()

    int.InventoryItemRemove( "inv_saw" );

  end;
  local use_saw_beg = function ()

    ObjDelete( "obj_farm_use_saw" );

  end;
  local use_saw_end = function ()

    ObjSet( "spr_farm_stick_shadow", { alp = 1 } );
    ObjSet( "spr_farm_stick",        { alp = 1, input = true } );
    ObjSet( "gfx_farm_stick",        { active = true } );
    ObjSet( "spr_farm_stick_part",   { alp = 1 } );
    ObjDelete( "anm_farm_saw" );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_saw", use_saw_beg, private.room_objname );
  cmn.AddSubscriber( "use_saw", use_saw_inv );
  cmn.AddSubscriber( "use_saw", use_saw_end, private.room_objname );
  cmn.AddSubscriber( "use_saw_inv", use_saw_inv, private.room_objname );
  cmn.AddSubscriber( "use_saw_beg", use_saw_beg, private.room_objname );
  cmn.AddSubscriber( "use_saw_end", use_saw_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_carlever () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_carlever" ] =
  {
    type = "click",
    clk_obj = "obj_car_clk_carlever",
    room = private.room_objname,
    zz = "zz_car",
    zz_gate = "gzz_farm_car"
  };
  -----------------------------------------------
  local clk_carlever_beg = function ()

    ObjDelete( "obj_car_clk_carlever" );

  end;
  local clk_carlever_end = function ()

    ObjSet( "spr_car_seat_open",     { alp = 1 } );
    ObjSet( "spr_car_amuletgate_1",  { input = true, active = true } );
    ObjSet( "spr_car_amuletcrypt_2", { input = true, active = true } );
    ObjSet( "obj_car_box",           { input = true } );
    ObjDelete( "spr_car_seat_close" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_carlever", clk_carlever_beg, private.room_objname );
  cmn.AddSubscriber( "clk_carlever", clk_carlever_end, private.room_objname );
  cmn.AddSubscriber( "clk_carlever_beg", clk_carlever_beg, private.room_objname );
  cmn.AddSubscriber( "clk_carlever_end", clk_carlever_end, private.room_objname ); 
  --------------------------------------------------------------------------------------------
  -- function clk_button4() end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_button4" ] =
  {
    type = "click",
    clk_obj = "obj_car_clk_button4",
    room = private.room_objname,
    zz = "zz_car",
    zz_gate = "gzz_farm_car"
  };
  -----------------------------------------------
  local clk_button4_beg = function ()

    ObjDelete( "obj_car_clk_button4" );

  end;
  local clk_button4_end = function ()
  
    ObjSet( "obj_car_compartment_open", { alp = 1, input = true } );
    ObjSet( "gfx_car_tweezersext",      { active = true } );
    ObjSet( "gfx_car_rivet",            { active = true } );
    ObjDelete( "spr_car_button4" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_button4", clk_button4_beg, private.room_objname );
  cmn.AddSubscriber( "clk_button4", clk_button4_end, private.room_objname );
  cmn.AddSubscriber( "clk_button4_beg", clk_button4_beg, private.room_objname );
  cmn.AddSubscriber( "clk_button4_end", clk_button4_end, private.room_objname );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
function private.get_prunerpart_2 ()

  cmn.SetEventDone( "get_prunerpart_2" );
  cmn.CallEventHandler( "get_prunerpart_2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_birdext_1 ()

  cmn.SetEventDone( "get_birdext_1" );
  cmn.CallEventHandler( "get_birdext_1" );
  
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_bluegem" ) and
     cmn.IsEventDone( "get_yang" )and
     cmn.IsEventDone( "get_birdext_1" ) then
    cmn.CloseSubRoom();
  end;


end;
-------------------------------------------------
function private.get_carlever ()

  cmn.SetEventDone( "get_carlever" );
  cmn.CallEventHandler( "get_carlever" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_yang ()

  cmn.SetEventDone( "get_yang" );
  cmn.CallEventHandler( "get_yang" );
  
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_bluegem" ) and
     cmn.IsEventDone( "get_yang" )and
     cmn.IsEventDone( "get_birdext_1" ) then
    cmn.CloseSubRoom();
  end;

end;
-------------------------------------------------
function private.get_bluegem ()

  cmn.SetEventDone( "get_bluegem" );
  cmn.CallEventHandler( "get_bluegem" );
  
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_bluegem" ) and
     cmn.IsEventDone( "get_yang" )and
     cmn.IsEventDone( "get_birdext_1" ) then
    cmn.CloseSubRoom();
  end;


end;
-------------------------------------------------
function private.get_amuletskull_1 ()

  cmn.SetEventDone( "get_amuletskull_1" );
  cmn.CallEventHandler( "get_amuletskull_1" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_portrait_2 ()

  cmn.SetEventDone( "get_portrait_2" );
  cmn.CallEventHandler( "get_portrait_2" );
  cmn.CloseSubRoom();
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_amuletgate_1 ()

  cmn.SetEventDone( "get_amuletgate_1" );
  cmn.CallEventHandler( "get_amuletgate_1" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_tweezersext ()

  cmn.SetEventDone( "get_tweezersext" );
  cmn.CallEventHandler( "get_tweezersext" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_amuletcrypt_2 ()

  cmn.SetEventDone( "get_amuletcrypt_2" );
  cmn.CallEventHandler( "get_amuletcrypt_2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_rivet ()

  cmn.SetEventDone( "get_rivet" );
  cmn.CallEventHandler( "get_rivet" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_recipeext ()

  ObjSet( "spr_car_recipeext_inv", { alp = 1 } );
  
  cmn.SetEventDone( "get_recipeext" );
  cmn.CallEventHandler( "get_recipeext" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_portrait_3" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_portrait_3 ()

  cmn.SetEventDone( "get_portrait_3" );
  cmn.CallEventHandler( "get_portrait_3" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_recipeext" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-------------------------------------------------
function private.get_angelstatuette ()

  cmn.SetEventDone( "get_angelstatuette" );
  cmn.CallEventHandler( "get_angelstatuette" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_coinext ()

  cmn.SetEventDone( "get_coinext" );
  cmn.CallEventHandler( "get_coinext" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_stick ()

  cmn.SetEventDone( "get_stick" );
  cmn.CallEventHandler( "get_stick" );
  
  cmn.GetObjectSfx();

end;
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_4_3 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_4_3 = function ()

    ObjDelete( "obj_farm_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_4_3", get_morphobject_4_3, private.room_objname );
--*********************************************************************************************************************
-------------------------------------------------
function public.use_dimgem ()

  local item = "inv_dimgem";

  if ( cmn.ApplyObj( item, "gzz_farm_hollow", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_hollow" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_hollow_use_dimgem", true ) ) then

    cmn.CallEventHandler( "use_dimgem_inv" );
    cmn.CallEventHandler( "use_dimgem_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_dimgem" );
      private.get_bluegem ();
      cmn.CallEventHandler( "use_dimgem_end" );
      int.Lock( false );

    end;
    
    ObjAnimate( "spr_hollow_yang", "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      1.4, 0, 0,
      1.8, 0, 1,
    } );
    
    ObjSet( "anm_hollow_fire", { alp = 0 } );
    ObjSet( "anm_hollow_gem_use", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_take_energy" );
    AnimPlay( "anm_hollow_gem_use", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_amuletspider ()

  local item = "inv_amuletspider";

  if ( cmn.ApplyObj( item, "gzz_farm_hollow", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_hollow" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_hollow_use_amuletspider", true ) ) then

    cmn.CallEventHandler( "use_amuletspider_inv" );
    cmn.CallEventHandler( "use_amuletspider_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_amuletspider" );
      cmn.CallEventHandler( "use_amuletspider_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_app_spider" );

    VidPlay( "vid_hollow_web_destruction", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_bone_1 ()

  local item = "inv_bone_1";

  if ( cmn.ApplyObj( item, "gzz_farm_skeletons", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_skeletons" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_skeletons_use_bone_1", true ) ) then

    cmn.CallEventHandler( "use_bone_1_inv" );
    cmn.CallEventHandler( "use_bone_1_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_bone_1" );
      cmn.CallEventHandler( "use_bone_1_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_scull" );
    ObjSet( "anm_skeletons_skeleton_1_static", { alp = 0 } );
    ObjSet( "anm_skeletons_skeleton_1_use_bone", { alp = 1 } ); 
    AnimPlay( "anm_skeletons_skeleton_1_use_bone", "DoAnim", func_end );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_bone_2 ()

  local item = "inv_bone_2";

  if ( cmn.ApplyObj( item, "gzz_farm_skeletons", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_skeletons" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_skeletons_use_bone_2", true ) ) then

    cmn.CallEventHandler( "use_bone_2_inv" );
    cmn.CallEventHandler( "use_bone_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_bone_2" );
      cmn.CallEventHandler( "use_bone_2_end" );
      int.Lock( false );

    end;   
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_leg" ); 
    ObjSet( "anm_skeletons_skeleton_2_static", { alp = 0 } );
    ObjSet( "anm_skeletons_skeleton_2_use_bone", { alp = 1 } ); 
    AnimPlay( "anm_skeletons_skeleton_2_use_bone", "DoAnim", func_end );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_button4 ()

  local item = "inv_button4";

  if ( cmn.ApplyObj( item, "gzz_farm_car", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_car" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_car_use_button4", true ) ) then

    cmn.CallEventHandler( "use_button4_inv" );
    cmn.CallEventHandler( "use_button4_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_button4" );
      cmn.CallEventHandler( "use_button4_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_button" );
    ObjAnimate( "spr_car_button4", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_carlever ()

  local item = "inv_carlever";

  if ( cmn.ApplyObj( item, "gzz_farm_car", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_car" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_car_use_carlever", true ) ) then

    cmn.CallEventHandler( "use_carlever_inv" );
    cmn.CallEventHandler( "use_carlever_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_carlever" );
      cmn.CallEventHandler( "use_carlever_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_app_lever" ); 
    ObjAnimate( "spr_car_carlever", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    local alp = ObjGet( "spr_car_seat_light" ).alp;

    ObjAnimate( "spr_car_seat_light", "alp", 0, 0, "",
    { 
      0.0, 0, alp, 
      0.3, 0, 0.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_yang ()

  local item = "inv_yang";

  if ( cmn.ApplyObj( item, "gzz_farm_car", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_car" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_car_use_yang", true ) ) then

    cmn.CallEventHandler( "use_yang_inv" );
    cmn.CallEventHandler( "use_yang_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_yang" );
      cmn.CallEventHandler( "use_yang_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_insert_inyan" );
    if ( cmn.IsEventDone( "use_yin" ) ) then

      ObjAnimate( "spr_car_yang", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      ObjAnimate( "obj_car_box_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.5, 0, 0.0, 
        0.8, 0, 1.0
      } );
      
      ObjSet( "tmr_car_aud", { playing = 1, time = 0.5, endtrig = function() cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_inyan_open" ) end } ); 

    else

      ObjAnimate( "spr_car_yang", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

    end;

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_yin ()

  local item = "inv_yin";

  if ( cmn.ApplyObj( item, "gzz_farm_car", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_car" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_car_use_yin", true ) ) then

    cmn.CallEventHandler( "use_yin_inv" );
    cmn.CallEventHandler( "use_yin_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_yin" );
      cmn.CallEventHandler( "use_yin_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_insert_inyan" );
    
    if ( cmn.IsEventDone( "use_yang" ) ) then

      ObjAnimate( "spr_car_yin", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      ObjAnimate( "obj_car_box_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.5, 0, 0.0, 
        0.8, 0, 1.0
      } );
      
      ObjSet( "tmr_car_aud", { playing = 1, time = 0.5, endtrig = function() cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_inyan_open" ) end } );

    else

      ObjAnimate( "spr_car_yin", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

    end;

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_amuletcrypt_1 ()

  local item = "inv_amuletcrypt_1";

  if ( cmn.ApplyObj( item, "gzz_farm_scrypt", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_scrypt" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_scrypt_use_amuletcrypt_1", true ) ) then

    cmn.CallEventHandler( "use_amuletcrypt_1_inv" );
    cmn.CallEventHandler( "use_amuletcrypt_1_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_amuletcrypt_1" );
      cmn.CallEventHandler( "use_amuletcrypt_1_end" );
      int.Lock( false );

      if ( cmn.IsEventDone( "use_amuletcrypt_2" ) ) then

        cmn.CloseSubRoom();

      end;

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_amulettowall" ); 

    if ( cmn.IsEventDone( "use_amuletcrypt_2" ) ) then

      ObjAnimate( "spr_scrypt_amuletcrypt_1", "alp", 0, 0,
      function ()
        
        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_openstonedoors" ); 
        
        ObjSet( "anm_scrypt_doors",      { alp = 1 } );
        ObjSet( "obj_scrypt_door_left",  { alp = 0 } );
        ObjSet( "obj_scrypt_door_right", { alp = 0 } );
        AnimPlay( "anm_scrypt_doors", "DoAnim", func_end );
        
      end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0,
        0.5, 0, 1.0
      } );

    else

      ObjAnimate( "spr_scrypt_amuletcrypt_1", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

    end;

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_tweezersext ()

  local item = "inv_tweezersext";

  if ( cmn.ApplyObj( item, "gzz_farm_scrypt", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_scrypt" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_scrypt_use_tweezersext", true ) ) then

    cmn.CallEventHandler( "use_tweezersext_inv" );
    cmn.CallEventHandler( "use_tweezersext_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_tweezersext" );
      cmn.CallEventHandler( "use_tweezersext_end" );
      int.Lock( false );

      private.get_coinext();

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_coin_take" );
    ObjSet( "obj_scrypt_door_right_coin", { alp = 0 } );
    ObjSet( "anm_scrypt_tweezersext", { alp = 1 } );
    ObjAttach( "anm_scrypt_tweezersext", "obj_scrypt_doors_over" );
    AnimPlay( "anm_scrypt_tweezersext", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_amuletcrypt_2 ()

  local item = "inv_amuletcrypt_2";

  if ( cmn.ApplyObj( item, "gzz_farm_scrypt", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_scrypt" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_scrypt_use_amuletcrypt_2", true ) ) then

    cmn.CallEventHandler( "use_amuletcrypt_2_inv" );
    cmn.CallEventHandler( "use_amuletcrypt_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_amuletcrypt_2" );
      cmn.CallEventHandler( "use_amuletcrypt_2_end" );
      int.Lock( false );

      if ( cmn.IsEventDone( "use_amuletcrypt_1" ) ) then

        cmn.CloseSubRoom();

      end;

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_amulettowall" ); 

    if ( cmn.IsEventDone( "use_amuletcrypt_1" ) ) then

      ObjAnimate( "spr_scrypt_amuletcrypt_2", "alp", 0, 0,
      function ()
        
        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_openstonedoors" ); 
        
        ObjSet( "anm_scrypt_doors",      { alp = 1 } );
        ObjSet( "obj_scrypt_door_left",  { alp = 0 } );
        ObjSet( "obj_scrypt_door_right", { alp = 0 } );
        AnimPlay( "anm_scrypt_doors", "DoAnim", func_end );
        
      end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0,
        0.5, 0, 1.0
      } );

    else

      ObjAnimate( "spr_scrypt_amuletcrypt_2", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

    end;

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_saw ()

  local item = "inv_saw";

  if ( cmn.ApplyObj( item, "obj_farm_use_saw", true ) ) then

    cmn.CallEventHandler( "use_saw_inv" );
    cmn.CallEventHandler( "use_saw_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_saw" );
      cmn.CallEventHandler( "use_saw_end" );
      int.Lock( false );
      
    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_saw" ); 

    AnimPlay( "anm_farm_saw", "DoAnim", func_end );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
function private.clk_carlever ()

  cmn.CallEventHandler( "clk_carlever_beg" );
  int.Lock( true );

  local func_end = function ()

    cmn.SetEventDone( "clk_carlever" );
    cmn.CallEventHandler( "clk_carlever_end" );
    int.Lock( false );

  end;

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_lever" );  

  ObjAnimate( "spr_car_carlever", "alp", 0, 0, "",
  { 
    0.0, 3, 1.0, 
    0.3, 3, 0.0,
  } );

  ObjAnimate( "spr_car_carlever_up", "alp", 0, 0, "",
  { 
    0.0, 3, 0.0, 
    0.3, 3, 1.0,
  } );

  ObjAnimate( "spr_car_seat_close", "alp", 0, 0, "",
  { 
    0.0, 3, 1.0, 
    0.5, 3, 1.0, 
    0.8, 3, 0.0,
  } );

  ObjAnimate( "spr_car_seat_open", "alp", 0, 0, func_end,
  { 
    0.0, 3, 0.0, 
    0.5, 3, 0.0, 
    0.8, 3, 1.0,
  } );

end;
-------------------------------------------------
function private.clk_button4 ()

  cmn.CallEventHandler( "clk_button4_beg" );
  int.Lock( true );

  local func_end = function ()

    cmn.SetEventDone( "clk_button4" );
    cmn.CallEventHandler( "clk_button4_end" );
    int.Lock( false );

  end;

    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_openglove" ); 

    ObjAnimate("spr_car_button4", "scale_xy", 0, 0, "", 
    {
      0.0,0,1,1,
      0.2,0,0.95,0.95,
      0.4,0,1,1
    });
    ObjAnimate("spr_car_button4", "alp", 0, 0, "", 
    {
      0.0,0,1,
      0.5,0,1,
      0.8,0,0
    });
    ObjAnimate( "obj_car_compartment_open", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.5, 0, 0.0, 
      0.8, 0, 1.0
    } );


end;
-------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_farm ()

  if not ( cmn.IsEventDone( "opn_farm" ) ) then

    cmn.SetEventDone( "opn_farm" );
    cmn.ShowBbt( "bbt_farm_first_open" );

  end;

end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.PreOpen ()
  
  cmn.StopAllEnv( "audio/level4/env/aud_farm_env", true );
  cmn.PlayAudio( "env", "audio/level4/env/aud_farm_env", 1, 2.5 );
  
end;  
--*********************************************************************************************************************
function public.Open ()

  private.opn_farm();

end;
--*********************************************************************************************************************
function private.InitSubroom ()
  
  subroom.Define( "zz_hollow" );
  
  -------------------------------------------------
  function zz_hollow.PreOpen ()

    if not ( cmn.IsEventDone( "use_dimgem" ) ) then
      cmn.PlayAudio( "env", "audio/level4/env/aud_zz_hollow_env", 1, 2.5 );
    end;

  end;
  -------------------------------------------------
  function zz_hollow.Close ()
    
    if not ( cmn.IsEventDone( "use_dimgem" ) ) then
      cmn.StopAudio( "env", "audio/level4/env/aud_zz_hollow_env", 1 );
    end;
    
  end;
 -------------------------------------------------
  
end;
--*********************************************************************************************************************
function public.Task ()
  
  int.AddedTaskMap( private.room_objname, "get_prunerpart_2" );
  int.AddedTaskMap( private.room_objname, "get_birdext_1",                                     { "use_amuletspider" } );
  int.AddedTaskMap( private.room_objname, "get_carlever",                                      { "use_amuletspider" } );
  int.AddedTaskMap( private.room_objname, "get_yang",                                          { "use_dimgem" } );
  int.AddedTaskMap( private.room_objname, "get_bluegem",                                       { "use_dimgem" } );
  int.AddedTaskMap( private.room_objname, "get_amuletskull_1",                                 { "use_bone_1" } );
  int.AddedTaskMap( private.room_objname, "get_portrait_2",                                    { "use_bone_2" } );
  int.AddedTaskMap( private.room_objname, "get_amuletgate_1",                                  { "clk_carlever" } );
  int.AddedTaskMap( private.room_objname, "get_tweezersext",                                   { "use_button4" } );
  int.AddedTaskMap( private.room_objname, "get_amuletcrypt_2",                                 { "clk_carlever" } );
  int.AddedTaskMap( private.room_objname, "get_rivet",                                         { "use_button4" } );
  int.AddedTaskMap( private.room_objname, "get_recipeext",                                     { "use_yang", "use_yin" } );
  int.AddedTaskMap( private.room_objname, "get_portrait_3",                                    { "use_yang", "use_yin" } );
  int.AddedTaskMap( private.room_objname, "get_angelstatuette" );
  int.AddedTaskMap( private.room_objname, "get_coinext",                                       { "use_tweezersext" } );
  int.AddedTaskMap( private.room_objname, "get_stick",                                         { "use_saw" } );
  
  int.AddedTaskMap( private.room_objname, "use_dimgem",                                        { "get_dimgem" } );
  int.AddedTaskMap( private.room_objname, "use_amuletspider",                                  { "get_amuletspider" } );
  int.AddedTaskMap( private.room_objname, "use_bone_1",                                        { "get_bone_1" } );
  int.AddedTaskMap( private.room_objname, "use_bone_2",                                        { "get_bone_2" } );
  int.AddedTaskMap( private.room_objname, "use_button4",                                       { "get_button4" } );
  int.AddedTaskMap( private.room_objname, "use_carlever",                                      { "get_carlever" } );
  int.AddedTaskMap( private.room_objname, "use_yang",                                          { "get_yang" } );
  int.AddedTaskMap( private.room_objname, "use_yin",                                           { "get_yin" } );
  int.AddedTaskMap( private.room_objname, "use_amuletcrypt_1",                                 { "get_amuletcrypt_1" } );
  int.AddedTaskMap( private.room_objname, "use_tweezersext",                                   { "get_tweezersext" } );
  int.AddedTaskMap( private.room_objname, "use_amuletcrypt_2",                                 { "get_amuletcrypt_2" } );
  int.AddedTaskMap( private.room_objname, "use_saw",                                           { "get_saw" } );
  
  int.AddedTaskMap( private.room_objname, "clk_carlever",                                      { "use_carlever" } );
  
  int.AddedTaskMap( private.room_objname, "win_hoscrypt",                                      { "use_amuletcrypt_1","use_amuletcrypt_2" } );
  
end;
--*********************************************************************************************************************
function private.InitAnim ()

  ObjAnimate( "spr_scrypt_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_scrypt_light_over", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_car_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_car_seat_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    1.4, 3, 1.0,
    2.8, 3, 0.3,
  } );

  ObjAnimate( "spr_skeletons_skeleton_1_flame_1", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    0.8, 3, 1.0,
    1.3, 3, 0.6,
    1.5, 3, 1.0,
    1.9, 3, 0.3,
  } );

  ObjAnimate( "spr_skeletons_skeleton_1_flame_2", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    0.7, 3, 1.0,
    1.1, 3, 0.6,
    1.4, 3, 1.0,
    1.7, 3, 0.3,
  } );
  
  ObjAnimate( "spr_skeletons_skeleton_2_flame_1", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    0.6, 3, 0.3,
    1.0, 3, 0.6,
    1.2, 3, 0.3,
    1.4, 3, 1.0,
  } );
  
  ObjAnimate( "spr_skeletons_skeleton_2_flame_2", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    0.5, 3, 0.3,
    0.9, 3, 0.6,
    1.2, 3, 0.3,
    1.5, 3, 1.0,
  } );
    
end;
--*********************************************************************************************************************
function private.AnimEyes ()
  
  ObjSet( "tmr_farm_eyes", {
    endtrig = function ()
      AnimPlay( "anm_farm_redeyes_"..math.random(1,3), "DoAnim", function () private.AnimEyes (); end );
    end,
    playing = true,
    time = 1
  } );
  
end
--*********************************************************************************************************************
function private.ScryptDoorsClick ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_scrypt_use_amuletcrypt" );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_stone_doors_touch" );
  ObjAnimate( "obj_scrypt_door_left", "pos_x", 0, 0, "", 
  {
    0.0, 3,  0,
    0.2, 3, -2,
    0.4, 3,  0,
    0.6, 3, -2,
    0.8, 3,  0,
  } );

  ObjAnimate( "obj_scrypt_door_right", "pos_x", 0, 0, func_end, 
  {
    0.0, 3,  0,
    0.2, 3,  2,
    0.4, 3,  0,
    0.6, 3,  2,
    0.8, 3,  0,
  } );

end;
--*********************************************************************************************************************
function private.ScryptCoinClick ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_scrypt_use_tweezersext" );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_coin" );
  
  ObjAnimate( "spr_scrypt_coinext_shake", "pos_xy", 0, 0, func_end, 
  {
    0.0, 0, 112, -118,
    0.2, 0, 113, -117,
    0.4, 0, 112, -118
  } );
  
  ObjAnimate( "spr_scrypt_coinext_shadow", "pos_xy", 0, 0, "", 
  {
    0.0, 0, 109, -107,
    0.2, 0, 110, -106,
    0.4, 0, 109, -107
  } );
  
end;
--*********************************************************************************************************************
function private.SceletonsAmuletscullClick ()

  int.Lock( true );

  local func_end = function ()
  
    ObjSet( "anm_skeletons_skeleton_1_static", { alp = 1, frame = 0 } );
    ObjSet( "anm_skeletons_skeleton_1_click", { alp = 0, frame = 0 } );  

    int.Lock( false );

    cmn.ShowBbt( "bbt_skeletons_use_bone_1" );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_bone_touch" );
  ObjSet( "anm_skeletons_skeleton_1_static", { alp = 0 } );
  ObjSet( "anm_skeletons_skeleton_1_click", { alp = 1 } );
  AnimPlay( "anm_skeletons_skeleton_1_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.SceletonsPortreitClick ()

  int.Lock( true );

  local func_end = function ()
  
    ObjSet( "anm_skeletons_skeleton_2_static", { alp = 1, frame = 0 } );
    ObjSet( "anm_skeletons_skeleton_2_click", { alp = 0, frame = 0 } );   

    int.Lock( false );

    cmn.ShowBbt( "bbt_skeletons_use_bone_2" );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_bone_touch" );
  ObjSet( "anm_skeletons_skeleton_2_static", { alp = 0 } );
  ObjSet( "anm_skeletons_skeleton_2_click", { alp = 1 } );
  AnimPlay( "anm_skeletons_skeleton_2_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.CarSeatClick ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_car_use_carlever" );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_chair_touch" );
  ObjAnimate( "spr_car_seat_close", "pos_xy", 0, 0, func_end, 
  {
    0.0, 3, -67, 76,
    0.2, 3, -70, 79,
    0.4, 3, -67, 76,
    0.6, 3, -70, 79,
    0.8, 3, -67, 76,
  } );

end;
--*********************************************************************************************************************
function private.YinYangClick ()
  
  int.Lock( true );
  
  local func_end = function ()
  
    int.Lock( false );
  
    if cmn.IsEventDone( "use_yang" ) or 
       cmn.IsEventDone( "use_yin" ) then
       
      cmn.ShowBbt( "bbt_car_use_yin_yang" );
      
    else 
      
      cmn.ShowBbt( "bbt_car_use_no_yin_yang" );
      
    end;  
  
  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_inyan_xx" );
  ObjAnimate( "spr_car_box_cover", "pos_xy", 0, 0, func_end, 
  {
    0.0, 3, -33, 13,
    0.2, 3, -34, 12,
    0.4, 3, -33, 13,
    0.6, 3, -34, 12,
    0.8, 3, -33, 13,
  } );
    
end;  
--*********************************************************************************************************************
function private.ClkNet ()
  
  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_hollow_use_amuletspider" );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_cobweb_touch" );
  ObjAnimate( "obj_hollow_net_closed", "pos_x", 0, 0, func_end, 
  { 
   0.0, 3, 0,
   0.2, 3, - 1,
   0.4, 3, 0,
  } );
  
end;  
--*********************************************************************************************************************