-- name=rm_flightdeck
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_flightdeck";

  ObjAttach( "zz_steeringwheel", "room_hub" );
  ObjAttach( "zz_panelext",      "room_hub" );
  ObjAttach( "zz_firstaidkit",   "room_hub" );
  
  ObjMultiSet( {
    { "spr_steeringwheel_phonenumber_2",     { event_mdown = private.get_phonenumber_2 }},
    { "spr_steeringwheel_swissknife",        { event_mdown = private.get_swissknife } },
    { "spr_steeringwheel_batteryext_2",      { event_mdown = private.get_batteryext_2 } },
    { "spr_panelext_phonenumber_1",          { event_mdown = private.get_phonenumber_1 } },
    { "spr_panelext_radiobutton",            { event_mdown = private.get_radiobutton } },
    { "spr_panelext_batteryext_1",           { event_mdown = private.get_batteryext_1 } },
    { "spr_firstaidkit_glove",               { event_mdown = private.get_gloveext } },
    { "spr_firstaidkit_bandage",             { event_mdown = private.get_bandage } },
    { "spr_firstaidkit_bulbext",             { event_mdown = private.get_bulbext } },
    { "obj_steeringwheel_use_radiobutton",   { event_mdown = private.clk_wires } },
    { "obj_steeringwheel_use_amuletwatch",   { event_mdown = private.clk_chains } },
    { "obj_steeringwheel_clk_radiobutton",   { event_mdown = private.clk_radiobutton } },
    { "obj_steeringwheel_clk_steeringwheel", { event_mdown = private.clk_steeringwheel } },
    { "spr_steeringwheel_collect2_4_4",      { event_mdown = private.get_collect2_4_4 } },
    { "obj_panelext_use_screwdriverext",     { event_mdown = private.ClkPanel } },
    
  } );

  private.Anims();
  private.InitSubroom(); 
  int.InitMorphRandomState( 4 );

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_flightdeck = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gzz_flightdeck_steeringwheel",
        "gzz_flightdeck_panelext",
        "gzz_flightdeck_firstaidkit",
        "gmg_flightdeck_mgfate",
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_steeringwheel", 
        "zz_panelext", 
        "zz_firstaidkit",
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_flightdeck", update_game_mode_flightdeck, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_phonenumber_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_phonenumber_2" ] =
  {
    type = "get",
    get_obj = "spr_steeringwheel_phonenumber_2",
    room = private.room_objname,
    zz = "zz_steeringwheel",
    zz_gate = "gzz_flightdeck_steeringwheel"
  };
  -----------------------------------------------
  local get_phonenumber_2_inv = function ()

    int.InventoryItemAdd( "inv_phonenumber_2", "spr_steeringwheel_phonenumber_2" );

  end;

  local get_phonenumber_2_closezz = function ()

    ObjDelete( "gfx_steeringwheel_phonenumber_2" );
    ObjDelete( "spr_steeringwheel_phonenumber_shadow" );
    ObjDelete( "spr_flightdeck_phonenumber_2" );

  end;

  cmn.AddSubscriber( "get_phonenumber_2", get_phonenumber_2_inv );
  cmn.AddSubscriber( "get_phonenumber_2", get_phonenumber_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_swissknife () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_swissknife" ] =
  {
    type = "get",
    get_obj = "spr_steeringwheel_swissknife",
    room = private.room_objname,
    zz = "zz_steeringwheel",
    zz_gate = "gzz_flightdeck_steeringwheel"
  };
  -----------------------------------------------
  local get_swissknife_inv = function ()

    int.InventoryItemAdd( "inv_swissknife", "spr_steeringwheel_swissknife" );
    ObjSet( "inv_swissknife", { drag = false  } );

  end;

  local get_swissknife_closezz = function ()

    ObjDelete( "spr_steeringwheel_swissknife_shadow" );
    ObjDelete( "gfx_steeringwheel_swissknife" );
    ObjDelete( "spr_flightdeck_swissknife" );

  end;

  cmn.AddSubscriber( "get_swissknife", get_swissknife_inv );
  cmn.AddSubscriber( "get_swissknife", get_swissknife_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_batteryext_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_batteryext_2" ] =
  {
    type = "get",
    get_obj = "spr_steeringwheel_batteryext_2",
    room = private.room_objname,
    zz = "zz_steeringwheel",
    zz_gate = "gzz_flightdeck_steeringwheel"
  };
  -----------------------------------------------
  local get_batteryext_2_inv = function ()

    int.InventoryItemAdd( "inv_batteryext", "spr_steeringwheel_batteryext_2", "assets/levels/levelext/rm_flightdeck/zz_panelext/inv/inv_batteryext_morph" );
    levelext_inv.CheckBatteryext();
    
    if ( cmn.IsEventDone( "get_brokenflashlight" ) ) and
       ( cmn.IsEventDone( "get_batteryext_1" ) ) then

      ObjSet( "inv_brokenflashlight_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_batteryext_2_closezz = function ()

    ObjDelete( "spr_steeringwheel_battery_shadow" );
    ObjDelete( "gfx_steeringwheel_batteryext_2" );
    ObjDelete( "spr_flightdeck_battery_2" );

  end;

  cmn.AddSubscriber( "get_batteryext_2", get_batteryext_2_inv );
  cmn.AddSubscriber( "get_batteryext_2", get_batteryext_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_phonenumber_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_phonenumber_1" ] =
  {
    type = "get",
    get_obj = "spr_panelext_phonenumber_1",
    room = private.room_objname,
    zz = "zz_panelext",
    zz_gate = "gzz_flightdeck_panelext"
  };
  -----------------------------------------------
  local get_phonenumber_1_inv = function ()

    int.InventoryItemAdd( "inv_phonenumber_1", "spr_panelext_phonenumber_1" );

  end;

  local get_phonenumber_1_closezz = function ()

    ObjDelete( "gfx_panelext_phonenumber_1" );
    ObjDelete( "spr_panelext_phonenumber_shadow" );
    ObjDelete( "spr_flightdeck_phonenumber_1" );
    
    if cmn.IsEventDone( "get_batteryext_1" ) and
       cmn.IsEventDone( "get_phonenumber_1" ) and
       cmn.IsEventDone( "get_radiobutton" ) then
       
      ObjDelete( "gzz_flightdeck_panelext" );
      
    end; 

  end;

  cmn.AddSubscriber( "get_phonenumber_1", get_phonenumber_1_inv );
  cmn.AddSubscriber( "get_phonenumber_1", get_phonenumber_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_radiobutton () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_radiobutton" ] =
  {
    type = "get",
    get_obj = "spr_panelext_radiobutton",
    room = private.room_objname,
    zz = "zz_panelext",
    zz_gate = "gzz_flightdeck_panelext"
  };
  -----------------------------------------------
  local get_radiobutton_inv = function ()

    int.InventoryItemAdd( "inv_radiobutton", "spr_panelext_radiobutton" );

  end;

  local get_radiobutton_closezz = function ()

    ObjDelete( "gfx_panelext_radiobutton" );
    
    if cmn.IsEventDone( "get_batteryext_1" ) and
       cmn.IsEventDone( "get_phonenumber_1" ) and
       cmn.IsEventDone( "get_radiobutton" ) then
       
      ObjDelete( "gzz_flightdeck_panelext" );
      
    end; 
    
    ObjDelete( "spr_panelext_radiobutton_shadow" );
    ObjDelete( "spr_flightdeck_button" );

  end;

  cmn.AddSubscriber( "get_radiobutton", get_radiobutton_inv );
  cmn.AddSubscriber( "get_radiobutton", get_radiobutton_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_batteryext_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_batteryext_1" ] =
  {
    type = "get",
    get_obj = "spr_panelext_batteryext_1",
    room = private.room_objname,
    zz = "zz_panelext",
    zz_gate = "gzz_flightdeck_panelext"
  };
  -----------------------------------------------
  local get_batteryext_1_inv = function ()

    int.InventoryItemAdd( "inv_batteryext", "spr_panelext_batteryext_1", "assets/levels/levelext/rm_flightdeck/zz_panelext/inv/inv_batteryext_morph" );
    levelext_inv.CheckBatteryext();
    
    if ( cmn.IsEventDone( "get_brokenflashlight" ) ) and
       ( cmn.IsEventDone( "get_batteryext_2" ) ) then

      ObjSet( "inv_brokenflashlight_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_batteryext_1_closezz = function ()

    ObjDelete( "spr_panelext_battery_shadow" );
    ObjDelete( "gfx_panelext_batteryext_1" );
    ObjDelete( "spr_flightdeck_battery_1" );
    
    if cmn.IsEventDone( "get_batteryext_1" ) and
       cmn.IsEventDone( "get_phonenumber_1" ) and
       cmn.IsEventDone( "get_radiobutton" ) then
       
      ObjDelete( "gzz_flightdeck_panelext" );
      
    end;  

  end;

  cmn.AddSubscriber( "get_batteryext_1", get_batteryext_1_inv );
  cmn.AddSubscriber( "get_batteryext_1", get_batteryext_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gloveext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gloveext" ] =
  {
    type = "get",
    get_obj = "spr_firstaidkit_glove",
    room = private.room_objname,
    zz = "zz_firstaidkit",
    zz_gate = "gzz_flightdeck_firstaidkit"
  };
  -----------------------------------------------
  local get_gloveext_inv = function ()

    int.InventoryItemAdd( "inv_gloveext", "spr_firstaidkit_glove" );

  end;

  local get_gloveext_closezz = function ()

    ObjDelete( "gfx_firstaidkit_gloveext" );
    ObjDelete( "spr_firstaidkit_glove_shadow" );
    ObjDelete( "spr_flightdeck_glove" );
    
    if ( cmn.IsEventDone( "get_gloveext" ) and
         cmn.IsEventDone( "get_bandage" ) and
         cmn.IsEventDone( "get_bulbext" ) ) then
      ObjDelete( "gzz_flightdeck_firstaidkit" );
    end;

  end;

  cmn.AddSubscriber( "get_gloveext", get_gloveext_inv );
  cmn.AddSubscriber( "get_gloveext", get_gloveext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bandage () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bandage" ] =
  {
    type = "get",
    get_obj = "spr_firstaidkit_bandage",
    room = private.room_objname,
    zz = "zz_firstaidkit",
    zz_gate = "gzz_flightdeck_firstaidkit"
  };
  -----------------------------------------------
  local get_bandage_inv = function ()

    int.InventoryItemAdd( "inv_bandage", "spr_firstaidkit_bandage" );

  end;

  local get_bandage_closezz = function ()

    ObjDelete( "gfx_firstaidkit_bandage" );
    ObjDelete( "spr_firstaidkit_bandage_shadow" );
    ObjDelete( "spr_flightdeck_bandage" );
    
    if ( cmn.IsEventDone( "get_gloveext" ) and
         cmn.IsEventDone( "get_bandage" ) and
         cmn.IsEventDone( "get_bulbext" ) ) then
      ObjDelete( "gzz_flightdeck_firstaidkit" );
    end;

  end;

  cmn.AddSubscriber( "get_bandage", get_bandage_inv );
  cmn.AddSubscriber( "get_bandage", get_bandage_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bulbext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bulbext" ] =
  {
    type = "get",
    get_obj = "spr_firstaidkit_bulbext",
    room = private.room_objname,
    zz = "zz_firstaidkit",
    zz_gate = "gzz_flightdeck_firstaidkit"
  };
  -----------------------------------------------
  local get_bulbext_inv = function ()

    int.InventoryItemAdd( "inv_bulbext", "spr_firstaidkit_bulbext" );

    if ( cmn.IsEventDone( "get_brokenflashlight" )  ) then

      ObjSet( "inv_brokenflashlight_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_bulbext_closezz = function ()

    ObjDelete( "gfx_firstaidkit_bulbext" );
    ObjDelete( "spr_firstaidkit_lamp_add" );
    ObjDelete( "spr_flightdeck_light_add" );
    
    ObjDelete( "spr_flightdeck_lightbulb" );

    if ( cmn.IsEventDone( "get_gloveext" ) and
         cmn.IsEventDone( "get_bandage" ) and
         cmn.IsEventDone( "get_bulbext" ) ) then
      ObjDelete( "gzz_flightdeck_firstaidkit" );
    end;

  end;

  cmn.AddSubscriber( "get_bulbext", get_bulbext_inv );
  cmn.AddSubscriber( "get_bulbext", get_bulbext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_4_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_4_4 = function ()

    ObjDelete( "spr_steeringwheel_collect2_4_4" );

  end;

  cmn.AddSubscriber( "get_collect2_4_4", get_collect2_4_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_4_4 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_4_4 = function ()

    ObjDelete( "obj_flightdeck_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_4_4", get_morphobject_4_4, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_amuletwatch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletwatch" ] =
  {
    type = "use",
    use_obj = "inv_amuletwatch",
    use_place = "obj_steeringwheel_use_amuletwatch",
    room = private.room_objname,
    zz = "zz_steeringwheel",
    zz_gate = "gzz_flightdeck_steeringwheel"
  };
  -----------------------------------------------
  local use_amuletwatch_inv = function ()

    int.InventoryItemRemove( "inv_amuletwatch" );
    ObjSet( "int_button_map_impl", { input = false } );
    
  end;
  local use_amuletwatch_beg = function ()

    ObjDelete( "obj_steeringwheel_use_amuletwatch" );

  end;
  local use_amuletwatch_end = function ()

    ObjSet( "spr_steeringwheel_wheel", { alp = 1 } );
    ObjSet( "obj_steeringwheel_clk_steeringwheel", { input = true } );
    ObjDelete( "anm_steeringwheel_wheel_static" );
    ObjDelete( "anm_steeringwheel_wheel_click" );
    ObjDelete( "spr_steeringwheel_chain" );
    ObjDelete( "spr_steeringwheel_amuletwatch" );
    ObjDelete( "spr_flightdeck_chain" );
    ObjDelete( "anm_flightdeck_wheel" );
    ObjSet( "spr_flightdeck_wheel", { alp = 1 } );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_amuletwatch", use_amuletwatch_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletwatch", use_amuletwatch_inv );
  cmn.AddSubscriber( "use_amuletwatch", use_amuletwatch_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletwatch_inv", use_amuletwatch_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletwatch_beg", use_amuletwatch_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletwatch_end", use_amuletwatch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_radiobutton () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_radiobutton" ] =
  {
    type = "use",
    use_obj = "inv_radiobutton",
    use_place = "obj_steeringwheel_use_radiobutton",
    room = private.room_objname,
    zz = "zz_steeringwheel",
    zz_gate = "gzz_flightdeck_steeringwheel"
  };
  -----------------------------------------------
  local use_radiobutton_inv = function ()

    int.InventoryItemRemove( "inv_radiobutton" );

  end;
  local use_radiobutton_beg = function ()

    ObjDelete( "obj_steeringwheel_use_radiobutton" );

  end;
  local use_radiobutton_end = function ()

    ObjDelete( "txt_steeringwheel_radio_sighn_2" );
    ObjDelete( "obj_steeringwheel_wires" );

    ObjSet( "obj_steeringwheel_clk_radiobutton", { input = true } );
    
    ObjSet( "spr_steeringwheel_radiobutton", { alp = 1 } );
    ObjSet( "spr_steeringwheel_radio_button_add", { active = true } );  
    ObjSet( "spr_flightdeck_button_1", { alp = 1 } ); 
    
    ObjDelete( "spr_flightdeck_wire" );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_radiobutton", use_radiobutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_radiobutton", use_radiobutton_inv );
  cmn.AddSubscriber( "use_radiobutton", use_radiobutton_end, private.room_objname );
  cmn.AddSubscriber( "use_radiobutton_inv", use_radiobutton_inv, private.room_objname );
  cmn.AddSubscriber( "use_radiobutton_beg", use_radiobutton_beg, private.room_objname );
  cmn.AddSubscriber( "use_radiobutton_end", use_radiobutton_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screwdriverext_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriverext_2" ] =
  {
    type = "use",
    use_obj = "inv_screwdriverext",
    use_place = "obj_panelext_use_screwdriverext",
    room = private.room_objname,
    zz = "zz_panelext",
    zz_gate = "gzz_flightdeck_panelext"
  };
  -----------------------------------------------
  local use_screwdriverext_2_inv = function ()

    if cmn.IsEventDone( "use_screwdriverext_1" ) then
      int.InventoryItemRemove( "inv_screwdriverext" );
    end;

  end;
  local use_screwdriverext_2_beg = function ()

    ObjDelete( "obj_panelext_use_screwdriverext" );

  end;
  local use_screwdriverext_2_end = function ()

    ObjSet( "obj_panelext_open", { alp = 1, input = true } );
    ObjSet( "gfx_panelext_batteryext_1",  { active = true } );
    ObjSet( "gfx_panelext_phonenumber_1", { active = true } );
    ObjDelete( "obj_panelext_close" );
    ObjDelete( "anm_panelext_smoke" );
    ObjDelete( "spr_flightdeck_cover_panel" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_screwdriverext_2", use_screwdriverext_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriverext_2", use_screwdriverext_2_inv );
  cmn.AddSubscriber( "use_screwdriverext_2", use_screwdriverext_2_end, private.room_objname );
  cmn.AddSubscriber( "use_screwdriverext_2_inv", use_screwdriverext_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_screwdriverext_2_beg", use_screwdriverext_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriverext_2_end", use_screwdriverext_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gloveext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gloveext" ] =
  {
    type = "use",
    use_obj = "inv_gloveext",
    use_place = "obj_panelext_use_gloveext",
    room = private.room_objname,
    zz = "zz_panelext",
    zz_gate = "gzz_flightdeck_panelext"
  };
  -----------------------------------------------
  local use_gloveext_inv = function ()

    int.InventoryItemRemove( "inv_gloveext" );

  end;
  local use_gloveext_beg = function ()

    ObjDelete( "obj_panelext_use_gloveext" );

  end;
  local use_gloveext_end = function ()

    ObjSet( "obj_panelext_use_bandage", { input = true } );
    ObjDelete( "spr_panelext_glove" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_gloveext", use_gloveext_beg, private.room_objname );
  cmn.AddSubscriber( "use_gloveext", use_gloveext_inv );
  cmn.AddSubscriber( "use_gloveext", use_gloveext_end, private.room_objname );
  cmn.AddSubscriber( "use_gloveext_inv", use_gloveext_inv, private.room_objname );
  cmn.AddSubscriber( "use_gloveext_beg", use_gloveext_beg, private.room_objname );
  cmn.AddSubscriber( "use_gloveext_end", use_gloveext_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bandage () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bandage" ] =
  {
    type = "use",
    use_obj = "inv_bandage",
    use_place = "obj_panelext_use_bandage",
    room = private.room_objname,
    zz = "zz_panelext",
    zz_gate = "gzz_flightdeck_panelext"
  };
  -----------------------------------------------
  local use_bandage_inv = function ()

    int.InventoryItemRemove( "inv_bandage" );

  end;
  local use_bandage_beg = function ()

    ObjDelete( "obj_panelext_use_bandage" );

  end;
  local use_bandage_end = function ()
  
    ObjDelete( "vid_panelext_use_bandage" );
    ObjDelete( "spr_panelext_wire" );
    ObjDelete( "anm_zz_panelext_fog" );
    ObjDelete( "anm_flightdeck_panel_smoke" );
    ObjDelete( "anm_zz_panelext_sparks" );
    ObjSet( "spr_panelext_crocked", { alp = 1 } );
    ObjSet( "spr_panelext_radiobutton_shadow", { alp = 1 } );
    ObjSet( "gfx_panelext_radiobutton", { active = true } );
    ObjSet( "spr_panelext_radiobutton", { alp = 1 } );
    ObjSet( "spr_flightdeck_bandage_1", { alp = 1 } );
    ObjSet( "spr_flightdeck_button", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_bandage", use_bandage_beg, private.room_objname );
  cmn.AddSubscriber( "use_bandage", use_bandage_inv );
  cmn.AddSubscriber( "use_bandage", use_bandage_end, private.room_objname );
  cmn.AddSubscriber( "use_bandage_inv", use_bandage_inv, private.room_objname );
  cmn.AddSubscriber( "use_bandage_beg", use_bandage_beg, private.room_objname );
  cmn.AddSubscriber( "use_bandage_end", use_bandage_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_caduceus_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_caduceus_1" ] =
  {
    type = "use",
    use_obj = "inv_caduceus_1",
    use_place = "obj_firstaidkit_use_caduceus_1",
    room = private.room_objname,
    zz = "zz_firstaidkit",
    zz_gate = "gzz_flightdeck_firstaidkit"
  };
  -----------------------------------------------
  local use_caduceus_1_inv = function ()

    int.InventoryItemRemove( "inv_caduceus_1" );

  end;
  local use_caduceus_1_beg = function ()

    ObjDelete( "obj_firstaidkit_use_caduceus_1" );

  end;
  local use_caduceus_1_end = function ()
  
    ObjSet( "spr_firstaidkit_caduceus_1", { alp = 1 } );
    
    ObjSet( "spr_flightdeck_caduceus1", { alp = 1 } );
    
    if cmn.IsEventDone( "use_caduceus_2" ) then
      
      ObjSet( "obj_firstaidkit_open_firstaidkit", { alp = 1, input = true } );
      ObjSet( "spr_firstaidkit_glove", { active = true } );
      ObjSet( "spr_firstaidkit_bandage", { active = true } );
      ObjDelete( "spr_firstaidkit_caduceus_1" );
      ObjDelete( "spr_firstaidkit_caduceus_2" );
      
      ObjDelete( "spr_flightdeck_caduceus1" );
      ObjDelete( "spr_flightdeck_caduceus2" );
      ObjSet( "spr_flightdeck_open_firstaidkit", { alp = 1 } );
      ObjSet( "spr_flightdeck_glove", { alp = 1 } );
      ObjSet( "spr_flightdeck_bandage", { alp = 1 } );
      
    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_caduceus_1", use_caduceus_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_caduceus_1", use_caduceus_1_inv );
  cmn.AddSubscriber( "use_caduceus_1", use_caduceus_1_end, private.room_objname );
  cmn.AddSubscriber( "use_caduceus_1_inv", use_caduceus_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_caduceus_1_beg", use_caduceus_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_caduceus_1_end", use_caduceus_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_caduceus_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_caduceus_2" ] =
  {
    type = "use",
    use_obj = "inv_caduceus_2",
    use_place = "obj_firstaidkit_use_caduceus_2",
    room = private.room_objname,
    zz = "zz_firstaidkit",
    zz_gate = "gzz_flightdeck_firstaidkit"
  };
  -----------------------------------------------
  local use_caduceus_2_inv = function ()

    int.InventoryItemRemove( "inv_caduceus_2" );

  end;
  local use_caduceus_2_beg = function ()

    ObjDelete( "obj_firstaidkit_use_caduceus_2" );

  end;
  local use_caduceus_2_end = function ()
  
    ObjSet( "spr_firstaidkit_caduceus_2", { alp = 1 } );
    ObjSet( "spr_flightdeck_caduceus2", { alp = 1 } );
    if cmn.IsEventDone( "use_caduceus_1" ) then
      ObjSet( "obj_firstaidkit_open_firstaidkit", { alp = 1, input = true } );
      ObjSet( "spr_firstaidkit_glove", { active = true } );
      ObjSet( "spr_firstaidkit_bandage", { active = true } );
      ObjDelete( "spr_firstaidkit_caduceus_1" );
      ObjDelete( "spr_firstaidkit_caduceus_2" );
      
      ObjDelete( "spr_flightdeck_caduceus1" );
      ObjDelete( "spr_flightdeck_caduceus2" );
      ObjSet( "spr_flightdeck_open_firstaidkit", { alp = 1 } );
      ObjSet( "spr_flightdeck_glove", { alp = 1 } );
      ObjSet( "spr_flightdeck_bandage", { alp = 1 } );
           
    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_caduceus_2", use_caduceus_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_caduceus_2", use_caduceus_2_inv );
  cmn.AddSubscriber( "use_caduceus_2", use_caduceus_2_end, private.room_objname );
  cmn.AddSubscriber( "use_caduceus_2_inv", use_caduceus_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_caduceus_2_beg", use_caduceus_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_caduceus_2_end", use_caduceus_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wrenchext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wrenchext" ] =
  {
    type = "use",
    use_obj = "inv_wrenchext",
    use_place = "obj_firstaidkit_use_wrenchext",
    room = private.room_objname,
    zz = "zz_firstaidkit",
    zz_gate = "gzz_flightdeck_firstaidkit"
  };
  -----------------------------------------------
  local use_wrenchext_inv = function ()

    int.InventoryItemRemove( "inv_wrenchext" );

  end;
  local use_wrenchext_beg = function ()

    ObjDelete( "obj_firstaidkit_use_wrenchext" );

  end;
  local use_wrenchext_end = function ()

    ObjSet( "obj_firstaidkit_open_plafond", { input = true } );
    ObjSet( "spr_firstaidkit_bulbext",      { active = true } );
    ObjDelete( "obj_firstaidkit_close_plafond" );
    ObjDelete( "spr_flightdeck_cover_lightbulb" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_wrenchext", use_wrenchext_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrenchext", use_wrenchext_inv );
  cmn.AddSubscriber( "use_wrenchext", use_wrenchext_end, private.room_objname );
  cmn.AddSubscriber( "use_wrenchext_inv", use_wrenchext_inv, private.room_objname );
  cmn.AddSubscriber( "use_wrenchext_beg", use_wrenchext_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrenchext_end", use_wrenchext_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_steeringwheel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_steeringwheel" ] =
  {
    type = "click",
    clk_obj = "obj_steeringwheel_clk_steeringwheel",
    room = private.room_objname,
    zz = "zz_steeringwheel",
    zz_gate = "gzz_flightdeck_steeringwheel"
  };
  -----------------------------------------------
  local clk_steeringwheel = function ()


  end;
  -----------------------------------------------
  local clk_steeringwheel_beg = function ()

    ObjDelete( "obj_steeringwheel_clk_steeringwheel" );

  end;
  -----------------------------------------------
  local clk_steeringwheel_end = function ()

    ObjDelete( "gzz_flightdeck_atropos_4_steeringwheel" );
    ObjSet( "obj_steeringwheel_clk_steeringwheel", { input = true } );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_steeringwheel", clk_steeringwheel );
  cmn.AddSubscriber( "clk_steeringwheel", clk_steeringwheel_beg, private.room_objname );
  cmn.AddSubscriber( "clk_steeringwheel", clk_steeringwheel_end, private.room_objname );
  cmn.AddSubscriber( "clk_steeringwheel_beg", clk_steeringwheel_beg, private.room_objname );
  cmn.AddSubscriber( "clk_steeringwheel_end", clk_steeringwheel_end, private.room_objname );
  -----------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_radiobutton () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_radiobutton" ] =
  {
    type = "click",
    clk_obj = "obj_steeringwheel_clk_radiobutton",
    room = private.room_objname,
    zz = "zz_steeringwheel",
    zz_gate = "gzz_flightdeck_steeringwheel"
  };
  -----------------------------------------------
  local clk_radiobutton = function ()


  end;
  -----------------------------------------------
  local clk_radiobutton_beg = function ()

    ObjDelete( "obj_steeringwheel_clk_radiobutton" );

  end;
  -----------------------------------------------
  local clk_radiobutton_end = function ()
  
    ObjDelete( "anm_steeringwheel_use_radiobutton" );
    ObjDelete( "obj_steeringwheel_close_radio" );
    ObjSet( "obj_steeringwheel_open_radio", { alp = 1, input = true } );
    ObjSet( "spr_steeringwheel_phonenumber_2", { active = true } );
    ObjSet( "spr_flightdeck_phonenumber_2", { alp = 1 } );
    ObjDelete( "spr_steeringwheel_radio_add" );
    ObjSet( "spr_flightdeck_open", { alp = 1 } );
    ObjSet( "obj_steeringwheel_open_radio", { alp = 1 } );
    ObjDelete( "spr_steeringwheel_radiobutton" );
    ObjDelete( "spr_flightdeck_button_1" );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_radiobutton", clk_radiobutton );
  cmn.AddSubscriber( "clk_radiobutton", clk_radiobutton_beg, private.room_objname );
  cmn.AddSubscriber( "clk_radiobutton", clk_radiobutton_end, private.room_objname );
  cmn.AddSubscriber( "clk_radiobutton_beg", clk_radiobutton_beg, private.room_objname );
  cmn.AddSubscriber( "clk_radiobutton_end", clk_radiobutton_end, private.room_objname );
  -----------------------------------------------
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function dlg_flightdeck_atropos_4 () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_flightdeck_atropos_4" ] =
  {
    type = "click",
    room = private.room_objname,
  };
  -----------------------------------------------
  local dlg_flightdeck_atropos_4_beg = function ()

    ObjSet( "spr_flightdeck_dark", { alp = 1 } );

  end;
  -----------------------------------------------
  local dlg_flightdeck_atropos_4_end = function ()
  
  end;

  cmn.AddSubscriber( "dlg_flightdeck_atropos_4", dlg_flightdeck_atropos_4_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_flightdeck_atropos_4", dlg_flightdeck_atropos_4_end, private.room_objname );
  cmn.AddSubscriber( "dlg_flightdeck_atropos_4_beg", dlg_flightdeck_atropos_4_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_flightdeck_atropos_4_end", dlg_flightdeck_atropos_4_end, private.room_objname );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
-------------------------------------------------
function private.dlg_flightdeck_atropos_4_show ()

  local func_end = function ()

    int.Lock( false );
    private.dlg_flightdeck_atropos_4();

    ObjSet( "anm_flightdeck_atropos_appearance", { alp = 0, playing = false, frame = 0 } );

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_atropos_appearence" );

  ObjSet( "anm_flightdeck_atropos_appearance", { alp = 1 } );
  ObjSet( "spr_flightdeck_dark",               { alp = 1 } );
  AnimPlay( "anm_flightdeck_atropos_appearance", "DoAnim", func_end );

end;
-------------------------------------------------
function private.dlg_flightdeck_atropos_4 ()

  local func_end = function ()

    int.Lock( false );
    cmn.CallEventHandler( "dlg_flightdeck_atropos_4_end" );
    cmn.SetEventDone( "clk_steeringwheel" );
    cmn.GotoRoom( "mg_mgfate" );

    ObjSet( "anm_flightdeck_atropos_disappearance", { alp = 0, playing = false, frame = 0 } );
   
  end;
 
  local func_end_dialog = function ()

    int.Lock( true );
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_atropos_disappearence" );

    ObjSet( "anm_flightdeck_atropos_disappearance", { alp = 1 } );
    AnimPlay( "anm_flightdeck_atropos_disappearance", "DoAnim", func_end );

  end;
  
  ObjAttach( "dlg_flightdeck_atropos_4", "rm_flightdeck" );
  AnimPlay( "anm_flightdeck_atropos_4_halo", "DoAnim", "" );
  AnimPlay( "anm_flightdeck_atropos_4_darksmoke", "DoAnim", "" );
  AnimPlay( "anm_flightdeck_atropos_4_static1", "DoAnim", "" );    
  common_impl.dialog_character_loc = "anm_flightdeck_atropos_disappearance";
  private.dialog_voices_time = { 3 };

  common_impl.DialogCharacterStart( "atropos_4", 1, nil, nil, false, func_end_dialog );

  ObjSet( "tmr_flightdeck_fordial", { playing = 1, time = 0.3, endtrig = "" } );

end;
-------------------------------------------------
function private.get_phonenumber_2 ()

  cmn.SetEventDone( "get_phonenumber_2" );
  cmn.CallEventHandler( "get_phonenumber_2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_swissknife ()

  cmn.SetEventDone( "get_swissknife" );
  cmn.CallEventHandler( "get_swissknife" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_batteryext_2 ()

  cmn.SetEventDone( "get_batteryext_2" );
  cmn.CallEventHandler( "get_batteryext_2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_phonenumber_1 ()

  cmn.SetEventDone( "get_phonenumber_1" );
  cmn.CallEventHandler( "get_phonenumber_1" );
  
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_batteryext_1" ) and
     cmn.IsEventDone( "get_phonenumber_1" ) and
     cmn.IsEventDone( "get_radiobutton" ) then
     
    cmn.CloseSubRoom();
    
  end;

end;
-------------------------------------------------
function private.get_radiobutton ()

  cmn.SetEventDone( "get_radiobutton" );
  cmn.CallEventHandler( "get_radiobutton" );
  
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_batteryext_1" ) and
     cmn.IsEventDone( "get_phonenumber_1" ) and
     cmn.IsEventDone( "get_radiobutton" ) then
     
    cmn.CloseSubRoom();
    
  end;

end;
-------------------------------------------------
function private.get_batteryext_1 ()

  cmn.SetEventDone( "get_batteryext_1" );
  cmn.CallEventHandler( "get_batteryext_1" );
  
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_batteryext_1" ) and
     cmn.IsEventDone( "get_phonenumber_1" ) and
     cmn.IsEventDone( "get_radiobutton" ) then
     
    cmn.CloseSubRoom();
    
  end; 

end;
-------------------------------------------------
function private.get_gloveext ()

  cmn.SetEventDone( "get_gloveext" );
  cmn.CallEventHandler( "get_gloveext" );
  
  cmn.GetObjectSfx();
  
  if ( cmn.IsEventDone( "get_gloveext" ) and
       cmn.IsEventDone( "get_bandage" ) and
       cmn.IsEventDone( "get_bulbext" ) ) then
    cmn.CloseSubRoom();
  end;

end;
-------------------------------------------------
function private.get_bandage ()

  cmn.SetEventDone( "get_bandage" );
  cmn.CallEventHandler( "get_bandage" );
  
  cmn.GetObjectSfx();
  
  if ( cmn.IsEventDone( "get_gloveext" ) and
       cmn.IsEventDone( "get_bandage" ) and
       cmn.IsEventDone( "get_bulbext" ) ) then
    cmn.CloseSubRoom();
  end;

end;
-------------------------------------------------
function private.get_bulbext ()

  cmn.SetEventDone( "get_bulbext" );
  cmn.CallEventHandler( "get_bulbext" );
  
  cmn.GetObjectSfx();
  
  if ( cmn.IsEventDone( "get_gloveext" ) and
       cmn.IsEventDone( "get_bandage" ) and
       cmn.IsEventDone( "get_bulbext" ) ) then
    cmn.CloseSubRoom();
  end;

end;
---------------------------------------------------------------------------------
function private.get_collect2_4_4()

  int.AddCollectibles2( "spr_steeringwheel_collect2_4_4" );
  
end;
--*********************************************************************************************************************
-------------------------------------------------
function public.use_amuletwatch ()

  local item = "inv_amuletwatch";

  if ( cmn.ApplyObj( item, "gzz_flightdeck_steeringwheel", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_steeringwheel" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_steeringwheel_use_amuletwatch", true ) ) then

    cmn.CallEventHandler( "use_amuletwatch_inv" );
    cmn.CallEventHandler( "use_amuletwatch_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_amuletwatch" );
      cmn.CallEventHandler( "use_amuletwatch_end" );
      int.Lock( false );
      private.clk_steeringwheel();
      
    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_detail" );
    
    ObjSet( "anm_steeringwheel_wheel_static", { alp = 0 } );
    ObjSet( "spr_steeringwheel_chain", { alp = 1 } );
    ObjSet( "spr_steeringwheel_wheel", { alp = 1 } );
    
    ObjAnimate( "spr_steeringwheel_amuletwatch", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 1.0,
      0.9, 0, 0.0
    } );
    ObjAnimate( "spr_steeringwheel_chain", "alp", 0, 0, func_end,
    { 
      0.0, 0, 1.0,
      0.6, 0, 1.0,  
      0.9, 0, 0.0
    } );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_radiobutton ()

  local item = "inv_radiobutton";

  if ( cmn.ApplyObj( item, "gzz_flightdeck_steeringwheel", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_steeringwheel" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_steeringwheel_use_radiobutton", true ) ) then

    cmn.CallEventHandler( "use_radiobutton_inv" );
    cmn.CallEventHandler( "use_radiobutton_beg" );
    int.Lock( true );

    local func_end = function ()
      
      cmn.SetEventDone( "use_radiobutton" );
      cmn.CallEventHandler( "use_radiobutton_end" );
      int.Lock( false );
        
    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_button3" );

    ObjAnimate( "obj_steeringwheel_wires", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    ObjAnimate( "spr_steeringwheel_radiobutton", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "txt_steeringwheel_radio_sighn_2", "alp", 0, 0, "",
    { 
      0.0, 0, 1, 
      0.3, 0, 0.0
    } );

    ObjAnimate( "spr_steeringwheel_radio_sighn_1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_screwdriverext_2 ()

  local item = "inv_screwdriverext";

  if ( cmn.ApplyObj( item, "gzz_flightdeck_panelext", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_panelext" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_panelext_use_screwdriverext", true ) ) then

    cmn.CallEventHandler( "use_screwdriverext_2_inv" );
    cmn.CallEventHandler( "use_screwdriverext_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_screwdriverext_2" );
      cmn.CallEventHandler( "use_screwdriverext_2_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_openpanel" );
    
    VidPlay( "vid_panelext_use_screwdriver", 
    function () 
      ObjAnimate( "obj_panelext_close", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );

      ObjAnimate( "obj_panelext_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
    end );    

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_gloveext ()

  local item = "inv_gloveext";

  if ( cmn.ApplyObj( item, "gzz_flightdeck_panelext", false ) and 
       cmn.IsEventDone( "use_screwdriverext_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_panelext" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_panelext_use_gloveext", true ) and
           cmn.IsEventDone( "use_screwdriverext_2" ) ) then

    cmn.CallEventHandler( "use_gloveext_inv" );
    cmn.CallEventHandler( "use_gloveext_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_gloveext" );
      cmn.CallEventHandler( "use_gloveext_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_gloves" );

    ObjAnimate( "spr_panelext_glove", "pos_xy", 0, 0, func_end,
    { 
      0.0, 3, -346, 140, 
      0.6, 3, -15, 17,
      0.9, 3, -15, 17,
      1.5, 3, -346, 140, 
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_bandage ()

  local item = "inv_bandage";

  if ( cmn.ApplyObj( item, "gzz_flightdeck_panelext", false ) and
       cmn.IsEventDone( "use_gloveext" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_panelext" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_panelext_use_bandage", true ) and
           cmn.IsEventDone( "use_gloveext" )) then

    cmn.CallEventHandler( "use_bandage_inv" );
    cmn.CallEventHandler( "use_bandage_beg" );
    int.Lock( true );

    local func_end = function ()
    
      local func_end = function ()
      
        cmn.SetEventDone( "use_bandage" );
        cmn.CallEventHandler( "use_bandage_end" );
        int.Lock( false );
        
      end;              
         
      ObjAnimate( "vid_panelext_use_bandage", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );      
      ObjAnimate( "anm_zz_panelext_fog", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      ObjAnimate( "anm_zz_panelext_sparks", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      ObjAnimate( "spr_panelext_radiobutton_shadow", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      ObjAnimate( "spr_panelext_radiobutton", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      ObjAnimate( "spr_panelext_wire", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
      ObjAnimate( "spr_panelext_crocked", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

    end;

    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_tape" );
    ObjSet( "vid_panelext_use_bandage", { alp = 1 } );
    VidPlay( "vid_panelext_use_bandage", func_end );    

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_caduceus_1 ()

  local item = "inv_caduceus_1";

  if ( cmn.ApplyObj( item, "gzz_flightdeck_firstaidkit", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_firstaidkit" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_firstaidkit_use_caduceus_1", true ) ) then

    cmn.CallEventHandler( "use_caduceus_1_inv" );
    cmn.CallEventHandler( "use_caduceus_1_beg" );
    int.Lock( true );

    local func_end = function ()
    
      local func_end = function ()
      
        cmn.SetEventDone( "use_caduceus_1" );
        cmn.CallEventHandler( "use_caduceus_1_end" );
        int.Lock( false );
        
      end;
           
      if cmn.IsEventDone( "use_caduceus_2" ) then
        
        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_opencasket" );
        
        ObjAnimate( "spr_firstaidkit_caduceus_1", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 1.0,
          0.6, 0, 0.0,
        } );
        
        ObjAnimate( "spr_firstaidkit_caduceus_2", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 1.0,
          0.6, 0, 0.0,
        } );
        
        ObjAnimate( "obj_firstaidkit_open_firstaidkit", "alp", 0, 0, func_end,
        { 
          0.0, 0, 0.0, 
          0.3, 0, 0.0,
          0.6, 0, 1.0,
        } ); 
        
      else 
        
        func_end();
        
      end;

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_snake" );

    ObjAnimate( "spr_firstaidkit_caduceus_1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_caduceus_2 ()

  local item = "inv_caduceus_2";

  if ( cmn.ApplyObj( item, "gzz_flightdeck_firstaidkit", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_firstaidkit" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_firstaidkit_use_caduceus_2", true ) ) then

    cmn.CallEventHandler( "use_caduceus_2_inv" );
    cmn.CallEventHandler( "use_caduceus_2_beg" );
    int.Lock( true );

    local func_end = function ()
    
      local func_end = function ()
      
        cmn.SetEventDone( "use_caduceus_2" );
        cmn.CallEventHandler( "use_caduceus_2_end" );
        int.Lock( false );
        
      end;
           
      if cmn.IsEventDone( "use_caduceus_1" ) then
        
        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_opencasket" );

        ObjAnimate( "spr_firstaidkit_caduceus_1", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 1.0,
          0.6, 0, 0.0,
        } );
        
        ObjAnimate( "spr_firstaidkit_caduceus_2", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 1.0,
          0.6, 0, 0.0,
        } );
        
        ObjAnimate( "obj_firstaidkit_open_firstaidkit", "alp", 0, 0, func_end,
        { 
          0.0, 0, 0.0, 
          0.3, 0, 0.0,
          0.6, 0, 1.0,
        } ); 
        
      else 
        
        func_end();
        
      end;
      
    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_snake" );

    ObjAnimate( "spr_firstaidkit_caduceus_2", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_wrenchext ()

  local item = "inv_wrenchext";

  if ( cmn.ApplyObj( item, "gzz_flightdeck_firstaidkit", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_firstaidkit" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_firstaidkit_use_wrenchext", true ) ) then

    cmn.CallEventHandler( "use_wrenchext_inv" );
    cmn.CallEventHandler( "use_wrenchext_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_wrenchext" );
      cmn.CallEventHandler( "use_wrenchext_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_flightdeck_unscrew" );
    VidPlay( "vid_firstaidkit_use_wrenchext",
    function ()

      ObjAnimate( "vid_firstaidkit_use_wrenchext", "alp", 0, 0, func_end, 
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

    end );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
private.clk_steeringwheel_flag = 0;
-------------------------------------------------
function private.clk_steeringwheel ()

  local func_end = function ()
  
    cmn.CallEventHandler( "clk_steeringwheel_end" );
    cmn.CallEventHandler( "clk_steeringwheel" );
    
    private.clk_steeringwhee_flag = 1;
    
    int.Lock( false );
    cmn.CloseSubRoom();

  end;

  cmn.CallEventHandler( "clk_steeringwheel_beg" );   

  int.Lock( true );

  func_end();

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_radiobutton ()

  local func_end = function ()
  
    cmn.CallEventHandler( "clk_radiobutton_end" );
    cmn.CallEventHandler( "clk_radiobutton" );
    
    int.Lock( false );

  end;

  cmn.CallEventHandler( "clk_radiobutton_beg" );

  int.Lock( true );

  local func_end = function ()
  
    cmn.SetEventDone( "clk_radiobutton" );
    cmn.CallEventHandler( "clk_radiobutton_end" );
    int.Lock( false );
    
  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_lilexplode" );
  
  ObjDelete( "spr_steeringwheel_radio_sighn_1" );
  ObjDelete( "spr_steeringwheel_radiobutton" );
  ObjSet( "anm_steeringwheel_use_radiobutton", { alp = 1 } );
  AnimPlay( "anm_steeringwheel_use_radiobutton", "DoAnim", func_end ); 
  ObjStopAnimate( "spr_steeringwheel_radio_add", "alp" );
  ObjSet( "spr_steeringwheel_radio_add", { alp = 0 } );
    
end;
-------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_flightdeck ()

  if not ( cmn.IsEventDone( "opn_flightdeck" ) ) then

    cmn.SetEventDone( "opn_flightdeck" );
    cmn.ShowBbt( "bbt_flightdeck_first_open" );
    
    int_dialog_task.UpdateHourglassStage( false );
    ng_global.progress[ "ext" ][ "opn_flightdeck" ].see_hourglass4 = 0;
    
    cmn.PlayAudio( "mus", "audio/aud_grave_mus" );

  end;
  
  if ( cmn.IsEventDone( "win_hofridge" ) ) then
    
    local func_end = function ()
    
      ng_global.progress[ "ext" ][ "opn_flightdeck" ].crack = true;
      
    end;
    
    if not ng_global.progress[ "ext" ][ "opn_flightdeck" ].crack then 
      
      AnimPlay("anm_flightdeck_crack_appear", "DoAnim", func_end );
      
    else   
      
      ObjSet( "spr_flightdeck_glass_crack", { alp = 1 } );  
      
    end;
    
    ObjSet( "anm_flightdeck_plane_fire", { alp = 1 } );  
    
  end;

  if ( cmn.IsEventDone( "use_amuletwatch" ) and not cmn.IsEventDone( "clk_steeringwheel" ) ) then

    private.clk_steeringwhee_flag = 1;
    zz_steeringwheel.Close();

  end;

end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_flightdeck();
  
  cmn.StopAllEnv( "audio/level4/env/aud_flightdeck_env", true );
  cmn.PlayAudio( "env", "audio/level4/env/aud_flightdeck_env", 1, 2.5 );
  
  if ( cmn.IsEventDone( "win_hofridge" ) ) and ( ng_global.progress[ "ext" ][ "opn_flightdeck" ].see_hourglass4 == 0 ) then
    int_dialog_task.UpdateHourglassStage( false );
    ng_global.progress[ "ext" ][ "opn_flightdeck" ].see_hourglass4 = 1;
  end;

end;
--*********************************************************************************************************************
function public.Task ()
  
  int.AddedTaskMap( private.room_objname, "get_phonenumber_2",                                  { "clk_radiobutton" } );
  int.AddedTaskMap( private.room_objname, "get_swissknife" );
  int.AddedTaskMap( private.room_objname, "get_batteryext_2" );
  int.AddedTaskMap( private.room_objname, "get_phonenumber_1",                                  { "use_screwdriverext_2" } );
  int.AddedTaskMap( private.room_objname, "get_radiobutton",                                    { "use_bandage" } );
  int.AddedTaskMap( private.room_objname, "get_batteryext_1",                                   { "use_screwdriverext_2" } );
  int.AddedTaskMap( private.room_objname, "get_gloveext",                                       { "use_caduceus_1","use_caduceus_2" } );
  int.AddedTaskMap( private.room_objname, "get_bandage",                                        { "use_caduceus_1","use_caduceus_2" } );
  int.AddedTaskMap( private.room_objname, "get_bulbext",                                        { "use_wrenchext" } );
  
  int.AddedTaskMap( private.room_objname, "use_amuletwatch",                                    { "win_hofridge" } );
  int.AddedTaskMap( private.room_objname, "use_radiobutton",                                    { "get_radiobutton" } );
  int.AddedTaskMap( private.room_objname, "use_screwdriverext_2",                               { "clk_sparekey","get_screwdriverext" } );
  int.AddedTaskMap( private.room_objname, "use_gloveext",                                       { "get_gloveext" } );
  int.AddedTaskMap( private.room_objname, "use_bandage",                                        { "use_gloveext","get_bandage" } );
  int.AddedTaskMap( private.room_objname, "use_caduceus_1",                                     { "get_caduceus_1" } );
  int.AddedTaskMap( private.room_objname, "use_caduceus_2",                                     { "get_caduceus_2" } );
  int.AddedTaskMap( private.room_objname, "use_wrenchext",                                      { "get_wrenchext" } );
  
  int.AddedTaskMap( private.room_objname, "clk_radiobutton",                                    { "use_radiobutton" } );
  int.AddedTaskMap( private.room_objname, "clk_steeringwheel",                                  { "use_amuletwatch" } );  
    
end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_steeringwheel" );
  -------------------------------------------------
  function zz_steeringwheel.Close ()

    if ( not cmn.IsEventDone( "clk_steeringwheel" ) and
         private.clk_steeringwhee_flag == 1 ) then

      local func_end = function ()

        int.Lock( false );
        private.dlg_flightdeck_atropos_4_show();
        cmn.StopAudio( "sfx", "audio/level4/sfx/aud_flightdeck_crash_sfx" );  
        --cmn.StopAudio( "voc", "audio/level1/voc/aud_intro_voc" );
        --cmn.PlayAudio( "env", "audio/level1/env/aud_bypolicestation_env", 1 );

      end;

      int.Lock( true );

      common_impl.PlayDialogVideo( "vid_flightdeck_crash", func_end );  
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_flightdeck_crash_sfx" );  
      --cmn.PlayAudio( "voc", "audio/level1/voc/aud_intro_voc" );

    end;

  end;
  -------------------------------------------------

end;
--*********************************************************************************************************************
function private.Anims ()

  ObjAnimate( "obj_flightdeck_hub", "scale_xy", 1, 0, "", 
  {
    0.00, 3, 1.00, 1.00,
    2.00, 3, 1.00, 1.00,
    2.10, 3, 1.05, 1.05,
    2.60, 3, 1.05, 1.05,
    2.90, 3, 1.00, 1.00,
    16.0, 3, 1.00, 1.00,
  } );
  
  ObjAnimate( "spr_flightdeck_chair1", "scale_xy", 1, 0, "", 
  {
    0.00, 3, 1.00, 1.00,
    2.00, 3, 1.00, 1.00,
    2.10, 3, 1.02, 1.02,
    2.60, 3, 1.02, 1.02,
    2.90, 3, 1.00, 1.00,
    16.0, 3, 1.00, 1.00,
  } );
  
   ObjAnimate( "spr_flightdeck_chair2", "scale_xy", 1, 0, "", 
  {
    0.00, 3, 1.00, 1.00,
    2.00, 3, 1.00, 1.00,
    2.10, 3, 1.02, 1.02,
    2.60, 3, 1.02, 1.02,
    2.90, 3, 1.00, 1.00,
    16.0, 3, 1.00, 1.00,
  } ); 
  
    ObjAnimate( "spr_flightdeck_chair2", "ang", 1, 0, "", 
  {
    0.00, 3, 0,
    2.00, 3, 0,
    2.10, 3, -0.01,
    2.60, 3, -0.01, 
    2.90, 3, 0,
    16.0, 3, 0,
  } );
  
  ObjAnimate( "obj_flightdeck_hub", "pos_y", 1, 0, "", 
  {
    0.00, 3,  0,
    2.00, 3,  0,
    2.10, 3, 18,
    2.20, 3,  0,
    2.30, 3, 18,
    2.40, 3,  0,
    2.50, 3, 18,
    2.60, 3,  0,
    16.0, 3,  0,
  } );
  
  ObjAnimate( "anm_flightdeck_wires_left", "pos_x", 1, 0, "", 
  {
    0.00, 3,  -624,
    2.00, 3,  -624,
    2.10, 3,  -640,
    2.20, 3,  -624,
    2.30, 3,  -640,
    2.40, 3,  -624,
    2.50, 3,  -640,
    2.60, 3,  -624,
    16.0, 3,  -624,
  } );
  
    ObjAnimate( "anm_flightdeck_wires_right", "pos_x", 1, 0, "", 
  {
    0.00, 3,  -619,
    2.00, 3,  -619,
    2.10, 3,  -600,
    2.20, 3,  -619,
    2.30, 3,  -600,
    2.40, 3,  -619,
    2.50, 3,  -600,
    2.60, 3,  -619,
    16.0, 3,  -619,
  } );
  
  ObjAnimate( "spr_flightdeck_back", "scale_xy", 1, 0, "", 
  {
    0.00, 3, 1.00, 1.00,
    2.00, 3, 1.00, 1.00,
    2.10, 3, 1.05, 1.05,
    2.60, 3, 1.05, 1.05,
    2.90, 3, 1.00, 1.00,
    16.0, 3, 1.00, 1.00,
  } );

  ObjAnimate( "spr_flightdeck_back", "pos_y", 1, 0, "", 
  {
    0.00, 3,  0,
    2.00, 3,  0,
    2.10, 3, 18,
    2.20, 3,  0,
    2.30, 3, 18,
    2.40, 3,  0,
    2.50, 3, 18,
    2.60, 3,  0,
    16.0, 3,  0,
  } );
  
  ObjAnimate( "spr_flightdeck_wires_1", "pos_x", 1, 0, "", 
  {
    0.00, 3, 192,
    1.00, 3, 180,
    2.00, 3, 192,
  } );

  ObjAnimate( "spr_flightdeck_wires_4", "pos_x", 1, 0, "", 
  {
    0.00, 3, -290,
    1.40, 3, -315,
    2.80, 3, -290,
  } );

  ObjAnimate( "spr_flightdeck_alarm", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    0.3, 3, 0.0,
    0.6, 3, 1.0,
  } );
  
  ObjAnimate( "spr_flightdeck_light_add", "alp", 1, 0, "", 
  {
    0.0, 3, 0.5,
    0.4, 3, 1.0,
    0.8, 3, 0.5,
  } );
  
  ObjAnimate( "spr_flightdeck_flare", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_flightdeck_panel_lights", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    1.5, 3, 1.0,
    1.6, 3, 0.3,
    1.7, 3, 1.0,
    1.8, 3, 0.3,
    1.9, 3, 1.0,
    7.0, 3, 1.0,
  } );

  ObjAnimate( "spr_flightdeck_lighting_1", "alp", 1, 0, "", 
  {
    0.0, 3, 0.0,
    2.3, 3, 0.0,
    2.4, 3, 1.3,
    2.5, 3, 0.0,
    9.8, 3, 0.0,
  } );

  ObjAnimate( "spr_flightdeck_lighting_2", "alp", 1, 0, "", 
  {
    0.0,  3, 0.0,
    5.3,  3, 0.0,
    5.4,  3, 1.3,
    5.5,  3, 0.0,
    16.0, 3, 0.0,
  } );

  ObjAnimate( "spr_flightdeck_window_light", "alp", 1, 0, "", 
  {
    0.0,  3, 0.0,
    5.3,  3, 0.0,
    5.4,  3, 1.3,
    5.5,  3, 0.0,
    16.0, 3, 0.0,
  } );

  ObjAnimate( "spr_flightdeck_lighting_3", "alp", 1, 0, "", 
  {
    0.0, 3, 0.0,
    4.0, 3, 0.0,
    4.1, 3, 1.3,
    4.2, 3, 0.0,
    8.0, 3, 0.0,
  } );

  ObjAnimate( "spr_flightdeck_window_light_right", "alp", 1, 0, "", 
  {
    0.0, 3, 0.0,
    4.0, 3, 0.0,
    4.1, 3, 1.3,
    4.2, 3, 0.0,
    8.0, 3, 0.0,
  } );

  ObjAnimate( "spr_flightdeck_wall_fire_1", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.0, 3, 1.0,
    4.0, 3, 0.3,
  } );

  ObjAnimate( "spr_flightdeck_wall_fire_2", "alp", 1, 0, "", 
  {
    0.0, 3, 0.5,
    0.9, 3, 1.0,
    1.8, 3, 0.5,
  } );

  ObjAnimate( "spr_flightdeck_wall_fire_3", "alp", 1, 0, "", 
  {
    0.0, 3, 0.4,
    1.4, 3, 1.0,
    2.8, 3, 0.4,
  } );

  ObjAnimate( "spr_flightdeck_wall_fire_4", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    1.1, 3, 0.2,
    2.2, 3, 1.0,
  } );

  ObjAnimate( "spr_flightdeck_monitor_noize_big", "alp", 1, 0, "", 
  {
    0.0, 3, 0.0,
    2.2, 3, 0.0,
    2.3, 3, 1.0,
    2.6, 3, 1.0,
    2.7, 3, 0.0,
    6.8, 3, 0.0,
  } );

  ObjAnimate( "spr_flightdeck_monitor_noize", "alp", 1, 0, "", 
  {
    0.0, 3, 0.0,
    2.9, 3, 0.0,
    3.1, 3, 1.0,
    3.3, 3, 1.0,
    3.4, 3, 0.0,
    3.6, 3, 1.0,
    3.7, 3, 0.0,
    9.9, 3, 0.0,
  } );

  ObjAnimate( "obj_flightdeck_animhub_1", "pos_y", 1, 0, "", 
  {
    0.0, 3, 384,
    2.0, 3, 404,
    4.0, 3, 384,
  } );
  
  ObjAnimate( "obj_flightdeck_animhub_2", "pos_y", 1, 0, "", 
  {
    0.0, 3, 384,
    2.0, 3, 404,
    4.0, 3, 384,
  } );

  ObjAnimate( "spr_steeringwheel_radio_add", "alp", 1, 0, "", 
  {
    0.0, 3, 1,
    1.5, 3, 0.4,
    3.0, 3, 1,
  } );

  ObjAnimate( "spr_steeringwheel_add_light", "alp", 1, 0, "", 
  {
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1,
  } );

  ObjAnimate( "spr_steeringwheel_monitors_add", "alp", 1, 0, "", 
  {
    0.0, 3, 1,
    1.5, 3, 0.5,
    3.0, 3, 1,
  } );

  ObjAnimate( "spr_steeringwheel_clock_add", "alp", 1, 0, "", 
  {
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1,
  } );

  ObjAnimate( "spr_steeringwheel_green_button", "alp", 1, 0, "", 
  {
    0.0, 3, 1,
    0.5, 3, 0,
    1.0, 3, 1,
  } );

  ObjAnimate( "spr_panelext_add_light", "alp", 1, 0, "", 
  {
    0.0, 3, 1,
    1.5, 3, 0.5,
    3.0, 3, 1,
  } );

  ObjAnimate( "spr_panelext_add_light_2", "alp", 1, 0, "", 
  {
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1,
  } );
  
  ObjAnimate( "spr_firstaidkit_add_light_2", "alp", 1, 0, "", 
  {
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1,
  } );
  
  ObjAnimate( "spr_firstaidkit_add_light", "alp", 1, 0, "", 
  {
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1,
  } );
  
  ObjAnimate( "spr_firstaidkit_lamp_add", "alp", 1, 0, "", 
  {
    0.0, 3, 1,
    0.4, 3, 0.5,
    0.8, 3, 1,
  } );
  
  ObjAnimate( "spr_flightdeck_window_light_right_alp", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    1.1, 3, 0.5,
    2.2, 3, 0.3,
  } );
  
    ObjAnimate( "spr_flightdeck_window_light_alp", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    1.1, 3, 0.5,
    2.2, 3, 0.3,
  } );
  
  ObjAnimate( "spr_steeringwheel_radio_button_add", "alp", 1, 0, "", 
  {
    0.0, 3, 0,
    1.5, 3, 1,
    3.0, 3, 0,
  } );
  
end;
--*********************************************************************************************************************
function private.clk_wires ()

  local func_end = function ()
    cmn.ShowBbt( "bbt_steeringwheel_use_radiobutton" );
    int.Lock( false );
  end;

  int.Lock( true );
  ObjAnimate( "obj_steeringwheel_wire1", "ang", 0, 0, "", 
  { 
    0.0, 0, 0,
    0.3, 0, -0.33,
    0.6, 0, 0,
  } );
  ObjAnimate( "obj_steeringwheel_wire2", "ang", 0, 0, func_end, 
  { 
    0.0, 0, 0,
    0.3, 0, 0.42,
    0.6, 0, 0,
  } );

end;
--*********************************************************************************************************************
function private.ClkPanel ()

  local func_end = function ()
  
    cmn.ShowBbt( "bbt_panelext_use_screwdriverext" );
    int.Lock( false );
    
  end;

  int.Lock( true );
  
  ObjAnimate( "spr_panelext_cover", "scale_xy", 0, 0, func_end, 
  { 
    0.0, 0, 1,1,
    0.2, 0, 1.005,1.005,
    0.4, 0, 1,1,
    0.6, 0, 1.005,1.005,
    0.8, 0, 1,1,
  } );
  
  ObjAnimate( "spr_panelext_cover", "pos_x", 0, 0, "", 
  { 
    0.0, 0, -20,
    0.2, 0, -21,
    0.4, 0, -20,
    0.6, 0, -21,
    0.8, 0, -20
  } );
  
end;
--*********************************************************************************************************************
function private.clk_chains ()

  local func_end = function ()
  
    AnimStop( "anm_steeringwheel_wheel_static"); 
    AnimPlay( "anm_steeringwheel_wheel_static", "DoAnim", "" ); 
    ObjSet( "anm_steeringwheel_wheel_static", { alp = 1 } );
    ObjSet( "anm_steeringwheel_wheel_click", { alp = 0 } );
    cmn.ShowBbt( "bbt_steeringwheel_use_amuletwatch" );

    int.Lock( false );
    
  end;
  
  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_wheel_xx" );
  
  ObjSet( "anm_steeringwheel_wheel_static", { alp = 0 } );
  ObjSet( "anm_steeringwheel_wheel_click", { alp = 1 } );
  AnimPlay( "anm_steeringwheel_wheel_click", "DoAnim", func_end ); 
  
end;
--*********************************************************************************************************************
