-- name=rm_kitchenext
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_kitchenext";

  ObjAttach( "zz_flowerext", "room_hub" );
  ObjAttach( "zz_phoenix",   "room_hub" );
  ObjAttach( "zz_roaster",   "room_hub" );
  
  ObjMultiSet(
  {
    { "spr_flowerext_roomkeyext",      { event_mdown = private.get_roomkeyext } },
    { "spr_flowerext_tongsext",        { event_mdown = private.get_tongsext } },    
    { "spr_flowerext_tombstonepart_1", { event_mdown = private.get_tombstonepart_1 } },
    { "spr_phoenix_bowl_2",            { event_mdown = private.get_bowl_2 } },
    { "spr_phoenix_bells",             { event_mdown = private.get_bells } },
    { "spr_roaster_chain",             { event_mdown = private.get_chain } },
    { "spr_phoenix_collect2_4_2",      { event_mdown = private.get_collect2_4_2 } },
    { "obj_roaster_use_fileext",       { event_mdown = private.RoasterChainClick } },
    { "obj_phoenix_use_phoenixfeather",{ event_mdown = private.PhoenixClick } },
    { "obj_phoenix_clk_leg",           { event_mdown = private.PhoenixClickLeg } },
    { "obj_phoenix_use_heart",         { event_mdown = private.PhoenixClickNoLeg } },
    { "obj_kitchenext_use_flute",      { event_mdown = private.DogClick } },    
  } );

  private.InitSubroom();
  private.InitPhoenix();
  private.InitAnims();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_kitchenext = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gzz_kitchenext_flowerext",
        "gzz_kitchenext_phoenix",
        "gzz_kitchenext_roaster",
        "gmg_kitchenext_lulling"
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_flowerext", 
        "zz_phoenix", 
        "zz_roaster",
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_kitchenext", update_game_mode_kitchenext, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_roomkeyext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_roomkeyext" ] =
  {
    type = "get",
    get_obj = "spr_flowerext_roomkeyext",
    room = private.room_objname,
    zz = "zz_flowerext",
    zz_gate = "gzz_kitchenext_flowerext"
  };
  -----------------------------------------------
  local get_roomkeyext_inv = function ()

    int.InventoryItemAdd( "inv_roomkeyext", "spr_flowerext_roomkeyext" );

  end;

  local get_roomkeyext_closezz = function ()

    ObjDelete( "gfx_flowerext_roomkeyext" );
    ObjDelete( "spr_flowerext_roomkeyext_hotspot" );
    ObjDelete( "spr_kitchenext_flowerext_key" );

  end;

  cmn.AddSubscriber( "get_roomkeyext", get_roomkeyext_inv );
  cmn.AddSubscriber( "get_roomkeyext", get_roomkeyext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tongsext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tongsext" ] =
  {
    type = "get",
    get_obj = "spr_flowerext_tongsext",
    room = private.room_objname,
    zz = "zz_flowerext",
    zz_gate = "gzz_kitchenext_flowerext"
  };
  -----------------------------------------------
  local get_tongsext_inv = function ()

    int.InventoryItemAdd( "inv_tongsext", "spr_flowerext_tongsext" );

  end;

  local get_tongsext_closezz = function ()

    ObjDelete( "gfx_flowerext_tongsext" );
    ObjDelete( "spr_flowerext_tongsext_shadow" );
    ObjDelete( "spr_kitchenext_flowerext_tongs" );

  end;

  cmn.AddSubscriber( "get_tongsext", get_tongsext_inv );
  cmn.AddSubscriber( "get_tongsext", get_tongsext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tombstonepart_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tombstonepart_1" ] =
  {
    type = "get",
    get_obj = "spr_flowerext_tombstonepart_1",
    room = private.room_objname,
    zz = "zz_flowerext",
    zz_gate = "gzz_kitchenext_flowerext"
  };
  -----------------------------------------------
  local get_tombstonepart_1_inv = function ()

    int.InventoryItemAdd( "inv_tombstonepart_1", "spr_flowerext_tombstonepart_1" );

    if ( cmn.IsEventDone( "get_tombstonebasis" ) ) then

      ObjSet( "inv_tombstonebasis_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_tombstonepart_1_closezz = function ()

    ObjDelete( "gfx_flowerext_tombstonepart_1" );
    ObjDelete( "spr_flowerext_tombstonepart_1_shadow" );
    ObjDelete( "spr_kitchenext_flowerext_stone" );
    
    if ( cmn.IsEventDone( "get_hookext" ) ) then
    
      ObjDelete( "gzz_kitchenext_flowerext" );

    end;

  end;

  cmn.AddSubscriber( "get_tombstonepart_1", get_tombstonepart_1_inv );
  cmn.AddSubscriber( "get_tombstonepart_1", get_tombstonepart_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hookext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hookext" ] =
  {
    type = "get",
    get_obj = "spr_flowerext_hookext",
    room = private.room_objname,
    zz = "zz_flowerext",
    zz_gate = "gzz_kitchenext_flowerext"
  };
  -----------------------------------------------
  local get_hookext_inv = function ()

    int.InventoryItemAdd( "inv_hookext", "spr_flowerext_hookext" );
    ObjSet( "inv_hookext", { drag = false } );
    if not cmn.IsEventDone( "get_chain" ) then
      ObjSet( "inv_hookext_plus_focus2", { alp = 0 } );
    end;

  end;

  local get_hookext_closezz = function ()

    ObjDelete( "spr_flowerext_hookext_shadow" );
    ObjDelete( "spr_kitchenext_flowerext_hook" );
    
    if ( cmn.IsEventDone( "get_tombstonepart_1" ) ) then
    
      ObjDelete( "gzz_kitchenext_flowerext" );

    end;
      
  end;

  cmn.AddSubscriber( "get_hookext", get_hookext_inv );
  cmn.AddSubscriber( "get_hookext", get_hookext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bowl_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bowl_2" ] =
  {
    type = "get",
    get_obj = "spr_phoenix_bowl_2",
    room = private.room_objname,
    zz = "zz_phoenix",
    zz_gate = "gzz_kitchenext_phoenix"
  };
  -----------------------------------------------
  local get_bowl_2_inv = function ()

    int.InventoryItemAdd( "inv_bowl_2", "spr_phoenix_bowl_2" );

  end;

  local get_bowl_2_closezz = function ()

    ObjDelete( "gfx_phoenix_bowl_2" );
    ObjDelete( "spr_kitchenext_phoenix_bowl" );
    --ObjDelete( "gzz_kitchenext_phoenix" );

  end;

  cmn.AddSubscriber( "get_bowl_2", get_bowl_2_inv );
  cmn.AddSubscriber( "get_bowl_2", get_bowl_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bells () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bells" ] =
  {
    type = "get",
    get_obj = "spr_phoenix_bells",
    room = private.room_objname,
    zz = "zz_phoenix",
    zz_gate = "gzz_kitchenext_phoenix"
  };
  -----------------------------------------------
  local get_bells_inv = function ()

    int.InventoryItemAdd( "inv_bells", "spr_phoenix_bells" );

  end;

  local get_bells_closezz = function ()

    ObjDelete( "gfx_phoenix_bells" );
    ObjDelete( "spr_kitchenext_phoenix_bell" );
    
    if ( cmn.IsEventDone( "get_collect2_4_2" ) ) then
    
      ObjDelete( "gzz_kitchenext_phoenix" );

    end;

  end;

  cmn.AddSubscriber( "get_bells", get_bells_inv );
  cmn.AddSubscriber( "get_bells", get_bells_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_heart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_heart" ] =
  {
    type = "get",
    get_obj = "spr_roaster_heart",
    room = private.room_objname,
    zz = "zz_roaster",
    zz_gate = "gzz_kitchenext_roaster"
  };
  -----------------------------------------------
  local get_heart_inv = function ()

    int.InventoryItemAdd( "inv_heart", "spr_roaster_heart" );

  end;

  local get_heart_closezz = function ()
  
    ObjDelete( "spr_kitchenext_roaster_heart" );

  end;

  cmn.AddSubscriber( "get_heart", get_heart_inv );
  cmn.AddSubscriber( "get_heart", get_heart_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_chain () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chain" ] =
  {
    type = "get",
    get_obj = "obj_roaster_chain_hint",
    room = private.room_objname,
    zz = "zz_roaster",
    zz_gate = "gzz_kitchenext_roaster"
  };
  -----------------------------------------------
  local get_chain_inv = function ()

    int.InventoryItemAdd( "inv_chain", "spr_roaster_chain" );
    
    if cmn.IsEventDone( "get_hookext" ) then

      ObjSet( "inv_hookext_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_chain_closezz = function ()

    ObjDelete( "gzz_kitchenext_roaster" );
    ObjDelete( "spr_kitchenext_roaster_chain" );

  end;

  cmn.AddSubscriber( "get_chain", get_chain_inv );
  cmn.AddSubscriber( "get_chain", get_chain_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect2_4_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect2_4_2 = function ()

    ObjDelete( "spr_phoenix_collect2_4_2" );

    if ( cmn.IsEventDone( "get_bells" ) ) then

      ObjDelete( "gzz_kitchenext_phoenix" );

    end;
    
  end;

  cmn.AddSubscriber( "get_collect2_4_2", get_collect2_4_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_4_5 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_4_5 = function ()

    ObjDelete( "obj_kitchenext_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_4_5", get_morphobject_4_5, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_herbicide () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_herbicide" ] =
  {
    type = "use",
    use_obj = "inv_herbicide",
    use_place = "obj_flowerext_use_herbicide",
    room = private.room_objname,
    zz = "zz_flowerext",
    zz_gate = "gzz_kitchenext_flowerext"
  };
  -----------------------------------------------
  local use_herbicide_inv = function ()

    int.InventoryItemRemove( "inv_herbicide" );

  end;
  local use_herbicide_beg = function ()

    ObjDelete( "obj_flowerext_use_herbicide" );

  end;
  local use_herbicide_end = function ()

    ObjSet( "obj_flowerext_flower",                 { alp = 1, input = true, active = true } );
    ObjSet( "obj_flowerext_use_fileext",            { input = true } );
    ObjSet( "spr_kitchenext_flowerext_flower2",     { alp = 1 } );
    ObjDelete( "spr_kitchenext_flowerext_flower1" );
    ObjDelete( "anm_flowerext_flower" );
    ObjDelete( "anm_flowerext_herbicide" );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_herbicide", use_herbicide_beg, private.room_objname );
  cmn.AddSubscriber( "use_herbicide", use_herbicide_inv );
  cmn.AddSubscriber( "use_herbicide", use_herbicide_end, private.room_objname );
  cmn.AddSubscriber( "use_herbicide_inv", use_herbicide_inv, private.room_objname );
  cmn.AddSubscriber( "use_herbicide_beg", use_herbicide_beg, private.room_objname );
  cmn.AddSubscriber( "use_herbicide_end", use_herbicide_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fileext_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fileext_2" ] =
  {
    type = "use",
    use_obj = "inv_fileext",
    use_place = "obj_flowerext_use_fileext",
    room = private.room_objname,
    zz = "zz_flowerext",
    zz_gate = "gzz_kitchenext_flowerext"
  };
  -----------------------------------------------
  local use_fileext_2_inv = function ()

    if ( cmn.IsEventDone( "use_fileext_1" ) ) then
  
      int.InventoryItemRemove( "inv_fileext" );
      
    end;

  end;
  local use_fileext_2_beg = function ()

    ObjDelete( "obj_flowerext_use_fileext" );

  end;
  local use_fileext_2_end = function ()

    ObjDelete( "anm_flowerext_fileext" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_fileext_2", use_fileext_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_fileext_2", use_fileext_2_inv );
  cmn.AddSubscriber( "use_fileext_2", use_fileext_2_end, private.room_objname );
  cmn.AddSubscriber( "use_fileext_2_inv", use_fileext_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_fileext_2_beg", use_fileext_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_fileext_2_end", use_fileext_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_phoenixfeather () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_phoenixfeather" ] =
  {
    type = "use",
    use_obj = "inv_phoenixfeather",
    use_place = "obj_phoenix_use_phoenixfeather",
    room = private.room_objname,
    zz = "zz_phoenix",
    zz_gate = "gzz_kitchenext_phoenix"
  };
  -----------------------------------------------
  local use_phoenixfeather_inv = function ()

    int.InventoryItemRemove( "inv_phoenixfeather" );

  end;
  local use_phoenixfeather_beg = function ()

    ObjDelete( "obj_phoenix_use_phoenixfeather" );

  end;
  local use_phoenixfeather_end = function ()

    ObjSet( "spr_phoenix_feather_1", { alp = 1 } );
    ObjSet( "spr_phoenix_feather_2", { alp = 1 } );
    ObjSet( "spr_phoenix_feather_3", { alp = 1 } );    
    ObjSet( "obj_phoenix_mmg", { input = true } );
    ObjDelete( "anm_phoenix_feather" );
    
    ObjSet( "spr_kitchenext_phoenix_wing", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_phoenixfeather", use_phoenixfeather_beg, private.room_objname );
  cmn.AddSubscriber( "use_phoenixfeather", use_phoenixfeather_inv );
  cmn.AddSubscriber( "use_phoenixfeather", use_phoenixfeather_end, private.room_objname );
  cmn.AddSubscriber( "use_phoenixfeather_inv", use_phoenixfeather_inv, private.room_objname );
  cmn.AddSubscriber( "use_phoenixfeather_beg", use_phoenixfeather_beg, private.room_objname );
  cmn.AddSubscriber( "use_phoenixfeather_end", use_phoenixfeather_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_heart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_heart" ] =
  {
    type = "use",
    use_obj = "inv_heart",
    use_place = "obj_phoenix_use_heart",
    room = private.room_objname,
    zz = "zz_phoenix",
    zz_gate = "gzz_kitchenext_phoenix"
  };
  -----------------------------------------------
  local use_heart_inv = function ()

    int.InventoryItemRemove( "inv_heart" );

  end;
  local use_heart_beg = function ()

    ObjDelete( "obj_phoenix_use_heart" );

  end;
  local use_heart_end = function ()

    ObjSet( "obj_phoenix_open_beak", { alp = 1, input = true } );
    ObjSet( "gfx_phoenix_bowl_2", { active = true } );
    ObjSet( "spr_phoenix_heart", { alp = 1 } );
    ObjSet( "obj_phoenix_head", { alp = 1 } );
    ObjSet( "spr_kitchenext_phoenix_heart", { alp = 1 } );
    ObjSet( "spr_kitchenext_phoenix_beak", { alp = 1 } );
    ObjDelete( "spr_phoenix_bowl_2_closed" );
    ObjDelete( "anm_phoenix_head_open" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_heart", use_heart_beg, private.room_objname );
  cmn.AddSubscriber( "use_heart", use_heart_inv );
  cmn.AddSubscriber( "use_heart", use_heart_end, private.room_objname );
  cmn.AddSubscriber( "use_heart_inv", use_heart_inv, private.room_objname );
  cmn.AddSubscriber( "use_heart_beg", use_heart_beg, private.room_objname );
  cmn.AddSubscriber( "use_heart_end", use_heart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tongsext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tongsext" ] =
  {
    type = "use",
    use_obj = "inv_tongsext",
    use_place = "obj_roaster_use_tongsext",
    room = private.room_objname,
    zz = "zz_roaster",
    zz_gate = "gzz_kitchenext_roaster"
  };
  -----------------------------------------------
  local use_tongsext_inv = function ()

    int.InventoryItemRemove( "inv_tongsext" );

  end;
  local use_tongsext_beg = function ()

    ObjDelete( "obj_roaster_use_tongsext" );

  end;
  local use_tongsext_end = function ()

    ObjDelete( "amn_roaster_tongsext" );
    ObjSet( "amn_roaster_tongsext_end", { alp = 1 } );
  
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_tongsext", use_tongsext_beg, private.room_objname );
  cmn.AddSubscriber( "use_tongsext", use_tongsext_inv );
  cmn.AddSubscriber( "use_tongsext", use_tongsext_end, private.room_objname );
  cmn.AddSubscriber( "use_tongsext_inv", use_tongsext_inv, private.room_objname );
  cmn.AddSubscriber( "use_tongsext_beg", use_tongsext_beg, private.room_objname );
  cmn.AddSubscriber( "use_tongsext_end", use_tongsext_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fileext_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fileext_1" ] =
  {
    type = "use",
    use_obj = "inv_fileext",
    use_place = "obj_roaster_use_fileext",
    room = private.room_objname,
    zz = "zz_roaster",
    zz_gate = "gzz_kitchenext_roaster"
  };
  -----------------------------------------------
  local use_fileext_1_inv = function ()

    if ( cmn.IsEventDone( "use_fileext_2" ) ) then
  
      int.InventoryItemRemove( "inv_fileext" );
      
    end;

  end;
  local use_fileext_1_beg = function ()

    ObjDelete( "obj_roaster_use_fileext" );

  end;
  local use_fileext_1_end = function ()

    ObjDelete( "amn_roaster_chain" );    
    --ObjDelete( "amn_roaster_fileext" );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_fileext_1", use_fileext_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_fileext_1", use_fileext_1_inv );
  cmn.AddSubscriber( "use_fileext_1", use_fileext_1_end, private.room_objname );
  cmn.AddSubscriber( "use_fileext_1_inv", use_fileext_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_fileext_1_beg", use_fileext_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_fileext_1_end", use_fileext_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_flute () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_flute" ] =
  {
    type = "use",
    use_obj = "inv_flute",
    use_place = "obj_kitchenext_use_flute",
    room = private.room_objname
  };
  -----------------------------------------------
  local use_flute_inv = function ()

    int.InventoryItemRemove( "inv_flute" );

  end;
  local use_flute_beg = function ()

    ObjDelete( "obj_kitchenext_use_flute" );

  end;
  local use_flute_end = function ()

    ObjSet( "gmg_kitchenext_lulling", { active = true, input = true, alp = 1 } );
    ObjDelete( "anm_kitchenext_use_flute" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_flute", use_flute_beg, private.room_objname );
  cmn.AddSubscriber( "use_flute", use_flute_inv );
  cmn.AddSubscriber( "use_flute", use_flute_end, private.room_objname );
  cmn.AddSubscriber( "use_flute_inv", use_flute_inv, private.room_objname );
  cmn.AddSubscriber( "use_flute_beg", use_flute_beg, private.room_objname );
  cmn.AddSubscriber( "use_flute_end", use_flute_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_phoenix() end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_phoenix" ] =
  {
    room = private.room_objname,
    zz = "zz_phoenix",
    zz_gate = "gzz_kitchenext_phoenix"
  };
  --*********************************************************************************************************************
  local win_phoenix = function ()

    if ( cmn.IsEventDone( "win_phoenix" ) ) then
      
      for n=1, 8 do
        ObjSet( "spr_phoenix_feather_"..n, { 
          pos_x = private.coords[ n ][1],
          pos_y = private.coords[ n ][2],
          ang = 0 
        } );
      end;

      ObjSet( "obj_phoenix_paw", { alp = 1 } );
      ObjSet( "spr_phoenix_paw", { ang = -0.55 } );
      ObjSet( "spr_phoenix_bells", { input = true, alp = 1 } );
      ObjSet( "gfx_phoenix_bells", { active = true } );
      ObjSet( "obj_phoenix_mmg", { input = false } );
      ObjDelete( "anm_phoenix_paw_open" );
      ObjDelete( "obj_phoenix_clk_leg" );
      
    elseif ( cmn.IsEventStart( "win_phoenix" ) ) then

      private.LoadPhoenix();   

    end;

  end;

  cmn.AddSubscriber( "win_phoenix", win_phoenix, private.room_objname );
  --------------------------------------------------------------------------------------------
    -- function dlg_kitchenext_atropos_3 () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_kitchenext_atropos_3" ] =
  {
    type = "click",
    room = private.room_objname,
  };
  --*********************************************************************************************************************
    -----------------------------------------------
  local dlg_kitchenext_atropos_3 = function ()
  
   int.LockRoomMap( "kitchenext", 1 );
   int.LockRoomMap( "livingroomext", 1 );
   int.LockRoomMap( "basementext", 1 );
   ObjDelete( "vid_kitchenext_transfer" );
   
  end;
  -----------------------------------------------
  local dlg_kitchenext_atropos_3_beg = function ()
  end;
  -----------------------------------------------
  local dlg_kitchenext_atropos_3_end = function ()
  end;

  cmn.AddSubscriber( "dlg_kitchenext_atropos_3", dlg_kitchenext_atropos_3 );
  cmn.AddSubscriber( "dlg_kitchenext_atropos_3", dlg_kitchenext_atropos_3_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_kitchenext_atropos_3", dlg_kitchenext_atropos_3_end, private.room_objname );
  cmn.AddSubscriber( "dlg_kitchenext_atropos_3_beg", dlg_kitchenext_atropos_3_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_kitchenext_atropos_3_end", dlg_kitchenext_atropos_3_end, private.room_objname );
    --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
-------------------------------------------------
function private.dlg_kitchenext_atropos_3_show ()

  local func_end = function ()

    int.Lock( false );
    private.dlg_kitchenext_atropos_3();

    ObjSet( "anm_kitchenext_atropos_appearance", { alp = 0, playing = false, frame = 0 } );

  end;

  int.Lock( true );
  
  cmn.StopAllMus();
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_atropos_appearence" );

  ObjSet( "anm_kitchenext_atropos_appearance", { alp = 1 } );
  AnimPlay( "anm_kitchenext_atropos_appearance", "DoAnim", func_end );

end;
-------------------------------------------------
function private.dlg_kitchenext_atropos_3 ()

  local func_end = function ()
  
    private.PlaneTransfer();

    ObjSet( "anm_kitchenext_atropos_disappearance", { alp = 0, playing = false, frame = 0 } );
  
  end;

  local func_end_dialog = function ()

    int.Lock( true );
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_atropos_disappearence" );

    ObjSet( "anm_kitchenext_atropos_disappearance", { alp = 1 } );
    AnimPlay( "anm_kitchenext_atropos_disappearance", "DoAnim", func_end );

  end;

  ObjAttach( "dlg_kitchenext_atropos_3", "rm_kitchenext" );
  AnimPlay( "anm_kitchenext_atropos_3_halo", "DoAnim", "" );
  AnimPlay( "anm_kitchenext_atropos_3_darksmoke", "DoAnim", "" );
  AnimPlay( "anm_kitchenext_atropos_3_static1", "DoAnim", "" );    
  common_impl.dialog_character_loc = "anm_kitchenext_atropos_disappearance";
  private.dialog_voices_time = { 3 };

  common_impl.DialogCharacterStart( "atropos_3", 1, nil, nil, false, func_end_dialog );

  ObjSet( "tmr_kitchenext_fordial", { playing = 1, time = 0.3, endtrig = "" } );

end;
-------------------------------------------------
-------------------------------------------------
function private.get_roomkeyext ()

  cmn.SetEventDone( "get_roomkeyext" );
  cmn.CallEventHandler( "get_roomkeyext" );
  
  cmn.GetObjectSfx();

  if ( not cmn.IsEventDone( "get_tombstonepart_1" ) ) then
  
    private.get_tombstonepart_1();
    
  end;
  
end;
-------------------------------------------------
function private.get_tongsext ()

  cmn.SetEventDone( "get_tongsext" );
  cmn.CallEventHandler( "get_tongsext" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_tombstonepart_1 ()

  cmn.SetEventDone( "get_tombstonepart_1" );
  cmn.CallEventHandler( "get_tombstonepart_1" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_hookext" ) ) then
  
    cmn.CloseSubRoom();

  end;
    
end;
-------------------------------------------------
function private.get_hookext ()

  cmn.SetEventDone( "get_hookext" );
  cmn.CallEventHandler( "get_hookext" );
  
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_tombstonepart_1" ) ) then
  
    cmn.CloseSubRoom();

  end;
  
end;
-------------------------------------------------
function private.get_bowl_2 ()

  cmn.SetEventDone( "get_bowl_2" );
  cmn.CallEventHandler( "get_bowl_2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_bells ()

  cmn.SetEventDone( "get_bells" );
  cmn.CallEventHandler( "get_bells" );
  
  cmn.GetObjectSfx();
  
  if ( cmn.IsEventDone( "get_collect2_4_2" ) ) then
  
    cmn.CloseSubRoom();

  end;
    
end;
-------------------------------------------------
function private.get_heart ()

  cmn.SetEventDone( "get_heart" );
  cmn.CallEventHandler( "get_heart" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_chain ()

  cmn.SetEventDone( "get_chain" );
  cmn.CallEventHandler( "get_chain" );
  cmn.CloseSubRoom();
  cmn.GetObjectSfx();

end;
---------------------------------------------------------------------------------
function private.get_collect2_4_2()

  int.AddCollectibles2( "spr_phoenix_collect2_4_2" );
  
  if ( cmn.IsEventDone( "get_bells" ) ) then

    cmn.CloseSubRoom();

  end;
  
end;
--*********************************************************************************************************************
-------------------------------------------------
function public.use_herbicide ()

  local item = "inv_herbicide";

  if ( cmn.ApplyObj( item, "gzz_kitchenext_flowerext", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_flowerext" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_flowerext_use_herbicide", true ) ) then

    cmn.CallEventHandler( "use_herbicide_inv" );
    cmn.CallEventHandler( "use_herbicide_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_herbicide" );
      cmn.CallEventHandler( "use_herbicide_end" );
      int.Lock( false );

    end;

    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_acid2" );
    
    ObjSet( "anm_flowerext_flower",    { alp = 0 } );
    ObjSet( "anm_flowerext_herbicide", { alp = 1 } );

    AnimPlay( "anm_flowerext_herbicide", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_fileext_2 ()

  local item = "inv_fileext";

  if ( cmn.ApplyObj( item, "gzz_kitchenext_flowerext", false ) ) and
     ( cmn.IsEventDone( "use_herbicide" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_flowerext" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_flowerext_use_fileext", true ) ) and
         ( cmn.IsEventDone( "use_herbicide" ) ) then

    cmn.CallEventHandler( "use_fileext_2_inv" );
    cmn.CallEventHandler( "use_fileext_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_fileext_2" );
      cmn.CallEventHandler( "use_fileext_2_end" );
      int.Lock( false );

      private.get_hookext();
      
    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_hacksawhook" );

    AnimPlay( "anm_flowerext_fileext", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_phoenixfeather ()

  local item = "inv_phoenixfeather";

  if ( cmn.ApplyObj( item, "gzz_kitchenext_phoenix", false ) ) and
     ( cmn.IsEventDone( "get_phoenixfeather_1" ) ) and
     ( cmn.IsEventDone( "get_phoenixfeather_2" ) ) and
     ( cmn.IsEventDone( "get_phoenixfeather_3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_phoenix" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_phoenix_use_phoenixfeather", true ) ) and
         ( cmn.IsEventDone( "get_phoenixfeather_1" ) ) and
         ( cmn.IsEventDone( "get_phoenixfeather_2" ) ) and
         ( cmn.IsEventDone( "get_phoenixfeather_3" ) ) then

    cmn.CallEventHandler( "use_phoenixfeather_inv" );
    cmn.CallEventHandler( "use_phoenixfeather_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_phoenixfeather" );
      cmn.CallEventHandler( "use_phoenixfeather_end" );
      int.Lock( false );
      
      common_impl.PassingMgStart( "phoenix" );
      private.InitPhoenixStart();

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_feathers" );

    AnimPlay( "anm_phoenix_feather", "DoAnim", func_end );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_heart ()

  local item = "inv_heart";

  if ( cmn.ApplyObj( item, "gzz_kitchenext_phoenix", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_phoenix" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_phoenix_use_heart", true ) ) then

    cmn.CallEventHandler( "use_heart_inv" );
    cmn.CallEventHandler( "use_heart_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_heart" );
      cmn.CallEventHandler( "use_heart_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_hearttoeagle" );

    ObjAnimate("spr_phoenix_heart", "alp", 0, 0, 
    function ()
      ObjSet( "obj_phoenix_head", { alp = 0 } );
      ObjSet( "anm_phoenix_head_open", { alp = 1 } ); 
      AnimPlay( "anm_phoenix_head_open", "DoAnim", func_end );     
    end, 
    {
      0.0,0,0,
      0.3,0,1
    });    

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_tongsext ()

  local item = "inv_tongsext";

  if ( cmn.ApplyObj( item, "gzz_kitchenext_roaster", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_roaster" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_roaster_use_tongsext", true ) ) then

    cmn.CallEventHandler( "use_tongsext_inv" );
    cmn.CallEventHandler( "use_tongsext_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_tongsext" );
      cmn.CallEventHandler( "use_tongsext_end" );
      int.Lock( false );

      private.get_heart();
      
    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_take_heart" );
    AnimPlay( "amn_roaster_tongsext", "DoAnim", func_end );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_fileext_1 ()

  local item = "inv_fileext";

  if ( cmn.ApplyObj( item, "gzz_kitchenext_roaster", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_roaster" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_roaster_use_fileext", true ) ) then

    cmn.CallEventHandler( "use_fileext_1_inv" );
    cmn.CallEventHandler( "use_fileext_1_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_fileext_1" );
      cmn.CallEventHandler( "use_fileext_1_end" );
      int.Lock( false );

      private.get_chain();
      
    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_sawchain" );

    ObjSet( "amn_roaster_chain", { alp = 0 } );
    ObjSet( "amn_roaster_fileext", { alp = 1 } );
    
    AnimPlay( "amn_roaster_fileext", "DoAnim", func_end );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_flute ()

  local item = "inv_flute";

  if ( cmn.ApplyObj( item, "obj_kitchenext_use_flute", true ) ) then

    cmn.CallEventHandler( "use_flute_inv" );
    cmn.CallEventHandler( "use_flute_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_flute" );
      cmn.CallEventHandler( "use_flute_end" );
      int.Lock( false );

      cmn.GotoRoom( "mg_lulling" );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_flute" );

    AnimPlay( "anm_kitchenext_use_flute", "DoAnim", func_end );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------

--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_kitchenext ()

  if not ( cmn.IsEventDone( "opn_kitchenext" ) ) then

    cmn.SetEventDone( "opn_kitchenext" );
    cmn.ShowBbt( "bbt_kitchenext_first_open" );
    ng_global.progress[ "ext" ][ "opn_kitchenext" ].see_hourglass4 = 0;
    
    cmn.PlayAudio( "mus", "audio/aud_scare_theme_mus" );

  end;
  
  if ( cmn.IsEventDone( "win_lulling" ) ) then
     
     private.dlg_kitchenext_atropos_3_show();

  end;  
  
end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_kitchenext();
  
  cmn.StopAllEnv( "audio/level4/env/aud_kitchenext_env", true );
  cmn.PlayAudio( "env", "audio/level4/env/aud_kitchenext_env", 1, 2.5 );
  
  if ( cmn.IsEventDone( "get_flute" ) ) and ( ng_global.progress[ "ext" ][ "opn_kitchenext" ].see_hourglass4 == 0 ) then
    int_dialog_task.UpdateHourglassStage( false );
    ng_global.progress[ "ext" ][ "opn_kitchenext" ].see_hourglass4 = 1;
  end;

end;
--*********************************************************************************************************************
function public.Task ()
  
  int.AddedTaskMap( private.room_objname, "get_roomkeyext",                                  { "use_herbicide" } );
  int.AddedTaskMap( private.room_objname, "get_tongsext",                                    { "use_amuletfire_2" } );
  int.AddedTaskMap( private.room_objname, "get_tombstonepart_1",                             { "use_herbicide" } );
  int.AddedTaskMap( private.room_objname, "get_hookext",                                     { "use_fileext_2" } );
  int.AddedTaskMap( private.room_objname, "get_bowl_2",                                      { "use_heart" } );
  int.AddedTaskMap( private.room_objname, "get_bells",                                       { "win_phoenix" } );
  int.AddedTaskMap( private.room_objname, "get_heart",                                       { "use_tongsext" } );
  int.AddedTaskMap( private.room_objname, "get_chain",                                       { "use_fileext_1" } );

  int.AddedTaskMap( private.room_objname, "use_herbicide",                                   { "get_herbicide" } );
  int.AddedTaskMap( private.room_objname, "use_fileext_2",                                   { "get_fileext" } );
  int.AddedTaskMap( private.room_objname, "use_phoenixfeather",                              { "get_phoenixfeather_1", "get_phoenixfeather_2", "get_phoenixfeather_3" } );
  int.AddedTaskMap( private.room_objname, "use_heart",                                       { "get_heart" } );
  int.AddedTaskMap( private.room_objname, "use_tongsext",                                    { "get_tongsext" } );
  int.AddedTaskMap( private.room_objname, "use_fileext_1",                                   { "get_fileext" } );
  int.AddedTaskMap( private.room_objname, "use_flute",                                       { "get_flute" } );

  int.AddedTaskMap( private.room_objname, "win_phoenix",                                     { "use_phoenixfeather" } );
  int.AddedTaskMap( private.room_objname, "win_lulling",                                     { "use_flute" } );  
  
end;
--*********************************************************************************************************************
function private.PlaneTransfer ()

  local func_end = function ()

    --cmn.StopAudio( "sfx", "audio/level1/sfx/aud_intro_mus" );
    --cmn.StopAudio( "voc", "audio/level1/voc/aud_intro_voc" );
    cmn.StopAudio( "sfx", "audio/aud_back_in_past" );
    int.Lock( false );
    ObjSet( "rm_kitchenext", { color_r = 0, color_g = 0, color_b = 0 } );
    cmn.CallEventHandler( "dlg_kitchenext_atropos_3_end" );
    cmn.GotoRoom( "rm_plane" );
    int.LockRoomMap( "kitchenext", 1 );
    int.LockRoomMap( "livingroomext", 1 );
    int.LockRoomMap( "basementext", 1 );
    --cmn.SetEventDone( "opn_controltower" );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/aud_back_in_past" );
  common_impl.PlayDialogVideo( "vid_kitchenext_transfer", func_end );  

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_phoenix" );
  -------------------------------------------------
  function zz_phoenix.Open()

    if ( cmn.IsEventStart( "win_phoenix" ) and not cmn.IsEventDone( "win_phoenix" ) ) then

      cmn.MiniGameShow( "phoenix" );
      common_impl.PassingMgStart( "phoenix" );
      private.ZoomPhoenix(1,false);
      
    end;

  end;
  -------------------------------------------------
  function zz_phoenix.PreClose()

    if ( cmn.IsEventStart( "win_phoenix" ) and not cmn.IsEventDone( "win_phoenix" ) ) then

      cmn.MiniGameHide( "phoenix" );
      common_impl.PassingMgStop( "phoenix" );
      private.ZoomPhoenix(0,false);
    end;
    
  end;
  -------------------------------------------------
  function zz_phoenix.Skip ()

    for n=1, 8 do
      ObjSet( "spr_phoenix_feather_"..n, { 
        pos_x = private.coords[ n ][1],
        pos_y = private.coords[ n ][2],
        ang = 0 
      } );
    end;
    private.WinPhoenix();

  end;
  -------------------------------------------------
  function zz_phoenix.Reset ()
    
    private.state = {8,3,4,2,1,7,6,5};
    ng_global.progress[ "ext" ][ "win_phoenix" ].state = {8,3,4,2,1,7,6,5};
    local ang = 0;
    for n=1, 8 do
      ang = (n - private.state[n]) * (private.ang / 7)
      ObjSet( "spr_phoenix_feather_"..n, { 
        input = true,
        pos_x = private.coords[ private.state[n] ][1],
        pos_y = private.coords[ private.state[n] ][2],
        ang = ang 
      } );
    end;

  end;
  
end;
--*********************************************************************************************************************
function private.InitAnims ()

  ObjAnimate( "obj_lodge_light_1", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "obj_lodge_light_2", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_lodge_bowl_1", "ang", 1, 0, "", 
  {
    0.0, 3, -0.05,
    1.5, 3,  0.05,
    3.0, 3, -0.05,
  } );

  ObjAnimate( "obj_statue_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_gravestone_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );
  
  ObjAnimate( "spr_flowerext_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );
  
  ObjAnimate( "spr_flowerext_roomkeyext_hotspot", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    1.0, 3, 1.0,
    2.0, 3, 0.3,
    4.0, 3, 1.0,
    6.0, 3, 0.3,
  } );
  
  ObjAnimate("spr_phoenix_bowl_2_closed", "ang", 1, 0, "", 
  {
    0.0,0,0.02,
    3.0,3,-0.02,
    6.0,3,0.02
  });
  ObjAnimate( "spr_phoenix_light_add", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    2.5, 3, 0.6,
    5.0, 3, 1.0,
  } );
  
  ObjAnimate("spr_kitchenext_phoenix_bowl", "ang", 1, 0, "", 
  {
    0.0,0,0.03,
    3.0,3,-0.03,
    6.0,3,0.03
  });
  ObjAnimate("spr_kitchenext_phoenix_bell", "ang", 1, 0, "", 
  {
    0.0,0,-0.03,
    3.5,3,0.03,
    7.0,3,-0.03
  });
  
end;
--*********************************************************************************************************************
function private.RoasterChainClick ()

  int.Lock( true );

  local func_end = function ()

    cmn.ShowBbt( "bbt_roaster_use_fileext" );

    int.Lock( false );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_chain" );

  AnimPlay( "amn_roaster_chain", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.DogClick ()
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_evil_dogs" );
  ObjSet( "anm_kitchenext_dog_static", { alp = 0 } );
  ObjSet( "anm_kitchenext_dog_click", { alp = 1 } );
  AnimPlay( "anm_kitchenext_dog_click", "DoAnim", 
  function ()
    int.Lock( false );
    cmn.ShowBbt( "bbt_kitchenext_use_flute" );
    ObjSet( "anm_kitchenext_dog_static", { alp = 1, frame = 0 } );
    ObjSet( "anm_kitchenext_dog_click", { alp = 0 } );
  end);
  
end;
--*********************************************************************************************************************
function private.PhoenixClick ()

  int.Lock( true );

  local func_end = function ()

    cmn.ShowBbt( "bbt_phoenix_use_phoenixfeather" );

    int.Lock( false );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_wings" );

  local ang;
  
  for i=4, 8 do
    ang = ObjGet("spr_phoenix_feather_"..i).ang;
    ObjAnimate("spr_phoenix_feather_"..i, "ang", 0, 0, "", 
    {
      0.0,0,ang,
      0.2,2,ang + 0.02,
      0.4,3,ang - 0.02,
      0.6,1,ang
    });
  end;
  ObjAnimate("obj_phoenix_mmg", "alp", 0, 0, func_end, 
  {
    0.0,0,1,
    0.6,1,1
  });

end;
--*********************************************************************************************************************
function private.PhoenixClickHead ()

  int.Lock( true );

  local func_end = function ()

    cmn.ShowBbt( "bbt_phoenix_use_phoenixfeather" );

    int.Lock( false );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_wings" );

  local ang;
  
  for i=4, 8 do
    ang = ObjGet("spr_phoenix_feather_"..i).ang;
    ObjAnimate("spr_phoenix_feather_"..i, "ang", 0, 0, "", 
    {
      0.0,0,ang,
      0.2,2,ang + 0.02,
      0.4,3,ang - 0.02,
      0.6,1,ang
    });
  end;
  ObjAnimate("obj_phoenix_mmg", "alp", 0, 0, func_end, 
  {
    0.0,0,1,
    0.6,1,1
  });

end;
--*********************************************************************************************************************
function private.PhoenixClickLeg ()

  int.Lock( true );

  local func_end = function ()

    cmn.ShowBbt( "bbt_phoenix_clk_leg" );
    ObjSet( "anm_phoenix_leg", { alp = 0 } );
    ObjSet( "anm_phoenix_paw_open", { alp = 1 } );
    int.Lock( false );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_eaglehead" );
  
  ObjSet( "anm_phoenix_leg", { alp = 1 } );
  ObjSet( "anm_phoenix_paw_open", { alp = 0 } );
  
  AnimPlay( "anm_phoenix_leg", "DoAnim", func_end );
  
end;
--*********************************************************************************************************************
function private.PhoenixClickNoLeg ()

  int.Lock( true );

  local func_end = function ()

    cmn.ShowBbt( "bbt_phoenix_use_heart" );
    ObjSet( "anm_phoenix_head", { alp = 0 } );
    ObjSet( "obj_phoenix_head", { alp = 1 } );
    int.Lock( false );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_eaglehead" );
  
  ObjSet( "anm_phoenix_head", { alp = 1 } );
  ObjSet( "obj_phoenix_head", { alp = 0 } );
  
  AnimPlay( "anm_phoenix_head", "DoAnim", func_end );
  
end;
--*********************************************************************************************************************
-- function *** MMG PHOENIX***  () end;
--********************************************************************************************************************
--********************************************************************************************************************
  function private.InitPhoenix ()

    private.state = {8,3,4,2,1,7,6,5};
    private.win = {1,2,3,4,5,6,7,8};
    private.ang = 1.2;
    private.prev = 0;

    private.coords = {{114,-199},{126,-186},{120,-172},{107,-159},{92,-150},{77,-147},{63,-136},{47,-131}};

    local ang = 0;
    for n=1, 8 do
      ang = (n - private.state[n]) * (private.ang / 7)
      ObjSet( "spr_phoenix_feather_"..n, { 
        input = true,
        event_mdown = function () private.FeatherClk ( n ); end,
        event_menter = function () private.FeatherEnter ( n ) end,
        event_mleave = function () private.FeatherLeave ( n ) end,
        pos_x = private.coords[ private.state[n] ][1],
        pos_y = private.coords[ private.state[n] ][2],
        ang = ang 
      } );
    end;

  end;
  --*********************************************************************************************************************
  function private.InitPhoenixStart ()  

    cmn.MiniGameShow( "phoenix" );

    ng_global.progress[ "ext" ][ "win_phoenix" ].state = {8,3,4,2,1,7,6,5};
    
    private.ZoomPhoenix(1,true);
  end;
  --********************************************************************************************************************
  function private.ZoomPhoenix( check, anim )
    
    local time = 1;
    int.Lock( true ) ;
    
    if anim == true then
      
      if check == 1 then
        ObjSet("subroom",{ croprect_init = true, croprect_x = 237, croprect_y = 109, croprect_w = 550, croprect_h = 550 });
        ObjAnimate("zz_phoenix", "scale_x", 0, 0, "", {0, 3, 1, time, 3, 2});
        ObjAnimate("zz_phoenix", "scale_y", 0, 0, "", {0, 3, 1, time, 3, 2});
        ObjAnimate("zz_phoenix", "pos_x", 0, 0, "", {0, 3, 512, time, 3, 225});
        ObjAnimate("zz_phoenix", "pos_y", 0, 0, function() private.ZoomPhoenixEndAnim(1); end, {0, 3, 384, time, 3, 650});
      else
        ObjAnimate("zz_phoenix", "scale_x", 0, 0, "", {0, 3, 2, time, 3, 1});
        ObjAnimate("zz_phoenix", "scale_y", 0, 0, "", {0, 3, 2, time, 3, 1});
        ObjAnimate("zz_phoenix", "pos_x", 0, 0, "", {0, 3, 225, time, 3, 512});
        ObjAnimate("zz_phoenix", "pos_y", 0, 0, function() private.ZoomPhoenixEndAnim(0); end, {0, 3, 650, time, 3, 384});      
      end;
        
    else
        
        if check == 1 then
        ObjSet("subroom",{ croprect_init = true, croprect_x = 237, croprect_y = 109, croprect_w = 550, croprect_h = 550 });
        ObjSet("zz_phoenix", { scale_x=2 });
        ObjSet("zz_phoenix", { scale_y=2 });
        ObjSet("zz_phoenix", { pos_x=225 });
        ObjSet("zz_phoenix", { pos_y=650 });
        private.ZoomPhoenixEndAnim(1);
      else
        ObjSet("zz_phoenix", { scale_x=1 });
        ObjSet("zz_phoenix", { scale_y=1 });
        ObjSet("zz_phoenix", { pos_x=512 });
        ObjSet("zz_phoenix", { pos_y=384 });      
        private.ZoomPhoenixEndAnim(0);
      end;
        
    end;
  end;
  --********************************************************************************************************************
  function private.ZoomPhoenixEndAnim( check )
    if check == 0 then
      ObjSet("subroom",{ croprect_init = false, croprect_x = 0, croprect_y = 0, croprect_w = 0, croprect_h = 0 });
    end;
    int.Lock( false ) ;
  end;
  --********************************************************************************************************************
  function private.LoadPhoenix ()
    
    local ang = 0;
    for n=1, 8 do
      private.state[ n ] = ng_global.progress[ "ext" ][ "win_phoenix" ].state[ n ];
      ang = (n - private.state[n]) * (private.ang / 7)
      ObjSet( "spr_phoenix_feather_"..n, { 
        input = not ( private.state[ n ] == private.win[ n ] ),
        pos_x = private.coords[ private.state[n] ][1],
        pos_y = private.coords[ private.state[n] ][2],
        ang = ang 
      } );
    end;

  end;
  --*********************************************************************************************************************
  function private.CheckWinPhoenix ()
    
    local win = true;
    
    for n=1, 8 do
      if ( private.state[ n ] ~= private.win[ n ] ) then
        win = false;
        break;
      end;       
    end;
    
    if ( win ) then
      private.WinPhoenix();
    else
      for n=1, 8 do
        ng_global.progress[ "ext" ][ "win_phoenix" ].state[ n ] = private.state[ n ];
      end;
    end;

  end;
  --*********************************************************************************************************************
  function private.WinPhoenix ()
    
    private.ZoomPhoenix(0,true);
    
    local func_end = function ()

      cmn.MiniGameHide( "phoenix" );
      cmn.SetEventDone( "win_phoenix" );
      cmn.CallEventHandler( "win_phoenix" );

      int.Lock( false ) ;

      --cmn.CloseSubRoom();

    end;

    int.Lock( true ) ;
    
    common_impl.PassingMgWin( "phoenix" );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_eagle_win" );
    AnimPlay( "anm_phoenix_paw_open", "DoAnim", 
    function ()  
      ObjSet( "anm_phoenix_paw_open", { alp = 0 } );
      ObjSet( "obj_phoenix_paw", { alp = 1 } );
      ObjSet( "spr_phoenix_bells", { alp = 1 } );
      ObjAnimate("spr_phoenix_paw", "ang", 0, 0, func_end, 
      {
        0.0,0,0,
        0.3,0,0,
        0.8,0,-0.55
      });
    end );

  end;
  --*********************************************************************************************************************
  function private.FeatherClk ( n )       
    
    local func_end = function ()
    
      int.Lock( false );             
      
      ObjSet( "spr_phoenix_feather_"..n, { 
      input = not ( private.state[ n ] == private.win[ n ] ),
      } );
      ObjSet( "spr_phoenix_feather_"..private.prev, { 
      input = not ( private.state[ private.prev ] == private.win[ private.prev ] ),
      } );
      
      private.prev = 0;
      private.CheckWinPhoenix();
    
    end;

    if ( private.prev == 0 ) then
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_clk_feather" );
      
      private.prev = n;
      ObjAnimate("spr_phoenix_feather_"..n, "scale_x", 0, 0, "", 
      {
        0.0,0,ObjGet( "spr_phoenix_feather_"..n ).scale_x,
        0.2,0,1.05
      });
      
    elseif ( private.prev == n ) then
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_clk_feather" );
      
      private.prev = 0;
      ObjAnimate("spr_phoenix_feather_"..n, "scale_x", 0, 0, "", 
      {
        0.0,0,ObjGet( "spr_phoenix_feather_"..n ).scale_x,
        0.2,0,1
      });
      
    else

      int.Lock( true );    
     
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_change_feathers" ); 

      local tmp = private.state[ private.prev ];
      private.state[ private.prev ] = private.state[ n ];
      private.state[ n ] = tmp;      
      
      local ang = (n - private.state[n]) * (private.ang / 7)
      ObjAnimate("spr_phoenix_feather_"..n, "pos_xy", 0, 0, func_end, 
      {
        0.0,0,ObjGet("spr_phoenix_feather_"..n).pos_x,ObjGet("spr_phoenix_feather_"..n).pos_y,
        0.3,0,private.coords[ private.state[n] ][1],private.coords[ private.state[n] ][2]
      });
      ObjAnimate("spr_phoenix_feather_"..n, "ang", 0, 0, "", 
      {
        0.0,0,ObjGet("spr_phoenix_feather_"..n).ang,
        0.3,0,ang
      });

      ang = (private.prev - private.state[ private.prev ]) * (private.ang / 7)
      ObjAnimate("spr_phoenix_feather_"..private.prev, "pos_xy", 0, 0, "", 
      {
        0.0,0,ObjGet("spr_phoenix_feather_"..private.prev).pos_x,ObjGet("spr_phoenix_feather_"..private.prev).pos_y,
        0.3,0,private.coords[ private.state[ private.prev ] ][1],private.coords[ private.state[ private.prev ] ][2]
      });
      ObjAnimate("spr_phoenix_feather_"..private.prev, "ang", 0, 0, "", 
      {
        0.0,0,ObjGet("spr_phoenix_feather_"..private.prev).ang,
        0.3,0,ang
      });
      ObjAnimate("spr_phoenix_feather_"..private.prev, "scale_x", 0, 0, "", 
      {
        0.0,0,ObjGet("spr_phoenix_feather_"..private.prev).scale_x,
        0.2,0,1
      });
      
    end;

  end;
  --*********************************************************************************************************************
  function private.FeatherEnter ( n )

    cmn.SetCursor(CURSOR_HAND);

  end;
  --*********************************************************************************************************************
  function private.FeatherLeave ( n )

    cmn.SetCursor(CURSOR_DEFAULT);

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************