-- name=rm_livingroomext
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_livingroomext";

  ObjAttach( "zz_horrorhouse",    "room_hub" );
  ObjAttach( "zz_kitchendoorext", "room_hub" );
  ObjAttach( "zz_deskext",        "room_hub" );
  ObjAttach( "zz_roomdoorext",    "room_hub" );
  ObjAttach( "zz_windowext",      "room_hub" );
  
  ObjMultiSet( {
    { "spr_horrorhouse_pliersext",          { event_mdown = private.get_pliersext } },
    { "spr_kitchendoorext_amulethorror_1",  { event_mdown = private.get_amulethorror_1 } },
    { "spr_deskext_blade",                  { event_mdown = private.get_blade } },
    { "spr_deskext_amuletbook_2",           { event_mdown = private.get_amuletbook_2 } },
    { "spr_deskext_poisons",                { event_mdown = private.get_poisons } },
    { "spr_deskext_paints",                 { event_mdown = private.get_paints } },
    { "spr_windowext_deskhandleext",        { event_mdown = private.get_deskhandleext }},
    { "spr_windowext_themis",               { event_mdown = private.get_themis } },
    { "spr_windowext_plane_1",              { event_mdown = private.get_plane_1 } },
    { "spr_windowext_buttonext_1",          { event_mdown = private.get_buttonext_1 } },
    { "spr_windowext_trebleclef",           { event_mdown = private.get_trebleclef } },
    { "spr_windowext_phoenixfeather_1",     { event_mdown = private.get_phoenixfeather_1 } },
    { "obj_roomdoorext_clk_roomkeyext",     { event_mdown = private.clk_roomkeyext } },
    { "obj_roomdoorext_use_blade",          { event_mdown = private.RoomdoorextAmulethorrorClick } },
    { "obj_roomdoorext_use_roomkeyext",     { event_mdown = private.RoomdoorextDoorClick } },
    { "obj_kitchendoorext_use_pliersext",   { event_mdown = private.KitchendoorextAmulethorrorClick } },
    { "obj_windowext_use_bowl_1",           { event_mdown = private.ClkBowl } },
    { "obj_windowext_use_bowl_2",           { event_mdown = private.ClkBowl } },
    { "obj_horrorhouse_use_amulethorror_1", { event_mdown = private.ClkHouse } },
    { "obj_horrorhouse_use_amulethorror_2", { event_mdown = private.ClkHouse } },
    { "obj_deskext_use_deskhandleext",      { event_mdown = private.ClkBox } },
    { "obj_livingroomext_mannequin",        { event_mdown = private.LivingroomextMannequinClick } },
  } );

  private.InitAnims();
  private.InitWindowext();
  private.InitSubroom();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_livingroomext = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gho_livingroomext_house",
        "gzz_livingroomext_horrorhouse",
        "gzz_livingroomext_kitchendoorext",
        "gzz_livingroomext_deskext",
        "gzz_livingroomext_roomdoorext",
        "gzz_livingroomext_windowext",
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_horrorhouse", 
        "zz_kitchendoorext", 
        "zz_deskext", 
        "zz_roomdoorext", 
        "zz_windowext", 
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_livingroomext", update_game_mode_livingroomext, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_pliersext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pliersext" ] =
  {
    type = "get",
    get_obj = "spr_horrorhouse_pliersext",
    room = private.room_objname,
    zz = "zz_horrorhouse",
    zz_gate = "gzz_livingroomext_horrorhouse"
  };
  -----------------------------------------------
  local get_pliersext_inv = function ()

    int.InventoryItemAdd( "inv_pliersext", "spr_horrorhouse_pliersext" );

  end;

  local get_pliersext_closezz = function ()

    ObjDelete( "gfx_horrorhouse_pliersext" );
    ObjDelete( "spr_horrorhouse_pliersext_shadow" );
    
    ObjDelete( "spr_livingroomext_horrorhouse_pliers" );

  end;

  cmn.AddSubscriber( "get_pliersext", get_pliersext_inv );
  cmn.AddSubscriber( "get_pliersext", get_pliersext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amulethorror_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amulethorror_1" ] =
  {
    type = "get",
    get_obj = "spr_kitchendoorext_amulethorror_1",
    room = private.room_objname,
    zz = "zz_kitchendoorext",
    zz_gate = "gzz_livingroomext_kitchendoorext"
  };
  -----------------------------------------------
  local get_amulethorror_1_inv = function ()

    int.InventoryItemAdd( "inv_amulethorror_1", "spr_kitchendoorext_amulethorror_1" );

  end;

  local get_amulethorror_1_closezz = function ()

    ObjDelete( "gfx_kitchendoorext_amulethorror_1" );
    ObjDelete( "spr_livingroomext_kitchendoorext_amulethorror_1" );
    ObjDelete( "spr_kitchendoorext_amulethorror_1_shadow" );

  end;

  cmn.AddSubscriber( "get_amulethorror_1", get_amulethorror_1_inv );
  cmn.AddSubscriber( "get_amulethorror_1", get_amulethorror_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_blade () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_blade" ] =
  {
    type = "get",
    get_obj = "spr_deskext_blade",
    room = private.room_objname,
    zz = "zz_deskext",
    zz_gate = "gzz_livingroomext_deskext"
  };
  -----------------------------------------------
  local get_blade_inv = function ()

  int.InventoryItemAdd( "inv_blade", "spr_deskext_blade" );

  end;

  local get_blade_closezz = function ()

    ObjDelete( "gfx_deskext_blade" );
    
    ObjDelete( "spr_livingroomext_deskext_blade" );

  end;

  cmn.AddSubscriber( "get_blade", get_blade_inv );
  cmn.AddSubscriber( "get_blade", get_blade_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletbook_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletbook_2" ] =
  {
    type = "get",
    get_obj = "spr_deskext_amuletbook_2",
    room = private.room_objname,
    zz = "zz_deskext",
    zz_gate = "gzz_livingroomext_deskext"
  };
  -----------------------------------------------
  local get_amuletbook_2_inv = function ()

  int.InventoryItemAdd( "inv_amuletbook_2", "spr_deskext_amuletbook_2" );
    ObjSet( "inv_book_plus_focus2", { alp = 1 } );

  end;

  local get_amuletbook_2_closezz = function ()

    ObjDelete( "gfx_deskext_amuletbook_2" );
    ObjDelete( "spr_deskext_amuletbook_2_shadow" );
    
    ObjDelete( "spr_livingroomext_deskext_amuletbook_2" );
    
  end;

  cmn.AddSubscriber( "get_amuletbook_2", get_amuletbook_2_inv );
  cmn.AddSubscriber( "get_amuletbook_2", get_amuletbook_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_poisons () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_poisons" ] =
  {
    type = "get",
    get_obj = "spr_deskext_poisons",
    room = private.room_objname,
    zz = "zz_deskext",
    zz_gate = "gzz_livingroomext_deskext"
  };
  -----------------------------------------------
  local get_poisons_inv = function ()

  int.InventoryItemAdd( "inv_poisons", "spr_deskext_poisons2" );
    if cmn.IsEventDone( "get_recipeext" ) then
      ObjSet( "inv_recipeext_plus_focus2", { alp = 1 } );
    end;

  end;

  local get_poisons_closezz = function ()

    ObjDelete( "gfx_deskext_poisons" );
    ObjDelete( "spr_deskext_poisons" );
    --ObjDelete( "gzz_livingroomext_deskext" );
    
    ObjDelete( "spr_livingroomext_deskext_poison" );

  end;

  cmn.AddSubscriber( "get_poisons", get_poisons_inv );
  cmn.AddSubscriber( "get_poisons", get_poisons_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_paints () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_paints" ] =
  {
    type = "get",
    get_obj = "spr_deskext_paints",
    room = private.room_objname,
    zz = "zz_deskext",
    zz_gate = "gzz_livingroomext_deskext"
  };
  -----------------------------------------------
  local get_paints_inv = function ()

  int.InventoryItemAdd( "inv_paints", "spr_deskext_paints" );

  end;

  local get_paints_closezz = function ()

    ObjDelete( "spr_deskext_paints_shadow" );
    ObjDelete( "gfx_deskext_paints" );
    ObjDelete( "spr_deskext_paints_over" );
    ObjDelete( "gzz_livingroomext_deskext" );
    
    ObjDelete( "spr_livingroomext_deskext_paints_open" );
    ObjSet( "spr_livingroomext_deskext_broken_glass", { alp = 1 } );

  end;

  cmn.AddSubscriber( "get_paints", get_paints_inv );
  cmn.AddSubscriber( "get_paints", get_paints_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amulethorror_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amulethorror_2" ] =
  {
    type = "get",
    get_obj = "spr_roomdoorext_amulethorror_2",
    room = private.room_objname,
    zz = "zz_roomdoorext",
    zz_gate = "gzz_livingroomext_roomdoorext"
  };
  -----------------------------------------------
  local get_amulethorror_2_inv = function ()

    int.InventoryItemAdd( "inv_amulethorror_2", "spr_roomdoorext_amulethorror_2" );

  end;

  local get_amulethorror_2_closezz = function ()
  
    ObjDelete( "spr_livingroomext_roomdoorext_amulethorror_2" );

  end;

  cmn.AddSubscriber( "get_amulethorror_2", get_amulethorror_2_inv );
  cmn.AddSubscriber( "get_amulethorror_2", get_amulethorror_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_deskhandleext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_deskhandleext" ] =
  {
    type = "get",
    get_obj = "spr_windowext_deskhandleext",
    room = private.room_objname,
    zz = "zz_windowext",
    zz_gate = "gzz_livingroomext_windowext"
  };
  -----------------------------------------------
  local get_deskhandleext_inv = function ()

    int.InventoryItemAdd( "inv_deskhandleext", "spr_windowext_deskhandleext" );

  end;

  local get_deskhandleext_closezz = function ()

    ObjDelete( "gfx_windowext_deskhandleext" );
    ObjDelete( "spr_windowext_deskhandle_shadow" );
    ObjDelete( "spr_windowext_deskhandle_shadow_up" );
    ObjDelete( "spr_windowext_deskhandle_over" );
    ObjDelete( "spr_livingroomext_windowext_handle" );
    
    if ( cmn.IsEventDone( "get_deskhandleext" ) and
         cmn.IsEventDone( "get_themis" ) and
         cmn.IsEventDone( "get_plane_1" ) and
         cmn.IsEventDone( "get_buttonext_1" ) and
         cmn.IsEventDone( "get_trebleclef" ) and
         cmn.IsEventDone( "get_phoenixfeather_1" ) ) then
         
      ObjDelete( "gzz_livingroomext_windowext" );
      
    end;

  end;

  cmn.AddSubscriber( "get_deskhandleext", get_deskhandleext_inv );
  cmn.AddSubscriber( "get_deskhandleext", get_deskhandleext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_themis () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_themis" ] =
  {
    type = "get",
    get_obj = "spr_windowext_themis",
    room = private.room_objname,
    zz = "zz_windowext",
    zz_gate = "gzz_livingroomext_windowext"
  };
  -----------------------------------------------
  local get_themis_inv = function ()

    int.InventoryItemAdd( "inv_themis", "spr_windowext_themis" );

  end;

  local get_themis_closezz = function ()

    ObjDelete( "gfx_windowext_themis" );
    ObjDelete( "spr_windowext_themis_shadow" );
    ObjDelete( "spr_livingroomext_windowext_themis" );
    
    if ( cmn.IsEventDone( "get_deskhandleext" ) and
         cmn.IsEventDone( "get_themis" ) and
         cmn.IsEventDone( "get_plane_1" ) and
         cmn.IsEventDone( "get_buttonext_1" ) and
         cmn.IsEventDone( "get_trebleclef" ) and
         cmn.IsEventDone( "get_phoenixfeather_1" ) ) then
         
      ObjDelete( "gzz_livingroomext_windowext" );
      
    end;

  end;

  cmn.AddSubscriber( "get_themis", get_themis_inv );
  cmn.AddSubscriber( "get_themis", get_themis_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_plane_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_plane_1" ] =
  {
    type = "get",
    get_obj = "spr_windowext_plane_1",
    room = private.room_objname,
    zz = "zz_windowext",
    zz_gate = "gzz_livingroomext_windowext"
  };
  -----------------------------------------------
  local get_plane_1_inv = function ()

    int.InventoryItemAdd( "inv_plane", "spr_windowext_plane_1", "assets/levels/levelext/rm_livingroomext/zz_windowext/inv/inv_plane_morph" );
    levelext_inv.CheckPlane();

  end;

  local get_plane_1_closezz = function ()

    ObjDelete( "gfx_windowext_plane_1" );
    ObjDelete( "spr_windowext_plane_1_shadow" );
    ObjDelete( "spr_livingroomext_windowext_plane" );
    ObjSet( "spr_windowext_themis", { input = true, active = true } );
    if ( cmn.IsEventDone( "get_deskhandleext" ) and
         cmn.IsEventDone( "get_themis" ) and
         cmn.IsEventDone( "get_plane_1" ) and
         cmn.IsEventDone( "get_buttonext_1" ) and
         cmn.IsEventDone( "get_trebleclef" ) and
         cmn.IsEventDone( "get_phoenixfeather_1" ) ) then
         
      ObjDelete( "gzz_livingroomext_windowext" );
      
    end;

  end;

  cmn.AddSubscriber( "get_plane_1", get_plane_1_inv );
  cmn.AddSubscriber( "get_plane_1", get_plane_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_buttonext_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_buttonext_1" ] =
  {
    type = "get",
    get_obj = "spr_windowext_buttonext_1",
    room = private.room_objname,
    zz = "zz_windowext",
    zz_gate = "gzz_livingroomext_windowext"
  };
  -----------------------------------------------
  local get_buttonext_1_inv = function ()

    int.InventoryItemAdd( "inv_buttonext_1", "spr_windowext_buttonext_1" );

  end;

  local get_buttonext_1_closezz = function ()

    ObjDelete( "gfx_windowext_buttonext_1" );
    ObjDelete( "spr_windowext_buttonext_1_shadow" );
    ObjDelete( "spr_livingroomext_windowext_button" );
    ObjSet( "spr_windowext_trebleclef", { input = true, active = true } );
    if ( cmn.IsEventDone( "get_deskhandleext" ) and
         cmn.IsEventDone( "get_themis" ) and
         cmn.IsEventDone( "get_plane_1" ) and
         cmn.IsEventDone( "get_buttonext_1" ) and
         cmn.IsEventDone( "get_trebleclef" ) and
         cmn.IsEventDone( "get_phoenixfeather_1" ) ) then
         
      ObjDelete( "gzz_livingroomext_windowext" );
      
    end;

  end;

  cmn.AddSubscriber( "get_buttonext_1", get_buttonext_1_inv );
  cmn.AddSubscriber( "get_buttonext_1", get_buttonext_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_trebleclef () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_trebleclef" ] =
  {
    type = "get",
    get_obj = "spr_windowext_trebleclef",
    room = private.room_objname,
    zz = "zz_windowext",
    zz_gate = "gzz_livingroomext_windowext"
  };
  -----------------------------------------------
  local get_trebleclef_inv = function ()

    int.InventoryItemAdd( "inv_trebleclef", "spr_windowext_trebleclef" );

  end;

  local get_trebleclef_closezz = function ()

    ObjDelete( "gfx_windowext_trebleclef" );
    ObjDelete( "spr_windowext_trebleclef_shadow" );
    ObjDelete( "spr_livingroomext_windowext_trebleclef" );
    
    if ( cmn.IsEventDone( "get_deskhandleext" ) and
         cmn.IsEventDone( "get_themis" ) and
         cmn.IsEventDone( "get_plane_1" ) and
         cmn.IsEventDone( "get_buttonext_1" ) and
         cmn.IsEventDone( "get_trebleclef" ) and
         cmn.IsEventDone( "get_phoenixfeather_1" ) ) then
         
      ObjDelete( "gzz_livingroomext_windowext" );
      
    end;

  end;

  cmn.AddSubscriber( "get_trebleclef", get_trebleclef_inv );
  cmn.AddSubscriber( "get_trebleclef", get_trebleclef_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_phoenixfeather_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_phoenixfeather_1" ] =
  {
    type = "get",
    get_obj = "spr_windowext_phoenixfeather_1",
    room = private.room_objname,
    zz = "zz_windowext",
    zz_gate = "gzz_livingroomext_windowext"
  };
  -----------------------------------------------
  local get_phoenixfeather_1_inv = function ()

    int.InventoryItemAdd( "inv_phoenixfeather", "spr_windowext_phoenixfeather_1", "assets/levels/levelext/rm_livingroomext/zz_windowext/inv/inv_phoenixfeather_morph" );
    levelext_inv.CheckPhoenixfeather();

  end;

  local get_phoenixfeather_1_closezz = function ()

    ObjDelete( "gfx_windowext_phoenixfeather_1" );
    ObjDelete( "spr_windowext_phoenixfeather_shadow" );
    ObjDelete( "spr_livingroomext_windowext_feather" );
    
    if ( cmn.IsEventDone( "get_deskhandleext" ) and
         cmn.IsEventDone( "get_themis" ) and
         cmn.IsEventDone( "get_plane_1" ) and
         cmn.IsEventDone( "get_buttonext_1" ) and
         cmn.IsEventDone( "get_trebleclef" ) and
         cmn.IsEventDone( "get_phoenixfeather_1" ) ) then
         
      ObjDelete( "gzz_livingroomext_windowext" );
      
    end;

  end;

  cmn.AddSubscriber( "get_phoenixfeather_1", get_phoenixfeather_1_inv );
  cmn.AddSubscriber( "get_phoenixfeather_1", get_phoenixfeather_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_4_6 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_4_6 = function ()

    ObjDelete( "obj_livingroomext_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_4_6", get_morphobject_4_6, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_amulethorror_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amulethorror_1" ] =
  {
    type = "use",
    use_obj = "inv_amulethorror_1",
    use_place = "obj_horrorhouse_use_amulethorror_1",
    room = private.room_objname,
    zz = "zz_horrorhouse",
    zz_gate = "gzz_livingroomext_horrorhouse"
  };
  -----------------------------------------------
  local use_amulethorror_1_inv = function ()

    int.InventoryItemRemove( "inv_amulethorror_1" );

  end;
  local use_amulethorror_1_beg = function ()

    ObjDelete( "obj_horrorhouse_use_amulethorror_1" );

  end;
  local use_amulethorror_1_end = function ()

    if ( cmn.IsEventDone( "use_amulethorror_2" ) ) then
      
      ObjDelete( "anm_horrorhouse_house" );
      ObjDelete( "anm_horrorhouse_house_click" );
      ObjDelete( "anm_horrorhouse_house_amulet_horror_2" );
      ObjDelete( "anm_horrorhouse_house_amulets" );
      ObjDelete( "anm_horrorhouse_house_open" );
      ObjDelete( "gzz_livingroomext_horrorhouse" );
      ObjSet( "gho_livingroomext_house", { input = true, alp = 1, active = true } );
      
      ObjSet( "spr_livingroomext_horrorhouse_open_ho", { alp = 1 } );
      ObjDelete( "spr_livingroomext_horrorhouse_amulethorror_1" );
      ObjDelete( "spr_livingroomext_horrorhouse_amulethorror_2" );

    else 
    
      ObjDelete( "anm_horrorhouse_house_amulets_empty" );
      ObjDelete( "anm_horrorhouse_house_click_no_amulets" );
      ObjSet( "anm_horrorhouse_house_amulet_horror_1", { alp = 1, playing = true } );
      
      ObjSet( "spr_livingroomext_horrorhouse_amulethorror_1", { alp = 1 } );
      
    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_amulethorror_1", use_amulethorror_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_amulethorror_1", use_amulethorror_1_inv );
  cmn.AddSubscriber( "use_amulethorror_1", use_amulethorror_1_end, private.room_objname );
  cmn.AddSubscriber( "use_amulethorror_1_inv", use_amulethorror_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_amulethorror_1_beg", use_amulethorror_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_amulethorror_1_end", use_amulethorror_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amulethorror_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amulethorror_2" ] =
  {
    type = "use",
    use_obj = "inv_amulethorror_2",
    use_place = "obj_horrorhouse_use_amulethorror_2",
    room = private.room_objname,
    zz = "zz_horrorhouse",
    zz_gate = "gzz_livingroomext_horrorhouse"
  };
  -----------------------------------------------
  local use_amulethorror_2_inv = function ()

    int.InventoryItemRemove( "inv_amulethorror_2" );

  end;
  local use_amulethorror_2_beg = function ()

    ObjDelete( "obj_horrorhouse_use_amulethorror_2" );

  end;
  local use_amulethorror_2_end = function ()

  if ( cmn.IsEventDone( "use_amulethorror_1" ) ) then
    
      ObjDelete( "anm_horrorhouse_house" );
      ObjDelete( "anm_horrorhouse_house_click" );
      ObjDelete( "anm_horrorhouse_house_amulet_horror_1" );
      ObjDelete( "anm_horrorhouse_house_amulets" );
      ObjDelete( "anm_horrorhouse_house_open" );
      ObjDelete( "gzz_livingroomext_horrorhouse" );
      ObjSet( "gho_livingroomext_house", { input = true, alp = 1, active = true } );
      
      ObjSet( "spr_livingroomext_horrorhouse_open_ho", { alp = 1 } );
      ObjDelete( "spr_livingroomext_horrorhouse_amulethorror_1" );
      ObjDelete( "spr_livingroomext_horrorhouse_amulethorror_2" );

    else 
    
      ObjDelete( "anm_horrorhouse_house_amulets_empty" );
      ObjDelete( "anm_horrorhouse_house_click_no_amulets" );
      ObjSet( "anm_horrorhouse_house_amulet_horror_2", { alp = 1, playing = true } );
      
      ObjSet( "spr_livingroomext_horrorhouse_amulethorror_1", { alp = 1 } );
      
    end;


  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_amulethorror_2", use_amulethorror_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_amulethorror_2", use_amulethorror_2_inv );
  cmn.AddSubscriber( "use_amulethorror_2", use_amulethorror_2_end, private.room_objname );
  cmn.AddSubscriber( "use_amulethorror_2_inv", use_amulethorror_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_amulethorror_2_beg", use_amulethorror_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_amulethorror_2_end", use_amulethorror_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pliersext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pliersext" ] =
  {
    type = "use",
    use_obj = "inv_pliersext",
    use_place = "obj_kitchendoorext_use_pliersext",
    room = private.room_objname,
    zz = "zz_kitchendoorext",
    zz_gate = "gzz_livingroomext_kitchendoorext"
  };
  -----------------------------------------------
  local use_pliersext_inv = function ()

    int.InventoryItemRemove( "inv_pliersext" );

  end;
  local use_pliersext_beg = function ()

    ObjDelete( "obj_kitchendoorext_use_pliersext" );

  end;
  local use_pliersext_end = function ()

    ObjDelete( "spr_kitchendoorext_nails" );
    ObjDelete( "spr_kitchendoorext_amulethorror_1_over" );
    ObjDelete( "spr_livingroomext_kitchendoorext_nails" );
    ObjDelete( "anm_kitchendoorext_pliersext" );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_pliersext", use_pliersext_beg, private.room_objname );
  cmn.AddSubscriber( "use_pliersext", use_pliersext_inv );
  cmn.AddSubscriber( "use_pliersext", use_pliersext_end, private.room_objname );
  cmn.AddSubscriber( "use_pliersext_inv", use_pliersext_inv, private.room_objname );
  cmn.AddSubscriber( "use_pliersext_beg", use_pliersext_beg, private.room_objname );
  cmn.AddSubscriber( "use_pliersext_end", use_pliersext_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletfire_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletfire_1" ] =
  {
    type = "use",
    use_obj = "inv_amuletfire_1",
    use_place = "obj_kitchendoorext_use_amuletfire_1",
    room = private.room_objname,
    zz = "zz_kitchendoorext",
    zz_gate = "gzz_livingroomext_kitchendoorext"
  };
  -----------------------------------------------
  local use_amuletfire_1_inv = function ()

    int.InventoryItemRemove( "inv_amuletfire_1" );

  end;
  local use_amuletfire_1_beg = function ()

    ObjDelete( "obj_kitchendoorext_use_amuletfire_1" );

  end;
  local use_amuletfire_1_end = function ()

    ObjSet( "spr_kitchendoorext_fire_amulet1", { alp = 1 } );
    ObjSet( "spr_livingroomext_kitchendoorext_fire_amulet_1", { alp = 1 } );
    
    if ( cmn.IsEventDone( "use_amuletfire_2" ) ) then

      ObjDelete( "gzz_livingroomext_kitchendoorext" );
      ObjSet( "grm_livingroomext_kitchenext", { active = true, input = true, visible = true } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_livingroomext_kitchenext_focus");
      end;
      ObjDelete( "obj_livingroomext_kitchendoorext_closed" );
      ObjSet( "spr_livingroomext_kitchendoorext_open", { alp = 1 } );       
      ObjDelete( "vid_livingroom_kitchendoorext_combustion" );
    
    end;
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_amuletfire_1", use_amuletfire_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletfire_1", use_amuletfire_1_inv );
  cmn.AddSubscriber( "use_amuletfire_1", use_amuletfire_1_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletfire_1_inv", use_amuletfire_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletfire_1_beg", use_amuletfire_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletfire_1_end", use_amuletfire_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletfire_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletfire_2" ] =
  {
    type = "use",
    use_obj = "inv_amuletfire_2",
    use_place = "obj_kitchendoorext_use_amuletfire_2",
    room = private.room_objname,
    zz = "zz_kitchendoorext",
    zz_gate = "gzz_livingroomext_kitchendoorext"
  };
  -----------------------------------------------
  local use_amuletfire_2_inv = function ()

    int.InventoryItemRemove( "inv_amuletfire_2" );

  end;
  local use_amuletfire_2_beg = function ()

    ObjDelete( "obj_kitchendoorext_use_amuletfire_2" );

  end;
  local use_amuletfire_2_end = function ()

    ObjSet( "spr_kitchendoorext_fire_amulet2", { alp = 1 } );
    ObjSet( "spr_livingroomext_kitchendoorext_fire_amulet_2", { alp = 1 } );
    
    if ( cmn.IsEventDone( "use_amuletfire_1" ) ) then

      ObjDelete( "gzz_livingroomext_kitchendoorext" );
      ObjSet( "grm_livingroomext_kitchenext", { active = true, input = true, visible = true } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_livingroomext_kitchenext_focus");
      end;
      ObjDelete( "obj_livingroomext_kitchendoorext_closed" );
      ObjSet( "spr_livingroomext_kitchendoorext_open", { alp = 1 } );
      ObjDelete( "vid_livingroom_kitchendoorext_combustion" );      
      
    end;
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_amuletfire_2", use_amuletfire_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletfire_2", use_amuletfire_2_inv );
  cmn.AddSubscriber( "use_amuletfire_2", use_amuletfire_2_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletfire_2_inv", use_amuletfire_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletfire_2_beg", use_amuletfire_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletfire_2_end", use_amuletfire_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_deskhandleext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_deskhandleext" ] =
  {
    type = "use",
    use_obj = "inv_deskhandleext",
    use_place = "obj_deskext_use_deskhandleext",
    room = private.room_objname,
    zz = "zz_deskext",
    zz_gate = "gzz_livingroomext_deskext"
  };
  -----------------------------------------------
  local use_deskhandleext_inv = function ()

    int.InventoryItemRemove( "inv_deskhandleext" );

  end;
  local use_deskhandleext_beg = function ()

    ObjDelete( "obj_deskext_use_deskhandleext" );

  end;
  local use_deskhandleext_end = function ()

    ObjSet( "obj_deskext_open_box", { input = true, alp = 1 } );
    ObjSet( "gfx_deskext_amuletbook_2", { active = true } );
    ObjSet( "gfx_deskext_blade", { active = true } );
    ObjDelete( "spr_deskext_deskhandle" );
    
    ObjSet( "spr_livingroomext_deskext_open_desk", { input = true, alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_deskhandleext", use_deskhandleext_beg, private.room_objname );
  cmn.AddSubscriber( "use_deskhandleext", use_deskhandleext_inv );
  cmn.AddSubscriber( "use_deskhandleext", use_deskhandleext_end, private.room_objname );
  cmn.AddSubscriber( "use_deskhandleext_inv", use_deskhandleext_inv, private.room_objname );
  cmn.AddSubscriber( "use_deskhandleext_beg", use_deskhandleext_beg, private.room_objname );
  cmn.AddSubscriber( "use_deskhandleext_end", use_deskhandleext_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_themis () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_themis" ] =
  {
    type = "use",
    use_obj = "inv_themis",
    use_place = "obj_deskext_use_themis",
    room = private.room_objname,
    zz = "zz_deskext",
    zz_gate = "gzz_livingroomext_deskext"
  };
  -----------------------------------------------
  local use_themis_inv = function ()

    int.InventoryItemRemove( "inv_themis" );

  end;
  local use_themis_beg = function ()

    ObjDelete( "obj_deskext_use_themis" );

  end;
  local use_themis_end = function ()

    ObjSet( "obj_deskext_open_themis", { input = true, alp = 1 } );
    ObjSet( "gfx_deskext_poisons", { active = true } );
    ObjSet( "spr_deskext_themis", { alp = 1 } );
    ObjDelete( "spr_deskext_themis_closed" );
    
    ObjSet( "spr_livingroomext_deskext_themis", { alp = 1 } );
    ObjSet( "spr_livingroomext_deskext_themis_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_themis", use_themis_beg, private.room_objname );
  cmn.AddSubscriber( "use_themis", use_themis_inv );
  cmn.AddSubscriber( "use_themis", use_themis_end, private.room_objname );
  cmn.AddSubscriber( "use_themis_inv", use_themis_inv, private.room_objname );
  cmn.AddSubscriber( "use_themis_beg", use_themis_beg, private.room_objname );
  cmn.AddSubscriber( "use_themis_end", use_themis_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tuningforkext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tuningforkext" ] =
  {
    type = "use",
    use_obj = "inv_tuningforkext",
    use_place = "obj_deskext_use_tuningforkext",
    room = private.room_objname,
    zz = "zz_deskext",
    zz_gate = "gzz_livingroomext_deskext"
  };
  -----------------------------------------------
  local use_tuningforkext_inv = function ()

    int.InventoryItemRemove( "inv_tuningforkext" );

  end;
  local use_tuningforkext_beg = function ()

    ObjDelete( "obj_deskext_use_tuningforkext" );

  end;
  local use_tuningforkext_end = function ()

    ObjSet( "spr_deskext_glass_open", { alp = 1 } );
    ObjSet( "spr_deskext_paints_over", { alp = 1 } );
    ObjSet( "spr_deskext_paints", { input = true } );
    ObjSet( "gfx_deskext_paints", { active = true } );
    ObjDelete( "vid_deskext_use_tuningfork" );
    
    ObjSet( "spr_livingroomext_deskext_paints_open", { alp = 1 } );
    ObjDelete( "spr_livingroomext_deskext_paints" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_tuningforkext", use_tuningforkext_beg, private.room_objname );
  cmn.AddSubscriber( "use_tuningforkext", use_tuningforkext_inv );
  cmn.AddSubscriber( "use_tuningforkext", use_tuningforkext_end, private.room_objname );
  cmn.AddSubscriber( "use_tuningforkext_inv", use_tuningforkext_inv, private.room_objname );
  cmn.AddSubscriber( "use_tuningforkext_beg", use_tuningforkext_beg, private.room_objname );
  cmn.AddSubscriber( "use_tuningforkext_end", use_tuningforkext_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_blade () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_blade" ] =
  {
    type = "use",
    use_obj = "inv_blade",
    use_place = "obj_roomdoorext_use_blade",
    room = private.room_objname,
    zz = "zz_roomdoorext",
    zz_gate = "gzz_livingroomext_roomdoorext"
  };
  -----------------------------------------------
  local use_blade_inv = function ()

    int.InventoryItemRemove( "inv_blade" );

  end;
  local use_blade_beg = function ()

    ObjDelete( "obj_roomdoorext_use_blade" );

  end;
  local use_blade_end = function ()

    ObjSet( "spr_roomdoorext_rope_2_shadow",  { alp = 1 } );
    ObjDelete( "spr_roomdoorext_rope_1_shadow" );
    ObjDelete( "anm_roomdoorext_blade" );
    ObjDelete( "anm_roomdoorext_amulethorror_2_click" );
    
    ObjDelete( "spr_livingroomext_roomdoorext_rope" );
    ObjSet( "spr_livingroomext_roomdoorext_rope_cut",  { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_blade", use_blade_beg, private.room_objname );
  cmn.AddSubscriber( "use_blade", use_blade_inv );
  cmn.AddSubscriber( "use_blade", use_blade_end, private.room_objname );
  cmn.AddSubscriber( "use_blade_inv", use_blade_inv, private.room_objname );
  cmn.AddSubscriber( "use_blade_beg", use_blade_beg, private.room_objname );
  cmn.AddSubscriber( "use_blade_end", use_blade_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_roomkeyext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_roomkeyext" ] =
  {
    type = "use",
    use_obj = "inv_roomkeyext",
    use_place = "obj_roomdoorext_use_roomkeyext",
    room = private.room_objname,
    zz = "zz_roomdoorext",
    zz_gate = "gzz_livingroomext_roomdoorext"
  };
  -----------------------------------------------
  local use_roomkeyext_inv = function ()

    int.InventoryItemRemove( "inv_roomkeyext" );

  end;
  local use_roomkeyext_beg = function ()

    ObjDelete( "obj_roomdoorext_use_roomkeyext" );

  end;
  local use_roomkeyext_end = function ()

    ObjSet( "spr_roomdoorext_roomkeyext_1",   { pos_x = 172, pos_y = -70 } );
    ObjSet( "obj_roomdoorext_clk_roomkeyext", { input = true } );
    
    ObjSet( "spr_livingroomext_roomdoorext_key", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_roomkeyext", use_roomkeyext_beg, private.room_objname );
  cmn.AddSubscriber( "use_roomkeyext", use_roomkeyext_inv );
  cmn.AddSubscriber( "use_roomkeyext", use_roomkeyext_end, private.room_objname );
  cmn.AddSubscriber( "use_roomkeyext_inv", use_roomkeyext_inv, private.room_objname );
  cmn.AddSubscriber( "use_roomkeyext_beg", use_roomkeyext_beg, private.room_objname );
  cmn.AddSubscriber( "use_roomkeyext_end", use_roomkeyext_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bowl_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bowl_1" ] =
  {
    type = "use",
    use_obj = "inv_bowl_1",
    use_place = "obj_windowext_use_bowl_1",
    room = private.room_objname,
    zz = "zz_windowext",
    zz_gate = "gzz_livingroomext_windowext"
  };
  -----------------------------------------------
  local use_bowl_1_inv = function ()

    int.InventoryItemRemove( "inv_bowl_1" );

  end;
  local use_bowl_1_beg = function ()

    ObjDelete( "obj_windowext_use_bowl_1" );

  end;
  local use_bowl_1_end = function ()

    ObjSet( "spr_windowext_scales_part_1", { alp = 1 } );
    ObjSet( "spr_windowext_scales_part_1_shadow", { alp = 1 } );
    ObjSet( "spr_livingroomext_windowext_bowl1", { alp = 1 } );
    if not cmn.IsEventDone( "use_bowl_2" ) then
      ObjSet( "spr_windowext_scales_part", { ang = 0.45 } );
      ObjSet( "spr_windowext_scales_part_1", { ang = -0.45 } );
    else
      ObjSet( "spr_windowext_scales_part", { ang = 0 } );
      ObjSet( "spr_windowext_scales_part_2", { ang = 0 } );
      ObjSet( "obj_windowext_mmg", { input = true } );
    end;  
  
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_bowl_1", use_bowl_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_bowl_1", use_bowl_1_inv );
  cmn.AddSubscriber( "use_bowl_1", use_bowl_1_end, private.room_objname );
  cmn.AddSubscriber( "use_bowl_1_inv", use_bowl_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_bowl_1_beg", use_bowl_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_bowl_1_end", use_bowl_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bowl_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bowl_2" ] =
  {
    type = "use",
    use_obj = "inv_bowl_2",
    use_place = "obj_windowext_use_bowl_2",
    room = private.room_objname,
    zz = "zz_windowext",
    zz_gate = "gzz_livingroomext_windowext"
  };
  -----------------------------------------------
  local use_bowl_2_inv = function ()

    int.InventoryItemRemove( "inv_bowl_2" );

  end;
  local use_bowl_2_beg = function ()

    ObjDelete( "obj_windowext_use_bowl_2" );

  end;
  local use_bowl_2_end = function ()

    ObjSet( "spr_windowext_scales_part_2", { alp = 1 } );
    ObjSet( "spr_windowext_scales_part_2_shadow", { alp = 1 } );
    ObjSet( "spr_livingroomext_windowext_bowl2", { alp = 1 } );
    if not cmn.IsEventDone( "use_bowl_1" ) then
      ObjSet( "spr_windowext_scales_part", { ang = -0.45 } );
      ObjSet( "spr_windowext_scales_part_2", { ang = 0.45 } );
    else
      ObjSet( "spr_windowext_scales_part", { ang = 0 } );
      ObjSet( "spr_windowext_scales_part_1", { ang = 0 } );
      ObjSet( "obj_windowext_mmg", { input = true } );
    end; 

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_bowl_2", use_bowl_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_bowl_2", use_bowl_2_inv );
  cmn.AddSubscriber( "use_bowl_2", use_bowl_2_end, private.room_objname );
  cmn.AddSubscriber( "use_bowl_2_inv", use_bowl_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_bowl_2_beg", use_bowl_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_bowl_2_end", use_bowl_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletviolin () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletviolin" ] =
  {
    type = "use",
    use_obj = "inv_amuletviolin",
    use_place = "obj_windowext_use_amuletviolin",
    room = private.room_objname,
    zz = "zz_windowext",
    zz_gate = "gzz_livingroomext_windowext"
  };
  -----------------------------------------------
  local use_amuletviolin_inv = function ()

    int.InventoryItemRemove( "inv_amuletviolin" );

  end;
  local use_amuletviolin_beg = function ()

    ObjDelete( "obj_windowext_use_amuletviolin" );

  end;
  local use_amuletviolin_end = function ()

    ObjDelete( "spr_windowext_amuletviolin" );
    ObjSet( "obj_windowext_open_violin", { alp = 1, input = true } );
    ObjSet( "spr_windowext_buttonext_1", { active = true } );
    ObjSet( "spr_windowext_phoenixfeather_1", { active = true } );
    
    ObjSet( "spr_livingroomext_windowext_violin_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_amuletviolin", use_amuletviolin_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletviolin", use_amuletviolin_inv );
  cmn.AddSubscriber( "use_amuletviolin", use_amuletviolin_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletviolin_inv", use_amuletviolin_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletviolin_beg", use_amuletviolin_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletviolin_end", use_amuletviolin_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_roomkeyext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_roomkeyext" ] =
  {
    type = "click",
    clk_obj = "obj_roomdoorext_clk_roomkeyext",
    room = private.room_objname,
    zz = "zz_roomdoorext",
    zz_gate = "gzz_livingroomext_roomdoorext"
  };
  -----------------------------------------------
  local clk_roomkeyext_beg = function ()

    ObjDelete( "obj_roomdoorext_clk_roomkeyext" );

  end;
  local clk_roomkeyext_end = function ()

    ObjSet( "grm_livingroomext_basementext", { input = true, active = true, visible = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_livingroomext_basementext_focus");
    end;
    ObjDelete( "obj_roomdoorext_door" );
    ObjDelete( "anm_roomdoorext_door_open" );
    ObjDelete( "anm_roomdoorext_door_click_1" );
    ObjDelete( "anm_roomdoorext_door_click_2" );
    ObjDelete( "gzz_livingroomext_roomdoorext" );
    
    ObjDelete( "spr_livingroomext_roomdoorext_closed" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_roomkeyext", clk_roomkeyext_beg, private.room_objname );
  cmn.AddSubscriber( "clk_roomkeyext", clk_roomkeyext_end, private.room_objname );
  cmn.AddSubscriber( "clk_roomkeyext_beg", clk_roomkeyext_beg, private.room_objname );
  cmn.AddSubscriber( "clk_roomkeyext_end", clk_roomkeyext_end, private.room_objname );
  --*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function win_windowext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_windowext" ] =
  {
    type = "click",
    clk_obj = "spr_windowext_gnome",
    room = private.room_objname,
    zz = "zz_windowext",
    zz_gate = "gzz_livingroomext_windowext"
  };
  --*********************************************************************************************************************
  local win_windowext_inv = function ()

    if ( cmn.IsEventDone( "win_windowext" ) ) then



    end;

  end;
  --*********************************************************************************************************************
  local win_windowext = function ()

    if ( cmn.IsEventDone( "win_windowext" ) ) then
      
      ObjDelete( "anm_windowext_atropos_appear" );
      ObjDelete( "anm_windowext_atropos_static" );
      ObjDelete( "anm_windowext_atropos_static_over" );
      ObjDelete( "anm_windowext_atropos_disapp" );
      ObjSet( "obj_windowext_open_box", { alp = 1, input = true } );
      ObjSet( "spr_windowext_plane_1", { active = true } );
      ObjSet( "obj_windowext_mmg", { input = false } );
      
      ObjSet( "spr_livingroomext_windowext_mmg_open", { alp = 1 } );
      ObjDelete( "spr_livingroomext_windowext_mmg_start" );
      
    end;
    
    if ( cmn.IsEventStart( "win_windowext" ) ) then

      ObjSet( "spr_windowext_scales_part", { ang = ng_global.progress[ "ext" ][ "win_windowext" ].ang } );
      ObjSet( "spr_windowext_scales_part_1", { ang = - ng_global.progress[ "ext" ][ "win_windowext" ].ang } );
      ObjSet( "spr_windowext_scales_part_2", { ang = - ng_global.progress[ "ext" ][ "win_windowext" ].ang } );
      
      ----------------------  
      for i = 1, 3 do

        if ( ng_global.progress[ "ext" ][ "win_windowext" ].left_scales[ i ] ~= 0 ) then
          
          local left_id = ng_global.progress[ "ext" ][ "win_windowext" ].left_scales[ i ];
          
          if left_id ~= 0 then
            
            ObjAttach( "obj_windowext_weight"..left_id, "spr_windowext_scales_part_1");
            ObjSet( "obj_windowext_weight"..left_id, { 
                                                      pos_x = private.left_position[ i ][ left_id ][ 1 ],
                                                      pos_y = private.left_position[ i ][ left_id ][ 2 ], 
                                                      pos_z = i,
                                                     } );
          end;
                                                   
        end;
        -----------------------   
        if ( ng_global.progress[ "ext" ][ "win_windowext" ].right_scales[ i ] ~= 0 ) then  
          
          local right_id = ng_global.progress[ "ext" ][ "win_windowext" ].right_scales[ i ];
          
          if right_id ~= 0 then
            
            ObjAttach( "obj_windowext_weight"..right_id, "spr_windowext_scales_part_2");
            ObjSet( "obj_windowext_weight"..right_id, { 
                                                       pos_x = private.right_position[ i ][ right_id ][ 1 ],
                                                       pos_y = private.right_position[ i ][ right_id ][ 2 ], 
                                                       pos_z = i,
                                                      } );
          end;

        end;

      end;
      ------------------
    end;    
   
  end;

  cmn.AddSubscriber( "win_windowext", win_windowext_inv );
  cmn.AddSubscriber( "win_windowext", win_windowext, private.room_objname );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
function private.get_pliersext ()

  cmn.SetEventDone( "get_pliersext" );
  cmn.CallEventHandler( "get_pliersext" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_amulethorror_1 ()

  cmn.SetEventDone( "get_amulethorror_1" );
  cmn.CallEventHandler( "get_amulethorror_1" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_blade ()

  cmn.SetEventDone( "get_blade" );
  cmn.CallEventHandler( "get_blade" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_amuletbook_2 ()

  cmn.SetEventDone( "get_amuletbook_2" );
  cmn.CallEventHandler( "get_amuletbook_2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_poisons ()

  cmn.SetEventDone( "get_poisons" );
  cmn.CallEventHandler( "get_poisons" );
  
  ObjSet( "spr_deskext_poisons", { alp = 0 } );
  ObjSet( "spr_deskext_poisons2", { alp = 1 } );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_paints ()

  cmn.SetEventDone( "get_paints" );
  cmn.CallEventHandler( "get_paints" );
  
  cmn.GetObjectSfx();
  ObjSet( "spr_deskext_paints", { alp = 1 } );
  ObjSet( "spr_deskext_paints_over", { alp = 0 } );
  
  cmn.CloseSubRoom();

end;
-------------------------------------------------
function private.get_amulethorror_2 ()

  cmn.SetEventDone( "get_amulethorror_2" );
  cmn.CallEventHandler( "get_amulethorror_2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_deskhandleext ()

  cmn.SetEventDone( "get_deskhandleext" );
  cmn.CallEventHandler( "get_deskhandleext" );
  
  cmn.GetObjectSfx();
  
  if ( cmn.IsEventDone( "get_deskhandleext" ) and
     cmn.IsEventDone( "get_themis" ) and
     cmn.IsEventDone( "get_plane_1" ) and
     cmn.IsEventDone( "get_buttonext_1" ) and
     cmn.IsEventDone( "get_trebleclef" ) and
     cmn.IsEventDone( "get_phoenixfeather_1" ) ) then
     
    cmn.CloseSubRoom();
  
  end;

end;
-------------------------------------------------
function private.get_themis ()

  cmn.SetEventDone( "get_themis" );
  cmn.CallEventHandler( "get_themis" );
  
  cmn.GetObjectSfx();
  if ( cmn.IsEventDone( "get_deskhandleext" ) and
       cmn.IsEventDone( "get_themis" ) and
       cmn.IsEventDone( "get_plane_1" ) and
       cmn.IsEventDone( "get_buttonext_1" ) and
       cmn.IsEventDone( "get_trebleclef" ) and
       cmn.IsEventDone( "get_phoenixfeather_1" ) ) then
     
    cmn.CloseSubRoom();
  
  end;

end;
-------------------------------------------------
function private.get_plane_1 ()

  cmn.SetEventDone( "get_plane_1" );
  cmn.CallEventHandler( "get_plane_1" );
  
  cmn.GetObjectSfx();
  
  if ( cmn.IsEventDone( "get_deskhandleext" ) and
       cmn.IsEventDone( "get_themis" ) and
       cmn.IsEventDone( "get_plane_1" ) and
       cmn.IsEventDone( "get_buttonext_1" ) and
       cmn.IsEventDone( "get_trebleclef" ) and
       cmn.IsEventDone( "get_phoenixfeather_1" ) ) then
     
    cmn.CloseSubRoom();
  
  end;

end;
-------------------------------------------------
function private.get_buttonext_1 ()

  cmn.SetEventDone( "get_buttonext_1" );
  cmn.CallEventHandler( "get_buttonext_1" );
  
  cmn.GetObjectSfx();
  
  if ( cmn.IsEventDone( "get_deskhandleext" ) and
       cmn.IsEventDone( "get_themis" ) and
       cmn.IsEventDone( "get_plane_1" ) and
       cmn.IsEventDone( "get_buttonext_1" ) and
       cmn.IsEventDone( "get_trebleclef" ) and
       cmn.IsEventDone( "get_phoenixfeather_1" ) ) then
     
    cmn.CloseSubRoom();
  
  end;

end;
-------------------------------------------------
function private.get_trebleclef ()

  cmn.SetEventDone( "get_trebleclef" );
  cmn.CallEventHandler( "get_trebleclef" );
  
  cmn.GetObjectSfx();
  if ( cmn.IsEventDone( "get_deskhandleext" ) and
       cmn.IsEventDone( "get_themis" ) and
       cmn.IsEventDone( "get_plane_1" ) and
       cmn.IsEventDone( "get_buttonext_1" ) and
       cmn.IsEventDone( "get_trebleclef" ) and
       cmn.IsEventDone( "get_phoenixfeather_1" ) ) then
     
    cmn.CloseSubRoom();
  
  end;

end;
-------------------------------------------------
function private.get_phoenixfeather_1 ()

  cmn.SetEventDone( "get_phoenixfeather_1" );
  cmn.CallEventHandler( "get_phoenixfeather_1" );
  
  cmn.GetObjectSfx();
  if ( cmn.IsEventDone( "get_deskhandleext" ) and
       cmn.IsEventDone( "get_themis" ) and
       cmn.IsEventDone( "get_plane_1" ) and
       cmn.IsEventDone( "get_buttonext_1" ) and
       cmn.IsEventDone( "get_trebleclef" ) and
       cmn.IsEventDone( "get_phoenixfeather_1" ) ) then
     
    cmn.CloseSubRoom();
  
  end;

end;
--*********************************************************************************************************************
-------------------------------------------------
function public.use_amulethorror_1 ()

  local item = "inv_amulethorror_1";

  if ( cmn.ApplyObj( item, "gzz_livingroomext_horrorhouse", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_horrorhouse" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_horrorhouse_use_amulethorror_1", true ) ) then

    cmn.CallEventHandler( "use_amulethorror_1_inv" );
    cmn.CallEventHandler( "use_amulethorror_1_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_amulethorror_1" );
      cmn.CallEventHandler( "use_amulethorror_1_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_insert_smileface" );
    
    if ( cmn.IsEventDone( "use_amulethorror_2" ) ) then
      
      local func_end1 = function ()
      
        local func_end = function ()
        
          cmn.SetEventDone( "use_amulethorror_1" );
          cmn.CallEventHandler( "use_amulethorror_1_end" );
          int.Lock( false );
          cmn.CloseSubRoom();
          
        end;
        
        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_chainsbroke" );
      
        ObjSet( "anm_horrorhouse_house_amulets", { alp = 0 } );
        ObjSet( "anm_horrorhouse_house_open", { alp = 1 } );
        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_open_evil_house" );
        AnimPlay( "anm_horrorhouse_house_open", "DoAnim", func_end ); 
        
      end;
    
      AnimStop( "anm_horrorhouse_house_amulet_horror_2" ); 
      ObjSet( "anm_horrorhouse_house_amulet_horror_2", { playing = true } );
      ObjSet( "anm_horrorhouse_house_amulets", { playing = true } );
      
      ObjAnimate( "anm_horrorhouse_house_amulet_horror_2", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0,
      } );
      ObjAnimate( "anm_horrorhouse_house_amulets", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0,
      } );
      
      ObjSet( "tmr_horrorhouse_anims", { playing = 1, time = 2.0, endtrig = func_end1 } ); 

    else
      
      AnimStop( "anm_horrorhouse_house_amulets_empty" ); 
      ObjSet( "anm_horrorhouse_house_amulets_empty", { playing = true } );
      ObjSet( "anm_horrorhouse_house_amulet_horror_1", { playing = true } );
      
      ObjAnimate( "anm_horrorhouse_house_amulets_empty", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0,
      } );
      ObjAnimate( "anm_horrorhouse_house_amulet_horror_1", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0,
      } );

    end;

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_amulethorror_2 ()

  local item = "inv_amulethorror_2";

  if ( cmn.ApplyObj( item, "gzz_livingroomext_horrorhouse", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_horrorhouse" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_horrorhouse_use_amulethorror_2", true ) ) then

    cmn.CallEventHandler( "use_amulethorror_2_inv" );
    cmn.CallEventHandler( "use_amulethorror_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_amulethorror_2" );
      cmn.CallEventHandler( "use_amulethorror_2_end" );
      int.Lock( false );
      
    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_insert_smileface" );
    
    if ( cmn.IsEventDone( "use_amulethorror_1" ) ) then

      local func_end1 = function ()
      
        local func_end = function ()
        
          cmn.SetEventDone( "use_amulethorror_2" );
          cmn.CallEventHandler( "use_amulethorror_2_end" );
          int.Lock( false );
          cmn.CloseSubRoom();
          
        end;
        
        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_chainsbroke" );
      
        ObjSet( "anm_horrorhouse_house_amulets", { alp = 0 } );
        ObjSet( "anm_horrorhouse_house_open", { alp = 1 } );
        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_open_evil_house" );
        AnimPlay( "anm_horrorhouse_house_open", "DoAnim", func_end ); 
        
      end;
    
      AnimStop( "anm_horrorhouse_house_amulet_horror_1" ); 
      ObjSet( "anm_horrorhouse_house_amulet_horror_1", { playing = true } );
      ObjSet( "anm_horrorhouse_house_amulets", { playing = true } );
      
      ObjAnimate( "anm_horrorhouse_house_amulet_horror_1", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0,
      } );
      ObjAnimate( "anm_horrorhouse_house_amulets", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0,
      } );
      
      ObjSet( "tmr_horrorhouse_anims", { playing = 1, time = 2.0, endtrig = func_end1 } ); 

    else

      AnimStop( "anm_horrorhouse_house_amulets_empty" ); 
      ObjSet( "anm_horrorhouse_house_amulets_empty", { playing = true } );
      ObjSet( "anm_horrorhouse_house_amulet_horror_2", { playing = true } );
      
      ObjAnimate( "anm_horrorhouse_house_amulets_empty", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0,
      } );
      ObjAnimate( "anm_horrorhouse_house_amulet_horror_2", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0,
      } );

    end;

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_pliersext ()

  local item = "inv_pliersext";

  if ( cmn.ApplyObj( item, "gzz_livingroomext_kitchendoorext", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_kitchendoorext" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_kitchendoorext_use_pliersext", true ) ) then

    cmn.CallEventHandler( "use_pliersext_inv" );
    cmn.CallEventHandler( "use_pliersext_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_pliersext" );
      cmn.CallEventHandler( "use_pliersext_end" );
      int.Lock( false );
      private.get_amulethorror_1();
      
    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_removenails" );

    ObjSet( "spr_kitchendoorext_amulethorror_1_shadow", { alp = 0 } );
    ObjSet( "spr_kitchendoorext_amulethorror_1",        { alp = 0, pos_x = -180, pos_y = 290 } );
    ObjSet( "anm_kitchendoorext_pliersext",             { alp = 1 } );
    
    AnimPlay( "anm_kitchendoorext_pliersext", "DoAnim", func_end );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_amuletfire_1 ()

  local item = "inv_amuletfire_1";

  if ( cmn.ApplyObj( item, "gzz_livingroomext_kitchendoorext", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_kitchendoorext" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_kitchendoorext_use_amuletfire_1", true ) ) then

    cmn.CallEventHandler( "use_amuletfire_1_inv" );
    cmn.CallEventHandler( "use_amuletfire_1_beg" );
    int.Lock( true );

    local func_end = function ()
      
    if ( cmn.IsEventDone( "use_amuletfire_2" ) ) then
        
        cmn.CloseSubRoom();
        private.DoorCombustion( 1 );                        

      else
        
        cmn.SetEventDone( "use_amuletfire_1" );
        cmn.CallEventHandler( "use_amuletfire_1_end" );
        int.Lock( false );
        
      end;
      
    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_light" ); 
    ObjAnimate( "spr_kitchendoorext_fire_amulet1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_amuletfire_2 ()

  local item = "inv_amuletfire_2";

  if ( cmn.ApplyObj( item, "gzz_livingroomext_kitchendoorext", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_kitchendoorext" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_kitchendoorext_use_amuletfire_2", true ) ) then

    cmn.CallEventHandler( "use_amuletfire_2_inv" );
    cmn.CallEventHandler( "use_amuletfire_2_beg" );
    int.Lock( true );

    local func_end = function ()
      
      if ( cmn.IsEventDone( "use_amuletfire_1" ) ) then
        
        cmn.CloseSubRoom();
        private.DoorCombustion( 2 );                        

      else
        
        cmn.SetEventDone( "use_amuletfire_2" );
        cmn.CallEventHandler( "use_amuletfire_2_end" );
        int.Lock( false );
        
      end;
      
    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_light" ); 
    ObjAnimate( "spr_kitchendoorext_fire_amulet2", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_deskhandleext ()

  local item = "inv_deskhandleext";

  if ( cmn.ApplyObj( item, "gzz_livingroomext_deskext", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_deskext" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_deskext_use_deskhandleext", true ) ) then

    cmn.CallEventHandler( "use_deskhandleext_inv" );
    cmn.CallEventHandler( "use_deskhandleext_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_deskhandleext" );
      cmn.CallEventHandler( "use_deskhandleext_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_insert_handle_house" );
    ObjAnimate("spr_deskext_deskhandle", "alp", 0, 0, "", 
    {
      0.0,0,0,
      0.3,0,1,
      0.6,0,1,
      0.9,0,0
    });
    ObjAnimate("obj_deskext_open_box", "alp", 0, 0, func_end, 
    {
      0.0,0,0,
      0.6,0,0,
      0.9,0,1
    });
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_themis ()

  local item = "inv_themis";

  if ( cmn.ApplyObj( item, "gzz_livingroomext_deskext", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_deskext" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_deskext_use_themis", true ) ) then

    cmn.CallEventHandler( "use_themis_inv" );
    cmn.CallEventHandler( "use_themis_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_themis" );
      cmn.CallEventHandler( "use_themis_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_statue" );
    ObjAnimate("spr_deskext_themis", "alp", 0, 0, "", 
    {
      0.0,0,0,
      0.3,0,1
    });
    ObjAnimate("spr_deskext_themis_closed", "alp", 0, 0, "", 
    {
      0.0,0,1,      
      0.5,0,1,
      0.8,0,0
    });
    ObjAnimate("obj_deskext_open_themis", "alp", 0, 0, func_end, 
    {
      0.0,0,0,      
      0.5,0,0,
      0.8,0,1
    });
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_tuningforkext ()

  local item = "inv_tuningforkext";

  if ( cmn.ApplyObj( item, "gzz_livingroomext_deskext", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_deskext" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_deskext_use_tuningforkext", true ) ) then

    cmn.CallEventHandler( "use_tuningforkext_inv" );
    cmn.CallEventHandler( "use_tuningforkext_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_tuningforkext" );
      cmn.CallEventHandler( "use_tuningforkext_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_fork" );
    ObjSet( "vid_deskext_use_tuningfork", { alp = 1 } );
    VidPlay( "vid_deskext_use_tuningfork", func_end );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_blade ()

  local item = "inv_blade";

  if ( cmn.ApplyObj( item, "gzz_livingroomext_roomdoorext", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_roomdoorext" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_roomdoorext_use_blade", true ) ) then

    cmn.CallEventHandler( "use_blade_inv" );
    cmn.CallEventHandler( "use_blade_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_blade" );
      cmn.CallEventHandler( "use_blade_end" );
      int.Lock( false );

      ObjSet( "obj_roomdoorext_door",  { alp = 1 } );
      private.get_amulethorror_2();
      
    end;

    ObjSet( "obj_roomdoorext_door",  { alp = 0 } );
    ObjSet( "anm_roomdoorext_blade", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_cut_rope" );
    AnimPlay( "anm_roomdoorext_blade", "DoAnim", func_end );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_roomkeyext ()

  local item = "inv_roomkeyext";

  if ( cmn.ApplyObj( item, "gzz_livingroomext_roomdoorext", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_roomdoorext" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_roomdoorext_use_roomkeyext", true ) ) then

    cmn.CallEventHandler( "use_roomkeyext_inv" );
    cmn.CallEventHandler( "use_roomkeyext_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_roomkeyext" );
      cmn.CallEventHandler( "use_roomkeyext_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_insert_strange_key" );
    ObjAnimate( "spr_roomdoorext_roomkeyext_1", "pos_xy", 0, 0, func_end,
    { 
      0.0, 3, 335,  24,
      0.7, 3, 172, -70,
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_bowl_1 ()

  local item = "inv_bowl_1";

  if ( cmn.ApplyObj( item, "gzz_livingroomext_windowext", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_windowext" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_windowext_use_bowl_1", true ) ) then

    cmn.CallEventHandler( "use_bowl_1_inv" );
    cmn.CallEventHandler( "use_bowl_1_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_bowl_1" );
      cmn.CallEventHandler( "use_bowl_1_end" );
      int.Lock( false );
      
      if cmn.IsEventDone( "use_bowl_2" ) then
        
        ng_global.progress[ "ext" ][ "win_windowext" ].left_scales = { 0, 0, 0 };
        ng_global.progress[ "ext" ][ "win_windowext" ].right_scales = { 0, 0, 0 };
        ng_global.progress[ "ext" ][ "win_windowext" ].ang = 0;
        cmn.MiniGameShow( "windowext" );
        common_impl.PassingMgStart( "windowext" );
        
      end;  

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_app_saucer1" );   
    
    if not cmn.IsEventDone( "use_bowl_2" ) then

      ObjAnimate( "spr_windowext_scales_part", "ang", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 0.45
      } );
      ObjAnimate( "spr_windowext_scales_part_1", "ang", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, -0.45
      } );
    else 
      
      ObjAnimate( "spr_windowext_scales_part", "ang", 0, 0, "",
      { 
        0.0, 0, -0.45, 
        0.3, 0, 0
      } );
      ObjAnimate( "spr_windowext_scales_part_2", "ang", 0, 0, "",
      { 
        0.0, 0, 0.45, 
        0.3, 0, 0
      } );
     
    end;
    
    ObjAnimate( "spr_windowext_scales_part_1_shadow", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_windowext_scales_part_1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_bowl_2 ()

  local item = "inv_bowl_2";

  if ( cmn.ApplyObj( item, "gzz_livingroomext_windowext", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_windowext" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_windowext_use_bowl_2", true ) ) then

    cmn.CallEventHandler( "use_bowl_2_inv" );
    cmn.CallEventHandler( "use_bowl_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_bowl_2" );
      cmn.CallEventHandler( "use_bowl_2_end" );
      int.Lock( false );
      
      if cmn.IsEventDone( "use_bowl_1" ) then
        
        ng_global.progress[ "ext" ][ "win_windowext" ].left_scales = { 0, 0, 0 };
        ng_global.progress[ "ext" ][ "win_windowext" ].right_scales = { 0, 0, 0 };
        ng_global.progress[ "ext" ][ "win_windowext" ].ang = 0;
        cmn.MiniGameShow( "windowext" );
        common_impl.PassingMgStart( "windowext" );
        
      end;  

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_app_saucer2" );   
    if not cmn.IsEventDone( "use_bowl_1" ) then

      ObjAnimate( "spr_windowext_scales_part", "ang", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, -0.45
      } );
      ObjAnimate( "spr_windowext_scales_part_2", "ang", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 0.45
      } );
      
    else 
      
      ObjAnimate( "spr_windowext_scales_part", "ang", 0, 0, "",
      { 
        0.0, 0, 0.45, 
        0.3, 0, 0
      } );
      ObjAnimate( "spr_windowext_scales_part_1", "ang", 0, 0, "",
      { 
        0.0, 0, -0.45, 
        0.3, 0, 0
      } );
      
    end;

    ObjAnimate( "spr_windowext_scales_part_2_shadow", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_windowext_scales_part_2", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_amuletviolin ()

  local item = "inv_amuletviolin";

  if ( cmn.ApplyObj( item, "gzz_livingroomext_windowext", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_windowext" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_windowext_use_amuletviolin", true ) ) then

    cmn.CallEventHandler( "use_amuletviolin_inv" );
    cmn.CallEventHandler( "use_amuletviolin_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_amuletviolin" );
      cmn.CallEventHandler( "use_amuletviolin_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_violin" );

    ObjAnimate( "spr_windowext_amuletviolin", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0, 
      0.6, 0, 1.0,
      0.9, 0, 0.0
    } );
    ObjAnimate( "obj_windowext_open_violin", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 0.0, 
      0.6, 0, 0.0,
      0.9, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
function private.clk_roomkeyext ()

  cmn.CallEventHandler( "clk_roomkeyext_beg" );
  int.Lock( true );

  local func_end = function ()

    cmn.SetEventDone( "clk_roomkeyext" );
    cmn.CallEventHandler( "clk_roomkeyext_end" );
    int.Lock( false );

    cmn.CloseSubRoom();

  end;

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_rotate_strange_key" );

  ObjAnimate( "spr_roomdoorext_roomkeyext_1", "alp", 0, 0, "",
  { 
    0.0, 3, 1.0, 
    0.3, 3, 0.0,
  } );

  ObjAnimate( "spr_roomdoorext_roomkeyext_2", "alp", 0, 0, "",
  { 
    0.0, 3, 0.0, 
    0.3, 3, 1.0,
  } );

  ObjAnimate( "obj_roomdoorext_door", "alp", 0, 0, "",
  { 
    0.0, 3, 1.0, 
    0.3, 3, 1.0,
    0.3, 3, 0.0,
  } );

  ObjAnimate( "spr_roomdoorext_catch_shadow", "alp", 0, 0, "",
  { 
    0.0, 3, 1.0, 
    0.3, 3, 0.0,
  } );

  ObjAnimate( "spr_roomdoorext_catch", "pos_xy", 0, 0, "",
  { 
    0.0, 3, 199, -131, 
    0.3, 3, 183, -126,
  } );
  
  ObjAnimate( "anm_roomdoorext_door_open", "alp", 0, 0,
  function ()
    
    AnimPlay( "anm_roomdoorext_door_open", "DoAnim", func_end );

  end,
  { 
    0.0, 3, 0.0, 
    0.3, 3, 0.0,
    0.3, 3, 1.0,
    0.5, 3, 1.0,
  } );
  
end;
-------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_livingroomext ()

  if not ( cmn.IsEventDone( "opn_livingroomext" ) ) then

    cmn.SetEventDone( "opn_livingroomext" );
    cmn.ShowBbt( "bbt_livingroomext_first_open" );
    
    cmn.AddPageDiary( 22 );
    
    int_dialog_task.UpdateHourglassStage( false );
    ng_global.progress[ "ext" ][ "opn_livingroomext" ].see_hourglass2 = 0;
    
    cmn.PlayAudio( "mus", "audio/aud_all_is_lost_much_mus" );

  end;

end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_livingroomext();
  
  cmn.StopAllEnv( "audio/level4/env/aud_livingroomext_env", true );
  cmn.PlayAudio( "env", "audio/level4/env/aud_livingroomext_env", 1, 2.5 );  
  
  if ( cmn.IsEventDone( "get_roomkeyext" ) ) and ( ng_global.progress[ "ext" ][ "opn_livingroomext" ].see_hourglass2 == 0 ) then
    int_dialog_task.UpdateHourglassStage( false );
    ng_global.progress[ "ext" ][ "opn_livingroomext" ].see_hourglass2 = 1;
  end;

end;
--*********************************************************************************************************************
function public.Task ()
  
  int.AddedTaskMap( private.room_objname, "get_pliersext",                                       { "win_mirrors" } );
  int.AddedTaskMap( private.room_objname, "get_amulethorror_1",                                  { "use_pliersext" } );
  int.AddedTaskMap( private.room_objname, "get_blade",                                           { "use_deskhandleext" } );
  int.AddedTaskMap( private.room_objname, "get_amuletbook_2",                                    { "use_deskhandleext" } );
  int.AddedTaskMap( private.room_objname, "get_poisons",                                         { "use_themis" } );
  int.AddedTaskMap( private.room_objname, "get_paints",                                          { "use_tuningforkext" } );
  int.AddedTaskMap( private.room_objname, "get_amulethorror_2",                                  { "use_blade" } );
  int.AddedTaskMap( private.room_objname, "get_deskhandleext" );
  int.AddedTaskMap( private.room_objname, "get_themis",                                          { "get_plane_1" } );
  int.AddedTaskMap( private.room_objname, "get_plane_1",                                         { "win_windowext" } );
  int.AddedTaskMap( private.room_objname, "get_buttonext_1",                                     { "use_amuletviolin" } );
  int.AddedTaskMap( private.room_objname, "get_trebleclef",                                      { "get_buttonext_1" } );
  int.AddedTaskMap( private.room_objname, "get_phoenixfeather_1",                                { "use_amuletviolin" } );
  
  int.AddedTaskMap( private.room_objname, "use_amulethorror_1",                                  { "get_amulethorror_1" } );
  int.AddedTaskMap( private.room_objname, "use_amulethorror_2",                                  { "get_amulethorror_2" } );
  int.AddedTaskMap( private.room_objname, "use_pliersext",                                       { "get_pliersext" } );
  int.AddedTaskMap( private.room_objname, "use_amuletfire_1",                                    { "win_house"} );
  int.AddedTaskMap( private.room_objname, "use_amuletfire_2",                                    { "get_amuletfire_2" } );
  int.AddedTaskMap( private.room_objname, "use_deskhandleext",                                   { "get_deskhandleext" } );
  int.AddedTaskMap( private.room_objname, "use_themis",                                          { "get_themis" } );
  int.AddedTaskMap( private.room_objname, "use_tuningforkext",                                   { "get_tuningforkext" } );
  int.AddedTaskMap( private.room_objname, "use_blade",                                           { "get_blade" } );
  int.AddedTaskMap( private.room_objname, "use_roomkeyext",                                      { "get_roomkeyext" } );
  int.AddedTaskMap( private.room_objname, "use_bowl_1",                                          { "get_bowl_1" } );
  int.AddedTaskMap( private.room_objname, "use_bowl_2",                                          { "get_bowl_2" } );
  int.AddedTaskMap( private.room_objname, "use_amuletviolin",                                    { "get_amuletviolin" } );
  
  int.AddedTaskMap( private.room_objname, "clk_roomkeyext",                                      { "use_roomkeyext" } );
  
  int.AddedTaskMap( private.room_objname, "win_windowext",                                       { "use_bowl_1", "use_bowl_2" } );
  int.AddedTaskMap( private.room_objname, "win_house",                                           { "use_amulethorror_1", "use_amulethorror_2" } );
  
  int.AddedTaskMap( private.room_objname, "opn_kitchenext",                                      { "use_amuletfire_1", "use_amuletfire_2" } );
  int.AddedTaskMap( private.room_objname, "opn_basementext",                                     { "clk_roomkeyext" } );
  
end;
--*********************************************************************************************************************
function private.DoorCombustion ( num )

  local func_end = function ()
  
    ObjSet( "spr_livingroomext_kitchendoorext_open", { alp = 1 } );
    ObjAnimate("vid_livingroom_kitchendoorext_combustion", "alp", 0, 0, 
    function ()
      cmn.SetEventDone( "use_amuletfire_"..num );
      cmn.CallEventHandler( "use_amuletfire_"..num.."_end" );
      int.Lock( false );      
    end, 
    {
      0.0,0,1,
      0.2,0,0
    });

  end;

  int.Lock( true );

  ObjSet( "gzz_livingroomext_kitchendoorext", { alp = 0, input = false } );
  ObjSet( "vid_livingroom_kitchendoorext_combustion", { alp = 1 } );  
  VidPlay( "vid_livingroom_kitchendoorext_combustion", func_end );
  VidPlay( "vid_livingroom_kitchendoorext_combustion_add", "" );

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_open_kitchen" );  

end;
--*********************************************************************************************************************
function private.InitSubroom ()
  
  subroom.Define( "zz_windowext" );
  -------------------------------------------------
  function zz_windowext.Open()

    if ( cmn.IsEventStart( "win_windowext" ) and not cmn.IsEventDone( "win_windowext" ) ) then

      cmn.MiniGameShow( "windowext" );
      common_impl.PassingMgStart( "windowext" );

    end;

  end;
  -------------------------------------------------
  function zz_windowext.PreClose()

    if ( cmn.IsEventStart( "win_windowext" ) and not cmn.IsEventDone( "win_windowext" ) ) then

      cmn.MiniGameHide( "windowext" );
      common_impl.PassingMgStop( "windowext" );

    end;

  end;
  -------------------------------------------------
  function zz_windowext.Skip ()
    
    ObjSet( "spr_windowext_scales_part", { ang = 0 } );
    ObjSet( "spr_windowext_scales_part_1", { ang = 0 } );
    ObjSet( "spr_windowext_scales_part_2", { ang = 0 } );
    
    ng_global.progress[ "ext" ][ "win_windowext" ].left_scales = { 1, 4, 6 };
    ng_global.progress[ "ext" ][ "win_windowext" ].right_scales = { 2, 3, 5 };
    ng_global.progress[ "ext" ][ "win_windowext" ].ang = 0;

    for i = 1, 3 do
      
      if ( ng_global.progress[ "ext" ][ "win_windowext" ].left_scales[ i ] ~= 0 ) then
        
        local left_id = ng_global.progress[ "ext" ][ "win_windowext" ].left_scales[ i ];
        
        if left_id ~= 0 then
          ObjAttach( "obj_windowext_weight"..left_id, "spr_windowext_scales_part_1");
          ObjSet( "obj_windowext_weight"..left_id, { 
                                                    pos_x = private.left_position[ i ][ left_id ][ 1 ],
                                                    pos_y = private.left_position[ i ][ left_id ][ 2 ], 
                                                    pos_z = i,
                                                    input = false
                                                   } );
        end;
                                             
        local right_id = ng_global.progress[ "ext" ][ "win_windowext" ].right_scales[ i ];
        
        if right_id ~= 0 then
          ObjAttach( "obj_windowext_weight"..right_id, "spr_windowext_scales_part_2");
          ObjSet( "obj_windowext_weight"..right_id, { 
                                                     pos_x = private.right_position[ i ][ right_id ][ 1 ],
                                                     pos_y = private.right_position[ i ][ right_id ][ 2 ], 
                                                     pos_z = i,
                                                     input = false
                                                    } );
        end;

      end;
      
    end;
                                              
    private.WindowextWin()
    
  end;
  -------------------------------------------------
  function zz_windowext.Reset ()
    
    for i = 1, 6 do
      
      ObjAttach( "obj_windowext_weight"..i, "obj_windowext_weights");
      ObjSet( "obj_windowext_weight"..i, { pos_x = 0, pos_y = 0, pos_z = i, input = true } );
      
    end;
    
    ng_global.progress[ "ext" ][ "win_windowext" ].left_scales = { 0, 0, 0 };
    ng_global.progress[ "ext" ][ "win_windowext" ].right_scales = { 0, 0, 0 };
    ng_global.progress[ "ext" ][ "win_windowext" ].ang = 0;
    
    ObjSet( "spr_windowext_scales_part", { ang = 0 } );
    ObjSet( "spr_windowext_scales_part_1", { ang = 0 } );
    ObjSet( "spr_windowext_scales_part_2", { ang = 0 } );
    
  end;
  -------------------------------------------------
end  
--*********************************************************************************************************************
function private.RoomdoorextAmulethorrorClick ()

  int.Lock( true );

  local func_end = function ()

    cmn.ShowBbt( "bbt_roomdoorext_use_blade" );
    int.Lock( false );
    
    ObjSet( "obj_roomdoorext_door",                 { alp = 1 } );
    ObjSet( "anm_roomdoorext_amulethorror_2_click", { alp = 0 } );

  end;

  ObjSet( "obj_roomdoorext_door",                 { alp = 0 } );
  ObjSet( "anm_roomdoorext_amulethorror_2_click", { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_touch_something" );
  AnimPlay( "anm_roomdoorext_amulethorror_2_click", "DoAnim", func_end );
  
end;
--*********************************************************************************************************************
function private.RoomdoorextDoorClick ()

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_touch_gate_grill" );
  local func_end = function ()

    cmn.ShowBbt( "bbt_roomdoorext_use_roomkeyext" );
    int.Lock( false );
    
    ObjSet( "obj_roomdoorext_door",         { alp = 1 } );
    ObjSet( "anm_roomdoorext_door_click_1", { alp = 0 } );
    ObjSet( "anm_roomdoorext_door_click_2", { alp = 0 } );

  end;

  ObjSet( "obj_roomdoorext_door", { alp = 0 } );
  
  if ( not cmn.IsEventDone( "get_amulethorror_2" ) ) then
  
    ObjSet( "anm_roomdoorext_door_click_1", { alp = 1 } );
    AnimPlay( "anm_roomdoorext_door_click_1", "DoAnim", func_end );
  
  else

    ObjSet( "anm_roomdoorext_door_click_2", { alp = 1 } );
    AnimPlay( "anm_roomdoorext_door_click_2", "DoAnim", func_end );
    
  end;
  
end;
--*********************************************************************************************************************
function private.LivingroomextMannequinClick ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );
    
    ObjSet( "obj_livingroomext_mannequin", { input = false } );
    
  end;

  AnimPlay( "anm_livingroomext_mannequin", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.KitchendoorextAmulethorrorClick ()

  int.Lock( true );

  local func_end = function ()

    cmn.ShowBbt( "bbt_kitchendoor_use_pliersext" );
    int.Lock( false );
    
  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_pumpkin" );

  ObjAnimate("spr_kitchendoorext_amulethorror_1", "ang", 0, 0, func_end, 
  {
    0.0,0,0,
    0.2,2,-0.02,
    0.4,3,0.02,
    0.6,1,0
  });

  ObjAnimate("spr_kitchendoorext_amulethorror_1_shadow", "ang", 0, 0, "", 
  {
    0.0,0,0,
    0.2,2,-0.02,
    0.4,3,0.02,
    0.6,1,0
  });
  
end;
--*********************************************************************************************************************
function private.InitAnims ()

  ObjAnimate( "spr_horrorhouse_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_livingroomext_lavalight_add", "alp", 1, 0, "", 
  {
    0.0, 0, 1.0,
    1.0, 0, 1.0,
    1.5, 0, 0.8,
    1.8, 0, 1.0,
    3.6, 0, 1.0,
    4.0, 0, 0.7,
    4.3, 0, 1.0  
  } );
  
  ObjAnimate( "spr_livingroomext_lavalight_add2", "alp", 1, 0, "", 
  {
    0.0, 0, 1.0,
    1.5, 0, 0.7,
    2.0, 0, 1.0,
    3.0, 0, 1.0,
    3.2, 0, 0.9,
    3.4, 0, 1.0
  } );
  
  ObjAnimate( "spr_windowext_add_glass", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    2.0, 3, 0.6,
    4.0, 3, 1.0,
  } );
  
  ObjAnimate( "spr_windowext_add_light", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    2.0, 3, 0.6,
    4.0, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG WINDOWEXT *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.InitWindowext ()
    
    private.weight = { 13, 10, 7, 6, 4, 2 };--вес каждой гири
    
    for i = 1, 6 do
      
      ObjSet( "spr_windowext_weight"..i, { event_mdown = function() private.ClkWeight( i ) end } );
      ObjSet( "spr_windowext_weight"..i, { event_dragdrop = function() private.DropWeight( i ) end } );

    end;
        
    private.win_left_scales = { 1, 4, 6 };
    private.win_right_scales = { 2, 3, 5 };
        
    private.left_position = { 
                              { { - 20, 1 },{ - 201, -58 },{ 23, 6 },{ - 8, -107 },{ - 60, -107 },{ - 17, -126 } },
                              { { 48, 2 },{ - 156, - 56 },{ 77, - 10 },{ 41, - 106 },{ -4, - 103 },{ 37, - 126 } },
                              { { 13, 25 }, { -175, -32 }, { 55, 14 }, { 22, -79 }, { -22, -76 }, { 15, -95 } }
                            };
                              
    private.right_position = { 
                              { { - 15, 2 },{ -210, -52 },{ 23, -11 },{ - 15, -105 },{ - 68, -103 },{ - 21, -128 } },
                              { { 33, 1 },{  -153, - 56 },{ 85, - 14 },{ 54, - 111 },{ 0, - 108 },{ 43, - 125 } },
                              { { 11, 22 }, { -175, -30 }, { 59, 16 }, { 20, -76 }, { -23, -74 }, { 18, -94} }
                             };
    
                           end;
  --*********************************************************************************************************************
  function private.ClkWeight ( id )
    
    ObjSet( "obj_windowext_weight"..id, { pos_z = 50 } );
    ObjSet( "spr_windowext_weight_shadow"..id, { alp = 0 } );
    
    local left_count = 0;
    local right_count = 0;
    
    for i = 1, 3 do
      
      if ng_global.progress[ "ext" ][ "win_windowext" ].left_scales[ i ] == id then--если берем груз с левой чаши
        
        ng_global.progress[ "ext" ][ "win_windowext" ].left_scales[ i ] = 0;
        
        for j = 1, 3 do
          
          local left_number = ng_global.progress[ "ext" ][ "win_windowext" ].left_scales[ j ];
          
          if left_number ~= 0 then
            local left_weight = private.weight[ left_number ];
            left_count = left_count + left_weight;--общий вес на левой чаше
          end;
          
          local right_number = ng_global.progress[ "ext" ][ "win_windowext" ].right_scales[ j ];
          
          if right_number ~= 0 then
            local right_weight = private.weight[ right_number ];
            right_count = right_count + right_weight;--общий вес на правой чаше
          end;
          
        end;
        
        private.CompareWeight ( left_count, right_count );--функция сравнивает веса, а потом выставляет угол весов
        ObjAttach( "obj_windowext_weight"..id, "obj_windowext_weights");

        return;
               
      end;
    
      if ng_global.progress[ "ext" ][ "win_windowext" ].right_scales[ i ] == id then
        
        ng_global.progress[ "ext" ][ "win_windowext" ].right_scales[ i ] = 0;
        
        for j = 1, 3 do
          
          local left_number = ng_global.progress[ "ext" ][ "win_windowext" ].left_scales[ j ];
          if left_number ~= 0 then
            local left_weight = private.weight[ left_number ];
            left_count = left_count + left_weight;
          end;
          
          local right_number = ng_global.progress[ "ext" ][ "win_windowext" ].right_scales[ j ];
          if right_number ~= 0 then
            local right_weight = private.weight[ right_number ];
            right_count = right_count + right_weight;
          end;
          
        end;
        
        private.CompareWeight ( left_count, right_count );
        ObjAttach( "obj_windowext_weight"..id, "obj_windowext_weights");
        return;
        
      end;
      
    end;  
    
  end;
  --*********************************************************************************************************************
  function private.DropWeight ( id )
    
    local left_count = 0;
    local right_count = 0;
    
    if ( cmn.ApplyObj( "obj_windowext_tmp"..id, "spr_windowext_scales_part_1", true ) ) then--левая чаша 

      for i = 1, 3 do
        
        if ( ng_global.progress[ "ext" ][ "win_windowext" ].left_scales[ i ] == 0 ) then--если свободно место на чаше
          
          ng_global.progress[ "ext" ][ "win_windowext" ].left_scales[ i ] = id;--вписываем в массив номер гирьки
          
          for j = 1, 3 do
            
            local left_number = ng_global.progress[ "ext" ][ "win_windowext" ].left_scales[ j ];
            
            if left_number ~= 0 then
              local left_weight = private.weight[ left_number ];
              left_count = left_count + left_weight;--общий вес на левой чаше
            end;
            
            local right_number = ng_global.progress[ "ext" ][ "win_windowext" ].right_scales[ j ];
            
            if right_number ~= 0 then
              local right_weight = private.weight[ right_number ];
              right_count = right_count + right_weight;--общий вес на правой чаше
            end;
            
          end;
          
          private.CompareWeight ( left_count, right_count );--функция сравнивает веса, а потом выставляет угол весов
          ObjAttach( "obj_windowext_weight"..id, "spr_windowext_scales_part_1");
          ObjSet( "obj_windowext_weight"..id, { 
                                                pos_x = private.left_position[ i ][ id ][ 1 ],
                                                pos_y = private.left_position[ i ][ id ][ 2 ], 
                                                pos_z = i,
                                               } );
          ObjSet( "spr_windowext_weight_shadow"..id, { alp = 1 } );
          return;
          
        end;
        
      end;
      
    end;
    
    
    if ( cmn.ApplyObj( "obj_windowext_tmp"..id, "spr_windowext_scales_part_2", true ) ) then--правая чаша  

      for i = 1, 3 do
      
        if ( ng_global.progress[ "ext" ][ "win_windowext" ].right_scales[ i ] == 0 ) then
        
          ng_global.progress[ "ext" ][ "win_windowext" ].right_scales[ i ] = id;
          
          for j = 1, 3 do
            
            local left_number = ng_global.progress[ "ext" ][ "win_windowext" ].left_scales[ j ];
            if left_number ~= 0 then
              local left_weight = private.weight[ left_number ];
              left_count = left_count + left_weight;
            end;
            
            local right_number = ng_global.progress[ "ext" ][ "win_windowext" ].right_scales[ j ];
            if right_number ~= 0 then
              local right_weight = private.weight[ right_number ];
              right_count = right_count + right_weight;
            end;
            
          end;
          
          private.CompareWeight ( left_count, right_count );
          ObjAttach( "obj_windowext_weight"..id, "spr_windowext_scales_part_2");
          ObjSet( "obj_windowext_weight"..id, {
                                               pos_x = private.right_position[ i ][ id ][ 1 ],
                                               pos_y = private.right_position[ i ][ id ][ 2 ],
                                               pos_z = i, 
                                              } );
          ObjSet( "spr_windowext_weight_shadow"..id, { alp = 1 } );
          return;
          
        end;
      
      end;
    
    end;
    
    ObjSet( "obj_windowext_weight"..id, { pos_z = id, pos_x = 0, pos_y = 0 } );--если гирька снова возвращается на свое место
    ObjSet( "spr_windowext_weight_shadow"..id, { alp = 1 } );
    
  end;
  --*********************************************************************************************************************
  function private.CompareWeight ( left_count, right_count )
    
    --DbgTrace( left_count.." : ".. right_count );
    
    local relation, ang;
    local start_rel = 0.5;--отношение меньшего веса к большему, при котором начинается отклонение весов
    local max_ang = 0.45;--модуль максимального отклонение весов
    
    if ( left_count > right_count ) then--если груз на левой чаше больше

      relation = right_count / left_count;
       
      if ( relation > start_rel ) then
        ang = max_ang - ( ( ( relation - start_rel ) / start_rel ) * max_ang );
      else 
        ang = max_ang;
      end;  
      
    elseif ( left_count < right_count ) then--если груз на правой чаше больше

      relation = left_count / right_count;
      
      if ( relation > start_rel ) then
        ang = - max_ang - ( ( ( relation - start_rel ) / start_rel ) * ( - max_ang ) );
      else 
        ang = - max_ang;
      end;
        
    elseif ( left_count == right_count ) then--если груз на правых и левых чашах одинаковый   

      ang = 0;
      
      local win = true;--проверка на выигрыш
      for i = 1, 3 do
        
        if ng_global.progress[ "ext" ][ "win_windowext" ].left_scales[ i ] == 0 or
           ng_global.progress[ "ext" ][ "win_windowext" ].right_scales[ i ] == 0 then
           win = false;
           break;
        end;
         
      end;
       
      if win then
        private.WindowextWin();
      end;  
        
    end;
    
    ng_global.progress[ "ext" ][ "win_windowext" ].ang = ang;
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_app_weight" );
    ObjAnimate( "spr_windowext_scales_part", "ang", 0, 0, "", 
    { 
      0.0, 0, ObjGet( "spr_windowext_scales_part" ).ang,
      0.3, 0, ang,
    } );
    ObjAnimate( "spr_windowext_scales_part_1", "ang", 0, 0, "", 
    { 
      0.0, 0, ObjGet( "spr_windowext_scales_part_1" ).ang,
      0.3, 0, - ang,
    } );
    ObjAnimate( "spr_windowext_scales_part_2", "ang", 0, 0, "", 
    { 
      0.0, 0, ObjGet( "spr_windowext_scales_part_2" ).ang,
      0.3, 0, - ang,
    } );
          
  end;
  --*********************************************************************************************************************
  function private.WindowextWin()
    
    cmn.MiniGameHide( "windowext" );
    cmn.SetEventDone( "win_windowext" );
    common_impl.PassingMgWin( "windowext" );
    
    int.Lock( true );
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_see_atropos" );
    
    ObjSet( "anm_windowext_fire", { alp = 0 } );
    ObjSet( "anm_windowext_atropos_appear", { alp = 1 } );
    AnimPlay( "anm_windowext_atropos_appear", "DoAnim", function() private.WindowextWin1() end );
    
  end;
  --*********************************************************************************************************************
  function private.WindowextWin1()        
    
    ObjSet( "anm_windowext_atropos_appear", { alp = 0 } );
    ObjSet( "anm_windowext_atropos_static", { alp = 1, playing = true } );
    ObjSet( "anm_windowext_atropos_static_over", { alp = 1, playing = true } );
    ObjSet( "tmr_windowext_atropos", { playing = 1, time = 3.0, endtrig = function() private.WindowextWin2() end } ); 
    
  end;  
  --*********************************************************************************************************************
  function private.WindowextWin2()
    
    ObjSet( "anm_windowext_atropos_static", { alp = 0 } );
    ObjSet( "anm_windowext_atropos_static_over", { alp = 0 } );
    ObjSet( "anm_windowext_atropos_disapp", { alp = 1 } );
    AnimPlay( "anm_windowext_atropos_disapp", "DoAnim", function() private.WindowextWin3() end );
    
  end;
  --*********************************************************************************************************************
  function private.WindowextWin3()
    
    ObjSet( "anm_windowext_atropos_disapp", { alp = 0 } );
    ObjSet( "anm_windowext_fire", { alp = 1 } );
    
    ObjAnimate( "obj_windowext_open_box", "alp", 0, 0, function() private.WindowextWinEnd() end, 
    { 
      0.0, 0, 0,
      0.3, 0, 0,
      0.6, 0, 1,
    } );
    
    ObjSet( "tmr_windowext_atropos", { playing = 1, time = 0.3, endtrig = function() cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_open_weight_box" ) end } ); 
    
  end;  
  --*********************************************************************************************************************
  function private.WindowextWinEnd()
    
    --common_impl.PassingMgWin( "windowext" );

    cmn.CallEventHandler( "win_windowext" );
    cmn.CallEventHandler( "win_windowext_inv" );
    
    int.Lock( false );
    
  end;  
  --*********************************************************************************************************************
-------------------------------------------------
function private.ClkBowl ()
  
  if cmn.IsEventDone( "use_bowl_1" ) or 
     cmn.IsEventDone( "use_bowl_2" )then
     
    cmn.ShowBbt( "bbt_windowext_use_bowl" );
    
  else
    
    cmn.ShowBbt( "bbt_windowext_use_no_bowl" );  
    
  end;
  
end;
-------------------------------------------------
function private.ClkHouse ()
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_house" );
  
  local func_end = function () 
  
    if ( cmn.IsEventDone( "use_amulethorror_1" ) ) then 
      AnimStop( "anm_horrorhouse_house_amulet_horror_1" );
      ObjSet( "anm_horrorhouse_house_amulet_horror_1", { alp = 1, playing = true } ); 
      ObjSet( "anm_horrorhouse_house_click_amulet_horror_1", { alp = 0 } );
    elseif ( cmn.IsEventDone( "use_amulethorror_2" ) ) then 
      AnimStop( "anm_horrorhouse_house_amulet_horror_2" );
      ObjSet( "anm_horrorhouse_house_amulet_horror_2", { alp = 1, playing = true } ); 
      ObjSet( "anm_horrorhouse_house_click_amulet_horror_2", { alp = 0 } );
    else  
      AnimStop( "anm_horrorhouse_house_amulets_empty" );
      ObjSet( "anm_horrorhouse_house_amulets_empty", { alp = 1, playing = true } ); 
      ObjSet( "anm_horrorhouse_house_click_no_amulets", { alp = 0 } );
    end; 
    
    AnimStop( "anm_horrorhouse_house" );
    ObjSet( "anm_horrorhouse_house", { alp = 1, playing = true } ); 
    ObjSet( "anm_horrorhouse_house_click", { alp = 0 } );
    cmn.ShowBbt( "bbt_horrorhouse_use_amulethorror" );
    int.Lock( false ); 
     
  end;
  
  int.Lock( true ); 
  
  if ( cmn.IsEventDone( "use_amulethorror_1" ) ) then 
    ObjSet( "anm_horrorhouse_house_amulet_horror_1", { alp = 0 } ); 
    ObjSet( "anm_horrorhouse_house_click_amulet_horror_1", { alp = 1 } );
    AnimPlay( "anm_horrorhouse_house_click_amulet_horror_1", "DoAnim", "" );  
  elseif ( cmn.IsEventDone( "use_amulethorror_2" ) ) then 
    ObjSet( "anm_horrorhouse_house_amulet_horror_2", { alp = 0 } ); 
    ObjSet( "anm_horrorhouse_house_click_amulet_horror_2", { alp = 1 } );
    AnimPlay( "anm_horrorhouse_house_click_amulet_horror_2", "DoAnim", "" ); 
  else 
    ObjSet( "anm_horrorhouse_house_amulets_empty", { alp = 0 } ); 
    ObjSet( "anm_horrorhouse_house_click_no_amulets", { alp = 1 } );
    AnimPlay( "anm_horrorhouse_house_click_no_amulets", "DoAnim", "" );   
  end; 
  
  ObjSet( "anm_horrorhouse_house", { alp = 0 } ); 
  ObjSet( "anm_horrorhouse_house_click", { alp = 1 } );
  AnimPlay( "anm_horrorhouse_house_click", "DoAnim", func_end ); 
  
end;
-------------------------------------------------
function private.ClkBox ()
  
  local func_end = function () 
  
    int.Lock( false ); 
    cmn.ShowBbt( "bbt_deskext_use_deskhandleext" );
    
  end;
  
  int.Lock( true ); 
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_box" );
  ObjAnimate( "spr_deskext_box", "scale_xy", 0, 0, func_end, 
  { 
    0.0, 3, 1, 1,
    0.3, 3, 1.01, 1.01,
    0.6, 3, 1, 1,
  } );
  
end;  
-------------------------------------------------