-- name=rm_nearcar
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_nearcar";

  ObjAttach( "zz_mirrors", "room_hub" );
  ObjAttach( "zz_gate",    "room_hub" );
  ObjAttach( "zz_pit",     "room_hub" );
  ObjAttach( "zz_zzbook",  "room_hub" );
  
  ObjMultiSet( {
    { "spr_mirrors_amuletskull_3",     { event_mdown = private.get_amuletskull_3 } },
    { "spr_mirrors_prunerpart_1",      { event_mdown = private.get_prunerpart_1 } },
    { "spr_mirrors_basrelief_3",       { event_mdown = private.get_basrelief_3 } },
    { "spr_gate_amuletskull_2",        { event_mdown = private.get_amuletskull_2 } },
    { "spr_gate_chisel",               { event_mdown = private.get_chisel } },
    { "spr_gate_chisel_handle",        { event_mdown = private.get_chisel } },
    { "spr_gate_demonstatuette",       { event_mdown = private.get_demonstatuette } },
    { "obj_gate_button4",              { event_mdown = private.get_button4 } },
    { "spr_pit_spring_1",              { event_mdown = private.get_spring_1 } },
    { "spr_pit_bone_1",                { event_mdown = private.get_bone_1 } },
    { "spr_pit_grindstoneext",         { event_mdown = private.get_grindstoneext } },
    { "spr_pit_basrelief_1",           { event_mdown = private.get_basrelief_1 } },
    { "spr_pit_balletdancer",          { event_mdown = private.get_balletdancer } },
    { "spr_pit_dimgem",                { event_mdown = private.get_dimgem } },
    { "spr_pit_amuletbook_1",          { event_mdown = private.get_amuletbook_1 } },
    { "spr_zzbook_carvedhandle",       { event_mdown = private.get_carvedhandle } },
    { "spr_zzbook_amuletcrypt_1",      { event_mdown = private.get_amuletcrypt_1 } },
    { "obj_nearcar_dlg_atropos_1_clk", { event_mdown = private.dlg_nearcar_atropos_1_show } },
    { "obj_pit_clk_skeletonkey",       { event_mdown = private.clk_skeletonkey } },
    { "obj_zzbook_use_amuletskull",    { event_mdown = private.BookClick } },
    { "obj_pit_use_chisel",            { event_mdown = private.ClkAsphalt } },
    { "obj_pit_use_shovelext",         { event_mdown = private.ClkSoil } },
    { "obj_gate_use_amuletgate_1",     { event_mdown = private.ClkGates } },
    { "obj_gate_use_amuletgate_2",     { event_mdown = private.ClkGates } },
    { "obj_gate_use_carvedhandle",     { event_mdown = private.ClkChisel } },
    { "obj_pit_use_skeletonkey",       { event_mdown = private.PitChestClick } },
  } );
  
  private.Anims();
  private.InitSubroom();
  private.InitMirrors();
  private.InitGate();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_nearcar = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gzz_nearcar_mirrors",
        "gzz_nearcar_gate",
        "gzz_nearcar_pit",
        "gzz_nearcar_zzbook",
        "gmg_nearcar_mgbook"
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_mirrors", 
        "zz_gate", 
        "zz_pit", 
        "zz_zzbook", 
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_nearcar", update_game_mode_nearcar, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_amuletskull_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletskull_3" ] =
  {
    type = "get",
    get_obj = "spr_mirrors_amuletskull_3",
    room = private.room_objname,
    zz = "zz_mirrors",
    zz_gate = "gzz_nearcar_mirrors"
  };
  -----------------------------------------------
  local get_amuletskull_3_inv = function ()

    int.InventoryItemAdd( "inv_amuletskull", "spr_mirrors_amuletskull_3", "assets/levels/levelext/rm_farm/zz_skeletons/inv/inv_amuletskull_morph" );

  end;

  local get_amuletskull_3_closezz = function ()

    ObjDelete( "gfx_mirrors_amuletskull_3" );
    ObjDelete( "spr_nearcar_mirrors_skull" );
    levelext_inv.CheckAmuletskull();
    
  end;

  cmn.AddSubscriber( "get_amuletskull_3", get_amuletskull_3_inv );
  cmn.AddSubscriber( "get_amuletskull_3", get_amuletskull_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_prunerpart_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_prunerpart_1" ] =
  {
    type = "get",
    get_obj = "spr_mirrors_prunerpart_1",
    room = private.room_objname,
    zz = "zz_mirrors",
    zz_gate = "gzz_nearcar_mirrors"
  };
  -----------------------------------------------
  local get_prunerpart_1_inv = function ()

    int.InventoryItemAdd( "inv_prunerpart_1", "spr_mirrors_prunerpart_1" );
    ObjSet( "inv_prunerpart_1", { drag = false } );
    if cmn.IsEventDone( "get_prunerpart_2" ) then
      ObjSet( "inv_prunerpart_1_plus_focus2", { alp = 1 } );
    else 
      ObjSet( "inv_prunerpart_1_plus_focus2", { alp = 0 } );
    end;

  end;

  local get_prunerpart_1_closezz = function ()

    ObjDelete( "gfx_mirrors_prunerpart_1" );
    ObjDelete( "spr_mirrors_prunerpart_1_shadow" );
    ObjDelete( "spr_nearcar_mirrors_secaterus" );

  end;

  cmn.AddSubscriber( "get_prunerpart_1", get_prunerpart_1_inv );
  cmn.AddSubscriber( "get_prunerpart_1", get_prunerpart_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_basrelief_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_basrelief_3" ] =
  {
    type = "get",
    get_obj = "spr_mirrors_basrelief_3",
    room = private.room_objname,
    zz = "zz_mirrors",
    zz_gate = "gzz_nearcar_mirrors"
  };
  -----------------------------------------------
  local get_basrelief_3_inv = function ()

    int.InventoryItemAdd( "inv_basrelief", "spr_mirrors_basrelief_3", "assets/levels/levelext/rm_nearcar/zz_pit/inv/inv_basrelief_3_morph" );
    levelext_inv.CheckBasrelief();
    
  end;

  local get_basrelief_3_closezz = function ()

    ObjDelete( "gfx_mirrors_basrelief_3" );
    ObjDelete( "spr_nearcar_mirrors_bas_relief" );
    
  end;

  cmn.AddSubscriber( "get_basrelief_3", get_basrelief_3_inv );
  cmn.AddSubscriber( "get_basrelief_3", get_basrelief_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletskull_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletskull_2" ] =
  {
    type = "get",
    get_obj = "spr_gate_amuletskull_2",
    room = private.room_objname,
    zz = "zz_gate",
    zz_gate = "gzz_nearcar_gate"
  };
  -----------------------------------------------
  local get_amuletskull_2_inv = function ()

  int.InventoryItemAdd( "inv_amuletskull", "spr_gate_amuletskull_2", "assets/levels/levelext/rm_farm/zz_skeletons/inv/inv_amuletskull_morph" );
    levelext_inv.CheckAmuletskull();

  end;

  local get_amuletskull_2_closezz = function ()

    ObjDelete( "gfx_gate_amuletskull_2" );
    ObjDelete( "spr_gate_amuletskull_2_shadow" );
    ObjDelete( "spr_nearcar_gate_skull_gate" );
     
    if cmn.IsEventDone( "get_demonstatuette" ) then
      
      ObjSet( "obj_gate_use_amuletgate_1", { input = true } );
      ObjSet( "obj_gate_use_amuletgate_2", { input = true } );
      
    end;

  end;

  cmn.AddSubscriber( "get_amuletskull_2", get_amuletskull_2_inv );
  cmn.AddSubscriber( "get_amuletskull_2", get_amuletskull_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_chisel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chisel" ] =
  {
    type = "get",
    get_obj = "spr_gate_chisel",
    room = private.room_objname,
    zz = "zz_gate",
    zz_gate = "gzz_nearcar_gate"
  };
  -----------------------------------------------
  local get_chisel_inv = function ()

    int.InventoryItemAdd( "inv_chisel", "spr_gate_chisel" );

  end;

  local get_chisel_closezz = function ()

    ObjDelete( "spr_nearcar_gate_chisel" );

  end;

  cmn.AddSubscriber( "get_chisel", get_chisel_inv );
  cmn.AddSubscriber( "get_chisel", get_chisel_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_demonstatuette () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_demonstatuette" ] =
  {
    type = "get",
    get_obj = "spr_gate_demonstatuette",
    room = private.room_objname,
    zz = "zz_gate",
    zz_gate = "gzz_nearcar_gate"
  };
  -----------------------------------------------
  local get_demonstatuette_inv = function ()

    int.InventoryItemAdd( "inv_demonstatuette", "spr_gate_demonstatuette" );

  end;

  local get_demonstatuette_closezz = function ()

    ObjDelete( "gfx_gate_demonstatuette" );
    ObjDelete( "spr_gate_demonstatuette_shadow" );
    ObjDelete( "spr_nearcar_gate_statue" );
    
    if cmn.IsEventDone( "get_amuletskull_2" ) then
      
      ObjSet( "obj_gate_use_amuletgate_1", { input = true } );
      ObjSet( "obj_gate_use_amuletgate_2", { input = true } );
      
    end;

  end;

  cmn.AddSubscriber( "get_demonstatuette", get_demonstatuette_inv );
  cmn.AddSubscriber( "get_demonstatuette", get_demonstatuette_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_button4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_button4" ] =
  {
    type = "get",
    get_obj = "obj_gate_button4",
    room = private.room_objname,
    zz = "zz_gate",
    zz_gate = "gzz_nearcar_gate"
  };
  -----------------------------------------------
  local get_button4_inv = function ()

    int.InventoryItemAdd( "inv_button4", "spr_gate_button" );

  end;

  local get_button4_closezz = function ()

    ObjDelete( "gfx_gate_button4" );
    ObjDelete( "obj_gate_button4" );
    ObjDelete( "spr_nearcar_gate_button" );
    ObjDelete( "anm_gate_button" );

  end;

  cmn.AddSubscriber( "get_button4", get_button4_inv );
  cmn.AddSubscriber( "get_button4", get_button4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_spring_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_spring_1" ] =
  {
    type = "get",
    get_obj = "spr_pit_spring_1",
    room = private.room_objname,
    zz = "zz_pit",
    zz_gate = "gzz_nearcar_pit"
  };
  -----------------------------------------------
  local get_spring_1_inv = function ()

    int.InventoryItemAdd( "inv_spring_1", "spr_pit_spring_1" );

  end;

  local get_spring_1_closezz = function ()

    ObjDelete( "gfx_pit_spring_1" );
    ObjDelete( "spr_pit_spring_1_shadow" );
    ObjDelete( "spr_nearcar_pit_spring" );
    ObjDelete( "anm_pit_asphalt_light" );
    ObjDelete( "anm_nearcar_asphalt_light" );

  end;

  cmn.AddSubscriber( "get_spring_1", get_spring_1_inv );
  cmn.AddSubscriber( "get_spring_1", get_spring_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bone_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bone_1" ] =
  {
    type = "get",
    get_obj = "spr_pit_bone_1",
    room = private.room_objname,
    zz = "zz_pit",
    zz_gate = "gzz_nearcar_pit"
  };
  -----------------------------------------------
  local get_bone_1_inv = function ()

    int.InventoryItemAdd( "inv_bone_1", "spr_pit_bone_1" );

  end;

  local get_bone_1_closezz = function ()

    ObjDelete( "gfx_pit_bone_1" );
    ObjDelete( "spr_pit_bone_1_shadow" );
    ObjDelete( "spr_nearcar_pit_bone" );
    
  end;

  cmn.AddSubscriber( "get_bone_1", get_bone_1_inv );
  cmn.AddSubscriber( "get_bone_1", get_bone_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_grindstoneext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_grindstoneext" ] =
  {
    type = "get",
    get_obj = "spr_pit_grindstoneext",
    room = private.room_objname,
    zz = "zz_pit",
    zz_gate = "gzz_nearcar_pit"
  };
  -----------------------------------------------
  local get_grindstoneext_inv = function ()

    int.InventoryItemAdd( "inv_grindstoneext", "spr_pit_grindstoneext" );
    if cmn.IsEventDone( "use_coinext" ) then
      ObjSet( "inv_prunerpart_1_plus_focus2", { alp = 1 } );
    end;

  end;

  local get_grindstoneext_closezz = function ()

    ObjDelete( "gfx_pit_grindstoneext" );
    ObjDelete( "spr_pit_grindstoneext_shadow" );
    ObjDelete( "spr_nearcar_pit_grindstone" );

  end;

  cmn.AddSubscriber( "get_grindstoneext", get_grindstoneext_inv );
  cmn.AddSubscriber( "get_grindstoneext", get_grindstoneext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_basrelief_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_basrelief_1" ] =
  {
    type = "get",
    get_obj = "spr_pit_basrelief_1",
    room = private.room_objname,
    zz = "zz_pit",
    zz_gate = "gzz_nearcar_pit"
  };
  -----------------------------------------------
  local get_basrelief_1_inv = function ()

    int.InventoryItemAdd( "inv_basrelief", "spr_pit_basrelief_1", "assets/levels/levelext/rm_nearcar/zz_pit/inv/inv_basrelief_1_morph" );
    levelext_inv.CheckBasrelief();

  end;

  local get_basrelief_1_closezz = function ()

    ObjDelete( "gfx_pit_basrelief_1" );
    ObjDelete( "spr_pit_basrelief_1_shadow" );
    ObjDelete( "spr_nearcar_pit_part_basrelief" );

  end;

  cmn.AddSubscriber( "get_basrelief_1", get_basrelief_1_inv );
  cmn.AddSubscriber( "get_basrelief_1", get_basrelief_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_balletdancer () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_balletdancer" ] =
  {
    type = "get",
    get_obj = "spr_pit_balletdancer",
    room = private.room_objname,
    zz = "zz_pit",
    zz_gate = "gzz_nearcar_pit"
  };
  -----------------------------------------------
  local get_balletdancer_inv = function ()

    int.InventoryItemAdd( "inv_balletdancer", "spr_pit_balletdancer" );

  end;

  local get_balletdancer_closezz = function ()

    ObjDelete( "gfx_pit_balletdancer" );
    ObjDelete( "spr_pit_balletdancer_shadow" );
    ObjDelete( "spr_nearcar_pit_ballerina" );

  end;

  cmn.AddSubscriber( "get_balletdancer", get_balletdancer_inv );
  cmn.AddSubscriber( "get_balletdancer", get_balletdancer_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_dimgem () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_dimgem" ] =
  {
    type = "get",
    get_obj = "spr_pit_dimgem",
    room = private.room_objname,
    zz = "zz_pit",
    zz_gate = "gzz_nearcar_pit"
  };
  -----------------------------------------------
  local get_dimgem_inv = function ()

    int.InventoryItemAdd( "inv_dimgem", "spr_pit_dimgem" );

  end;

  local get_dimgem_closezz = function ()

    ObjDelete( "gfx_pit_dimgem" );
    ObjDelete( "spr_pit_dimgem_shadow" );   
    ObjDelete( "spr_nearcar_pit_stone" );
    
    if cmn.IsEventDone( "get_amuletbook_1" ) then
      ObjDelete( "gzz_nearcar_pit" );
    end;

  end;

  cmn.AddSubscriber( "get_dimgem", get_dimgem_inv );
  cmn.AddSubscriber( "get_dimgem", get_dimgem_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletbook_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletbook_1" ] =
  {
    type = "get",
    get_obj = "spr_pit_amuletbook_1",
    room = private.room_objname,
    zz = "zz_pit",
    zz_gate = "gzz_nearcar_pit"
  };
  -----------------------------------------------
  local get_amuletbook_1_inv = function ()

    int.InventoryItemAdd( "inv_amuletbook_1", "spr_pit_amuletbook_1" );
    ObjSet( "inv_book_plus_focus2", { alp = 1 } );

  end;

  local get_amuletbook_1_closezz = function ()

    ObjDelete( "gfx_pit_amuletbook_1" );
    ObjDelete( "spr_pit_amuletbook_1_shadow" );
    ObjDelete( "spr_nearcar_pit_amulet_books" );
        
    if cmn.IsEventDone( "get_dimgem" ) then
      ObjDelete( "gzz_nearcar_pit" );
    end;

  end;

  cmn.AddSubscriber( "get_amuletbook_1", get_amuletbook_1_inv );
  cmn.AddSubscriber( "get_amuletbook_1", get_amuletbook_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_carvedhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_carvedhandle" ] =
  {
    type = "get",
    get_obj = "spr_zzbook_carvedhandle",
    room = private.room_objname,
    zz = "zz_zzbook",
    zz_gate = "gzz_nearcar_zzbook"
  };
  -----------------------------------------------
  local get_carvedhandle_inv = function ()

    int.InventoryItemAdd( "inv_carvedhandle", "spr_zzbook_carvedhandle" );

  end;

  local get_carvedhandle_closezz = function ()

    ObjDelete( "gfx_zzbook_carvedhandle" );
    ObjDelete( "spr_zzbook_carvedhandle_shadow" );

  end;

  cmn.AddSubscriber( "get_carvedhandle", get_carvedhandle_inv );
  cmn.AddSubscriber( "get_carvedhandle", get_carvedhandle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletcrypt_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletcrypt_1" ] =
  {
    type = "get",
    get_obj = "spr_zzbook_amuletcrypt_1",
    room = private.room_objname,
    zz = "zz_zzbook",
    zz_gate = "gzz_nearcar_zzbook"
  };
  -----------------------------------------------
  local get_amuletcrypt_1_inv = function ()

    int.InventoryItemAdd( "inv_amuletcrypt_1", "spr_zzbook_amuletcrypt_1" );

  end;

  local get_amuletcrypt_1_closezz = function ()

    ObjDelete( "gfx_zzbook_amuletcrypt_1" );
    ObjDelete( "spr_zzbook_amuletcrypt_1_shadow" );
    ObjDelete( "anm_zzbook_amuletcrypt" );
    ObjDelete( "spr_nearcar_zzbook_amuletcrypt_1" );
    
  end;

  cmn.AddSubscriber( "get_amuletcrypt_1", get_amuletcrypt_1_inv );
  cmn.AddSubscriber( "get_amuletcrypt_1", get_amuletcrypt_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_4_7 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_4_7 = function ()

    ObjDelete( "obj_nearcar_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_4_7", get_morphobject_4_7, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_demonstatuette () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_demonstatuette" ] =
  {
    type = "use",
    use_obj = "inv_demonstatuette",
    use_place = "obj_mirrors_use_demonstatuette",
    room = private.room_objname,
    zz = "zz_mirrors",
    zz_gate = "gzz_nearcar_mirrors"
  };
  -----------------------------------------------
  local use_demonstatuette_inv = function ()

    int.InventoryItemRemove( "inv_demonstatuette" );

  end;
  local use_demonstatuette_beg = function ()

    ObjDelete( "obj_mirrors_use_demonstatuette" );

  end;
  local use_demonstatuette_end = function ()

    ObjSet( "spr_mirrors_demonstatuette", { alp = 1 } );
    ObjSet( "spr_nearcar_mirrors_demonstatuette", { alp = 1 } );
    if cmn.IsEventDone( "use_angelstatuette" ) then
      ObjDelete( "anm_mirrors_opn_cashe" );
      ObjSet( "obj_mirrors_open_cache", { alp = 1, input = true } );
      ObjSet( "gfx_mirrors_amuletskull_3", { active = true } );
      ObjSet( "gfx_mirrors_basrelief_3", { active = true } );
      ObjSet( "spr_nearcar_mirrors_open_cashe", { alp = 1 } );
    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_demonstatuette", use_demonstatuette_beg, private.room_objname );
  cmn.AddSubscriber( "use_demonstatuette", use_demonstatuette_inv );
  cmn.AddSubscriber( "use_demonstatuette", use_demonstatuette_end, private.room_objname );
  cmn.AddSubscriber( "use_demonstatuette_inv", use_demonstatuette_inv, private.room_objname );
  cmn.AddSubscriber( "use_demonstatuette_beg", use_demonstatuette_beg, private.room_objname );
  cmn.AddSubscriber( "use_demonstatuette_end", use_demonstatuette_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_angelstatuette () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_angelstatuette" ] =
  {
    type = "use",
    use_obj = "inv_angelstatuette",
    use_place = "obj_mirrors_use_angelstatuette",
    room = private.room_objname,
    zz = "zz_mirrors",
    zz_gate = "gzz_nearcar_mirrors"
  };
  -----------------------------------------------
  local use_angelstatuette_inv = function ()

    int.InventoryItemRemove( "inv_angelstatuette" );

  end;
  local use_angelstatuette_beg = function ()

    ObjDelete( "obj_mirrors_use_angelstatuette" );

  end;
  local use_angelstatuette_end = function ()

    ObjSet( "spr_mirrors_angelstatuette", { alp = 1 } );
    ObjSet( "spr_nearcar_mirrors_angelstatuette", { alp = 1 } );
    if cmn.IsEventDone( "use_demonstatuette" ) then
      ObjDelete( "anm_mirrors_opn_cashe" );
      ObjSet( "obj_mirrors_open_cache", { alp = 1, input = true } );
      ObjSet( "gfx_mirrors_amuletskull_3", { active = true } );
      ObjSet( "gfx_mirrors_basrelief_3", { active = true } );
      ObjSet( "spr_nearcar_mirrors_open_cashe", { alp = 1 } );
    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_angelstatuette", use_angelstatuette_beg, private.room_objname );
  cmn.AddSubscriber( "use_angelstatuette", use_angelstatuette_inv );
  cmn.AddSubscriber( "use_angelstatuette", use_angelstatuette_end, private.room_objname );
  cmn.AddSubscriber( "use_angelstatuette_inv", use_angelstatuette_inv, private.room_objname );
  cmn.AddSubscriber( "use_angelstatuette_beg", use_angelstatuette_beg, private.room_objname );
  cmn.AddSubscriber( "use_angelstatuette_end", use_angelstatuette_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_blacklantern () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_blacklantern" ] =
  {
    type = "use",
    use_obj = "inv_blacklantern",
    use_place = "obj_mirrors_use_blacklantern",
    room = private.room_objname,
    zz = "zz_mirrors",
    zz_gate = "gzz_nearcar_mirrors"
  };
  -----------------------------------------------
  local use_blacklantern_inv = function ()

    int.InventoryItemRemove( "inv_blacklantern" );

  end;
  local use_blacklantern_beg = function ()

    ObjDelete( "obj_mirrors_use_blacklantern" );

  end;
  local use_blacklantern_end = function ()

    ObjSet( "spr_mirrors_blacklantern", { alp = 1 } );
    ObjSet( "spr_mirrors_shine_1", { alp = 1 } );
    ObjSet( "obj_mirrors_mmg", { input = true } );
    ObjSet( "spr_nearcar_mirrors_blacklantern", { alp = 1 } );
    --ObjDelete( "gzz_nearcar_mirrors" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_blacklantern", use_blacklantern_beg, private.room_objname );
  cmn.AddSubscriber( "use_blacklantern", use_blacklantern_inv );
  cmn.AddSubscriber( "use_blacklantern", use_blacklantern_end, private.room_objname );
  cmn.AddSubscriber( "use_blacklantern_inv", use_blacklantern_inv, private.room_objname );
  cmn.AddSubscriber( "use_blacklantern_beg", use_blacklantern_beg, private.room_objname );
  cmn.AddSubscriber( "use_blacklantern_end", use_blacklantern_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_carvedhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_carvedhandle" ] =
  {
    type = "use",
    use_obj = "inv_carvedhandle",
    use_place = "obj_gate_use_carvedhandle",
    room = private.room_objname,
    zz = "zz_gate",
    zz_gate = "gzz_nearcar_gate"
  };
  -----------------------------------------------
  local use_carvedhandle_inv = function ()

    int.InventoryItemRemove( "inv_carvedhandle" );

  end;
  local use_carvedhandle_beg = function ()

    ObjDelete( "obj_gate_use_carvedhandle" );

  end;
  local use_carvedhandle_end = function ()

    ObjDelete( "anm_gate_chisel" );
    ObjDelete( "anm_gate_chisel_click" );
    ObjSet( "spr_nearcar_gate_chisel_handle", { alp = 1 } );
      
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_carvedhandle", use_carvedhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_carvedhandle", use_carvedhandle_inv );
  cmn.AddSubscriber( "use_carvedhandle", use_carvedhandle_end, private.room_objname );
  cmn.AddSubscriber( "use_carvedhandle_inv", use_carvedhandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_carvedhandle_beg", use_carvedhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_carvedhandle_end", use_carvedhandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_prunerext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_prunerext" ] =
  {
    type = "use",
    use_obj = "inv_prunerext",
    use_place = "obj_gate_use_prunerext",
    room = private.room_objname,
    zz = "zz_gate",
    zz_gate = "gzz_nearcar_gate"
  };
  -----------------------------------------------
  local use_prunerext_inv = function ()

    int.InventoryItemRemove( "inv_prunerext" );

  end;
  local use_prunerext_beg = function ()

    ObjDelete( "obj_gate_use_prunerext" );

  end;
  local use_prunerext_end = function ()

    ObjSet( "obj_gate_mmg", { input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_prunerext", use_prunerext_beg, private.room_objname );
  cmn.AddSubscriber( "use_prunerext", use_prunerext_inv );
  cmn.AddSubscriber( "use_prunerext", use_prunerext_end, private.room_objname );
  cmn.AddSubscriber( "use_prunerext_inv", use_prunerext_inv, private.room_objname );
  cmn.AddSubscriber( "use_prunerext_beg", use_prunerext_beg, private.room_objname );
  cmn.AddSubscriber( "use_prunerext_end", use_prunerext_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletgate_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletgate_1" ] =
  {
    type = "use",
    use_obj = "inv_amuletgate_1",
    use_place = "obj_gate_use_amuletgate_1",
    room = private.room_objname,
    zz = "zz_gate",
    zz_gate = "gzz_nearcar_gate"
  };
  -----------------------------------------------
  local use_amuletgate_1_inv = function ()

    int.InventoryItemRemove( "inv_amuletgate_1" );

  end;
  local use_amuletgate_1_beg = function ()

    ObjDelete( "obj_gate_use_amuletgate_1" );

  end;
  local use_amuletgate_1_end = function ()

    ObjSet( "spr_gate_amuletgate_1", { alp = 1 } );
    ObjSet( "spr_nearcar_gate_amuletgate_1", { alp = 1 } );
    
    if cmn.IsEventDone( "use_amuletgate_2" ) then
      ObjSet( "grm_nearcar_cemetery", { active = true, input = true, visible = true } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_nearcar_cemetery_focus");
      end;
      ObjSet( "spr_nearcar_gate_open", { alp = 1 } );
      ObjDelete( "spr_nearcar_gate_gates" );
      ObjDelete( "gzz_nearcar_gate" );
      ObjDelete( "anm_nearcar_open_gate" );
    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_amuletgate_1", use_amuletgate_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletgate_1", use_amuletgate_1_inv );
  cmn.AddSubscriber( "use_amuletgate_1", use_amuletgate_1_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletgate_1_inv", use_amuletgate_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletgate_1_beg", use_amuletgate_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletgate_1_end", use_amuletgate_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletgate_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletgate_2" ] =
  {
    type = "use",
    use_obj = "inv_amuletgate_2",
    use_place = "obj_gate_use_amuletgate_2",
    room = private.room_objname,
    zz = "zz_gate",
    zz_gate = "gzz_nearcar_gate"
  };
  -----------------------------------------------
  local use_amuletgate_2_inv = function ()

    int.InventoryItemRemove( "inv_amuletgate_2" );

  end;
  local use_amuletgate_2_beg = function ()

    ObjDelete( "obj_gate_use_amuletgate_2" );

  end;
  local use_amuletgate_2_end = function ()

    ObjSet( "spr_gate_amuletgate_2", { alp = 1 } );
    ObjSet( "spr_nearcar_gate_amuletgate_2", { alp = 1 } );
        
    if cmn.IsEventDone( "use_amuletgate_1" ) then
      ObjSet( "grm_nearcar_cemetery", { active = true, input = true, visible = true } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_nearcar_cemetery_focus");
      end;      
      ObjSet( "spr_nearcar_gate_open", { alp = 1 } );
      ObjDelete( "spr_nearcar_gate_gates" );
      ObjDelete( "gzz_nearcar_gate" );
      ObjDelete( "anm_nearcar_open_gate" );
    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_amuletgate_2", use_amuletgate_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletgate_2", use_amuletgate_2_inv );
  cmn.AddSubscriber( "use_amuletgate_2", use_amuletgate_2_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletgate_2_inv", use_amuletgate_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletgate_2_beg", use_amuletgate_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletgate_2_end", use_amuletgate_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chisel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chisel" ] =
  {
    type = "use",
    use_obj = "inv_chisel",
    use_place = "obj_pit_use_chisel",
    room = private.room_objname,
    zz = "zz_pit",
    zz_gate = "gzz_nearcar_pit"
  };
  -----------------------------------------------
  local use_chisel_inv = function ()

    int.InventoryItemRemove( "inv_chisel" );

  end;
  local use_chisel_beg = function ()

    ObjDelete( "obj_pit_use_chisel" );

  end;
  local use_chisel_end = function ()

    ObjSet( "obj_pit_asphalt", { input = true } );
    ObjSet( "gfx_pit_bone_1", { active = true } );
    ObjSet( "obj_pit_asphalt_down", { alp = 1 } );
    ObjDelete( "obj_pit_asphalt_up" );
    ObjDelete( "spr_nearcar_pit_asphalt" );    
    ObjDelete( "anm_pit_asphalt_light_2" );
    ObjSet( "gfx_pit_spring_1", { active = true } );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_chisel", use_chisel_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel", use_chisel_inv );
  cmn.AddSubscriber( "use_chisel", use_chisel_end, private.room_objname );
  cmn.AddSubscriber( "use_chisel_inv", use_chisel_inv, private.room_objname );
  cmn.AddSubscriber( "use_chisel_beg", use_chisel_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel_end", use_chisel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shovelext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_shovelext" ] =
  {
    type = "use",
    use_obj = "inv_shovelext",
    use_place = "obj_pit_use_shovelext",
    room = private.room_objname,
    zz = "zz_pit",
    zz_gate = "gzz_nearcar_pit"
  };
  -----------------------------------------------
  local use_shovelext_inv = function ()

    int.InventoryItemRemove( "inv_shovelext" );

  end;
  local use_shovelext_beg = function ()

    ObjDelete( "obj_pit_use_shovelext" );

  end;
  local use_shovelext_end = function ()

    ObjSet( "obj_pit_chest", { input = true } );
    ObjSet( "gfx_pit_basrelief_1", { active = true } );
    ObjSet( "gfx_pit_balletdancer", { active = true } );
    ObjSet( "obj_pit_use_skeletonkey", { input = true } );
    ObjDelete( "anm_pit_shovel" );
    ObjDelete( "spr_nearcar_pit_soil" );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_shovelext", use_shovelext_beg, private.room_objname );
  cmn.AddSubscriber( "use_shovelext", use_shovelext_inv );
  cmn.AddSubscriber( "use_shovelext", use_shovelext_end, private.room_objname );
  cmn.AddSubscriber( "use_shovelext_inv", use_shovelext_inv, private.room_objname );
  cmn.AddSubscriber( "use_shovelext_beg", use_shovelext_beg, private.room_objname );
  cmn.AddSubscriber( "use_shovelext_end", use_shovelext_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_skeletonkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_skeletonkey" ] =
  {
    type = "use",
    use_obj = "inv_skeletonkey",
    use_place = "obj_pit_use_skeletonkey",
    room = private.room_objname,
    zz = "zz_pit",
    zz_gate = "gzz_nearcar_pit"
  };
  -----------------------------------------------
  local use_skeletonkey_inv = function ()

    int.InventoryItemRemove( "inv_skeletonkey" );

  end;
  local use_skeletonkey_beg = function ()

    ObjDelete( "obj_pit_use_skeletonkey" );

  end;
  local use_skeletonkey_end = function ()

    ObjSet( "obj_pit_key_1", { alp = 1 } );
    ObjSet( "obj_pit_clk_skeletonkey", { input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_skeletonkey", use_skeletonkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_skeletonkey", use_skeletonkey_inv );
  cmn.AddSubscriber( "use_skeletonkey", use_skeletonkey_end, private.room_objname );
  cmn.AddSubscriber( "use_skeletonkey_inv", use_skeletonkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_skeletonkey_beg", use_skeletonkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_skeletonkey_end", use_skeletonkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletskull () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletskull" ] =
  {
    type = "use",
    use_obj = "inv_amuletskull",
    use_place = "obj_zzbook_use_amuletskull",
    room = private.room_objname,
    zz = "zz_zzbook",
    zz_gate = "gzz_nearcar_zzbook"
  };
  -----------------------------------------------
  local use_amuletskull_inv = function ()

    int.InventoryItemRemove( "inv_amuletskull" );

  end;
  local use_amuletskull_beg = function ()

    ObjDelete( "obj_zzbook_use_amuletskull" );

  end;
  local use_amuletskull_end = function ()

    ObjSet( "gmg_nearcar_mgbook", { input = true, alp = 1, active = true } );
    ObjSet( "spr_nearcar_zzbook_sculls", { alp = 1 } );
    ObjDelete( "gzz_nearcar_zzbook" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_amuletskull", use_amuletskull_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletskull", use_amuletskull_inv );
  cmn.AddSubscriber( "use_amuletskull", use_amuletskull_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletskull_inv", use_amuletskull_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletskull_beg", use_amuletskull_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletskull_end", use_amuletskull_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_skeletonkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_skeletonkey" ] =
  {
    type = "click",
    clk_obj = "obj_pit_clk_skeletonkey",
    use_place = "obj_pit_clk_skeletonkey",
    room = private.room_objname,
    zz = "zz_pit",
    zz_gate = "gzz_nearcar_pit"
  };
  -----------------------------------------------
  local clk_skeletonkey_beg = function ()

    ObjDelete( "obj_pit_clk_skeletonkey" );

  end;
  local clk_skeletonkey_end = function ()

    ObjSet( "obj_pit_open_chest", { input = true, alp = 1 } );
    ObjSet( "gfx_pit_dimgem", { active = true } );
    ObjSet( "gfx_pit_amuletbook_1", { active = true } );
    ObjSet( "obj_pit_key_2", { alp = 1 } );
    ObjDelete( "obj_pit_key_1" );
    ObjDelete( "spr_pit_chest_cover" );
    ObjSet( "spr_nearcar_pit_open_chest", { alp = 1 } );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_skeletonkey", clk_skeletonkey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_skeletonkey", clk_skeletonkey_end, private.room_objname );
  cmn.AddSubscriber( "clk_skeletonkey_beg", clk_skeletonkey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_skeletonkey_end", clk_skeletonkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_maniac () end;
  --------------------------------------------------------------------------------------------
  local see_maniac = function ()
  
    ObjSet( "vid_nearcar_smoke_1", { alp = 1, playing = true, looped = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "see_maniac", see_maniac, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_maniac_destruction () end;
  --------------------------------------------------------------------------------------------
  local see_maniac_destruction = function ()
  
    ObjDelete( "vid_nearcar_smoke_3" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "see_maniac_destruction", see_maniac_destruction, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_nearcar_atropos_1 () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_nearcar_atropos_1" ] =
  {
    type = "click",
    clk_obj = "obj_nearcar_dlg_atropos_1_clk",
    room = private.room_objname,
  };
  -----------------------------------------------
  local dlg_nearcar_atropos_1_beg = function ()


  end;
  -----------------------------------------------
  local dlg_nearcar_atropos_1_end = function ()

    ObjDelete( "obj_nearcar_dlg_atropos_1_clk" );

  end;

  cmn.AddSubscriber( "dlg_nearcar_atropos_1", dlg_nearcar_atropos_1_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_nearcar_atropos_1", dlg_nearcar_atropos_1_end, private.room_objname );
  cmn.AddSubscriber( "dlg_nearcar_atropos_1_beg", dlg_nearcar_atropos_1_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_nearcar_atropos_1_end", dlg_nearcar_atropos_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_nearcar_atropos_2 () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_nearcar_atropos_2" ] =
  {
    type = "click",
    room = private.room_objname,
  };
    -----------------------------------------------
  local dlg_nearcar_atropos_2 = function ()

    int.LockRoomMap( "nearcar", 1 );
    int.LockRoomMap( "farm", 1 );
    int.LockRoomMap( "cemetery", 1 );    

  end;
  -----------------------------------------------
  local dlg_nearcar_atropos_2_beg = function ()
  end;
  -----------------------------------------------
  local dlg_nearcar_atropos_2_end = function ()
    ObjDelete( "vid_nearcar_transfer" );
  end;
  
  cmn.AddSubscriber( "dlg_nearcar_atropos_2", dlg_nearcar_atropos_2 );
  cmn.AddSubscriber( "dlg_nearcar_atropos_2", dlg_nearcar_atropos_2_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_nearcar_atropos_2", dlg_nearcar_atropos_2_end, private.room_objname );
  cmn.AddSubscriber( "dlg_nearcar_atropos_2_beg", dlg_nearcar_atropos_2_beg, private.room_objname );
  cmn.AddSubscriber( "dlg_nearcar_atropos_2_end", dlg_nearcar_atropos_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_mirrors () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_mirrors" ] =
  {
    room = private.room_objname,
    zz = "zz_mirrors",
    zz_gate = "gzz_nearcar_mirrors"
  };
  --*********************************************************************************************************************
  local win_mirrors = function ()

    if ( cmn.IsEventDone( "win_mirrors" ) ) then

      ObjDelete( "gzz_nearcar_mirrors" );

    elseif ( cmn.IsEventStart( "win_mirrors" ) ) then

      private.LoadMirrors();   

    end;

  end;

  cmn.AddSubscriber( "win_mirrors", win_mirrors, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_gate() end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_gate" ] =
  {
    room = private.room_objname,
    zz = "zz_mirrors",
    zz_gate = "gzz_nearcar_gate"
  };
  --*********************************************************************************************************************
  local win_gate = function ()

    if ( cmn.IsEventDone( "win_gate" ) ) then

      ObjSet( "obj_gate_open", { input = true } );
      ObjSet( "gfx_gate_amuletskull_2", { active = true } );
      ObjSet( "gfx_gate_demonstatuette", { active = true } );
      ObjDelete( "obj_gate_mmg" );
      ObjDelete( "obj_nearcar_gate_mmg" );

    elseif ( cmn.IsEventStart( "win_gate" ) ) then

      private.LoadGate();   

    end;

  end;

  cmn.AddSubscriber( "win_gate", win_gate, private.room_objname );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
-------------------------------------------------
function private.dlg_nearcar_atropos_1_show ()

  local func_end = function ()

    int.Lock( false );
    private.dlg_nearcar_atropos_1();

    ObjSet( "anm_nearcar_atropos_appearance", { alp = 0, playing = false, frame = 0 } );

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_atropos_appearence" );

  ObjSet( "anm_nearcar_atropos_appearance", { alp = 1 } );
  AnimPlay( "anm_nearcar_atropos_appearance", "DoAnim", func_end );

end;
-------------------------------------------------
function private.dlg_nearcar_atropos_1 ()

  local func_end = function ()

    int.Lock( false );
    cmn.CallEventHandler( "dlg_nearcar_atropos_1_end" );
    private.see_maniac();  

    ObjSet( "anm_nearcar_atropos_disappearance", { alp = 0, playing = false, frame = 0 } );

  end;

  local func_end_dialog = function ()

    int.Lock( true );
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_atropos_disappearence" );

    ObjSet( "anm_nearcar_atropos_disappearance", { alp = 1 } );
    AnimPlay( "anm_nearcar_atropos_disappearance", "DoAnim", func_end );

  end;

  ObjAttach( "dlg_nearcar_atropos_1", "rm_nearcar" );
  AnimPlay( "anm_nearcar_atropos_1_halo", "DoAnim", "" );
  AnimPlay( "anm_nearcar_atropos_1_darksmoke", "DoAnim", "" );
  AnimPlay( "anm_nearcar_atropos_1_static1", "DoAnim", "" );
  AnimPlay( "anm_nearcar_atropos_1_static2", "DoAnim", "" );
  common_impl.dialog_character_loc = "anm_nearcar_atropos_disappearance";
  private.dialog_voices_time = { 3 };

  common_impl.DialogCharacterStart( "atropos_1", 2, nil, nil, true, func_end_dialog );

  ObjSet( "tmr_nearcar_fordial", { playing = 1, time = 0.3, endtrig = "" } );

end;
-------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )

    if ( dlg_name == "atropos_1" ) then

      if ( count_txt == 2 ) then

        ObjAnimate( "anm_nearcar_atropos_1_static1", "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.2, 0, 1.0,
          0.4, 0, 0.0
        } );
        ObjAnimate( "anm_nearcar_atropos_1_static2", "alp", 0, 0, "",
        { 
          0.0, 0, 0.0, 
          0.3, 0, 1.0
        } );

      end;
    
    end;

  end;
-------------------------------------------------
function private.dlg_nearcar_atropos_2_show ()

  local func_end = function ()

    int.Lock( false );
    private.dlg_nearcar_atropos_2();

    ObjSet( "anm_nearcar_atropos_appearance", { alp = 0, playing = false, frame = 0 } );
   
  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_atropos_appearence" );

  ObjSet( "anm_nearcar_atropos_appearance", { alp = 1 } );
  AnimPlay( "anm_nearcar_atropos_appearance", "DoAnim", func_end );

end;
-------------------------------------------------
function private.dlg_nearcar_atropos_2 ()

  local func_end = function ()

    private.LivingroomTransfer();
    
    ObjSet( "anm_nearcar_atropos_disappearance", { alp = 0, playing = false, frame = 0 } );

  end;

  local func_end_dialog = function ()

    int.Lock( true );
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_atropos_disappearence" );

    ObjSet( "anm_nearcar_atropos_disappearance", { alp = 1 } );
    AnimPlay( "anm_nearcar_atropos_disappearance", "DoAnim", func_end );

  end;

  ObjAttach( "dlg_nearcar_atropos_2", "rm_nearcar" );
  AnimPlay( "anm_nearcar_atropos_2_halo", "DoAnim", "" );
  AnimPlay( "anm_nearcar_atropos_2_darksmoke", "DoAnim", "" );
  AnimPlay( "anm_nearcar_atropos_2_static1", "DoAnim", "" );   
  common_impl.dialog_character_loc = "anm_nearcar_atropos_disappearance";
  private.dialog_voices_time = { 3 };

  common_impl.DialogCharacterStart( "atropos_2", 1, nil, nil, false, func_end_dialog );

  ObjSet( "tmr_nearcar_fordial", { playing = 1, time = 0.3, endtrig = "" } );

end;
-------------------------------------------------
function private.get_amuletskull_3 ()

  cmn.SetEventDone( "get_amuletskull_3" );
  cmn.CallEventHandler( "get_amuletskull_3" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_prunerpart_1 ()

  cmn.SetEventDone( "get_prunerpart_1" );
  cmn.CallEventHandler( "get_prunerpart_1" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_basrelief_3 ()

  cmn.SetEventDone( "get_basrelief_3" );
  cmn.CallEventHandler( "get_basrelief_3" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_amuletskull_2 ()

  cmn.SetEventDone( "get_amuletskull_2" );
  cmn.CallEventHandler( "get_amuletskull_2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_chisel ()

  cmn.SetEventDone( "get_chisel" );
  cmn.CallEventHandler( "get_chisel" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_demonstatuette ()

  cmn.SetEventDone( "get_demonstatuette" );
  cmn.CallEventHandler( "get_demonstatuette" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_button4 ()

  cmn.SetEventDone( "get_button4" );
  cmn.CallEventHandler( "get_button4" );
  
  cmn.GetObjectSfx();
  
  ObjSet( "anm_gate_button", { alp = 0 } );
  ObjSet( "spr_gate_button", { alp = 1 } );

end;
-------------------------------------------------
function private.get_spring_1 ()

  cmn.SetEventDone( "get_spring_1" );
  cmn.CallEventHandler( "get_spring_1" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_bone_1 ()

  cmn.SetEventDone( "get_bone_1" );
  cmn.CallEventHandler( "get_bone_1" );
  
  cmn.GetObjectSfx();
  
  if not cmn.IsEventDone( "get_spring_1" ) then
    private.get_spring_1 ();
  end;  

end;
-------------------------------------------------
function private.get_grindstoneext ()

  cmn.SetEventDone( "get_grindstoneext" );
  cmn.CallEventHandler( "get_grindstoneext" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_basrelief_1 ()

  cmn.SetEventDone( "get_basrelief_1" );
  cmn.CallEventHandler( "get_basrelief_1" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_balletdancer ()

  cmn.SetEventDone( "get_balletdancer" );
  cmn.CallEventHandler( "get_balletdancer" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_dimgem ()

  cmn.SetEventDone( "get_dimgem" );
  cmn.CallEventHandler( "get_dimgem" );
  
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_amuletbook_1" ) then
    cmn.CloseSubRoom();
  end;

end;
-------------------------------------------------
function private.get_amuletbook_1 ()

  cmn.SetEventDone( "get_amuletbook_1" );
  cmn.CallEventHandler( "get_amuletbook_1" );
  
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_dimgem" ) then
    cmn.CloseSubRoom();
  end;

end;
-------------------------------------------------
function private.get_carvedhandle ()

  cmn.SetEventDone( "get_carvedhandle" );
  cmn.CallEventHandler( "get_carvedhandle" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_amuletcrypt_1 ()

  cmn.SetEventDone( "get_amuletcrypt_1" );
  cmn.CallEventHandler( "get_amuletcrypt_1" );
  
  cmn.GetObjectSfx();

end;
--*********************************************************************************************************************
-------------------------------------------------
function public.use_demonstatuette ()

  local item = "inv_demonstatuette";

  if ( cmn.ApplyObj( item, "gzz_nearcar_mirrors", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_mirrors" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_mirrors_use_demonstatuette", true ) ) then

    cmn.CallEventHandler( "use_demonstatuette_inv" );
    cmn.CallEventHandler( "use_demonstatuette_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_demonstatuette" );
      cmn.CallEventHandler( "use_demonstatuette_end" );
      int.Lock( false );
      
    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_insert_figure" ); 
    ObjAnimate("spr_mirrors_demonstatuette", "alp", 0, 0, 
    function ()
      if cmn.IsEventDone( "use_angelstatuette" ) then
        
        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zzmirrows_open" ); 
        AnimPlay( "anm_mirrors_opn_cashe", "DoAnim", func_end );
        
      else
        func_end();
      end;
    end,
    {
      0.0,0,0,
      0.3,0,1
    });

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_angelstatuette ()

  local item = "inv_angelstatuette";

  if ( cmn.ApplyObj( item, "gzz_nearcar_mirrors", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_mirrors" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_mirrors_use_angelstatuette", true ) ) then

    cmn.CallEventHandler( "use_angelstatuette_inv" );
    cmn.CallEventHandler( "use_angelstatuette_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_angelstatuette" );
      cmn.CallEventHandler( "use_angelstatuette_end" );
      int.Lock( false );
      
    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_insert_figure" ); 
    ObjAnimate("spr_mirrors_angelstatuette", "alp", 0, 0, 
    function ()
      if cmn.IsEventDone( "use_demonstatuette" ) then
        AnimPlay( "anm_mirrors_opn_cashe", "DoAnim", func_end );
        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zzmirrows_open" ); 
        
      else
        func_end();
      end;
    end,
    {
      0.0,0,0,
      0.3,0,1
    });

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_blacklantern ()

  local item = "inv_blacklantern";

  if ( cmn.ApplyObj( item, "gzz_nearcar_mirrors", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_mirrors" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_mirrors_use_blacklantern", true ) ) then

    cmn.CallEventHandler( "use_blacklantern_inv" );
    cmn.CallEventHandler( "use_blacklantern_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_blacklantern" );
      cmn.CallEventHandler( "use_blacklantern_end" );
      int.Lock( false );
      
      common_impl.PassingMgStart( "mirrors" );
      private.InitMirrorsStart();

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_place_lighter" );
    ObjAnimate("spr_mirrors_blacklantern", "alp", 0, 0, func_end, 
    {
      0.0,0,0,
      0.3,0,1
    });
    ObjAnimate("spr_mirrors_shine_1", "alp", 0, 0, "", 
    {
      0.0,0,0,
      0.3,0,1
    });

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_carvedhandle ()

  local item = "inv_carvedhandle";

  if ( cmn.ApplyObj( item, "gzz_nearcar_gate", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_gate" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_gate_use_carvedhandle", true ) ) then

    cmn.CallEventHandler( "use_carvedhandle_inv" );
    cmn.CallEventHandler( "use_carvedhandle_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_carvedhandle" );
      private.get_chisel ();
      cmn.CallEventHandler( "use_carvedhandle_end" );
      int.Lock( false );

    end;

    ObjSet( "anm_gate_chisel_click", { alp = 0 } );
    ObjSet( "anm_gate_chisel", { alp = 1 } );
    AnimPlay( "anm_gate_chisel", "DoAnim", func_end ) 
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_insert_handle" );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_prunerext ()

  local item = "inv_prunerext";

  if ( cmn.ApplyObj( item, "gzz_nearcar_gate", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_gate" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_gate_use_prunerext", true ) ) then

    cmn.CallEventHandler( "use_prunerext_inv" );
    cmn.CallEventHandler( "use_prunerext_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_prunerext" );
      cmn.CallEventHandler( "use_prunerext_end" );
      int.Lock( false );
      common_impl.PassingMgStart( "gate" );
      private.InitGateStart();      

    end;

    --ObjAnimate( "spr", "alp", 0, 0, func_end,
    --{ 
    --  0.0, 0, 0.0, 
    --  0.3, 0, 1.0
    --} );

    func_end();
    return true;

  end;

  return false;

end;
-------------------------------------------------
function private.PrunerCursorEnterStart()
  
  cmn.SetCursor( CURSOR_NULL );
  ObjSet( "anm_gate_pruner", { alp = 1 } );
  private.PrunerCursorEnter();
  
end;
-------------------------------------------------
function private.PrunerCursorEnter()
  
  local pos = GetZoomCursorPos();
  local pos_x_cursor = pos[ 1 ] - 512;
  local pos_y_cursor = pos[ 2 ] - 384;
  ObjSet( "anm_gate_pruner", { pos_x  = pos_x_cursor + 395, pos_y  = pos_y_cursor + 245 } ); 
  ObjSet( "tmr_gate_1", { playing = 1, time = 0.01, endtrig = function () private.PrunerCursorEnter() end } ); 
  
end;  
-------------------------------------------------
function private.PrunerCursorLeave ()
  
  cmn.SetCursor( CURSOR_DEFAULT );
  ObjSet( "anm_gate_pruner", { alp = 0 } );
  ObjSet( "tmr_gate_1", { playing = 0 } ); 
  
end;
-------------------------------------------------
function public.use_amuletgate_1 ()

  local item = "inv_amuletgate_1";

  if ( cmn.ApplyObj( item, "gzz_nearcar_gate", false ) and
       cmn.IsEventDone( "get_amuletskull_2" ) and 
       cmn.IsEventDone( "get_demonstatuette" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_gate" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_gate_use_amuletgate_1", true ) and
           cmn.IsEventDone( "get_amuletskull_2" ) and 
           cmn.IsEventDone( "get_demonstatuette" ) ) then

    cmn.CallEventHandler( "use_amuletgate_1_inv" );
    cmn.CallEventHandler( "use_amuletgate_1_beg" );
    int.Lock( true );

    local func_end = function ()
    
      local func_end1 = function ()
        cmn.SetEventDone( "use_amuletgate_1" );
        cmn.CallEventHandler( "use_amuletgate_1_end" );
        int.Lock( false );
      end;
     
      if cmn.IsEventDone( "use_amuletgate_2" ) then
        cmn.CloseSubRoom();
        ObjSet( "gzz_nearcar_gate", { input = false } );
        ObjSet( "anm_nearcar_open_gate", { alp = 1 } );
        AnimPlay( "anm_nearcar_open_gate", "DoAnim", func_end1 );
        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_open_metal_gates" ); 
        
      else
        func_end1();
      end;

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_insert_to_metal_gates" ); 
    ObjAnimate("spr_gate_amuletgate_1", "alp", 0, 0, func_end, 
    {
      0.0,0,0,
      0.3,0,1
    });

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_amuletgate_2 ()

  local item = "inv_amuletgate_2";

  if ( cmn.ApplyObj( item, "gzz_nearcar_gate", false ) and
       cmn.IsEventDone( "get_amuletskull_2" ) and 
       cmn.IsEventDone( "get_demonstatuette" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_gate" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_gate_use_amuletgate_2", true ) and
           cmn.IsEventDone( "get_amuletskull_2" ) and 
           cmn.IsEventDone( "get_demonstatuette" ) ) then

    cmn.CallEventHandler( "use_amuletgate_2_inv" );
    cmn.CallEventHandler( "use_amuletgate_2_beg" );
    int.Lock( true );

    local func_end = function ()

      local func_end1 = function ()
        cmn.SetEventDone( "use_amuletgate_2" );
        cmn.CallEventHandler( "use_amuletgate_2_end" );
        int.Lock( false );
      end;
     
      if cmn.IsEventDone( "use_amuletgate_1" ) then
        cmn.CloseSubRoom();
        ObjSet( "gzz_nearcar_gate", { input = false } );
        ObjSet( "anm_nearcar_open_gate", { alp = 1 } );
        AnimPlay( "anm_nearcar_open_gate", "DoAnim", func_end1 );
        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_open_metal_gates" );         
      else
        func_end1();
      end;

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_insert_to_metal_gates" ); 
    ObjAnimate("spr_gate_amuletgate_2", "alp", 0, 0, func_end, 
    {
      0.0,0,0,
      0.3,0,1
    });

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_chisel ()

  local item = "inv_chisel";

  if ( cmn.ApplyObj( item, "gzz_nearcar_pit", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pit" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_pit_use_chisel", true ) ) then

    cmn.CallEventHandler( "use_chisel_inv" );
    cmn.CallEventHandler( "use_chisel_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_chisel" );
      cmn.CallEventHandler( "use_chisel_end" );
      int.Lock( false );

    end;

    ObjSet( "anm_pit_asphalt_click", { alp = 0 } );
    ObjSet( "anm_pit_chisel",        { alp = 1 } );
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_chisel" );
    AnimPlay( "anm_pit_chisel", "DoAnim", func_end );
    
    ObjSet( "anm_pit_asphalt_light_2",        { alp = 0 } );
    --ObjAnimate("anm_pit_asphalt_light_2", "alp", 0, 0, "", 
    --{
    --  0.0,0,1,
    --  3.0,0,0
    --});

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_shovelext ()

  local item = "inv_shovelext";

  if ( cmn.ApplyObj( item, "gzz_nearcar_pit", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pit" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_pit_use_shovelext", true ) ) then

    cmn.CallEventHandler( "use_shovelext_inv" );
    cmn.CallEventHandler( "use_shovelext_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_shovelext" );
      cmn.CallEventHandler( "use_shovelext_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_digging" ); 
    AnimPlay( "anm_pit_shovel", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_skeletonkey ()

  local item = "inv_skeletonkey";

  if ( cmn.ApplyObj( item, "gzz_nearcar_pit", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pit" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_pit_use_skeletonkey", true ) ) then

    cmn.CallEventHandler( "use_skeletonkey_inv" );
    cmn.CallEventHandler( "use_skeletonkey_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_skeletonkey" );
      cmn.CallEventHandler( "use_skeletonkey_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_insert_key" ); 
    ObjAnimate("obj_pit_key_1", "alp", 0, 0, func_end, 
    {
      0.0,0,0,
      0.3,0,1
    });

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_amuletskull ()

  local item = "inv_amuletskull";

  if ( cmn.ApplyObj( item, "gzz_nearcar_zzbook", false ) and
       cmn.IsEventDone( "get_amuletskull_1" ) and
       cmn.IsEventDone( "get_amuletskull_2" ) and
       cmn.IsEventDone( "get_amuletskull_3" ) and
       cmn.IsEventDone( "get_amuletcrypt_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_zzbook" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_zzbook_use_amuletskull", true ) and
           cmn.IsEventDone( "get_amuletskull_1" ) and
           cmn.IsEventDone( "get_amuletskull_2" ) and
           cmn.IsEventDone( "get_amuletskull_3" ) and
           cmn.IsEventDone( "get_amuletcrypt_1" ) ) then

    cmn.CallEventHandler( "use_amuletskull_inv" );
    cmn.CallEventHandler( "use_amuletskull_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_amuletskull" );
      cmn.CallEventHandler( "use_amuletskull_end" );
      int.Lock( false );
      cmn.CloseSubRoom();
      cmn.GotoRoom( 'mg_mgbook' )

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_threeskulls" );
     
    ObjAnimate( "spr_zzbook_amuletskull_1", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "spr_zzbook_amuletskull_2", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.4, 0, 0.0, 
      0.7, 0, 1.0
    } );
    
    ObjAnimate( "spr_zzbook_amuletskull_3", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.8, 0, 0.0, 
      1.1, 0, 1.0,
      1.4, 0, 1.0
    } );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function private.clk_skeletonkey ()

  cmn.CallEventHandler( "clk_skeletonkey_beg" );
  int.Lock( true );

  local func_end = function ()

    cmn.SetEventDone( "clk_skeletonkey" );
    cmn.CallEventHandler( "clk_skeletonkey_end" );
    int.Lock( false );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_open_box" );
  ObjAnimate("obj_pit_key_2", "alp", 0, 0, "", 
  {
    0.0,0,0,
    0.3,0,1
  });
  ObjAnimate("obj_pit_key_1", "alp", 0, 0, "", 
  {
    0.0,0,1,
    0.3,0,0
  });
  ObjAnimate("spr_pit_chest_cover", "alp", 0, 0, "", 
  {
    0.0,0,1,
    0.5,0,1,
    0.8,0,0
  });
  ObjAnimate("obj_pit_open_chest", "alp", 0, 0, func_end, 
  {
    0.0,0,0,
    0.5,0,0,
    0.8,0,1
  });

end;
-------------------------------------------------
-------------------------------------------------
function private.see_maniac ()

  local func_end = function ()

    int.Lock( false );
    cmn.StopAudio( "sfx", "audio/level4/sfx/aud_nearcar_maniac" );  
    --cmn.StopAudio( "voc", "audio/level1/voc/aud_intro_voc" );
    --cmn.PlayAudio( "env", "audio/level1/env/aud_bypolicestation_env", 1 );
    cmn.PlayAudio( "mus", "audio/aud_very_ugly_mus" );

    cmn.SetEventDone( "see_maniac" );
    cmn.CallEventHandler( "see_maniac" );
    
    cmn.AddPageDiary( 20 );  
    
    ng_global.task_current = "task_4";   
    interface.KeyUpdate();
    
    int_dialog_task.UpdateHourglassStage( true );
    cmn.ShowBbt( "bbt_dialog_task_4_1" );
  
  end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_nearcar_maniac", func_end );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_nearcar_maniac" );  

  --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_intro_mus" );
  --cmn.PlayAudio( "voc", "audio/level1/voc/aud_intro_voc" );

end;
-------------------------------------------------
function private.see_maniac_destruction ()

  --if ( cmn.IsEventDone( "use_blacklantern" ) ) then

    local func_end = function ()

      int.Lock( false );
      cmn.StopAudio( "sfx", "audio/level4/sfx/aud_nearcar_maniac_destruction_sfx" ); 

      cmn.SetEventDone( "see_maniac_destruction" );
      cmn.CallEventHandler( "see_maniac_destruction" );
      private.dlg_nearcar_atropos_2_show();
    
    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_nearcar_maniac_destruction_sfx" ); 
    common_impl.PlayDialogVideo( "vid_nearcar_maniac_destruction", func_end );  

    --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_intro_mus" );
    --cmn.PlayAudio( "voc", "audio/level1/voc/aud_intro_voc" );

  --end;

end;
-------------------------------------------------
function private.opn_nearcar ()

  if not ( cmn.IsEventDone( "opn_nearcar" ) ) then

    cmn.SetEventDone( "opn_nearcar" );
    ng_global.progress[ "ext" ][ "opn_nearcar" ].zoom_maniac1 = 0;
    ng_global.progress[ "ext" ][ "opn_nearcar" ].zoom_maniac2 = 0;
    ng_global.progress[ "ext" ][ "opn_nearcar" ].zoom_maniac3 = 0;

  end;
  
  if ( cmn.IsEventDone( "win_mirrors" ) and not cmn.IsEventDone( "see_maniac_destruction" ) ) then
    private.see_maniac_destruction();
  end;

end;
-------------------------------------------------
--*********************************************************************************************************************
function public.Load ()

  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.PreOpen ()

  if ( not cmn.IsEventDone( "beg_levelext" ) ) then

    common_impl.InterfaceSetVisible( false );
    ObjSet( "rm_nearcar", { color_r = 0, color_g = 0, color_b = 0 } );
  else  
    cmn.StopAllEnv( "audio/level4/env/aud_nearcar_env", true );
    cmn.PlayAudio( "env", "audio/level4/env/aud_nearcar_env", 1, 2.5 ); 
  end;

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_nearcar();
  
  if not ( cmn.IsEventDone( "beg_levelext" ) ) then

    private.IntroLvl4();
     
  end;

  if ( cmn.IsEventDone( "dlg_nearcar_atropos_1" ) and not cmn.IsEventDone( "see_maniac" ) ) then

    private.see_maniac();
     
  end;

  if ( cmn.IsEventDone( "see_maniac_destruction" ) and not cmn.IsEventDone( "dlg_nearcar_atropos_2" ) ) then

    private.dlg_nearcar_atropos_2_show();
     
  end;
  
  if ( cmn.IsEventDone( "win_hoscrypt" ) ) and ( cmn.IsEventDone( "get_amuletgate_1" ) ) and ( ng_global.progress[ "ext" ][ "opn_nearcar" ].zoom_maniac1 == 0 ) then

    private.ZoomToManiac( 2 );
    ng_global.progress[ "ext" ][ "opn_nearcar" ].zoom_maniac1 = 1;
     
  end;
  
  if ( cmn.IsEventDone( "get_shovelext" ) ) and ( ng_global.progress[ "ext" ][ "opn_nearcar" ].zoom_maniac2 == 0 ) then

    ng_global.progress[ "ext" ][ "opn_nearcar" ].zoom_maniac2 = 1;
    int_dialog_task.UpdateHourglassStage( true );
    cmn.ShowBbt( "bbt_dialog_task_4_3" );
     
  end;
  
  if ( cmn.IsEventDone( "get_blacklantern" ) ) and ( ng_global.progress[ "ext" ][ "opn_nearcar" ].zoom_maniac3 == 0 ) then

    private.ZoomToManiac( 4 );
    ng_global.progress[ "ext" ][ "opn_nearcar" ].zoom_maniac3 = 1;
     
  end;

end;
--*********************************************************************************************************************
function public.Task ()
  
  int.AddedTaskMap( private.room_objname, "get_amuletskull_3",                       { "use_angelstatuette", "use_demonstatuette" } );
  int.AddedTaskMap( private.room_objname, "get_prunerpart_1" );
  int.AddedTaskMap( private.room_objname, "get_basrelief_3",                         { "use_angelstatuette", "use_demonstatuette" } );
  int.AddedTaskMap( private.room_objname, "get_amuletskull_2",                       { "win_gate" } );
  int.AddedTaskMap( private.room_objname, "get_chisel",                              { "use_carvedhandle" } );
  int.AddedTaskMap( private.room_objname, "get_demonstatuette",                      { "win_gate" } );
  int.AddedTaskMap( private.room_objname, "get_button4" );
  int.AddedTaskMap( private.room_objname, "get_spring_1",                            { "use_chisel" } );
  int.AddedTaskMap( private.room_objname, "get_bone_1",                              { "use_chisel" } );
  int.AddedTaskMap( private.room_objname, "get_grindstoneext" );
  int.AddedTaskMap( private.room_objname, "get_basrelief_1",                         { "use_shovelext" } );
  int.AddedTaskMap( private.room_objname, "get_balletdancer",                        { "use_shovelext" } );
  int.AddedTaskMap( private.room_objname, "get_dimgem",                              { "clk_skeletonkey" } );
  int.AddedTaskMap( private.room_objname, "get_amuletbook_1",                        { "clk_skeletonkey" } );
  int.AddedTaskMap( private.room_objname, "get_carvedhandle" );
  int.AddedTaskMap( private.room_objname, "get_amuletcrypt_1" );
  int.AddedTaskMap( private.room_objname, "get_book",                                { "win_mgbook" } );
  
  int.AddedTaskMap( private.room_objname, "use_demonstatuette",                      { "get_demonstatuette" } );
  int.AddedTaskMap( private.room_objname, "use_angelstatuette",                      { "get_angelstatuette" } );
  int.AddedTaskMap( private.room_objname, "use_blacklantern",                        { "get_blacklantern" } );
  int.AddedTaskMap( private.room_objname, "use_carvedhandle",                        { "get_carvedhandle" } );
  int.AddedTaskMap( private.room_objname, "use_prunerext",                           { "get_prunerext" } );
  int.AddedTaskMap( private.room_objname, "use_amuletgate_1",                        { "get_amuletgate_1" } );
  int.AddedTaskMap( private.room_objname, "use_amuletgate_2",                        { "win_hoscrypt" } );
  int.AddedTaskMap( private.room_objname, "use_chisel",                              { "get_chisel" } );
  int.AddedTaskMap( private.room_objname, "use_shovelext",                           { "get_shovelext" } );
  int.AddedTaskMap( private.room_objname, "use_skeletonkey",                         { "get_skeletonkey" } );
  int.AddedTaskMap( private.room_objname, "use_chisel",                              { "get_chisel" } );
  int.AddedTaskMap( private.room_objname, "use_shovelext",                           { "get_shovelext" } );
  int.AddedTaskMap( private.room_objname, "use_skeletonkey",                         { "get_skeletonkey" } );
  int.AddedTaskMap( private.room_objname, "use_amuletskull",                         { "get_amuletskull_1", "get_amuletskull_2", "get_amuletskull_3" } );
  
  int.AddedTaskMap( private.room_objname, "clk_skeletonkey",                         { "use_skeletonkey" } );
  
  int.AddedTaskMap( private.room_objname, "win_mirrors",                             { "use_blacklantern" } );
  int.AddedTaskMap( private.room_objname, "win_gate",                                { "use_prunerext" } );
  int.AddedTaskMap( private.room_objname, "win_mgbook",                              { "use_amuletskull" } );
  
  int.AddedTaskMap( private.room_objname, "opn_cemetery",                            { "use_amuletgate_1", "use_amuletgate_2" } );
  int.AddedTaskMap( private.room_objname, "opn_farm" );

  
end;
--*********************************************************************************************************************
function private.IntroLvl4()

  cmn.StopAllMus();
  cmn.StopAllEnv();

  local func_end = function ()

    cmn.SetEventDone( "beg_levelext" );
    ObjSet( "rm_nearcar", { color_r = 1, color_g = 1, color_b = 1 } );
    int.Lock( false );
    cmn.ShowBbt( "bbt_nearcar_first_open" );

    common_impl.InterfaceSetVisible( true );
    cmn.StopAllEnv( "audio/level4/env/aud_nearcar_env", true );
    cmn.StopAudio( "sfx", "audio/level4/sfx/aud_nearcar_intro_sfx" ); 
    cmn.StopAudio( "voc", "audio/level4/voc/aud_nearcar_intro_voc" );
    cmn.PlayAudio( "env", "audio/level4/env/aud_nearcar_env", 1 );
    
    cmn.AddPageDiary( 19 );
    
    int_dialog_task.InitHourglassStage();

  end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_nearcar_intro", func_end );  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_nearcar_intro_sfx" ); 
  cmn.PlayAudio( "voc", "audio/level4/voc/aud_nearcar_intro_voc" );

end;
--*********************************************************************************************************************
function private.LivingroomTransfer ()

  local func_end = function ()

    --cmn.StopAudio( "sfx", "audio/level1/sfx/aud_intro_mus" );
    --cmn.StopAudio( "voc", "audio/level1/voc/aud_intro_voc" );
    cmn.StopAudio( "sfx", "audio/aud_back_in_past" );
    int.Lock( false );
    ObjSet( "rm_nearcar", { color_r = 0, color_g = 0, color_b = 0 } );
    cmn.CallEventHandler( "dlg_nearcar_atropos_2_end" );
    cmn.GotoRoom( "rm_livingroomext" );
    int.LockRoomMap( "nearcar", 1 );
    int.LockRoomMap( "farm", 1 );
    int.LockRoomMap( "cemetery", 1 );
    --cmn.SetEventDone( "opn_controltower" );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/aud_back_in_past" );
  common_impl.PlayDialogVideo( "vid_nearcar_transfer", func_end );  

  --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_intro_mus" );
  --cmn.PlayAudio( "voc", "audio/level1/voc/aud_intro_voc" );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_mirrors" );
  -------------------------------------------------
  function zz_mirrors.Open()

    if ( cmn.IsEventStart( "win_mirrors" ) and not cmn.IsEventDone( "win_mirrors" ) ) then

      cmn.MiniGameShow( "mirrors" );
      common_impl.PassingMgStart( "mirrors" );

    end;

  end;
  -------------------------------------------------
  function zz_mirrors.PreClose()

    if ( cmn.IsEventStart( "win_mirrors" ) and not cmn.IsEventDone( "win_mirrors" ) ) then

      cmn.MiniGameHide( "mirrors" );
      common_impl.PassingMgStop( "mirrors" );

    end;

  end;
  -------------------------------------------------
  function zz_mirrors.Skip ()

    for num=1, 6 do
      ObjSet( "spr_mirrors_ray_"..num.."_"..(num+1), { alp = 1 } ); 
      ObjSet( "spr_mirrors_shine_"..(num+1), { alp = 1 } );
    end;
    ObjSet( "spr_mirrors_mirror_3_1", { alp = 1 } );
    ObjSet( "spr_mirrors_mirror_4_1", { alp = 1 } );
    ObjSet( "spr_mirrors_mirror_6_1", { alp = 1 } );

    private.WinMirrors();

  end;
  -------------------------------------------------
  function zz_mirrors.Reset ()

    for num=1, 7 do
      private.state[ num ] = private.init_state[ num ];
      ng_global.progress[ "ext" ][ "win_mirrors" ].state[ num ] = private.init_state[ num ];      
    end;

    ObjSet( "spr_mirrors_mirror_3_0", { alp = 1, input = true } );
    ObjSet( "spr_mirrors_mirror_3_1", { alp = 0, input = false } );
    ObjSet( "spr_mirrors_mirror_4_0", { alp = 1, input = true } );
    ObjSet( "spr_mirrors_mirror_4_1", { alp = 0, input = false } );
    ObjSet( "spr_mirrors_mirror_6_0", { alp = 1, input = true } );
    ObjSet( "spr_mirrors_mirror_6_1", { alp = 0, input = false } );
    
    for num=1, 6 do
      if ( private.state[ num ] == 1 ) then
        ObjSet( "spr_mirrors_ray_"..num.."_"..(num+1), { alp = 1 } );
        ObjSet( "spr_mirrors_shine_"..(num+1), { alp = 1 } ); 
      else
        for i=num, 6 do
          ObjSet( "spr_mirrors_ray_"..i.."_"..(i+1), { alp = 0 } );
          ObjSet( "spr_mirrors_shine_"..(i+1), { alp = 0 } ); 
        end;
        break;
      end;
    end;
    
  end;

  -------------------------------------------------
  subroom.Define( "zz_gate" );
  -------------------------------------------------
  function zz_gate.Open()

    if ( cmn.IsEventStart( "win_gate" ) and not cmn.IsEventDone( "win_gate" ) ) then

      cmn.MiniGameShow( "gate" );
      --common_impl.PassingMgStart( "gate" );

    end;

  end;
  -------------------------------------------------
  function zz_gate.PreClose()

    if ( cmn.IsEventStart( "win_gate" ) and not cmn.IsEventDone( "win_gate" ) ) then

      cmn.MiniGameHide( "gate" );
      --common_impl.PassingMgStop( "gate" );

    end;

  end;
  -------------------------------------------------
  function zz_gate.Skip ()

    ObjAnimate("obj_gate_mmg", "alp", 0, 0, 
    function()
      private.WinGate();
    end, 
    {
      0.0,0,1,
      0.3,0,0
    });    

  end;
  -------------------------------------------------
  function zz_gate.Reset ()

    ng_global.progress[ "ext" ][ "win_gate" ].cur_state = 1;
    private.cur_state = 1;  
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_branch_away" ); 
    for st=1, 5 do
      if ( ObjGet( "spr_gate_mmg_stage_"..st.."_base" ).alp == 0 ) then
        ObjAnimate("spr_gate_mmg_stage_"..st.."_base", "alp", 0, 0, "", 
        {
          0.0,0,0,
          0.3,0,1
        });
        ObjSet( "spr_nearcar_gate_mmg"..st, { alp = 1 } );
      end;
      for n=1, private.roses_cnt[st] do             
        if ( private.roses_state[ st ][ n ] == 1 ) then
          ObjAnimate("spr_gate_mmg_rose_"..st.."_"..n, "alp", 0, 0, "", 
          {
            0.0,0,0,
            0.3,0,1
          });
          ObjSet("spr_gate_mmg_rose_"..st.."_"..n, { input = true } );          
        end;
        private.roses_state[ st ][ n ] = 0;
        ng_global.progress[ "ext" ][ "win_gate" ].roses_state[ st ][ n ] = 0;
      end;
    end;
    
  end;

end;
-------------------------------------------------
--*********************************************************************************************************************
function private.Anims ()

  ObjAnimate("spr_mirrors_blacklantern_base_add", "alp", 1, 0, "", 
  {
    0.0,0,1,
    2.0,0,0.7,
    4.0,0,1
  }); 
 
  ObjAnimate("spr_nearcar_mirrors_blacklantern_add", "alp", 1, 0, "", 
  {
    0.0,0,1,
    2.0,0,0.7,
    4.0,0,1
  });
  
  ObjAnimate("spr_mirrors_light_add", "alp", 1, 0, "", 
  {
    0.0,0,1,
    1.5,0,0.7,
    3.0,0,1
  });

  local ray_scale;
  for i=1, 6 do
    ObjAnimate("spr_mirrors_shine_"..i, "ang", 1, 0, "", 
    {
      0.0,0,0,
      30.0,0,6.28,
      30.0,0,0
    });
    ray_scale = ObjGet( "spr_mirrors_ray_"..i.."_"..(i+1) ).scale_y;
    ObjAnimate("spr_mirrors_ray_"..i.."_"..(i+1), "scale_y", 1, 0, "", 
    {
      0.0,0,ray_scale,
      1.5,3,ray_scale-0.05,
      3.0,3,ray_scale
    });
  end;

  ObjAnimate( "spr_zzbook_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_pit_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );
  
  ObjAnimate("spr_nearcar_rays_add", "alp", 1, 0, "", 
  {
    0.0,0,1,
    1.5,0,0.7,
    3.0,0,1
  });
  ObjAnimate("spr_nearcar_light_add", "alp", 1, 0, "", 
  {
    0.0,0,1,
    2.0,0,0.7,
    4.0,0,1
  });
  ObjAnimate("spr_nearcar_eyes_1", "alp", 1, 0, "", 
  {
    0.0,0,1,
    2.0,0,1,
    2.1,0,0,
    2.2,0,1,
    6.0,0,1
  });
  ObjAnimate("spr_gate_light_add", "alp", 1, 0, "", 
  {
    0.0,0,1,
    2.0,0,0.7,
    4.0,0,1
  });

end;
--*********************************************************************************************************************
function private.BookClick ()
  
  int.Lock( true );
  
  local func_end = function ()
  
    int.Lock( false );
    cmn.ShowBbt( "bbt_zzbook_use_amuletskull" );
    ObjSet( "anm_zzbook_skull", { visible = true } );

    if ( not cmn.IsEventDone( "get_amuletcrypt_1" ) ) then
    
      ObjSet( "anm_zzbook_amuletcrypt",          { visible = false } );
      ObjSet( "spr_zzbook_amuletcrypt_1",        { visible = true } );
      ObjSet( "spr_zzbook_amuletcrypt_1_shadow", { visible = true } );
      
    end;
  
  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_book" );
  
  ObjSet( "anm_zzbook_skull", { visible = false } );

  AnimPlay( "anm_zzbook_book", "DoAnim", func_end );
  
  if ( not cmn.IsEventDone( "get_amuletcrypt_1" ) ) then
  
    ObjSet( "anm_zzbook_amuletcrypt",          { visible = true } );
    ObjSet( "spr_zzbook_amuletcrypt_1",        { visible = false } );
    ObjSet( "spr_zzbook_amuletcrypt_1_shadow", { visible = false } );
    AnimPlay( "anm_zzbook_amuletcrypt", "DoAnim", "" );
    
  end;
  
end;
--*********************************************************************************************************************
function private.ClkChisel ()
  
  
  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_gate_use_carvedhandle" );

  end;
  
  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_chisel" );
  AnimPlay( "anm_gate_chisel_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.ClkAsphalt ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_pit_use_chisel" );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_rocks" );
  AnimPlay( "anm_pit_asphalt_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.ClkSoil ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_pit_use_shovelext" ); 

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_rocks" );

  ObjAnimate( "anm_pit_shovel", "scale_xy", 0, 0, func_end, 
  {
    0.0, 3, 1, 1,
    0.3, 3, 1.003, 1.003,
    0.6, 3, 0.997, 0.997,
    0.9, 3, 1, 1
  } );
  
end;
--*********************************************************************************************************************
function private.PitChestClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_pit_use_skeletonkey" );

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_chest" );

  ObjAnimate( "obj_pit_chest_cover", "pos_xy", 0, 0, func_end, 
  {
    0.0, 3, 0,  0,
    0.2, 3, 1, -1,
    0.4, 3, 0,  0,
    0.6, 3, 1, -1,
    0.8, 3, 0,  0,
  } );
  
end;
--*********************************************************************************************************************
function private.ZoomToManiac ( num )
  
  int.Lock( true );
  
  ObjAnimate("rm_nearcar", "pos_xy", 0, 0, "", 
  {
    0.0,0,0,0,
    0.5,3,-238,-4,
    1.0,0,-238,-4,
    1.5,3,0,0
  });
  ObjAnimate("rm_nearcar", "scale_xy", 0, 0, 
  function ()
    int.Lock( false );
    int_dialog_task.UpdateHourglassStage( true );
    cmn.ShowBbt( "bbt_dialog_task_4_"..num );
  end, 
  {
    0.0,0,1,1,
    0.5,3,1.2,1.2,
    1.0,0,1.2,1.2,
    1.5,3,1,1
  });
  
end;
--*********************************************************************************************************************
--********************************************************************************************************************
-- function *** MMG MIRRORS***  () end;
--********************************************************************************************************************
--********************************************************************************************************************
  function private.InitMirrors ()

    private.init_state = {1,1,0,0,1,0,1};
    private.state = {1,1,0,0,1,0,1};
    private.win = {1,1,1,1,1,1,1};

    ObjMultiSet( {
      { "spr_mirrors_mirror_3_1", { 
        event_mdown = function () private.ClkMirror( 3 ); end,
        event_menter = function () cmn.SetCursor(CURSOR_HAND); end,
        event_mleave = function () cmn.SetCursor(CURSOR_DEFAULT); end,
      } },
      { "spr_mirrors_mirror_3_0", { 
        event_mdown = function () private.ClkMirror( 3 ); end,
        event_menter = function () cmn.SetCursor(CURSOR_HAND); end,
        event_mleave = function () cmn.SetCursor(CURSOR_DEFAULT); end,
      } },
      { "spr_mirrors_mirror_4_1", { 
        event_mdown = function () private.ClkMirror( 4 ); end,
        event_menter = function () cmn.SetCursor(CURSOR_HAND); end,
        event_mleave = function () cmn.SetCursor(CURSOR_DEFAULT); end,
      } },
      { "spr_mirrors_mirror_4_0", { 
        event_mdown = function () private.ClkMirror( 4 ); end,
        event_menter = function () cmn.SetCursor(CURSOR_HAND); end,
        event_mleave = function () cmn.SetCursor(CURSOR_DEFAULT); end,
      } },
      { "spr_mirrors_mirror_6_1", { 
        event_mdown = function () private.ClkMirror( 6 ); end,
        event_menter = function () cmn.SetCursor(CURSOR_HAND); end,
        event_mleave = function () cmn.SetCursor(CURSOR_DEFAULT); end,
      } },
      { "spr_mirrors_mirror_6_0", { 
        event_mdown = function () private.ClkMirror( 6 ); end,
        event_menter = function () cmn.SetCursor(CURSOR_HAND); end,
        event_mleave = function () cmn.SetCursor(CURSOR_DEFAULT); end,
      } },
    } );


  end;
  --*********************************************************************************************************************
  function private.InitMirrorsStart ()  

    cmn.MiniGameShow( "mirrors" );

    ng_global.progress[ "ext" ][ "win_mirrors" ].state = {1,1,0,0,1,0,1}; 

    private.RayPath();   

  end;
  --********************************************************************************************************************
  function private.LoadMirrors ()

    for i=1, 7 do
      private.state[ i ] = ng_global.progress[ "ext" ][ "win_mirrors" ].state[ i ];
    end;

    if ( private.state[ 3 ] == 1 ) then
      ObjSet( "spr_mirrors_mirror_3_1", { alp = 1, input = true } );
      ObjSet( "spr_mirrors_mirror_3_0", { alp = 0, input = false } );
    else
      ObjSet( "spr_mirrors_mirror_3_0", { alp = 1, input = true } );
      ObjSet( "spr_mirrors_mirror_3_1", { alp = 0, input = false } );
    end;
    if ( private.state[ 4 ] == 1 ) then
      ObjSet( "spr_mirrors_mirror_4_1", { alp = 1, input = true } );
      ObjSet( "spr_mirrors_mirror_4_0", { alp = 0, input = false } );
    else
      ObjSet( "spr_mirrors_mirror_4_0", { alp = 1, input = true } );
      ObjSet( "spr_mirrors_mirror_4_1", { alp = 0, input = false } );
    end;
    if ( private.state[ 6 ] == 1 ) then
      ObjSet( "spr_mirrors_mirror_6_1", { alp = 1, input = true } );
      ObjSet( "spr_mirrors_mirror_6_0", { alp = 0, input = false } );
    else
      ObjSet( "spr_mirrors_mirror_6_0", { alp = 1, input = true } );
      ObjSet( "spr_mirrors_mirror_6_1", { alp = 0, input = false } );
    end;

    for num=1, 6 do
      if ( private.state[ num ] == 1 ) then
        ObjSet( "spr_mirrors_ray_"..num.."_"..(num+1), { alp = 1 } ); 
        ObjSet( "spr_mirrors_shine_"..(num+1), { alp = 1 } );
      else
        for i=num, 6 do
          ObjSet( "spr_mirrors_ray_"..i.."_"..(i+1), { alp = 0 } );
          ObjSet( "spr_mirrors_shine_"..(i+1), { alp = 0 } );
        end;
        break;
      end;
    end;

  end;
  --*********************************************************************************************************************
  function private.CheckWinMirrors ()

    local win = true;

    for i=1, 7 do
      if ( private.state[ i ] ~= private.win[ i ] ) then
        win = false;
      end;
    end;

    if ( win ) then
      private.WinMirrors();
    else
      for i=1, 7 do
        ng_global.progress[ "ext" ][ "win_mirrors" ].state[ i ] = private.state[ i ];
      end;
    end;

  end;
  --*********************************************************************************************************************
  function private.WinMirrors ()

    local func_end = function ()

      cmn.MiniGameHide( "mirrors" );
      cmn.SetEventDone( "win_mirrors" );
      cmn.CallEventHandler( "win_mirrors" );
      common_impl.PassingMgWin( "mirrors" );

      int.Lock( false ) ;

      cmn.CloseSubRoom();

      private.see_maniac_destruction();

    end;

    int.Lock( true ) ;
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mirrow_win" );
    func_end();

  end;
  --*********************************************************************************************************************
  function private.ClkMirror ( num )

    local func_end = function ()

      private.RayPath();

    end;

    int.Lock( true );
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_click_mirrow" );
    if ( private.state[ num ] == 0 ) then
      private.state[ num ] = 1;
      ObjAnimate("spr_mirrors_mirror_"..num.."_0", "alp", 0, 0, func_end, 
      {
        0.0,0,1,
        0.3,0,0
      });
      ObjAnimate("spr_mirrors_mirror_"..num.."_1", "alp", 0, 0, "", 
      {
        0.0,0,0,
        0.3,0,1
      });
      ObjSet( "spr_mirrors_mirror_"..num.."_1", { input = true } );
      ObjSet( "spr_mirrors_mirror_"..num.."_0", { input = false } );
    else
      private.state[ num ] = 0;
      ObjAnimate("spr_mirrors_mirror_"..num.."_1", "alp", 0, 0, func_end, 
      {
        0.0,0,1,
        0.3,0,0
      });
      ObjAnimate("spr_mirrors_mirror_"..num.."_0", "alp", 0, 0, "", 
      {
        0.0,0,0,
        0.3,0,1
      });
      ObjSet( "spr_mirrors_mirror_"..num.."_1", { input = false } );
      ObjSet( "spr_mirrors_mirror_"..num.."_0", { input = true } );
    end;

  end;
  --*********************************************************************************************************************
  function private.RayPath ()

--    local func_end = function ()
--
--      int.Lock( false );
--      private.CheckWinMirrors();
--
--    end;

    for num=1, 6 do

      if ( private.state[ num ] == 1 ) then

        if ( ObjGet( "spr_mirrors_ray_"..num.."_"..(num+1) ).alp ~= 1 ) then
          ObjAnimate("spr_mirrors_ray_"..num.."_"..(num+1), "alp", 0, 0, "", 
          {
            0.0,0,0,
            0.3,0,1
          });
        end;
        if ( ObjGet( "spr_mirrors_shine_"..(num+1) ).alp ~= 1 ) then
          ObjAnimate("spr_mirrors_shine_"..(num+1), "alp", 0, 0, "", 
          {
            0.0,0,0,
            0.3,0,1
          });
        end;

      else

        for i=num, 6 do

          if ( ObjGet( "spr_mirrors_ray_"..i.."_"..(i+1) ).alp ~= 0 ) then
            ObjAnimate("spr_mirrors_ray_"..i.."_"..(i+1), "alp", 0, 0, "", 
            {
              0.0,0,1,
              0.3,0,0
            });         
          end;
          if ( ObjGet( "spr_mirrors_shine_"..(i+1) ).alp ~= 0 ) then
            ObjAnimate("spr_mirrors_shine_"..(i+1), "alp", 0, 0, "", 
            {
              0.0,0,1,
              0.3,0,0
            });
          end;

        end;

        break;

      end;

    end;

    ObjSet( "tmr_mirrors_mmg", {
      time = 0.4,
      playing = true,
      endtrig = function ()
                  int.Lock( false );
                  private.CheckWinMirrors();
                end
    } );

  end;
  --*********************************************************************************************************************
--*********************************************************************************************************************
--********************************************************************************************************************
-- function *** MMG GATE***  () end;
--********************************************************************************************************************
--********************************************************************************************************************
  function private.InitGate ()

    private.roses_cnt = {7,6,4,5,8};
    private.roses_state = {
      {0,0,0,0,0,0,0,},
      {0,0,0,0,0,0,},
      {0,0,0,0},
      {0,0,0,0,0},
      {0,0,0,0,0,0,0,0}
    };
    private.cur_state = 1;

    for st=1, 5 do
      for n=1, private.roses_cnt[st] do
        ObjSet("spr_gate_mmg_rose_"..st.."_"..n, {
          input = true,
          event_menter = function () private.RoseEnter( st, n ); end,
          event_mleave = function () private.RoseLeave( st, n ); end,
          event_mdown = function () private.RoseClk( st, n ); end
        });
      end;
    end;

  end;
  --*********************************************************************************************************************
  function private.InitGateStart ()  

    cmn.MiniGameShow( "gate" );

    ng_global.progress[ "ext" ][ "win_gate" ].roses_state = {
      {0,0,0,0,0,0,0,},
      {0,0,0,0,0,0,},
      {0,0,0,0},
      {0,0,0,0,0},
      {0,0,0,0,0,0,0,0}
    };
    ng_global.progress[ "ext" ][ "win_gate" ].cur_state = 1;

  end;
  --********************************************************************************************************************
  function private.LoadGate ()

    private.cur_state = ng_global.progress[ "ext" ][ "win_gate" ].cur_state;
    for st=1, 5 do
      local win_st = true;
      for n=1, private.roses_cnt[st] do
        private.roses_state[ st ][ n ] = ng_global.progress[ "ext" ][ "win_gate" ].roses_state[ st ][ n ];
        if ( private.roses_state[ st ][ n ] == 1 ) then
          ObjSet( "spr_gate_mmg_rose_"..st.."_"..n, { alp = 0, input = false } );
        else
          win_st = false;
        end;        
      end;
      if ( win_st ) then
        ObjSet( "spr_gate_mmg_stage_"..st.."_base", { alp = 0 } );
        ObjSet( "spr_nearcar_gate_mmg"..st, { alp = 0 } );
      end;
    end;

  end;
  --*********************************************************************************************************************
  function private.CheckWinGate ()

    int.Lock( false );

    local win = true;

    for i=1, private.roses_cnt[ 5 ] do
      if ( private.roses_state[ 5 ][ i ] ~= 1 ) then
        win = false;
      end;
    end;

    if ( win ) then
      private.WinGate();
    else
      private.SaveStateGate();
    end;

  end;
  --*********************************************************************************************************************
  function private.SaveStateGate ()
      
    ng_global.progress[ "ext" ][ "win_gate" ].cur_state = private.cur_state;
    for st=1, 5 do
      for n=1, private.roses_cnt[st] do
        ng_global.progress[ "ext" ][ "win_gate" ].roses_state[ st ][ n ] = private.roses_state[ st ][ n ];
      end;
    end;
      
  end;
  --*********************************************************************************************************************
  function private.WinGate ()

    local func_end = function ()

      cmn.MiniGameHide( "gate" );
      cmn.SetEventDone( "win_gate" );
      cmn.CallEventHandler( "win_gate" );
      common_impl.PassingMgWin( "gate" );

      int.Lock( false ) ;

      --cmn.CloseSubRoom();

    end;

    int.Lock( true ) ;

    func_end();

  end;
  --*********************************************************************************************************************
  function private.RoseClk ( st, n )

    if ( st ~= private.cur_state ) then

      zz_gate.Reset();

    else

      local func_end = function ()

        ObjSet( "spr_gate_mmg_rose_"..st.."_"..n, { input = false } );
        private.roses_state[ st ][ n ] = 1;

        local fin_st = true;
        for i=1, private.roses_cnt[ st ] do
          if ( private.roses_state[ st ][ i ] == 0 ) then
            fin_st = false;
          end;
        end;

        if ( fin_st ) then 
          
          cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_branch_away" ); 
          ObjAnimate("spr_gate_mmg_stage_"..st.."_base", "alp", 0, 0, 
          function ()
            private.cur_state = private.cur_state + 1;
            private.CheckWinGate();
          end, 
          {
            0.0,0,1,
            0.3,0,0
          });
          ObjSet( "spr_nearcar_gate_mmg"..st, { alp = 0 } );
        else
          int.Lock( false );
          private.SaveStateGate();
        end;

      end;
    
      int.Lock( true );
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_scissors_go" ); 
      ObjAnimate("spr_gate_mmg_rose_"..st.."_"..n, "alp", 0, 0, func_end, 
      {
        0.0,0,1,
        0.3,0,0
      });
      
    end;    

  end;
  --*********************************************************************************************************************
  function private.RoseEnter ( st, n )

    private.PrunerCursorEnterStart();
    ObjAnimate("spr_gate_mmg_rose_"..st.."_"..n, "scale_xy", 0, 0, "", 
    {
      0.0,0,ObjGet("spr_gate_mmg_rose_"..st.."_"..n).scale_x,ObjGet("spr_gate_mmg_rose_"..st.."_"..n).scale_y,
      0.1,0,1.1,1.1
    });

  end;
  --*********************************************************************************************************************
  function private.RoseLeave ( st, n )

    private.PrunerCursorLeave ()
    ObjAnimate("spr_gate_mmg_rose_"..st.."_"..n, "scale_xy", 0, 0, "", 
    {
      0.0,0,ObjGet("spr_gate_mmg_rose_"..st.."_"..n).scale_x,ObjGet("spr_gate_mmg_rose_"..st.."_"..n).scale_y,
      0.1,0,1,1
    });

  end;
  --*********************************************************************************************************************
  --*********************************************************************************************************************=======
function private.ClkGates ()
    
    if not ( cmn.IsEventDone( "use_amuletgate_1" ) or cmn.IsEventDone( "use_amuletgate_2" ) )  then
      
      local func_end = function ()
      
        int.Lock( false );
        cmn.ShowBbt( "bbt_gate_use_amuletgate" );
        if not cmn.IsEventDone( "get_chisel" ) then
          ObjSet( "anm_gate_gateclickchisel", { alp = 0 } );
          ObjSet( "anm_gate_chisel", { alp = 1 } );
        end;  
        
      end;
    
      int.Lock( true );
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_metal_doors_touch" ); 
      if cmn.IsEventDone( "get_chisel" ) then
        AnimPlay( "anm_gate_gateclick", "DoAnim", func_end ) 
      else 
        ObjSet( "anm_gate_gateclickchisel", { alp = 1 } );
        ObjSet( "anm_gate_chisel", { alp = 0 } );
        AnimPlay( "anm_gate_gateclick", "DoAnim", "" ) 
        AnimPlay( "anm_gate_gateclickchisel", "DoAnim", func_end ) 
      end;
      
    else 
      
      cmn.ShowBbt( "bbt_gate_use_amuletgate" );  
      
    end;
  
end;
--*********************************************************************************************************************
