-- name=rm_plane
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_plane";

  ObjAttach( "zz_luggageext",     "room_hub" );
  ObjAttach( "zz_stewardessdoor", "room_hub" );
  ObjAttach( "zz_pilotedoor",     "room_hub" );
  ObjAttach( "zz_illuminator",    "room_hub" );
  
  ObjMultiSet( {
    { "spr_luggageext_scissorsext",            { event_mdown = private.get_scissorsext } },
    { "spr_luggageext_stewardesskey",          { event_mdown = private.get_stewardesskey } },
    { "spr_luggageext_stewardessbadge",        { event_mdown = private.get_stewardessbadge } },
    { "spr_stewardessdoor_dog",                { event_mdown = private.get_dog } },
    { "spr_pilotedoor_screwdriverext",         { event_mdown = private.get_screwdriverext } },
    { "spr_illuminator_handle4",               { event_mdown = private.get_handle4 } },
    { "spr_illuminator_brokenflashlight",      { event_mdown = private.get_brokenflashlight } },
    { "spr_illuminator_plane_2",               { event_mdown = private.get_plane_2 } },
    { "obj_luggageext_use_plane",              { event_mdown = private.LuggageextSuitcaseClick } },
    { "obj_pilotedoor_clk_sparekey",           { event_mdown = private.clk_sparekey } },
    { "obj_stewardessdoor_clk_stewardesskey",  { event_mdown = private.clk_stewardesskey } },
    { "obj_stewardessdoor_use_stewardesskey",  { event_mdown = private.StewardessdoorHandleClick } },
    { "obj_stewardessdoor_use_screwdriverext", { event_mdown = private.StewardessdoorPlateClick } },
    { "obj_illuminator_use_birdext_1",         { event_mdown = private.IlluminatorBoxClick } },
    { "obj_illuminator_use_birdext_2",         { event_mdown = private.IlluminatorBoxClick } },
    { "obj_illuminator_use_scissorsext",       { event_mdown = private.IlluminatorPlaneClick } },
    { "obj_illuminator_use_dog",               { event_mdown = private.IlluminatorBugClick } },
    { "obj_luggageext_use_handle4",            { event_mdown = private.ClkLuggageDoor } },
    { "obj_luggageext_use_tombstone",          { event_mdown = private.ClkGrave } },
    { "obj_pilotedoor_use_sparekey",           { event_mdown = private.ClkDoor } },
  } );

  private.InitAnims();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_plane = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gzz_plane_luggageext",
        "gzz_plane_stewardessdoor",
        "gzz_plane_pilotedoor",
        "gzz_plane_illuminator",
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_luggageext", 
        "zz_stewardessdoor", 
        "zz_pilotedoor", 
        "zz_illuminator", 
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_plane", update_game_mode_plane, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_scissorsext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_scissorsext" ] =
  {
    type = "get",
    get_obj = "spr_luggageext_scissorsext",
    room = private.room_objname,
    zz = "zz_luggageext",
    zz_gate = "gzz_plane_luggageext"
  };
  -----------------------------------------------
  local get_scissorsext_inv = function ()

    int.InventoryItemAdd( "inv_scissorsext", "spr_luggageext_scissorsext" );

  end;

  local get_scissorsext_closezz = function ()

    ObjDelete( "gfx_luggageext_scissorsext" );
    ObjDelete( "spr_luggageext_scissorsext_shadow" );

  end;

  cmn.AddSubscriber( "get_scissorsext", get_scissorsext_inv );
  cmn.AddSubscriber( "get_scissorsext", get_scissorsext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stewardesskey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stewardesskey" ] =
  {
    type = "get",
    get_obj = "spr_luggageext_stewardesskey",
    room = private.room_objname,
    zz = "zz_luggageext",
    zz_gate = "gzz_plane_luggageext"
  };
  -----------------------------------------------
  local get_stewardesskey_inv = function ()

    int.InventoryItemAdd( "inv_stewardesskey", "spr_luggageext_stewardesskey" );

  end;

  local get_stewardesskey_closezz = function ()

    ObjDelete( "gfx_luggageext_stewardesskey" );
    ObjDelete( "spr_luggageext_stewardesskey_shadow" );

  end;

  cmn.AddSubscriber( "get_stewardesskey", get_stewardesskey_inv );
  cmn.AddSubscriber( "get_stewardesskey", get_stewardesskey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stewardessbadge () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stewardessbadge" ] =
  {
    type = "get",
    get_obj = "spr_luggageext_stewardessbadge",
    room = private.room_objname,
    zz = "zz_luggageext",
    zz_gate = "gzz_plane_luggageext"
  };
  -----------------------------------------------
  local get_stewardessbadge_inv = function ()

    int.InventoryItemAdd( "inv_stewardessbadge", "spr_luggageext_stewardessbadge" );

  end;

  local get_stewardessbadge_closezz = function ()

    ObjDelete( "gfx_luggageext_stewardessbadge" );
    ObjDelete( "spr_luggageext_stewardessbadge_shadow" );
    ObjDelete( "gzz_plane_luggageext" );
    ObjDelete( "spr_plane_luggageext_stewardessbadge" );
    
  end;

  cmn.AddSubscriber( "get_stewardessbadge", get_stewardessbadge_inv );
  cmn.AddSubscriber( "get_stewardessbadge", get_stewardessbadge_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_dog () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_dog" ] =
  {
    type = "get",
    get_obj = "spr_stewardessdoor_dog",
    room = private.room_objname,
    zz = "zz_stewardessdoor",
    zz_gate = "gzz_plane_stewardessdoor"
  };
  -----------------------------------------------
  local get_dog_inv = function ()

    int.InventoryItemAdd( "inv_dog", "spr_stewardessdoor_dog" );

  end;

  local get_dog_closezz = function ()

    ObjDelete( "spr_stewardessdoor_dog_shadow" );
    ObjDelete( "spr_stewardessdoor_dog_hotspot" );

  end;

  cmn.AddSubscriber( "get_dog", get_dog_inv );
  cmn.AddSubscriber( "get_dog", get_dog_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_screwdriverext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_screwdriverext" ] =
  {
    type = "get",
    get_obj = "spr_pilotedoor_screwdriverext",
    room = private.room_objname,
    zz = "zz_pilotedoor",
    zz_gate = "gzz_plane_pilotedoor"
  };
  -----------------------------------------------
  local get_screwdriverext_inv = function ()

    int.InventoryItemAdd( "inv_screwdriverext", "spr_pilotedoor_screwdriverext" );

  end;

  local get_screwdriverext_closezz = function ()

    ObjDelete( "gfx_pilotedoor_screwdriverext" );
    ObjDelete( "spr_pilotedoor_screwdriverext_shadow" );
    ObjDelete( "spr_pilotedoor_screwdriverext_over" );
    ObjDelete( "spr_plane_pilotedoor_screwdriver" );

  end;

  cmn.AddSubscriber( "get_screwdriverext", get_screwdriverext_inv );
  cmn.AddSubscriber( "get_screwdriverext", get_screwdriverext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_spring_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_spring_3" ] =
  {
    type = "get",
    get_obj = "spr_pilotedoor_spring_3",
    room = private.room_objname,
    zz = "zz_pilotedoor",
    zz_gate = "gzz_plane_pilotedoor"
  };
  -----------------------------------------------
  local get_spring_3_inv = function ()

    int.InventoryItemAdd( "inv_spring_3", "spr_pilotedoor_spring_3" );

  end;

  local get_spring_3_closezz = function ()

    ObjDelete( "spr_pilotedoor_spring_3_shadow" );
    ObjDelete( "spr_pilotedoor_spring_3_hotspot" );

  end;

  cmn.AddSubscriber( "get_spring_3", get_spring_3_inv );
  cmn.AddSubscriber( "get_spring_3", get_spring_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_handle4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_handle4" ] =
  {
    type = "get",
    get_obj = "spr_illuminator_handle4",
    room = private.room_objname,
    zz = "zz_illuminator",
    zz_gate = "gzz_plane_illuminator"
  };
  -----------------------------------------------
  local get_handle4_inv = function ()

    int.InventoryItemAdd( "inv_handle4", "spr_illuminator_handle4" );

  end;

  local get_handle4_closezz = function ()

    ObjDelete( "gfx_illuminator_handle4" );
    ObjDelete( "spr_illuminator_handle4_shadow" );
    ObjDelete( "spr_plane_illuminator_handle1" );

  end;

  cmn.AddSubscriber( "get_handle4", get_handle4_inv );
  cmn.AddSubscriber( "get_handle4", get_handle4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_plane_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_plane_2" ] =
  {
    type = "get",
    get_obj = "spr_illuminator_plane_2",
    room = private.room_objname,
    zz = "zz_illuminator",
    zz_gate = "gzz_plane_illuminator"
  };
  -----------------------------------------------
  local get_plane_2_inv = function ()

    int.InventoryItemAdd( "inv_plane", "spr_illuminator_plane_2", "assets/levels/levelext/rm_livingroomext/zz_windowext/inv/inv_plane_morph" );
    levelext_inv.CheckPlane();

  end;

  local get_plane_2_closezz = function ()

    ObjDelete( "spr_illuminator_plane_2_shadow" );
    ObjDelete( "gfx_illuminator_plane_2" );
  
  end;

  cmn.AddSubscriber( "get_plane_2", get_plane_2_inv );
  cmn.AddSubscriber( "get_plane_2", get_plane_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokenflashlight () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brokenflashlight" ] =
  {
    type = "get",
    get_obj = "spr_illuminator_brokenflashlight",
    room = private.room_objname,
    zz = "zz_illuminator",
    zz_gate = "gzz_plane_illuminator"
  };
  -----------------------------------------------
  local get_brokenflashlight_inv = function ()

    int.InventoryItemAdd( "inv_brokenflashlight", "spr_illuminator_brokenflashlight" );
    ObjSet( "inv_brokenflashlight", { drag = false } );

  end;

  local get_brokenflashlight_closezz = function ()

    ObjDelete( "gfx_illuminator_brokenflashlight" );
    ObjDelete( "spr_illuminator_brokenflashlight_shadow" );
    ObjDelete( "spr_illuminator_brokenflashlight_over" );
    ObjDelete( "gzz_plane_illuminator" );
    ObjDelete( "spr_plane_illuminator_lamp" );

  end;

  cmn.AddSubscriber( "get_brokenflashlight", get_brokenflashlight_inv );
  cmn.AddSubscriber( "get_brokenflashlight", get_brokenflashlight_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_4_8 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_4_8 = function ()

    ObjDelete( "obj_plane_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_4_8", get_morphobject_4_8, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_plane () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_plane" ] =
  {
    type = "use",
    use_obj = "inv_plane",
    use_place = "obj_luggageext_use_plane",
    room = private.room_objname,
    zz = "zz_luggageext",
    zz_gate = "gzz_plane_luggageext"
  };
  -----------------------------------------------
  local use_plane_inv = function ()

    int.InventoryItemRemove( "inv_plane" );

  end;
  local use_plane_beg = function ()

    ObjDelete( "obj_luggageext_use_plane" );

  end;
  local use_plane_end = function ()

    ObjDelete( "obj_luggageext_suitcase_close" );
    ObjSet( "obj_luggageext_suitcase_open", { alp = 1, input = true } );
    ObjSet( "gfx_luggageext_stewardesskey", { active = true } );
    ObjSet( "spr_plane_luggageext_plane_right", { alp = 1 } );
    ObjSet( "spr_plane_luggageext_plane_left", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_plane", use_plane_beg, private.room_objname );
  cmn.AddSubscriber( "use_plane", use_plane_inv );
  cmn.AddSubscriber( "use_plane", use_plane_end, private.room_objname );
  cmn.AddSubscriber( "use_plane_inv", use_plane_inv, private.room_objname );
  cmn.AddSubscriber( "use_plane_beg", use_plane_beg, private.room_objname );
  cmn.AddSubscriber( "use_plane_end", use_plane_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_handle4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_handle4" ] =
  {
    type = "use",
    use_obj = "inv_handle4",
    use_place = "obj_luggageext_use_handle4",
    room = private.room_objname,
    zz = "zz_luggageext",
    zz_gate = "gzz_plane_luggageext"
  };
  -----------------------------------------------
  local use_handle4_inv = function ()

    int.InventoryItemRemove( "inv_handle4" );

  end;
  local use_handle4_beg = function ()

    ObjDelete( "obj_luggageext_use_handle4" );

  end;
  local use_handle4_end = function ()

    ObjDelete( "obj_luggageext_close" );
    ObjSet( "obj_luggageext_open",        { input = true } );
    ObjSet( "gfx_luggageext_scissorsext", { active = true } );
    ObjSet( "spr_plane_luggageext_handle",{ alp = 1 } );
    ObjDelete( "spr_plane_luggageext_close_door" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_handle4", use_handle4_beg, private.room_objname );
  cmn.AddSubscriber( "use_handle4", use_handle4_inv );
  cmn.AddSubscriber( "use_handle4", use_handle4_end, private.room_objname );
  cmn.AddSubscriber( "use_handle4_inv", use_handle4_inv, private.room_objname );
  cmn.AddSubscriber( "use_handle4_beg", use_handle4_beg, private.room_objname );
  cmn.AddSubscriber( "use_handle4_end", use_handle4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tombstone () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tombstone" ] =
  {
    type = "use",
    use_obj = "inv_tombstone",
    use_place = "obj_luggageext_use_tombstone",
    room = private.room_objname,
    zz = "zz_luggageext",
    zz_gate = "gzz_plane_luggageext"
  };
  -----------------------------------------------
  local use_tombstone_inv = function ()

    int.InventoryItemRemove( "inv_tombstone" );

  end;
  local use_tombstone_beg = function ()

    ObjDelete( "obj_luggageext_use_tombstone" );

  end;
  local use_tombstone_end = function ()

    ObjSet( "spr_luggageext_gravestone",      { alp = 1 } );
    ObjSet( "obj_luggageext_grave_open",      { alp = 1, input = true } );
    ObjSet( "gfx_luggageext_stewardessbadge", { active = true } );
    ObjSet( "spr_plane_luggageext_tombstone", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_tombstone", use_tombstone_beg, private.room_objname );
  cmn.AddSubscriber( "use_tombstone", use_tombstone_inv );
  cmn.AddSubscriber( "use_tombstone", use_tombstone_end, private.room_objname );
  cmn.AddSubscriber( "use_tombstone_inv", use_tombstone_inv, private.room_objname );
  cmn.AddSubscriber( "use_tombstone_beg", use_tombstone_beg, private.room_objname );
  cmn.AddSubscriber( "use_tombstone_end", use_tombstone_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_stewardesskey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_stewardesskey" ] =
  {
    type = "use",
    use_obj = "inv_stewardesskey",
    use_place = "obj_stewardessdoor_use_stewardesskey",
    room = private.room_objname,
    zz = "zz_stewardessdoor",
    zz_gate = "gzz_plane_stewardessdoor"
  };
  -----------------------------------------------
  local use_stewardesskey_inv = function ()

    int.InventoryItemRemove( "inv_stewardesskey" );

  end;
  local use_stewardesskey_beg = function ()

    ObjDelete( "obj_stewardessdoor_use_stewardesskey" );

  end;
  local use_stewardesskey_end = function ()

    ObjSet( "spr_stewardessdoor_lock_light_open",      { alp = 1 } );
    ObjSet( "spr_stewardessdoor_stewardesskey_shadow", { alp = 1, pos_x = -115, pos_y = 60 } );
    ObjSet( "obj_stewardessdoor_clk_stewardesskey",    { input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_stewardesskey", use_stewardesskey_beg, private.room_objname );
  cmn.AddSubscriber( "use_stewardesskey", use_stewardesskey_inv );
  cmn.AddSubscriber( "use_stewardesskey", use_stewardesskey_end, private.room_objname );
  cmn.AddSubscriber( "use_stewardesskey_inv", use_stewardesskey_inv, private.room_objname );
  cmn.AddSubscriber( "use_stewardesskey_beg", use_stewardesskey_beg, private.room_objname );
  cmn.AddSubscriber( "use_stewardesskey_end", use_stewardesskey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screwdriverext_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriverext_1" ] =
  {
    type = "use",
    use_obj = "inv_screwdriverext",
    use_place = "obj_stewardessdoor_use_screwdriverext",
    room = private.room_objname,
    zz = "zz_stewardessdoor",
    zz_gate = "gzz_plane_stewardessdoor"
  };
  -----------------------------------------------
  local use_screwdriverext_1_inv = function ()

    if cmn.IsEventDone( "use_screwdriverext_2" ) then
      int.InventoryItemRemove( "inv_screwdriverext" );
    end;

  end;
  local use_screwdriverext_1_beg = function ()

    ObjDelete( "obj_stewardessdoor_use_screwdriverext" );

  end;
  local use_screwdriverext_1_end = function ()

    ObjDelete( "spr_stewardessdoor_plate_up" );
    ObjDelete( "vid_stewardessroom_use_screwdriver" );
    ObjSet( "obj_stewardessdoor_plate_down", { alp = 1 } );
    ObjSet( "spr_plane_stewardessdoor_plate", { ang = 0.28 } );
    ObjSet( "spr_stewardessdoor_plate_down", { active = true } );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_screwdriverext_1", use_screwdriverext_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriverext_1", use_screwdriverext_1_inv );
  cmn.AddSubscriber( "use_screwdriverext_1", use_screwdriverext_1_end, private.room_objname );
  cmn.AddSubscriber( "use_screwdriverext_1_inv", use_screwdriverext_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_screwdriverext_1_beg", use_screwdriverext_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriverext_1_end", use_screwdriverext_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magnet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_magnet" ] =
  {
    type = "use",
    use_obj = "inv_magnet",
    use_place = "obj_pilotedoor_use_magnet",
    room = private.room_objname,
    zz = "zz_pilotedoor",
    zz_gate = "gzz_plane_pilotedoor"
  };
  -----------------------------------------------
  local use_magnet_inv = function ()

    int.InventoryItemRemove( "inv_magnet" );

  end;
  local use_magnet_beg = function ()

    ObjDelete( "obj_pilotedoor_use_magnet" );

  end;
  local use_magnet_end = function ()

    ObjDelete( "spr_pilotedoor_magnet" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_magnet", use_magnet_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet", use_magnet_inv );
  cmn.AddSubscriber( "use_magnet", use_magnet_end, private.room_objname );
  cmn.AddSubscriber( "use_magnet_inv", use_magnet_inv, private.room_objname );
  cmn.AddSubscriber( "use_magnet_beg", use_magnet_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet_end", use_magnet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sparekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sparekey" ] =
  {
    type = "use",
    use_obj = "inv_sparekey",
    use_place = "obj_pilotedoor_use_sparekey",
    room = private.room_objname,
    zz = "zz_pilotedoor",
    zz_gate = "gzz_plane_pilotedoor"
  };
  -----------------------------------------------
  local use_sparekey_inv = function ()

    int.InventoryItemRemove( "inv_sparekey" );

  end;
  local use_sparekey_beg = function ()

    ObjDelete( "obj_pilotedoor_use_sparekey" );

  end;
  local use_sparekey_end = function ()

    ObjSet( "spr_pilotedoor_sparekey_1",   { pos_x = 134, pos_y = 211 } );
    ObjSet( "obj_pilotedoor_clk_sparekey", { input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_sparekey", use_sparekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_sparekey", use_sparekey_inv );
  cmn.AddSubscriber( "use_sparekey", use_sparekey_end, private.room_objname );
  cmn.AddSubscriber( "use_sparekey_inv", use_sparekey_inv, private.room_objname );
  cmn.AddSubscriber( "use_sparekey_beg", use_sparekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_sparekey_end", use_sparekey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_birdext_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_birdext_1" ] =
  {
    type = "use",
    use_obj = "inv_birdext_1",
    use_place = "obj_illuminator_use_birdext_1",
    room = private.room_objname,
    zz = "zz_illuminator",
    zz_gate = "gzz_plane_illuminator"
  };
  -----------------------------------------------
  local use_birdext_1_inv = function ()

    int.InventoryItemRemove( "inv_birdext_1" );

  end;
  local use_birdext_1_beg = function ()

    ObjDelete( "obj_illuminator_use_birdext_1" );

  end;
  local use_birdext_1_end = function ()

    ObjSet( "spr_illuminator_birdext_1",       { alp = 1 } );
    ObjSet( "spr_plane_illuminator_birdext_1", { alp = 1 } );

    if ( cmn.IsEventDone( "use_birdext_2" ) ) then

      ObjDelete( "obj_illuminator_box_close" );
      ObjSet( "obj_illuminator_box_open",         { alp = 1, input = true } );
      ObjSet( "spr_plane_illuminator_box",         { alp = 1 } );
      ObjSet( "gfx_illuminator_brokenflashlight", { active = true } );
      
    end;
      
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_birdext_1", use_birdext_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_birdext_1", use_birdext_1_inv );
  cmn.AddSubscriber( "use_birdext_1", use_birdext_1_end, private.room_objname );
  cmn.AddSubscriber( "use_birdext_1_inv", use_birdext_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_birdext_1_beg", use_birdext_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_birdext_1_end", use_birdext_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_scissorsext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_scissorsext" ] =
  {
    type = "use",
    use_obj = "inv_scissorsext",
    use_place = "obj_illuminator_use_scissorsext",
    room = private.room_objname,
    zz = "zz_illuminator",
    zz_gate = "gzz_plane_illuminator"
  };
  -----------------------------------------------
  local use_scissorsext_inv = function ()

    int.InventoryItemRemove( "inv_scissorsext" );

  end;
  local use_scissorsext_beg = function ()

    ObjDelete( "obj_illuminator_use_scissorsext" );

  end;
  local use_scissorsext_end = function ()

    ObjDelete( "anm_illuminator_plane" );
    ObjDelete( "anm_illuminator_scissorsext" );
    ObjSet( "spr_illuminator_rope_cut",       { alp = 1 } );
    ObjSet( "spr_illuminator_plane_2_shadow", { alp = 1 } );
    ObjSet( "spr_illuminator_plane_2",        { alp = 1, input = true, active = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_scissorsext", use_scissorsext_beg, private.room_objname );
  cmn.AddSubscriber( "use_scissorsext", use_scissorsext_inv );
  cmn.AddSubscriber( "use_scissorsext", use_scissorsext_end, private.room_objname );
  cmn.AddSubscriber( "use_scissorsext_inv", use_scissorsext_inv, private.room_objname );
  cmn.AddSubscriber( "use_scissorsext_beg", use_scissorsext_beg, private.room_objname );
  cmn.AddSubscriber( "use_scissorsext_end", use_scissorsext_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_dog () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_dog" ] =
  {
    type = "use",
    use_obj = "inv_dog",
    use_place = "obj_illuminator_use_dog",
    room = private.room_objname,
    zz = "zz_illuminator",
    zz_gate = "gzz_plane_illuminator"
  };
  -----------------------------------------------
  local use_dog_inv = function ()

    int.InventoryItemRemove( "inv_dog" );

  end;
  local use_dog_beg = function ()

    ObjDelete( "obj_illuminator_use_dog" );

  end;
  local use_dog_end = function ()

    ObjDelete( "obj_illuminator_bag_close" );
    ObjDelete( "anm_illuminator_zipper" );
    ObjDelete( "anm_illuminator_bag_click" );
    ObjSet( "obj_illuminator_bag_open",   { alp = 1, input = true } );
    ObjSet( "anm_illuminator_plane",      { active = true } );
    ObjSet( "obj_plane_illuminator", { alp = 1 } );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_dog", use_dog_beg, private.room_objname );
  cmn.AddSubscriber( "use_dog", use_dog_inv );
  cmn.AddSubscriber( "use_dog", use_dog_end, private.room_objname );
  cmn.AddSubscriber( "use_dog_inv", use_dog_inv, private.room_objname );
  cmn.AddSubscriber( "use_dog_beg", use_dog_beg, private.room_objname );
  cmn.AddSubscriber( "use_dog_end", use_dog_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_birdext_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_birdext_2" ] =
  {
    type = "use",
    use_obj = "inv_birdext_2",
    use_place = "obj_illuminator_use_birdext_2",
    room = private.room_objname,
    zz = "zz_illuminator",
    zz_gate = "gzz_plane_illuminator"
  };
  -----------------------------------------------
  local use_birdext_2_inv = function ()

    int.InventoryItemRemove( "inv_birdext_2" );

  end;
  local use_birdext_2_beg = function ()

    ObjDelete( "obj_illuminator_use_birdext_2" );

  end;
  local use_birdext_2_end = function ()

    ObjSet( "spr_illuminator_birdext_2",       { alp = 1 } );
    ObjSet( "spr_plane_illuminator_birdext_1", { alp = 1 } );

    if ( cmn.IsEventDone( "use_birdext_1" ) ) then

      ObjDelete( "obj_illuminator_box_close" );
      ObjSet( "obj_illuminator_box_open",      { alp = 1, input = true } );
      ObjSet( "spr_plane_illuminator_box",         { alp = 1 } );
      ObjSet( "gfx_illuminator_brokenflashlight", { active = true } );
      
    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_birdext_2", use_birdext_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_birdext_2", use_birdext_2_inv );
  cmn.AddSubscriber( "use_birdext_2", use_birdext_2_end, private.room_objname );
  cmn.AddSubscriber( "use_birdext_2_inv", use_birdext_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_birdext_2_beg", use_birdext_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_birdext_2_end", use_birdext_2_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_sparekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_sparekey" ] =
  {
    type = "click",
    clk_obj = "obj_pilotedoor_clk_sparekey",
    room = private.room_objname,
    zz = "zz_pilotedoor",
    zz_gate = "gzz_plane_pilotedoor"
  };
  -----------------------------------------------
  local clk_sparekey_beg = function ()

    ObjDelete( "obj_pilotedoor_clk_sparekey" );

  end;
  local clk_sparekey_end = function ()

    ObjSet( "grm_plane_flightdeck", { input = true, visible = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_plane_flightdeck_focus");
    end;
    ObjDelete( "gzz_plane_pilotedoor" );
    ObjSet( "spr_plane_pilotedoor_open_door1", { alp = 1 } );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_sparekey", clk_sparekey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_sparekey", clk_sparekey_end, private.room_objname );
  cmn.AddSubscriber( "clk_sparekey_beg", clk_sparekey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_sparekey_end", clk_sparekey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_stewardesskey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_stewardesskey" ] =
  {
    type = "click",
    clk_obj = "obj_stewardessdoor_clk_stewardesskey",
    room = private.room_objname,
    zz = "zz_stewardessdoor",
    zz_gate = "gzz_plane_stewardessdoor"
  };
  -----------------------------------------------
  local clk_stewardesskey_beg = function ()

    ObjDelete( "obj_stewardessdoor_clk_stewardesskey" );

  end;
  local clk_stewardesskey_end = function ()

    ObjSet( "grm_plane_stewardessroom", { input = true, visible = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_plane_stewardessroom_focus");
    end;    
    ObjSet( "spr_plane_stewardessdoor_open_door", { alp = 1 } );
    ObjDelete( "gzz_plane_stewardessdoor" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_stewardesskey", clk_stewardesskey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_stewardesskey", clk_stewardesskey_end, private.room_objname );
  cmn.AddSubscriber( "clk_stewardesskey_beg", clk_stewardesskey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_stewardesskey_end", clk_stewardesskey_end, private.room_objname );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
function private.get_scissorsext ()

  cmn.SetEventDone( "get_scissorsext" );
  cmn.CallEventHandler( "get_scissorsext" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_stewardesskey ()

  cmn.SetEventDone( "get_stewardesskey" );
  cmn.CallEventHandler( "get_stewardesskey" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_stewardessbadge ()

  cmn.SetEventDone( "get_stewardessbadge" );
  cmn.CallEventHandler( "get_stewardessbadge" );
  cmn.CloseSubRoom();
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_screwdriverext ()

  cmn.SetEventDone( "get_screwdriverext" );
  cmn.CallEventHandler( "get_screwdriverext" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_handle4 ()

  cmn.SetEventDone( "get_handle4" );
  cmn.CallEventHandler( "get_handle4" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_plane_2 ()

  cmn.SetEventDone( "get_plane_2" );
  cmn.CallEventHandler( "get_plane_2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_brokenflashlight ()

  cmn.SetEventDone( "get_brokenflashlight" );
  cmn.CallEventHandler( "get_brokenflashlight" );
  cmn.CloseSubRoom();
  cmn.GetObjectSfx();

end;
--*********************************************************************************************************************
-------------------------------------------------
function public.use_plane ()

  local item = "inv_plane";

  if ( cmn.ApplyObj( item, "gzz_plane_luggageext", false ) and 
     ( cmn.IsEventDone( "get_plane_1" ) ) and 
     ( cmn.IsEventDone( "get_plane_2" ) ) and 
     ( cmn.IsEventDone( "use_handle4" ) ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_luggageext" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_luggageext_use_plane", true ) and 
         ( cmn.IsEventDone( "get_plane_1" ) ) and 
         ( cmn.IsEventDone( "get_plane_2" ) ) and
         ( cmn.IsEventDone( "use_handle4" ) ) ) then

    cmn.CallEventHandler( "use_plane_inv" );
    cmn.CallEventHandler( "use_plane_beg" );
    int.Lock( true );

    local func_end = function ()

      local func_end = function ()
      
        cmn.SetEventDone( "use_plane" );
        cmn.CallEventHandler( "use_plane_end" );
        int.Lock( false );
        
      end;
      
      ObjSet( "spr_luggageext_suitcase_close", { alp = 0 } );
      ObjSet( "anm_luggageext_case_open", { alp = 1 } );
      AnimPlay( "anm_luggageext_case_open", "DoAnim", func_end ); 

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_lilplane" );
          
    ObjAnimate( "anm_luggageext_case_open", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.3, 0, 1,
      0.6, 0, 1,
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_handle4 ()

  local item = "inv_handle4";

  if ( cmn.ApplyObj( item, "gzz_plane_luggageext", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_luggageext" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_luggageext_use_handle4", true ) ) then

    cmn.CallEventHandler( "use_handle4_inv" );
    cmn.CallEventHandler( "use_handle4_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_handle4" );
      cmn.CallEventHandler( "use_handle4_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_openbaggage" );
    
    ObjSet( "spr_luggageext_door", { alp = 0 } );
    ObjSet( "anm_luggageext_open_door", { alp = 1 } );
    AnimPlay( "anm_luggageext_open_door", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_tombstone ()

  local item = "inv_tombstone";

  if ( cmn.ApplyObj( item, "gzz_plane_luggageext", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_luggageext" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_luggageext_use_tombstone", true ) ) then

    cmn.CallEventHandler( "use_tombstone_inv" );
    cmn.CallEventHandler( "use_tombstone_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_tombstone" );
      cmn.CallEventHandler( "use_tombstone_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_headstone1" );

    ObjAnimate( "spr_luggageext_gravestone", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "obj_luggageext_grave_open", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.5, 0, 0.0, 
      0.8, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_stewardesskey ()

  local item = "inv_stewardesskey";

  if ( cmn.ApplyObj( item, "gzz_plane_stewardessdoor", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stewardessdoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stewardessdoor_use_stewardesskey", true ) ) then

    cmn.CallEventHandler( "use_stewardesskey_inv" );
    cmn.CallEventHandler( "use_stewardesskey_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_stewardesskey" );
      cmn.CallEventHandler( "use_stewardesskey_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_insertcard" );

    ObjAnimate( "spr_stewardessdoor_stewardesskey_shadow", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "spr_stewardessdoor_stewardesskey_shadow", "pos_xy", 0, 0, "",
    { 
      0.0, 3,  -83, -52,
      0.3, 3,  -83, -52,
      0.8, 3, -115,  60,
    } );

    ObjAnimate( "spr_stewardessdoor_lock_light_open", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.6, 0, 0.0, 
      0.9, 0, 1.0
    } );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_screwdriverext_1 ()

  local item = "inv_screwdriverext";

  if ( cmn.ApplyObj( item, "gzz_plane_stewardessdoor", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stewardessdoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stewardessdoor_use_screwdriverext", true ) ) then

    cmn.CallEventHandler( "use_screwdriverext_1_inv" );
    cmn.CallEventHandler( "use_screwdriverext_1_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_screwdriverext_1" );
      cmn.CallEventHandler( "use_screwdriverext_1_end" );
      cmn.SetEventDone( "get_dog" );
      int.Lock( false );
      
    end;

    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_unscrew_panel" );
    ObjSet( "obj_stewardessdoor_plate_up", { alp = 0 } );
    ObjSet( "vid_stewardessroom_use_screwdriver", { alp = 1 } );
    VidPlay( "vid_stewardessroom_use_screwdriver", 
    function ()
      cmn.CallEventHandler( "get_dog" );
      cmn.GetObjectSfx();
      func_end();
    end );    
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_magnet ()

  local item = "inv_magnet";

  if ( cmn.ApplyObj( item, "gzz_plane_pilotedoor", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pilotedoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_pilotedoor_use_magnet", true ) ) then

    cmn.CallEventHandler( "use_magnet_inv" );
    cmn.CallEventHandler( "use_magnet_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_magnet" );
      cmn.CallEventHandler( "use_magnet_end" );
      cmn.SetEventDone( "get_spring_3" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_usemagnit" );

    ObjAnimate( "spr_pilotedoor_magnet", "pos_xy", 0, 0, func_end,
    { 
      0.0, 3, 330, 280,
      0.5, 3, -32, 162,
      2.0, 3, -32, -78,
      2.5, 3, 340,   0,
    } );

    ObjAnimate( "spr_pilotedoor_spring_3", "pos_xy", 0, 0,
    function ()

      cmn.CallEventHandler( "get_spring_3" );
      cmn.GetObjectSfx();

    end,
    { 
      0.0, 3, -99, 130,
      0.5, 3, -99, 130,
      2.0, 3, -89, -97,
    } );

    ObjAnimate( "spr_pilotedoor_spring_3_shadow", "alp", 0, 0, "",
    { 
      0.0, 3, 0.8,
      0.5, 3, 0.8,
      0.8, 3, 0
    } );
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_sparekey ()

  local item = "inv_sparekey";

  if ( cmn.ApplyObj( item, "gzz_plane_pilotedoor", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pilotedoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_pilotedoor_use_sparekey", true ) ) then

    cmn.CallEventHandler( "use_sparekey_inv" );
    cmn.CallEventHandler( "use_sparekey_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_sparekey" );
      cmn.CallEventHandler( "use_sparekey_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_insertkey1" );

    ObjAnimate( "spr_pilotedoor_sparekey_1", "pos_xy", 0, 0, func_end,
    { 
      0.0, 3, 317, 248, 
      0.7, 3, 134, 211,
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_birdext_1 ()

  local item = "inv_birdext_1";

  if ( cmn.ApplyObj( item, "gzz_plane_illuminator", false ) and
       cmn.IsEventDone( "use_dog" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_illuminator" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_illuminator_use_birdext_1", true ) and
           cmn.IsEventDone( "use_dog" )) then

    cmn.CallEventHandler( "use_birdext_1_inv" );
    cmn.CallEventHandler( "use_birdext_1_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_birdext_1" );
      cmn.CallEventHandler( "use_birdext_1_end" );
      int.Lock( false );

    end;

    if ( cmn.IsEventDone( "use_birdext_2" ) ) then
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_openbox2" ); 
    
      ObjAnimate( "spr_illuminator_birdext_1", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      ObjAnimate( "obj_illuminator_box_close", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.5, 0, 1.0, 
        0.8, 0, 0.0
      } );

      ObjAnimate( "obj_illuminator_box_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.5, 0, 0.0, 
        0.8, 0, 1.0
      } );

    else
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_eaglepart" ); 

      ObjAnimate( "spr_illuminator_birdext_1", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
    end;
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_scissorsext ()

  local item = "inv_scissorsext";

  if ( cmn.ApplyObj( item, "gzz_plane_illuminator", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_illuminator" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_illuminator_use_scissorsext", true ) ) then

    cmn.CallEventHandler( "use_scissorsext_inv" );
    cmn.CallEventHandler( "use_scissorsext_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_scissorsext" );
      cmn.CallEventHandler( "use_scissorsext_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_cutplane" );
    
    ObjSet( "anm_illuminator_scissorsext", { alp = 1 } );
    ObjSet( "anm_illuminator_plane",       { alp = 0 } );
    
    AnimPlay( "anm_illuminator_scissorsext", "DoAnim", func_end );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_dog ()

  local item = "inv_dog";

  if ( cmn.ApplyObj( item, "gzz_plane_illuminator", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_illuminator" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_illuminator_use_dog", true ) ) then

    cmn.CallEventHandler( "use_dog_inv" );
    cmn.CallEventHandler( "use_dog_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_dog" );
      cmn.CallEventHandler( "use_dog_end" );
      int.Lock( false );

    end;

    local func_end_anim = function ()

      ObjAnimate( "obj_illuminator_bag_close", "alp", 0, 0, "", 
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "obj_illuminator_bag_open", "alp", 0, 0, func_end, 
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;    
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zipper" );
    
    ObjSet( "anm_illuminator_zipper",    { alp = 1 } );
    ObjSet( "anm_illuminator_bag_click", { alp = 0 } );
    
    AnimPlay( "anm_illuminator_zipper", "DoAnim", func_end_anim );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_birdext_2 ()

  local item = "inv_birdext_2";

  if ( cmn.ApplyObj( item, "gzz_plane_illuminator", false ) and
       cmn.IsEventDone( "use_dog" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_illuminator" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_illuminator_use_birdext_2", true ) and
           cmn.IsEventDone( "use_dog" ) ) then

    cmn.CallEventHandler( "use_birdext_2_inv" );
    cmn.CallEventHandler( "use_birdext_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_birdext_2" );
      cmn.CallEventHandler( "use_birdext_2_end" );
      int.Lock( false );

    end;

    if ( cmn.IsEventDone( "use_birdext_1" ) ) then
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_openbox2" ); 
    
      ObjAnimate( "spr_illuminator_birdext_2", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      ObjAnimate( "obj_illuminator_box_close", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.5, 0, 1.0, 
        0.8, 0, 0.0
      } );

      ObjAnimate( "obj_illuminator_box_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.5, 0, 0.0, 
        0.8, 0, 1.0
      } );

    else
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_eaglepart" ); 

      ObjAnimate( "spr_illuminator_birdext_2", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
    end;
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
function private.clk_sparekey ()

  cmn.CallEventHandler( "clk_sparekey_beg" );
  int.Lock( true );

  local func_end = function ()

    cmn.SetEventDone( "clk_sparekey" );
    cmn.CallEventHandler( "clk_sparekey_end" );
    cmn.CloseSubRoom();
    int.Lock( false );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_opendoor2" ); 

  ObjAnimate( "spr_pilotedoor_sparekey_1", "alp", 0, 0, "",
  { 
    0.0, 3, 1.0, 
    0.3, 3, 0.0,
  } );

  ObjAnimate( "spr_pilotedoor_sparekey_2", "alp", 0, 0, func_end,
  { 
    0.0, 3, 0.0, 
    0.3, 3, 1.0,
    0.5, 3, 1.0,
  } );

end;
-------------------------------------------------
function private.clk_stewardesskey ()

  cmn.CallEventHandler( "clk_stewardesskey_beg" );
  int.Lock( true );

  local func_end = function ()

    cmn.SetEventDone( "clk_stewardesskey" );
    cmn.CallEventHandler( "clk_stewardesskey_end" );
    cmn.CloseSubRoom();
    int.Lock( false );

  end;

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_openstuardroom" );

  ObjAnimate( "spr_stewardessdoor_lock_door_handle", "ang", 0, 0, func_end,
  { 
    0.0, 3,  0.0, 
    0.3, 3, -0.2,
    0.5, 3, -0.2,
  } );

end;
-------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_plane ()

  if not ( cmn.IsEventDone( "opn_plane" ) ) then

    cmn.SetEventDone( "opn_plane" );
    cmn.ShowBbt( "bbt_plane_first_open" );
    
    cmn.AddPageDiary( 23 );
    
    int_dialog_task.UpdateHourglassStage( false );
    ng_global.progress[ "ext" ][ "opn_plane" ].see_hourglass2 = 0;

  end;

end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_plane();
  
  cmn.StopAllEnv( "audio/level4/env/aud_plane_env", true );
  cmn.PlayAudio( "env", "audio/level4/env/aud_plane_env", 1, 2.5 ); 
  
  if ( cmn.IsEventDone( "get_tombstone" ) ) and ( ng_global.progress[ "ext" ][ "opn_plane" ].see_hourglass2 == 0 ) then
    int_dialog_task.UpdateHourglassStage( false );
    ng_global.progress[ "ext" ][ "opn_plane" ].see_hourglass2 = 1;
  end;

end;
--*********************************************************************************************************************
function public.Task ()
  
  int.AddedTaskMap( private.room_objname, "get_scissorsext",                                      { "use_handle4" } );
  int.AddedTaskMap( private.room_objname, "get_stewardesskey",                                    { "use_plane" } );
  int.AddedTaskMap( private.room_objname, "get_stewardessbadge",                                  { "use_tombstone" } );
  int.AddedTaskMap( private.room_objname, "get_dog",                                              { "use_screwdriverext_1" } );
  int.AddedTaskMap( private.room_objname, "get_screwdriverext" );
  int.AddedTaskMap( private.room_objname, "get_spring_3",                                         { "use_magnet" } );
  int.AddedTaskMap( private.room_objname, "get_handle4",                                          { "use_dog" } );
  int.AddedTaskMap( private.room_objname, "get_plane_2",                                          { "use_scissorsext" } );
  int.AddedTaskMap( private.room_objname, "get_brokenflashlight",                                 { "use_birdext_1", "use_birdext_2" } );
  
  int.AddedTaskMap( private.room_objname, "use_plane",                                            { "get_plane_1", "get_plane_2", "use_handle4" } );
  int.AddedTaskMap( private.room_objname, "use_tombstone",                                        { "get_tombstone" } );
  int.AddedTaskMap( private.room_objname, "use_stewardesskey",                                    { "get_stewardesskey" } );
  int.AddedTaskMap( private.room_objname, "use_screwdriverext_1",                                 { "get_screwdriverext" } );
  int.AddedTaskMap( private.room_objname, "use_magnet",                                           { "get_magnet" } );
  int.AddedTaskMap( private.room_objname, "use_sparekey",                                         { "win_hocabinet" } );
  int.AddedTaskMap( private.room_objname, "use_birdext_1",                                        { "get_birdext_1", "use_dog" } );
  int.AddedTaskMap( private.room_objname, "use_scissorsext",                                      { "get_scissorsext" } );
  int.AddedTaskMap( private.room_objname, "use_dog",                                              { "get_dog" } );
  int.AddedTaskMap( private.room_objname, "use_birdext_2",                                        { "get_birdext_2", "use_dog" } );
  int.AddedTaskMap( private.room_objname, "use_handle4",                                          { "get_handle4" } );
  
  int.AddedTaskMap( private.room_objname, "clk_sparekey",                                         { "use_sparekey" } );
  int.AddedTaskMap( private.room_objname, "clk_stewardesskey",                                    { "use_stewardesskey" } );
  
  int.AddedTaskMap( private.room_objname, "opn_stewardessroom",                                   { "clk_stewardesskey" } );
  int.AddedTaskMap( private.room_objname, "opn_flightdeck",                                       { "clk_sparekey" } );
  
end;  
--*********************************************************************************************************************
function private.LuggageextSuitcaseClick ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_luggageext_use_plane" );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_case" );

  ObjAnimate( "obj_luggageext_suitcase_close", "pos_y", 0, 0, func_end, 
  {
    0.0, 3,  0,
    0.2, 3, -2,
    0.4, 3,  0,
    0.6, 3, -2,
    0.8, 3,  0,
  } );

  if ( not cmn.IsEventDone( "get_scissorsext" ) ) then

    ObjAnimate( "spr_luggageext_scissorsext_shadow", "pos_y", 0, 0, "", 
    {
      0.0, 3, -54,
      0.2, 3, -56,
      0.4, 3, -54,
      0.6, 3, -56,
      0.8, 3, -54,
    } );

    ObjAnimate( "spr_luggageext_scissorsext", "pos_y", 0, 0, "", 
    {
      0.0, 3, -59,
      0.2, 3, -61,
      0.4, 3, -59,
      0.6, 3, -61,
      0.8, 3, -59,
    } );

  end;

end;
--*********************************************************************************************************************
function private.StewardessdoorPlateClick ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_stewardessdoor_use_screwdriverext" );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_plate2" );

  ObjAnimate( "spr_stewardessdoor_plate_up", "pos_y", 0, 0, func_end, 
  {
    0.0, 3, -55,
    0.2, 3, -57,
    0.4, 3, -55,
    0.6, 3, -57,
    0.8, 3, -55,
  } );

end;
--*********************************************************************************************************************
function private.StewardessdoorHandleClick ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_stewardessdoor_use_stewardesskey" );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_handle2" );

  ObjAnimate( "spr_stewardessdoor_lock_light_close", "alp", 0, 0, "", 
  {
    0.0, 3, 0.0,
    0.3, 3, 0.0,
    0.4, 3, 1.0,
    0.5, 3, 0.0,
    0.6, 3, 1.0,
    0.7, 3, 0.0,
  } );

  ObjAnimate( "spr_stewardessdoor_lock_door_handle", "ang", 0, 0, func_end,
  { 
    0.0, 3,  0.0, 
    0.3, 3, -0.2,
    0.7, 3, -0.2,
    1.0, 3,  0.0,
  } );

end;
--*********************************************************************************************************************
function private.IlluminatorPlaneClick ()

  cmn.ShowBbt( "bbt_illuminator_use_scissorsext" );

end;
--*********************************************************************************************************************
function private.IlluminatorBoxClick ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_illuminator_use_birdext" );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_lilbox" );

  ObjAnimate( "obj_illuminator_box_close", "pos_xy", 0, 0, func_end,
  { 
    0.0, 3, 0,  0, 
    0.2, 3, 1, -1,
    0.4, 3, 0,  0,
    0.6, 3, 1, -1,
    0.8, 3, 0,  0,
  } );

end;
--*********************************************************************************************************************
function private.IlluminatorBugClick ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_illuminator_use_dog" );

  end;

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_bag_xx" );
  AnimPlay( "anm_illuminator_bag_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.InitAnims ()

  ObjAnimate( "spr_luggageext_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

  ObjAnimate( "spr_stewardessdoor_plate_down", "ang", 1, 0, "", 
  {
    0.0, 3, 0.00,
    1.5, 3, 0.05,
    3.0, 3, 0.00,
  } );

  ObjAnimate( "spr_stewardessdoor_dog_hotspot", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    1.0, 3, 1.0,
    2.0, 3, 0.3,
    4.0, 3, 1.0,
    6.0, 3, 0.3,
  } );
  
  ObjAnimate( "obj_plane_hub", "scale_xy", 1, 0, "", 
  {
    0.00, 3, 1.00, 1.00,
    2.00, 3, 1.00, 1.00,
    2.10, 3, 1.05, 1.05,
    2.60, 3, 1.05, 1.05,
    2.90, 3, 1.00, 1.00,
    16.0, 3, 1.00, 1.00,
  } );

  ObjAnimate( "obj_plane_hub", "pos_y", 1, 0, "", 
  {
    0.00, 3,  0,
    2.00, 3,  0,
    2.10, 3, 18,
    2.20, 3,  0,
    2.30, 3, 18,
    2.40, 3,  0,
    2.50, 3, 18,
    2.60, 3,  0,
    16.0, 3,  0,
  } );
  
  ObjAnimate( "obj_plane_back_hub", "scale_xy", 1, 0, "", 
  {
    0.00, 3, 1.00, 1.00,
    2.00, 3, 1.00, 1.00,
    2.10, 3, 1.05, 1.05,
    2.60, 3, 1.05, 1.05,
    2.90, 3, 1.00, 1.00,
    16.0, 3, 1.00, 1.00,
  } );
  
  ObjAnimate( "obj_plane_back_hub", "pos_y", 1, 0, "", 
  {
    0.00, 3,  0,
    2.00, 3,  0,
    2.10, 3, 18,
    2.20, 3,  0,
    2.30, 3, 18,
    2.40, 3,  0,
    2.50, 3, 18,
    2.60, 3,  0,
    16.0, 3,  0,
  } );
  
  ObjAnimate( "obj_palne_animhub_1", "pos_y", 1, 0, "", 
  {
    0.0, 3, 384,
    2.0, 3, 404,
    4.0, 3, 384,
  } );
  
  ObjAnimate( "obj_plane_animhub_2", "pos_y", 1, 0, "", 
  {
    0.0, 3, 384,
    2.0, 3, 404,
    4.0, 3, 384,  
  } );
  
end;
--*********************************************************************************************************************
function private.ClkLuggageDoor ()
  
  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_luggageext_use_handle4" );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_baggage" );

  ObjAnimate( "spr_luggageext_door", "pos_y", 0, 0, func_end, 
  { 
    0.0, 3, 0,
    0.2, 3, -2,
    0.4, 3, 0,
  } );
  
end;
--*********************************************************************************************************************
function private.ClkGrave ()
  
  int.Lock( true );

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_luggageext_use_tombstone" );

  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_grobik" );

  ObjAnimate( "spr_luggageext_grave", "pos_x", 0, 0, func_end, 
  { 
    0.0, 3, 154,
    0.2, 3, 153,
    0.4, 3, 154,
  } );
  
end;
--*********************************************************************************************************************
function private.ClkDoor ()
  
  private.AnimDoor();
  
  int.Lock( true );

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_pilotedoor_use_sparekey" );
    ObjSet( "anm_pilotedoor_doors", { alp = 1 } );
    ObjSet( "anm_pilotedoor_doors2", { alp = 0 } );   
    ObjSet( "spr_pilotedoor_spring_3", { alp = 1 } );
    ObjSet( "spr_pilotedoor_spring_3_shadow", { alp = 0.8 } );
      
  end;
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_planedoor" );
  
  AnimPlay( "anm_pilotedoor_doors2", "DoAnim", func_end );
  
end;
--*********************************************************************************************************************
function private.AnimDoor ()
  
  ObjSet( "anm_pilotedoor_doors", { alp = 0 } );
  ObjSet( "spr_pilotedoor_spring_3", { alp = 0 } );
  ObjSet( "spr_pilotedoor_spring_3_shadow", { alp = 0 } );
  
  if ( not cmn.IsEventDone( "get_screwdriverext" ) and
       not cmn.IsEventDone( "get_spring_3" ) ) then

      ObjSet( "anm_pilotedoor_doors2", { alp = 1, res = "assets/levels/levelext/rm_plane/zz_pilotedoor/anims/anm_doors2" } );
      
  elseif ( not cmn.IsEventDone( "get_screwdriverext" ) and
           cmn.IsEventDone( "get_spring_3" ) ) then    
  
      ObjSet( "anm_pilotedoor_doors2", { alp = 1, res = "assets/levels/levelext/rm_plane/zz_pilotedoor/anims/anm_doorsnospring" } );
      
  elseif ( cmn.IsEventDone( "get_screwdriverext" ) and
             not cmn.IsEventDone( "get_spring_3" ) ) then    

      ObjSet( "anm_pilotedoor_doors2", { alp = 1, res = "assets/levels/levelext/rm_plane/zz_pilotedoor/anims/anm_doorsnoscrew" } ); 
      
  elseif ( cmn.IsEventDone( "get_screwdriverext" ) and
           cmn.IsEventDone( "get_spring_3" ) ) then    

      ObjSet( "anm_pilotedoor_doors2", { alp = 1, res = "assets/levels/levelext/rm_plane/zz_pilotedoor/anims/anm_doors" } ); 
      
  end;
    
end;
--*********************************************************************************************************************