-- name=rm_stewardessroom
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_stewardessroom";

  ObjAttach( "zz_cabinetext", "room_hub" );
  ObjAttach( "zz_fridge",     "room_hub" );
  ObjAttach( "zz_phone",      "room_hub" );

  ObjMultiSet( {
    { "spr_cabinetext_glueext",             { event_mdown = private.get_glueext } },
    { "spr_fridge_magnet",                  { event_mdown = private.get_magnet } },
    { "spr_fridge_tombstonepart_2",         { event_mdown = private.get_tombstonepart_2 } },
    { "spr_fridge_caduceus_2",              { event_mdown = private.get_caduceus_2 } },
    { "spr_phone_birdext_2",                { event_mdown = private.get_birdext_2 } },
    { "spr_phone_buttonext_2",              { event_mdown = private.get_buttonext_2 } },
    { "spr_phone_tombstonebasis",           { event_mdown = private.get_tombstonebasis } },
    { "spr_phone_caduceus_1",               { event_mdown = private.get_caduceus_1 } },
    { "obj_fridge_get_caduceus_2",          { event_mdown = private.get_caduceus_2 } },
    { "obj_cabinetext_use_stewardessbadge", { event_mdown = private.ClkLock } },
    { "obj_fridge_use_corkscrewext",        { event_mdown = private.FridgeCorkClick } },
    { "obj_fridge_clk_button_fridge",       { event_mdown = private.clk_button_fridge } },
    { "spr_phone_book",                     { event_mdown = function () private.PhoneBookClick( true ) end } },
    { "obj_phone_book_big",                 { event_mdown = function () private.PhoneBookClick( false ) end } },
  } );
  
  for i=0, 11 do
    ObjSet( "spr_phone_button_"..i, {
      event_menter = function () cmn.SetCursor(CURSOR_HAND); end,
      event_mleave = function () cmn.SetCursor(CURSOR_DEFAULT); end,
      event_mdown = function () private.ClkButton( i ); end,
    } );
  end;

  private.FridgeInit();
  private.InitAnims();
  private.InitSubroom();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_stewardessroom = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;
      local gates = 
      {
        "gho_stewardessroom_hofridge",
        "gho_stewardessroom_hocabinet",
        "gzz_stewardessroom_cabinetext",
        "gzz_stewardessroom_fridge",
        "gzz_stewardessroom_phone",
      }
      for i = 1, #gates do
      
        local name = gates[ i ]
        if ( common.GetObjectPrefix( name ) == "gho" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
        elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
          table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
        end;

      end;

      local mas_parent_gfx = 
      {
        private.room_objname,
        "zz_cabinetext", 
        "zz_fridge", 
        "zz_phone",
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_stewardessroom", update_game_mode_stewardessroom, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_glueext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_glueext" ] =
  {
    type = "get",
    get_obj = "spr_cabinetext_glueext",
    room = private.room_objname,
    zz = "zz_cabinetext",
    zz_gate = "gzz_stewardessroom_cabinetext"
  };
  -----------------------------------------------
  local get_glueext_inv = function ()

    int.InventoryItemAdd( "inv_glueext", "spr_cabinetext_glueext" );

    if ( cmn.IsEventDone( "use_tombstonepart_2" ) ) then

      ObjSet( "inv_tombstonebasis_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_glueext_closezz = function ()

    ObjDelete( "gfx_cabinetext_glueext" );
    --ObjDelete( "spr_cabinetext_glueext_shad" );
    ObjDelete( "spr_stewardessroom_cabinetext_glueext" );

  end;

  cmn.AddSubscriber( "get_glueext", get_glueext_inv );
  cmn.AddSubscriber( "get_glueext", get_glueext_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magnet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_magnet" ] =
  {
    type = "get",
    get_obj = "spr_fridge_magnet",
    room = private.room_objname,
    zz = "zz_fridge",
    zz_gate = "gzz_stewardessroom_fridge"
  };
  -----------------------------------------------
  local get_magnet_inv = function ()

    int.InventoryItemAdd( "inv_magnet", "spr_fridge_magnet" );

  end;

  local get_magnet_closezz = function ()

    ObjDelete( "gfx_fridge_magnet" );
    ObjDelete( "spr_fridge_magnet_shadow" );
    ObjDelete( "spr_stewardessroom_fridge_magnet" );

  end;

  cmn.AddSubscriber( "get_magnet", get_magnet_inv );
  cmn.AddSubscriber( "get_magnet", get_magnet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tombstonepart_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tombstonepart_2" ] =
  {
    type = "get",
    get_obj = "spr_fridge_tombstonepart_2",
    room = private.room_objname,
    zz = "zz_fridge",
    zz_gate = "gzz_stewardessroom_fridge"
  };
  -----------------------------------------------
  local get_tombstonepart_2_inv = function ()

    int.InventoryItemAdd( "inv_tombstonepart_2", "spr_fridge_tombstonepart_2" );

    if ( cmn.IsEventDone( "use_tombstonepart_1" ) ) then

      ObjSet( "inv_tombstonebasis_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_tombstonepart_2_closezz = function ()

    ObjDelete( "gfx_fridge_tombstonepart_2" );
    ObjDelete( "spr_fridge_tombstonepart_2_shadow" );
    ObjDelete( "spr_stewardessroom_fridge_tombstonepart_2" );
    ObjSet( "anm_stewardessroom_refrigerator_door", { animfunc = "DoAnim", playing = true, res = "assets/levels/levelext/rm_stewardessroom/anims/anm_refrigerator_door_dark_2" } );
    
  end;

  cmn.AddSubscriber( "get_tombstonepart_2", get_tombstonepart_2_inv );
  cmn.AddSubscriber( "get_tombstonepart_2", get_tombstonepart_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_caduceus_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_caduceus_2" ] =
  {
    type = "get",
    get_obj = "obj_fridge_get_caduceus_2",
    room = private.room_objname,
    zz = "zz_fridge",
    zz_gate = "gzz_stewardessroom_fridge"
  };
  -----------------------------------------------
  local get_caduceus_2_inv = function ()
  
    int.InventoryItemAdd( "inv_caduceus_2", "spr_fridge_caduceus_2" );
    ObjDelete( "obj_fridge_get_caduceus_2" );

  end;

  local get_caduceus_2_closezz = function ()

    ObjDelete( "anm_fridge_bottle" );
    ObjDelete( "gfx_fridge_caduceus_2" );    
    ObjDelete( "spr_stewardessroom_fridge_bottle" );
    ObjSet( "anm_stewardessroom_refrigerator_door", {  animfunc = "DoAnim", playing = true, res = "assets/levels/levelext/rm_stewardessroom/anims/anm_refrigerator_door_dark" } );
    
  end;

  cmn.AddSubscriber( "get_caduceus_2", get_caduceus_2_inv );
  cmn.AddSubscriber( "get_caduceus_2", get_caduceus_2_closezz, private.room_objname );
  cmn.AddSubscriber( "get_caduceus_2_inv", get_caduceus_2_inv );
  cmn.AddSubscriber( "get_caduceus_2_closezz", get_caduceus_2_closezz );
  --------------------------------------------------------------------------------------------
  -- function get_birdext_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_birdext_2" ] =
  {
    type = "get",
    get_obj = "spr_phone_birdext_2",
    room = private.room_objname,
    zz = "zz_phone",
    zz_gate = "gzz_stewardessroom_phone"
  };
  -----------------------------------------------
  local get_birdext_2_inv = function ()

    int.InventoryItemAdd( "inv_birdext_2", "spr_phone_birdext_2" );

  end;

  local get_birdext_2_closezz = function ()

    ObjDelete( "gfx_phone_birdext_2" );
    ObjDelete( "spr_phone_birdext_2_shadow" );
    ObjDelete( "gzz_stewardessroom_phone" );
    ObjDelete( "spr_stewardessroom_phone_birdext_2" );

  end;

  cmn.AddSubscriber( "get_birdext_2", get_birdext_2_inv );
  cmn.AddSubscriber( "get_birdext_2", get_birdext_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_buttonext_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_buttonext_2" ] =
  {
    type = "get",
    get_obj = "spr_phone_buttonext_2",
    room = private.room_objname,
    zz = "zz_phone",
    zz_gate = "gzz_stewardessroom_phone"
  };
  -----------------------------------------------
  local get_buttonext_2_inv = function ()

    int.InventoryItemAdd( "inv_buttonext_2", "spr_phone_buttonext_2" );

  end;

  local get_buttonext_2_closezz = function ()

    ObjDelete( "gfx_phone_buttonext_2" );
    ObjDelete( "spr_phone_buttonext_2_shadow" );
    ObjDelete( "spr_stewardessroom_phone_buttonext_2" );

  end;

  cmn.AddSubscriber( "get_buttonext_2", get_buttonext_2_inv );
  cmn.AddSubscriber( "get_buttonext_2", get_buttonext_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tombstonebasis () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tombstonebasis" ] =
  {
    type = "get",
    get_obj = "spr_phone_tombstonebasis",
    room = private.room_objname,
    zz = "zz_phone",
    zz_gate = "gzz_stewardessroom_phone"
  };
  -----------------------------------------------
  local get_tombstonebasis_inv = function ()

    int.InventoryItemAdd( "inv_tombstonebasis", "spr_phone_tombstonebasis" );
    ObjSet( "inv_tombstonebasis", { drag = false } );

    if ( not cmn.IsEventDone( "get_tombstonepart_1" ) ) then

      ObjSet( "inv_tombstonebasis_plus_focus2", { alp = 0 } );

    end;

  end;

  local get_tombstonebasis_closezz = function ()

    ObjDelete( "gfx_phone_tombstonebasis" );
    ObjDelete( "spr_phone_tombstonebasis_shadow" );
    ObjDelete( "spr_stewardessroom_phone_tombstonebasis" );

  end;

  cmn.AddSubscriber( "get_tombstonebasis", get_tombstonebasis_inv );
  cmn.AddSubscriber( "get_tombstonebasis", get_tombstonebasis_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_caduceus_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_caduceus_1" ] =
  {
    type = "get",
    get_obj = "spr_phone_caduceus_1",
    room = private.room_objname,
    zz = "zz_phone",
    zz_gate = "gzz_stewardessroom_phone"
  };
  -----------------------------------------------
  local get_caduceus_1_inv = function ()

    int.InventoryItemAdd( "inv_caduceus_1", "spr_phone_caduceus_1" );

  end;

  local get_caduceus_1_closezz = function ()

    ObjDelete( "gfx_phone_caduceus_1" );
    ObjDelete( "spr_phone_caduceus_1_shadow" );
    ObjDelete( "spr_stewardessroom_phone_caduceus_1" );

  end;

  cmn.AddSubscriber( "get_caduceus_1", get_caduceus_1_inv );
  cmn.AddSubscriber( "get_caduceus_1", get_caduceus_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_4_9 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_4_9 = function ()

    ObjDelete( "obj_stewardessroom_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_4_9", get_morphobject_4_9, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_stewardessbadge () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_stewardessbadge" ] =
  {
    type = "use",
    use_obj = "inv_stewardessbadge",
    use_place = "obj_cabinetext_use_stewardessbadge",
    room = private.room_objname,
    zz = "zz_cabinetext",
    zz_gate = "gzz_stewardessroom_cabinetext"
  };
  -----------------------------------------------
  local use_stewardessbadge_inv = function ()

    int.InventoryItemRemove( "inv_stewardessbadge" );

  end;
  local use_stewardessbadge_beg = function ()

    ObjDelete( "obj_cabinetext_use_stewardessbadge" );

  end;
  local use_stewardessbadge_end = function ()

    ObjDelete( "spr_cabinetext_lock" );
    ObjDelete( "gzz_stewardessroom_cabinetext" );
    ObjSet( "gho_stewardessroom_hocabinet", { active = true, input = true, alp = 1 } );
    ObjSet( "spr_stewardessroom_cabinetext_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_stewardessbadge", use_stewardessbadge_beg, private.room_objname );
  cmn.AddSubscriber( "use_stewardessbadge", use_stewardessbadge_inv );
  cmn.AddSubscriber( "use_stewardessbadge", use_stewardessbadge_end, private.room_objname );
  cmn.AddSubscriber( "use_stewardessbadge_inv", use_stewardessbadge_inv, private.room_objname );
  cmn.AddSubscriber( "use_stewardessbadge_beg", use_stewardessbadge_beg, private.room_objname );
  cmn.AddSubscriber( "use_stewardessbadge_end", use_stewardessbadge_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_buttonext_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_buttonext_1" ] =
  {
    type = "use",
    use_obj = "inv_buttonext_1",
    use_place = "obj_fridge_use_buttonext_1",
    room = private.room_objname,
    zz = "zz_fridge",
    zz_gate = "gzz_stewardessroom_fridge"
  };
  -----------------------------------------------
  local use_buttonext_1_inv = function ()

    int.InventoryItemRemove( "inv_buttonext_1" );

  end;
  local use_buttonext_1_beg = function ()

    ObjDelete( "obj_fridge_use_buttonext_1" );

  end;
  local use_buttonext_1_end = function ()

  ObjSet( "spr_fridge_buttonext_1", { alp = 1 } );
  ObjSet( "spr_stewardessroom_fridge_button_1", { alp = 1 } );
    
    if ( cmn.IsEventDone( "use_buttonext_2" ) ) then

      ObjSet( "obj_fridge_sells", { input = true } );
      ObjSet( "spr_stewardessroom_fridge_cell", { alp = 1 } );
      
    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_buttonext_1", use_buttonext_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_buttonext_1", use_buttonext_1_inv );
  cmn.AddSubscriber( "use_buttonext_1", use_buttonext_1_end, private.room_objname );
  cmn.AddSubscriber( "use_buttonext_1_inv", use_buttonext_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_buttonext_1_beg", use_buttonext_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_buttonext_1_end", use_buttonext_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_buttonext_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_buttonext_2" ] =
  {
    type = "use",
    use_obj = "inv_buttonext_2",
    use_place = "obj_fridge_use_buttonext_2",
    room = private.room_objname,
    zz = "zz_fridge",
    zz_gate = "gzz_stewardessroom_fridge"
  };
  -----------------------------------------------
  local use_buttonext_2_inv = function ()

    int.InventoryItemRemove( "inv_buttonext_2" );

  end;
  local use_buttonext_2_beg = function ()

    ObjDelete( "obj_fridge_use_buttonext_2" );

  end;
  local use_buttonext_2_end = function ()

  ObjSet( "spr_fridge_buttonext_2", { alp = 1 } );
  ObjSet( "spr_stewardessroom_fridge_button_2", { alp = 1 } );
    
    if ( cmn.IsEventDone( "use_buttonext_1" ) ) then

      ObjSet( "obj_fridge_sells", { input = true } );
      ObjSet( "spr_stewardessroom_fridge_cell", { alp = 1 } );
      
    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_buttonext_2", use_buttonext_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_buttonext_2", use_buttonext_2_inv );
  cmn.AddSubscriber( "use_buttonext_2", use_buttonext_2_end, private.room_objname );
  cmn.AddSubscriber( "use_buttonext_2_inv", use_buttonext_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_buttonext_2_beg", use_buttonext_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_buttonext_2_end", use_buttonext_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_corkscrewext () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_corkscrewext" ] =
  {
    type = "use",
    use_obj = "inv_corkscrewext",
    use_place = "obj_fridge_use_corkscrewext",
    room = private.room_objname,
    zz = "zz_fridge",
    zz_gate = "gzz_stewardessroom_fridge"
  };
  -----------------------------------------------
  local use_corkscrewext_inv = function ()

    int.InventoryItemRemove( "inv_corkscrewext" );

  end;
  local use_corkscrewext_beg = function ()

    ObjDelete( "obj_fridge_use_corkscrewext" );

  end;
  local use_corkscrewext_end = function ()

    ObjDelete( "obj_fridge_bottle" );
    ObjDelete( "vid_fridge_use_corkscrew" );
    ObjSet( "anm_fridge_bottle",         { alp = 1 } );
    ObjSet( "obj_fridge_get_caduceus_2", { input = true } );
    ObjSet( "gfx_fridge_caduceus_2",     { active = true } );
    ObjSet( "anm_stewardessroom_refrigerator_door", {  animfunc = "DoAnim", playing = true, res = "assets/levels/levelext/rm_stewardessroom/anims/anm_refrigerator_door_dark_3" } );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_corkscrewext", use_corkscrewext_beg, private.room_objname );
  cmn.AddSubscriber( "use_corkscrewext", use_corkscrewext_inv );
  cmn.AddSubscriber( "use_corkscrewext", use_corkscrewext_end, private.room_objname );
  cmn.AddSubscriber( "use_corkscrewext_inv", use_corkscrewext_inv, private.room_objname );
  cmn.AddSubscriber( "use_corkscrewext_beg", use_corkscrewext_beg, private.room_objname );
  cmn.AddSubscriber( "use_corkscrewext_end", use_corkscrewext_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_flashlight () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_flashlight" ] =
  {
    type = "use",
    use_obj = "inv_flashlight",
    use_place = "obj_fridge_use_flashlight",
    room = private.room_objname,
    zz = "zz_fridge",
    zz_gate = "gzz_stewardessroom_fridge"
  };
  -----------------------------------------------
  local use_flashlight_inv = function ()

    int.InventoryItemRemove( "inv_flashlight" );

  end;
  local use_flashlight_beg = function ()

    ObjDelete( "obj_fridge_use_flashlight" );

  end;
  local use_flashlight_end = function ()

    ObjDelete( "anm_fridge_vegetables" );
    ObjSet( "obj_fridge_clk_button_fridge", { input = true, active = true } );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_flashlight", use_flashlight_beg, private.room_objname );
  cmn.AddSubscriber( "use_flashlight", use_flashlight_inv );
  cmn.AddSubscriber( "use_flashlight", use_flashlight_end, private.room_objname );
  cmn.AddSubscriber( "use_flashlight_inv", use_flashlight_inv, private.room_objname );
  cmn.AddSubscriber( "use_flashlight_beg", use_flashlight_beg, private.room_objname );
  cmn.AddSubscriber( "use_flashlight_end", use_flashlight_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spring_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_spring_1" ] =
  {
    type = "use",
    use_obj = "inv_spring_1",
    use_place = "obj_phone_use_spring_1",
    room = private.room_objname,
    zz = "zz_phone",
    zz_gate = "gzz_stewardessroom_phone"
  };
  -----------------------------------------------
  local use_spring_1_inv = function ()

    int.InventoryItemRemove( "inv_spring_1" );

  end;
  local use_spring_1_beg = function ()

    ObjDelete( "obj_phone_use_spring_1" );

  end;
  local use_spring_1_end = function ()

    ObjSet( "spr_phone_spring_1", { alp = 1 } );
    ObjSet( "spr_stewardessroom_phone_spring1", { alp = 1 } );
  
    if ( cmn.IsEventDone( "use_spring_2" ) ) and
       ( cmn.IsEventDone( "use_spring_3" ) ) then
    
      ObjSet( "spr_phone_tombstonebasis", { input = true, active = true } );
      ObjSet( "spr_phone_buttonext_2",    { input = true, active = true } );
      ObjSet( "obj_phone_box_open",       { alp = 1 } );
      ObjDelete( "obj_phone_box_close" );
      
      ObjSet( "spr_stewardessroom_phone_open",       { alp = 1 } );
      ObjDelete( "obj_stewardessroom_phone_box_closed" );
      
    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_spring_1", use_spring_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_spring_1", use_spring_1_inv );
  cmn.AddSubscriber( "use_spring_1", use_spring_1_end, private.room_objname );
  cmn.AddSubscriber( "use_spring_1_inv", use_spring_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_spring_1_beg", use_spring_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_spring_1_end", use_spring_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spring_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_spring_2" ] =
  {
    type = "use",
    use_obj = "inv_spring_2",
    use_place = "obj_phone_use_spring_2",
    room = private.room_objname,
    zz = "zz_phone",
    zz_gate = "gzz_stewardessroom_phone"
  };
  -----------------------------------------------
  local use_spring_2_inv = function ()

    int.InventoryItemRemove( "inv_spring_2" );

  end;
  local use_spring_2_beg = function ()

    ObjDelete( "obj_phone_use_spring_2" );

  end;
  local use_spring_2_end = function ()

    ObjSet( "spr_phone_spring_2", { alp = 1 } );
    ObjSet( "spr_stewardessroom_phone_spring2", { alp = 1 } );
  
    if ( cmn.IsEventDone( "use_spring_1" ) ) and
       ( cmn.IsEventDone( "use_spring_3" ) ) then
    
      ObjSet( "spr_phone_tombstonebasis", { input = true, active = true } );
      ObjSet( "spr_phone_buttonext_2",    { input = true, active = true } );
      ObjSet( "obj_phone_box_open",       { alp = 1 } );
      ObjDelete( "obj_phone_box_close" );
      
      ObjSet( "spr_stewardessroom_phone_open",       { alp = 1 } );
      ObjDelete( "obj_stewardessroom_phone_box_closed" );
      
    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_spring_2", use_spring_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_spring_2", use_spring_2_inv );
  cmn.AddSubscriber( "use_spring_2", use_spring_2_end, private.room_objname );
  cmn.AddSubscriber( "use_spring_2_inv", use_spring_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_spring_2_beg", use_spring_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_spring_2_end", use_spring_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spring_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_spring_3" ] =
  {
    type = "use",
    use_obj = "inv_spring_3",
    use_place = "obj_phone_use_spring_3",
    room = private.room_objname,
    zz = "zz_phone",
    zz_gate = "gzz_stewardessroom_phone"
  };
  -----------------------------------------------
  local use_spring_3_inv = function ()

    int.InventoryItemRemove( "inv_spring_3" );

  end;
  local use_spring_3_beg = function ()

    ObjDelete( "obj_phone_use_spring_3" );

  end;
  local use_spring_3_end = function ()

    ObjSet( "spr_phone_spring_3", { alp = 1 } );
    ObjSet( "spr_stewardessroom_phone_spring3", { alp = 1 } );
  
    if ( cmn.IsEventDone( "use_spring_1" ) ) and
       ( cmn.IsEventDone( "use_spring_2" ) ) then
    
      ObjSet( "spr_phone_tombstonebasis", { input = true, active = true } );
      ObjSet( "spr_phone_buttonext_2",    { input = true, active = true } );
      ObjSet( "obj_phone_box_open",       { alp = 1 } );
      ObjDelete( "obj_phone_box_close" );
      
      ObjSet( "spr_stewardessroom_phone_open",       { alp = 1 } );
      ObjDelete( "obj_stewardessroom_phone_box_closed" );
      
    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_spring_3", use_spring_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_spring_3", use_spring_3_inv );
  cmn.AddSubscriber( "use_spring_3", use_spring_3_end, private.room_objname );
  cmn.AddSubscriber( "use_spring_3_inv", use_spring_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_spring_3_beg", use_spring_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_spring_3_end", use_spring_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_phonenumber_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_phonenumber_1" ] =
  {
    type = "use",
    use_obj = "inv_phonenumber_1",
    use_place = "obj_phone_use_phonenumber_1",
    room = private.room_objname,
    zz = "zz_phone",
    zz_gate = "gzz_stewardessroom_phone"
  };
  -----------------------------------------------
  local use_phonenumber_1_inv = function ()

    int.InventoryItemRemove( "inv_phonenumber_1" );

  end;
  local use_phonenumber_1_beg = function ()

    ObjDelete( "obj_phone_use_phonenumber_1" );
    ObjDelete( "obj_phone_use_phonenumber_1_book" );
    
  end;
  local use_phonenumber_1_end = function ()

    ObjSet( "spr_phone_caduceus_1",        { alp = 1, input = true } );
    ObjSet( "gfx_phone_caduceus_1",        { active = true } );
    ObjSet( "spr_phone_caduceus_1_shadow", { alp = 1 } );
    ObjSet( "spr_phone_phonenumber_1",     { alp = 1 } );
    ObjDelete( "anm_phone_put" );
    ObjDelete( "anm_phone_call" );
    ObjSet( "spr_stewardessroom_phone_caduceus_1",     { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_phonenumber_1", use_phonenumber_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_phonenumber_1", use_phonenumber_1_inv );
  cmn.AddSubscriber( "use_phonenumber_1", use_phonenumber_1_end, private.room_objname );
  cmn.AddSubscriber( "use_phonenumber_1_inv", use_phonenumber_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_phonenumber_1_beg", use_phonenumber_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_phonenumber_1_end", use_phonenumber_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_phonenumber_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_phonenumber_2" ] =
  {
    type = "use",
    use_obj = "inv_phonenumber_2",
    use_place = "obj_phone_use_phonenumber_2",
    room = private.room_objname,
    zz = "zz_phone",
    zz_gate = "gzz_stewardessroom_phone"
  };
  -----------------------------------------------
  local use_phonenumber_2_inv = function ()

    int.InventoryItemRemove( "inv_phonenumber_2" );

  end;
  local use_phonenumber_2_beg = function ()

    ObjDelete( "obj_phone_use_phonenumber_2" );
    ObjDelete( "obj_phone_use_phonenumber_2_book" );
    
  end;
  local use_phonenumber_2_end = function ()

    ObjSet( "obj_phone_broken",        { alp = 1 } );
    ObjSet( "spr_phone_phonenumber_2", { alp = 1 } );
    ObjSet( "spr_phone_birdext_2",     { input = true } );
    ObjSet( "gfx_phone_birdext_2",     { active = true } );
    ObjDelete( "anm_phone_take" );
    ObjDelete( "anm_phone_explosion" );
    ObjDelete( "obj_phone_buttons" );
    
    ObjSet( "spr_stewardessroom_phone_broken",        { alp = 1 } );
    ObjDelete( "spr_stewardessroom_phone_phone" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_phonenumber_2", use_phonenumber_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_phonenumber_2", use_phonenumber_2_inv );
  cmn.AddSubscriber( "use_phonenumber_2", use_phonenumber_2_end, private.room_objname );
  cmn.AddSubscriber( "use_phonenumber_2_inv", use_phonenumber_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_phonenumber_2_beg", use_phonenumber_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_phonenumber_2_end", use_phonenumber_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_button_fridge () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_button_fridge" ] =
  {
    type = "click",
    clk_obj = "obj_fridge_clk_button_fridge",
    room = private.room_objname,
    zz = "zz_fridge",
    zz_gate = "gzz_stewardessroom_fridge"
  };
  -----------------------------------------------
  local clk_button_fridge_beg = function ()

    ObjDelete( "obj_fridge_clk_button_fridge" );

  end;
  local clk_button_fridge_end = function ()
  
    ObjSet( "anm_stewardessroom_refrigerator_door", {  animfunc = "DoAnim", playing = true, res = "assets/levels/levelext/rm_stewardessroom/anims/anm_refrigerator_door_light" } );
    ObjDelete( "spr_stewardessroom_fridge_open_dark" );
    ObjDelete( "gzz_stewardessroom_fridge" );
    ObjSet( "gho_stewardessroom_hofridge", { input = true, alp = 1, active = true } );
    ObjSet( "anm_stewardessroom_refrigerator_door_light", { alp = 1 } );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_button_fridge", clk_button_fridge_beg, private.room_objname );
  cmn.AddSubscriber( "clk_button_fridge", clk_button_fridge_end, private.room_objname );
  cmn.AddSubscriber( "clk_button_fridge_beg", clk_button_fridge_beg, private.room_objname );
  cmn.AddSubscriber( "clk_button_fridge_end", clk_button_fridge_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_fridge () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_fridge" ] =
  {
    room = private.room_objname,
    zz = "zz_fridge",
    zz_gate = "gzz_stewardessroom_fridge"
  };
  --*********************************************************************************************************************
  local win_fridge = function ()

    if ( cmn.IsEventDone( "win_fridge" ) ) then

      ObjDelete( "obj_fridge_close" );
      ObjDelete( "obj_stewardessroom_fridge_closed" );
      ObjSet( "obj_fridge_open", { alp = 1, input = true } );
      ObjSet( "gfx_fridge_tombstonepart_2", { active = true } );
      ObjSet( "obj_stewardessroom_fridge_open", { alp = 1 } );
      
    elseif ( cmn.IsEventStart( "win_fridge" ) ) then

      private.FridgeLoad();   

    end;

  end;

  cmn.AddSubscriber( "win_fridge", win_fridge, private.room_objname );
  
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------
function private.get_glueext ()

  cmn.SetEventDone( "get_glueext" );
  cmn.CallEventHandler( "get_glueext" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_magnet ()

  cmn.SetEventDone( "get_magnet" );
  cmn.CallEventHandler( "get_magnet" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_tombstonepart_2 ()

  cmn.SetEventDone( "get_tombstonepart_2" );
  cmn.CallEventHandler( "get_tombstonepart_2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_birdext_2 ()

  cmn.SetEventDone( "get_birdext_2" );
  cmn.CallEventHandler( "get_birdext_2" );
  cmn.CloseSubRoom();
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_buttonext_2 ()

  cmn.SetEventDone( "get_buttonext_2" );
  cmn.CallEventHandler( "get_buttonext_2" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_tombstonebasis ()

  cmn.SetEventDone( "get_tombstonebasis" );
  cmn.CallEventHandler( "get_tombstonebasis" );
  
  cmn.GetObjectSfx();

  if ( not cmn.IsEventDone( "get_buttonext_2" ) ) then
    
    private.get_buttonext_2();
    
  end;
  
end;
-------------------------------------------------
function private.get_caduceus_1 ()

  cmn.SetEventDone( "get_caduceus_1" );
  cmn.CallEventHandler( "get_caduceus_1" );
  
  cmn.GetObjectSfx();

end;
-------------------------------------------------
function private.get_caduceus_2 ()

  local func_end = function ()

    int.Lock( false );  
    cmn.SetEventDone( "get_caduceus_2" );
    cmn.CallEventHandler( "get_caduceus_2_closezz" );
    cmn.GetObjectSfx();
    
  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_ottabottle" );
  
  AnimPlay( "anm_fridge_bottle", "DoAnim",
  function ()

    cmn.CallEventHandler( "get_caduceus_2_inv" );
    
    ObjAnimate( "anm_fridge_bottle", "alp", 0, 0, func_end, 
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );
    
  end );
  
end;
--*********************************************************************************************************************
-------------------------------------------------
function public.use_stewardessbadge ()

  local item = "inv_stewardessbadge";

  if ( cmn.ApplyObj( item, "gzz_stewardessroom_cabinetext", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cabinetext" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cabinetext_use_stewardessbadge", true ) ) then

    cmn.CallEventHandler( "use_stewardessbadge_inv" );
    cmn.CallEventHandler( "use_stewardessbadge_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_stewardessbadge" );
      cmn.CallEventHandler( "use_stewardessbadge_end" );
      int.Lock( false );
      cmn.CloseSubRoom();

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_avia" );

    ObjAnimate( "spr_cabinetext_medalion", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "spr_cabinetext_lock", "pos_xy", 0, 0, "",
    { 
      0.0, 0, 312, 365, 
      0.3, 0, 312, 365, 
      0.8, 0, 427, 369
    } );

    ObjAnimate( "spr_cabinetext_open_door", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.8, 0, 0.0, 
      1.1, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_buttonext_1 ()

  local item = "inv_buttonext_1";

  if ( cmn.ApplyObj( item, "gzz_stewardessroom_fridge", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fridge" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_fridge_use_buttonext_1", true ) ) then

    cmn.CallEventHandler( "use_buttonext_1_inv" );
    cmn.CallEventHandler( "use_buttonext_1_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_buttonext_1" );
      cmn.CallEventHandler( "use_buttonext_1_end" );
      int.Lock( false );

      if ( cmn.IsEventDone( "use_buttonext_2" ) ) then
        
        cmn.MiniGameShow( "fridge" );
        common_impl.PassingMgStart( "fridge" );

        if ( cmn.IsEventDone( "use_buttonext_2" ) ) then

          ng_global.progress[ "ext" ][ "win_fridge" ].cells =
          {
            false, false, false, false, false, false,
            false, false, false, false, false, false,
            false, false, false, false, false, false,
            false, false, false, false, false, false,
            false, false, false, false, false, false,
            false, false, false, false, false, false,
          };
        
        end;
    
      end;
      
    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_button2" );

    ObjAnimate( "spr_fridge_buttonext_1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_buttonext_2 ()

  local item = "inv_buttonext_2";

  if ( cmn.ApplyObj( item, "gzz_stewardessroom_fridge", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fridge" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_fridge_use_buttonext_2", true ) ) then

    cmn.CallEventHandler( "use_buttonext_2_inv" );
    cmn.CallEventHandler( "use_buttonext_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_buttonext_2" );
      cmn.CallEventHandler( "use_buttonext_2_end" );
      int.Lock( false );

      if ( cmn.IsEventDone( "use_buttonext_1" ) ) then
        
        cmn.MiniGameShow( "fridge" );
        common_impl.PassingMgStart( "fridge" );

        if ( cmn.IsEventDone( "use_buttonext_2" ) ) then

          ng_global.progress[ "ext" ][ "win_fridge" ].cells =
          {
            false, false, false, false, false, false,
            false, false, false, false, false, false,
            false, false, false, false, false, false,
            false, false, false, false, false, false,
            false, false, false, false, false, false,
            false, false, false, false, false, false,
          };
        
        end;

      end;
      
    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_button2" );

    ObjAnimate( "spr_fridge_buttonext_2", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_corkscrewext ()

  local item = "inv_corkscrewext";

  if ( cmn.ApplyObj( item, "gzz_stewardessroom_fridge", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fridge" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_fridge_use_corkscrewext", true ) ) then

    cmn.CallEventHandler( "use_corkscrewext_inv" );
    cmn.CallEventHandler( "use_corkscrewext_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_corkscrewext" );
      cmn.CallEventHandler( "use_corkscrewext_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_openbottle" );
    
    ObjSet( "obj_fridge_bottle", { alp = 0 } );
    ObjSet( "vid_fridge_use_corkscrew", { alp = 1 } );
    VidPlay( "vid_fridge_use_corkscrew", func_end );


    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_flashlight ()

  local item = "inv_flashlight";

  if ( cmn.ApplyObj( item, "gzz_stewardessroom_fridge", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fridge" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_fridge_use_flashlight", true ) ) then

    cmn.CallEventHandler( "use_flashlight_inv" );
    cmn.CallEventHandler( "use_flashlight_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_flashlight" );
      cmn.CallEventHandler( "use_flashlight_end" );
      int.Lock( false );
      
    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_flashlight" );

    AnimPlay( "anm_fridge_vegetables", "DoAnim", func_end );
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_spring_1 ()

  local item = "inv_spring_1";
  local book_big_alp = ObjGet( "obj_phone_book_big" ).alp;

  if ( cmn.ApplyObj( item, "gzz_stewardessroom_phone", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_phone" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_phone_use_spring_1", true ) ) and
         ( book_big_alp == 0 ) then

    cmn.CallEventHandler( "use_spring_1_inv" );
    cmn.CallEventHandler( "use_spring_1_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_spring_1" );
      cmn.CallEventHandler( "use_spring_1_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_archipelag" );

    if ( cmn.IsEventDone( "use_spring_2" ) ) and
       ( cmn.IsEventDone( "use_spring_3" ) ) then
       
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_opendrawer1" );
    
      ObjAnimate( "spr_phone_spring_1", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
      ObjAnimate( "obj_phone_box_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.5, 0, 0.0, 
        0.8, 0, 1.0
      } );
      
    else

      ObjAnimate( "spr_phone_spring_1", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
    end;
      
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_spring_2 ()

  local item = "inv_spring_2";
  local book_big_alp = ObjGet( "obj_phone_book_big" ).alp;

  if ( cmn.ApplyObj( item, "gzz_stewardessroom_phone", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_phone" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_phone_use_spring_2", true ) ) and
         ( book_big_alp == 0 ) then

    cmn.CallEventHandler( "use_spring_2_inv" );
    cmn.CallEventHandler( "use_spring_2_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_spring_2" );
      cmn.CallEventHandler( "use_spring_2_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_archipelag" );

    if ( cmn.IsEventDone( "use_spring_1" ) ) and
       ( cmn.IsEventDone( "use_spring_3" ) ) then
       
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_opendrawer1" );
    
      ObjAnimate( "spr_phone_spring_2", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
      ObjAnimate( "obj_phone_box_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.5, 0, 0.0, 
        0.8, 0, 1.0
      } );
      
    else

      ObjAnimate( "spr_phone_spring_2", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
    end;
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-------------------------------------------------
function public.use_spring_3 ()

  local item = "inv_spring_3";
  local book_big_alp = ObjGet( "obj_phone_book_big" ).alp;

  if ( cmn.ApplyObj( item, "gzz_stewardessroom_phone", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_phone" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_phone_use_spring_3", true ) ) and
         ( book_big_alp == 0 ) then

    cmn.CallEventHandler( "use_spring_3_inv" );
    cmn.CallEventHandler( "use_spring_3_beg" );
    int.Lock( true );

    local func_end = function ()

      cmn.SetEventDone( "use_spring_3" );
      cmn.CallEventHandler( "use_spring_3_end" );
      int.Lock( false );

    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_archipelag" );

    if ( cmn.IsEventDone( "use_spring_1" ) ) and
       ( cmn.IsEventDone( "use_spring_2" ) ) then
       
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_opendrawer1" );
    
      ObjAnimate( "spr_phone_spring_3", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
      ObjAnimate( "obj_phone_box_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.5, 0, 0.0, 
        0.8, 0, 1.0
      } );
      
    else

      ObjAnimate( "spr_phone_spring_3", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
    end;
    
    return true;

  end;

  return false;

end;
-------------------------------------------------
-----------------------------------------------
function public.use_phonenumber_1 ()

  local item = "inv_phonenumber_1";
  local book_big_alp = ObjGet( "obj_phone_book_big" ).alp;
  
  if ( cmn.ApplyObj( item, "gzz_stewardessroom_phone", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_phone" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_phone_use_phonenumber_1", true ) ) or
         ( ( book_big_alp == 1 ) and ( cmn.ApplyObj( item, "obj_phone_use_phonenumber_1_book", true ) ) )  then

    cmn.CallEventHandler( "use_phonenumber_1_inv" );
    cmn.CallEventHandler( "use_phonenumber_1_beg" );
    int.Lock( true );

    local func_end = function ()

    AnimPlay( "anm_phone_take", "DoAnim", 
      function ()
        ObjSet( "anm_phone_take", { alp = 0, frame = 0 } );
        ObjSet( "anm_phone_call", { alp = 1 } );
        AnimPlay( "anm_phone_call", "DoAnim", function () private.use_phonenumber_1_end(); end );
      end
    );

    end;
  
    local insert_func = function ()
    
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_number" );
      
      ObjAnimate( "obj_phone_book_big", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0,
        0.5, 0, 1.0,
        0.8, 0, 0.0,
      } );
      
      ObjAnimate( "spr_phone_book", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0,
        0.5, 0, 0.0,
        0.8, 0, 1.0,
      } );
      
      ObjAnimate( "spr_phone_phonenumber_1", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
    
    end;
  
    ObjSet( "obj_phone_buttons", { alp = 0 } );

    if ( book_big_alp == 0 ) then
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_opendiary" );
    
      ObjAnimate( "obj_phone_book_big", "alp", 0, 0, insert_func,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );    
    
    else
      
      insert_func();
      
    end;
    
    return true;

  end;

  return false;

end;
-----------------------------------------------
function private.use_phonenumber_1_end ()
  
  local func_end = function ()

    ObjSet( "spr_phone_book",     { alp = 1, input = true } );
    ObjSet( "obj_phone_book_big", { alp = 0, input = false } );
    ObjSet( "anm_phone_put", { alp = 0 } );
    ObjSet( "anm_phone_take", { alp = 1 } );
    ObjSet( "obj_phone_buttons", { alp = 1 } );

    cmn.SetEventDone( "use_phonenumber_1" );
    cmn.CallEventHandler( "use_phonenumber_1_end" );
    int.Lock( false );

  end;
  
  ObjSet( "anm_phone_call", { alp = 0 } );
  ObjSet( "anm_phone_put", { alp = 1 } );
  ObjSet( "spr_phone_caduceus_1", { alp = 1 } );
  ObjSet( "spr_phone_caduceus_1_shadow", { alp = 1 } );
  AnimPlay( "anm_phone_put", "DoAnim", func_end );
    
    
end;
-------------------------------------------------
-------------------------------------------------
function public.use_phonenumber_2 ()

  local item = "inv_phonenumber_2";
  local book_big_alp = ObjGet( "obj_phone_book_big" ).alp;

  if ( cmn.ApplyObj( item, "gzz_stewardessroom_phone", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_phone" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_phone_use_phonenumber_2", true ) ) or
         ( ( book_big_alp == 1 ) and ( cmn.ApplyObj( item, "obj_phone_use_phonenumber_2_book", true ) ) )  then

    cmn.CallEventHandler( "use_phonenumber_2_inv" );
    cmn.CallEventHandler( "use_phonenumber_2_beg" );
    int.Lock( true );

    local func_end = function ()

      AnimPlay( "anm_phone_take", "DoAnim", function () private.use_phonenumber_2_end(); end );

    end;
    
    local insert_func = function ()
    
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_phoneexplode" );
      
      ObjAnimate( "obj_phone_book_big", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0,
        0.5, 0, 1.0,
        0.8, 0, 0.0,
      } );
      
      ObjAnimate( "spr_phone_book", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0,
        0.5, 0, 0.0,
        0.8, 0, 1.0,
      } );
      
      ObjAnimate( "spr_phone_phonenumber_2", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
      
    end;
    
    ObjSet( "obj_phone_buttons", { alp = 0 } );

    if ( book_big_alp == 0 ) then
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_opendiary" );

      ObjAnimate( "obj_phone_book_big", "alp", 0, 0, insert_func,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

    
    else
      
      insert_func();
      
    end;
      
    return true;

  end;

  return false;

end;
-------------------------------------------------
function private.use_phonenumber_2_end ()
  
  local func_end = function ()

    ObjSet( "spr_phone_book",     { alp = 1, input = true } );
    ObjSet( "obj_phone_book_big", { alp = 0, input = false } );

    cmn.SetEventDone( "use_phonenumber_2" );
    cmn.CallEventHandler( "use_phonenumber_2_end" );
    int.Lock( false );

  end;   
  
  ObjSet( "anm_phone_take", { alp = 0 } );  
  ObjSet( "anm_phone_explosion", { alp = 1 } );
  AnimPlay( "anm_phone_explosion", "DoAnim", func_end );
    
end;
-------------------------------------------------
-------------------------------------------------
function private.clk_button_fridge()

  cmn.CallEventHandler( "clk_button_fridge_beg" );
  int.Lock( true );

  local func_end = function ()

    cmn.SetEventDone( "clk_button_fridge" );
    cmn.CallEventHandler( "clk_button_fridge_end" );
    cmn.CloseSubRoom();
    int.Lock( false );

  end;

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_turnonthelight" );
  
  ObjAnimate( "spr_fridge_open_up_shadow", "alp", 0, 0, "",
  { 
    0.0, 3, 1.0, 
    0.3, 3, 0.0,
  } );
    
  ObjAnimate( "spr_fridge_button", "alp", 0, 0, func_end,
  { 
    0.0, 3, 0.0, 
    0.3, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_stewardessroom ()

  if not ( cmn.IsEventDone( "opn_stewardessroom" ) ) then

    cmn.SetEventDone( "opn_stewardessroom" );
    cmn.ShowBbt( "bbt_stewardessroom_first_open" );

  end;

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_fridge" );
  subroom.Define( "zz_phone" );
  -------------------------------------------------
  function zz_fridge.Open ()

    if ( cmn.IsEventDone( "use_buttonext_1" ) and cmn.IsEventDone( "use_buttonext_2" ) and not cmn.IsEventDone( "win_fridge" ) ) then

      cmn.MiniGameShow( "fridge" );
      common_impl.PassingMgStart( "fridge" );

    end;

  end;
  -------------------------------------------------
  function zz_fridge.PreClose ()

    if ( cmn.IsEventDone( "use_buttonext_1" ) and cmn.IsEventDone( "use_buttonext_2" ) and not cmn.IsEventDone( "win_fridge" ) ) then

      cmn.MiniGameHide( "fridge" );
      common_impl.PassingMgStop( "fridge" );

    end;

  end;
  -------------------------------------------------
  function zz_fridge.Skip ()
    
    private.FridgeSkip();
    
  end;
  -------------------------------------------------
  function zz_fridge.Reset ()

    private.FridgeReset();

  end;
  -------------------------------------------------

  function zz_phone.Close()

    ObjSet( "spr_phone_book",     { alp = 1, input = true } );
    ObjSet( "obj_phone_book_big", { alp = 0, input = false } );

  end;
  
end;
--*********************************************************************************************************************
function public.Load ()
  -- вызывается сразу после загрузки профиля

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_stewardessroom();
  
  cmn.StopAllEnv( "audio/level4/env/aud_stewardessroom_env", true );
  cmn.PlayAudio( "env", "audio/level4/env/aud_stewardessroom_env", 1, 2.5 );   

end;
--*********************************************************************************************************************
function public.Task ()
  
  int.AddedTaskMap( private.room_objname, "get_glueext" );
  int.AddedTaskMap( private.room_objname, "get_magnet" );
  int.AddedTaskMap( private.room_objname, "get_tombstonepart_2",                                    { "win_fridge" } );
  int.AddedTaskMap( private.room_objname, "get_caduceus_2",                                         { "use_corkscrewext" } );
  int.AddedTaskMap( private.room_objname, "get_birdext_2",                                          { "use_phonenumber_2" } );
  int.AddedTaskMap( private.room_objname, "get_buttonext_2",                                        { "use_spring_1", "use_spring_2", "use_spring_3" } );
  int.AddedTaskMap( private.room_objname, "get_tombstonebasis",                                     { "use_spring_1", "use_spring_2", "use_spring_3" } );
  int.AddedTaskMap( private.room_objname, "get_caduceus_1",                                         { "use_phonenumber_1" } );
  
  int.AddedTaskMap( private.room_objname, "use_stewardessbadge",                                    { "get_stewardessbadge" } );
  int.AddedTaskMap( private.room_objname, "use_buttonext_1",                                        { "get_buttonext_1" } );
  int.AddedTaskMap( private.room_objname, "use_buttonext_2",                                        { "get_buttonext_2" } );
  int.AddedTaskMap( private.room_objname, "use_corkscrewext",                                       { "get_corkscrewext" } );
  int.AddedTaskMap( private.room_objname, "use_flashlight",                                         { "get_flashlight" } );
  int.AddedTaskMap( private.room_objname, "use_spring_1",                                           { "get_spring_1" } );
  int.AddedTaskMap( private.room_objname, "use_spring_2",                                           { "get_spring_2" } );
  int.AddedTaskMap( private.room_objname, "use_spring_3",                                           { "get_spring_3" } );
  int.AddedTaskMap( private.room_objname, "use_phonenumber_1",                                      { "get_phonenumber_1" } );
  int.AddedTaskMap( private.room_objname, "use_phonenumber_2",                                      { "get_phonenumber_2" } );
  
  int.AddedTaskMap( private.room_objname, "win_fridge",                                             { "use_buttonext_1", "use_buttonext_2" } );
  int.AddedTaskMap( private.room_objname, "win_hofridge",                                           { "use_flashlight" } );
  int.AddedTaskMap( private.room_objname, "win_hocabinet",                                          { "use_stewardessbadge" } );
  
end;  
--*********************************************************************************************************************
function private.ClkLock ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_cabinetext_use_stewardessbadge" );

  end;

  int.Lock( true );

  ObjAnimate( "spr_cabinetext_lock", "pos_xy", 0, 0, func_end, 
  {
    0.0, 3, 312, 365,
    0.2, 3, 320, 366,
    0.3, 3, 312, 365,
    0.4, 3, 320, 366,
    0.6, 3, 312, 365,
  } );
  
  ObjAnimate( "spr_cabinetext_door", "scale_xy", 0, 0, func_end, 
  {
    0.0, 3, 1, 1,
    0.2, 3, 1.01, 1.01,
    0.3, 3, 1, 1,
    0.4, 3, 1.01, 1.01,
    0.6, 3, 1, 1,
  } );
  
  ObjAnimate( "obj_cabinetext_lock", "scale_xy", 0, 0, func_end, 
  {
    0.0, 3, 1, 1,
    0.2, 3, 1.002, 1.002,
    0.3, 3, 1, 1,
    0.4, 3, 1.002, 1.002,
    0.6, 3, 1, 1,
  } );

end;
--*********************************************************************************************************************
function private.FridgeCorkClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_fridge_use_corkscrewext" );

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_cork" );

  ObjAnimate( "spr_fridge_cork", "pos_xy", 0, 0, func_end, 
  {
    0.0, 3, 33, -93,
    0.2, 3, 35, -97,
    0.3, 3, 33, -93,
    0.4, 3, 35, -97,
    0.6, 3, 33, -93,
  } );

end;
--*********************************************************************************************************************
function private.PhoneBookClick ( is_open )

  local alp_1 = 1;
  local alp_2 = 0;
  local inp_1 = false;
  local inp_2 = true;
  
  if ( not is_open ) then

    alp_1 = 0;
    alp_2 = 1;
    inp_1 = true;
    inp_2 = false;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_opendiary" );
  
  else
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_closediary" );

  end;

  local func_end = function ()

    int.Lock( false );

    ObjSet( "spr_phone_book",     { input = inp_1 } );
    ObjSet( "obj_phone_book_big", { input = inp_2 } );
    
  end;
  
  int.Lock( true );

  ObjAnimate( "spr_phone_book", "alp", 0, 0, func_end, 
  {
    0.0, 3, alp_1,
    0.3, 3, alp_2,
  } );

  ObjAnimate( "obj_phone_book_big", "alp", 0, 0, "", 
  {
    0.0, 3, alp_2,
    0.3, 3, alp_1,
  } );
  
end;
--*********************************************************************************************************************
function private.ClkButton ( num )
  
  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_button1" );
  
  local py = ObjGet( "spr_phone_button_"..num ).pos_y
  ObjAnimate("spr_phone_button_"..num, "pos_y", 0, 0, function () int.Lock( false ); end, 
  {
    0.0,0,py,
    0.2,1,py+1,
    0.4,2,py
  });
  
end;  
--*********************************************************************************************************************
-- function MMG FRIDGE () end;
--*********************************************************************************************************************
  function private.FridgeInit ()
    
    private.cells_count = 36;
    private.win_cells = { 2, 3, 7, 8, 9, 10, 11, 14, 15, 16, 17, 21, 22, 23, 27, 28, 33 };
        
    for c = 1, private.cells_count do
      
      ObjSet( "spr_fridge_cell_"..c,
      {
        event_mdown  = function () private.FridgeCellClick( c ) end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      } );
      
    end;
    
  end;
--*********************************************************************************************************************
  function private.FridgeCellClick ( cell )
    
    int.Lock( true );
    
    local func_end = function ()
    
      int.Lock( false );
    
      ObjSet( "spr_fridge_cell_"..cell, { input = false } );
      
      if ( private.FridgeIsWin( cell ) ) then

        int.Lock( true );
        
        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_open_refri" );
        ObjAnimate( "obj_fridge_open", "alp", 0, 0,
        function ()
          
          int.Lock( false );
          
          private.FridgeWin();
          
        end, 
        {
          0.0, 3, 0.0,
          0.2, 3, 0.0,
          0.5, 3, 1.0,
        } );
        
      else
        
        ng_global.progress[ "ext" ][ "win_fridge" ].cells[ cell ] = true;

      end;
      
    end;
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_openslot" );
    
    ObjAnimate( "spr_fridge_cell_"..cell, "scale_xy", 0, 0, func_end, 
    {
      0.0, 3, 1.0, 1.0,
      0.3, 3, 0.0, 0.0,
    } );
    
  end;
--*********************************************************************************************************************
  function private.FridgeLoad ()
    
    for c = 1, private.cells_count do
      
      local is_click = ng_global.progress[ "ext" ][ "win_fridge" ].cells[ c ];
      
      if ( is_click ) then
        
        ObjSet( "spr_fridge_cell_"..c, { scale_x = 0, scale_y = 0, input = false } );
        
      end;
      
    end;
    
  end;
--*********************************************************************************************************************
  function private.FridgeReset ()
    
    for c = 1, private.cells_count do
      
      ObjSet( "spr_fridge_cell_"..c, { scale_x = 1, scale_y = 1, input = true } );
        
    end;
    
    ng_global.progress[ "ext" ][ "win_fridge" ].cells =
    {
      false, false, false, false, false, false,
      false, false, false, false, false, false,
      false, false, false, false, false, false,
      false, false, false, false, false, false,
      false, false, false, false, false, false,
      false, false, false, false, false, false,
    };
          
  end;
--*********************************************************************************************************************
  function private.FridgeSkip ()
    
    int.Lock( true );
    
    local func_end = function ()
    
      int.Lock( false );
    
      private.FridgeWin();
      
    end;
    
    for c = 1, #private.win_cells do
      
      local scale = ObjGet( "spr_fridge_cell_"..private.win_cells[ c ] );
      
      ObjAnimate( "spr_fridge_cell_"..private.win_cells[ c ], "scale_xy", 0, 0, "", 
      {
        0.0, 3, scale.scale_x, scale.scale_y,
        0.3, 3, 0.0, 0.0,
      } );
    
    end;

    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_open_refri" );
    ObjAnimate( "obj_fridge_open", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.5, 3, 0.0,
      0.8, 3, 1.0,
    } );

  end;
--*********************************************************************************************************************
  function private.FridgeIsWin ( cell )

    local temp_cells = {};
    
    for c = 1, private.cells_count do
      
      temp_cells[ c ] = ng_global.progress[ "ext" ][ "win_fridge" ].cells[ c ];
      
    end;

    temp_cells[ cell ] = true;

    for c = 1, #private.win_cells do
      
      if ( not temp_cells[ private.win_cells[ c ] ] ) then
      
        return false;
        
      end;
      
    end;
    
    return true;
    
  end;
--*********************************************************************************************************************
  function private.FridgeWin ()

    cmn.MiniGameHide( "fridge" );
    cmn.SetEventDone( "win_fridge" );
    cmn.CallEventHandler( "win_fridge" );
    common_impl.PassingMgWin( "fridge" );
    
  end;
--*********************************************************************************************************************
function private.InitAnims ()

  --ObjAnimate( "spr_cabinetext_light", "alp", 1, 0, "", 
  --{
  --  0.0, 3, 1.0,
  --  2.5, 3, 0.3,
  --  5.0, 3, 1.0,
  --} );

  --ObjAnimate( "spr_fridge_light", "alp", 1, 0, "", 
  --{
  --  0.0, 3, 0.3,
  --  2.5, 3, 1.3,
  --  5.0, 3, 0.3,
  --} );
  
  --ObjAnimate( "spr_phone_light", "alp", 1, 0, "", 
  --{
  --  0.0, 3, 1.0,
  --  2.5, 3, 0.6,
  --  5.0, 3, 1.0,
  --} );
  ObjAnimate( "obj_stewardessroom_hub", "scale_xy", 1, 0, "", 
  {
    0.00, 3, 1.00, 1.00,
    2.00, 3, 1.00, 1.00,
    2.10, 3, 1.05, 1.05,
    2.60, 3, 1.05, 1.05,
    2.90, 3, 1.00, 1.00,
    16.0, 3, 1.00, 1.00,
  } );

  ObjAnimate( "obj_stewardessroom_hub", "pos_y", 1, 0, "", 
  {
    0.00, 3,  0,
    2.00, 3,  0,
    2.10, 3, 10,
    2.20, 3,  0,
    2.30, 3, 10,
    2.40, 3,  0,
    2.50, 3, 10,
    2.60, 3,  0,
    16.0, 3,  0,
  } );
  
  ObjAnimate( "obj_stewardessroom_back_hub", "scale_xy", 1, 0, "", 
  {
    0.00, 3, 1.00, 1.00,
    2.00, 3, 1.00, 1.00,
    2.10, 3, 1.05, 1.05,
    2.60, 3, 1.05, 1.05,
    2.90, 3, 1.00, 1.00,
    16.0, 3, 1.00, 1.00,
  } );
  
  ObjAnimate( "obj_stewardessroom_back_hub", "pos_y", 1, 0, "", 
  {
    0.00, 3,  0,
    2.00, 3,  0,
    2.10, 3, 10,
    2.20, 3,  0,
    2.30, 3, 10,
    2.40, 3,  0,
    2.50, 3, 10,
    2.60, 3,  0,
    16.0, 3,  0,
  } );
  
   ObjAnimate( "obj_stewardessroom_animhub_1", "pos_y", 1, 0, "", 
  {
    0.0, 3, 384,
    2.0, 3, 395,
    4.0, 3, 384,
  } );
  
  ObjAnimate( "obj_stewardessroom_animhub_2", "pos_y", 1, 0, "", 
  {
    0.0, 3, 384,
    2.0, 3, 395,
    4.0, 3, 384,  
  } );
  
end;
--*********************************************************************************************************************
--*******************************************************************************************************************