-- name=ho_crashreport_rpl
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------

  room.Define( "ho_crashreport_rpl" );

  private.room_objname = "ho_crashreport_rpl";
  game.relations[ private.room_objname ].exitroom = "rm_replayroom";

  private.win_crashreport_rpl = {};

  private.InitAnim();
  private.win_crashreport_rpl.time = { 9, 4.5, 9, 4.5, 5.5, 12, 13, 7.5, 6, 8, 8, 9 };
  --------------------------------------------------------------------------------------------
  -- function win_crashreport_rpl () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_crashreport_rpl" ] =
  {
    type    = "get",
    get_obj = "spr_crashreport_rpl_win",
    room    = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local start_crashreport_rpl_func = function ()

  if cmn.IsEventStart( "win_crashreport_rpl" ) and not cmn.IsEventDone( "win_crashreport_rpl" ) then

        common_impl.ProcessHoStart( "crashreport_rpl" );

        local ho_found = ng_global.progress[ "rpl" ][ "win_crashreport_rpl" ].found;

        for i = 1, #ho_found, 1 do

            ObjDelete( ho_found[ i ][ "object" ] );

        end;

        for i = 1,3 do

          local idx = ng_global.progress["rpl"]["win_crashreport_rpl"].note[ i ][ 1 ];

          if ( ng_global.progress["rpl"]["win_crashreport_rpl"].note[ i ][ 2 ] ) then

            ObjSet( "spr_crashreport_rpl_"..i.."check", { alp = 1 } );

          end;

        end;

    end;

  end;
  cmn.AddSubscriber( "win_crashreport_rpl", start_crashreport_rpl_func, "ho_crashreport_rpl" );
  --------------------------------------------------------------------------------------------------

  private.win_crashreport_rpl.task = { "april", "plane", "taxi", "key", "clock", "wings", "suitcase", "money", "case_file", "court", "photo", "plan" };

  for i = 1, #private.win_crashreport_rpl.task do

    ObjSet( "spr_crashreport_rpl_"..private.win_crashreport_rpl.task[ i ], { input = false, event_mdown = function () private.CompleteTask( private.win_crashreport_rpl.task[ i ] ); end } );

  end;
  --------------------------------------------------------------------------------------------------  
end;
--*********************************************************************************************************************
function public.Load ()


end;
--*********************************************************************************************************************
function public.ResetHO ()  
  
  ObjDelete( "spr_crashreport_rpl_win" );
  ObjDelete( "obj_crashreport_rpl_taskpanel" );
  
  ng_global.progress[ "rpl" ][ "win_crashreport_rpl" ].start = 0;
  ng_global.progress[ "rpl" ][ "win_crashreport_rpl" ].done = 0;
  ng_global.progress[ "rpl" ][ "win_crashreport_rpl" ].number = 1;
  ng_global.progress[ "rpl" ][ "win_crashreport_rpl" ].note = { { 5, false }, { 8, false }, { 12, false } };  
    
end;
--*********************************************************************************************************************
function public.PreOpen ()  
  
  cmn.CallEventHandler( "win_crashreport_rpl" );
  
  cmn.InterfaceSetVisible( true );

  if ( not cmn.IsEventDone( "opn_crashreport_rpl" ) ) then

    cmn.SetEventDone( "opn_crashreport_rpl" );
    cmn.CallEventHandler( "opn_crashreport_rpl" );

    ng_global.progress[ "rpl" ][ "win_crashreport_rpl" ].number = 1;
    ng_global.progress[ "rpl" ][ "win_crashreport_rpl" ].note = { { 5, false }, { 8, false }, { 12, false } };

  end;

  private.TaskStart();

  local ho_tasks = {};

  interface.TaskPanelTaskAdd( ho_tasks, "april",     1, 0, { { "spr_crashreport_rpl_april"        } } );
  interface.TaskPanelTaskAdd( ho_tasks, "plane",     1, 0, { { "spr_crashreport_rpl_plane"    } } );
  interface.TaskPanelTaskAdd( ho_tasks, "taxi",      1, 0, { { "spr_crashreport_rpl_taxi"   } } );
  interface.TaskPanelTaskAdd( ho_tasks, "key",       1, 0, { { "spr_crashreport_rpl_key"       } } );
  interface.TaskPanelTaskAdd( ho_tasks, "clock",     1, 0, { { "spr_crashreport_rpl_clock"     } } );
  interface.TaskPanelTaskAdd( ho_tasks, "wings",     1, 0, { { "spr_crashreport_rpl_wings"      } } );
  interface.TaskPanelTaskAdd( ho_tasks, "suitcase",  1, 0, { { "spr_crashreport_rpl_suitcase"       } } );
  interface.TaskPanelTaskAdd( ho_tasks, "money",     1, 0, { { "spr_crashreport_rpl_money"         } } );
  interface.TaskPanelTaskAdd( ho_tasks, "case_file", 1, 0, { { "spr_crashreport_rpl_case_file"       } } );
  interface.TaskPanelTaskAdd( ho_tasks, "court",     1, 0, { { "spr_crashreport_rpl_court"        } } );
  interface.TaskPanelTaskAdd( ho_tasks, "photo",     1, 0, { { "spr_crashreport_rpl_photo" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "plan",      1, 0, { { "spr_crashreport_rpl_plan"    } } );


  if ( not cmn.IsEventStart( "win_crashreport_rpl" ) ) then

      cmn.InitHo( "crashreport_rpl" );

  end;

  int.TaskPanelShow( ho_tasks );
  private.Panel();

  cmn.StopAllMus();
  cmn.PlayAudio( "mus", "audio/aud_amnesia_theme_mus", 1 );

end;
--*********************************************************************************************************************
function public.Open ()

  private.TimerStart();

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();
  --cmn.StopAudio( "env", "audio/level1/env/aud_ho_theme_mus_env", 0.3 );
  cmn.StopAllVoc();

end;
--*********************************************************************************************************************
function public.Close ()

  ObjAttach( "obj_crashreport_rpl_taskpanel" , "ho_crashreport_rpl" );

end;
--*********************************************************************************************************************
function public.HoComplete ()

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )

  local postfix = "";

  if ( number ) then

     postfix = "_1"

  end;

  cmn.HoTaskFind( "spr_crashreport_rpl_"..name..postfix, name..postfix );
  private.CheckDone();
  if ( ng_global.progress["rpl"]["win_crashreport_rpl"].number ~= 12) then

    ng_global.progress["rpl"]["win_crashreport_rpl"].number = ng_global.progress["rpl"]["win_crashreport_rpl"].number + 1;
    private.Task();

  end;

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjAttach( "obj_crashreport_rpl_taskpanel" , "int_taskpanel_impl" );

end;
--*********************************************************************************************************************
function private.TaskStart()

  local number = ng_global.progress[ "rpl" ][ "win_crashreport_rpl" ].number;
  ObjSet( "txt_crashreport_rpl_taskpanel", { alp = 1, text = "tsk_crashreport_rpl_"..private.win_crashreport_rpl.task[ number ] } );
  ObjSet( "spr_crashreport_rpl_"..private.win_crashreport_rpl.task[ number ], { input = true } );

end;
--*********************************************************************************************************************
function private.Task ()
  
  local func_end = function ()

    local number = ng_global.progress["rpl"]["win_crashreport_rpl"].number;
    ObjSet( "txt_crashreport_rpl_taskpanel", { text = "tsk_crashreport_rpl_"..private.win_crashreport_rpl.task[ number ] } );
    ObjSet( "spr_crashreport_rpl_"..private.win_crashreport_rpl.task[ number ], { input = true } );

  end;

  local func_end2 = function ()

    int.Lock( false );

  end;

  int.Lock( true );

  ObjAnimate( "txt_crashreport_rpl_taskpanel", "alp", 0, 0, func_end2,
  { 
    0.0, 0, 1, 
    0.3, 0, 0,
    0.4, 0, 0,
    0.7, 0, 1

  } );

  ObjAnimate( "ho_crashreport_rpl", "alp", 0, 0, func_end,
  { 
    0.0, 0, 1, 
    0.3, 0, 1
  } );

  private.TimerDone();
  private.TimerStart();

end;
--*********************************************************************************************************************
function private.TimerStart ()

  local number = ng_global.progress[ "rpl" ][ "win_crashreport_rpl" ].number;

  ObjSet( "tmr_crashreport_rpl_voice", 
    { 
    playing = true, 
    time = private.win_crashreport_rpl.time[ number ],
    endtrig = private.TimerDone
    } );

  cmn.StopAllVoc();
  cmn.PlayAudio( "voc", "audio/level3/voc/aud_jackie_dict_"..number.."_voc", 0 ); 

  ObjSet( "obj_crashreport_rpl_button", { input = false } );
  ObjSet( "anm_crashreport_rpl_recorder", { active = true } );
  ObjAnimate( "spr_crashreport_rpl_play2", "alp", 0, 0, "",
  { 
    0.0, 0, ObjGet( "spr_crashreport_rpl_play2" ).alp, 
    0.3, 0, 1
  } );

end;
--*********************************************************************************************************************
function private.TimerDone ()

  local func_end = function ()

    private.TimerStart();
    cmn.PlayAudio( "env", "audio/level1/env/aud_investigatorsdesk_in", 0 );
 
  end;

  local number = ng_global.progress[ "rpl" ][ "win_crashreport_rpl" ].number;

  cmn.StopAllVoc();
  cmn.PlayAudio( "env", "audio/level1/env/aud_investigatorsdesk_in", 0 );
  ObjSet( "obj_crashreport_rpl_button", { input = true, event_mdown = func_end } );
  ObjSet( "anm_crashreport_rpl_recorder", { active = false } );
  ObjAnimate( "spr_crashreport_rpl_play2", "alp", 0, 0, "",
  { 
    0.0, 0, ObjGet( "spr_crashreport_rpl_play2" ).alp, 
    0.3, 0, 0
  } );

end;

--*********************************************************************************************************************
function private.CheckDone ()

  local number = ng_global.progress["rpl"]["win_crashreport_rpl"].number;

  for i = 1,3 do

    local idx = ng_global.progress["rpl"]["win_crashreport_rpl"].note[ i ][ 1 ];

    if ( number == idx ) and not ( ng_global.progress["rpl"]["win_crashreport_rpl"].note[ i ][ 2 ] ) then

      ng_global.progress["rpl"]["win_crashreport_rpl"].note[ i ][ 2 ] = true;
      ObjAnimate( "spr_crashreport_rpl_"..i.."check", "alp", 0, 0, "",
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      } );

      AnimPlay( "anm_crashreport_rpl_sighnfx_"..i, "DoAnim", "" );

    end;


  end;

end;
--*********************************************************************************************************************
function private.InitAnim ()

  ObjAnimate( "spr_crashreport_rpl_light", "alp", 1, 0, "",
  { 
    0.0, 0, 1, 
    2, 0, 0.1,
    4, 0, 1 
  } );

end;