-- name=ho_dollhouse_rpl
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_dollhouse_rpl" );
  game.relations[ "ho_dollhouse_rpl" ].exitroom = "rm_replayroom";
  private.room_objname = "ho_dollhouse_rpl";

  private.win_dollhouse_rpl = {};

  private.win_dollhouse_rpl.task = { "sphere", "balloon", "bow_1", "bow_2", "figure", "fish", "giraffe", "key", "lips", "man", "photo", "stone_ring" };

  common_impl.hint[ "win_dollhouse_rpl" ] =
  {
    type = "get",
    get_obj = "spr_dollhouse_rpl_win",
    room = private.room_objname
  };

  ObjSet( "obj_dollhouse_rpl_clk_fish",     { event_mdown = private.ClkFish } );  
  ObjSet( "obj_dollhouse_rpl_clk_cap",      { event_mdown = private.ClkCap } );  
  ObjSet( "obj_dollhouse_rpl_clk_drumstic", { event_mdown = private.ClkDrumstic } );  

 private.InitAnims();
 
 --------------------------------------------------------------------------------------------
  -- function win_dollhouse_rpl () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------------
  local start_dollhouse_rpl_func = function ()
  
    if cmn.IsEventStart( "win_dollhouse_rpl" ) then

      local ho_found = ng_global.progress[ "rpl" ][ "win_dollhouse_rpl" ].found;

      for i = 1, #ho_found do

        local name = common.GetObjectName( ho_found[ i ].item );

        if ( name ~= "dollhouse_rpl_balloon" ) then

          ObjSet( "spr_"..name, { alp = 1 } );

        else 

          ObjSet( "anm_"..name, { alp = 1 } );

        end;

        ObjSet( "obj_"..name, { input = false } );

      end;
      
    end;

--    if ( cmn.IsEventDone( "win_dollhouse_rpl" ) ) then
--
--      common_impl.ProcessHoStart( "dollhouse_rpl" );
--
--    end;

  end;
  cmn.AddSubscriber( "win_dollhouse_rpl", start_dollhouse_rpl_func, "ho_dollhouse_rpl" );
  --------------------------------------------------------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
end;
function public.Load ()

end;
--*********************************************************************************************************************
function public.ResetHO ()  
  
  ObjDelete( "spr_dollhouse_rpl_win" );
  
  ng_global.progress[ "rpl" ][ "win_dollhouse_rpl" ].start = 0;
  ng_global.progress[ "rpl" ][ "win_dollhouse_rpl" ].done = 0;
    
end;
--*********************************************************************************************************************
function public.PreOpen ()
  
  ObjSet( "int_itempanel", { visible = true } );
  
  cmn.CallEventHandler( "win_dollhouse_rpl" );

  cmn.InterfaceSetVisible( true );

  if ( not cmn.IsEventDone( "opn_dollhouse_rpl" ) ) then

      cmn.SetEventDone( "opn_dollhouse_rpl" );
      cmn.CallEventHandler( "opn_dollhouse_rpl" );

  end;

  local ho_tasks = {};

  if ( not cmn.IsEventStart( "win_dollhouse_rpl" ) ) then

    cmn.InitHo( "dollhouse_rpl" );

  end;
  private.Panel();
  for i = 1, #private.win_dollhouse_rpl.task do

      interface.ItemPanelItemAdd( ho_tasks, private.win_dollhouse_rpl.task[ i ] );

  end;

  int.ItemPanelShow( ho_tasks );

  cmn.StopAllMus();
  cmn.PlayAudio( "mus", "audio/aud_amnesia_theme_mus", 1 );

end;
--*********************************************************************************************************************
function public.Open ()

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.ItemPanelHide();  
  
  cmn.StopAudio( "env", "audio/level1/env/aud_ho_theme_mus_env", 0.3 );

end;
--*********************************************************************************************************************
function public.Close ()

  ObjSet( "int_itempanel", { visible = false } );

end;
--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function private.TaskComplete( name )

  local spr = "itm_dollhouse_rpl_"..name;
  local spr_shad = "spr_dollhouse_rpl_"..name.."_shadow";

  cmn.HoItemFind( spr, name );
  common_impl.PassingHoCheck();

  ObjSet( spr, { input = false } );
  ObjSet( spr_shad, { input = false } );

  ObjAnimate( spr, "alp", 0, 0, "", { 
    0,   0, 1, 
    0.3, 0, 0
  } );

  ObjAnimate( spr_shad, "alp", 0, 0, "", { 
    0,   0, 1, 
    0.3, 0, 0
  } );

  MsgSend( Event_DialogHo_Show, {} );

end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_ho_dollhouse_rpl_right_click" );
  local name = common.GetObjectName( item_name );
  local item_object_name = "obj_"..name;

  local item_spr_name = "spr_"..name;

  if ( name == "dollhouse_rpl_balloon" ) then

    item_spr_name = "anm_"..name;

  end;

  ObjSet( item_object_name, { input = false } );

  ObjSet( item_spr_name, { alp = 1 } );  

    if ( interface.itempanel.countdown == 0 ) then

      MsgSend( Event_DialogHo_Show, {} );

    end;

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );

  for i = 1, #private.win_dollhouse_rpl.task do

      local obj_name = "itm_dollhouse_rpl_"..private.win_dollhouse_rpl.task[ i ];
      local sub_name = "obj_dollhouse_rpl_item";
      ObjCreate( obj_name, "spr" );
      ObjAttach( obj_name, sub_name );  
      ObjSet( obj_name, 
          { 
          --event_mdown     = function () private.TaskComplete( private.win_dollhouse_rpl.task[ i ] ); end, 
          input           = false,
          res             = "assets/levels/level2/ho_dollhouse/layers/inv/"..private.win_dollhouse_rpl.task[ i ].."_inv",
          inputrect_init  = true,
          inputrect_x     = -50,
          inputrect_y     = -50,
          inputrect_w     = 100,
          inputrect_h     = 100,
          event_dragdrop  = function () cmn.HoItemFind( "itm_dollhouse_rpl_"..private.win_dollhouse_rpl.task[ i ] ); end,
          event_menter    = function () interface.PopupShow( "pop_dollhouse_rpl_"..private.win_dollhouse_rpl.task[ i ] ); end,
          event_mleave    = interface.PopupHide,
          event_startdrag = function () cmn.HoItemOff( "itm_dollhouse_rpl_"..private.win_dollhouse_rpl.task[ i ] ); end
          });

  end;

    --ObjAttach( "spr_dollhouse_rpl_ho2" , "spr_int_itempanel" );

end;
--********************************************************************************************************************* 
function private.InitAnims ()

  ObjAnimate( "spr_dollhouse_rpl_butterfly", "ang", 1, 0, "", 
  {
    0.0, 3, 0.09,
    3.0, 3, -0.09,
    6.0, 3, 0.09
  } );

  ObjAnimate( "spr_dollhouse_rpl_beasts", "ang", 1, 0, "", 
  {
    0.0, 3, 0.28,
    2.0, 3, 0,
    4.0, 3, 0.28
  } );

end;

--********************************************************************************************************************* 
function private.ClkFish ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

  end;

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_toy_ball" ); 
  AnimPlay( "anm_dollhouse_rpl_fish_click", "DoAnim", func_end );

end;
--********************************************************************************************************************* 
function private.ClkCap ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

  end;

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_moove_hat" );
  AnimPlay( "anm_dollhouse_rpl_cap_click", "DoAnim", func_end );

end;
--********************************************************************************************************************* 
function private.ClkDrumstic ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

  end;

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xilophone" ); 
  AnimPlay( "anm_dollhouse_rpl_drumstick_click", "DoAnim", func_end );

end;
--********************************************************************************************************************* 
