-- name=ho_farmhouse_rpl
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_farmhouse_rpl" );
  game.relations[ "ho_farmhouse_rpl" ].exitroom = "rm_replayroom";
  private.room_objname = "ho_farmhouse_rpl";

  private.taskpanel = 
  {
    horseshoe = { "spr_farmhouse_rpl_rifle",   "spr_farmhouse_rpl_spurs",      "spr_farmhouse_rpl_saddle" },
    amulet    = { "spr_farmhouse_rpl_hat",   "spr_farmhouse_rpl_scull_horns",    "spr_farmhouse_rpl_whip" }

  };

  --------------------------------------------------------------------------------------------
  -- function win_farmhouse_rpl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_farmhouse_rpl" ] =
  {
    type = "get",
    get_obj = "spr_farmhouse_rpl_win",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local start_farmhouse_rpl_func = function ()

    if ( cmn.IsEventStart( "win_farmhouse_rpl" ) ) then

      common_impl.ProcessHoStart( "farmhouse_rpl" );
      local ho_found = ng_global.progress[ "rpl" ][ "win_farmhouse_rpl" ].found;

      for i = 1, #ho_found, 1 do

        ObjDelete( ho_found[ i ][ "object" ] );

        for j = 1, #private.task do

          if ( ho_found[ i ][ "object" ] == "spr_farmhouse_rpl_"..private.task[ j ] ) then

            ObjSet( "txt_farmhouse_rpl_taskpanel_task"..j,
            {
              text = "tsk_farmhouse_rpl_"..private.task[ j ],
              color_r = 0,
              color_g = 0.1,
              color_b = 0,
            } );

          end;

        end;

      end;

      if ( ng_global.progress[ ng_global.currentprogress ][ "win_farmhouse_rpl" ].amulet == 5 ) then

        ObjSet( "spr_farmhouse_rpl_taskpanel_crack2", { alp = 1, input = true } );
        ObjSet( "obj_farmhouse_rpl_taskpanel_box2_hint", { input = true } );
        ObjSet( "spr_farmhouse_rpl_taskpanel_box2_key", { input = true } );

      elseif ( ng_global.progress[ ng_global.currentprogress ][ "win_farmhouse_rpl" ].amulet == 6 ) then

        ObjSet( "spr_farmhouse_rpl_taskpanel_crack2", { alp = 1 } );
        ObjDelete( "spr_farmhouse_rpl_taskpanel_box2_key" );
        ObjDelete( "spr_farmhouse_rpl_taskpanel_box2" );
        ObjSet( "spr_farmhouse_rpl_taskpanel_list2", { alp = 1, input = true } );
        private.OpenBox( "amulet" );

      end;

      if ( ng_global.progress[ ng_global.currentprogress ][ "win_farmhouse_rpl" ].horseshoe == 5 ) then

        ObjSet( "spr_farmhouse_rpl_taskpanel_crack1", { alp = 1, input = true } );
        ObjSet( "obj_farmhouse_rpl_taskpanel_box1_hint", { input = true } );
        ObjSet( "spr_farmhouse_rpl_taskpanel_box1_key", { input = true } );

      elseif ( ng_global.progress[ ng_global.currentprogress ][ "win_farmhouse_rpl" ].horseshoe == 6 ) then

        ObjSet( "spr_farmhouse_rpl_taskpanel_crack1", { alp = 1 } );
        ObjDelete( "spr_farmhouse_rpl_taskpanel_box1_key" );
        ObjDelete( "spr_farmhouse_rpl_taskpanel_box1" );
        ObjSet( "spr_farmhouse_rpl_taskpanel_list1", { alp = 1, input = true } );
        private.OpenBox( "horseshoe" );

      end;

    end;

  end;
  cmn.AddSubscriber( "win_farmhouse_rpl", start_farmhouse_rpl_func, "ho_farmhouse_rpl" );
  --------------------------------------------------------------------------------------------------

  private.task = { "rifle", "spurs", "saddle", "hat", "scull_horns", "whip" };

  for i = 1, #private.task do

    ObjSet( "spr_farmhouse_rpl_"..private.task[ i ], { event_mdown = function () private.CompleteTask( private.task[ i ] ); end } );

  end;

  for i = 1, 5 do

    ObjSet( "spr_farmhouse_rpl_horseshoe_"..i, { event_mdown = function () private.CompleteTask( "horseshoe_"..i ); end } );

  end;

  for i = 1, 5 do

    ObjSet( "spr_farmhouse_rpl_amulet_"..i, { event_mdown = function () private.CompleteTask( "amulet_"..i ); end } );

  end;

  ObjSet( "spr_farmhouse_rpl_taskpanel_box1_key", { event_startdrag = function () private.GetItem( "box1_key" ); end, event_dragdrop = function () private.UseItem( "box1_key" ); end, } );
  ObjSet( "spr_farmhouse_rpl_taskpanel_box2_key", { event_startdrag = function () private.GetItem( "box2_key" ); end, event_dragdrop = function () private.UseItem( "box2_key" ); end } );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function public.ResetHO ()  
  
  ObjDelete( "spr_farmhouse_rpl_win" );
  
  ng_global.progress[ "rpl" ][ "win_farmhouse_rpl" ].start = 0;
  ng_global.progress[ "rpl" ][ "win_farmhouse_rpl" ].done = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_farmhouse_rpl" ].amulet = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_farmhouse_rpl" ].horseshoe = 0;
  
  ObjDelete( "obj_farmhouse_rpl_taskpanel" );
    
end;
--*********************************************************************************************************************
function public.PreOpen ()
  
  cmn.CallEventHandler( "win_farmhouse_rpl" );

  local ho_tasks = {};
  cmn.InterfaceSetVisible( true );

  if ( not cmn.IsEventDone( "opn_farmhouse_rpl" ) ) then

      cmn.SetEventDone( "opn_farmhouse_rpl" );
      cmn.CallEventHandler( "opn_farmhouse_rpl" );
      ng_global.progress[ ng_global.currentprogress ][ "win_farmhouse_rpl" ].amulet = 0;
      ng_global.progress[ ng_global.currentprogress ][ "win_farmhouse_rpl" ].horseshoe = 0;

  end;

  if ( not cmn.IsEventStart( "win_farmhouse_rpl" ) ) then

    cmn.InitHo( "farmhouse_rpl" );

  end;

  for i = 1, #private.task do

    interface.TaskPanelTaskAdd( ho_tasks, private.task[ i ], 1, 0, { { "spr_farmhouse_rpl_"..private.task[ i ] } } );

  end;

  for i = 1, 5 do

    interface.TaskPanelTaskAdd( ho_tasks, "horseshoe_"..i, 1, 0, { { "spr_farmhouse_rpl_horseshoe_"..i } } );
    interface.TaskPanelTaskAdd( ho_tasks, "amulet_"..i, 1, 0,    { { "spr_farmhouse_rpl_amulet_"..i } } );

  end;

  interface.TaskPanelTaskAdd( ho_tasks, "horseshoe", 1, 0, { { "spr_farmhouse_rpl_taskpanel_box1_key", "obj_farmhouse_rpl_taskpanel_box1_hint" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "amulet", 1, 0, { { "spr_farmhouse_rpl_taskpanel_box2_key", "obj_farmhouse_rpl_taskpanel_box2_hint" } } );

  int.TaskPanelShow( ho_tasks );
  private.Panel();

  cmn.StopAllMus();
  cmn.PlayAudio( "mus", "audio/aud_amnesia_theme_mus", 1 );

end;
--*********************************************************************************************************************
function public.Open ()

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();
  cmn.StopAudio( "env", "audio/level1/env/aud_ho_theme_mus_env", 0.3 );

end;
--*********************************************************************************************************************
function public.Close ()

  ObjSet( "spr_int_taskpanel", { alp = 1, input = true } );
  ObjSet( "obj_int_taskpanel", { alp = 1, input = true } );
  ObjAttach( "obj_farmhouse_rpl_taskpanel" , "ho_farmhouse_rpl" );

end;
--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function private.CompleteTask ( task_name )

  cmn.HoTaskFind( "spr_farmhouse_rpl_"..task_name, task_name );
  private.CheckTask( task_name );   

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "spr_int_taskpanel", { alp = 0, input = false } );
  ObjSet( "obj_int_taskpanel", { alp = 0, input = false } );
  ObjAttach( "obj_farmhouse_rpl_taskpanel" , "int_taskpanel_impl" );
  ObjSet( "txt_farmhouse_rpl_taskpanel_horseshoe_count", { text = ng_global.progress[ ng_global.currentprogress ][ "win_farmhouse_rpl" ].horseshoe } );
  ObjSet( "txt_farmhouse_rpl_taskpanel_amulet_count", { text = ng_global.progress[ ng_global.currentprogress ][ "win_farmhouse_rpl" ].amulet } );
   
end;
--*********************************************************************************************************************
function private.CheckTask( obj )

  local ho_progress = ng_global.progress[ ng_global.currentprogress ][ "win_farmhouse_rpl" ];
      
  if ( string.find( obj, "amulet" ) ) then

    ng_global.progress[ ng_global.currentprogress ][ "win_farmhouse_rpl" ].amulet = ng_global.progress[ ng_global.currentprogress ][ "win_farmhouse_rpl" ].amulet + 1;
    local amulet = ng_global.progress[ ng_global.currentprogress ][ "win_farmhouse_rpl" ].amulet;
    ObjSet( "txt_farmhouse_rpl_taskpanel_amulet_count", { text = amulet } );

    if ( amulet == 5 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );
        ObjSet( "spr_farmhouse_rpl_taskpanel_crack2", { input = true } );
        ObjSet( "spr_farmhouse_rpl_taskpanel_box2_key", { input = true } );
        ObjSet( "spr_farmhouse_rpl_taskpanel_box2", { input = true } );
        ObjSet( "obj_farmhouse_rpl_taskpanel_box2_hint", { input = true } );

      end;

      ObjAnimate( "spr_farmhouse_rpl_taskpanel_amulet", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 1.0, 
        0.6, 0, 0.0
      } );

      ObjAnimate( "spr_farmhouse_rpl_taskpanel_crack2", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 0.0, 
        0.6, 0, 1.0
      } );

    end;

  elseif ( string.find( obj, "horseshoe" ) ) then

    ng_global.progress[ ng_global.currentprogress ][ "win_farmhouse_rpl" ].horseshoe = ng_global.progress[ ng_global.currentprogress ][ "win_farmhouse_rpl" ].horseshoe + 1;
    local horseshoe = ng_global.progress[ ng_global.currentprogress ][ "win_farmhouse_rpl" ].horseshoe;
    ObjSet( "txt_farmhouse_rpl_taskpanel_horseshoe_count", { text = horseshoe } );

    if ( horseshoe == 5 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );
        ObjSet( "spr_farmhouse_rpl_taskpanel_crack1", { input = true } );
        ObjSet( "spr_farmhouse_rpl_taskpanel_box1_key", { input = true } );
        ObjSet( "spr_farmhouse_rpl_taskpanel_box1", { input = true } );
        ObjSet( "obj_farmhouse_rpl_taskpanel_box1_hint", { input = true } );

      end;

      ObjAnimate( "spr_farmhouse_rpl_taskpanel_horseshoe", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 1.0, 
        0.6, 0, 0.0
      } );

      ObjAnimate( "spr_farmhouse_rpl_taskpanel_crack1", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 0.0, 
        0.6, 0, 1.0
      } );

    end;

  end;

  for i = 1, #private.task do

    if ( obj == private.task[i] ) then

      ObjSet( "txt_farmhouse_rpl_taskpanel_task"..i,
      {
        text = "tsk_farmhouse_rpl_"..private.task[ i ],
        color_r = 0,
        color_g = 0.1,
        color_b = 0,
      } );

    end;

  end;

end;
--*********************************************************************************************************************
function private.GetItem( name )

  local item = "spr_farmhouse_rpl_taskpanel_"..name;
  ObjSet( item, { pos_z = 20 } );
  ObjAttach( item, "obj_farmhouse_rpl_taskpanel" );
  cmn.PlayAudio( "sfx", "audio/aud_take_inventory" );

end;
--*********************************************************************************************************************
function private.UseItem( name )

  local item = "spr_farmhouse_rpl_taskpanel_"..name;
  
  if ( ObjIntersect( item, "spr_farmhouse_rpl_taskpanel_box1" ) and string.find( item, "box1" ) ) then

    ObjDelete( item );
    int.Lock( true );

    local trg_after = function()

      private.CompleteTask ( "horseshoe" );
      ObjDelete( "spr_farmhouse_rpl_taskpanel_box1" );
      ObjSet( "spr_farmhouse_rpl_taskpanel_list1", { input = true } );

    end;

    int.Lock( false );
    private.OpenBox( "horseshoe" );
    ObjAnimate( "spr_farmhouse_rpl_taskpanel_box1", "alp", 0, 0, trg_after, 
    { 
      0.0,  0,  1,
      0.3,  0,  0
    } ); 

    ObjAnimate( "spr_farmhouse_rpl_taskpanel_list1", "alp", 0, 0, "", 
    { 
      0.0,  0,  0,
      0.3,  0,  1
    } ); 
  elseif ( ObjIntersect( item, "spr_farmhouse_rpl_taskpanel_box2" ) and string.find( item, "box2" ) ) then

    ObjDelete( item );
    int.Lock( true );
    local trg_after = function()

      private.CompleteTask ( "amulet" );
      ObjDelete( "spr_farmhouse_rpl_taskpanel_box2" );
      ObjSet( "spr_farmhouse_rpl_taskpanel_list2", { input = true } );
      int.Lock( false );

    end;

    private.OpenBox( "amulet" );
    ObjAnimate( "spr_farmhouse_rpl_taskpanel_box2", "alp", 0, 0, trg_after, 
    { 
      0.0,  0,  1,
      0.3,  0,  0
    } ); 

    ObjAnimate( "spr_farmhouse_rpl_taskpanel_list2", "alp", 0, 0, "", 
    { 
      0.0,  0,  0,
      0.3,  0,  1
    } ); 

  else

    if ( name == "box1_key" ) then

      ObjAttach( item, "spr_farmhouse_rpl_taskpanel_crack1" );

    else 

      ObjAttach( item, "spr_farmhouse_rpl_taskpanel_crack2" );

    end;

    ObjSet( "spr_farmhouse_rpl_taskpanel_"..name, { pos_z = 1 } );
    cmn.WrongApply();

  end;

end;
--*********************************************************************************************************************
function private.OpenBox( name )

 for i = 1, #private.taskpanel[ name ] do

  ObjSet( private.taskpanel[ name ][ i ], { input = true } ); 

 end;

 for i = 1, #private.task do

  ObjSet( "txt_farmhouse_rpl_taskpanel_task"..i,
  {
    text = "tsk_farmhouse_rpl_"..private.task[ i ],
  } );

 end;

end;
--*********************************************************************************************************************