-- name=ho_hoscrypt_rpl
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_hoscrypt_rpl" );

  private.room_objname = "ho_hoscrypt_rpl";
  game.relations[ private.room_objname ].exitroom = "rm_replayroom";
  
  ObjSet( "spr_hoscrypt_rpl_amuletgate_2", { event_mdown = private.GetAmulet } );

  private.InitAnims();
  --------------------------------------------------------------------------------------------
  -- function win_hoscrypt_rpl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_hoscrypt_rpl" ] =
  {
    type = "get",
    get_obj = "spr_hoscrypt_rpl_win",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local UnmarkAmulet = function () 

    ObjSet( "spr_hoscrypt_rpl_shield",         { input = false, pos_x = 690, pos_y = 590  } ); 
    ObjSet( "spr_hoscrypt_rpl_amuletgate_2",   { input = true } ); 
    
  end;

  --cmn.AddSubscriber( "UnmarkAmulet", UnmarkAmulet, "ho_hoscrypt_rpl" );  
  cmn.AddSubscriber( "UnmarkAmulet", UnmarkAmulet, "rm_replayroom" );  
  --------------------------------------------------------------------------------------------------
  local start_hoscrypt_rpl_func = function ()

    if ( cmn.IsEventStart( "win_hoscrypt_rpl" ) ) then

      common_impl.ProcessHoStart( "hoscrypt_rpl" );
      local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt_rpl" ].found;

        if cmn.IsUnmarkedTask( "hoscrypt_rpl", "amulet" ) then

            UnmarkAmulet();

        end;

      for i = 1, #ho_found, 1 do

        ObjDelete( ho_found[ i ][ "object" ] );

      end;

    end;

  end;
  cmn.AddSubscriber( "win_hoscrypt_rpl", start_hoscrypt_rpl_func, "ho_hoscrypt_rpl" );
  --------------------------------------------------------------------------------------------------
  for i = 1, 12 do

    ObjSet( "spr_hoscrypt_rpl_pic_"..i, { event_mdown = function () private.CompleteTask( "pic_"..i, i ); end, input = false  } );

  end;

  for i = 1, 12 do

    ObjSet( "spr_hoscrypt_rpl_rose_"..i, { event_mdown = function () private.CompleteTask( "rose_"..i, i ); end, input = false  } );

  end;
  --------------------------------------------------------------------------------------------------  
end;

--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function public.ResetHO ()  
  
  ObjDelete( "spr_hoscrypt_rpl_win" );
  
  ng_global.progress[ "rpl" ][ "win_hoscrypt_rpl" ].start = 0;
  ng_global.progress[ "rpl" ][ "win_hoscrypt_rpl" ].done = 0;
  ng_global.progress[ "rpl" ][ "win_hoscrypt_rpl" ].unmark.amulet.done = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt_rpl" ].stage = 1;
  ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt_rpl" ].count = 12;
  ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt_rpl" ].all = { { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 }, { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 } };
    
end;
--*********************************************************************************************************************
function public.PreOpen ()
  
  cmn.CallEventHandler( "win_hoscrypt_rpl" );

  local ho_tasks = {};
  cmn.InterfaceSetVisible( true );

  if ( not cmn.IsEventDone( "opn_hoscrypt_rpl" ) ) then

      cmn.SetEventDone( "opn_hoscrypt_rpl" );
      cmn.CallEventHandler( "opn_hoscrypt_rpl" );
      ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt_rpl" ].stage = 1;
      ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt_rpl" ].count = 12;
      ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt_rpl" ].all = { { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 }, { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 } };

  end;

  if ( not cmn.IsEventStart( "win_hoscrypt_rpl" ) ) then

    cmn.InitHo( "hoscrypt_rpl" );
    cmn.SetMarkedTask( "hoscrypt_rpl", "amulet" );

  end;

  for i = 1, 12 do

    interface.TaskPanelTaskAdd( ho_tasks, "pic_"..i,    1, 0, { { "spr_hoscrypt_rpl_pic_"..i } } );

  end;

  for i = 1, 12 do

    interface.TaskPanelTaskAdd( ho_tasks, "rose_"..i,    1, 0, { { "spr_hoscrypt_rpl_rose_"..i } } );

  end;

  interface.TaskPanelTaskAdd( ho_tasks, "amulet", 1, 1, { { "spr_hoscrypt_rpl_amuletgate_2" } } );

  int.TaskPanelShow( ho_tasks );
  private.Panel();

  cmn.StopAllMus();
  cmn.PlayAudio( "mus", "audio/aud_amnesia_theme_mus", 1 );
--
end;
--*********************************************************************************************************************
function public.Open ()

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close ()

  ObjAttach( "obj_hoscrypt_rpl_panel","ho_hoscrypt_rpl" );
  
end;
--*********************************************************************************************************************
function public.HoComplete ()

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )

  int.Lock( true );

  local postfix = "";

  if ( number ) then

      local stage = ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt_rpl" ].stage;
      ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt_rpl" ].all[ stage ][ number ] = 0

  end;

  cmn.HoTaskFind( "spr_hoscrypt_rpl_"..name, name );  
  private.ChangeTask();

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjAttach( "obj_hoscrypt_rpl_panel" , "spr_int_taskpanel" );

  private.CheckTask();

end;
--********************************************************************************************************************* 
function private.ChangeTask () 

   ObjAnimate( "txt_hoscrypt_rpl_count", "ang", 0, 0, "", 
   {
     0.0, 3, 0.0,
     0.1, 3, 0.5,
     0.2, 3, -0.5,
     0.3, 3, 0.0
   } );

   ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt_rpl" ].count = ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt_rpl" ].count - 1;

   local stage = ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt_rpl" ].stage;
   local count = ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt_rpl" ].count;

   ObjSet( "txt_hoscrypt_rpl_count", { text = count } );

   if ( ( stage == 1 or stage == 2 ) and count == 0 ) then

      ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt_rpl" ].stage = ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt_rpl" ].stage + 1;

      local func_end = function ()

        ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt_rpl" ].count = 12;
        private.CheckTask();

      end;

      ObjAnimate( "txt_hoscrypt_rpl_task", "alp", 0, 0, "", 
      { 
        0,   0, 1, 
        0.3, 0, 0, 
        0.6, 0, 0, 
        0.9, 0, 1 
      })

      ObjAnimate( "ho_hoscrypt_rpl", "alp", 0, 0, func_end, 
      { 
        0,   0, 1, 
        0.3, 0, 1
      })

   else 

     int.Lock( false );

   end;
   
end;
--********************************************************************************************************************* 
function private.CheckTask () 

   local stage = ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt_rpl" ].stage;

   ObjSet( "txt_hoscrypt_rpl_task",  { text = "tsk_hoscrypt_rpl_task_"..stage } );
   ObjSet( "txt_hoscrypt_rpl_count", { text = ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt_rpl" ].count } );

   local func_end = function ()

     int.Lock( false );

   end;

   ObjAnimate( "txt_hoscrypt_rpl_task", "alp", 0, 0, func_end, 
   { 
     0,   0, 0, 
     0.3, 0, 1
   })

   if ( stage == 1 ) then

     ObjSet( "txt_hoscrypt_rpl_task", { pos_x = 50 } );
     ObjSet( "txt_hoscrypt_rpl_num",  { pos_x = 10 } );

      for i = 1, 12 do

        if ( ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt_rpl" ].all[ stage ][ i ] == 1 ) then

          ObjSet( "spr_hoscrypt_rpl_rose_"..i, { input = true  } );

        end;

      end;

   elseif ( stage == 2 ) then

      ObjSet( "txt_hoscrypt_rpl_task", { pos_x = 50 } );
      ObjSet( "txt_hoscrypt_rpl_num",  { pos_x = 10 } );

      for i = 1, 12 do

        if ( ng_global.progress[ ng_global.currentprogress ][ "win_hoscrypt_rpl" ].all[ stage ][ i ] == 1 ) then

          ObjSet( "spr_hoscrypt_rpl_pic_"..i, { input = true  } );

        end;    

      end;

  elseif ( stage == 3 ) then
   
    ObjSet( "txt_hoscrypt_rpl_num",          { alp = 0 } );
    ObjSet( "spr_hoscrypt_rpl_amuletgate_2", { input = true } ); 
    ObjSet( "spr_hoscrypt_rpl_shield",       { event_mdown = private.ClkShield, input = true } );
    ObjSet( "txt_hoscrypt_rpl_task",         { pos_x = 50 } );

  end;

end;
--*********************************************************************************************************************
function private.ClkShield ()

  local func_end = function ()

    int.Lock( false );
    cmn.UnmarkTask( "hoscrypt_rpl", "amulet" );
    cmn.CallEventHandler( "UnmarkAmulet" );
    int.Lock( false );

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_moveshield" ); 

  ObjAnimate( "spr_hoscrypt_rpl_shield", "pos_xy", 0, 0, func_end, 
  {
    0.0, 3, 645,552,
    0.5, 3, 690,590
  } );

end;
--*********************************************************************************************************************
function private.GetAmulet ()

  local func_end = function ()

    int.Lock( false );

  end;

  int.Lock( true );
  MsgSend( Event_DialogHo_Show, {} );
  ObjAnimate( "spr_hoscrypt_rpl_amuletgate_2", "alp", 0, 0, func_end, 
  {
    0.0, 3, 1.0,
    0.3, 3, 0.0,
  } );

end;
--*********************************************************************************************************************
function private.InitAnims ()

  ObjAnimate( "txt_hoscrypt_rpl_num", "scale_xy", 1, 0, "",
  { 
    0.0, 3, 1.05,1.05,
    2.0, 3, 0.95,0.95,
    3.0, 3, 1.05,1.05
  } );

end;
--********************************************************************************************************************* 