-- name=ho_hosecuritypoint_rpl
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_hosecuritypoint_rpl" );

  private.room_objname = "ho_hosecuritypoint_rpl";
  game.relations[ private.room_objname ].exitroom = "rm_replayroom";

  private.win_hosecuritypoint_rpl = {};

  private.win_hosecuritypoint_rpl.pos_inv = 
  {-240, -120, 0, 120, 240, 360, 480, 600, 720, 840, 960, 1080};

   private.InitAnims();
  --------------------------------------------------------------------------------------------
  -- function win_hosecuritypoint_rpl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_hosecuritypoint_rpl" ] =
  {
    type = "get",
    get_obj = "spr_hosecuritypoint_rpl_win",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local start_hosecuritypoint_rpl_func = function ()

    if ( cmn.IsEventStart( "win_hosecuritypoint_rpl" ) ) then

      common_impl.ProcessHoStart( "hosecuritypoint_rpl" );
      local ho_found = ng_global.progress[ "rpl" ][ "win_hosecuritypoint_rpl" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
      end;

    end;

  end;
  cmn.AddSubscriber( "win_hosecuritypoint_rpl", start_hosecuritypoint_rpl_func, "ho_hosecuritypoint_rpl" );
  --------------------------------------------------------------------------------------------------
  private.win_hosecuritypoint_rpl.task = { "burger", "camera", "cup", "dart", "fire_extinguisher", "gun", "handcuffs", "hat", "megaphone", "pin", "rifle", "triangular_key" };

  for i = 1, #private.win_hosecuritypoint_rpl.task do

    ObjSet( "spr_hosecuritypoint_rpl_"..private.win_hosecuritypoint_rpl.task[ i ], { event_mdown = function () private.CompleteTask( private.win_hosecuritypoint_rpl.task[ i ] ); end, input = false } );

  end;
  --------------------------------------------------------------------------------------------------  

end;

--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.ResetHO () 
 
  ObjDelete( "spr_hosecuritypoint_rpl_win" ); 
  
  ng_global.progress[ "rpl" ][ "win_hosecuritypoint_rpl" ].start = 0;
  ng_global.progress[ "rpl" ][ "win_hosecuritypoint_rpl" ].done = 0;
  ng_global.progress[ "rpl" ][ "win_hosecuritypoint_rpl" ].task_check = nil; 
  
  ObjDelete( "obj_hosecuritypoint_rpl_panel" );
    
end;
--*********************************************************************************************************************
function public.PreOpen ()
  
  cmn.CallEventHandler( "win_hosecuritypoint_rpl" );
  
  local ho_tasks = {};
  cmn.InterfaceSetVisible( true );

  if ( not cmn.IsEventDone( "opn_hosecuritypoint_rpl" ) ) then

      cmn.SetEventDone( "opn_hosecuritypoint_rpl" );
      cmn.CallEventHandler( "opn_hosecuritypoint_rpl" );

  end;

  if ( not cmn.IsEventStart( "win_hosecuritypoint_rpl" ) ) then

    cmn.InitHo( "hosecuritypoint_rpl" );

  end;

  for i = 1, #private.win_hosecuritypoint_rpl.task do

    interface.TaskPanelTaskAdd( ho_tasks, private.win_hosecuritypoint_rpl.task[ i ], 1, 0, { { "spr_hosecuritypoint_rpl_"..private.win_hosecuritypoint_rpl.task[ i ] } } );

  end;

  int.TaskPanelShow( ho_tasks );
  private.Panel();

  cmn.StopAllMus();
  cmn.PlayAudio( "mus", "audio/aud_amnesia_theme_mus", 1 );
--
end;
--*********************************************************************************************************************
function public.Open ()

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close ()

  ObjAttach( "obj_hosecuritypoint_rpl_panel" , "ho_hosecuritypoint_rpl" ); 

end;
--*********************************************************************************************************************
function public.HoComplete ()
 

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )

  int.Lock( true );

  local postfix = "";

  if ( number ) then

     postfix = "_"..number;

  end;

  cmn.HoTaskFind( "spr_hosecuritypoint_rpl_"..name..postfix, name );
  for i = 1,#private.win_hosecuritypoint_rpl.task do

      if ( private.win_hosecuritypoint_rpl.task[i] == name ) then 

          local object_name = "obj_sec_"..i; 
          local collect_name  = "pfx_hosecuritypoint_rpl_collect_"..object_name.."_effect";
          ng_global.progress[ "rpl" ][ "win_hosecuritypoint_rpl" ].task_check[ i ] = 1;
          ObjCreate( collect_name, "partsys" );

          ObjSet( collect_name,
          {
            res    = "assets/interface/resources/effects_ho_hint",
            pos_x  = ObjGet( object_name ).pos_x, pos_y = ObjGet( object_name ).pos_y,
            active = 1, visible = 1, input = 0
          } );

          ObjAttach( collect_name, "obj_hosecuritypoint_rpl_panel" );
          ObjSet( collect_name, { blendmode = 2, scale_x = 0.8, scale_y = 0.8 } );
          --PartSysSetMaskObj( collect_name, object_name );  
          local func_end = function () private.AnimInv( i ); end;
          ObjAnimate( object_name, 8,0,0, func_end,
          { 
              0.0, 0, 1.0,
              0.5, 0, 0.0
          } );
--
      end;

  end;

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjAttach( "obj_hosecuritypoint_rpl_panel" , "spr_int_taskpanel" );

  if ( not ng_global.progress[ "rpl" ]["win_hosecuritypoint_rpl"].task_check ) then

     ng_global.progress["rpl"]["win_hosecuritypoint_rpl"].task_check = {0,0,0,0,0,0,0,0,0,0,0,0};

  end;

  local posx = -240;
  local tmp = 0;

  ObjSet( "obj_hosecuritypoint_rpl_panel", { croprect_init = true, croprect_x = -308, croprect_y = -200, croprect_w = 617, croprect_h = 400 } );

  for i = 1,#private.win_hosecuritypoint_rpl.task do 

     local obj = "obj_sec_"..i;

     if ( ng_global.progress["rpl"]["win_hosecuritypoint_rpl"].task_check[i] == 0 ) and
        ( not ObjGet( obj ) ) then

        ObjCreate( obj, "obj" );
        ObjAttach( obj, "obj_hosecuritypoint_rpl_panel" );        
        ObjSet( obj, { pos_x = posx, pos_y = 17, inputrect_init = true, inputrect_x = -45, inputrect_y = -45, inputrect_w = 90, inputrect_h = 90, alp = 1, input = false  } );
        local spr = "spr_hosecuritypoint_rpl_"..private.win_hosecuritypoint_rpl.task[i].."_inv";
        ObjCreate( spr, "spr" );
        ObjSet( spr, { res = "assets/levels/level3/ho_hosecuritypoint/layers/inv/"..private.win_hosecuritypoint_rpl.task[i].."_inv", scale_x = 0.85, scale_y = 0.85 } );
        ObjAttach( spr, obj );
        tmp = tmp + 1;
        if ( tmp < 6 ) then

           private.CheckPanel( i, tmp );
          
        end;

        posx = posx + 120;

        if ( tmp == 12 ) then

            ng_global.progress["rpl"]["win_hosecuritypoint_rpl"].set = 1;

        end;

     else

     end;

  end;
   
end;
--********************************************************************************************************************* 
function private.CheckPanel ( i, tmp ) 

   local obj = "obj_sec_"..i;

   if ( tmp < 6 ) then

      ObjSet( obj, { input = 1 } );

      ObjAnimate( obj, "alp", 0, 0, "", 
      { 
        0,0,0, 
        0.3,0,1 
      });

      ObjSet( "spr_hosecuritypoint_rpl_"..private.win_hosecuritypoint_rpl.task[i], { alp = 1, input = 1 } );

   end;
   
end;
--*********************************************************************************************************************
function private.AnimInv ( num )

  local item = "obj_sec_"..num;
  local tmp = num + 1;

      for i = tmp,#private.win_hosecuritypoint_rpl.task do
          local obj_tmp = "obj_sec_"..i;

          if obj_tmp ~= nil and ng_global.progress["rpl"]["win_hosecuritypoint_rpl"].task_check[i] ~= 1 then

              ObjAnimate( "obj_sec_"..i, "pos_x", 0, 0, "", 
              { 
                0,3,ObjGet( "obj_sec_"..i ).pos_x, 
                0.6,3,ObjGet( "obj_sec_"..i ).pos_x-120
              });

               if ObjGet( "obj_sec_"..i ).pos_x-120 == 240 then

                  ObjAnimate( "obj_sec_"..i, "scale_xy", 0, 0, "", 
                  { 
                    0.0,0,0.2,0.2, 
                    0.7,0,1,1
                  });

               end;

          end;

      end;

  private.Check( num );

end;
--*********************************************************************************************************************
function private.Check ( num )  

   local tmp = 0;

   for i = 1,#private.win_hosecuritypoint_rpl.task do

       local item = "obj_sec_"..i;

       if ( item and ng_global.progress[ "rpl" ][ "win_hosecuritypoint_rpl" ].task_check[ i ] ~= 1 ) then

          tmp = tmp + 1;

          if ( tmp < 6 ) then

             ObjSet( "spr_hosecuritypoint_rpl_"..private.win_hosecuritypoint_rpl.task[ i ], { alp = 1, input = 1 } );

          end;

          num = num + 1;

       end;

   end;
   
   local func_end = function () int.Lock( false ) end;

   ObjAnimate( "ho_hosecuritypoint_rpl", "alp", 0, 0, func_end, 
   { 
    0,3,1, 
    0.6,3,1
   });

end;
--*********************************************************************************************************************
function private.InitAnims ()

  ObjAnimate( "spr_hosecuritypoint_rpl_lamp", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    2.0, 3, 1.0,
    2.1, 3, 0.8,
    2.2, 3, 1.0,
    2.3, 3, 0.8,
    2.4, 3, 1.0,
    4.0, 3, 1.0,
  } );

  ObjAnimate( "spr_hosecuritypoint_rpl_monitors", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    0.03, 3, 0.9,
    0.06, 3, 1.0
  } );

  ObjAnimate( "spr_hosecuritypoint_rpl_window", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    2.5, 3, 1.0,
    5.0, 3, 0.3,
  } );

end;
--********************************************************************************************************************* 