-- name=ho_investigatorsdesk_rpl
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------

  room.Define( "ho_investigatorsdesk_rpl" );

  private.room_objname = "ho_investigatorsdesk_rpl";
  game.relations[ private.room_objname ].exitroom = "rm_replayroom";

  private.win_investigatorsdesk_rpl = {};

  private.InitAnim();
  private.win_investigatorsdesk_rpl.time = { 9, 8.5, 3.5, 7, 9, 6, 7, 5.3, 7.0, 8, 9.5, 9 };
  --------------------------------------------------------------------------------------------
  -- function opn_investigatorsdesk_rpl () end;
  --------------------------------------------------------------------------------------------
  local opn_investigatorsdesk_rpl = function ()

  end;

  cmn.AddSubscriber( "opn_investigatorsdesk_rpl", opn_investigatorsdesk_rpl, private.room_objname );
  --------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_investigatorsdesk_rpl" ] =
  {
    type    = "get",
    get_obj = "spr_investigatorsdesk_rpl_win",
    room    = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local start_investigatorsdesk_rpl_func = function ()

    if ( cmn.IsEventStart( "win_investigatorsdesk_rpl" ) ) then

        common_impl.ProcessHoStart( "investigatorsdesk_rpl" );

        local ho_found = ng_global.progress[ "rpl" ][ "win_investigatorsdesk_rpl" ].found;

        for i = 1, #ho_found, 1 do

            ObjDelete( ho_found[ i ][ "object" ] );

        end;

        for i = 1,3 do

          local idx = ng_global.progress["rpl"]["win_investigatorsdesk_rpl"].note[ i ][ 1 ];

          if ( ng_global.progress["rpl"]["win_investigatorsdesk_rpl"].note[ i ][ 2 ] ) then

            ObjSet( "spr_investigatorsdesk_rpl_"..i.."check", { alp = 1 } );

          end;

        end;

    end;

  end;
  cmn.AddSubscriber( "win_investigatorsdesk_rpl", start_investigatorsdesk_rpl_func, "ho_investigatorsdesk_rpl" );
  --------------------------------------------------------------------------------------------------

  private.win_investigatorsdesk_rpl.task = { "twentythree", "car", "spikes", "cartracks", "gun", "camera", "family", "cassette", "house", "knife", "deer", "manphoto" };

  for i = 1, #private.win_investigatorsdesk_rpl.task do

    ObjSet( "spr_investigatorsdesk_rpl_"..private.win_investigatorsdesk_rpl.task[ i ], { input = false, event_mdown = function () private.CompleteTask( private.win_investigatorsdesk_rpl.task[ i ] ); end } );

  end;
  --------------------------------------------------------------------------------------------------  
end;
--*********************************************************************************************************************
function public.Load ()


end;
--*********************************************************************************************************************
function public.ResetHO ()  
  
  ObjDelete( "spr_investigatorsdesk_rpl_win" );
  
  ng_global.progress[ "rpl" ][ "win_investigatorsdesk_rpl" ].start = 0;
  ng_global.progress[ "rpl" ][ "win_investigatorsdesk_rpl" ].done = 0;
  ng_global.progress["rpl"]["win_investigatorsdesk_rpl"].number = 1;
  ng_global.progress["rpl"]["win_investigatorsdesk_rpl"].note = { { 6, false }, { 9, false }, { 12, false } };  
    
end;
--*********************************************************************************************************************
function public.PreOpen ()
  
  cmn.CallEventHandler( "win_investigatorsdesk_rpl" );

  cmn.InterfaceSetVisible( true );

  if ( not cmn.IsEventDone( "opn_investigatorsdesk_rpl" ) ) then

    cmn.SetEventDone( "opn_investigatorsdesk_rpl" );
    cmn.CallEventHandler( "opn_investigatorsdesk_rpl" );

    ng_global.progress["rpl"]["win_investigatorsdesk_rpl"].number = 1;
    ng_global.progress["rpl"]["win_investigatorsdesk_rpl"].note = { { 6, false }, { 9, false }, { 12, false } };

    --cmn.TutorialShow( "tutorial_page_10" );
    --cmn.TutorialSetShown( "tutorial_page_10" );

  end;

  private.TaskStart();

  local ho_tasks = {};

  interface.TaskPanelTaskAdd( ho_tasks, "twentythree",    1, 0, { { "spr_investigatorsdesk_rpl_twentythree"        } } );
  interface.TaskPanelTaskAdd( ho_tasks, "car",            1, 0, { { "spr_investigatorsdesk_rpl_car"  } } );
  interface.TaskPanelTaskAdd( ho_tasks, "spikes",         1, 0, { { "spr_investigatorsdesk_rpl_spikes"  } } );
  interface.TaskPanelTaskAdd( ho_tasks, "cartracks",      1, 0, { { "spr_investigatorsdesk_rpl_cartracks" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "gun",            1, 0, { { "spr_investigatorsdesk_rpl_gun"     } } );
  interface.TaskPanelTaskAdd( ho_tasks, "camera",         1, 0, { { "spr_investigatorsdesk_rpl_camera"       } } );
  interface.TaskPanelTaskAdd( ho_tasks, "family",         1, 0, { { "spr_investigatorsdesk_rpl_family"      } } );
  interface.TaskPanelTaskAdd( ho_tasks, "cassette",       1, 0, { { "spr_investigatorsdesk_rpl_cassette"      } } );
  interface.TaskPanelTaskAdd( ho_tasks, "house",          1, 0, { { "spr_investigatorsdesk_rpl_house"  } } );
  interface.TaskPanelTaskAdd( ho_tasks, "knife",          1, 0, { { "spr_investigatorsdesk_rpl_knife"       } } );
  interface.TaskPanelTaskAdd( ho_tasks, "deer",           1, 0, { { "spr_investigatorsdesk_rpl_deer" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "manphoto",       1, 0, { { "spr_investigatorsdesk_rpl_manphoto"     } } );


  if ( not cmn.IsEventStart( "win_investigatorsdesk_rpl" ) ) then

      cmn.InitHo( "investigatorsdesk_rpl" );

  end;

  int.TaskPanelShow( ho_tasks );
  private.Panel();

  cmn.StopAllMus();
  cmn.PlayAudio( "mus", "audio/aud_amnesia_theme_mus", 1 );

end;
--*********************************************************************************************************************
function public.Open ()

  private.TimerStart();

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();
  --cmn.StopAudio( "env", "audio/level1/env/aud_ho_theme_mus_env", 0.3 );
  cmn.StopAllVoc();

end;
--*********************************************************************************************************************
function public.Close ()

  ObjAttach( "obj_investigatorsdesk_rpl_taskpanel" , "ho_investigatorsdesk_rpl" );

end;
--*********************************************************************************************************************
function public.HoComplete ()


end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )

  local postfix = "";

  if ( number ) then

     postfix = "_1"

  end;

  cmn.HoTaskFind( "spr_investigatorsdesk_rpl_"..name..postfix, name..postfix );
  private.CheckDone();
  if ( ng_global.progress["rpl"]["win_investigatorsdesk_rpl"].number ~= 12) then

    ng_global.progress["rpl"]["win_investigatorsdesk_rpl"].number = ng_global.progress["rpl"]["win_investigatorsdesk_rpl"].number + 1;
    private.Task();

  end;

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjAttach( "obj_investigatorsdesk_rpl_taskpanel" , "int_taskpanel_impl" );

end;
--*********************************************************************************************************************
function private.TaskStart()

  local number = ng_global.progress["rpl"]["win_investigatorsdesk_rpl"].number;
  ObjSet( "txt_investigatorsdesk_rpl_taskpanel", { alp = 1, text = "tsk_investigatorsdesk_rpl_"..private.win_investigatorsdesk_rpl.task[ number ] } );
  ObjSet( "spr_investigatorsdesk_rpl_"..private.win_investigatorsdesk_rpl.task[ number ], { input = true } );

end;
--*********************************************************************************************************************
function private.Task ()
  
  local func_end = function ()

    local number = ng_global.progress["rpl"]["win_investigatorsdesk_rpl"].number;
    ObjSet( "txt_investigatorsdesk_rpl_taskpanel", { text = "tsk_investigatorsdesk_rpl_"..private.win_investigatorsdesk_rpl.task[ number ] } );
    ObjSet( "spr_investigatorsdesk_rpl_"..private.win_investigatorsdesk_rpl.task[ number ], { input = true } );

  end;

  local func_end2 = function ()

    int.Lock( false );

  end;

  int.Lock( true );

  ObjAnimate( "txt_investigatorsdesk_rpl_taskpanel", "alp", 0, 0, func_end2,
  { 
    0.0, 0, 1, 
    0.3, 0, 0,
    0.4, 0, 0,
    0.7, 0, 1

  } );

  ObjAnimate( "ho_investigatorsdesk_rpl", "alp", 0, 0, func_end,
  { 
    0.0, 0, 1, 
    0.3, 0, 1
  } );

  private.TimerDone();
  private.TimerStart();

end;
--*********************************************************************************************************************
function private.TimerStart ()

  local number = ng_global.progress["rpl"]["win_investigatorsdesk_rpl"].number;

  ObjSet( "tmr_investigatorsdesk_rpl_voice", 
    { 
    playing = true, 
    time = private.win_investigatorsdesk_rpl.time[ number ],
    endtrig = private.TimerDone
    } );

  cmn.StopAllVoc();
  cmn.PlayAudio( "voc", "audio/level1/voc/aud_youngpolice"..number.."_voc", 0 ); 

  ObjSet( "obj_investigatorsdesk_rpl_button", { input = false } );
  ObjSet( "anm_investigatorsdesk_rpl_recorder", { active = true } );
  ObjAnimate( "spr_investigatorsdesk_rpl_play2", "alp", 0, 0, "",
  { 
    0.0, 0, ObjGet( "spr_investigatorsdesk_rpl_play2" ).alp, 
    0.3, 0, 1
  } );

end;
--*********************************************************************************************************************
function private.TimerDone ()

  local func_end = function ()

    private.TimerStart();
    cmn.PlayAudio( "env", "audio/level1/env/aud_investigatorsdesk_in", 0 );

  end;

  local number = ng_global.progress["rpl"]["win_investigatorsdesk_rpl"].number;

  cmn.StopAllVoc();
  cmn.PlayAudio( "env", "audio/level1/env/aud_investigatorsdesk_in", 0 );
  ObjSet( "obj_investigatorsdesk_rpl_button", { input = true, event_mdown = func_end } );
  ObjSet( "anm_investigatorsdesk_rpl_recorder", { active = false } );
  ObjAnimate( "spr_investigatorsdesk_rpl_play2", "alp", 0, 0, "",
  { 
    0.0, 0, ObjGet( "spr_investigatorsdesk_rpl_play2" ).alp, 
    0.3, 0, 0
  } );

end;
--*********************************************************************************************************************
function private.CheckDone ()

  local number = ng_global.progress["rpl"]["win_investigatorsdesk_rpl"].number;

  for i = 1,3 do

    local idx = ng_global.progress["rpl"]["win_investigatorsdesk_rpl"].note[ i ][ 1 ];

    if ( number == idx ) and not ( ng_global.progress["rpl"]["win_investigatorsdesk_rpl"].note[ i ][ 2 ] ) then

      ng_global.progress["rpl"]["win_investigatorsdesk_rpl"].note[ i ][ 2 ] = true;
      ObjAnimate( "spr_investigatorsdesk_rpl_"..i.."check", "alp", 0, 0, "",
      { 
        0.0, 0, 0, 
        0.3, 0, 1
      } );

      AnimPlay( "anm_investigatorsdesk_rpl_sighnfx_"..i, "DoAnim", "" );

    end;


  end;

end;
--*********************************************************************************************************************
function private.InitAnim ()

  ObjAnimate( "spr_investigatorsdesk_rpl_lamp_light_add", "alp", 1, 0, "",
  { 
    0.0, 0, 1, 
    0.5, 0, 0.9,
    1, 0, 1 
  } );

end;
--*********************************************************************************************************************