-- name=mg_cashtill_rpl
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_cashtill_rpl";
  game.relations[ "mg_cashtill_rpl" ].exitroom = "rm_replayroom";

  ObjMultiSet( {
    --{ "spr_cashtill_rpl_twister",     { event_mdown = private.get_twister } },
    { "spr_cashtill_rpl_button_open", { event_mdown = private.clk_cashtill_rpl } },
    { "spr_cashtill_rpl_fork",        { event_mdown = private.ForkClick } },
    { "obj_cashtill_rpl_candy_click", { event_mdown = private.CandyClick } },
    { "obj_cashtill_rpl_ice_click",   { event_mdown = private.IceClick } },
  } );

  private.Init();
  private.Anims();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_cashtill_rpl = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;
  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    

      visible_sparkle_area = false;

    end;

    local visible_sparkle_ho = true;  

    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    

      visible_sparkle_ho = false;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then

      ObjMultiSet( table_multiset );

    end;

  end;

  cmn.AddSubscriber( "update_game_mode_cashtill_rpl", update_game_mode_cashtill_rpl, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_cashtill_rpl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_cashtill_rpl" ] =
  {
    type = "click",
    get_obj = "spr_cashtill_rpl_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_cashtill_rpl = function ()

    if ( cmn.IsEventStart( "win_cashtill_rpl" ) ) and not ( cmn.IsEventDone( "win_cashtill_rpl" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_cashtill_rpl", win_cashtill_rpl, private.room_objname );

end;
--*********************************************************************************************************************
function private.Init ()

  private.button_pos = { { 481, 119 }, { 593, 176 }, { 704, 232 }, { 425, 232 }, { 537, 289 }, { 649, 344 }, { 369, 344 }, { 482, 402 }, { 596, 456 } };

  private.count_buttons = 9;
  private.count_lamps   = 16;

  for b = 1, private.count_buttons do

    ObjSet( "spr_cashtill_rpl_button_"..b,
    {
      input = true,
      event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      event_mdown  = function () private.ButtonClick( b ) end,
    } );

  end;

end;
--*********************************************************************************************************************
function private.Load ()

  for b = 1, private.count_buttons do

    local idx = ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].field[ b ];

    ObjSet( "obj_cashtill_rpl_button_"..idx,
    {
      pos_x = private.button_pos[ b ][ 1 ],
      pos_y = private.button_pos[ b ][ 2 ],
    } );

  end;

  if ( ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].button ) then

    ObjSet( "spr_cashtill_rpl_button_"..ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].button.."_light", { alp = 1 } );

  end;

  private.IsWin();

end;
--*********************************************************************************************************************
function public.PreOpen () 
  
  cmn.CallEventHandler( "win_cashtill_rpl" );
  
  if cmn.IsEventDone( "win_cashtill_rpl" ) then
    public.Reset();
    ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].start = 0;
    ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].done = 0;
  end;

  cmn.StopAllMus();
  cmn.PlayAudio( "mus", "audio/aud_amnesia_theme_mus", 1 );

end;
--*********************************************************************************************************************
function public.Open () 
  
  if not ( cmn.IsEventStart( "win_cashtill_rpl" ) ) then    
    private.Start();
    private.Anims();
  elseif cmn.IsEventStart( "win_cashtill_rpl" ) then
    cmn.MiniGameShow( "cashtill_rpl" );
  end;

--  if ( not cmn.IsEventDone( "win_cashtill_rpl" ) ) then
--
--    cmn.MiniGameShow( "cashtill_rpl" );
--    --common_impl.PassingMgStart( "cashtill_rpl" );
--
--  end;
--
--  if ( not cmn.IsEventDone( "opn_cashtill_rpl" ) ) then
--
--    cmn.SetEventDone( "opn_cashtill_rpl" );
--
--  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  cmn.MiniGameHide();
  --common_impl.PassingMgWin( "cashtill_rpl" );

end;
--*********************************************************************************************************************
function public.Reset ()

  int.Lock( true );

  local start_state = { 7, 8, 9, 4, 5, 6, 1, 2, 3 };

  for b = 1, private.count_buttons do

    local pos = ObjGet( "obj_cashtill_rpl_button_"..start_state[ b ] );

    if ( ( pos.pos_x ~= private.button_pos[ b ][ 1 ] ) or ( pos.pos_y ~= private.button_pos[ b ][ 2 ] ) ) then

      ObjAnimate( "obj_cashtill_rpl_button_"..start_state[ b ], "pos_xy", 0, 0, "", 
      {
        0.0, 3, pos.pos_x, pos.pos_y,
        0.5, 3, private.button_pos[ b ][ 1 ], private.button_pos[ b ][ 2 ],
      } );

      ObjAnimate( "spr_cashtill_rpl_button_"..start_state[ b ].."_shadow", "alp", 0, 0, "", 
      {
        0.00, 3, 1,
        0.15, 3, 0,
        0.35, 3, 0,
        0.50, 3, 1,
      } );

    end;

  end;

  local lamps_light = { 0, 0, 0, 1, 1, 1, 0, 1, 1, 0, 1, 1, 1, 0, 0, 0 };

  for b = 1, private.count_lamps do

    local alp = ObjGet( "spr_cashtill_rpl_lamp_"..b ).alp;

    ObjAnimate( "spr_cashtill_rpl_lamp_"..b, "alp", 0, 0, "", 
    {
      0.0, 3, alp,
      0.3, 3, lamps_light[ b ],
    } );

  end;

  if ( ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].button ) then

    ObjSet( "spr_cashtill_rpl_button_"..ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].button.."_light", { alp = 0 } );

  end;

  ObjSet( "tmr_cashtill_rpl_reset", 
  { 
    playing = 1,
    time = 0.5,
    endtrig = function ()

      int.Lock( false );

      ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].field  = { 7, 8, 9, 4, 5, 6, 1, 2, 3 };
      ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].button = nil;

    end
  } );

end;
--*********************************************************************************************************************
function public.Skip ()

  int.Lock( true );

  local win_state = { 8, 1, 6, 3, 5, 7, 4, 9, 2 };

  for b = 1, private.count_buttons do

    local pos = ObjGet( "obj_cashtill_rpl_button_"..win_state[ b ] );

    if ( ( pos.pos_x ~= private.button_pos[ b ][ 1 ] ) or ( pos.pos_y ~= private.button_pos[ b ][ 2 ] ) ) then

      ObjAnimate( "obj_cashtill_rpl_button_"..win_state[ b ], "pos_xy", 0, 0, "", 
      {
        0.0, 3, pos.pos_x, pos.pos_y,
        0.5, 3, private.button_pos[ b ][ 1 ], private.button_pos[ b ][ 2 ],
      } );

      ObjAnimate( "spr_cashtill_rpl_button_"..win_state[ b ].."_shadow", "alp", 0, 0, "", 
      {
        0.00, 3, 1,
        0.15, 3, 0,
        0.35, 3, 0,
        0.50, 3, 1,
      } );

    end;

  end;

  for b = 1, private.count_lamps do

    local alp = ObjGet( "spr_cashtill_rpl_lamp_"..b ).alp;

    ObjAnimate( "spr_cashtill_rpl_lamp_"..b, "alp", 0, 0, "", 
    {
      0.0, 3, alp,
      0.3, 3, 1,
    } );

  end;

  if ( ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].button ) then

    ObjSet( "spr_cashtill_rpl_button_"..ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].button.."_light", { alp = 0 } );

  end;

  ObjSet( "tmr_cashtill_rpl_reset", 
  { 
    playing = 1,
    time = 0.5,
    endtrig = function ()

      int.Lock( false );

      ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].field  = { 8, 1, 6, 3, 5, 7, 4, 9, 2 };
      ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].button = nil;

      private.Win();

    end
  } );

end;
--*********************************************************************************************************************
function private.Start ()

    ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].field  = { 7, 8, 9, 4, 5, 6, 1, 2, 3 };
    ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].button = nil;  

  cmn.MiniGameShow( "cashtill_rpl" );  

end;
--*********************************************************************************************************************
function private.Win ()

  cmn.MiniGameHide();
  
  cmn.SetEventDone( "win_cashtill_rpl" );
  cmn.CallEventHandler( "win_cashtill_rpl" );
  
  cmn.GotoRoom( "rm_replayroom" );

end;
--*********************************************************************************************************************
function private.GetPos ( idx )

  for b = 1, private.count_buttons do

    if ( ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].field[ b ] == idx ) then

      return b;

    end;

  end;

end;
--*********************************************************************************************************************
function private.IsWin ()

  local lamps   = { { 1, 2 }, { 8, 9 }, { 15, 16 }, { 3, 10 }, { 5, 12 }, { 7, 14 }, { 4, 13 }, { 6, 11 } };
  local buttons = { { 1, 2, 3 }, { 4, 5, 6 }, { 7, 8, 9 }, { 1, 4, 7 }, { 2, 5, 8 }, { 3, 6, 9 }, { 1, 5, 9 }, { 3, 5, 7 } };

  local is_win = true;

  for b = 1, #buttons do

    local kit = buttons[ b ];
    local sum = 0;

    for k = 1, #kit do

      sum = sum + ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].field[ kit[ k ] ]; 

    end;

    if ( sum == 15 ) then

      ObjSet( "spr_cashtill_rpl_lamp_"..lamps[ b ][ 1 ], { alp = 1 } );
      ObjSet( "spr_cashtill_rpl_lamp_"..lamps[ b ][ 2 ], { alp = 1 } );

    else

      is_win = false;

      ObjSet( "spr_cashtill_rpl_lamp_"..lamps[ b ][ 1 ], { alp = 0 } );
      ObjSet( "spr_cashtill_rpl_lamp_"..lamps[ b ][ 2 ], { alp = 0 } );

    end;

  end;

  return is_win;

end;
--*********************************************************************************************************************
function private.ButtonClick ( idx )

  local current = ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].button;

  int.Lock( true );

  if ( current ) then

    if ( current == idx ) then

      local func_end = function ()

        int.Lock( false );

        ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].button = nil;

      end;
      
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_cashtill_click" );
      ObjAnimate( "spr_cashtill_rpl_button_"..idx.."_light", "alp", 0, 0, func_end, 
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

    else

      local name_1 = "obj_cashtill_rpl_button_"..idx;
      local name_2 = "obj_cashtill_rpl_button_"..current;

      local pos_1 = ObjGet( name_1 );
      local pos_2 = ObjGet( name_2 );

      ObjSet( name_1, { pos_z = 10 } );
      ObjSet( name_2, { pos_z = 10 } );

      local func_end = function ()

        int.Lock( false );

        ObjSet( name_1, { pos_z = 2 } );
        ObjSet( name_2, { pos_z = 2 } );

        local idx_1 = private.GetPos( idx );
        local idx_2 = private.GetPos( current );

        ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].field[ idx_1 ] = current;
        ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].field[ idx_2 ] = idx;
        ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].button = nil;

        if ( private.IsWin() ) then

          private.Win();

        end;

      end;
      
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_cashtill_switch" );
      ObjAnimate( "spr_cashtill_rpl_button_"..idx.."_light", "alp", 0, 0, "", 
      {
        0.0, 3, 0,
        0.3, 3, 1,
        0.5, 3, 1,
        0.8, 3, 0,
      } );

      ObjAnimate( "spr_cashtill_rpl_button_"..current.."_light", "alp", 0, 0, "", 
      {
        0.0, 3, 1,
        0.5, 3, 1,
        0.8, 3, 0,
      } );

      ObjAnimate( "spr_cashtill_rpl_button_"..idx.."_shadow", "alp", 0, 0, "", 
      {
        0.00, 3, 1,
        0.50, 3, 1,
        0.65, 3, 0,
        0.85, 3, 0,
        1.00, 3, 1,
      } );

      ObjAnimate( "spr_cashtill_rpl_button_"..current.."_shadow", "alp", 0, 0, "", 
      {
        0.00, 3, 1,
        0.50, 3, 1,
        0.65, 3, 0,
        0.85, 3, 0,
        1.00, 3, 1,
      } );

      ObjAnimate( name_1, "pos_xy", 0, 0, "", 
      {
        0.0, 3, pos_1.pos_x, pos_1.pos_y,
        0.5, 3, pos_1.pos_x, pos_1.pos_y,
        1.0, 3, pos_2.pos_x, pos_2.pos_y,
      } );

      ObjAnimate( name_2, "pos_xy", 0, 0, func_end, 
      {
        0.0, 3, pos_2.pos_x, pos_2.pos_y,
        0.5, 3, pos_2.pos_x, pos_2.pos_y,
        1.0, 3, pos_1.pos_x, pos_1.pos_y,
      } );

    end;

  else

    local func_end = function ()

      int.Lock( false );

      ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].button = idx;

    end;
    
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_cashtill_click" );
    ObjAnimate( "spr_cashtill_rpl_button_"..idx.."_light", "alp", 0, 0, func_end, 
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

  end;

end;
--*********************************************************************************************************************
function private.Anims ()

  ObjAnimate( "spr_cashtill_rpl_light_down", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    3.0, 3, 1.0,
    6.0, 3, 0.3,
  } );

  ObjAnimate( "spr_cashtill_rpl_light_up", "alp", 0, 1, "", 
  {
    0.0, 3, 0.3,
    3.0, 3, 1.0,
    6.0, 3, 0.3,
  } );

  ObjAnimate( "spr_cashtill_rpl_light", "alp", 0, 1, "", 
  {
    0.0, 3, 0.3,
    3.0, 3, 1.0,
    6.0, 3, 0.3,
  } );

  ObjAnimate( "spr_cashtill_rpl_monitor_light", "alp", 1, 0, "", 
  {
    0.0, 3, 1.0,
    2.0, 3, 1.0,
    2.1, 3, 0.5,
    2.2, 3, 1.0,
    2.3, 3, 0.5,
    2.4, 3, 1.0,
    8.0, 3, 1.0,
  } );

  ObjAnimate( "spr_cashtill_rpl_button_open_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.0,
    0.8, 3, 1.0,
    1.6, 3, 0.0,
  } );

end;
--*********************************************************************************************************************
function private.ForkClick ()

  local func_end = function ()

    int.Lock( false );

  end;

  int.Lock( true );

  ObjAnimate( "spr_cashtill_rpl_fork", "ang", 0, 0, func_end, 
  {
    0.0, 3,  0.0,
    0.5, 3, -0.05,
    1.0, 3,  0.0,
  } );

end;
--*********************************************************************************************************************
function private.CandyClick ()

  local func_end = function ()

    int.Lock( false );

    ng_global.progress[ "rpl" ][ "win_cashtill_rpl" ].candy = true;

    ObjDelete( "obj_cashtill_rpl_candy" );

  end;

  int.Lock( true );

  ObjAnimate( "spr_cashtill_rpl_candy_1", "alp", 0, 0, "", 
  {
    0.0, 3,  1.0,
    0.1, 3,  1.0,
    0.4, 3,  0.0,
  } );

  ObjAnimate( "spr_cashtill_rpl_candy_2", "alp", 0, 0, func_end, 
  {
    0.0, 3,  1.0,
    0.6, 3,  1.0,
    0.9, 3,  0.0,
  } );

end;
--*********************************************************************************************************************
function private.IceClick ()

  local func_end = function ()

    int.Lock( false );

    ObjSet( "anm_cashtill_rpl_ice",       { alp = 1, frame = 0 } );
    ObjSet( "anm_cashtill_rpl_ice_click", { alp = 0 } );

  end;

  int.Lock( true );

  ObjSet( "anm_cashtill_rpl_ice",       { alp = 0 } );
  ObjSet( "anm_cashtill_rpl_ice_click", { alp = 1 } );

  AnimPlay( "anm_cashtill_rpl_ice_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************