-- name=mg_darkness_rpl
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_darkness_rpl";
  game.relations[ "mg_darkness_rpl" ].exitroom = "rm_replayroom";

  private.hidden_count = {136,139}
  private.stage = 1;
  private.opened_count = {0,0};

  for i = 1, private.hidden_count[ 1 ] do
    ObjSet( "spr_darkness_rpl_symbol_1_hide_"..i, {
      input = true,
      event_menter = function () private.EnterPart( i ); end,
      event_mleave = function () private.LeavePart( i ); end
    });
  end;

  for i = 1, private.hidden_count[ 2 ] do
    ObjSet( "spr_darkness_rpl_symbol_2_hide_"..i, {
      input = true,
      event_menter = function () private.EnterPart( i ); end,
      event_mleave = function () private.LeavePart( i ); end
    });
  end;   

  --------------------------------------------------------------------------------------------
  -- function win_darkness_rpl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_darkness_rpl" ] =
  {
    type = "click",
    get_obj = "spr_darkness_rpl_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_darkness_rpl = function ()

    if ( cmn.IsEventStart( "win_darkness_rpl" ) ) and not ( cmn.IsEventDone( "win_darkness_rpl" ) ) then

      private.Load();

    end;

  end;
  cmn.AddSubscriber( "win_darkness_rpl", win_darkness_rpl, private.room_objname );    

end;
--*********************************************************************************************************************
function private.Load ()

  private.stage = ng_global.progress[ "rpl" ][ "win_darkness_rpl" ].stage;
  private.opened_count[ 1 ] = ng_global.progress[ "rpl" ][ "win_darkness_rpl" ].opened_count[ 1 ];
  private.opened_count[ 2 ] = ng_global.progress[ "rpl" ][ "win_darkness_rpl" ].opened_count[ 2 ];

  if ( private.stage == 1 ) then
    ObjSet( "obj_darkness_rpl_symdol_1", { alp = 1, input = true } );
    ObjSet( "obj_darkness_rpl_symdol_2", { alp = 0, input = false } );
    ObjSet( "anm_darkness_rpl_atropos_left_hand_big", { alp = 1, playing = true } );
    ObjSet( "anm_darkness_rpl_atropos_left_hand", { alp = 0, playing = false } );
  elseif ( private.stage == 2 ) then
    ObjSet( "obj_darkness_rpl_symdol_2", { alp = 1, input = true } );
    ObjSet( "obj_darkness_rpl_symdol_1", { alp = 0, input = false } );
    ObjSet( "anm_darkness_rpl_atropos_right_hand_big", { alp = 1, playing = true } );
    ObjSet( "anm_darkness_rpl_atropos_right_hand", { alp = 0, playing = false } );
    ObjSet( "anm_darkness_rpl_atropos_left_hand_big", { alp = 1, playing = true } );
    ObjSet( "anm_darkness_rpl_atropos_left_hand", { alp = 0, playing = false } );
  end

  for i = 1, private.opened_count[ private.stage ] do
    ObjSet( "spr_darkness_rpl_symbol_"..private.stage.."_hide_"..i, { alp = 0 } );
  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()
 
 cmn.CallEventHandler( "win_darkness_rpl" ); 

  if cmn.IsEventDone( "win_darkness_rpl" ) then
    public.Reset();
    ng_global.progress[ "rpl" ][ "win_darkness_rpl" ].start = 0;
    ng_global.progress[ "rpl" ][ "win_darkness_rpl" ].done = 0;
  end;
  
  cmn.StopAllMus();
  cmn.PlayAudio( "mus", "audio/aud_amnesia_theme_mus", 1 );

end;
--*********************************************************************************************************************
function public.Open () 

  if not ( cmn.IsEventStart( "win_darkness_rpl" ) ) then    
    private.Start();
    private.InitAnim();
  elseif cmn.IsEventStart( "win_darkness_rpl" ) then
    cmn.MiniGameShow( "darkness_rpl" );
  end;

  private.Anims();
  
end;
--*********************************************************************************************************************
function public.PreClose ()

  if ( cmn.IsEventStart( "win_darkness_rpl" ) and not cmn.IsEventDone( "win_darkness_rpl" ) ) then
    cmn.MiniGameHide();
  end;

  cmn.StopAllEnv( );

end;
--*********************************************************************************************************************
function public.Reset ()

  ObjStopAnimate( "spr_darkness_rpl_symbol_"..private.stage.."_over", "alp" );
  
  private.stage = 1;
  private.opened_count = {0,0};
  ng_global.progress[ "rpl" ][ "win_darkness_rpl" ].stage = 1;
  ng_global.progress[ "rpl" ][ "win_darkness_rpl" ].opened_count = {0,0};

  for i = 2, private.hidden_count[ 1 ] do
    ObjSet( "spr_darkness_rpl_symbol_1_hide_"..i, { alp = 1 } );
  end;

  for i = 2, private.hidden_count[ 2 ] do
    ObjSet( "spr_darkness_rpl_symbol_2_hide_"..i, { alp = 1 } );
  end; 

  ObjSet( "obj_darkness_rpl_symdol_1", { alp = 1, input = true } );
  ObjSet( "obj_darkness_rpl_symdol_2", { alp = 0, input = false } );

  ObjSet( "anm_darkness_rpl_atropos_right_hand_big", { alp = 0, playing = false } );
  ObjSet( "anm_darkness_rpl_atropos_right_hand", { alp = 1, playing = true } );

  private.Anims();  

end;
--*********************************************************************************************************************
function public.Skip ()

  ObjAnimate("obj_darkness_rpl_symdol_"..private.stage, "alp", 0, 0, 
  function()
    private.WinEnd();
  end, 
  {
    0.0,0,1,
    0.3,0,0
  });

end;
--*********************************************************************************************************************
function private.Start ()

  ng_global.progress[ "rpl" ][ "win_darkness_rpl" ].stage = 1;
  ng_global.progress[ "rpl" ][ "win_darkness_rpl" ].opened_count = {0,0};  

  cmn.MiniGameShow( "darkness_rpl" );  

end;
--*********************************************************************************************************************
function private.InitAnim ()

  local func_end = function ()

    int.Lock( false );

    ObjSet( "anm_darkness_rpl_atropos_left_hand_throw", { alp = 0, playing = false } );
    ObjSet( "obj_darkness_rpl_symdol_1", { input = true } );
    ObjSet( "anm_darkness_rpl_atropos_left_hand_big", { alp = 1, playing = true } );

  end;

  int.Lock( true );

  ObjSet( "anm_darkness_rpl_atropos_left_hand_throw", { alp = 1 } );
  ObjSet( "anm_darkness_rpl_atropos_left_hand", { alp = 0, playing = false } );
  AnimPlay( "anm_darkness_rpl_atropos_left_hand_throw", "DoAnim", func_end );
  ObjAnimate("obj_darkness_rpl_symdol_1", "alp", 0, 0, "", 
  {
    0.0,0,0,
    0.9,0,0,
    1.2,0,1
  });

end;
--*********************************************************************************************************************
function private.WinEnd ()

  cmn.MiniGameHide();

  cmn.SetEventDone( "win_darkness_rpl" );
  cmn.CallEventHandler( "win_darkness_rpl" );
  
  cmn.GotoRoom( "rm_replayroom" );

end;
--*********************************************************************************************************************
function private.Win ()

  int.Lock( true );

  ObjAnimate("obj_darkness_rpl_symdol_2", "alp", 0, 0, 
  function ()
    int.Lock( false );
    private.WinEnd();
  end, 
  {
    0.0,0,1,
    0.3,0,0
  });

end;
--*********************************************************************************************************************
function private.ResetPath ()

  for i=2, private.hidden_count[ 1 ] do
    ObjSet( "spr_darkness_rpl_symbol_"..private.stage.."_hide_"..i, { alp = 1 } );
  end;

  private.opened_count[ private.stage ] = 0;

end;
--*********************************************************************************************************************
function private.EnterPart ( num )

  private.CustomCursorShow();
  if ( num > 1 ) then    
    if ( ObjGet( "spr_darkness_rpl_symbol_"..private.stage.."_hide_"..(num - 1) ).alp < 1 )and
       ( ObjGet( "spr_darkness_rpl_symbol_"..private.stage.."_hide_"..num ).alp == 1 ) then
      ObjStopAnimate( "spr_darkness_rpl_symbol_"..private.stage.."_start", "alp" );
      ObjSet(  "spr_darkness_rpl_symbol_"..private.stage.."_start", { alp = 0 } );
      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_darkness_one_pattern" );
      ObjAnimate( "spr_darkness_rpl_symbol_"..private.stage.."_hide_"..num, "alp", 0, 0, 
      function()
        private.opened_count[ private.stage ] = num;       
        if ( num == private.hidden_count[ private.stage ] ) then
          private.CheckWin();
        else
          ng_global.progress[ "rpl" ][ "win_darkness_rpl" ].opened_count[ private.stage ] = num;
        end;
      end, 
      {
        0.0,0,1,
        0.2,0,0
      } );
    end;
  else
    ObjSet( "spr_darkness_rpl_symbol_"..private.stage.."_hide_1", { alp = 0 } );
  end;

end;
--*********************************************************************************************************************
function private.LeavePart ( num )

  private.CustomCursorHide();

end;
--*********************************************************************************************************************
function private.CustomCursorShow ()

  local pos = GetZoomCursorPos();
  local pcx = pos[1];
  local pcy = pos[2];

  cmn.SetCursor( CURSOR_NULL );
  ObjSet( "anm_darkness_rpl_cursor", { pos_x = pcx + 22, pos_y = pcy + 20, alp = 1 } );

  ObjSet( "tmr_darkness_rpl_cursor", { playing = 1, time = 0.01, endtrig = function () private.CustomCursorShow(); end } );

end;
--*********************************************************************************************************************
function private.CustomCursorHide ()

  cmn.SetCursor(CURSOR_DEFAULT);
  ObjSet( "tmr_darkness_rpl_cursor", { playing = false } ); 
  ObjSet( "anm_darkness_rpl_cursor", { alp = 0 } );

end;
--*********************************************************************************************************************
function private.CheckWin ()

  if ( private.stage == 1 ) then

    private.ChangeSymbol();

  elseif ( private.stage == 2 ) then

    private.Win();   

  end;

end;
--*********************************************************************************************************************
function private.ChangeSymbol ()

  local func_end = function ()

    int.Lock( false );

    ObjSet( "anm_darkness_rpl_atropos_right_hand_throw", { alp = 0, playing = false } );
    ObjSet( "anm_darkness_rpl_atropos_right_hand_big", { alp = 1, playing = true } );
    ObjSet( "obj_darkness_rpl_symdol_2", { alp = 1, input = true } );
    ObjSet( "obj_darkness_rpl_symdol_1", { input = false } );

    private.stage = 2;
    ng_global.progress[ "rpl" ][ "win_darkness_rpl" ].stage = private.stage;

    private.Anims();

  end;
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_darkness_miniwin" );
  ObjStopAnimate( "spr_darkness_rpl_symbol_1_over", "alp" );
  ObjAnimate("obj_darkness_rpl_symdol_1", "alp", 0, 0, 
  function ()
    ObjSet( "anm_darkness_rpl_atropos_right_hand_throw", { alp = 1 } );
    ObjSet( "anm_darkness_rpl_atropos_right_hand", { alp = 0, playing = false } );
    AnimPlay( "anm_darkness_rpl_atropos_right_hand_throw", "DoAnim", func_end );
    ObjAnimate("obj_darkness_rpl_symdol_2", "alp", 0, 0, "", 
    {
      0.0,0,0,
      0.9,0,0,
      1.2,0,1
    });
  end, 
  {
    0.0,0,1,
    0.3,0,0
  });

end;
--*********************************************************************************************************************
function private.Anims ()

  local obj= "";
  local obj_start = "";
  if private.stage == 1 then
    obj = "spr_darkness_rpl_symbol_1_over";
    obj_start = "spr_darkness_rpl_symbol_1_start";
  elseif private.stage == 2 then
    obj = "spr_darkness_rpl_symbol_2_over";
    obj_start = "spr_darkness_rpl_symbol_2_start";
  end;

  ObjAnimate( obj, "alp", 1, 0, "", 
  {
    0.0,0,0,
    3.0,0,0,
    3.6,0,0.3,
    4.2,0,0,
    10.0,0,0
  });
  if ( private.opened_count[ private.stage ] < 2 ) then
    ObjAnimate(obj_start, "alp", 1, 0, "", 
    {
      0.0,0,0,
      0.7,0,0,
      1.0,0,1,
      1.2,0,1,
      1.5,0,0,
      1.8,0,0
    });
  end;
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************