-- name=mg_lulling_rpl
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_lulling_rpl";
  game.relations[ "mg_lulling_rpl" ].exitroom = "rm_replayroom";
  
  private.smbl_pairs = {
    {4,9,6,1,7,3,5,10,2,8},
    {4,5,9,1,2,8,10,6,3,7}
  };

  private.state = {
    {
      {0,0,0,0,0,0,0,0,0,0},
      {0,0,0,0},
    },{
      {0,0,0,0,0,0,0,0,0,0},
      {0,0,0,0}
    }
  };

  private.stage = {1,1};

  private.prev = 0;

  for st=1, 2 do
    for n=1, 10 do
      ObjSet("spr_lulling_rpl_thorn_"..st.."_"..n, {
        input = true,
        inputrect_init = true,
        inputrect_x = -25,
        inputrect_y = -25,
        inputrect_w = 50,
        inputrect_h = 50,
        event_menter = function () cmn.SetCursor(CURSOR_HAND); end,
        event_mleave = function () cmn.SetCursor(CURSOR_DEFAULT); end,
        event_mdown = function () private.ClkThorn( n ); end
      });
    end;
  end;
  for st=1, 2 do
    for n=1, 8 do
      ObjSet("spr_lulling_rpl_stamp_"..st.."_"..n, {
        input = true,
        inputrect_init = true,
        inputrect_x = -25,
        inputrect_y = -25,
        inputrect_w = 50,
        inputrect_h = 50,
        event_menter = function () cmn.SetCursor(CURSOR_HAND); end,
        event_mleave = function () cmn.SetCursor(CURSOR_DEFAULT); end,
        event_mdown = function () private.ClkStamp( n ); end
      });
    end;
  end;

  --------------------------------------------------------------------------------------------
  -- function win_lulling_rpl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_lulling_rpl" ] =
  {
    type = "click",
    get_obj = "spr_lulling_rpl_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_lulling_rpl = function ()

    if ( cmn.IsEventStart( "win_lulling_rpl" ) ) and not ( cmn.IsEventDone( "win_lulling_rpl" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_lulling_rpl", win_lulling_rpl, private.room_objname );
  
end;
--*********************************************************************************************************************
function private.Start ()

  ng_global.progress[ "rpl" ][ "win_lulling_rpl" ].state = {
    {
      {0,0,0,0,0,0,0,0,0,0},
      {0,0,0,0},
    },{
      {0,0,0,0,0,0,0,0,0,0},
      {0,0,0,0}
    }
  };

  ng_global.progress[ "rpl" ][ "win_lulling_rpl" ].stage = {1,1};

  cmn.MiniGameShow( "lulling_rpl" );

  ObjSet( "obj_lulling_rpl_mg_1_1", { input = true } );

end; 
--*********************************************************************************************************************
function private.Load ()

  private.stage[1] = ng_global.progress[ "rpl" ][ "win_lulling_rpl" ].stage[1];
  private.stage[2] = ng_global.progress[ "rpl" ][ "win_lulling_rpl" ].stage[2];

  for st1=1, 2 do
    for st2 =1, 2 do
      for i=1, #private.state[ st1 ][ st2 ] do
        private.state[ st1 ][ st2 ][ i ] = ng_global.progress[ "rpl" ][ "win_lulling_rpl" ].state[ st1 ][ st2 ][ i ];
        if ( st2 == 1 ) and ( private.state[ st1 ][ st2 ][ i ] == 1 ) then
          ObjSet( "spr_lulling_rpl_thorn_"..st1.."_"..i, { alp = 0, input = false } );
        elseif ( st2 == 2 ) and ( private.state[ st1 ][ st2 ][ i ] == 1 ) then
          ObjSet( "spr_lulling_rpl_stamp_"..st1.."_"..i, { input = false } );
          ObjSet( "spr_lulling_rpl_stamp_"..st1.."_"..i.."_select", { alp = 1 } );
        end;
      end;
    end;
  end;

  if ( private.stage[1] == 1 and private.stage[2] == 1 ) then
    ObjSet( "obj_lulling_rpl_mg_1_1", { input = true } );
  elseif ( private.stage[1] == 1 and private.stage[2] == 2 ) then
    ObjSet( "obj_lulling_rpl_mg_1_1", { input = false, alp = 0 } );
    ObjSet( "obj_lulling_rpl_mg_1_2", { input = true, alp = 1 } );
    ObjSet( "anm_lulling_rpl_evil_symbol_1", { alp = 1 } );
  elseif ( private.stage[1] == 2 and private.stage[2] == 1 ) then
    ObjSet( "obj_lulling_rpl_mg_1_2", { input = false } );
    ObjSet( "obj_lulling_rpl_mg_2_1", { input = true, alp = 1 } );
    ObjSet( "anm_lulling_rpl_evil_head_1", { alp = 0 } );
    ObjSet( "anm_lulling_rpl_sleep_head_1", { alp = 1 } );
  elseif ( private.stage[1] == 2 and private.stage[2] == 2 ) then
    ObjSet( "obj_lulling_rpl_mg_2_1", { input = false, alp = 0 } );
    ObjSet( "obj_lulling_rpl_mg_2_2", { input = true, alp = 1 } );
    ObjSet( "anm_lulling_rpl_evil_symbol_2", { alp = 1 } );
  end;

end;
--*********************************************************************************************************************
function public.PreOpen () 
  
  cmn.CallEventHandler( "win_lulling_rpl" ); 

  if cmn.IsEventDone( "win_lulling_rpl" ) then
    public.Reset();
    ng_global.progress[ "rpl" ][ "win_lulling_rpl" ].start = 0;
    ng_global.progress[ "rpl" ][ "win_lulling_rpl" ].done = 0;
  end;
  
  cmn.StopAllMus();
  cmn.PlayAudio( "mus", "audio/aud_amnesia_theme_mus", 1 );  

end;
--*********************************************************************************************************************
function public.Open () 

  if not ( cmn.IsEventStart( "win_lulling_rpl" ) ) then    
    private.Start();
  elseif cmn.IsEventStart( "win_lulling_rpl" ) then
    cmn.MiniGameShow( "lulling_rpl" );
  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  if ( cmn.IsEventStart( "win_lulling_rpl" ) and not cmn.IsEventDone( "win_lulling_rpl" ) ) then
    cmn.MiniGameHide();
  end;

end;
--*********************************************************************************************************************
function public.Reset ()

  private.state = {
    {
      {0,0,0,0,0,0,0,0,0,0},
      {0,0,0,0},
    },{
      {0,0,0,0,0,0,0,0,0,0},
      {0,0,0,0}
    }
  };
  ng_global.progress[ "rpl" ][ "win_lulling_rpl" ].state = {
    {
      {0,0,0,0,0,0,0,0,0,0},
      {0,0,0,0},
    },{
      {0,0,0,0,0,0,0,0,0,0},
      {0,0,0,0}
    }
  };
  
  private.prev = 0;

  private.stage = {1,1};
  ng_global.progress[ "rpl" ][ "win_lulling_rpl" ].stage = {1,1};

  for st=1, 2 do
    for n=1, 10 do
      ObjSet("spr_lulling_rpl_thorn_"..st.."_"..n, { input = true, alp = 1 });
      --ObjSet("spr_lulling_rpl_symbol_"..st.."_"..n, { alp = 0 });
    end;
  end;
  for st=1, 2 do
    for n=1, 8 do
      ObjSet("spr_lulling_rpl_stamp_"..st.."_"..n, { input = true, alp = 1 });
      ObjSet("spr_lulling_rpl_stamp_"..st.."_"..n.."_select", { alp = 0 });
    end;
  end;

  ObjMultiSet( {
    { "obj_lulling_rpl_mg_1_1", { input = true, alp = 1 } },
    { "obj_lulling_rpl_mg_1_2", { input = false, alp = 0 } },
    { "obj_lulling_rpl_mg_2_1", { input = false, alp = 1 } },
    { "obj_lulling_rpl_mg_2_2", { input = false, alp = 0 } },
    { "anm_lulling_rpl_evil_head_1", { alp = 1 } },
    { "anm_lulling_rpl_evil_head_2", { alp = 1 } },
    { "anm_lulling_rpl_evil_symbol_1", { alp = 0 } },
    { "anm_lulling_rpl_evil_symbol_2", { alp = 0 } },
    { "anm_lulling_rpl_sleep_head_1", { alp = 0 } },
    { "anm_lulling_rpl_sleep_head_2", { alp = 0 } },
  } );


end;
--*********************************************************************************************************************
function public.Skip ()

  ObjMultiSet( {
    { "obj_lulling_rpl_mg_1_1", { input = false, alp = 0 } },
    { "obj_lulling_rpl_mg_1_2", { input = false, alp = 0 } },
    { "obj_lulling_rpl_mg_2_1", { input = false, alp = 0 } },
    { "obj_lulling_rpl_mg_2_2", { input = false, alp = 0 } },
    { "anm_lulling_rpl_evil_head_1", { alp = 0 } },
    { "anm_lulling_rpl_evil_head_2", { alp = 0 } },
    { "anm_lulling_rpl_sleep_head_1", { alp = 1 } },
    { "anm_lulling_rpl_sleep_head_2", { alp = 1 } },
  } );

  private.Win();

end;
--*********************************************************************************************************************
function private.WinEnd ()

  cmn.MiniGameHide();

  cmn.SetEventDone( "win_lulling_rpl" );
  cmn.CallEventHandler( "win_lulling_rpl" );
  
  cmn.GotoRoom( "rm_replayroom" );

end;
--*********************************************************************************************************************
function private.Win ()

  private.WinEnd();

end;
--*********************************************************************************************************************
function private.ClkThorn ( num )

  local func_end = function ()

    if ( private.prev == 0 ) then

      private.prev = num;
      ObjSet( "spr_lulling_rpl_thorn_"..private.stage[ 1 ].."_"..num, { input = false } );
      int.Lock( false );

    else

      local func_end_1 = function ()

        if ( private.smbl_pairs[ private.stage[ 1 ] ][ private.prev ] == num ) then 
          cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_wrightsigns" );
          ObjSet( "spr_lulling_rpl_thorn_"..private.stage[ 1 ].."_"..num, { input = false } );
          ObjSet("spr_lulling_rpl_thorn_"..private.stage[ 1 ].."_"..private.prev, { input = false } );
          private.state[ private.stage[ 1 ] ][ private.stage[ 2 ] ][ num ] = 1;
          private.state[ private.stage[ 1 ] ][ private.stage[ 2 ] ][ private.prev ] = 1;
          private.prev = 0;
          int.Lock( false );
          private.CheckWin();
        else
          cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_nosigns" );
          ObjAnimate("spr_lulling_rpl_thorn_"..private.stage[ 1 ].."_"..num, "alp", 0, 0, 
          function ()
            int.Lock( false );
            ObjSet( "spr_lulling_rpl_thorn_"..private.stage[ 1 ].."_"..num, { input = true } );
            ObjSet( "spr_lulling_rpl_thorn_"..private.stage[ 1 ].."_"..private.prev, { input = true } );
            private.prev = 0;
          end, 
          {
            0.0,0,0,
            0.3,0,1
          });
          ObjAnimate("spr_lulling_rpl_thorn_"..private.stage[ 1 ].."_"..private.prev, "alp", 0, 0, "", 
          {
            0.0,0,0,
            0.3,0,1
          });
        end;        

      end;

      ObjAnimate("spr_lulling_rpl_symbol_"..private.stage[ 1 ].."_"..num, "alp", 0, 0, "", 
      {
        0.0,0,1,
        0.3,0,0
      });
      ObjAnimate("spr_lulling_rpl_symbol_"..private.stage[ 1 ].."_"..private.prev, "alp", 0, 0, func_end_1, 
      {
        0.0,0,1,
        0.3,0,0
      });      

    end;

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_clk_sign" );

  ObjAnimate("spr_lulling_rpl_thorn_"..private.stage[ 1 ].."_"..num, "alp", 0, 0, "", 
  {
    0.0,0,1,
    0.3,0,0
  });
  ObjAnimate("spr_lulling_rpl_symbol_"..private.stage[ 1 ].."_"..num, "alp", 0, 0, func_end, 
  {
    0.0,0,0,
    0.3,0,1
  });

end;
--*********************************************************************************************************************
function private.ClkStamp ( num )
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_clk_sign" );

  if ( num >= 1 and num <= 4 ) then

    local func_end = function ()
            
      ObjSet( "spr_lulling_rpl_stamp_"..private.stage[ 1 ].."_"..num, { input = false } );
      private.state[ private.stage[ 1 ] ][ private.stage[ 2 ] ][ num ] = 1;
      private.CheckWin();

    end;

    int.Lock( true );

    ObjAnimate("spr_lulling_rpl_stamp_"..private.stage[ 1 ].."_"..num.."_select", "alp", 0, 0, func_end, 
    {
      0.0,0,0,
      0.3,0,1
    });

  else

    int.Lock( true );
     
    ObjMultiSet( {
      { "anm_lulling_rpl_body_agressive", { alp = 1 } },
      { "anm_lulling_rpl_body", { alp = 0 } },
      { "anm_lulling_rpl_agr_head_1", { alp = 1 } },
      { "anm_lulling_rpl_agr_head_2", { alp = 1 } },      
      { "anm_lulling_rpl_evil_head_1", { alp = 0 } },
      { "anm_lulling_rpl_evil_head_2", { alp = 0 } },
      { "anm_lulling_rpl_sleep_head_1", { alp = 0 } },
      { "anm_lulling_rpl_sleep_head_2", { alp = 0 } }, 
    } ); 
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_evil_dogs" );
  
    AnimPlay( "anm_lulling_rpl_body_agressive", "DoAnim", "" );
    AnimPlay( "anm_lulling_rpl_agr_head_1", "DoAnim", "" );
    AnimPlay( "anm_lulling_rpl_agr_head_2", "DoAnim", 
    function ()
      int.Lock( false );
      ObjMultiSet( {
        { "anm_lulling_rpl_body_agressive", { alp = 0 } },
        { "anm_lulling_rpl_body", { alp = 1, frame = 0 } },
        { "anm_lulling_rpl_agr_head_1", { alp = 0 } },
        { "anm_lulling_rpl_agr_head_2", { alp = 0 } },        
      } );      
      public.Reset();
      
    end );
    
  end;
  
end;
--*********************************************************************************************************************
function private.CheckWin ()

  local func_end = function ()

    int.Lock( false );
    ng_global.progress[ "rpl" ][ "win_lulling_rpl" ].stage[1] = private.stage[1];
    ng_global.progress[ "rpl" ][ "win_lulling_rpl" ].stage[2] = private.stage[2];
    for st1=1, 2 do
      for st2 =1, 2 do
        for i=1, #private.state[ st1 ][ st2 ] do
          ng_global.progress[ "rpl" ][ "win_lulling_rpl" ].state[ st1 ][ st2 ][ i ] = private.state[ st1 ][ st2 ][ i ];
        end;
      end;
    end;

  end;

  local to_next = true;

  for i=1, #private.state[ private.stage[ 1 ] ][ private.stage[ 2 ] ] do
    if ( private.state[ private.stage[ 1 ] ][ private.stage[ 2 ] ][ i ] == 0 ) then
      to_next = false;
    end;
  end;

  if (to_next) then

    if ( private.stage[1] == 1 and private.stage[2] == 1 ) then
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_signondog" );

      private.stage = {1,2};
      ObjSet( "obj_lulling_rpl_mg_1_1", { input = false } );
      ObjSet( "obj_lulling_rpl_mg_1_2", { input = true } );
      ObjAnimate("obj_lulling_rpl_mg_1_1", "alp", 0, 0, "", 
      {
        0.0,0,1,
        0.3,0,0
      });
      ObjAnimate("obj_lulling_rpl_mg_1_2", "alp", 0, 0, "", 
      {
        0.0,0,0,
        0.3,0,1
      });
      ObjAnimate("anm_lulling_rpl_evil_symbol_1", "alp", 0, 0, func_end, 
      {
        0.0,0,0,
        0.3,0,1
      });

    elseif ( private.stage[1] == 1 and private.stage[2] == 2 ) then

      private.stage = {2,1};
      ObjSet( "obj_lulling_rpl_mg_1_2", { input = false } );
      ObjSet( "obj_lulling_rpl_mg_2_1", { input = true } );
      ObjAnimate("obj_lulling_rpl_mg_1_2", "alp", 0, 0, "", 
      {
        0.0,0,1,
        0.3,0,0
      });
      ObjAnimate("anm_lulling_rpl_evil_symbol_1", "alp", 0, 0, "", 
      {
        0.6,0,1,
        1.0,0,0
      });
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_flute2" );
      
      AnimPlay( "anm_lulling_rpl_flute", "DoAnim", 
        function ()
          ObjSet( "anm_lulling_rpl_flute", { frame = 0 } );
          ObjSet( "anm_lulling_rpl_evil_head_1", { alp = 0 } );
          ObjSet( "anm_lulling_rpl_lulling_head_1", { alp = 1 } );
          AnimPlay( "anm_lulling_rpl_lulling_head_1", "DoAnim", 
          function ()
            ObjSet( "anm_lulling_rpl_lulling_head_1", { alp = 0, frame = 0 } );
            ObjSet( "anm_lulling_rpl_sleep_head_1", { alp = 1, frame = 0 } );
            func_end();
          end );
       end );            

    elseif ( private.stage[1] == 2 and private.stage[2] == 1 ) then
        
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_signondog" );        

      private.stage = {2,2};
      ObjSet( "obj_lulling_rpl_mg_2_1", { input = false } );
      ObjSet( "obj_lulling_rpl_mg_2_2", { input = true } );
      ObjAnimate("obj_lulling_rpl_mg_2_1", "alp", 0, 0, "", 
      {
        0.0,0,1,
        0.3,0,0
      });
      ObjAnimate("obj_lulling_rpl_mg_2_2", "alp", 0, 0, "", 
      {
        0.0,0,0,
        0.3,0,1
      });
      ObjAnimate("anm_lulling_rpl_evil_symbol_2", "alp", 0, 0, func_end, 
      {
        0.0,0,0,
        0.3,0,1
      });

    elseif ( private.stage[1] == 2 and private.stage[2] == 2 ) then
      
      ObjAnimate("obj_lulling_rpl_mg_2_2", "alp", 0, 0, "", 
      {
        0.0,0,1,
        0.3,0,0
      });
      ObjAnimate("anm_lulling_rpl_evil_symbol_2", "alp", 0, 0, "", 
      {
        0.6,0,1,
        1.0,0,0
      });
      
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_flute2" );
      
      AnimPlay( "anm_lulling_rpl_flute", "DoAnim", 
        function ()
          ObjSet( "anm_lulling_rpl_flute", { frame = 0 } );
          ObjSet( "anm_lulling_rpl_evil_head_2", { alp = 0 } );
          ObjSet( "anm_lulling_rpl_lulling_head_2", { alp = 1 } );
          AnimPlay( "anm_lulling_rpl_lulling_head_2", "DoAnim", 
          function ()
            ObjSet( "anm_lulling_rpl_lulling_head_2", { alp = 0, frame = 0 } );
            ObjSet( "anm_lulling_rpl_sleep_head_2", { alp = 1, frame = 0 } );
            private.Win();
          end );
       end );  

    end;

  else
 
    func_end();

  end;  

end;
--*********************************************************************************************************************