-- name=mg_mgboxes_rpl
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_mgboxes_rpl";

  game.relations[ "mg_mgboxes_rpl" ].exitroom = "rm_replayroom";

  private.Init();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_mgboxes_rpl = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;

      local mas_parent_gfx = 
      {
        private.room_objname
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_mgboxes_rpl", update_game_mode_mgboxes_rpl, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_mgboxes_rpl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_mgboxes_rpl" ] =
  {
    type = "click",
    get_obj = "spr_mgboxes_rpl_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_mgboxes_rpl = function ()

    if ( cmn.IsEventStart( "win_mgboxes_rpl" ) ) and not ( cmn.IsEventDone( "win_mgboxes_rpl" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_mgboxes_rpl", win_mgboxes_rpl, private.room_objname );  

end;

--*********************************************************************************************************************
function private.Load ()

  for e = 1, private.count_evt do

    local idx = ng_global.progress[ "rpl" ][ "win_mgboxes_rpl" ].event[ e ];

    local event = "spr_mgboxes_rpl_event_"..e;

    if ( idx ~= 0 ) then

      ObjSet( event, { alp = 1, res = "assets/levels/level1/mg_mgboxes/layers/arrow_"..idx } );

    end;

  end;

end;
--*********************************************************************************************************************
function public.PreOpen () 
  
  cmn.CallEventHandler( "win_mgboxes_rpl" );
  
  if cmn.IsEventDone( "win_mgboxes_rpl" ) then
    ObjSet( "obj_mgboxes_rpl_arm_base", { pos_y = 360 } );
    ObjSet( "obj_mgboxes_rpl_arm_wrist", { pos_x = 216 } );
    ObjSet( "spr_mgboxes_rpl_arm_tube", { pos_x = -276, croprect_w = 217 } );
    ObjSet( "spr_mgboxes_rpl_arm_manipulator_1", { ang = 0.3 } );
    ObjSet( "spr_mgboxes_rpl_arm_manipulator_2", { ang = -0.3 } );
    for i=1, 12 do
      ObjSet( "spr_mgboxes_rpl_event_light_"..i, { alp = 0 } );
    end;
    public.Reset();
    ng_global.progress[ "rpl" ][ "win_mgboxes_rpl" ].start = 0;
    ng_global.progress[ "rpl" ][ "win_mgboxes_rpl" ].done = 0;
  end;

  cmn.StopAllMus();
  cmn.PlayAudio( "mus", "audio/aud_amnesia_theme_mus", 1 );

end;
--*********************************************************************************************************************
function public.Open () 

  if not ( cmn.IsEventStart( "win_mgboxes_rpl" ) ) then    
    private.Start();
  elseif cmn.IsEventStart( "win_mgboxes_rpl" ) then
    cmn.MiniGameShow( "mgboxes_rpl" );
  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  cmn.MiniGameHide();
  --common_impl.PassingMgWin( "mgboxes_rpl" );

end;
--*********************************************************************************************************************
function private.Init ()

  private.count_row = 7;
  private.count_col = 8;
  private.count_btn = 8;
  private.count_evt = 12;
  private.count_set = 0;

  private.box_pos = { { 605, 2 }, { 677, 2 }, { 750, 2 }, { 822, 2 } };
  private.times   = { 3, 1, 0, 3, 2, 0, 2, 0, 2, 1, 1, 0 };
  private.arm     = { 6, 4 };

  private.lamp = 0;
  private.tick = 0;
  private.cur_event = 1;

  private.field =
  {
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 1, 0, 0, 0 },
    { 0, 1, 0, 1, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 1, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
  };  

  ObjSet( "spr_mgboxes_rpl_play",
  {
    event_menter = function ()

      cmn.SetCursor( CURSOR_HAND );

    end,
    event_mleave = function ()

      cmn.SetCursor( CURSOR_DEFAULT );

    end,
    event_mdown = function ()

      private.ButtonPlay();

    end,
  } );

  for b = 1, private.count_btn do

    ObjSet( "spr_mgboxes_rpl_btn_arrow_"..b,
    {
      event_startdrag = function ()

        ObjAttach( "spr_mgboxes_rpl_btn_arrow_"..b, "obj_mgboxes_rpl_hub" );

        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_take_arrow" );

      end,
      event_menter = function ()

        cmn.SetCursor( CURSOR_HAND );

      end,
      event_mleave = function ()

        cmn.SetCursor( CURSOR_DEFAULT );

      end,
      event_dragdrop = function ()

        private.ButtonDrop( b );
        ObjAttach( "spr_mgboxes_rpl_btn_arrow_"..b, "obj_mgboxes_rpl_btn_arrows" );

        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_app_arrow" );

      end,
    } );

  end;

end;
--*********************************************************************************************************************
function private.Start ()

  ng_global.progress[ "rpl" ][ "win_mgboxes_rpl" ].event = { 0, 0, 9, 0, 0, 9, 0, 9, 0, 0, 0, 9 };

  cmn.MiniGameShow( "mgboxes_rpl" );  

end;
--*********************************************************************************************************************
function public.Reset ()

  int.Lock( true );

  local func_end = function ()

    private.arm  = { 6, 4 };
    private.lamp = 0;
    private.tick = 0;
    private.cur_event = 1;

    private.field =
    {
      { 0, 0, 0, 0, 0, 0, 0, 0 },
      { 0, 0, 0, 0, 1, 0, 0, 0 },
      { 0, 1, 0, 1, 0, 0, 0, 0 },
      { 0, 0, 0, 0, 0, 0, 0, 0 },
      { 0, 0, 0, 0, 0, 0, 1, 0 },
      { 0, 0, 0, 0, 0, 0, 0, 0 },
      { 0, 0, 0, 0, 0, 0, 0, 0 },
    };  

    ng_global.progress[ "rpl" ][ "win_mgboxes_rpl" ].event = { 0, 0, 9, 0, 0, 9, 0, 9, 0, 0, 0, 9 };

  end;

  for b = 1, 12 do

    if ( private.times[ b ] ~= 0 ) then

      ObjAnimate( "spr_mgboxes_rpl_event_"..b, "alp", 0, 0, "", 
      {
        0.0, 3, ObjGet( "spr_mgboxes_rpl_event_"..b ).alp,
        0.3, 3, 0.0,
      } );

    end;

  end;

  ObjSet( "tmr_mgboxes_rpl_timer",
  { 
    endtrig = function ()

      int.Lock( false );

      func_end();

    end,
    time    = 0.3,
    playing = true,
  } );
  
  ObjSet( "obj_mgboxes_rpl_safe_open", { alp = 0 } );
  
  local boxes = { "2_5", "3_2", "3_4", "5_7" };
  for b = 1, 4 do
    ObjSet( "spr_mgboxes_rpl_box_"..boxes[ b ], { alp = 1 } );
    ObjSet( "spr_mgboxes_rpl_box_"..b, { alp = 0 } );
    ObjSet( "spr_mgboxes_rpl_safe_light_"..b, { alp = 0 });
  end;

end;
--*********************************************************************************************************************
function public.Skip ()

  local boxes = { "2_5", "3_2", "3_4", "5_7" };
  local tme = 0.3;

  for b = 1, 4 do

    ObjAnimate( "spr_mgboxes_rpl_box_"..boxes[ b ], "alp", 0, 0, "", 
    {
      0.0,           0, 1.0,
      0.0 + tme * b, 0, 1.0,
      0.3 + tme * b, 0, 0.0,
    } );

    ObjAnimate( "spr_mgboxes_rpl_box_"..b, "alp", 0, 0, "", 
    {
      0.0,           0, 0.0,
      0.0 + tme * b, 0, 0.0,
      0.3 + tme * b, 0, 1.0,
    } );

    ObjAnimate( "spr_mgboxes_rpl_safe_light_"..b, "alp", 0, 0, "", 
    {
      0.0,           0, 0.0,
      0.0 + tme * b, 0, 0.0,
      0.3 + tme * b, 0, 1.0,
    } );

  end;

  ObjAnimate( "obj_mgboxes_rpl_safe_open", "alp", 0, 0,
  function ()

    private.Win();

  end, 
  {
    0.0, 3, 0.0,
    1.7, 3, 0.0,
    2.0, 3, 1.0,
  } );    

end;
--*********************************************************************************************************************
function private.Win ()

  cmn.MiniGameHide();
  
  cmn.SetEventDone( "win_mgboxes_rpl" );
  cmn.CallEventHandler( "win_mgboxes_rpl" );
  
  cmn.GotoRoom( "rm_replayroom" );

end;
--*********************************************************************************************************************
function private.ButtonDrop ( idx )

  local button = "spr_mgboxes_rpl_btn_arrow_"..idx;

  for e = 1, private.count_evt do

    local event = "spr_mgboxes_rpl_event_"..e;

    if ( ApplyObj( button, event ) ) then

      ng_global.progress[ "rpl" ][ "win_mgboxes_rpl" ].event[ e ] = idx;

      ObjSet( event, { alp = 1, res = "assets/levels/level1/mg_mgboxes/layers/arrow_"..idx } );

      return;

    end;

  end;

end;
--*********************************************************************************************************************
function private.ButtonPlay ()

  private.steps = {};
  local directions = { { "right" }, { "right", "down" }, { "down" }, { "left", "down" }, { "left" }, { "left", "up" }, { "up" }, { "right", "up" } };

  local is_deadline = false;

  ObjAnimate( "spr_mgboxes_rpl_play", "alp", 0, 0, "", 
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

  for t = 1, private.count_evt do

    local times = private.times[ t ];

    if ( times == 0 ) then

      table.insert( private.steps, "action" );

    else

      for s = 1, times do

        local dir = ng_global.progress[ "rpl" ][ "win_mgboxes_rpl" ].event[ t ];

        if ( dir == 0 ) then

          is_deadline = true;
          break;

        end;

        for d = 1, #directions[ dir ] do

          table.insert( private.steps, directions[ dir ][ d ] );

        end;

      end;

    end;

    if ( is_deadline ) then

      break;

    end;

  end;

  private.lamp = 1;

  private.NextStep();

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_play" );

end;
--*********************************************************************************************************************
function private.NextStep ()  

  if ( not private.steps ) or ( #private.steps == 0 ) then

    private.Restart();

    return;

  end;

  if ( ( private.tick == private.times[ private.cur_event ] ) or ( private.times[ private.cur_event ] == 0 ) ) then

    private.tick = 0;
    private.lamp = private.cur_event + 1;
    private.cur_event = private.cur_event + 1;

  end;

  private.tick = private.tick + 1;

  if ( private.lamp ) then

    ObjAnimate( "spr_mgboxes_rpl_event_light_"..private.lamp, "alp", 0, 0, "", 
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

  end;

  private.lamp = nil;

  local step = private.steps[ 1 ];

  table.remove( private.steps, 1 );

  if ( step == "action" ) then

    private.StepAction();

  else

    private.StepMove( step );

  end;

end;
--*********************************************************************************************************************
function private.StepMove ( direction )

  local pos = private.GetArmPos( direction );

  if ( not pos ) then

    private.Restart();

    return;

  end;

  local func_end = function ()

    int.Lock( false );
    private.NextStep();

  end;

  int.Lock( true );

  if ( ( direction == "left" ) or ( direction == "right" ) ) then

    ObjAnimate( "obj_mgboxes_rpl_arm_wrist", "pos_x", 0, 0, func_end, 
    {
      0.0, 0, pos[ 1 ],
      0.5, 0, pos[ 3 ],
    } );

    ObjAnimate( "spr_mgboxes_rpl_arm_tube", "pos_x", 0, 0, "", 
    {
      0.0, 0, -pos[ 1 ] - 60,
      0.5, 0, -pos[ 3 ] - 60,
    } );

    ObjAnimate( "spr_mgboxes_rpl_arm_tube", "croprect_w", 0, 0, "", 
    {
      0.0, 0, pos[ 1 ] + 1,
      0.5, 0, pos[ 3 ] + 1,
    } );

  else

    ObjAnimate( "obj_mgboxes_rpl_arm_base", "pos_y", 0, 0, func_end, 
    {
      0.0, 0, pos[ 2 ],
      0.5, 0, pos[ 4 ],
    } );

    local delta       = 50;
    local angle_end   = ( pos[ 2 ] - pos[ 4 ] ) / delta;
    local angle_start = ObjGet( "spr_mgboxes_rpl_gear_1" ).ang;

    ObjAnimate( "spr_mgboxes_rpl_gear_1", "ang", 0, 0, "", 
    {
      0.0, 0, angle_start,
      0.5, 0, angle_start + angle_end,
    } );

    ObjAnimate( "spr_mgboxes_rpl_gear_2", "ang", 0, 0, "", 
    {
      0.0, 0, angle_start,
      0.5, 0, angle_start + angle_end,
    } );

  end;

  if ( ( not private.action ) or ( private.action ~= direction ) ) then

    cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_up" );
    cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_down" );
    cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_right" );
    cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_left" );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_"..direction );

    private.action = direction;

  end;

end;
--*********************************************************************************************************************
function private.StepAction ()

  private.action = nil;
  cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_up" );
  cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_down" );
  cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_right" );
  cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_left" );

  if ( private.field[ private.arm[ 1 ] ][ private.arm[ 2 ] ] ~= 1 ) then

    private.Restart();

    return;

  end;

  local func_end = function ()

    int.Lock( false );

    private.field[ private.arm[ 1 ] ][ private.arm[ 2 ] ] = 0;

    if ( private.count_set == 4 ) then

      cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_left" );
      cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_down" );

      private.Win();

    else

      private.NextStep();

    end;

  end;

  int.Lock( true );

  local arm_x_start = ObjGet( "obj_mgboxes_rpl_arm_wrist" ).pos_x;
  local arm_y_start = ObjGet( "obj_mgboxes_rpl_arm_base" ).pos_y;

  private.count_set = private.count_set + 1;

  local arm_x_end = private.box_pos[ private.count_set ][ 1 ];
  local arm_y_end = private.box_pos[ private.count_set ][ 2 ];

  local tme_x = math.abs( arm_x_start - arm_x_end ) / 250;
  local tme_y = math.abs( arm_y_start - arm_y_end ) / 250;

  local tme = tme_x;

  if ( tme < tme_y ) then tme = tme_y end;

  ObjAnimate( "obj_mgboxes_rpl_arm_base", "scale_x", 0, 0,
  function ()

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_right" );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_up" );

  end, 
  {
    0.0,                         0, 1,
    0.3,                         0, 1,
  } );

  ObjAnimate( "obj_mgboxes_rpl_arm_base", "scale_y", 0, 0,
  function ()

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_left" );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_down" );

  end, 
  {
    0.0,                         0, 1,
    0.6 + tme,                   0, 1,
  } );

  ObjAnimate( "obj_mgboxes_rpl_arm_wrist", "scale_x", 0, 0,
  function ()

    if ( private.count_set == 4 ) then

      ObjSet( "obj_mgboxes_rpl_arm", { pos_z = 44 } );

    end;

  end, 
  {
    0.0,                         0, 1,
    0.3,                         0, 1,
    0.3 + tme,                   0, 1,
  } );

  ObjAnimate( "obj_mgboxes_rpl_arm_base", "pos_y", 0, 0, "", 
  {
    0.0,                         0, arm_y_start,
    0.3,                         0, arm_y_start,
    0.3 + tme,                   0, arm_y_end,
    0.6 + tme,                   0, arm_y_end,
    0.6 + tme * 2,               0, arm_y_start,
  } );

  ObjAnimate( "obj_mgboxes_rpl_arm_wrist", "pos_x", 0, 0, func_end, 
  {
    0.0,                         0, arm_x_start,
    0.3,                         0, arm_x_start,
    0.3 + tme,                   0, arm_x_end,
    0.6 + tme,                   0, arm_x_end,
    0.6 + tme * 2,               0, arm_x_start,
  } );

  ObjAnimate( "spr_mgboxes_rpl_arm_tube", "pos_x", 0, 0, "", 
  {
    0.0,                         0, -arm_x_start - 60,
    0.3,                         0, -arm_x_start - 60,
    0.3 + tme,                   0, -arm_x_end - 60,
    0.6 + tme,                   0, -arm_x_end - 60,
    0.6 + tme * 2,               0, -arm_x_start - 60,
  } );

  ObjAnimate( "spr_mgboxes_rpl_arm_tube", "croprect_w", 0, 0, "", 
  {
    0.0,                         0, arm_x_start + 1,
    0.3,                         0, arm_x_start + 1,
    0.3 + tme,                   0, arm_x_end + 1,
    0.6 + tme,                   0, arm_x_end + 1,
    0.6 + tme * 2,               0, arm_x_start + 1,
  } );

  ObjAnimate( "spr_mgboxes_rpl_arm_manipulator_1", "ang", 0, 0, "", 
  {
    0.0,                 3, 0.3,
    0.3,                 3, 0.0,
    0.3 + tme,           3, 0.0,
    0.6 + tme,           3, 0.3,
  } );

  ObjAnimate( "spr_mgboxes_rpl_arm_manipulator_2", "ang", 0, 0, "", 
  {
    0.0,                 3, -0.3,
    0.3,                 3,  0.0,
    0.3 + tme,           3,  0.0,
    0.6 + tme,           3, -0.3,
  } );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_take_box" );

  ObjAnimate( "spr_mgboxes_rpl_arm_manipulator_1", "scale_x", 0, 0,
  function ()

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_leave_box" );
    cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_right" );
    cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_up" );

  end, 
  {
    0.0,                 3, 1.0,
    0.3 + tme,           3, 1.0,
  } );

  ObjAnimate( "spr_mgboxes_rpl_arm_box", "alp", 0, 0, "", 
  {
    0.0,                 0, 0.0,
    0.3,                 0, 1.0,
    0.6 + tme,           0, 1.0,
    0.6 + tme,           0, 0.0,
  } );

  ObjAnimate( "spr_mgboxes_rpl_box_"..private.arm[ 1 ].."_"..private.arm[ 2 ], "alp", 0, 0, "", 
  {
    0.0,                 0, 1.0,
    0.3,                 0, 0.0,
  } );

  ObjAnimate( "spr_mgboxes_rpl_box_"..private.count_set, "alp", 0, 0, "", 
  {
    0.0,                 0, 0.0,
    0.3,                 0, 0.0,
    0.6 + tme,           0, 0.0,
    0.6 + tme,           0, 1.0,
  } );

  ObjAnimate( "spr_mgboxes_rpl_safe_light_"..private.count_set, "alp", 0, 0, "", 
  {
    0.0,                 3, 0.0,
    0.3 + tme,           3, 0.0,
    0.6 + tme,           3, 1.0,
  } );

  if ( private.count_set == 4 ) then

    ObjAnimate( "obj_mgboxes_rpl_safe_open", "alp", 0, 0, "", 
    {
      0.0,                 3, 0.0,
      0.6 + tme,           3, 0.0,
      0.9 + tme,           3, 1.0,
    } );    

    ObjAnimate( "obj_mgboxes_rpl_safe_open", "scale_x", 0, 0,
    function ()

      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_open_case" );

    end, 
    {
      0.0,                 3, 1.0,
      0.6 + tme,           3, 1.0,
    } );    

  end;

  local delta       = 50;
  local angle_end   = ( arm_y_start - arm_y_end ) / delta;
  local angle_start = ObjGet( "spr_mgboxes_rpl_gear_1" ).ang;

  ObjAnimate( "spr_mgboxes_rpl_gear_1", "ang", 0, 0, "", 
  {
    0.0,                         0, angle_start,
    0.3,                         0, angle_start,
    0.3 + tme,                   0, angle_start + angle_end,
    0.6 + tme,                   0, angle_start + angle_end,
    0.6 + tme * 2,               0, angle_start,
  } );

  ObjAnimate( "spr_mgboxes_rpl_gear_2", "ang", 0, 0, "", 
  {
    0.0,                         0, angle_start,
    0.3,                         0, angle_start,
    0.3 + tme,                   0, angle_start + angle_end,
    0.6 + tme,                   0, angle_start + angle_end,
    0.6 + tme * 2,               0, angle_start,
  } );

end;
--*********************************************************************************************************************
function private.GetArmPos ( dir )

  local directions = { [ "up" ] = { -1, 0 }, [ "down" ] = { 1, 0 }, [ "right" ] = { 0, 1 }, [ "left" ] = { 0, -1 } }

  local pos_x_1 = private.arm[ 2 ] * 72 - 72;
  local pos_y_1 = private.arm[ 1 ] * 72 - 72;

  private.arm[ 1 ] = private.arm[ 1 ] + directions[ dir ][ 1 ];
  private.arm[ 2 ] = private.arm[ 2 ] + directions[ dir ][ 2 ];

  if ( ( private.arm[ 1 ] < 1 ) or ( private.arm[ 1 ] > private.count_row ) or
       ( private.arm[ 2 ] < 1 ) or ( private.arm[ 2 ] > private.count_col ) ) then

    return false;

  end;

  local pos_x_2 = private.arm[ 2 ] * 72 - 72;
  local pos_y_2 = private.arm[ 1 ] * 72 - 72;

  return { pos_x_1, pos_y_1, pos_x_2, pos_y_2 };

end;
--*********************************************************************************************************************
function private.Restart ()

  cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_up" );
  cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_down" );
  cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_right" );
  cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_left" );
  private.action = nil;

  int.Lock( true );

  private.arm = { 6, 4 };
  private.count_set = 0;

  private.lamp = 0;
  private.tick = 0;
  private.cur_event = 1;

  private.field =
  {
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 1, 0, 0, 0 },
    { 0, 1, 0, 1, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 1, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0, 0 },
  };  

  local arm_x_start = ObjGet( "obj_mgboxes_rpl_arm_wrist" ).pos_x;
  local arm_y_start = ObjGet( "obj_mgboxes_rpl_arm_base" ).pos_y;

  local arm_x_end = private.arm[ 2 ] * 72 - 72;
  local arm_y_end = private.arm[ 1 ] * 72 - 72;

  local tme_x = math.abs( arm_x_start - arm_x_end ) / 250;
  local tme_y = math.abs( arm_y_start - arm_y_end ) / 250;
  if ( tme_x < tme_y ) then tme_x = tme_y end;

  local delay = tme_x;

  if ( delay < 0.3 ) then delay = 0.3 end;

  ObjAnimate( "obj_mgboxes_rpl_arm_base", "pos_y", 0, 0, "", 
  {
    0.0,         0, arm_y_start,
    0.0 + tme_x, 0, arm_y_end,
  } );

  ObjAnimate( "obj_mgboxes_rpl_arm_wrist", "pos_x", 0, 0, func_end, 
  {
    0.0,         0, arm_x_start,
    0.0 + tme_x, 0, arm_x_end,
  } );

  ObjAnimate( "spr_mgboxes_rpl_arm_tube", "pos_x", 0, 0, "", 
  {
    0.0,         0, -arm_x_start - 60,
    0.0 + tme_x, 0, -arm_x_end   - 60,
  } );

  ObjAnimate( "spr_mgboxes_rpl_arm_tube", "croprect_w", 0, 0, "", 
  {
    0.0,         0, arm_x_start + 1,
    0.0 + tme_x, 0, arm_x_end   + 1,
  } );
  
  local ang_1 = ObjGet( "spr_mgboxes_rpl_arm_manipulator_1" ).ang;
  local ang_2 = ObjGet( "spr_mgboxes_rpl_arm_manipulator_2" ).ang;

  ObjAnimate( "spr_mgboxes_rpl_arm_manipulator_1", "ang", 0, 0, "", 
  {
    0.0, 3, ang_1,
    0.3, 3, 0.3,
  } );

  ObjAnimate( "spr_mgboxes_rpl_arm_manipulator_2", "ang", 0, 0, "", 
  {
    0.0, 3, ang_2,
    0.3, 3, -0.3,
  } );

  local boxes = { "2_5", "3_2", "3_4", "5_7" };

  for b = 1, 4 do

    ObjAnimate( "spr_mgboxes_rpl_box_"..b, "alp", 0, 0, "", 
    {
      0.0, 3, ObjGet( "spr_mgboxes_rpl_box_"..b ).alp,
      0.3, 3, 0.0,
    } );

    ObjAnimate( "spr_mgboxes_rpl_box_"..boxes[ b ], "alp", 0, 0, "", 
    {
      0.0, 3, ObjGet( "spr_mgboxes_rpl_box_"..boxes[ b ] ).alp,
      0.3, 3, 1.0,
    } );

    ObjAnimate( "spr_mgboxes_rpl_safe_light_"..b, "alp", 0, 0, "", 
    {
      0.0, 3, ObjGet( "spr_mgboxes_rpl_safe_light_"..b ).alp,
      0.3, 3, 0.0,
    } );

  end;

  for b = 1, private.count_evt do

    ObjAnimate( "spr_mgboxes_rpl_event_light_"..b, "alp", 0, 0, "", 
    {
      0.0, 3, ObjGet( "spr_mgboxes_rpl_event_light_"..b ).alp,
      0.3, 3, 0.0,
    } );

  end;

  ObjAnimate( "spr_mgboxes_rpl_play", "alp", 0, 0, "", 
  {
    0.0, 3, 1.0,
    0.3, 3, 0.0,
  } );

  ObjSet( "tmr_mgboxes_rpl_timer",
  { 
    endtrig = function ()

      int.Lock( false );

      cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_left" );
      cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_down" );

    end,
    time    = delay,
    playing = true,
  } );

  local delta       = 50;
  local angle_end   = ( arm_y_start - arm_y_end ) / delta;
  local angle_start = ObjGet( "spr_mgboxes_rpl_gear_1" ).ang;

  ObjAnimate( "spr_mgboxes_rpl_gear_1", "ang", 0, 0, "", 
  {
    0.0,         0, angle_start,
    0.0 + tme_x, 0, angle_start + angle_end,
  } );

  ObjAnimate( "spr_mgboxes_rpl_gear_2", "ang", 0, 0, "", 
  {
    0.0,         0, angle_start,
    0.0 + tme_x, 0, angle_start + angle_end,
  } );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_left" );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_boxes_hand_down" );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************