-- name=mg_mgfate_rpl
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_mgfate_rpl";
  game.relations[ "mg_mgfate_rpl" ].exitroom = "rm_replayroom";

  private.Init();  

  --------------------------------------------------------------------------------------------
  -- function win_mgfate_rpl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_mgfate_rpl" ] =
  {
    type = "click",
    get_obj = "spr_mgfate_rpl_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_mgfate_rpl = function ()

    if ( cmn.IsEventStart( "win_mgfate_rpl" ) ) and not ( cmn.IsEventDone( "win_mgfate_rpl" ) ) then

      private.Load ();

    end;

  end;

  --cmn.AddSubscriber( "win_mgfate_rpl", win_mgfate_rpl, private.room_objname );
  cmn.AddSubscriber( "win_mgfate_rpl", win_mgfate_rpl, "rm_replayroom" );

end;

--*********************************************************************************************************************
function private.Init ()

  private.cards =
  {
    { "atropos", "bloody_mary", "crazy_artist", "damned_john", "damned_louise", "father", "kaine",
      "mirror", "obsessively_brandon", "obsessively_jackey", "spirit", "witch", "swamp", "grays_castle", "pension"  },
    { "alex", "brandon", "brandon_young", "elizabeth", "jackey", "jackey_young", "james", "john", "louise", "nat", "castle_mcgrays", "family_house" }
  };

  private.ANGLE_MAX = -0.8;
  private.POSX_MAX = 480;
  private.ANIM_POS_CARDS = { 
    ["atropos"] = { ["start_x"] = -298, ["end_x"] = 0, ["start_y"] = -368, ["end_y"] = 0 }, 
    ["grays"]   = { ["start_x"] = -291, ["end_x"] = 0, ["start_y"] = -380, ["end_y"] = 0 } };
  private.ROUNDS = { 14, 22, 28 };
  private.mode = 2;

  --ObjSet( "obj_mgfate_rpl_library", { 
  --  event_menter = function () private.MouseEnterDeck() end,
  --  event_mleave = function () private.MouseLeaveDeck()end,
  --  event_mdown = function () private.NewCard("grays") end } );

  ObjSet( "obj_mgfate_rpl_timer", { 
    event_menter = function () private.MouseEnterStep() end,
    event_mleave = function () private.MouseLeaveStep()end,
    event_mdown = function () private.EndOfTurn() end } );

  private.LIGHT_START = 231;
  private.LIGHT_HEIGHT = 338;
    
end;  
--*********************************************************************************************************************
function private.Load ()
--DbgTrace( "mgfate_rpl private.Load " );

  local side = { "atropos", "grays" };
  
  for i = 1, #side do

    for j = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side[i] ] do

      private.GenerateCard( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side[i] ][ j ], side[i] );

    end;

  end;

  ObjSet( "spr_mgfate_rpl_progress_bar_stripe", { scale_y = ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].player.progress * ( 1 / private.ROUNDS[ private.mode ] ) } );
  ObjSet( "txt_mgfate_rpl_hp_heart", { text = tostring( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].player.life ) } );
  ObjSet( "spr_mgfate_rpl_progress_bar_add", { pos_y = ( private.LIGHT_START - ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].player.progress * ( private.LIGHT_HEIGHT / private.ROUNDS[ private.mode ] ) ) } );

end;
--*********************************************************************************************************************
function public.PreOpen () 

  if cmn.IsEventDone( "win_mgfate_rpl" ) then      

    local rel = ObjGetRelations( "obj_mgfate_rpl_field_atropos" );
    for i=1, #rel.childs do
      ObjDelete( rel.childs[i] );
    end;
    rel = ObjGetRelations( "obj_mgfate_rpl_field_grays" );
    for i=1, #rel.childs do
      ObjDelete( rel.childs[i] );
    end;  
    rel = ObjGetRelations( "obj_mgfate_rpl_hand_atropos_center" );
    for i=1, #rel.childs do
      ObjDelete( rel.childs[i] );
    end;
    rel = ObjGetRelations( "obj_mgfate_rpl_hand_grays_center" );
    for i=1, #rel.childs do
      ObjDelete( rel.childs[i] );
    end;    
    
    local side = { "atropos", "grays" };
    for i = 1, #side do
      for j = 1, #private.cards[ i ] do              
        ObjDelete( "obj_mgfate_rpl_"..side[i].."_"..private.cards[ i ][ j ] ); 
        ObjDelete( "spr_mgfate_rpl_"..side[i].."_"..private.cards[ i ][ j ] );         
      end;
    end;    
    
    --public.Reset(); 
    
    ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ] = nil;
    ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ] = nil;
    ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "player" ] = nil;
    ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].start = 0;
    ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].done = 0;
    
  end;

  --ObjSet( "int_button_map_impl", { alp = 0, active = false, input = false } );
  --int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventStart( "win_mgfate_rpl" ) ) then

    private.ResetCards();
    private.Load ();

  end;

  for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ] do
    ObjSet( "spr_mgfate_rpl_grays_"..ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][1].."_backcard", { alp = 0 } );
  end;
  
  private.CheckWin();
  
  cmn.StopAllMus();
  cmn.PlayAudio( "mus", "audio/aud_amnesia_theme_mus", 1 );

end;
--*********************************************************************************************************************
function public.Open () 
  
  cmn.StopAllEnv( "audio/level4/env/aud_mgfate_env", true );
  cmn.PlayAudio( "env", "audio/level4/env/aud_mgfate_env", 1 );
  
--DbgTrace( "mgfate_rpl private.Open" );
  if ( not cmn.IsEventDone( "win_mgfate_rpl" ) ) then

    cmn.MiniGameShow( "mgfate_rpl" );

    --for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ] do
    --  ObjSet( "spr_mgfate_rpl_grays_"..ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][1].."_backcard", { alp = 0 } );
    --end;

    private.UnwrapCard( "obj_mgfate_rpl_hand_grays_center" );
    private.UnwrapCard( "obj_mgfate_rpl_hand_atropos_center" );
    private.UnwrapCard( "obj_mgfate_rpl_field_atropos" );
    private.UnwrapCard( "obj_mgfate_rpl_field_grays" );    
    --common_impl.PassingMgStart( "mgfate_rpl" );

  end;

--  if ( not cmn.IsEventDone( "opn_mgfate_rpl" ) ) then
--
--    cmn.SetEventDone( "opn_mgfate_rpl" );
--   
--    cmn.TutorialShow( "tutorial_page_23" );
--    cmn.TutorialSetShown( "tutorial_page_23" );
--
--  end;    

end;
--*********************************************************************************************************************
function public.PreClose ()

  cmn.MiniGameHide();
  --common_impl.PassingMgStop( "mgfate_rpl" );

end;
--*********************************************************************************************************************
function public.Reset ()

  int.Lock( true );

  private.RULES.up_hp = 0;
  private.RULES.down_hp = 0;   
    
  ObjSet( "tmr_mgfate_rpl_turn", { playing = false, endtrig = "" } );
  ObjSet( "tmr_mgfate_rpl_add",  { playing = false, endtrig = "" } );
  
  ObjSet( "obj_mgfate_rpl_big", { input = false, event_mdown = "" } );
  ObjSet( "spr_mgfate_rpl_dark", { alp = 0 });
  ObjSet( "obj_mgfate_rpl_big_card", { scale_x = 1, scale_y = 1 });    
  
  local side = { "atropos", "grays" };

  ObjAttach( "anm_mgfate_rpl_card_appear", "obj_mgfate_rpl_anims" );
  
  for i = 1, #side do

    --for j = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side[i] ] do      
    
    for j = 1, #private.cards[ i ] do              
      ObjDelete( "obj_mgfate_rpl_"..side[i].."_"..private.cards[ i ][ j ] ); 
      ObjDelete( "spr_mgfate_rpl_"..side[i].."_"..private.cards[ i ][ j ] );         
      
      --ObjDelete( "obj_mgfate_rpl_"..side[i].."_"..ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side[i] ][ j ][ 1 ] );        
    end;

  end;

  private.ResetCards();

  ObjSet( "spr_mgfate_rpl_progress_bar_add", { pos_y = 225 + tostring( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].player.progress ) } );

  private.Load ();

  for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ] do
    ObjSet( "spr_mgfate_rpl_grays_"..ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][1].."_backcard", { alp = 0 } );
  end;

  ObjAnimate( "spr_mgfate_rpl_progress_bar_stripe", "scale_y", 0, 0,
  function ()
    
    int.Lock( false );

  end, 
    {
      0.0, 0, ObjGet( "spr_mgfate_rpl_progress_bar_stripe" ).scale_y,
      0.3, 0, 0
    } );

  ObjAnimate( "spr_mgfate_rpl_progress_bar_add", "pos_y", 0, 0, "", 
    {
      0.0, 0, ObjGet( "spr_mgfate_rpl_progress_bar_add" ).pos_y,
      0.3, 0, private.LIGHT_START
    } );

  for i = 1, #side do

    private.UnwrapCard( "obj_mgfate_rpl_hand_"..side[ i ].."_center" );

  end;

end;
--*********************************************************************************************************************
function public.Skip ()

  private.Win();

end;
--*********************************************************************************************************************
function private.WinEnd ()
  
  int.Lock( false );

  cmn.SetEventDone( "win_mgfate_rpl" );
  cmn.CallEventHandler( "win_mgfate_rpl" );

  cmn.GotoRoom( "rm_replayroom" );

end;
--*********************************************************************************************************************
function private.Win ()
  
  --common_impl.PassingMgWin( "mgfate_rpl" );
  cmn.MiniGameHide();
--    
--
--  local func_end = function ()
--    
--    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mgfate_rpl_outro_sfx" );
--    common_impl.PlayDialogVideo( "vid_mgfate_rpl_outro", 
--    function ()
--
--      int.Lock( false );
--
--      cmn.StopAudio( "sfx", "audio/level4/sfx/aud_mgfate_rpl_outro_sfx" );
--      private.WinEnd();
--
--    end );
--    ObjSet( "mg_mgfate_rpl", { color_r = 0, color_g = 0, color_b = 0 } );
--    --cmn.PlayAudio( "sfx", "audio/levelext/sfx/aud_outro" );
--    --cmn.PlayAudio( "voc", "audio/levelext/voc/aud_outro_voc" );
--
--  end;

  int.Lock( true );  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_glasshourbroke" );
  ObjSet( "anm_mgfate_rpl_clock_break", { alp = 1 } );
  AnimPlay( "anm_mgfate_rpl_clock_break", "DoAnim", function () private.WinEnd(); end );    
  --ObjSet( "tmr_mgfate_rpl_vid", { playing = 1, time = 1.5, endtrig = func_end } ); 

end;
--*********************************************************************************************************************
--function CARDS ()
--*********************************************************************************************************************
  function private.MouseEnterCards ( card, side ) -- наведение на карту

    cmn.SetCursor( CURSOR_HAND );
    
    if ( ObjGet( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_focus" ) ) then    

      ObjAnimate( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_focus", "alp", 0, 0, "", 
        {
          0.0, 0, ObjGet( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_focus" ).alp,
          0.3, 0, 1
        } );
      
    end;

  end;
  --*********************************************************************************************************************
  function private.MouseLeaveCards ( card, side ) 

    cmn.SetCursor( CURSOR_DEFAULT );
    
    if ( ObjGet( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_focus" ) ) then
      
      ObjAnimate( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_focus", "alp", 0, 0, "", 
        {
          0.0, 0, ObjGet( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_focus" ).alp,
          0.3, 0, 0
        } );      
              
    end;

  end;
  --*********************************************************************************************************************
  function private.OpenCard ( card, side ) 

    cmn.SetCursor( CURSOR_DEFAULT );
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_choosecard" );
    
    ObjAttach( "obj_mgfate_rpl_"..side.."_"..card[ 1 ], "obj_mgfate_rpl_big_card" );  
    local func_end = function ()

      int.Lock( false );
      ObjSet( "obj_mgfate_rpl_big", { input = true, event_mdown = function () private.CloseCard( card, side ) end } );

    end;

    int.Lock( true );

    ObjAnimate( "spr_mgfate_rpl_dark", "alp", 0, 0, "", 
    {
      0.0, 0, 0,
      0.2, 0, 0.5
    } );    
    ObjAnimate( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_bigcard_add", "alp", 0, 0, "", 
    {
      0.0, 0, ObjGet( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_bigcard_add" ).alp,
      0.5, 0, 1
    } );
    ObjAnimate( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_shadow", "alp", 0, 0, "", 
    {
      0.0, 0, ObjGet( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_shadow" ).alp,
      0.5, 0, 0
    } );    
    ObjAnimate( "obj_mgfate_rpl_big_card", "scale_xy", 0, 0, "", 
    {
      0.0, 0, 1,   1,
      0.5, 0, 2.5, 2.5
    } );      
    
    local rel = "";
    
    for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ] do
    
      if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ][i][1] == card[ 1 ] )  then
          
        rel = ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ][i][2];
        break;
        
      end;
    
    end;     
    
    if ( rel == "hand" ) then          

      local card_angle = ( -1 ) * ObjGet( "obj_mgfate_rpl_"..side.."_"..card[ 1 ] ).ang ;

      ObjSet( "obj_mgfate_rpl_big_card", { pos_x = 0, pos_y = 603, ang = 0.4 } );      
        
      ObjAnimate( "obj_mgfate_rpl_big_card", "ang", 0, 0, "", 
      {
        0.0, 0, ObjGet( "obj_mgfate_rpl_big_card" ).ang,
        0.5, 0, card_angle
      } );
      
      ObjAnimate( "obj_mgfate_rpl_big_card", "pos_y", 0, 0, func_end, 
      {
        0.0, 0, ObjGet( "obj_mgfate_rpl_big_card" ).pos_y,
        0.5, 0, 880
      } );
      
    else 
      
      ObjSet( "obj_mgfate_rpl_big_card", { pos_x = -240, pos_y = ObjGet( "obj_mgfate_rpl_field_"..side ).pos_y, ang = 0 } );
      
      local dx = ( ObjGet( "obj_mgfate_rpl_"..side.."_"..card[ 1 ] ).pos_x - 240 ) * 2.5; 
      
      ObjAnimate( "obj_mgfate_rpl_big_card", "pos_xy", 0, 0, func_end, 
      {
        0.0, 0, ObjGet( "obj_mgfate_rpl_big_card" ).pos_x, ObjGet( "obj_mgfate_rpl_big_card" ).pos_y,
        0.5, 0, -597-dx, 866
      } );      

    end;    
    
  end;
  --*********************************************************************************************************************
  function private.CloseCard ( card, side ) 
    
    int.Lock( true );
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_putcard" );
   
    ObjAnimate( "spr_mgfate_rpl_dark", "alp", 0, 0, "", 
    {
      0.0, 0, 0.5,
      0.3, 0, 0.5,
      0.5, 0, 0
    } );
    ObjAnimate( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_bigcard_add", "alp", 0, 0, "", 
    {
      0.0, 0, ObjGet( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_bigcard_add" ).alp,
      0.5, 0, 0
    } );
    ObjAnimate( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_shadow", "alp", 0, 0, "", 
    {
      0.0, 0, ObjGet( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_shadow" ).alp,
      0.5, 0, 1
    } );    
    ObjAnimate( "obj_mgfate_rpl_big_card", "scale_xy", 0, 0, "", 
    {
      0.0, 0, 2.5, 2.5,
      0.5, 0, 1,   1
    } );    
    
    local rel = "";
    
    for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ] do
    
      if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ][i][1] == card[ 1 ] )  then
          
        rel = ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ][i][2];
        break;
        
      end;
    
    end;  
    
    local func_end = function () end;

    if ( rel == "hand" ) then      
     
      func_end = function ()

        int.Lock( false );
        ObjAttach( "obj_mgfate_rpl_"..side.."_"..card[ 1 ], "obj_mgfate_rpl_hand_"..side.."_center" );
        ObjSet( "obj_mgfate_rpl_big", { input = false, event_mdown = "" } );

      end;    
      
      ObjAnimate( "obj_mgfate_rpl_big_card", "ang", 0, 0, "", 
      {
        0.0, 0, ObjGet( "obj_mgfate_rpl_big_card" ).ang,
        0.5, 0, 0.4
      } );      
      ObjAnimate( "obj_mgfate_rpl_big_card", "pos_y", 0, 0, func_end, 
      {
        0.0, 0, ObjGet( "obj_mgfate_rpl_big_card" ).pos_y,
        0.5, 0, 603
      } );      
    
    else
    
      func_end = function ()

        int.Lock( false );
        ObjAttach( "obj_mgfate_rpl_"..side.."_"..card[ 1 ], "obj_mgfate_rpl_field_"..side );
        ObjSet( "obj_mgfate_rpl_big", { input = false, event_mdown = "" } );

      end;     
      
      ObjAnimate( "obj_mgfate_rpl_big_card", "pos_xy", 0, 0, func_end, 
      {
        0.0, 0, ObjGet( "obj_mgfate_rpl_big_card" ).pos_x, ObjGet( "obj_mgfate_rpl_big_card" ).pos_y,
        0.5, 0, -240, ObjGet( "obj_mgfate_rpl_field_"..side ).pos_y
      } );         
    
    end;      

  end;
  --*********************************************************************************************************************
  function private.StartDragCard ( card, side ) 

    cmn.SetCursor( CURSOR_NULL );
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_clk_card" );

    ObjAttach( "spr_mgfate_rpl_"..side.."_"..card[ 1 ], "obj_mgfate_rpl_big" );
    ObjAttach( "obj_mgfate_rpl_"..side.."_"..card[ 1 ], "obj_mgfate_rpl_hand_"..side.."_center" );
    ObjSet( "spr_mgfate_rpl_"..side.."_"..card[ 1 ], { scale_x = 0.5, scale_y = 0.5 } );


    --int.Lock( false );
    ObjStopAnimate( "spr_mgfate_rpl_dark", "alp" );
    ObjSet( "spr_mgfate_rpl_dark", { alp = 0 });
    ObjStopAnimate( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_bigcard_add", "alp" );
    ObjStopAnimate( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_shadow", "alp" );
    ObjStopAnimate( "obj_mgfate_rpl_big_card", "ang" );
    ObjStopAnimate( "obj_mgfate_rpl_big_card", "scale_xy" );
    ObjStopAnimate( "obj_mgfate_rpl_big_card", "pos_y" );

  end;
  --*********************************************************************************************************************
  function private.DragDropCard ( card, side ) 

    cmn.SetCursor( CURSOR_DEFAULT );
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_playcard" );

    ObjAttach( "spr_mgfate_rpl_"..side.."_"..card[ 1 ], "obj_mgfate_rpl_"..side.."_"..card[ 1 ] );
    ObjSet( "spr_mgfate_rpl_"..side.."_"..card[ 1 ], { scale_x = 1, scale_y = 1 } );

    if ( cmn.ApplyObj( "spr_mgfate_rpl_"..side.."_"..card[ 1 ], "obj_mgfate_rpl_field", true ) ) then

      int.Lock( true );

      ObjAttach( "obj_mgfate_rpl_"..side.."_"..card[ 1 ], "obj_mgfate_rpl_field_"..side );  
      ObjSet( "obj_mgfate_rpl_"..side.."_"..card[ 1 ], { pos_x = 240, ang = 0 } );
      -- drag off
      ObjSet( "spr_mgfate_rpl_"..side.."_"..card[ 1 ], {                  
          drag = false,
          realdrag = false,
          event_startdrag = "",
          event_dragdrop = "" } );  
          
      for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ] do
      
        if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ][i][1] == card[ 1 ] )  then
            
          ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ][i][2] = "field";
          break;
          
        end;
      
      end;    
      
      private.UnwrapCard( "obj_mgfate_rpl_field_"..side );  
      private.UnwrapCard( "obj_mgfate_rpl_hand_"..side.."_center" );  
      
      local func_1 = function ()
      
        private.RULES[ card[ 1 ] ]();
        ObjSet( "tmr_mgfate_rpl_turn", { playing = 1, time = 1, endtrig = function () private.EndOfTurn( card[ 1 ] ); end } );         
      
      end;
      
      ObjSet( "tmr_mgfate_rpl_turn", { playing = 1, time = 1, endtrig = function () func_1(); end } );       
     
    end;

  end;
  --*********************************************************************************************************************
  function private.GenerateCard ( card, side ) -- создаем карту
  --DbgTrace( "mgfate_rpl private.GenerateCard"..side.."_"..card[ 1 ] );
    -- create card
    if ( card ) then

      private.RULES[ card[ 1 ].."_count" ] = 0;                                                                                                    
      
      -- object
      ObjCreate( "obj_mgfate_rpl_"..side.."_"..card[ 1 ] , "obj" );
      ObjSet( "obj_mgfate_rpl_"..side.."_"..card[ 1 ],
        {
          alp = 1,
          ang = -0.4,
          scale_x = 0.4,
          scale_y = 0.4,
          pos_z = 50
        } );
      -- spr big light
      ObjCreate( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_bigcard_add" , "spr" );
      ObjAttach( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_bigcard_add" , "obj_mgfate_rpl_"..side.."_"..card[ 1 ] );
      ObjSet( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_bigcard_add",
        {
          pos_y = -913,
          input = false,
          pos_z = -1,
          alp = 0,
          blendmode = 2, --"AdditiveAlpha",
          --res = "assets/levels/levelext/mg_mgfate/layers/"..side.."_bigcard_add"
        } );
      -- spr
      ObjCreate( "spr_mgfate_rpl_"..side.."_"..card[ 1 ] , "spr" );
      ObjAttach( "spr_mgfate_rpl_"..side.."_"..card[ 1 ] , "obj_mgfate_rpl_"..side.."_"..card[ 1 ] );
      ObjSet( "spr_mgfate_rpl_"..side.."_"..card[ 1 ],
        {
          pos_y = -913,
          drag = true,
          realdrag = true,
          alp = 1,
          res = "assets/levels/levelext/mg_mgfate/layers/"..side.."/"..side.."_"..card[ 1 ],
          event_mup = function () private.OpenCard( card, side ); end,
          event_startdrag = function () private.StartDragCard( card, side ); end,
          event_dragdrop = function () private.DragDropCard( card, side ); end,
          event_menter = function () private.MouseEnterCards( card, side ); end,
          event_mleave = function () private.MouseLeaveCards( card, side ); end
        } );
      -- text title
      ObjCreate( "txt_mgfate_rpl"..side.."_"..card[ 1 ].."_text_title" , "text" );
      ObjAttach( "txt_mgfate_rpl"..side.."_"..card[ 1 ].."_text_title" , "spr_mgfate_rpl_"..side.."_"..card[ 1 ] );
      ObjSet( "txt_mgfate_rpl"..side.."_"..card[ 1 ].."_text_title",
        {
          text = "str_mgfate_rpl_"..card[ 1 ].."_title",
          res = "assets/fonts/times",
          input = false,          
          pos_y = 19,
          fontsize = 20,
          fontcolor_r = 0,
          fontcolor_g = 0,
          fontcolor_b = 0
        } );
      -- text text
      ObjCreate( "txt_mgfate_rpl"..side.."_"..card[ 1 ].."_text" , "text" );
      ObjAttach( "txt_mgfate_rpl"..side.."_"..card[ 1 ].."_text" , "spr_mgfate_rpl_"..side.."_"..card[ 1 ] );
      ObjSet( "txt_mgfate_rpl"..side.."_"..card[ 1 ].."_text",
        {
          text = "str_mgfate_rpl_"..card[ 1 ].."_text",
          res = "assets/fonts/times",
          input = false,
          pos_y = 97,
          fontsize = 18,
          maxwidth = 245,
          align = 3,
          fontcolor_r = 0,
          fontcolor_g = 0,
          fontcolor_b = 0
        } );
      -- spr shadow 
      ObjCreate( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_shadow" , "spr" );
      ObjAttach( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_shadow" , "spr_mgfate_rpl_"..side.."_"..card[ 1 ] );
      ObjSet( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_shadow",
        {
          --res = "assets/levels/levelext/mg_mgfate/layers/card_shadow",
          input = false,
          scale_x = 2.76,
          scale_y = 2.61,
          pos_x = -10,
          pos_y = 11
        } );
      -- spr focus small 
      ObjCreate( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_focus" , "spr" );
      ObjAttach( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_focus" , "spr_mgfate_rpl_"..side.."_"..card[ 1 ] );
      ObjSet( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_focus",
        {
          alp = 0,
          res = "assets/levels/levelext/mg_mgfate/layers/card_focus",
          input = false,
          scale_x = 2.65,
          scale_y = 2.65,
          blendmode = 2 --"AdditiveAlpha",
        } );
      -- spr big back
      ObjCreate( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_backcard" , "spr" );
      ObjAttach( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_backcard" , "obj_mgfate_rpl_"..side.."_"..card[ 1 ] );
      ObjSet( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_backcard",
        {
          pos_y = -913,
          input = false,
          pos_z = 1,
          alp = 1,
          res = "assets/levels/levelext/mg_mgfate/layers/"..side.."_backcard"
        } );
      
      if ( card[ 2 ] == "hand" ) then

        ObjAttach( "obj_mgfate_rpl_"..side.."_"..card[ 1 ], "obj_mgfate_rpl_hand_"..side.."_center" );

      else

        ObjAttach( "obj_mgfate_rpl_"..side.."_"..card[ 1 ], "obj_mgfate_rpl_field_"..side );
        ObjSet( "obj_mgfate_rpl_"..side.."_"..card[ 1 ], { pos_x = 240, ang = 0 } );
        ObjSet( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_backcard" , { alp = 0 } );        
        -- drag off
        ObjSet( "spr_mgfate_rpl_"..side.."_"..card[ 1 ], {                  
            drag = false,
            realdrag = false,
            event_startdrag = "",
            event_dragdrop = "" } );          
      
      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.UnwrapCard ( source, side ) -- разворачиваем карты
  --DbgTrace( "mgfate_rpl private.UnwrapCard" );
  
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_arranged" );   
  
    local rel = ObjGetRelations( source );

    if ( rel ) then

      if ( string.find( source, "hand" ) ) then 
      -- разворачиваем по углу в руке

        for i = 1, #rel.childs do
  --DbgTrace( "rel.childs[ i ] = "..tostring( rel.childs[ i ] ) );
          local angle = ( private.ANGLE_MAX / ( #rel.childs + 1 ) ) * i ; 
  --DbgTrace( "angle = "..tostring( angle ) );
          ObjSet( rel.childs[ i ], { alp = 1, pos_z = i } );
          --int.Lock( true );
          ObjAnimate( rel.childs[ i ], "ang", 0, 0,
          function ()
            
            if ( side == "grays" ) then
              
              int.Lock( false );
              
            end;
            
          end,
            {
              0.0, 0, ObjGet( rel.childs[ i ] ).ang,
              0.3, 0, angle
            } );    

        end;

      else
      -- разворачиваем по х на поле

        for i = 1, #rel.childs do
  --DbgTrace( "rel.childs[ i ] = "..tostring( rel.childs[ i ] ) );
          local posx = ( private.POSX_MAX / ( #rel.childs + 1 ) ) * i ; 
  --DbgTrace( "angle = "..tostring( angle ) );
          ObjSet( rel.childs[ i ], { alp = 1, pos_z = i } );
          --int.Lock( true );
          ObjAnimate( rel.childs[ i ], "pos_x", 0, 0,
          function ()
            
            if ( side == "grays" ) then
              
              int.Lock( false );
              
            end;
            
          end,
            {
              0.0, 0, ObjGet( rel.childs[ i ] ).pos_x,
              0.3, 0, posx
            } );    

        end;      
      
      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.ResetCards (  ) -- сбрасываем все карты

    ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].player = { ["life"] = 20, ["progress"] = 0 } -- life, progress_bar

    local side = { "atropos", "grays" };
    
    local is_atropos = false;
    
    for i = 1, #side do

      ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side[i] ] = {};

      local array = {};

      for j = 1, #private.cards[ i ] do
        
        if ( private.cards[ i ][ j ] ~= "bloody_mary" ) then        
          
           table.insert( array, private.cards[ i ][ j ] );
        
        end;

      end;

      for k = 1, 4 do

        local rnd = math.random( 1, #array );

        if ( array[ rnd ] == "atropos" ) then
          
          is_atropos = true;
          
        end;
        
        table.insert( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side[i] ], { array[ rnd ], "hand" } );

        table.remove( array, rnd );
      
      end;

    end;
    
    if ( not is_atropos ) then
      
      ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side[ 1 ] ][ 1 ][ 1 ] = "atropos";
      
    end;
    
        --table.insert( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ] , { "pension", "field" } );
        --table.insert( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ] , { "mirror", "field" } );
        --table.insert( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ] , { "obsessively_jackey", "hand" } );    

  end;
  --*********************************************************************************************************************
  function private.NewCard ( side ) -- взятие карты в руку

    local number = 1;
    if ( side == "grays" ) then number = 2; end;

    local array = {};
    
    for i = 1, #private.cards[ number ] do

      local is_card = false;    

      for j = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ] do

        if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ][ j ][ 1 ] == private.cards[ number ][ i ] ) or 
           ( private.cards[ number ][ i ] == "bloody_mary" ) then

          is_card = true;
          break;

        end;

      end;

      if ( not is_card ) then

        table.insert( array, private.cards[ number ][ i ] );

      end;

    end;
    
    if ( #array > 0 ) then

      local rnd = math.random( 1, #array );
      table.insert( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ] , { array[ rnd ], "hand" } );

      private.GetNewCard( { array[ rnd ], "hand" }, side );

    else

      int.Lock( false );
      --DbgTrace( "Cards over "..side );
      --private.HpDown( 2 );

    end;

  end;
  --*********************************************************************************************************************
  function private.GetNewCard ( card, side ) -- полет карты

      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_gimmecard" );
    
      private.GenerateCard( card, side );
      ObjAttach( "anm_mgfate_rpl_card_appear", "obj_mgfate_rpl_"..side.."_"..card[ 1 ] );

      local func_end = function ()

        local func_end_1 = function ()

        --int.Lock( false );
          ObjAttach( "anm_mgfate_rpl_card_appear", "obj_mgfate_rpl_anims" );
          private.UnwrapCard( "obj_mgfate_rpl_hand_"..side.."_center", side );

        end;

        if ( side == "grays" ) then

          AnimPlay( "anm_mgfate_rpl_card_appear", "DoAnim", "" );
          ObjAnimate( "spr_mgfate_rpl_"..side.."_"..card[ 1 ].."_backcard", "alp", 0, 0, func_end_1, 
            {
              0.0, 0, 1,
              0.2, 0, 0
            } );

        else

          ObjAnimate( "spr_mgfate_rpl_"..side.."_"..card[ 1 ], "alp", 0, 0, func_end_1, 
            {
              0.0, 0, 1,
              0.2, 0, 1
            } );

        end;

      end;
        --int.Lock( true );
      ObjAnimate( "obj_mgfate_rpl_"..side.."_"..card[ 1 ], "pos_xy", 0, 0, func_end, 
        {
          0.0, 0, private.ANIM_POS_CARDS[ side ].start_x, private.ANIM_POS_CARDS[ side ].start_y ,
          0.6, 0, private.ANIM_POS_CARDS[ side ].end_x, private.ANIM_POS_CARDS[ side ].end_y 
        } );

  end;
  --*********************************************************************************************************************
  function private.DeleteCard ( card_name, side, func_end ) -- удаление карты  
 
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_cardexplode" );   
    
    local func_1 = function ( number )
    
      ObjSet("anm_mgfate_rpl_card_destroy", { alp = 1 });      
      local postfix = "_"..card_name;
      ObjClone( "anm_mgfate_rpl_card_destroy", postfix, false, "obj_mgfate_rpl_"..side.."_"..card_name );
       
      local func_end_1 = function ()

      --int.Lock( false );
        ObjDelete( "obj_mgfate_rpl_"..side.."_"..card_name );
        ObjDelete( "spr_mgfate_rpl_"..side.."_"..card_name );
        if ( func_end ) then
          
           func_end();        

        end;
      
      end;

      --int.Lock( true );
        AnimPlay( "anm_mgfate_rpl_card_destroy"..postfix, "DoAnim", "" );
        ObjAnimate( "obj_mgfate_rpl_"..side.."_"..card_name, "alp", 0, 0, func_end_1, 
          {
            0.0, 0, 1,
            0.6, 0, 1,              
            0.65, 0, 0
          } );
                    
    end;
            
    for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ] do
      
      if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ][ i ][ 1 ] == card_name ) then 
           --( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ][ i ][ 2 ] == "field" ) ) then

        func_1( i );
        table.remove( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ], i );           
        break;
         
      end;
      
    end;      
    
  end; 
  --*********************************************************************************************************************
  function private.AtroposPutCard ( ) -- ход atropos     
    
    -- берем рандомную карту в руке атропос     

    local array = {};

    for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ] do
      
      if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 2 ] == "hand" ) then

         table.insert( array, ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ] );
         
      end;

    end;

    local rnd = math.random( 1, #array );

    -- анимируем ее из руки на стол
    
    ObjAttach( "obj_mgfate_rpl_atropos_"..array[ rnd ][ 1 ], "obj_mgfate_rpl_field_atropos" );  
    ObjSet( "obj_mgfate_rpl_atropos_"..array[ rnd ][ 1 ], { ang = 0, pos_x = 240, pos_y = -220 } );  
    ObjAttach( "anm_mgfate_rpl_card_ontable", "obj_mgfate_rpl_atropos_"..array[ rnd ][ 1 ] );

    local func_end = function ()

      local func_end_1 = function ()

        ObjAttach( "anm_mgfate_rpl_card_ontable", "obj_mgfate_rpl_anims" );
        
        --int.Lock( false );
        private.UnwrapCard( "obj_mgfate_rpl_hand_atropos_center" );
        private.UnwrapCard( "obj_mgfate_rpl_field_atropos" );        
        
        for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ] do
          
          if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 1 ] == array[ rnd ][ 1 ] ) then

            ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][i][2] = "field";   
            -- drag off
            ObjSet( "spr_mgfate_rpl_atropos"..array[ rnd ][ 1 ], {                  
                drag = false,
                realdrag = false,
                event_startdrag = "",
                event_dragdrop = "" } );              
            break;         
             
          end;

        end;        
             
        local func_1 = function ()
        
          private.RULES[ array[ rnd ][ 1 ] ]();
          ObjSet( "tmr_mgfate_rpl_turn", { playing = 1, time = 1, endtrig = function () private.EndOfTurn( array[ rnd ][ 1 ] ); end } );         
        
        end;
        
        ObjSet( "tmr_mgfate_rpl_turn", { playing = 1, time = 1, endtrig = function () func_1(); end } );          

      end;


      AnimPlay( "anm_mgfate_rpl_card_ontable", "DoAnim", func_end_1 );
      ObjAnimate( "spr_mgfate_rpl_atropos_"..array[ rnd ][ 1 ].."_backcard", "alp", 0, 0, "", 
        {
          0.0, 0, 1,
          0.2, 0, 0
        } );

    end;
      
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_rivalsturn" );

      --int.Lock( true );    
    ObjAnimate( "obj_mgfate_rpl_atropos_"..array[ rnd ][ 1 ], "pos_xy", 0, 0, func_end, 
      {
        0.0, 0, ObjGet( "obj_mgfate_rpl_atropos_"..array[ rnd ][ 1 ] ).pos_x, ObjGet( "obj_mgfate_rpl_atropos_"..array[ rnd ][ 1 ] ).pos_y,
        0.6, 0, 240, 0 
      } );    
  
    
  end;     
  --*********************************************************************************************************************
  function private.TransformCard ( card_name, side ) -- переманивание карт на другую сторону        

    local array_names = {};
    array_names["brandon_young"]       = "obsessively_brandon";
    array_names["obsessively_brandon"] = "brandon_young";
    array_names["jackey_young"]        = "obsessively_jackey";
    array_names["obsessively_jackey"]  = "jackey_young";
    array_names["louise"]              = "damned_louise";
    array_names["john"]                = "damned_john";
    
    local anti_side = "atropos";
    if ( side == "atropos" ) then      
      anti_side = "grays";      
    end;
    
    local new_card = { array_names[ card_name ], "field" };   
    
    local func_1 = function ( )
    
      ObjSet("anm_mgfate_rpl_card_transform", { alp = 1 } ); 
      ObjAttach( "obj_mgfate_rpl_"..side.."_"..card_name, "obj_mgfate_rpl_field_"..anti_side );

      local func_end_1 = function ()

      --int.Lock( false );
        ObjDelete( "obj_mgfate_rpl_"..side.."_"..card_name );
        ObjDelete( "spr_mgfate_rpl_"..side.."_"..card_name );        

      end;

      if ( side == "grays" ) then
                
        private.GenerateCard( new_card, anti_side );
        ObjAttach( "obj_mgfate_rpl_"..anti_side.."_"..new_card[ 1 ], "obj_mgfate_rpl_field_"..anti_side );  
        
        local postfix = "_"..new_card[ 1 ];
        ObjClone( "anm_mgfate_rpl_card_transform", postfix, false, "obj_mgfate_rpl_"..anti_side.."_"..new_card[ 1 ] );  
        ObjSet(  "obj_mgfate_rpl_"..anti_side.."_"..new_card[ 1 ], { pos_x = 240, pos_y = 168 } );                
        ObjSet( "obj_mgfate_rpl_"..side.."_"..card_name, { pos_x = 240, pos_y = 168 } );
        --int.Lock( true );
        AnimPlay( "anm_mgfate_rpl_card_transform"..postfix, "DoAnim", func_end_1 );        
        ObjAnimate( "obj_mgfate_rpl_"..side.."_"..card_name, "pos_xy", 0, 0, "", 
          {
            0.0, 0, ObjGet( "obj_mgfate_rpl_"..side.."_"..card_name ).pos_x, ObjGet( "obj_mgfate_rpl_"..side.."_"..card_name ).pos_y,
            0.6, 0, 240, 0 
          } );  
        ObjAnimate( "obj_mgfate_rpl_"..anti_side.."_"..new_card[ 1 ], "pos_xy", 0, 0, "", 
          {
            0.0, 0, ObjGet( "obj_mgfate_rpl_"..anti_side.."_"..new_card[ 1 ] ).pos_x, ObjGet( "obj_mgfate_rpl_"..anti_side.."_"..new_card[ 1 ] ).pos_y,
            0.6, 0, 240, 0 
          } );           
          
      else
          
        private.GenerateCard( new_card, anti_side );
        ObjAttach( "obj_mgfate_rpl_"..anti_side.."_"..new_card[ 1 ], "obj_mgfate_rpl_field_"..anti_side );    
        
        local postfix = "_"..new_card[ 1 ];
        ObjClone( "anm_mgfate_rpl_card_transform", postfix, false, "obj_mgfate_rpl_"..anti_side.."_"..new_card[ 1 ] );                                    
        ObjSet(  "obj_mgfate_rpl_"..anti_side.."_"..new_card[ 1 ], { pos_x = 240, pos_y = -168 } );
        ObjSet(  "obj_mgfate_rpl_"..anti_side.."_"..new_card[ 1 ], { pos_x = 240, pos_y = -168 } );                        
        ObjSet( "obj_mgfate_rpl_"..side.."_"..card_name, { pos_x = 240, pos_y = -168 } );
        --int.Lock( true );
        AnimPlay( "anm_mgfate_rpl_card_transform"..postfix, "DoAnim", func_end_1 );        
        ObjAnimate( "obj_mgfate_rpl_"..side.."_"..card_name, "pos_xy", 0, 0, "", 
          {
            0.0, 0, ObjGet( "obj_mgfate_rpl_"..side.."_"..card_name ).pos_x, ObjGet( "obj_mgfate_rpl_"..side.."_"..card_name ).pos_y,
            0.6, 0, 240, 0 
          } );  
        ObjAnimate( "obj_mgfate_rpl_"..anti_side.."_"..new_card[ 1 ], "pos_xy", 0, 0, "", 
          {
            0.0, 0, ObjGet( "obj_mgfate_rpl_"..anti_side.."_"..new_card[ 1 ] ).pos_x, ObjGet( "obj_mgfate_rpl_"..anti_side.."_"..new_card[ 1 ] ).pos_y,
            0.6, 0, 240, 0 
          } );           
          
      end;    
    
    end;
            
    for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ] do
      
      if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ][ i ][ 1 ] == card_name ) and 
           ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ][ i ][ 2 ] == "field" ) ) then
           --DbgTrace("transform "..card_name);   

        local piu_piu = false;        
           
        table.remove( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ], i );
        --private.DeleteCard ( new_card[1], side );                    
        for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ anti_side ] do
          
          if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ anti_side ][ i ][ 1 ] == new_card[1] ) then
            -- удаляем из массива принимающей стороны, если там уже есть такой в руке или поле, объект сам исчезнет - фича)
            --private.DeleteCard ( new_card[1], side );            
            private.DeleteCard ( new_card[1], anti_side, function () table.insert( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ anti_side ], new_card ); func_1(); end );                        
            table.remove( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ anti_side ], i );
            piu_piu = true;            
            break;          
            
          end;
          
        end;

        -- добавляем в массив принимающей стороны       
        if ( not piu_piu ) then
          table.insert( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ anti_side ], new_card );                                              
          func_1();
        end;

        break;
         
      end;
      
    end;      
    
  end;
  
  --*********************************************************************************************************************
  function private.AddExtraCard ( card_name, side ) -- создание карт брендона, мери и джеки ребенка   

    local func_end_2 = function ()
      
    -- int.Lock( false );
      ObjAttach( "anm_mgfate_rpl_card_appear", "obj_mgfate_rpl_anims" );
      private.UnwrapCard( "obj_mgfate_rpl_field_"..side );

    end;
    
    local func_end_1 = function ()
          --DbgTrace("AddExtraCard func_end_1");
      private.GenerateCard( { card_name, "field" }, side );
      ObjAttach( "anm_mgfate_rpl_card_appear", "obj_mgfate_rpl_"..side.."_"..card_name );         

      --int.Lock( true );
      AnimPlay( "anm_mgfate_rpl_card_appear", "DoAnim", func_end_2 );
      ObjAnimate( "spr_mgfate_rpl_"..side.."_"..card_name.."_backcard", "alp", 0, 0, "", 
        {
          0.0, 0, 1,
          0.2, 0, 0
        } );

    end;    
      
    local card_exist = false;
    
    for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ] do
      
      if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ][ i ][ 1 ] == card_name ) then
        
        card_exist = true;    
        break;          
        
      end;
      
    end;    
    
    
    
    if ( not card_exist ) then
      --DbgTrace("AddExtraCard not");
      table.insert( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ] , { card_name, "field" } );
      func_end_1();
      
    else
      --DbgTrace("AddExtraCard yes");      
      private.DeleteCard ( card_name, side, function () table.insert( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ] , { card_name, "field" } ); func_end_1(); end );        
      --ObjSet( "tmr_mgfate_rpl_add", { playing = 1, time = 1.3, endtrig = function () table.insert( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ side ] , { card_name, "field" } ); func_end_1(); end } );       
            --func_end_1();
      
    end;
  
  end;
  
--*********************************************************************************************************************
--end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--function DECK ()
--*********************************************************************************************************************
  function private.MouseEnterDeck ( ) -- наведение на дэку

    cmn.SetCursor( CURSOR_GET );

    ObjAnimate( "spr_mgfate_rpl_decks_under_add", "alp", 0, 0, "", 
      {
        0.0, 0, ObjGet( "spr_mgfate_rpl_decks_under_add" ).alp,
        0.3, 0, 1
      } );

  end;
  --*********************************************************************************************************************
  function private.MouseLeaveDeck ( ) 

    cmn.SetCursor( CURSOR_DEFAULT );

    ObjAnimate( "spr_mgfate_rpl_decks_under_add", "alp", 0, 0, "", 
      {
        0.0, 0, ObjGet( "spr_mgfate_rpl_decks_under_add" ).alp,
        0.3, 0, 0
      } );

  end;
--*********************************************************************************************************************
--end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--function RULES ()
--*********************************************************************************************************************
    private.RULES = {};
    private.RULES.up_hp = 0;
    private.RULES.down_hp = 0;    
    --*********************************************************************************************************************
    --function atropos ()
    private.RULES[ "atropos_count" ] = 0;    
    private.RULES[ "atropos" ] = function ()
    
      -- -6 HP 
      private.RULES.down_hp = private.RULES.down_hp + 6;
      
      -- delete cards once
      if ( private.RULES[ "atropos_count" ] == 0 ) then
        
        for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ] do

          if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ] ) then
            
            if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ] == "alex" ) and ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 2 ] == "field" ) ) or
               ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ] == "nat" ) and ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 2 ] == "field" ) ) then
            
              private.DeleteCard( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ], "grays" );    
               
            end;
            
          end;
          
        end;
        
      end;
      
      private.RULES[ "atropos_count" ] = 1;        
    
    end;
    --*********************************************************************************************************************
    --end; function bloody_mary ()  
    private.RULES[ "bloody_mary_count" ] = 0;        
    private.RULES[ "bloody_mary" ] = function ()
    
      -- -13 HP 
      private.RULES.down_hp = private.RULES.down_hp + 13;
     
    end;  
    --*********************************************************************************************************************
    --end; function crazy_artist ()  
    private.RULES[ "crazy_artist_count" ] = 0;            
    private.RULES[ "crazy_artist" ] = function ()
    
      -- -7 HP 
      for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ] do
        
        if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ] ) then                                                                                                                                                                            
        
          if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ] == "family_house" ) and 
               ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 2 ] == "field" ) ) then
               
               private.RULES.down_hp = private.RULES.down_hp + 5;                           
            break;
             
          end;
          
        end;
        
      end;      
    
      private.RULES.down_hp = private.RULES.down_hp + 3;
      
    end;  
    --*********************************************************************************************************************
    --end; function damned_john ()  
    private.RULES[ "damned_john_count" ] = 0;                
    private.RULES[ "damned_john" ] = function ()
    
      -- -3 HP 
      private.RULES.down_hp = private.RULES.down_hp + 3;
      
    end;  
    --*********************************************************************************************************************
    --end; function damned_louise ()  
    private.RULES[ "damned_louise_count" ] = 0;                    
    private.RULES[ "damned_louise" ] = function ()
    
      -- -3 HP
      private.RULES.down_hp = private.RULES.down_hp + 3;  
      
    end;   
    --*********************************************************************************************************************
    --end; function father ()  
    private.RULES[ "father_count" ] = 0;                        
    private.RULES[ "father" ] = function ()
    
      -- -3 HP 
      private.RULES.down_hp = private.RULES.down_hp + 3;  
      
      -- delete cards once
      if ( private.RULES[ "father_count" ] == 0 ) then
        
        for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ] do
          
          if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ] ) then        
            
            if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ] == "louise" ) and ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 2 ] == "field" ) ) or
               ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ] == "john" ) and ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 2 ] == "field" ) ) then
            
              private.DeleteCard( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ], "grays" );    
              
            end;
            
          end;
          
        end;   
       
      end; 
      
      private.RULES[ "father_count" ] = 1;  
      
    end;   
    --*********************************************************************************************************************
    --end; function kaine ()  
    private.RULES[ "kaine_count" ] = 0;                            
    private.RULES[ "kaine" ] = function ()

    -- -3 HP
    private.RULES.down_hp = private.RULES.down_hp + 3; 
    
    -- transform cards permanent
      if ( private.RULES[ "kaine_count" ] == 0 ) then
        
        for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ] do
          
          if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ] ) then                  
            
            if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ] == "louise" ) and ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 2 ] == "field" ) ) or
               ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ] == "john" ) and ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 2 ] == "field" ) ) then
            
              private.TransformCard( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ], "grays" );
               
            end;
            
          end;
          
        end;    
        
      end;
      
      private.RULES[ "kaine_count" ] = 1;
      
    end;  
    --*********************************************************************************************************************
    --end; function mirror ()  
    private.RULES[ "mirror_count" ] = 0;                                
    private.RULES[ "mirror" ] = function ()
       
      -- -2 HP 
      private.RULES.down_hp = private.RULES.down_hp + 2;      
    
    -- transform cards permanent
      if ( private.RULES[ "mirror_count" ] == 0 ) then    
        
        for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ] do
          
          if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ] ) then                  
          
            if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ] == "jackey_young" ) and 
                 ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 2 ] == "field" ) ) then
            
              private.TransformCard( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ], "grays" );
              break;
               
            end;
            
          end;
          
        end;    
        
      end;
      
      private.RULES[ "mirror_count" ] = 1;
      
    end; 
    --*********************************************************************************************************************
    --end; function obsessively_brandon ()  
    private.RULES[ "obsessively_brandon_count" ] = 0;                                    
    private.RULES[ "obsessively_brandon" ] = function ()
    
      -- -2 HP 
      private.RULES.down_hp = private.RULES.down_hp + 2;     
      
    end;     
    --*********************************************************************************************************************
    --end; function obsessively_jackey ()  
    private.RULES[ "obsessively_jackey_count" ] = 0;                                        
    private.RULES[ "obsessively_jackey" ] = function ()
       
      -- -2 HP 
      private.RULES.down_hp = private.RULES.down_hp + 2;      

      -- create cards once
      if ( private.RULES[ "obsessively_jackey_count" ] == 0 ) then        
        
        local both = 0;
        
        for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ] do
          
          if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ] ) then                            
          
            if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 1 ] == "pension" ) and ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 2 ] == "field" ) ) or
               ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 1 ] == "mirror" ) and ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 2 ] == "field" ) ) then
            
               both = both + 1;
               
            end;
             
          end;
          
        end;    
         
        if ( both == 2 ) then
          
          private.AddExtraCard( "bloody_mary", "atropos" );
          
        end;
        
      end;
      
      private.RULES[ "obsessively_jackey_count" ] = 1;
      
    end;      
    --*********************************************************************************************************************
    --end; function spirit ()  
    private.RULES[ "spirit_count" ] = 0;                                            
    private.RULES[ "spirit" ] = function ()
    
      -- -4 HP 
      private.RULES.down_hp = private.RULES.down_hp + 4;   
      
      -- delete cards once
      if ( private.RULES[ "spirit_count" ] == 0 ) then        
      
        for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ] do
          
          if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ] ) then                                      
            
            if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ] == "elizabeth" ) and ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 2 ] == "field" ) ) or
              ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ] == "james" ) and ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 2 ] == "field" ) ) then
            
              private.DeleteCard( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ], "grays" );    
              
            end;
            
          end;
          
        end;    
        
      end;
      
      private.RULES[ "spirit_count" ] = 1; 
      
    end; 
    --*********************************************************************************************************************
    --end; function witch ()  
    private.RULES[ "witch_count" ] = 0;                                                
    private.RULES[ "witch" ] = function ()
       
      -- -4 HP 
      private.RULES.down_hp = private.RULES.down_hp + 4;      
    
      -- transform cards once
      if ( private.RULES[ "witch_count" ] == 0 ) then              
      
        for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ] do
          
          if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ] ) then                                                
          
            if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ] == "brandon_young" ) and 
                 ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 2 ] == "field" ) ) then
            
              private.TransformCard( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ], "grays" );
              break;
               
            end;
            
          end;
          
        end;    
        
      end;
      
      private.RULES[ "witch_count" ] = 1;
      
    end;   
    --*********************************************************************************************************************
    --end; function swamp ()  
    private.RULES[ "swamp_count" ] = 0;                                                    
    private.RULES[ "swamp" ] = function ()
    
      -- -2 HP permanent if not brandon_young

      local is_brandon_young = false;
      
      for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ] do
        
        if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ] ) then                                                        
        
          if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ] == "brandon_young" ) and 
               ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 2 ] == "field" ) ) then
          
            is_brandon_young = true;
            break;
             
          end;
          
        end;
        
      end;          
    
      if ( not is_brandon_young ) then
        
        private.RULES.down_hp = private.RULES.down_hp + 2;    
        
      else
        
        private.RULES.up_hp = private.RULES.up_hp + 2;       
      
      end;      
      
    end; 
    --*********************************************************************************************************************
    --end; function grays_castle ()  
    private.RULES[ "grays_castle_count" ] = 0;                                                        
    private.RULES[ "grays_castle" ] = function ()
    
    -- -3 HP permanent if not john on table
    
    --[[ 1 TRY
      local is_john_louise = false;
      
      for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ] do
        
        if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ] ) then                                                                
        
          if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ] == "john" ) and ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 2 ] == "field" ) ) then
            --( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ] == "louise" ) and ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 2 ] == "field" ) ) then
          
            is_john_louise = true;
            break;
             
          end;
          
        end;
        
      end;          
    
      if ( not is_john_louise ) then
        
        private.RULES.down_hp = private.RULES.down_hp + 3;    
      
      end;]]
      
      -- 2 TRY
      private.RULES.down_hp = private.RULES.down_hp + 3;
      
    end; 
    --*********************************************************************************************************************
    --end; function pension ()  
    private.RULES[ "pension_count" ] = 0;                                                            
    private.RULES[ "pension" ] = function ()
    
      -- -4 HP p
      private.RULES.down_hp = private.RULES.down_hp + 4;      
      
    end;   
        
    --*********************************************************************************************************************
    --end; function alex ()  
    private.RULES[ "alex_count" ] = 0;                                                                
    private.RULES[ "alex" ] = function ()
       
      -- +2 HP 
      private.RULES.up_hp = private.RULES.up_hp + 2;
    
      -- transform cards once
      if ( private.RULES[ "alex_count" ] == 0 ) then                  
    
        for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ] do
          
          if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ] ) then                                                                          
            
            if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 1 ] == "obsessively_jackey" ) and 
                 ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 2 ] == "field" ) ) then
            
              private.TransformCard( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 1 ], "atropos" );
              break;
               
            end;
            
          end;
          
        end;   
       
      end; 
      
      private.RULES[ "alex_count" ] = 1;
      
    end;  
    --*********************************************************************************************************************
    --end; function brandon ()
    private.RULES[ "brandon_count" ] = 0;                                                                    
    private.RULES[ "brandon" ] = function ()
    
      -- +4 HP 
      private.RULES.up_hp = private.RULES.up_hp + 4;
      
      -- delete cards once
      if ( private.RULES[ "brandon_count" ] == 0 ) then                        
      
        for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ] do
          
          if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ] ) then                                                                                    
          
            if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 1 ] == "father" ) and ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 2 ] == "field" ) ) or
               ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 1 ] == "kaine" ) and ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 2 ] == "field" ) ) then
            
              private.DeleteCard( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 1 ], "atropos" );    
              
            end;
            
          end;
          
        end;
        
      end;
      
      private.RULES[ "brandon_count" ] = 1;
    
    end;  
    --*********************************************************************************************************************
    --end; function brandon_young ()  
    private.RULES[ "brandon_young_count" ] = 0;                                                                        
    private.RULES[ "brandon_young" ] = function ()
       
      -- +2 HP 
      private.RULES.up_hp = private.RULES.up_hp + 2;
        
      private.RULES[ "brandon_young_count" ] = 1;  
      
    end;  
    --*********************************************************************************************************************
    --end; function elizabeth ()  
    private.RULES[ "elizabeth_count" ] = 0;                                                                            
    private.RULES[ "elizabeth" ] = function ()
    --DbgTrace("elizabeth");                  
    -- +1 HP 
    private.RULES.up_hp = private.RULES.up_hp + 1;
    
    -- transform cards once
      if ( private.RULES[ "elizabeth_count" ] == 0 ) then                            
    
        for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ] do
          
          if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ] ) then                                                                                                        
          
            if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 1 ] == "witch" ) and 
                 ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 2 ] == "field" ) ) then
            
              private.DeleteCard( "witch", "atropos" );                  
              break;
               
            end;
            
          end;
          
        end;    
        
      end;
      
      private.RULES[ "elizabeth_count" ] = 1;  
      
    end;  
    --*********************************************************************************************************************
    --end; function jackey ()
    private.RULES[ "jackey_count" ] = 0;                                                                                
    private.RULES[ "jackey" ] = function ()
    
      -- +4 HP 
      private.RULES.up_hp = private.RULES.up_hp + 4;
      
      -- delete cards once
      if ( private.RULES[ "jackey_count" ] == 0 ) then                                  
      
        for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ] do
          
          if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ] ) then                                                                                                                  
          
            if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 1 ] == "bloody_mary" ) and ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 2 ] == "field" ) ) or
               ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 1 ] == "crazy_artist" ) and ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 2 ] == "field" ) ) then
            
              private.DeleteCard( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 1 ], "atropos" );    
              
            end;
            
          end;
          
        end;
        
      end;
      
      private.RULES[ "jackey_count" ] = 1; 
    
    end;    
    --*********************************************************************************************************************
    --end; function jackey_young ()
    private.RULES[ "jackey_young_count" ] = 0;                                                                                    
    private.RULES[ "jackey_young" ] = function ()
    
      -- +2 HP 
      private.RULES.up_hp = private.RULES.up_hp + 2;
      
      -- delete cards once
      if ( private.RULES[ "jackey_young_count" ] == 0 ) then                                        
      
        for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ] do
          
          if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ] ) then                                                                                                                            
          
            if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 1 ] == "pension" ) and ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 2 ] == "field" ) ) or
               ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 1 ] == "mirror" ) and ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 2 ] == "field" ) ) then
            
              private.DeleteCard( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 1 ], "atropos" );    
              -- +5 HP once for each
              private.HpUp( 5 );      
               
            end;
            
          end;
          
        end;
    
      end;
      
      private.RULES[ "jackey_young_count" ] = 1;
    
    end;  
    --*********************************************************************************************************************
    --end; function james ()  
    private.RULES[ "james_count" ] = 0;
    private.RULES[ "james" ] = function ()
    --DbgTrace("james");           
      -- +2 HP 
      private.RULES.up_hp = private.RULES.up_hp + 2;
    
      -- delete cards once     
      if ( private.RULES[ "james_count" ] == 0 ) then
        
        for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ] do
          
          if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ] ) then                                                                                                                                      
          
            if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ] == "elizabeth" ) and 
                 ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 2 ] == "field" ) ) then
            
                 
              for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ] do
                
                if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ] ) then                                                                                                                                      
                
                  if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 1 ] == "spirit" ) and 
                       ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 2 ] == "field" ) ) then
                  
                    private.DeleteCard( "spirit", "atropos" );    
                    break;
                     
                  end;
                  
                end;
                
              end;
              break;              
                 
            end;
            
          end;
          
        end;
    
      end; 
    
      private.RULES[ "james_count" ] = 1;    
        
    end;  
    --*********************************************************************************************************************
    --end; function john ()  
    private.RULES[ "john_count" ] = 0;                                                                                        
    private.RULES[ "john" ] = function ()
       
      -- +3 HP 
      private.RULES.up_hp = private.RULES.up_hp + 3;
    
    -- transform cards once
      if ( private.RULES[ "john_count" ] == 0 ) then                                                  
    
        for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ] do
          
          if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ] ) then                                                                                                                                                
          
            if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 1 ] == "obsessively_brandon" ) and 
                 ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 2 ] == "field" ) ) then
            
              private.TransformCard( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 1 ], "atropos" );
              break;
               
            end;
            
          end;
          
        end;    
        
      end;
      
      private.RULES[ "john_count" ] = 1;
      
    end;  
    --*********************************************************************************************************************
    --end; function louise ()  
    private.RULES[ "louise_count" ] = 0;                                                                                        
    private.RULES[ "louise" ] = function ()
    --DbgTrace("private.RULES[ louise ]")       
      -- +3 HP 
      private.RULES.up_hp = private.RULES.up_hp + 3;
    
    -- add cards once
      if ( private.RULES[ "louise_count" ] == 0 ) then                                                      
    
        for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ] do
          
          if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ] ) then                                                                                                                                                          
          
            if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ] == "john" ) and 
                 ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 2 ] == "field" ) ) then
            
              private.AddExtraCard( "brandon_young", "grays" );              
              break;
               
            end;
            
          end;
          
        end;    
        
      end;
      
      private.RULES[ "louise_count" ] = 1;
      
    end;  
    --*********************************************************************************************************************
    --end; function nat ()  
    private.RULES[ "nat_count" ] = 0;                                                                                            
    private.RULES[ "nat" ] = function ()
       
      -- +3 HP 
      private.RULES.up_hp = private.RULES.up_hp + 3;

    -- add cards once
      if ( private.RULES[ "nat_count" ] == 0 ) then                                                          

        for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ] do

          if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ] ) then                                                                                                                                                                    

            if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ] == "alex" ) and 
                 ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 2 ] == "field" ) ) then

              private.AddExtraCard( "jackey_young", "grays" );                            
              break;
               
            end;
            
          end;
          
        end;    
        
      end;
      
      private.RULES[ "nat_count" ] = 1;
      
    end;      
    --*********************************************************************************************************************
    --end; function castle_mcgrays ()  
    private.RULES[ "castle_mcgrays_count" ] = 0;                                                                                                
    private.RULES[ "castle_mcgrays" ] = function ()
    
    -- +2 HP p
      private.RULES.up_hp = private.RULES.up_hp + 2;

    end;      
    --*********************************************************************************************************************
    --end; function family_house ()  
    private.RULES[ "family_house_count" ] = 0;                                                                                                    
    private.RULES[ "family_house" ] = function ()

      --[[ 1 TRY
      for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ] do
        
        if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ] ) then                                                                                                                                                                            
        
          if ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ] == "family_house" ) and 
               ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 2 ] == "field" ) ) then
               --DbgTrace("family_house field");   
            ObjSet( "tmr_mgfate_rpl_turn", { playing = 1, time = 0.5, endtrig = function () private.NewCard("grays");  end } );                             
            break;
             
          end;
          
        end;
        
      end; ]]
      
      -- +3 HP p
      private.RULES.up_hp = private.RULES.up_hp + 3;

    end;        
--*********************************************************************************************************************
--end;
--*********************************************************************************************************************
function private.MouseEnterStep ( ) -- наведение на дэку

  cmn.SetCursor( CURSOR_HAND );

  --ObjAnimate( "spr_mgfate_rpl_decks_under_add", "alp", 0, 0, "", 
  --  {
  --    0.0, 0, ObjGet( "spr_mgfate_rpl_decks_under_add" ).alp,
  --    0.3, 0, 1
  --  } );

end;
--*********************************************************************************************************************
function private.MouseLeaveStep ( ) 

  cmn.SetCursor( CURSOR_DEFAULT );
--
--  ObjAnimate( "spr_mgfate_rpl_decks_under_add", "alp", 0, 0, "", 
--    {
--      0.0, 0, ObjGet( "spr_mgfate_rpl_decks_under_add" ).alp,
--      0.3, 0, 0
--    } );

end;
--*********************************************************************************************************************
function private.NextTurn () -- ход

  ObjAnimate( "spr_mgfate_rpl_progress_bar_stripe", "scale_y", 0, 0, "", 
    {
      0.0, 0, ObjGet( "spr_mgfate_rpl_progress_bar_stripe" ).scale_y,
      0.3, 0, ObjGet( "spr_mgfate_rpl_progress_bar_stripe" ).scale_y + ( 1 / private.ROUNDS[ private.mode ] )
    } );

  ObjAnimate( "spr_mgfate_rpl_progress_bar_add", "pos_y", 0, 0, "", 
    {
      0.0, 0, ObjGet( "spr_mgfate_rpl_progress_bar_add" ).pos_y,
      0.3, 0, ObjGet( "spr_mgfate_rpl_progress_bar_add" ).pos_y - ( private.LIGHT_HEIGHT / private.ROUNDS[ private.mode ] )
    } );
    
  if ( private.ROUNDS[ private.mode ] > ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].player.progress + 1 ) then

    ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].player.progress = ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].player.progress + 1;

    if ( math.fmod( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].player.progress, 2 ) ~= 1 ) then
      --DbgTrace("NextTurn grays");    
      private.NewCard( "grays" );
      --private.RULES[ "family_house" ]();

    else
      --DbgTrace("NextTurn atropos");    
      private.NewCard( "atropos" );
      ObjSet( "tmr_mgfate_rpl_turn", { playing = 1, time = 1.5, endtrig = function () private.AtroposPutCard();  end } );               
           
    end;

  else -- last step

    ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].player.progress = ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].player.progress + 1;
    --DbgTrace( "Steps over" );
    private.CheckWin();

  end;

end;
--*********************************************************************************************************************
function private.EndOfTurn ( except_card ) -- конец хода
  
  int.Lock( true );

  if ( not except_card ) then
    except_card = "";
  end;
  
  -- след ход
  local func_3 = function ()

    private.RULES.up_hp = 0;
    private.RULES.down_hp = 0;    
    private.UnwrapCard( "obj_mgfate_rpl_field_atropos" );
    private.UnwrapCard( "obj_mgfate_rpl_field_grays" );       
    private.NextTurn();
    
  end;    
  
  -- дамажимся
  local func_2 = function ()

    for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ] do
      
      if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 2 ] == "field" ) and
         ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 1 ] ~= except_card ) then
         --DbgTrace("конец хода выполняем "..ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 1 ]);                  
        private.RULES[ ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "atropos" ][ i ][ 1 ] ]();
         
      end;
      
    end;  
    private.HpDown( private.RULES.down_hp );
    if ( private.RULES.down_hp ~= 0 ) then
       ObjSet( "tmr_mgfate_rpl_turn", { playing = 1, time = 0.75, endtrig = function () func_3() end } );     
    else
       ObjSet( "tmr_mgfate_rpl_turn", { playing = 1, time = 0.05, endtrig = function () func_3() end } );         
    end;
  
  end;  
  
  -- лечимся
  local func_1 = function ()

    for i = 1, #ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ] do
      
      if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 2 ] == "field" ) and
         ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ] ~= except_card ) then
         --DbgTrace("конец хода выполняем "..ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ]);         
        private.RULES[ ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ][ "grays" ][ i ][ 1 ] ]();
         
      end;
      
    end;

    private.HpUp( private.RULES.up_hp );  
    ObjSet( "tmr_mgfate_rpl_turn", { playing = 1, time = 0.75, endtrig = function () func_2() end } ); 
  
  end;
  
  func_1();
  
end;
--*********************************************************************************************************************
function private.CheckWin( )

  if ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].player.life <= 0 ) then

--DbgTrace( "YOU LOSE" );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_heartbroke" );
    ObjSet( "anm_mgfate_rpl_heart_break", { alp = 1 } );
    AnimPlay( "anm_mgfate_rpl_heart_break", "DoAnim", function () ObjSet( "anm_mgfate_rpl_heart_break", { alp = 0 } ); public.Reset(); end );    
  
  elseif ( ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].player.life > 0 ) and
           ( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].player.progress == private.ROUNDS[ private.mode ] ) ) then

--DbgTrace( "YOU WIN" );
    private.Win();
  
  end;

end;
--*********************************************************************************************************************
function private.HpDown( cnt )
  --DbgTrace("DOWN hp - "..cnt)    
  if ( cnt ~= 0 ) then
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_lesshp" );

    ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].player.life = ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].player.life - cnt;

    ObjSet( "anm_mgfate_rpl_health_down", { alp = 1 } );
    --int.Lock( true );

    local func_end = function ()

      ObjSet( "anm_mgfate_rpl_health_down", { alp = 0 } );
      --int.Lock( false );
      private.CheckWin();

    end;

    AnimPlay( "anm_mgfate_rpl_health_down", "DoAnim", func_end );
    ObjSet( "txt_mgfate_rpl_hp_cnt", { text = "-"..tostring( cnt ) } );
    ObjAnimate( "txt_mgfate_rpl_hp_cnt", "pos_y", 0, 0, function ()   ObjSet( "txt_mgfate_rpl_hp_heart", { text = tostring( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].player.life ) } ); end, 
    {
      0.0, 0, 6,
      0.1, 0, 6,
      0.7, 3, -30
    } );
    ObjAnimate( "txt_mgfate_rpl_hp_cnt", "alp", 0, 0, "", 
    {
      0.0, 0, 0,
      0.1, 0, 0,
      0.2, 0, 1,
      0.6, 0, 1,
      0.7, 0, 0
    } );
    ObjAnimate( "spr_mgfate_rpl_hp_heart", "alp", 0, 0, "", 
    {
      0.0, 0, 1,
      0.1, 0, 0,
      0.7, 0, 0,
      0.8, 0, 1,
    } );
    
  else 
    
    private.CheckWin();   
    
  end;

end;
--*********************************************************************************************************************
function private.HpUp( cnt )
  --DbgTrace("UP hp - "..cnt)        
  
  if ( cnt ~= 0 ) then  
    
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_morehp" );

    ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].player.life = ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].player.life + cnt;

    ObjSet( "anm_mgfate_rpl_health_up", { alp = 1 } );
    --int.Lock( true );

    local func_end = function ()

      ObjSet( "anm_mgfate_rpl_health_up", { alp = 0 } );
      --int.Lock( false );
      private.CheckWin();

    end;

    AnimPlay( "anm_mgfate_rpl_health_up", "DoAnim", "" );
    ObjSet( "txt_mgfate_rpl_hp_cnt", { text = "+"..tostring( cnt ) } );
    ObjAnimate( "txt_mgfate_rpl_hp_cnt", "pos_y", 0, 0, function ()   ObjSet( "txt_mgfate_rpl_hp_heart", { text = tostring( ng_global.progress[ "rpl" ][ "win_mgfate_rpl" ].player.life ) } ); end, 
    {
      0.0, 0, 6,
      0.1, 0, 6,
      0.7, 3, -30
    } );
    ObjAnimate( "txt_mgfate_rpl_hp_cnt", "alp", 0, 0, func_end, 
    {
      0.0, 0, 0,
      0.1, 0, 0,
      0.2, 0, 1,
      0.6, 0, 1,
      0.71, 0, 0
    } );
    --ObjAnimate( "spr_mgfate_rpl_hp_heart", "alp", 0, 0, "", 
    --{
    --  0.0, 0, 1,
    --  0.1, 0, 0,
    --  0.7, 0, 0,
    --  0.8, 0, 1,
    --} );
    
  else 
    
    private.CheckWin();   
    
  end;

end;