-- name=mg_mgstatue_rpl
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_mgstatue_rpl";
  game.relations[ "mg_mgstatue_rpl" ].exitroom = "rm_replayroom";
  
  private.objs = { "ball","car","cat","girl","luggage","man","man1","people","pointer","toy", 
                   "sign", "bag", "bag1", "bike", "drawing", "kettle", "man2", "squirrel", "thorns", "wheel" 
                 };
  private.state = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }; 
 
  ObjSet( "spr_mgstatue_rpl_brokenlantern", { event_mdown = private.get_brokenlantern } ); 
  
  for i=1, #private.objs do
    ObjSet( "spr_mgstatue_rpl_final_"..private.objs[i], {
      --input = true,
      event_menter = function() private.ItemMEnter ( private.objs[i], true ); end,
      event_mleave = function() private.ItemMLeave ( private.objs[i], true ); end,
    } );
    ObjSet( "spr_mgstatue_rpl_init_"..private.objs[i], {
      --input = true,      
      drag = true,
      event_menter = function() private.ItemMEnter ( private.objs[i], false ); end,
      event_mleave = function() private.ItemMLeave ( private.objs[i], false ); end,
      event_startdrag = function() private.ItemStartDrag ( private.objs[i] ); end,
      event_dragdrop = function() private.ItemDragDrop ( private.objs[i] ); end,
      } );
  end;
  
  --------------------------------------------------------------------------------------------
  -- function win_mgstatue_rpl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_mgstatue_rpl" ] =
  {
    type = "click",
    get_obj = "spr_mgstatue_rpl_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_mgstatue_rpl = function ()

    if ( cmn.IsEventStart( "win_mgstatue_rpl" ) ) and not ( cmn.IsEventDone( "win_mgstatue_rpl" ) ) then

      private.Load();

    end;

  end;
  
  cmn.AddSubscriber( "win_mgstatue_rpl", win_mgstatue_rpl, private.room_objname );  

end;
  
--*********************************************************************************************************************
function private.Start ()
  
  cmn.MiniGameShow( "mgstatue_rpl" );
  
  ng_global.progress[ "rpl" ][ "win_mgstatue_rpl" ].state = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };  

end;
--*********************************************************************************************************************
function private.Load ()
  
  for i=1, #private.state do
    
    private.state[ i ] = ng_global.progress[ "rpl" ][ "win_mgstatue_rpl" ].state[ i ];
    if ( private.state[ i ] == 1 ) then
      ObjSet( "spr_mgstatue_rpl_init_"..private.objs[ i ], { alp = 0, input = false } );
      ObjSet( "spr_mgstatue_rpl_final_"..private.objs[ i ], { alp = 1, input = true } );
    else
    end;
    
  end;  

end;
--*********************************************************************************************************************
function public.PreOpen ()
 
 cmn.CallEventHandler( "win_mgstatue_rpl" ); 

  if cmn.IsEventDone( "win_mgstatue_rpl" ) then
    public.Reset();
    ng_global.progress[ "rpl" ][ "win_mgstatue_rpl" ].start = 0;
    ng_global.progress[ "rpl" ][ "win_mgstatue_rpl" ].done = 0;
  end;
  
  cmn.StopAllMus();
  cmn.PlayAudio( "mus", "audio/aud_amnesia_theme_mus", 1 );  

end;
--*********************************************************************************************************************
function public.Open () 

  if not ( cmn.IsEventStart( "win_mgstatue_rpl" ) ) then    
    private.Start();
  elseif cmn.IsEventStart( "win_mgstatue_rpl" ) then
    cmn.MiniGameShow( "mgstatue_rpl" );
  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  if ( cmn.IsEventStart( "win_mgstatue_rpl" ) and not cmn.IsEventDone( "win_mgstatue_rpl" ) ) then
    cmn.MiniGameHide();
  end;

end;
--*********************************************************************************************************************
function public.Reset ()
  
  private.state = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 }; 
  ng_global.progress[ "rpl" ][ "win_mgstatue_rpl" ].state = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };  
 
  for i=1, #private.state do
    ObjSet( "spr_mgstatue_rpl_init_"..private.objs[ i ], { alp = 1, input = true } );
    ObjSet( "spr_mgstatue_rpl_final_"..private.objs[ i ], { alp = 0, input = false } );
  end;

end;
--*********************************************************************************************************************
function public.Skip ()

  for i=1, #private.state do
    ObjSet( "spr_mgstatue_rpl_init_"..private.objs[ i ], { alp = 0, input = false } );
    ObjSet( "spr_mgstatue_rpl_final_"..private.objs[ i ], { alp = 1, input = true } );
  end;
  private.Win();

end;
--*********************************************************************************************************************
function private.ItemMEnter ( obj, isFinal )

  local item = "";
  
  if (isFinal) then    
    
    item = "spr_mgstatue_rpl_final_"..obj.."_light";
    ObjAnimate(item, "alp", 0, 0, "", 
    {
      0.0,0,ObjGet( item ).alp,
      0.2,0,1
    });
    item = "anm_mgstatue_rpl_final_"..obj.."_fx";
    AnimPlay( item, "DoAnim", "" );
    
  else
    
    cmn.SetCursor(CURSOR_GET);
    
    item = "spr_mgstatue_rpl_init_"..obj.."_light";
    ObjAnimate(item, "alp", 0, 0, "", 
    {
      0.0,0,ObjGet( item ).alp,
      0.2,0,1
    });
    
  end;

end;
--*********************************************************************************************************************
function private.ItemMLeave ( obj, isFinal )
  
  cmn.SetCursor(CURSOR_DEFAULT);
  
  local item = "";
  
  if (isFinal) then
    
    item = "spr_mgstatue_rpl_final_"..obj.."_light";
    ObjAnimate(item, "alp", 0, 0, "", 
    {
      0.0,0,ObjGet( item ).alp,
      0.2,0,0
    });
    
  else
    
    item = "spr_mgstatue_rpl_init_"..obj.."_light";
    ObjAnimate(item, "alp", 0, 0, "", 
    {
      0.0,0,ObjGet( item ).alp,
      0.2,0,0
    });
    
  end;


end;
--*********************************************************************************************************************
function private.ItemStartDrag ( obj )
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mgstatue_take" );
  ObjSet( "spr_mgstatue_rpl_init_"..obj, { pos_z = 10 } );

end;
--*********************************************************************************************************************
function private.ItemDragDrop ( obj )
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mgstatue_put" );
  local item = "spr_mgstatue_rpl_init_"..obj;
  
  ObjSet( item, { pos_z = 0 } );
  
  if ( cmn.ApplyObj( item, "obj_mgstatue_rpl_use_"..obj, true ) ) then
    
    ObjSet( item, { alp = 0, input = false } );
    ObjSet( "spr_mgstatue_rpl_final_"..obj, { alp = 1, input = true } );
    
    local ind = 0;
    for i=1, #private.objs do
      if ( private.objs[ i ] == obj  ) then
        ind = i;
        break;
      end;
    end;
    
    private.state[ ind ] = 1;
    
    private.CheckWin();
    
  end;

end;
--*********************************************************************************************************************
function private.WinEnd ()

  cmn.MiniGameHide();
  
  cmn.SetEventDone( "win_mgstatue_rpl" );
  cmn.CallEventHandler( "win_mgstatue_rpl" );
  
  cmn.GotoRoom( "rm_replayroom" );

end;
--*********************************************************************************************************************
function private.Win ()  

  ObjAnimate("spr_mgstatue_rpl_back", "alp", 0, 0, function () private.WinEnd(); end, {0.0,0,1,  0.3,0,1});  

end;
--*********************************************************************************************************************
function private.CheckWin ()
  
  local win = true;
  
  for i=1, #private.state do
    if ( private.state[ i ] == 0 ) then
      win = false;
      break;
    end;
  end;
  
  if ( win ) then
    private.Win();
  else
    for i=1, #private.state do
      ng_global.progress[ "rpl" ][ "win_mgstatue_rpl" ].state[ i ] = private.state[ i ];
    end;
  end;
  
end;
--*********************************************************************************************************************