-- name=mg_ondoor_rpl
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_ondoor_rpl";
  game.relations[ "mg_ondoor_rpl" ].exitroom = "rm_replayroom";

  ObjMultiSet(
  {
    { "spr_ondoor_rpl_cleaningagent",           { event_mdown = private.get_cleaningagent } },
    { "spr_ondoor_rpl_controltowerkey",         { event_mdown = private.get_controltowerkey } },
    { "spr_ondoor_rpl_controltowerkey_trinket", { event_mdown = private.get_controltowerkey } },
  } );

  private.Init();
  private.Animations();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_ondoor_rpl = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;
  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    

      visible_sparkle_area = false;

    end;

    local visible_sparkle_ho = true;  

    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    

      visible_sparkle_ho = false;

    end;

    local mas_parent_gfx = 
    {
      private.room_objname
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then

      ObjMultiSet( table_multiset );

    end;

  end;

  cmn.AddSubscriber( "update_game_mode_ondoor_rpl", update_game_mode_ondoor_rpl, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_ondoor_rpl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_ondoor_rpl" ] =
  {
    type = "click",
    get_obj = "spr_ondoor_rpl_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_ondoor_rpl = function ()

    if ( cmn.IsEventStart( "win_ondoor_rpl" ) ) and not ( cmn.IsEventDone( "win_ondoor_rpl" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_ondoor_rpl", win_ondoor_rpl, private.room_objname );
  

end;
--*********************************************************************************************************************
function private.Init ()

  private.locks_count   = 6;
  private.chains_count  = 4;
  private.buttons_count = 4;

  private.lock_pos = { { 587, 251 }, { 662, 380 }, { 586, 506 }, { 437, 509 }, { 362, 380 }, { 438, 252 } };
  private.chain = { { 1, 4, 3, 2, 1 }, { 3, 6, 1, 2, 3 }, { 4, 1, 6, 5, 4 }, { 6, 3, 4, 5, 6 } };
  private.button = { 1, 3, 4, 6 };
  private.button_input = { 3, 4, 1, 2 };

  for b = 1, private.buttons_count do

    ObjSet( "obj_ondoor_rpl_button_"..b,
    {
      event_mdown  = function () private.ButtonClick( b ) end,
      event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
    } );

  end;

end;
--*********************************************************************************************************************
function private.Start ()
  
  ng_global.progress[ "rpl" ][ "win_ondoor_rpl" ].lock  = { 3, 1, 2, 5, 4, 6 };
  ng_global.progress[ "rpl" ][ "win_ondoor_rpl" ].button = nil;
  
  cmn.MiniGameShow( "ondoor_rpl" ); 
    
end;
--*********************************************************************************************************************
function private.Load ()

  for i = 1, private.locks_count do

    local lock = ng_global.progress[ "rpl" ][ "win_ondoor_rpl" ].lock[ i ];

    ObjSet( "obj_ondoor_rpl_lock_"..lock, { pos_x = private.lock_pos[ i ][ 1 ], pos_y = private.lock_pos[ i ][ 2 ] } );

  end;  

  local button = ng_global.progress[ "rpl" ][ "win_ondoor_rpl" ].button;

  if ( button ) then

    ObjSet( "spr_ondoor_rpl_lock_"..ng_global.progress[ "rpl" ][ "win_ondoor_rpl" ].lock[ button ].."_light", { alp = 1 } );

    private.SetInput( button );

  end;

end;
--*********************************************************************************************************************
function public.PreOpen () 
  
  cmn.CallEventHandler( "win_ondoor_rpl" ); 
  
  if cmn.IsEventDone( "win_ondoor_rpl" ) then
    public.Reset();
    ng_global.progress[ "rpl" ][ "win_ondoor_rpl" ].start = 0;
    ng_global.progress[ "rpl" ][ "win_ondoor_rpl" ].done = 0;
  end;

  cmn.StopAllMus();
  cmn.PlayAudio( "mus", "audio/aud_amnesia_theme_mus", 1 );

end;
--*********************************************************************************************************************
function public.Open () 
  
  if not ( cmn.IsEventStart( "win_ondoor_rpl" ) ) then    
    private.Start();
  elseif cmn.IsEventStart( "win_ondoor_rpl" ) then
    cmn.MiniGameShow( "ondoor_rpl" );
  end;

--  if ( not cmn.IsEventDone( "win_ondoor_rpl" ) ) then
--
--    cmn.MiniGameShow( "ondoor_rpl" );
--    --common_impl.PassingMgStart( "ondoor_rpl" );
--
--  end;
--
--  if ( not cmn.IsEventDone( "opn_ondoor_rpl" ) ) then
--
--    cmn.SetEventDone( "opn_ondoor_rpl" );
--
--  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  cmn.MiniGameHide();
  --common_impl.PassingMgWin( "ondoor_rpl" );

end;
--*********************************************************************************************************************
function public.Reset ()

  ng_global.progress[ "rpl" ][ "win_ondoor_rpl" ].lock  = { 3, 1, 2, 5, 4, 6 };
  ng_global.progress[ "rpl" ][ "win_ondoor_rpl" ].button = nil;

  for i = 1, private.locks_count do

    ObjSet( "obj_ondoor_rpl_lock_"..ng_global.progress[ "rpl" ][ "win_ondoor_rpl" ].lock[ i ], { pos_x = private.lock_pos[ i ][ 1 ], pos_y = private.lock_pos[ i ][ 2 ] } );
    ObjSet( "spr_ondoor_rpl_lock_"..i.."_light",                                           { alp = 0 } );

  end;  

  private.SetInput();
  
  ObjSet( "obj_ondoor_rpl_cabinet_open", { alp = 0 } );

end;
--*********************************************************************************************************************
function public.Skip ()

  int.Lock( true );

  ObjAnimate( "obj_ondoor_rpl_cabinet_open", "alp", 0, 0,
  function ()

    int.Lock( false );

    private.Win();

  end, 
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
function private.Win ()

  cmn.MiniGameHide();
  
  cmn.SetEventDone( "win_ondoor_rpl" );
  cmn.CallEventHandler( "win_ondoor_rpl" );
  
  cmn.GotoRoom( "rm_replayroom" );

end;
--*********************************************************************************************************************
function private.IsWin ()

  for i = 1, private.locks_count do

    if ( private.locks[ i ] ~= i ) then

      private.SaveProgress();

      return false;

    end;

  end;

  return true;

end;
--*********************************************************************************************************************
function private.ButtonClick ( idx )

  local current = ng_global.progress[ "rpl" ][ "win_ondoor_rpl" ].button;

  int.Lock( true );

  if ( current ) then

    if ( current == idx ) then

      local func_end = function ()

        int.Lock( false );

        ng_global.progress[ "rpl" ][ "win_ondoor_rpl" ].button = nil;

        private.SetInput();

      end;
      
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_keystand_click" );
      ObjAnimate( "spr_ondoor_rpl_lock_"..ng_global.progress[ "rpl" ][ "win_ondoor_rpl" ].lock[ private.button[ idx ] ].."_light", "alp", 0, 0, func_end, 
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

    else

      private.locks = {};

      for i = 1, private.locks_count do

        private.locks[ i ] = ng_global.progress[ "rpl" ][ "win_ondoor_rpl" ].lock[ i ];

      end;

      local func_end = function ()

        int.Lock( false );
        private.SetInput();

        for c = 1, private.chains_count do

          private.locks[ private.chain[ current ][ c + 1 ] ] = ng_global.progress[ "rpl" ][ "win_ondoor_rpl" ].lock[ private.chain[ current ][ c ] ];

        end;

        if ( private.IsWin() ) then

          int.Lock( true );

          ObjAnimate( "obj_ondoor_rpl_cabinet_open", "alp", 0, 0,
          function ()

            int.Lock( false );

            private.SaveProgress();
            private.Win();

          end, 
          {
            0.0, 3, 0.0,
            0.2, 3, 0.0,
            0.5, 3, 1.0,
          } );

        end;

      end;

      ObjAnimate( "spr_ondoor_rpl_lock_"..ng_global.progress[ "rpl" ][ "win_ondoor_rpl" ].lock[ private.button[ idx ] ].."_light", "alp", 0, 0, "", 
      {
        0.0, 3, 0,
        0.3, 3, 1,
        0.5, 3, 1,
        0.8, 3, 0,
      } );

      ObjAnimate( "spr_ondoor_rpl_lock_"..ng_global.progress[ "rpl" ][ "win_ondoor_rpl" ].lock[ private.button[ current ] ].."_light", "alp", 0, 0, func_end, 
      {
        0.0, 3, 1,
        0.5, 3, 1,
        0.8, 3, 0,
        1.0, 3, 0,
      } );

      
      local func_end_aud = function ()
      
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_keystand_switch" );
        
      end;
    
      local chain = private.chain[ current ];

      ObjSet( "tmr_ondoor_rpl_1", { playing = 1, time = 0.5, endtrig = func_end_aud } ); 
      for c = 1, private.chains_count do

        local pos_1 = private.lock_pos[ chain[ c ] ];
        local pos_2 = private.lock_pos[ chain[ c + 1 ] ];

        ObjAnimate( "obj_ondoor_rpl_lock_"..private.locks[ chain[ c ] ], "pos_xy", 0, 0, "", 
        {
          0.0, 3, pos_1[ 1 ], pos_1[ 2 ],
          0.5, 3, pos_1[ 1 ], pos_1[ 2 ],
          1.0, 3, pos_2[ 1 ], pos_2[ 2 ],
        } );

      end;

    end;

  else

    private.SetInput( idx );

    local func_end = function ()

      int.Lock( false );

      ng_global.progress[ "rpl" ][ "win_ondoor_rpl" ].button = idx;

    end;
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_keystand_click" );
    ObjAnimate( "spr_ondoor_rpl_lock_"..ng_global.progress[ "rpl" ][ "win_ondoor_rpl" ].lock[ private.button[ idx ] ].."_light", "alp", 0, 0, func_end, 
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

  end;

end;
--*********************************************************************************************************************
function private.SaveProgress ()

  for i = 1, private.locks_count do

    ng_global.progress[ "rpl" ][ "win_ondoor_rpl" ].lock[ i ] = private.locks[ i ];

  end;

  ng_global.progress[ "rpl" ][ "win_ondoor_rpl" ].button = nil;

end;
--*********************************************************************************************************************
function private.SetInput ( idx )

  if ( not idx ) then

    for b = 1, private.buttons_count do

      ObjSet( "obj_ondoor_rpl_button_"..b, { input = true } );

    end;

  else

    for b = 1, private.buttons_count do

      ObjSet( "obj_ondoor_rpl_button_"..b, { input = false } );

    end;

    ObjSet( "obj_ondoor_rpl_button_"..idx,                         { input = true } );
    ObjSet( "obj_ondoor_rpl_button_"..private.button_input[ idx ], { input = true } );

  end;

end;
--*********************************************************************************************************************
function private.Animations ()

  ObjAnimate( "obj_ondoor_rpl_controltowerkey_trinket", "ang", 1, 0, "", 
  {
    0.0, 3, -0.05,
    1.3, 3,  0.05,
    2.6, 3, -0.05,
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************