-- name=mg_onsafedoor_rpl
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_onsafedoor_rpl";
  game.relations[ "mg_onsafedoor_rpl" ].exitroom = "rm_replayroom";
  --ObjSet( "spr_onsafedoor_rpl_switchroomplan", { event_mdown = private.get_switchroomplan } );

  private.limit_x = {
    { { -3,163}, {-116,150}, { -56, 68} },
    { {-52,114}, { -62, 90}, {-113,123} },
    { {-40,126}, { -90,119}, { -56, 65} }
  };
  private.init_x = {
    { 163, -116, 21   },
    { -51,  -61, -112 },
    { 125,  107, 65   }
  };
  private.pointer_pos = {
    {-84,280}, {-102,184}, {-35,132}, {-108,70}, {-26,31}, 
    {-119,-25}, {-33,-70}, {-110,-137}, {-36,-201}, {-89,-289}
  };

  private.drag_offset = 0;
  private.init_y = 0;

  private.current_num = 1;

  for pin=1, 3 do
    for part=1, 3 do
      ObjSet( "spr_onsafedoor_rpl_pin_"..pin.."_part_"..part, {
        input = true,
        event_menter = function () cmn.SetCursor(CURSOR_HAND); end,
        event_mleave = function () cmn.SetCursor(CURSOR_DEFAULT); private.PartDrop( pin, part ); end,
        event_mdown = function () private.PartClick( pin, part );  end,
        event_mup = function () private.PartDrop( pin, part ); cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_onsafedoor_release" );  end,
      });
    end;
  end;

  for i=1, 10 do
    ObjSet( "obj_onsafedoor_rpl_pin_num_"..i, {
      event_mdown = function () private.NumClick( i );  end
    } );
  end;
  --------------------------------------------------------------------------------------------
  -- function win_onsafedoor_rpl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_onsafedoor_rpl" ] =
  {
    type = "click",
    get_obj = "spr_onsafedoor_rpl_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_onsafedoor_rpl = function ()

    if ( cmn.IsEventStart( "win_onsafedoor_rpl" ) ) and not ( cmn.IsEventDone( "win_onsafedoor_rpl" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_onsafedoor_rpl", win_onsafedoor_rpl, private.room_objname );

end;
--*********************************************************************************************************************
function private.Start ()

  ng_global.progress[ "rpl" ][ "win_onsafedoor_rpl" ].current_num = 1;
  ng_global.progress[ "rpl" ][ "win_onsafedoor_rpl" ].cur_x = {
    { 163, -116, 21   },
    { -51,  -61, -112 },
    { 125,  107, 65   }
  };  

  cmn.MiniGameShow( "onsafedoor_rpl" );

end;
--*********************************************************************************************************************
function private.Load ()

  private.current_num = ng_global.progress[ "rpl" ][ "win_onsafedoor_rpl" ].current_num;

  for i=1, (private.current_num - 1) do
    ObjSet( "spr_onsafedoor_rpl_light_step_"..i, { alp = 1 } );
    ObjSet( "obj_onsafedoor_rpl_pin_num_"..i, { input = false } );
    ObjSet( "spr_onsafedoor_rpl_pin_num_"..i, { alp = 1 } );
  end;

  ObjSet( "spr_onsafedoor_rpl_pointer", { 
    pos_x = private.pointer_pos[ private.current_num ][ 1 ], 
    pos_y = private.pointer_pos[ private.current_num ][ 2 ]
  } );

  for pin=1, 3 do
    for part=1, 3 do
      ObjSet( "spr_onsafedoor_rpl_pin_"..pin.."_part_"..part, {
        pos_x = ng_global.progress[ "rpl" ][ "win_onsafedoor_rpl" ].cur_x[ pin ][ part ]
      });
    end;
  end;

end;
--*********************************************************************************************************************
function public.PreOpen () 
  
  cmn.CallEventHandler( "win_onsafedoor_rpl" ); 

  if cmn.IsEventDone( "win_onsafedoor_rpl" ) then
    public.Reset();
    ng_global.progress[ "rpl" ][ "win_onsafedoor_rpl" ].start = 0;
    ng_global.progress[ "rpl" ][ "win_onsafedoor_rpl" ].done = 0;
  end;
  
  cmn.StopAllMus();
  cmn.PlayAudio( "mus", "audio/aud_amnesia_theme_mus", 1 );  

end;
--*********************************************************************************************************************
function public.Open () 

  if not ( cmn.IsEventStart( "win_onsafedoor_rpl" ) ) then    
    private.Start();
  elseif cmn.IsEventStart( "win_onsafedoor_rpl" ) then
    cmn.MiniGameShow( "onsafedoor_rpl" );
  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  if ( cmn.IsEventStart( "win_onsafedoor_rpl" ) and not cmn.IsEventDone( "win_onsafedoor_rpl" ) ) then
    cmn.MiniGameHide();
  end;

end;
--*********************************************************************************************************************
function public.Reset ()

  private.current_num = 1;
  ng_global.progress[ "rpl" ][ "win_onsafedoor_rpl" ].current_num = 1;
  ng_global.progress[ "rpl" ][ "win_onsafedoor_rpl" ].cur_x = {
    { 163, -116, 21   },
    { -51,  -61, -112 },
    { 125,  107, 65   }
  }; 

  for i=1, 10 do
    ObjSet( "spr_onsafedoor_rpl_light_step_"..i, { alp = 0 } );
    ObjSet( "obj_onsafedoor_rpl_pin_num_"..i, { input = true } );
    ObjSet( "spr_onsafedoor_rpl_pin_num_"..i, { alp = 0 } );
  end; 

  ObjSet( "spr_onsafedoor_rpl_pointer", { 
    pos_x = private.pointer_pos[ 1 ][ 1 ], 
    pos_y = private.pointer_pos[ 1 ][ 2 ]
  } );

  for pin=1, 3 do
    for part=1, 3 do
      ObjSet( "spr_onsafedoor_rpl_pin_"..pin.."_part_"..part, {
        pos_x = ng_global.progress[ "rpl" ][ "win_onsafedoor_rpl" ].cur_x[ pin ][ part ]
      });
    end;
  end;
  
  ObjSet( "spr_onsafedoor_rpl_pin_1_base", { pos_x = 568 } );
  ObjSet( "spr_onsafedoor_rpl_pin_2_base", { pos_x = 616 } );
  ObjSet( "spr_onsafedoor_rpl_pin_3_base", { pos_x = 606 } );

end;
--*********************************************************************************************************************
function public.Skip ()

  for i=private.current_num, 10 do
    ObjAnimate( "spr_onsafedoor_rpl_light_step_"..i, "alp", 0, 0, "", 
    {
      0.0,0,0,
      0.3,0,1
    });
    ObjAnimate( "spr_onsafedoor_rpl_pin_num_"..i, "alp", 0, 0, "", 
    {
      0.0,0,0,
      0.3,0,1
    });
    ObjSet( "obj_onsafedoor_rpl_pin_num_"..i, { input = false } );
  end; 

  ObjAnimate( "spr_onsafedoor_rpl_pointer", "pos_xy", 0, 0, function () private.Win(); end, 
  {
    0.0,0,private.pointer_pos[ private.current_num ][ 1 ],private.pointer_pos[ private.current_num ][ 2 ],
    0.3,0,private.pointer_pos[ 10 ][ 1 ],private.pointer_pos[ 10 ][ 2 ]
  });

end;
--*********************************************************************************************************************
function private.WinEnd ()

  cmn.MiniGameHide();

  cmn.SetEventDone( "win_onsafedoor_rpl" );
  cmn.CallEventHandler( "win_onsafedoor_rpl" );

  cmn.GotoRoom( "rm_replayroom" );

end;
--*********************************************************************************************************************
function private.Win ()
  
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_onsafedoor_win" );  

  local tme = 1.2;
  ObjAnimate( "spr_onsafedoor_rpl_coghwheel_up", "ang", 0, 0, "", 
  {
    0.0,0,0.0,
    tme,1,6.28
  });
  ObjAnimate( "spr_onsafedoor_rpl_coghwheel_down", "ang", 0, 0, "", 
  {
    0.0,0,0.0,
    tme,1,-6.28
  });

  ObjAnimate( "spr_onsafedoor_rpl_pin_1_base", "pos_x", 0, 0, "", 
  {
    0.0,0,568,
    tme,1,1318
  });
  ObjAnimate( "spr_onsafedoor_rpl_pin_2_base", "pos_x", 0, 0, "", 
  {
    0.0,0,616,
    tme,1,1366
  });

  ObjAnimate( "spr_onsafedoor_rpl_pin_3_base", "pos_x", 0, 0, 
  function()
    int.Lock( false );
    private.WinEnd();
  end, 
  {
    0.0,0,606,
    tme,1,1356
  });


end;
--*********************************************************************************************************************
function private.PartClick ( pin, part )
  
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_onsafedoor_click" );

  local init_cur_pos = GetZoomCursorPos();
  private.drag_offset = ObjGet( "spr_onsafedoor_rpl_pin_"..pin.."_part_"..part ).pos_x - init_cur_pos[ 1 ];

  private.PartDrag( pin, part );

end;
--*********************************************************************************************************************
function private.PartDrag ( pin, part )

  local pos = GetZoomCursorPos();

  local pos_x1 = pos[ 1 ] + private.drag_offset;

  if ( pos_x1 < private.limit_x[ pin ][ part ][ 1 ] ) then
    pos_x1 = private.limit_x[ pin ][ part ][ 1 ];
  elseif ( pos_x1 > private.limit_x[ pin ][ part ][ 2 ] ) then
    pos_x1 = private.limit_x[ pin ][ part ][ 2 ];
  end;

  ObjSet( "spr_onsafedoor_rpl_pin_"..pin.."_part_"..part, { pos_x = pos_x1 } )

  ObjSet( "tmr_onsafedoor_rpl_part", { playing = 1, time = 0.01, endtrig = function () private.PartDrag( pin, part ) end } );

end;
--*********************************************************************************************************************
function private.PartDrop ( pin, part )  
    
  ObjSet( "tmr_onsafedoor_rpl_part", { playing = false } ); 

  ng_global.progress[ "rpl" ][ "win_onsafedoor_rpl" ].cur_x[ pin ][ part ] = ObjGet( "spr_onsafedoor_rpl_pin_"..pin.."_part_"..part ).pos_x;

end;
--*********************************************************************************************************************
function private.NumClick ( num )

  local func_end = function ()

    int.Lock( false );

    ObjSet( "obj_onsafedoor_rpl_pin_num_"..num, { input = false } );
    ng_global.progress[ "rpl" ][ "win_onsafedoor_rpl" ].current_num = private.current_num;

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_onsafedoor_button" );    

  if ( num == private.current_num ) then

    ObjAnimate("spr_onsafedoor_rpl_pin_num_"..num, "alp", 0, 0, "", 
    {
      0.0,0,0,
      0.2,0,1
    });

    if num == 10 then

      ObjAnimate( "spr_onsafedoor_rpl_light_step_10", "alp", 0, 0, 
      function ()
        private.Win();
      end,
      {
        0.0,0,0,
        0.3,0,1
      });

    else

      local old_x = private.pointer_pos[ private.current_num ][ 1 ];    
      local old_y = private.pointer_pos[ private.current_num ][ 2 ];
      local new_x = private.pointer_pos[ private.current_num + 1 ][ 1 ];    
      local new_y = private.pointer_pos[ private.current_num + 1 ][ 2 ];
      
      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_onsafedoor_move" );

      ObjAnimate( "spr_onsafedoor_rpl_light_step_"..num, "alp", 0, 0, "", 
      {
        0.0,0,0,
        0.3,0,1
      });
      ObjAnimate( "spr_onsafedoor_rpl_pointer", "pos_xy", 0, 0, func_end, 
      {
        0.0,0,old_x,old_y,
        0.5,0,old_x,old_y,
        0.9,0,new_x,new_y
      });

      private.current_num = private.current_num + 1;

    end;

  else

    ObjAnimate("spr_onsafedoor_rpl_pin_num_"..num, "alp", 0, 0, "", 
    {
      0.0,0,0,
      0.2,0,1,
      0.3,0,1,
      0.5,0,0
    });

    local old_x = private.pointer_pos[ private.current_num ][ 1 ];    
    local old_y = private.pointer_pos[ private.current_num ][ 2 ];
    local new_x = private.pointer_pos[ 1 ][ 1 ];    
    local new_y = private.pointer_pos[ 1 ][ 2 ];

    for i=1, (private.current_num - 1) do
      ObjAnimate( "spr_onsafedoor_rpl_light_step_"..i, "alp", 0, 0, "", 
      {
        0.0,0,1,
        0.3,0,0
      });
      ObjAnimate( "spr_onsafedoor_rpl_pin_num_"..i, "alp", 0, 0, "", 
      {
        0.0,0,1,
        0.3,0,1,
        0.5,0,0
      });
      ObjSet( "obj_onsafedoor_rpl_pin_num_"..i, { input = true } );
    end;

    ObjAnimate( "spr_onsafedoor_rpl_pointer", "pos_xy", 0, 0, function () int.Lock( false ); end, 
    {
      0.0,0,old_x,old_y,
      0.5,0,old_x,old_y,
      0.9,0,new_x,new_y
    });

    private.current_num = 1;

  end;

end;
--*********************************************************************************************************************