-- name=mg_onthelid_rpl
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_onthelid_rpl";
  game.relations[ "mg_onthelid_rpl" ].exitroom = "rm_replayroom";

  private.Init();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_onthelid_rpl = function ()
      
      local table_multiset = {};
      local visible_sparkle_area = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
        visible_sparkle_area = false;
      end;
      local visible_sparkle_ho = true;  
      if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
        visible_sparkle_ho = false;
      end;

      local mas_parent_gfx = 
      {
        private.room_objname
      };
      common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

      if ( #table_multiset > 0 ) then
        ObjMultiSet( table_multiset );
      end;

    end;
    cmn.AddSubscriber( "update_game_mode_onthelid_rpl", update_game_mode_onthelid_rpl, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_onthelid_rpl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_onthelid_rpl" ] =
  {
    type = "click",
    get_obj = "spr_onthelid_rpl_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_onthelid_rpl = function ()


    if ( cmn.IsEventStart( "win_onthelid_rpl" ) ) and not ( cmn.IsEventDone( "win_onthelid_rpl" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_onthelid_rpl", win_onthelid_rpl, private.room_objname );

end;
--*********************************************************************************************************************
function private.Init ()

  private.field_row = 7;
  private.field_col = 7;
  private.fuel = 12;

  private.enemy =
  {
    { 0, 0, 1, 0, 0, 0, 1 },
    { 0, 0, 0, 0, 1, 0, 0 },
    { 0, 1, 1, 0, 1, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 1 },
    { 0, 0, 0, 1, 0, 0, 0 },
    { 1, 0, 0, 0, 0, 1, 1 },
    { 0, 0, 1, 0, 0, 0, 0 },
  };

  for r = 1, private.field_row do

    for c = 1, private.field_col do

      local name = "obj_onthelid_rpl_field_cell_"..r.."_"..c;

      ObjSet( name,
      {
        input = false,
        event_mdown  = function () private.DoorClick( r, c ); end,
        event_menter = function () private.DoorEnter( r, c ); end,
        event_mleave = function () private.DoorLeave( r, c ); end,
        croprect_init = true,
        croprect_x = -35,
        croprect_y = -35,
        croprect_h =  70,
        croprect_w =  70,
      } );

    end;

  end;

  ObjSet( "obj_onthelid_rpl_field_cell_1_2", { input = true } );
  ObjSet( "obj_onthelid_rpl_field_cell_2_1", { input = true } );

  private.Anims();

end;
--*********************************************************************************************************************
function private.Start ()

  ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].field =
  {
    { 9, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0 },
  };

  ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].plane = { [ "row" ] = 1, [ "col" ] = 1, [ "fuel" ] = 12, [ "ang" ] = 0 };
  ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].direction = nil;
  ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].label = {};


  cmn.MiniGameShow( "onthelid_rpl" );  

end;
--*********************************************************************************************************************
function private.Load ()

  local plane = ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].plane;-- = { [ "row" ] = 1, [ "col" ] = 1, [ "fuel" ] = 12, [ "ang" ] = 0 };

  local path_params =
  {
    { "path_start", 0 },
    { "path_start", -1.57 },
    { "path_line", 0 },
    { "path_line", 1.57 },
    { "path_corner", 0 },
    { "path_corner", -1.57 },
    { "path_corner", 3.14 },
    { "path_corner", 1.57 },
  };

  for r = 1, private.field_row do

    for c = 1, private.field_col do

      ObjSet( "obj_onthelid_rpl_field_cell_"..r.."_"..c, { input = false } );

      local idx = ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].field[ r ][ c ];

      if ( ( idx > 0 ) and ( idx < 9 ) ) then

        ObjSet( "spr_onthelid_rpl_field_path_"..r.."_"..c, { alp = 1, ang = path_params[ idx ][ 2 ], res = "assets/levels/level1/mg_onthelid/layers/"..path_params[ idx ][ 1 ] } );

      end;
      if ( idx ~= 0 ) then

        ObjSet( "spr_onthelid_rpl_field_door_"..r.."_"..c, { pos_y = 70 } );

      end;

    end;

  end;

  for f = plane[ "fuel" ] + 1, private.fuel do

    ObjSet( "spr_onthelid_rpl_fuel_"..f, { alp = 0 } );

  end;

  for i = 1, #ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].label do

    local label = ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].label[ i ];

    ObjSet( "spr_onthelid_rpl_field_door_label_"..label[ 1 ].."_"..label[ 2 ], { alp = 1 } );

  end;

  local plane_params = ObjGet( "obj_onthelid_rpl_field_cell_"..plane[ "row" ].."_"..plane[ "col" ] );

  ObjSet( "spr_onthelid_rpl_plane_shadow", { ang = plane[ "ang" ] } );
  ObjSet( "spr_onthelid_rpl_plane",        { ang = plane[ "ang" ] } );
  ObjSet( "obj_onthelid_rpl_plane",        { pos_x = plane_params.pos_x, pos_y = plane_params.pos_y } );

  private.DoorSetInput( plane[ "row" ], plane[ "col" ] );

end;
--*********************************************************************************************************************
function public.PreOpen () 
  
  cmn.CallEventHandler( "win_onthelid_rpl" ); 
  
  if cmn.IsEventDone( "win_onthelid_rpl" ) then
    public.Reset();
    ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].start = 0;
    ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].done = 0;
  end;
  
  cmn.StopAllMus();
  cmn.PlayAudio( "mus", "audio/aud_amnesia_theme_mus", 1 );

end;
--*********************************************************************************************************************
function public.Open () 
  
  if not ( cmn.IsEventStart( "win_onthelid_rpl" ) ) then    
    private.Start();
  elseif cmn.IsEventStart( "win_onthelid_rpl" ) then
    cmn.MiniGameShow( "onthelid_rpl" );
  end;



end;
--*********************************************************************************************************************
function public.PreClose ()

  cmn.MiniGameHide();
  --common_impl.PassingMgWin( "onthelid_rpl" );

end;
--*********************************************************************************************************************
function public.Reset ()

  ObjAttach( "obj_onthelid_rpl_plane", "mg_onthelid_rpl");
  private.Reset( true );

end;
--*********************************************************************************************************************
function private.Reset ( full )

  ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].plane = { [ "row" ] = 1, [ "col" ] = 1, [ "fuel" ] = 12, [ "ang" ] = 0 };
  ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].direction = nil;
  ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].field =
  {
    { 9, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0 },
  };

  if ( full ) then

    ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].label = {};

    for r = 1, private.field_row do

      for c = 1, private.field_col do

        ObjSet( "spr_onthelid_rpl_field_door_label_"..r.."_"..c, { alp = 0 } );

      end;

    end;

  end;

  for r = 1, private.field_row do

    for c = 1, private.field_col do

      ObjSet( "spr_onthelid_rpl_field_path_"..r.."_"..c,       { alp = 0, res = "" } );
      ObjSet( "spr_onthelid_rpl_field_door_"..r.."_"..c,       { color_r = 1, color_g = 1, color_b = 1, input = false, pos_y = 0 } );

    end;

  end;

  for f = 1, private.fuel do

    ObjSet( "spr_onthelid_rpl_fuel_"..f, { alp = 1 } );

  end;

  ObjSet( "spr_onthelid_rpl_plane_shadow", { ang = 0 } );
  ObjSet( "spr_onthelid_rpl_plane",        { ang = 0 } );
  ObjSet( "obj_onthelid_rpl_plane",        { pos_x = 323, pos_y = 136 } );
  ObjSet( "spr_onthelid_rpl_field_shadow", { alp = 1 } );
  ObjSet( "obj_onthelid_rpl_field_left",   { pos_x = 0 } );
  ObjSet( "obj_onthelid_rpl_field_right",  { pos_x = 0 } );

  private.DoorSetInput( 1, 1 );

end;
--*********************************************************************************************************************
function public.Skip ()

  local r = ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].plane[ "row" ];
  local c = ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].plane[ "col" ];

  private.WinAnim( r, c );

end;
--*********************************************************************************************************************
function private.Win ()

  cmn.MiniGameHide();
  
  cmn.SetEventDone( "win_onthelid_rpl" );
  cmn.CallEventHandler( "win_onthelid_rpl" );
  
  cmn.GotoRoom( "rm_replayroom" );

end;
--*********************************************************************************************************************
function private.WinAnim ( r, c )

  int.Lock( true );

  ObjSet( "obj_onthelid_rpl_plane",                  { pos_x = 0, pos_y = 0 } );
  ObjSet( "obj_onthelid_rpl_field_cell_"..r.."_"..c, { pos_z = 10, croprect_init = false } );
  ObjSet( "spr_onthelid_rpl_field_door_"..r.."_"..c, { alp = 0 } );
  ObjAttach( "obj_onthelid_rpl_plane", "obj_onthelid_rpl_field_cell_"..r.."_"..c );

  ObjAnimate( "spr_onthelid_rpl_field_shadow", "alp", 0, 0, "", 
  {
    0.0, 3, 1.0,
    0.2, 3, 0.0,
  } );

  ObjAnimate( "obj_onthelid_rpl_field_left", "pos_x", 0, 0, "", 
  {
    0.0, 3,    0,
    1.0, 3, -272,
  } );

  ObjAnimate( "obj_onthelid_rpl_field_right", "pos_x", 0, 0,
  function ()

    int.Lock( false );

    private.Win();

  end, 
  {
    0.0, 3,   0,
    1.0, 3, 204,
  } );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_plane_win" );  

end;
--*********************************************************************************************************************
function private.DoorEnter ( r, c )

  cmn.SetCursor( CURSOR_HAND );
  local light_name = "spr_onthelid_rpl_field_door_light_"..r.."_"..c;
  local alp = ObjGet( light_name ).alp;

  ObjAnimate( light_name, "alp", 0, 0, "", 
  {
    0.0, 3, alp,
    0.2, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
function private.DoorLeave ( r, c )

  cmn.SetCursor( CURSOR_DEFAULT );
  local light_name = "spr_onthelid_rpl_field_door_light_"..r.."_"..c;
  local alp = ObjGet( light_name ).alp;

  ObjAnimate( light_name, "alp", 0, 0, "", 
  {
    0.0, 3, alp,
    0.2, 3, 0.0,
  } );
end;
--*********************************************************************************************************************
function private.DoorClick ( r, c )

  local cell_name = "obj_onthelid_rpl_field_cell_"..r.."_"..c;
  local door_name = "spr_onthelid_rpl_field_door_"..r.."_"..c;
  local path_name = "spr_onthelid_rpl_field_path_"..r.."_"..c;

  local plane = ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].plane;
  local tme = 0.2;

  int.Lock( true );

  -- открытие двери ----------------------------------------------------
  ObjAnimate( door_name, "color_rgb", 0, 0, "", 
  {
    0.0, 3, 1.0, 1.0, 1.0,
    0.2, 3, 0.7, 0.7, 0.7,
  } );

  ObjAnimate( door_name, "pos_y", 0, 0, "", 
  {
    0.0, 3,  0,
    0.2, 3,  0,
    0.5, 3, 70,
  } );

  -- поворот самолета на угол ------------------------------------------
  local new_direction = "start";
  local angs =
  {
    [ "up" ]    = { [ "right" ] =  1.57, [ "left" ] = -4.71, [ "up" ]    =  1.57, },
    [ "down" ]  = { [ "right" ] = -1.57, [ "left" ] = -1.57, [ "start" ] = -1.57, [ "down" ]  = -1.57 },
    [ "left" ]  = { [ "up" ]    =  3.14, [ "down" ] = -3.14, [ "left" ]  = -3.14 },
    [ "right" ] = { [ "up" ]    =  0.00, [ "down" ] =  0.00, [ "start" ] =  0.00, [ "right" ] =  0.00 },
  };

  if ( plane[ "row" ] > r ) then new_direction = "up" end;
  if ( plane[ "row" ] < r ) then new_direction = "down" end;
  if ( plane[ "col" ] > c ) then new_direction = "left" end;
  if ( plane[ "col" ] < c ) then new_direction = "right" end;

  local old_direction = ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].direction or "start";

  local ang = angs[ new_direction ][ old_direction ];

  if ( plane[ "ang" ] == ang ) then tme = 0.0 end;

  ObjAnimate( "spr_onthelid_rpl_plane_shadow", "ang", 0, 0, "", 
  {
    0.0, 3, plane[ "ang" ],
    tme, 3, ang,
  } );

  ObjAnimate( "spr_onthelid_rpl_plane", "ang", 0, 0, "", 
  {
    0.0, 3, plane[ "ang" ],
    tme, 3, ang,
  } );

  -- топливо -----------------------------------------------------------
  local fuel_name = "spr_onthelid_rpl_fuel_"..plane[ "fuel" ];

  ObjAnimate( fuel_name, "alp", 0, 0, "", 
  {
    0.0,       3, 1.0,
    0.5 + tme, 3, 1.0,
    0.9 + tme, 3, 0.0,
  } );

  -- путь --------------------------------------------------------------
  local path_idx = private.ShowPath( new_direction );

  ObjAnimate( "spr_onthelid_rpl_field_path_"..plane[ "row" ].."_"..plane[ "col" ], "alp", 0, 0, "", 
  {
    0.0,       3, 0,
    0.5 + tme, 3, 0,
    0.9 + tme, 3, 1,
  } );

  -- враги -------------------------------------------------------------
  local enemy = private.IsMeetEnemy( r, c, new_direction );

  if ( enemy ) then

    ObjAnimate( "obj_onthelid_rpl_field_enemy_"..r.."_"..c, "pos_xy", 0, 0,"", 
    {
      0.0,       3, enemy.x, enemy.y,
      0.5 + tme, 3, enemy.x, enemy.y,
      0.9 + tme, 3, 0.0,     0.0,
    } );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_plane_bad_clk" );  

  else

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_plane_clk" );  

  end;

  ----------------------------------------------------------------------
  local func_end = function ()

    int.Lock( false );

    if ( enemy ) then

      int.Lock( true );

      AnimPlay( "anm_onthelid_rpl_explosion", "DoAnim",
      function ()

        int.Lock( false );

        ObjSet( "spr_onthelid_rpl_field_enemy_"..r.."_"..c,        { alp = 1, ang = 0 } );
        ObjSet( "spr_onthelid_rpl_field_enemy_shadow_"..r.."_"..c, { alp = 1, ang = 0 } );
        ObjSet( "spr_onthelid_rpl_plane",                          { alp = 1 } );
        ObjSet( "spr_onthelid_rpl_plane_shadow",                   { alp = 1 } );
        ObjSet( "spr_onthelid_rpl_field_door_label_"..r.."_"..c,   { alp = 1 } );

        table.insert( ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].label, { r, c } );

        private.Reset( false );

      end );

      ObjAnimate( "spr_onthelid_rpl_field_enemy_"..r.."_"..c, "alp", 0, 0, "", 
      {
        0.0, 3, 1.0,
        0.3, 3, 0.3,
      } );

      ObjAnimate( "spr_onthelid_rpl_field_enemy_shadow_"..r.."_"..c, "alp", 0, 0, "", 
      {
        0.0, 3, 1.0,
        0.3, 3, 0.3,
      } );

      ObjAnimate( "spr_onthelid_rpl_plane", "alp", 0, 0, "", 
      {
        0.0, 3, 1.0,
        0.3, 3, 0.3,
      } );

      ObjAnimate( "spr_onthelid_rpl_plane_shadow", "alp", 0, 0, "", 
      {
        0.0, 3, 1.0,
        0.3, 3, 0.3,
      } );

      return;

    end;

    if ( ( r == private.field_row ) and ( c == private.field_col ) ) then

      private.WinAnim( r, c );

      return;

    end;

    if ( ang > 3.14 )  then ang = ang - 6.28; end;
    if ( ang < -3.14 ) then ang = ang + 6.28; end;
    if ( ang == 3.14 ) then ang = -3.14; end;

    ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].field[ plane[ "row" ] ][ plane[ "col" ] ] = path_idx;

    plane[ "row" ] = r;
    plane[ "col" ] = c;
    plane[ "ang" ] = ang;
    plane[ "fuel" ] = plane[ "fuel" ] - 1;

    if ( plane[ "fuel" ] == 0 ) then

      int.Lock( true );

      local func_end_reset = function ()

        int.Lock( false );

        private.Reset( false );

      end;

      for f = 1, private.fuel do

        ObjSet( "spr_onthelid_rpl_fuel_"..f, { alp = 1 } );

      end;

      ObjAnimate( "obj_onthelid_rpl_fuel", "alp", 0, 0, func_end_reset, 
      {
        0.0, 3, 0.0,
        0.2, 3, 1.0,
        0.4, 3, 0.0,
        0.6, 3, 1.0,
        0.8, 3, 0.0,
        1.0, 3, 1.0,
      } );

      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_plane_fuel" );  

      return;

    end;

    ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].plane = plane;
    ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].direction = new_direction;
    ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].field[ plane[ "row" ] ][ plane[ "col" ] ] = 9;

    private.DoorSetInput( r, c );

  end;

  -- полет самолета ----------------------------------------------------
  local start_name = "obj_onthelid_rpl_field_cell_"..plane[ "row" ].."_"..plane[ "col" ];

  local start_pos = ObjGet( start_name );
  local end_pos   = ObjGet( cell_name );

  ObjAnimate( "obj_onthelid_rpl_plane", "pos_xy", 0, 0, func_end, 
  {
    0.0,       3, start_pos.pos_x, start_pos.pos_y,
    0.5 + tme, 3, start_pos.pos_x, start_pos.pos_y,
    0.9 + tme, 3, end_pos.pos_x,   end_pos.pos_y,
  } );
  ----------------------------------------------------------------------

  private.GearsAnim( tme );

end;
--*********************************************************************************************************************
function private.ShowPath ( new_direction )

  local old_direction = ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].direction or "start";
  local revert_direction = { [ "start" ] = "start", [ "up" ] = "down", [ "down" ] = "up", [ "left" ] = "right", [ "right" ] = "left" };
  local path_params =
  {
    [ "start_right" ] = { 1, "path_start", 0 },
    [ "start_down" ]  = { 2, "path_start", -1.57 },
    [ "left_right" ]  = { 3, "path_line", 0 },
    [ "right_left" ]  = { 3, "path_line", 0 },
    [ "up_down" ]     = { 4, "path_line", 1.57 },
    [ "down_up" ]     = { 4, "path_line", 1.57 },
    [ "down_right" ]  = { 5, "path_corner", 0 },
    [ "right_down" ]  = { 5, "path_corner", 0 },
    [ "left_down" ]   = { 6, "path_corner", -1.57 },
    [ "down_left" ]   = { 6, "path_corner", -1.57 },
    [ "left_up" ]     = { 7, "path_corner", 3.14 },
    [ "up_left" ]     = { 7, "path_corner", 3.14 },
    [ "up_right" ]    = { 8, "path_corner", 1.57 },
    [ "right_up" ]    = { 8, "path_corner", 1.57 },
  };

  local direction = revert_direction[ old_direction ].."_"..new_direction;
  local plane = ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].plane;

  ObjSet( "spr_onthelid_rpl_field_path_"..plane[ "row" ].."_"..plane[ "col" ],
  {
    res = "assets/levels/level1/mg_onthelid/layers/"..path_params[ direction ][ 2 ],
    ang = path_params[ direction ][ 3 ],
  } );

  return path_params[ direction ][ 1 ];

end;
--*********************************************************************************************************************
function private.DoorSetInput ( row, col )

  local delta = { -1, 1 };

  for r = 1, private.field_row do

    for c = 1, private.field_col do

      local name = "obj_onthelid_rpl_field_cell_"..r.."_"..c;

      ObjSet( name, { input = false } );

    end;

  end;

  for d = 1, #delta do

    local new_row = row + delta[ d ];
    local new_col = col + delta[ d ];

    if ( new_row > 0 ) and ( new_row <= private.field_row ) and
       ( ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].field[ new_row ][ col ] == 0 ) then

      ObjSet( "obj_onthelid_rpl_field_cell_"..new_row.."_"..col, { input = true } );

    end;

    if ( new_col > 0 ) and ( new_col <= private.field_col) and
       ( ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].field[ row ][ new_col ] == 0 ) then

      ObjSet( "obj_onthelid_rpl_field_cell_"..row.."_"..new_col, { input = true } );

    end;

  end;

  for i = 1, #ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].label do

    local label = ng_global.progress[ "rpl" ][ "win_onthelid_rpl" ].label[ i ];

    ObjSet( "obj_onthelid_rpl_field_cell_"..label[ 1 ].."_"..label[ 2 ], { input = false } );

  end;

end;
--*********************************************************************************************************************
function private.IsMeetEnemy ( row, col, direction )

  local enemy_direction = { [ "up" ] = "down", [ "down" ] = "up", [ "left" ] = "right", [ "right" ] = "left" };
  local enemy_params =
  {
    [ "up" ]    = { [ "ang" ] =  0.00, [ "x" ] =   0, [ "y" ] =  60 },
    [ "down" ]  = { [ "ang" ] =  3.14, [ "x" ] =   0, [ "y" ] = -60 },
    [ "left" ]  = { [ "ang" ] =  1.57, [ "x" ] =  60, [ "y" ] =   0 },
    [ "right" ] = { [ "ang" ] = -1.57, [ "x" ] = -60, [ "y" ] =   0 },
  };

  if ( private.enemy[ row ][ col ] == 1 ) then

    ObjSet( "spr_onthelid_rpl_field_enemy_"..row.."_"..col,        { ang = enemy_params[ enemy_direction[ direction ] ][ "ang" ] } );
    ObjSet( "spr_onthelid_rpl_field_enemy_shadow_"..row.."_"..col, { ang = enemy_params[ enemy_direction[ direction ] ][ "ang" ] } );

    return { x = enemy_params[ enemy_direction[ direction ] ][ "x" ], y = enemy_params[ enemy_direction[ direction ] ][ "y" ] };

  end;

  return false;

end;
--*********************************************************************************************************************
function private.GearsAnim ( tme )

  ObjAnimate( "spr_onthelid_rpl_gear_1_shadow", "ang", 0, 0, "", 
  {
    0.0,       3, 0.00,
    0.9 + tme, 3, 6.28,
  } );

  ObjAnimate( "spr_onthelid_rpl_gear_1", "ang", 0, 0, "", 
  {
    0.0,       3, 0.00,
    0.9 + tme, 3, 6.28,
  } );

  ObjAnimate( "spr_onthelid_rpl_gear_2_shadow", "ang", 0, 0, "", 
  {
    0.0,       3,  0.00,
    0.9 + tme, 3, -6.28,
  } );

  ObjAnimate( "spr_onthelid_rpl_gear_2", "ang", 0, 0, "", 
  {
    0.0,       3,  0.00,
    0.9 + tme, 3, -6.28,
  } );

  ObjAnimate( "spr_onthelid_rpl_gear_3_shadow", "ang", 0, 0, "", 
  {
    0.0,       3, 0.00,
    0.9 + tme, 3, 6.28,
  } );

  ObjAnimate( "spr_onthelid_rpl_gear_3", "ang", 0, 0, "", 
  {
    0.0,       3, 0.00,
    0.9 + tme, 3, 6.28,
  } );

  ObjAnimate( "spr_onthelid_rpl_gear_4_shadow", "ang", 0, 0, "", 
  {
    0.0,       3,  0.00,
    0.9 + tme, 3, -6.28,
  } );

  ObjAnimate( "spr_onthelid_rpl_gear_4", "ang", 0, 0, "", 
  {
    0.0,       3,  0.00,
    0.9 + tme, 3, -6.28,
  } );

  ObjAnimate( "spr_onthelid_rpl_gear_5_shadow", "ang", 0, 0, "", 
  {
    0.0,       3, 0.00,
    0.9 + tme, 3, 6.28,
  } );

  ObjAnimate( "spr_onthelid_rpl_gear_5", "ang", 0, 0, "", 
  {
    0.0,       3, 0.00,
    0.9 + tme, 3, 6.28,
  } );

end;
--*********************************************************************************************************************
function private.Anims ()

  ObjAnimate( "spr_onthelid_rpl_light", "alp", 1, 0, "", 
  {
    0.0, 3, 0.3,
    4.5, 3, 1.0,
    9.0, 3, 0.3,
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************