-- name=mg_worriedmessage_rpl
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_worriedmessage_rpl";
  game.relations[ "mg_worriedmessage_rpl" ].exitroom = "rm_replayroom";

  private.init_pos = {
    {0,0,0,0,0,0,0,0,0,0},
    {0,2,2,3,1,4,2,3,1,0},
    {0,3,3,1,4,3,1,4,4,0},
    {0,4,4,1,1,4,4,1,1,0},
    {0,1,4,1,3,4,2,2,1,0},
    {0,1,1,1,4,2,3,3,2,0},
    {0,3,1,3,2,3,1,1,1,0},
    {0,4,1,3,2,2,2,1,2,0},
    {0,2,3,2,2,2,1,1,2,0},
    {0,0,0,0,0,0,0,0,0,0}
  };

  private.curr_pos = {
    {0,0,0,0,0,0,0,0,0,0},
    {0,2,2,3,1,4,2,3,1,0},
    {0,3,3,1,4,3,1,4,4,0},
    {0,4,4,1,1,4,4,1,1,0},
    {0,1,4,1,3,4,2,2,1,0},
    {0,1,1,1,4,2,3,3,2,0},
    {0,3,1,3,2,3,1,1,1,0},
    {0,4,1,3,2,2,2,1,2,0},
    {0,2,3,2,2,2,1,1,2,0},
    {0,0,0,0,0,0,0,0,0,0}
  };

  private.smbl_to_change = {};
  private.steps_left = 15;

  private.smbl_num = { "sun", "cloud", "plane", "alarm" };


  for i=2, 9 do
    for j=2, 9 do
      ObjCreate( "spr_worriedmessage_rpl_symbol_"..i.."_"..j, "spr" );
      ObjAttach( "spr_worriedmessage_rpl_symbol_"..i.."_"..j, "obj_worriedmessage_rpl_symbols" );
      ObjSet( "spr_worriedmessage_rpl_symbol_"..i.."_"..j, {
        res = "assets/levels/level3/mg_worriedmessage/layers/monitor_"..private.smbl_num[ private.init_pos[j][i] ],
        pos_x = 558 - 65.5 * (i - 2),
        pos_y = 506 - 59.5 * (j - 2),
        blendmode = 2,
      } );
    end;
  end;

  for i=1, 4 do
    ObjSet( "spr_worriedmessage_rpl_button_"..i, {
      event_mdown = function () private.ClkButton( i ); end,
      event_menter = function () private.MEnterButton ( i ); end,
      event_mleave = function () private.MLeaveButton ( i ); end,
    } );
  end;  
  
  private.Anims();

  --------------------------------------------------------------------------------------------
  -- function win_worriedmessage_rpl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_worriedmessage_rpl" ] =
  {
    type = "click",
    get_obj = "spr_worriedmessage_rpl_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_worriedmessage_rpl = function ()
  
    if ( cmn.IsEventStart( "win_worriedmessage_rpl" ) ) and not ( cmn.IsEventDone( "win_worriedmessage_rpl" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_worriedmessage_rpl", win_worriedmessage_rpl, private.room_objname );
  
end;

--*********************************************************************************************************************
function private.Load ()  

  for i=1,8 do
    for j=1,8 do
      private.curr_pos[ i+1 ][ j+1 ] = ng_global.progress[ "rpl" ][ "win_worriedmessage_rpl" ].curr_pos[ i ][ j ];
    end;
  end;

  for i=2, 9 do
    for j=2, 9 do
      ObjSet( "spr_worriedmessage_rpl_symbol_"..i.."_"..j, {
        res = "assets/levels/level3/mg_worriedmessage/layers/monitor_"..private.smbl_num[ private.curr_pos[j][i] ],
      } );
    end;
  end;

  private.steps_left = ng_global.progress[ "rpl" ][ "win_worriedmessage_rpl" ].steps_left;

  local r_digit = 0;
  local l_digit = 0;    

  if ( private.steps_left > 9 ) then
    l_digit = 1;
    r_digit = private.steps_left - 10;
  else
    l_digit = 0;
    r_digit = private.steps_left;
  end;

  ObjSet( "txt_worriedmessage_rpl_counter_left", { text = l_digit } );
  ObjSet( "txt_worriedmessage_rpl_counter", { text = r_digit } );
  if ( r_digit > 0 ) then
    ObjSet( "txt_worriedmessage_rpl_counter_up", { text = r_digit - 1 } );
  else
    ObjSet( "txt_worriedmessage_rpl_counter_up", { text = "9" } );
  end;

end;
--************** *******************************************************************************************************
function public.PreOpen () 
  
  cmn.CallEventHandler( "win_worriedmessage_rpl" ); 

  if cmn.IsEventDone( "win_worriedmessage_rpl" ) then
    public.Reset();
    ng_global.progress[ "rpl" ][ "win_worriedmessage_rpl" ].start = 0;
    ng_global.progress[ "rpl" ][ "win_worriedmessage_rpl" ].done = 0;
  end;  
  
  cmn.StopAllMus();
  cmn.PlayAudio( "mus", "audio/aud_amnesia_theme_mus", 1 );  

end;
--************** *******************************************************************************************************
function public.Open () 

  if not ( cmn.IsEventStart( "win_worriedmessage_rpl" ) ) then    
    private.Start();
  elseif cmn.IsEventStart( "win_worriedmessage_rpl" ) then
    cmn.MiniGameShow( "worriedmessage_rpl" );
  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  if ( cmn.IsEventStart( "win_worriedmessage_rpl" ) and not cmn.IsEventDone( "win_worriedmessage_rpl" ) ) then
    cmn.MiniGameHide();
  end;

end;
--*********************************************************************************************************************
function public.Reset ()

  for i=1,8 do
    for j=1,8 do
      ng_global.progress[ "rpl" ][ "win_worriedmessage_rpl" ].curr_pos[ i ][ j ] = private.init_pos[ i+1 ][ j+1 ];
    end;
  end;

  for i=2,9 do
    for j=2,9 do
      private.curr_pos[ i ][ j ] = private.init_pos[ i ][ j ];
    end;
  end;

  for i=2, 9 do
    for j=2, 9 do
      ObjSet( "spr_worriedmessage_rpl_symbol_"..i.."_"..j, {
        res = "assets/levels/level3/mg_worriedmessage/layers/monitor_"..private.smbl_num[ private.curr_pos[j][i] ],
      } );
    end;
  end;

  ng_global.progress[ "rpl" ][ "win_worriedmessage_rpl" ].steps_left = 15;
  private.steps_left = 15;

  ObjSet( "txt_worriedmessage_rpl_counter_left", { text = "1" } );
  ObjSet( "txt_worriedmessage_rpl_counter", { text = "5" } );
  ObjSet( "txt_worriedmessage_rpl_counter_up", { text = "4" } );

end;
--*********************************************************************************************************************
function public.Skip ()

  for i=2, 9 do
    for j=2, 9 do
      ObjSet( "spr_worriedmessage_rpl_symbol_"..i.."_"..j, {
        res = "assets/levels/level3/mg_worriedmessage/layers/monitor_alarm"
      } );
    end;
  end;

  private.Win();

end;
--*********************************************************************************************************************
function private.Start ()

  ng_global.progress[ "rpl" ][ "win_worriedmessage_rpl" ].curr_pos = {
    {2,2,3,1,4,2,3,1},
    {3,3,1,4,3,1,4,4},
    {4,4,1,1,4,4,1,1},
    {1,4,1,3,4,2,2,1},
    {1,1,1,4,2,3,3,2},
    {3,1,3,2,3,1,1,1},
    {4,1,3,2,2,2,1,2},
    {2,3,2,2,2,1,1,2}
  };
  ng_global.progress[ "rpl" ][ "win_worriedmessage_rpl" ].steps_left = 15;

  ObjSet( "txt_worriedmessage_rpl_counter_left", { text = "1" } );
  ObjSet( "txt_worriedmessage_rpl_counter", { text = "5" } );

  cmn.MiniGameShow( "worriedmessage_rpl" );

end;
--*********************************************************************************************************************
function private.WinEnd ()

  cmn.MiniGameHide(); 

  cmn.SetEventDone( "win_worriedmessage_rpl" );
  cmn.CallEventHandler( "win_worriedmessage_rpl" );  

  cmn.GotoRoom( "rm_replayroom" );

end;
--*********************************************************************************************************************
function private.Win ()

  local func_end = function ()

      private.WinEnd();

  end;

    ObjSet( "tmr_worriedmessage_rpl_vid", { playing = 1, time = 0.5, endtrig = func_end } ); 

end;
--*********************************************************************************************************************
function private.MEnterButton ( num )

  cmn.SetCursor(CURSOR_HAND);
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mg_worriedmessage_focus_button" );
  ObjAnimate("spr_worriedmessage_rpl_button_"..num.."_light", "alp", 0, 0, "", 
  {
    0.0,0,ObjGet( "spr_worriedmessage_rpl_button_"..num.."_light" ).alp,
    0.2,0,1
  });
  
end;
--*********************************************************************************************************************
function private.MLeaveButton ( num )

  cmn.SetCursor(CURSOR_DEFAULT);
  ObjAnimate("spr_worriedmessage_rpl_button_"..num.."_light", "alp", 0, 0, "", 
  {
    0.0,0,ObjGet( "spr_worriedmessage_rpl_button_"..num.."_light" ).alp,
    0.2,0,0
  });

end;
--*********************************************************************************************************************
function private.ClkButton ( num )

  int.Lock( true );
  private.ChangeNum();
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mg_worriedmessage_press_button" );
  ObjAnimate("spr_worriedmessage_rpl_button_"..num, "scale_xy", 0, 0, 
  function()
    int.Lock( false );
    private.ChangeSymbols( num );    
  end,
  {
    0.0,0,1.00,1.00,
    0.2,0,0.95,0.95,
    0.3,0,0.95,0.95,
    0.5,0,1.00,1.00
  });

end;
--*********************************************************************************************************************
function private.ChangeSymbols ( btn )

  local init_smbl = private.curr_pos[ 2 ][ 2 ];
  private.FindChildren( 2, 2, btn, init_smbl );

  for i=1, #private.smbl_to_change do
    private.curr_pos[ private.smbl_to_change[i][1] ][ private.smbl_to_change[i][2] ] = btn;
  end;

  private.smbl_to_change = {};

  for i=2, 9 do
    for j=2, 9 do
      ObjSet( "spr_worriedmessage_rpl_symbol_"..i.."_"..j, {
        res = "assets/levels/level3/mg_worriedmessage/layers/monitor_"..private.smbl_num[ private.curr_pos[j][i] ],
      } );
    end;
  end;

  private.CheckWin();

end;
--*********************************************************************************************************************
function private.FindChildren ( i, j, btn, init_smbl )

  local directions = {};

  if (private.curr_pos[i-1][j] == btn) or (private.curr_pos[i-1][j] == init_smbl) then

    table.insert( directions, {i-1, j} );

  end;

  if (private.curr_pos[i+1][j] == btn) or (private.curr_pos[i+1][j] == init_smbl) then

    table.insert( directions, {i+1, j} );

  end;

  if (private.curr_pos[i][j+1] == btn) or (private.curr_pos[i][j+1] == init_smbl) then

    table.insert( directions, {i, j+1} );

  end;

  if (private.curr_pos[i][j-1] == btn) or (private.curr_pos[i][j-1] == init_smbl) then

    table.insert( directions, {i, j-1} );

  end;

  for k=1, #directions do

    local continue = true;
    for n=1, #private.smbl_to_change do
      if ( private.smbl_to_change[n][1] == directions[k][1] ) and ( private.smbl_to_change[n][2] == directions[k][2] ) then
        continue = false;
      end;
    end;

    if ( continue ) then
      table.insert( private.smbl_to_change, { directions[k][1], directions[k][2] } );
      if ( private.curr_pos[ directions[k][1] ][ directions[k][2] ] == btn ) then
        private.FindChildren( directions[k][1], directions[k][2], btn, btn );
      else
        private.FindChildren( directions[k][1], directions[k][2], btn, init_smbl );
      end;
    end;

  end;

end;
--*********************************************************************************************************************
function private.CheckWin ()

  local win = true;

  for i=2, 9 do
    for j=2, 9 do
      if ( private.curr_pos[i][j] ~= 4 ) then
        win = false;
      end;
    end;
  end;

  if ( private.steps_left < 1 ) and not ( win ) then
    public.Reset();
  end;

  if ( win ) then
    private.Win();
  else
    for i=1,8 do
      for j=1,8 do
        ng_global.progress[ "rpl" ][ "win_worriedmessage_rpl" ].curr_pos[ i ][ j ] = private.curr_pos[ i+1 ][ j+1 ];
      end;
    end;
    ng_global.progress[ "rpl" ][ "win_worriedmessage_rpl" ].steps_left = private.steps_left;
  end;

end;
--*********************************************************************************************************************
function private.ChangeNum ()

  local func_end = function ()

    private.steps_left = private.steps_left - 1;

    local r_digit = 0;
    local l_digit = 0;    

    if ( private.steps_left > 9 ) then
      l_digit = 1;
      r_digit = private.steps_left - 10;
    else
      l_digit = 0;
      r_digit = private.steps_left;
    end;

    ObjSet( "txt_worriedmessage_rpl_counter_left", { text = l_digit } );
    ObjSet( "txt_worriedmessage_rpl_counter", { text = r_digit } );
    if ( r_digit > 0 ) then
      ObjSet( "txt_worriedmessage_rpl_counter_up", { text = r_digit - 1 } );
    else
      ObjSet( "txt_worriedmessage_rpl_counter_up", { text = "9" } );
    end;
    ObjSet( "spr_worriedmessage_rpl_counter", { pos_y = 116 } );
    ObjSet( "spr_worriedmessage_rpl_counter_up", { pos_y = 64 } );

  end;

  ObjAnimate("spr_worriedmessage_rpl_counter", "pos_y", 0, 0, "", 
  {
    0.0,0,116,
    0.3,3,168
  });
  ObjAnimate("spr_worriedmessage_rpl_counter_up", "pos_y", 0, 0, func_end, 
  {
    0.0,0, 64,
    0.3,3,116
  });

end;
--*********************************************************************************************************************
function private.Anims ()

  ObjAnimate("txt_worriedmessage_rpl_cursor", "alp", 1, 0, "", 
  {
    0.0,0,0,
    0.6,0,0,
    0.7,0,1,
    1.0,0,1,
    1.1,0,0
  });  

  ObjAnimate("spr_worriedmessage_rpl_locator_right_over_light", "alp", 1, 0, "", 
  {
    0.0,0,1,
    3.0,0,1,
    3.5,0,0.7,
    4.0,0,1,
    6.0,0,1
  });
  ObjAnimate("spr_worriedmessage_rpl_locator_left", "ang", 1, 0, "", 
  {
    0.0,0, 0.00,
    7.0,0,-6.28,
    7.0,0, 0.00
  });
  ObjAnimate("spr_worriedmessage_rpl_locator_right", "ang", 1, 0, "", 
  {
    0.0,0, 0.00,
    8.0,0,-6.28,
    8.0,0, 0.00
  });
  ObjAnimate("spr_worriedmessage_rpl_radio_arrow", "ang", 1, 0, "", 
  {
    0.0,0, 0.0,
    2.0,0, 0.0,
    2.5,0,-0.4,
    3.0,0, 0.0,
    3.3,0, 0.0,
    3.6,0,-0.2,
    3.9,0, 0.0,
    4.2,0,-0.2,
    4.5,0, 0.0
  });
  ObjAnimate("spr_worriedmessage_rpl_radio_light", "alp", 1, 0, "", 
  {
    0.0,0,1,
    1.5,0,1,
    1.8,0,0.7,
    2.0,0,1,
    3.2,0,1,
    3.8,0,0.8,
    4.5,0,1
  });

  local tme = 2.2;
  local delay = 0.0;
  for i=1, 3 do
    delay = delay + 0.2;
    ObjAnimate("spr_worriedmessage_rpl_tumbler_light_"..i, "alp", 1, 0, "", 
    {
      0.0     ,0,0,
      tme+delay     ,0,0,
      tme+0.3+delay ,0,1,
      tme+0.4+delay ,0,1,
      tme+0.7+delay ,0,0,
      tme+11.5 ,0,0
    });
  end;

  private.AnimPanel();

end;
--*********************************************************************************************************************
function private.AnimPanel ()

  local tme = 2.8;
  local delay = 0.0;
  for i=1, 3 do
    delay = delay + 0.2;
    ObjAnimate("spr_worriedmessage_rpl_counter_light_"..i, "alp", 1, 0, "", 
    {
      0.0     ,0,0,
      tme+delay     ,0,0,
      tme+0.3+delay ,0,1,
      tme+0.4+delay ,0,1,
      tme+0.7+delay ,0,0,
      tme+11.5 ,0,0
    });
  end;

  ObjAnimate("spr_worriedmessage_rpl_red_button_light_1", "alp", 1, 0, "", 
  {
    0.0,0,0,
    1.5,0,0,
    1.8,0,1,
    2.0,0,1,
    2.3,0,0,
    4.5,0,0
  });
  ObjAnimate("spr_worriedmessage_rpl_red_button_light_2", "alp", 1, 0, "", 
  {
    0.0,0,0,
    2.0,0,0,
    2.3,0,1,
    2.5,0,1,
    2.8,0,0,
    4.5,0,0
  });

  private.AnimMonitorLight();

end;
--*********************************************************************************************************************
function private.AnimMonitorLight ()

  ObjAnimate("spr_worriedmessage_rpl_monitor_light", "alp", 1, 0, "", 
  {
    0.0,0,0,
    1.0,0,0,
    1.3,0,1,
    1.5,0,1,
    1.8,0,0,
    3.0,0,0
  });

end;
--*********************************************************************************************************************