-- name=levelrpl

function public.Start ( param )

  int.WidgetAdd( InterfaceWidget_Pause, 1800 );

  int.WidgetAdd( InterfaceWidget_BtnMenu, 12 );
  int.WidgetAdd( InterfaceWidget_BtnGuide, 10 );

  int.WidgetAdd( InterfaceWidget_BtnHint, 9  );
  int.WidgetAdd( InterfaceWidget_BtnSkip, 9 );
  int.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  int.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  int.WidgetAdd( InterfaceWidget_Inventory, 21 );
  int.WidgetAdd( InterfaceWidget_TaskPanel, 22 );
  int.WidgetAdd( InterfaceWidget_ItemPanel, 22 );

  int.WidgetAdd( InterfaceWidget_Effects, 23 );

  int.WidgetAdd( InterfaceWidget_BtnMap, 13 );

  int.WidgetAdd( InterfaceWidget_DialogHo );

  int.ButtonLockAdd();

  int.WidgetAdd( InterfaceWidget_FrameSubroom, 8 );

  int.WidgetAdd( InterfaceWidget_Popup, 31 );

  int.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  int.WidgetAdd( InterfaceWidget_Dialog );

  int.WidgetAdd( InterfaceWidget_DialogVideo, 1491 );
  int.WidgetAdd( InterfaceWidget_DialogStory, 1491 );
  int.WidgetAdd( InterfaceWidget_DialogCharacter, 1491 );

  int.WidgetAdd( InterfaceWidget_StrategyGuide );
  int.WidgetAdd( InterfaceWidget_Window );

  int.WidgetAdd( InterfaceWidget_Tutorial );
  int.WidgetAdd( InterfaceWidget_Map, 24  );

  int.PanelNotificationAdd();
  int.DeployInvAdd(9);
  int.DialogHintAdd( 10 );
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );
  int.InitMiniho( 18 );


  private.Init();
  ModLoad( "assets/levels/levelrpl/mod_levelrpl_inv" );
  levelrpl_inv.Init();

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    interface.AchievementsAdd( 10 );
    --int.MorphingAdd( 10 );
    --int.CollectiblesAdd( 10 );
    --int.Collectibles2Add( 10 );

  end;

  --common.LevelLoad( "levelrpl", "rpl", "rm_replayroom", param, private.menu_moduls );
  common.LevelLoad( "levelrpl", "rpl", "rm_replayroom", param );  
  --if IsCollectorsEdition() then

    --common_impl.Collectibles2CoinsLoad();

  --end;

  --private.TutorialSetParams();
  --interface.KeyUpdate();

  --event_show_investigation = "beg_levelrpl";

  --interface.InvestigationButtonCheck();
  
  --interface.PanelProvideShow();
  
end;
    
function private.Init ()

  game = {};
  game.room_names =
  {
    "rm_replayroom"
   ,"ho_crashreport_rpl"
   ,"ho_dollhouse_rpl"
   ,"ho_farmhouse_rpl"
   ,"ho_hocabinet_rpl"
   ,"ho_hofridge_rpl"
   ,"ho_hoscrypt_rpl"
   ,"ho_hosecuritypoint_rpl"
   ,"ho_house_rpl"
   ,"ho_inbasement_rpl"
   ,"ho_investigatorsdesk_rpl"   
   ,"ho_investigatorsdesk2_rpl"
   ,"ho_roundthecorner_rpl"
   ,"ho_serverroom_rpl"
   ,"mg_cashtill_rpl"
   ,"mg_darkness_rpl"
   ,"mg_lulling_rpl"
   ,"mg_mgbook_rpl"
   ,"mg_mgboxes_rpl"
   ,"mg_mgfate_rpl"
   ,"mg_mgremovecollapse_rpl"
   ,"mg_mgstatue_rpl"
   ,"mg_ondoor_rpl"
   ,"mg_onsafedoor_rpl"
   ,"mg_onthelid_rpl"
   ,"mg_repair_rpl"
   ,"mg_worriedmessage_rpl"      
  };

  game.progress_names =
  {
    "beg_levelrpl" 
   ,"opn_replayroom"
   ,"opn_crashreport_rpl"
   ,"win_crashreport_rpl"   
   ,"opn_dollhouse_rpl"
   ,"win_dollhouse_rpl"
   ,"opn_farmhouse_rpl"
   ,"win_farmhouse_rpl"
   ,"opn_hocabinet_rpl"
   ,"win_hocabinet_rpl"
   ,"opn_hofridge_rpl"
   ,"win_hofridge_rpl"
   ,"opn_hoscrypt_rpl"
   ,"win_hoscrypt_rpl"
   ,"opn_hosecuritypoint_rpl"
   ,"win_hosecuritypoint_rpl"
   ,"opn_house_rpl"
   ,"win_house_rpl"
   ,"opn_inbasement_rpl"
   ,"win_inbasement_rpl"
   ,"opn_investigatorsdesk_rpl"   
   ,"win_investigatorsdesk_rpl"   
   ,"opn_investigatorsdesk2_rpl"
   ,"win_investigatorsdesk2_rpl"
   ,"opn_roundthecorner_rpl"
   ,"win_roundthecorner_rpl"
   ,"opn_serverroom_rpl"
   ,"win_serverroom_rpl"
   ,"win_cashtill_rpl"
   ,"win_darkness_rpl"
   ,"win_lulling_rpl"
   ,"win_mgbook_rpl"
   ,"win_mgboxes_rpl"
   ,"win_mgfate_rpl"
   ,"win_mgremovecollapse_rpl"
   ,"win_mgstatue_rpl"
   ,"win_ondoor_rpl"
   ,"win_onsafedoor_rpl"
   ,"win_onthelid_rpl"
   ,"win_repair_rpl"
   ,"win_worriedmessage_rpl" 
  };
  
  game.relations = {};
  
  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      --"rm_collectibles2",
      --"rm_collectibles",
      "rm_achievements",
    }
    for i = 1, #menu_moduls_ce do
      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );
    end;

  end;

end;
--************************************************************************************************************************

--function private.TutorialSetParams()
--
--  if not ng_global.progress[ "rpl" ][ "see_tutorial_rpl" ] then
--
--    ng_global.progress[ "rpl" ][ "see_tutorial_rpl" ] = {};
--    ng_global.progress[ "rpl" ][ "see_tutorial_rpl" ].done  = 0;
--    ng_global.progress[ "rpl" ][ "see_tutorial_rpl" ].start = 0;
--    ng_global.progress[ "rpl" ][ "see_tutorial_rpl" ].state = {};
--    ng_global.progress[ "rpl" ][ "see_tutorial_rpl" ].state.no  = 0;
--    ng_global.progress[ "rpl" ][ "see_tutorial_rpl" ].state.currentpage = "tutorial_page_1_rpl";
--    ng_global.progress[ "rpl" ][ "see_tutorial_rpl" ].func = function() end;
--
--    local offset = 0;
--
--    if ( GetWiderpleen() ) then
--
--      offset = 0.5 * ( GetAppWidth() - 1024 );
--      
--    end;
--
--    ng_global.progress[ "rpl" ][ "see_tutorial_rpl" ].state.pages = {
--
--      [ "tutorial_page_1_rpl" ] = { shown = 0, noskip = true, posx = 512, posy = 200, arrows = {} } , -- Показать туториал? 
--
--      [ "tutorial_page_2_rpl" ] = { shown = 0, noskip = false, posx = 450, posy = 300, arrows = { 
--                                                                              { pos_x = 760, pos_y = 230, ang =  -1.3 }
--                                                                            } },   -- туториал на кнопку сообщений
--
--      [ "tutorial_page_3_rpl" ] = { shown = 0, noskip = false, posx = 390, posy = 100, arrows = { 
--                                                                              { pos_x = 390, pos_y = 270, ang =  3.14 }
--                                                                            } },   -- туториал на две папки
--
--      [ "tutorial_page_4_rpl" ] = { shown = 0, noskip = false, posx = 700, posy = 500, arrows = { 
--                                                                              { pos_x = 400, pos_y = 490, ang =  1.3 }
--                                                                            } },   -- туториал на задания в папках
--
--      [ "tutorial_page_5_rpl" ] = { shown = 0, noskip = false, posx = 512, posy = 600, arrows = { 
--                                                                              { pos_x = 800, pos_y = 480, ang =  -1.1 }
--                                                                            } },   -- туториал о получении звезд
--
--      [ "tutorial_page_6_rpl" ] = { shown = 0, noskip = false, posx = 512, posy = 600, arrows = { 
--                                                                              { pos_x = 170, pos_y = 640, ang =  1.7 }
--                                                                            } },   -- туториал на таймер
--
--      [ "tutorial_page_7_rpl" ] = { shown = 0, noskip = false, posx = 210, posy = 300, arrows = { 
--                                                                              { pos_x = 500, pos_y = 230, ang =  -1.3 }
--                                                                            } },   -- туториал на папку с видеороликами
--    };
--
--  end;
--
--end;
--************************************************************************************************************************
function public.InventoryDisable()

  interface.WidgetSetVisible( InterfaceWidget_Inventory, false );
  interface.WidgetSetInput( InterfaceWidget_Inventory, false );   
  interface.WidgetSetVisible( InterfaceWidget_BtnMap, false );  
  interface.WidgetSetInput( InterfaceWidget_BtnMap, false );   
  interface.WidgetSetVisible( InterfaceWidget_BtnHint, false );  
  interface.WidgetSetInput( InterfaceWidget_BtnHint, false );  
  interface.WidgetSetVisible( InterfaceWidget_BtnMenu, false );  
  interface.WidgetSetInput( InterfaceWidget_BtnMenu, false );  
  interface.WidgetSetVisible( InterfaceWidget_BtnSkip, false );  
  interface.WidgetSetInput( InterfaceWidget_BtnSkip, false );  
  interface.WidgetSetVisible( InterfaceWidget_BtnGuide, false );  
  interface.WidgetSetInput( InterfaceWidget_BtnGuide, false );  

  ObjStopAnimate( "int_inventory", "alp" );
  ObjSet( "int_inventory", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );    

end;