-- name=rm_replayroom
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_replayroom";
  
  private.mgs = {
    {  1, "/mg/mg_mgboxes",            "mg_mgboxes_rpl" },    --num, path to screeen, module
    {  2, "/mg/mg_mgremovecollapse",   "mg_mgremovecollapse_rpl" },
    {  3, "/mg/mg_onthelid",           "mg_onthelid_rpl" },
    {  4, "/mg/mg_darkness",           "mg_darkness_rpl" },
    {  5, "/mg/mg_onsafedoor",         "mg_onsafedoor_rpl" },
    {  6, "/mg/mg_repair",             "mg_repair_rpl" },
    {  7, "/mg/mg_cashtill",           "mg_cashtill_rpl" },
    {  8, "/mg/mg_ondoor",             "mg_ondoor_rpl" },
    {  9, "/mg/mg_worriedmessage",     "mg_worriedmessage_rpl" },
    { 10, "/mg/mg_lulling",            "mg_lulling_rpl" },
    { 11, "/mg/mg_mgbook",             "mg_mgbook_rpl" },
    { 12, "/mg/mg_mgfate",             "mg_mgfate_rpl" },
    { 13, "/mg/mg_mgstatue",           "mg_mgstatue_rpl" }
  };
  private.hos = {
    {  1, "/ho/ho_farmhouse",          "ho_farmhouse_rpl" },    --num, path to screeen, module
    {  2, "/ho/ho_investigatorsdesk",  "ho_investigatorsdesk_rpl" },
    {  3, "/ho/ho_roundthecorner",     "ho_roundthecorner_rpl" },
    {  4, "/ho/ho_dollhouse",          "ho_dollhouse_rpl" },
    {  5, "/ho/ho_inbasement",         "ho_inbasement_rpl" },
    {  6, "/ho/ho_investigatorsdesk2", "ho_investigatorsdesk2_rpl" },
    {  7, "/ho/ho_crashreport",        "ho_crashreport_rpl" },
    {  8, "/ho/ho_hosecuritypoint",    "ho_hosecuritypoint_rpl" },
    {  9, "/ho/ho_serverroom",         "ho_serverroom_rpl" },
    { 10, "/ho/ho_hocabinet",          "ho_hocabinet_rpl" },
    { 11, "/ho/ho_hofridge",           "ho_hofridge_rpl" },
    { 12, "/ho/ho_hoscrypt",           "ho_hoscrypt_rpl" },
    { 13, "/ho/ho_house",              "ho_house_rpl" }
  };
  
  private.mg_num = 1;
  private.ho_num = 1;
  private.cur_scr = "mg";
  
  ObjMultiSet({
    { "obj_replayroom_button_play", {
      event_menter = function () private.BtnEnter( "play" ); end,
      event_mleave = function () private.BtnLeave( "play" ); end,
      event_mdown =  function () private.OpenTask(); end,
    }},
    { "obj_replayroom_button_prev", {
      event_menter = function () private.BtnEnter( "prev" ); end,
      event_mleave = function () private.BtnLeave( "prev" ); end,
      event_mdown =  function () private.ChangeNum( -1 ); end,
    }},
    { "obj_replayroom_button_next", {
      event_menter = function () private.BtnEnter( "next" ); end,
      event_mleave = function () private.BtnLeave( "next" ); end,
      event_mdown =  function () private.ChangeNum( 1 ); end,
    }},
    { "obj_replayroom_button_mgs", {
      event_menter = function () private.BtnEnter( "mgs" ); end,
      event_mleave = function () private.BtnLeave( "mgs" ); end,
      event_mdown =  function () private.SwitchType( "mg" ); end,
    }},
    { "obj_replayroom_button_hos", {
      event_menter = function () private.BtnEnter( "hos" ); end,
      event_mleave = function () private.BtnLeave( "hos" ); end,
      event_mdown =  function () private.SwitchType( "ho" ); end,
    }},
    { "obj_replayroom_button_exit", {
      event_menter = function () private.BtnEnter( "exit" ); end,
      event_mleave = function () private.BtnLeave( "exit" ); end,
      event_mdown =  function () public.ExitRoom(); end,
    }},      
    { "spr_replayroom_screen_mg", {
      res = "assets/levels/levelrpl/rm_replayroom/layers"..private.mgs[ private.mg_num ][ 2 ]
    }},
    { "spr_replayroom_screen_ho", {
    res = "assets/levels/levelrpl/rm_replayroom/layers"..private.hos[ private.ho_num ][ 2 ]
    }},
  });
  
  private.Anims();    
  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
    local update_game_mode_replayroom = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      --"gzz_",
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    end;
    cmn.AddSubscriber( "update_game_mode_replayroom", update_game_mode_replayroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
    local update_performance_mode_replayroom = function ()

    local effects_table = 
    {
      "obj_replayroom_anim" 
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

    end;
    cmn.AddSubscriber( "update_performance_mode_replayroom", update_performance_mode_replayroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_replayroom () end;
  --------------------------------------------------------------------------------------------
  local opn_replayroom = function ()
  
    if cmn.IsEventDone( "opn_replayroom" ) then
      private.Load();
    end;

  end;
  cmn.AddSubscriber( "opn_replayroom", opn_replayroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function beg_levelrpl () end;
  --------------------------------------------------------------------------------------------
  local beg_levelrpl = function ()  

  end;
  cmn.AddSubscriber( "beg_levelrpl", beg_levelrpl, private.room_objname );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Open()

  cmn.StopAllMus();
  cmn.StopAllEnv();
  cmn.PlayAudio( "mus", "audio/aud_location_theme_mus", 1 );

end;
--*********************************************************************************************************************
function public.PreOpen()

  interface.WidgetSetInput( InterfaceWidget_BtnHint, false );  

  if not cmn.IsEventDone( "opn_replayroom" ) then    
    
    ng_global.progress[ "rpl" ][ "opn_replayroom" ].mg_num = 1;
    ng_global.progress[ "rpl" ][ "opn_replayroom" ].ho_num = 1;
    ng_global.progress[ "rpl" ][ "opn_replayroom" ].cur_scr = "mg";

    cmn.SetEventDone( "opn_replayroom" );

  end;

  levelrpl.InventoryDisable();  

end;
--*********************************************************************************************************************
function public.Close()


end;
--*********************************************************************************************************************
function public.PreClose()

  levelrpl.InventoryDisable();

  --cmn.StopAudio( "mus", "common/audio/aud_adventure1_mus", 1 );
  common_impl.StopMusEnv();

end;
--*********************************************************************************************************************
function private.Load ()
  
    private.mg_num = ng_global.progress[ "rpl" ][ "opn_replayroom" ].mg_num ;
    private.ho_num = ng_global.progress[ "rpl" ][ "opn_replayroom" ].ho_num ;
    private.cur_scr = ng_global.progress[ "rpl" ][ "opn_replayroom" ].cur_scr;
    
    ObjSet( "spr_replayroom_screen_mg", { res = "assets/levels/levelrpl/rm_replayroom/layers"..private.mgs[ private.mg_num ][ 2 ] } );
    ObjSet( "spr_replayroom_screen_ho", { res = "assets/levels/levelrpl/rm_replayroom/layers"..private.hos[ private.ho_num ][ 2 ] } );
    
    if ( private.cur_scr == "mg" ) then
      ObjSet( "spr_replayroom_screen_mg", { alp = 1 } );
      ObjSet( "spr_replayroom_screen_ho", { alp = 0 } );
      ObjSet( "txt_replayroom_counter", { text = private.mg_num.."/13" } );
    elseif ( private.cur_scr == "ho" ) then
      ObjSet( "spr_replayroom_screen_mg", { alp = 0 } );
      ObjSet( "spr_replayroom_screen_ho", { alp = 1 } );
      ObjSet( "txt_replayroom_counter", { text = private.ho_num.."/13" } );
    end;
  
end;
--*********************************************************************************************************************
function private.OpenTask()

  int.Lock( false );
  
  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );
  
  if ( private.cur_scr == "mg" ) then
    
    cmn.GotoRoom( private.mgs[ private.mg_num ][ 3 ], 1, true );  
    
  elseif ( private.cur_scr == "ho" ) then 
    
    if cmn.IsEventDone( "win_"..string.sub( private.hos[ private.ho_num ][ 3 ], 4 ) ) then
      _G[ private.hos[ private.ho_num ][ 3 ] ].ResetHO();
      ObjDelete( private.hos[ private.ho_num ][ 3 ] );
      ModLoad( string.format( "assets/levels/levelrpl/%s/mod_%s", private.hos[ private.ho_num ][ 3 ], string.sub( private.hos[ private.ho_num ][ 3 ], 4 ) ) );
      _G[ private.hos[ private.ho_num ][ 3 ] ].Init();
      _G[ private.hos[ private.ho_num ][ 3 ] ].Load();
    end;    
    
    cmn.GotoRoom( private.hos[ private.ho_num ][ 3 ], 1, true ); 
    
  end;  
  
end;
--*********************************************************************************************************************
function public.ExitRoom()
  
  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );

  SaveProfiles();
  SaveSettings();

  SetCursor( CURSOR_DEFAULT );
  
  --ng_global.is_rpl = true;

  ObjSet( "int_inventory", { input = true } );

  common.LevelSwitch( "menu", "game" );

end;
  --******************************************************************************************
function private.Anims ()

  ObjAnimate("spr_replayroom_buttons", "ang", 1, 0, "", 
  {
    0.0,0,0.02,
    3.0,3,-0.02,
    6.0,3,0.02
  });
  ObjAnimate("spr_replayroom_light_add", "alp", 1, 0, "", 
  {
    0.0,0,1,
    2.5,0,0.7,
    5.0,0,1
  });
  
end;
--******************************************************************************************
function private.BtnEnter ( btn )
  
  cmn.SetCursor(CURSOR_HAND);
  ObjAnimate("spr_replayroom_button_"..btn.."_focus", "alp", 0, 0, "", 
  {
    0.0,0,ObjGet("spr_replayroom_button_"..btn.."_focus").alp,
    0.2,0,1
  });
  
end;  
--******************************************************************************************
function private.BtnLeave ( btn )
  
  cmn.SetCursor(CURSOR_DEFAULT);
  ObjAnimate("spr_replayroom_button_"..btn.."_focus", "alp", 0, 0, "", 
  {
    0.0,0,ObjGet("spr_replayroom_button_"..btn.."_focus").alp,
    0.2,0,0
  });    
  
end;  
--******************************************************************************************
function private.SwitchType ( tpe )
  
  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );
  
  if ( tpe ~= private.cur_scr ) then
    
    int.Lock( true );
  
    if ( private.cur_scr == "mg" ) then
              
      ObjAnimate("spr_replayroom_screen_mg", "alp", 0, 0, 
      function ()
        int.Lock( false );
        ObjSet( "txt_replayroom_counter", { text = private.ho_num.."/13" } );
        
      end, 
      {
        0.0,0,1,
        0.3,0,0
      });
      ObjAnimate("spr_replayroom_screen_ho", "alp", 0, 0, "", 
      {
        0.0,0,0,
        0.3,0,1
      });
      private.cur_scr = "ho";
      
    elseif ( private.cur_scr == "ho" ) then

      ObjAnimate("spr_replayroom_screen_mg", "alp", 0, 0,  
      function ()
        int.Lock( false );
        ObjSet( "txt_replayroom_counter", { text = private.mg_num.."/13" } );
      end, 
      {
        0.0,0,0,
        0.3,0,1
      });
      ObjAnimate("spr_replayroom_screen_ho", "alp", 0, 0, "", 
      {
        0.0,0,1,
        0.3,0,0
      });
      private.cur_scr = "mg";
      
    end;
    
    ng_global.progress[ "rpl" ][ "opn_replayroom" ].cur_scr = private.cur_scr;
    
  end;
  
end; 
--******************************************************************************************
function private.ChangeNum ( val )
  
  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );
  
  if ( private.cur_scr == "mg" ) then
    
    if ( private.mg_num == 13 ) and ( val == 1 ) then
      private.mg_num  = 1;
    elseif ( private.mg_num == 1 ) and ( val == -1 ) then
      private.mg_num  = 13;
    else
      private.mg_num = private.mg_num + val;        
    end;
    
    ObjSet( "spr_replayroom_screen_mg", { res = "assets/levels/levelrpl/rm_replayroom/layers"..private.mgs[ private.mg_num ][ 2 ] } );
    ObjSet( "txt_replayroom_counter", { text = private.mg_num.."/13" } );
    
    ng_global.progress[ "rpl" ][ "opn_replayroom" ].mg_num  = private.mg_num;
    
  elseif ( private.cur_scr == "ho" ) then
    
    if ( private.ho_num == 13 ) and ( val == 1 ) then
      private.ho_num  = 1;
    elseif ( private.ho_num == 1 ) and ( val == -1 ) then
      private.ho_num  = 13;
    else
      private.ho_num = private.ho_num + val;        
    end;
    
    ObjSet( "spr_replayroom_screen_ho", { res = "assets/levels/levelrpl/rm_replayroom/layers"..private.hos[ private.ho_num ][ 2 ] } );
    ObjSet( "txt_replayroom_counter", { text = private.ho_num.."/13" } );
    
    ng_global.progress[ "rpl" ][ "opn_replayroom" ].ho_num  = private.ho_num;
    
  end;
  
end;
--******************************************************************************************