-- name=rm_secondfloorcorridor_scr
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_secondfloorcorridor_scr";

  private.InitAnims();
  
  cmn.SecretroomhAddObj( private.room_objname, "roses",            1 );
  cmn.SecretroomhAddObj( private.room_objname, "knives",           2 );
  cmn.SecretroomhAddObj( private.room_objname, "fire",             3 );
  cmn.SecretroomhAddObj( private.room_objname, "planes",           4 );
  cmn.SecretroomhAddObj( private.room_objname, "cursed_tickets",   5 );
  cmn.SecretroomhAddObj( private.room_objname, "cards_of_destiny", 2 );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_secondfloorcorridor_scr = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
  "grm_secondfloorcorridor_scr_technicalroom_scr",
  "grm_secondfloorcorridor_scr_aircompaniesstand_scr",
  };
  for i = 1, #gates do
    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;
  end;

    local mas_parent_gfx = 
    {
      private.room_objname,
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_secondfloorcorridor_scr", update_game_mode_secondfloorcorridor_scr, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_secondfloorcorridor_scr = function ()

  local effects_table = 
  {
  "obj_secondfloorcorridor_scr_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_secondfloorcorridor_scr", update_performance_mode_secondfloorcorridor_scr, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_secondfloorcorridor_scr () end;
  --------------------------------------------------------------------------------------------
  local opn_secondfloorcorridor_scr_map = function ()

    --common_impl.VisitMapRoom( "secondfloorcorridor_secret" );

  end;
  cmn.AddSubscriber( "opn_secondfloorcorridor_scr", opn_secondfloorcorridor_scr_map );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_secondfloorcorridor_scr();
  cmn.StartMorhpTask();  
  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  --int_taskpanel_secret.UpdateAchievpanel();
  cmn.StopAllEnv( "audio/level3/env/aud_secondfloorcorridor_env", true );
  cmn.PlayAudio( "env", "audio/level3/env/aud_secondfloorcorridor_env", 1 );
  cmn.DefaultMorphItemSecret();

  --common_impl.EnvPlay( {"level2/env/aud_secondfloorcorridor_env"} , "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()

  cmn.DefaultMorphItemSecret();

end;
--*********************************************************************************************************************
function private.opn_secondfloorcorridor_scr ()
  
end;
--*********************************************************************************************************************
function private.InitAnims ()


end;
--*********************************************************************************************************************