-- name=rm_technicalroom_scr
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_technicalroom_scr";

  private.InitAnims();
  
  cmn.SecretroomhAddObj( private.room_objname, "roses",            1 );
  cmn.SecretroomhAddObj( private.room_objname, "knives",           2 );
  cmn.SecretroomhAddObj( private.room_objname, "fire",             3 );
  cmn.SecretroomhAddObj( private.room_objname, "planes",           4 );
  cmn.SecretroomhAddObj( private.room_objname, "cursed_tickets",   5 );
  cmn.SecretroomhAddObj( private.room_objname, "cards_of_destiny", 2 );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_technicalroom_scr = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
  "grm_technicalroom_scr_secondfloorcorridor_scr",
  };
  for i = 1, #gates do
    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;
  end;

    local mas_parent_gfx = 
    {
      private.room_objname,
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_technicalroom_scr", update_game_mode_technicalroom_scr, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_technicalroom_scr = function ()

  local effects_table = 
  {
  "obj_technicalroom_scr_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_technicalroom_scr", update_performance_mode_technicalroom_scr, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_technicalroom_scr () end;
  --------------------------------------------------------------------------------------------
  local opn_technicalroom_scr_map = function ()

    --common_impl.VisitMapRoom( "technicalroom_secret" );

  end;
  cmn.AddSubscriber( "opn_technicalroom_scr", opn_technicalroom_scr_map );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_technicalroom_scr();
  cmn.StartMorhpTask();  
  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );
  
end;
--*********************************************************************************************************************
function public.PreOpen ()

  --int_taskpanel_secret.UpdateAchievpanel();
  cmn.StopAllEnv( "audio/level3/env/aud_technicalroom_env", true );
  cmn.PlayAudio( "env", "audio/level3/env/aud_technicalroom_env", 1 );
  cmn.DefaultMorphItemSecret();

  --common_impl.EnvPlay( {"level2/env/aud_technicalroom_env"} , "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()

  cmn.DefaultMorphItemSecret();

end;
--*********************************************************************************************************************
function private.opn_technicalroom_scr ()
  
end;
--*********************************************************************************************************************
function private.InitAnims ()

  ObjAnimate( "spr_secondfloorcorridor_scr_woman", "alp", 1, 0, "", 
  { 
    0.0, 3, 1.0,
    1.0, 3, 0.6,
    2.0, 3, 1.0,
    3.0, 3, 0.6,
    4.0, 3, 1.0,
    5.0, 3, 0.6,
    6.0, 3, 1.0,
    7.0, 3, 0.6,
    8.0, 3, 1.0,
    8.2, 3, 0.6,
    8.4, 3, 1.0,
    8.6, 3, 0.6,
    8.8, 3, 1.0,
  } );

end;
--*********************************************************************************************************************