-- name=rm_waitinghall_scr
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_waitinghall_scr";

  private.InitAnims();
  
  ObjMultiSet( { 
    { "obj_timer_start", { event_mdown = private.StartTimer } },
  } );  
  cmn.SecretroomhAddObj( private.room_objname, "roses",            1 );
  cmn.SecretroomhAddObj( private.room_objname, "knives",           2 );
  cmn.SecretroomhAddObj( private.room_objname, "fire",             3 );
  cmn.SecretroomhAddObj( private.room_objname, "planes",           4 );
  cmn.SecretroomhAddObj( private.room_objname, "cursed_tickets",   5 );
  cmn.SecretroomhAddObj( private.room_objname, "cards_of_destiny", 2 );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_waitinghall_scr = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
  "grm_waitinghall_scr_window_scr",
  "grm_waitinghall_scr_aircompaniesstand_scr",
  };
  for i = 1, #gates do
    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;
  end;

    local mas_parent_gfx = 
    {
      private.room_objname,
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_waitinghall_scr", update_game_mode_waitinghall_scr, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_waitinghall_scr = function ()

  local effects_table = 
  {
  "obj_waitinghall_scr_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_waitinghall_scr", update_performance_mode_waitinghall_scr, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_waitinghall_scr () end;
  --------------------------------------------------------------------------------------------
  local opn_waitinghall_scr_map = function ()

    --common_impl.VisitMapRoom( "waitinghall_secret" );

  end;
  cmn.AddSubscriber( "opn_waitinghall_scr", opn_waitinghall_scr_map );

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_waitinghall_scr();

  local pages = ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state.pages;
  if ( pages[ "tutorial_page_1_scr" ][ "shown" ] == 0 ) then

    cmn.TutorialShow( "tutorial_page_1_scr" );

  else 

    cmn.StartMorhpTask();  

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  --int_taskpanel_secret.UpdateAchievpanel();
  cmn.StopAllEnv( "audio/level3/env/aud_airport_env", true );
  cmn.PlayAudio( "env", "audio/level3/env/aud_airport_env", 1 );
  
  cmn.DefaultMorphItemSecret();

  --common_impl.EnvPlay( {"level2/env/aud_waitinghall_env"} , "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()

end;
--*********************************************************************************************************************
function private.opn_waitinghall_scr ()
  
end;
--*********************************************************************************************************************
function private.InitAnims ()

  ObjAnimate( "obj_waitinghall_scr_people", "alp", 1, 0, "", 
  { 
    0.0, 3, 1.0,
    0.3, 3, 1.0,
    1.3, 3, 0.6,
    2.3, 3, 1.0,
    3.3, 3, 0.6,
    4.3, 3, 1.0,
    5.3, 3, 0.6,
    6.3, 3, 1.0,
    7.3, 3, 0.6,
    8.3, 3, 1.0,
    8.5, 3, 0.6,
    8.7, 3, 1.0,
    8.9, 3, 0.6,
    9.1, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
function private.StartTimer ()

  int_timer_scr.StartTimer();

end;