-- name=rm_achievements
--******************************************************************************************
function public.Init()

  private.updated = {};

  private.COUNT_LIST = 24;

  local rel = ObjGetRelations( "obj_achievements_obj" );

  local table_multiset = {};

  for i = 1, #rel.childs do

    if not (string.sub( rel.childs[ i ], #rel.childs[ i ] - 4, #rel.childs[ i ] ) == "_lock") then

      table.insert( table_multiset, { rel.childs[ i ], 
         {
           input = true,
           event_menter = function() private.PopupShow( rel.childs[ i ] ); end ,
           event_mleave = function() private.PopupHide() end
         } 
      } );      

    end;

  end;  

  table.insert( table_multiset, { "obj_achievements_btn_close", { 
      event_mdown = private.BtnCloseMouseDown, 
      event_menter = function() private.BtnMouseEnter( CURSOR_DOWN, "anm_achievements_btn_close_focus" ) end, 
      event_mleave = function() private.BtnMouseLeave( "anm_achievements_btn_close_focus" ) end; } } );

  table.insert( table_multiset, { "obj_achievements_btn_exit", { 
      event_mdown = private.BtnCloseMouseDown, 
      event_menter = function() private.BtnMouseEnter( CURSOR_HAND, "achievements_btn_exit" ) end, 
      event_mleave = function() private.BtnMouseLeave( "achievements_btn_exit" ) end; } } );

  
  ObjMultiSet( table_multiset );

  private.StartAnims();
  private.Anims();

end;
--******************************************************************************************
function public.PreOpen()

  interface.InterfaceSetInput( false ); 
  interface.InterfaceSetVisible( false );
 
  local current_room = common.GetCurrentRoom();
  if ( current_room ) then

    int.Lock( false );--разблокировка для карты EE

  end;
  private.Update();
  --cmn.PlayAudio(  "mus", "common/audio/aud_mt8_maintheme_mus", 1 );

end;
--******************************************************************************************
function public.Close()

  interface.InterfaceSetInput( true ); 
  interface.InterfaceSetVisible( true );  

  if cmn.IsFromMap then

    cmn.IsFromMap = false;
    ObjSet( "int_map", { input = true, visible = true, alp = 1 });

  end;    

  ObjSet( "tmr_common_anm", { active = true } );

end;
--******************************************************************************************
function private.Update ()

  if not ( private.COUNT_LIST > 24 ) then

    for i = 1, private.COUNT_LIST do

      local event = common_impl.GetNameAchiev( i );
--DbgTrace("event = "..event);
      if ( not private.updated[ event ] ) then

        if ( ng_global.achievements[ event ].done == 1 ) then
  
          if ( event == "win_secret_4" ) then

            ObjSet( "anm_achievements_win_secret_4", { alp = 1, playing = true, input = true } );

          else  

            ObjSet( "spr_achievements_"..event, { alp = 1 } );
            ObjSet( "spr_achievements_"..event.."_lock", { alp = 0 } );

          end;

          if ( event == "not_skip_mg_3" or event == "not_skip_mg_4" or event == "ho_hint_3" ) then
    
            ObjSet( "anm_achievments_"..event, { playing = true } );

          end;

          private.updated[ event ] = true;

        end;

      end;

    end;

  end;

end;
--******************************************************************************************
function private.BtnMouseEnter( type_cursor, button )
      
  if ( type_cursor ) then
    cmn.SetCursor( type_cursor );
  else
    cmn.SetCursor( CURSOR_DEFAULT );
  end;

  local obj = "pfx_"..button.."_focus";

  if ( GetPerformanceMode() == 1 ) then

      obj = "spr_"..button.."_focus";

  end;    

  local alp = ObjGet( obj ).alp;
  local time = 0.3;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,              0, alp, 
    time*( 1 - alp ), 0, 1
  } );

  cmn.PlayAudio( "sfx", "audio/aud_menter" );

end;
--******************************************************************************************
function private.BtnMouseLeave( button )
    
  cmn.SetCursor( CURSOR_DEFAULT );

  local obj = "pfx_"..button.."_focus";

  if ( GetPerformanceMode() == 1 ) then

      obj = "spr_"..button.."_focus";

  end; 

  local alp = ObjGet( obj ).alp;
  local time = 0.3;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,        0, alp,
    time * alp, 0,   0 
  });

end;
--******************************************************************************************
function public.Hide()
  private.BtnCloseMouseDown();
end;
--******************************************************************************************
function private.BtnCloseMouseDown( )
  
  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );

  local current_room = common.GetCurrentRoom();
  if ( not current_room ) then

    current_room = "rm_extra";

  end;  
--
--  if ng_global.achievements.previous_room == "mg_fish" then
--
--    ng_global.achievements.previous_room = "rm_frontyard";
--
--  end;

  cmn.GotoRoom( ng_global.achievements.previous_room, nil, true );

end;
--******************************************************************************************
--function --**POPUP**-- () end;
--******************************************************************************************

function private.PopupShow( name )

  cmn.SetCursor( CURSOR_LOUPE );

  name = string.sub( name, 18 );
  local title = "str_achievements_name_"..name;
  local description = "str_achievements_description_"..name;
  private.WindowShow( title, description );  

end;
--------------------------------------------------------------------------------------------
function private.PopupHide() 

  private.WindowHide();  
  cmn.SetCursor( CURSOR_DEFAULT );

end;

--******************************************************************************************
--function --**ANIMATIONS**-- () end;
--******************************************************************************************
function private.StartAnims()

  ObjAnimate( "obj_achievements_obj_add", "alp", 1, 0, "",
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.9,
    0.6, 0, 1
  } );

  ObjAnimate( "obj_achievements_scales_add", "alp", 1, 0, "",
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.9,
    0.6, 0, 1
  } );

end;
--******************************************************************************************
function private.Anims()

  local rel = ObjGetRelations( "obj_achievements_obj" );
  local ang;
  local tme;

  for i = 1, #rel.childs do

    ang = math.random(-5, 5)/100;
    tme = math.random(40,50)/10;
    ObjAnimate( rel.childs[ i ], "ang", 1, 0, "", 
    {
      0.0,      0, 0,
      tme*0.5,  2, ang,
      tme*1.5,  3, ang * -1,
      tme*2.0,  1, 0
    });

  end;

end;
--******************************************************************************************
--function --**Dialog**-- () end;
--******************************************************************************************
function private.WindowShow( dialog_text_title, dialog_text )

  local game_cursor = GetZoomCursorPos();
  dialog_pos_x = game_cursor[ 1 ];
  dialog_pos_y = game_cursor[ 2 ];
    
  ObjSet( "txt_achievements_window_title", { text = dialog_text_title } );
  ObjSet( "txt_achievements_window", { text = dialog_text } );

  private.GRID_CORNER_W =  58;
  private.GRID_CORNER_H =  58;
  private.GRID_MID_W    =   4;
  private.GRID_MID_H    =   4;

  private.GRID_BORDER_W = 100;
  private.GRID_BORDER_H = 100;

  private.MIN_W = 370;
  private.MAX_W = 500;
  private.MIN_H = 150;
  private.MAX_H = 500;

  private.WindowShow_ANIM_TIME = 0.3;

  local off_x = private.GRID_BORDER_W;
  local off_y = private.GRID_BORDER_H;

  local dialog_w = ObjGet( "txt_achievements_window" ).draw_width + off_x;

  if ( dialog_w < private.MIN_W ) then

    dialog_w = private.MIN_W;

  elseif ( dialog_w > private.MAX_W ) then

    dialog_w = private.MAX_W;

  end;

  local dialog_h = ObjGet( "txt_achievements_window" ).draw_height + off_y;

  if ( dialog_h < private.MIN_H ) then

    dialog_h = private.MIN_H;

  elseif ( dialog_h > private.MAX_H ) then
  
    dialog_h = private.MAX_H;

  end;

  local offset = 50;
  if ( dialog_pos_x < 171 ) then

    dialog_pos_x = 171 ;
  
  elseif ( dialog_pos_x > GetAppWidth() - 171 ) then

    dialog_pos_x = GetAppWidth() - 171;

  end;
  
  dialog_pos_y = dialog_pos_y - dialog_h/2;
  if ( dialog_pos_y - dialog_h < 0 ) then

    dialog_pos_y = dialog_h / 2;

  end;

  local grid_corner_w = private.GRID_CORNER_W;
  local grid_corner_h = private.GRID_CORNER_H;

  local grid_mid_w = private.GRID_MID_W;
  local grid_mid_h = private.GRID_MID_H;

  interface.FrameGridSet( "achievements_window",
  {
    grid_w   = dialog_w,
    grid_h   = dialog_h,
    corner_w = grid_corner_w,
    corner_h = grid_corner_h,
    mid_w    = grid_mid_w,
    mid_h    = grid_mid_h
  } );

  ObjSet( "obj_achievements_window",
  {
    active = true, visible = true,
    pos_x = dialog_pos_x, pos_y = dialog_pos_y
  } );

  local event_id = "show";
  
  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.WindowShow_ANIM_TIME;

  ObjAnimate( "obj_achievements_window", "alp", 0, 0, trg,
  {
    0.0, 2, 0,
    tme, 2, 1
  } );

  local pos_x = - dialog_w / 2 + 19;
  local pos_y = dialog_h / 2 - 42;

  ObjSet( "spr_achievements_window_decor_left", { pos_x = pos_x, pos_y = pos_y } );
  ObjSet( "spr_achievements_window_decor_right", { pos_x = - pos_x, pos_y = pos_y } );


end;
--******************************************************************************************
function private.WindowHide( )
  
  ObjSet( "obj_achievements_window", { input = false } );

  local event_id = "hide";  
  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.WindowShow_ANIM_TIME;

  ObjAnimate( "obj_achievements_window", "alp", 0, 0, trg,
  {
    0.0, 2, 1,
    tme, 2, 0
  } );

end;
--******************************************************************************************
function private.EventAnimEnd( event_id )

------------------------------------------------------------------------------------
  if ( event_id == "show" ) then
  
  ObjSet( "obj_achievements_window", { active = true, visible = true } );

------------------------------------------------------------------------------------
  elseif ( event_id == "hide" ) then

  ObjSet( "obj_achievements_window", { active = false, visible = false } );

------------------------------------------------------------------------------------
  end;

end;
--*****************************************************************************************
