-- name=rm_collectibles
--******************************************************************************************
function public.Init()

  private.collectibles = {};
  private.collectibles.current_big = { 0, 0 };
  private.collectibles.animtime = 0.4;

  private.collectibles.TMP_POS = {};
  private.collectibles.TMP_POS.X = 0;
  private.collectibles.TMP_POS.Y = 0;
  private.collectibles.POPUP_ANIM_FLY = 0.4;

 local table_multiset = {};

  for i = 1, 4 do

    for j = 1, 4 do

      table.insert( table_multiset, { "spr_collectibles_collect_"..i.."_"..j.."_small", 
         {
           event_mdown  = function() private.MouseDownSmall( i, j ); end ,
           event_menter = function() private.MouseEnter( CURSOR_LOUPE, i, j ); end ,
           event_mleave = function() private.MouseLeave( CURSOR_DEFAULT, i, j ) end
         } 
      } );

    end;

  end;  

  table.insert( table_multiset, { "obj_collectibles_btn_exit",
    { 
      event_mdown = private.BtnCloseMouseDown, 
      event_menter = function() private.BtnMouseEnter( CURSOR_HAND, "collectibles_btn_exit" ) end, 
      event_mleave = function() private.BtnMouseLeave( "collectibles_btn_exit" ) end;
    } 
  } );

  table.insert( table_multiset, { "obj_collectibles_btn_exit_2",
    { 
      event_mdown = private.BtnCloseMouseDown, 
      event_menter = function() private.BtnMouseEnter( CURSOR_HAND, "collectibles_btn_exit_2" ) end, 
      event_mleave = function() private.BtnMouseLeave( "collectibles_btn_exit_2" ) end;
    } 
  } );
  
  ObjMultiSet( table_multiset );

  if ng_global[ "collect" ] == nil then

     ng_global[ "collect" ] = {};

  end;

end;
--******************************************************************************************
--******************************************************************************************
function public.PreOpen()

  interface.InterfaceSetInput( false ); 
  interface.InterfaceSetVisible( false );  

--  local current_room = common.GetCurrentRoom();
--  if ( current_room ) then
--
--    int.Lock( false );--разблокировка для карты EE
--
--  end;
  
  private.Update();
  --cmn.PlayAudio(  "mus", "common/audio/aud_mt8_maintheme_mus", 1 );

end;
--******************************************************************************************
function public.Open()

  cmn.StopAllMus();
  cmn.StopAllEnv();
  cmn.PlayAudio( "mus", "audio/level1/mus/aud_scare_mid_short_mus", 1 );

end;
--******************************************************************************************
--******************************************************************************************
function public.Close()

  interface.InterfaceSetInput( true ); 
  interface.InterfaceSetVisible( true );  
  
  if cmn.IsFromMap then

    cmn.IsFromMap = false;
    ObjSet( "int_map", { input = true, visible = true, alp = 1 });
    
  end;  
  cmn.StopAllMus();
  cmn.GotoRoom( ng_global.achievements.previous_room, 0, true );

end;
--******************************************************************************************
--******************************************************************************************
function private.Update ()

  local prg   = ng_global.currentprogress;
  local level = ng_global.progress[ prg ].common.chapter;
  local lvl   = string.sub(level,6);

  if ( lvl == "ext" or lvl == "scr" ) then

    lvl = 4

  end;

  for i = 1, 4 do

      for j = 1, 4 do

          local name_collect = "collect2_"..i.."_"..j;

              if ( ng_global[ "collect" ][ name_collect ] ~= nil ) then
--ng_global[ "collect" ][ name_collect ].done = 1;
                  if ( ng_global[ "collect" ][ name_collect ].done == 1 ) then

                      ObjSet( "obj_collectibles_collect_"..i.."_"..j, { alp = 1, input = true } );
                      ObjSet( "obj_collectibles_collect_"..i.."_"..j.."_text", { alp = 1 } );      

                  else 

                      ObjSet( "obj_collectibles_collect_"..i.."_"..j, { alp = 0, input = false } );
                      ObjSet( "obj_collectibles_collect_"..i.."_"..j.."_text", { alp = 0 } );  

                  end;

              end;

      end;

  end;

end;
--******************************************************************************************
function private.BtnMouseEnter( type_cursor, name )

  if type_cursor then
    SetCursor( type_cursor );
  else
    SetCursor( CURSOR_DEFAULT );
  end;
  
  if GetPerformanceMode() == 0 then

    name = "pfx_"..name.."_focus";

  else

    name = "spr_"..name.."_focus";

  end;

  local alp = ObjGet( name ).alp;

  ObjAnimate( name, "alp", 0, 0, "", { 0, 0, alp, ( private.collectibles.animtime * ( 1 - alp ) ), 0, 1 } );
  cmn.PlayAudio( "sfx", "audio/aud_menter" );

end;
--******************************************************************************************
function private.BtnMouseLeave( name )

  SetCursor( CURSOR_DEFAULT );

  if GetPerformanceMode() == 0 then

    name = "pfx_"..name.."_focus";

  else

    name = "spr_"..name.."_focus";

  end;

  local alp = ObjGet( name ).alp;

  ObjAnimate( name, "alp", 0, 0, "", { 0, 1, alp, ( private.collectibles.animtime * alp ), 1, 0 } );
  cmn.PlayAudio( "sfx", "audio/aud_menter" );

end;
--******************************************************************************************
function private.MouseEnter( type_cursor, i, j )

  if type_cursor then
    SetCursor( type_cursor );
  else
    SetCursor( CURSOR_DEFAULT );
  end;

  local tme = private.collectibles.POPUP_ANIM_FLY;
  local scalex = ObjGet( "obj_collectibles_collect_"..i.."_"..j ).scale_x;
  local scaley = ObjGet( "obj_collectibles_collect_"..i.."_"..j ).scale_y;
  ObjAnimate( "obj_collectibles_collect_"..i.."_"..j, "scale_xy", 0, 0, "", 
  { 
    0.0, 3, scalex, scaley,
    tme, 3, 1.1, 1.1
  } ); 

--  local name = cmn.GetObjectName( ne_params.sender );
--  if GetPerformanceMode() == 0 then
--
--    name = "pfx_"..name.."_focus";
--
--  else
--
--    name = "spr_"..name.."_focus";
--
--  end;
--
--  local alp = ObjGet( name ).alp;
--
--  ObjAnimate( name, "alp", 0, 0, "", { 0, 0, alp, ( private.animtime * ( 1 - alp ) ), 0, 1 } );

  if ( type_cursor ~= CURSOR_DOWN ) then

     cmn.PlayAudio( "sfx", "audio/aud_menter" );
  
  end;

end;
--******************************************************************************************
function private.MouseLeave ( type_cursor, i, j )

  SetCursor( CURSOR_DEFAULT );

  local tme = private.collectibles.POPUP_ANIM_FLY;
  local scalex = ObjGet( "obj_collectibles_collect_"..i.."_"..j ).scale_x;
  local scaley = ObjGet( "obj_collectibles_collect_"..i.."_"..j ).scale_y;
  ObjAnimate( "obj_collectibles_collect_"..i.."_"..j, "scale_xy", 0, 0, "", 
  { 
    0.0, 3, scalex, scaley,
    tme, 3, 1.0, 1.0
  } ); 

--  local name = cmn.GetObjectName( ne_params.sender );
--  if GetPerformanceMode() == 0 then
--
--    name = "pfx_"..name.."_focus";
--
--  else
--
--    name = "spr_"..name.."_focus";
--
--  end;

--  local alp = ObjGet( name ).alp;
--
--  ObjAnimate( name, "alp", 0, 0, "", { 0, 1, alp, (private.animtime*alp  ), 1, 0 } );

--  if ( type_cursor ~= CURSOR_DOWN ) then
--
--     cmn.PlayAudio( "sfx", "audio/aud_menter" );
--  
--  end;

end;
--*********************************************************************************************************************
function public.Hide()
  private.BtnCloseMouseDown();
end;
--******************************************************************************************
function private.BtnCloseMouseDown ()

  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );

  local current_room = common.GetCurrentRoom();
  if ( not current_room ) then

    current_room = "rm_extra";

  end;  

  if ( private.collectibles.current_big[ 1 ] == 0 ) then

      cmn.GotoRoom( ng_global.achievements.previous_room, nil, true );

  else 

      local idx1 = private.collectibles.current_big[ 1 ];
      local idx2 = private.collectibles.current_big[ 2 ];

      private.MouseDownPopup ( idx1, idx2 );

  end;

end;
--******************************************************************************************
function private.MouseDownSmall( i, j )

  local func_end = function ()

    ObjSet( "rm_collectibles", { input = true } );
    local table_multiset = {};

    table.insert( table_multiset, { "obj_collectibles_popup", 
      { 
      event_mdown = function() private.MouseDownPopup( i, j ) end,  
      event_menter = function() private.MouseEnter( CURSOR_DOWN, i, j ); end ,
      event_mleave = function() private.MouseLeave( CURSOR_DEFAULT, i, j ) end
      } 
    } );

    ObjMultiSet( table_multiset );
    private.collectibles.current_big = { i, j };

  end;

  local tme = private.collectibles.POPUP_ANIM_FLY;

  if not private.collectibles.popup_first_show then

    private.collectibles.popup_first_show = true;
    ObjAttach( "obj_collectibles_popup", "rm_collectibles" );

  end;

  ObjSet( "spr_collectibles_popup_collect", { res = "assets/levels/menu/rm_collectibles/layers/collect_"..i.."/collect2_"..i.."_"..j } );
  ObjSet( "txt_collectibles_popup_name", { text = "str_collectibles_collect2_"..i.."_"..j } );
  ObjSet( "txt_collectibles_popup_info", { text = "str_collectibles_collect2_"..i.."_"..j.."_info" } );  

  local current_name = "obj_collectibles_collect_"..i.."_"..j;
  private.collectibles.TMP_POS.X = ObjGet( current_name ).pos_x;
  private.collectibles.TMP_POS.Y = ObjGet( current_name ).pos_y;

  ObjSet( "obj_collectibles_popup", { input = 1, pos_z = 10 } );

  ObjSet( "rm_collectibles", { input = false } );

  ObjAnimate( "obj_collectibles_popup", "scale_xy", 0, 0, "", 
  { 
    0.0, 3, 0.0, 0.0,
    tme, 3, 1.0, 1.0
  } );  

  ObjAnimate( "spr_collectibles_collect_"..i.."_"..j.."_small", "alp", 0, 0, "", 
  { 
    0.0, 3, 1.0,
    tme, 3, 0.0
  } );  

  ObjAnimate( "obj_collectibles_popup", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 3, private.collectibles.TMP_POS.X, private.collectibles.TMP_POS.Y,
    tme, 3, 512, 384
  } );  

end;
--******************************************************************************************
function private.MouseDownPopup( i, j )

  local func_end = function ()

    ObjSet( "rm_collectibles", { input = true } );
    private.collectibles.current_big = { 0, 0 };

  end;

  local tme = private.collectibles.POPUP_ANIM_FLY;

  ObjSet( "obj_collectibles_popup", { input = 0 } );

  ObjSet( "rm_collectibles", { input = false } );

  ObjAnimate( "obj_collectibles_popup", "scale_xy", 0, 0, "", 
  { 
    0.0, 3, 1.0, 1.0,
    tme, 3, 0.0, 0.0
  } );  

  ObjAnimate( "spr_collectibles_collect_"..i.."_"..j.."_small", "alp", 0, 0, "", 
  { 
    0.0, 3, 0.0,
    tme, 3, 1.0
  } ); 

  ObjAnimate( "obj_collectibles_popup", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 3, 512, 384,
    tme, 3, private.collectibles.TMP_POS.X, private.collectibles.TMP_POS.Y
  } );   

end;
--******************************************************************************************