-- name=rm_credits
--******************************************************************************************
function public.Init()

  private.amount = 120;
  private.timer = "tmr_titles_end";
  private.mirror = {};
  private.mirror.inc  = {};
  private.mirror.out  = {};
  private.mirror.temp = {};
  private.pages = 
  {

    { --EG--
      {  1,   6 },
      {  7,   13 },
      { 14,  20 },
      { 21,  27 },
      { 28,  33 },
      { 34,  39 },
      { 40,  44 },
      { 45,  50 },
      { 51,  58 },
      { 59,  61 },
      { 62,  65 }
    },
      { --BFG--
      { 66,  71 },
      { 72,  78 },
      { 79,  84 },
      { 85,  89 },
      { 90,  98 },
      { 99, 106 },
      { 107, 112 },
      { 113, 119 },
      { 120, 120 },      
      --{ 116, 122 },
      --{ 123, 128 },
      --{ 129, 133 },
      --{ 134, 134 },
      --{ 71,  75 },
      --{ 76,  80 },
      --{ 81,  private.amount }
    }

  };
  private.LAST_NAMES_EG  = 65;
  private.LAST_NAMES_BFG = private.amount;
  private.TIME_SHOW_CHAR = 0.05;
  private.size_text = {};
  private.size_text.width = {};
  private.size_text.count = {};

  private.screen_current = 0;

  private.screen_max = 11;
  private.screen_countline = { 6, 6, 3, 3, 9, 11, 8, 2, 7, 5, 1 };

  cmn.SetCursor(CURSOR_DEFAULT);

  ObjSet("obj_credits_btn_quit", {
    event_mdown = function () private.QuitClk(); end,
    event_menter = function () private.ButtonMouseEnter(); end,
    event_mleave = function () private.ButtonMouseLeave(); end
  }); 

  private.Anims();

end;
--******************************************************************************************
function public.PreOpen()

  interface.InterfaceSetInput( false ); 
  interface.InterfaceSetVisible( false );  
  
  ObjSet( "spr_credits_label_bigfish_logo", { alp = 0 } )
  ObjSet( "spr_credits_label_elephant_logo", { alp = 0 } )

  if IsCollectorsEdition() then

    ObjSet( "spr_credits_logo_ce", { visible  = 1, alp = 1 } );

  else

    ObjSet( "spr_credits_logo_ce", { visible = 0 } );

  end;

  ObjSet( "obj_credits_btn_quit", { alp = 0, input = 0 } );

  ObjCreate("obj_credits_names", "obj");
  ObjAttach("obj_credits_names", "rm_credits");
  ObjSet("obj_credits_names", {pos_x = 534, pos_y = 400, pos_z = 5, input = false});

--  for i = 1, private.screen_max do
--
--    ObjSet( "obj_credits_screen_"..i, { alp = 0 } );
--
--  end;
--
--  ObjSet( "txt_credits_title_1", { alp = 0 } );
--  ObjSet( "txt_credits_title_2", { alp = 0 } );

end;
--******************************************************************************************
function public.Open()

  private.current_room = common.GetCurrentRoom();

  --private.screen_current = 1;

  private.Animation()

  local func_end = function ()

    ObjSet( "obj_credits_btn_quit", { alp = 1, input = 1 } );

  end;

  ObjAnimate("obj_credits_btn_quit", "alp", 0, 0, func_end, { 
    0,  0,  0, 
    4,  0,  0, 
    5,  0,  1 
  });

  local prg  = ng_global.currentprogress;  
  local flag = true;

  if prg == "std" then 

    -- ! Вставить последнее событие прогресса
    if ( ng_global.progress[ "std" ][ "win_worriedmessage" ] ) then
     
      if ( ng_global.progress[ "std" ][ "win_worriedmessage" ].done == 1 ) then
        
        if IsCollectorsEdition() then

          ng_global.progress[ "std" ].common.gamewin   = true; 
          ng_global.progress[ "std" ].common.gamestart = false;

        end;

        SaveProfiles();
        SaveSettings();
      
      end;

    end;

  elseif prg == "ext" then

    -- ! Вставить последнее событие прогресса
    if ( ng_global.progress[ "ext" ][ "win_mgfate" ] ) then 

      if ( ng_global.progress[ "ext" ][ "win_mgfate" ].done == 1 ) then
        
        ng_global.progress[ "ext" ].common.gamewin   = true; 
        ng_global.progress[ "ext" ].common.gamestart = false;

        SaveProfiles();
        SaveSettings();      
        
      end;

    end;

  end;

  --common_impl.StopAllMus( "common/audio/mus/aud_credits_mus" );
  cmn.StopAllMus();
  cmn.StopAllEnv();
  cmn.PlayAudio( "mus", "audio/aud_grave_mus", 1 );

end;
--******************************************************************************************
function public.Close()

  interface.InterfaceSetInput( true );
  interface.InterfaceSetVisible( true );

  for i = 1, private.screen_max do

    ObjStopAnimate( "obj_credits_screen_"..i, "alp" );
    ObjSet( "obj_credits_screen_"..i, { alp = 0 } );

  end;

  --ObjDetach("obj_credits_pencil","obj_credits_names");
  ObjDelete("obj_credits_names");
  
  cmn.StopAllMus();
  cmn.StopAllEnv();

end;
--******************************************************************************************
function public.PreClose()

  --

end;
-------------------------------------------------------------------
function private.PencilDraw( id_string )

  ---Рисуем карандашом-----------------------------
  --ObjSet( "obj_credits_pencil", { alp = 1 } );

  local pos_x_start = ObjGet( "txt_credits_names_"..id_string ).pos_x + 20;

  --ObjSet( "obj_credits_pencil", { alp = 1, pos_x = pos_x_start, pos_y = ObjGet( "txt_credits_names_"..id_string ).pos_y } );
  --ObjAttach( "obj_credits_pencil", "txt_credits_names_"..id_string );
  --ObjAttach( "obj_credits_pencil", "obj_credits_names" );

  local start_posx = pos_x_start;
  local time = private.size_text.count[ id_string ] * private.TIME_SHOW_CHAR + 0.2;

  --ObjAnimate( "obj_credits_pencil", "pos_x", 0, 0, "", 
  --{ 
  --  0.0,  0, start_posx, 
  --  time, 0, start_posx + private.size_text.width[ id_string ];
  --} );
  -------------------------------------------------

end;

--******************************************************************************************---
function private.ShowOverlapEnd( name_dust )

  --ObjDelete( name_dust );

end;
--******************************************************************************************---

function private.ShowOverlap()

  local dName = "spr_credits_overlap";
--  ObjCreate( dName, "partsys_pm" );
--  ObjAttach( dName, "obj_credits_names" );
--
--  local params = 
--  {
--    active = 1,
--    pos_x = 0,
--    pos_y = 78,
--    pos_z = 100,
--    input = 0,
--    res = "assets/levels/menu/rm_credits/anims/pfx_dust",
--    alp = 0
--  }
--
--  ObjSet( dName, params );
  
  local trg = function () 
    private.ShowOverlapEnd( dName ); 
  end;
  
  ObjAnimate( dName, "alp", 0, 0, trg, 
  { 
    --0.0, 0, 0.0, 
    --1.2, 0, 0.0,
    --1.6, 0, 1.0,
    --3.2, 0, 1.0,
    --3.4, 0, 0.0
    0.0, 0, 0.0, 
    2.5, 0, 0.0,
    3.3, 0, 1.0,
    3.4, 0, 0.0
  } );

end;

function private.ShowOverlapLabel()
--
--  local dName = "pfx_credits_label_dust";
--  ObjCreate( dName, "partsys_pm" );
--  ObjAttach( dName, "obj_credits_label" );
--
--  local params = 
--  {
--    active = 1,
--    pos_x = 0,
--    pos_y = 0,
--    pos_z = 100,
--    input = 0,
--    res = "assets/levels/menu/rm_credits/anims/pfx_dust",
--    alp = 0
--  }
--
--  ObjSet( dName, params );
--  
--  local trg = "*private.ShowOverlapEnd( &apos;"..dName.."&apos; );"
--  
--  ObjAnimate( dName, "alp", 0, 0, trg, 
--  { 
--    0.0, 0, 0.0, 
--    0.2, 0, 1.0,
--    1.0, 0, 1.0,
--    1.3, 0, 0.0,
--  } );

end;

----Определение ширины выводимого текста------------------------------------
function private.WidthText()

  ObjCreate( "tmp_credits_names", "obj" );

  for i = 1, private.amount do
    
    local str_hub = "str_dialog_credits_names_"..i;
    local tmp_buffer = StringGet( str_hub );

    private.size_text.count[ i ] = string.len( tmp_buffer );

    local tmp_hub = "tmp_credits_names_"..i;
    ObjCreate( tmp_hub, "text" );

    local font = "assets/fonts/times";

    local title_params = 
    {
        text      = tmp_buffer, 
        res       = font, 
        fontsize  = 22,
        align     = 0,
        disprawtext = true
    };
    
    ObjSet( tmp_hub, title_params  );
    ObjAttach( tmp_hub, "tmp_credits_names" );
    
    ObjAttach( "tmp_credits_names", "rm_credits" );

    private.size_text.width[ i ] = ObjGet( tmp_hub ).draw_width;
    private.mirror.temp[ i ] = tmp_buffer;
    
  end;

  ObjDelete( "tmp_credits_names" );

end;
--******************************************************************************************---
function private.Animation()
  
  ObjSet( "spr_credits_label_bigfish_logo", { alp = 0 } )

  ObjAnimate( "spr_credits_label_elephant_logo", "alp", 0, 0, "", 
  { 
    0.0, 0, 0.0, 
    0.3, 0, 0.0,
    0.8, 0, 1.0
  } );

  private.WidthText();

  for i = 1, private.amount do
    
    local obj_hub = "str_dialog_credits_names_"..i;
    private.mirror.inc[ i ] = StringGet( obj_hub );
    private.mirror.out[ i ] = private.IncToOut( private.mirror.inc[ i ] );
    
  end;
  
  local id_company = 1;
  local id_groupe  = 1;
  local id_string  = 1;
  
  private.CreateString( id_company, id_groupe );
  private.OutToIncAnim( id_company, id_groupe, id_string );

  private.PencilDraw( id_string );
  
end;
--******************************************************************************************------
function private.CreateString( id_company, id_groupe )

  local font = "assets/fonts/times";

  local index = private.pages[ id_company ][ id_groupe ];

  --DbgTrace( "____CREDITS index = "..index[ 1 ] );

  local count_string = 0;

  --Смещение фразы (с)EG ниже----
  if index[ 2 ] == private.LAST_NAMES_BFG then

    count_string = 3;
  
  elseif index[ 2 ] > private.LAST_NAMES_EG then

    count_string = 1;
  
  end; 
  ---------------------
  
  for i = index[ 1 ], index[ 2 ] do

    local title_name = "txt_credits_names_"..i;

    if ( not ObjGet( title_name ) ) then

      ObjCreate( title_name, "text" );
      ObjAttach( title_name, "obj_credits_names" );

      local fst_dev_id = string.sub( private.mirror.temp[ i ], 1, 1 );
      
      local title_params = 
      {
        text      = "", 
        res       = font, 
        fontsize  = 22,
        color_r   = 0.0,
        color_g   = 0.0,
        color_b   = 0.0,
        maxwidth  = 750,
        pos_y     = count_string * 40 - 10,
        pos_x     = - 0.5 * private.size_text.width[ i ],
        align     = 0
      };

      if ( fst_dev_id == " " ) then

        title_params = 
        {
          text      = "", 
          res       = font, 
          fontsize  = 22,
          color_r   = 0.0,
          color_g   = 0.0,
          color_b   = 1.0,
          maxwidth  = 600,
          pos_y     = count_string * 40,
          pos_x     = - 0.5 * private.size_text.width[ i ],
          align     = 0
        };

      end;      

      ObjSet( title_name, title_params );

      count_string = count_string + 1;

    end;
    
  end;
  
end;
--******************************************************************************************------
function private.NextGroup( id_company, id_groupe, id_string )

  local index = private.pages[ id_company ][ id_groupe ];
  
  --ObjDetach( "obj_credits_pencil" );

  for i = index[ 1 ], index[ 2 ] do  

    ObjDelete( "txt_credits_names_"..i );

  end;

  if id_string == private.LAST_NAMES_EG + 1 then

    id_groupe  = 0;
    id_company = 2;

    --private.ShowOverlap();

    ObjAnimate( "spr_credits_label_elephant_logo", "alp", 0, 0, "", 
    { 
      0.0, 0, 1.0, 
      0.2, 0, 0.0
    } );

    ObjAnimate( "spr_credits_label_bigfish_logo", "alp", 0, 0, "", 
    { 
      0.0, 0, 0.0, 
      0.2, 0, 0.0,
      0.4, 0, 1.0
    } );

  elseif id_string == private.LAST_NAMES_BFG + 1 then

    --private.ShowOverlap();

    ObjAnimate( "spr_credits_label_elephant_logo", "alp", 0, 0, "", 
    { 
      0.0, 0, 0.0, 
      0.2, 0, 0.0,
      0.4, 0, 1.0
    } );

    ObjAnimate( "spr_credits_label_bigfish_logo", "alp", 0, 0, "", 
    { 
      0.0, 0, 1.0, 
      0.2, 0, 0.0
    } );

    id_string  = 1;
    id_groupe  = 0;
    id_company = 1;

  end;
  
  id_groupe = id_groupe + 1;
  private.CreateString( id_company, id_groupe );
  private.OutToIncAnim( id_company, id_groupe, id_string );

  private.PencilDraw( id_string );
  
end;

--******************************************************************************************------

function private.OutToIncAnim( id_company, id_groupe, id_string, id_inc, id_out )

  id_inc = id_inc or 1;
  id_out = id_out or 2;

  local text_inc = private.mirror.inc[ id_string ];
  local text_out = private.mirror.out[ id_string ];

  local char = string.sub( text_inc, id_inc, id_inc );
  local step = - 1 + private.CharBytes( char );

  id_inc = id_inc + step;

  local out = string.sub( text_inc, 1, id_inc )..string.sub( text_out, id_out );

  ObjSet( "txt_credits_names_"..id_string, { text = out } );

  if ( id_out <= string.len( text_out ) ) then

    id_inc = id_inc + 1;
    id_out = id_out + 1;  

    --local trg = string.format( "function () private.OutToIncAnim( %i, %i, %i, %i, %i ); end;", id_company, id_groupe, id_string, id_inc, id_out );

    local trg = function ()
      private.OutToIncAnim( id_company, id_groupe, id_string, id_inc, id_out )
    end;


    ObjSet( "tmr_credits_show", { time = private.TIME_SHOW_CHAR, endtrig = trg, playing = 1 } );
  
  else

    local index = private.pages[ id_company ][ id_groupe ];
    id_string = id_string + 1;

    if id_string <= index[ 2 ] then

      private.PencilDraw( id_string );

      --вывод очередной строки группы
      private.OutToIncAnim( id_company, id_groupe, id_string );

    else

      --плавное отключение текущей группы, по окончанию переход на новую группу
      if index[ 2 ] - index[ 1 ] ~= 0 then

        for i = index[ 1 ], ( index[ 2 ] - 1 ) do
      
          if ( id_string ) ~= ( private.LAST_NAMES_BFG + 1 ) then

            ObjAnimate( "txt_credits_names_"..i, "alp", 0, 0, "", 
            { 
              0.0, 0, 1.0, 
              2.5, 0, 1.0,
              3.5, 0, 0.0
            } );

            --ObjAnimate( "obj_credits_pencil", "alp", 0, 0, "", 
            --{ 
            --  0.0, 0, 1.0, 
            --  0.2, 0, 0.0 
            --} );

          else

            private.ShowOverlap()
            
            ObjAnimate( "txt_credits_names_"..i, "alp", 0, 0, "", 
            { 
              0.0, 0, 1.0, 
              2.3, 0, 1.0,
              3.2, 0, 0.0
            } );

--            ObjAnimate( "obj_credits_pencil", "alp", 0, 0, "", 
--            { 
--              0.0, 0, 1.0, 
--              0.2, 0, 0.0 
--            } );
--
          end;

        end;

      end;
        
      local end_trg = function () 
        private.NextGroup( id_company, id_groupe, id_string ); 
      end;
      
      if id_string ~= ( private.LAST_NAMES_BFG + 1 ) then

        ObjAnimate( "txt_credits_names_"..index[ 2 ], "alp", 0, 0, end_trg, 
        { 
          0.0, 0, 1.0, 
          2.3, 0, 1.0,
          3.2, 0, 0.0
        } );
        
        --ObjSet( "obj_credits_pencil", { alp = 0 } );

        private.ShowOverlap()

      else

        ObjAnimate( "txt_credits_names_"..index[ 2 ], "alp", 0, 0, end_trg, 
        { 
          0.0, 0, 1.0, 
          2.3, 0, 1.0,
          3.2, 0, 0.0
        } );

        --ObjSet( "obj_credits_pencil", { alp = 0 } );

        private.ShowOverlap()

      end;      
      ---------------------------------------------------------------------------------
    
    end;

  end;
  
end;

--******************************************************************************************

function private.IncToOut( text )

  local add = "\32";--text_tbl[ math.random( 1, #text_tbl ) ];

  local char = string.sub( text, 1, 1 );
  --DbgTrace( "char "..char );
  local step = 1 + private.CharBytes( char );

--[[
  if ( char == "\32" )
  or ( char == "\10" )
  or ( char == "." )
  or ( char == "," )
  or ( char == "!" )
  or ( char == "?" )
  or ( char == ":" )
  or ( char == ";" )
  then

    add = char;

  end;
]]
  local next = string.sub( text, step );

  if ( string.len( next ) == 0 ) then

    return add;

  else

    return add..private.IncToOut( next );

  end;  

end;
--******************************************************************************************

function private.CharBytes( char )

  local out = nil;

  local byte = string.byte( char, 1, 1 );

  --DbgTrace( "char = "..char.." byte = "..byte );

  if ( byte > 240 ) then

    out = 4;

  elseif ( byte > 224 ) then

    out = 3;

  elseif ( byte >= 192 ) then

    out = 2;

  else

    out = 1;

  end;

  return out;

end;
--******************************************************************************************

function private.AnimationExecute()

  if ( GetPerformanceMode() == 0 ) then
 
    --ObjSet( "obj_credits_pencil", { active = 1, visible = 1 } );
    --ObjSet( "obj_moregames_animation_drop", { active = 1 } );

  else

    --ObjSet( "obj_credits_pencil", { active = 0, visible = 0 } );  
    --ObjSet( "obj_moregames_animation_drop", { active = 0 } ); 
    
  end;

end;

--******************************************************************************************

--ObjAnimate( "spr_credits_pencil", "pos_xy", 1, 0, "", 
--{ 
--  0.0, 0, -10, 13,
--  0.06, 0,   0, 0,
--  0.12, 0, -10, 13
--} );

--******************************************************************************************
function private.ButtonMouseEnter ()

  local tme = 0.3;

  local obj = "pfx_credits_btn_quit_focus";

  if ( GetPerformanceMode() == 1 ) then

      obj = "spr_credits_btn_quit_focus";

  end;  

  local alp = ObjGet( obj ).alp;
  cmn.SetCursor( CURSOR_HAND );

  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,               0,    alp, 
    tme *( 1 - alp ),  0,    1
  } );

  --cmn.PlayAudio( "sfx", "common/audio/aud_guidance" );

end;
--******************************************************************************************
function private.ButtonMouseLeave ()

  local tme = 0.3;

  local obj = "pfx_credits_btn_quit_focus";

  if ( GetPerformanceMode() == 1 ) then

      obj = "spr_credits_btn_quit_focus";

  end;  

  local alp = ObjGet( obj ).alp;
  cmn.SetCursor( CURSOR_DEFAULT );

  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,                      0, alp, 
    tme * alp, 0,    0
  } );

end;
--******************************************************************************************
--port. fix
function public.QuitClk()
  private.QuitClk();
end;
--******************************************************************************************
function private.QuitClk ()

  ObjSet( "rm_credits", { input = 0 } );
  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );

--  ObjStopAnimate( "obj_credits_screen_"..private.screen_current, "alp" );
--
--  local func_end = function ()

    private.Exit();

  --end;

--  ObjAnimate("obj_credits_screen_"..private.screen_current - 1, "alp", 0, 0, "", { 
--    0,    0,  ObjGet( "obj_credits_screen_"..private.screen_current-1 ).alp, 
--    0.5,  0,  0 
--  });
--
--  ObjAnimate("obj_credits_btn_quit", "alp", 0, 0, func_end, { 
--    0,    0,  1, 
--    0.5,  0,  1, 
--    0.8,  0,  0 
--  });

  --cmn.PlayAudio( "sfx", "common/audio/aud_click_menu" );

end;
--******************************************************************************************
function public.Exit()
  private.Exit();
end;
function private.Exit()

  local prg  = ng_global.currentprogress;  
  local flag = true;

  if prg == "std" then 

    --! Вставить последнее событие прогресса
    if ( ng_global.progress[ "std" ][ "win_worriedmessage" ] ) then
     
      if ( ng_global.progress[ "std" ][ "win_worriedmessage" ].done == 1 ) then
        
        private.Skip();
        flag = false;
        
      end;

    end;

  elseif prg == "ext" then

    -- ! Вставить последнее событие прогресса
    if ( ng_global.progress[ "ext" ][ "win_mgfate" ] ) then 

      if ( ng_global.progress[ "ext" ][ "win_mgfate" ].done == 1 ) then
        
        private.SkipExt();
        flag = false;
        
      end;
      
    end;

  end;

  --common_impl.StopAllMus();

  if ( not private.current_room ) then

    private.current_room = "rm_menu";

  end;

  if ( flag ) then

    common.GotoRoom( private.current_room );

  end;

end;
--******************************************************************************************
function private.Skip ()

  if IsCollectorsEdition() then

    ng_global.progress[ "std" ].common.gamewin   = true; 
    ng_global.progress[ "std" ].common.gamestart = false;

  end;

  SaveProfiles();
  SaveSettings();

  cmn.SetCursor( CURSOR_DEFAULT );  

  common.LevelSwitch( "menu", "game" );

end;
--******************************************************************************************
function private.SkipExt ()

  ng_global.progress[ "ext" ].common.gamewin   = true; 
  ng_global.progress[ "ext" ].common.gamestart = false;

  SaveProfiles();
  SaveSettings();

  cmn.SetCursor( CURSOR_DEFAULT );  

  common.LevelSwitch( "menu", "game" );

end;
--******************************************************************************************
function private.Anims ()

  ObjAnimate("obj_credits_wheel", "ang", 1, 0, "", 
  {
    0.0,0, 0.02,
    3.0,3,-0.02,
    6.0,3, 0.02
  });

  ObjAnimate("spr_credits_wiper_1", "ang", 1, 0, "", 
  {
    0.0,0,0.0,  
    8.0,0,0.0 , 
    8.7,3,1.7,
    9.4,3,0.0
  });

  ObjAnimate("spr_credits_wiper_2", "ang", 1, 0, "", 
  {
    0.0,0,0.0,  
    8.0,0,0.0,  
    8.7,3,1.7,
    9.4,3,0.0
  });

  ObjAnimate("spr_credits_light_add", "alp", 1, 0, "", 
  {
    0.0,0,1,
    1.5,0,1,
    2.0,0,0.9,
    2.5,0,1,
    3.6,0,1,
    4.8,0,0.8,
    5.7,0,1
  });

end;
