-- name=rm_diary
--*********************************************************************************************************************
function public.Init ()
  -- вызывается сразу после загрузки модуля до загрузки профиля
  private.room_objname = "rm_diary";

  ObjSet( "btn_diary_close",
  {
    event_mdown  = function () private.Hide() end,
    event_menter = function () private.MouseEnter( "btn_diary_close" ) end,
    event_mleave = function () private.MouseLeave( "btn_diary_close" ) end
  } );

  ObjSet( "btn_diary_left",
  {
    event_mdown  = function () private.DiaryPageDown( "btn_diary_left" ) end,
    event_menter = function () private.MouseEnter( "btn_diary_left" ) end,
    event_mleave = function () private.MouseLeave( "btn_diary_left" ) end
  } );

  ObjSet( "btn_diary_right",
  {
    event_mdown  = function () private.DiaryPageDown( "btn_diary_right" ) end,
    event_menter = function () private.MouseEnter( "btn_diary_right" ) end,
    event_mleave = function () private.MouseLeave( "btn_diary_right" ) end
  } );

  private.page_count = 17;

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  interface.InterfaceSetVisible( false );
  interface.InterfaceSetInput( false );

  private.InitState();

end;
--*********************************************************************************************************************
function public.Open ()

  cmn.StopAllMus();
  cmn.StopAllEnv();

end;
--*********************************************************************************************************************
function public.PreClose ()

end;
--*********************************************************************************************************************
function public.Close ()

  interface.InterfaceSetVisible( true );
  interface.InterfaceSetInput( true );
  
  if cmn.IsFromMap then

    cmn.IsFromMap = false;
    ObjSet( "int_map", { input = true, visible = true, alp = 1 });

  end;  

end;
--*********************************************************************************************************************
function public.Hide()
  private.Hide();
end;
--*********************************************************************************************************************
function private.Hide ()

  local room = common.GetCurrentRoom();

  if ( room == "rm_achievements" ) then

    room = ng_global.achievements.previous_room;

  end;

  cmn.GotoRoom( room );

end;
--*********************************************************************************************************************
function private.MouseEnter ( btn )

  cmn.SetCursor( CURSOR_HAND );
  cmn.PlayAudio( "sfx", "audio/aud_menter" );

  local prefix = "pfx_";

  if string.find( btn, "close" ) then
 
    if ( GetPerformanceMode() == 1 ) then
 
        prefix = "spr_";

    end;    

  else 

    prefix = "spr_";

  end;

  name = prefix..btn.."_focus";

  ObjAnimate( name, "alp", 0, 0, "", 
  {
    0.0, 0, ObjGet( name ).alp,
    0.3, 0, 1,
  } );

end;
--*********************************************************************************************************************
function private.MouseLeave ( btn )

  cmn.SetCursor( CURSOR_DEFAULT );

  local prefix = "pfx_";

  if string.find( btn, "close" ) then
    
    if ( GetPerformanceMode() == 1 ) then

        prefix = "spr_";

    end;    

  else 

    prefix = "spr_";

  end;

  name = prefix..btn.."_focus";

  ObjAnimate( name, "alp", 0, 0, "", 
  {
    0.0, 0, ObjGet( name ).alp,
    0.3, 0, 0,
  } );

end;
--*********************************************************************************************************************
function private.InitState ()

  local prg = ng_global.currentprogress;
  local current = ng_global.progress[ prg ].common.diary.current;
  local page_pos = { 0, 530 };

  for i = 1, math.ceil( private.page_count / 2 ) do

    ObjSet( "obj_diary_group_"..i, { alp = 0, visible = false } );

  end;

  ObjSet( "obj_diary_group_"..current, { alp = 1, visible = true } );

  for i = 1, ng_global.progress[ prg ].common.diary.last_page  do

    local group = math.ceil( i / 2 );
    local page  = math.fmod( i , 2 );

    if ( page == 0 ) then

      page = 2;

    end;

    ObjAttach( "obj_diary_page_"..ng_global.progress[ prg ].common.diary.pages[ i ], "obj_diary_group_"..group );
    ObjSet( "obj_diary_page_"..ng_global.progress[ prg ].common.diary.pages[ i ],
    {
      pos_x = page_pos[ page ],
      alp = 1,
      visible = true
    } );

  end;

  private.ButtonsActive();

end;
--*********************************************************************************************************************
function private.DiaryPageDown ( course )

  ObjSet( "rm_diary", { input = false } );

  cmn.PlayAudio( "sfx", "audio/aud_list_diary", 0 );

  local def = 1;

  if ( course == "btn_diary_left" ) then

    def = -1;

  end;

  local func_end = function ()

    ObjSet( "rm_diary", { input = true } );

    local prg = ng_global.currentprogress;

    ObjSet( "obj_diary_group_"..( ng_global.progress[ prg ].common.diary.current ), { alp = 0, visible = false } );

    ng_global.progress[ prg ].common.diary.current = ng_global.progress[ prg ].common.diary.current + def;

    private.ButtonsActive();

  end;

  local prg = ng_global.currentprogress;

  ObjAnimate( "obj_diary_group_"..ng_global.progress[ prg ].common.diary.current, "alp", 0, 0, "", 
  { 
    0.0, 0, 1, 
    0.2, 0, 0 
  } );

  ObjSet( "obj_diary_group_"..( ng_global.progress[ prg ].common.diary.current + def ), { alp = 0, visible = true } );

  ObjAnimate( "obj_diary_group_"..( ng_global.progress[ prg ].common.diary.current + def ), "alp", 0, 0, func_end, 
  { 
    0.0, 0, 0, 
    0.2, 0, 1 
  } );

end;
--*********************************************************************************************************************
function private.ButtonsActive ()

  local prg = ng_global.currentprogress;
  local right_index = math.ceil( ng_global.progress[ prg ].common.diary.last_page / 2 );
  local left_index  = 1;
  
  if ( ng_global.progress[ prg ].common.diary.current ~= "" ) then
    
    local num = tonumber( ng_global.progress[ prg ].common.diary.current );

    if ( num < tonumber( right_index ) ) then

      ObjSet( "btn_diary_right", { color_r = 1.0, color_g = 1.0, color_b = 1.0, input = true } );

    else

      ObjSet( "btn_diary_right", { color_r = 0.4, color_g = 0.4, color_b = 0.4, input = false } );

    end;
    
    if ( num > tonumber( left_index ) ) then

      ObjSet( "btn_diary_left", { color_r = 1.0, color_g = 1.0, color_b = 1.0, input = true } );

    else

      ObjSet( "btn_diary_left", { color_r = 0.4, color_g = 0.4, color_b = 0.4, input = false } );

    end;
    
  end; 

end;
--*********************************************************************************************************************
--*********************************************************************************************************************