-- name=rm_extra
--******************************************************************************************
function public.Init()

  private.tab = 
  {
    "art",
    "music",
    "wallpaper",
    "playextra",
    "screensaver",
    "archive"
  };

  private.music = 
  { 
    "soundtrack_1",
    "soundtrack_2",
    "soundtrack_3",
    "soundtrack_4",
    "soundtrack_5"
  };

  private.tab_current       = 4;
  private.wallpaper_current = 1;
  public.wallpaper_current_big = 1;
  public.wallpaper_current_big_pos = {0,0};
  private.art_current       = 1;
  public.art_current_big = 1;
  public.art_current_big_pos = {0,0};
  public.music_current     = 1;
  private.music_is_play     = false;
  private.achievements_opn = false;
  private.collectibles_opn = false;

  ObjMultiSet( {
    {"obj_extra_button_playextra", 
       {
         event_mdown =  function () private.Play(); end,
         event_menter = function () private.ButtonMouseEnter( 'playextra' ); end,
         event_mleave = function () private.ButtonMouseLeave( 'playextra' ); end 
       } 
    },    
    {"obj_extra_button_wallpaper",
      {
        event_mdown =  function () private.UpdateExtraScr( 3 ); end,
        event_menter = function () private.ButtonMouseEnter( 'wallpaper' ); end,
        event_mleave = function () private.ButtonMouseLeave( 'wallpaper' ); end
      }
    },
    {"obj_extra_wallpaper",
      {
        event_mdown =  function () private.ButtonDownExtra(); end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end
      }
    },
    {"spr_extra_wallpaper_big",
      {
        event_mdown =  function () private.ButtonDownWallpaperBig(); end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end
      }
    },
    {"spr_extra_button_setwallpaper",
      {
        event_mdown =  function () private.Setwallpaper(); end,
        event_menter = function () private.ButtonMouseEnter( 'setwallpaper' ); end,
        event_mleave = function () private.ButtonMouseLeave( 'setwallpaper' ); end
      }
    },
    {"obj_extra_button_art",
      {
        event_mdown =  function () private.UpdateExtraScr( 1 ); end,
        event_menter = function () private.ButtonMouseEnter( 'art' ); end,
        event_mleave = function () private.ButtonMouseLeave( 'art' ); end
      }
    },
    {"obj_extra_button_archive",
      {
        event_mdown =  function () private.ButtonReplayroom(); end,
        event_menter = function () private.ButtonMouseEnter( 'archive' ); end,
        event_mleave = function () private.ButtonMouseLeave( 'archive' ); end
      }
    },      
    {"obj_extra_art",
      {
        event_mdown =  function () private.ButtonDownExtra(); end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end
      }
    },
    {"spr_extra_art_big",
      {
        event_mdown =  function () private.ButtonDownArtBig(); end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end
      }
    },
    {"spr_extra_art_big_over",
      {
        event_mdown =  function () private.ButtonDownArtBig(); end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end
      }
    },
    {"obj_extra_button_music",
      {
        event_mdown =  function () private.UpdateExtraScr( 2 ); private.AnimText ( 0 ); end,
        event_menter = function () private.ButtonMouseEnter( 'music' ); end,
        event_mleave = function () private.ButtonMouseLeave( 'music' ); end
      }
    },
    {"obj_extra_button_collectibles",
      {
        event_mdown =  function () private.ButtonCollectibles(); end,
        event_menter = function () private.ButtonMouseEnter( 'collectibles' ) end,
        event_mleave = function () private.ButtonMouseLeave( 'collectibles' ) end
      }
    },
    {"obj_extra_button_achievments",
      {
        event_mdown =  function () private.ButtonAchievments(); end,
        event_menter = function () private.ButtonMouseEnter( 'achievments' ); end,
        event_mleave = function () private.ButtonMouseLeave( 'achievments' ); end
      }
    },
    {"obj_extra_button_secretroom",
      {
        event_mdown =  function () private.ButtonSecretroom(); end,
        event_menter = function () private.ButtonMouseEnter( 'secretroom' ); end,
        event_mleave = function () private.ButtonMouseLeave( 'secretroom' ); end
      }
    },
    --{"obj_extra_button_screensaver",
    --  {
    --    event_mdown =  function () private.UpdateExtraScr( 5 ); end,
    --    event_menter = function () private.ButtonMouseEnter( 'screensaver' ); end,
    --    event_mleave = function () private.ButtonMouseLeave( 'screensaver' ); end
    --  }
    --},
    {"obj_extra_button_menu",
      {
        event_mdown =  function () private.ButtonDownExit(); end,
        event_menter = function () private.ButtonMouseEnter( 'menu' ); end,
        event_mleave = function () private.ButtonMouseLeave( 'menu' ); end
      }
    },
    {"obj_extra_button_monsters",
      {
        event_mdown =  function () private.ButtonMonsters(); end,
        event_menter = function () private.ButtonMouseEnter( 'monsters' ); end,
        event_mleave = function () private.ButtonMouseLeave( 'monsters' ); end
      }
    },
    {"obj_extra_button_close",
      {
        event_mdown =  function () private.ButtonDownExit(); end,
        event_menter = function () private.ButtonMouseEnter( 'close' ); end,
        event_mleave = function () private.ButtonMouseLeave( 'close' ); end
      }
    },
    {"spr_extra_button_art_arrow_left",
      {
        event_mdown =  function () private.ArtNext( -1 ); end,
        event_menter = function () private.ButtonMouseEnter( 'art_arrow_left' ); end,
        event_mleave = function () private.ButtonMouseLeave( 'art_arrow_left' ); end
      }
    },
    {"spr_extra_button_art_arrow_right",
      {
        event_mdown =  function () private.ArtNext( 1 ); end,
        event_menter = function () private.ButtonMouseEnter( 'art_arrow_right' ); end,
        event_mleave = function () private.ButtonMouseLeave( 'art_arrow_right' ); end
      }
    },
    {"obj_extra_button_saveart",
      {
        event_mdown =  function () private.Saveart(); end,
        event_menter = function () private.ButtonMouseEnter( 'saveart' ); end,
        event_mleave = function () private.ButtonMouseLeave( 'saveart' ); end
      }
    },
    {"obj_extra_button_setwallpaper",
      {
        event_mdown =  function () private.Setwallpaper(); end,
        event_menter = function () private.ButtonMouseEnter( 'setwallpaper' ); end,
        event_mleave = function () private.ButtonMouseLeave( 'setwallpaper' ); end
      }
    },
    --{"obj_extra_button_screensaver",
    --  {
    --    event_mdown =  function () private.Setscreensaver(); end,
    --    event_menter = function () private.ButtonMouseEnter( 'screensaver' ); end,
    --    event_mleave = function () private.ButtonMouseLeave( 'screensaver' ); end
    --  }
    --},
    --{"obj_extra_button_savemusic",
    --  {
    --    event_mdown =  function () private.Savemusic(); end,
    --    event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
    --    event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end
    --  }
    --},
    {"obj_extra_button_next_track",
      {
        event_mdown =  function () private.ButtonNextTrack(); end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end
      }
    },
    {"obj_extra_button_prev_track",
      {
        event_mdown =  function () private.ButtonPrevTrack(); end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end
      }
    },
    {"obj_extra_button_play_track",
      {
        event_mdown =  function () private.ButtonPlayTrack(); end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end
      }
    },
    {"obj_extra_button_volume_up",
      {
        event_mdown =  function () private.ButtonVolumeUp(); end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end
      }
    },
    {"obj_extra_button_volume_down",
      {
        event_mdown =  function () private.ButtonVolumeDown(); end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end
      }
    },
    {"obj_extra_music",
      {
        event_mdown =  function () private.ButtonDownExtra(); end,
        --event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
        --event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end
      }
    }

  } );

  for i=1, 8 do
    ObjSet("spr_extra_art_"..i, {
      event_mdown =  function () private.ArtBig( i, "spr_extra_art_"..i ); end,
      event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end
    });
  end;

  for i=1, 10 do
    ObjSet("spr_extra_wallpaper_"..i, {
      event_mdown =  function () private.WallpaperBig( i, "spr_extra_wallpaper_"..i ); end,
      event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end
    });
  end;

  if private.music_is_play then

      local name = "spr_extra_music_track"..public.music_current.."_pause";
      ObjSet( name, { alp = 1, input = 1 } );

      name = "spr_extra_music_track"..public.music_current.."_play";
      ObjSet( name, { input = 0, alp = 0 } );

      private.music_is_play = false;

  end;
    
  local platform = GetPlatform();    
  if platform == "mac" or port.isPortable() == 1 then

    ObjDelete( "obj_extra_button_screensaver" );
    ObjSet("obj_extra_button_savemusic",{ alp = 0, visible = 0, active = 0, input = 0 });
  end;    

end;
--******************************************************************************************
function public.PreOpen()
 

  
end;
--******************************************************************************************
function public.Open()

  cmn.StopAllMus();
  cmn.StopAllEnv();
  private.PlayExtraTrack( public.music_current );

end;
--******************************************************************************************
--Global animation--

--for i = 1, 5 do
--
--  ObjAnimate( "spr_extra_music_track"..i.."_light", "alp", 1, 0, "", 
--  {
--     0.0, 0, 0.6,
--     0.8, 0, 1.0,
--     1.6, 0, 0.3,
--     2.4, 0, 0.6
--  } ); 
--
--end;

--******************************************************************************************
function private.UpdateExtraScr( new_scr )

  
  new_scr = tonumber( new_scr );
  
  --private.tab_old           = new_scr;
  if private.tab_current ~= new_scr then

    ObjSet( "obj_extra_button_"..private.tab[ new_scr ], {event_mdown = "" } );

    cmn.PlayAudio( "sfx", "audio/aud_click_menu" );

    --private.ActivateExtraScr( 0 );
    ObjSet( "obj_extra_button_collectibles", { input = 0 });        
    ObjSet( "obj_extra_button_achievments", { input = 0 });        
    for i=1,#private.tab do
      if i ~= new_scr then
        ObjSet( "obj_extra_button_"..private.tab[ i ], { input = 0 }); 
        --DbgTrace("obj_extra_button_"..private.tab[ i ]) 
        ObjSet( "obj_extra_"..private.tab[ i ], { alp = 0, input = 0 } );    
        --DbgTrace("obj_extra_"..private.tab[ i ])   
      end;
    end;

    private.UpdateExtraScr1(new_scr);
  end;

  
 
end;
--******************************************************************************************
function private.SetButtonMouseDown( new_scr )

  ObjSet( "obj_extra_button_"..private.tab[ new_scr ], { event_mdown = function () private.UpdateExtraScr(new_scr); end; } ); 
 
end;
--******************************************************************************************
function private.UpdateExtraScr1( new_scr )

    local tme = 0.0;

    int.Lock( true );

    if new_scr == 1 or new_scr == 2 or new_scr == 3 then
      ObjAnimate( "spr_extra_back", "alp", 0, 0, "", 
      { 
        0.0, 3, 0,
        0.5, 3, 0.6
      } );
    end;
    local name = "obj_extra_"..private.tab[ new_scr ];
    ObjSet( name, { visible = 1 } );

    ObjAttach( name, "rm_extra" );

    ObjAnimate( name, "alp", 0, 0, "", 
    {
      0.0, 0, 0,
      tme, 0, 1
    } );
    ObjSet( name, { visible = 1, input = 1, alp = 1, pos_z = 50 } );

    local name_text = "txt_extra_"..private.tab[ new_scr ];
    local trg = function ()
      private.SetButtonMouseDown(new_scr);
      private.ActivateExtraScr( 1, name);
    end;
    ObjAnimate( name_text, "alp", 0, 0, trg, 
    {
      0.0, 0, 0,
      tme+0.5, 0, 0
    } );

    local name_old = "obj_extra_"..private.tab[ private.tab_current ];
    local func_end = function ()

        ObjSet( name_old, { visible = 0, input = 0 } );
        ObjAttach( name_old, "hub_extra" );

    end;
    ObjAnimate( name_old, "alp", 0, 0, func_end, 
    { 
      0.0, 0, ObjGet( name ).alp, 
      tme, 0, 0
    } );

    
    
    
end;
--
--******************************************************************************************
function private.ActivateExtraScr( vinput, name )

  for i=1,#private.tab do
    ObjSet( "obj_extra_button_"..private.tab[ i ], { input = 1 });        
  end;
  ObjSet( "obj_extra_button_collectibles", { input = 1 });        
  ObjSet( "obj_extra_button_achievments", { input = 1 });        
  ObjSet( "obj_extra_buttons", { input = vinput } );

  if name then

    ObjSet( name, { input = vinput });

  end;
  int.Lock( false );
end;
--******************************************************************************************
--******************************************************************************************
--
function private.WallpaperBig( num, obj )

    trg_after = function ()
      ObjSet( 'spr_extra_wallpaper_big', { input = 1 } ); 
      int.Lock( false );
    end;
    public.wallpaper_current_big = num;
    num = public.wallpaper_current_big;
    --local obj = ne_params.sender;
    local obj = obj;
    public.wallpaper_current_big_pos[1] = ObjGet( obj ).pos_x + 1190;
    public.wallpaper_current_big_pos[2] = ObjGet( obj ).pos_y + 250;

    public.wallpaper_current_big_pos[1] = ObjGet( obj ).pos_x;
    public.wallpaper_current_big_pos[2] = ObjGet( obj ).pos_y;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/aud_paper");
    --ObjAttach("spr_extra_wallpaper_"..num,"obj_extra_wallpaper_big");

    ObjSet( "spr_extra_wallpaper_bigs", { res = "assets/levels/menu/rm_extra/content/wallpaper_"..num.."_logo", scale_x = 1.3, scale_y = 1.3 } );
    ObjSet( "obj_extra_wallpaper_"..num, { input = 0 } );
    ObjAnimate( "obj_extra_wallpaper_"..num, "alp", 0, 0, "", 
    { 
      0,0,1, 
      0.2,0,0
    });
    ObjAnimate( "spr_extra_wallpaper_bigs", "alp", 0, 0, "", 
    { 
      0,0,0, 
      0.3,0,1
    });
    --ObjSet( "spr_extra_wallpaper_"..num, { pos_x = 0, pos_y = 0, scale_x = 1, scale_y = 1 } );
    ObjAnimate( "spr_extra_wallpaper_big", "scale_xy", 0, 0, "", 
    { 
      0,0,0,0, 
      0.3,0,1,1 
    });
    ObjAnimate( "spr_extra_wallpaper_big", "pos_xy", 0, 0, trg_after, 
    { 
      0,0,public.wallpaper_current_big_pos[1],public.wallpaper_current_big_pos[2], 
      0.3,0,-68,68 
    });
    ObjAnimate( "spr_extra_wallpaper_big", "alp", 0, 0, "", 
    { 
      0,0,0, 
      0.3,0,1 
    });


end;
--******************************************************************************************
--
function private.ArtNext( inc )

  local max_count = 2;
  local new_num;
  ObjSet( "obj_extra_art_arrows", { input = 0 } );

  if private.art_current == 1 and inc == 1 then

    ObjSet( "spr_extra_button_art_arrow_right", { alp = 0, input = 0 } );
    ObjSet( "spr_extra_button_art_arrow_left", { alp = 1, input = 1 } );
    new_num = max_count;

    ObjAnimate( "spr_extra_left_arrow", "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      0.3, 0, 1
    } );

  elseif private.art_current == 2 and inc == -1 then

    ObjSet( "spr_extra_button_art_arrow_right", { alp = 1, input = 1 } );
    ObjSet( "spr_extra_button_art_arrow_left", { alp = 0, input = 0 } );
    new_num = 1;

    ObjAnimate( "spr_extra_right_arrow", "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      0.3, 0, 1
    } );

  elseif private.art_current == 1 and inc == -1 then
    new_num = max_count;

  else

    new_num = private.art_current + inc;
    ObjSet( "spr_extra_button_art_arrow_right", { alp = 1, input = 1 } );
    ObjSet( "spr_extra_button_art_arrow_left", { alp = 1, input = 1 } );
  end;

  local name     = "obj_extra_art_page_";
  local name_arr = "obj_extra_art_arrows";
  local tme      = 0.3;
  private.ActivateExtraScr( 0, name_arr );

  for i = 1,2 do
      if i ~= new_num then
         ObjAnimate( name..i, "alp", 0, 0, "", { 0,0,0, tme,0,0 } );
         ObjSet( name..i, { input = 0 } );
      else
         ObjSet( name..new_num, { alp = 1, input = 1 } );
      end;
      ObjAnimate( "obj_extra_art_arrows", "alp", 0, 0, "*ObjSet( 'obj_extra_art_arrows', { input = 1 } );", 
      { 
        0,0,1, 
        0.3,0,1 
      });
  end;
  ObjAnimate( name..new_num, "alp", 0, 0, "", { 0,0,0, tme,0,1 } );
  ObjSet( name..new_num, { alp = 1 } );
  local trg = function ()
    private.ActivateExtraScr( 1, name_arr );
  end;
  ObjAnimate( name..private.art_current, "alp", 0, 0, trg, { 0,0,1, tme,0,0 } );
  ObjSet( "txt_extra_wallpaper_counter", { text = new_num.."/"..max_count } );
  private.art_current = new_num;
  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );

end;
--
--******************************************************************************************
--******************************************************************************************
--
function private.ArtBig( num, obj )

    local obj = obj;
    trg_after = function ()
      ObjSet( 'spr_extra_art_big', { input = 1 } ); 
      int.Lock( false );
    end;
    public.art_current_big = num;
    --num = public.art_current_big;
    public.wallpaper_current_big_pos[1] = ObjGet( obj ).pos_x + 1190;
    public.wallpaper_current_big_pos[2] = ObjGet( obj ).pos_y + 250;

    public.art_current_big_pos[1] = ObjGet( obj ).pos_x;
    public.art_current_big_pos[2] = ObjGet( obj ).pos_y;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/aud_paper");
    --ObjAttach("spr_extra_art_"..num,"obj_extra_wallpaper_big");

    ObjSet( "spr_extra_art_bigs", { res = "assets/levels/menu/rm_extra/content/art_"..num.."_logo", scale_x = 1.3, scale_y = 1.3 } );
    ObjSet( "spr_extra_art_"..num, { input = 0 } );
    ObjAnimate( "spr_extra_art_"..num, "alp", 0, 0, "", 
    { 
      0,0,1, 
      0.3,0,0
    });
    ObjAnimate( "spr_extra_art_bigs", "alp", 0, 0, "", 
    { 
      0,0,0, 
      0.3,0,1
    });
    --ObjSet( "spr_extra_art_"..num, { pos_x = 0, pos_y = 0, scale_x = 1, scale_y = 1 } );
    ObjAnimate( "spr_extra_art_big", "scale_xy", 0, 0, "", 
    { 
      0,0,0,0, 
      0.3,0,1,1 
    });
    ObjAnimate( "spr_extra_art_big", "pos_xy", 0, 0, trg_after, 
    { 
      0,0,public.art_current_big_pos[1],public.art_current_big_pos[2], 
      0.3,0,-68,68 
    });
    ObjAnimate( "spr_extra_art_big", "alp", 0, 0, "", 
    { 
      0,0,0, 
      0.3,0,1 
    });


end;
--
--******************************************************************************************
function private.ButtonDownExit()
  
  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );
  
  cmn.GotoRoom( "rm_menu", nil, true );

end;
--
--******************************************************************************************
--******************************************************************************************
function private.ButtonDownExtra()

  --ld.PlayAudio( "sfx", "audio/aud_click_menu" );
  ObjAttach( "obj_extra_music", "hub_extra" );
  ObjAttach( "obj_extra_art", "hub_extra" );
  ObjAttach( "obj_extra_wallpaper", "hub_extra" );
  ObjAttach( "obj_extra_archive", "hub_extra" );
  ObjAnimate( "spr_extra_back", "alp", 0, 0, "", 
  { 
    0.0, 3, 0.6,
    0.5, 3, 0
  } );

end;
--
--******************************************************************************************
--******************************************************************************************
function private.ButtonDownWallpaperBig()

    local num = public.wallpaper_current_big;
    trg_after = function ()
      ObjSet( 'spr_extra_wallpaper_big', { input = 1 } ); 
      int.Lock( false );
    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/aud_paper");
    ObjSet( "obj_extra_wallpaper_"..num, { input = 1 } );

    --ObjAttach( "obj_extra_wallpaper_"..num, "obj_extra_wallpaper_page_1" );

    --ObjAnimate( "obj_extra_wallpaper_"..num, "alp", 0, 0, "", 
    --{ 
    --  0,0,1,
    --  0.2,0,1,  
    --  0.3,0,0, 
    --  0.4,0,1
    --});
--
--    ObjSet( "obj_extra_wallpaper_"..num, { pos_x = public.wallpaper_current_big_pos[1], pos_y = public.wallpaper_current_big_pos[2], scale_x = 0.5, scale_y = 0.5 } );

    --ObjSet( "spr_extra_wallpaper_bigs", { res = "assets/levels/menu/rm_extra/content/wallpaper_"..num, scale_x = 0.5, scale_y = 0.5 } );
    --ObjAnimate( "obj_extra_wallpaper_"..num, "alp", 0, 0, "", 
    --{ 
    --  0,0,0, 
    --  0.3,0,1
    --});
    --ObjAnimate( "spr_extra_wallpaper_bigs", "alp", 0, 0, "", 
    --{ 
    --  0,0,0, 
    --  0.3,0,1
    --});
    --ObjAnimate( "spr_extra_wallpaper_big", "scale_xy", 0, 0, "", 
    --{ 
    --  0,0,1,1, 
    --  0.3,0,0,0 
    --});
    --ObjAnimate( "spr_extra_wallpaper_big", "pos_xy", 0, 0, trg_after, 
    --{ 
    --  0,0,-68,68,
    --  0.3,0,public.wallpaper_current_big_pos[1],public.wallpaper_current_big_pos[2] 
    --});

    pos_x1 = ObjGet( "spr_extra_wallpaper_"..num ).pos_x;
    pos_y1 = ObjGet( "spr_extra_wallpaper_"..num ).pos_y;

    ObjAnimate( "obj_extra_wallpaper_"..num, "alp", 0, 0, "", 
    { 
      0, 0, 0, 
      0.3, 0, 1
    });
    ObjAnimate( "spr_extra_wallpaper_bigs", "alp", 0, 0, "", 
    { 
      0,0,0, 
      0.3,0,1
    });
    ObjAnimate( "spr_extra_wallpaper_big", "scale_xy", 0, 0, "", 
    { 
      0,0,1,1, 
      0.3,0,0,0 
    });
    ObjAnimate( "spr_extra_wallpaper_big", "pos_xy", 0, 0, trg_after, 
    { 
      0,0,-68,68,
      0.3,0,pos_x1,pos_y1 
    });


end;
--
--******************************************************************************************
--
--******************************************************************************************
function private.ButtonDownArtBig()

    local num = public.art_current_big;

    trg_after = function () 
      ObjSet( 'spr_extra_art_big', { input = 1 } ); 
      int.Lock( false );
    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/aud_paper");
    ObjSet( "spr_extra_art_"..num, { input = 1 } );

    if ( num > 0 and num < 5 ) then

      ObjAttach( "spr_extra_art_"..num, "obj_extra_art_page_1" );

    elseif ( num > 3 and num < 9 ) then

      ObjAttach( "spr_extra_art_"..num, "obj_extra_art_page_2" );

    elseif ( num > 8 ) then

      ObjAttach( "spr_extra_art_"..num, "obj_extra_art_page_3" );

    end;

    ObjAnimate( "spr_extra_art_"..num, "alp", 0, 0, "", 
    { 
      0,0,1,
      0.2,0,1,  
      0.3,0,0, 
      0.4,0,1
    });

    ObjSet( "spr_extra_art_"..num, { pos_x = public.art_current_big_pos[1], pos_y = public.art_current_big_pos[2], scale_x = 0.5, scale_y = 0.5  } );

    ObjSet( "spr_extra_art_bigs", { res = "assets/levels/menu/rm_extra/content/art_"..num, scale_x = 0.5, scale_y = 0.5 } );
    ObjAnimate( "spr_extra_art_"..num, "alp", 0, 0, "", 
    { 
      0,0,0, 
      0.3,0,1
    });
    ObjAnimate( "spr_extra_art_bigs", "alp", 0, 0, "", 
    { 
      0,0,0, 
      0.3,0,1
    });

    ObjAnimate( "spr_extra_art_big", "scale_xy", 0, 0, "", 
    { 
      0,0,1,1, 
      0.3,0,0,0 
    });
    ObjAnimate( "spr_extra_art_big", "pos_xy", 0, 0, trg_after, 
    { 
      0,0,-68,68,
      0.3,0,public.art_current_big_pos[1],public.art_current_big_pos[2] 
    });

end;
--
--******************************************************************************************
function private.ButtonMouseEnter( but_name )

  cmn.SetCursor( CURSOR_HAND );

  if but_name == 'close' or
     string.find( but_name, "arrow" ) or
     string.find( but_name, "music_track" ) or
     but_name == 'setwallpaper' or
     --but_name == 'setscreensaver' or
     but_name == 'saveart' or
     but_name == 'menu' or
     but_name == 'savemusic' then

    local obj = "pfx_extra_button_"..but_name.."_focus";

    if ( GetPerformanceMode() == 1 or string.find( but_name, "music_track" ) or string.find( but_name, "arrow" ) or but_name == "menu" ) then

        obj = "spr_extra_button_"..but_name.."_focus";

    end;

    local alp = ObjGet( obj ).alp;


  local trg = function ()

  end;

    ObjAnimate( obj, 8, 0, 0, trg, { 0, 0, alp, ( 0.3 * ( 1 - alp ) ), 0, 1 } );

    if but_name == "art_arrow_right" then

      ObjAnimate( "spr_extra_right_arrow", "alp", 0, 0, "", 
      { 
        0.0, 0, 1, 
        0.3, 0, 0 
      });

    elseif but_name == "art_arrow_left" then

      ObjAnimate( "spr_extra_left_arrow", "alp", 0, 0, "", 
      { 
        0.0, 0, 1, 
        0.3, 0, 0 
      });

    end;

  else 

    local name_button = "spr_extra_button_"..but_name;
    local name_focus = name_button.."_focus1";
    cmn.PlayAudio( "sfx", "audio/aud_menter" );  

    ObjAnimate( name_focus, "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.3, 0, 1 
    });

  end;

end;
--------------------------------------------------------------------
function private.ButtonMouseLeave( but_name )

  cmn.SetCursor( CURSOR_DEFAULT );

  if but_name == 'close' or
     string.find( but_name, "arrow" ) or
     string.find( but_name, "music_track" ) or
     but_name == 'setwallpaper' or
     --but_name == 'setscreensaver' or
     but_name == 'saveart' or
     but_name == 'menu' or
     but_name == 'savemusic' then

    local obj = "pfx_extra_button_"..but_name.."_focus";

    if ( GetPerformanceMode() == 1 or string.find( but_name, "music_track" ) or string.find( but_name, "arrow" ) or but_name == "menu" ) then

        obj = "spr_extra_button_"..but_name.."_focus";

    end;

    local alp = ObjGet( obj ).alp;

    ObjAnimate( obj, 8, 0, 0, "", { 0, 0, alp, ( 0.3 * alp ), 0, 0 } );

    if but_name == "art_arrow_right" and ObjGet( "spr_extra_button_art_arrow_right" ).input then

      ObjAnimate( "spr_extra_right_arrow", "alp", 0, 0, "", 
      { 
        0.0, 0, 0, 
        0.3, 0, 1 
      });

    elseif but_name == "art_arrow_left" and ObjGet( "spr_extra_button_art_arrow_left" ).input then

      ObjAnimate( "spr_extra_left_arrow", "alp", 0, 0, "", 
      { 
        0.0, 0, 0, 
        0.3, 0, 1 
      });

    end;

  else

    local name_button = "spr_extra_button_"..but_name;
    local name_focus = name_button.."_focus1";

    ObjAnimate( name_focus, "alp", 0, 0, "", 
    { 
      0.0, 0, 1, 
      0.3, 0, 0 
    });

  end;

end;
--******************************************************************************************
function private.Play()

  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );
  cmn.SetCursor( CURSOR_DEFAULT );

  if ( ng_global.progress[ "std" ].common.gamewin ) then

    local prg = "ext";

    if ( ng_global.progress[ prg ].common.gamewin == true and
      ng_global.progress[ prg ].common.gamestart == false ) then

      --cmn.DialogWindowShow( "common", "finish"..prg, true );
      common.dialog.ButtonMouseDown( "playchoice", "reset", "ext" );      
      --common.dialog.playchoice.resetprogress = prg;
      --common.DialogWindowShow( "common", "reset", true );
    
    else

      ng_global.currentprogress = prg;

      if ( not ng_global.progress[ prg ].common.gamestart ) then
        ng_global.progress[ prg ].common.gamestart = true;
      end;

      cmn.SetCursor( CURSOR_DEFAULT );
      local level = ng_global.progress[ prg ].common.chapter;
      cmn.is_inmenunow = false;

      common.LevelSwitch( level );

    end;

  else

    if IsDemoEdition() or IsSurveyEdition() then

      common.DialogWindowShow( "common", "demoextra" );

    else
    
      common.DialogWindowShow( "common", "unlockextra" );

    end;

  end;

end;
--******************************************************************************************
function private.Setwallpaper()

  cmn.SetCursor( CURSOR_DEFAULT );
  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );

  if ( IsDemoEdition() ) then

    cmn.DialogWindowShow( "common", "demoextra" );

  else

    cmn.DialogWindowShow( "common", "setwallpaper", true );

  end;

end;
--******************************************************************************************
function private.Saveart()

  cmn.SetCursor( CURSOR_DEFAULT );
  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );

  if ( IsDemoEdition() ) then

    cmn.DialogWindowShow( "common", "demoextra" );

  else

    cmn.DialogWindowShow( "common", "saveart", true );

  end;

end;
--
--******************************************************************************************
function private.Setscreensaver()

--  cmn.SetCursor( CURSOR_DEFAULT );
--  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );
--
--  if ( IsDemoEdition() ) then
--
--    cmn.DialogWindowShow( "common", "demoextra" );
--
--  else

    --if ( private.screensaver_current == 2 ) then

      --if ng_global.secretwin then
        --cmn.DialogWindowShow( "common", "setscreen", true );
      --else
      --  cmn.DialogWindowShow( "common", "lockscreen" );
      --end;

    --else

      --cmn.DialogWindowShow( "common", "setscreen", true );

    --end;

  --end;  

end;
--
--
--------------------------------------------------------------------
--------------------------------------------------------------------
--
function private.AnimationExecute()

  if ( GetPerformanceMode() == 0 ) then
  

  else


  end;

end;
--
--------------------------------------------------------------------
--------------------------------------------------------------------
function private.ButtonCollectibles()

  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );

  if not ( private.collectibles_opn ) then

      ModLoad( "assets/levels/menu/rm_collectibles/mod_collectibles" );
      rm_collectibles.Init();
      private.collectibles_opn = true;

  end;

  ng_global.achievements.previous_room = GetCurrentRoom();

  cmn.GotoRoom( "rm_collectibles", nil, true );

end;
--------------------------------------------------------------------
--------------------------------------------------------------------
function private.ButtonAchievments()

  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );

  --TrgExecute( "trg_achiev_init" );
  --LoadCurrentProfile();

  if not ( private.achievements_opn ) then

      ModLoad( "assets/levels/menu/rm_achievements/mod_achievements" );
      rm_achievements.Init();
      private.achievements_opn = true;

  end;

  ng_global.achievements.previous_room = GetCurrentRoom();

  cmn.GotoRoom( "rm_achievements", nil, true );
  
end;
--
--------------------------------------------------------------------
--------------------------------------------------------------------
function private.ButtonMonsters()

  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );

  if not ( ld.monsters_loaded ) then

    ld.monsters_loaded = true;

    ModLoad( "assets/levels/menu/rm_monsters/mod_monsters" );
    TrgExecute( "trg_monsters_init" );
    int.monster.CLICK_TO_SCREEN = true;

  end;

  ng_var.previous_room = GetCurrentRoom();

  cmn.GotoRoom( "rm_monsters", nil, true);
  
end;
--------------------------------------------------------------------
--------------------------------------------------------------------
function private.ButtonSecretroom()

  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );
  cmn.SetCursor( CURSOR_DEFAULT );

  if ( ng_global.progress[ "ext" ].common.gamewin ) then

    local prg = "scr";
    ng_global.currentprogress = prg;

    if ( not ng_global.progress[ prg ].common.gamestart ) then

      if ( ng_global.progress[ prg ].common.gamewin ) then

        common.ResetSecretroom();
        ng_global.progress[ prg ].common.gamewin = false;

      end;

      ng_global.progress[ prg ].common.gamestart = true;

      SetCursor( CURSOR_DEFAULT );
      local level = ng_global.progress[ prg ].common.chapter;
      cmn.is_inmenunow = false;
      common.LevelSwitch( level );

    else 

      common.DialogWindowShow( "common", "continuesecret" );

    end;

  else

    common.DialogWindowShow( "common", "unlocksecret" );

  end;

end;
--------------------------------------------------------------------
--------------------------------------------------------------------
function private.ButtonReplayroom()

  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );
  cmn.SetCursor( CURSOR_DEFAULT );


  if ng_global.progress[ "rpl" ].common.gamewin == true  then
    
    cmn.DialogWindowShow( "common", "finishreplayroom", true )

  elseif ng_global.progress[ "ext" ].common.gamewin == true   then

    local level = ng_global.progress[ "rpl" ].common.chapter;

    common.LevelSwitch( level );

  else

      if IsDemoEdition() or IsSurveyEdition() then

        cmn.DialogWindowShow( "common", "demoextra" );

      else
      
        cmn.DialogWindowShow( "common", "unlockreplay" );

      end;
   
  end; 

end;
--------------------------------------------------------------------
--------------------------------------------------------------------
function private.DetectiveOver()

  ObjSet( "spr_extra_detective", { input = 0 } );
  ObjAnimate( "spr_extra_text", "alp", 0, 0, "*ObjSet('spr_extra_detective',{input=1});", 
  { 
    0,0,0, 
    0.5,0,1,
    3.5,0,1,
    4.0,0,0
  });
  ObjAnimate( "spr_extra_overlap_text", "alp", 0, 0, "", 
  { 
    0,0,1, 
    0.5,0,0,
    3.5,0,0,
    4.0,0,1
  });
end;
--------------------------------------------------------------------
--------------------------------------------------------------------
------function MUSIC () end;----------------------------------------
--------------------------------------------------------------------
  --function private.PlayExtraTrack( new_mus, is_button )
  function private.PlayExtraTrack ( new_mus )

    new_mus = tonumber( new_mus );

    local name = "";
    local tme = 0.0;

    if not ( IsNoSoundDevice() )  then

      local track_path = "levels/menu/rm_extra/content/aud_"..private.music[ tonumber( new_mus ) ].."_mus";

      if private.music_is_play then

          cmn.StopAllMus();

      end;

      public.music_current = tonumber( new_mus );    

      
      cmn.PlayAudio( "mus", track_path, 1 );--, "", "*private.PlayExtraTrack( '"..next_track.."' );", 0.5 );

      private.music_is_play = true;

--    else
--
--      if is_button then
--        
--        cmn.DialogWindowShow( "common", "noaudio" );
--
--      end;    

    end;

  end;
  --******************************************************************************************
  function private.PauseExtraTrack ( cur_mus )

    cmn.PlayAudio( "sfx", "audio/aud_click_menu" );

    cmn.StopAllMus();
    private.music_is_play = false;
    
  end;
  --******************************************************************************************
  function private.Savemusic ()

    private.ButtonMusicDown( "savemusic" );

    cmn.SetCursor( CURSOR_DEFAULT );
    cmn.PlayAudio( "sfx", "audio/aud_click_menu" );

    if ( IsDemoEdition() ) then

      cmn.DialogWindowShow( "common", "demoextra" );

    else

      cmn.DialogWindowShow( "common", "savemusic", true );

    end;

  end;
  --******************************************************************************************
  function private.ButtonMusicDown ( type )

    ObjAnimate("spr_extra_button_"..type.."_pressed", "alp", 0, 0, "", 
    {
      0.0,0,0,
      0.2,0,1,
      0.4,0,0
    });

  end;
  --******************************************************************************************
  function private.ButtonNextTrack ()

    private.ButtonMusicDown( "next_track" );

    if ( public.music_current < 5 ) then
      public.music_current = public.music_current + 1;
    else
      public.music_current = 1;
    end;  

    private.AnimText( 0 ); 

    if ( private.music_is_play == true ) then
      private.PlayExtraTrack( public.music_current );
    end;

  end;
  --******************************************************************************************
  function private.ButtonPrevTrack ()

    private.ButtonMusicDown( "prev_track" );

    if ( public.music_current > 1 ) then
      public.music_current = public.music_current - 1;
    else
      public.music_current = 5;
    end; 

    private.AnimText( 0 ); 

    if ( private.music_is_play == true ) then
      private.PlayExtraTrack( public.music_current );
    end;

  end;
  --******************************************************************************************
  function private.ButtonPlayTrack ()

    private.ButtonMusicDown( "play_track" );

    if ( private.music_is_play == false ) then
      private.PlayExtraTrack( public.music_current );
    else
      private.PauseExtraTrack( public.music_current );
    end;

  end;
  --******************************************************************************************
  function private.ButtonVolumeUp ()

    private.ButtonMusicDown( "volume_up" );

    local sound_volume = GetSoundVolume( "soundtrack" );

    if sound_volume < 1 then
      sound_volume = sound_volume + 0.1;
      SetSoundVolume( "soundtrack", sound_volume );
    end;   

    private.MusicTextChange()

  end;
  --******************************************************************************************
  function private.ButtonVolumeDown ()

    private.ButtonMusicDown( "volume_down" );

    local sound_volume = GetSoundVolume( "soundtrack" );

    if sound_volume > 0 then
      sound_volume = sound_volume - 0.1;
      SetSoundVolume( "soundtrack", sound_volume );
    end;

    private.MusicTextChange();

  end;
  --******************************************************************************************
  function private.MusicTextChange ()

    local volume = GetSoundVolume( "soundtrack" ) * 100;
    local volume_txt;

    if (volume < 5) then
      volume_txt = "0";
    elseif (volume >= 5) and (volume < 15) then
      volume_txt = "10";
    elseif (volume >= 15) and (volume < 25) then
      volume_txt = "20";
    elseif (volume >= 25) and (volume < 35) then
      volume_txt = "30";
    elseif (volume >= 35) and (volume < 45) then
      volume_txt = "40";
    elseif (volume >= 45) and (volume < 55) then
      volume_txt = "50";
    elseif (volume >= 55) and (volume < 65) then
      volume_txt = "60";
    elseif (volume >= 65) and (volume < 75) then
      volume_txt = "70";
    elseif (volume >= 75) and (volume < 85) then
      volume_txt = "80";
    elseif (volume >= 85) and (volume < 95) then
      volume_txt = "90";
    elseif (volume >= 95) then
      volume_txt = "100";
    end;

    local txt = StringGet("str_extra_volume");
    ObjSet( "txt_extra_music_track_num", { 
      text = txt.." "..volume_txt.."%"
    });
    
    ObjSet( "tmr_extra_music", {
      endtrig = function() private.AnimText ( 0 ); end,
      time = 1,
      playing = true
    });

  end;
  --******************************************************************************************
  function private.AnimText ( step )

    local init_text = StringGet("str_extra_music_track"..public.music_current);--.." ";
    ObjSet( "txt_extra_music_track_num", { text = init_text } );
--    local tmp_text;
--
--    tmp_text = string.sub(init_text, #init_text-step, #init_text)..string.sub(init_text, 0, #init_text - step)
--    ObjSet( "txt_extra_music_track_num", { text = tmp_text } );
--
--    local delay;
--    if step == 0 then
--      delay = 1.5;
--    else
--      delay = 0.4
--    end;
--
--    if step == #init_text-1 then
--      step = 0;
--    else
--      step = step + 1;
--    end
--
--    ObjSet( "tmr_extra_music", {
--      endtrig = function() private.AnimText ( step ); end,
--      time = delay,
--      playing = true
--    });

  end;