-- name=rm_intro
--******************************************************************************************
-- для добавления нового лого достаточно добавить его название в массив private.logo
--******************************************************************************************
private.counter = 0;
private.obj = {"obj_intro_logo_bigfishgames","obj_intro_logo_elephantgames"};
private.activeLogo = 0;
--******************************************************************************************
function public.Init()

  ObjSet( "spr_intro_logo_bigfishgames_bg", 
  { 
    scale_x = (1024 / 256), 
    scale_y = (768 / 192)
  } );

  ObjSet( "spr_intro_logo_elephantgames_bg", 
  { 
    scale_x = 1024 / 2, 
    scale_y = 768 / 2
  } );


  ObjSet( "obj_intro_logo_bigfishgames", 
  { 
  inputrect_w = 1024,
  inputrect_h = 768
  } );

  ObjSet( "obj_intro_logo_elephantgames", 
  { 
  inputrect_w = 1024,
  inputrect_h = 768
  } );
  
 if tostring(GetPlatform()) == "ios" or tostring(GetPlatform()) == "android" then
    
    
    
    local w = GetScreenSize().w;
    local h = GetScreenSize().h;
    
    if h>w then
      local t = w;
      w = h;
      h = t;
    end;
    
    SetPerformanceMode(1);
    
    local BigFishSize = { "680", "636" };
    local EGSize = { "624", "241" };
    local ratioBigFish = BigFishSize[1]/BigFishSize[2];
    local ratioEG = EGSize[1]/EGSize[2];
    
    local sX = w/1024;
    local sY = h/768;
    
    local outBigFishSize = {};
    outBigFishSize[1] = sX * BigFishSize[1];
    outBigFishSize[2] = sY * BigFishSize[2];
    local outNeedBigFishSizeX = outBigFishSize[2] * ratioBigFish;
    local needScaleBigFishX = outNeedBigFishSizeX / outBigFishSize[1];
    
    local outEGSize = {};
    outEGSize[1] = sX * EGSize[1];
    outEGSize[2] = sY * EGSize[2];
    local outNeedEGSizeX = outEGSize[2] * ratioEG;
    local needScaleEGX = outNeedEGSizeX / outEGSize[1];
    
    
    DbgTrace("w:"..tostring(w).." h:"..tostring(h).." sX:"..tostring(sX).." sY:"..tostring(sY).." ScaleEGX:"..tostring(needScaleEGX).." ScaleBFX:"..tostring(needScaleBigFishX));
    
    ObjSet( "spr_intro_logo_bigfishgames", 
      { 
      scale_x = needScaleBigFishX
      } );
    
    ObjSet( "spr_intro_logo_elephantgames", 
      { 
      scale_x = needScaleEGX
      } );
    
    
  end;
    
  room.Define( "rm_intro" );
  ObjSet(private.obj[1], {
    input = false,
    event_mdown = private.IntroLogoHide
  });
  private.UpdateLogoToNextRes();
  
  MsgSend(Command_Level_Loaded);

end;
--******************************************************************************************
function public.Open()

  private.counter = 1;
  if tostring(GetPlatform()) == "ios" then
      if iOS_IsGameCanStart() == 1 then
          private.IntroLogoShow();
      else
          ObjSet("tmr_intro_gamecanstart", {endtrig = function() private.IsGameCanStartTimer(); end, time = 1, playing = 1 });
      end;
  else
      private.IntroLogoShow();
  end;

end;
--******************************************************************************************
  
function private.IsGameCanStartTimer()
    if iOS_IsGameCanStart() == 1 then
        private.IntroLogoShow();
    else
        ObjSet("tmr_intro_gamecanstart", {endtrig = function() private.IsGameCanStartTimer(); end, time = 1, playing = 1 });
    end;
end;
--******************************************************************************************
function private.UpdateLogoToNextRes()
  
  private.counter = private.counter + 1;
  ObjSet(private.obj[private.counter], { alp = 0, active = true });
  
end;
--******************************************************************************************
function private.IntroLogoShow()

  ObjAnimate( private.obj[private.counter], "alp", 0, 0 ,private.IntroLogoActivate, { 0,0,0, 0.8,0,1 } );

end;
--******************************************************************************************
function private.IntroLogoActivate()

  ObjSet( private.obj[private.counter], { input = true } );
  ObjStopAnimate( private.obj[private.counter], "alp" );
  ObjAnimate( private.obj[private.counter], "alp", 0, 0, private.IntroLogoHide, { 0,0,1, 1.5,0,1 } );
  
  
end;
--******************************************************************************************
function private.IntroLogoHide()

  local trg = function () 
    private.UpdateLogoToNextRes();
    private.IntroLogoShow(); 
  end;
  if private.counter == #private.obj then
    trg = private.IntroVideoPlay;
  end;
  ObjSet( private.obj[private.counter], { input = false } );
  ObjStopAnimate( private.obj[private.counter], "alp" );
  ObjAnimate( private.obj[private.counter], "alp",0 ,0, trg, { 0,0,1, 0.8,0,0 } );

end;
--******************************************************************************************
function private.IntroVideoPlay()

  interface.DialogVideoShow( "vid_intro_video", 1, function() private.IntroVideoEnd( 'skip' ); end );  
  VidPlay( "vid_intro_video", function() private.IntroVideoEnd( nil ); end );
  
  if ( IsCollectorsEdition() ) then
    ObjAnimate( "spr_intro_logo_ce", "alp", 0, 0, "", 
    {
      0.0,  0, 0,
      33.5, 0, 0,
      34.0, 0, 1,
      37.0, 0, 1,
      37.5, 0, 0
    } );
  end;  
  cmn.PlayAudio("sfx", "audio/aud_preintro");
end;
--******************************************************************************************
function private.IntroVideoEnd( skip )

  interface.DialogVideoHide();
  ObjAttach( "tmr_intro_videoend", "cmn_timers" );

  if skip then  
    cmn.StopAudio("sfx", "audio/aud_preintro");
  end;

  local funcVideoEnd = function () 
    cmn.GotoRoom('rm_menu'); 
    ObjDelete('tmr_intro_videoend'); 
  end; 
  ObjSet( "tmr_intro_videoend", 
  { 
    endtrig = funcVideoEnd, 
    time = 0.6, 
    playing = true
  } );
  
  if tostring(GetPlatform()) == "ios" or tostring(GetPlatform()) == "android" then
    MsgSend(Command_Level_CanShowLoading);
  end;

end;
--******************************************************************************************